;;;-*- Mode:common-LISP; Package:SYSTEM-INTERNALS; Base:10 -*-


;;;                           RESTRICTED RIGHTS LEGEND

;;;Use, duplication, or disclosure by the Government is subject to
;;;restrictions as set forth in subdivision (c)(1)(ii) of the Rights in
;;;Technical Data and Computer Software clause at 52.227-7013.
;;;
;;;                     TEXAS INSTRUMENTS INCORPORATED.
;;;                              P.O. BOX 2909
;;;                           AUSTIN, TEXAS 78769
;;;                                 MS 2151
;;;
;;; Copyright (C) 1986-1989 Texas Instruments Incorporated. All rights reserved.

;;;
;;;   
;;; 11-11-86  MBC  New distinct defsystems.
;;; 01/29/87   HW  Changed name from Local-File to File-System.
;;;  2/24/87   JK  Included the BASIC-STREAMS module, previously in the PATHNAME defsystem, because some 
;;;                FS flavors depend on this.
;;; 03.05.87  DAB  Changed :patchable and added :warnings-pathname-default
;;; 07.15.87  LS   Changed file to FILE-COLD so io;defs doesn't redefine an existing system  
;;; 02-26-88  ab   o Broke into two defsystems, one for local-file-system support, other
;;;                for basic file support (file streams, load, directory etc). 
;;;                Local-File now has its own directory.
;;;                Both should be loaded for Explorer; only Basic-File for the mX.
;;;                o Moved IO;EXPORTS-FS here from IO defsystem.
;;;                o Moved BALDIR, DRIBBL here from IO.
;;;                o Moved OPEN and OPEN-ERROR-SUPPORT here from FILE.

(Defsystem Basic-FILE
  (:Name "File Support")			
  (:Short-Name "File")
  (:Pathname-Default "SYS:basic-FILE;")
  (:patchable "SYS: PATCH.basic-FILE;" PATCH)
  (:warnings-pathname-default "SYS: CWARNS; basic-FILE.lisp")
  
  (:Module Basic-Stream ("Stream"))
  (:Module fs-Defs ("exports-fs" "Fs-Error-Defs"))
  (:Module Main ("NEW-QRAND-SOURCEFILE" "LOAD" "open-error-support" "Open"))
  (:module Directory-support ("directory-support"
			      "baldir"
			      "dribbl"
			      ))
  
  (:Compile-Load Basic-Stream)
  (:Compile-Load FS-Defs (:Fasload Basic-Stream))
  (:Compile-Load Main (:Fasload Basic-Stream Fs-Defs))
  (:Compile-Load Directory-support (:Fasload Basic-Stream Fs-Defs Main))     ;02-01-88 DAB
  )


