;;-*- Mode:Common-Lisp; Package:FILE-SYSTEM; Base:10 -*-

;;;                           RESTRICTED RIGHTS LEGEND

;;;Use, duplication, or disclosure by the Government is subject to
;;;restrictions as set forth in subdivision (c)(1)(ii) of the Rights in
;;;Technical Data and Computer Software clause at 52.227-7013.
;;;
;;;                     TEXAS INSTRUMENTS INCORPORATED.
;;;                              P.O. BOX 2909
;;;                           AUSTIN, TEXAS 78769
;;;                                 MS 2151
;;;
;;; Copyright (C) 1987-1989 Texas Instruments Incorporated. All rights reserved.

;;; 04-25-89 DAB Added all function, variables, flavors and instances that are documented to export list.
;;; 1/19/87  HW  Original

;;; This defines all of the symbols to be exported from the FS package
;;; that are used by the file system. These are functions unless otherwise noted.


(export  '(pathname-raw-host
	   pathname-raw-device
	   pathname-raw-directory
	   pathname-raw-name
	   pathname-raw-type
	   pathname-raw-version
	   set-host-working-directory
	   *defaults-are-per-host*		;variable
	   *always-merge-type-and-version*	;variable
	   *name-specified-default-type*	;variable
	   last-file-opened			;variable
	   make-pathname-defaults
	   copy-pathname-defaults
	   default-pathname
	   pathname-parse-error			;condition
	   merge-pathname-defaults
	   merge-and-set-pathname-defaults
	   describe-pathname
	   init-file-pathname
	   pathname-plist
	   *pathname-hash-table*		;variable
	   sample-pathname
	   *generic-base-type-alist*		;variable
	   add-logical-pathname-host
	   set-logical-pathname-host
	   make-logical-pathname-host
	   translated-pathname
	   unknown-logical-directory		;condition
	   *copy-file-known-text-types*		;variable
	   *copy-file-known-binary-types*       ;variable
	   *copy-file-known-short-binary-types* ;variable
	   file-attribute-list
	   extract-attribute-list
	   read-attribute-list
	   file-attribute-bindings
	   extract-attribute-bindings
	   invalid-file-attribute		;condition
	   reading-from-file			;macro
	   reading-from-file-case		;macro
	   change-file-properties
	   file-properties
	   complete-pathname
	   directory-list
	   directory-list-stream
	   expunge-directory
	   create-directory
	   remote-connect
	   balance-directories
	   initialize-file-system
	   boot-file-system
	   expand-file-system
	   user-personal-name-first-name-first  ;variable
	   *merge-unix-types*			;variable
	   lm-salvage
	   default-host
	   define-canonical-type
	   parse-pathname
	   set-default-pathname
	   load-pathname-defaults               ;variable  ; DAB 04-25-89
	   *its-uninteresting-types*            ;variable
	   file-error                           ;flavor
	   file-operation-condition             ;condition
	   file-open-for-output                 ;condition
	   file-locked                          ;condition
	   invalid-byte-size                    ;condition
	   no-more-room                         ;condition
	   filepos-out-of-range                 ;condition
           not-available                        ;condition
	   file-lookup-error device-not-found directory-not-found file-not-found ;conditions
	   multiple-file-not-found access-error incorrect-access-to-file incorrect-access-to-directory   ;conditions
           invalid-wildcard wildcard-not-allowed wrong-kind-of-file creation-failure file-already-exists ;conditions
           superior-not-directory delete-failure directory-not-empty dont-delete-flag-set rename-failure ;conditions
           rename-to-existing-file rename-across-directories unknown-property invalid-property-value     ;conditions
	   invalid-property-name                 ;condition
	   
	   )
	'FS)



(export '(sys:stream             ;flavor     ; DAB 04-25-89
	   sys:input-stream      ;flavor  
	   sys:output-stream     ;flavor
	   sys:bidirection-stream ;flavor
	   sys:property-list-mixin ;flavor
           sys:buffered-input-stream  ;flavor
	   sys:buffered-output-stream ;flavor
	   sys:buffered-stream   ;flavor
	   sys:buffered-line-input-stream ;flavor
	   sys:line-output-stream-mixin   ;flavor
	   sys:buffered-input-character-stream ;flavor
	   sys:buffered-output-character-stream ;flavor
	   sys:buffered-character-stream
	   sys:input-pointer-remembering-mixin  ;flavor
	   sys:output-pointer-remembering-mixin ;flavor
	   sys:stream-output-lower-limit        ;instance
           sys:stream-output-limit              ;instance
	   sys:output-pointer-base              ;instance
	   sys:file-stream-mixin                ;flavor
	   sys:input-file-stream-mixin          ;flavor
	   sys:output-file-stream-mixin         ;flavor
	   )
	'sys)