;;; -*- Mode: Common-Lisp; Package: User; Base: 10.; Patch-File: T -*-
;;; Written 08/02/88 15:14:26 by CYDNEY,
;;; Reason: Changed the function SENDELT to optionally post an event.
;;; while running on Quintillian from band LOD4
;;; With SYSTEM 4.61, VIRTUAL-MEMORY 4.4, EH 4.5, MAKE-SYSTEM 4.5, MICRONET 4.5, LOCAL-FILE 4.1,
;;;  BASIC-PATHNAME 4.12, NETWORK-SUPPORT-COLD 4.1, NAMESPACE 4.22, NETWORK-NAMESPACE 4.2,
;;;  DISK-IO 4.13, DISK-LABEL 4.0, BASIC-FILE 4.7, MAC-PATHNAME 4.5, NETWORK-PATHNAME 4.1,
;;;  COMPILER 4.13, TV 4.85, DATALINK 4.14, CHAOSNET 4.18, GC 4.3, MEMORY-AUX 4.0,
;;;  NVRAM 4.6, SYSLOG 4.0, STREAMER-TAPE 4.4, UCL 4.1, INPUT-EDITOR 4.0, METER 4.3,
;;;  ZWEI 4.18, DEBUG-TOOLS 4.2, NETWORK-SUPPORT 4.5, NETWORK-SERVICE 4.0, DATALINK-DISPLAYS 4.0,
;;;  FONT-EDITOR 4.0, SERIAL 4.0, PRINTER 4.8, PRINTER-TYPES 4.2, IMAGEN 4.0, SUGGESTIONS 4.0,
;;;  MAIL-DAEMON 4.7, MAIL-READER 4.6, TELNET 4.1, VT100 4.6, NAMESPACE-EDITOR 4.5,
;;;  PROFILE 4.4, VISIDOC 4.5, RPC 4.16, LX 3.0, NFS 3.0, BN 3.0,  microcode 534,
;;;  Band Name: Explorer 4.1, LX 3.0 6/28


;;; Changed sendelt to optionally post an event. KCW


#!C
;;; From file bn:bn;dispatcher
#10R BN#:
(COMPILER-LET ((*PACKAGE* (FIND-PACKAGE "BN"))
                          (SI:*LISP-MODE* :COMMON-LISP)
                          (*READTABLE* SYS:COMMON-LISP-READTABLE)
                          (SI:*READER-SYMBOL-SUBSTITUTIONS* SYS::*COMMON-LISP-SYMBOL-SUBSTITUTIONS*))
  (COMPILER#:PATCH-SOURCE-FILE "BN: BN; DISPATCHER.#"


(defun SENDELT (slot channel rq-entry wait-p &optional (post-event t))
   "sends RQ-ENTRY to another slot by linking it onto the SLOT
 and CHANNEL Request Queue header"
   (declare (values ignore)
	     (ignore wait-p))
   (when-debugging
     (check-type slot slot-number)
     (check-type channel channel-number)
     (check-type rq-entry rq-entry))
   (let ((empty-flag nil))
     (with-rq-header (rq-header slot channel)
       (with-header-locked (rq-header)
	 (when-debugging					; verify header emptiness consistency
	   (assert (valid-rq-header-p rq-header) ()
		    "Inconsistent COUNT, HEAD, and TAIL fields in RQ header: ~%~A"
		    (format-rqh nil rq-header)))
	 ;; link entry to header
	 (setf empty-flag (linkn rq-header rq-entry))
	 )	 ;with-header-locked            
       ;; finally, post an event to the other slot
       (when (and post-event empty-flag) (post-busnet-event rq-header))	; if queue was empty before link, post event
       )	;with-rq-header
     ) ; let
   ) ;sendelt

))
