;;; -*- Mode: Common-Lisp; Package: ("CONDITIONS" :USE "LISP" :SHADOW ("BREAK" "ERROR" "CERROR" "SIGNAL" "CHECK-TYPE" "ASSERT" "ETYPECASE" "CTYPECASE" "ECASE" "CCASE" "IGNORE-ERRORS" "MAKE-CONDITION" "WARN" "*BREAK-ON-WARNINGS*")); Base: 10 -*-

;;;			      RESTRICTED RIGHTS LEGEND

;;;Use, duplication, or disclosure by the Government is subject to
;;;restrictions as set forth in subdivision (c)(1)(ii) of the Rights in
;;;Technical Data and Computer Software clause at 52.227-7013.
;;;
;;;			TEXAS INSTRUMENTS INCORPORATED.
;;;				 P.O. BOX 2909
;;;			      AUSTIN, TEXAS 78769
;;;				    MS 2151
;;;
;;; Copyright (C) 1989 Texas Instruments Incorporated. All rights reserved.
;;;
;;;  System definition for the CLEH (Common LISP error handling).
;;;
;;;

;;;
;;; Change history:
;;;
;;;  Date      Author	Description
;;; -------------------------------------------------------------------------------------
;;;   5/09/89  clm      Moved `debug' module to the CLEH defsystem because of dependencies
;;;                     which require CLEH be built before the UCL-debugger.
;;;
;;;

(IN-PACKAGE "CONDITIONS" :USE '("LISP" "TICL") :nicknames '("CLEH"))

(SHADOW '(break error cerror signal make-condition ignore-errors warn *break-on-warnings*
	  check-type assert etypecase ctypecase ecase ccase))

(EXPORT '(;; shadowed symbols
	  error cerror signal warn check-type assert invoke-debugger 
	  etypecase ctypecase ecase ccase break *break-on-warnings* 
	  ;; new symbols
	  handler-case handler-bind ignore-errors 
	  with-simple-restart restart-case restart-bind find-restart compute-restarts
	  invoke-restart restart restart-name restart-function restart-report-function
	  restart-interactive-function invoke-restart-interactively 
	  abort continue muffle-warning store-value use-value 
	  define-condition make-condition condition *break-on-signals* *debugger-hook*
	  warning serious-condition simple-condition simple-warning simple-error
	  simple-condition-format-string simple-condition-format-arguments
	  storage-condition stack-overflow storage-exhausted type-error
	  type-error-datum type-error-expected-type simple-type-error
	  program-error control-error stream-error stream-error-stream
	  end-of-file file-error file-error-pathname cell-error
	  unbound-variable undefined-function arithmetic-error
	  arithmetic-error-operation arithmetic-error-operands
	  package-error package-error-package
	  division-by-zero floating-point-overflow floating-point-underflow
	  ))

(IMPORT '(eh:format-string eh:format-args))


(DEFSYSTEM CLEH
  (:NAME "Common LISP Condition System")
  (:SHORT-NAME "CLEH")
  (:NICKNAMES "Common-LISP-Condition-System")
;  (:PACKAGE CLEH)
  (:PATHNAME-DEFAULT "SYS:CLEH;")
  (:WARNINGS-PATHNAME-DEFAULT "SYS: CWARNS; CLEH.LISP")
  (:PATCHABLE "SYS:PATCH.CLEH;" CLEH)

  (:module restarts    "cl-restarts")
  (:module handlers    "cl-handlers")
  (:module signals     "cl-signals")
  (:module conditions  "cl-conditions")
  (:module ctypes      "cl-predefined-condition-types")
  (:module debug       "EH;ucl-debugger")      ; UCL-debugger 05/09/89 
  (:compile-load restarts)
  (:compile-load handlers )
  (:compile-load signals (:fasload restarts handlers))
  (:compile-load conditions (:fasload signals))
  (:compile-load ctypes   (:fasload conditions))
  (:compile-load debug (:fasload ctypes))

  )


