;;; -*- Mode: Common-Lisp; Package: User; Base: 10.; Patch-File: T -*-
;;; Written 05/20/88 08:06:00 by DUSSUD,
;;; Reason: Debugger changes for CLOS (Courtesy of CLM).
;;; while running on Jenner from band LODA
;;; With SYSTEM 4.57, VIRTUAL-MEMORY 4.1, EH 4.2, MAKE-SYSTEM 4.4, MICRONET 4.4, Experimental LOCAL-FILE 4.0,
;;;  BASIC-PATHNAME 4.10, DISK-IO 4.6, Experimental DISK-LABEL 4.0, BASIC-FILE 4.6,
;;;  MAC-PATHNAME 4.3, Experimental NETWORK-PATHNAME 4.0, COMPILER 4.7, NETWORK-NAMESPACE 4.3,
;;;  TV 4.73, DATALINK 4.14, CHAOSNET 4.15, GC 4.3, Experimental MEMORY-AUX 4.0, NVRAM 4.4,
;;;  Experimental SYSLOG 4.0, Experimental STREAMER-TAPE 4.2, UCL 4.1, Experimental INPUT-EDITOR 4.0,
;;;  METER 4.3, ZWEI 4.17, DEBUG-TOOLS 4.2, NETWORK-SUPPORT 4.5, Experimental NETWORK-SERVICE 4.0,
;;;  Experimental DATALINK-DISPLAYS 4.0, Experimental FONT-EDITOR 4.0, Experimental SERIAL 4.0,
;;;  PRINTER 4.7, Experimental PRINTER-TYPES 4.2, Experimental IMAGEN 4.0, Experimental SUGGESTIONS 4.0,
;;;  MAIL-DAEMON 4.6, MAIL-READER 4.5, TELNET 4.1, VT100 4.4, NAMESPACE-EDITOR 4.5,
;;;  PROFILE 4.4, VISIDOC 4.4, NAMESPACE 4.18, NETWORK-SUPPORT-COLD 4.1, IP 3.12,
;;;  Experimental BUG 10.0, Experimental TI-CLOS 6.4,  microcode 338, Band Name: pre 4.1 + IP 4/11

#!C
; From file RUN-ERRING-SG.LISP#> NEWK.CLOS; Jules-Verne:
#10R EH#:
(COMPILER-LET ((*PACKAGE* (FIND-PACKAGE "EH"))
                          (SI:*LISP-MODE* :COMMON-LISP)
                          (*READTABLE* COMMON-LISP-READTABLE)
                          (SI:*READER-SYMBOL-SUBSTITUTIONS* SYS::*COMMON-LISP-SYMBOL-SUBSTITUTIONS*))
  (COMPILER#:PATCH-SOURCE-FILE "sys:eh; RUN-ERRING-SG.#"


(defun push-new-frame (sg frame function args
		       &optional (call-info-word 0) (arg-offset (- frame %call-state-length)))
  "Using FUNCTION and ARGS, builds a new frame on top of FRAME in regular pdl of SG"
  ;; 03/10/87 CLM - Set %%call-info-lexpr-funcall-flag bit in call-info-word to 0.
  ;;                This wasn't being done and was causing the arguments to be handled
  ;;                incorrectly.
  ;; 05/20/88 CLM - Added CLOS support.
  (let* ((reg-pdl (sg-regular-pdl sg))
	 (next-frame-arg-offset (rp-argument-offset sg reg-pdl frame))
	 (next-frame-local-offset (rp-local-offset sg reg-pdl frame))
	 (num-args (length args))
	 (local-offset (+ arg-offset num-args %call-state-length))
	 (new-frame-state (+ local-offset
			     (IF (TYPEP function 'compiled-function)
				 (fef-number-of-locals function)
				 0)))			; The only important non-fef case so far is microcode entries.  
	 (new-frame (+ new-frame-state %call-state-length)))
    ;; Move top frame's call-state words to just below new frame's local index
    ;; and just above the args for the new frame.
    ;; This does not have to be done when there are no args for the new frame
    ;; (i.e., when the frame index is the same as the local-offset index)
    (unless (= frame local-offset)
      (if (< frame local-offset)
	  (loop for i from 1 to %call-state-length
		doing (setf (aref reg-pdl (- local-offset i)) (aref reg-pdl (- frame i))))
	  (loop for i from %call-state-length downto 1
		doing (setf (aref reg-pdl (- local-offset i)) (aref reg-pdl (- frame i)))))
      ;; Need to convert arg and local pointer of frame state we just moved up
      (setf (sg-top-frame sg) local-offset)
      (setf (rp-local-pointer reg-pdl local-offset) (pdl-buffer-index sg next-frame-local-offset))
      (setf (rp-argument-pointer reg-pdl local-offset) (pdl-buffer-index sg next-frame-arg-offset)))

    ;; Set new top frame to this new frame for FUNCTION
    (setf (sg-top-frame sg) new-frame)
    ;; Set all 5 call-state words for new frame:
    (setf (rp-location-counter-offset reg-pdl new-frame) (if (typep function 'compiled-function)
							     (fef-initial-pc function)
							     0))
    (setf (rp-function-word reg-pdl new-frame) function)
    ;; NOTE: PDL-BUFFER-INDEX converts a pdl array index to a pdl buffer index
    (setf (rp-local-pointer reg-pdl new-frame) (pdl-buffer-index sg local-offset))
    (setf (rp-argument-pointer reg-pdl new-frame) (pdl-buffer-index sg arg-offset))
    (setf (rp-call-info-word reg-pdl new-frame)
	  (dpb 0 %%call-info-lexpr-funcall-flag    ;set the lexpr-funcall bit to 0***
	       (dpb (sg-restore-microstack sg)	    ; Preserve the bit.  - pf, Apr 18, 1986
		    %%call-info-microstack-pushed
		    (dpb (length args)
			 %%call-info-number-of-arguments
			 call-info-word))))
    ;;if this is a clos method the args contain the mapping-tables and the
    ;;the continuation, these should be included in the call-info args field
    (setf (rp-number-of-arguments reg-pdl new-frame)
	  (if (zerop (ldb si:%%call-info-clos-info-provided call-info-word))
	      num-args
	      (let* ((debug-info (extract-debug-info-struct-from-fef function ))
		     (map-slots (get-debug-info-field debug-info :map-slots))
		     (continuation-slot 1))   ;;there will always be a continuation
		(- num-args map-slots continuation-slot ))))
    

    ;; Move args onto stack
    (do ((arg args (cdr arg))
	 (i arg-offset (1+ i)))
	((null arg))
      (setf (aref reg-pdl i) (car arg))
      (%p-store-cdr-code (locf (aref reg-pdl i)) cdr-next))
     ;; Store NILs in local slots.
    (loop for i from local-offset below new-frame-state
	  do (setf (aref reg-pdl i) nil))
    ;; No microstack saved for this new frame
    (setf (sg-restore-microstack sg) 0)
    new-frame))
))

#!C
; From file RUN-ERRING-SG.LISP#> NEWK.CLOS; Jules-Verne:
#10R EH#:
(COMPILER-LET ((*PACKAGE* (FIND-PACKAGE "EH"))
                          (SI:*LISP-MODE* :COMMON-LISP)
                          (*READTABLE* COMMON-LISP-READTABLE)
                          (SI:*READER-SYMBOL-SUBSTITUTIONS* SYS::*COMMON-LISP-SYMBOL-SUBSTITUTIONS*))
  (COMPILER#:PATCH-SOURCE-FILE "sys:eh; RUN-ERRING-SG.#"

(defun sg-unwind-to-frame-and-reinvoke (sg dest-frame
					&optional (form (get-frame-function-and-args sg dest-frame)))
  "Unwind stack group SG until DEST-FRAME is the innermost frame, and prepare to reinvoke it.
If FORM is specified, it is what to execute instead of what DEST-FRAME was executing previously.
Uses STACK-GROUP-RESUME to make SG take off and run."
  ;; 03/25/87 CLM - Fix to set the binding-block-pushed bit in the call-info word to zero when we
  ;;                remove all special bindings (previously it was setting qbbfl flag to zero).
  ;; 05/05/87 CLM - After unwinding the stack, check the sg-state word to see if there is a saved
  ;;                microstack that needs to be popped.  Previously we checked the call-info-word 
  ;;                bit for this, but because of another correction this was no longer valid.  This 
  ;;                fixes the problems encountered in trying to resume from a too-few/many args error.
  ;;                In theses cases where we don't want to resume the microcode we must make sure we
  ;;                flush any saved microstacks on the specpdl.  Also add test to make sure second element
  ;;                of a binding pair is a locative.
  ;; 05/20/88 CLM - Added CLOS support.
  ;; 02/21/89 clm - ran into a situation where we want to return values from a CLOS method
  ;;                via ctrl-r.  In this case, the method is at dest-frame and has mapping tables
  ;;                etc., but the function we are going to invoke is VALUES.  Before we assume we
  ;;                are going to reinvoke a CLOS method should make sure that's the case, and if not,
  ;;                modify the original call-info-word to a non-clos form.
  (declare (special *innermost-visible-frame* ))
  (let ((rp (sg-regular-pdl sg)))
    (assure-free-space)
    ;; Unwind back to point where frame to be retried is about to return.
    ;; This gets rid of its unwind-protects but not its special bindings
    (let ((old-trap-on-call (sg-flags-trap-on-call sg)))
      (setf (sg-flags-trap-on-call sg) 0)
      (sg-unwind-to-frame sg dest-frame nil)
      (setf (sg-flags-trap-on-call sg) old-trap-on-call))
    ;;  Unwinding throws away the args of the last frame unwound.  If the frame immediately above
    ;;  dest-frame was for foothold, the "args" are the state of the stack-group saved by sg-save-state
    ;;  which were stored as two words for each element of the leader of the stack-group.  Thus, we
    ;;  check against the greater of call-arguments-limit, for normal functions, and the size of the foothold
    ;;  state, for the case of unwinding back to the top frame after a trap.  - pf, July 11, 1986
    (unless (<= 0 (- dest-frame (sg-top-frame sg)) (max call-arguments-limit (* 2 (array-leader-length sg))))
      (format t "~&Warning:  While returning from sg-unwind-to-frame, ~@
		   DEST-FRAME: ~A, ~A  and TOP-FRAME: ~A, ~A " 
	      dest-frame (rp-function-word rp dest-frame)
	      (sg-top-frame sg) (rp-function-word rp (sg-top-frame sg))))
    ;;  Unwinding throws away the args of the unwound frame immediately above the destination frame,
    ;;  so dest-frame will always be greater than sg-top-frame when unwinding to a non-top frame.  Since
    ;;  this is known behavior of *unwind-stack (and different from vm1), we'll just adjust dest-frame here.
    ;;     - pf, May 8, 1986
    (setq dest-frame (sg-top-frame sg))
    ;; Next line prevents total disaster if error in the code below
    (setq *innermost-visible-frame* (sg-top-frame sg))
    ;; Get rid of the saved microstack in special pdl for DEST-FRAME.
    ;; There will at least be an entry for XUWR1+1.
   ;; Changed the test from checking the call-info-word to checking the sg-state word to see if
   ;; there is a saved microstack. This is the result of a previous fix.
    (let ((start-idx (sg-frame-special-pdl-range sg dest-frame)))
      (unless (zerop (sg-restore-microstack sg) )
	(do ((sp (sg-special-pdl sg))
	     (spp (sg-special-pdl-pointer sg) (1- spp))
	     (loc))
	    (nil)
	  (setq loc (locf (aref sp spp)))
	  (when (neq (%p-data-type loc) dtp-fix)
	    (ferror nil "Where's my saved microstack?"))
	  (when (not (zerop (%p-ldb %%specpdl-block-start-flag loc)))
	    (return (setf (sg-special-pdl-pointer sg) (1- spp)))))
	;; No longer any saved microstack in special pdl
	(setf (sg-restore-microstack sg) 0))
      ;; Now flush any special bindings made within DEST-FRAME,
      ;; but keep any that were made by closures, flavor instances, etc.
      ;; on entry to DEST-FRAME.
      (when start-idx
	(do ((sp (sg-special-pdl sg))
	     ;; SPP is the index of the first word of a binding pair.
	     ;; So is START-IDX.
	     (spp (1- (sg-special-pdl-pointer sg)) (- spp 2))
	     (loc))
	    ((or (< spp start-idx)
		 (not (zerop (%p-ldb %%specpdl-closure-binding (locf (aref sp spp))))))
	     ;; SPP points to a pair that doesn't belong to DEST-FRAME
	     ;; or else should not be flushed.
	     (setf (sg-special-pdl-pointer sg) (1+ spp))
	     ;; If there was a binding block and we flushed the whole thing,
	     ;; clear the flag saying DEST-FRAME has made a binding block.
	     (when (< spp start-idx)
	       (setf (rp-binding-block-pushed rp dest-frame) 0))
	     ;;set the bit in the call-info word instead of the qbbfl flag
	     ;;(when (< spp start-idx)
	     ;;  (setf (sg-flags-qbbfl sg) 0))
	     )
	  (setq loc (locf (aref sp (1+ spp))))
	  ;;make sure that the second element of the binding pair is a locative and
	  ;;if not, error out. 
	  (when (neq (%p-data-type loc) dtp-locative)
	    (ferror nil "The last word of a binding pair wasn't a locative")))))
    ;; Make sure exit pc is within bounds
    (let ((function (rp-function-word rp dest-frame)))
      (when (and (typep function 'compiled-function)
		 (> (rp-location-counter-offset rp dest-frame) (* 2 (fef-length function))))
	(setf (rp-location-counter-offset rp dest-frame) 0)))
    ;; Now rebuild DEST-FRAME as if it was about to be called
    ;; Redo DEST-FRAME with function and args in form
    (let ((func-to-reinvoke (if (si:validate-function-spec (car form))
				(fdefinition (car form))
				(car form)))
	  (args (cdr form))
	  (next-frame (sg-next-frame sg dest-frame))
	  (call-info-word (rp-call-info-word rp dest-frame)))
      ;;check for clos methods; must repush the mapping-tables and the continuation if present;
      ;;the number of mapping-tables and the local offset for the continuation are
      ;;kept in the functions debug-info
      (unless (zerop (ldb si:%%call-info-clos-info-provided call-info-word))
	(let* ((debug-info (extract-debug-info-struct-from-fef func-to-reinvoke ))
	       (map-slots (get-debug-info-field debug-info :map-slots))
	       (continuation-slot (get-debug-info-field debug-info :continuation-slot)))
	  ;;if there is no continuation (as for a combined method) we must still push a
	  ;;NIL in that slot
	  (if map-slots
	      (progn
		(if continuation-slot
		    (push-end (sg-frame-local-value sg dest-frame continuation-slot) args)
		    (push-end nil args))
		(unless (zerop map-slots)
		  (push-end (sg-frame-local-value sg
						  dest-frame
						  sys:local-for-first-mapping-table) args)
		  (when (> map-slots 1)
		    (dotimes (local (1- map-slots))
		      (push-end (sg-frame-local-value sg
						      dest-frame
						      (+ local sys:locals-for-mapping-table-base))
				args)))))
	      ;; clm 02/21/89
	      (setq call-info-word (si:%logdpb 0 si:%%call-info-clos-info-provided call-info-word))
	      )
	  
	    ))
      (push-new-frame sg next-frame func-to-reinvoke args
		      call-info-word (rp-argument-offset sg rp dest-frame)))
    ;; Now send the SG on its way
    (setf (sg-current-state sg) sg-state-invoke-call-on-return)))
))

#!C
; From file ERROR-CONDITION-DEFINITIONS.LISP#> EH; MR-X:
#10R EH#:
(COMPILER-LET ((*PACKAGE* (FIND-PACKAGE "EH"))
                          (SI:*LISP-MODE* :COMMON-LISP)
                          (*READTABLE* COMMON-LISP-READTABLE)
                          (SI:*READER-SYMBOL-SUBSTITUTIONS* SYS::*COMMON-LISP-SYMBOL-SUBSTITUTIONS*))
  (COMPILER#:PATCH-SOURCE-FILE "SYS: EH; ERROR-CONDITION-DEFINITIONS.#"

;;
;; CLOS ERRORS
;;

;; Clos-Ran-out-of-args-before-method-found 

(def-ucode-format-error Clos-Ran-out-of-args-before-method-found error 
  "TICLOS - Ran out of arguments to dispatch on before method found
         during a Generic Function Dispatch.")

;; Generic-function-hash-table-value-error

(def-ucode-format-error Generic-function-hash-table-value-error error  
  "TICLOS - During Generic Function dispatching, a value was found in a Generic 
         function hash-table which was neither an array or locative.")

;; Generic-function-Individual-hash-table-value-error

(def-ucode-format-error Generic-function-Individual-hash-table-value-error error  
  "TICLOS - During Generic Function dispatching, a value was found in a Generic 
         function individual hash-table which was neither an array or locative.")

;; Support-vector-failure-for-clos

(def-ucode-format-error Support-vector-failure-for-clos error  
  "TICLOS - During Class description look up in the in the Class-Description table
         or the Array Class-Description table in the Support Vector area, neither
         a class-description nor a function to call was found.") 

;; Class-description-not-found-after-call-out

(def-ucode-format-error Class-description-not-found-after-call-out error  
  "TICLOS - The Class description was not found after the function in the 
         Class-Description table or the Array Class-Description table in the
         Support Vector area was called.")

;; CLOS-looping-forever-looking-for-key-in-hash-table

(def-ucode-format-error CLOS-looping-forever-looking-for-key-in-hash-table error
  "TICLOS - The microcode has has gone through the whole hash table without
         finding the key or finding a empty slot.  Hash table may be full.")

;; CLOS-Dispatch-failure-bad-hash-table

(def-ucode-format-error CLOS-Dispatch-failure-bad-hash-table error  
  "TICLOS - During Generic Function dispatching, the array being used as a hash
         table is not a valid TICLOS has table.")

;; CLOS-Permuation-list-does-not-contain-fixnums

(def-ucode-format-error CLOS-Permuation-list-does-not-contain-fixnums error  
  "TICLOS - During Generic Function dispatching, the permutation list
         passed in contains objects other than fixnums.  The 
         permutation list must be cdr-coded list of fixnums.")

;; CLOS-Permuation-list-not-a-cdr-coded-list

(def-ucode-format-error CLOS-Permuation-list-not-a-cdr-coded-list error  
  "TICLOS - During Generic Function dispatching, the permutation list
         passed in is not a cdr-coded list.  The permutation list
         must be cdr-coded list of fixnums.")

;; CLOS-Permutation-list-ended-before-method-found

(def-ucode-format-error CLOS-Permutation-list-ended-before-method-found error  
  "TICLOS - During Generic Function dispatching, the end of the permutation
         list was reached before the method to use was found.  Either the
         permutation list is incorrect or the dispatch tables are wrong.") 

;; CLOS-Permuation-list-not-fixnum-or-list

(def-ucode-format-error CLOS-Permuation-list-not-fixnum-or-list error  
  "TICLOS - The second argument to %dispatch-method, the permutation list
         was not a fixnum or a cdr-coded list of fixnums.")

;; CLOS--no-hash-table-after-calling-out

(def-ucode-format-error CLOS--no-hash-table-after-calling-out error  
  "TICLOS - The %Dispatch-method miscop was called with no hash table so
         the microcode called out. The function called out to did not
         return a hash table.")

;; CLOS-Method-was-found-but-is-not-a-function

(def-ucode-format-error CLOS-Method-was-found-but-is-not-a-function error  
  "TICLOS - During generic dispatching, the method was found but was not
         a compiled function.")

;; Cant-handle-self-mapping-table-bit-in-fef-header-in-generic-functions 

(def-ucode-format-error Cant-handle-self-mapping-table-bit-in-fef-header-in-generic-functions error  
  "TICLOS - During generic dispatching, the method was found but the self-mapping
         table bit is set which is illegal for TICLOS methods.")

;; CLOS-cant-handle-optionals-in-method

(def-ucode-format-error CLOS-cant-handle-optionals-in-method error  
  "TICLOS - During generic dispatching, the method was found but it contained 
         optional arguments which can't be handled by generic dispatching.")

;; CLOS-Non-cdr-coded-list-for-list-of-clos-mapping-tables 

(def-ucode-format-error CLOS-Non-cdr-coded-list-for-list-of-clos-mapping-tables error
  "TICLOS - during function calling, the Clos-info-provided bit was set in the call info
         word, but the mapping table list provided was not a cdr-coded list.")

;; Clos-mapping-table-not-array 

(def-ucode-format-error Clos-mapping-table-not-array error  
  "TICLOS - During transport of a SELF-REF-POINTER, a mapped reference was 
         indicated, but the value obtained from the local block was not a
         mapping table (array).")

;; CLOS-local-or-arg-not-instance 

(def-ucode-format-error CLOS-local-or-arg-not-instance error  
  "TICLOS - During transport of a SELF-REF-POINTER, the value obtained from
         the local block or argument block was not an instance.")

;; Clos-mapping-table-not-array-during-map-leader-ref 

(def-ucode-format-error Clos-mapping-table-not-array-during-map-leader-ref error  
  "TICLOS - During transport of a SELF-REF-POINTER, a map leader reference was
         indicated, but the value read from the array leader was not a mapping
         table (array).")

))
