;;; -*- Mode:Common-Lisp; Package:SYSTEM; Base:8; Patch-file:T; Fonts:(CPTFONT CPTFONTB HL12BI HL12) -*-

;;;			      RESTRICTED RIGHTS LEGEND

;;;Use, duplication, or disclosure by the Government is subject to
;;;restrictions as set forth in subdivision (c)(1)(ii) of the Rights in
;;;Technical Data and Computer Software clause at 52.227-7013.
;;;
;;;			TEXAS INSTRUMENTS INCORPORATED.
;;;				 P.O. BOX 2909
;;;			      AUSTIN, TEXAS 78769
;;;				    MS 2151
;;;
;;; Copyright (C) 1989 Texas Instruments Incorporated. All rights reserved.


;;; Written 11/03/87 10:34:58 by DUSSUD,
;;; Reason: Added support for interpreted functions in get-debug-info-struct.
;;; Reason: 
;;; Reason: Kernel changes for CLOS.
;;; Reason: Kernel changes for CLOS
;;; Reason: Changes for CLOS.
;;; Reason: CLOS Support
;;; Reason: Add support for setf functions.
;;; while running on Jenner from band LODA
;;; With IO 3.44, PATHNAME 3.17, FILE 3.15, SYSTEM 3.104, METER 3.7, SERIAL 3.2, CHAOSNET 3.23,
;;;  ETHERNET 3.3, GC 3.24, IMAGEN 3.0, MAIL-DAEMON 3.7, NETWORK-SUPPORT 3.21, PROFILE 3.4,
;;;  SUGGESTIONS 3.6, UCL 3.3, ZWEI 3.24, STREAMER-TAPE 3.16, DEBUG-TOOLS 3.5, FONT-EDITOR 3.1,
;;;  GLOSSARY 3.0, INPUT-EDITOR 3.0, MAIL-READER 3.19, NAMESPACE-EDITOR 3.6, NVRAM 3.6,
;;;  TELNET 3.7, TV 3.28, NAMESPACE 3.15, COMPILER 3.35, PRINTER 3.7, SYSLOG 3.0,
;;;  VT100 3.14, IP 2.69, Experimental BUG 8.0, Experimental VISIDOC 1.0,  microcode 230,
;;;  Band Name: PRE 3.2 10-8 +IP

;;  8/10/88 DNG - Moved EXPORT to new file FIRSTDEFS.
;;  8/25/88 clm - Fixed TYPEP-TWO-ARGS for clos; only generate a typep-structure-or-flavor 
;;                instruction if the class object is of type standard-class.


#!C
; From file DEFMACRO.LISP#> KERNEL; MR-X:
#10R SYSTEM#:
(COMPILER-LET ((*PACKAGE* (FIND-PACKAGE "SYSTEM"))
                          (SI:*LISP-MODE* :COMMON-LISP)
                          (*READTABLE* COMMON-LISP-READTABLE)
                          (SI:*READER-SYMBOL-SUBSTITUTIONS* *COMMON-LISP-SYMBOL-SUBSTITUTIONS*))
  (COMPILER#:PATCH-SOURCE-FILE "SYS: KERNEL; DEFMACRO.#"


(eval-when (compile load eval)
;; 12/23/88 DNG - Add special handling for :EXPR-SXHASH declarations - fixes SPR 6038.
(Defun PARSE-MACRO-BODY (x)
;;; if the defmacro form is (defmacro foo arglist . body), then parse-macro-body is called with arg (body)
  
  (MULTIPLE-VALUE-BIND (body decls doc-string)
      (PARSE-BODY x nil t)
    (LET (declarations-for-debug-info
	  declarations-for-body)
      (DOLIST (dec (FLATTEN-DECLARATIONS decls))
	(LET ((temp (CDR (ASSOC (CAR dec) *DEBUG-STRUCT-LOCAL-DECLARATION-TYPES* :test #'EQ))))
	  (IF temp
	      (setq declarations-for-debug-info (LIST* temp (COPY-TREE (CDR dec)) declarations-for-debug-info))
	    (if (eq (first dec) ':expr-sxhash)
		(setq declarations-for-debug-info (LIST* (first dec) (second dec) declarations-for-debug-info))
	      (PUSH dec  declarations-for-body)))))
      (values body declarations-for-debug-info declarations-for-body doc-string))))
)
))

#!C
; From file SETF.LISP#> KERNEL; SYS:
#8R SYSTEM#:
(COMPILER-LET ((*PACKAGE* (FIND-PACKAGE "SYSTEM"))
                          (SI:*LISP-MODE* :COMMON-LISP)
                          (*READTABLE* COMMON-LISP-READTABLE)
                          (SI:*READER-SYMBOL-SUBSTITUTIONS* *COMMON-LISP-SYMBOL-SUBSTITUTIONS*))
  (COMPILER#:PATCH-SOURCE-FILE "sys: KERNEL; SETF.#"


(defun get-setf-method-multiple-value (form &optional short-cut &aux tem form1)
  "Return the canonical five values that say how to do SETF on FORM.
The values are:
* a list of symbols, gensyms, that stand for parts of FORM
* a list of the parts of FORM that they stand for
* a list of symbols, gensyms, that stand for the values to be stored
* an expression to do the storing.  It contains the gensyms described already.
* an expression to refer to the existing value of FORM.
  It differs from FORM in that it has the gensyms replacing the
  parts of FORM that they stand for.
These values give all the information needed to examine and set
 FORM repeatedly without evaluating any of its subforms more than once.

If SHORT-CUT is non-NIL, and if FORM's method of SETFing was defined
by a simple DEFSETF that just gives a function to do the setting,
then we return just two values: the setting function and a replacement FORM
\(differing from FORM by having macros expanded, CADR -> CAR (CDR ...), etc.).
The caller can tell that this case occurred because the first value
is a non-NIL symbol in this case, and is always a list in the normal case."
  (declare (values tempvars tempargs storevars storeform refform))
  (cond ((symbolp (Setf form (parse-the-in-place form)))
	 (let ((g (gensym)))
	   (values nil nil (list g) `(setq ,form ,g) form)))
	((atom form))
	((not (symbolp (setf form1 (car form))))
	 (ferror nil "~S non-symbolic function in SETF." form1))
	((or (eq (getdecl form1 'setf-method) 'unsetfable)
             (eq (getdecl form1 'setf) 'unsetfable))
	 (nosetf form))
	((setq tem (getdecl form1 'setf-method))
	 (if (symbolp tem)
	     (if short-cut
		 (values tem form)
	       (let ((gs (mapcar #'(lambda (ignore) (gensym)) (cdr form)))
		     (g (gensym)))
		 (values gs (cdr form) (list g)
			 `(,tem ,@gs ,g)
			 `(,form1 ,@gs))))
	   (if (eq (cdr tem) 'nosetf)
	       (nosetf form))
	   (funcall (cdr tem) form si:*macroexpand-environment* )))
	((setq tem (getdecl form1 'setf-expand))
	 (get-setf-method-multiple-value (funcall tem form) short-cut))
	((and (fboundp form1)
	      (arrayp (symbol-function form1)))
	 (get-setf-method-multiple-value `(aref #',form1 . ,(cdr form)) short-cut))
	((and (fboundp form1)
	      (symbolp (symbol-function form1)))
	 (get-setf-method-multiple-value `(,(symbol-function form1) . ,(cdr form)) short-cut))
	((not (eq form (setq form (macroexpand-1 form 
						 si:*macroexpand-environment*))))
	 (get-setf-method-multiple-value form short-cut))
	(t (let ((gs (mapcar #'(lambda (ignore) (gensym)) (cdr form)))
		 (g (gensym)))
	     (values gs (cdr form) (list g)
		     `(funcall (function (setf ,(car form))) ,g ,@gs )
		     `(,form1 ,@gs))))
	))

(COMPILER-LET ((local-declarations '((:expr-sxhash 3795008.))))	; suppress version warnings
(defmacro locf (accessor)
  "Return a locative pointer to the place where ACCESSOR's value is stored.
Note that (CDR (LOCF SOMETHING)) is normally equivalent to SOMETHING,
which may be a list rather than a locative."
  (do-forever
    (let (fcn)
      (cond ((symbolp (setf accessor (parse-the-in-place accessor)))			;SPECIAL CASE NEEDED.
	     (return `(variable-location ,accessor)))
	    ((not (symbolp (car accessor)))
	     (ferror nil "~S non-symbolic function in LOCF" (car accessor)))
	    ((eq (getdecl (car accessor) 'locf) 'unlocfable)
	     (ferror 'unknown-locf-reference
		     "LOCF is explicitly forbidden on ~S." (car accessor)))
	    ((setq fcn (getdecl (car accessor) 'locf-method))
	     (if (symbolp fcn)
		 (return (cons fcn (cdr accessor)))
	       (return (funcall (cdr fcn)  accessor  *macroexpand-environment*))))
	    ((setq fcn (getdecl (car accessor) 'setf-expand))
	     (setq accessor (funcall fcn accessor)))
	    ((and (fboundp (car accessor)) (arrayp (symbol-function (car accessor))))
	     (return `(aloc #',(car accessor) . ,(cdr accessor))))
	    ((and (fboundp (car accessor)) (symbolp (symbol-function (car accessor))))
	     (return `(locf (,(symbol-function (car accessor)) . ,(cdr accessor)))))
	    ((not (eq accessor (setq accessor (macroexpand-1 accessor
							     *macroexpand-environment*)))))
	    (t (return `(funcall (function (locf ,(car accessor))) . ,(cdr accessor))))))))
)

(defun delete-locf-method (access-fn)
  "delete the locf method associated with the accessor function access-fn"
  (dolist (prop '(locf locf-method))
    (when (get access-fn prop)
      (remprop access-fn prop))))


))

;;  8/10/88 DNG - Moved SETF function support to new file FIRSTDEFS.

#!C
; From file SELECT-MATCH.LISP#> KERNEL; SYS:
#10R SYSTEM#:
(COMPILER-LET ((*PACKAGE* (FIND-PACKAGE "SYSTEM"))
                          (SI:*LISP-MODE* :COMMON-LISP)
                          (*READTABLE* COMMON-LISP-READTABLE)
                          (SI:*READER-SYMBOL-SUBSTITUTIONS* *COMMON-LISP-SYMBOL-SUBSTITUTIONS*))
  (COMPILER#:PATCH-SOURCE-FILE "SYS: KERNEL; SELECT-MATCH.#"

;; 12/12/88 DNG - Replace variable "OBJ" with "OBJECT" because "OBJ" has been 
;;		declared special in file "SYS:MEMORY-MANAGEMENT;MEMORY-DEBUG.LISP".
(defun select-match-matchitems (patt expr)
  (declare (special boundvars))
  (cond
    ((null patt) `(null ,expr))
    ((symbolp patt)
     (cond
       ((eq patt 'ignore) `(progn ,expr t))
       ((member patt boundvars :test #'eq) `(equal ,expr ,patt))
       (t (push patt boundvars) `(progn
				   (setq ,patt ,expr)
				   t))))
    ((eq (car patt) 'xr-bq-cons)
     `(match-car-cdr ,expr #'(lambda (object)
			   ,(select-match-matchitems (cadr patt) 'object))
	 #'(lambda  (object)
	   ,(select-match-matchitems (caddr patt) 'object))) )
    ((eq (car patt) 'xr-bq-list)
     (let ((exp '(null object))
	   (eltmatches (mapcar 'select-match-matchitems (cdr patt) (circular-list 'object))))
       (loop for eltmatch in (reverse eltmatches) do
	  (setq exp
		`(match-car-cdr object #'(lambda (object)
				    ,eltmatch)
		    #'(lambda (object)
		      ,exp))))
       `(match-car-cdr ,expr ,@(cddr exp))))
    ((eq (car patt) 'xr-bq-list*)
     (let ((exp (select-match-matchitems (car (last patt)) 'object))
	   (eltmatches (mapcar 'select-match-matchitems (butlast (cdr patt)) (circular-list 'object))))
       (loop for eltmatch in (reverse eltmatches) do 
	  (setq  exp
		`(match-car-cdr object #'(lambda (object)
				    ,eltmatch)
		    #'(lambda (object)
		      ,exp))))
       `(match-car-cdr ,expr ,@(cddr exp))))
    ((eq (car patt) 'quote) `(equal ,expr ',(cadr patt)))
    ((member (car patt) '`(,@xr-bq-nconc ,@xr-bq-vector) :test #'eq)
     (ferror () "Appending, nconcing or vector construction in SELECT-MATCH pattern."))
    (t (ferror () "Unexpected function ~S found in SELECT-MATCH pattern." (car patt)))))
(assert (not (compiler:specialp 'object)))
))

#!C
; From file SETF.LISP#> KERNEL; SYS:
#8R SYSTEM#:
(COMPILER-LET ((*PACKAGE* (FIND-PACKAGE "SYSTEM"))
                          (SI:*LISP-MODE* :COMMON-LISP)
                          (*READTABLE* COMMON-LISP-READTABLE)
                          (SI:*READER-SYMBOL-SUBSTITUTIONS* *COMMON-LISP-SYMBOL-SUBSTITUTIONS*))
  (COMPILER#:PATCH-SOURCE-FILE "SYS: KERNEL; SETF.#"


(defmacro pushnew (value place &rest options &key (test nil test-p) (test-not nil test-n-p) key)
  "Add VALUE to the front of the list PLACE, if it's not already a member of the list.
Equivalent to (SETF PLACE (ADJOIN VALUE PLACE OPTIONS...))
but evaluates subforms of PLACE only once."
  (declare (arglist value place &key test test-not key))
  (let ((pl (gensym))
	(val (gensym)))
    (sublis-eval-once `((,val . ,value))
		      (sublis-eval-once `((,pl . ,place))
					`(if ,(if (or (and (eq (car-safe key) 'function)
							   (eq (cadr-safe key) 'car))
						      (eq key 'car))
						  `(assoc (car ,val) ,pl ,@(and test-p `(:test ,test))
							  ,@(and test-n-p `(:test-not ,test-not)))
						  `(member ,val ,pl ,@options))
					     ,pl
					     (values (setf ,place (cons ,val ,pl))))))))
))

;;;placed in "SYS:KERNEL;PREDICATES"
(DEFSUBST ticlos:clos-instance-p (i)
  (AND (INSTANCEP i) (ODDP (sys:%p-cdr-code i))))

;;;placed in "SYS:KERNEL;TYPES"
(defsubst classp (object)
  ;; Is the argument a CLOS class object?
  (typep-structure-or-flavor object 'ticlos:class))

;;;placed in "SYS:KERNEL;RUNTIME-FLAVOR"
(defsubst get-flavor (flavor-name &optional environment)
  ;; Given a flavor name, return the flavor structure or nil.
  ;; 11/23/88 DNG - Original.
  (compiler:get-from-environment flavor-name 'si::flavor nil environment))


;; Note: when this is integrated into the release 6 source, TYPE-SPECIFIER-P 
;; probably should be changed to accept an optional environment argument 
;; which it will pass to CLASS-NAMED and GETDECL.   -- D.N.G. 10/26/88


;;; add this to "KERNEL;TYPES"

;;; 08/04/88 clm - if requested (by passing :CREATE as the first optional arg)
;;; create a dummy class for CLASS-NAME.  This may be needed if 
;;; class-name was known when the file was compiled but not when the xld 
;;; is loaded.
;;  9/23/88 DNG - When creating, let class-options default.
;;  9/24/88 DNG - Signal error for invalid argument type.  
;;  9/26/88 DNG - Added handling for alias flavors that aren't in *ALL-FLAVOR-NAMES* .
;; 10/14/88 DNG - Redesigned to use environments.
;; 11/10/88 DNG - Add use of MAKE-CLASS-FOR-STRUCTURE .
;; 11/23/88 DNG - Use GET-FLAVOR instead of GETDECL.
;; 12/01/88 DNG - Use function ADD-NAMED-CLASS-INTERNAL instead of TICLOS::ADD-NAMED-CLASS.
;; 12/12/88 DNG - Add a doc string.
(defun ticlos:class-named (class-name &optional noerrorp environment)
  "Return the class object whose name is the first argument.  If the argument 
is a symbol, its class object is returned.  If the argument is a class object, 
then it is simply returned.  If no such class exists, an error is signalled 
unless the second argument is true, in which case NIL will be returned."
  (if (symbolp class-name)
      (let ((cl (compiler:get-from-environment class-name ticlos:class-property nil 
					       environment)))
	(or cl
	    (and (not noerrorp)
		 (get class-name 'si:defstruct-description)
		 (let ((default-cons-area background-cons-area))
		   (ticlos:make-class-for-structure class-name)
		   (get class-name ticlos:class-property)))
	    (let ((fl (get-flavor class-name environment)))
	      (and fl
		   (not (eq (sys:flavor-name fl) class-name))
		   ;; an alias flavor
		   (ticlos:class-named (sys:flavor-name fl) noerrorp environment)))
	    ;;if the class was defined at compile time, but is not
	    ;;defined at load time, create a dummy class for class-name
	    ;;trusting in redefinition later
	    (and (eq noerrorp :create)
		 (ticlos:add-named-class-internal    ;;the main part of defclass
		   'ticlos:standard-class
		   class-name nil nil nil environment))
	    (unless noerrorp
	      (error "Class named ~S does not exist." class-name))
	    nil))
    (if (sys:typep-structure-or-flavor class-name 'ticlos:class)
	class-name
      (error "~S is neither a class object or class name." class-name))))

;; 10/03/88 DNG - Modified to test UNDO-DECLARATIONS-FLAG instead of QC-FILE-IN-PROGRESS.
;; 10/06/88 DNG - Redesigned to use environments.
(defun (setf ticlos:class-named ) (class class-name &optional noerrorp environment)
  (declare (ignore noerrorp))
  (check-type class-name (and symbol (not null)) "a non-nil symbol")
  (compiler:putprop-in-environment class-name class ticlos:class-property environment)
  class)

#!C
; From file TYPES.LISP#> KERNEL; SYS:
#10R SYSTEM#:
(COMPILER-LET ((*PACKAGE* (FIND-PACKAGE "SYSTEM"))
                          (SI:*LISP-MODE* :COMMON-LISP)
                          (*READTABLE* COMMON-LISP-READTABLE)
                          (SI:*READER-SYMBOL-SUBSTITUTIONS* *COMMON-LISP-SYMBOL-SUBSTITUTIONS*))
  (COMPILER#:PATCH-SOURCE-FILE "SYS: KERNEL; TYPES.#"

;;PHD 6/29/88 Added support for clos classes.
;;CLM for PHD 02/11/87 - fix bug report ????? [from Stephanie Keene] on subtypep.
;;Fix: last clause of (case...) changed from (apply tem (cdr typespec)) to 
;;(type-canonicalize (apply tem (cdr typespec))).
;;DNG 8/10/88 Use TYPEP-STRUCTURE-OR-FLAVOR instead of TYPEP for CLASS test to 
;;	avoid bootstrapping problems.
(defun type-canonicalize (typespec &aux tem)
  "Returns a typespec equivalent in meaning to TYPESPEC, but possibly simpler."
  (cond
    ((null typespec) nil)
    ((eq typespec t) t)
    ((symbolp typespec)
     (cond
       ((setq tem (get typespec 'type-alias-for)) (type-canonicalize tem))
       ((setq tem (getdecl typespec 'type-expander)) (type-canonicalize (funcall tem)))
       (t typespec)))
    ((classp typespec) typespec)
    ((and (consp typespec) (symbolp (car typespec)))
     (case (car typespec)
       (or
	(when (null (cdr typespec))
	  (type-canonicalize
	    (cerror t () 'wrong-type-argument "~*~S invalid typespec." 'typespec typespec)))
	(let ((z
		(mapcan
		  #'(lambda (x)
		      (setq x (type-canonicalize x))
		      (if (and (consp x) (eq (car x) 'or))
			  (cdr x)
			  (list x)))
		  (cdr typespec))))
	  (if (cdr z)
	      (cons 'or z)
	      (car z))))
       (and
	(when (null (cdr typespec))
	  (type-canonicalize
	    (cerror t () 'wrong-type-argument "~*~S invalid typespec." 'typespec typespec)))
	(let ((z
		(mapcan
		  #'(lambda (x)
		      (setq x (type-canonicalize x))
		      (if (and (consp x) (eq (car x) 'and))
			  (cdr x)
			  (list x)))
		  (cdr typespec))))
	  (if (cdr z)
	      (cons 'and z)
	      (car z))))
       (not
	(if (null (cdr typespec))
	    (type-canonicalize
	      (cerror t () 'wrong-type-argument "~*~S invalid typespec." 'typespec typespec))
	    (let ((z (type-canonicalize (cadr typespec))))
	      (if (and (consp z) (eq (car z) 'not))
		  (cadr z)
		  (list 'not z)))))
       ((member global:member)
	`(member ,@(cdr typespec)))
       (t
	(if (dolist (elt (cdr typespec) t)
	      (unless (eq elt '*)
		(return ())))
	    (type-canonicalize (car typespec))
	    (if (setq tem (getdecl (car typespec) 'type-expander))
		(type-canonicalize (apply tem (cdr typespec)))
		typespec)))))
    (t
     (type-canonicalize
       (cerror t () 'wrong-type-argument "~*~S invalid typespec." 'typespec typespec))))) 

;;  8/10/88 DNG - Use TYPEP-STRUCTURE-OR-FLAVOR instead of TYPEP for CLASS 
;;		test to avoid bootstrapping problems.
;; 10/25/88 DNG - Modifed to call CLASS-NAMED once instead of twice.
(defun typep (object &optional (type nil type-specified-p))
  "T if OBJECT fits the data type specifier TYPE.
An obsolete mode of use is with one argument;
then the value is a type specifier describing OBJECT."
  (declare (arglist object type))
  (let (predicate
	expander
	structure-desc
	(type type)
	dtp)
    (cond
      ((not type-specified-p)
       (setq dtp (%data-type object))
       ;; Cannot use TYPE-OF, since we must
       ;; for back-compatibility return keywords.
       (cond
	 ((= dtp dtp-instance)
	  (%p-contents-offset (instance-flavor object) %instance-descriptor-typename))
	 ((= dtp dtp-array)
	  (cond
	    ((named-structure-p object))
	    ((stringp object) :string)
	    (t :array)))
	 ((= dtp dtp-extended-number)
	  (select (%p-ldb-offset %%header-type-field object 0)
	    (%header-type-bignum :bignum)
	    (%header-type-rational :rational)
	    (%header-type-complex :complex)
	    (%header-type-double-float 'double-float)
	    (otherwise :random)))
	 ((cdr (assoc dtp typep-one-arg-alist :test #'eq)))
	 (t :random)))
      ((classp type)
       (typep-structure-or-flavor object type))
      ((setq predicate (get (if (atom type)
				type
				(car type))
			    'type-predicate))
       (if (atom type)
	   (funcall predicate object)
	   (apply predicate object (cdr type))))
      ((setq dtp
	     (or (rassoc type type-of-alist :test #'eq)
		 (rassoc type typep-one-arg-alist :test #'eq)))
       (= (%data-type object) (car dtp)))
      ((setq expander (getdecl (if (atom type)	;PDC 8/4/86
				   type
				   (car type))
			       'type-expander))
       (typep object (apply expander (if (atom type)
					 ()
					 (cdr type)))))
      ((progn
	 (unless (symbolp type)
	   (setq type (car type)))
	 (get type 'flavor))
       (typep-structure-or-flavor object type))
      ((or
	 (and (setq structure-desc (get type 'defstruct-description))
	      (defstruct-description-named-p structure-desc))
	 (get type 'defstruct-named-p))
       (typep-structure-or-flavor object type))
      ((setq dtp (ticlos:class-named type t))
       (typep-structure-or-flavor object dtp))
      (t
       (typep object
	      (cerror t () 'wrong-type-arg "~1@*~S is not a type known to TYPEP" 'typep type)))))) 

(defun type-specifier-p (type)
  "Returns T on valid type specifiers, NIL on any other object."
  ;; 10/26/88 DNG - Use *compile-file-environment*.
  (multiple-value-bind
    (expanded-type error-p )
      (ignore-errors (type-canonicalize type))
    (if error-p nil
	(progn 
	  (when (member expanded-type '(nil structure ratio atom bignum null random-state t
					    common	;(or number ...... )
					    fat-char	;(and character (satisfies ....)
					    keyword	;(and symbol (satisfies keywordp ))
					    list	;(or null cons)
					    number	; (or complex real)
					    real	; (or rational float)
					    ))
	    (return-from type-specifier-p t))
	  (typecase expanded-type
	    (symbol (not (null
			   (cond
			     ((get expanded-type 'type-validator)
			      (funcall (get expanded-type 'type-validator)))
			     ((rassoc expanded-type type-of-alist
				      :test #'(lambda (expanded-type cons)
						(if (consp cons)
						    (member expanded-type cons :test #'eq)
						    (eq expanded-type cons))))
			      t)
			     ((getdecl expanded-type 'type-predicate) t)
			     ((compilation-flavor expanded-type t) t)
			     ((getdecl expanded-type 'defstruct-description) t)   ;; check for typed structure
			     ((ticlos:class-named expanded-type t compiler:*compile-file-environment*) t)
			     ))))
	    (list (and (get (first expanded-type) 'type-validator)
		       (apply (get (first expanded-type) 'type-validator) (rest expanded-type)))))))))


(defun typep-two-args (form &aux opt type pred dtp tem)
  ;;phd 1/15/85 Change the type-of-alist lookup to symbolic-type-of-alist lookup
  ;;to be able to do cross compilation when the datatypes have changed.
  ;;phd 11/22/85 fixed flavor and defstruct part
  ;;Fixed some optimizations problems:
  ;;This function does not recurse anymore and relies on the compiler's 
  ;;optimizer driver to call it repeatedly until no optimization is being done.
  ;;The type expansion is done here instead of calling type-canonicalize that
  ;;would recurse and prevent intermediate optimizations.
  ;;PHD-PAD 3/12/87 Added getdecl for flavors and structures.
  ;;08/04/88 clm - if the type will need to be known at load time, but the
  ;;               class is undefined at that time, send signal to CLASS-NAMED to create 
  ;;               the class on the fly to prevent unloadable xlds.  Changes also made to
  ;;               CLASS-NAMED to do the actual creation.
  ;;08/25/88 clm - for clos, only generate a typep-structure-or-flavor instruction
  ;;               if the class object is of type standard-class.
  ;;03/06/89 clm - don't try to handle type-predicates which are not symbols.  Genasys cannot handle
  ;;               the forms this would generate.
  (cond
    ((and (= (length form) 3) (constantp (caddr form)))
     (setq type (compiler:eval-for-target (caddr form)))
     ;;This takes care of constants evaluation
     (cond
       ((symbolp type)
	(cond
	  ((setq opt (get type 'type-optimizer)) (funcall opt form))
	  ((and (setq pred (get type 'type-predicate)) (symbolp pred)) `(,pred ,(cadr form))) ;; clm 03/06/89
	  ((setq dtp (rassoc type symbolic-type-of-alist :test #'eq))
	   `(= (%data-type ,(cadr form)) ,(car dtp)))
	  ((compilation-flavor type (just-compiling)) `(typep-structure-or-flavor ,(cadr form) ',type))
	  ((getdecl type 'defstruct-description) `(typep-structure-or-flavor ,(cadr form) ',type))
	  ((typep-structure-or-flavor (ticlos:class-named type t compiler:*compile-file-environment*)
				      'ticlos:standard-class)
	   `(typep-structure-or-flavor ,(cadr form)
				       (sys:eval-at-load-time (ticlos:class-named ',type :create))))
	  ((setq tem (get type 'type-alias-for)) `(typep ,(cadr form) ',tem))
	  ((setq tem (getdecl type 'type-expander)) `(typep ,(cadr form) ',(funcall tem)))
	  (t form)))
       ((classp type)
	`(typep-structure-or-flavor ,(cadr form) ',type))
       (t
	(cond
	  ((setq opt (get (car type) 'type-optimizer)) (apply opt form (cdr type)))
	  ((setf tem (getdecl (car type) 'type-expander))
	   `(typep ,(cadr form) ',(apply tem (cdr type))))
	  (t form)))))
    (t form)))  
))

#!C
; From file TYPES.LISP#> KERNEL; SYS:
#10R SYSTEM#:
(COMPILER-LET ((*PACKAGE* (FIND-PACKAGE "SYSTEM"))
                          (SI:*LISP-MODE* :COMMON-LISP)
                          (*READTABLE* COMMON-LISP-READTABLE)
                          (SI:*READER-SYMBOL-SUBSTITUTIONS* *COMMON-LISP-SYMBOL-SUBSTITUTIONS*))
  (COMPILER#:PATCH-SOURCE-FILE "sys: KERNEL; TYPES.#"

;; 8/4/88 clm - fixed problem reported in 8423; (subtypep 'list 'atom) was incorrectly
;; returning T.
;; 10/26/88 DNG - Use COMPILER:*COMPILE-FILE-ENVIRONMENT*; don't compute C2 until needed.
(defun atom-subtypep (x y &aux t1 t2 (f1 (compilation-flavor x (just-compiling)))
		                     (f2 (compilation-flavor y (just-compiling))))

  (cond
    ((eq x y) t)
    
    (f1
     (or (eq y 'atom)
	(and f2 (member y (dont-optimize (flavor-depends-on-all f1)) :test #'eq) t)))
    (f2 nil)
    ((or (and (setq t1 (getdecl x 'defstruct-description)) (defstruct-description-named-p t1))
	(getdecl x 'defstruct-named-p))
     (if (member y '(structure atom array common) :test #'eq)
       t
       (and
	(or (and (setq t2 (getdecl y 'defstruct-description)) (defstruct-description-named-p t2))
	   (get y 'defstruct-named-p))
	(do ((symbol x
	      (and (setq t1 (getdecl symbol 'defstruct-description))
		 (car (defstruct-description-include t1)))))
	    ((null symbol)
	     nil)
	  (and (eq y symbol) (return t))))))
    (t (OR (not (null (member x (get y 'subtypes) :test #'eq)))
	   (LET ((c1 (ticlos:class-named x t compiler:*compile-file-environment*))
		 c2)
	     (AND c1
		  (not (typep-structure-or-flavor c1 'ticlos:built-in-class))
		  (or (eq y 'atom)
		      (and (setq c2 (ticlos:class-named y t compiler:*compile-file-environment*))
			   (ticlos:subclassp c1 c2) t))))))))

))

#!Z
; From file LROY-QCOM.LISP#> UCODE; SYS:
#8R SYSTEM#:
(COMPILER-LET ((*PACKAGE* (FIND-PACKAGE "SYSTEM"))
                          (SI:*LISP-MODE* :ZETALISP)
                          (*READTABLE* STANDARD-READTABLE)
                          (SI:*READER-SYMBOL-SUBSTITUTIONS* *ZETALISP-SYMBOL-SUBSTITUTIONS*))
  (COMPILER#:PATCH-SOURCE-FILE "sys: UCODE; LROY-QCOM.#"


(DefAlternate FEF-Storage-length-Fields
	      (Q-corresponding-variable-lists System-Constant-Lists)
   ;;Storage-length word definitions
   (%%FEF-Storage-Length-Generic-Function-Flag    3601 ; 0 if this is a Generic function
    ))
(Defsysconst %SVC-CLOS-OBSOLETE-CLASS-DESCRIPTION 161)
(Defsysconst %SVC-CLOS-CLASS-DESCRIPTION-NIL      162)  	;#o162- Clos class description for NIL

))

#!C
; From file DEBUG-INFO.LISP#> KERNEL; MR-X:
#10R SYSTEM#:
(COMPILER-LET ((*PACKAGE* (FIND-PACKAGE "SYSTEM"))
                          (SI:*LISP-MODE* :COMMON-LISP)
                          (*READTABLE* COMMON-LISP-READTABLE)
                          (SI:*READER-SYMBOL-SUBSTITUTIONS* *COMMON-LISP-SYMBOL-SUBSTITUTIONS*))
  (COMPILER#:PATCH-SOURCE-FILE "sys: KERNEL; DEBUG-INFO.#"

;;PHD added support for  unencapsulated argument on interpreted functions.
(Defun GET-DEBUG-INFO-STRUCT (function-object &OPTIONAL unencapsulated)
  (TYPECASE function-object
    (SYMBOL
     (GET-DEBUG-INFO-STRUCT (if  unencapsulated
				 (unencapsulate-function-spec function-object)
				 (SYMBOL-FUNCTION function-object))))
    (COMPILED-FUNCTION
     (let* ((struct(EXTRACT-DEBUG-INFO-STRUCT-FROM-FEF function-object))
	    (info (and unencapsulated (get-debug-info-field struct 'encapsulated-definition))))
       (if info
	   (GET-DEBUG-INFO-STRUCT (car info) unencapsulated )
	   struct)))
    (MICROCODE-FUNCTION
     (EXTRACT-DEBUG-INFO-STRUCT-FROM-UCODE function-object))
    (CLOSURE 
     (GET-DEBUG-INFO-STRUCT (CLOSURE-FUNCTION function-object)))
    (LIST                ;; handle macros and named-lambdas and named-substs
     ;; Note: a named-lambda can have a debug-info ALIST and will have the form
     ;;    (named-lambda (foo . debugging-info) (x y z..) "doc-string" . body) 
     ;;  for instance, encapsulations made by TRACE, are defined this way.
     (COND ((EQ (CAR function-object) 'MACRO) 
	    (GET-DEBUG-INFO-STRUCT (CDR function-object) unencapsulated)) ;; tail-recursive call
	   ((MEMBER (CAR function-object) 
		      '(NAMED-LAMBDA NAMED-SUBST closure-named-lambda
			GLOBAL:NAMED-LAMBDA GLOBAL:NAMED-SUBST) 
		      :TEST #'EQ)
	    (and (CONSP (CADR function-object))
		 (let* ((struct  (CADADR function-object))
		       (info (and unencapsulated (get-debug-info-field struct 'encapsulated-definition))))
		   (if info
		       (GET-DEBUG-INFO-STRUCT (car info) unencapsulated )
			 struct))))
	   ((MEMBER (CAR function-object) '(LAMBDA SUBST ZLC:LAMBDA ZLC:SUBST) :TEST #'EQ) nil)
	   (t (GET-DEBUG-INFO-STRUCT (fdefinition
				       (if unencapsulated
					   (unencapsulate-function-spec function-object)
					   function-object)) nil))))
    (T nil)))
))

#!C
; From file FLAVOR.LISP#> KERNEL; MR-X:
#8R SYSTEM#:
(COMPILER-LET ((*PACKAGE* (FIND-PACKAGE "SYSTEM"))
                          (SI:*LISP-MODE* :COMMON-LISP)
                          (*READTABLE* COMMON-LISP-READTABLE)
                          (SI:*READER-SYMBOL-SUBSTITUTIONS* *COMMON-LISP-SYMBOL-SUBSTITUTIONS*))
  (COMPILER#:PATCH-SOURCE-FILE "SYS: KERNEL; FLAVOR.#"

;;  9/02/88 DNG - Extended to handle CLOS methods.
;; 11/02/88 DNG - Use new function FLAVOR-METHOD-SPEC-P to ensure consistency with DEFMETHOD.
(defmacro undefmethod (method-spec &rest things &environment env)
  (declare (arglist spec &optional lambda-list &rest ignore))
  "Forcibly remove a method definition from a class or flavor's method table.
Syntax is identical to the beginning of a DEFMETHOD for the same method.
For CLOS: (UNDEFMETHOD function-spec [method-qualifier] specialized-lambda-list)
For Flavors: (UNDEFMETHOD (flavor-name [daemon-type] operation))"
  (if (ticlos::flavor-method-spec-p method-spec)
      ;; Flavors method
      `(progn
	 (fundefine '(:method . ,method-spec))
	 (delete-flavor-method-table-entry ',(first method-spec) ',(second method-spec)))
    ;; else CLOS method
    (multiple-value-bind ( method-combination-identifiers specializers function lambda-list fspec)
	(ticlos::parse-method things method-spec env)
      (declare (ignore method-combination-identifiers specializers function))
      (if (null lambda-list)
	  (error "Lambda-list missing for UNDEFMETHOD")
	`(fundefine ',fspec) ))))
))


;;; It's probably not worth patching, but when this file is integrated into a 
;;; source release, SYS:SUBLIS-EVAL-ONCE can be made more efficient by doing 
;;; the following instead of using CW-TOP-LEVEL:	-- DNG 
#|   ...
      (when (or (not (fboundp 'compiler:code-walk))
		(catch 'special-form
		  (compiler:code-walk
		    exp
		    #'(lambda (form)
			(when (member (car form)
				      '( variable-location cond and or return return-from go
					*catch *throw catch throw
					do do* do-named do*-named if comment) :test #'eq)
			  (throw 'special-form t))
			form)
		    #'identity
		    nil
		    environment)
		  nil))
	(setq value-so-far `(progn ,@(mapcar 'car nonconstant-alist) ,value-so-far)))
     ...
 |#


#!C
; From file FUNCTIONS.LISP#> KERNEL; MR-X:
#10R SYSTEM#:
(COMPILER-LET ((*PACKAGE* (FIND-PACKAGE "SYSTEM"))
                          (SI:*LISP-MODE* :COMMON-LISP)
                          (*READTABLE* COMMON-LISP-READTABLE)
                          (SI:*READER-SYMBOL-SUBSTITUTIONS* *COMMON-LISP-SYMBOL-SUBSTITUTIONS*))
  (COMPILER#:PATCH-SOURCE-FILE "SYS: KERNEL; FUNCTIONS.#"

;This is useful for sorting function specs
(defun FUNCTION-SPEC-LESSP (fs1 fs2)
  "Compare two function specs, approximately alphabetically."
  ;; 11/12/86 DNG - Fixed to not error on :LOCATION specs.
  ;;  7/22/87 DNG - Adapted for Documenter by fixing for :INTERNAL function specs. [SPR 5932]
  ;;  8/15/88 DNG - Update to not error on CLOS method names.
  ;; 12/12/88 DNG - Put the Documenter version of this back into the kernel.
  ;;  1/13/89 DNG - Fix to not error on qualified methods.
  (declare (optimize (safety 0) (speed 3)))
  (cond ((and (symbolp fs1) (symbolp fs2)) ; most common case
	 (string< fs1 fs2))
	((and (consp fs1) (consp fs2)
	      (eq (first fs1) (first fs2)) (eq (second fs1) (second fs2)))
	 (let ((n1 (third fs1))
	       (n2 (third fs2)))
	   (cond ((numberp n1)
		  (if (numberp n2) (< n1 n2) nil))
		 ((numberp n2) t)
		 ((consp n1)
		  (if (consp n2) ; here for CLOS method specializers
		      (function-spec-lessp (car n1) (car n2))
		1    *;; here if fs1 is an unqualified method and fs2 is a qualified method.
		1    *t))
		 ((consp n2) ; here if fs1 is a qualified method and fs2 is an unqualified method.
		  nil)
		 (t (string< n1 n2)))))
	((consp fs1)
	 (function-spec-lessp (if (locativep (second fs1)) (first fs1) (second fs1))
			      fs2))
	((consp fs2)
	 (or (eq fs1 (second fs2))
	     (function-spec-lessp fs1 (if (locativep (second fs2)) (first fs2) (second fs2)))))
	(t (string< fs1 fs2))))
))


#!C
; From file FUNCTIONS.LISP#> KERNEL; MR-X:
#10R SYSTEM#:
(COMPILER-LET ((*PACKAGE* (FIND-PACKAGE "SYSTEM"))
                          (SI:*LISP-MODE* :COMMON-LISP)
                          (*READTABLE* COMMON-LISP-READTABLE)
                          (SI:*READER-SYMBOL-SUBSTITUTIONS* *COMMON-LISP-SYMBOL-SUBSTITUTIONS*))
  (COMPILER#:PATCH-SOURCE-FILE "SYS: KERNEL; FUNCTIONS.#"

1;; 12/29/88 DNG - Don't record source file name for locatives pointing into 
;;*		1the stack (in order to avoid wasting space storing useless information).*
(DEFUN LOCATION-FUNCTION-SPEC-HANDLER (FUNCTION FUNCTION-SPEC &OPTIONAL ARG1 ARG2)
  (LET ((LOC (SECOND FUNCTION-SPEC)))
    (IF (NOT (AND (= (LENGTH FUNCTION-SPEC) 2)
		  (OR (= (%DATA-TYPE LOC) DTP-LOCATIVE)
		      (= (%DATA-TYPE LOC) DTP-LIST))))
	(UNLESS (EQ FUNCTION 'VALIDATE-FUNCTION-SPEC)
	  (FERROR 'SYS:INVALID-FUNCTION-SPEC
		  "The function spec ~S is invalid." FUNCTION-SPEC))
      (CASE FUNCTION
	(VALIDATE-FUNCTION-SPEC T)
	(FDEFINE (RPLACD LOC ARG1))
	(FDEFINITION (CDR LOC))
	(FDEFINEDP (AND (/= (%P-DATA-TYPE LOC) DTP-NULL) (NOT (NULL (CDR LOC)))))
	(FDEFINITION-LOCATION LOC)
	;; FUNDEFINE could store DTP-NULL, which would only be right sometimes
	(OTHERWISE
	 1(UNLESS (AND (EQ FUNCTION 'PUTPROP)*
		        1(EQ ARG2 ':SOURCE-FILE-NAME)*
			1(EQL (%AREA-NUMBER LOC) PDL-AREA))*
	    (FUNCTION-SPEC-DEFAULT-HANDLER FUNCTION FUNCTION-SPEC ARG1 ARG2)1)*)))))
))


#!C
; From file FLET.LISP#> KERNEL; MR-X:
#10R SYSTEM#:
(COMPILER-LET ((*PACKAGE* (FIND-PACKAGE "SYSTEM"))
                          (SI:*LISP-MODE* :COMMON-LISP)
                          (*READTABLE* COMMON-LISP-READTABLE)
                          (SI:*READER-SYMBOL-SUBSTITUTIONS* *COMMON-LISP-SYMBOL-SUBSTITUTIONS*))
  (COMPILER#:PATCH-SOURCE-FILE "SYS: KERNEL; FLET.#"

;;PHD 3/2/87 early evaluation of caller to generate a better code.
;;PHD 3/2/87 Replaced list and list* by stack list primitives.
;;DNG 11/16/88 Add support for GENERIC-FLET.
(eval-when (compile)
  (DEFMACRO WITH-FUNCTION-BINDING-LIST ((fctlist caller) &BODY body)
    `(LET ((bindlist (%MAKE-STACK-LIST (* 2 (LENGTH ,fctlist)))))
       (DO ((nextbinding ,fctlist (CDR nextbinding))
	    (nextstackpos bindlist (CDDR nextstackpos))
	    (fct)
	    (fctsymbol))
	   ((ATOM nextbinding)
	    (WITH-STACK-LIST* (*INTERPRETER-FUNCTION-ENVIRONMENT*
				bindlist *INTERPRETER-FUNCTION-ENVIRONMENT*)
	      . ,body))
	 (SETQ fct (CAR nextbinding) fctsymbol (CAR fct))
	 (COND
	   ((VARIABLE-P fctsymbol)
	    (SETF (CAR nextstackpos) (LOCF (SYMBOL-FUNCTION fctsymbol)))
	    ;;Warning, dont-optimize is required because %make-explicit-stack-list modifies the 
            ;;stack. prevent the compiler from interleaving stack primitives with stack-list 
            ;;primitives.
	    (dont-optimize
	    (let ((value ,(COND
		     ((EQ caller 'FLET)
			`(funcall  'FUNCTION  (%make-explicit-stack-list* 'cli:lambda (cdr fct))))
		     ((EQ caller 'LABELS)
		      `(let ((block-form (%make-explicit-stack-list*  'block fctsymbol (CDDR fct))))
			(%make-explicit-stack-list 'lambda (CADR fct) block-form)))
		     ((EQ caller 'MACROLET)
		      `(%make-explicit-stack-list*  'macro (MAKE-EXPANDER-FUNCTION fct)))
		     ((EQ caller 'TICLOS:GENERIC-FLET)
		      `(*eval (%make-explicit-stack-list* 'TICLOS:GENERIC-FUNCTION (cdr fct))))))
		  (place (CDR nextstackpos)))
	      (rplaca place  value))))
	   (t (BINDING-ERROR fctsymbol))))))
  )
))

(DEFUN TICLOS:GENERIC-FLET (&QUOTE function-list &REST body)
  "Syntax: (GENERIC-FLET ({function-spec lambda-list {option}*}*) {form}*)
Like FLET but the local functions are generic.  
The options are the same as for DEFGENERIC, but the most useful here is 
\(:METHOD {qualifier}* lambda-list . body)"
  ;; 11/16/88 DNG - Original.
   
   (LET ((ignore (EXTRACT-SPECIAL-DECLARATIONS)))
      (WITH-FUNCTION-BINDING-LIST (function-list TICLOS:GENERIC-FLET)
         (EVAL-BODY-AS-PROGN body))))

(DEFUN TICLOS:GENERIC-LABELS (&QUOTE function-list &REST body)
  "Syntax: (GENERIC-LABELS ({function-spec lambda-list {option}*}*) {form}*)
Like LABELS but the local functions are generic.  
The options are the same as for DEFGENERIC, but the most useful here is 
\(:METHOD {qualifier}* lambda-list . body)"
  ;; 11/16/88 DNG - Original.
   
   (LET ((ignore (EXTRACT-SPECIAL-DECLARATIONS)))
      (WITH-FUNCTION-BINDING-LIST (function-list LABELS)
         (DO ((frametail (CAR *INTERPRETER-FUNCTION-ENVIRONMENT*) (CDDR frametail)))
	     ((ATOM frametail))
	  (SETF (CADR frametail)
	       (*eval (%make-explicit-stack-list* 'TICLOS:GENERIC-FUNCTION
						       (cdr (CADR frametail))))))
         (EVAL-BODY-AS-PROGN body))))

(DEFMACRO TICLOS:WITH-ADDED-METHODS ((function-specifier lambda-list &rest options) &body body)
  "Syntax:  (WITH-ADDED-METHODS (function-spec lambda-list {option}*) {form}*)
Like GENERIC-LABELS except that the local function inherits methods from any 
previous definition of the function."
  ;; 12/08/88 DNG - Initial crude version - not completely correct.
  ;; 12/19/88 DNG - Fixed for (SETF ...) functions, but still not as complete as the compiler's version.
  (let ((required-args (loop for x in lambda-list
			     until (member x '(&rest &optional &key &aux))
			     unless (member x lambda-list-keywords :test #'eq)
			     collect (if (atom x) x (car x))))
	(defined (if (and (compiler:external-symbol-p function-specifier)
		       (fboundp function-specifier)
		       (member (symbol-package function-specifier)
			       '#,(mapcar #'find-package '("LISP" "TICL" "TICLOS" "SYS"))
			       :test #'eq))
		  't
		(if (symbolp function-specifier)
		    `(fboundp ',function-specifier)
		  `(fdefinedp ',function-specifier))))
	(outer-function (if (symbolp function-specifier)
			    `(quote ,function-specifier)
			  `(cdr (eval-at-load-time (fdefinition-location ',function-specifier))))))
    `(ticlos:generic-labels ((,function-specifier ,lambda-list
			      ,(if (= (length required-args) (length lambda-list))
				   `(:method ,required-args
					     (if ,defined
						 (funcall ,outer-function . ,required-args)
					       (ticlos:no-applicable-method
						 #',function-specifier . ,required-args)))
				 `(:method (,@required-args &rest ticlos::.rest.)
					   (if ,defined
					       (apply ,outer-function
						      ,@required-args ticlos::.rest.)
					     (apply #'ticlos:no-applicable-method
						    #',function-specifier ,@required-args ticlos::.rest.))))
			      . ,options))
       . ,body)))


#!C
; From file FLAVOR.LISP#24 KERNEL; MR-X:
#8R SYSTEM#:
(COMPILER-LET ((*PACKAGE* (FIND-PACKAGE "SYSTEM"))
                          (SI:*LISP-MODE* :COMMON-LISP)
                          (*READTABLE* COMMON-LISP-READTABLE)
                          (SI:*READER-SYMBOL-SUBSTITUTIONS* *COMMON-LISP-SYMBOL-SUBSTITUTIONS*))
  (COMPILER#:PATCH-SOURCE-FILE "SYS: KERNEL; FLAVOR.#"

;; 12/19/88 DNG - Separated new function DEFMETHOD1 from the DEFMETHOD macro 
;;		so that it can be used by both the Flavors and CLOS versions of DEFMETHOD.

(defun defmethod1 (spec lambda-list body)
  (let ((flavor-name (car spec))
	(function-spec (cons :method spec))
	fl)
    `(progn
       ,(and (just-compiling) (compilation-flavor flavor-name t)
	     (neq flavor-name 'vanilla-flavor);This kludge avoids bootstrapping problems!
	   `(eval-when (compile)
	       (let ((*just-compiling* t))
		 (flavor-notice-method ',function-spec))))
       ,(cond
	  ((and (symbolp lambda-list) (not (null lambda-list)) (null body))
	   `(fdefine-for-defmethod ',function-spec ',lambda-list t))
	  ((setq fl (compilation-flavor flavor-name t))
	   (if (flavor-get fl :alias-flavor)
	     (ferror () "Attempt to define ~S; the flavor is an alias flavor."
		     (cons :method spec)))
	   `(defun ,function-spec ,(method-argument-list lambda-list function-spec)
	      (declare (:self-flavor ,flavor-name))
	      ,@body))
	  (t
	     (ferror () "~S is not a flavor." (car spec)))))))

2(comment ;   * * *   this should go in the release 6 kernel source, but not in *
		2this CLOS patch file because it is defined again in file "generic".   -- DNG 1/6/89   * * **
(COMPILER-LET ((local-declarations '((:expr-sxhash 3542393.))))
(defmacro defmethod (spec lambda-list . body)
  "(DEFMETHOD (flavor-name [daemon-type] operation [:case-sub-operation]) lambda-list . body)
Defines the method for flavor: flavor-name for the message operation,
Daemon-type can be one of: :BEFORE :AFTER :AROUND :INVERSE-AROUND :CASE :DEFAULT :OR :AND :OVERRIDE
:PROGN :LIST :INVERSE-LIST :PASS-ON :APPEND :NCONC.
:case-sub-operation must be provided for :CASE deamon-type,it is illegal otherwise."
  (defmethod1 spec lambda-list body)))
2) ; end comment*

))

