;;; -*- Mode:Common-Lisp; Package:COLOR; Base:10 -*-

;;;			      RESTRICTED RIGHTS LEGEND

;;;Use, duplication, or disclosure by the Government is subject to
;;;restrictions as set forth in subdivision (b)(3)(ii) of the Rights in
;;;Technical Data and Computer Software clause at 52.227-7013.
;;;
;;;			TEXAS INSTRUMENTS INCORPORATED.
;;;				 P.O. BOX 2909
;;;			      AUSTIN, TEXAS 78769
;;;				    MS 2151
;;;
;;; Copyright (C) 1987, 1988 Texas Instruments Incorporated. All rights reserved.




(DEFFLAVOR color-window-pane-flavor (index-loc)
	   (basic-color-pane w:graphics-mixin)                   
  (:documentation "This flavor is used for the center area pane which contanins the
               foreground and background areas")
  (:settable-instance-variables))

(DEFMETHOD (color-window-pane-flavor :draw-foreground-background-color) (&optional (color (send (send self :superior)
												:color-to-edit)))
  (LET* ((w (SEND self :inside-width))
	 (h (SEND self :inside-height))
	 (w8 (FLOOR (/ w 8)))
	 (h8 (FLOOR (/ h 8)))
	 (half-w8 (floor (/ w8 2) ))
	 (half-h8 (floor (/ h8 2) ))
	 (fore-color (send (send self :superior) :col-ed-foreground-color))
	 (back-color (send (send self :superior) :col-ed-background-color)))
    (send self :draw-background-color back-color)
    (if (= (send superior :background-color) color)
	(send self :draw-filled-rectangle (+ w8 half-w8) (+ h8 half-h8) (* 5 w8) (* 5 h8) fore-color w:alu-back)
	(send self :draw-filled-rectangle (+ w8 half-w8) (+ h8 half-h8) (* 5 w8) (* 5 h8) fore-color))))

(DEFMETHOD (color-window-pane-flavor :draw-foreground-color) (&optional (color (send (send self :superior)
										     :color-to-edit)))
  (LET* ((w (SEND self :inside-width))
	 (h (SEND self :inside-height))
	 (w8 (FLOOR (/ w 8)))
	 (h8 (FLOOR (/ h 8))))
    (SEND self :draw-filled-rectangle (* 1.7 w8) (* 1.7 h8) (* 4.6 w8) (* 4.6 h8) color) 
    (send self :set-cursorpos 0 (- h8 (* 2 (+ (send self :line-height) (send self :vsp)))))
    (send self :clear-eol)
    (send self :set-cursorpos 0 (- h8 (send self :line-height) (send self :vsp)))
    (send self :clear-eol)
    (send self :string-out-centered (format nil "Color # ~d" color))
    ))

(DEFMETHOD (color-window-pane-flavor :draw-background-color) (&optional (color (send (send self :superior)    
										     :col-ed-background-color)))
  (LET* ((w (SEND self :inside-width))
	 (h (SEND self :inside-height))
	 (w8 (FLOOR (/ w 8)))
	 (h8 (FLOOR (/ h 8)))
	 (half-w8 (floor (/ w8 2)))
	 (half-h8 (floor (/ h8 2)))
	 (alu-val w:normal)
	 (fore-color (send (send self :superior) :col-ed-foreground-color)))
    (when (= (send superior :background-color) color)
      (setq alu-val w:alu-back))
    (send self :draw-filled-rectangle half-w8 half-h8 (- w w8) (- h h8) color alu-val)
    (if (= (send superior :background-color) color)
	(send self :draw-filled-rectangle (+ w8 half-w8) (+ h8 half-h8) (* 5 w8) (* 5 h8) fore-color w:alu-back)
	(send self :draw-filled-rectangle (+ w8 half-w8) (+ h8 half-h8) (* 5 w8) (* 5 h8) fore-color))))

(defmethod (color-window-pane-flavor :after :refresh) (&rest ignore)   
  (send self :draw-foreground-background-color))