;;;-*- Mode:Common-Lisp; Package:color; Base:10; Fonts:(CPTFONT MEDFNB HL12BI MEDFNB) -*-

;;;			      RESTRICTED RIGHTS LEGEND

;;;Use, duplication, or disclosure by the Government is subject to
;;;restrictions as set forth in subdivision (b)(3)(ii) of the Rights in
;;;Technical Data and Computer Software clause at 52.227-7013.
;;;
;;;			TEXAS INSTRUMENTS INCORPORATED.
;;;				 P.O. BOX 2909
;;;			      AUSTIN, TEXAS 78769
;;;				    MS 2151
;;;
;;; Copyright (C) 1987, 1988 Texas Instruments Incorporated. All rights reserved.




(DEFFLAVOR color-editor-constraint-frame ()
	   (w:bordered-constraint-frame-with-shared-io-buffer w:label-mixin
	    w:box-label-mixin)
  (:documentation "This flavor contains the constraint frame for the color map editor.")
  (:settable-instance-variables)
  (:default-init-plist
    :label '(:string "Color Map Editor" :centered :top :font fonts:hl12bi))
  )

(DEFMETHOD (color-editor-constraint-frame :before :init) (&rest ignore)
  "Defines the panes and constraints"
  (LET* ((left-parent (send self :left-model-instance))
	 (left (send left-parent :name))
         (right-parent (SEND self :right-model-instance))
	 (right (send right-parent :name)))
    (SETQ TV:panes (CONCATENATE 'LIST
                                (expand-panes :LEFT left-parent left
                                              (col-n-color-of-model 1 left)
                                              (col-n-color-of-model 2 left)
                                              (col-n-color-of-model 3 left))
                                (expand-panes :RIGHT right-parent right
                                              (col-n-color-of-model 1 right)
                                              (col-n-color-of-model 2 right)
                                              (col-n-color-of-model 3 right))
                                '((color-display color-window-pane-flavor    
                                                     :label nil
                                                     :blinker-p nil
                                                     :borders nil))
				'((color-message-pane color-message-display
					      :borders nil))               ;;;10/06
				'((color-number-pane color-number-display
					      :pane-type :color-number
					      :borders nil))
				'((contrast-message-pane space-filler))

                                '((menu-pane menu-pane-flavor)))
          TV:constraints
          `((main . ((display-portion menu-pane)
                     ((menu-pane .25))           
                     ((display-portion
                        :horizontal (:even)
                        (left-col1-space  left-col1-panes
                                          left-col2-space left-col2-panes
                                          left-col3-space left-col3-panes
                                          color-window-pane
                                          right-col1-panes right-col1-space
                                          right-col2-panes right-col2-space
                                          right-col3-panes right-col3-space
                                          )
                        ((left-col1-space 0.03)
                         (left-col1-panes
                           :vertical (0.08)
                           (left-col1-title
                             left-col1-top-arrow
                             left-col1-slide-bar
                             left-col1-bottom-arrow
                             left-col1-number-readout
                             )
                           ((left-col1-title 0.06) 
                            (left-col1-top-arrow 0.1)
                            (left-col1-slide-bar 0.68)
                            (left-col1-bottom-arrow 0.1)
                            (left-col1-number-readout 0.06)))
                         (left-col2-space 0.02)
                         (left-col2-panes
                           :vertical (0.08)
                           (left-col2-title
                             left-col2-top-arrow
                             left-col2-slide-bar
                             left-col2-bottom-arrow
                             left-col2-number-readout)
                           ((left-col2-title 0.06) 
                            (left-col2-top-arrow 0.1)
                            (left-col2-slide-bar 0.68)
                            (left-col2-bottom-arrow 0.1)
                            (left-col2-number-readout 0.06)))
                         (left-col3-space 0.02)
                         (left-col3-panes
                           :vertical (0.08)
                           (left-col3-title
                             left-col3-top-arrow
                             left-col3-slide-bar
                             left-col3-bottom-arrow
                             left-col3-number-readout)
                           ((left-col3-title 0.06) 
                            (left-col3-top-arrow 0.1)
                            (left-col3-slide-bar 0.68)
                            (left-col3-bottom-arrow 0.1)
                            (left-col3-number-readout 0.06)))
                         
                         (color-window-pane                                      ;;;10/06
			   :vertical (0.4) 
			   (color-message-pane color-number-pane color-display contrast-message-pane)
			   ((color-message-pane .07)
			    (color-number-pane .06)
			    (contrast-message-pane .06)
			    (color-display .79)))
                         (right-col1-panes
                           :vertical (0.08)
                           (right-col1-title
                             right-col1-top-arrow
                             right-col1-slide-bar
                             right-col1-bottom-arrow
                             right-col1-number-readout)
                           ((right-col1-title 0.06)
                            (right-col1-top-arrow 0.1)
                            (right-col1-slide-bar 0.68)
                            (right-col1-bottom-arrow 0.1)
                            (right-col1-number-readout 0.06)))
                         (right-col1-space 0.02)
                         (right-col2-panes
                           :vertical (0.08)
                           (right-col2-title
                             right-col2-top-arrow
                             right-col2-slide-bar
                             right-col2-bottom-arrow
                             right-col2-number-readout)
                           ((right-col2-title 0.06) 
                            (right-col2-top-arrow 0.1)
                            (right-col2-slide-bar 0.68)
                            (right-col2-bottom-arrow 0.1)
                            (right-col2-number-readout 0.06)))
                         (right-col2-space 0.02)
                         (right-col3-panes
                           :vertical (0.08)
                           (right-col3-title
                             right-col3-top-arrow
                             right-col3-slide-bar
                             right-col3-bottom-arrow
                             right-col3-number-readout)
                           ((right-col3-title 0.06)
                            (right-col3-top-arrow 0.1)
                            (right-col3-slide-bar 0.68)
                            (right-col3-bottom-arrow 0.1)
                            (right-col3-number-readout 0.06)))
                         (right-col3-space 0.02)
                         )))))))))

(DEFUN expand-panes (side parent model col-1-name col-2-name col-3-name)
  (LET ((side-name (SYMBOL-NAME side)))		;1If :LEFT, "LEFT" else "RIGHT"*
    `(
      ;1;Column 1*
      (,(make-name `,side-name "1-*COL1-SPACE") space-filler)        ;; :column ,col-1-name :model ,model)
      (,(make-name `,side-name "1-*COL1-SLIDE-BAR") slide-bar-pane
       :range       ,(range-of-model-column model col-1-name)
       :column      ,col-1-name
       :model       ,model
       :parent      ,parent
       :side        ,side
       :pane-type   :slide-bar)
      (,(make-name `,side-name "1-*COL1-NUMBER-READOUT") readout-pane
       :range       ,(range-of-model-column model col-1-name)
       :column      ,col-1-name
       :model       ,model
       :parent      ,parent
       :side        ,side
       :pane-type   :numeric-readout)
      (,(make-name `,side-name "1-*COL1-TITLE") title-readout
       :label ,`(:string ,(title-of-model-column model col-1-name) :centered :FONT FONTS:CPTFONTB))
      (,(make-name `,side-name "1-*COL1-TOP-ARROW") up-arrow-pane
       :column      ,col-1-name
       :model       ,model
       :parent      ,parent
       :side        ,side
       :pane-type   :up-arrow)
      (,(make-name `,side-name "1-*COL1-BOTTOM-ARROW") down-arrow-pane
       :column      ,col-1-name
       :model       ,model
       :parent      ,parent
       :side        ,side
       :pane-type   :down-arrow)
      ;1; Column 2*
      (,(make-name `,side-name "1-*COL2-SPACE") space-filler)
      (,(make-name `,side-name "1-*COL2-SLIDE-BAR") slide-bar-pane
       :range       ,(range-of-model-column model col-2-name)
       :column      ,col-2-name
       :model       ,model
       :parent      ,parent
       :side        ,side
       :pane-type   :slide-bar)
      (,(make-name `,side-name "1-*COL2-NUMBER-READOUT") readout-pane
       :range       ,(range-of-model-column model col-2-name)
       :column      ,col-2-name
       :model       ,model
       :parent      ,parent
       :side        ,side
       :pane-type   :numeric-readout)
      (,(make-name `,side-name "1-*COL2-TITLE") title-readout
       :label ,`(:string ,(title-of-model-column model col-2-name) :centered :FONT FONTS:CPTFONTB))
      (,(make-name `,side-name "1-*COL2-TOP-ARROW") up-arrow-pane
       :column      ,col-2-name
       :model       ,model
       :parent      ,parent
       :side        ,side
       :pane-type   :up-arrow)
      (,(make-name `,side-name "1-*COL2-BOTTOM-ARROW") down-arrow-pane
       :column      ,col-2-name
       :model       ,model
       :parent      ,parent
       :side        ,side
       :pane-type   :down-arrow)
      ;1; Column 3*
      (,(make-name `,side-name "1-*COL3-SPACE") space-filler)
      (,(make-name `,side-name "1-*COL3-SLIDE-BAR") slide-bar-pane
       :range       ,(range-of-model-column model col-3-name)
       :column      ,col-3-name
       :model       ,model
       :parent      ,parent
       :side        ,side
       :pane-type   :slide-bar)
      (,(make-name `,side-name "1-*COL3-NUMBER-READOUT") readout-pane
       :range       ,(range-of-model-column model col-3-name)
       :column      ,col-3-name
       :model       ,model
       :parent      ,parent
       :Side        ,side
       :pane-type   :numeric-readout)
      (,(make-name `,side-name "1-*COL3-TITLE") title-readout
       :label ,`(:string ,(title-of-model-column model col-3-name) :centered :FONT FONTS:CPTFONTB))
      (,(make-name `,side-name "1-*COL3-TOP-ARROW") up-arrow-pane
       :column      ,col-3-name
       :model       ,model
       :parent      ,parent
       :side        ,side
       :pane-type   :up-arrow)
      (,(make-name `,side-name "1-*COL3-BOTTOM-ARROW") down-arrow-pane
       :column      ,col-3-name
       :model       ,model
       :parent      ,parent
       :side        ,side
       :pane-type   :down-arrow))))