;;;-*- Mode:Common-Lisp; Package:color; Base:10; Fonts:(CPTFONT MEDFNB HL12BI MEDFNB) -*-

;;;			      RESTRICTED RIGHTS LEGEND

;;;Use, duplication, or disclosure by the Government is subject to
;;;restrictions as set forth in subdivision (b)(3)(ii) of the Rights in
;;;Technical Data and Computer Software clause at 52.227-7013.
;;;
;;;			TEXAS INSTRUMENTS INCORPORATED.
;;;				 P.O. BOX 2909
;;;			      AUSTIN, TEXAS 78769
;;;				    MS 2151
;;;
;;; Copyright (C) 1987, 1988 Texas Instruments Incorporated. All rights reserved.




(DEFFLAVOR title-readout ()
	   (basic-color-pane)
  (:documentation "This flavor is used for the title panes")
  (:default-init-plist
    :BORDERS NIL
    :FONT-MAP '(FONTS:CPTFONTB)
    :blinker-p nil))

(defflavor color-message-display ()
	   (basic-color-pane
	    w:stream-mixin)
  (:documentation "This flavor is used to display color name or number heading.")
  (:default-init-plist
    :borders nil
    :blinker-p nil
    :label nil))

(defflavor color-number-display ()
	   (basic-color-pane
	    w:stream-mixin )
  (:documentation "This flavor is used to display color name or number.")
  (:default-init-plist
    :borders nil
    :blinker-p nil
    :label nil
    ))

(DEFMETHOD (color-number-display :who-line-documentation-string) ()
  '(:MOUSE-any    "Enter a number or a color name to specify the color to edit "
    :NO-COMMA " "))

(DEFFLAVOR space-filler ()
	   (basic-color-pane)                  
  (:documentation "This flavor is used for the space panes used between the slide bars")
  (:default-init-plist
    :blinker-p nil
    :label nil
    :borders nil))

(defflavor menu-pane-flavor (column)
	   (w:menu basic-color-pane)   
  (:documentation "This flavor is used for the pane that contains the color map editor commands")
  (:default-init-plist
    :label '(:string "Color Map Editor Commands" :centered :top :font fonts:tr12b)
    :blinker-p t
    :BORDERS NIL
    :FONT-MAP '(fonts:tr12)
    :scrolling-p nil
    :command-menu t
;   :multicolumn t
    :column-spec-list nil))

(defmethod (menu-pane-flavor :after :init) (&rest ignore)
  (send self :set-font-map (make-array 26 :initial-element fonts:tr12)))


