;;; -*- Mode:Common-Lisp; Package:COLOR; Base:10 -*-

;;;			      RESTRICTED RIGHTS LEGEND

;;;Use, duplication, or disclosure by the Government is subject to
;;;restrictions as set forth in subdivision (b)(3)(ii) of the Rights in
;;;Technical Data and Computer Software clause at 52.227-7013.
;;;
;;;			TEXAS INSTRUMENTS INCORPORATED.
;;;				 P.O. BOX 2909
;;;			      AUSTIN, TEXAS 78769
;;;				    MS 2151
;;;
;;; Copyright (C) 1987, 1988 Texas Instruments Incorporated. All rights reserved.




(DEFFLAVOR readout-pane ()
	   (readout-pane-mixin
	    basic-color-pane
	    w:select-mixin
	    w:delay-notification-mixin
	    w:stream-mixin)
  (:documentation :combination)
  (:default-init-plist
    :blinker-p nil
    :label nil
    :font-map (MAKE-ARRAY 26. :initial-element fonts:tr8)
    ))

(DEFFLAVOR readout-pane-mixin ()  
	   ()
  (:settable-instance-variables)         
  (:required-flavors basic-color-pane)
  (:documentation :mixin))

(DEFMETHOD (readout-pane :after :init) (ignore)     
  (LET ((super (SEND self :superior)))  
    (CASE side
      (:left (setf parent (SEND super :left-model-instance)))
      (:right (setf parent (SEND super :right-model-instance))))
    (CASE (column-of-model-column model column)
      (1 (LET ()
	   (SETF (column-numeric-readout (SEND parent :column1)) self)
	   (SEND parent :set-range1 (range-of-model-column model column))
	   (SEND parent :set-readout1 0)))
      (2 (LET ()
	   (SETF (column-numeric-readout (SEND parent :column2)) self)
	   (SEND parent :set-range2 (range-of-model-column model column))
	   (SEND parent :set-readout2 0)))
      (3 (LET ()
	   (SETF (column-numeric-readout (SEND parent :column3)) self)
	   (SEND parent :set-range3 (range-of-model-column model column))
	   (SEND parent :set-readout3 0))))))

(DEFMETHOD (readout-pane-mixin :who-line-documentation-string) ()
  '(:MOUSE-ANY "Enter a value from the keyboard "))

(DEFMETHOD (readout-pane-mixin :update-readout) (new-val)
  ;; new-val is already scaled appropriately 
  (UNLESS (= range 1.0)
    (SETF new-val (ROUND new-val)))
  (SEND self :set-current-position new-val)
  (SEND self :clear-window)
  (COND ((< new-val 0)
	 (SETF new-val 0))
	((> new-val range)
	 (SETF new-val range)))
  (SEND self :string-out-x-y-centered-explicit
	(if (integerp new-val)
	    (FORMAT nil "~3D" new-val)
	    (format nil "~5,3f" new-val))
	(SEND self :margins)
	(ROUND (/ (SEND self :inside-height) 2))))

(defmethod (readout-pane-mixin :after :refresh) (&rest ignore)
  (send self :clear-window)
  (SEND self :string-out-x-y-centered-explicit
	(if (integerp current-position)
	    (FORMAT nil "~3D" current-position)
	    (format nil "~5,3f" current-position))
	(SEND self :margins)
	(ROUND (/ (SEND self :inside-height) 2))))

(COMPILE-FLAVOR-METHODS readout-pane)
