;;; -*- Mode: Common-Lisp; Package: User; Base: 10.; Patch-File: T -*-

;;;			      RESTRICTED RIGHTS LEGEND

;;;Use, duplication, or disclosure by the Government is subject to
;;;restrictions as set forth in subdivision (b)(3)(ii) of the Rights in
;;;Technical Data and Computer Software clause at 52.227-7013.
;;;
;;;			TEXAS INSTRUMENTS INCORPORATED.
;;;				 P.O. BOX 2909
;;;			      AUSTIN, TEXAS 78769
;;;				    MS 2151
;;;
;;; Copyright (C) 1987 Texas Instruments Incorporated. All rights reserved.

;;; Written 07/02/87 11:49:10 by graham,
;;; Reason: Add :directory "property" to FOP of Attributes Message. Fixes "S" command in Dired.
;;; while running on Oppenheimer from band LOD1
;;; With IO 3.18, PATHNAME 3.13, FILE 3.7, SYSTEM 3.36, METER 3.1, SERIAL 3.0, CHAOSNET 3.10,
;;;  ETHERNET 3.0, GC 3.7, IMAGEN 3.0, MAIL-DAEMON 3.1, NETWORK-SUPPORT 3.6, PROFILE 3.0,
;;;  SUGGESTIONS 3.3, UCL 3.0, ZWEI 3.6, STREAMER-TAPE 3.5, DEBUG-TOOLS 3.0, FONT-EDITOR 3.1,
;;;  GLOSSARY 3.0, INPUT-EDITOR 3.0, MAIL-READER 3.1, NAMESPACE-EDITOR 3.2, NVRAM 3.0,
;;;  TELNET 3.0, TV 3.5, NAMESPACE 3.7, COMPILER 3.9, PRINTER 3.1, SYSLOG 3.0, VT100 3.1,
;;;  IP 2.22, Experimental BUG 4.18, DECNET 1.0,  microcode 395, Band Name: 6/25+DECnet

#!C
; From file dap_server.lisp#> decnet; sys:
#10R DNA#:
(COMPILER-LET ((*PACKAGE* (FIND-PACKAGE "DNA"))
                          (SI:*LISP-MODE* :COMMON-LISP)
                          (*READTABLE* SYS:COMMON-LISP-READTABLE)
                          (SI:*READER-SYMBOL-SUBSTITUTIONS* SYS::*COMMON-LISP-SYMBOL-SUBSTITUTIONS*))
  (COMPILER#:PATCH-SOURCE-FILE "SYS: DECNET; DAP_SERVER.#"


(defmethod (dap-server-stream :server-directory-list) (filespec display)
  (let ((path (send self :decnet-parse-for-server filespec dap-local-dir-pathname)))
    (when path
      (server-display "~% Directory-list called for ~a" path)
      (send self :send-name-message volname-nametype "")
      (send self :send-name-message dirname-nametype (send path :string-for-directory))
      (let ((pathname-list (send path :directory-list '(:noerror))))
	(if (not (eql (type-of pathname-list) 'cons))
	    (send self :server-map-error pathname-list)
	    (dolist (element (cdr pathname-list))
	      (send self :send-name-message filename-nametype (send (car element) :string-for-dired))
	      
	      (when (test-display-for-main-attributes display)
		(server-display "~%Dired main attributes message")
		(let* ((bls 1024.)
		       (bsz (or (get (locf (cdr element)) :byte-size) 8))
		       (ebk (or (get (locf (cdr element)) :length-in-blocks) 0))
		       (ffb (or (- (* bls ebk) (or (get (locf (cdr element)) :length-in-bytes) 0)))))
		  (send self :send-attributes-message (if (get (locf (cdr element)) :characters)
							  ascii-data image-data)
			                              0 nil nil bls nil ebk nil nil nil
						      nil nil 
						      (if (get (locf (cdr element)) :directory)
							  '(5 7) nil)
						      bsz nil nil nil ebk ebk ffb)))
	      
	      (when (test-display-for-key-definition display)
		(server-display "~%Dired key definition attributes message")
		(send self :send-key-definition-attributes))
	      
	      (when (test-display-for-allocation display)
		(server-display "~%Dired allocation attributes message")
		(send self :send-allocation-attributes))
	      
	      (when (test-display-for-summary display) 
		(server-display "~%Dired summary attributes message")
		(send self :send-summary-attributes))
	      
	      (when (test-display-for-date-and-time display)
		(server-display "~%Dired date-and-time attributes message")
		(send self :send-date-time-attributes (get (locf (cdr element)) :creation-date)))
	      (when (test-display-for-protection display)
		
		(server-display "~%Dired protection attributes message")
		(send self :send-protection-attributes (get (locf (cdr element)) :author)))
	      
	      (send self :send-acknowledge-message nil))
	    )))
    (send self :send-access-complete-message cmpfunc-response)))
))

#!C
; From file dap_server.lisp#> decnet; sys:
#10R DNA#:
(COMPILER-LET ((*PACKAGE* (FIND-PACKAGE "DNA"))
                          (SI:*LISP-MODE* :COMMON-LISP)
                          (*READTABLE* SYS:COMMON-LISP-READTABLE)
                          (SI:*READER-SYMBOL-SUBSTITUTIONS* SYS::*COMMON-LISP-SYMBOL-SUBSTITUTIONS*))
  (COMPILER#:PATCH-SOURCE-FILE "SYS: DECNET; DAP_SERVER.#"


(defmethod (dap-server-stream :process-display) (display path always-send-main-attributes
						 &optional (data-type ascii-data)
						           (org seq-org)
							   (rfm rfm-variable)
							   (rat rat-implied-crlf)
							   (bls nil)
							   (mrs nil)
							   (alq nil)
							   (deq nil))
  (unless bls (setf bls 1024.))
  (let* ((bsz (or (get (send path :properties) :byte-size) 8))
	 (ebk (or (get (send path :properties) :length-in-blocks) 0))
	 (ffb (or (- (* ebk bls) (or (get (send path :properties) :length-in-bytes) 0))))
	 (fop-list (if (get (send path :properties) :directory) '(5 7) nil)))

  (when (or always-send-main-attributes (test-display-for-main-attributes display))
    (server-display "~%Asked for Main attributes message")
    (send self :send-attributes-message data-type org rfm rat bls mrs alq nil nil 0 nil
	                                          deq fop-list bsz nil nil nil nil ebk ffb))
    
  (when (test-display-for-key-definition display)
    (server-display "~%Asked for key definition attributes message")
    (send self :send-key-definition-attributes))

  (when (test-display-for-allocation display)
    (server-display "~%Asked for allocation attributes message")
    (send self :send-allocation-attributes))

  (when (test-display-for-summary display) 
    (server-display "~%Asked for summary attributes message")
    (send self :send-summary-attributes))

  (when (test-display-for-date-and-time display)
    (server-display "~%Asked for Date and Time attributes message")
    (send self :send-date-time-attributes (or (get (send path :properties) :creation-date)
					      (get-universal-time))))
  (when (test-display-for-protection display)
    (server-display "~%Asked for File Protection attributes message")
    (send self :send-protection-attributes))

  (when (test-display-for-access-control display)
    (server-display "~%Asked for Access control list attributes message"))

  (when (test-display-for-name display)
    (server-display "~%Asked for Name message control list attributes message")
    (send self :send-name-message filespec-nametype (send path :string-for-host)))))
))
