;;; -*- Mode: Common-Lisp; Package: User; Base: 10.; Patch-File: T -*-

;;;			      RESTRICTED RIGHTS LEGEND

;;;Use, duplication, or disclosure by the Government is subject to
;;;restrictions as set forth in subdivision (b)(3)(ii) of the Rights in
;;;Technical Data and Computer Software clause at 52.227-7013.
;;;
;;;			TEXAS INSTRUMENTS INCORPORATED.
;;;				 P.O. BOX 2909
;;;			      AUSTIN, TEXAS 78769
;;;				    MS 2151
;;;
;;; Copyright (C) 1987 Texas Instruments Incorporated. All rights reserved.

;;; Written 07/20/87 14:24:08 by REINER,
;;; Reason: Fix for displaying total blocks allocated during dired.  Should use EBK instead of ALQ field.
;;; [No SPR] Code Readers:  BRG, LER	
;;; while running on NOVEMBER from band LOD1
;;; With IO 3.24, PATHNAME 3.16, FILE 3.9, SYSTEM 3.47, METER 3.5, SERIAL 3.1, CHAOSNET 3.10,
;;;  ETHERNET 3.0, GC 3.9, IMAGEN 3.0, MAIL-DAEMON 3.1, NETWORK-SUPPORT 3.7, PROFILE 3.1,
;;;  SUGGESTIONS 3.3, UCL 3.1, ZWEI 3.14, STREAMER-TAPE 3.7, DEBUG-TOOLS 3.1, FONT-EDITOR 3.1,
;;;  GLOSSARY 3.0, INPUT-EDITOR 3.0, MAIL-READER 3.4, NAMESPACE-EDITOR 3.4, NVRAM 3.3,
;;;  TELNET 3.5, TV 3.9, NAMESPACE 3.7, COMPILER 3.20, PRINTER 3.2, SYSLOG 3.0, Inconsistent VT100 3.9,
;;;  IP 2.44, Experimental BUG 4.10, DECNET 1.9,  microcode 355, Band Name: 6/17 + DECNET

#!C
; From file DAP_UTILITIES.LISP#> DECNET; SYS:
#10R DNA#:
(COMPILER-LET ((*PACKAGE* (FIND-PACKAGE "DNA"))
                          (SI:*LISP-MODE* :COMMON-LISP)
                          (*READTABLE* SYS:COMMON-LISP-READTABLE)
                          (SI:*READER-SYMBOL-SUBSTITUTIONS* SYS::*COMMON-LISP-SYMBOL-SUBSTITUTIONS*))
  (COMPILER#:PATCH-SOURCE-FILE "SYS: DECNET; DAP_UTILITIES.#"


(defmethod (DAP-basic-stream :handle-attributes-message) (header offset)
  (multiple-value-setq (nil nil nil nil nil offset)
		       (decode-operator-field header offset))
  (multiple-value-bind (nil datatype nil RFM RAT BLS nil ALQ
			nil nil nil nil nil FOP BSZ nil nil nil nil EBK FFB)
      (decode-attributes-message header offset)
    (values datatype BLS ALQ BSZ RFM RAT FOP (if (and bls ebk ffb) (- (* bls ebk) ffb) nil)
	    ebk)))

))

#!C
; From file DAP_UTILITIES.LISP#> DECNET; SYS:
#10R DNA#:
(COMPILER-LET ((*PACKAGE* (FIND-PACKAGE "DNA"))
                          (SI:*LISP-MODE* :COMMON-LISP)
                          (*READTABLE* SYS:COMMON-LISP-READTABLE)
                          (SI:*READER-SYMBOL-SUBSTITUTIONS* SYS::*COMMON-LISP-SYMBOL-SUBSTITUTIONS*))
  (COMPILER#:PATCH-SOURCE-FILE "SYS: DECNET; DAP_UTILITIES.#"


(defmethod (DAP-basic-stream :empty-directory-check) ()
  (let (empty-p bls alq bsz rat rfm fop attribute-error length-in-bytes datatype ebk)
    (multiple-value-bind (header offset)
	(send self :receive-next-message)
      (let ((packet-type (dap-type header offset)))
	(case packet-type
	      (#.DAP-name-message (setf empty-p nil))	                           

	      (#.DAP-access-complete-message (send self :empty-directory-check))   ;Left overs
	      
	      (#.DAP-status-message (if (setf empty-p (send self :handle-status-message header offset))
					(progn
					  (send self :send-access-complete-message  cmpfunc-close)
					  (send self :process-access-complete-response))
					(setf attribute-error t)))

	      (#.DAP-attributes-message (multiple-value-setq
					 (datatype bls alq bsz rfm rat fop length-in-bytes ebk)
					 (send self :handle-attributes-message header offset)))
	      (otherwise (call-unknown-message-error header offset packet-type)))))
    (values empty-p attribute-error datatype bls alq bsz rfm rat fop length-in-bytes ebk)))

))

#!C
; From file DAP_UTILITIES.LISP#> DECNET; SYS:
#10R DNA#:
(COMPILER-LET ((*PACKAGE* (FIND-PACKAGE "DNA"))
                          (SI:*LISP-MODE* :COMMON-LISP)
                          (*READTABLE* SYS:COMMON-LISP-READTABLE)
                          (SI:*READER-SYMBOL-SUBSTITUTIONS* SYS::*COMMON-LISP-SYMBOL-SUBSTITUTIONS*))
  (COMPILER#:PATCH-SOURCE-FILE "SYS: DECNET; DAP_UTILITIES.#"


(defmethod (DAP-basic-stream :pathname-directory-list) (dir-pathname)
  (let ((display (loop for display-list in '(#.display-main #.display-date-time #.display-file-protection)
		       with display = 0
		       do  (setq display (dpb 1 (byte 1 display-list) display))
		       finally (return display)))
        (dir-list ())
	(namespec nil) (nametype nil) (condition nil) (empty-p nil)
	(return-value-1 nil) (return-value-2 nil)
	(default-pathname (send pathname :new-pathname :name :unspecific :type :unspecific
				         :version :unspecific)))
    (unwind-protect
	(setf condition
	      (catch 'dap-catch-errors
		(progn
		  (if send-config?
		      (progn
			(send self :send-config-message)
			(send self :process-config-message))
		      )	    
		  (send self :clear-receive-queue)		  
		  (send self :send-access-message accfunc-dir-list
			                          0 dir-pathname nil nil display nil)

		  (if (not (send self :empty-directory-check))   ;This checks for Volume name or File-Not-Found status.
		      (send self :empty-directory-check)          ;If previous message was a name, this also is a name.
		      (progn
			(setf empty-p t)))
;			(send self :send-access-complete-message  cmpfunc-close)))
		  (setf end-of-file nil)
		  (loop			   ;get filename(s) returned
		    (if (or empty-p end-of-file)
			(return dir-list)
			(multiple-value-setq (namespec nametype)
					     (send self :process-name-message))
			(when namespec
			  (when (eql nametype dirname-nametype) (send self :process-name-message))
			  (let (bls alq bsz rfm rat fop cdt rdt uic datatype ebk
				inner-condition	attribute-error length-in-bytes)
			    (unwind-protect
				(setf inner-condition
				      (catch 'dap-catch-errors
					(multiple-value-setq
					  (empty-p attribute-error datatype
					   bls alq bsz rfm rat fop length-in-bytes ebk)
							     (send self :empty-directory-check))))
			      (if empty-p
				  (progn
				    (setf end-of-file t))
;				    (send self :send-access-complete-message  cmpfunc-close))
				  (progn
				    (if (or inner-condition attribute-error)
					(send self :send-continue-transfer-message confunc-skip)
					(progn
					  (multiple-value-setq (cdt rdt)
							       (send self :process-date-time-attributes))
					  (setq uic (send self :process-protection-attributes))))
				    (push
				      (format-list
					namespec default-pathname cdt rdt uic
					(if (eql datatype ascii-data) t nil) bls
					(or bsz (compute-byte-size rfm rat bsz)) ebk length-in-bytes
					(if inner-condition (send inner-condition :report-string) nil)
					;;If bit 5 (for ultrix) or bit 7 (for VMS) of FOP is set, this could be a directory.
					(when fop (or (ldb-test (byte 1 5) fop) (ldb-test (byte 1 7) fop))))
				      dir-list)
				    (unless (or inner-condition attribute-error)
				      (send self :process-acknowledge-message)))))))))

	      (setf dir-list (send self :sort-list dir-list))
	      (push (list NIL :PATHNAME pathname) dir-list))))
    (if (eql (type-of condition) 'dna-base-error-flavor)
	(setf return-value-1 nil return-value-2 condition)
	(setf return-value-1 dir-list return-value-2 nil)))
    (values return-value-1 return-value-2)))

))
