;;; -*- Mode: Common-Lisp; Package: User; Base: 10.; Patch-File: T -*-

;;;			      RESTRICTED RIGHTS LEGEND

;;;Use, duplication, or disclosure by the Government is subject to
;;;restrictions as set forth in subdivision (b)(3)(ii) of the Rights in
;;;Technical Data and Computer Software clause at 52.227-7013.
;;;
;;;			TEXAS INSTRUMENTS INCORPORATED.
;;;				 P.O. BOX 2909
;;;			      AUSTIN, TEXAS 78769
;;;				    MS 2151
;;;
;;; Copyright (C) 1987 Texas Instruments Incorporated. All rights reserved.

;;; Patch file for DECNET version 1.13
;;; Reason: Add instance variable and echo control for abnormal echo conditions
;;; as seen while using VMS EMACS in CTERM.
;;; Code read by CRW and BRG.
;;; Written 07/22/87 13:22:44 by WALTON,
;;; while running on CHARLIE from band LODA
;;; With IO 3.24, PATHNAME 3.16, FILE 3.9, SYSTEM 3.47, METER 3.3, SERIAL 3.1, CHAOSNET 3.10,
;;;  ETHERNET 3.0, GC 3.9, IMAGEN 3.0, MAIL-DAEMON 3.1, NETWORK-SUPPORT 3.7, PROFILE 3.1,
;;;  SUGGESTIONS 3.3, UCL 3.1, ZWEI 3.14, STREAMER-TAPE 3.7, DEBUG-TOOLS 3.1, FONT-EDITOR 3.1,
;;;  GLOSSARY 3.0, INPUT-EDITOR 3.0, MAIL-READER 3.4, NAMESPACE-EDITOR 3.4, NVRAM 3.2,
;;;  TELNET 3.5, TV 3.9, NAMESPACE 3.7, COMPILER 3.20, PRINTER 3.2, SYSLOG 3.0, VT100 3.9,
;;;  IP 2.44, Experimental BUG 7.0, DECNET 1.12,  microcode 400, Band Name: REL3+DECnet

#!C
; From file CTERM_FLAVOR.LISP#> DECNET; SYS:
#10R DNA#:
(COMPILER-LET ((*PACKAGE* (FIND-PACKAGE "DNA"))
                          (SI:*LISP-MODE* :COMMON-LISP)
                          (*READTABLE* SYS:COMMON-LISP-READTABLE)
                          (SI:*READER-SYMBOL-SUBSTITUTIONS* SYS::*COMMON-LISP-SYMBOL-SUBSTITUTIONS*))
  (COMPILER#:PATCH-SOURCE-FILE "SYS: DECNET; CTERM_FLAVOR.#"


(defflavor CTERM-stream
     	   ; Instance Variables
	   ((direction       :BIDIRECTIONAL)
	    (port                       nil)
	    (host                       nil)
	    (system-type                nil)       ; VMS or ULTRIX
	    (window                     nil)	   ; CTERM - VT100 window
	    (status                 :CLOSED)
	    (raw-mode                   nil)       ; T if sgl input char processing - ULTRIX
	      (defaults-sent              nil)       ;default characteristics values
	    (time-out-flag                t)
	    (raise-input-p              nil)
	    (termset                      0)
	    (max-len                      0)
	    (echo-flag                  nil)	   ; nil for passwords, and ULTRIX
	    (echo-terminator            nil)
	    (normal-echo                  t)       ; flag set in Characteristics message 
	    (format-flag                  t)
	    (prompt-data                nil)       ;characters beyond the end of the prompt
	    (prefix-cr-code               0)       ;next input buffer should be cr-pkt
	    (prefix-cr-count              0)       ; followed by n linefeeds or special char
	    (postfix-cr-code              0)       ;cr-pkt should follow this write
	    (postfix-cr-count             0)       ; followed by n linefeeds or special char
	    (last-input-buffer   first-data)       ;0 current-input-buffer 1 predata 2 postdata 3 1st data
	    (last-start-index             0)
	    (current-input-buffer       nil)	   ;Corresponds to:  si:stream-input-buffer   
	    (current-input-index          0)	   ;                  si:stream-input-index
	    (current-input-bufferlen      0)       ;length of buffer to the end of the pkt
	    (current-input-datalen        0)       ;data portion of the current msg
	    (next-msg-offset              0)       
	    (next-msg-len                 0)       ;numbytes of the next msg.    
	    (current-output-buffer      nil)	   ;                  si:stream-output-buffer 
	    (current-output-index         0)	   ;                  si:stream-output-index
	    (current-output-limit         0))	   ;                  si:stream-output-limit
	   
	   ; Component Flavors
	   (si:buffered-character-stream)
  
  :gettable-instance-variables
  :settable-instance-variables
  :inittable-instance-variables
  (:documentation "CTERM stream flavor")
  )

))

#!C
; From file CTERM_FLAVOR.LISP#> DECNET; SYS:
#10R DNA#:
(COMPILER-LET ((*PACKAGE* (FIND-PACKAGE "DNA"))
                          (SI:*LISP-MODE* :COMMON-LISP)
                          (*READTABLE* SYS:COMMON-LISP-READTABLE)
                          (SI:*READER-SYMBOL-SUBSTITUTIONS* SYS::*COMMON-LISP-SYMBOL-SUBSTITUTIONS*))
  (COMPILER#:PATCH-SOURCE-FILE "SYS: DECNET; CTERM_FLAVOR.#"


(defmethod (cterm-stream :reset-instance-vars)()
  (setf port                     nil)
  (setf host                     nil)
  (setf system-type              nil)       
  (setf status               :CLOSED)
  (setf raw-mode                 nil)      
  (setf defaults-sent            nil)       
  (setf time-out-flag              t)
  (setf raise-input-p            nil)
  (setf termset                    0)
  (setf max-len                    0)
  (setf echo-flag                nil)
  (setf echo-terminator          nil)
  (setf normal-echo                t)
  (setf last-input-buffer first-data)       
  (setf last-start-index           0)
  (setf current-input-buffer     nil)	   
  (setf current-input-index        0)	   
  (setf current-input-bufferlen    0)       
  (setf current-input-datalen      0)       
  (setf next-msg-offset            0)       
  (setf next-msg-len               0)       
  (setf current-output-buffer    nil)	   
  (setf current-output-index       0)	   
  (setf current-output-limit       0))  

))

#!C
; From file CTERM_MSG_DECODER.LISP#> DECNET; SYS:
#10R DNA#:
(COMPILER-LET ((*PACKAGE* (FIND-PACKAGE "DNA"))
                          (SI:*LISP-MODE* :COMMON-LISP)
                          (*READTABLE* SYS:COMMON-LISP-READTABLE)
                          (SI:*READER-SYMBOL-SUBSTITUTIONS* SYS::*COMMON-LISP-SYMBOL-SUBSTITUTIONS*))
  (COMPILER#:PATCH-SOURCE-FILE "SYS: DECNET; CTERM_MSG_DECODER.#"


(defun CTERM-get-selector-type2-values (header offset selector-id selector-list)
  (declare (values (offset selector-list normal-echo-flag)))
  (let ((char nil)(mask nil)(attrib-bitmap nil)(out-of-band nil)(include-flag nil)
	(discard-flag nil)(cntrl-char-echo nil)(spec-char-switch nil)(value nil)
	(selector-type 2)(normal-echo nil))
    (cond
      ;; boolean or bit-map
      ((member selector-id '(1 3 4 5 6 7 9. 10.))
       (when (< offset (array-length header))
	 (multiple-value-setq (value offset)
			      (CTERM-get-1-byte header offset))
	 (when (eql selector-id 5)
	   (setf normal-echo value))
	 (push (list selector-type selector-id value) selector-list)))
      ;; compound value
      ((= selector-id 2)
       (when (< offset (array-length header))
	 (multiple-value-setq (char		  mask
			       attrib-bitmap      out-of-band
			       include-flag	  discard-flag
			       cntrl-char-echo    spec-char-switch
			       offset)
			      (CTERM-get-compound-value header offset))
	 (push (list selector-type selector-id char mask attrib-bitmap out-of-band
		     include-flag discard-flag cntrl-char-echo spec-char-switch)
	       selector-list)))
     ;; integer value
      ((= selector-id 8.)
       (when (< offset (array-length header))
	 (multiple-value-setq (value offset)
				  (CTERM-get-2-bytes header offset))
	     (push (list selector-type selector-id value) selector-list)))
      (t))	 
    (values offset selector-list normal-echo)))

))

#!C
; From file CTERM_MSG_DECODER.LISP#> DECNET; SYS:
#10R DNA#:
(COMPILER-LET ((*PACKAGE* (FIND-PACKAGE "DNA"))
                          (SI:*LISP-MODE* :COMMON-LISP)
                          (*READTABLE* SYS:COMMON-LISP-READTABLE)
                          (SI:*READER-SYMBOL-SUBSTITUTIONS* SYS::*COMMON-LISP-SYMBOL-SUBSTITUTIONS*))
  (COMPILER#:PATCH-SOURCE-FILE "SYS: DECNET; CTERM_MSG_DECODER.#"


(defun CTERM-get-selector-value-list (header offset)
  (declare (values (selector-list offset normal-echo-flag)))
  (let ((selector-list ())(selector-type nil)(selector-id nil)(normal-echo nil))    
    (loop
      (if (>= offset (array-length header))
	  (return nil)
	  
	  (multiple-value-setq (selector-id offset)
			       (cterm-get-1-byte header offset))
	  (multiple-value-setq (selector-type offset)
			       (cterm-get-1-byte header offset))
	  (case selector-type
		(0 (multiple-value-setq (offset selector-list)
					(CTERM-get-selector-type0-values
					  header offset selector-id selector-list)))
		(1 (multiple-value-setq (offset selector-list)
					(CTERM-get-selector-type1-values
					  header offset selector-id selector-list)))
		(2 (multiple-value-setq (offset selector-list normal-echo)
					(CTERM-get-selector-type2-values
					  header offset selector-id selector-list)))) ))
    (values selector-list offset normal-echo)))  

))

#!C
; From file CTERM_MSG_DECODER.LISP#> DECNET; SYS:
#10R DNA#:
(COMPILER-LET ((*PACKAGE* (FIND-PACKAGE "DNA"))
                          (SI:*LISP-MODE* :COMMON-LISP)
                          (*READTABLE* SYS:COMMON-LISP-READTABLE)
                          (SI:*READER-SYMBOL-SUBSTITUTIONS* SYS::*COMMON-LISP-SYMBOL-SUBSTITUTIONS*))
  (COMPILER#:PATCH-SOURCE-FILE "SYS: DECNET; CTERM_MSG_DECODER.#"


(defun Decode-CHARACTERISTICS-message (header offset)
  (declare (values offset flags selector-list normal-echo-flag))  
  (let ((flags 0)(selector-list nil)(normal-echo nil))    
    (multiple-value-setq (flags offset)
			 (CTERM-get-1-byte header (1+ offset)))
    (multiple-value-setq (selector-list offset normal-echo)
			 (CTERM-get-selector-value-list header offset))
    (values offset flags selector-list normal-echo)))

))

#!C
; From file CTERM_MSG_HANDLER.LISP#> DECNET; SYS:
#10R DNA#:
(COMPILER-LET ((*PACKAGE* (FIND-PACKAGE "DNA"))
                          (SI:*LISP-MODE* :COMMON-LISP)
                          (*READTABLE* SYS:COMMON-LISP-READTABLE)
                          (SI:*READER-SYMBOL-SUBSTITUTIONS* SYS::*COMMON-LISP-SYMBOL-SUBSTITUTIONS*))
  (COMPILER#:PATCH-SOURCE-FILE "SYS: DECNET; CTERM_MSG_HANDLER.#"


(defmethod (Cterm-stream :process-start-read-msg) ()
  (let (disable-cntrl-defn end-of-prompt start-of-display
	 non-def-termset start-read-data-offset truncated)
    (multiple-value-setq (format-flag		raise-input-p
			  disable-cntrl-defn	echo-flag		      
			  echo-terminator       time-out-flag
			  max-len		start-of-display
			  end-of-prompt		termset
			  non-def-termset	start-read-data-offset  
			  truncated		prompt-data)
	(decode-start-read-message current-input-buffer current-input-index))
    (if truncated      ;last message before disconnect-initiate
	(progn
	  (setf current-input-index current-input-bufferlen)	  
	  (setf status :CLOSING)	  
	  (signal 'dna:normal-restart "Connection closed by foreign host."))
	; check for abnormal echo condition
	(when (numberp normal-echo)
	  (if (zerop normal-echo)
	      (setf echo-flag nil)
	      (setf echo-flag t)))
	(when (eql system-type ':VMS4)
	  (send self :send-blocked-done-msg))
	(when (and time-out-flag non-def-termset)
	  (unless (zerop non-def-termset)
	    (send self :send-special-edit-response)))
	(if (= 1 disable-cntrl-defn)
	  (send window :set-ctrl-u-and-r-enabled nil)
	  (send window :set-ctrl-u-and-r-enabled t))
	(if (or (= 2 disable-cntrl-defn)(= 3 disable-cntrl-defn))
	    (send window :set-ctrl-enable nil)
	    (send window :set-ctrl-enable t))
	(if (zerop start-read-data-offset)
	    (setf current-input-index (+ current-input-index next-msg-len))
	    (setf current-input-index start-read-data-offset))
	(setf current-input-datalen
	      (- end-of-prompt start-of-display))
	;handle the case of the prompt without the leading fresh-line characters.
	(unless (zerop current-input-datalen)
	  (multiple-value-bind (x ignore)
	      (send window :read-cursorpos :character)
	    (unless (or (= ascii-cr (aref current-input-buffer start-read-data-offset))
			(zerop x))
	      (setf (aref current-input-buffer (- start-read-data-offset 2)) ascii-cr)
	      (setf (aref current-input-buffer (- start-read-data-offset 1)) ascii-lf)
	      (setf start-read-data-offset (- start-read-data-offset 2))
	      (setf current-input-datalen (+ 2 current-input-datalen))
	      (setf current-input-index (- current-input-index 2)))))
	(if (zerop current-input-datalen)
	    nil
	    t))))

))

#!C
; From file CTERM_MSG_HANDLER.LISP#> DECNET; SYS:
#10R DNA#:
(COMPILER-LET ((*PACKAGE* (FIND-PACKAGE "DNA"))
                          (SI:*LISP-MODE* :COMMON-LISP)
                          (*READTABLE* SYS:COMMON-LISP-READTABLE)
                          (SI:*READER-SYMBOL-SUBSTITUTIONS* SYS::*COMMON-LISP-SYMBOL-SUBSTITUTIONS*))
  (COMPILER#:PATCH-SOURCE-FILE "SYS: DECNET; CTERM_MSG_HANDLER.#"


(defmethod (Cterm-stream :process-characteristics-msg) ()
  (let ((flags 0)(selector-list nil))
    (multiple-value-setq (current-input-index flags selector-list normal-echo)
			 (decode-characteristics-message current-input-buffer current-input-index))
    (when (eql system-type ':VMS4)
      (send self :send-blocked-done-msg))
    (setf current-input-index current-input-bufferlen)
    (setf current-input-datalen 0)))

))

#!C
; From file CTERM_MSG_HANDLER.LISP#> DECNET; SYS:
#10R DNA#:
(COMPILER-LET ((*PACKAGE* (FIND-PACKAGE "DNA"))
                          (SI:*LISP-MODE* :COMMON-LISP)
                          (*READTABLE* SYS:COMMON-LISP-READTABLE)
                          (SI:*READER-SYMBOL-SUBSTITUTIONS* SYS::*COMMON-LISP-SYMBOL-SUBSTITUTIONS*))
  (COMPILER#:PATCH-SOURCE-FILE "SYS: DECNET; CTERM_MSG_HANDLER.#"


(defmethod (Cterm-stream :process-unread-msg) ()
;  (let ((unread-condition nil))
;   (multiple-value-setq (current-input-index unread-condition)
;			 (decode-unread-message current-input-buffer current-input-index))
  (let ((comp-code 6))
    ; completion code for unread is 6
  (send self :send-sgl-char-read-msg ascii-nul comp-code)
  (setf current-input-index (+ current-input-index 2))
  (setf current-input-datalen 0)))

))

#!C
; From file CTERM_MSG_HANDLER.LISP#> DECNET; SYS:
#10R DNA#:
(COMPILER-LET ((*PACKAGE* (FIND-PACKAGE "DNA"))
                          (SI:*LISP-MODE* :COMMON-LISP)
                          (*READTABLE* SYS:COMMON-LISP-READTABLE)
                          (SI:*READER-SYMBOL-SUBSTITUTIONS* SYS::*COMMON-LISP-SYMBOL-SUBSTITUTIONS*))
  (COMPILER#:PATCH-SOURCE-FILE "SYS: DECNET; CTERM_MSG_HANDLER.#"


(defmethod (Cterm-stream :send-control-char)(ch &optional (comp-code 0)(termpos 0))
  (let* ((buffer (get-new-pkt-hdr))
	 (pkt (array-leader buffer 0))
	 (offset 0)(next-msglen 9.))
    (setf offset (setup-discard-state-message buffer offset))
    (setf offset (cterm-set-2-bytes buffer offset next-msglen))
    (setf ch (make-string 1 :initial-element ch))
    (if (eql max-len 1)	
	(setf offset (setup-read-data-message buffer offset ch 4 1)) ; completion code for input buffer is full is 4
	(setf offset (setup-read-data-message buffer offset ch comp-code termpos)))
    (get-application-header pkt :DATA offset)
    (send self :transmit-packet pkt)
    ))

))
