;;; -*- Mode: Common-Lisp; Package: User; Base: 10.; Patch-File: T -*-

;;;			      RESTRICTED RIGHTS LEGEND

;;;Use, duplication, or disclosure by the Government is subject to
;;;restrictions as set forth in subdivision (b)(3)(ii) of the Rights in
;;;Technical Data and Computer Software clause at 52.227-7013.
;;;
;;;			TEXAS INSTRUMENTS INCORPORATED.
;;;				 P.O. BOX 2909
;;;			      AUSTIN, TEXAS 78769
;;;				    MS 2151
;;;
;;; Copyright (C) 1987 Texas Instruments Incorporated. All rights reserved.

;;; Patch file for DECNET version 1.23
;;; Reason: Fixed default value of any-bad-addresses flag (was t should be nil) for determining end processing of PMU. DECnet
;;; patch 1.18 *MUST* be loaded before this patch. Code read by BRG.
;;; Written 08/07/87 10:29:28 by graham,
;;; while running on Oppenheimer from band LOD1
;;; With IO 3.18, PATHNAME 3.13, FILE 3.7, SYSTEM 3.36, METER 3.1, SERIAL 3.0, CHAOSNET 3.10,
;;;  ETHERNET 3.0, GC 3.7, IMAGEN 3.0, MAIL-DAEMON 3.1, NETWORK-SUPPORT 3.6, PROFILE 3.0,
;;;  SUGGESTIONS 3.3, UCL 3.0, ZWEI 3.6, STREAMER-TAPE 3.5, DEBUG-TOOLS 3.0, FONT-EDITOR 3.1,
;;;  GLOSSARY 3.0, INPUT-EDITOR 3.0, MAIL-READER 3.1, NAMESPACE-EDITOR 3.2, NVRAM 3.0,
;;;  TELNET 3.0, TV 3.5, NAMESPACE 3.7, COMPILER 3.9, PRINTER 3.1, SYSLOG 3.0, VT100 3.1,
;;;  IP 2.22, Experimental BUG 4.18, Inconsistent DECNET 1.22,  microcode 395, Band Name: 6/25+DECnet

#!C
; From file DECNET_SERVERS.LISP#> DECNET; MR-X:
#10R DNA#:
(COMPILER-LET ((*PACKAGE* (FIND-PACKAGE "DNA"))
                          (SI:*LISP-MODE* :COMMON-LISP)
                          (*READTABLE* SYS:COMMON-LISP-READTABLE)
                          (SI:*READER-SYMBOL-SUBSTITUTIONS* SYS::*COMMON-LISP-SYMBOL-SUBSTITUTIONS*))
  (COMPILER#:PATCH-SOURCE-FILE "SYS: DECNET; DECNET_SERVERS.#"


(defun start-pmu (host stream from message address-list total-to-list)
  (let ((any-valid-addresses nil)
	(any-bad-addresses nil))
    (send stream :string-out (string-upcase from))          ;The first packet contains the user-id field
    (send stream :force-output)
    (dolist (to address-list (send-zero-message stream))
      (send stream :string-out                              ;Until we see a #x00, TO: fields will follow.
	    (string-upcase (send to :local-part-string)))
      (send stream :force-output)
      (if (= (char-int (send stream :tyi)) 1)
	  (progn 
	    (dotimes (i 3) (send stream :tyi))
	    (setf any-valid-addresses t)
	    (send message :dispose-address to :delivered host))
	  (progn
	    (pmu-error host stream message to)              ; One of the addresses failed.
	    (setf any-bad-addresses t)
	    )))
    (when any-valid-addresses
      (if total-to-list                                     ;send total address list
	  (send stream :string-out total-to-list)                          
	   (dolist (address address-list)                    ;If TO: line not available(?), send addresses from address-list.
	     (send stream :string-out (send address :string-for-message))
	     (send stream :string-out ",")))
      (send stream :force-output))
    (values any-valid-addresses any-bad-addresses)))
))
