;;; -*- Mode: Common-Lisp; Package: User; Base: 10.; Patch-File: T -*-

;;;			      RESTRICTED RIGHTS LEGEND

;;;Use, duplication, or disclosure by the Government is subject to
;;;restrictions as set forth in subdivision (b)(3)(ii) of the Rights in
;;;Technical Data and Computer Software clause at 52.227-7013.
;;;
;;;			TEXAS INSTRUMENTS INCORPORATED.
;;;				 P.O. BOX 2909
;;;			      AUSTIN, TEXAS 78769
;;;				    MS 2151
;;;
;;; Copyright (C) 1987 Texas Instruments Incorporated. All rights reserved.

;;; Written 08/07/87 15:47:25 by GRAHAM,
;;; Reason: DAP server now gets file properties using (fs:file-properties ..) not properties from the stream object. This
;;; fixes bug report 6157 where we were trying to read a remote file from the DAP server.
;;; while running on Oppenheimer from band LOD1
;;; With IO 3.18, PATHNAME 3.13, FILE 3.7, SYSTEM 3.36, METER 3.1, SERIAL 3.0, CHAOSNET 3.10,
;;;  ETHERNET 3.0, GC 3.7, IMAGEN 3.0, MAIL-DAEMON 3.1, NETWORK-SUPPORT 3.6, PROFILE 3.0,
;;;  SUGGESTIONS 3.3, UCL 3.0, ZWEI 3.6, STREAMER-TAPE 3.5, DEBUG-TOOLS 3.0, FONT-EDITOR 3.1,
;;;  GLOSSARY 3.0, INPUT-EDITOR 3.0, MAIL-READER 3.1, NAMESPACE-EDITOR 3.2, NVRAM 3.0,
;;;  TELNET 3.0, TV 3.5, NAMESPACE 3.7, COMPILER 3.9, PRINTER 3.1, SYSLOG 3.0, VT100 3.1,
;;;  IP 2.22, Experimental BUG 4.18, DECNET 1.0,  microcode 395, Band Name: 6/25+DECnet

#!C
; From file DAP_SERVER.LISP#> DECNET; MR-X:
#10R DNA#:
(COMPILER-LET ((*PACKAGE* (FIND-PACKAGE "DNA"))
                          (SI:*LISP-MODE* :COMMON-LISP)
                          (*READTABLE* SYS:COMMON-LISP-READTABLE)
                          (SI:*READER-SYMBOL-SUBSTITUTIONS* SYS::*COMMON-LISP-SYMBOL-SUBSTITUTIONS*))
  (COMPILER#:PATCH-SOURCE-FILE "SYS: DECNET; DAP_SERVER.#"


(defmethod (dap-server-stream :server-open-for-output) (path display)
  (server-display "~% Open for output called on ~a" path)
  (let ((truename (send path :truename nil))
	(any-error t))
    (if (errorp truename)
	(send self :server-map-error truename)
	(let* ((props (send truename :properties))
	       (data-type (if (get props :characters) ascii-data image-data))
	       (org seq-org)
	       (rfm (if (eql (get props :byte-size) 8)
			(if (eql data-type ascii-data) rfm-variable rfm-undef)
			rfm-fixed))
	       (rat (case rfm
			  (#.rfm-variable rat-implied-crlf)
			  (#.rfm-undef rat-blk)
			  (#.rfm-fixed rat-embedded-format)))
	       (mrs (if (eql data-type image-data) 512. 0))
;	       (dev-map (list dev-FOD dev-SHR dev-MNT dev-IDV dev-ODV dev-AVL dev-RAD))
	       )
	  (send self :process-display display truename t data-type org rfm rat mrs 0. 0.)
	  (send self :send-acknowledge-message)
	  (if (send self :server-process-control-message)  ;this is the INITIATE message
	      (let* ((internal-stream (send path :open path :direction :input
					   :if-does-not-exist :error :error nil
					   :byte-size :default :characters :default))
		    (internal-props (fs:file-properties internal-stream)))
		(if (errorp internal-stream)
		    (send self :server-map-error internal-stream)
		    (progn
		      (send self :send-acknowledge-message)
		      (unwind-protect
			  (let ((stream (make-instance (decnet-server-stream-flavor-type
							 :output
							 (get internal-props :byte-size)
							 (get internal-props :characters))
						       :pathname (send internal-stream :truename)
						       :basic-stream self)))
			    (unwind-protect
				(progn
				  (send self :server-process-control-message)	   ;this is the GET message
				  (setf (send (send self :port) :remote-window-size) 1);Set output window size
				  (stream-copy-until-eof internal-stream stream))
				(send stream :close)	   ;Send this to the "new" stream
				(send self :output-close)  ;Send this to ourself
				(setf any-error nil)))	
		  (send internal-stream :close)))
		    )) 
	      (send self :send-access-complete-message cmpfunc-close)
	  )))))
))
