;;; -*- Mode: Common-Lisp; Package: User; Base: 10.; Patch-File: T -*-

;;;			      RESTRICTED RIGHTS LEGEND

;;;Use, duplication, or disclosure by the Government is subject to
;;;restrictions as set forth in subdivision (b)(3)(ii) of the Rights in
;;;Technical Data and Computer Software clause at 52.227-7013.
;;;
;;;			TEXAS INSTRUMENTS INCORPORATED.
;;;				 P.O. BOX 2909
;;;			      AUSTIN, TEXAS 78769
;;;				    MS 2151
;;;
;;; Copyright (C) 1987 Texas Instruments Incorporated. All rights reserved.

;;; Written 08/14/87 13:47:04 by PHIL,
;;; Reason: Fix connection-possible-p function for nsp-stream to adhere to network-support
;;; patch 3.9 functionality [spr#5572].  Code readers: LER, PJW.
;;; while running on NOVEMBER from band LOD1
;;; With IO 3.25, PATHNAME 3.16, FILE 3.10, SYSTEM 3.50, METER 3.5, SERIAL 3.1, CHAOSNET 3.10,
;;;  ETHERNET 3.0, GC 3.9, IMAGEN 3.0, MAIL-DAEMON 3.1, NETWORK-SUPPORT 3.7, PROFILE 3.1,
;;;  SUGGESTIONS 3.3, UCL 3.3, ZWEI 3.14, STREAMER-TAPE 3.7, DEBUG-TOOLS 3.2, FONT-EDITOR 3.1,
;;;  GLOSSARY 3.0, INPUT-EDITOR 3.0, MAIL-READER 3.4, NAMESPACE-EDITOR 3.4, NVRAM 3.3,
;;;  TELNET 3.5, TV 3.15, NAMESPACE 3.7, COMPILER 3.22, PRINTER 3.2, SYSLOG 3.0, VT100 3.12,
;;;  IP 2.46, Experimental BUG 7.0, DECNET 1.24,  microcode 409, Band Name: 7/27+DECNET+ENET patch

#!C
; From file NSP_STREAMS.LISP#> DECNET; SYS:
#10R DNA#:
(COMPILER-LET ((*PACKAGE* (FIND-PACKAGE "DNA"))
                          (SI:*LISP-MODE* :COMMON-LISP)
                          (*READTABLE* SYS:COMMON-LISP-READTABLE)
                          (SI:*READER-SYMBOL-SUBSTITUTIONS* SYS::*COMMON-LISP-SYMBOL-SUBSTITUTIONS*))
  (COMPILER#:PATCH-SOURCE-FILE "SYS: DECNET; NSP_STREAMS.#"


(defun nsp-stream-connection-possible-p-function (host-a
						  &optional (host-b si:local-host) logical-contact-name)
  "Return T if it is possible to create a connection from host-a to host-b"
  (let* ((host-a (si:parse-host host-a t t))
	 (host-b (si:parse-host host-b t t)))
    (and host-a
	 host-b
	 (or (not logical-contact-name) (net:translate-logical-contact-name logical-contact-name :NSP-STREAM))
	 (get-decnet-address host-a)
	 (get-decnet-address host-b))))

))
