;;; -*- Mode: Common-Lisp; Package: User; Base: 10.; Patch-File: T -*-
;;; Written 09/18/87 10:50:06 by REINER,
;;; Reason: Modifications to DECnet to reflect changes made in the Ethernet code.  [No SPR#]  Code Readers: MMG, LER
;;; while running on NOVEMBER from band LOD2
;;; With IO 3.37, PATHNAME 3.16, FILE 3.14, SYSTEM 3.87, METER 3.6, SERIAL 3.2, Inconsistent CHAOSNET 3.18,
;;;  ETHERNET 3.2, GC 3.21, IMAGEN 3.0, MAIL-DAEMON 3.4, NETWORK-SUPPORT 3.15, PROFILE 3.2,
;;;  SUGGESTIONS 3.3, UCL 3.3, ZWEI 3.17, STREAMER-TAPE 3.13, DEBUG-TOOLS 3.4, FONT-EDITOR 3.1,
;;;  GLOSSARY 3.0, INPUT-EDITOR 3.0, MAIL-READER 3.13, NAMESPACE-EDITOR 3.5, NVRAM 3.6,
;;;  TELNET 3.7, TV 3.21, NAMESPACE 3.10, COMPILER 3.31, PRINTER 3.4, SYSLOG 3.0,
;;;  VT100 3.14, IP 2.57, Experimental BUG 8.0, Experimental DATALINK 19.0, Experimental DATALINK-DISPLAYS 7.0,
;;;  DECNET 1.25,  microcode 454, Band Name: 3.1 9/10 IP DL19

#!C
; From file DEFS.LISP#> DECNET; SYS:
#10R DNA#:
(COMPILER-LET ((*PACKAGE* (FIND-PACKAGE "DNA"))
                          (SI:*LISP-MODE* :COMMON-LISP)
                          (*READTABLE* SYS:COMMON-LISP-READTABLE)
                          (SI:*READER-SYMBOL-SUBSTITUTIONS* SYS::*COMMON-LISP-SYMBOL-SUBSTITUTIONS*))
  (COMPILER#:PATCH-SOURCE-FILE "SYS: DECNET; DEFS.#"


(Defparameter *MC-ADDR-LIST* `(,dna:all-routers ,dna:all-endnodes)   "List of multicast addresses")

))

#!C
; From file ROUTING.LISP#> DECNET; SYS:
#10R DNA#:
(COMPILER-LET ((*PACKAGE* (FIND-PACKAGE "DNA"))
                          (SI:*LISP-MODE* :COMMON-LISP)
                          (*READTABLE* SYS:COMMON-LISP-READTABLE)
                          (SI:*READER-SYMBOL-SUBSTITUTIONS* SYS::*COMMON-LISP-SYMBOL-SUBSTITUTIONS*))
  (COMPILER#:PATCH-SOURCE-FILE "SYS: DECNET; ROUTING.#"


(defun ROUTING-RECEIVER (circuit data-array nbytes type src-addr dst-addr
			 &optional (free-buffer t))
  "Receive a DECnet packet from the datalink handler.  This function must never block, go into the error
    handler, or take excessive CPU time.  It is executed in the receiver process for the datalink."
  (declare (special *nsp-object*))
  (unwind-protect
      (when (and *receive-enabled*
		 (not (eql 0 nbytes))
		 (not (null dna:my-addresses)))
	(let* ((INHIBIT-SCHEDULING-FLAG T)
	       (start-time  (sys:%fixnum-microsecond-time))
	       (default-cons-area *decnet-area*)
	       (pkt (send *routing-handler* :allocate-pkt :input))
	       (header-preamble
		 (progn (WITHOUT-INTERRUPTS
			  (SYS:%BLT (SYS:%MAKE-POINTER-OFFSET
				  SYS:DTP-FIX data-array
				  (SI:ARRAY-DATA-OFFSET data-array))
				(SYS:%MAKE-POINTER-OFFSET
				  SYS:DTP-FIX (send pkt :base-array)
				  (SI:ARRAY-DATA-OFFSET
				    (send pkt :base-array)))
				(min (CEILING NBYTES 4)
				     (FLOOR (length (send pkt :base-array)) 4))
				1))
			(unless (<= (* 4 (CEILING NBYTES 4))	   ;rwf 10/31/86
				    (length (send pkt :base-array)))
			  (when *packet-trace-enable*
			    (record-unusual-packet :too-big
						   (send pkt :base-array) :receive nbytes
						   type src-addr dst-addr circuit)))
			(setf (net:packet-time-received     pkt) (time))
			(setf (net:packet-datalink-src-addr pkt) src-addr) 
			(setf (net:packet-datalink-dst-addr pkt) dst-addr) 
			(setf (net:packet-datalink-nbytes   pkt)
			      (min nbytes (+ 2 (FLAGS-PACKET-SIZE (send pkt :base-array)))))
			(setf (net:packet-datalink-type     pkt) type)
			(setf (net:packet-datalink-circuit  pkt) circuit)
			(net:get-datalink-header
			  pkt :pre-routing
			  (DNA:ROUTE-HEADER-OFFSET (send pkt :base-array)))))
	       (datalink-data (net:get-datalink-data
				pkt (min (- nbytes (length header-preamble))
					 (flags-packet-size header-preamble))
				)
			      )
	       (header        (net:get-network-header
				pkt
				(DNA:PARSE-ROUTE-MESSAGE-TYPE  datalink-data)
				(DNA:PARSE-ROUTE-HEADER-LENGTH datalink-data)))
	       (data          (net:get-network-data
				pkt (min (- nbytes
					    (length header-preamble)
					    (length header))
					 (- (flags-packet-size header-preamble)
					    (length header)))
				)
			      )
	       )

	      (if (prog1 (not (and header data))
			 (when *packet-trace-enable*
			   (record-packet (send pkt :base-array) :receive (net:packet-datalink-nbytes pkt)
					  type src-addr dst-addr circuit)))
		  (incf (routing-handler-ill-formed-packets-received *routing-handler*)) 
		  (progn
		    (unless (member (area (src-node header)) dna:my-areas)
		      (incf (routing-handler-packets-from-other-area *routing-handler*))
		      (when *packet-trace-enable*
			(record-unusual-packet :foreign-area
					       (send pkt :base-array) :receive nbytes
					       type src-addr dst-addr circuit))
		      )
		    (incf (routing-handler-packets-received        *routing-handler*))
		    
		    
		    (when (< 2 (length header-preamble))
		      (incf (routing-handler-padded-packets-received *routing-handler*)))
		    (incf (routing-handler-bytes-received   *routing-handler*) nbytes)
		    (let* ((source (src-node header)))
		      (when source
			(let* ((entry (LOOKUP-NODE-COUNTERS source)))
			  (when entry 
			    (case (net:get-network-header-kind pkt)
				  (:ENDNODE-HELLO-MESSAGE
				   (incf (node-counters-ENDNODE-HELLO-packets-received   entry)))
				  (:ROUTER-HELLO-MESSAGE
				   (incf (node-counters-ROUTER-HELLO-packets-received    entry)))   
				  (:LEVEL-2-ROUTING-MESSAGE
				   (incf (node-counters-level-2-routing-packets-received entry)))
				  (:LEVEL-1-ROUTING-MESSAGE
				   (incf (node-counters-level-1-routing-packets-received entry)))
				  (:HELLO-AND-TEST-MESSAGE
				   (incf (node-counters-hello-and-test-packets-received  entry)))
				  (:ROUTING
		                   (setf (node-counters-last-receive-time entry) (get-universal-time))
				   (incf (node-counters-long-route-packets-received      entry))
				   (incf (node-counters-packets-received entry))
				   (incf (node-counters-bytes-received   entry) nbytes)
				   )
				  (otherwise
				   (setf (node-counters-last-receive-time entry) (get-universal-time))
				   (incf (node-counters-unknown-type-packets-received    entry))
				   (incf (node-counters-packets-received entry))
				   (incf (node-counters-bytes-received   entry) nbytes)
				   )
				  )	   ;case
			    )		   ;when
			  )		   ;let*
			)		   ;when
		      )			   ;let*
		    (case (net:get-network-header-kind pkt)
			  (:ENDNODE-HELLO-MESSAGE (process-endnode-hello pkt dst-addr))
			  (:ROUTER-HELLO-MESSAGE  (process-router-hello  pkt dst-addr))   
			  (:LEVEL-2-ROUTING-MESSAGE
			   (incf (routing-handler-level-2-routing-packets-received *routing-handler*))
			   (send *routing-handler* :deallocate-pkt pkt))
			  (:LEVEL-1-ROUTING-MESSAGE
			   (incf (routing-handler-level-1-routing-packets-received *routing-handler*))
			   (send *routing-handler* :deallocate-pkt pkt))
			  (:HELLO-AND-TEST-MESSAGE
			   (incf (routing-handler-hello-and-test-packets-received  *routing-handler*))
			   (send *routing-handler* :deallocate-pkt pkt))
			  (:ROUTING
			   (incf (routing-handler-long-route-packets-received      *routing-handler*))
			   (when (and (not *passive-nsp*)
				      (variable-boundp *nsp-object*)
				      *nsp-object*)
			     (send *nsp-object* :receive-message pkt (src-node header))))
			  (otherwise
			   (incf (routing-handler-unknown-type-packets-received    *routing-handler*))
			   (when *packet-trace-enable*
			     (record-unusual-packet :unknown-packet-type
						    (send pkt :base-array) :receive nbytes
						    type src-addr dst-addr circuit))
			   (send *nsp-object* :receive-odd-message pkt
				 (net:swap-bytes (logxor src-addr hiord_16))))			   
			  )		   ;case
		    )			   ;else (progn)
		  )			   ;if
	  (incf (routing-handler-time-receiving *routing-handler*)        
		(round (time-difference (sys:%fixnum-microsecond-time) start-time) 1000.)
		)))
	;; clean up resources.
	(when free-buffer
	  (ethernet::deallocate-net-packet type data-array)))
    )

))

#!C
; From file ROUTING.LISP#> DECNET; SYS:
#10R DNA#:
(COMPILER-LET ((*PACKAGE* (FIND-PACKAGE "DNA"))
                          (SI:*LISP-MODE* :COMMON-LISP)
                          (*READTABLE* SYS:COMMON-LISP-READTABLE)
                          (SI:*READER-SYMBOL-SUBSTITUTIONS* SYS::*COMMON-LISP-SYMBOL-SUBSTITUTIONS*))
  (COMPILER#:PATCH-SOURCE-FILE "SYS: DECNET; ROUTING.#"


(defun ROUTING-TRANSMIT (output-array nbytes destination &optional (self-receive nil))
  "The transmit routine for DNA Routing."
  (when (and *transmit-enabled*
	     (not (null dna:my-addresses)))
    (let* ((pkt-nbytes  nbytes)
	   (controller  (first net:controller-list))	   ;TEMPORARY!!!!!
	   (Destination-Ether-Address (if (< destination #x10000)
					  (logior HIORD_16 (net:swap-bytes destination))
					  destination))
	   (Source-Ether-Address      (send controller :ethernet-address))
	   (output-word-array nil))
      (when (eql (flags-padded byte-pkt) 1)
	(INCF (routing-handler-padded-packets-sent *ROUTING-HANDLER*)))
      (when *packet-trace-enable*
	(record-packet output-array :transmit pkt-nbytes
		       *ROUTE-ETHERNET-TYPE*
		       Source-Ether-Address
		       Destination-Ether-Address
		       Controller))
      
      (INCF (routing-handler-packets-sent *ROUTING-HANDLER*))
      (INCF (routing-handler-bytes-sent   *ROUTING-HANDLER*) pkt-nbytes)
      
      (when (< destination #x10000)
	(let* ((entry (LOOKUP-NODE-COUNTERS destination)))
	  (when entry 
	    (case (DNA:ROUTE-MESSAGE-TYPE  byte-pkt)
	      (:ENDNODE-HELLO-MESSAGE
	       (incf (node-counters-ENDNODE-HELLO-packets-sent   entry)))
	      (:ROUTER-HELLO-MESSAGE
	       (incf (node-counters-ROUTER-HELLO-packets-sent    entry)))   
	      (:LEVEL-2-ROUTING-MESSAGE
	       (incf (node-counters-level-2-routing-packets-sent entry)))
	      (:LEVEL-1-ROUTING-MESSAGE
	       (incf (node-counters-level-1-routing-packets-sent entry)))
	      (:HELLO-AND-TEST-MESSAGE
	       (incf (node-counters-hello-and-test-packets-sent  entry)))
	      (:ROUTING
	       (setf (node-counters-last-send-time entry) (get-universal-time))
	       (incf (node-counters-long-route-packets-sent      entry))
	       (incf (node-counters-packets-sent entry))
	       (incf (node-counters-bytes-sent   entry) pkt-nbytes)
	       )
	      (otherwise
	       (setf (node-counters-last-send-time entry) (get-universal-time))
	       (incf (node-counters-packets-sent entry))
	       (incf (node-counters-bytes-sent   entry) pkt-nbytes)
	       )
	      )
	    )
	  )
	)
      (without-interrupts
	(setq output-word-array (if (= 16. (si:array-element-size output-array))
				    output-array       
				    (when (SI:ARRAY-INDIRECT-P output-array)
				      (ferror nil "~& Illegal (indirect) input to net."))
				    (assert (<= (* 4 (CEILING pkt-nbytes 4))	   ;rwf 10/31/86
						(* 2 (length real-word-pkt))))
				    
				    (SYS:%BLT (SYS:%MAKE-POINTER-OFFSET
						SYS:DTP-FIX
						output-array
						(SI:ARRAY-DATA-OFFSET output-array))
					      (SYS:%MAKE-POINTER-OFFSET
						SYS:DTP-FIX
						real-word-pkt
						(SI:ARRAY-DATA-OFFSET real-word-pkt))
					      (CEILING pkt-nbytes 4)
					      1)
				    real-word-pkt))
	
	(unless (MEMBER destination dna:my-addresses)
	  (SEND controller :TRANSMIT-FAST
		*ROUTE-ETHERNET-TYPE*
		Destination-Ether-Address
		output-word-array
		pkt-nbytes)
	  )
	
	(when (or (MEMBER destination dna:my-addresses) self-receive)
	  (ROUTING-RECEIVER
	    controller
	    output-word-array
	    pkt-nbytes
	    *ROUTE-ETHERNET-TYPE*
	    Source-Ether-Address      
	    Destination-Ether-Address 
	    nil)
	  (process-allow-schedule))
	)
      )					   ;when
    )					   ;let
  )					   ;defun

))

#!C
; From file ROUTING.LISP#> DECNET; SYS:
#10R DNA#:
(COMPILER-LET ((*PACKAGE* (FIND-PACKAGE "DNA"))
                          (SI:*LISP-MODE* :COMMON-LISP)
                          (*READTABLE* SYS:COMMON-LISP-READTABLE)
                          (SI:*READER-SYMBOL-SUBSTITUTIONS* SYS::*COMMON-LISP-SYMBOL-SUBSTITUTIONS*))
  (COMPILER#:PATCH-SOURCE-FILE "SYS: DECNET; ROUTING.#"


(Defun SETUP-ETHERNET-ADDRESS (controller)
  "Reads the Config ROM Ethernet Address from CONTROLLER, manufactures a new Decnet
   Ethernet Address, then issues an IA-Setup command to CONTROLLER to load the
   new address."  
  (Let ((Net-Addr (Send Controller :Read-Rom-Id)))
    (Send Controller :IA-Setup
	  (Cond ((And (not (null my-address))
		      (not (eql 0 my-address)))
		 (+ hiord_16 (net:swap-bytes my-address))
		 )
		((or (zerop Net-Addr) (= Net-Addr #xFFFFFFFFFFFF))
		 (+ #x080028010000 Chaos:My-Address))
		(t Net-Addr)
		)			   ; cond
	  )				   ; send
    )					   ; let
  )					   ; setup-ethernet-address

))

#!C
; From file ROUTING.LISP#> DECNET; SYS:
#10R DNA#:
(COMPILER-LET ((*PACKAGE* (FIND-PACKAGE "DNA"))
                          (SI:*LISP-MODE* :COMMON-LISP)
                          (*READTABLE* SYS:COMMON-LISP-READTABLE)
                          (SI:*READER-SYMBOL-SUBSTITUTIONS* SYS::*COMMON-LISP-SYMBOL-SUBSTITUTIONS*))
  (COMPILER#:PATCH-SOURCE-FILE "SYS: DECNET; ROUTING.#"


(defun SET-HOST-ADDRESSES ()
  (declare (special ethernet:*ethernet-addr-hash-table*))
  (dolist (area-item DNA:NODE-NAME-MAP)
    (dolist (host-item (cdr area-item))
      (let* ((node  0)
	     (area-id-number (car area-item))
	     (host-id-number (car host-item ))
	     (host (si:parse-host (cdr host-item) t))
	     (addresses (when host
			  (send host :send-if-handles :network-addresses)))
	     )
	(setf (area    node) area-id-number)
	(setf (host-id node) host-id-number)
	(if (and (null host)
		 (variable-boundp ethernet:*ethernet-addr-hash-table*)
		 ethernet:*ethernet-addr-hash-table*)
	    (setf (gethash (+ #xAA0004000000 (net:swap-bytes node))
			   ethernet:*ethernet-addr-hash-table*)
		  (cdr host-item)))
	(unless (or (null addresses) (member :dna addresses))   
	  (nconc addresses (list :dna (list node)))))))
  )

))


#!C
; From file ROUTING.LISP#> DECNET; SYS:
#10R DNA#:
(COMPILER-LET ((*PACKAGE* (FIND-PACKAGE "DNA"))
                          (SI:*LISP-MODE* :COMMON-LISP)
                          (*READTABLE* SYS:COMMON-LISP-READTABLE)
                          (SI:*READER-SYMBOL-SUBSTITUTIONS* SYS::*COMMON-LISP-SYMBOL-SUBSTITUTIONS*))
  (COMPILER#:PATCH-SOURCE-FILE "SYS: DECNET; ROUTING.#"


(defun ROUTING-RESET (&key (enable t) (hard t))
  "Put the DECnet module into a (hopefully) runnable state.  Note that this host's ETHERNET
    address may change if this is the first time that the machine was reset with DECnet installed."
  (dna:disable)
  (dna:reset-on-ethernet-cache)
  (dna:reset-node-counters)
  (dna:setup-my-address)		   ;possibly obsolete ethernet address
  (if hard
      (progn
	(ethernet:add-protocol dna:*ROUTE-ETHERNET-TYPE* 'Routing-Receiver)
	(Ethernet:Add-Net-Packet-Allocator
	  dna:*ROUTE-ETHERNET-TYPE* 'CHAOS::ALLOCATE-INT-PKT 'CHAOS::FREE-INT-PKT)
	(net:reset-packets)
        (setf *ROUTING-HANDLER* (make-instance 'routing-handler))
	(net:send-all-controllers :disable)	   ;need to permanently flush old controllers using...
	(Dolist (Cont Net:Controller-List)
	  (Setup-Ethernet-Address Cont))
	(ethernet:reset-address-translations)  ;force rebroadcasts of our (new) ethernet address
	(Dolist (Cont Net:Controller-List)
	  (Send Cont :Set-Mc-Addr-List DNA:*Mc-Addr-List*))  ;MMG	
	(net:send-all-controllers :reset)
	(net:send-all-controllers :enable))	
      (send *routing-handler* :reset))
  (when (and my-address (not (eql 0 my-address)))
    (set-host-addresses)
    (reset-hello-xmitter))
  (when enable
    (dna:enable))
  )

))

#!C
; From file ROUTE_DEBUG.LISP#> DECNET; SYS:
#10R DNA#:
(COMPILER-LET ((*PACKAGE* (FIND-PACKAGE "DNA"))
                          (SI:*LISP-MODE* :COMMON-LISP)
                          (*READTABLE* SYS:COMMON-LISP-READTABLE)
                          (SI:*READER-SYMBOL-SUBSTITUTIONS* SYS::*COMMON-LISP-SYMBOL-SUBSTITUTIONS*))
  (COMPILER#:PATCH-SOURCE-FILE "SYS: DECNET; ROUTE_DEBUG.#"


(defun EAVESDROP-ON-DECNET ()
  (without-interrupts
    (dna:disable)
    (setq *passive-nsp* t) 
    (unless (<= (length ethernet:*ethernet-protocols*) 1)
      (setq ethernet:*old-ethernet-protocols* ethernet:*ethernet-protocols*)
      (setq ethernet:*ethernet-protocols* nil))
    (ETHERNET:ADD-PROTOCOL DNA:*ROUTE-ETHERNET-TYPE* 'Routing-Receiver)
    (Send (Net:Select-Controller) :Set-Enet-Prm T)
    (dna:reset)
    )
  )

))

#!C
; From file ROUTE_DEBUG.LISP#> DECNET; SYS:
#10R DNA#:
(COMPILER-LET ((*PACKAGE* (FIND-PACKAGE "DNA"))
                          (SI:*LISP-MODE* :COMMON-LISP)
                          (*READTABLE* SYS:COMMON-LISP-READTABLE)
                          (SI:*READER-SYMBOL-SUBSTITUTIONS* SYS::*COMMON-LISP-SYMBOL-SUBSTITUTIONS*))
  (COMPILER#:PATCH-SOURCE-FILE "SYS: DECNET; ROUTE_DEBUG.#"


(defun STOP-EAVESDROPING ()
  (without-interrupts
    (unless (<= (length ethernet:*old-ethernet-protocols*) 1)
      (setq ethernet:*ethernet-protocols* ethernet:*old-ethernet-protocols*)	   
      (setq ethernet:*old-ethernet-protocols* nil))
    (Send (Net:Select-Controller) :Set-Enet-Prm Nil)
    (setq *passive-nsp* nil) 
    (dna:reset)
    (dna:disable)
    )
  )

))

#!C
; From file PEEKCH.LISP#> DECNET; SYS:
#10R DNA#:
(COMPILER-LET ((*PACKAGE* (FIND-PACKAGE "DNA"))
                          (SI:*LISP-MODE* :COMMON-LISP)
                          (*READTABLE* SYS:COMMON-LISP-READTABLE)
                          (SI:*READER-SYMBOL-SUBSTITUTIONS* SYS::*COMMON-LISP-SYMBOL-SUBSTITUTIONS*))
  (COMPILER#:PATCH-SOURCE-FILE "SYS: DECNET; PEEKCH.#"


(DEFUN CACHE-PEEK (IGNORE)
  (declare (special *mc-addr-list* new-list))
  (LIST NIL
	(TV:SCROLL-PARSE-ITEM
	  "DECnet ON-Ethernet Cache at "
	  `(:FUNCTION (lambda (&aux s m h)
			  (MULTIPLE-VALUE-SETQ (S M H) (GET-DECODED-TIME))
			  h)
		      () NIL ("~10,2,'0r:"))
          `(:FUNCTION (lambda (&aux s m h)
			  (MULTIPLE-VALUE-SETQ (S M H) (GET-DECODED-TIME))
			  m)
		      () NIL ("~10,2,'0r:"))	  
	  `(:FUNCTION (lambda (&aux s m h)
			  (MULTIPLE-VALUE-SETQ (S M H) (GET-DECODED-TIME))
			  s)
		      () NIL ("~10,2,'0r"))
	  )
	
	(TV:SCROLL-PARSE-ITEM "")

	(tv:scroll-parse-item
	  `(:string "")
	  `(:mouse-item
	     (nil :eval (progn
			  (if (member dna:all-routers *mc-addr-list*)
			      (setf *mc-addr-list* (remove dna:all-routers *mc-addr-list*))
			      (setf *mc-addr-list* (cons dna:all-routers *mc-addr-list*)))
			  (unless (first *mc-addr-list*) (setf *mc-addr-list* nil))
			  (Net:Send-All-Controllers :Set-Mc-Addr-List *Mc-Addr-List*)
			  (process-run-function "DNA reset" #'(lambda (&rest ignore) (dna:reset t t)))))
	     :function ,#'(lambda (&rest ignore)
			    (declare (special *mc-addr-list*))
			    (if (member dna:all-routers *mc-addr-list*)
				"    L" "NOT l"))
	     nil nil (" ~aistening for routers")))

	(tv:scroll-parse-item
	  `(:string "")
	  `(:mouse-item
	     (nil :eval (progn
			  (if (member dna:all-endnodes *mc-addr-list*)
			      (setf *mc-addr-list* (remove dna:all-endnodes *mc-addr-list*))
			      (setf *mc-addr-list* (cons dna:all-endnodes *mc-addr-list*)))
			  (unless (first *mc-addr-list*)
			    (setf *mc-addr-list* nil))
			  (Net:Send-All-Controllers :Set-Mc-Addr-List *Mc-Addr-List*)
			  (dna:reset t t)))
	     :function ,#'(lambda (&rest ignore)
			    (declare (special *mc-addr-list*))
			    (if (member dna:all-endnodes *mc-addr-list*)
				"    L" "NOT l"))
	     nil nil (" ~aistening for endnodes")))

	(TV:SCROLL-PARSE-ITEM "")

	(tv:scroll-parse-item
	  `(:FUNCTION (lambda ()
			(let ((address DNA:*DESIGNATED-ROUTER*))
			  (cond ((numberp address)
				 (or (map-node-to-name
				       (area    address)
				       (host-id address))
				     (format nil "~d.~d" (area address) (host-id address)))
				 )
				((stringp address)
				 address)
				((null address)
				 "<none>")
				(t address)
				)
			  )
			)
		      () NIL
		      (" Designated Router: ~6a")))
	
	(TV:SCROLL-PARSE-ITEM "")

	(TV:SCROLL-PARSE-ITEM
"     Name      Node ID    Last Hello  Hellos In   Blocksize   Timer    Type     Dst. Address")
	(TV:SCROLL-PARSE-ITEM
" ------------  -------    ----------  ---------   ---------   -----   -------   ------------")
	(TV:SCROLL-PARSE-ITEM "")

	(TV:SCROLL-MAINTAIN-LIST 
	  #'(lambda () DNA:*ON-ETHERNET-CACHE*)
	  #'DNA:CACHE-ITEM)))

))
