;;; -*- Mode: Common-Lisp; Package: User; Base: 10.; Patch-File: T -*-
;;; Written 08/28/87 14:40:56 by reiner,
;;; Reason: Fix for PMU server handling unknown hosts.  [SPR#6386]  Code Readers:  CW, LER
;;; while running on NOVEMBER from band LOD1
;;; With IO 3.33, PATHNAME 3.16, FILE 3.14, SYSTEM 3.78, METER 3.6, SERIAL 3.2, CHAOSNET 3.13,
;;;  ETHERNET 3.1, GC 3.16, IMAGEN 3.0, MAIL-DAEMON 3.2, NETWORK-SUPPORT 3.10, PROFILE 3.1,
;;;  SUGGESTIONS 3.3, UCL 3.3, ZWEI 3.17, STREAMER-TAPE 3.11, DEBUG-TOOLS 3.4, FONT-EDITOR 3.1,
;;;  GLOSSARY 3.0, INPUT-EDITOR 3.0, MAIL-READER 3.9, NAMESPACE-EDITOR 3.5, NVRAM 3.5,
;;;  TELNET 3.7, TV 3.21, NAMESPACE 3.9, COMPILER 3.31, PRINTER 3.3, SYSLOG 3.0, VT100 3.14,
;;;  IP 2.52, Experimental BUG 8.0, DECNET 1.26,  microcode 413, Band Name: 8/20+DECNET+ENET

#!C
; From file DECNET_SERVERS.LISP#> SYS; DECNET:
#10R DNA#:
(COMPILER-LET ((*PACKAGE* (FIND-PACKAGE "DNA"))
                          (SI:*LISP-MODE* :COMMON-LISP)
                          (*READTABLE* SYS:COMMON-LISP-READTABLE)
                          (SI:*READER-SYMBOL-SUBSTITUTIONS* SYS::*COMMON-LISP-SYMBOL-SUBSTITUTIONS*))
  (COMPILER#:PATCH-SOURCE-FILE "SYS: DECNET; DECNET_SERVERS.#"


(defun pmu-server-function ()
  (let (message server-object foreign-host text-line data-p)
    (unwind-protect
	(with-open-stream
	  (mail-stream (host:listen-for-connection-on-medium
			 :nsp-stream "PMU"
			 :stream-type :ascii-translating-character-stream))
	  (setq foreign-host (send mail-stream :foreign-host))
	  (IF (typep foreign-host 'net:host) 
	      (setq foreign-host (send foreign-host :name))
	      (setq foreign-host "UNKNOWN"))
	  (setq server-object (add-server-to-wholine mail-stream "MAIL"))
	  (setq message (allocate-resource 'mail:message))
	  (send message :line-out (format nil "~a ~a" "Date:" (time:print-current-time nil)))
	  (when (process-from-field mail-stream message foreign-host)
	    (multiple-value-bind (any-message-received any-message-error)
	      (process-to-field mail-stream message)
	      (if any-message-received
		  (when (process-subject-field mail-stream message)
		    (loop		                                  ;This is the text of the message.
		      (setq text-line (pmu-read mail-stream))
		      (when (eql (int-char 0) (aref text-line 0)) (return))
		      (setf data-p t)
		      (send message :line-out text-line))
		    (when data-p
		      (send message :force-output)
		      (mail:enqueue-message message)
		      (pmu-force-acknowledge mail-stream)
		      (pmu-end-session mail-stream any-message-error)))
	      (pmu-end-session mail-stream)))))
      (when server-object
	(send w:who-line-file-state-sheet :delete-server server-object))
      )))

))
