;;; -*- Mode: Common-Lisp; Package: User; Base: 10.; Patch-File: T -*-

;;;			      RESTRICTED RIGHTS LEGEND

;;;Use, duplication, or disclosure by the Government is subject to
;;;restrictions as set forth in subdivision (b)(3)(ii) of the Rights in
;;;Technical Data and Computer Software clause at 52.227-7013.
;;;
;;;			TEXAS INSTRUMENTS INCORPORATED.
;;;				 P.O. BOX 2909
;;;			      AUSTIN, TEXAS 78769
;;;				    MS 2151
;;;
;;; Copyright (C) 1987 Texas Instruments Incorporated. All rights reserved.

;;; Patch file for DECNET version 1.3
;;; Reason: Provide a 20 minute connection timeout for dap server. Code read by BRG, CRW.
;;; Written 07/08/87 11:19:42 by WALTON,
;;; while running on CHARLIE from band LODA
;;; With IO 3.22, PATHNAME 3.13, FILE 3.8, SYSTEM 3.41, METER 3.1, SERIAL 3.0, CHAOSNET 3.10,
;;;  ETHERNET 3.0, GC 3.7, IMAGEN 3.0, MAIL-DAEMON 3.1, NETWORK-SUPPORT 3.7, PROFILE 3.0,
;;;  SUGGESTIONS 3.3, UCL 3.0, ZWEI 3.6, STREAMER-TAPE 3.5, DEBUG-TOOLS 3.1, FONT-EDITOR 3.1,
;;;  GLOSSARY 3.0, INPUT-EDITOR 3.0, MAIL-READER 3.2, NAMESPACE-EDITOR 3.4, NVRAM 3.0,
;;;  TELNET 3.3, TV 3.5, NAMESPACE 3.7, COMPILER 3.12, PRINTER 3.1, SYSLOG 3.0, VT100 3.5,
;;;  IP 2.42, Experimental BUG 4.10, DECNET 1.1,  microcode 355, Band Name: Release 3.0 - 6/17+ip

#!C
; From file dap_server.LISP.NEWEST >REL3-DNA> SA:
#10R DNA#:
(COMPILER-LET ((*PACKAGE* (FIND-PACKAGE "DNA"))
	       (SI:*LISP-MODE* :COMMON-LISP)
	       (*READTABLE* SYS:COMMON-LISP-READTABLE)
	       (SI:*READER-SYMBOL-SUBSTITUTIONS* SYS::*COMMON-LISP-SYMBOL-SUBSTITUTIONS*))
  (COMPILER#:PATCH-SOURCE-FILE "SYS: DECNET; DAP_SERVER.#"
			       
			       
  (defun dap-server ()
    (let* ((port (host:listen-for-connection-on-medium
		   :nsp-stream "DAP"
		   :stream-type :port))
	   (who-line-obj (dap-add-server-to-wholine port))
	   wait-timeout-value)
      (accept-connection port)
      (unwind-protect
	  (condition-case (error-condition)
	      (let* ((dap-stream (make-instance 'dap-server-stream  :port port)))
		(send dap-stream :send-config-message)
		(send dap-stream :process-config-message)
		(loop
		  (catch 'server-start-over
		    (setq wait-timeout-value
			  (process-wait-with-timeout "DNA server wait" 72000.
						     #'(lambda (port) (or (send port :data-available-p)
									  (neq (send port :state) :Running)))
						     port))
		    (if wait-timeout-value
			(if (eq (send port :state) :running)
			    (send dap-stream :server-start-session)
			    (return nil))
			(return nil)))))
	    (error (server-notify-error error-condition)))
	(send who-line-obj :close))))
			       
  ))