;;; -*- Mode: Common-Lisp; Package: User; Base: 10.; Patch-File: T -*-
;;; Written 02/15/88 16:04:29 by nagase,
;;; Reason: Forwarding a message from Vax to Explorer loses text. - spr7248, nn.
;;;			      RESTRICTED RIGHTS LEGEND

;;;Use, duplication, or disclosure by the Government is subject to
;;;restrictions as set forth in subdivision (b)(3)(ii) of the Rights in
;;;Technical Data and Computer Software clause at 52.227-7013.
;;;
;;;			TEXAS INSTRUMENTS INCORPORATED.
;;;				 P.O. BOX 2909
;;;			      AUSTIN, TEXAS 78769
;;;				    MS 2151
;;;
;;; Copyright (C) 1988 Texas Instruments Incorporated. All rights reserved.

;;; while running on Foxtrot from band LOD2
;;; With IO 3.47, PATHNAME 3.17, FILE 3.16, SYSTEM 3.114, METER 3.7, SERIAL 3.2, CHAOSNET 3.25,
;;;  ETHERNET 3.4, GC 3.25, IMAGEN 3.0, MAIL-DAEMON 3.8, NETWORK-SUPPORT 3.21, PROFILE 3.7,
;;;  SUGGESTIONS 3.7, UCL 3.4, ZWEI 3.45, STREAMER-TAPE 3.20, DEBUG-TOOLS 3.7, FONT-EDITOR 3.2,
;;;  GLOSSARY 3.1, INPUT-EDITOR 3.0, MAIL-READER 3.23, NAMESPACE-EDITOR 3.7, NVRAM 3.6,
;;;  TELNET 3.8, TV 3.34, NAMESPACE 3.15, COMPILER 3.35, PRINTER 3.10, SYSLOG 3.1,
;;;  VT100 3.15, VISIDOC 1.0, IP 2.77, Experimental BUG 8.0, DECNET 1.29,  microcode 469,
;;;  Band Name: Release 3.2 - 11/12 +IP

#!C
; From file DECNET_SERVERS.LISP#> DECNET; VIRGO:
#10R DNA#:
(COMPILER-LET ((*PACKAGE* (FIND-PACKAGE "DNA"))
                          (SI:*LISP-MODE* :COMMON-LISP)
                          (*READTABLE* SYS:COMMON-LISP-READTABLE)
                          (SI:*READER-SYMBOL-SUBSTITUTIONS* SYS::*COMMON-LISP-SYMBOL-SUBSTITUTIONS*))
  (COMPILER#:PATCH-SOURCE-FILE "SYS: DECNET; DECNET_SERVERS.#"


(defun pmu-server-function ()
  (let (message server-object foreign-host text-line data-p)
    (unwind-protect
	(with-open-stream
	  (mail-stream (host:listen-for-connection-on-medium
			 :nsp-stream "PMU"
			 :stream-type :ascii-translating-character-stream))
	  (setq foreign-host (send mail-stream :foreign-host))
	  (IF (typep foreign-host 'net:host) 
	      (setq foreign-host (send foreign-host :name))
	      (setq foreign-host "UNKNOWN"))
	  (setq server-object (add-server-to-wholine mail-stream "MAIL"))
	  (setq message (allocate-resource 'mail:message))
	  (send message :line-out (format nil "~a ~a" "Date:" (time:print-current-time nil)))
	  (when (process-from-field mail-stream message foreign-host)
	    (multiple-value-bind (any-message-received any-message-error)
		(process-to-field mail-stream message)
	      (if any-message-received
		  (when (process-subject-field mail-stream message)
		    (block do-text
		      (loop		   ;This is the text of the message.
			(setq text-line (pmu-read mail-stream))
			(cond ((or (= (length text-line) 0)
				   (not (eql (aref text-line 0) (int-char 0))))
			       (setf data-p t)
			       (send message :line-out text-line))
			      (t
			       (return-from do-text)))))
		    (when data-p
		      (send message :force-output)
		      (mail:enqueue-message message)
		      (pmu-force-acknowledge mail-stream)
		      (pmu-end-session mail-stream any-message-error)))
		  (pmu-end-session mail-stream)))))
      (when server-object
	(send w:who-line-file-state-sheet :delete-server server-object))
      )))

))
