;;; -*- Mode: Common-Lisp; Package: User; Base: 10.; Patch-File: T -*-
;;; Written 03/04/88 10:51:44 by WALTON,
;;; Reason: Ensures the default host used for pathname merging is the local host.
;;; Code readers: LER, LAS, & CRW.
;;;			      RESTRICTED RIGHTS LEGEND

;;;Use, duplication, or disclosure by the Government is subject to
;;;restrictions as set forth in subdivision (b)(3)(ii) of the Rights in
;;;Technical Data and Computer Software clause at 52.227-7013.
;;;
;;;			TEXAS INSTRUMENTS INCORPORATED.
;;;				 P.O. BOX 2909
;;;			      AUSTIN, TEXAS 78769
;;;				    MS 2151
;;;
;;; Copyright (C) 1988 Texas Instruments Incorporated. All rights reserved.

;;; while running on CHARLIE from band LODA
;;; With IO 3.52, PATHNAME 3.17, FILE 3.19, SYSTEM 3.123, METER 3.7, SERIAL 3.2, CHAOSNET 3.30,
;;;  ETHERNET 3.4, GC 3.28, IMAGEN 3.0, MAIL-DAEMON 3.11, NETWORK-SUPPORT 3.24, PROFILE 3.9,
;;;  SUGGESTIONS 3.7, UCL 3.4, ZWEI 3.49, STREAMER-TAPE 3.22, DEBUG-TOOLS 3.7, FONT-EDITOR 3.2,
;;;  GLOSSARY 3.1, INPUT-EDITOR 3.0, MAIL-READER 3.27, NAMESPACE-EDITOR 3.8, NVRAM 3.8,
;;;  TELNET 3.8, TV 3.38, NAMESPACE 3.17, COMPILER 3.41, PRINTER 3.13, SYSLOG 3.2,
;;;  VT100 3.16, VISIDOC 1.2, IP 2.83, DECNET 1.30,  microcode 239, Band Name: Rel 3.2+IP 2/4

#!C
; From file DAP_SERVER.LISP#> DECNET; DECNET:
#10R DNA#:
(COMPILER-LET ((*PACKAGE* (FIND-PACKAGE "DNA"))
                          (SI:*LISP-MODE* :COMMON-LISP)
                          (*READTABLE* SYS:COMMON-LISP-READTABLE)
                          (SI:*READER-SYMBOL-SUBSTITUTIONS* SYS::*COMMON-LISP-SYMBOL-SUBSTITUTIONS*))
  (COMPILER#:PATCH-SOURCE-FILE "DECNET: DECNET; DAP_SERVER.#"


(defmethod (dap-server-stream :server-open) (filespec fac display datatype rfm rat create-p)
  (let* ((default (fs:make-pathname :defaults nil :host si:local-host
				    :type :LISP   :version :NEWEST))
	 (path (send self :decnet-parse-for-server filespec default)))
    (setf pathname path)
    (when path
	  (case (ldb (byte 2 0) fac)
		(#.fac-get (send self :server-open-for-output path display))
		(#.fac-put (send self :server-open-for-input path display datatype rfm rat create-p))
		(#.fac-put-and-get (send self :server-open-for-input path display datatype rfm rat create-p))
		(t (server-display "~% Unknown access option ~{~d~}." fac)
		   (send self :server-send-error  dap-format-error dap-access-message #o23))))))

))

#!C
; From file DAP_SERVER.LISP#> DECNET; DECNET:
#10R DNA#:
(COMPILER-LET ((*PACKAGE* (FIND-PACKAGE "DNA"))
                          (SI:*LISP-MODE* :COMMON-LISP)
                          (*READTABLE* SYS:COMMON-LISP-READTABLE)
                          (SI:*READER-SYMBOL-SUBSTITUTIONS* SYS::*COMMON-LISP-SYMBOL-SUBSTITUTIONS*))
  (COMPILER#:PATCH-SOURCE-FILE "DECNET: DECNET; DAP_SERVER.#"


(defmethod (dap-server-stream :server-rename) (filespec display)
  (let* ((default (fs:make-pathname :defaults nil :host si:local-host
				    :type :LISP   :version :NEWEST))
	 (path (send self :decnet-parse-for-server filespec default)))
    (when path
      (server-display "~% Rename called for ~a" path)
      (let* ((new-filespec (send self :process-name-message))
	     (new-path (send self :decnet-parse-for-server new-filespec path)))
	(when path
	  (multiple-value-bind (result orig-truename result-truename)
	      (fs:rename-file path new-path :error nil)
	    (if (or (errorp result)	   ;If error, THIRD arg is the error object! ICK!
		    (errorp orig-truename)
		    (errorp result-truename))
		(send self :server-map-error (cond ((errorp result) result)
						   ((errorp orig-truename) orig-truename)
						   ((errorp result-truename) result-truename)))
		(progn
		  (send self :process-display display orig-truename nil)
		  (send self :send-acknowledge-message)
		  (send self :process-display display result-truename nil)
		  (send self :send-acknowledge-message)
		  (send self :send-access-complete-message cmpfunc-response)))))))))

))

#!C
; From file DAP_SERVER.LISP#> DECNET; DECNET:
#10R DNA#:
(COMPILER-LET ((*PACKAGE* (FIND-PACKAGE "DNA"))
                          (SI:*LISP-MODE* :COMMON-LISP)
                          (*READTABLE* SYS:COMMON-LISP-READTABLE)
                          (SI:*READER-SYMBOL-SUBSTITUTIONS* SYS::*COMMON-LISP-SYMBOL-SUBSTITUTIONS*))
  (COMPILER#:PATCH-SOURCE-FILE "DECNET: DECNET; DAP_SERVER.#"


(defmethod (dap-server-stream :server-delete) (filespec display)
  (let* ((default (fs:make-pathname :defaults nil :host si:local-host
				    :type :LISP   :version :NEWEST))
	 (path (send self :decnet-parse-for-server filespec default)))
	     (when path
	       (server-display "~% Delete called for ~a" path)
	       (let ((result (send path :delete-and-expunge nil)))
		 (if (errorp result)		       
		     (send self :server-map-error result)
		     (progn
		       (send self :process-display display path nil))
		       (send self :send-acknowledge-message)
		       (send self :send-access-complete-message cmpfunc-response ))))))

))

#!C
; From file DAP_SERVER.LISP#> DECNET; DECNET:
#10R DNA#:
(COMPILER-LET ((*PACKAGE* (FIND-PACKAGE "DNA"))
                          (SI:*LISP-MODE* :COMMON-LISP)
                          (*READTABLE* SYS:COMMON-LISP-READTABLE)
                          (SI:*READER-SYMBOL-SUBSTITUTIONS* SYS::*COMMON-LISP-SYMBOL-SUBSTITUTIONS*))
  (COMPILER#:PATCH-SOURCE-FILE "DECNET: DECNET; DAP_SERVER.#"


(defmethod (dap-server-stream :server-directory-list) (filespec display)
  (let* ((default (fs:make-pathname :defaults nil :host si:local-host
				    :type :LISP   :version :NEWEST))
	 (path (send self :decnet-parse-for-server filespec default)))
    (when path
      (server-display "~% Directory-list called for ~a" path)
      (send self :send-name-message volname-nametype "")
      (send self :send-name-message dirname-nametype (send path :string-for-directory))
      (let ((pathname-list (send path :directory-list '(:noerror))))
	(if (not (eql (type-of pathname-list) 'cons))
	    (send self :server-map-error pathname-list)
	    (dolist (element (cdr pathname-list))
	      (send self :send-name-message filename-nametype (send (car element) :string-for-dired))
	      
	      (when (test-display-for-main-attributes display)
		(server-display "~%Dired main attributes message")
		(let* ((bls 1024.)
		       (bsz (or (get (locf (cdr element)) :byte-size) 8))
		       (ebk (or (get (locf (cdr element)) :length-in-blocks) 0))
		       (ffb (or (- (* bls ebk) (or (get (locf (cdr element)) :length-in-bytes) 0)))))
		  (send self :send-attributes-message (if (get (locf (cdr element)) :characters)
							  ascii-data image-data)
			                              0 nil nil bls nil ebk nil nil nil
						      nil nil 
						      (if (get (locf (cdr element)) :directory)
							  '(5 7) nil)
						      bsz nil nil nil ebk ebk ffb)))
	      
	      (when (test-display-for-key-definition display)
		(server-display "~%Dired key definition attributes message")
		(send self :send-key-definition-attributes))
	      
	      (when (test-display-for-allocation display)
		(server-display "~%Dired allocation attributes message")
		(send self :send-allocation-attributes))
	      
	      (when (test-display-for-summary display) 
		(server-display "~%Dired summary attributes message")
		(send self :send-summary-attributes))
	      
	      (when (test-display-for-date-and-time display)
		(server-display "~%Dired date-and-time attributes message")
		(send self :send-date-time-attributes (get (locf (cdr element)) :creation-date)))
	      (when (test-display-for-protection display)
		
		(server-display "~%Dired protection attributes message")
		(send self :send-protection-attributes (get (locf (cdr element)) :author)))
	      
	      (send self :send-acknowledge-message nil))
	    )))
    (send self :send-access-complete-message cmpfunc-response)))

))
