;;; -*- Mode: Common-Lisp; Package: User; Base: 10.; Patch-File: T -*-

;;; Reason: *LOAD-THIS-PATCH-IFF-EXPLORER4.0*.
;;; Removes CTERM's reference to the LED-Pane and LED-Lights-List
;;; which are no longer in the system. 
;;; Needed on an Explorer System REL4.0 or greater version.
;;;			      RESTRICTED RIGHTS LEGEND

;;;Use, duplication, or disclosure by the Government is subject to
;;;restrictions as set forth in subdivision (b)(3)(ii) of the Rights in
;;;Technical Data and Computer Software clause at 52.227-7013.
;;;
;;;			TEXAS INSTRUMENTS INCORPORATED.
;;;				 P.O. BOX 2909
;;;			      AUSTIN, TEXAS 78769
;;;				    MS 2151
;;;
;;; Copyright (C) 1988 Texas Instruments Incorporated. All rights reserved.

;;; Patch file for DECNET version 1.32
;;; Written 03/10/88 14:30:39 by WALTON,
;;; while running on CHARLIE from band LODA
;;; With Experimental SYSTEM 4.34, Experimental VIRTUAL-MEMORY 4.0, Experimental EH 4.0,
;;;  Experimental MAKE-SYSTEM 4.1, Experimental MICRONET 4.3, Experimental LOCAL-FILE 4.0,
;;;  Experimental BASIC-PATHNAME 4.3, Experimental DISK-IO 4.1, Experimental DISK-LABEL 4.0,
;;;  Experimental BASIC-FILE 4.1, Experimental MAC-PATHNAME 4.0, Experimental NETWORK-PATHNAME 4.0,
;;;  Experimental COMPILER 4.1, Experimental NETWORK-NAMESPACE 4.3, Experimental TV 4.42,
;;;  Experimental DATALINK 4.10, Experimental CHAOSNET 4.4, Experimental GC 4.2, Experimental MEMORY-AUX 4.0,
;;;  Experimental NVRAM 4.3, Experimental SYSLOG 4.0, Experimental STREAMER-TAPE 4.1,
;;;  Experimental UCL 4.1, Experimental INPUT-EDITOR 4.0, Experimental METER 4.3,
;;;  Experimental ZWEI 4.11, Experimental DEBUG-TOOLS 4.0, Experimental NETWORK-SUPPORT 4.1,
;;;  Experimental NETWORK-SERVICE 4.0, Experimental DATALINK-DISPLAYS 4.0, Experimental FONT-EDITOR 4.0,
;;;  Experimental SERIAL 4.0, Experimental PRINTER 4.2, Experimental PRINTER-TYPES 4.0,
;;;  Experimental IMAGEN 4.0, Experimental SUGGESTIONS 4.0, Experimental MAIL-DAEMON 4.0,
;;;  Experimental MAIL-READER 4.4, Experimental TELNET 4.0, Experimental VT100 4.3,
;;;  Experimental NAMESPACE-EDITOR 4.2, Experimental PROFILE 4.0, Experimental VISIDOC 4.0,
;;;  Experimental NAMESPACE 4.7, Experimental BUG 11.0, Experimental IP 3.0, DECNET 1.31,
;;;   microcode 289, Band Name: REL4+DECnet 3/9

#!C
; From file CTERMINAL.LISP#> DECNET; DECNET:
#10R DNA#:
(COMPILER-LET ((*PACKAGE* (FIND-PACKAGE "DNA"))
                          (SI:*LISP-MODE* :COMMON-LISP)
                          (*READTABLE* SYS:COMMON-LISP-READTABLE)
                          (SI:*READER-SYMBOL-SUBSTITUTIONS* SYS::*COMMON-LISP-SYMBOL-SUBSTITUTIONS*))
  (COMPILER#:PATCH-SOURCE-FILE "DECNET: DECNET; CTERMINAL.#"

(defmethod (CTERM-TERMINAL-WINDOW :after :init) (&rest ignore)
   "Creates the terminal's stream and process and enables the terminal."
   (let ((label nil))
     (without-interrupts        
       (incf *number-of-cterminals*)
       (setf label (format nil "CTERM Terminal ~d" *number-of-cterminals*)) ; Create the terminal's name	
       (setf stream (dna:make-cterm-stream))			 ; Create the stream object
       (send stream :set-window self)
       (setf sys:process					 ; Create the terminal process
	      (make-process label
			        :sg-area *DECnet-area*
			        :special-pdl-size 2048
				:regular-pdl-size 4096
				:priority 0))
       (send self :clear-screen)
       (send self :clear-input)
       (send self :set-label label)
       (setf telnet:vt100-pane self)				 ; Make  
       ;(setf telnet:led-pane self)				 ; VT100
       (send self :initial-setup)				 ; happy.
       (setf telnet:new-line
	      (+ 2 (w:font-char-height w:current-font)))
       (send sys:process
	       :preset #'terminal-processor self)   	         ; Preset the processor.
       (process-enable sys:process)))			         ; Enable the new terminal
   )

))
#!C
; From file CTERMINAL.LISP#> DECNET; DECNET:
#10R DNA#:
(COMPILER-LET ((*PACKAGE* (FIND-PACKAGE "DNA"))
                          (SI:*LISP-MODE* :COMMON-LISP)
                          (*READTABLE* SYS:COMMON-LISP-READTABLE)
                          (SI:*READER-SYMBOL-SUBSTITUTIONS* SYS::*COMMON-LISP-SYMBOL-SUBSTITUTIONS*))
  (COMPILER#:PATCH-SOURCE-FILE "DECNET: DECNET; CTERMINAL.#"


(DEFMETHOD (CTERM-TERMINAL-WINDOW :PROCESS-ESCAPE-BRACKET-NUMERIC-SEQUENCE) (CH)
  ; The order of the cond tests is important!
  (COND
    ((= CH #\m)				   ; ESC [ 0 m   ESC [ 1 m   ESC [ 4 m   ESC [ 5 m   ESC [ 7 m
     (SEND SELF :HANDLE-CHARACTER-ATTRIBUTES))
    (telnet:ESCAPE-BRACKET-NUMERIC-SEMICOLON-FLAG
     (SEND SELF :PROCESS-ESCAPE-BRACKET-NUMERIC-SEMICOLON-NUMERIC-SEQUENCE CH))
    ((= CH #\q)				   ; ESC [ num q  sequences
					    ;turn on the led that matches var ESCAPE-BRACKET-NUMERIC-CH
     ;(SETQ telnet:LED-LIGHTS-LIST (CONS telnet:ESCAPE-BRACKET-NUMERIC-CH telnet:LED-LIGHTS-LIST))
     ;(SEND telnet:LED-PANE :CHANGE-LED telnet:LED-LIGHTS-LIST)
     (SEND SELF :RESET))
    (telnet:ESCAPE-BRACKET-NUMERIC-NUMERIC-FLAG
     (SEND SELF :PROCESS-ESCAPE-BRACKET-NUMERIC-NUMERIC-SEQUENCE CH))
    ((AND (>= CH #\A) (<= CH #\Z))	   ;Do we have an up letter?
     (SEND SELF :PROCESS-ESCAPE-BRACKET-NUMERIC-UP-LETTER-SEQUENCE CH))
    ((= CH #\;)				   ; ESC [ num ;
     (SETQ telnet:ESCAPE-BRACKET-NUMERIC-SEMICOLON-FLAG T))
    ((AND (>= CH #\0) (<= CH #\9))	   ;Do we have a digit?
     (SETQ telnet:STARTING-LINE-SECOND-CH CH)
     (SETQ telnet:STARTING-LINE-COMPLETED-VALUE (MAKE-TWO-DIGIT-VALUE telnet:STARTING-LINE CH))
     (SETQ telnet:ESCAPE-BRACKET-NUMERIC-NUMERIC-FLAG T))
    ((= CH #\c)				   ; ESC [ num c
					   ;What kind of terminal are you ?  Response is VT100 with NO options.
     (SEND SELF :WHAT-ARE-YOU) (SEND SELF :RESET))
    ((= CH #\n)				   ; ESC [ 5 n   ESC [ 6 n
					   ; Status report or Cursor position report
     (COND
       ((= telnet:ESCAPE-BRACKET-NUMERIC-CH #\5)  
	(SEND SELF :STATUS-REPORT)(SEND SELF :RESET))
       ((= telnet:ESCAPE-BRACKET-NUMERIC-CH #\6)  
	(SEND SELF :CURSOR-POSITION-REPORT) (SEND SELF :RESET))))
    ((= CH #\g)				   ; ESC [ num g
     (SEND SELF :PROCESS-ESCAPE-BRACKET-NUMERIC-DOWN-LETTER-SEQUENCE CH))
    (T (SEND SELF :RESET))))

))






