;;; -*- Mode: Common-Lisp; Package: User; Base: 10.; Patch-File: T -*-
;;; Written 04/22/88 13:52:47 by nagase,
;;; Reason: Add default PMU access to VMS by defining "mailer" account. To effect this,
;;; the network manager must set up this account usr/pwd "mailer/mailer" with
;;; only inbound access with no other privileges.  -- spr7367 nn/cw
;;;			      RESTRICTED RIGHTS LEGEND

;;;Use, duplication, or disclosure by the Government is subject to
;;;restrictions as set forth in subdivision (b)(3)(ii) of the Rights in
;;;Technical Data and Computer Software clause at 52.227-7013.
;;;
;;;			TEXAS INSTRUMENTS INCORPORATED.
;;;				 P.O. BOX 2909
;;;			      AUSTIN, TEXAS 78769
;;;				    MS 2151
;;;
;;; Copyright (C) 1988 Texas Instruments Incorporated. All rights reserved.

;;; while running on Foxtrot from band LOD3
;;; With IO 3.47, PATHNAME 3.17, FILE 3.16, SYSTEM 3.114, METER 3.7, SERIAL 3.2, CHAOSNET 3.25,
;;;  ETHERNET 3.4, GC 3.25, IMAGEN 3.0, MAIL-DAEMON 3.8, NETWORK-SUPPORT 3.21, PROFILE 3.7,
;;;  SUGGESTIONS 3.7, UCL 3.4, ZWEI 3.45, STREAMER-TAPE 3.20, DEBUG-TOOLS 3.7, FONT-EDITOR 3.2,
;;;  GLOSSARY 3.1, INPUT-EDITOR 3.0, MAIL-READER 3.23, NAMESPACE-EDITOR 3.7, NVRAM 3.6,
;;;  TELNET 3.8, TV 3.34, NAMESPACE 3.15, COMPILER 3.35, PRINTER 3.10, SYSLOG 3.1,
;;;  VT100 3.15, VISIDOC 1.0, IP 2.77, Experimental BUG 8.0, DECNET 1.31,  microcode 469,
;;;  Band Name: Rel 3.2 - 11/12 ip+decnet

#!C
; From file DECNET_SERVERS.LISP#> DECNET; MR-X:
#10R DNA#:
(COMPILER-LET ((*PACKAGE* (FIND-PACKAGE "DNA"))
                          (SI:*LISP-MODE* :COMMON-LISP)
                          (*READTABLE* SYS:COMMON-LISP-READTABLE)
                          (SI:*READER-SYMBOL-SUBSTITUTIONS* SYS::*COMMON-LISP-SYMBOL-SUBSTITUTIONS*))
  (COMPILER#:PATCH-SOURCE-FILE "SYS: DECNET; DECNET_SERVERS.#"


(defmethod (pmu-service :deliver) (host-queue host &optional error-p
				   (medium :byte-stream) (contact-name "PMU"))
  (let ((userid "mailer")
	(password "mailer"))
    (with-open-stream (stream (host:open-connection-on-medium host medium contact-name
							      :stream-type :ascii-translating-character-stream
							      :error error-p
							      :timeout *pmu-connect-timeout*
							      :user-id userid :password password))
      (if (errorp stream)
	  stream
	  (pmu-mail-client host stream host-queue)))))

(defun clean-up-transmission (stream &optional (any-error-p nil))
  (send-zero-message stream)
  (let ((returned-value (char-int (send stream :tyi))))
    (when (eql returned-value #x01)
      (dotimes (i 2) (send stream :tyi))                    ; Use up rest of this message; and get acknowledge.
      (unless any-error-p (send stream :tyi)))))

))
