;;; -*- Mode: Common-Lisp; Package: User; Base: 10.; Patch-File: T -*-
;;; Patch file for DECNET version 1.38
;;; Reason: Check for old EtherTalk driver software on microExplorer.
;;; Prevent packet-still-in-use problem.  cw/ab 9/27/88.
;;; Written 09/27/88 17:04:19 by ab,
;;; while running on MX6 from band N923
;;; With SYSTEM 5.8, GC 5.1, VIRTUAL-MEMORY 5.4, MICRONET 5.2, MICRONET-COMM 5.3,
;;;  DISK-IO 5.1, BASIC-PATHNAME 5.1, MAC-PATHNAME 5.0, NETWORK-SUPPORT-COLD 5.0,
;;;  BASIC-NAMESPACE 5.1, BASIC-FILE 5.3, RPC 5.4, Experimental NFS 5.9, EH 5.1, MAKE-SYSTEM 5.0,
;;;  MEMORY-AUX 5.0, COMPILER 5.0, TV 5.1, NVRAM 5.0, UCL 5.0, INPUT-EDITOR 5.0, METER 5.0,
;;;  ZWEI 5.4, DEBUG-TOOLS 5.0, WINDOW-MX 5.11, Experimental NETWORK-PATHNAME 5.0,
;;;  Experimental NETWORK-NAMESPACE 5.0, DATALINK 5.3, CHAOSNET 5.3, Experimental NETWORK-SUPPORT 5.0,
;;;  Experimental NETWORK-SERVICE 5.0, DATALINK-DISPLAYS 5.0, Experimental NAMESPACE-EDITOR 5.1,
;;;  IP 3.28, Experimental NFS-SERVER 5.3, PRINTER 5.2, MAIL-DAEMON 5.0, MAIL-READER 5.0,
;;;  TELNET 5.0, VT100 5.0, DECNET 1.37, VISIDOC 5.2, PROFILE 5.0, PRINTER-TYPES 5.0,
;;;  IMAGEN 5.1, STREAMER-TAPE 5.0, Experimental MACTOOLBOX 1.0,  microcode 87, Band Name: mX Network (9-23)

#!C
; From file ROUTING.LISP#> DECNET; MR-X:
#10R DNA#:
(COMPILER-LET ((*PACKAGE* (FIND-PACKAGE "DNA"))
                          (SI:*LISP-MODE* :COMMON-LISP)
                          (*READTABLE* SYS:COMMON-LISP-READTABLE)
                          (SI:*READER-SYMBOL-SUBSTITUTIONS* SYS::*COMMON-LISP-SYMBOL-SUBSTITUTIONS*))
  (COMPILER#:PATCH-SOURCE-FILE "sys: DECNET; ROUTING.#"

(DELETE-INITIALIZATION "Stop DECnet"  :before-cold)    ;;cw 9/27/88
(ADD-INITIALIZATION "Stop DECnet"  '(dna:disable) nil 'net:*NETWORK-BEFORE-COLD-INITIALIZATION-LIST*)       ;;cw 9/27/88

;;cw 9/27/88.  Check for old Ethertalk software on microExplorer.
(defun ROUTING-RESET (&key (enable t) (hard t))
  "Put the DECnet module into a (hopefully) runnable state.  Note that this host's ETHERNET
    address may change if this is the first time that the machine was reset with DECnet installed."
  (LET* ((newdriverp t)
	(c (CAR net:controller-list))
	(enable-p (SEND c :enabled)))
    (dna:disable)
    (dna:reset-on-ethernet-cache)
    (dna:reset-node-counters)
    (WHEN (si:mx-p)
      (SEND c :disable)
      (send c :set-eaddr (+ hiord_16 (net:swap-bytes my-address)))
      (send c :close)
      (SEND c :initialize)
      (WHEN enable-p
	(SEND c :enable))
      (setf newdriverp       
	    (equalp (send c :read-eadr)
		    (send c :read-rom-id))))
    (if newdriverp
	(progn
	  (dna:setup-my-address)	   ;possibly obsolete ethernet address
	  (if hard
	      (progn
		(ethernet:add-protocol dna:*ROUTE-ETHERNET-TYPE* 'Routing-Receiver)
		(Ethernet:Add-Net-Packet-Allocator
		  dna:*ROUTE-ETHERNET-TYPE* 'CHAOS::ALLOCATE-INT-PKT 'CHAOS::FREE-INT-PKT)
		(net:reset-packets)
		(setf *ROUTING-HANDLER* (make-instance 'routing-handler))
		(net:send-all-controllers :disable)  ;need to permanently flush old controllers using...
		(Dolist (Cont Net:Controller-List)
		  (Setup-Ethernet-Address Cont))
		(ethernet:reset-address-translations) ;force rebroadcasts of our (new) ethernet address
		(net:send-all-controllers :reset)
		(net:send-all-controllers :enable))	
	      (send *routing-handler* :reset))
	  (when (and my-address (not (eql 0 my-address)))
	    (set-host-addresses)
	    (reset-hello-xmitter))
	  (when enable
	    (dna:enable))
	  )
	(tv:notify nil " *** WARNING ***   Unable to initialize or reset DECnet. ~%          You must first install EtherTalk version 1.1")
	)
    ))
))
