;;; -*- Mode: Common-Lisp; Package: DNA; Base: 10.; Patch-File: T -*-

;;; Reason: Fixed DAP-CONNECT.  If sc-establish-connection fails port will be nil. The code was attempting to close port, hence the error "Function NIL is undefined...".

;;;                           RESTRICTED RIGHTS LEGEND
;;;
;;; Use, duplication, or disclosure by the Government is subject to
;;; restrictions as set forth in subdivision (c)(1)(ii) of the Rights in
;;; Technical Data and Computer Software clause at 52.227-7013.
;;;
;;;   TEXAS INSTRUMENTS INCORPORATED      
;;;   P.O. BOX 2909, M/S 2151             
;;;   AUSTIN, TEXAS 78769                 
;;;
;;; Copyright (C) 1988 Texas Instruments Incorporated.
;;; All rights reserved.

;;; Written 10/27/88 08:11:56 by BERGER,
;;; while running on ARIES from band LODX
;;; With SYSTEM 5.8, VIRTUAL-MEMORY 5.4, EH 5.1, MICRONET 5.2, LOCAL-FILE 5.0, BASIC-PATHNAME 5.1,
;;;  NETWORK-SUPPORT-COLD 5.0, BASIC-NAMESPACE 5.1, NETWORK-NAMESPACE 5.0, DISK-IO 5.1,
;;;  DISK-LABEL 5.0, BASIC-FILE 5.3, MAC-PATHNAME 5.0, NETWORK-PATHNAME 5.0, COMPILER 5.0,
;;;  MAKE-SYSTEM 5.0, TV 5.1, DATALINK 5.4, CHAOSNET 5.3, GC 5.1, MEMORY-AUX 5.0,
;;;  NVRAM 5.0, SYSLOG 5.0, STREAMER-TAPE 5.0, UCL 5.0, INPUT-EDITOR 5.0, METER 5.0,
;;;  ZWEI 5.4, DEBUG-TOOLS 5.0, NETWORK-SUPPORT 5.0, NETWORK-SERVICE 5.0, DATALINK-DISPLAYS 5.0,
;;;  FONT-EDITOR 5.0, SERIAL 5.0, PRINTER 5.3, PRINTER-TYPES 5.1, IMAGEN 5.1, SUGGESTIONS 5.0,
;;;  MAIL-DAEMON 5.0, MAIL-READER 5.0, TELNET 5.0, VT100 5.0, Experimental NAMESPACE-EDITOR 5.1,
;;;  PROFILE 5.0, VISIDOC 5.2, Experimental BUG 10.2, IP 3.28, VISIDOC-SERVER 5.2,
;;;  DECNET 1.38,  microcode 398, Band Name: Pre 5.0 +1p 9/23 +visidoc

#!C
; From file DAP_INTERFACE.LISP#> DECNET; SYS:
#10R DNA#:
(COMPILER-LET ((*PACKAGE* (FIND-PACKAGE "DNA"))
                          (SI:*LISP-MODE* :COMMON-LISP)
                          (*READTABLE* SYS:COMMON-LISP-READTABLE)
                          (SI:*READER-SYMBOL-SUBSTITUTIONS* SYS::*COMMON-LISP-SYMBOL-SUBSTITUTIONS*))
  (COMPILER#:PATCH-SOURCE-FILE "SYS: DECNET; DAP_INTERFACE.#"


(defun dap-connect (dstnode &key userid password accounting)
  (let ((nbytes 3)(src-format 2)
	(port (reuse-port dstnode)) (send-config-msg nil))
    (unless port
      (loop 
	(setf port (sc-establish-connection :dstnode dstnode :nbytes nbytes
			 :format src-format :usrcode 0 :grpcode 0 :descrpt userid
			 :userid userid :password password :accounting accounting
			 :objtype dap-connect-objtype))
	(if (not (eql (send port :STATE) :RUNNING))
	    (progn
	      (when port (send port :close))  ;10-27-88 DAB If sc-establish-connection fails port will be nil.
	      (setf port nil)
	      (decnet-signal-error 'dna-connect-error "failed to connect"
				   (send (si:get-host-from-address dstnode :dna) :name) t t))
	    (progn
	      (setf send-config-msg t)
	      (setf (send port :who-line-state) "DAP Connect")
	      (return)))))
    (values port send-config-msg)))
))
