;;; -*- Mode: Common-Lisp; Package: User; Base: 10.; Patch-File: T -*-
;;; Written 11/11/88 18:06:47 by ab,
;;; Reason: Fix problem where multicast addresses were not being set up until after the user
;;; toggled one of the Peek monitors.   11/11/88.
;;; while running on MX6 from band test
;;; With SYSTEM 5.17, GC 5.3, VIRTUAL-MEMORY 5.5, MICRONET 5.5, MICRONET-COMM 5.13,
;;;  DISK-IO 5.9, BASIC-PATHNAME 5.2, MAC-PATHNAME 5.0, NETWORK-SUPPORT-COLD 5.1,
;;;  BASIC-NAMESPACE 5.5, BASIC-FILE 5.3, RPC 5.4, NFS 5.8, EH 5.2, MAKE-SYSTEM 5.1,
;;;  MEMORY-AUX 5.1, MACTOOLBOX 1.23, COMPILER 5.1, TV 5.17, NVRAM 5.1, UCL 5.0, INPUT-EDITOR 5.0,
;;;  METER 5.0, ZWEI 5.8, DEBUG-TOOLS 5.0, WINDOW-MX 5.24, PRINTER 5.10, MAC-PRINTER-TYPES 5.2,
;;;  NETWORK-PATHNAME 5.0, NETWORK-NAMESPACE 5.0, DATALINK 5.7, CHAOSNET 5.6, NETWORK-SUPPORT 5.0,
;;;  NETWORK-SERVICE 5.0, DATALINK-DISPLAYS 5.0, NAMESPACE-EDITOR 5.1, IP 3.31, NFS-SERVER 5.3,
;;;  PRINTER-TYPES 5.2, IMAGEN 5.1, MAIL-DAEMON 5.1, MAIL-READER 5.3, TELNET 5.1,
;;;  VT100 5.0, STREAMER-TAPE 5.6, DECNET 1.39, VISIDOC 5.4, PROFILE 5.1, DISK-LABEL 5.1,
;;;   microcode 96, Band Name: test

#!C
; From file ROUTING.LISP#> DECNET; MR-X:
#10R DNA#:
(COMPILER-LET ((*PACKAGE* (FIND-PACKAGE "DNA"))
                          (SI:*LISP-MODE* :COMMON-LISP)
                          (*READTABLE* SYS:COMMON-LISP-READTABLE)
                          (SI:*READER-SYMBOL-SUBSTITUTIONS* SYS::*COMMON-LISP-SYMBOL-SUBSTITUTIONS*))
  (COMPILER#:PATCH-SOURCE-FILE "sys: DECNET; ROUTING.#"

;;ab New 11/11/88.  
(DEFUN setup-multicast-addresses ()
  (DOLIST (controller net:controller-list)
    (LET ((current-list (COPY-LIST (SEND controller :mc-addr-list))))
      (DOLIST (address *mc-addr-list*)
	(UNLESS (MEMBER address current-list)
	  (PUSH address current-list)))
      (WITHOUT-INTERRUPTS 
	(SETF (SYMEVAL-IN-INSTANCE controller 'ethernet:mc-addr-list) current-list)))
    (SEND controller :mc-setup))
  )

;;cw 9/27/88.  Check for old Ethertalk software on microExplorer.
;;ab 11/11/88. Run setup for multicast addresses on each routing reset.  Previously
;;             the controller's mc-addr-list slot was not being set up until you ran
;;             one of the Peek monitors.
(defun ROUTING-RESET (&key (enable t) (hard t))
  "Put the DECnet module into a (hopefully) runnable state.  Note that this host's ETHERNET
    address may change if this is the first time that the machine was reset with DECnet installed."
  (when net:controller-list
    (LET* ((newdriverp t)
	   (c (CAR net:controller-list))
	   (enable-p (SEND c :enabled)))
      (dna:disable)
      (dna:reset-on-ethernet-cache)
      (dna:reset-node-counters)
      (WHEN (si:mx-p)
	(SEND c :disable)
	(send c :set-eaddr (+ hiord_16 (net:swap-bytes my-address)))
	(send c :close)
	(SEND c :initialize)
	(WHEN enable-p
	  (SEND c :enable))
	(setf newdriverp       
	      (equalp (send c :read-eadr)
		      (send c :read-rom-id))))
      (if newdriverp
	  (progn
	    (dna:setup-my-address)		       ;possibly obsolete ethernet address
	    (if hard
		(progn
		  (ethernet:add-protocol dna:*ROUTE-ETHERNET-TYPE* 'Routing-Receiver)
		  (Ethernet:Add-Net-Packet-Allocator
		    dna:*ROUTE-ETHERNET-TYPE* 'CHAOS::ALLOCATE-INT-PKT 'CHAOS::FREE-INT-PKT)
		  (net:reset-packets)
		  (setf *ROUTING-HANDLER* (make-instance 'routing-handler))
		  (net:send-all-controllers :disable)  ;need to permanently flush old controllers using...
		  (Dolist (Cont Net:Controller-List)
		    (Setup-Ethernet-Address Cont))
		  (ethernet:reset-address-translations)	       ;force rebroadcasts of our (new) ethernet address
		  (net:send-all-controllers :reset)
		  (net:send-all-controllers :enable))	
		(send *routing-handler* :reset))
	    (when (and my-address (not (eql 0 my-address)))
	      (set-host-addresses)
	      (reset-hello-xmitter))
	    (when enable
	      (dna:enable))
	    (setup-multicast-addresses)		       ;ab 11/11/88
	    )
	  (tv:notify nil " *** WARNING ***   Unable to initialize or reset DECnet. ~%          You must first install EtherTalk version 1.1")
	  )
      )))

(dna:reset t)
))
