;;; -*- Mode: Common-Lisp; Package: DNA; Base: 10.; Patch-File: T -*-
;;; Written 11/16/88 08:28:22 by BERGER,
;;; Reason: Added :device to most of the pathname defualts. Also fixed :parse-pathname-for-server to handle mac pathname properly for server-directory-list.
;;; 	
;;; while running on MX29 from band NA27
;;; With SYSTEM 5.19, GC 5.3, VIRTUAL-MEMORY 5.5, MICRONET 5.5, MICRONET-COMM 5.13,
;;;  DISK-IO 5.9, BASIC-PATHNAME 5.2, MAC-PATHNAME 5.0, NETWORK-SUPPORT-COLD 5.1,
;;;  BASIC-NAMESPACE 5.5, BASIC-FILE 5.3, RPC 5.4, NFS 5.8, EH 5.2, MAKE-SYSTEM 5.1,
;;;  MEMORY-AUX 5.1, MACTOOLBOX 1.24, COMPILER 5.1, TV 5.17, NVRAM 5.1, UCL 5.0, INPUT-EDITOR 5.0,
;;;  METER 5.0, ZWEI 5.8, DEBUG-TOOLS 5.0, WINDOW-MX 5.24, PRINTER 5.11, MAC-PRINTER-TYPES 5.3,
;;;  NETWORK-PATHNAME 5.0, NETWORK-NAMESPACE 5.0, DATALINK 5.7, CHAOSNET 5.6, NETWORK-SUPPORT 5.0,
;;;  NETWORK-SERVICE 5.0, DATALINK-DISPLAYS 5.0, NAMESPACE-EDITOR 5.1, IP 3.33, NFS-SERVER 5.3,
;;;  PRINTER-TYPES 5.2, IMAGEN 5.1, MAIL-DAEMON 5.1, MAIL-READER 5.3, TELNET 5.1,
;;;  VT100 5.0, STREAMER-TAPE 5.6, DECNET 1.42, VISIDOC 5.4, PROFILE 5.1, DISK-LABEL 5.1,
;;;   microcode 96, Band Name: microExplorer Network (10/27)

#!C
; From file DAP_SERVER.LISP#> decnet; sys:
#10R DNA#:
(COMPILER-LET ((*PACKAGE* (FIND-PACKAGE "DNA"))
                          (SI:*LISP-MODE* :COMMON-LISP)
                          (*READTABLE* SYS:COMMON-LISP-READTABLE)
                          (SI:*READER-SYMBOL-SUBSTITUTIONS* SYS::*COMMON-LISP-SYMBOL-SUBSTITUTIONS*))
  (COMPILER#:PATCH-SOURCE-FILE "sys: decnet; DAP_SERVER.#"

(defparameter dap-local-host-pathname (fs:make-pathname :defaults nil
							:host si:local-host
							:device (SEND si:local-host :default-device)  ;11-15-88 DAB
							:type :lisp
							:version :NEWEST))
(defparameter dap-local-dir-pathname
	      (fs:make-pathname :host si:local-host :device (SEND si:local-host :default-device) 
				:directory :wild :type :wild :version :wild :name :wild))

(defmethod (dap-server-stream :server-open) (filespec fac display datatype rfm rat create-p)
  (let* ((default (fs:make-pathname :defaults nil :host si:local-host :device (SEND si:local-host :default-device)
				    :type :unspecific   :version :NEWEST))
	 (path (send self :decnet-parse-for-server filespec default)))
    (setf pathname path)
    (when path
	  (case (ldb (byte 2 0) fac)
		(#.fac-get (send self :server-open-for-output path display))
		(#.fac-put (send self :server-open-for-input path display datatype rfm rat create-p))
		(#.fac-put-and-get (send self :server-open-for-input path display datatype rfm rat create-p))
		(t (server-display "~% Unknown access option ~{~d~}." fac)
		   (send self :server-send-error  dap-format-error dap-access-message #o23))))))

(Defmethod (dap-server-stream :decnet-parse-for-server) (string &optional (default dap-local-host-pathname))
  (condition-case (result)
      (let* ((fs:*always-merge-type-and-version* t)	     
	     (pname (fs:merge-pathnames  (IF (EQ (net:get-host-attribute si:local-host :machine-type) :microexplorer)
					     (STRING-APPEND (SEND si:local-host :name) ":" string)
					     string
					     )
					 default)))
	(server-display "~%Pathname parsed ~a" pname)
	pname)
    (error
     (send self :server-send-error 4. #o227)	   ;Any kind of pathname error we will map.
     nil)
    ))


(DEFMETHOD  (dap-server-stream :server-directory-list) (filespec display)
  (let* ((default (fs:make-pathname :defaults nil  :host si:local-host :device (SEND si:local-host :default-device)
				    :type :unspecific   :version :NEWEST
				    ))
	 (path (send self :decnet-parse-for-server filespec default)))
    (when path
      (server-display "~% Directory-list called for ~a" path)
      (send self :send-name-message volname-nametype "")
      (send self :send-name-message dirname-nametype (send path :string-for-directory))
      (let ((pathname-list (send path :directory-list '(:noerror))))
	(if (not (eql (type-of pathname-list) 'cons))
	    (send self :server-map-error pathname-list)
	    (dolist (element (cdr pathname-list))
	      (send self :send-name-message filename-nametype (send (car element) :string-for-dired))
	      
	      (when (test-display-for-main-attributes display)
		(server-display "~%Dired main attributes message")
		(let* ((bls 1024.)
		       (bszp (get (locf (cdr element)) :byte-size)) ;11-16-88 DAB Could be :default
		       (bsz (if (numberp bszp) bszp  8))
		       (ebk (or (get (locf (cdr element)) :length-in-blocks) 0))
		       (ffb (or (- (* bls ebk) (or (get (locf (cdr element)) :length-in-bytes) 0)))))
		  (send self :send-attributes-message (if (get (locf (cdr element)) :characters)
							  ascii-data image-data)
			                              0 nil nil bls nil ebk nil nil nil
						      nil nil 
						      (if (get (locf (cdr element)) :directory)
							  '(5 7) nil)
						      bsz nil nil nil ebk ebk ffb)))
	      
	      (when (test-display-for-key-definition display)
		(server-display "~%Dired key definition attributes message")
		(send self :send-key-definition-attributes))
	      
	      (when (test-display-for-allocation display)
		(server-display "~%Dired allocation attributes message")
		(send self :send-allocation-attributes))
	      
	      (when (test-display-for-summary display) 
		(server-display "~%Dired summary attributes message")
		(send self :send-summary-attributes))
	      
	      (when (test-display-for-date-and-time display)
		(server-display "~%Dired date-and-time attributes message")
		(send self :send-date-time-attributes (get (locf (cdr element)) :creation-date)))
	      (when (test-display-for-protection display)
		
		(server-display "~%Dired protection attributes message")
		(send self :send-protection-attributes (get (locf (cdr element)) :author)))
	      
	      (send self :send-acknowledge-message nil))
	    )))
    (send self :send-access-complete-message cmpfunc-response)))


(defmethod (dap-server-stream :server-delete) (filespec display)
  (let* ((default (fs:make-pathname :defaults nil :host si:local-host
				    :device (send si:local-host :default-device)
				    :type :unspecific   :version :NEWEST))
	 (path (send self :decnet-parse-for-server filespec default)))
	     (when path
	       (server-display "~% Delete called for ~a" path)
	       (let ((result (if (send path :undeletable-p)   ;11-16-88 DAB
				 (send path :delete-and-expunge nil)
				 (send path :delete nil))))
		 (if (errorp result)		       
		     (send self :server-map-error result)
		     (progn
		       (send self :process-display display path nil))
		       (send self :send-acknowledge-message)
		       (send self :send-access-complete-message cmpfunc-response ))))))

(defmethod (dap-server-stream :process-display) (display path always-send-main-attributes
						 &optional (data-type ascii-data)
						           (org seq-org)
							   (rfm rfm-variable)
							   (rat rat-implied-crlf)
							   (bls nil)
							   (mrs nil)
							   (alq nil)
							   (deq nil))
  (unless bls (setf bls 1024.))
  (let* ((properties  (condition-case () ;11-16-88 DAB 
			  ;;This will error off if I am a microExplorer and I am coming from server-delete. This is because the NFS code will attempt to locate the file, which of course is not there.
			  ;;In this case try to get the properties from the stream
			  (send path :properties)
			(error (send path :property-list))))
	 (bszp (get properties :byte-size))
	 (bsz (if (numberp bszp) bszp 8))
	 (ebk (or (get properties :length-in-blocks) 0))
	 (ffb (or (- (* ebk bls) (or (get properties :length-in-bytes) 0))))
	 (fop-list (if (get properties :directory) '(5 7) nil)))

  (when (or always-send-main-attributes (test-display-for-main-attributes display))
    (server-display "~%Asked for Main attributes message")
    (send self :send-attributes-message data-type org rfm rat bls mrs alq nil nil 0 nil
	                                          deq fop-list bsz nil nil nil nil ebk ffb))
    
  (when (test-display-for-key-definition display)
    (server-display "~%Asked for key definition attributes message")
    (send self :send-key-definition-attributes))

  (when (test-display-for-allocation display)
    (server-display "~%Asked for allocation attributes message")
    (send self :send-allocation-attributes))

  (when (test-display-for-summary display) 
    (server-display "~%Asked for summary attributes message")
    (send self :send-summary-attributes))

  (when (test-display-for-date-and-time display)
    (server-display "~%Asked for Date and Time attributes message")
    (send self :send-date-time-attributes (or (get properties :creation-date)
					      (get-universal-time))))
  (when (test-display-for-protection display)
    (server-display "~%Asked for File Protection attributes message")
    (send self :send-protection-attributes))

  (when (test-display-for-access-control display)
    (server-display "~%Asked for Access control list attributes message"))

  (when (test-display-for-name display)
    (server-display "~%Asked for Name message control list attributes message")
    (send self :send-name-message filespec-nametype (send path :string-for-host)))))


(defmethod (dap-server-stream :server-rename) (filespec display)
  (let* ((default (fs:make-pathname :defaults nil :host si:local-host
				    :device (send si:local-host :default-device) ;11-16-88 DAB
				    :type :unspecific  :version :NEWEST))
	 (path (send self :decnet-parse-for-server filespec default)))
    (when path
      (server-display "~% Rename called for ~a" path)
      (let* ((new-filespec (send self :process-name-message))
	     (new-path (send self :decnet-parse-for-server new-filespec path)))
	(when path
	  (multiple-value-bind (result orig-truename result-truename)
	      (fs:rename-file path new-path :error nil)
	    (if (or (errorp result)	   ;If error, THIRD arg is the error object! ICK!
		    (errorp orig-truename)
		    (errorp result-truename))
		(send self :server-map-error (cond ((errorp result) result)
						   ((errorp orig-truename) orig-truename)
						   ((errorp result-truename) result-truename)))
		(progn
		  (send self :process-display display orig-truename nil)
		  (send self :send-acknowledge-message)
		  (send self :process-display display result-truename nil)
		  (send self :send-acknowledge-message)
		  (send self :send-access-complete-message cmpfunc-response)))))))))

(defmethod (dap-server-stream :server-open-for-output) (path display)
  (server-display "~% Open for output called on ~a" path)
  (let ((truename (send path :truename nil))
	(any-error t))
    (if (errorp truename)
	(send self :server-map-error truename)
	(let* ((props (send truename :properties))
	       (data-type (if (get props :characters) ascii-data image-data))
	       (org seq-org)
	       (rfm (if (eql (get props :byte-size) 8)
			(if (eql data-type ascii-data) rfm-variable rfm-undef)
			rfm-fixed))
	       (rat (case rfm
			  (#.rfm-variable rat-implied-crlf)
			  (#.rfm-undef rat-blk)
			  (#.rfm-fixed rat-embedded-format)))
	       (mrs (if (eql data-type image-data) 512. 0))
;	       (dev-map (list dev-FOD dev-SHR dev-MNT dev-IDV dev-ODV dev-AVL dev-RAD))
	       )
	  (send self :process-display display truename t data-type org rfm rat mrs 0. 0.)
	  (send self :send-acknowledge-message)
	  (if (send self :server-process-control-message)  ;this is the INITIATE message
	      (let* ((internal-stream (send path :open path :direction :input
					   :if-does-not-exist :error :error nil
					   :byte-size (or (get props :byte-size) 8)
					   :characters (if (eql data-type ascii-data) T nil)))
		    (internal-props (fs:file-properties internal-stream)))
		(if (errorp internal-stream)
		    (send self :server-map-error internal-stream)
		    (progn
		      (send self :send-acknowledge-message)
		      (unwind-protect
			  (let ((stream (make-instance (decnet-server-stream-flavor-type
							 :output
							 (get internal-props :byte-size)
							 (get internal-props :characters))
						       :pathname (send internal-stream :truename)
						       :basic-stream self)))
			    (unwind-protect
				(progn
				  (send self :server-process-control-message)	   ;this is the GET message
				  (setf (send (send self :port) :remote-window-size) 1);Set output window size
				  (stream-copy-until-eof internal-stream stream))
				(send stream :close)	   ;Send this to the "new" stream
				(send self :output-close)  ;Send this to ourself
				(setf any-error nil)))	
		  (send internal-stream :close)))
		    )) 
	      (send self :send-access-complete-message cmpfunc-close)
	  )))))


))
