;;; -*- Mode: Common-Lisp; Package: DNA; Base: 10.; Patch-File: T -*-

;;; Reason: Fixed :rename and  :create-directory to handle microExplorers as Explorers.

;;;                           RESTRICTED RIGHTS LEGEND
;;;
;;; Use, duplication, or disclosure by the Government is subject to
;;; restrictions as set forth in subdivision (c)(1)(ii) of the Rights in
;;; Technical Data and Computer Software clause at 52.227-7013.
;;;
;;;   TEXAS INSTRUMENTS INCORPORATED      
;;;   P.O. BOX 2909, M/S 2151             
;;;   AUSTIN, TEXAS 78769                 
;;;
;;; Copyright (C) 1988 Texas Instruments Incorporated.
;;; All rights reserved.

;;; Written 11/16/88 13:28:51 by BERGER,
;;; while running on ARIES from band LODX
;;; With SYSTEM 5.9, VIRTUAL-MEMORY 5.5, EH 5.2, MICRONET 5.5, LOCAL-FILE 5.0, BASIC-PATHNAME 5.2,
;;;  NETWORK-SUPPORT-COLD 5.1, BASIC-NAMESPACE 5.5, NETWORK-NAMESPACE 5.0, DISK-IO 5.9,
;;;  DISK-LABEL 5.1, BASIC-FILE 5.3, MAC-PATHNAME 5.0, NETWORK-PATHNAME 5.0, COMPILER 5.1,
;;;  MAKE-SYSTEM 5.1, TV 5.17, DATALINK 5.7, CHAOSNET 5.6, GC 5.3, MEMORY-AUX 5.1,
;;;  NVRAM 5.1, SYSLOG 5.0, STREAMER-TAPE 5.6, UCL 5.0, INPUT-EDITOR 5.0, METER 5.0,
;;;  ZWEI 5.8, DEBUG-TOOLS 5.0, NETWORK-SUPPORT 5.0, NETWORK-SERVICE 5.0, DATALINK-DISPLAYS 5.0,
;;;  FONT-EDITOR 5.0, SERIAL 5.0, PRINTER 5.11, PRINTER-TYPES 5.2, IMAGEN 5.1, SUGGESTIONS 5.0,
;;;  MAIL-DAEMON 5.1, MAIL-READER 5.3, TELNET 5.1, VT100 5.0, Experimental NAMESPACE-EDITOR 5.1,
;;;  PROFILE 5.1, VISIDOC 5.4, Experimental BUG 10.2, IP 3.33, VISIDOC-SERVER 5.2,
;;;  DECNET 1.42,  microcode 398, Band Name: Pre 5.0 +1p 9/23 +visidoc

#!C
; From file DAP_PATHNAME.LISP#> DECNET; sys:
#10R FILE-SYSTEM#:
(COMPILER-LET ((*PACKAGE* (FIND-PACKAGE "FILE-SYSTEM"))
                          (SI:*LISP-MODE* :COMMON-LISP)
                          (*READTABLE* COMMON-LISP-READTABLE)
                          (SI:*READER-SYMBOL-SUBSTITUTIONS* SYS::*COMMON-LISP-SYMBOL-SUBSTITUTIONS*))
  (COMPILER#:PATCH-SOURCE-FILE "sys: DECNET; DAP_PATHNAME.#"


(defmethod (dap :rename) (medium pathname new-pathname &optional (error-p t))
  (declare (ignore medium))
  (let ((translated-pathname (fs:translated-pathname pathname))
	(new-translated-pathname (fs:translated-pathname new-pathname)))
    (if (and (not (eql (net:get-host-attribute (send pathname :host) :machine-type) :microexplorer))
	     (or (eql (send (send pathname :host) :system-type) :unix-ucb)
		 (eql (send (send pathname :host) :system-type) :unix)))
	(let ((batch-pathname (fs:merge-pathname-defaults "DECnet-rename" pathname :unspecific :newest nil)))
	  (with-open-file (output-stream batch-pathname :batch-file t)
	    (format output-stream "~?" unix-rename-string (list (send pathname :string-for-host)
								(send new-pathname :string-for-host))))
	  (process-sleep 120. "Rename")	  
	  new-pathname)
	(dna:rename-decnet (send translated-pathname :host)
			   translated-pathname new-translated-pathname error-p))))

(defmethod (dap :create-directory) (medium pathname &optional (error-p t))
  (declare (ignore medium))
  (let ((translated-pathname (fs:translated-pathname pathname)))
    (if  (and (not (eql (net:get-host-attribute (send pathname :host) :machine-type)
		       :microexplorer)) ;11-16-88 DAB Handle microExplorers like Explorers.
	      (or (eql (send (send pathname :host) :system-type) :unix-ucb)
		  (eql (send (send pathname :host) :system-type) :unix)))
	(let ((batch-pathname (fs:merge-pathname-defaults
				"DECnet-CD"
				 (send pathname :directory-pathname-as-file)
				 :unspecific :newest nil)))
	  (with-open-file (output-stream batch-pathname :batch-file t :error nil)
	    (if (errorp output-stream)
		(if error-p (signal output-stream) (setf translated-pathname output-stream))
		(format output-stream "~?" ultrix-create-dir-string
			(list (send (pathname (send pathname :directory-pathname-as-file)) :string-for-host))))
	  ))
	(let ((batch-pathname (fs:merge-pathname-defaults
				"DECnet-CD"
				(send pathname :directory-pathname-as-file)
				:unspecific :newest nil)))
	  (with-open-file (output-stream batch-pathname :batch-file t :error error-p)
	    (if (errorp output-stream)
		(if error-p (signal output-stream) (setf translated-pathname output-stream))
	    (format output-stream "~?" vms4-create-dir-string
		    (list (send (send (send (send pathname :new-name nil) :new-type nil) :new-version nil)
				:string-for-host))))
	  )))
    translated-pathname))


))
