;;; -*- Mode: Common-Lisp; Package: DNA; Base: 10.; Patch-File: T -*-

;;; Reason: Fixed :process-open-output and :send-open-access-message to handle microExplorer like an explorer. 

;;;                           RESTRICTED RIGHTS LEGEND
;;;
;;; Use, duplication, or disclosure by the Government is subject to
;;; restrictions as set forth in subdivision (c)(1)(ii) of the Rights in
;;; Technical Data and Computer Software clause at 52.227-7013.
;;;
;;;   TEXAS INSTRUMENTS INCORPORATED      
;;;   P.O. BOX 2909, M/S 2151             
;;;   AUSTIN, TEXAS 78769                 
;;;
;;; Copyright (C) 1988 Texas Instruments Incorporated.
;;; All rights reserved.

;;; Written 11/17/88 13:36:55 by BERGER,
;;; while running on ARIES from band LODX
;;; With SYSTEM 5.19, VIRTUAL-MEMORY 5.5, EH 5.3, MICRONET 5.5, LOCAL-FILE 5.0, BASIC-PATHNAME 5.2,
;;;  NETWORK-SUPPORT-COLD 5.1, BASIC-NAMESPACE 5.5, NETWORK-NAMESPACE 5.0, DISK-IO 5.9,
;;;  DISK-LABEL 5.1, BASIC-FILE 5.3, MAC-PATHNAME 5.0, NETWORK-PATHNAME 5.0, COMPILER 5.1,
;;;  MAKE-SYSTEM 5.1, TV 5.20, DATALINK 5.7, CHAOSNET 5.6, GC 5.3, MEMORY-AUX 5.1,
;;;  NVRAM 5.1, SYSLOG 5.0, STREAMER-TAPE 5.6, UCL 5.0, INPUT-EDITOR 5.0, METER 5.0,
;;;  ZWEI 5.9, DEBUG-TOOLS 5.1, NETWORK-SUPPORT 5.0, NETWORK-SERVICE 5.0, DATALINK-DISPLAYS 5.0,
;;;  FONT-EDITOR 5.0, SERIAL 5.0, PRINTER 5.11, PRINTER-TYPES 5.2, IMAGEN 5.1, SUGGESTIONS 5.0,
;;;  MAIL-DAEMON 5.1, MAIL-READER 5.3, TELNET 5.1, VT100 5.0, Experimental NAMESPACE-EDITOR 5.1,
;;;  PROFILE 5.1, VISIDOC 5.4, Experimental BUG 10.2, IP 3.33, VISIDOC-SERVER 5.2,
;;;  Inconsistent DECNET 1.44, RPC 5.4,  microcode 398, Band Name: Pre 5.0 +1p 9/23 +visidoc

#!C
; From file DAP_UTILITIES.LISP#> DECNET; sys:
#10R DNA#:
(COMPILER-LET ((*PACKAGE* (FIND-PACKAGE "DNA"))
                          (SI:*LISP-MODE* :COMMON-LISP)
                          (*READTABLE* SYS:COMMON-LISP-READTABLE)
                          (SI:*READER-SYMBOL-SUBSTITUTIONS* SYS::*COMMON-LISP-SYMBOL-SUBSTITUTIONS*))
  (COMPILER#:PATCH-SOURCE-FILE "sys: DECNET; DAP_UTILITIES.#"


(defmethod (DAP-basic-stream :handle-attributes-message) (header offset)
  (multiple-value-setq (nil nil nil nil nil offset)
		       (decode-operator-field header offset))
  (multiple-value-bind (nil datatype nil RFM RAT BLS nil ALQ
			nil nil nil nil nil FOP BSZ nil nil nil nil EBK FFB)
      (decode-attributes-message header offset)
    (values datatype BLS ALQ BSZ RFM RAT FOP
	    (cond ((and bls ebk ffb) (- (* bls ebk) ffb))
		  (ffb ffb)
		  (t nil))
	    ebk)))


(defmethod (DAP-basic-stream :process-open-output) (pname new-version error-if-does-not-exist
						    data-type overwrite append supersede byte-size
						    estimated-length ascii-stream batch)
  (let ((direction :output)
	returned-name-string RAT RFM)
    (send self :send-open-attributes-message direction data-type byte-size ascii-stream)
    (send self :send-open-access-message batch direction new-version pname (or append overwrite) supersede)
    (multiple-value-bind (header offset message-length)
	(send self :receive-next-message)
      (let ((packet-type (dap-type header offset)))
	(case packet-type
	  (#.DAP-status-message
	   (multiple-value-bind (nil nil nil nil nil new-offset)
	       (decode-operator-field header offset)
	     (multiple-value-bind (nil miccode)
		 (decode-status-message header new-offset message-length)
	       (cond ((and (eql miccode #o62)	   ;File not found - try open with create
			   (eql direction :output)
			   new-version)
		      (send self :process-open-output pname nil error-if-does-not-exist
			                              data-type overwrite append supersede byte-size
						      estimated-length ascii-stream batch))
		     ((and (eql miccode #o55)
			   (eql direction :output)
			   (not error-if-does-not-exist))
		      (send self :process-open-output pname nil error-if-does-not-exist
			                              data-type overwrite append supersede byte-size
						      estimated-length ascii-stream batch))
		     (t (send self :process-unexpected-message header offset))))))
	  (#.DAP-attributes-message
	   (multiple-value-setq (nil nil nil nil nil offset)
	     (decode-operator-field header offset))
	   (multiple-value-setq (nil nil nil RFM RAT)
	     (decode-attributes-message header offset))
	   (if RAT (when (ldb-test (byte 1 1) RAT) (setf (send self :implied-crlf?) t))
	       (setf (send self :implied-crlf?) nil))
	   (when RFM (when (eql RFM 4) (setf (send self :implied-crlf?) nil)))
	   (multiple-value-bind (cdt rdt)
	       (send self :process-date-time-attributes)
	     (when cdt (send self :putprop (time:parse-universal-time cdt) :creation-date))
	     (when rdt (send self :putprop (time:parse-universal-time rdt) :last-updated)))
	   (setf returned-name-string (send self :process-name-message))
	   (send self :process-acknowledge-message)
	   (setf end-of-file nil)
	   (cond
	     (overwrite (send self :send-control-message ctlfunc-connect)
		        (send self :send-control-message ctlfunc-put))
	     (append    (send self :send-control-message ctlfunc-connect nil nil nil #x01)
		        (send self :send-data-push-message))
	     (supersede (send self :send-control-message ctlfunc-connect 3 nil nil
			      ;;This kludge is for Ultrix who barfs if it sees a ROP of Truncate-put
			      
			      (if (and (not (eql (net:get-host-attribute (send pathname :host) :machine-type) :microexplorer))
				       (or (eql (send (send pathname :host) :system-type) :unix-ucb)
					   (eql (send (send pathname :host) :system-type) :unix)))
				  nil #x40))
			(send self :send-data-push-message))
	     (t         (send self :send-initiate-data-stream-message)
			(send self :send-data-push-message)))
	   returned-name-string)
	  (t (send self :process-unexpected-message header offset)))))))


(defmethod (DAP-basic-stream :send-open-attributes-message)
	   (direction data-type byte-size &optional ascii-stream new-version error-if-does-not-exist
	    supersede append overwrite (estimated-length 0))
  (let ((fop-map (list (when (and (eql direction :output) supersede) fop-SUP)
		       (when (and (eql direction :output) new-version) fop-CIF)
		       (when (and (eql direction :output)
				  (not error-if-does-not-exist)
				  (not overwrite)
				  (not append)) fop-CIF)		       
		       fop-SQO
		       (when (and (eql direction :output) (eql byte-size 8.)) fop-TEF)))
	(dev-map (list dev-FOD dev-SHR dev-MNT dev-IDV dev-ODV dev-AVL dev-RAD)))
    (send self :send-attributes-message
	  data-type			           ;data-type
	  seq-org			           ;file organization
	  (cond (ascii-stream rfm-undef)
		((and (eql data-type ascii-data)   ;record format
		      (eql byte-size 8))
		 rfm-variable)
		((and (eql data-type image-data)
		      (eql byte-size 8))
		 rfm-undef)
		((and (eql data-type image-data)
		      (eql byte-size 16.))
		 rfm-fixed)
		(t rfm-undef))
	  ;; This kluge is because Ultrix barfs at RAT-BLK for binary files.
	  (cond (ascii-stream 0)
		((and (eql data-type ascii-data)   ;record attributes
		      (eql byte-size 8))
		 rat-implied-crlf)
		((and (eql data-type image-data)
		      (eql byte-size 8))
		 rat-embedded-format)
		((and (eql data-type image-data)
		      (eql byte-size 16.))
		 (if (and (not (eql (net:get-host-attribute (send pathname :host) :machine-type) :microexplorer))
			  (or (eql (send (send pathname :host) :system-type) :unix-ucb)
			      (eql (send (send pathname :host) :system-type) :unix)))
		     nil rat-blk))
		(t rat-embedded-format))
	  
	  nil				   ;BLS
	  (if (or (eql byte-size 8.) (eql data-type ascii-data))   ;MRS
	      0. 512.)
	  (if estimated-length		   ;ALQ
	      estimated-length
	      0)
	  nil nil nil nil		   ;BKS FSZ MRN RUNSYS
	  0				   ;DEQ
	  fop-map			   ;FOP
	  nil				   ;BSZ
	  dev-map)))

))

