;;; -*- Mode: Common-Lisp; Package: DNA; Base: 10.; Patch-File: T -*-

;;; Reason: Another case were DAP-CONNECT errors with function NIL undefined.

;;;                           RESTRICTED RIGHTS LEGEND
;;;
;;; Use, duplication, or disclosure by the Government is subject to
;;; restrictions as set forth in subdivision (c)(1)(ii) of the Rights in
;;; Technical Data and Computer Software clause at 52.227-7013.
;;;
;;;   TEXAS INSTRUMENTS INCORPORATED      
;;;   P.O. BOX 2909, M/S 2151             
;;;   AUSTIN, TEXAS 78769                 
;;;
;;; Copyright (C) 1988 Texas Instruments Incorporated.
;;; All rights reserved.

;;; Written 12/14/88 12:38:56 by BERGER,
;;; while running on ARIES from band LOD1
;;; With SYSTEM 5.23, VIRTUAL-MEMORY 5.5, EH 5.3, MICRONET 5.5, LOCAL-FILE 5.0, BASIC-PATHNAME 5.3,
;;;  NETWORK-SUPPORT-COLD 5.1, BASIC-NAMESPACE 5.8, NETWORK-NAMESPACE 5.0, DISK-IO 5.9,
;;;  DISK-LABEL 5.1, BASIC-FILE 5.4, MAC-PATHNAME 5.0, NETWORK-PATHNAME 5.0, COMPILER 5.2,
;;;  MAKE-SYSTEM 5.3, TV 5.22, DATALINK 5.7, CHAOSNET 5.6, GC 5.4, MEMORY-AUX 5.1,
;;;  NVRAM 5.1, SYSLOG 5.1, STREAMER-TAPE 5.7, UCL 5.0, INPUT-EDITOR 5.0, METER 5.0,
;;;  ZWEI 5.11, DEBUG-TOOLS 5.1, Experimental NETWORK-SUPPORT 5.1, Experimental NETWORK-SERVICE 5.1,
;;;  DATALINK-DISPLAYS 5.0, FONT-EDITOR 5.0, SERIAL 5.0, PRINTER 5.12, PRINTER-TYPES 5.5,
;;;  IMAGEN 5.1, SUGGESTIONS 5.0, MAIL-DAEMON 5.4, MAIL-READER 5.5, TELNET 5.1, VT100 5.1,
;;;  Experimental NAMESPACE-EDITOR 5.1, PROFILE 5.1, VISIDOC 5.4, Experimental BUG 10.2,
;;;  IP 3.33, VISIDOC-SERVER 5.2, DECNET 1.47,  microcode 398, Band Name: Pre 5.0 +1p 9/23 +visidoc

#!C
; From file DAP_INTERFACE.LISP#> DECNET; sys:
#10R DNA#:
(COMPILER-LET ((*PACKAGE* (FIND-PACKAGE "DNA"))
                          (SI:*LISP-MODE* :COMMON-LISP)
                          (*READTABLE* SYS:COMMON-LISP-READTABLE)
                          (SI:*READER-SYMBOL-SUBSTITUTIONS* SYS::*COMMON-LISP-SYMBOL-SUBSTITUTIONS*))
  (COMPILER#:PATCH-SOURCE-FILE "sys: DECNET; DAP_INTERFACE.#"


(defun dap-connect (dstnode &key userid password accounting)
  (let ((nbytes 3)(src-format 2)
	(port (reuse-port dstnode)) (send-config-msg nil))
    (unless port
      (loop 
	(setf port (sc-establish-connection :dstnode dstnode :nbytes nbytes
			 :format src-format :usrcode 0 :grpcode 0 :descrpt userid
			 :userid userid :password password :accounting accounting
			 :objtype dap-connect-objtype))
	
	(if (or (not port) (not (eql (send port :STATE) :RUNNING)))
	    (progn
	      (when port (send port :close))  ;10-27-88 DAB If sc-establish-connection fails port will be nil.
	      (setf port nil)
	      (decnet-signal-error 'dna-connect-error "failed to connect"
				   (if (typep dstnode 'net:host)
				       (send dstnode :name)
				       (send (si:get-host-from-address dstnode :dna) :name))
				   t t))
	    (progn
	      (setf send-config-msg t)
	      (setf (send port :who-line-state) "DAP Connect")
	      (return)))))
    (values port send-config-msg)))
))
