;;; -*- Mode: Common-Lisp; Package: DNA; Base: 10.; Patch-File: T -*-

;;; Reason: Fixed (NSP-port :segmentation-send) to retransmit pkt when a timeout has occurred. VAX 5.0 machines seem to hang if we just send LINK SERVICEs.

;;;                           RESTRICTED RIGHTS LEGEND
;;;
;;; Use, duplication, or disclosure by the Government is subject to
;;; restrictions as set forth in subdivision (c)(1)(ii) of the Rights in
;;; Technical Data and Computer Software clause at 52.227-7013.
;;;
;;;   TEXAS INSTRUMENTS INCORPORATED      
;;;   P.O. BOX 2909, M/S 2151             
;;;   AUSTIN, TEXAS 78769                 
;;;
;;; Copyright (C) 1989 Texas Instruments Incorporated.
;;; All rights reserved.

;;; Written 02/21/89 09:26:53 by BERGER,
;;; while running on ARIES from band LOD1
;;; With Experimental SYSTEM 6.0, Experimental VIRTUAL-MEMORY 6.0, Experimental EH 6.0,
;;;  Experimental MAKE-SYSTEM 6.0, Experimental MICRONET 6.0, Experimental LOCAL-FILE 6.0,
;;;  Experimental BASIC-PATHNAME 6.0, Experimental NETWORK-SUPPORT-COLD 6.0, Experimental BASIC-NAMESPACE 6.0,
;;;  Experimental NETWORK-NAMESPACE 6.0, Experimental DISK-IO 6.0, Experimental DISK-LABEL 6.0,
;;;  Experimental BASIC-FILE 6.0, Experimental MAC-PATHNAME 6.0, Experimental NETWORK-PATHNAME 6.0,
;;;  Experimental COMPILER 6.0, Experimental TV 6.0, Experimental DATALINK 6.0, Experimental CHAOSNET 6.0,
;;;  Experimental GC 6.0, Experimental MEMORY-AUX 6.0, Experimental NVRAM 6.0, Experimental SYSLOG 6.0,
;;;  Experimental STREAMER-TAPE 6.0, Experimental CLEH 1.0, Experimental UCL 6.0,
;;;  Experimental INPUT-EDITOR 6.0, Experimental METER 6.0, Experimental ZWEI 6.0,
;;;  Experimental DEBUG-TOOLS 6.0, Experimental NETWORK-SUPPORT 6.0, Experimental NETWORK-SERVICE 6.0,
;;;  DATALINK-DISPLAYS 6.0, Experimental FONT-EDITOR 6.0, Experimental SERIAL 6.0,
;;;  Experimental PRINTER 6.0, Experimental MAC-PRINTER-TYPES 6.0, Experimental PRINTER-TYPES 6.0,
;;;  Experimental IMAGEN 6.0, Experimental SUGGESTIONS 6.0, Experimental MAIL-DAEMON 6.0,
;;;  Experimental MAIL-READER 6.0, Experimental TELNET 6.0, Experimental VT100 6.0,
;;;  Experimental NAMESPACE-EDITOR 6.0, Experimental PROFILE 6.0, VISIDOC 6.0, Experimental BUG 10.7,
;;;  IP 3.41, Experimental TI-CLOS 14.21, NIL CLX 3.0, Experimental X11M 1.11, NIL CLUE 15.0,
;;;  NIL RPC 4.19, NIL NFS 3.4, DECNET 1.53,  microcode 414, Band Name: REL 6.0 2/2 +DNA


#!C
; From file NSP_TRANSMIT.LISP#> DECNET; SYS:
#10R DNA#:
(COMPILER-LET ((*PACKAGE* (FIND-PACKAGE "DNA"))
                          (SI:*LISP-MODE* :COMMON-LISP)
                          (*READTABLE* SYS:COMMON-LISP-READTABLE)
                          (SI:*READER-SYMBOL-SUBSTITUTIONS* SYS::*COMMON-LISP-SYMBOL-SUBSTITUTIONS*))
  (COMPILER#:PATCH-SOURCE-FILE "SYS: DECNET; NSP_TRANSMIT.#"


(defmethod (NSP-port :segmentation-send) (pkt eom bom)
  (declare (special *setup-both*
		    *setup-neither*))
  (let ((header (get-nsp-header pkt))
	(timeout nil))
    (set-msgflag-data-message eom bom header)
    (setf (dstaddr header) ADDRrem)
    (setf (srcaddr header) ADDRloc)
    (unless *setup-neither*
      (setf (acknum-number header) NUMdata-received)
      (setf (acknum-qual header) qual-ack)
      (set-acknum-presence header t)
      (when *setup-both*
	(setf (ackoth-number header) NUMoth-received)
	(setf (ackoth-qual header) cross-subchannel-ack)
	(set-ackoth-presence header t)))
    (setf (segnum header) NUMdat)
    (setf state :RUNNING)
    (if (eql flowrem-sw :SEND)
	(if (<=segnum numdat (+segnum remote-window-size numdat-remote))
	    (progn
	      (nsp-display "~%TRANSMIT normal data pkt. Number ~d." numdat)
	      (send self :transmit-buffer pkt))
	    (loop
	      (setf timeout
		    (process-wait-with-timeout (or Who-line-state "Net Output") 1800.
		     #'(lambda (instance)
				(or ;(send instance :try-sending)
				    (not (eql (send instance :state) :RUNNING))
				    (= (send instance :numdat)
				       (+segnum 1 (send instance :numdat-remote)))))
			    self))
	      (if timeout 
		  (progn
		    (setf try-sending nil)
		    (when (eql state :RUNNING)
		      (send self :transmit-buffer pkt)
		      (nsp-display "~%TRANSMIT AFTER WAIT normal data pkt. Number ~d." numdat))
		    
		    (return nil))
		  (if (<segnum  (+segnum 1 numdat-remote) numdat)  ; DAB 02-21-89 5.0 VAX seem to need retrans
		      (send self :retransmit-earliest-data )       ; so try it.
		      (send self :send-other-data-message (nsp-get-pkt) t)))))
	(send self :queue-for-retransmission pkt))
    (setf NUMdat (+segnum 1 NUMdat))
    (incf Data-segment-message-transmitted)))
))
