;;; -*- Mode: Common-Lisp; Package: User; Base: 10.; Patch-File: T -*-
;;; Written 03/09/89 03:40:52 by BERGER,
;;; Reason: Changes to fix CTERM hang problems with VAX 4.7 and 5.0 machines.
;;; while running on MX29 from band NDAB
;;; With SYSTEM 5.19, GC 5.3, VIRTUAL-MEMORY 5.5, MICRONET 5.5, MICRONET-COMM 5.13,
;;;  DISK-IO 5.9, BASIC-PATHNAME 5.2, MAC-PATHNAME 5.0, NETWORK-SUPPORT-COLD 5.1,
;;;  BASIC-NAMESPACE 5.6, BASIC-FILE 5.3, RPC 5.4, NFS 5.10, EH 5.3, MAKE-SYSTEM 5.2,
;;;  MEMORY-AUX 5.1, MACTOOLBOX 1.25, COMPILER 5.1, TV 5.21, NVRAM 5.1, UCL 5.0, INPUT-EDITOR 5.0,
;;;  METER 5.0, ZWEI 5.9, DEBUG-TOOLS 5.1, WINDOW-MX 5.28, PRINTER 5.11, MAC-PRINTER-TYPES 5.4,
;;;  NETWORK-PATHNAME 5.0, NETWORK-NAMESPACE 5.0, DATALINK 5.7, CHAOSNET 5.6, NETWORK-SUPPORT 5.0,
;;;  NETWORK-SERVICE 5.0, DATALINK-DISPLAYS 5.0, NAMESPACE-EDITOR 5.1, IP 3.33, NFS-SERVER 5.3,
;;;  PRINTER-TYPES 5.2, IMAGEN 5.1, MAIL-DAEMON 5.1, MAIL-READER 5.3, TELNET 5.1,
;;;  VT100 5.0, STREAMER-TAPE 5.6, Inconsistent DECNET 1.54, VISIDOC 5.4, PROFILE 5.1,
;;;  DISK-LABEL 5.1,  microcode 97, Band Name: microExplorer Network (11/22)



#!C
; From file DAP_DEFS.LISP#> DECNET; SYS:
#10R DNA#:
(COMPILER-LET ((*PACKAGE* (FIND-PACKAGE "DNA"))
                          (SI:*LISP-MODE* :COMMON-LISP)
                          (*READTABLE* SYS:COMMON-LISP-READTABLE)
                          (SI:*READER-SYMBOL-SUBSTITUTIONS* SYS::*COMMON-LISP-SYMBOL-SUBSTITUTIONS*))
  (COMPILER#:PATCH-SOURCE-FILE "SYS: DECNET; DAP_DEFS.#"



(defvar dap-buffer-size 512. "size of dap data buffers") ;03-07-89 This used to be 1451. but it sometimes hangs on VAX 5.0 Machines.

))





#!C
; From file NSP_PORTS.LISP#> DECNET; SYS:
#10R DNA#:
(COMPILER-LET ((*PACKAGE* (FIND-PACKAGE "DNA"))
                          (SI:*LISP-MODE* :COMMON-LISP)
                          (*READTABLE* SYS:COMMON-LISP-READTABLE)
                          (SI:*READER-SYMBOL-SUBSTITUTIONS* SYS::*COMMON-LISP-SYMBOL-SUBSTITUTIONS*))
  (COMPILER#:PATCH-SOURCE-FILE "SYS: DECNET; NSP_PORTS.#"


(defflavor NSP-port
	   (NEXT			   ;Pointer to next linked port
	    STATE		           ;State of the port
	    NODEaddr			   ;Remote node address
	    ADDRloc			   ;Local link address
	    ADDRrem			   ;Remote link address
	    Port-packets-retransmitted	   ;Number of packet retransmissions
	    NUMdat 			   ;Number of next DATA SEGMENT message to transmit.
	    NUMdat-remote		   ;Number of DATA SEGMENT message acknowledged by remote host.
	    NUMoth 			   ;Number of next INTERRUPT or LINK SERVICE message to transmit.
	    NUMoth-remote		   ;Number of highest OTHER DATA message acknowledged by remote host.
	    NUMdata-received		   ;Highest numbered DATA SEGMENT message received from remote NSP.
	    NUMoth-received                ;Highest numbered OHTER DATA segment received from remote NSPl
	    ACKxmt-dat		           ;Number of last DATA SEGMENT message ack sent by local NSP.
	    ACKxmt-oth		           ;Number of last Interrupt or Link service message ack sent by local NSP
	    ACKrcv-dat	        	   ;Number of highest DATA SEGMENT message received from remote NSP
	    FLOWrem-data		   ;The cumulative normal data request count received from remote NSP
	    FLOWrem-int 		   ;Cumulative interrupt data request count received from the remote NSP
	    FLOWrem-sw 		           ;Normal data on/off switch most recently received from remote NSP :SEND :NO-SEND
	    FLOWrem-type 	           ;Flow control type of the remote receiver :NONE :SEGMENT :SESSION-CONTROL
	    BUFxmt 		           ;Data to be transmitted with CONNECT CONFIRM, DISCONNECT INITIATE or INTERRUPT
	    BUFrcv 		           ;Buffer to contain data for received INTERRUPT msgs.
	    BUFdis			   ;Buffer to contain DISCONNECT INITIATE message.
	    BUFacc 		           ;Contains accept data for received CONNECT CONFIRM msg.
	    BUFcon 		           ;Buffer to contain data from a transmitted or received CONNECT INITIATE msg.
	    Ack-Window-size		   ;Round trip time-of-day value for start of round trip time estimation.
	    BOM-packet			   ;If this message does NOT contain an EOM.
	    Who-line-state		   ;Who line message.
	    SIZEseg 			   ;Transmit segment size
	    RETRANSMISSION-QUEUE 	   ;Queue for holding normal packets for retransmission
	    RECEIVE-PACKET-QUEUE           ;Queue for received data packets
	    QUEUED-OTHER-DATA-MESSAGES	   ;Queue for interrupt data messages
	    REASON-FOR-USE		   ;If host or server.
	    LOCAL-WINDOW-SIZE		   ;Number of received messages to queue before sending a "halt" message
	    remote-window-size		   ;Number of messages to send before waiting for an ack.
	    average-time-between-packets   ;Raw average between ANY packet arrivals.
	    last-packet-received-time	   ;time (in 60ths) when last packet arrived.
	    halt-time			   ;If we have sent a HALT link service request. (cleared by sending a RESUME)
	    try-sending 		   ;Set T if we receive a LS message - used if we "miss" a data ack.
	    preallocated-ack-pkt
	    last-activity-time		   ;A timestamp of activity except link services DAB 02-15-89
	    resume-after-halt
	    )
	    ()
           (:ordered-instance-variables)
           (:settable-instance-variables)
           (:documentation "NSP Port flavor"))

(defmethod (nsp-port :init) (&rest ignore)
  (declare (special *nsp-window-size*))
  (setf NEXT nil)
  (setf STATE :CLOSED)
  (setf NODEaddr nil)	
  (setf ADDRloc 0)	
  (setf ADDRrem 0)
  (setf NUMdat 1)			   
  (setf NUMdat-remote 0)
  (setf NUMoth 1)			   
  (setf NUMoth-remote 0)
  (setf NUMoth-received  0)		   
  (setf NUMdata-received 0)
  (setf ACKxmt-dat 0)		
  (setf ACKxmt-oth 0)		
  (setf ACKrcv-dat 0)		
  (setf FLOWrem-data 0)	
  (setf FLOWrem-int 1)	
  (setf FLOWrem-sw :SEND)	
  (setf FLOWrem-type :NONE)	
  (setf BUFxmt nil)		
  (setf BUFrcv nil)
  (setf BUFdis nil)
  (setf BUFacc nil)		
  (setf BUFcon nil)		
  (setf BOM-packet nil)	
  (setf SIZEseg 0)		
  (setf RETRANSMISSION-QUEUE nil)
  (setf RECEIVE-PACKET-QUEUE nil)
  (setf QUEUED-OTHER-DATA-MESSAGES nil)
  (setf Who-line-state "DNA Connect")
  (setf port-packets-retransmitted 0)
  (setf local-window-size *nsp-window-size*)
  (setf remote-window-size *nsp-remote-window-size*)
  (setf average-time-between-packets 0.)
  (setf last-packet-received-time 0.)
  (setf halt-time nil)
  (setf try-sending nil)
  (setf preallocated-ack-pkt nil)
  (setf last-activity-time  (time:time)) ; DAB 02-15-89
  (setf resume-after-halt nil)
  )
))

#!C
; From file NSP_TRANSMIT.LISP#> DECNET; SYS:
#10R DNA#:
(COMPILER-LET ((*PACKAGE* (FIND-PACKAGE "DNA"))
                          (SI:*LISP-MODE* :COMMON-LISP)
                          (*READTABLE* SYS:COMMON-LISP-READTABLE)
                          (SI:*READER-SYMBOL-SUBSTITUTIONS* SYS::*COMMON-LISP-SYMBOL-SUBSTITUTIONS*))
  (COMPILER#:PATCH-SOURCE-FILE "SYS: DECNET; NSP_TRANSMIT.#"


(defmethod (NSP-port :send-data-request-message) (pkt &optional (ack-p nil))
  (send self :send-ls-message pkt ack-p FCMOD-send-data FCVAL-INT-data-request 0)
  (when halt-time
    (if (> (time:time-difference (time:time) halt-time) 1800.)
	(if (> local-window-size 4)
	    (decf local-window-size 4)
	    (if (> local-window-size 2) (decf local-window-size)))
	(when (< local-window-size 20.) (incf local-window-size 4)))
    (nsp-display "new local window size = ~d" local-window-size)
    (setf halt-time nil)
    (setf resume-after-halt (time:time)))
  )
))

#!C
; From file NSP_ROUTING.LISP#> DECNET; SYS:
#10R DNA#:
(COMPILER-LET ((*PACKAGE* (FIND-PACKAGE "DNA"))
                          (SI:*LISP-MODE* :COMMON-LISP)
                          (*READTABLE* SYS:COMMON-LISP-READTABLE)
                          (SI:*READER-SYMBOL-SUBSTITUTIONS* SYS::*COMMON-LISP-SYMBOL-SUBSTITUTIONS*))
  (COMPILER#:PATCH-SOURCE-FILE "Sys: DECNET; NSP_ROUTING.#"


(defun process-data-type-message (pkt node-id funny-p)
  "This routine will process a data type message. It can be one of three types of
 message: 1) Data Segment message
           2) Interrupt-message
           3) Link Service message"
  (let* ((header (get-nsp-header pkt))
	 (port (return-port-from-link-address (dstaddr header))))
    (prog1 
      (case (message-subtype-field header)
	(#.subtype-link-service (process-link-service-message pkt node-id funny-p))
	(#.subtype-interrupt (process-interrupt-message pkt node-id funny-p))
	(otherwise (when port (setf (send port :resume-after-halt) nil)) 
		   (process-data-segment-message pkt node-id funny-p)))
      ;;The following code was added to fix cterm hang problems with VAX 5.0 machines. There were no followup checking on whether
      ;; the resume that was sent after a HALT was successful.
      (when (and port (send port :resume-after-halt)
		 (> (time:time-difference (time:time) (send port :resume-after-halt))
		    600))  ;10 seconds
	(send port :send-data-request-message (nsp-get-pkt)))
      )
    ))





(compile-flavor-methods nsp nsp-port  CTERM-TERMINAL-WINDOW)

(initialize-nsp)



))
