;;; -*- Mode: Common-Lisp; Package: DNA; Base: 10.; Patch-File: T -*-
;;; Patch file for DECNET version 1.56
;;; Reason: Changed the pmu Mail server to not prompt for userid and passwords. Login should not be required to send mail.
;;; Written 03/09/89 03:56:44 by BERGER,
;;; while running on MX29 from band NDAB
;;; With SYSTEM 5.19, GC 5.3, VIRTUAL-MEMORY 5.5, MICRONET 5.5, MICRONET-COMM 5.13,
;;;  DISK-IO 5.9, BASIC-PATHNAME 5.2, MAC-PATHNAME 5.0, NETWORK-SUPPORT-COLD 5.1,
;;;  BASIC-NAMESPACE 5.6, BASIC-FILE 5.3, RPC 5.4, NFS 5.10, EH 5.3, MAKE-SYSTEM 5.2,
;;;  MEMORY-AUX 5.1, MACTOOLBOX 1.25, COMPILER 5.1, TV 5.21, NVRAM 5.1, UCL 5.0, INPUT-EDITOR 5.0,
;;;  METER 5.0, ZWEI 5.9, DEBUG-TOOLS 5.1, WINDOW-MX 5.28, PRINTER 5.11, MAC-PRINTER-TYPES 5.4,
;;;  NETWORK-PATHNAME 5.0, NETWORK-NAMESPACE 5.0, DATALINK 5.7, CHAOSNET 5.6, NETWORK-SUPPORT 5.0,
;;;  NETWORK-SERVICE 5.0, DATALINK-DISPLAYS 5.0, NAMESPACE-EDITOR 5.1, IP 3.33, NFS-SERVER 5.3,
;;;  PRINTER-TYPES 5.2, IMAGEN 5.1, MAIL-DAEMON 5.1, MAIL-READER 5.3, TELNET 5.1,
;;;  VT100 5.0, STREAMER-TAPE 5.6, Inconsistent DECNET 1.54, VISIDOC 5.4, PROFILE 5.1,
;;;  DISK-LABEL 5.1,  microcode 97, Band Name: microExplorer Network (11/22)

#!C
; From file SC_HOST.LISP#> DECNET; SYS:
#10R DNA#:
(COMPILER-LET ((*PACKAGE* (FIND-PACKAGE "DNA"))
                          (SI:*LISP-MODE* :COMMON-LISP)
                          (*READTABLE* SYS:COMMON-LISP-READTABLE)
                          (SI:*READER-SYMBOL-SUBSTITUTIONS* SYS::*COMMON-LISP-SYMBOL-SUBSTITUTIONS*))
  (COMPILER#:PATCH-SOURCE-FILE "SYS: DECNET; SC_HOST.#"


(defun build-connect-msg (pkt objtyp src-format &optional (name si:user-id)(usrcode 0)(grpcode 0)
			  descrpt rqstrid password account usrdata)
  (let ((menuver 3.)(offset 0)(name-len 16.)
	(descrpt-len 12.)(field-len 39.)(data-len 16.)(sc-header nil))
    
   ; converts the format of the arguments into strings 
    
    (when rqstrid
      (if (string-equal rqstrid "PMU-Mailer")   ; DAB 03-09-89 Mailer server typically do not require login
	  (progn (setf rqstrid nil) (setf password nil))
	  (setf rqstrid  (convert-arg-to-string rqstrid))))
    (when password
      (setf password (convert-arg-to-string password)))
    (when account
      (setf account  (convert-arg-to-string account)))
    (when usrdata
      (setf usrdata  (convert-arg-to-string usrdata)))

    (setq sc-header (get-session-header pkt :dna-session :unknown))

    ;fill in SC connect msg fields
    (setf offset (set-1-byte sc-header (if (numberp objtyp) 0 1) offset)) ;dst-format-field

    (case (type-of objtyp)                                            ;dst-objtyp-field
	  ('fixnum (setf offset (set-1-byte sc-header objtyp offset)))
	  ('string (setf offset (set-1-byte sc-header 0 offset))
		   (setf offset (set-I-string-field sc-header offset objtyp 16. nil)))
	  ('symbol (setf offset (set-1-byte sc-header 0 offset))
		   (setf offset (set-I-string-field sc-header offset (format nil "~s" objtyp) 16. nil)))
	  (t (ferror 'unknown-objtype "Unknown object type")))

    (setf offset (set-1-byte sc-header src-format offset))           ;src-format-field
    (setf offset (set-1-byte sc-header 0 offset))                    ;src-objtyp-field
    (if (eql src-format 2)
	(progn	  
	  (setf offset (set-2-bytes sc-header grpcode offset))       ;src grpcode
	  (setf offset (set-2-bytes sc-header usrcode offset))       ;src usrcode
	  (setf offset (set-i-string-field sc-header offset descrpt descrpt-len t)))
	;else src-format = 1
	(setf offset (set-i-string-field sc-header offset name name-len nil)))
    
      (setf offset (set-1-byte sc-header menuver offset))      ;menuver vector field
    
    (unless (zerop (ldb (byte 1 0) menuver))
      (if rqstrid
	  (setf offset (set-i-string-field sc-header offset rqstrid field-len nil))      ; rqstrid field
	  (setf offset (set-1-byte sc-header 0 offset)))                                 ;rqstrid-len field
      
      (if password
	  (setf offset (set-i-string-field sc-header offset password field-len nil))         ; password field
	  (setf offset (set-1-byte sc-header 0 offset)))                                 ;password-len field
	
      (if account
	  (setf offset (set-i-string-field sc-header offset account field-len nil))          ; account field
	  (setf offset (set-1-byte sc-header 0 offset)))                                 ;account-len field
	)
    
    (unless (zerop (ldb (byte 1 1) menuver))
      (if usrdata
	  (setf offset (set-i-string-field sc-header offset usrdata data-len nil))           ; usrdata field
	  (setf offset (set-1-byte sc-header 0 offset)))                                 ;usrdata-len field
      )

    (get-session-header pkt :dna-session offset)
  
    pkt))
))

#!C
; From file DECNET_SERVERS.LISP#> DECNET; SYS:
#10R DNA#:
(COMPILER-LET ((*PACKAGE* (FIND-PACKAGE "DNA"))
                          (SI:*LISP-MODE* :COMMON-LISP)
                          (*READTABLE* SYS:COMMON-LISP-READTABLE)
                          (SI:*READER-SYMBOL-SUBSTITUTIONS* SYS::*COMMON-LISP-SYMBOL-SUBSTITUTIONS*))
  (COMPILER#:PATCH-SOURCE-FILE "SYS: DECNET; DECNET_SERVERS.#"


(defmethod (pmu-service :deliver) (host-queue host &optional error-p
				   (medium :byte-stream) (contact-name "PMU"))
  (let ((userid "PMU-Mailer")
	;(password "mailer")    ; DAB 03-09-89
	)
    (with-open-stream (stream (host:open-connection-on-medium host medium contact-name
							      :stream-type :ascii-translating-character-stream
							      :error error-p
							      :timeout *pmu-connect-timeout*
							      :user-id userid)) ; DAB 03-09-89 Removed password.
      (if (errorp stream)
	  stream
	  (pmu-mail-client host stream host-queue)))))
))

#!C
; From file NSP_STREAMS.LISP#> DECNET; SYS:
#10R DNA#:
(COMPILER-LET ((*PACKAGE* (FIND-PACKAGE "DNA"))
                          (SI:*LISP-MODE* :COMMON-LISP)
                          (*READTABLE* SYS:COMMON-LISP-READTABLE)
                          (SI:*READER-SYMBOL-SUBSTITUTIONS* SYS::*COMMON-LISP-SYMBOL-SUBSTITUTIONS*))
  (COMPILER#:PATCH-SOURCE-FILE "SYS: DECNET; NSP_STREAMS.#"


(defun nsp-stream-connect-function (host logical-contact-name connection
				    &rest args &key stream-type timeout window-size password user-id
				    &allow-other-keys)
  (declare (ignore connection window-size timeout))
  (let* ((contact-name (net:translate-logical-contact-name logical-contact-name :NSP-STREAM))
	 (stream-type (net:find-stream-type-flavor stream-type :NSP-STREAM))
	 (node-id (parse-dna-address-spec host)))
    (unless (or (and user-id password)  (and user-id (string-equal user-id "PMU-Mailer")))  ; DAB 03-09-89 Should not be required.
	      (multiple-value-setq (user-id password)
		(fs:file-get-password (or user-id si:user-id) (si:parse-host host))))
    (let* ((nbytes 3)
	   (src-format 2)
	   (port (condition-case (condition)
		     (sc-establish-connection :dstnode node-id :nbytes nbytes
					      :format src-format :usrcode 0 :grpcode 0 :descrpt user-id
					      :userid user-id :password password :objtype contact-name)
		   (error nil))))
	   (if port (map-stream-type stream-type port) nil))))
))
