;;; -*- Mode: Common-Lisp; Package: User; Base: 10.; Patch-File: T -*-
;;; Patch file for DECNET version 1.57
;;; Reason: Changed routing-reset to not modify the ethernet address if local-host does not have a decnet address.
;;; Written 03/09/89 04:39:09 by BERGER,
;;; while running on MX29 from band NDAB
;;; With SYSTEM 5.19, GC 5.3, VIRTUAL-MEMORY 5.5, MICRONET 5.5, MICRONET-COMM 5.13,
;;;  DISK-IO 5.9, BASIC-PATHNAME 5.2, MAC-PATHNAME 5.0, NETWORK-SUPPORT-COLD 5.1,
;;;  BASIC-NAMESPACE 5.6, BASIC-FILE 5.3, RPC 5.4, NFS 5.10, EH 5.3, MAKE-SYSTEM 5.2,
;;;  MEMORY-AUX 5.1, MACTOOLBOX 1.25, COMPILER 5.1, TV 5.21, NVRAM 5.1, UCL 5.0, INPUT-EDITOR 5.0,
;;;  METER 5.0, ZWEI 5.9, DEBUG-TOOLS 5.1, WINDOW-MX 5.28, PRINTER 5.11, MAC-PRINTER-TYPES 5.4,
;;;  NETWORK-PATHNAME 5.0, NETWORK-NAMESPACE 5.0, DATALINK 5.7, CHAOSNET 5.6, NETWORK-SUPPORT 5.0,
;;;  NETWORK-SERVICE 5.0, DATALINK-DISPLAYS 5.0, NAMESPACE-EDITOR 5.1, IP 3.33, NFS-SERVER 5.3,
;;;  PRINTER-TYPES 5.2, IMAGEN 5.1, MAIL-DAEMON 5.1, MAIL-READER 5.3, TELNET 5.1,
;;;  VT100 5.0, STREAMER-TAPE 5.6, Inconsistent DECNET 1.54, VISIDOC 5.4, PROFILE 5.1,
;;;  DISK-LABEL 5.1,  microcode 97, Band Name: microExplorer Network (11/22)

#!C
; From file ROUTING.LISP#> DECNET; SYS:
#10R DNA#:
(COMPILER-LET ((*PACKAGE* (FIND-PACKAGE "DNA"))
                          (SI:*LISP-MODE* :COMMON-LISP)
                          (*READTABLE* SYS:COMMON-LISP-READTABLE)
                          (SI:*READER-SYMBOL-SUBSTITUTIONS* SYS::*COMMON-LISP-SYMBOL-SUBSTITUTIONS*))
  (COMPILER#:PATCH-SOURCE-FILE "SYS: DECNET; ROUTING.#"


(defun ROUTING-RESET (&key (enable t) (hard t))
  "Put the DECnet module into a (hopefully) runnable state.  Note that this host's ETHERNET
    address may change if this is the first time that the machine was reset with DECnet installed."
  (when net:controller-list
    (LET* ((newdriverp t)
	   (c (CAR net:controller-list))
	   (enable-p (SEND c :enabled)))
      (dna:disable)
      (dna:reset-on-ethernet-cache)
      (dna:reset-node-counters)
      (dna:setup-my-address)		       ;possibly obsolete ethernet address ;03-08-89 DAB Was below in first statement in progn.
      (WHEN (and (si:mx-p) my-address (not (eql  0 my-address)))  ;03-08-89 DAB Don't change ethernet if we don't have a decnet address.
	(SEND c :disable)
	(send c :set-eaddr (+ hiord_16 (net:swap-bytes my-address)))
	(send c :close)
	(SEND c :initialize)
	(WHEN enable-p
	  (SEND c :enable))
	(setf newdriverp       
	      (equalp (send c :read-eadr)
		      (send c :read-rom-id))))
      (if newdriverp
	  (progn
	    (if hard
		(progn
		  (ethernet:add-protocol dna:*ROUTE-ETHERNET-TYPE* 'Routing-Receiver)
		  (Ethernet:Add-Net-Packet-Allocator
		    dna:*ROUTE-ETHERNET-TYPE* 'CHAOS::ALLOCATE-INT-PKT 'CHAOS::FREE-INT-PKT)
		  (net:reset-packets)
		  (setf *ROUTING-HANDLER* (make-instance 'routing-handler))
		  (net:send-all-controllers :disable)  ;need to permanently flush old controllers using...
		  (Dolist (Cont Net:Controller-List)
		    (Setup-Ethernet-Address Cont))
		  (ethernet:reset-address-translations)	       ;force rebroadcasts of our (new) ethernet address
		  (net:send-all-controllers :reset)
		  (net:send-all-controllers :enable))	
		(send *routing-handler* :reset))
	    (when (and my-address (not (eql 0 my-address)))
	      (set-host-addresses)
	      (reset-hello-xmitter))
	    (when enable
	      (dna:enable))
	    (setup-multicast-addresses)		       ;ab 11/11/88
	    )
	  (tv:notify nil " *** WARNING ***   Unable to initialize or reset DECnet. ~%          You must first install EtherTalk version 1.1")
	  )
      )))
))
