;;; -*- Mode: Common-Lisp; Package: DNA; Base: 10.; Patch-File: T -*-

;;; Reason: DAP-server was returning a  bad length-in-bytes.

;;;                           RESTRICTED RIGHTS LEGEND
;;;
;;; Use, duplication, or disclosure by the Government is subject to
;;; restrictions as set forth in subdivision (c)(1)(ii) of the Rights in
;;; Technical Data and Computer Software clause at 52.227-7013.
;;;
;;;   TEXAS INSTRUMENTS INCORPORATED      
;;;   P.O. BOX 2909, M/S 2151             
;;;   AUSTIN, TEXAS 78769                 
;;;
;;; Copyright (C) 1988 Texas Instruments Incorporated.
;;; All rights reserved.

;;; Written 03/10/89 14:56:29 by BERGER,
;;; while running on ARIES from band LOD1
;;; With NIL SYSTEM 6.0, Experimental VIRTUAL-MEMORY 6.0, Experimental EH 6.0, Experimental MAKE-SYSTEM 6.0,
;;;  Experimental MICRONET 6.0, Experimental LOCAL-FILE 6.0, Experimental BASIC-PATHNAME 6.0,
;;;  Experimental NETWORK-SUPPORT-COLD 6.0, Experimental BASIC-NAMESPACE 6.0, Experimental NETWORK-NAMESPACE 6.0,
;;;  Experimental DISK-IO 6.0, Experimental DISK-LABEL 6.0, Experimental BASIC-FILE 6.0,
;;;  Experimental MAC-PATHNAME 6.0, Experimental NETWORK-PATHNAME 6.0, Experimental COMPILER 6.0,
;;;  Experimental TV 6.0, Experimental DATALINK 6.0, Experimental CHAOSNET 6.0, Experimental GC 6.0,
;;;  Experimental MEMORY-AUX 6.0, Experimental NVRAM 6.0, Experimental SYSLOG 6.0,
;;;  Experimental STREAMER-TAPE 6.0, Experimental CLEH 1.0, Experimental UCL 6.0,
;;;  Experimental INPUT-EDITOR 6.0, Experimental METER 6.0, Experimental ZWEI 6.0,
;;;  Experimental DEBUG-TOOLS 6.0, Experimental NETWORK-SUPPORT 6.0, Experimental NETWORK-SERVICE 6.0,
;;;  DATALINK-DISPLAYS 6.0, Experimental FONT-EDITOR 6.0, Experimental SERIAL 6.0,
;;;  Experimental PRINTER 6.0, Experimental MAC-PRINTER-TYPES 6.0, Experimental PRINTER-TYPES 6.0,
;;;  Experimental IMAGEN 6.0, Experimental SUGGESTIONS 6.0, Experimental MAIL-DAEMON 6.0,
;;;  Experimental MAIL-READER 6.0, Experimental TELNET 6.0, Experimental VT100 6.0,
;;;  Experimental NAMESPACE-EDITOR 6.0, Experimental PROFILE 6.0, VISIDOC 6.0, Experimental TI-CLOS 14.27,
;;;  IP 3.41, Experimental BUG 10.8, Inconsistent DECNET 1.57,  microcode 416, Band Name: rel6.0 1/10 + DNA

#!C
; From file DAP_SERVER.LISP#> DECNET; SYS:
#10R DNA#:
(COMPILER-LET ((*PACKAGE* (FIND-PACKAGE "DNA"))
                          (SI:*LISP-MODE* :COMMON-LISP)
                          (*READTABLE* SYS:COMMON-LISP-READTABLE)
                          (SI:*READER-SYMBOL-SUBSTITUTIONS* SYS::*COMMON-LISP-SYMBOL-SUBSTITUTIONS*))
  (COMPILER#:PATCH-SOURCE-FILE "SYS: DECNET; DAP_SERVER.#"


(DEFMETHOD  (dap-server-stream :server-directory-list) (filespec display)
  (let* ((default (fs:make-pathname :defaults nil  :host si:local-host :device (SEND si:local-host :default-device)
				    :type :unspecific   :version :NEWEST
				    ))
	 (path (send self :decnet-parse-for-server filespec default)))
    (when path
      (server-display "~% Directory-list called for ~a" path)
      (send self :send-name-message volname-nametype "")
      (send self :send-name-message dirname-nametype (send path :string-for-directory))
      (let ((pathname-list (send path :directory-list '(:noerror))))
	(if (not (eql (type-of pathname-list) 'cons))
	    (send self :server-map-error pathname-list)
	    (dolist (element (cdr pathname-list))
	      (send self :send-name-message filename-nametype (send (car element) :string-for-dired))
	      
	      (when (test-display-for-main-attributes display)
		(server-display "~%Dired main attributes message")
		(let* ((bls 1024.)
		       (bszp (get (locf (cdr element)) :byte-size))  ;11-16-88 Dab Could be :default.
		       (bsz (if (numberp bszp) bszp  8))
		       (ebk (or (get (locf (cdr element)) :length-in-blocks) 0))
		       (ffb (or (abs (- (* bls ebk) (or (get (locf (cdr element)) :length-in-bytes)) 0)))))
		  (send self :send-attributes-message (if (get (locf (cdr element)) :characters)
							  ascii-data image-data)
			                              0 nil nil bls nil ebk nil nil nil
						      nil nil 
						      (if (get (locf (cdr element)) :directory)
							  '(5 7) nil)
						      bsz nil nil nil ebk ebk ffb)))
	      
	      (when (test-display-for-key-definition display)
		(server-display "~%Dired key definition attributes message")
		(send self :send-key-definition-attributes))
	      
	      (when (test-display-for-allocation display)
		(server-display "~%Dired allocation attributes message")
		(send self :send-allocation-attributes))
	      
	      (when (test-display-for-summary display) 
		(server-display "~%Dired summary attributes message")
		(send self :send-summary-attributes))
	      
	      (when (test-display-for-date-and-time display)
		(server-display "~%Dired date-and-time attributes message")
		(send self :send-date-time-attributes (get (locf (cdr element)) :creation-date)))
	      (when (test-display-for-protection display)
		
		(server-display "~%Dired protection attributes message")
		(send self :send-protection-attributes (get (locf (cdr element)) :author)))
	      
	      (send self :send-acknowledge-message nil))
	    )))
    (send self :send-access-complete-message cmpfunc-response)))
))
