;;; -*- Mode: Common-Lisp; Package: DNA; Base: 10.; Patch-File: T -*-
;;; Written 04/27/89 13:46:42 by BERGER,
;;; Reason: Fxied :send-name-message and :Send-attribute-message to make sure write-offset is boundp before checking for buffer overflows.
;;; while running on MX29 from band NB22
;;; With SYSTEM 5.19, GC 5.3, VIRTUAL-MEMORY 5.5, MICRONET 5.5, MICRONET-COMM 5.13,
;;;  DISK-IO 5.9, BASIC-PATHNAME 5.2, MAC-PATHNAME 5.0, NETWORK-SUPPORT-COLD 5.1,
;;;  BASIC-NAMESPACE 5.6, BASIC-FILE 5.3, RPC 5.4, NFS 5.10, EH 5.3, MAKE-SYSTEM 5.2,
;;;  MEMORY-AUX 5.1, MACTOOLBOX 1.25, COMPILER 5.1, TV 5.21, NVRAM 5.1, UCL 5.0, INPUT-EDITOR 5.0,
;;;  METER 5.0, ZWEI 5.9, DEBUG-TOOLS 5.1, WINDOW-MX 5.28, PRINTER 5.11, MAC-PRINTER-TYPES 5.4,
;;;  NETWORK-PATHNAME 5.0, NETWORK-NAMESPACE 5.0, DATALINK 5.7, CHAOSNET 5.6, NETWORK-SUPPORT 5.0,
;;;  NETWORK-SERVICE 5.0, DATALINK-DISPLAYS 5.0, NAMESPACE-EDITOR 5.1, IP 3.33, NFS-SERVER 5.3,
;;;  PRINTER-TYPES 5.2, IMAGEN 5.1, MAIL-DAEMON 5.1, MAIL-READER 5.3, TELNET 5.1,
;;;  VT100 5.0, STREAMER-TAPE 5.6, DECNET 1.64, VISIDOC 5.4, PROFILE 5.1, DISK-LABEL 5.1,
;;;   microcode 97, Band Name: microExplorer Network (11/22)

#!C
; From file DAP_FLAVOR.LISP#> DECNET; SYS:
#10R DNA#:
(COMPILER-LET ((*PACKAGE* (FIND-PACKAGE "DNA"))
                          (SI:*LISP-MODE* :COMMON-LISP)
                          (*READTABLE* SYS:COMMON-LISP-READTABLE)
                          (SI:*READER-SYMBOL-SUBSTITUTIONS* SYS::*COMMON-LISP-SYMBOL-SUBSTITUTIONS*))
  (COMPILER#:PATCH-SOURCE-FILE "SYS: DECNET; DAP_FLAVOR.#"


(defmethod  (DAP-basic-stream :send-attributes-message)
	   (&optional (data-type nil) (org nil) (rfm nil) (rat nil) (bls nil) (mrs nil) (alq nil)
	    (bks nil) (fsz nil) (mrn nil) (runsys nil) (deq nil) (fop nil) (bsz nil) (dev nil)
	    (sdc nil) (lrl nil) (hbk nil) (ebk nil) (ffb nil) (sbn nil))
  ;; DAB 04-14-89 Make sure we dont overflow the buffer. We were getting error in DIR on a VAX
  ;; 65 is the max lenght of an attribute record, except for runsys.Runsys can be up to 40 bytes.
  (when (boundp 'write-offset)
    (when (>= (+ write-offset (length runsys) 65)   bufsiz)
      (send self :force-output-header)))
  (let ((fop-ex-field 0)
	(dev-ex-field 0))
    (dolist (bit-pos fop) (when bit-pos (setf fop-ex-field (dpb 1 (byte 1 bit-pos) fop-ex-field))))
    (dolist (bit-pos dev) (when bit-pos (setf dev-ex-field (dpb 1 (byte 1 bit-pos) dev-ex-field))))

    (multiple-value-bind (header offset)
      (send self :get-output-header)
    (setf offset (setup-operator-field header DAP-attributes-message offset nil 0))
    (setf offset (setup-attributes-message header offset
		    data-type	           ;Data type
			 org		   ;File organization
			 rfm		   ;Record format
			 rat		   ;Record attributes
			 bls		   ;Physical block size
			 mrs		   ;Length of each file record in number of bytes.
			 alq		   ;Allocation quantity
			 bks		   ;Bucket size in blocks
			 fsz		   ;Size in bytes of the fixed part of variable length record.
			 mrn		   ;Maximum record number for file (relative files only)
			 runsys		   ;Name of the runtime system environment required to execute this code.
			 deq		   ;File extension quantum size in virtual blocks
			        	   ;File access options.
			 (if fop fop-ex-field nil)
			 bsz		   ;Number of bits per bute for data stored in the file on the accessed node.
			 		   ;Generic characteristics of the device on which a file resides.
			 (if dev dev-ex-field nil)
			 sdc		   ;Spooling device characteristics
			 lrl		   ;Length of the longest record in the file.
			 hbk		   ;Highest virtual block allocated to the file.
			 ebk		   ;End of file virtual block number.
			 ffb		   ;First free byte in end of file block. (byte size as determined in BSZ)
			 sbn))		   ;Starting logical block number for file if contiguous
    (send self :set-output-header-length offset)
    )))


(defmethod (DAP-basic-stream :send-name-message) (nametype string)
  (when (boundp 'write-offset)
    (when (>= (+ write-offset (length string) 10)   bufsiz) ; DAB 04-11-89 Make sure we dont overflow the buffer. We were getting error in DIR on a VAX
      (send self :force-output-header)))                     ;of a large directory on an Explorer.
  (multiple-value-bind (header offset)
      (send self :get-output-header)
    (setf offset (setup-operator-field header DAP-name-message offset nil 0))
    (setf offset (setup-name-message header offset nametype string))
    (send self :set-output-header-length offset)
    ))

))
