;;; -*- Mode: Common-Lisp; Package: User; Base: 10.; Patch-File: T -*-
;;; Written 05/05/89 21:49:04 by jones,
;;; Reason: Re-enable the network controller when disabling Decnet because the Ethernet address is not set.
;;; while running on HOBBS from band LOD1
;;; With SYSTEM 5.29, GC 5.4, VIRTUAL-MEMORY 5.5, MICRONET 5.6, MICRONET-COMM 5.14,
;;;  DISK-IO 5.11, BASIC-PATHNAME 5.4, MAC-PATHNAME 5.1, NETWORK-SUPPORT-COLD 5.3,
;;;  BASIC-NAMESPACE 5.10, BASIC-FILE 5.5, RPC 5.7, NFS 5.20, EH 5.4, MAKE-SYSTEM 5.4,
;;;  MEMORY-AUX 5.1, MACTOOLBOX 1.36, COMPILER 5.4, TV 5.29, NVRAM 5.3, UCL 5.0, INPUT-EDITOR 5.1,
;;;  METER 5.1, ZWEI 5.14, DEBUG-TOOLS 5.1, WINDOW-MX 5.38, PRINTER 5.12, MAC-PRINTER-TYPES 5.5,
;;;  NETWORK-PATHNAME 5.1, NETWORK-NAMESPACE 5.2, DATALINK 5.10, CHAOSNET 5.6, NETWORK-SUPPORT 5.1,
;;;  NETWORK-SERVICE 5.1, DATALINK-DISPLAYS 5.0, NAMESPACE-EDITOR 5.2, IP 3.42, NFS-SERVER 5.3,
;;;  PRINTER-TYPES 5.5, IMAGEN 5.3, MAIL-DAEMON 5.8, MAIL-READER 5.6, TELNET 5.3,
;;;  VT100 5.1, STREAMER-TAPE 5.8, DECNET 1.64, VISIDOC 5.6, PROFILE 5.1, DISK-LABEL 5.2,
;;;  MX-SERIAL 1.1, MX-DATALINK 2.2, Experimental FAST-RPC 1.5,  microcode 126, Band Name: n414+aux

#!C
; From file ROUTING.LISP#> DECNET; WOODY:
#10R DNA#:
(COMPILER-LET ((*PACKAGE* (FIND-PACKAGE "DNA"))
                          (SI:*LISP-MODE* :Common-lisp)
                          (*READTABLE* Sys:Common-lisp-readtable)
                          (SI:*READER-SYMBOL-SUBSTITUTIONS* Sys::*common-lisp-symbol-substitutions*))
  (COMPILER#:PATCH-SOURCE-FILE "DECNET: DECNET; ROUTING.#"


(defun ROUTING-RESET (&key (enable t) (hard t))
  "Put the DECnet module into a (hopefully) runnable state.  Note that this host's ETHERNET
    address may change if this is the first time that the machine was reset with DECnet installed."
  (when net:controller-list
    (dna:disable)
    (dna:reset-on-ethernet-cache)
    (dna:reset-node-counters)
    (dna:setup-my-address)
    (unless (or (null my-address) (zerop my-address))
      (if hard
	  (progn
	    ;; Don't keep trying to set the Ethernet address on a microExplorer. *BJ*
	    (when *routing-reset-inhibit*
	      (tv:notify nil "Decnet is disabled until after the next Macintosh boot.")
	      (return-from routing-reset nil))
	    
	    (ethernet:add-protocol dna:*ROUTE-ETHERNET-TYPE* 'Routing-Receiver)
	    (Ethernet:Add-Net-Packet-Allocator
	      dna:*ROUTE-ETHERNET-TYPE* 'CHAOS::ALLOCATE-INT-PKT 'CHAOS::FREE-INT-PKT)
	    (net:reset-packets)
	    (setf *ROUTING-HANDLER* (make-instance 'routing-handler))
	    (net:send-all-controllers :disable)	       ;need to permanently flush old controllers using...
	    (Dolist (Cont Net:Controller-List)
	      (when (and (not (Setup-Ethernet-Address Cont)) (si:mx-p) )
		;; If the address was not set on an MX then disable decnet.
		(setf my-address 0)
		(setf *routing-reset-inhibit* t)))
	    (ethernet:reset-address-translations)      ;force rebroadcasts of our (new) ethernet address
	    (net:send-all-controllers :reset)
	    (net:send-all-controllers :enable))	
	  (send *routing-handler* :reset))
      (when (not *routing-reset-inhibit*)
	(reset-hello-xmitter)
	(set-host-addresses)
	(when enable
	  (dna:enable))
	(setup-multicast-addresses)))
    ))

))
