;;; -*- Mode: Common-Lisp; Package: DNA; Base: 10.; Patch-File: T -*-

;;; Reason:  Changed (DAP-basic-stream :send-attribute-message) and (DAP-basic-stream :send-name-message) to use variable-boundp instead of boundp.

;;;                           RESTRICTED RIGHTS LEGEND
;;;
;;; Use, duplication, or disclosure by the Government is subject to
;;; restrictions as set forth in subdivision (c)(1)(ii) of the Rights in
;;; Technical Data and Computer Software clause at 52.227-7013.
;;;
;;;   TEXAS INSTRUMENTS INCORPORATED      
;;;   P.O. BOX 2909, M/S 2151             
;;;   AUSTIN, TEXAS 78769                 
;;;
;;; Copyright (C) 1989 Texas Instruments Incorporated.
;;; All rights reserved.

;;; Written 05/11/89 08:01:59 by BERGER,
;;; while running on ARIES from band LOD1
;;; With Experimental REL6G 6.8, Experimental SYSTEM 6.0, Experimental VIRTUAL-MEMORY 6.0,
;;;  Experimental EH 6.0, Experimental MAKE-SYSTEM 6.0, Experimental MICRONET 6.0,
;;;  Experimental LOCAL-FILE 6.0, Experimental BASIC-PATHNAME 6.0, Experimental NETWORK-SUPPORT-COLD 6.0,
;;;  Experimental BASIC-NAMESPACE 6.0, Experimental NETWORK-NAMESPACE 6.0, Experimental DISK-IO 6.0,
;;;  Experimental DISK-LABEL 6.0, Experimental BASIC-FILE 6.0, Experimental MAC-PATHNAME 6.0,
;;;  Experimental NETWORK-PATHNAME 6.0, Experimental COMPILER 6.0, Experimental TV 6.0,
;;;  Experimental DATALINK 6.0, Experimental CHAOSNET 6.0, Experimental GC 6.0, Experimental MEMORY-AUX 6.0,
;;;  Experimental NVRAM 6.0, Experimental SYSLOG 6.0, Experimental STREAMER-TAPE 6.0,
;;;  Experimental CLEH 1.0, Experimental UCL 6.0, Experimental INPUT-EDITOR 6.0, Experimental METER 6.0,
;;;  Experimental ZWEI 6.0, Experimental DEBUG-TOOLS 6.0, Experimental NETWORK-SUPPORT 6.0,
;;;  Experimental NETWORK-SERVICE 6.0, DATALINK-DISPLAYS 6.0, Experimental FONT-EDITOR 6.0,
;;;  Experimental SERIAL 6.0, Experimental PRINTER 6.0, Experimental MAC-PRINTER-TYPES 6.0,
;;;  Experimental PRINTER-TYPES 6.0, Experimental IMAGEN 6.0, Experimental SUGGESTIONS 6.0,
;;;  Experimental MAIL-DAEMON 6.0, Experimental MAIL-READER 6.0, Experimental TELNET 6.0,
;;;  Experimental VT100 6.0, Experimental NAMESPACE-EDITOR 6.0, Experimental PROFILE 6.0,
;;;  VISIDOC 6.0, Experimental TI-CLOS 16.7, Experimental CLX 4.0, Experimental X11M 2.1,
;;;  Experimental CLUE 19.1, Experimental RPC 6.0, NFS 3.5, Experimental BUG 11.4,
;;;  IP 3.45, Inconsistent DECNET 1.66,  microcode 423, Band Name: 6.0 4/19 SLE,DNA,
;;; NP2

#!C
; From file DAP_FLAVOR.LISP#> DECNET; SYS:
#10R DNA#:
(COMPILER-LET ((*PACKAGE* (FIND-PACKAGE "DNA"))
                          (SI:*LISP-MODE* :COMMON-LISP)
                          (*READTABLE* SYS:COMMON-LISP-READTABLE)
                          (SI:*READER-SYMBOL-SUBSTITUTIONS* SYS::*COMMON-LISP-SYMBOL-SUBSTITUTIONS*))
  (COMPILER#:PATCH-SOURCE-FILE "SYS: DECNET; DAP_FLAVOR.#"


(defmethod (DAP-basic-stream :send-name-message) (nametype string)
  (when (variable-boundp write-offset)  ; DAB 04-27-89 ; DAB 05-11-89
    (when (>= (+ write-offset (length string) 10)   bufsiz) ; DAB 04-11-89 Make sure we dont overflow the buffer. We were getting error in DIR on a VAX
      (send self :force-output-header)))                     ;of a large directory on an Explorer.
  (multiple-value-bind (header offset)
      (send self :get-output-header)
    (setf offset (setup-operator-field header DAP-name-message offset nil 0))
    (setf offset (setup-name-message header offset nametype string))
    (send self :set-output-header-length offset)
    ))


(defmethod  (DAP-basic-stream :send-attributes-message)
	   (&optional (data-type nil) (org nil) (rfm nil) (rat nil) (bls nil) (mrs nil) (alq nil)
	    (bks nil) (fsz nil) (mrn nil) (runsys nil) (deq nil) (fop nil) (bsz nil) (dev nil)
	    (sdc nil) (lrl nil) (hbk nil) (ebk nil) (ffb nil) (sbn nil))
  ;; DAB 04-14-89 Make sure we dont overflow the buffer. We were getting error in DIR on a VAX
  ;; 65 is the max lenght of an attribute record, except for runsys.Runsys can be up to 40 bytes.
  (when (variable-boundp write-offset)  ; DAB 04-27-89
    (when (>= (+ write-offset (length runsys) 65)   bufsiz)
      (send self :force-output-header)))
  (let ((fop-ex-field 0)
	(dev-ex-field 0))
    (dolist (bit-pos fop) (when bit-pos (setf fop-ex-field (dpb 1 (byte 1 bit-pos) fop-ex-field))))
    (dolist (bit-pos dev) (when bit-pos (setf dev-ex-field (dpb 1 (byte 1 bit-pos) dev-ex-field))))

    (multiple-value-bind (header offset)
      (send self :get-output-header)
    (setf offset (setup-operator-field header DAP-attributes-message offset nil 0))
    (setf offset (setup-attributes-message header offset
		    data-type	           ;Data type
			 org		   ;File organization
			 rfm		   ;Record format
			 rat		   ;Record attributes
			 bls		   ;Physical block size
			 mrs		   ;Length of each file record in number of bytes.
			 alq		   ;Allocation quantity
			 bks		   ;Bucket size in blocks
			 fsz		   ;Size in bytes of the fixed part of variable length record.
			 mrn		   ;Maximum record number for file (relative files only)
			 runsys		   ;Name of the runtime system environment required to execute this code.
			 deq		   ;File extension quantum size in virtual blocks
			        	   ;File access options.
			 (if fop fop-ex-field nil)
			 bsz		   ;Number of bits per bute for data stored in the file on the accessed node.
			 		   ;Generic characteristics of the device on which a file resides.
			 (if dev dev-ex-field nil)
			 sdc		   ;Spooling device characteristics
			 lrl		   ;Length of the longest record in the file.
			 hbk		   ;Highest virtual block allocated to the file.
			 ebk		   ;End of file virtual block number.
			 ffb		   ;First free byte in end of file block. (byte size as determined in BSZ)
			 sbn))		   ;Starting logical block number for file if contiguous
    (send self :set-output-header-length offset)
    )))
))
