;;; -*- Mode: Common-Lisp; Package: User; Base: 10.; Patch-File: T -*-

;;; Reason: Fix for toggling end nodes and router nodes in peek.    06/12/89  LER

;;;                           RESTRICTED RIGHTS LEGEND
;;;
;;; Use, duplication, or disclosure by the Government is subject to
;;; restrictions as set forth in subdivision (c)(1)(ii) of the Rights in
;;; Technical Data and Computer Software clause at 52.227-7013.
;;;
;;;   TEXAS INSTRUMENTS INCORPORATED      
;;;   P.O. BOX 2909, M/S 2151             
;;;   AUSTIN, TEXAS 78769                 
;;;
;;; Copyright (C) 1989 Texas Instruments Incorporated.
;;; All rights reserved.

;;; Written 06/12/89 06:08:15 by REINER,
;;; while running on MX30 from band DEC 
;;; With SYSTEM 6.2, GC 6.0, VIRTUAL-MEMORY 6.0, MICRONET 6.0, MICRONET-COMM 6.0,
;;;  DISK-IO 6.0, DISK-LABEL 6.0, BASIC-PATHNAME 6.0, MAC-PATHNAME 6.0, NETWORK-SUPPORT-COLD 6.0,
;;;  BASIC-NAMESPACE 6.0, BASIC-FILE 6.0, RPC 6.0, NFS 6.0, EH 6.0, MAKE-SYSTEM 6.0,
;;;  MEMORY-AUX 6.0, COMPILER 6.1, TV 6.6, NVRAM 6.0, UCL 6.0, INPUT-EDITOR 6.0, MACTOOLBOX 2.0,
;;;  METER 6.0, ZWEI 6.0, DEBUG-TOOLS 6.0, WINDOW-MX 6.0, PRINTER 6.0, MAC-PRINTER-TYPES 6.0,
;;;  CLIPBOARD 6.0, NETWORK-PATHNAME 6.0, NETWORK-NAMESPACE 6.0, DATALINK 6.0, CHAOSNET 6.0,
;;;  NETWORK-SUPPORT 6.0, NETWORK-SERVICE 6.0, DATALINK-DISPLAYS 6.0, Inconsistent MX-DATALINK 6.1,
;;;  NAMESPACE-EDITOR 6.0, IP 3.42, NFS-SERVER 6.0, MX-SERIAL 6.0, PRINTER-TYPES 6.0,
;;;  IMAGEN 6.0, MAIL-DAEMON 6.2, MAIL-READER 6.0, TELNET 6.0, VT100 6.0, STREAMER-TAPE 6.0,
;;;  DECNET 1.65, VISIDOC 6.0, PROFILE 6.1, TI-CLOS 6.3, CLEH 6.0, CLX 6.0, CLUE 6.0,
;;;  Experimental BUG 11.5,  microcode 138, Band Name: Release 6.0 mx 5/26

#!C
; From file ROUTING.LISP#> DECNET; SYS:
#10R DNA#:
(COMPILER-LET ((*PACKAGE* (FIND-PACKAGE "DNA"))
                          (SI:*LISP-MODE* :COMMON-LISP)
                          (*READTABLE* SYS:COMMON-LISP-READTABLE)
                          (SI:*READER-SYMBOL-SUBSTITUTIONS* SYS::*COMMON-LISP-SYMBOL-SUBSTITUTIONS*))
  (COMPILER#:PATCH-SOURCE-FILE "DECNET: DECNET; ROUTING.#"


(defun ROUTING-RESET (&key (enable t) (hard t))
  "Put the DECnet module into a (hopefully) runnable state.  Note that this host's ETHERNET
    address may change if this is the first time that the machine was reset with DECnet installed."
  (when net:controller-list
    (dna:disable)
    (dna:reset-on-ethernet-cache)
    (dna:reset-node-counters)
    (dna:setup-my-address)
    (unless (or (null my-address) (zerop my-address))
      (if hard
	  (progn
	    ;; Don't keep trying to set the Ethernet address on a microExplorer. *BJ*
	    (when *routing-reset-inhibit*
	      (tv:notify nil "Decnet is disabled until after the next Macintosh boot.")
	      (return-from routing-reset nil))
	    
	    (ethernet:add-protocol dna:*ROUTE-ETHERNET-TYPE* 'Routing-Receiver)
	    (Ethernet:Add-Net-Packet-Allocator
	      dna:*ROUTE-ETHERNET-TYPE* 'CHAOS::ALLOCATE-INT-PKT 'CHAOS::FREE-INT-PKT)
	    (net:reset-packets)
	    (setf *ROUTING-HANDLER* (make-instance 'routing-handler))
	    (net:send-all-controllers :disable)	       ;need to permanently flush old controllers using...
	    (Dolist (Cont Net:Controller-List)
              (send cont :enabled)
              (when (si:mx-p)
                (send cont :disable)
                (send cont :close)
                (send cont :initialize))
	      (when (and (not (Setup-Ethernet-Address Cont)) (si:mx-p) )
		;; If the address was not set on an MX then disable decnet.
		(setf my-address 0)
		(setf *routing-reset-inhibit* t)))
	    (ethernet:reset-address-translations)      ;force rebroadcasts of our (new) ethernet address
	    (net:send-all-controllers :reset)
	    (net:send-all-controllers :enable))	
	  (send *routing-handler* :reset))
      (when (not *routing-reset-inhibit*)
	(reset-hello-xmitter)
	(set-host-addresses)
	(when enable
	  (dna:enable))
	(setup-multicast-addresses)))
    ))

))
