;;; -*- Mode: Common-Lisp; Package: User; Base: 10.; Patch-File: T -*-

;;;			      RESTRICTED RIGHTS LEGEND

;;;Use, duplication, or disclosure by the Government is subject to
;;;restrictions as set forth in subdivision (b)(3)(ii) of the Rights in
;;;Technical Data and Computer Software clause at 52.227-7013.
;;;
;;;			TEXAS INSTRUMENTS INCORPORATED.
;;;				 P.O. BOX 2909
;;;			      AUSTIN, TEXAS 78769
;;;				    MS 2151
;;;
;;; Copyright (C) 1987 Texas Instruments Incorporated. All rights reserved.

;;; Patch file for DECNET version 1.7
;;; Reason: Add the value for the low water position to blocked read-data messages
;;; and the value for the horizontal position to write-completion messages.
;;; VMS-EMACS requires this. 
;;; Code read by CRW and BRG.
;;; Written 07/09/87 10:19:50 by WALTON,
;;; while running on CHARLIE from band LODA
;;; With IO 3.22, PATHNAME 3.15, FILE 3.8, SYSTEM 3.43, METER 3.1, SERIAL 3.0, CHAOSNET 3.10,
;;;  ETHERNET 3.0, GC 3.8, IMAGEN 3.0, MAIL-DAEMON 3.1, NETWORK-SUPPORT 3.7, PROFILE 3.0,
;;;  SUGGESTIONS 3.3, UCL 3.0, ZWEI 3.7, STREAMER-TAPE 3.5, DEBUG-TOOLS 3.1, FONT-EDITOR 3.1,
;;;  GLOSSARY 3.0, INPUT-EDITOR 3.0, MAIL-READER 3.2, NAMESPACE-EDITOR 3.4, NVRAM 3.1,
;;;  TELNET 3.3, TV 3.6, NAMESPACE 3.7, COMPILER 3.19, PRINTER 3.1, SYSLOG 3.0, VT100 3.5,
;;;  IP 2.44, Experimental BUG 4.10, DECNET 1.6,  microcode 355, Band Name: Release 3.0 - 6/17+ip

#!C
; From file CTERM_FLAVOR.LISP#> DECNET; SYS:
#10R DNA#:
(COMPILER-LET ((*PACKAGE* (FIND-PACKAGE "DNA"))
                          (SI:*LISP-MODE* :COMMON-LISP)
                          (*READTABLE* SYS:COMMON-LISP-READTABLE)
                          (SI:*READER-SYMBOL-SUBSTITUTIONS* SYS::*COMMON-LISP-SYMBOL-SUBSTITUTIONS*))
  (COMPILER#:PATCH-SOURCE-FILE "SYS: DECNET; CTERM_FLAVOR.#"


(defmethod (cterm-stream :add-missing-field-values) (buffer data-len)
  (let* ((len-offset 2)(term-pos-offset 10.)(low-water-offset 6.)
	 (next-msglen (- data-len 4))	           ;4 = 2 byte discard-state-msg + 2 byte length field
	 (term-pos (- next-msglen 9.)))	           ;8 = msgtype + flags + 2 byte low-water + vertpos
					           ;     + horizpos + 2 byte termpos fields
                                                   ;    + INDEX BUMP = 9
    (cterm-set-2-bytes buffer len-offset next-msglen)
    (if (eql system-type ':VMS4)
	(progn
	  (cterm-set-2-bytes buffer low-water-offset term-pos)
	  (cterm-set-2-bytes buffer term-pos-offset term-pos))
	(cterm-set-2-bytes buffer term-pos-offset (incf term-pos)))))

))

#!C
; From file CTERM_MSG_HANDLER.LISP#> DECNET; SYS:
#10R DNA#:
(COMPILER-LET ((*PACKAGE* (FIND-PACKAGE "DNA"))
                          (SI:*LISP-MODE* :COMMON-LISP)
                          (*READTABLE* SYS:COMMON-LISP-READTABLE)
                          (SI:*READER-SYMBOL-SUBSTITUTIONS* SYS::*COMMON-LISP-SYMBOL-SUBSTITUTIONS*))
  (COMPILER#:PATCH-SOURCE-FILE "SYS: DECNET; CTERM_MSG_HANDLER.#"


(defmethod (Cterm-stream :send-blocked-done-msg)(&optional (horiz-pos 0))
  (unless (eql system-type ':UNIX-UCB)
    (let* ((header (get-new-pkt-hdr))
	   (pkt (array-leader header 0))
	   (offset 0)(next-msglen 6.))
      (setf offset (setup-discard-state-message header offset))
      (setf offset (set-2-bytes header next-msglen offset)) 
      (setf offset (setup-write-completion-message header offset nil horiz-pos))
      (get-application-header pkt :DATA offset)	   ;setup header length for this message.
      (send self :transmit-packet pkt))))

))
