;;; -*- Mode: Common-Lisp; Package: User; Base: 10.; Patch-File: T -*-

;;;			      RESTRICTED RIGHTS LEGEND

;;;Use, duplication, or disclosure by the Government is subject to
;;;restrictions as set forth in subdivision (b)(3)(ii) of the Rights in
;;;Technical Data and Computer Software clause at 52.227-7013.
;;;
;;;			TEXAS INSTRUMENTS INCORPORATED.
;;;				 P.O. BOX 2909
;;;			      AUSTIN, TEXAS 78769
;;;				    MS 2151
;;;
;;; Copyright (C) 1987 Texas Instruments Incorporated. All rights reserved.

;;; Written 07/10/87 09:51:46 by WALTON,
;;; Reason: Change loopback server to not allocate a return loopdata packet
;;; until the client sends one. This is necessary because the client
;;; side may time out and not send the data after waking up the
;;; loopback server.  Code read by CRW and BRG.
;;; while running on CHARLIE from band LODA
;;; With IO 3.22, PATHNAME 3.16, FILE 3.8, SYSTEM 3.43, METER 3.1, SERIAL 3.0, CHAOSNET 3.10,
;;;  ETHERNET 3.0, GC 3.8, IMAGEN 3.0, MAIL-DAEMON 3.1, NETWORK-SUPPORT 3.7, PROFILE 3.0,
;;;  SUGGESTIONS 3.3, UCL 3.0, ZWEI 3.12, STREAMER-TAPE 3.5, DEBUG-TOOLS 3.1, FONT-EDITOR 3.1,
;;;  GLOSSARY 3.0, INPUT-EDITOR 3.0, MAIL-READER 3.2, NAMESPACE-EDITOR 3.4, NVRAM 3.1,
;;;  TELNET 3.3, TV 3.6, NAMESPACE 3.7, COMPILER 3.19, PRINTER 3.2, SYSLOG 3.0, VT100 3.5,
;;;  IP 2.44, Experimental BUG 4.10, DECNET 1.7,  microcode 355, Band Name: Release 3.0 - 6/17+ip

#!C
; From file NCP.LISP#> DECNET; SYS:
#10R DNA#:
(COMPILER-LET ((*PACKAGE* (FIND-PACKAGE "DNA"))
                          (SI:*LISP-MODE* :COMMON-LISP)
                          (*READTABLE* SYS:COMMON-LISP-READTABLE)
                          (SI:*READER-SYMBOL-SUBSTITUTIONS* SYS::*COMMON-LISP-SYMBOL-SUBSTITUTIONS*))
  (COMPILER#:PATCH-SOURCE-FILE "SYS: DECNET; NCP.#"


(defun net-mgr-server ()
  (let ((port (host:listen-for-connection-on-medium
		:nsp-stream "loopback"
		:stream-type :port)))
    (let* ((accept-pkt (allocate-special-pkt :kind :ACCEPT))
	   (appl-header (get-application-header accept-pkt :end-user 2.)))
      (set-two-byte-field loop-length appl-header 0.) ; set max-loop-size default in the accept-data-pkt
      (send port :accept accept-pkt)
      
      ;keep returning loopback data pkts until NSP closes the port
      (loop
	(let* ((BOM-flag t)(EOM-flag t)(xmt-header nil)(received-header nil)
	       (received-pkt (send port :data-rcv))	          ;host loopback data pkt
	       (xmt-pkt nil))	  
	
	  (when received-pkt
	    (setq xmt-pkt (allocate-special-pkt :kind :DATA))	   ;server loopback return data pkt
	    (get-session-header xmt-pkt :DNA-SESSION 0.)   	        
	    (setq received-header (get-nsp-data received-pkt))
	    (setq xmt-header (get-application-header xmt-pkt :end-user (array-length received-header)))
	    (load-looped-data xmt-header received-header (ARRAY-LENGTH received-header))
	    (SEND port :data-xmt xmt-pkt BOM-flag EOM-flag)
	    (return-pkt received-pkt))
	  
	  (when (neq (send port :state) :RUNNING)
	    (return nil)))))
    (send port :close)))

))
