;;;  -*- Mode:Common-Lisp; Package:EH; Base:10 -*-

;;;                           RESTRICTED RIGHTS LEGEND

;;;Use, duplication, or disclosure by the Government is subject to
;;;restrictions as set forth in subdivision (c)(1)(ii) of the Rights in
;;;Technical Data and Computer Software clause at 52.227-7013.
;;;
;;;                     TEXAS INSTRUMENTS INCORPORATED.
;;;                              P.O. BOX 2909
;;;                           AUSTIN, TEXAS 78769
;;;                                 MS 2151
;;;
;;; Copyright (C) 1989 Texas Instruments Incorporated. All rights reserved.

;;;
;;;  System definition for the Rel 3 error-handler.
;;;
;;;
;;;  Here's the old one.

;(DEFSYSTEM EH
;  (:NAME "Error Handler")
;  (:SHORT-NAME "EH")
;  (:NICKNAMES "EH")
;  (:PACKAGE EH)
;  (:PATHNAME-DEFAULT "SYS:EH;")
;  (:PATCHABLE "SYS:PATCH-EH;" PATCH)
;  (:COMPILE-LOAD ("EH" "EHF" "EHC" "ucl-ehc")))

;;;create the conditions(cleh) package so that references to it in the new eh code
;;;wont barf

(UNLESS (FIND-PACKAGE "CONDITIONS")
  (make-package 'conditions :nicknames '("CLEH")))

;;;
;;;  Here's the new one.

(DEFSYSTEM EH
  (:NAME "Error Handler")
  (:SHORT-NAME "EH")
  (:NICKNAMES "EH")
  (:PACKAGE EH)
  (:PATHNAME-DEFAULT "SYS:EH;")
  (:warnings-pathname-default "SYS: CWARNS; EH.LISP")  ;; las 06.24.87
  (:PATCHABLE "SYS:PATCH.EH;" PATCH)

  (:module defs       "eh-defs")
  (:module prims      ("eh-initialize" "sg-pdl-contents" "run-erring-sg" "symeval-in-stack-group"))
  (:module warm-init  "eh-initialize-warm")
  (:module examine    "sg-args-locals-function")
  (:module signal     "condition-signalling")
  (:module sg	      "error-handler-stack-groups")
  (:module commands   ("debugger-commands" "eh-debug"))
  (:module zmacs      "insert-delete")
  (:module misc	      "breakon")
  (:module conditions "error-condition-definitions")

  (:compile-load defs)
  (:compile-load warm-init)
  (:compile-load prims    (:fasload defs))
  (:compile-load examine  (:fasload defs prims))
  (:compile-load signal	  (:fasload defs prims examine))
  (:compile-load sg	  (:fasload defs prims examine signal))
  (:compile-load commands (:fasload defs prims examine signal sg))
  (:compile  zmacs	  (:fasload defs prims))
  (:compile-load misc	  (:fasload defs prims))
  ;;  This file doesn't really depend on all the others, but these dependencies
  ;;  ensure that it won't be loaded in a :noload situation, which is important
  ;;  in a cross-compilation because flavors aren't handled properly at all.
  (:compile-load conditions (:fasload defs prims examine signal sg commands misc)))
