;;; -*- Mode:Common-Lisp; Package:EH; Fonts:(CPTFONT HL12B HL12BI); Base:10; Cold-Load:T -*-



;;;                           RESTRICTED RIGHTS LEGEND

;;;Use, duplication, or disclosure by the Government is subject to
;;;restrictions as set forth in subdivision (c)(1)(ii) of the Rights in
;;;Technical Data and Computer Software clause at 52.227-7013.
;;;
;;;                     TEXAS INSTRUMENTS INCORPORATED.
;;;                              P.O. BOX 2909
;;;                           AUSTIN, TEXAS 78769
;;;                                 MS 2151
;;;
;;; Copyright (C) 1984-1989 Texas Instruments Incorporated. All rights reserved.
;1;; Copyright (c) 1981 Massachusetts Institute of Technology 


;; New error handler.
;;*
;;;History of changes:
;;;  06/25/87  clm    Added (proclaim '(special %call-state-length)).
;;;  06/29/88  clm    Renamed "turd-alert" error to NO-CURRENTLY-PREPARED-SHEET-ERROR.
;;;  09/26/88  clm    The command dispatch table is taking up 16 blocks of the load band.
;;;                   Space on the MX is critical, so add form to full-gc-initialization-list
;;;                   to remove the table at gc time.


(export '(*ABORT-OBJECT*			; Variables and functions that are used outside the EH.
	  *BREAKON-FUNCTIONS*
	  *CONDITION-DEFAULT-HANDLERS*
	  *CONDITION-HANDLERS*
	  *CONDITION-PROCEED-TYPES*
	  *CONDITION-RESUME-HANDLERS*
	  *CURRENT-STACK-GROUP*
	  *CURRENT-STACK-GROUP-RESUMER*
	  *DATA-TYPE-NAMES*
	  *DEBUG-IO-OVERRIDE*
	  *DEFAULT-BUG-REPORT-FRAMES*
	  *DISASSEMBLE-INSTRUCTION-COUNT*
	  *ENABLE-TRANS-TRAP-DWIM*
	  *ENTER-WINDOW-DEBUGGER*
	  *ERRING-FRAME*
	  *ERRING-SG*
	  *ERROR-BACKTRACE-LENGTH*
	  *ERROR-DEPTH*
	  *ERROR-HANDLER-AREA*
	  *ERROR-MESSAGE-HOOK*
	  *ERROR-OBJECT*
	  *ERROR-SG*
	  *ERRSET*
	  *ERRSET-INSIDE-ERROR*
	  *ERRSET-PRINT-MSG*
	  *ERRSET-STATUS*
	  *INHIBIT-DEBUGGER-PROCEED-PROMPT*
	  *PDL-GROW-RATIO*
	  *PROCESSOR-UCODE-NAME-ALIST*
	  *READING-COMMAND*
	  *SG-STEPPING-TABLE*
	  *TRACE-CONDITIONS*
	  *UNINTERESTING-FUNCTIONS*
	  *USE-FSH-SAFE*
	  *USE-OLD-DEBUGGER*
	  ARG
	  ARG-NAME
	  CELL-LOCATION-IN-STACK-GROUP
	  CONDITION-NAME-HANDLED-P
	  CONDITION-RESUME-TYPES
	  CURRENT-FUNCTION-NAME
	  DEBUG
	  FUN
	  INVOKE-DEBUGGER
	  INVOKE-RESTART-HANDLERS
	  INVOKE-RESUME-HANDLER
	  LOC
	  LOCAL-NAME
	  MAKE-CONDITION-FUNCTION
	  PDL-GROW-RATIO
	  PUSH-NEW-FRAME
	  REST-ARG-NAME
	  RESTORE-SCREEN-FOR-COLD-LOAD-STREAM
	  SAVE-SCREEN-FOR-COLD-LOAD-STREAM
	  SET-IN-STACK-GROUP
	  SG-APPLY-NO-TRAP
	  SG-EVAL-IN-FRAME
	  SG-FRAME-ARG-VALUE
	  SG-FRAME-LOCAL-VALUE
	  SG-FRAME-SPECIAL-PDL-RANGE
	  SG-FRAME-VALUE-VALUE
	  SG-FUNCALL-IN-FRAME
	  SG-GROW-PDL
	  SG-INNERMOST-ACTIVE
	  SG-INNERMOST-FRAME
	  SG-MAYBE-GROW-PDLS
	  SG-NEXT-ACTIVE
	  SG-NEXT-FRAME
	  SG-NEXT-INTERESTING-ACTIVE
	  SG-NEXT-INTERESTING-FRAME
	  SG-NUMBER-OF-LOCALS
	  SG-NUMBER-OF-SPREAD-ARGS
	  SG-OUT-TO-INTERESTING-ACTIVE
	  SG-OUT-TO-INTERESTING-FRAME
	  SG-PREVIOUS-ACTIVE
	  SG-PREVIOUS-FRAME
	  SG-PREVIOUS-INTERESTING-ACTIVE
	  SG-PREVIOUS-INTERESTING-FRAME
	  SG-PREVIOUS-NTH-ACTIVE
	  SG-PREVIOUS-NTH-FRAME
	  SG-PREVIOUS-NTH-INTERESTING-ACTIVE
	  SG-PREVIOUS-NTH-INTERESTING-FRAME
	  SG-REST-ARG-VALUE
	  SG-RESTORE-STATE
	  SG-SAVE-STATE
	  SG-UNWIND
	  SG-UNWIND-TO-FRAME
	  SG-UNWIND-TO-FRAME-AND-REINVOKE
	  SYMBOL-FROM-VALUE-CELL-LOCATION
	  THROW-TRAP-ERROR
	  UNWIND-SG
	  VAL
	  VALUE-NAME

	  ARG-TYPE-ERROR			1; Flavor and signal names that might be used outside the EH.*
	  ARRAY-NUMBER-DIMENSIONS-ERROR
	  BAD-NUMBER-ERROR
	  CALL-TRAP-ERROR
	  COMMON-LISP-CERROR
	  DANGEROUS-ERROR
	  EXIT-TRAP-ERROR
	  FLOATING-EXPONENT-OVERFLOW-ERROR
	  FLOATING-EXPONENT-UNDERFLOW-ERROR
	  FUNCTION-ENTRY-ERROR
	  OFFLINE-ERROR
	  PARSE-ERROR-1
	  PDL-OVERFLOW-ERROR
	  STEP-BREAK-ERROR
	  SUBSCRIPT-ERROR
	  SUBSCRIPT-PAST-FILL-POINTER-ERROR
	  THROW-TRAP-ERROR
	  TRACE-BREAK
	  TRACE-BREAKPOINT
	  NO-CURRENTLY-PREPARED-SHEET-ERROR
	  UNCLAIMED-MESSAGE-ERROR
	  UNIT-BAD-NUMBER-ERROR
	  UNIT-ERROR
	  UNIT-OFFLINE-ERROR
	  USER-NUBUS-ERROR
	  WRONG-TYPE-ARGUMENT-ERROR))

(proclaim '(special %call-state-length))   ;;this is defined in SYS:UCODE;LROY-QCOM

(defvar *error-handler-running* nil
  2"This variable is bound to T in every second-level error handler to identify them."*)
(forward-value-cell 'error-handler-running '*error-handler-running*)

1;; ERROR-TABLE:
;; The error table, read from SYS: UBIN; ELROY TBL nnn into %MICROCODE-ERROR-TABLE,
;; describes the symbolic meaning of certain microcode pcs.
;; Its data is rearranged into other variables below.
;; ERROR-TABLE relates the micro pc to a symbolic name of error,
;; called an ETE, whose car will then have properties saying how to
;; construct a condition instance.  The properties are defined in EHF.LISP*

(defvar microcode-error-table :unbound
  2"Actual error table read in from file"*)

(defvar microcode-error-table-version-number 0
  2"Ucode version number to which the loaded value of MICROCODE-ERROR-TABLE pertains."*)

1;; ASSURE-TABLE-PROCESSED looks at MICROCODE-ERROR-TABLE and produces these lists:*

(defvar *error-table* :unbound
  2"List of ETEs."*)

(defvar *error-table-number* -1
  2"Microcode version number for ERROR-TABLE."*)

(defvar *calls-sub-list* nil
  2"Alist of micro* 2pcs to symbols."*)

(defvar *restart-list* nil
  2"Alist of symbols to micro* 2pcs."*)

(defvar *arg-popped-list* nil
  2"Alist of micropcs just after where misc insns pop their args.
The cdr of the element says where the arg went:
a place to find it if the error is after the pop."*)

(defvar *default-arg-locations-list* nil
  2"Alist of microfun symbols to where their args live in the absence of info to contrary."*)

(defvar *stack-words-pushed-list* nil
  2"Alist of micropcs, of error or on stack at error, 
to how many words that subroutine had pushed on the stack since it was called, 
up to the time it called the next subroutine or got the error."*)

(defvar *begin-qaryr* nil
  2"Used by SG-ERRING-FUNCTION to see if function or array"*)

(defvar *end-qaryr* nil
  2"Used by SG-ERRING-FUNCTION to see if function or array"*)


1;; An error immediately runs the first level error handler stack group
;; whose job is to start a second level error handler stack group
;; in which the error handler actually runs.*

(defvar *free-second-level-error-handler-sg-list* nil
  2"List of error handler stack groups that were exited and can be reused."*)

(defvar *second-level-error-handler-count* 0
  2"Number of second level error handler stack groups made, for making unique names."*)

(defvar *last-second-level-error-handler-sg* nil
  2"The last second-level error handler stack group that was running.
This is so that when an error handler stack group is returned to it can tell
whether some other error handler stack group has been running in the meanwhile."*)

(defvar *error-handler-reprint-error* t
  2"Non-NIL => RUN-SG should reprint the error message on return from debugged SG."*)

;;ab 3/19/88
(ADD-INITIALIZATION "Clear EH cached SGs"
		    '(SETQ *free-second-level-error-handler-sg-list* nil)
		    :full-gc)

;;clm 9/26/88
(ADD-INITIALIZATION "Clear EH command dispatch table"
		    '(makunbound '*command-dispatch-table*)
		    :full-gc)
			   			   

1;; Here are the error handler's main operating parameters.*

(defvar *debug-io* :unbound			
  2"Stream for use by the debugger command loop.
Value in the stack group that got the error is used as the stream to do its i/o on."*)
(forward-value-cell 'debug-io '*debug-io*)
(proclaim '(special debug-io))

(defvar *debug-io-override* nil
  2"If non-NIL, this is used instead of *DEBUG-IO* by the debugger."*)

1;; NOTE: Leave *USE-OLD-DEBUGGER* set to T in DEFVAR.
;; It is set to NIL in an ADD-INITIALIZATION found in UCL-DEBUGGER.LISP.*
(defvar *use-old-debugger*  t
  2"If NIL the UCL version of the debugger is used.  If NON-NIL the old debugger is used"*)

(defvar *error-depth* 0
  2"Depth within error handlers in this stack group."*)
(forward-value-cell 'error-depth '*error-depth*)
(proclaim '(special error-depth))

(defvar *error-object* nil
  2"Inside condition handlers and the debugger, this is an error object
describing the error being handled."*)
;; 03/10/87 CLM define and forward old var  eh-error.
(defvar eh-error)
(forward-value-cell 'eh-error '*error-object*) 

(defvar *error-sg* nil
  2"The stack group that got the error.  Set by COMMAND-LOOP"*)
(forward-value-cell 'error-sg '*error-sg*)
(proclaim '(special error-sg))

(defvar *current-frame* nil
  2"The frame that the error handler is looking at."*)
(forward-value-cell 'current-frame '*current-frame*)

(defvar *error-locus-frame* nil
  2"The innermost visible frame which is not part of the error signaling mechanism.
Excludes innermost frames with a :error-reporter function and frames pushed on stack
by error handler, such as functions, foothold and fh-applier"*)
(forward-value-cell 'error-locus-frame '*error-locus-frame*)

(defvar *innermost-visible-frame* nil
  2"Frames on stack inside of this (ie, farther up the stack) can't be moved to.
This is the topmost frame on the stack which we want to know about ."*)
(forward-value-cell 'innermost-visible-frame '*innermost-visible-frame*)

(defvar *innermost-frame-is-interesting* nil
  2"T if we should regard the innermost frame* 2as interesting even if 
it is a call to a normally uninteresting function.  
This is set when we break on entry to or exit from an uninteresting function."*)
(forward-value-cell 'innermost-frame-is-interesting '*innermost-frame-is-interesting*) 

1;; Calls to functions listed in *UNINTERESTING-FUNCTIONS* should not be mentioned as frames
;; when stack-censoring is going on in interpreted functions.
;; This should include all functions that have &QUOTE args and are open-compiled.
;; *EVAL and APPLY-LAMBDA are there for peculiar reasons.*

(defparameter *uninteresting-functions* 
   '(si:*eval global:eval eval si:eval1
     si:apply-lambda si:zl-apply-lambda
     progv progw prog1 progn si:prog-internal prog prog* 
     let let* let-if compiler-let flet macrolet 
     block labels setq set store 
     si:interpreter-set si:interpreter-fsymeval
     cond if and or not 
     do do-named do* do-named* si:do-do*-internal si:do-serial si:do-parallel
     tagbody go
     return return-from
     with-stack-list with-stack-list*
     unstackify with-stack-list with-stack-list*
     unwind-protect function 
     throw dont-optimize
     multiple-value multiple-value-list
     multiple-value-prog1 multiple-value-call
     breakon-this-time
     call-function)
  2"Run-time support functions for the interpreter, which the debugger should not show you."*)

(defvar *ucl-debugger* nil  
  2"A UCL debugger"*)

(defvar *dbg-super-proceed-table* nil 
  2"The UCL proceed type table."*)


1;; These variables are set by the FH- functions for evaluating functions like
;; EH-ARG, EH-LOC, and EH-FUN in the erring stack group*

(defvar *erring-sg* nil
  2"In expressions evaluated by the debugger, this is the stack group that got the error."*)
;;03/10/87 CLM - Define and forward old var  eh-sg.
(defvar eh-sg)
(forward-value-cell 'eh-sg '*erring-sg*)


(defvar *erring-frame* nil
  2"In expressions evaluated by the debugger, this is the frame pointer of the current frame."*)
;;03/10/87 CLM - Define and forward old var  eh-frame.
(defvar eh-frame)
(forward-value-cell 'eh-frame '*erring-frame*)

1;; These next three aren't used anymore *** I think ****

(defvar error-flag (list nil)
  2"This is a random gensymmed object which is returned from SG-EVAL
to indicate that an error occurred within."*)

(defvar *sg-stepping-table* nil  
  2"Table of stack groups being stepped and stack groups stepping them."*)

;(defvar eh-ready nil
;  2"NIL until call to first level error handler after it has been preset.*
;2Normal error processing has no chance until this is set"*)

1;; These logically should go in SGDEFS*

(defvar *current-stack-group* :unbound
  2"The stack group now running."*)
(forward-value-cell '*current-stack-group* '%current-stack-group)
(forward-value-cell 'current-stack-group '*current-stack-group*)
(proclaim '(special current-stack-group))

(defvar *current-stack-group-resumer* :unbound
  2"The stack group that resumed the one now running."*)
(forward-value-cell '*current-stack-group-resumer* '%current-stack-group-previous-stack-group)
(forward-value-cell 'current-stack-group-resumer '*current-stack-group-resumer*)
(proclaim '(special current-stack-group-resumer))


1;; ERRSET  -- we should get rid of the use of errset - ****

(defvar *errset-status* nil
  2"T within an errset."*)
(forward-value-cell 'errset-status '*errset-status*)
(proclaim '(special errset-status))

(defvar *errset-print-msg* nil
  2"T if the error message should be printed anyway."*)
(forward-value-cell 'errset-print-msg '*errset-print-msg*)
(proclaim '(special errset-print-msg))

(defvar *errset* nil
  2"Non-NIL if the debugger should be entered even when within ERRSETs and CATCH-ERRORs."*)
(forward-value-cell 'errset '*errset*)
(proclaim '(special errset))

(defvar *errset-inside-error* nil
  2"T allows debugging inside EH by disabling the error handler's own ERRSETs"*)
(forward-value-cell 'errset-inside-error '*errset-inside-error*)
(proclaim '(special errset-inside-error))



;(defmacro print-carefully (ignore &body body)
;  2"If BODY gets an error, print a message saying error printing."*
;  `(condition-bind ((error 'proceed-with-abort-printing))
;     . ,body))

(defun proceed-with-abort-printing (condition)
  (when (member :abort-printing (send condition :proceed-types) :test #'eq) 
    :abort-printing))

;(defmacro print-carefully (message &body body)
;  2"If BODY gets an error, print a message saying error printing."*
;  `(multiple-value-bind (result error-flag)
;       (catch-error (progn . ,body) t)
;     (if error-flag (format t "... while printing ~A" ,message))))

(defmacro print-carefully (message &body body)
  2"If BODY gets an error, print a message saying error printing."*
  `(condition-case (condition)
       (progn . ,body)
     (error (format t "... Error while printing ~A: ~A" ,message condition))))

(defun p-prin1-careful (locative)
  2"Print the contents of LOCATIVE, catching and reporting errors in printing."*
  (if (%p-contents-safe-p locative)
      (print-carefully "locative" (prin1 (car locative)))
      (format t "#<~S ~O>" (%p-data-type locative) (%p-pointer locative))))

1;; Call these next two when it is apparent that some hacker set things up wrong:*

(defun bad-hacker (format-string &rest args)
  2"Report an error in the error table."*
  (format t "~%~%Foo, a hacker has screwn up somewhere.~2&Error:  ")
  (apply 'format t format-string args)
  (terpri) 
  (terpri)
  nil)

(defun barf (format-string &rest args)
  2"This function is used to report errors in the error handler commands"*
  (apply 'format t format-string args)
  (throw 'quit nil))

