;; -*- Mode:Common-Lisp; Package:user; Base:10 -*-
;;;
;;;                           RESTRICTED RIGHTS LEGEND

;;;Use, duplication, or disclosure by the Government is subject to
;;;restrictions as set forth in subdivision (c)(1)(ii) of the Rights in
;;;Technical Data and Computer Software clause at 52.227-7013.
;;;
;;;                     TEXAS INSTRUMENTS INCORPORATED.
;;;                              P.O. BOX 2909
;;;                           AUSTIN, TEXAS 78769
;;;                                 MS 2151
;;;
;;; Copyright (C) 1984-1989 Texas Instruments Incorporated. All rights reserved.

;;;		Dunn Camera Driver



(defvar dunn-rate 9600)  ;rs232 baud rate


(defvar dunn-stream '(si:make-serial-stream ':number-of-stop-bits 2
					    ':baud dunn-rate)) 


(defun reset-dunn-camera ()
  (write-char (int-char 65) dunn-stream))     ;"B"  restore default values


(defun wait-for-dunn-ready ()
  (loop doing (write-char (int-char 58) dunn-stream)
	until (= (tyi dunn-stream) 82)
	finally (clear-input dunn-stream) )) 
      

(defun read-dunn-camera-settings ()
  (write-char (int-char 60) dunn-stream)
  (list (tyi dunn-stream) (tyi dunn-stream) (tyi dunn-stream))) 


(defun setup-dunn-camera-exposure-times ()
  (reset-dunn-camera)
  (loop for message in                          ;exposure times
               '("KR165"			;red to 165
                 "KG167"			;green to 167
                 "KB180"			;blue to 180
                  ; exposure adjustment factors
                 "MR376"			;red to 376
                 "MG380"			;green to 380
                 "MB380"			;blue to 380)
        do (princ message dunn-stream)
	   (wait-for-dunn-ready)))) 
