;;; -*- Mode:common-LISP; Package:USER; Base:10 -*-

;;;                           RESTRICTED RIGHTS LEGEND

;;;Use, duplication, or disclosure by the Government is subject to
;;;restrictions as set forth in subdivision (c)(1)(ii) of the Rights in
;;;Technical Data and Computer Software clause at 52.227-7013.
;;;
;;;                     TEXAS INSTRUMENTS INCORPORATED.
;;;                              P.O. BOX 2909
;;;                           AUSTIN, TEXAS 78769
;;;                                 MS 2151
;;;
;;; Copyright (C) 1985-1989 Texas Instruments Incorporated. All rights reserved.

;;; 03.05.87  DAB  Changed :patchable and added :warnings-pathname-default
;;; 06.24.87  LAS  Changed make-package to defpackage
;;; 12.28.87  KTN  Added module fonts and auxiliary transformaton.

(DEFPACKAGE "IMAGEN"
  (:USE "LISP" "TICL")
  (:SIZE 1000))

(DEFPACKAGE "IMAGEN-FONTS"
  (:USE "LISP" "TICL")
  (:SIZE 1000))

(CLEAR-RESOURCE 'tv:temporary-choose-variable-values-window)

(DEFSYSTEM Imagen
  (:PACKAGE IMAGEN)
  (:NAME "Imagen")
  (:SHORT-NAME "IMAGEN")
  (:PATHNAME-DEFAULT "SYS:IMAGEN;")
  (:PATCHABLE "SYS:PATCH.IMAGEN;" PATCH) ;03.05.87 DAB
  (:warnings-pathname-default "SYS: CWARNS; IMAGEN.lisp") ;03.05.87 DAB
  (:MODULE IMPRESS "IMPRESS")
  (:MODULE IMAGENP "IMAGENP")
  (:MODULE TEST-FUNCS "TEST-FUNCS")
  (:MODULE FONTS ("SYS:IMAGEN.FONTS;CMASC09.XLD" "SYS:IMAGEN.FONTS;CMASC10.XLD"
	          "SYS:IMAGEN.FONTS;CMB09.XLD"  "SYS:IMAGEN.FONTS;CMB10.XLD"
		  "SYS:IMAGEN.FONTS;CMBTI.XLD"  "SYS:IMAGEN.FONTS;CMBTI09.XLD"
		  "SYS:IMAGEN.FONTS;CMBTIR.XLD" "SYS:IMAGEN.FONTS;CMCSC.XLD"
		  "SYS:IMAGEN.FONTS;CMI10.XLD"  "SYS:IMAGEN.FONTS;CMRMN10.XLD"
		  "SYS:IMAGEN.FONTS;CMS10.XLD"  "SYS:IMAGEN.FONTS;CMASC09.XLD"
		  "SYS:IMAGEN.FONTS;CMSC10.XLD" "SYS:IMAGEN.FONTS;CMSS10.XLD"
		  "SYS:IMAGEN.FONTS;CMSSB.XLD"  "SYS:IMAGEN.FONTS;CMSSS.XLD"
		  "SYS:IMAGEN.FONTS;CMSY10.XLD" "SYS:IMAGEN.FONTS;CMTI10.XLD")) ;12.28.87 KTN
  (:COMPILE-LOAD IMPRESS)
  (:COMPILE-LOAD IMAGENP (:fasload IMPRESS))
  (:COMPILE TEST-FUNCS (:fasload imagenp))
  (:AUXILIARY FONTS))

