;;;-*- Mode:Common-Lisp; Package:USER; Base:10 -*-

;;;                           RESTRICTED RIGHTS LEGEND

;;;Use, duplication, or disclosure by the Government is subject to
;;;restrictions as set forth in subdivision (c)(1)(ii) of the Rights in
;;;Technical Data and Computer Software clause at 52.227-7013.
;;;
;;;                     TEXAS INSTRUMENTS INCORPORATED.
;;;                              P.O. BOX 2909
;;;                           AUSTIN, TEXAS 78769
;;;                                 MS 2151
;;;
;;; Copyright (c) 1984-1989 Texas Instruments Incorporated.  All Rights Reserved.

;;;
;;; Change history:
;;;
;;;  Date      Author	Description
;;; -------------------------------------------------------------------------------------
;;;   3/12/87  DAN	Changed PATCHABLE pathname to new convention and added WARNINGS pathname.
;;;  12/01/87  LAS      Added zmacs files so history commands would work without having zmacs fully loaded.
;;;   1/26/87  ab       Use (:SKIP :FASLOAD ucl-defs) for ULC-DEFS dependency.

;;;;  Replaces the old rubout handler in Window;RH

(DEFSYSTEM input-editor
  (:NAME "Input Editor")
  (:PATHNAME-DEFAULT "SYS:INPUT-EDITOR;")
  (:SHORT-NAME "IE")
  (:PATCHABLE "SYS:PATCH.INPUT-EDITOR;" PATCH)
  (:warnings-pathname-default "sys:cwarns;input-editor.lisp")

  (:MODULE ucl-defs ("ucl;completion" "ucl;top-level-modes" "ucl;command" "ucl;defcom" "ucl;definitions"
		     "ucl;def-support" "ucl;command-loop" "ucl;menus" "ucl;selective-features" "ucl;table"
		     "ucl;temporary-commands" "ucl;utility"))

  (:MODULE defs  "definitions")
  (:MODULE rh-help  "rh-help")
  (:MODULE coms  "commands")
  (:MODULE loop  "command-loop")
  (:MODULE lisp	 "lisp-listener")
  (:MODULE zmacs-defs ("sys:zmacs;defs"))
  (:MODULE history-cmds ("sys:zmacs;defs" "sys:zmacs;macros" "sys:zmacs;history"))
  (:SKIP :FASLOAD ucl-defs)
  (:COMPILE-LOAD-INIT defs (ucl-defs) (:FASLOAD ucl-defs)
		      		      (:FASLOAD ucl-defs))
  (:COMPILE-LOAD-INIT rh-help (ucl-defs defs) (:FASLOAD ucl-defs defs)
		      		      (:FASLOAD ucl-defs defs))
  (:COMPILE-LOAD-INIT coms (ucl-defs defs) (:FASLOAD ucl-defs defs rh-help)
		      		      (:FASLOAD ucl-defs defs rh-help))
  (:COMPILE-LOAD-INIT loop (ucl-defs) (:FASLOAD ucl-defs defs)
		      		      (:FASLOAD ucl-defs defs))
  (:COMPILE-LOAD-INIT lisp (ucl-defs) (:FASLOAD ucl-defs defs rh-help coms loop)
		      		      (:FASLOAD ucl-defs defs))
  (:COMPILE-LOAD-INIT zmacs-defs   (ucl-defs) (:FASLOAD ucl-defs defs rh-help coms loop lisp)
		      		      (:FASLOAD ucl-defs defs rh-help coms loop lisp))
  (:COMPILE-LOAD-INIT history-cmds (ucl-defs) (:FASLOAD ucl-defs defs rh-help coms loop lisp zmacs-defs)
		      		      (:FASLOAD ucl-defs defs lisp zmacs-defs)))
