;;; -*- Mode: Common-Lisp; Package: User; Base: 10.; Patch-File: T -*-

;;;			      RESTRICTED RIGHTS LEGEND

;;; Use, duplication, or disclosure by the Government is subject to
;;; restrictions as set forth in subdivision (b)(3)(ii) of the Rights in
;;; Technical Data and Computer Software clause at 52.227-7013.
;;;
;;;			TEXAS INSTRUMENTS INCORPORATED.
;;;				 P.O. BOX 2909
;;;			      AUSTIN, TEXAS 78769
;;;				    MS 2151
;;;
;;; Copyright (C) 1988 Texas Instruments Incorporated. All rights reserved.

;;; Written 02/11/88 16:42:44 by jones,
;;; Reason: Make sure that the ftp status window is no wider than the screen.
;;; while running on HOBBS from band LOD1
;;; With Experimental SYSTEM 4.17, Experimental GC 4.0, Experimental COMPILER 4.0,
;;;  Experimental TV 4.12, Experimental IO 4.7, Experimental NVRAM 4.2, Experimental UCL 4.0,
;;;  Experimental INPUT-EDITOR 4.0, Experimental METER 4.0, Experimental ZWEI 4.3,
;;;  Experimental DEBUG-TOOLS 4.0, Experimental PATHNAME 4.11, Experimental RPC 4.5,
;;;  Experimental NAMESPACE 4.1, Experimental DATALINK 4.6, CHAOSNET 4.2, Experimental NETWORK-SUPPORT 4.0,
;;;  Experimental NETWORK-SERVICE 4.0, Experimental DATALINK-DISPLAYS 4.0, Experimental PRINTER 4.1,
;;;  Experimental IMAGEN 4.0, Experimental MAIL-DAEMON 4.0, Experimental MAIL-READER 4.2,
;;;  Experimental TELNET 4.0, Experimental VT100 4.1, Experimental NAMESPACE-EDITOR 4.1,
;;;  Experimental IP 4.0, Experimental NFS 4.16, Experimental PROFILE 4.0, Experimental MICRONET 4.3,
;;;  Experimental MICRONET-COMM 4.4, Experimental NFS-SERVER 4.0, Experimental WINDOW-MX 4.2,
;;;   microcode 9, Band Name: MX Network [2-11 B]

#!C
; From file FTPI.LISP#> IP; VIRGO:
#10R IP#:
(COMPILER-LET ((*PACKAGE* (FIND-PACKAGE "IP"))
                          (SI:*LISP-MODE* :Common-lisp)
                          (*READTABLE* Sys:Common-lisp-readtable)
                          (SI:*READER-SYMBOL-SUBSTITUTIONS* Sys::*common-lisp-symbol-substitutions*))
  (COMPILER#:PATCH-SOURCE-FILE "IP: IP; FTPI.#"


(DEFUN DISPLAY-STATUS (&OPTIONAL (EXPERT-MODE NIL) &AUX CHOICE)
 ;; 8/29/85 - modified to always allow choice of returning to previous menu
  (LET* ((CHOICE-ACTION '(NIL CHOICE-BOX-HANDLER NIL NIL))
	 (RETRY-CHOICE "To previous menu")
	 (TOP-CHOICE "To top-level menu")
	 (ABORT-CHOICE "Exit FTP")
	 (CHOICE-LIST
	  (LIST (CONS RETRY-CHOICE CHOICE-ACTION)
		(CONS TOP-CHOICE CHOICE-ACTION)
		(CONS ABORT-CHOICE CHOICE-ACTION))))
    (WHEN (NULL *FTP-STATUS-WINDOW*)
      (SETQ *FTP-STATUS-WINDOW*
	    (MAKE-INSTANCE 'FTP-STATUS-WINDOW-FLAVOR
			   :EDGES `(100
				     100
				     ,(min 800 (send tv:selected-window :width))
				     300)
			   :BLINKER-P ()
			   :LABEL "FTP STATUS"
			   :MARGIN-CHOICES ())))
    ;; want margin choices to be dynamic (based on status code) 
    (SEND *FTP-STATUS-WINDOW* :SET-MARGIN-CHOICES CHOICE-LIST)
    ;; display status information
    (SEND *FTP-STATUS-WINDOW* :EXPOSE-NEAR '(:MOUSE))
    (CONDITION-CASE ()
       (PROGN;catch abort here
	(SEND *FTP-STATUS-WINDOW* :SELECT ())
	(SEND *FTP-STATUS-WINDOW* :LINE-OUT "")
	(WHEN EXPERT-MODE; include last command executed in this mode
	  (SEND *FTP-STATUS-WINDOW* :STRING-OUT-CENTERED
	     (FORMAT () "Last command: ~A" *FTP-LAST-COMMAND*))
	  (SEND *FTP-STATUS-WINDOW* :LINE-OUT "")
	  (SEND *FTP-STATUS-WINDOW* :LINE-OUT ""))
	(SEND *FTP-STATUS-WINDOW* :STRING-OUT-CENTERED
	   (FORMAT () "Status code: ~A" *FTP-STATUS-CODE*))
	(SEND *FTP-STATUS-WINDOW* :LINE-OUT "")
	(SEND *FTP-STATUS-WINDOW* :LINE-OUT "")
	(CENTER-BLOCK *FTP-STATUS-MSG*)
	(WHEN *FTP-UNFAVORABLE*
	  (SEND *FTP-STATUS-WINDOW* :SET-REVERSE-VIDEO-P T)
	  (PROCESS-SLEEP 30 "ERROR"
			 );wait half a sec
	  (SEND *FTP-STATUS-WINDOW* :SET-REVERSE-VIDEO-P ()))
	(LOOP UNTIL (CONSP (SETQ CHOICE (SEND *FTP-STATUS-WINDOW* :ANY-TYI)))
	      FINALLY (RETURN (SETQ CHOICE (CADDR CHOICE))));choice-box-name
	)
       (SYSTEM:ABORT (SETQ CHOICE ())));cause to leave program
    (SEND *FTP-STATUS-WINDOW* :SET-REVERSE-VIDEO-P ())
    (SEND *FTP-STATUS-WINDOW* :DESELECT)
    (SEND *FTP-STATUS-WINDOW* :DEEXPOSE)
    ;; *** SEEMS TO PREVENT BLOWUP IN CVV WHEN SUBSEQUENTLY RETRYING PREVIOUS OPERATION ***
    (SEND *FTP-STATUS-WINDOW* :CLEAR-INPUT)
    ;; wait to do select to return result as result of this function
    (SELECTOR CHOICE STRING-EQUAL
      (RETRY-CHOICE :RETRY)
      (TOP-CHOICE NIL)
      (OTHERWISE (PROGN
		   (SETQ *GLOBAL-FTP-EXIT* T)
		   ())))			;end select
))  ; end let, defun

(setf  *FTP-STATUS-WINDOW* nil)

))
