;;; -*- Mode: Common-Lisp; Package: IP; Base: 10.; Patch-File: T -*-
;;; Patch file for IP version 3.10
;;; Reason: Added some cleanup form on tcp-eval-server.
;;; Written 04/07/88 14:57:29 by BERGER,
;;; while running on ARIES from band LODX
;;; With SYSTEM 4.48, Experimental VIRTUAL-MEMORY 4.0, Experimental EH 4.0, Experimental MAKE-SYSTEM 4.4,
;;;  Experimental MICRONET 4.3, Experimental LOCAL-FILE 4.0, BASIC-PATHNAME 4.8, Experimental DISK-IO 4.2,
;;;  Experimental DISK-LABEL 4.0, BASIC-FILE 4.5, Experimental MAC-PATHNAME 4.3, Experimental NETWORK-PATHNAME 4.0,
;;;  Experimental COMPILER 4.1, NETWORK-NAMESPACE 4.3, TV 4.60, DATALINK 4.13, Experimental CHAOSNET 4.5,
;;;  Experimental GC 4.3, Experimental MEMORY-AUX 4.0, Experimental NVRAM 4.3, Experimental SYSLOG 4.0,
;;;  Experimental STREAMER-TAPE 4.1, Experimental UCL 4.1, Experimental INPUT-EDITOR 4.0,
;;;  Experimental METER 4.3, Experimental ZWEI 4.16, Experimental DEBUG-TOOLS 4.2,
;;;  Experimental NETWORK-SUPPORT 4.2, Experimental NETWORK-SERVICE 4.0, Experimental DATALINK-DISPLAYS 4.0,
;;;  Experimental FONT-EDITOR 4.0, Experimental SERIAL 4.0, Experimental PRINTER 4.6,
;;;  Experimental PRINTER-TYPES 4.0, Experimental IMAGEN 4.0, Experimental SUGGESTIONS 4.0,
;;;  Experimental MAIL-DAEMON 4.3, Experimental MAIL-READER 4.5, Experimental TELNET 4.0,
;;;  Experimental VT100 4.4, Experimental NAMESPACE-EDITOR 4.4, PROFILE 4.4, VISIDOC 4.4,
;;;  NAMESPACE 4.14, Experimental NETWORK-SUPPORT-COLD 4.1, Experimental IP 3.6, Experimental BUG 10.0,
;;;   microcode 522, Band Name: pre 4.0 + IP 3/24

#!C
; From file TCP-PROTOCOLS.LISP#> IP; SYS:
#10R IP#:
(COMPILER-LET ((*PACKAGE* (FIND-PACKAGE "IP"))
                          (SI:*LISP-MODE* :COMMON-LISP)
                          (*READTABLE* SYS:COMMON-LISP-READTABLE)
                          (SI:*READER-SYMBOL-SUBSTITUTIONS* SYS::*COMMON-LISP-SYMBOL-SUBSTITUTIONS*))
  (COMPILER#:PATCH-SOURCE-FILE "SYS: IP; TCP-PROTOCOLS.#"


(DEFUN tcp-eval-server ()
  "Evaluate forms passed across a tcp stream and return their values."
  (CONDITION-CASE ()
      (WITH-OPEN-STREAM (stream (open-stream nil :local-port eval-port-number :characters :ascii
					     :timeout nil))
	(COND      
	  ((AND (EQ eval-server-on :not-logged-in) (NOT (MEMBER user-id '(nil "") :test #'EQUAL)))
	   (FORMAT stream "This machine is in use by ~A, try again later." user-id)
	   (RETURN-FROM tcp-eval-server nil))
	  ((NULL eval-server-on)
	   (RETURN-FROM tcp-eval-server nil))
	  ((EQ eval-server-on :notify)
	   (PROCESS-RUN-FUNCTION "Notify" 'tv:notify ()
				 "TCP Eval Server being used by ~A" (SEND stream :foreign-host))
	   (PROCESS-ALLOW-SCHEDULE)))
	(LET ((generic-server (MAKE-INSTANCE 'net:generic-peek-bs-server :stream stream))) 
	  (SEND tv:who-line-file-state-sheet :add-server generic-server "TCP EVAL" si:current-process)
	  (unwind-protect
	      (DO* ((*terminal-io* stream) ; Don't blow away machine on lossage
		    (*query-io* stream)
		    (input (READ stream nil 'quit) (READ stream nil 'quit)))
		   ((AND (SYMBOLP input) (STRING-EQUAL (SYMBOL-NAME input) "Quit"))
		    nil)
		(CATCH-ERROR
		  (DOLIST (value (MULTIPLE-VALUE-LIST (EVAL input)))
		    (FORMAT stream "~s~%" value))
		  t)
		(WRITE-CHAR #\End stream)
		(SEND stream :force-output))
	    ;;04-07-88 DAB Remove server from queue.
	    (SEND tv:who-line-file-state-sheet :delete-server generic-server "TCP EVAL" si:current-process))))
    (sys:network-error)))
))
