;;; -*- Mode: Common-Lisp; Package: IP; Base: 10.; Patch-File: T -*-
;;; Patch file for IP version 3.11
;;; Reason: Fixed to :read-reply. 4.3bsd has a bug that passes stderr to the control connection, so sometimes we'll get "/usr/foo not found" instead of a  coded reply.
;;; Written 04/11/88 09:20:20 by BERGER,
;;; while running on ARIES from band LODX
;;; With SYSTEM 4.52, VIRTUAL-MEMORY 4.1, Experimental EH 4.0, Experimental MAKE-SYSTEM 4.4,
;;;  MICRONET 4.4, Experimental LOCAL-FILE 4.0, BASIC-PATHNAME 4.10, DISK-IO 4.6,
;;;  Experimental DISK-LABEL 4.0, BASIC-FILE 4.6, Experimental MAC-PATHNAME 4.3, Experimental NETWORK-PATHNAME 4.0,
;;;  COMPILER 4.5, NETWORK-NAMESPACE 4.3, TV 4.73, DATALINK 4.14, CHAOSNET 4.15, Experimental GC 4.3,
;;;  Experimental MEMORY-AUX 4.0, Experimental NVRAM 4.3, Experimental SYSLOG 4.0,
;;;  Experimental STREAMER-TAPE 4.2, Experimental UCL 4.1, Experimental INPUT-EDITOR 4.0,
;;;  Experimental METER 4.3, ZWEI 4.17, Experimental DEBUG-TOOLS 4.2, NETWORK-SUPPORT 4.5,
;;;  Experimental NETWORK-SERVICE 4.0, Experimental DATALINK-DISPLAYS 4.0, Experimental FONT-EDITOR 4.0,
;;;  Experimental SERIAL 4.0, PRINTER 4.7, Experimental PRINTER-TYPES 4.2, Experimental IMAGEN 4.0,
;;;  Experimental SUGGESTIONS 4.0, MAIL-DAEMON 4.5, MAIL-READER 4.5, TELNET 4.1, Experimental VT100 4.4,
;;;  NAMESPACE-EDITOR 4.5, PROFILE 4.4, VISIDOC 4.4, NAMESPACE 4.18, Experimental NETWORK-SUPPORT-COLD 4.1,
;;;  IP 3.10, Experimental BUG 10.0, DECNET 1.33,  microcode 522, Band Name: pre 4.0 + IP 3/24

#!C
; From file FTP.LISP#> IP; SYS:
#10R IP#:
(COMPILER-LET ((*PACKAGE* (FIND-PACKAGE "IP"))
                          (SI:*LISP-MODE* :COMMON-LISP)
                          (*READTABLE* SYS:COMMON-LISP-READTABLE)
                          (SI:*READER-SYMBOL-SUBSTITUTIONS* SYS::*COMMON-LISP-SYMBOL-SUBSTITUTIONS*))
  (COMPILER#:PATCH-SOURCE-FILE "SYS: IP; FTP.#"


(DEFMETHOD (ftp-control-connection :read-reply) (&aux reply multi-line-reply)
  (DECLARE (ATOM multi-line-reply))
  (SETQ multi-line-reply ())
  (block read-reply
    (LOOP (loop				   ; Keep going until we get a number.
					   ; 4.3bsd has a bug that passes stderr to the control connection,
					   ; so sometimes we'll get "/usr/foo not found" instead of a
					   ; coded reply.  04-11-88 DAB for PF.
	    (SETQ reply (READ-LINE control-connection () ()))
	    (WHEN (NULL reply)
	      (SEND self :close-connections :abort)
	      (SETQ reply-code ())
	      (SETQ reply-string "control connection closed")
	      (RETURN-from read-reply))
	    (SETQ reply-code (PARSE-INTEGER reply :end 3 :junk-allowed t))
	    (when (integerp reply-code)
	      (return)))
	  (IF (OR (< reply-code 100) (> reply-code 599))
	      (SETQ reply-code 0))
	  (IF (NULL multi-line-reply)
	      (IF (EQUAL reply-code 0)
		  (SETQ reply-string reply)
		  (SETQ reply-string (SUBSEQ reply 4)))
	      (IF (AND (EQUAL (CHAR reply 3) #\Space) (> reply-code 0))
		  (PROGN
		    (SETQ multi-line-reply ())
		    (SETQ reply-string (CONCATENATE 'STRING reply-string "" (SUBSEQ reply 4))))
		  (IF (EQUAL reply-code 0)
		      (SETQ reply-string (CONCATENATE 'STRING reply-string "" reply))
		      (SETQ reply-string (CONCATENATE 'STRING reply-string "" (SUBSEQ reply 4))))))
	  (IF (AND (EQUAL (CHAR reply 3) #\-) (> reply-code 0))
	      (SETQ multi-line-reply t))
	  (IF (NULL multi-line-reply)
	      (RETURN)))))
))
