;;; -*- Mode: Common-Lisp; Package: IP; Base: 10.; Patch-File: T -*-
;;; Patch file for IP version 3.12
;;; Reason: The  dummy host was created incorrectly by ip:create-ip-host.
;;; Written 04/11/88 10:34:59 by BERGER,
;;; while running on ARIES from band LODX
;;; With SYSTEM 4.52, VIRTUAL-MEMORY 4.1, Experimental EH 4.0, Experimental MAKE-SYSTEM 4.4,
;;;  MICRONET 4.4, Experimental LOCAL-FILE 4.0, BASIC-PATHNAME 4.10, DISK-IO 4.6,
;;;  Experimental DISK-LABEL 4.0, BASIC-FILE 4.6, Experimental MAC-PATHNAME 4.3, Experimental NETWORK-PATHNAME 4.0,
;;;  COMPILER 4.5, NETWORK-NAMESPACE 4.3, TV 4.73, DATALINK 4.14, CHAOSNET 4.15, Experimental GC 4.3,
;;;  Experimental MEMORY-AUX 4.0, Experimental NVRAM 4.3, Experimental SYSLOG 4.0,
;;;  Experimental STREAMER-TAPE 4.2, Experimental UCL 4.1, Experimental INPUT-EDITOR 4.0,
;;;  Experimental METER 4.3, ZWEI 4.17, Experimental DEBUG-TOOLS 4.2, NETWORK-SUPPORT 4.5,
;;;  Experimental NETWORK-SERVICE 4.0, Experimental DATALINK-DISPLAYS 4.0, Experimental FONT-EDITOR 4.0,
;;;  Experimental SERIAL 4.0, PRINTER 4.7, Experimental PRINTER-TYPES 4.2, Experimental IMAGEN 4.0,
;;;  Experimental SUGGESTIONS 4.0, MAIL-DAEMON 4.5, MAIL-READER 4.5, TELNET 4.1, Experimental VT100 4.4,
;;;  NAMESPACE-EDITOR 4.5, PROFILE 4.4, VISIDOC 4.4, NAMESPACE 4.18, Experimental NETWORK-SUPPORT-COLD 4.1,
;;;  IP 3.10, Experimental BUG 10.0, DECNET 1.33,  microcode 522, Band Name: pre 4.0 + IP 3/24

#!C
; From file IP-ADDRESS.LISP#> IP; SYS:
#10R IP#:
(COMPILER-LET ((*PACKAGE* (FIND-PACKAGE "IP"))
                          (SI:*LISP-MODE* :COMMON-LISP)
                          (*READTABLE* SYS:COMMON-LISP-READTABLE)
                          (SI:*READER-SYMBOL-SUBSTITUTIONS* SYS::*COMMON-LISP-SYMBOL-SUBSTITUTIONS*))
  (COMPILER#:PATCH-SOURCE-FILE "SYS: IP; IP-ADDRESS.#"



(DEFUN create-ip-host (name address-spec &aux address (host nil))
  "Create a TEMPORARY host whose name can be used for TCP/IP access, but NOT in
pathnames.  
   If name is nil, an unnamed host will be returned."
  (COND
    ((SETQ address (net:ip-address-parser address-spec nil))
     (COND
       (name
	(WHEN (SETQ host (si:parse-host name t))
	  (UNLESS (MEMBER address (SEND host :send-if-handles :ip-addresses) :test #'EQL)
	    (FERROR 'ip-error "Existing host ~A  has same name but different address" host))))
       ((COND
	  ((SETQ host (si:get-host-from-address address :ip)))
	  (t (SETQ name (STRING-APPEND "UNKNOWN-IP-" (FORMAT () "~D" address)))))))
     (COND
       (host)
       (t
	;;Modified the following to handle the address correctly - dlc
	(si:define-host name :host-names (LIST name) :system-type :unknown :machine-type
			:unknown '(:addresses :group) `((:ip ,(net:print-network-address address :IP))))
	(SETQ host (si:parse-host name))	;this is ok even though si:parse-host may call this routine
	(SEND host :set-server-type ())
	host)))
    (t (FERROR 'ip-error "Illegal IP address ~A" address-spec))))
))
