;;; -*- Mode: Common-Lisp; Package: FS; Base: 10.; Patch-File: T -*-
;;; Written 04/12/88 08:03:48 by BERGER,
;;; Reason: Added :characters to plist in lispm-directory-line-parse .
;;; while running on ARIES from band LODX
;;; With Experimental SYSTEM 4.47, Experimental VIRTUAL-MEMORY 4.0, Experimental EH 4.0,
;;;  Experimental MAKE-SYSTEM 4.4, Experimental MICRONET 4.3, Experimental LOCAL-FILE 4.0,
;;;  Experimental BASIC-PATHNAME 4.6, Experimental DISK-IO 4.2, Experimental DISK-LABEL 4.0,
;;;  Experimental BASIC-FILE 4.4, Experimental MAC-PATHNAME 4.3, Experimental NETWORK-PATHNAME 4.0,
;;;  Experimental COMPILER 4.1, Experimental NETWORK-NAMESPACE 4.3, Experimental TV 4.59,
;;;  Experimental DATALINK 4.12, Experimental CHAOSNET 4.5, Experimental GC 4.3, Experimental MEMORY-AUX 4.0,
;;;  Experimental NVRAM 4.3, Experimental SYSLOG 4.0, Experimental STREAMER-TAPE 4.1,
;;;  Experimental UCL 4.1, Experimental INPUT-EDITOR 4.0, Experimental METER 4.3,
;;;  Experimental ZWEI 4.16, Experimental DEBUG-TOOLS 4.2, Experimental NETWORK-SUPPORT 4.2,
;;;  Experimental NETWORK-SERVICE 4.0, Experimental DATALINK-DISPLAYS 4.0, Experimental FONT-EDITOR 4.0,
;;;  Experimental SERIAL 4.0, Experimental PRINTER 4.6, Experimental PRINTER-TYPES 4.0,
;;;  Experimental IMAGEN 4.0, Experimental SUGGESTIONS 4.0, Experimental MAIL-DAEMON 4.3,
;;;  Experimental MAIL-READER 4.5, Experimental TELNET 4.0, Experimental VT100 4.4,
;;;  Experimental NAMESPACE-EDITOR 4.4, Experimental PROFILE 4.3, VISIDOC 4.2, Experimental NAMESPACE 4.12,
;;;  Experimental NETWORK-SUPPORT-COLD 4.1, Experimental IP 3.6, Experimental BUG 10.0,
;;;   microcode 522, Band Name: pre 4.0 + IP 3/24

#!C
; From file FTPINT.LISP#> IP; SYS:
#10R FILE-SYSTEM#:
(COMPILER-LET ((*PACKAGE* (FIND-PACKAGE "FILE-SYSTEM"))
                          (SI:*LISP-MODE* :COMMON-LISP)
                          (*READTABLE* COMMON-LISP-READTABLE)
                          (SI:*READER-SYMBOL-SUBSTITUTIONS* SYS::*COMMON-LISP-SYMBOL-SUBSTITUTIONS*))
  (COMPILER#:PATCH-SOURCE-FILE "SYS: IP; FTPINT.#"


(DEFUN lispm-directory-line-parse (dirobj line fast? &aux pathobj cursor cursor2 result month day year hours minutes seconds
				   length-in-blocks length-in-bytes byte-size)
  ;;; FORMAT:
  ;;; {d}  <pathname>  #-blocks  #-bytes(byte-size)  {!}{@}{$}{@} mm/dd//yy hh:mm:ss {author}

  ;;;                           ""    DIRECTORY         ""
  (WHEN (CHAR-EQUAL (AREF line 0) #\d)
    (PUSH t result)
    (PUSH :deleted result))
  ;; Careful - there may be multiple blanks embedded in the pathname and pathname parsing doesn't handle :Junk-allowed very well
  (SETQ cursor (POSITION #\Space (THE string (STRING line)) :start 1 :test-not 'CHAR-EQUAL))
  (SETQ cursor2
	(POSITION #\Space (THE string (STRING line)) :start
		  (POSITION #\# (THE string (STRING line)) :start cursor :test 'CHAR-EQUAL)
		  :test 'CHAR-EQUAL))
;; Make the pathname to merge with instead of parsing it. *BJ*
  (SETQ pathobj (MERGE-PATHNAMES
		  (parse-pathname (SUBSEQ line cursor cursor2) nil dirobj)
		  (fs:make-PATHNAME :host (send dirobj :host)
				    :type :unspecific)))
  (UNLESS fast?
    (MULTIPLE-VALUE-SETQ (length-in-blocks cursor)
			 (PARSE-INTEGER line :start cursor2 :junk-allowed t))
    (PUSH length-in-blocks result)
    (PUSH :length-in-blocks result)
    (IF (MULTIPLE-VALUE-SETQ (length-in-bytes cursor)
			     (PARSE-INTEGER line :start cursor :junk-allowed t))
	(PROGN
	  (MULTIPLE-VALUE-SETQ (BYTE-SIZE cursor)
			       (PARSE-INTEGER line :start (1+ cursor) :junk-allowed t))
	  (PUSH byte-size result)
	  (PUSH :byte-size result)
	  (PUSH length-in-bytes result)
	  (PUSH :length-in-bytes result))
	;; ELSE
	(PROGN
	  (PUSH t result)
	  (PUSH :directory result)
	  (INCF cursor (LENGTH "DIRECTOR"))))	;leave at "Y" (will be incremented)
    (push (DETERMINE-CHARACTERS-AND-BYTE-SIZE result pathobj pathobj nil nil nil) result)   ;04-12-88 DAB
    (push :characters result)                                                               ;04-12-88 DAB
    (LOOP
      (SETQ cursor
	    (POSITION #\Space (THE string (STRING line)) :start (1+ cursor) :test-not
		      'CHAR-EQUAL))
      (SELECTOR (AREF line cursor) char-equal (#\! (PUSH t result) (PUSH :not-backed-up result))
		(#\# (PUSH t result) (PUSH :dont-supersede result))
		(#\$ (PUSH t result) (PUSH :dont-reap result))
		(#\@ (PUSH t result) (PUSH :dont-delete result)) (:otherwise (RETURN))))
    (MULTIPLE-VALUE-SETQ (month cursor)
			 (PARSE-INTEGER line :start cursor :junk-allowed t))
    (MULTIPLE-VALUE-SETQ (day cursor)
			 (PARSE-INTEGER line :start (1+ cursor) :junk-allowed t))
    (MULTIPLE-VALUE-SETQ (year cursor)
			 (PARSE-INTEGER line :start (1+ cursor) :junk-allowed t))
    (MULTIPLE-VALUE-SETQ (hours cursor)
			 (PARSE-INTEGER line :start (1+ cursor) :junk-allowed t))
    (MULTIPLE-VALUE-SETQ (minutes cursor)
			 (PARSE-INTEGER line :start (1+ cursor) :junk-allowed t))
    (MULTIPLE-VALUE-SETQ (seconds cursor)
			 (PARSE-INTEGER line :start (1+ cursor) :junk-allowed t))
    (PUSH (ENCODE-UNIVERSAL-TIME seconds minutes hours day month year) result)
    (PUSH :creation-date result)
    (IF (SETQ cursor
	      (POSITION #\Space (THE string (STRING line)) :start cursor :test-not 'CHAR-EQUAL))
	(PROGN
	  (SETQ cursor2
		(POSITION #\Space (THE string (STRING line)) :start cursor :test 'CHAR-EQUAL))
	  (PUSH (SUBSEQ line cursor cursor2) result))
	;; else
	(PUSH (CAR (SEND dirobj :directory)) result))
    (PUSH :author result))
  (PUSH pathobj result))
))
