;;; -*- Mode: Common-Lisp; Package: IP; Base: 10.; Patch-File: T -*-
;;; Written 04/13/88 11:15:09 by BERGER,
;;; Reason:  Added a call to :get-directory during :login to get the default working directory and add it to fs:user-homedirs.
;;; while running on ARIES from band LODX
;;; With SYSTEM 4.57, VIRTUAL-MEMORY 4.1, EH 4.2, MAKE-SYSTEM 4.4, MICRONET 4.4, Experimental LOCAL-FILE 4.0,
;;;  BASIC-PATHNAME 4.10, DISK-IO 4.6, Experimental DISK-LABEL 4.0, BASIC-FILE 4.6,
;;;  MAC-PATHNAME 4.3, Experimental NETWORK-PATHNAME 4.0, COMPILER 4.7, NETWORK-NAMESPACE 4.3,
;;;  TV 4.73, DATALINK 4.14, CHAOSNET 4.15, GC 4.3, Experimental MEMORY-AUX 4.0, NVRAM 4.4,
;;;  Experimental SYSLOG 4.0, Experimental STREAMER-TAPE 4.2, UCL 4.1, Experimental INPUT-EDITOR 4.0,
;;;  METER 4.3, ZWEI 4.17, DEBUG-TOOLS 4.2, NETWORK-SUPPORT 4.5, Experimental NETWORK-SERVICE 4.0,
;;;  Experimental DATALINK-DISPLAYS 4.0, Experimental FONT-EDITOR 4.0, Experimental SERIAL 4.0,
;;;  PRINTER 4.7, Experimental PRINTER-TYPES 4.2, Experimental IMAGEN 4.0, Experimental SUGGESTIONS 4.0,
;;;  MAIL-DAEMON 4.6, MAIL-READER 4.5, TELNET 4.1, VT100 4.4, NAMESPACE-EDITOR 4.5,
;;;  PROFILE 4.4, VISIDOC 4.4, NAMESPACE 4.18, NETWORK-SUPPORT-COLD 4.1, IP 3.12,
;;;  Experimental BUG 10.0,  microcode 528, Band Name: pre 4.1 + IP 4/11

#!C
; From file FTP.LISP#> IP; SYS:
#10R IP#:
(COMPILER-LET ((*PACKAGE* (FIND-PACKAGE "IP"))
                          (SI:*LISP-MODE* :COMMON-LISP)
                          (*READTABLE* SYS:COMMON-LISP-READTABLE)
                          (SI:*READER-SYMBOL-SUBSTITUTIONS* SYS::*COMMON-LISP-SYMBOL-SUBSTITUTIONS*))
  (COMPILER#:PATCH-SOURCE-FILE "SYS: IP; FTP.#"


(DEFMETHOD (ftp-control-connection :login) (user &optional passw account)
  (DECLARE (STRING user))
  (SEND self :quote (FORMAT () "USER ~a" user))
  (WHEN (AND (INTEGERP reply-code) (EQUAL (FLOOR reply-code 100) ftp-positive-intermediate-reply)
	     (NOT (NULL passw)))
    (SEND self :quote (FORMAT () "PASS ~a" passw))
    (WHEN (AND (INTEGERP reply-code) (EQUAL (FLOOR reply-code 100) ftp-positive-intermediate-reply)
	       (NOT (NULL account)))
      (SEND self :quote (FORMAT () "ACCT ~a" account))))
  ;; Now added the proper working directory to the fs:user-homedirs list from basic-file; Open.lisp
  ;; 04-13-88 DAB
  (WHEN (AND (INTEGERP reply-code) (EQUAL (FLOOR reply-code 100) ftp-positive-completion-reply))
    (let ((host-name (send self :host))
	  item 
	  instring idx)
      (if (not (equal fs:user-id user))
	  ;; If the host user id is not the one specified in LOGIN,
	  ;; do not accept the file server's suggested home dir
	  ;; since it is based on the file server login id.
	  (setq instring (fs:parse-pathname
			   (format nil "~a:~a " (send  host-name :fully-qualified-name) fs:user-id)))
	  ;;Else
	  (send self :get-directory)
	  (WHEN (AND (INTEGERP reply-code) (EQUAL (FLOOR reply-code 100) ftp-positive-completion-reply))
	    (setq instring
		  (fs:parse-pathname
		    (format nil "~a:~a " (send  host-name :fully-qualified-name)
			    (subseq reply-string (setq idx (1+ (position #\" reply-string)))
				    (position #\" reply-string :start idx)))))))
	(if (setq item (assoc host-name fs:user-homedirs :test #'eq))
	    (rplacd item instring)
	    (push (cons host-name instring) fs:user-homedirs)))
      ))


))

#!C
; From file FTPINT.LISP#> IP; SYS:
#10R FILE-SYSTEM#:
(COMPILER-LET ((*PACKAGE* (FIND-PACKAGE "FILE-SYSTEM"))
                          (SI:*LISP-MODE* :COMMON-LISP)
                          (*READTABLE* COMMON-LISP-READTABLE)
                          (SI:*READER-SYMBOL-SUBSTITUTIONS* SYS::*COMMON-LISP-SYMBOL-SUBSTITUTIONS*))
  (COMPILER#:PATCH-SOURCE-FILE "SYS: IP; FTPINT.#"


(DEFMETHOD (FTP :homedir) (IGNORE pathname &optional (user user-id))
  (ip:with-stream-whostate
    "Homedir"
    (let ((-host- (pathname-host pathname)))  ;04-13-88 DAB Check fs:homedir.
    (or (cdr (assoc -host- fs:user-homedirs :test 'eq))
	(when (not (member user-id '(nil "")))
	  ;; Try logging in a file connection, in case that works.
	  (free-ftp-connection (reserve-ftp-connection -host- :homedir))
	  (cdr (assoc -host- fs:user-homedirs :test 'eq)))
	;; If we fail to establish a connection and don't already know a homedir,
	;; return something innocuous.  Don't get an error.
	(send pathname :quiet-homedir user)))
    ))
))
