;;; -*- Mode: Common-Lisp; Package: IP; Base: 10.; Patch-File: T -*-
;;; Written 04/13/88 14:15:17 by BERGER,
;;; Reason: ip:ip-ones-complement-checksum, ip:ip-ones-complement-checksum-8, and ip:ip-ones-complement-checksum-16 have been reworked according to suggestions gleaned from comp.protocols.tcp-ip.  Simple tests show up to a 12% speedup over the old versions. DAB for PF.
;;; while running on ARIES from band LODX
;;; With SYSTEM 4.57, VIRTUAL-MEMORY 4.1, EH 4.2, MAKE-SYSTEM 4.4, MICRONET 4.4, Experimental LOCAL-FILE 4.0,
;;;  BASIC-PATHNAME 4.10, DISK-IO 4.7, Experimental DISK-LABEL 4.0, BASIC-FILE 4.6,
;;;  MAC-PATHNAME 4.3, Experimental NETWORK-PATHNAME 4.0, COMPILER 4.7, NETWORK-NAMESPACE 4.3,
;;;  TV 4.74, DATALINK 4.14, CHAOSNET 4.15, GC 4.3, Experimental MEMORY-AUX 4.0, NVRAM 4.4,
;;;  Experimental SYSLOG 4.0, Experimental STREAMER-TAPE 4.2, UCL 4.1, Experimental INPUT-EDITOR 4.0,
;;;  METER 4.3, ZWEI 4.17, DEBUG-TOOLS 4.2, NETWORK-SUPPORT 4.5, Experimental NETWORK-SERVICE 4.0,
;;;  Experimental DATALINK-DISPLAYS 4.0, Experimental FONT-EDITOR 4.0, Experimental SERIAL 4.0,
;;;  PRINTER 4.7, Experimental PRINTER-TYPES 4.2, Experimental IMAGEN 4.0, Experimental SUGGESTIONS 4.0,
;;;  MAIL-DAEMON 4.6, MAIL-READER 4.6, TELNET 4.1, VT100 4.4, NAMESPACE-EDITOR 4.5,
;;;  PROFILE 4.4, VISIDOC 4.4, NAMESPACE 4.18, NETWORK-SUPPORT-COLD 4.1, IP 3.14,
;;;  Experimental BUG 10.0,  microcode 528, Band Name: pre 4.1 + IP 4/11

#!C
; From file IP.LISP#> IP; SYS:
#10R IP#:
(COMPILER-LET ((*PACKAGE* (FIND-PACKAGE "IP"))
                          (SI:*LISP-MODE* :COMMON-LISP)
                          (*READTABLE* SYS:COMMON-LISP-READTABLE)
                          (SI:*READER-SYMBOL-SUBSTITUTIONS* SYS::*COMMON-LISP-SYMBOL-SUBSTITUTIONS*))
  (COMPILER#:PATCH-SOURCE-FILE "SYS: IP; IP.#"


(proclaim '(optimize (speed 3) (space 0) (safety 0) (compilation-speed 0)))

(DEFUN ip-ones-complement-checksum (array &optional (ARRAY-LENGTH (1- (LENGTH array))) &rest parm-list)
   (let ((elem-size (array-element-size array))
	 (offset 0)
	 (sum nil))
     (loop while (array-indirect-p array)
	   as new-elem-size = (array-element-size array)
	   as index-offset = (sys:array-index-offset array)
	   when index-offset
	   do (cond ((= new-elem-size elem-size)
		     (incf offset index-offset))
		    ((< new-elem-size elem-size)	; Going to assume only 8 or 16 bit elements, so new is 8 here.
		     (setq elem-size new-elem-size
			   offset    (ash offset 1))
		     (incf offset index-offset))
		    ((> new-elem-size elem-size)	; Going to assume only 8 or 16 bit elements, so new is 16 here.
		     (when (oddp offset)	; May be a premature check.  The old form handles these.
		       (error "Can't checksum 16b array if length not on byte boundary."))
		     (setq elem-size new-elem-size
			   offset    (ash offset -1))
		     (incf offset index-offset)))
	   doing (setq array (sys:array-indirect-to array)))
     (ecase elem-size
       (16
	(let ((rolls (ash array-length -4))	; Unroll by factor of 16.
	      (unrolls (logand array-length 15))
	      (index (1- offset)))
	  (setq sum 0)
	  (loop repeat rolls
		doing (incf sum (aref array (incf index)))
		doing (incf sum (aref array (incf index)))
		doing (incf sum (aref array (incf index)))
		doing (incf sum (aref array (incf index)))
		doing (incf sum (aref array (incf index)))
		doing (incf sum (aref array (incf index)))
		doing (incf sum (aref array (incf index)))
		doing (incf sum (aref array (incf index)))
		doing (incf sum (aref array (incf index)))
		doing (incf sum (aref array (incf index)))
		doing (incf sum (aref array (incf index)))
		doing (incf sum (aref array (incf index)))
		doing (incf sum (aref array (incf index)))
		doing (incf sum (aref array (incf index)))
		doing (incf sum (aref array (incf index)))
		doing (incf sum (aref array (incf index))))
	  (loop repeat unrolls
		doing (incf sum (aref array (incf index)))))
	(setq sum (+ (ash sum -8) (ash (logand #xff sum) 8))))
       (8
	(let ((rolls (ash array-length -5))	; Unroll by factor of 16.
	      (unrolls (logand (ash array-length -1) 15))
	      (index (1- offset))
	      (suml 0)
	      (sumr 0))
	  (loop repeat rolls
		doing (incf suml (aref array (incf index)))
		      (incf sumr (aref array (incf index)))
		doing (incf suml (aref array (incf index)))
		      (incf sumr (aref array (incf index)))
		doing (incf suml (aref array (incf index)))
		      (incf sumr (aref array (incf index)))
		doing (incf suml (aref array (incf index)))
		      (incf sumr (aref array (incf index)))
		doing (incf suml (aref array (incf index)))
		      (incf sumr (aref array (incf index)))
		doing (incf suml (aref array (incf index)))
		      (incf sumr (aref array (incf index)))
		doing (incf suml (aref array (incf index)))
		      (incf sumr (aref array (incf index)))
		doing (incf suml (aref array (incf index)))
		      (incf sumr (aref array (incf index)))
		doing (incf suml (aref array (incf index)))
		      (incf sumr (aref array (incf index)))
		doing (incf suml (aref array (incf index)))
		      (incf sumr (aref array (incf index)))
		doing (incf suml (aref array (incf index)))
		      (incf sumr (aref array (incf index)))
		doing (incf suml (aref array (incf index)))
		      (incf sumr (aref array (incf index)))
		doing (incf suml (aref array (incf index)))
		      (incf sumr (aref array (incf index)))
		doing (incf suml (aref array (incf index)))
		      (incf sumr (aref array (incf index)))
		doing (incf suml (aref array (incf index)))
		      (incf sumr (aref array (incf index)))
		doing (incf suml (aref array (incf index)))
		      (incf sumr (aref array (incf index))))
	  (loop repeat unrolls
		doing (incf suml (aref array (incf index)))
		      (incf sumr (aref array (incf index))))
	  (setq sum (+ sumr (ash suml 8)))
	  (when (oddp array-length)
	    (incf sum (ash (aref array (+ offset -1 array-length)) 8))))))
     (loop for parm in parm-list
	   doing (incf sum parm))
     (loop until (< sum #x10000)
	   doing (setq sum (+ (logand #xFFFF sum) (ash sum -16))))

     ;; Return the ones COMPLEMENT of the sixteen bit number.  If the checksum is 0 (#XFFFF
     ;; before the LOGXOR), return >FFFF. 
     (if (= #xffff sum)
	 (values #xffff)
	 (values (logxor #xffff sum)))))

(DEFUN ip-ones-complement-checksum-16 (sixteen-bit-array length &rest parm-list)
  "Calculates the ones complement checksum for an art-16b array."
  (let ((rolls (ash length -4))		; Unroll by factor of 16.
	(unrolls (logand length 15))
	(index -1)
	(sum 0))
    (loop repeat rolls
	  doing (incf sum (net:swap-bytes (aref sixteen-bit-array (incf index))))
	  doing (incf sum (net:swap-bytes (aref sixteen-bit-array (incf index))))
	  doing (incf sum (net:swap-bytes (aref sixteen-bit-array (incf index))))
	  doing (incf sum (net:swap-bytes (aref sixteen-bit-array (incf index))))
	  doing (incf sum (net:swap-bytes (aref sixteen-bit-array (incf index))))
	  doing (incf sum (net:swap-bytes (aref sixteen-bit-array (incf index))))
	  doing (incf sum (net:swap-bytes (aref sixteen-bit-array (incf index))))
	  doing (incf sum (net:swap-bytes (aref sixteen-bit-array (incf index))))
	  doing (incf sum (net:swap-bytes (aref sixteen-bit-array (incf index))))
	  doing (incf sum (net:swap-bytes (aref sixteen-bit-array (incf index))))
	  doing (incf sum (net:swap-bytes (aref sixteen-bit-array (incf index))))
	  doing (incf sum (net:swap-bytes (aref sixteen-bit-array (incf index))))
	  doing (incf sum (net:swap-bytes (aref sixteen-bit-array (incf index))))
	  doing (incf sum (net:swap-bytes (aref sixteen-bit-array (incf index))))
	  doing (incf sum (net:swap-bytes (aref sixteen-bit-array (incf index))))
	  doing (incf sum (net:swap-bytes (aref sixteen-bit-array (incf index)))))
    (loop repeat unrolls
	  doing (incf sum (net:swap-bytes (aref sixteen-bit-array (incf index)))))
    (setq sum (+ (ash sum -8) (ash (logand #xff sum) 8)))
    (loop for parm in parm-list
	  doing (incf sum parm))
    (loop until (< sum #x10000)
	  doing (setq sum (+ (logand #xFFFF sum) (ash sum -16))))
    (logxor #xFFFF sum)))

(DEFUN ip-ones-complement-checksum-8 (eight-bit-array length &rest parm-list)
  "Calculates the ones complement checksum for an art-8b array."
  (let ((rolls (ash length -5))			; Unroll by factor of 16.
	(unrolls (logand (ash length -1) 15))
	(index -1)
	(sum 0))
    (loop repeat rolls
	  doing (incf sum (+ (ash (aref eight-bit-array (incf index)) 8)
			     (aref eight-bit-array (incf index))))
	  doing (incf sum (+ (ash (aref eight-bit-array (incf index)) 8)
			     (aref eight-bit-array (incf index))))
	  doing (incf sum (+ (ash (aref eight-bit-array (incf index)) 8)
			     (aref eight-bit-array (incf index))))
	  doing (incf sum (+ (ash (aref eight-bit-array (incf index)) 8)
			     (aref eight-bit-array (incf index))))
	  doing (incf sum (+ (ash (aref eight-bit-array (incf index)) 8)
			     (aref eight-bit-array (incf index))))
	  doing (incf sum (+ (ash (aref eight-bit-array (incf index)) 8)
			     (aref eight-bit-array (incf index))))
	  doing (incf sum (+ (ash (aref eight-bit-array (incf index)) 8)
			     (aref eight-bit-array (incf index))))
	  doing (incf sum (+ (ash (aref eight-bit-array (incf index)) 8)
			     (aref eight-bit-array (incf index))))
	  doing (incf sum (+ (ash (aref eight-bit-array (incf index)) 8)
			     (aref eight-bit-array (incf index))))
	  doing (incf sum (+ (ash (aref eight-bit-array (incf index)) 8)
			     (aref eight-bit-array (incf index))))
	  doing (incf sum (+ (ash (aref eight-bit-array (incf index)) 8)
			     (aref eight-bit-array (incf index))))
	  doing (incf sum (+ (ash (aref eight-bit-array (incf index)) 8)
			     (aref eight-bit-array (incf index))))
	  doing (incf sum (+ (ash (aref eight-bit-array (incf index)) 8)
			     (aref eight-bit-array (incf index))))
	  doing (incf sum (+ (ash (aref eight-bit-array (incf index)) 8)
			     (aref eight-bit-array (incf index))))
	  doing (incf sum (+ (ash (aref eight-bit-array (incf index)) 8)
			     (aref eight-bit-array (incf index))))
	  doing (incf sum (+ (ash (aref eight-bit-array (incf index)) 8)
			     (aref eight-bit-array (incf index)))))
    (loop repeat unrolls
	  doing (incf sum (+ (ash (aref eight-bit-array (incf index)) 8)
			     (aref eight-bit-array (incf index)))))
    (loop for parm in parm-list
	  doing (incf sum parm))
    (loop until (< sum #x10000)
	  doing (setq sum (+ (logand #xFFFF sum) (ash sum -16))))
    (logxor #xFFFF sum)))


))
