;;; -*- Mode: Common-Lisp; Package: IP; Base: 10.; Patch-File: T -*-

;;; Reason: Don't set user-homedirs for a Explorer machine in :login.
;;;			      RESTRICTED RIGHTS LEGEND

;;;Use, duplication, or disclosure by the Government is subject to
;;;restrictions as set forth in subdivision (b)(3)(ii) of the Rights in
;;;Technical Data and Computer Software clause at 52.227-7013.
;;;
;;;			TEXAS INSTRUMENTS INCORPORATED.
;;;				 P.O. BOX 2909
;;;			      AUSTIN, TEXAS 78769
;;;				    MS 2151
;;;
;;; Copyright (C) 1988 Texas Instruments Incorporated. All rights reserved.

;;; Patch file for IP version 3.16
;;; Written 04/25/88 14:47:12 by BERGER,
;;; while running on ARIES from band LODA
;;; With SYSTEM 4.59, VIRTUAL-MEMORY 4.4, EH 4.4, MAKE-SYSTEM 4.5, MICRONET 4.4, Experimental LOCAL-FILE 4.1,
;;;  BASIC-PATHNAME 4.12, NETWORK-SUPPORT-COLD 4.1, NAMESPACE 4.19, DISK-IO 4.10,
;;;  Experimental DISK-LABEL 4.0, BASIC-FILE 4.6, MAC-PATHNAME 4.3, Experimental NETWORK-PATHNAME 4.0,
;;;  COMPILER 4.10, TV 4.78, DATALINK 4.14, CHAOSNET 4.18, GC 4.3, Experimental MEMORY-AUX 4.0,
;;;  NVRAM 4.6, Experimental SYSLOG 4.0, Experimental STREAMER-TAPE 4.3, UCL 4.1,
;;;  Experimental INPUT-EDITOR 4.0, METER 4.3, ZWEI 4.18, DEBUG-TOOLS 4.2, NETWORK-SUPPORT 4.5,
;;;  Experimental NETWORK-SERVICE 4.0, DATALINK-DISPLAYS 4.0, Experimental FONT-EDITOR 4.0,
;;;  Experimental SERIAL 4.0, PRINTER 4.7, Experimental PRINTER-TYPES 4.2, Experimental IMAGEN 4.0,
;;;  Experimental SUGGESTIONS 4.0, MAIL-DAEMON 4.7, MAIL-READER 4.6, TELNET 4.1, VT100 4.4,
;;;  NAMESPACE-EDITOR 4.5, PROFILE 4.4, VISIDOC 4.4, IP 3.14, Experimental BUG 10.0,
;;;  NETWORK-NAMESPACE 4.2, DECNET 1.34,  microcode 305, Band Name: pre 4.1 +ip 4/22

#!C
; From file FTP.LISP#> IP; SYS:
#10R IP#:
(COMPILER-LET ((*PACKAGE* (FIND-PACKAGE "IP"))
                          (SI:*LISP-MODE* :COMMON-LISP)
                          (*READTABLE* SYS:COMMON-LISP-READTABLE)
                          (SI:*READER-SYMBOL-SUBSTITUTIONS* SYS::*COMMON-LISP-SYMBOL-SUBSTITUTIONS*))
  (COMPILER#:PATCH-SOURCE-FILE "SYS: IP; FTP.#"


(DEFMETHOD (ftp-control-connection :login) (user &optional passw account)
  (DECLARE (STRING user))
  (SEND self :quote (FORMAT () "USER ~a" user))
  (WHEN (AND (INTEGERP reply-code) (EQUAL (FLOOR reply-code 100) ftp-positive-intermediate-reply)
	     (NOT (NULL passw)))
    (SEND self :quote (FORMAT () "PASS ~a" passw))
    (WHEN (AND (INTEGERP reply-code) (EQUAL (FLOOR reply-code 100) ftp-positive-intermediate-reply)
	       (NOT (NULL account)))
      (SEND self :quote (FORMAT () "ACCT ~a" account))))
  ;; Now add the proper working directory to the fs:user-homedirs list from basic-file; Open.lisp
  ;; 04-13-88 DAB
  (WHEN (AND (INTEGERP reply-code) (EQUAL (FLOOR reply-code 100) ftp-positive-completion-reply))
    (let ((host-name (send self :host))
	  item 
	  instring idx)
      (if (not (string-equal fs:user-id user))
	  ;; If the host user id is not the one specified in LOGIN,
	  ;; do not accept the file server's suggested home dir
	  ;; since it is based on the file server login id.
	  (setq instring (fs:parse-pathname
			   (format nil "~a:~a " (send  host-name :fully-qualified-name) fs:user-id)))
	  ;;Else
	  (send self :get-directory)
	  (WHEN (AND (INTEGERP reply-code) (EQUAL (FLOOR reply-code 100) ftp-positive-completion-reply))
	    (setq instring
		  (fs:parse-pathname
		    (if (position #\" reply-string)
			(format nil "~a:~a " (send  host-name :fully-qualified-name)
			    	(subseq reply-string (setq idx (1+ (position #\" reply-string)))
					(position #\" reply-string :start idx)))
			reply-string)))))
	(if (setq item (assoc host-name fs:user-homedirs :test #'eq))
	    (rplacd item instring)
	    (push (cons host-name instring) fs:user-homedirs)))
      )
  (values reply-code reply-string))
))
