;;; -*- Mode: Common-Lisp; Package: IP; Base: 10.; Patch-File: T -*-

;;; Reason: When one gets an IP connection (FTP, Telnet, SMTP) from a host that isn't in the namespace, PEEK and the who line file status sheet don't give any indication of what the host is.Changed (basic-stream :foreign-host) to handle this. DAb for RA.
;;;			      RESTRICTED RIGHTS LEGEND

;;;Use, duplication, or disclosure by the Government is subject to
;;;restrictions as set forth in subdivision (b)(3)(ii) of the Rights in
;;;Technical Data and Computer Software clause at 52.227-7013.
;;;
;;;			TEXAS INSTRUMENTS INCORPORATED.
;;;				 P.O. BOX 2909
;;;			      AUSTIN, TEXAS 78769
;;;				    MS 2151
;;;
;;; Copyright (C) 1988 Texas Instruments Incorporated. All rights reserved.

;;; Patch file for IP version 3.21
;;; Written 06/01/88 08:39:03 by BERGER,
;;; while running on ARIES from band LODX
;;; With SYSTEM 4.70, VIRTUAL-MEMORY 4.4, EH 4.5, MAKE-SYSTEM 4.5, MICRONET 4.5, LOCAL-FILE 4.2,
;;;  BASIC-PATHNAME 4.13, NETWORK-SUPPORT-COLD 4.1, NAMESPACE 4.22, NETWORK-NAMESPACE 4.3,
;;;  DISK-IO 4.14, DISK-LABEL 4.0, BASIC-FILE 4.11, MAC-PATHNAME 4.7, NETWORK-PATHNAME 4.1,
;;;  COMPILER 4.12, TV 4.92, DATALINK 4.15, CHAOSNET 4.19, GC 4.3, MEMORY-AUX 4.1,
;;;  NVRAM 4.6, SYSLOG 4.0, STREAMER-TAPE 4.5, UCL 4.1, INPUT-EDITOR 4.0, METER 4.3,
;;;  ZWEI 4.21, DEBUG-TOOLS 4.2, NETWORK-SUPPORT 4.6, NETWORK-SERVICE 4.0, DATALINK-DISPLAYS 4.0,
;;;  FONT-EDITOR 4.0, SERIAL 4.0, PRINTER 4.9, PRINTER-TYPES 4.4, IMAGEN 4.0, SUGGESTIONS 4.0,
;;;  MAIL-DAEMON 4.9, MAIL-READER 4.9, TELNET 4.1, VT100 4.5, NAMESPACE-EDITOR 4.5,
;;;  PROFILE 4.4, VISIDOC 4.5, IP 3.19, Experimental BUG 10.1,  microcode 308, Band Name: Rel 4.1 + IP 5/9

#!C
; From file TCP-STREAM.LISP#> IP; SYS:
#10R IP#:
(COMPILER-LET ((*PACKAGE* (FIND-PACKAGE "IP"))
                          (SI:*LISP-MODE* :COMMON-LISP)
                          (*READTABLE* SYS:COMMON-LISP-READTABLE)
                          (SI:*READER-SYMBOL-SUBSTITUTIONS* SYS::*COMMON-LISP-SYMBOL-SUBSTITUTIONS*))
  (COMPILER#:PATCH-SOURCE-FILE "SYS: IP; TCP-STREAM.#"



(defun address-string-from-number (n)
     "Return a string of the form \"a.b.c.d\" where A, B, C, and D are the
      decimal representation of the octets of N."
     (format nil "~D.~D.~D.~D" (LDB (BYTE 8 24) n) (LDB (BYTE 8 16) n)
	     (LDB (BYTE 8 8) n) (LDB (BYTE 8 0) n)))

(DEFMETHOD (basic-stream :foreign-host) ()
     (COND
       (host)
       (t
	(SETF host (si:get-host-from-address (SEND connection :destination-address)
:ip)) 
	(cond
	  (host)
          ;;RDA creat a host if there isn't one so we'll get a readable name
	  (t (setf host (create-ip-host
			  (address-string-from-number (SEND connection :destination-address))
			  (SEND connection :destination-address))))))))

))
