;;; -*- Mode: Common-Lisp; Package: ip; Base: 10.; Patch-File: T -*-

;;; Reason: :login was return wrong reply-code when destination host did not support XPWD.

;;;                           RESTRICTED RIGHTS LEGEND
;;;
;;; Use, duplication, or disclosure by the Government is subject to
;;; restrictions as set forth in subdivision (c)(1)(ii) of the Rights in
;;; Technical Data and Computer Software clause at 52.227-7013.
;;;
;;;   TEXAS INSTRUMENTS INCORPORATED      
;;;   P.O. BOX 2909, M/S 2151             
;;;   AUSTIN, TEXAS 78769                 
;;;
;;; Copyright (C) 1988 Texas Instruments Incorporated.
;;; All rights reserved.

;;; Written 07/21/88 10:01:54 by BERGER,
;;; while running on ARIES from band LODX
;;; With SYSTEM 4.74, VIRTUAL-MEMORY 4.4, EH 4.5, MAKE-SYSTEM 4.6, MICRONET 4.5, Experimental LOCAL-FILE 4.2,
;;;  BASIC-PATHNAME 4.13, NETWORK-SUPPORT-COLD 4.1, NAMESPACE 4.23, NETWORK-NAMESPACE 4.3,
;;;  DISK-IO 4.16, DISK-LABEL 4.0, BASIC-FILE 4.13, MAC-PATHNAME 4.10, NETWORK-PATHNAME 4.1,
;;;  COMPILER 4.13, TV 4.93, DATALINK 4.16, CHAOSNET 4.19, GC 4.3, MEMORY-AUX 4.1,
;;;  NVRAM 4.6, SYSLOG 4.0, STREAMER-TAPE 4.8, UCL 4.1, INPUT-EDITOR 4.0, METER 4.3,
;;;  ZWEI 4.21, DEBUG-TOOLS 4.2, NETWORK-SUPPORT 4.6, NETWORK-SERVICE 4.0, DATALINK-DISPLAYS 4.0,
;;;  FONT-EDITOR 4.0, SERIAL 4.0, PRINTER 4.10, PRINTER-TYPES 4.5, IMAGEN 4.1, SUGGESTIONS 4.0,
;;;  MAIL-DAEMON 4.9, MAIL-READER 4.9, TELNET 4.1, VT100 4.6, NAMESPACE-EDITOR 4.5,
;;;  PROFILE 4.4, VISIDOC 4.5, IP 3.21, Experimental BUG 10.0,  microcode 345, Band Name: Rel 4.1.1 + IP 6/15

#!C
; From file FTP.LISP#> IP; SYS:
#10R IP#:
(COMPILER-LET ((*PACKAGE* (FIND-PACKAGE "IP"))
                          (SI:*LISP-MODE* :COMMON-LISP)
                          (*READTABLE* SYS:COMMON-LISP-READTABLE)
                          (SI:*READER-SYMBOL-SUBSTITUTIONS* SYS::*COMMON-LISP-SYMBOL-SUBSTITUTIONS*))
  (COMPILER#:PATCH-SOURCE-FILE "SYS: IP; FTP.#"


(DEFMETHOD (ftp-control-connection :login) (user &optional passw account)
  (DECLARE (STRING user))
  (SEND self :quote (FORMAT () "USER ~a" user))
  (WHEN (AND (INTEGERP reply-code) (EQUAL (FLOOR reply-code 100) ftp-positive-intermediate-reply)
	     (NOT (NULL passw)))
    (SEND self :quote (FORMAT () "PASS ~a" passw))
    (WHEN (AND (INTEGERP reply-code) (EQUAL (FLOOR reply-code 100) ftp-positive-intermediate-reply)
	       (NOT (NULL account)))
      (SEND self :quote (FORMAT () "ACCT ~a" account))))
  ;; Now add the proper working directory to the fs:user-homedirs list from basic-file; Open.lisp
  ;; 04-13-88 DAB
    
  (WHEN (AND (INTEGERP reply-code) (EQUAL (FLOOR reply-code 100) ftp-positive-completion-reply)
	     (not (EQ (send (send self :host) :system-type) :LISPM )))   ;04-25-88 DAB DON'T do to Explorer
    (let ((host-name (send self :host))
	  (save-reply-code reply-code)  ;07-21-88 DAB
	  (save-reply-string reply-string) ;07-21-88 DAB
	  item 
	  instring idx)
      (if (not (string-equal fs:user-id user))
	  ;; If the host user id is not the one specified in LOGIN,
	  ;; do not accept the file server's suggested home dir
	  ;; since it is based on the file server login id.
	  (setq instring (fs:parse-pathname
			   (format nil "~a:~a " (send  host-name :fully-qualified-name) fs:user-id)))
	  ;;Else
	  (send self :get-directory)
	  (WHEN (AND (INTEGERP reply-code) (EQUAL (FLOOR reply-code 100) ftp-positive-completion-reply))
	    (setq instring
		  (fs:parse-pathname
		    (format nil "~a:~a " (send  host-name :fully-qualified-name)
			    (subseq reply-string (setq idx (1+ (position #\" reply-string)))
				    (position #\" reply-string :start idx)))))))
	(if (setq item (assoc host-name fs:user-homedirs :test #'eq))
	    (rplacd item instring)
	    (push (cons host-name instring) fs:user-homedirs))
	(setf reply-code save-reply-code) ;07-21-88 DAB
	(setf reply-string save-reply-string)) ;07-21-88 DAB
      )
  (values reply-code reply-string))
))
