;;; -*- Mode: Common-Lisp; Package: User; Base: 10.; Patch-File: T -*-

;;; Reason: Fix ip-ones-complement-checksum-16 and ip-ones-complement-checksum-8.  8/5/88.

;;;                           RESTRICTED RIGHTS LEGEND
;;;
;;; Use, duplication, or disclosure by the Government is subject to
;;; restrictions as set forth in subdivision (c)(1)(ii) of the Rights in
;;; Technical Data and Computer Software clause at 52.227-7013.
;;;
;;;   TEXAS INSTRUMENTS INCORPORATED      
;;;   P.O. BOX 2909, M/S 2151             
;;;   AUSTIN, TEXAS 78769                 
;;;
;;; Copyright (C) 1988 Texas Instruments Incorporated.
;;; All rights reserved.

;;; Written 08/05/88 14:36:35 by ab,
;;; while running on M-IRWIN from band LOD5
;;; With SYSTEM 4.74, VIRTUAL-MEMORY 4.4, EH 4.5, MAKE-SYSTEM 4.6, MICRONET 4.5, Experimental LOCAL-FILE 4.2,
;;;  BASIC-PATHNAME 4.13, NETWORK-SUPPORT-COLD 4.1, NAMESPACE 4.23, NETWORK-NAMESPACE 4.3,
;;;  DISK-IO 4.16, DISK-LABEL 4.0, BASIC-FILE 4.13, MAC-PATHNAME 4.10, NETWORK-PATHNAME 4.1,
;;;  COMPILER 4.13, TV 4.93, DATALINK 4.16, CHAOSNET 4.19, GC 4.3, MEMORY-AUX 4.1,
;;;  NVRAM 4.6, SYSLOG 4.0, STREAMER-TAPE 4.8, UCL 4.1, INPUT-EDITOR 4.0, METER 4.3,
;;;  ZWEI 4.21, DEBUG-TOOLS 4.2, NETWORK-SUPPORT 4.6, NETWORK-SERVICE 4.0, DATALINK-DISPLAYS 4.0,
;;;  FONT-EDITOR 4.0, SERIAL 4.0, PRINTER 4.10, PRINTER-TYPES 4.5, IMAGEN 4.1, SUGGESTIONS 4.0,
;;;  MAIL-DAEMON 4.9, MAIL-READER 4.9, TELNET 4.1, VT100 4.6, NAMESPACE-EDITOR 4.5,
;;;  PROFILE 4.4, VISIDOC 4.5, IP 3.21, Experimental BUG 10.0, Experimental ROSIE 1.7,
;;;  Experimental SLAP 3.12, Experimental RPC 5.0, Experimental NFS 5.0,  microcode 349,
;;;  Band Name: 4.1.1 6/16 + MRosie

#!C
; From file IP.LISP#> IP; VIRGO:
#10R IP#:
(COMPILER-LET ((*PACKAGE* (FIND-PACKAGE "IP"))
                          (SI:*LISP-MODE* :COMMON-LISP)
                          (*READTABLE* SYS:COMMON-LISP-READTABLE)
                          (SI:*READER-SYMBOL-SUBSTITUTIONS* SYS::*COMMON-LISP-SYMBOL-SUBSTITUTIONS*))
  (COMPILER#:PATCH-SOURCE-FILE "SYS: IP; IP.#"

(DEFUN ip-ones-complement-checksum-16 (sixteen-bit-array length &rest parm-list)
  "Calculates the ones complement checksum for an art-16b array."
  (let ((rolls (ash length -4))		; Unroll by factor of 16.
	(unrolls (logand length 15))
	(index -1)
	(sum 0))
    (loop repeat rolls
	  doing (incf sum (net:swap-bytes (aref sixteen-bit-array (incf index))))
	  doing (incf sum (net:swap-bytes (aref sixteen-bit-array (incf index))))
	  doing (incf sum (net:swap-bytes (aref sixteen-bit-array (incf index))))
	  doing (incf sum (net:swap-bytes (aref sixteen-bit-array (incf index))))
	  doing (incf sum (net:swap-bytes (aref sixteen-bit-array (incf index))))
	  doing (incf sum (net:swap-bytes (aref sixteen-bit-array (incf index))))
	  doing (incf sum (net:swap-bytes (aref sixteen-bit-array (incf index))))
	  doing (incf sum (net:swap-bytes (aref sixteen-bit-array (incf index))))
	  doing (incf sum (net:swap-bytes (aref sixteen-bit-array (incf index))))
	  doing (incf sum (net:swap-bytes (aref sixteen-bit-array (incf index))))
	  doing (incf sum (net:swap-bytes (aref sixteen-bit-array (incf index))))
	  doing (incf sum (net:swap-bytes (aref sixteen-bit-array (incf index))))
	  doing (incf sum (net:swap-bytes (aref sixteen-bit-array (incf index))))
	  doing (incf sum (net:swap-bytes (aref sixteen-bit-array (incf index))))
	  doing (incf sum (net:swap-bytes (aref sixteen-bit-array (incf index))))
	  doing (incf sum (net:swap-bytes (aref sixteen-bit-array (incf index)))))
    (loop repeat unrolls
	  doing (incf sum (net:swap-bytes (aref sixteen-bit-array (incf index)))))
;;    (setq sum (+ (ash sum -8) (ash (logand #xff sum) 8)))   ab 8/5/88
    (loop for parm in parm-list
	  doing (incf sum parm))
    (loop until (< sum #x10000)
	  doing (setq sum (+ (logand #xFFFF sum) (ash sum -16))))
    (if (= #xffff sum)
	 (values #xffff)
	 (values (logxor #xffff sum)))))

(DEFUN ip-ones-complement-checksum-8 (eight-bit-array length &rest parm-list)
  "Calculates the ones complement checksum for an art-8b array."
  (let ((rolls (ash length -5))			; Unroll by factor of 16.
	(unrolls (logand (ash length -1) 15))
	(index -1)
	(sum 0))
    (loop repeat rolls
	  doing (incf sum (+ (ash (aref eight-bit-array (incf index)) 8)
			     (aref eight-bit-array (incf index))))
	  doing (incf sum (+ (ash (aref eight-bit-array (incf index)) 8)
			     (aref eight-bit-array (incf index))))
	  doing (incf sum (+ (ash (aref eight-bit-array (incf index)) 8)
			     (aref eight-bit-array (incf index))))
	  doing (incf sum (+ (ash (aref eight-bit-array (incf index)) 8)
			     (aref eight-bit-array (incf index))))
	  doing (incf sum (+ (ash (aref eight-bit-array (incf index)) 8)
			     (aref eight-bit-array (incf index))))
	  doing (incf sum (+ (ash (aref eight-bit-array (incf index)) 8)
			     (aref eight-bit-array (incf index))))
	  doing (incf sum (+ (ash (aref eight-bit-array (incf index)) 8)
			     (aref eight-bit-array (incf index))))
	  doing (incf sum (+ (ash (aref eight-bit-array (incf index)) 8)
			     (aref eight-bit-array (incf index))))
	  doing (incf sum (+ (ash (aref eight-bit-array (incf index)) 8)
			     (aref eight-bit-array (incf index))))
	  doing (incf sum (+ (ash (aref eight-bit-array (incf index)) 8)
			     (aref eight-bit-array (incf index))))
	  doing (incf sum (+ (ash (aref eight-bit-array (incf index)) 8)
			     (aref eight-bit-array (incf index))))
	  doing (incf sum (+ (ash (aref eight-bit-array (incf index)) 8)
			     (aref eight-bit-array (incf index))))
	  doing (incf sum (+ (ash (aref eight-bit-array (incf index)) 8)
			     (aref eight-bit-array (incf index))))
	  doing (incf sum (+ (ash (aref eight-bit-array (incf index)) 8)
			     (aref eight-bit-array (incf index))))
	  doing (incf sum (+ (ash (aref eight-bit-array (incf index)) 8)
			     (aref eight-bit-array (incf index))))
	  doing (incf sum (+ (ash (aref eight-bit-array (incf index)) 8)
			     (aref eight-bit-array (incf index)))))
    (loop repeat unrolls
	  doing (incf sum (+ (ash (aref eight-bit-array (incf index)) 8)
			     (aref eight-bit-array (incf index)))))
    (loop for parm in parm-list
	  doing (incf sum parm))
    (loop until (< sum #x10000)
	  doing (setq sum (+ (logand #xFFFF sum) (ash sum -16))))
    (if (= #xffff sum)
	 (values #xffff)
	 (values (logxor #xffff sum)))))
))
