;;; -*- Mode: Common-Lisp; Package: IP; Base: 10.; Patch-File: T -*-

;;; Reason:   Fixed (ftp-control-connection :login) to handle :get-working-directory for a microExplorer.

;;;                           RESTRICTED RIGHTS LEGEND
;;;
;;; Use, duplication, or disclosure by the Government is subject to
;;; restrictions as set forth in subdivision (c)(1)(ii) of the Rights in
;;; Technical Data and Computer Software clause at 52.227-7013.
;;;
;;;   TEXAS INSTRUMENTS INCORPORATED      
;;;   P.O. BOX 2909, M/S 2151             
;;;   AUSTIN, TEXAS 78769                 
;;;
;;; Copyright (C) 1988 Texas Instruments Incorporated.
;;; All rights reserved.

;;; Written 08/22/88 14:46:32 by BERGER,
;;; while running on ARIES from band LODX
;;; With SYSTEM 5.5, VIRTUAL-MEMORY 5.1, EH 5.0, MAKE-SYSTEM 5.0, MICRONET 5.1, LOCAL-FILE 5.0,
;;;  BASIC-PATHNAME 5.1, Experimental NETWORK-SUPPORT-COLD 5.0, BASIC-NAMESPACE 5.0,
;;;  Experimental NETWORK-NAMESPACE 5.0, DISK-IO 5.0, DISK-LABEL 5.0, BASIC-FILE 5.2,
;;;  MAC-PATHNAME 5.0, Experimental NETWORK-PATHNAME 5.0, COMPILER 5.0, TV 5.0, DATALINK 5.1,
;;;  CHAOSNET 5.2, GC 5.0, MEMORY-AUX 5.0, NVRAM 5.0, SYSLOG 5.0, STREAMER-TAPE 5.0,
;;;  UCL 5.0, INPUT-EDITOR 5.0, METER 5.0, ZWEI 5.2, DEBUG-TOOLS 5.0, Experimental NETWORK-SUPPORT 5.0,
;;;  Experimental NETWORK-SERVICE 5.0, DATALINK-DISPLAYS 5.0, FONT-EDITOR 5.0, SERIAL 5.0,
;;;  PRINTER 5.0, PRINTER-TYPES 5.0, IMAGEN 5.0, SUGGESTIONS 5.0, MAIL-DAEMON 5.0,
;;;  MAIL-READER 5.0, TELNET 5.0, VT100 5.0, Experimental NAMESPACE-EDITOR 5.0, PROFILE 5.0,
;;;  VISIDOC 5.0, Experimental BUG 10.0, IP 3.25,  microcode 352, Band Name: pre 5.0 + IP 8/17

#!C
; From file FTP.LISP#> IP; SYS:
#10R IP#:
(COMPILER-LET ((*PACKAGE* (FIND-PACKAGE "IP"))
                          (SI:*LISP-MODE* :COMMON-LISP)
                          (*READTABLE* SYS:COMMON-LISP-READTABLE)
                          (SI:*READER-SYMBOL-SUBSTITUTIONS* SYS::*COMMON-LISP-SYMBOL-SUBSTITUTIONS*))
  (COMPILER#:PATCH-SOURCE-FILE "SYS: IP; FTP.#"


(DEFMETHOD (ftp-control-connection :login) (user &optional passw account)
  (DECLARE (STRING user))
  (SEND self :quote (FORMAT () "USER ~a" user))
  (WHEN (AND (INTEGERP reply-code) (EQUAL (FLOOR reply-code 100) ftp-positive-intermediate-reply)
	     (NOT (NULL passw)))
    (SEND self :quote (FORMAT () "PASS ~a" passw))
    (WHEN (AND (INTEGERP reply-code) (EQUAL (FLOOR reply-code 100) ftp-positive-intermediate-reply)
	       (NOT (NULL account)))
      (SEND self :quote (FORMAT () "ACCT ~a" account))))
  ;; Now add the proper working directory to the fs:user-homedirs list from basic-file; Open.lisp
  ;; 04-13-88 DAB
    
  (WHEN (AND (INTEGERP reply-code) (EQUAL (FLOOR reply-code 100) ftp-positive-completion-reply)
	     (not (EQ (send (send self :host) :system-type) :LISPM )))   ;04-25-88 DAB DON'T do to Explorer
    (let ((host-name (send self :host))
	  (save-reply-code reply-code)  ;07-21-88 DAB
	  (save-reply-string reply-string) ;07-21-88 DAB
	  item 
	  instring idx)
      (if (not (string-equal fs:user-id user))
	  ;; If the host user id is not the one specified in LOGIN,
	  ;; do not accept the file server's suggested home dir
	  ;; since it is based on the file server login id.
	  (setq instring (fs:parse-pathname
			   (format nil "~a:~a " (send  host-name :fully-qualified-name) fs:user-id)))
	  ;;Else
	  (send self :get-directory)
	  (WHEN (AND (INTEGERP reply-code) (EQUAL (FLOOR reply-code 100) ftp-positive-completion-reply))
	    (setq instring
		  (fs:parse-pathname
		    (format nil "~a:~a " (send  host-name :fully-qualified-name)
			    (if (position #\" reply-string)   ;08-22-88 DAB microExplorer does not 
				(subseq reply-string (setq idx (1+ (position #\" reply-string)))
					(position #\" reply-string :start idx))
				reply-string))))))
	(if (setq item (assoc host-name fs:user-homedirs :test #'eq))
	    (rplacd item instring)
	    (push (cons host-name instring) fs:user-homedirs))
	(setf reply-code save-reply-code) ;07-21-88 DAB
	(setf reply-string save-reply-string)) ;07-21-88 DAB
      )
  (values reply-code reply-string))
))
