;;; -*- Mode: Common-Lisp; Package: IP; Base: 10.; Patch-File: T -*-

;;; Reason: Corrections to lispm-directory-line-parse  for changes added on 04-12-88.

;;;                           RESTRICTED RIGHTS LEGEND
;;;
;;; Use, duplication, or disclosure by the Government is subject to
;;; restrictions as set forth in subdivision (c)(1)(ii) of the Rights in
;;; Technical Data and Computer Software clause at 52.227-7013.
;;;
;;;   TEXAS INSTRUMENTS INCORPORATED      
;;;   P.O. BOX 2909, M/S 2151             
;;;   AUSTIN, TEXAS 78769                 
;;;
;;; Copyright (C) 1988 Texas Instruments Incorporated.
;;; All rights reserved.

;;; Written 08/26/88 14:12:38 by BERGER,
;;; while running on ARIES from band LODX
;;; With SYSTEM 5.5, VIRTUAL-MEMORY 5.1, EH 5.0, MAKE-SYSTEM 5.0, MICRONET 5.1, LOCAL-FILE 5.0,
;;;  BASIC-PATHNAME 5.1, Experimental NETWORK-SUPPORT-COLD 5.0, BASIC-NAMESPACE 5.0,
;;;  Experimental NETWORK-NAMESPACE 5.0, DISK-IO 5.0, DISK-LABEL 5.0, BASIC-FILE 5.2,
;;;  MAC-PATHNAME 5.0, Experimental NETWORK-PATHNAME 5.0, COMPILER 5.0, TV 5.0, DATALINK 5.1,
;;;  CHAOSNET 5.2, GC 5.0, MEMORY-AUX 5.0, NVRAM 5.0, SYSLOG 5.0, STREAMER-TAPE 5.0,
;;;  UCL 5.0, INPUT-EDITOR 5.0, METER 5.0, ZWEI 5.2, DEBUG-TOOLS 5.0, Experimental NETWORK-SUPPORT 5.0,
;;;  Experimental NETWORK-SERVICE 5.0, DATALINK-DISPLAYS 5.0, FONT-EDITOR 5.0, SERIAL 5.0,
;;;  PRINTER 5.0, PRINTER-TYPES 5.0, IMAGEN 5.0, SUGGESTIONS 5.0, MAIL-DAEMON 5.0,
;;;  MAIL-READER 5.0, TELNET 5.0, VT100 5.0, Experimental NAMESPACE-EDITOR 5.0, PROFILE 5.0,
;;;  VISIDOC 5.0, Experimental BUG 10.0, IP 3.25,  microcode 394, Band Name: pre 5.0 + IP 8/17

#!C
; From file FTPINT.LISP#> IP; SYS:
#10R FILE-SYSTEM#:
(COMPILER-LET ((*PACKAGE* (FIND-PACKAGE "FILE-SYSTEM"))
                          (SI:*LISP-MODE* :COMMON-LISP)
                          (*READTABLE* COMMON-LISP-READTABLE)
                          (SI:*READER-SYMBOL-SUBSTITUTIONS* SYS::*COMMON-LISP-SYMBOL-SUBSTITUTIONS*))
  (COMPILER#:PATCH-SOURCE-FILE "SYS: IP; FTPINT.#"


(DEFUN lispm-directory-line-parse (dirobj line fast? &aux pathobj cursor cursor2 result month day year hours minutes seconds
				   length-in-blocks length-in-bytes byte-size)
  ;;; FORMAT:
  ;;; {d}  <pathname>  #-blocks  #-bytes(byte-size)  {!}{@}{$}{@} mm/dd//yy hh:mm:ss {author}

  ;;;                           ""    DIRECTORY         ""
  (WHEN (CHAR-EQUAL (AREF line 0) #\d)
    (PUSH t result)
    (PUSH :deleted result))
  ;; Careful - there may be multiple blanks embedded in the pathname and pathname parsing doesn't handle :Junk-allowed very well
  (SETQ cursor (POSITION #\Space (THE string (STRING line)) :start 1 :test-not 'CHAR-EQUAL))
  (SETQ cursor2
	(POSITION #\Space (THE string (STRING line)) :start
		  (POSITION #\# (THE string (STRING line)) :start cursor :test 'CHAR-EQUAL)
		  :test 'CHAR-EQUAL))
;; Make the pathname to merge with instead of parsing it. *BJ*
  (SETQ pathobj (MERGE-PATHNAMES
		  (parse-pathname (SUBSEQ line cursor cursor2) nil dirobj)
		  (fs:make-PATHNAME :host (send dirobj :host)
				    :type :unspecific)))
  (UNLESS fast?
    (MULTIPLE-VALUE-SETQ (length-in-blocks cursor)
			 (PARSE-INTEGER line :start cursor2 :junk-allowed t))
    (PUSH length-in-blocks result)
    (PUSH :length-in-blocks result)
    (IF (MULTIPLE-VALUE-SETQ (length-in-bytes cursor)
			     (PARSE-INTEGER line :start cursor :junk-allowed t))
	(PROGN
	  (MULTIPLE-VALUE-SETQ (BYTE-SIZE cursor)
			       (PARSE-INTEGER line :start (1+ cursor) :junk-allowed t))
	  (PUSH byte-size result)
	  (PUSH :byte-size result)
	  (PUSH length-in-bytes result)
	  (PUSH :length-in-bytes result))
	;; ELSE
	(PROGN
	  (PUSH t result)
	  (PUSH :directory result)
	  (INCF cursor (LENGTH "DIRECTOR"))))	;leave at "Y" (will be incremented)
    (push (DETERMINE-CHARACTERS-AND-BYTE-SIZE result pathobj pathobj nil 8 nil t 8) result) ;04-12-88 DAB 08-26-88 DAB
    (push :characters result)                                                               ;04-12-88 DAB
    (LOOP
      (SETQ cursor
	    (POSITION #\Space (THE string (STRING line)) :start (1+ cursor) :test-not
		      'CHAR-EQUAL))
      (SELECTOR (AREF line cursor) char-equal (#\! (PUSH t result) (PUSH :not-backed-up result))
		(#\# (PUSH t result) (PUSH :dont-supersede result))
		(#\$ (PUSH t result) (PUSH :dont-reap result))
		(#\@ (PUSH t result) (PUSH :dont-delete result)) (:otherwise (RETURN))))
    (MULTIPLE-VALUE-SETQ (month cursor)
			 (PARSE-INTEGER line :start cursor :junk-allowed t))
    (MULTIPLE-VALUE-SETQ (day cursor)
			 (PARSE-INTEGER line :start (1+ cursor) :junk-allowed t))
    (MULTIPLE-VALUE-SETQ (year cursor)
			 (PARSE-INTEGER line :start (1+ cursor) :junk-allowed t))
    (MULTIPLE-VALUE-SETQ (hours cursor)
			 (PARSE-INTEGER line :start cursor :junk-allowed t)) ;04-28-88 DAB parse-integer ate the space
    (MULTIPLE-VALUE-SETQ (minutes cursor)
			 (PARSE-INTEGER line :start (1+ cursor) :junk-allowed t))
    (MULTIPLE-VALUE-SETQ (seconds cursor)
			 (PARSE-INTEGER line :start (1+ cursor) :junk-allowed t))
    (PUSH (ENCODE-UNIVERSAL-TIME seconds minutes hours day month year) result)
    (PUSH :creation-date result)
    (IF (SETQ cursor
	      (POSITION #\Space (THE string (STRING line)) :start cursor :test-not 'CHAR-EQUAL))
	(PROGN
	  (SETQ cursor2
		(POSITION #\Space (THE string (STRING line)) :start cursor :test 'CHAR-EQUAL))
	  (PUSH (SUBSEQ line cursor cursor2) result))
	;; else
	(PUSH (CAR (SEND dirobj :directory)) result))
    (PUSH :author result))
  (PUSH pathobj result))
))
