;;; -*- Mode: Common-Lisp; Package: IP; Base: 10.; Patch-File: T -*-

;;; Reason: Fixed tcp-eval-server. It was calling  tv:who-line-file-state-sheet :delete-server with too many arguments.

;;;                           RESTRICTED RIGHTS LEGEND
;;;
;;; Use, duplication, or disclosure by the Government is subject to
;;; restrictions as set forth in subdivision (c)(1)(ii) of the Rights in
;;; Technical Data and Computer Software clause at 52.227-7013.
;;;
;;;   TEXAS INSTRUMENTS INCORPORATED      
;;;   P.O. BOX 2909, M/S 2151             
;;;   AUSTIN, TEXAS 78769                 
;;;
;;; Copyright (C) 1988 Texas Instruments Incorporated.
;;; All rights reserved.

;;; Written 10/25/88 07:27:43 by BERGER,
;;; while running on ARIES from band LODX
;;; With SYSTEM 5.8, VIRTUAL-MEMORY 5.4, EH 5.1, MICRONET 5.2, LOCAL-FILE 5.0, BASIC-PATHNAME 5.1,
;;;  NETWORK-SUPPORT-COLD 5.0, BASIC-NAMESPACE 5.1, NETWORK-NAMESPACE 5.0, DISK-IO 5.1,
;;;  DISK-LABEL 5.0, BASIC-FILE 5.3, MAC-PATHNAME 5.0, NETWORK-PATHNAME 5.0, COMPILER 5.0,
;;;  MAKE-SYSTEM 5.0, TV 5.1, DATALINK 5.4, CHAOSNET 5.3, GC 5.1, MEMORY-AUX 5.0,
;;;  NVRAM 5.0, SYSLOG 5.0, STREAMER-TAPE 5.0, UCL 5.0, INPUT-EDITOR 5.0, METER 5.0,
;;;  ZWEI 5.4, DEBUG-TOOLS 5.0, NETWORK-SUPPORT 5.0, NETWORK-SERVICE 5.0, DATALINK-DISPLAYS 5.0,
;;;  FONT-EDITOR 5.0, SERIAL 5.0, PRINTER 5.3, PRINTER-TYPES 5.1, IMAGEN 5.1, SUGGESTIONS 5.0,
;;;  MAIL-DAEMON 5.0, MAIL-READER 5.0, TELNET 5.0, VT100 5.0, Experimental NAMESPACE-EDITOR 5.1,
;;;  PROFILE 5.0, VISIDOC 5.2, Experimental BUG 10.2, IP 3.28, VISIDOC-SERVER 5.2,
;;;   microcode 398, Band Name: Pre 5.0 +1p 9/23 +visidoc

#!C
; From file TCP-PROTOCOLS.LISP#> IP; SYS:
#10R IP#:
(COMPILER-LET ((*PACKAGE* (FIND-PACKAGE "IP"))
                          (SI:*LISP-MODE* :COMMON-LISP)
                          (*READTABLE* SYS:COMMON-LISP-READTABLE)
                          (SI:*READER-SYMBOL-SUBSTITUTIONS* SYS::*COMMON-LISP-SYMBOL-SUBSTITUTIONS*))
  (COMPILER#:PATCH-SOURCE-FILE "SYS: IP; TCP-PROTOCOLS.#"


(DEFUN tcp-eval-server ()
  "Evaluate forms passed across a tcp stream and return their values."
  (CONDITION-CASE ()
      (WITH-OPEN-STREAM (stream (open-stream nil :local-port eval-port-number :characters :ascii
					     :timeout nil))
	(COND      
	  ((AND (EQ eval-server-on :not-logged-in) (NOT (MEMBER user-id '(nil "") :test #'EQUAL)))
	   (FORMAT stream "This machine is in use by ~A, try again later." user-id)
	   (RETURN-FROM tcp-eval-server nil))
	  ((NULL eval-server-on)
	   (RETURN-FROM tcp-eval-server nil))
	  ((EQ eval-server-on :notify)
	   (PROCESS-RUN-FUNCTION "Notify" 'tv:notify ()
				 "TCP Eval Server being used by ~A" (SEND stream :foreign-host))
	   (PROCESS-ALLOW-SCHEDULE)))
	(LET ((generic-server (MAKE-INSTANCE 'net:generic-peek-bs-server :stream stream))) 
	  (SEND tv:who-line-file-state-sheet :add-server generic-server "TCP EVAL" si:current-process)
	  (unwind-protect
	      (DO* ((*terminal-io* stream) ; Don't blow away machine on lossage
		    (*query-io* stream)
		    (input (READ stream nil 'quit) (READ stream nil 'quit)))
		   ((AND (SYMBOLP input) (STRING-EQUAL (SYMBOL-NAME input) "Quit"))
		    nil)
		(CATCH-ERROR
		  (DOLIST (value (MULTIPLE-VALUE-LIST (EVAL input)))
		    (FORMAT stream "~s~%" value))
		  t)
		(WRITE-CHAR #\End stream)
		(SEND stream :force-output))
	    ;;04-07-88 DAB Remove server from queue.
	    (SEND tv:who-line-file-state-sheet :delete-server generic-server))))
    (sys:network-error)))
))
