;;; -*- Mode: Common-Lisp; Package: IP; Base: 10.; Patch-File: T -*-

;;; Reason: Changed udp-discard server to ignore error such as Ip:port-reset otherwise we get background error when net:reset. [7628
;;; ].

;;;                           RESTRICTED RIGHTS LEGEND
;;;
;;; Use, duplication, or disclosure by the Government is subject to
;;; restrictions as set forth in subdivision (c)(1)(ii) of the Rights in
;;; Technical Data and Computer Software clause at 52.227-7013.
;;;
;;;   TEXAS INSTRUMENTS INCORPORATED      
;;;   P.O. BOX 2909, M/S 2151             
;;;   AUSTIN, TEXAS 78769                 
;;;
;;; Copyright (C) 1988 Texas Instruments Incorporated.
;;; All rights reserved.

;;; Written 11/04/88 14:04:31 by BERGER,
;;; while running on ARIES from band LODX
;;; With SYSTEM 5.9, VIRTUAL-MEMORY 5.5, EH 5.2, MICRONET 5.5, LOCAL-FILE 5.0, BASIC-PATHNAME 5.2,
;;;  NETWORK-SUPPORT-COLD 5.1, BASIC-NAMESPACE 5.4, NETWORK-NAMESPACE 5.0, DISK-IO 5.8,
;;;  DISK-LABEL 5.1, BASIC-FILE 5.3, MAC-PATHNAME 5.0, NETWORK-PATHNAME 5.0, COMPILER 5.1,
;;;  MAKE-SYSTEM 5.1, TV 5.15, DATALINK 5.5, CHAOSNET 5.4, GC 5.3, MEMORY-AUX 5.1,
;;;  NVRAM 5.1, SYSLOG 5.0, STREAMER-TAPE 5.6, UCL 5.0, INPUT-EDITOR 5.0, METER 5.0,
;;;  ZWEI 5.8, DEBUG-TOOLS 5.0, NETWORK-SUPPORT 5.0, NETWORK-SERVICE 5.0, DATALINK-DISPLAYS 5.0,
;;;  FONT-EDITOR 5.0, SERIAL 5.0, PRINTER 5.10, PRINTER-TYPES 5.2, IMAGEN 5.1, SUGGESTIONS 5.0,
;;;  MAIL-DAEMON 5.0, MAIL-READER 5.3, TELNET 5.0, VT100 5.0, Experimental NAMESPACE-EDITOR 5.1,
;;;  PROFILE 5.1, VISIDOC 5.4, Experimental BUG 10.2, IP 3.31, VISIDOC-SERVER 5.2,
;;;   microcode 398, Band Name: Pre 5.0 +1p 9/23 +visidoc

#!C
; From file UDP-PROTOCOLS.LISP#> IP; sys:
#10R IP#:
(COMPILER-LET ((*PACKAGE* (FIND-PACKAGE "IP"))
                          (SI:*LISP-MODE* :COMMON-LISP)
                          (*READTABLE* SYS:COMMON-LISP-READTABLE)
                          (SI:*READER-SYMBOL-SUBSTITUTIONS* SYS::*COMMON-LISP-SYMBOL-SUBSTITUTIONS*))
  (COMPILER#:PATCH-SOURCE-FILE "sys: IP; UDP-PROTOCOLS.#"


(DEFUN udp-discard-server (&aux port)
  "UDP Discard Protocol server, discards all datagrams received."
  (UNWIND-PROTECT
      (PROGN
	(SETF port (SEND *udp-handler* :get-port discard-port-number))
	(ignore-errors ;Ignore error has as Ip:port-reset dab
	  (LOOP (SEND port :discard-input-buffer (SEND port :next-input-buffer))))
	)
    (WHEN port (SEND *udp-handler* :return-port port))))
))
