;;; -*- Mode: Common-Lisp; Package: FS; Base: 10.; Patch-File: T -*-

;;; Reason: Some implementation of excelan append subdirectory nodes to the name. We need to strip these off,otherwise we get too many subdirectory nodes in the pathname. 11-14-88 DAB from SN.

;;;                           RESTRICTED RIGHTS LEGEND
;;;
;;; Use, duplication, or disclosure by the Government is subject to
;;; restrictions as set forth in subdivision (c)(1)(ii) of the Rights in
;;; Technical Data and Computer Software clause at 52.227-7013.
;;;
;;;   TEXAS INSTRUMENTS INCORPORATED      
;;;   P.O. BOX 2909, M/S 2151             
;;;   AUSTIN, TEXAS 78769                 
;;;
;;; Copyright (C) 1988 Texas Instruments Incorporated.
;;; All rights reserved.

;;; Written 11/14/88 07:24:23 by BERGER,
;;; while running on aries from band LODX
;;; With SYSTEM 5.9, VIRTUAL-MEMORY 5.5, EH 5.2, MICRONET 5.5, LOCAL-FILE 5.0, BASIC-PATHNAME 5.2,
;;;  NETWORK-SUPPORT-COLD 5.1, BASIC-NAMESPACE 5.5, NETWORK-NAMESPACE 5.0, DISK-IO 5.9,
;;;  DISK-LABEL 5.1, BASIC-FILE 5.3, MAC-PATHNAME 5.0, NETWORK-PATHNAME 5.0, COMPILER 5.1,
;;;  MAKE-SYSTEM 5.1, TV 5.17, DATALINK 5.6, CHAOSNET 5.6, GC 5.3, MEMORY-AUX 5.1,
;;;  NVRAM 5.1, SYSLOG 5.0, STREAMER-TAPE 5.6, UCL 5.0, INPUT-EDITOR 5.0, METER 5.0,
;;;  ZWEI 5.8, DEBUG-TOOLS 5.0, NETWORK-SUPPORT 5.0, NETWORK-SERVICE 5.0, DATALINK-DISPLAYS 5.0,
;;;  FONT-EDITOR 5.0, SERIAL 5.0, PRINTER 5.10, PRINTER-TYPES 5.2, IMAGEN 5.1, SUGGESTIONS 5.0,
;;;  MAIL-DAEMON 5.1, MAIL-READER 5.3, TELNET 5.1, VT100 5.0, Experimental NAMESPACE-EDITOR 5.1,
;;;  PROFILE 5.1, VISIDOC 5.4, Experimental BUG 10.2, IP 3.33, VISIDOC-SERVER 5.2,
;;;   microcode 398, Band Name: Pre 5.0 +1p 9/23 +visidoc

#!C
; From file FTPINT.LISP#> IP; SYS:
#10R FILE-SYSTEM#:
(COMPILER-LET ((*PACKAGE* (FIND-PACKAGE "FILE-SYSTEM"))
                          (SI:*LISP-MODE* :COMMON-LISP)
                          (*READTABLE* COMMON-LISP-READTABLE)
                          (SI:*READER-SYMBOL-SUBSTITUTIONS* SYS::*COMMON-LISP-SYMBOL-SUBSTITUTIONS*))
  (COMPILER#:PATCH-SOURCE-FILE "SYS: IP; FTPINT.#"


(DEFUN vms-excelan-directory-line-parse (dirobj line &optional fast? &aux entry)
  
  (CONDITION-CASE (condition)
    (LET (path-start
	  path-end
	  cursor
	  cursor2
	  value
	  pathstring
	  pathobj)
      
      (IF (SETQ cursor (POSITION #\% line))
	  ;; THEN FORMAT IS <PATHNAME>: %<ERROR MESSAGE>
	  (PROGN
	    (SETQ path-start 0)
	    (SETQ path-end (POSITION #\: line :end cursor :from-end t))
	    (SETQ entry (LIST :dired-echo (SUBSEQ line cursor))))
	  
	  ;; ELSE FORMAT IS "RWED  [GROUP,OWNER]  BLKS-USED/ALLOC  DD-MON-YY HH:MM   PATHNAME"
	  (SETF cursor (STRING-SEARCH-SET '(#\R #\-) line))
	  (WHEN cursor
	    (PUSH (SUBSEQ line cursor (+ cursor 4)) entry)
	    (PUSH :dired-echo entry))
	  
	  (SETQ cursor (POSITION #\[ line :start (+ cursor 4)))
	  (SETQ cursor2 (1+ (POSITION #\] line :start cursor)))
	  (PUSH (SUBSEQ line cursor cursor2) entry)
	  (PUSH :author entry)
	  
	  (SETQ cursor (STRING-SEARCH-NOT-SET '(#\Space #\Tab) line cursor2))
	  (MULTIPLE-VALUE-SETQ (value cursor) (PARSE-INTEGER line :start cursor :junk-allowed t))
	  (PUSH value entry)
	  (PUSH :length-in-blocks entry)
	  
	  (SETQ cursor (POSITION #\- line :start cursor))
	  (LET*
	    ((day (PARSE-INTEGER line :start (- cursor 2) :end cursor :junk-allowed t))
	     (month (translate-alphabetic-month (SUBSEQ line (1+ cursor) (+ cursor 4))))
	     year hr min)
	    (MULTIPLE-VALUE-SETQ (year cursor) (PARSE-INTEGER line :start (+ cursor 5) :junk-allowed t))
	    (MULTIPLE-VALUE-SETQ (hr cursor) (PARSE-INTEGER line :start cursor :junk-allowed t))
	    (MULTIPLE-VALUE-SETQ (MIN cursor) (PARSE-INTEGER line :start (1+ cursor) :junk-allowed t))
	    (WHEN (AND (NUMBERP day) (NUMBERP month) (NUMBERP year) (NUMBERP hr) (NUMBERP min))
	      (PUSH (time:encode-universal-time 0 min hr day month year) entry)
	      (PUSH :creation-date entry)))
	  
	  (SETQ path-start (STRING-SEARCH-NOT-SET '(#\Space #\Tab) line cursor))
	  ;;Some implementation of excelan append subdirectory nodes to the name. We need to strip these off
	  ;;otherwise we get too many subdirectory nodes in the pathname. 11-14-88 DAB from SN.
	  (WHEN (STRING-SEARCH-SET "[" line path-start) 
	    (SETQ path-start (1+ (STRING-SEARCH-SET "]" line path-start))))
	  )
      
      (WHEN fast? (SETQ entry nil))		;cheating a bit
      (SETQ pathstring (SUBSEQ line path-start path-end))
      (WHEN (SETQ pathobj (IGNORE-ERRORS (parse-pathname pathstring (SEND dirobj :host) nil)))
	;; Make sure no type gets merged in if pathname has no type.  This will at least allow these 
	;; files to be accessed from dired (use of the raw pathname will yield a nil type and 
	;; merge will always stick something in)
	(UNLESS (SEND pathobj :type)
	  (SETQ pathobj (SEND pathobj :new-type :unspecific)))
        (SETQ pathobj (MERGE-PATHNAMES pathobj dirobj))
	(WHEN (STRING-EQUAL (SEND pathobj :type) (SEND pathobj :directory-file-type))
	   (PUSH t entry)
	   (PUSH :directory entry))
	(PUSH pathobj entry)))
    
    (ERROR 
       (WHEN *ftpint-debug*
          (FORMAT t "~&FTP ERROR PARSING [~A]:~% ~A~% RESULT SO FAR = ~A" line (SEND condition :report-string) entry))
       nil)))
))
