;;; -*- Mode: Common-Lisp; Package: FS; Base: 10.; Patch-File: T -*-

;;; Reason: Added a new method (FTP :case :omit-byte-size :vms4) to handle EXOS host that does not support the "LOCAL TYPE" transfer with logical bytes larger than 8.  As a result, the file transfer of :XLD files does not succeed. [9053]

;;;                           RESTRICTED RIGHTS LEGEND
;;;
;;; Use, duplication, or disclosure by the Government is subject to
;;; restrictions as set forth in subdivision (c)(1)(ii) of the Rights in
;;; Technical Data and Computer Software clause at 52.227-7013.
;;;
;;;   TEXAS INSTRUMENTS INCORPORATED      
;;;   P.O. BOX 2909, M/S 2151             
;;;   AUSTIN, TEXAS 78769                 
;;;
;;; Copyright (C) 1988 Texas Instruments Incorporated.
;;; All rights reserved.

;;; Written 12/20/88 14:18:54 by BERGER,
;;; while running on ARIES from band LOD1
;;; With SYSTEM 5.24, VIRTUAL-MEMORY 5.5, EH 5.3, MICRONET 5.5, LOCAL-FILE 5.0, BASIC-PATHNAME 5.3,
;;;  NETWORK-SUPPORT-COLD 5.1, BASIC-NAMESPACE 5.8, NETWORK-NAMESPACE 5.0, DISK-IO 5.9,
;;;  DISK-LABEL 5.1, BASIC-FILE 5.4, MAC-PATHNAME 5.0, NETWORK-PATHNAME 5.0, COMPILER 5.2,
;;;  MAKE-SYSTEM 5.3, TV 5.24, DATALINK 5.7, CHAOSNET 5.6, GC 5.4, MEMORY-AUX 5.1,
;;;  NVRAM 5.1, SYSLOG 5.2, STREAMER-TAPE 5.7, UCL 5.0, INPUT-EDITOR 5.0, METER 5.0,
;;;  ZWEI 5.11, DEBUG-TOOLS 5.1, Experimental NETWORK-SUPPORT 5.1, Experimental NETWORK-SERVICE 5.1,
;;;  DATALINK-DISPLAYS 5.0, FONT-EDITOR 5.0, SERIAL 5.0, PRINTER 5.12, PRINTER-TYPES 5.5,
;;;  IMAGEN 5.1, SUGGESTIONS 5.0, MAIL-DAEMON 5.5, MAIL-READER 5.5, TELNET 5.2, VT100 5.1,
;;;  Experimental NAMESPACE-EDITOR 5.1, PROFILE 5.1, VISIDOC 5.4, Experimental BUG 10.2,
;;;  IP 3.33, VISIDOC-SERVER 5.2, DECNET 1.47,  microcode 398, Band Name: Pre 5.0 +1p 9/23 +visidoc

#!C
; From file FTPINT.LISP#> IP; sys:
#10R FILE-SYSTEM#:
(COMPILER-LET ((*PACKAGE* (FIND-PACKAGE "FILE-SYSTEM"))
                          (SI:*LISP-MODE* :COMMON-LISP)
                          (*READTABLE* COMMON-LISP-READTABLE)
                          (SI:*READER-SYMBOL-SUBSTITUTIONS* SYS::*COMMON-LISP-SYMBOL-SUBSTITUTIONS*))
  (COMPILER#:PATCH-SOURCE-FILE "sys: IP; FTPINT.#"



(DEFUN ftp-omit-byte-size (path)
  (SEND *ftp-service* :omit-byte-size (ftp-system-type (PATHNAME-HOST path))
	path))
      
(DEFMETHOD (FTP :omit-byte-size) (IGNORE ignore)
   nil)
      
(DEFMETHOD (FTP :case :omit-byte-size :unix) (ignore)
;; (sigh) Some unix servers don't like a byte-size other than 8
   :unix)
      
(DEFMETHOD (FTP :case :omit-byte-size :vms4) (path)
  (CASE (SEND *ftp-service* :get-ftp-implementation-type (PATHNAME-HOST path))
    ;; (sigh) VMS-Excelan requires XLD files be transferred as :IMAGE files.
    (:vms-excelan :vms-excelan)
    (otherwise nil)))

))
