;;; -*- Mode: Common-Lisp; Package: IP; Base: 10.; Patch-File: T -*-

;;;			      RESTRICTED RIGHTS LEGEND

;;; Use, duplication, or disclosure by the Government is subject to
;;; restrictions as set forth in subdivision (b)(3)(ii) of the Rights in
;;; Technical Data and Computer Software clause at 52.227-7013.
;;;
;;;			TEXAS INSTRUMENTS INCORPORATED.
;;;				 P.O. BOX 2909
;;;			      AUSTIN, TEXAS 78769
;;;				    MS 2151
;;;
;;; Copyright (C) 1988 Texas Instruments Incorporated. All rights reserved.

;;; Written 02/26/88 06:39:43 by BERGER,
;;; Reason: Added a timeout optional argument to IP:remote-eval.
;;; while running on ARIES from band LODA
;;; With Experimental SYSTEM 4.23, Experimental COMPILER 4.0, Experimental NAMESPACE 4.2,
;;;  Experimental TV 4.21, Experimental DATALINK 4.10, CHAOSNET 4.3, Experimental GC 4.1,
;;;  Experimental NVRAM 4.3, Experimental SYSLOG 4.0, Experimental IO 4.10, Experimental UCL 4.0,
;;;  Experimental INPUT-EDITOR 4.0, Experimental PATHNAME-COLD 4.11, Experimental FILE-COLD 4.3,
;;;  Experimental METER 4.0, Experimental ZWEI 4.7, Experimental DEBUG-TOOLS 4.0,
;;;  Experimental NETWORK-SUPPORT 4.0, Experimental NETWORK-SERVICE 4.0, Experimental DATALINK-DISPLAYS 4.0,
;;;  Experimental FONT-EDITOR 4.0, Experimental SERIAL 4.0, Experimental PRINTER 4.2,
;;;  NIL PRINTER-TYPES 1.0, Experimental IMAGEN 4.0, Experimental SUGGESTIONS 4.0,
;;;  Experimental MAIL-DAEMON 4.0, Experimental MAIL-READER 4.4, Experimental TELNET 4.0,
;;;  Experimental VT100 4.2, Experimental NAMESPACE-EDITOR 4.2, Experimental PROFILE 4.0,
;;;  VISIDOC 1.0, Experimental BUG 10.0, Experimental IP 4.3, Experimental STREAMER-TAPE 9.0,
;;;   microcode 510, Band Name: pre4.0 2/19

#!C
; From file TCP-PROTOCOLS.LISP#> IP; SYS:
#10R IP#:
(COMPILER-LET ((*PACKAGE* (FIND-PACKAGE "IP"))
                          (SI:*LISP-MODE* :COMMON-LISP)
                          (*READTABLE* SYS:COMMON-LISP-READTABLE)
                          (SI:*READER-SYMBOL-SUBSTITUTIONS* SYS::*COMMON-LISP-SYMBOL-SUBSTITUTIONS*))
  (COMPILER#:PATCH-SOURCE-FILE "SYS: IP; TCP-PROTOCOLS.#"


(DEFUN remote-eval (host &optional timeout &aux form)
  "Evaluate forms on remote host.
HOST - May be a symbol, Host object, IP address.
An error occurs if no response has occured from HOST for TIMEOUT (seconds). The default is 300. "
  (SETF host (parse-ip-host-spec host))
  (WITH-OPEN-STREAM (tcp-stream (open-stream host :remote-port eval-port-number :characters :ascii))
    (FORMAT t "~%~%Eval Service ~A.~
               ~%Type in forms to be evaluated on remote host.  To quit press ABORT.~%" host)
    (when timeout (send tcp-stream :set-timeout timeout))  ;02-24-88 DAB
    (LOOP
      (SETQ form (READ))
      (TERPRI)
      (FORMAT tcp-stream "~s~%" form)
      (SEND tcp-stream :force-output)
      (WHEN (AND (SYMBOLP form)
		 (STRING-EQUAL (SYMBOL-NAME form) "Quit"))
	(RETURN ()))
      (DO ((CHAR (TYI tcp-stream) (TYI tcp-stream)))
	  ((CHAR-EQUAL char #\end))
	(SEND *standard-output* :tyo char)))))
))
