;;; -*- Mode: Common-Lisp; Package: FS; Base: 10.; Patch-File: T -*-

;;; Reason: Changed (ftp :create-directory) to check ftp-implementation-type and default :NAME to nil if :vms-excelan.

;;;                           RESTRICTED RIGHTS LEGEND
;;;
;;; Use, duplication, or disclosure by the Government is subject to
;;; restrictions as set forth in subdivision (c)(1)(ii) of the Rights in
;;; Technical Data and Computer Software clause at 52.227-7013.
;;;
;;;   TEXAS INSTRUMENTS INCORPORATED      
;;;   P.O. BOX 2909, M/S 2151             
;;;   AUSTIN, TEXAS 78769                 
;;;
;;; Copyright (C) 1988 Texas Instruments Incorporated.
;;; All rights reserved.

;;; Written 01/18/89 07:52:02 by BERGER,
;;; while running on ARIES from band LOD1
;;; With SYSTEM 5.24, VIRTUAL-MEMORY 5.5, EH 5.3, MICRONET 5.5, LOCAL-FILE 5.0, BASIC-PATHNAME 5.3,
;;;  NETWORK-SUPPORT-COLD 5.1, BASIC-NAMESPACE 5.8, NETWORK-NAMESPACE 5.0, DISK-IO 5.9,
;;;  DISK-LABEL 5.1, BASIC-FILE 5.4, MAC-PATHNAME 5.0, NETWORK-PATHNAME 5.0, COMPILER 5.2,
;;;  MAKE-SYSTEM 5.3, TV 5.24, DATALINK 5.7, CHAOSNET 5.6, GC 5.4, MEMORY-AUX 5.1,
;;;  NVRAM 5.1, SYSLOG 5.2, STREAMER-TAPE 5.7, UCL 5.0, INPUT-EDITOR 5.0, METER 5.1,
;;;  ZWEI 5.12, DEBUG-TOOLS 5.1, Experimental NETWORK-SUPPORT 5.1, Experimental NETWORK-SERVICE 5.1,
;;;  DATALINK-DISPLAYS 5.0, FONT-EDITOR 5.0, SERIAL 5.0, PRINTER 5.12, PRINTER-TYPES 5.5,
;;;  IMAGEN 5.1, SUGGESTIONS 5.0, MAIL-DAEMON 5.5, MAIL-READER 5.6, TELNET 5.2, VT100 5.1,
;;;  Experimental NAMESPACE-EDITOR 5.1, PROFILE 5.1, NIL VISIDOC 5.4, Experimental BUG 10.2,
;;;  IP 3.39, DECNET 1.47, RPC 5.5, NFS 5.8, VISIDOC-SERVER 6.0,  microcode 413, Band Name: Pre 5.0 +1p 9/23 +visidoc

#!C
; From file FTPINT.LISP#> IP; sys:
#10R FILE-SYSTEM#:
(COMPILER-LET ((*PACKAGE* (FIND-PACKAGE "FILE-SYSTEM"))
                          (SI:*LISP-MODE* :COMMON-LISP)
                          (*READTABLE* COMMON-LISP-READTABLE)
                          (SI:*READER-SYMBOL-SUBSTITUTIONS* SYS::*COMMON-LISP-SYMBOL-SUBSTITUTIONS*))
  (COMPILER#:PATCH-SOURCE-FILE "sys: IP; FTPINT.#"


(DEFMETHOD (FTP :create-directory) (ignore pathname &optional (error-p t) &aux ftp finished-p result)
  (ip:with-stream-whostate
    "Create-directory"
    (file-operation-retry
      (UNWIND-PROTECT
	  (PROGN
	    (SETQ ftp (reserve-ftp-connection (SEND pathname :host) :create-directory)) ;; last arg is nicety for peek
	    (SETF result
		  (IF (ftp-unfavorable (SEND ftp :create-directory
					     (dir-pathstring-for-ftp
					       (SEND pathname :new-pathname
						     :name (if   ; DAB 01-18-89 EXOS barf if name is :wild
							     (eq (SEND *ftp-service* :get-ftp-implementation-type
								       (PATHNAME-HOST pathname))
								 :vms-excelan)
							     nil
							     :wild)
						     :type nil :version nil))))
		      (IF (NOT (EQL 550 (SEND ftp :reply-code)))
			  (MAKE-CONDITION 'ftp-error (SEND ftp :reply-string) pathname :create-directory)
			  (COND ((OR (SEARCH "ermission" (SEND ftp :reply-string))
				     (SEARCH "ERMISSION" (SEND ftp :reply-string))
				     (SEARCH "rivilege" (SEND ftp :reply-string))    ;03-22-88 DAB mispelled privilege
				     (SEARCH "RIVILEGE" (SEND ftp :reply-string)))   ;03-22-88 DAB mispelled privilege
				 (MAKE-CONDITION 'incorrect-access-to-directory (SEND ftp :reply-string)
						 pathname :create-directory))
				((OR (SEARCH "xists" (SEND ftp :reply-string))
				     (SEARCH "XISTS" (SEND ftp :reply-string))
				     ;; workaround Unix returning two differing strings here
				     (SEARCH "Is a directory" (SEND ftp :reply-string)))
				 (MAKE-CONDITION 'file-already-exists (SEND ftp :reply-string)
						 pathname :create-directory))
				(t (MAKE-CONDITION 'directory-not-found "Directory not found for ~a"
						   pathname :create-directory))))
		      t))
	    (SETF finished-p t))
	;; cleanup
	(free-ftp-connection ftp (OR (TYPEP result 'condition) (NOT finished-p))))
      (IF (AND error-p (TYPEP result 'condition))
	  (SIGNAL-CONDITION result)
	  result))))
))
