;;; -*- Mode: Common-Lisp; Package: IP; Base: 10.; Patch-File: T -*-

;;; Reason: Changed reset-tftp-server to call a new function called start-tftp-server-process-if-necessary, which will use a locking method to lock out other tftp servers being created before this one is finished.

;;;                           RESTRICTED RIGHTS LEGEND
;;;
;;; Use, duplication, or disclosure by the Government is subject to
;;; restrictions as set forth in subdivision (c)(1)(ii) of the Rights in
;;; Technical Data and Computer Software clause at 52.227-7013.
;;;
;;;   TEXAS INSTRUMENTS INCORPORATED      
;;;   P.O. BOX 2909, M/S 2151             
;;;   AUSTIN, TEXAS 78769                 
;;;
;;; Copyright (C) 1989 Texas Instruments Incorporated.
;;; All rights reserved.

;;; Written 04/24/89 06:56:55 by BERGER,
;;; while running on ARIES from band LOD1
;;; With Experimental REL6G 6.0, Experimental SYSTEM 6.0, Experimental VIRTUAL-MEMORY 6.0,
;;;  Experimental EH 6.0, Experimental MAKE-SYSTEM 6.0, Experimental MICRONET 6.0,
;;;  Experimental LOCAL-FILE 6.0, Experimental BASIC-PATHNAME 6.0, Experimental NETWORK-SUPPORT-COLD 6.0,
;;;  Experimental BASIC-NAMESPACE 6.0, Experimental NETWORK-NAMESPACE 6.0, Experimental DISK-IO 6.0,
;;;  Experimental DISK-LABEL 6.0, Experimental BASIC-FILE 6.0, Experimental MAC-PATHNAME 6.0,
;;;  Experimental NETWORK-PATHNAME 6.0, Experimental COMPILER 6.0, Experimental TV 6.0,
;;;  Experimental DATALINK 6.0, Experimental CHAOSNET 6.0, Experimental GC 6.0, Experimental MEMORY-AUX 6.0,
;;;  Experimental NVRAM 6.0, Experimental SYSLOG 6.0, Experimental STREAMER-TAPE 6.0,
;;;  Experimental CLEH 1.0, Experimental UCL 6.0, Experimental INPUT-EDITOR 6.0, Experimental METER 6.0,
;;;  Experimental ZWEI 6.0, Experimental DEBUG-TOOLS 6.0, Experimental NETWORK-SUPPORT 6.0,
;;;  Experimental NETWORK-SERVICE 6.0, DATALINK-DISPLAYS 6.0, Experimental FONT-EDITOR 6.0,
;;;  Experimental SERIAL 6.0, Experimental PRINTER 6.0, Experimental MAC-PRINTER-TYPES 6.0,
;;;  Experimental PRINTER-TYPES 6.0, Experimental IMAGEN 6.0, Experimental SUGGESTIONS 6.0,
;;;  Experimental MAIL-DAEMON 6.0, Experimental MAIL-READER 6.0, Experimental TELNET 6.0,
;;;  Experimental VT100 6.0, Experimental NAMESPACE-EDITOR 6.0, Experimental PROFILE 6.0,
;;;  VISIDOC 6.0, Experimental TI-CLOS 16.4, Experimental CLX 4.0, Experimental X11M 2.0,
;;;  Experimental CLUE 19.0, Experimental RPC 6.0, NFS 3.5, Experimental BUG 11.4,
;;;  IP 3.42, DECNET 1.64,  microcode 423, Band Name: 6.0 4/19 SLE,DNA,NP2

#!C
; From file TFTP-DEFS.LISP#> IP; WOODY:
#10R IP#:
(COMPILER-LET ((*PACKAGE* (FIND-PACKAGE "IP"))
                          (SI:*LISP-MODE* :COMMON-LISP)
                          (*READTABLE* SYS:COMMON-LISP-READTABLE)
                          (SI:*READER-SYMBOL-SUBSTITUTIONS* SYS::*COMMON-LISP-SYMBOL-SUBSTITUTIONS*))
  (COMPILER#:PATCH-SOURCE-FILE "ip: IP; TFTP-DEFS.#"



(defvar *tftp-server-process-creation-lock* nil    ; DAB 04-24-89 New function to lock tftp-server
     "Lock used when creating TFTP Server processes to make sure only one is
      created.")
))

#!C
; From file TFTP-MAIN.LISP#> IP; WOODY:
#10R IP#:
(COMPILER-LET ((*PACKAGE* (FIND-PACKAGE "IP"))
                          (SI:*LISP-MODE* :COMMON-LISP)
                          (*READTABLE* SYS:COMMON-LISP-READTABLE)
                          (SI:*READER-SYMBOL-SUBSTITUTIONS* SYS::*COMMON-LISP-SYMBOL-SUBSTITUTIONS*))
  (COMPILER#:PATCH-SOURCE-FILE "ip: IP; TFTP-MAIN.#"



(defun start-tftp-server-process-if-necessary ()     ; DAB 04-24-89 New function to lock tftp-server
     (with-lock (*tftp-server-process-creation-lock*)
       (unless *tftp-server-process*
	 (SETF *tftp-server-process*
	       (PROCESS-RUN-FUNCTION
		 `(:name ,ip:tftp-process-name :priority 5) 'tftp-server)))))

(DEFUN reset-tftp-service (&optional (enable-p nil) (debug-mode nil))
  (delete-server tftp-port '*udp-server-alist*) 
  ;(WHEN *tftp-server-process*
  ;  (WITHOUT-INTERRUPTS
  ;    (SEND *tftp-server-process* :kill t)
  ;    (SETF *tftp-server-process* nil)))
  (WHEN enable-p
    (SETF *tftp-debug-mode* debug-mode)
    (add-server tftp-port
		   '(start-tftp-server-process-if-necessary) ; DAB 04-24-89 Call new function to lock.
		   '*udp-server-alist*))
  "TFTP Reset Complete")

))
