;;; -*- Mode: Common-Lisp; Package: IP; Base: 10.; Patch-File: T -*-
;;; Written 06/08/89 07:38:37 by BERGER,
;;; Reason: Changed tftp-get-local-file-name to handle mac-pathnames.
;;; while running on ARIES from band LOD1
;;; With SYSTEM 6.5, VIRTUAL-MEMORY 6.1, EH 6.0, MAKE-SYSTEM 6.0, MICRONET 6.0, LOCAL-FILE 6.0,
;;;  BASIC-PATHNAME 6.0, NETWORK-SUPPORT-COLD 6.0, BASIC-NAMESPACE 6.0, NETWORK-NAMESPACE 6.0,
;;;  DISK-IO 6.0, DISK-LABEL 6.0, BASIC-FILE 6.1, MAC-PATHNAME 6.0, NETWORK-PATHNAME 6.0,
;;;  COMPILER 6.2, TV 6.6, DATALINK 6.0, CHAOSNET 6.0, GC 6.2, MEMORY-AUX 6.0, NVRAM 6.0,
;;;  SYSLOG 6.0, STREAMER-TAPE 6.0, UCL 6.0, INPUT-EDITOR 6.0, METER 6.0, ZWEI 6.0,
;;;  DEBUG-TOOLS 6.0, NETWORK-SUPPORT 6.0, NETWORK-SERVICE 6.0, DATALINK-DISPLAYS 6.0,
;;;  FONT-EDITOR 6.1, SERIAL 6.0, PRINTER 6.1, MAC-PRINTER-TYPES 6.1, PRINTER-TYPES 6.0,
;;;  IMAGEN 6.0, SUGGESTIONS 6.0, MAIL-DAEMON 6.2, MAIL-READER 6.0, TELNET 6.0, VT100 6.0,
;;;  NAMESPACE-EDITOR 6.0, PROFILE 6.1, VISIDOC 6.0, TI-CLOS 6.5, CLEH 6.0, IP 3.45,
;;;  Experimental BUG 11.7, CLX 6.0, CLUE 6.0, X11M 6.0,  microcode 429, Band Name: Release 6.0 + SLE 5/22

#!C
; From file TFTP-MAIN.LISP#> IP; SYS:
#10R IP#:
(COMPILER-LET ((*PACKAGE* (FIND-PACKAGE "IP"))
                          (SI:*LISP-MODE* :COMMON-LISP)
                          (*READTABLE* SYS:COMMON-LISP-READTABLE)
                          (SI:*READER-SYMBOL-SUBSTITUTIONS* SYS::*COMMON-LISP-SYMBOL-SUBSTITUTIONS*))
  (COMPILER#:PATCH-SOURCE-FILE "SYS: IP; TFTP-MAIN.#"


(DEFUN  tftp-get-local-file-name (pkt)
  "Returns the filename string in a TFTP request packet."
  (declare (special  fs::disk-configuration))  ; DAB 06-07-89
  (LET* ((name (tftp-get-string pkt tftp-request-header-size))
	 (default-host (tftp-get-host tftp-default-pathname))
	 (mac-host-p (eql (send (si:parse-host default-host) :pathname-flavor) 'fs:mac-pathname))
	 )
    ;; If the local machine has no file system mounted
    ;; and the default pathname specifies no host or the
    ;; local file system, use the associated machine as the host. 
    ;; Otherwise, use the default pathname.
    (if mac-host-p ; DAB 06-07-89 Put the host back on, otherwise the device will be parsed as a host.
	(setf name (string-append default-host ":" name)))
    (MERGE-PATHNAMES name
		     (IF (AND (NOT (VARIABLE-BOUNDP fs::disk-configuration)) ;This is always true on MX.
			      (OR (STRING-EQUAL default-host  "LM")
				  (EQ (si:parse-host default-host) si:local-host)))
			 (MAKE-PATHNAME :host (SEND si:associated-machine :name)
					:device (SEND si:associated-machine :default-device)  ; DAB 06-07-89
					:directory "SITE"
					:name "TFTP-LOST-FILE" :type "LISP")
			 tftp-default-pathname))
    ))
))
