;;; -*- Mode: Common-Lisp; Package: IP; Base: 10.; Patch-File: T -*-

;;; Reason: ip-ones-complement-checksum  was discarding valid packets when checksums was zero. Checksum of zero is a very case in UDP. I move the check to UDP. Also modified ip-ones-complement-checksum-8 and ip-ones-complement-checksum-16 to remove code that was special casing zero checksum. ****DO A (NET:RESET T) after loading this patch. ****

;;;                           RESTRICTED RIGHTS LEGEND
;;;
;;; Use, duplication, or disclosure by the Government is subject to
;;; restrictions as set forth in subdivision (c)(1)(ii) of the Rights in
;;; Technical Data and Computer Software clause at 52.227-7013.
;;;
;;;   TEXAS INSTRUMENTS INCORPORATED      
;;;   P.O. BOX 2909, M/S 2151             
;;;   AUSTIN, TEXAS 78769                 
;;;
;;; Copyright (C) 1989 Texas Instruments Incorporated.
;;; All rights reserved.

;;; Written 09/15/89 08:46:26 by BERGER,
;;; while running on ARIES from band LOD1
;;; With SYSTEM 6.15, VIRTUAL-MEMORY 6.1, EH 6.4, MAKE-SYSTEM 6.0, MICRONET 6.0, LOCAL-FILE 6.0,
;;;  BASIC-PATHNAME 6.1, NETWORK-SUPPORT-COLD 6.0, BASIC-NAMESPACE 6.2, NETWORK-NAMESPACE 6.0,
;;;  DISK-IO 6.1, DISK-LABEL 6.0, BASIC-FILE 6.2, MAC-PATHNAME 6.0, NETWORK-PATHNAME 6.0,
;;;  COMPILER 6.10, TV 6.15, DATALINK 6.0, CHAOSNET 6.0, GC 6.3, MEMORY-AUX 6.0, NVRAM 6.1,
;;;  SYSLOG 6.1, STREAMER-TAPE 6.4, UCL 6.0, INPUT-EDITOR 6.0, METER 6.1, ZWEI 6.5,
;;;  DEBUG-TOOLS 6.3, NETWORK-SUPPORT 6.0, NETWORK-SERVICE 6.1, DATALINK-DISPLAYS 6.0,
;;;  FONT-EDITOR 6.1, SERIAL 6.0, PRINTER 6.3, MAC-PRINTER-TYPES 6.1, PRINTER-TYPES 6.1,
;;;  IMAGEN 6.0, SUGGESTIONS 6.0, MAIL-DAEMON 6.2, MAIL-READER 6.2, TELNET 6.0, VT100 6.0,
;;;  NAMESPACE-EDITOR 6.0, PROFILE 6.1, VISIDOC 6.4, TI-CLOS 6.20, CLEH 6.5, IP 3.47,
;;;  Experimental CLX 6.2, CLUE 6.10, X11M 6.13, Experimental BUG 11.15, DECNET 1.69,
;;;  VISIDOC-SERVER 6.1, RPC 6.1, NFS 3.9,  microcode 429, Band Name: Rel 6.0 + SLE 8/30

#!C
; From file IP.LISP#> IP; SYS:
#10R IP#:
(COMPILER-LET ((*PACKAGE* (FIND-PACKAGE "IP"))
                          (SI:*LISP-MODE* :COMMON-LISP)
                          (*READTABLE* SYS:COMMON-LISP-READTABLE)
                          (SI:*READER-SYMBOL-SUBSTITUTIONS* SYS::*COMMON-LISP-SYMBOL-SUBSTITUTIONS*))
  (COMPILER#:PATCH-SOURCE-FILE "SYS: IP; IP.#"


(WHEN (>= (si:get-system-version 'system) 5.)
  
  (DEFUN ip-ones-complement-checksum  (array &optional (ARRAY-LENGTH (1- (LENGTH array))) &rest parm-list)
    (let ((elem-size (array-element-size array))
	  (offset 0)
	  (sum nil))
      (loop while (array-indirect-p array)
	    as new-elem-size = (array-element-size array)
	    as index-offset = (sys:array-index-offset array)
	    when index-offset
	    do (cond ((= new-elem-size elem-size)
		      (incf offset index-offset))
		     ((< new-elem-size elem-size)  ; Going to assume only 8 or 16 bit elements, so new is 8 here.
		      (setq elem-size new-elem-size
			    offset    (ash offset 1))
		      (incf offset index-offset))
		     ((> new-elem-size elem-size)  ; Going to assume only 8 or 16 bit elements, so new is 16 here.
		      (when (oddp offset)  ; May be a premature check.  The old form handles these.
			(error "Can't checksum 16b array if length not on byte boundary."))
		      (setq elem-size new-elem-size
			    offset    (ash offset -1))
		      (incf offset index-offset)))
	    doing (setq array (sys:array-indirect-to array)))
      
      (setq sum (si:%sum-array array offset array-length)) ;ksct 8/25/88  use new miscop.
      
      (setq sum (+ (ash sum -8) (ash (logand #xff sum) 8)))
      (loop for parm in parm-list
	    doing (incf sum parm))
      (loop until (< sum #x10000)
	    doing (setq sum (+ (logand #xFFFF sum) (ash sum -16))))
      
      ;; ; DAB 09-08-89 The following check was added because UDP handles zero checksum differently.
      ;; I remove the check here and added it to (udp-port :send-output-buffer) and 
      ;; (udp-handler :receive-data) because we were rejecting valid TCP packet because this function
      ;; returned #xFFFF instead of 0.
      ;; Return the ones COMPLEMENT of the sixteen bit number.  If the checksum is 0 (#XFFFF
      ;; before the LOGXOR), return >FFFF. 
      ;(if (= #xffff sum)
      ;  (values #xffff)
      ;(values (logxor #xffff sum))
      ;)
      
      (values (logxor #xffff sum))
      ))
  )

(WHEN (NOT (>= (si:get-system-version 'system) 5.))
  
  (DEFUN ip-ones-complement-checksum (array &optional (ARRAY-LENGTH (1- (LENGTH array))) &rest parm-list)
    (let ((elem-size (array-element-size array))
	  (offset 0)
	  (sum nil))
      (loop while (array-indirect-p array)
	    as new-elem-size = (array-element-size array)
	    as index-offset = (sys:array-index-offset array)
	    when index-offset
	    do (cond ((= new-elem-size elem-size)
		      (incf offset index-offset))
		     ((< new-elem-size elem-size)  ; Going to assume only 8 or 16 bit elements, so new is 8 here.
		      (setq elem-size new-elem-size
			    offset    (ash offset 1))
		      (incf offset index-offset))
		     ((> new-elem-size elem-size)  ; Going to assume only 8 or 16 bit elements, so new is 16 here.
		      (when (oddp offset)  ; May be a premature check.  The old form handles these.
			(error "Can't checksum 16b array if length not on byte boundary."))
		      (setq elem-size new-elem-size
			    offset    (ash offset -1))
		      (incf offset index-offset)))
	    doing (setq array (sys:array-indirect-to array)))
      (ecase elem-size
	(16
	 (let ((rolls (ash array-length -4))	   ; Unroll by factor of 16.
	       (unrolls (logand array-length 15))
	       (index (1- offset)))
	   (setq sum 0)
	   (loop repeat rolls
		 doing (incf sum (aref array (incf index)))
		 doing (incf sum (aref array (incf index)))
		 doing (incf sum (aref array (incf index)))
		 doing (incf sum (aref array (incf index)))
		 doing (incf sum (aref array (incf index)))
		 doing (incf sum (aref array (incf index)))
		 doing (incf sum (aref array (incf index)))
		 doing (incf sum (aref array (incf index)))
		 doing (incf sum (aref array (incf index)))
		 doing (incf sum (aref array (incf index)))
		 doing (incf sum (aref array (incf index)))
		 doing (incf sum (aref array (incf index)))
		 doing (incf sum (aref array (incf index)))
		 doing (incf sum (aref array (incf index)))
		 doing (incf sum (aref array (incf index)))
		 doing (incf sum (aref array (incf index))))
	   (loop repeat unrolls
		 doing (incf sum (aref array (incf index)))))
	 (setq sum (+ (ash sum -8) (ash (logand #xff sum) 8))))
	(8
	 (let ((rolls (ash array-length -5))	   ; Unroll by factor of 16.
	       (unrolls (logand (ash array-length -1) 15))
	       (index (1- offset))
	       (suml 0)
	       (sumr 0))
	   (loop repeat rolls
		 doing (incf suml (aref array (incf index)))
		 (incf sumr (aref array (incf index)))
		 doing (incf suml (aref array (incf index)))
		 (incf sumr (aref array (incf index)))
		 doing (incf suml (aref array (incf index)))
		 (incf sumr (aref array (incf index)))
		 doing (incf suml (aref array (incf index)))
		 (incf sumr (aref array (incf index)))
		 doing (incf suml (aref array (incf index)))
		 (incf sumr (aref array (incf index)))
		 doing (incf suml (aref array (incf index)))
		 (incf sumr (aref array (incf index)))
		 doing (incf suml (aref array (incf index)))
		 (incf sumr (aref array (incf index)))
		 doing (incf suml (aref array (incf index)))
		 (incf sumr (aref array (incf index)))
		 doing (incf suml (aref array (incf index)))
		 (incf sumr (aref array (incf index)))
		 doing (incf suml (aref array (incf index)))
		 (incf sumr (aref array (incf index)))
		 doing (incf suml (aref array (incf index)))
		 (incf sumr (aref array (incf index)))
		 doing (incf suml (aref array (incf index)))
		 (incf sumr (aref array (incf index)))
		 doing (incf suml (aref array (incf index)))
		 (incf sumr (aref array (incf index)))
		 doing (incf suml (aref array (incf index)))
		 (incf sumr (aref array (incf index)))
		 doing (incf suml (aref array (incf index)))
		 (incf sumr (aref array (incf index)))
		 doing (incf suml (aref array (incf index)))
		 (incf sumr (aref array (incf index))))
	   (loop repeat unrolls
		 doing (incf suml (aref array (incf index)))
		 (incf sumr (aref array (incf index))))
	   (setq sum (+ sumr (ash suml 8)))
	   (when (oddp array-length)
	     (incf sum (ash (aref array (+ offset -1 array-length)) 8))))))
      (loop for parm in parm-list
	    doing (incf sum parm))
      (loop until (< sum #x10000)
	    doing (setq sum (+ (logand #xFFFF sum) (ash sum -16))))
      ;;  DAB 09-08-89 The following check was added because UDP handles zero checksum differently.
      ;; I remove the check here and added it to (udp-port :send-output-buffer) and 
      ;; (udp-handler :receive-data) because we were rejecting valid TCP packet because this function
      ;; returned #xFFFF instead of 0.
      ;; Return the ones COMPLEMENT of the sixteen bit number.  If the checksum is 0 (#XFFFF
      ;; before the LOGXOR), return >FFFF. 
      ;(if (= #xffff sum)
      ;	  (values #xffff)
      ;	  (values (logxor #xffff sum)))

      (values (logxor #xffff sum))
      ))
   )

(WHEN (>= (si:get-system-version 'system) 5.)
  
  (DEFUN ip-ones-complement-checksum-16 (sixteen-bit-array length &rest parm-list)
    "Calculates the ones complement checksum for an art-16b array."
    (let (sum)
      (setq sum (si:%sum-array sixteen-bit-array 0 length))
      (loop for parm in parm-list
	    doing (incf sum parm))
      (loop until (< sum #x10000)
	    doing (setq sum (+ (logand #xFFFF sum) (ash sum -16))))
      ;;  DAB 09-08-89 The following check was added because UDP handles zero checksum differently.
      ;; I remove the check here and added it to (udp-port :send-output-buffer) and 
      ;; (udp-handler :receive-data) because we were rejecting valid TCP packet because this function
      ;; returned #xFFFF instead of 0.
       ;(if (= #xffff sum)	  (values #xffff)
       ;  (values (logxor #xffff sum)))
       (values (logxor #xffff sum))
       ))
  )

(WHEN (NOT (>= (si:get-system-version 'system) 5.))
  
; This version of ip-ones-complement-checksum-16 was enter on 4-13-88 DAB for PF.
  (DEFUN ip-ones-complement-checksum-16 (sixteen-bit-array length &rest parm-list)
    "Calculates the ones complement checksum for an art-16b array."
    (let ((rolls (ash length -4))	   ; Unroll by factor of 16.
	  (unrolls (logand length 15))
	  (index -1)
	  (sum 0))
      (loop repeat rolls
	    doing (incf sum (net:swap-bytes (aref sixteen-bit-array (incf index))))
	    doing (incf sum (net:swap-bytes (aref sixteen-bit-array (incf index))))
	    doing (incf sum (net:swap-bytes (aref sixteen-bit-array (incf index))))
	    doing (incf sum (net:swap-bytes (aref sixteen-bit-array (incf index))))
	    doing (incf sum (net:swap-bytes (aref sixteen-bit-array (incf index))))
	    doing (incf sum (net:swap-bytes (aref sixteen-bit-array (incf index))))
	    doing (incf sum (net:swap-bytes (aref sixteen-bit-array (incf index))))
	    doing (incf sum (net:swap-bytes (aref sixteen-bit-array (incf index))))
	    doing (incf sum (net:swap-bytes (aref sixteen-bit-array (incf index))))
	    doing (incf sum (net:swap-bytes (aref sixteen-bit-array (incf index))))
	    doing (incf sum (net:swap-bytes (aref sixteen-bit-array (incf index))))
	    doing (incf sum (net:swap-bytes (aref sixteen-bit-array (incf index))))
	    doing (incf sum (net:swap-bytes (aref sixteen-bit-array (incf index))))
	    doing (incf sum (net:swap-bytes (aref sixteen-bit-array (incf index))))
	    doing (incf sum (net:swap-bytes (aref sixteen-bit-array (incf index))))
	    doing (incf sum (net:swap-bytes (aref sixteen-bit-array (incf index)))))
      (loop repeat unrolls
	    doing (incf sum (net:swap-bytes (aref sixteen-bit-array (incf index)))))
;;    (setq sum (+ (ash sum -8) (ash (logand #xff sum) 8)))   ab 8/5/88
      (loop for parm in parm-list
	    doing (incf sum parm))
      (loop until (< sum #x10000)
	    doing (setq sum (+ (logand #xFFFF sum) (ash sum -16))))
      ;;  DAB 09-08-89 The following check was added because UDP handles zero checksum differently.
      ;; I remove the check here and added it to (udp-port :send-output-buffer) and 
      ;; (udp-handler :receive-data) because we were rejecting valid TCP packet because this function
      ;; returned #xFFFF instead of 0.
      ;(if (= #xffff sum)
      ;  (values #xffff)
      ;  (values (logxor #xffff sum)))
      (values (logxor #xffff sum))
      ))
  )

(WHEN (>= (si:get-system-version 'system) 5.)
  
  (DEFUN ip-ones-complement-checksum-8 (eight-bit-array length &rest parm-list)
    "Calculates the ones complement checksum for an art-8b array."
    (let (sum)
      (SETQ sum (si:%sum-array eight-bit-array 0 length))
      (loop for parm in parm-list
	    doing (incf sum parm))
      (loop until (< sum #x10000)
	    doing (setq sum (+ (logand #xFFFF sum) (ash sum -16))))
      ;;  DAB 09-08-89 The following check was added because UDP handles zero checksum differently.
      ;; I remove the check here and added it to (udp-port :send-output-buffer) and 
      ;; (udp-handler :receive-data) because we were rejecting valid TCP packet because this function
      ;; returned #xFFFF instead of 0.
       
      ;(if (= #xffff sum)
      ;   (values #xffff)
      ;   (values (logxor #xffff sum)))
      (values (logxor #xffff sum))
      ))
  )

(WHEN (NOT (>= (si:get-system-version 'system) 5.))
  
; This version of ip-ones-complement-checksum-8 was enter on 4-13-88 DAB for PF.
  (DEFUN ip-ones-complement-checksum-8 (eight-bit-array length &rest parm-list)
    "Calculates the ones complement checksum for an art-8b array."
    (let ((rolls (ash length -5))	   ; Unroll by factor of 16.
	  (unrolls (logand (ash length -1) 15))
	  (index -1)
	  (sum 0))
      (loop repeat rolls
	    doing (incf sum (+ (ash (aref eight-bit-array (incf index)) 8)
			       (aref eight-bit-array (incf index))))
	    doing (incf sum (+ (ash (aref eight-bit-array (incf index)) 8)
			       (aref eight-bit-array (incf index))))
	    doing (incf sum (+ (ash (aref eight-bit-array (incf index)) 8)
			       (aref eight-bit-array (incf index))))
	    doing (incf sum (+ (ash (aref eight-bit-array (incf index)) 8)
			       (aref eight-bit-array (incf index))))
	    doing (incf sum (+ (ash (aref eight-bit-array (incf index)) 8)
			       (aref eight-bit-array (incf index))))
	    doing (incf sum (+ (ash (aref eight-bit-array (incf index)) 8)
			       (aref eight-bit-array (incf index))))
	    doing (incf sum (+ (ash (aref eight-bit-array (incf index)) 8)
			       (aref eight-bit-array (incf index))))
	    doing (incf sum (+ (ash (aref eight-bit-array (incf index)) 8)
			       (aref eight-bit-array (incf index))))
	    doing (incf sum (+ (ash (aref eight-bit-array (incf index)) 8)
			       (aref eight-bit-array (incf index))))
	    doing (incf sum (+ (ash (aref eight-bit-array (incf index)) 8)
			       (aref eight-bit-array (incf index))))
	    doing (incf sum (+ (ash (aref eight-bit-array (incf index)) 8)
			       (aref eight-bit-array (incf index))))
	    doing (incf sum (+ (ash (aref eight-bit-array (incf index)) 8)
			       (aref eight-bit-array (incf index))))
	    doing (incf sum (+ (ash (aref eight-bit-array (incf index)) 8)
			       (aref eight-bit-array (incf index))))
	    doing (incf sum (+ (ash (aref eight-bit-array (incf index)) 8)
			       (aref eight-bit-array (incf index))))
	    doing (incf sum (+ (ash (aref eight-bit-array (incf index)) 8)
			       (aref eight-bit-array (incf index))))
	    doing (incf sum (+ (ash (aref eight-bit-array (incf index)) 8)
			       (aref eight-bit-array (incf index)))))
      (loop repeat unrolls
	    doing (incf sum (+ (ash (aref eight-bit-array (incf index)) 8)
			       (aref eight-bit-array (incf index)))))
      (loop for parm in parm-list
	    doing (incf sum parm))
      (loop until (< sum #x10000)
	    doing (setq sum (+ (logand #xFFFF sum) (ash sum -16))))
      ;;  DAB 09-08-89 The following check was added because UDP handles zero checksum differently.
      ;; I remove the check here and added it to (udp-port :send-output-buffer) and 
      ;; (udp-handler :receive-data) because we were rejecting valid TCP packet because this function
      ;; returned #xFFFF instead of 0.
      ; (if (= #xffff sum)
      ;     (values #xffff)
      ;     (values (logxor #xffff sum)))
       (values (logxor #xffff sum))
       ))
  )

(DEFMETHOD (ip-handler :receive-data) (controller ip-pkt ignore
				       &optional pkt-type src-addr dest-addr (free-buffer t)
				       &aux (default-cons-area *ip-area*) (si:background-cons-area *ip-area*)
				       (words (TRUNCATE (1+ (ip-total-length ip-pkt)) 2))
				       original-checksum recalculated-checksum
				       inbound-rte outbound-rte dest-addr-mask
				       broadcast-hostaddr broadcast-received received-locally)
  "Called by (:method ethernet:ethernet-controller :receive-top-level)."
  (DECLARE (IGNORE pkt-type src-addr))
  (UNWIND-PROTECT
      (BLOCK receive-data
	(WHEN (OR (NOT *ip-receive-enabled*) (NULL my-addresses))
	  (RETURN-FROM receive-data))
	(WHEN *record-packet-mode*
	  (record-packet ip-pkt :receive))
	(WHEN *receive-debug-mode*
	  (LET ((a (MAKE-ARRAY words :type :art-16b :area *ip-area*)))
	    (COPY-ARRAY-PORTION ip-pkt 0 words a 0 words)
	    (PUSH a *ip-pkt-rvcd-list*)
	    (FORMAT t "~&IP Packet Received:")
	    (print-header ip-pkt)))
	(INCF packets-received)
	(SETF original-checksum (ip-header-checksum ip-pkt))
	(SETF (ip-header-checksum ip-pkt) 0)
	(SETF recalculated-checksum
	      (ip-ones-complement-checksum ip-pkt (* 2 (ip-header-length ip-pkt))))
	(SETF (ip-header-checksum ip-pkt) original-checksum)
	(CONDITION-CASE ()
	    (PROGN
	     ;; checksum verification
	     (WHEN (NOT (EQL original-checksum recalculated-checksum))
	       (INCF packets-with-bad-checksums)
	       (icmp ip-pkt parameter-problem 0 10)
	       (RETURN-FROM receive-data))
	     ;; header verification
	     (WHEN (OR (NOT (= (ip-version ip-pkt) ip-version))
		       (< (ip-header-length ip-pkt) 5) (> (ip-header-length ip-pkt) 15))
	       (INCF packets-dropped)
	       (icmp ip-pkt parameter-problem 0 0)
	       (RETURN-FROM receive-data))
	     (INCF bytes-received (- (ip-total-length ip-pkt) (* 4 (ip-header-length ip-pkt))))
	     ;; routing logic
	     (SETF dest-addr (ip-dst-addr ip-pkt))
	     (DOLIST (route-info ip-routing-table)
	       (WHEN (AND (EQ (ip-routing-controller route-info) controller)
			  (EQ (ip-routing-address route-info) :direct))
		 (SETF inbound-rte route-info)))
	     (SETF outbound-rte (IF (OR (EQL dest-addr #xFFFFFFFF) (EQL dest-addr #x00000000))
				    inbound-rte
				    (get-routing-entry dest-addr)))
	     ;; receive packet locally
	     (WHEN (SETF broadcast-received (local-broadcast-address-p dest-addr))
	       (INCF ip-broadcast-pkts-received))
	     (WHEN (SETF received-locally (OR broadcast-received (MEMBER dest-addr my-addresses)))
	       (ip-pass-on-packet ip-pkt))
	     ;; route packet
	     (WHEN *gateway-host-p*
	       (COND
		 ;; when subnetted and destination host is broadcasthost
		 (broadcast-received
		  (SETF dest-addr-mask (get-default-mask dest-addr))
		  (SETF broadcast-hostaddr (LOGXOR #xFFFFFFFF dest-addr-mask))
		  (WHEN (AND (NOT (EQL dest-addr-mask (ip-routing-mask inbound-rte)))
			     (OR (ZEROP (LOGAND dest-addr broadcast-hostaddr))
				 (EQL #xFFFFFFFF
				      (LOGIOR dest-addr-mask (LOGAND dest-addr broadcast-hostaddr)))))
		    ;; recompute broadcast-hostaddr to exclude subnet bits
		    (SETF broadcast-hostaddr (LOGXOR #xFFFFFFFF (ip-routing-mask inbound-rte)))
		    (DOLIST (route-info ip-routing-table)
		      (WHEN (AND (NOT (EQL route-info inbound-rte))
				 (EQL (LOGAND (ip-routing-network route-info) dest-addr-mask)
				      (LOGAND dest-addr dest-addr-mask)))
			(INCF packets-rerouted)
			(SETF (ip-dst-addr ip-pkt)
			      (LOGIOR broadcast-hostaddr (ip-routing-network route-info)))
			(ip-transmit ip-pkt route-info)))))
		 ;; no routing needed here
		 ((EQL inbound-rte outbound-rte)
		  (WHEN (NOT received-locally) (INCF packets-not-for-this-host)))
		 ;; no routing possible here
		 ((NULL outbound-rte)
		  (INCF packets-with-unknown-gateway-for-destination)
		  (WHEN (NOT (NULL (get-routing-entry (ip-src-addr ip-pkt))))
		    (icmp ip-pkt destination-unreachable 3 0)))
		 ;; on to next hop
		 (t (INCF packets-rerouted)
		    (ip-transmit ip-pkt outbound-rte)))))
	    (system:network-error (INCF packets-dropped))))
    ;; CLean up resources.
    (WHEN free-buffer (DEALLOCATE-RESOURCE 'ip-packet ip-pkt))))

))


#!C
; From file UDP.LISP#> IP; SYS:
#10R IP#:
(COMPILER-LET ((*PACKAGE* (FIND-PACKAGE "IP"))
                          (SI:*LISP-MODE* :COMMON-LISP)
                          (*READTABLE* SYS:COMMON-LISP-READTABLE)
                          (SI:*READER-SYMBOL-SUBSTITUTIONS* SYS::*COMMON-LISP-SYMBOL-SUBSTITUTIONS*))
  (COMPILER#:PATCH-SOURCE-FILE "SYS: IP; UDP.#"


(DEFMETHOD (udp-port :send-output-buffer) (packet &optional new-packet-index)
  "This method expects the following to be initialized properly:
udp-header-source-port, udp-packet-source-address, udp-header-destination-port, udp-packet-destination-address.
NEW-PACKET-INDEX (OPTIONAL) If non-nil, the new value of the packet index.
  If nil (the default), udp-packet-index is assumed to be set up properly."
  (WHEN reset-occured-p (FERROR 'port-reset "Port ~s has been reset" self))
  (WHEN new-packet-index (SETF (udp-packet-index packet) new-packet-index))
  (SETF last-sender-process si:current-process)
  (SETF last-sent-time (TIME))
  (INCF packets-transmitted)
  (INCF bytes-transmitted (- (udp-packet-index packet) udp-header-size))
  (SETF (udp-header-length packet) (udp-packet-index packet))
  (SETF (udp-header-checksum packet) 0)
  (let ((checksum (ip-ones-complement-checksum packet (udp-packet-index packet)  ; DAB 09-08-89
				     (udp-packet-destination-address packet)
				     (udp-packet-source-address packet)
				     (udp-header-length packet) *udp-protocol*)))
    ;;DAB 09-08-89 If the checksum is zero, return #xFFFF according to DOD Spec 2-176, RFC768 p2.
    (SETF (udp-header-checksum packet) (if (zerop checksum) #xFFFF checksum)))
  (WHEN *udp-debug-mode*
    (FORMAT t "~&UDP PACKET TRANSMITTED:")
    (print-udp-header packet))
  (SEND *ip-handler* :transmit packet :udp (udp-packet-destination-address packet)
	(udp-packet-index packet) (udp-packet-source-address packet)))
))

#!C
; From file UDPHAND.LISP#> IP; SYS:
#10R IP#:
(COMPILER-LET ((*PACKAGE* (FIND-PACKAGE "IP"))
                          (SI:*LISP-MODE* :COMMON-LISP)
                          (*READTABLE* SYS:COMMON-LISP-READTABLE)
                          (SI:*READER-SYMBOL-SUBSTITUTIONS* SYS::*COMMON-LISP-SYMBOL-SUBSTITUTIONS*))
  (COMPILER#:PATCH-SOURCE-FILE "SYS: IP; UDPHAND.#"


(DEFMETHOD (udp-handler :receive-data) (ip-packet start length source-address destination-address
					&aux packet packet-checksum computed-checksum 
					port-number port server-entry)
  (DECLARE (inline copy-pkt))
  (LET* ((default-cons-area *ip-area*))
    (INCF packets-received)
    ;; copy ip-packet to udp-packet
    (SETF length (MIN *udp-maximum-packet-size* length))
    (SETF packet (ALLOCATE-RESOURCE 'udp-packet length
				    :source-address source-address
				    :destination-address destination-address))
    (SETF (udp-packet-time packet) (TIME))
    (copy-pkt ip-packet packet length start)
    (WHEN *udp-debug-mode*
      (FORMAT t "~&UDP Packet Received:")
      (print-udp-header packet))
    (SETF port-number (udp-header-destination-port packet))
    (WITHOUT-INTERRUPTS
      (SETF port (CDR (ASSOC port-number *udp-receive-list*))))
    (SETF packet-checksum (udp-header-checksum packet))
    (SETF (udp-header-checksum packet) 0)
    ;;DAB 09-08-89 If the incoming packet has a checksum of ZERO indicates the transmitter
    ;; generated no checksum. If the checksum is #xFFFF indicates the checksum was generated 
    ;; and was equal to ZERO. RFC 768 P2, DOD Spec 2-176.
    (SETF computed-checksum (IF (ZEROP packet-checksum) 
				0
				(ip-ones-complement-checksum packet length 
							     destination-address source-address 
							     length *udp-protocol*)))
    (COND ((NOT (or (EQL packet-checksum computed-checksum)  ; DAB 09-08-89
		    (and (eql packet-checksum #xFFFF) ; DAB 09-08-89
			 (eql computed-checksum 0))))
	   (INCF checksum-errors)
	   (UNLESS (NULL port) (INCF (udp-port-checksum-errors port)))
	   (WHEN *udp-debug-mode*
	     (FORMAT t "~&UDP checksum error.  Packet = #x~16,4,'0r, Computed = #x~16,4,'0r."
		     packet-checksum computed-checksum))
	   (DEALLOCATE-RESOURCE 'udp-packet packet))
	  (t
	   (WHEN *udp-debug-mode* 
	     (tv:notify nil 
			"~&UPD-RECEIVE-DATA HANDLER: Port number = ~A  Port = ~A"
			port-number port))
	   (WITHOUT-INTERRUPTS
	     (COND ((NULL port)
		    (COND ((SETF server-entry
				 (ASSOC (udp-header-destination-port packet) *udp-server-alist* :test 'eql))
			   (PUSH (si:init-form server-entry) background-requests)
			   (WHEN (NOT background-event)
			     (SETF background-event (TIME-INCREMENT (TIME) *udp-server-packet-timeout*)))
			   (SETF server-packet-list (NREVERSE (CONS packet (NREVERSE server-packet-list)))))
			  (t
			   (DEALLOCATE-RESOURCE 'udp-packet packet)
			   (INCF nonexistant-ports))))
		   ((SEND port :received-packet)
		    (DEALLOCATE-RESOURCE 'udp-packet packet)
		    (INCF (udp-port-receive-overruns port)))
		   (t
		    (SETF (SEND port :received-packet) packet)
		    (SETF (SEND port :last-buffered-time) (time:get-universal-time))
		    (SETF (SEND port :sender-port) (udp-header-source-port packet))
		    (SETF (SEND port :sender-address) source-address)
		    (SETF (SEND port :receiver-address) destination-address))))))))
))
