;;; -*- Mode: Common-Lisp; Package: User; Base: 10.; Patch-File: T -*-
;;; Patch file for IP version 4.5
;;; Reason: after we build IP, we register :UDP if needed.
;;; Written 03/11/88 14:08:38 by KENNY,
;;; while running on Yankee from band LOD3
;;; With Experimental SYSTEM 4.17, Experimental COMPILER 4.0, Experimental NAMESPACE 4.1,
;;;  Experimental TV 4.12, Experimental DATALINK 4.6, CHAOSNET 4.2, Experimental GC 4.0,
;;;  Experimental NVRAM 4.2, Experimental SYSLOG 4.0, Experimental IO 4.7, Experimental STREAMER-TAPE 4.0,
;;;  Experimental UCL 4.0, Experimental INPUT-EDITOR 4.0, Inconsistent PATHNAME-COLD 4.14,
;;;  Experimental FILE-COLD 4.4, Experimental METER 4.0, Inconsistent ZWEI 4.11, Experimental DEBUG-TOOLS 4.0,
;;;  Experimental NETWORK-SUPPORT 4.0, Experimental NETWORK-SERVICE 4.0, Experimental DATALINK-DISPLAYS 4.0,
;;;  Experimental FONT-EDITOR 4.0, Experimental SERIAL 4.0, Experimental PRINTER 4.1,
;;;  Experimental PRINTER-TYPES 1.0, Experimental IMAGEN 4.0, Experimental SUGGESTIONS 4.0,
;;;  Experimental MAIL-DAEMON 4.0, Experimental MAIL-READER 4.2, Experimental TELNET 4.0,
;;;  Experimental VT100 4.1, Experimental NAMESPACE-EDITOR 4.1, Experimental PROFILE 4.0,
;;;  VISIDOC 1.0, Experimental BUG 10.0, Experimental IP 4.4, Experimental ETHERMAIL 3.0,
;;;  Inconsistent RPC 4.9, Inconsistent NFS 4.21, Inconsistent NFS-SERVER 4.7,  microcode 510,
;;;  Band Name: 4.0(2/12)+NFS+Ethermail

#!C
; From file UDP-MEDIUM.LISP#> IP; MR-X:
#10R IP#:
(COMPILER-LET ((*PACKAGE* (FIND-PACKAGE "IP"))
                          (SI:*LISP-MODE* :COMMON-LISP)
                          (*READTABLE* SYS:COMMON-LISP-READTABLE)
                          (SI:*READER-SYMBOL-SUBSTITUTIONS* SYS::*COMMON-LISP-SYMBOL-SUBSTITUTIONS*))
  (COMPILER#:PATCH-SOURCE-FILE "SYS: IP; UDP-MEDIUM.#"



;; A kludge to support the microExplorer. Rpc is loaded before IP so IP needs to go back
;; a register itself with the RPC handler if RPC is loaded.

(when (and (find-package "RPC")
	   (si:find-system-named "RPC" t t))
  (let ((sym (find-symbol "REGISTER-TRANSPORT-PROTOCOL" "RPC")))
    (let ((handler (intern "*UDP-HANDLER*" "IP"))
	  (receive-list (intern "*UDP-RECEIVE-LIST*" "IP"))
	  (max-udp-size (intern "*MAX-UDP-MSG-SIZE*" "RPC")) )
      (when (and handler sym (fboundp sym))
	
	(funcall sym :UDP
		 :protocol-no  17
		 :pmap-port-no 111.
		 :max-msg-size (symbol-value max-udp-size)
		 :port-handler (symbol-value handler)
		 :port-validator
		 #'(lambda (port-object)
		     (rest (rassoc port-object (symbol-value receive-list) :test #'eq)))
		 :get-port-object
		 #'(lambda (port-no)
		     (rest (assoc port-no (symbol-value receive-list)))))))))

;;; we need to start nfs server somewhere !! -- Tung
))
