;;; -*- Mode: Common-Lisp; Package: ip; Base: 10.; Patch-File: T -*-

;;; Reason: Fixed ftp-server default-directory to merge device on MXs. Fixed ftp-parse-for-server to handl string that is a pathname object.

;;;                           RESTRICTED RIGHTS LEGEND
;;;
;;; Use, duplication, or disclosure by the Government is subject to
;;; restrictions as set forth in subdivision (c)(1)(ii) of the Rights in
;;; Technical Data and Computer Software clause at 52.227-7013.
;;;
;;;   TEXAS INSTRUMENTS INCORPORATED      
;;;   P.O. BOX 149149, M/S 2151             
;;;   AUSTIN, TEXAS 78714-9149                 
;;;
;;; Copyright (C) 1989 Texas Instruments Incorporated.
;;; All rights reserved.

;;; Written 09/29/89 07:21:56 by BERGER,
;;; while running on MX29 from band P815
;;; With SYSTEM 6.15, GC 6.3, VIRTUAL-MEMORY 6.1, MICRONET 6.0, MICRONET-COMM 6.1,
;;;  DISK-IO 6.1, DISK-LABEL 6.0, BASIC-PATHNAME 6.1, MAC-PATHNAME 6.0, NETWORK-SUPPORT-COLD 6.0,
;;;  BASIC-NAMESPACE 6.2, BASIC-FILE 6.2, RPC 6.1, NFS-MX 6.1, EH 6.4, MAKE-SYSTEM 6.0,
;;;  MEMORY-AUX 6.0, COMPILER 6.10, TV 6.15, NVRAM 6.1, UCL 6.0, INPUT-EDITOR 6.0,
;;;  MACTOOLBOX 2.7, METER 6.1, ZWEI 6.5, DEBUG-TOOLS 6.3, WINDOW-MX 6.8, PRINTER 6.3,
;;;  MAC-PRINTER-TYPES 6.1, CLIPBOARD 6.1, TI-CLOS 6.20, CLEH 6.5, NETWORK-PATHNAME 6.0,
;;;  NETWORK-NAMESPACE 6.0, DATALINK 6.0, CHAOSNET 6.0, NETWORK-SUPPORT 6.0, NETWORK-SERVICE 6.1,
;;;  DATALINK-DISPLAYS 6.0, MX-DATALINK 6.1, NAMESPACE-EDITOR 6.0, IP 3.49, NFS-MX-SERVER 6.0,
;;;  MX-SERIAL 6.1, PRINTER-TYPES 6.1, IMAGEN 6.0, MAIL-DAEMON 6.2, MAIL-READER 6.2,
;;;  TELNET 6.0, VT100 6.0, STREAMER-TAPE 6.4, DECNET 1.70, VISIDOC 6.4, PROFILE 6.1,
;;;  Experimental CLX 6.3, CLUE 6.17, Experimental BUG 11.15,  microcode 138, Band Name: esmicroExplorer Network + SLE (8/15)

#!C
; From file FTP-SERVER.LISP#> IP; SYS:
#10R IP#:
(COMPILER-LET ((*PACKAGE* (FIND-PACKAGE "IP"))
                          (SI:*LISP-MODE* :COMMON-LISP)
                          (*READTABLE* SYS:COMMON-LISP-READTABLE)
                          (SI:*READER-SYMBOL-SUBSTITUTIONS* SYS::*COMMON-LISP-SYMBOL-SUBSTITUTIONS*))
  (COMPILER#:PATCH-SOURCE-FILE "SYS: IP; FTP-SERVER.#"

(defun ftp-parse-for-server
       (string &optional  (default-pathname (send (fs:sample-pathname "boot|lm") :merge-device)) &aux pathname)
  (condition-case (result)
      (progn
       (unless (strinGP STRING)   ; DAB 09-29-89
	 (SETF STRING (SEND STRING :String-FOR-host)))
       (if (typep default-pathname 'fs:lispm-pathname)
	   (fs:merge-pathname-defaults string default-pathname :unspecific :newest)
	   (multiple-value-bind (device directory name type version ignore quoted-string)
	       (send default-pathname :parse-namestring nil string)
	     (setf pathname
		   (fs:make-pathname-internal
		     quoted-string (pathname-host default-pathname)
		     device directory name type version)))
	   (fs:merge-pathname-defaults pathname default-pathname :unspecific :newest)))
    (pathname-error (send result :report-string))))



(DEFUN ftp-server-initialize ()
  "FTP Server's initialization function.
It sets all instance variables to their defaults."
  (DECLARE (SPECIAL default-directory))
  (DECLARE (SPECIAL user-name))
  (DECLARE (SPECIAL type-code))
  (DECLARE (SPECIAL byte-size))
  (DECLARE (SPECIAL format))
  (DECLARE (SPECIAL mode))
  (DECLARE (SPECIAL structure))
  (DECLARE (SPECIAL control-connection))
  (DECLARE (SPECIAL data-connection))
  (DECLARE (SPECIAL data-port-number))
  (DECLARE (SPECIAL data-port-address))
  (SETQ default-directory
	(send (MAKE-PATHNAME :host 'lm :directory :root :name :wild :type :unspecific :version :newest)
	      :merge-device))  ; DAB 09-29-89
  (SETQ user-name ())			   ; not logged in yet
  (SETQ type-code :ascii)		   ; for defaults, see the RFC
  (SETQ byte-size 8)
  (SETQ format :non-print)
  (SETQ mode :stream)
  (SETQ structure :file)
  (WHEN data-connection			   ; this is for reinitialize
    (IGNORE-ERRORS (CLOSE data-connection :abort t))
    (SETQ data-connection ()))
  ;; get the remote socket
  (SETQ data-port-number (NTH-VALUE 1 (SEND control-connection :status)))
  (SETQ data-port-address (NTH-VALUE 2 (SEND control-connection :status)))
  (WHEN (OR (NULL user-id)		   ; if no one is logged in
	    (EQUAL user-id ""))
    (LOGIN "File Server" 'lm t)		   ; login as File Server
    (fs::print-server-login-exegesis))	   ; and notify local user
  )
))
