;;; -*- Mode: Common-Lisp; Package: IP; Base: 10.; Patch-File: T -*-
;;; Patch file for IP version 3.7
;;; Reason: Fixed display-status when user mouses outside the margin choices. Now will return TOP-CHOICE.
;;; Written 04/07/88 07:37:49 by BERGER,
;;; while running on ARIES from band LODX
;;; With SYSTEM 4.48, Experimental VIRTUAL-MEMORY 4.0, Experimental EH 4.0, Experimental MAKE-SYSTEM 4.4,
;;;  Experimental MICRONET 4.3, Experimental LOCAL-FILE 4.0, BASIC-PATHNAME 4.8, Experimental DISK-IO 4.2,
;;;  Experimental DISK-LABEL 4.0, BASIC-FILE 4.5, Experimental MAC-PATHNAME 4.3, Experimental NETWORK-PATHNAME 4.0,
;;;  Experimental COMPILER 4.1, NETWORK-NAMESPACE 4.3, TV 4.60, DATALINK 4.13, Experimental CHAOSNET 4.5,
;;;  Experimental GC 4.3, Experimental MEMORY-AUX 4.0, Experimental NVRAM 4.3, Experimental SYSLOG 4.0,
;;;  Experimental STREAMER-TAPE 4.1, Experimental UCL 4.1, Experimental INPUT-EDITOR 4.0,
;;;  Experimental METER 4.3, Experimental ZWEI 4.16, Experimental DEBUG-TOOLS 4.2,
;;;  Experimental NETWORK-SUPPORT 4.2, Experimental NETWORK-SERVICE 4.0, Experimental DATALINK-DISPLAYS 4.0,
;;;  Experimental FONT-EDITOR 4.0, Experimental SERIAL 4.0, Experimental PRINTER 4.6,
;;;  Experimental PRINTER-TYPES 4.0, Experimental IMAGEN 4.0, Experimental SUGGESTIONS 4.0,
;;;  Experimental MAIL-DAEMON 4.3, Experimental MAIL-READER 4.5, Experimental TELNET 4.0,
;;;  Experimental VT100 4.4, Experimental NAMESPACE-EDITOR 4.4, PROFILE 4.4, VISIDOC 4.4,
;;;  NAMESPACE 4.14, Experimental NETWORK-SUPPORT-COLD 4.1, Experimental IP 3.6, Experimental BUG 10.0,
;;;   microcode 522, Band Name: pre 4.0 + IP 3/24

#!C
; From file FTPI.LISP#> IP; SYS:
#10R IP#:
(COMPILER-LET ((*PACKAGE* (FIND-PACKAGE "IP"))
                          (SI:*LISP-MODE* :COMMON-LISP)
                          (*READTABLE* SYS:COMMON-LISP-READTABLE)
                          (SI:*READER-SYMBOL-SUBSTITUTIONS* SYS::*COMMON-LISP-SYMBOL-SUBSTITUTIONS*))
  (COMPILER#:PATCH-SOURCE-FILE "SYS: IP; FTPI.#"


(DEFUN DISPLAY-STATUS (&OPTIONAL (EXPERT-MODE NIL) &AUX CHOICE)
 ;; 8/29/85 - modified to always allow choice of returning to previous menu
  (LET* ((CHOICE-ACTION '(NIL CHOICE-BOX-HANDLER NIL NIL))
	 (RETRY-CHOICE "To previous menu")
	 (TOP-CHOICE "To top-level menu")
	 (ABORT-CHOICE "Exit FTP")
	 (CHOICE-LIST
	  (LIST (CONS RETRY-CHOICE CHOICE-ACTION)
		(CONS TOP-CHOICE CHOICE-ACTION)
		(CONS ABORT-CHOICE CHOICE-ACTION))))
    (WHEN (NULL *FTP-STATUS-WINDOW*)
      (SETQ *FTP-STATUS-WINDOW*
	    (MAKE-INSTANCE 'FTP-STATUS-WINDOW-FLAVOR
			   :EDGES `(100
				     100
				     ,(min 800 (send tv:selected-window :width))  ;02-25-88 DAB
				     300)
			   :BLINKER-P ()
			   :LABEL "FTP STATUS"
                           :MARGIN-CHOICES ())))
    ;; want margin choices to be dynamic (based on status code) 
    (SEND *FTP-STATUS-WINDOW* :SET-MARGIN-CHOICES CHOICE-LIST)
    ;; display status information
    (SEND *FTP-STATUS-WINDOW* :EXPOSE-NEAR '(:MOUSE))
    (CONDITION-CASE ()
       (PROGN;catch abort here
	(SEND *FTP-STATUS-WINDOW* :SELECT ())
	(SEND *FTP-STATUS-WINDOW* :LINE-OUT "")
	(WHEN EXPERT-MODE; include last command executed in this mode
	  (SEND *FTP-STATUS-WINDOW* :STRING-OUT-CENTERED
	     (FORMAT () "Last command: ~A" *FTP-LAST-COMMAND*))
	  (SEND *FTP-STATUS-WINDOW* :LINE-OUT "")
	  (SEND *FTP-STATUS-WINDOW* :LINE-OUT ""))
	(SEND *FTP-STATUS-WINDOW* :STRING-OUT-CENTERED
	   (FORMAT () "Status code: ~A" *FTP-STATUS-CODE*))
	(SEND *FTP-STATUS-WINDOW* :LINE-OUT "")
	(SEND *FTP-STATUS-WINDOW* :LINE-OUT "")
	(CENTER-BLOCK *FTP-STATUS-MSG*)
	(WHEN *FTP-UNFAVORABLE*
	  (SEND *FTP-STATUS-WINDOW* :SET-REVERSE-VIDEO-P T)
	  (PROCESS-SLEEP 30 "ERROR"
			 );wait half a sec
	  (SEND *FTP-STATUS-WINDOW* :SET-REVERSE-VIDEO-P ()))
	(LOOP UNTIL (CONSP (SETQ CHOICE (SEND *FTP-STATUS-WINDOW* :ANY-TYI)))
	      FINALLY (RETURN (SETQ CHOICE (CADDR CHOICE))));choice-box-name
	)
       (SYSTEM:ABORT (SETQ CHOICE ())));cause to leave program
    (SEND *FTP-STATUS-WINDOW* :SET-REVERSE-VIDEO-P ())
    (SEND *FTP-STATUS-WINDOW* :DESELECT)
    (SEND *FTP-STATUS-WINDOW* :DEEXPOSE)
    ;; *** SEEMS TO PREVENT BLOWUP IN CVV WHEN SUBSEQUENTLY RETRYING PREVIOUS OPERATION ***
    (SEND *FTP-STATUS-WINDOW* :CLEAR-INPUT)
    ;; wait to do select to return result as result of this function
    (when (stringp choice)   ;otherwise the user mouse outside the margin choices. Default to top-choice 03-30-88 DAb
	(SELECTOR CHOICE STRING-EQUAL
	  (RETRY-CHOICE :RETRY)
	  (TOP-CHOICE NIL)
	  (OTHERWISE (PROGN
		       (SETQ *GLOBAL-FTP-EXIT* T)
		       ())))			;end select
	)))
))
