;;;-*- cold-load:t; Mode: Common-Lisp; Package: SI; Base: 10. -*-


;;;                           RESTRICTED RIGHTS LEGEND

;;;Use, duplication, or disclosure by the Government is subject to
;;;restrictions as set forth in subdivision (c)(1)(ii) of the Rights in
;;;Technical Data and Computer Software clause at 52.227-7013.

;;;                     TEXAS INSTRUMENTS INCORPORATED.
;;;                              P.O. BOX 2909
;;;                           AUSTIN, TEXAS 78769
;;;                                 MS 2151

;;; Copyright (C) 1987-1989 Texas Instruments Incorporated.  All rights reserved.

;;;  Initial Symbols in the LISP Package.

;;;  Contains as external symbols those symbols defined by standard 
;;;  Common Lisp as specified by Steele in CLTL (silver book) 
;;;  and on his clarifications list.  All symbols required for 
;;;  writing portable Common Lisp programs should reside in this
;;;  package.  Symbols that are used to implement Common Lisp may 
;;;  be specified as internal symbols in the LISP package.
;;;

;;;  04/25/89   jlm     moved COMPILEDP and DISPLACED-ARRAY-P to TICL
;;;  04/13/89   jlm     Removed many functions from LISP package (moved to TICL)
;;;  04/11/89	jlm	Removed PUTPROP it is now defined only in TICL and inherited in LISP

(defconstant *INITIAL-COMMON-LISP-SYMBOLS*
	     'LISP:(
	       
;;; Lambda-list keywords required by CLTL.
	       
	       &ALLOW-OTHER-KEYS
	       &AUX
	       &BODY
	       &ENVIRONMENT
	       &KEY
	       &OPTIONAL
	       &REST
	       &WHOLE
	       
;;; Variables and Function Names
	       
	       *
	       **
	       ***
	       *APPLYHOOK*
	       *BREAK-ON-WARNINGS*			
	       *DEBUG-IO*
	       *DEFAULT-PATHNAME-DEFAULTS*
	       *ERROR-OUTPUT*
	       *EVALHOOK*
	       *FEATURES*
	       *LOAD-VERBOSE*
	       *MACROEXPAND-HOOK*
	       *MODULES*
	       *PACKAGE*
	       *PRINT-ARRAY*
	       *PRINT-BASE*
	       *PRINT-CASE*
	       *PRINT-CIRCLE*
	       *PRINT-ESCAPE*
	       *PRINT-GENSYM*
	       *PRINT-LENGTH*
	       *PRINT-LEVEL*
	       *PRINT-PRETTY*
	       *PRINT-RADIX*
	       *QUERY-IO*
	       *RANDOM-STATE*
	       *READ-BASE*
	       *READ-DEFAULT-FLOAT-FORMAT*
	       *READ-SUPPRESS*
	       *READTABLE*
	       *STANDARD-INPUT*
	       *STANDARD-OUTPUT*
	       *TERMINAL-IO*
	       *TRACE-OUTPUT*
	       +
	       ++
	       +++
	       -
	       /
	       //
	       ///
	       /=
	       1+
	       1-
	       <
	       <=
	       =
	       >
	       >=
	       
	       ABS
	       ACONS
	       ACOS
	       ACOSH						
	       ADJOIN
	       ADJUST-ARRAY
	       ADJUSTABLE-ARRAY-P
	       ALPHA-CHAR-P
	       ALPHANUMERICP
	       AND
	       APPEND
	       APPLY
	       APPLYHOOK
	       APROPOS
	       APROPOS-LIST
	       AREF
	       ;;ARGLIST	;jlm 4/13/89
	       ARRAY
	       ARRAY-DIMENSION
	       ARRAY-DIMENSION-LIMIT
	       ARRAY-DIMENSIONS
	       ARRAY-ELEMENT-TYPE
	       ARRAY-HAS-FILL-POINTER-P
	       ARRAY-IN-BOUNDS-P
	       ARRAY-RANK
	       ARRAY-RANK-LIMIT
	       ARRAY-ROW-MAJOR-INDEX
	       ARRAY-TOTAL-SIZE
	       ARRAY-TOTAL-SIZE-LIMIT
	       ARRAYP
	       ASH
	       ASIN
	       ASINH
	       ASSERT
	       ASSOC
	       ASSOC-IF
	       ASSOC-IF-NOT
	       ATAN					  
	       ATANH
	       ATOM
	       BIGNUM
	       BIT
	       BIT-AND
	       BIT-ANDC1
	       BIT-ANDC2
	       BIT-EQV
	       BIT-IOR
	       BIT-NAND
	       BIT-NOR
	       BIT-NOT
	       BIT-ORC1
	       BIT-ORC2
	       BIT-VECTOR
	       BIT-VECTOR-P
	       BIT-XOR
	       BLOCK
	       BOOLE
	       BOOLE-1
	       BOOLE-2
	       BOOLE-AND
	       BOOLE-ANDC1
	       BOOLE-ANDC2
	       BOOLE-C1
	       BOOLE-C2
	       BOOLE-CLR
	       BOOLE-EQV
	       BOOLE-IOR
	       BOOLE-NAND
	       BOOLE-NOR
	       BOOLE-ORC1
	       BOOLE-ORC2
	       BOOLE-SET
	       BOOLE-XOR
	       BOTH-CASE-P
	       BOUNDP
	       BREAK
	       BUTLAST
	       BYTE
	       BYTE-POSITION
	       BYTE-SIZE
	       CAAAAR
	       CAAADR
	       CAAAR
	       CAADAR
	       CAADDR
	       CAADR
	       CAAR
	       CADAAR
	       CADADR
	       CADAR
	       CADDAR
	       CADDDR
	       CADDR
	       CADR
	       CALL-ARGUMENTS-LIMIT
	       CAR
	       CASE
	       CATCH
	       CCASE
	       CDAAAR
	       CDAADR
	       CDAAR
	       CDADAR
	       CDADDR
	       CDADR
	       CDAR
	       CDDAAR
	       CDDADR
	       CDDAR
	       CDDDAR
	       CDDDDR
	       CDDDR
	       CDDR
	       CDR
	       CEILING
	       CERROR
	       CHAR
	       CHAR-BIT
	       CHAR-BITS
	       CHAR-BITS-LIMIT
	       CHAR-CODE
	       CHAR-CODE-LIMIT
	       CHAR-CONTROL-BIT
	       CHAR-DOWNCASE
	       CHAR-EQUAL
	       CHAR-FONT
	       CHAR-FONT-LIMIT
	       CHAR-GREATERP
	       CHAR-HYPER-BIT
	       CHAR-INT
	       CHAR-LESSP
	       CHAR-META-BIT
	       CHAR-NAME
	       CHAR-NOT-EQUAL
	       CHAR-NOT-GREATERP
	       CHAR-NOT-LESSP
	       CHAR-SUPER-BIT
	       CHAR-UPCASE
	       CHAR/=
	       CHAR<
	       CHAR<=
	       CHAR=
	       CHAR>
	       CHAR>=
	       CHARACTER
	       CHARACTERP
	       CHECK-TYPE
	       CIS
	       CLEAR-INPUT
	       CLEAR-OUTPUT
	       CLOSE
	       CLRHASH
	       CODE-CHAR
	       COERCE
	       COMMON
	       COMMONP
	       COMPILATION-SPEED
	       COMPILE
	       COMPILE-FILE
	       COMPILED-FUNCTION
	       COMPILED-FUNCTION-P
	       ;;COMPILEDP	; jlm 4/25/89
	       COMPILER-LET		
	       COMPLEX
	       COMPLEXP
	       CONCATENATE
	       COND
	       CONJUGATE
	       CONS
	       CONSP
	       CONSTANTP
	       ;;COPY	;jlm 4/13/89
	       COPY-ALIST
	       COPY-LIST
	       COPY-READTABLE
	       COPY-SEQ
	       COPY-SYMBOL
	       COPY-TREE
	       COS
	       COSH
	       COUNT
	       COUNT-IF
	       COUNT-IF-NOT
	       CTYPECASE
	       DECF
	       DECLARATION
	       DECLARE
	       DECODE-FLOAT
	       DECODE-UNIVERSAL-TIME
	       DEFCONSTANT
	       DEFINE-MODIFY-MACRO
	       DEFINE-SETF-METHOD
	       DEFMACRO
	       DEFPARAMETER
	       DEFSETF
	       DEFSTRUCT				    
	       DEFTYPE
	       DEFUN
	       DEFVAR
	       DELETE
	       DELETE-DUPLICATES
	       DELETE-FILE
	       DELETE-IF
	       DELETE-IF-NOT
	       DELETE-PACKAGE
	       ;;DELETE-SETF-METHOD	;jlm 4/13/89
	       DENOMINATOR
	       DEPOSIT-FIELD
	       DESCRIBE
	       DIGIT-CHAR
	       DIGIT-CHAR-P
	       DIRECTORY
	       DIRECTORY-NAMESTRING
	       DISASSEMBLE
	       ;;DISPLACED-ARRAY-P	;jlm 4/25/89
	       DO
	       DO*
	       DO-ALL-SYMBOLS
	       DO-EXTERNAL-SYMBOLS
	       DO-SYMBOLS
	       DOCUMENTATION
	       DOLIST
	       DOTIMES
	       DOUBLE-FLOAT
	       DOUBLE-FLOAT-EPSILON
	       DOUBLE-FLOAT-NEGATIVE-EPSILON
	       DPB
	       DRIBBLE
	       ECASE
	       ED					
	       EIGHTH
	       ELT
	       ENCODE-UNIVERSAL-TIME
	       ENDP
	       ENOUGH-NAMESTRING
	       EQ
	       EQL
	       EQUAL
	       EQUALP
	       ERROR
	       ETYPECASE
	       EVAL					       
	       EVAL-WHEN
	       EVALHOOK
	       EVENP
	       EVERY
	       EXP
	       EXPORT
	       EXPT
	       FBOUNDP
	       FCEILING
	       FFLOOR
	       FIFTH
	       FILE-AUTHOR
	       FILE-LENGTH
	       FILE-NAMESTRING
	       FILE-POSITION
	       FILE-WRITE-DATE
	       FILL
	       FILL-POINTER
	       FIND
	       FIND-ALL-SYMBOLS				
	       FIND-IF
	       FIND-IF-NOT
	       FIND-PACKAGE
	       FIND-SYMBOL
	       FINISH-OUTPUT
	       FIRST
	       FIXNUM
	       FLET
	       FLOAT
	       FLOAT-DIGITS
	       FLOAT-PRECISION
	       FLOAT-RADIX
	       FLOAT-SIGN
	       FLOATP
	       FLOOR
	       FMAKUNBOUND
	       FORCE-OUTPUT
	       FORMAT
	       FOURTH						
	       FRESH-LINE
	       FROUND
	       FTRUNCATE
	       FTYPE
	       FUNCALL
	       FUNCTION
	       FUNCTIONP					
	       GCD
	       GENSYM
	       GENTEMP
	       GET
	       GET-DECODED-TIME
	       GET-DISPATCH-MACRO-CHARACTER
	       GET-INTERNAL-REAL-TIME
	       GET-INTERNAL-RUN-TIME
	       GET-MACRO-CHARACTER
	       GET-OUTPUT-STREAM-STRING
	       GET-PROPERTIES
	       GET-SETF-METHOD
	       GET-SETF-METHOD-MULTIPLE-VALUE
	       GET-UNIVERSAL-TIME
	       GETF
	       GETHASH
	       GO
	       GRAPHIC-CHAR-P
	       HASH-TABLE
	       HASH-TABLE-COUNT
	       HASH-TABLE-P
	       HASH-TABLE-REHASH-SIZE
	       HASH-TABLE-REHASH-THRESHOLD
	       HASH-TABLE-SIZE
	       HASH-TABLE-TEST
	       HOST-NAMESTRING
	       IDENTITY
	       IF
	       IGNORE
	       IMAGPART
	       IMPORT
	       IN-PACKAGE
	       INCF
	       INLINE
	       INPUT-STREAM-P
	       INSPECT
	       INT-CHAR
	       INTEGER
	       INTEGER-DECODE-FLOAT
	       INTEGER-LENGTH
	       INTEGERP
	       INTERN
	       INTERNAL-TIME-UNITS-PER-SECOND		
	       INTERSECTION				 
	       ISQRT
	       KEYWORD
	       KEYWORDP
	       LABELS
	       LAMBDA
	       LAMBDA-LIST-KEYWORDS
	       LAMBDA-PARAMETERS-LIMIT
	       LAST
	       LCM
	       LDB
	       LDB-TEST
	       LDIFF
	       LEAST-NEGATIVE-DOUBLE-FLOAT
	       LEAST-NEGATIVE-LONG-FLOAT
	       LEAST-NEGATIVE-SHORT-FLOAT
	       LEAST-NEGATIVE-SINGLE-FLOAT
	       LEAST-POSITIVE-DOUBLE-FLOAT
	       LEAST-POSITIVE-LONG-FLOAT
	       LEAST-POSITIVE-SHORT-FLOAT
	       LEAST-POSITIVE-SINGLE-FLOAT
	       LENGTH
	       LET
	       LET*
	       LISP-IMPLEMENTATION-TYPE
	       LISP-IMPLEMENTATION-VERSION
	       LIST
	       LIST*
	       LIST-ALL-PACKAGES
	       LIST-LENGTH
	       LISTEN
	       LISTP
	       LOAD
	       LOCALLY
	       LOG
	       LOGAND
	       LOGANDC1
	       LOGANDC2
	       LOGBITP
	       LOGCOUNT
	       LOGEQV
	       LOGIOR
	       LOGNAND
	       LOGNOR
	       LOGNOT
	       LOGORC1
	       LOGORC2
	       LOGTEST
	       LOGXOR
	       LONG-FLOAT
	       LONG-FLOAT-EPSILON
	       LONG-FLOAT-NEGATIVE-EPSILON
	       LONG-SITE-NAME
	       LOOP
	       LOWER-CASE-P
	       MACHINE-INSTANCE
	       MACHINE-TYPE
	       MACHINE-VERSION
	       MACRO-FUNCTION					
	       MACROEXPAND
	       MACROEXPAND-1
	       MACROLET
	       MAKE-ARRAY
	       MAKE-BROADCAST-STREAM
	       MAKE-CHAR
	       MAKE-CONCATENATED-STREAM
	       MAKE-DISPATCH-MACRO-CHARACTER
	       MAKE-ECHO-STREAM
	       MAKE-HASH-TABLE
	       MAKE-LIST
	       MAKE-PACKAGE
	       MAKE-PATHNAME
	       MAKE-RANDOM-STATE
	       MAKE-SEQUENCE
	       MAKE-STRING
	       MAKE-STRING-INPUT-STREAM
	       MAKE-STRING-OUTPUT-STREAM
	       MAKE-SYMBOL
	       MAKE-SYNONYM-STREAM
	       MAKE-TWO-WAY-STREAM
	       MAKUNBOUND
	       MAP
	       MAPC
	       MAPCAN
	       MAPCAR
	       MAPCON
	       MAPHASH
	       MAPL
	       MAPLIST
	       MASK-FIELD
	       MAX
	       MEMBER					  
	       MEMBER-IF
	       MEMBER-IF-NOT
	       MERGE
	       MERGE-PATHNAMES
	       MIN
	       MINUSP
	       MISMATCH
	       MOD
	       MOST-NEGATIVE-DOUBLE-FLOAT
	       MOST-NEGATIVE-FIXNUM
	       MOST-NEGATIVE-LONG-FLOAT
	       MOST-NEGATIVE-SHORT-FLOAT
	       MOST-NEGATIVE-SINGLE-FLOAT
	       MOST-POSITIVE-DOUBLE-FLOAT
	       MOST-POSITIVE-FIXNUM
	       MOST-POSITIVE-LONG-FLOAT
	       MOST-POSITIVE-SHORT-FLOAT
	       MOST-POSITIVE-SINGLE-FLOAT
	       MULTIPLE-VALUE-BIND
	       MULTIPLE-VALUE-CALL
	       MULTIPLE-VALUE-LIST
	       MULTIPLE-VALUE-PROG1
	       MULTIPLE-VALUE-SETQ
	       MULTIPLE-VALUES-LIMIT
	       NAME-CHAR
	       NAMESTRING
	       NBUTLAST
	       NCONC
	       NIL
	       NINTERSECTION				   
	       NINTH
	       NOT
	       NOTANY
	       NOTEVERY
	       NOTINLINE
	       NRECONC
	       NREVERSE
	       NSET-DIFFERENCE
	       NSET-EXCLUSIVE-OR
	       NSTRING-CAPITALIZE
	       NSTRING-DOWNCASE
	       NSTRING-UPCASE
	       NSUBLIS
	       NSUBST
	       NSUBST-IF
	       NSUBST-IF-NOT
	       NSUBSTITUTE
	       NSUBSTITUTE-IF	
	       NSUBSTITUTE-IF-NOT	
	       NTH
	       NTHCDR
	       NULL
	       NUMBER
	       NUMBERP
	       NUMERATOR
	       NUNION					    
	       ODDP
	       OPEN
	       OPTIMIZE
	       OR
	       OTHERWISE
	       OUTPUT-STREAM-P
	       PACKAGE
	       PACKAGE-NAME					
	       PACKAGE-NICKNAMES
	       PACKAGE-SHADOWING-SYMBOLS
	       PACKAGE-USE-LIST
	       PACKAGE-USED-BY-LIST
	       PACKAGEP
	       PAIRLIS
	       ;;PARSE-BODY	;jlm 4/13/89
	       PARSE-INTEGER
	       PARSE-NAMESTRING
	       PATHNAME
	       PATHNAME-DEVICE
	       PATHNAME-DIRECTORY
	       PATHNAME-HOST
	       PATHNAME-NAME
	       PATHNAME-TYPE
	       PATHNAME-VERSION
	       PATHNAMEP
	       PEEK-CHAR
	       PHASE
	       PI
	       PLUSP
	       POP
	       POSITION
	       POSITION-IF
	       POSITION-IF-NOT
	       PPRINT
	       PRIN1
	       PRIN1-TO-STRING
	       PRINC
	       PRINC-TO-STRING
	       PRINT
	       PROBE-FILE
	       PROCLAIM
	       PROG
	       PROG*
	       PROG1
	       PROG2
	       PROGN
	       PROGV
	       PROVIDE
	       PSETF
	       PSETQ
	       PUSH
	       PUSHNEW
               ;;PUTPROP	; jlm 4/11/89
	       QUOTE
	       RANDOM
	       RANDOM-STATE
	       RANDOM-STATE-P
	       RASSOC
	       RASSOC-IF
	       RASSOC-IF-NOT
	       RATIO
	       RATIONAL
	       RATIONALIZE
	       RATIONALP
	       READ
	       READ-BYTE
	       READ-CHAR
	       READ-CHAR-NO-HANG
	       READ-DELIMITED-LIST
	       READ-FROM-STRING
	       READ-LINE
	       READ-PRESERVING-WHITESPACE
	       READTABLE
	       READTABLEP
	       REALPART
	       REDUCE
	       REM
	       REMF
	       REMHASH
	       REMOVE					    
	       REMOVE-DUPLICATES
	       REMOVE-IF
	       REMOVE-IF-NOT
	       REMPROP
	       RENAME-FILE
	       RENAME-PACKAGE
	       REPLACE
	       REQUIRE
	       REST
	       RETURN						
	       RETURN-FROM
	       REVAPPEND
	       REVERSE
	       ROOM
	       ROTATEF
	       ROUND
	       ROW-MAJOR-AREF
	       RPLACA
	       RPLACD
	       SAFETY
	       SATISFIES
	       SBIT
	       SCALE-FLOAT
	       SCHAR
	       SEARCH
	       SECOND
	       SEQUENCE
	       SET
	       SET-CHAR-BIT
	       SET-DIFFERENCE
	       SET-DISPATCH-MACRO-CHARACTER
	       SET-EXCLUSIVE-OR
	       SET-MACRO-CHARACTER
	       SET-SYNTAX-FROM-CHAR
	       SETF
	       SETQ
	       SEVENTH
	       SHADOW
	       SHADOWING-IMPORT
	       SHIFTF
	       SHORT-FLOAT
	       SHORT-FLOAT-EPSILON
	       SHORT-FLOAT-NEGATIVE-EPSILON
	       SHORT-SITE-NAME
	       SIGNED-BYTE
	       ;;SIGNED-LDB	;jlm 4/13/89
	       SIGNUM
	       SIMPLE-ARRAY
	       SIMPLE-BIT-VECTOR
	       SIMPLE-BIT-VECTOR-P
	       SIMPLE-STRING
	       SIMPLE-STRING-P		
	       SIMPLE-VECTOR
	       SIMPLE-VECTOR-P
	       SIN
	       SINGLE-FLOAT
	       SINGLE-FLOAT-EPSILON
	       SINGLE-FLOAT-NEGATIVE-EPSILON
	       SINH
	       SIXTH
	       SLEEP
	       SOFTWARE-TYPE
	       SOFTWARE-VERSION
	       SOME
	       SORT
	       SPACE
	       SPECIAL						
	       SPECIAL-FORM-P
	       SPEED
	       SQRT
	       STABLE-SORT
	       STANDARD-CHAR
	       STANDARD-CHAR-P
	       STEP
	       STREAM
	       STREAM-ELEMENT-TYPE
	       STREAMP
	       STRING
	       STRING-CAPITALIZE
	       STRING-CHAR
	       STRING-CHAR-P
	       STRING-DOWNCASE
	       STRING-EQUAL
	       STRING-GREATERP
	       STRING-LEFT-TRIM
	       STRING-LESSP
	       STRING-NOT-EQUAL
	       STRING-NOT-GREATERP
	       STRING-NOT-LESSP
	       STRING-RIGHT-TRIM
	       STRING-TRIM
	       STRING-UPCASE
	       STRING/=
	       STRING<
	       STRING<=
	       STRING=
	       STRING>
	       STRING>=
	       STRINGP
	       SUBLIS
	       SUBSEQ
	       SUBSETP
	       SUBST					   
	       SUBST-IF
	       SUBST-IF-NOT
	       SUBSTITUTE
	       SUBSTITUTE-IF
	       SUBSTITUTE-IF-NOT
	       SUBTYPEP
	       SVREF
	       SXHASH
	       SYMBOL
	       SYMBOL-FUNCTION
	       SYMBOL-NAME
	       SYMBOL-PACKAGE
	       SYMBOL-PLIST
	       SYMBOL-VALUE
	       SYMBOLP
	       T
	       TAGBODY
	       TAILP
	       TAN
	       TANH
	       TENTH
	       TERPRI
	       THE
	       THIRD
	       THROW
	       TIME
	       TRACE
	       TREE-EQUAL
	       TRUENAME
	       TRUNCATE
	       TYPE
	       TYPE-OF
	       ;;TYPE-SPECIFIER-P	;jlm 4/13/89
	       TYPECASE
	       TYPEP
	       ;;UNCOMPILE	;jlm 4/13/89
	       UNEXPORT
	       UNINTERN
	       UNION					      
	       UNLESS
	       UNREAD-CHAR
	       UNSIGNED-BYTE
	       UNTRACE
	       UNUSE-PACKAGE
	       UNWIND-PROTECT
	       UPPER-CASE-P
	       USE-PACKAGE
	       USER-HOMEDIR-PATHNAME
	   