;;;-*- Mode: Common-Lisp; Package: SI; Base: 10.; Cold-Load: T -*-

;;;			      RESTRICTED RIGHTS LEGEND

;;; Use, duplication, or disclosure by the Government is subject to
;;; restrictions as set forth in subdivision (c)(1)(ii) of the Rights in
;;; Technical Data and Computer Software clause at 52.227-7013.
;;;
;;;			TEXAS INSTRUMENTS INCORPORATED.
;;;				 P.O. BOX 2909
;;;			      AUSTIN, TEXAS 78769
;;;				    MS 2151
;;;
;;; Copyright (C) 1989 Texas Instruments Incorporated. All rights reserved.


;;;  Initial Symbols in the TICL (TI Common Lisp) Package.

;;;  Contains as external symbols TI's language and user interface
;;;  extensions to Common Lisp, as well as all development utilities.
;;;  Implementation-dependent extensions are not intended to be in
;;;  this package.  Unadvertised symbols that implement TI extensions
;;;  to Common Lisp may someday reside as internal symbols within the 
;;;  TICL package.

;;  5/28/87 DNG - Added HASH-TABLE-MIXIN, EQ-HASH-TABLE-MIXIN, and EQUAL-HASH-TABLE-MIXIN for SPR 5505.
;;  1/04/88 RJF - Added ART-EXTENDED-FIX.
;;  6/13/88 CLM - Added TAND for SPR 8287.
;;  4/11/89 JLM - Put PUTPROP back in TICL (also taken out of LISP)
;;  4/13/89 JLM - Added many functions to TICL (moved from LISP)
;;  4/25/89 JLm - Added DISPLACED-ARRAY-P and COMPILEDP from LISP

(defconstant *INITIAL-TICL-SYMBOLS*
	     'TICL:(
	       
;;;  Lambda-list keywords not in the LISP package.
	       
	       &EVAL						
	       &EXTENSION					
	       &FUNCTIONAL					
	       &LIST-OF					
	       &LOCAL						
	       &QUOTE						
	       &SPECIAL
	       
	       	       
;;;  Variables and Function Names

	       %DIV
	       *ALL-FLAVOR-NAMES*			        
	       *ALL-FLAVOR-NAMES-AARRAY*
	       *CURRENT-STACK-GROUP*
	       *CURRENT-STACK-GROUP-RESUMER*
	       *DOCUMENTATION-VIEWED-SO-FAR*	;globalized by UCL
	       *ERRSET*
	       *GLOBAL-PACKAGE*
	       *KEYWORD-PACKAGE*
	       *LISP-PACKAGE*
	       *NOPOINT
	       *PRINT-BASE-SUBSCRIPT*
	       *PRINT-STRUCTURE*
	       *RSET
	       *STEP-FORM*
	       *STEP-VALUE*
	       *STEP-VALUES*
	       *SYSTEM-PACKAGE*
	       *TICL-PACKAGE*
	       *UNWIND-STACK
	       *USER-PACKAGE*
	       *VALUES*
	       *ZLC-PACKAGE*
	       
	       ADD-INITIALIZATION
	       ADD-LOGICAL-PATHNAME-HOST
	       ADD-PRINTER-DEVICE
	       ADVISE					       
	       ADVISE-WITHIN
	       ALL-DIRECTORIES
	       ALL-OPEN-FILES
	       ALLOCATE-RESOURCE
	       ALOC						
	       ALPHABETIC-CASE-AFFECTS-STRING-COMPARISON	
	       ALPHALESSP
	       AP-1						
	       AP-1-FORCE				       
	       AP-2					       
	       AP-3						
	       AP-LEADER
	       APPEND-TO-ARRAY
	       APROPOSB
	       APROPOSF
	       APROPOS-FLAVOR
	       APROPOS-RESOURCE
	       APROPOS-METHOD
	       ARGLIST			;jlm 4/13/89
	       AR-1
	       AR-1-FORCE
	       AR-2
	       AR-3
	       AREA-LIST
	       AREA-NAME
	       AROUND-METHOD-CONTINUE
	       ARRAY-ACTIVE-LENGTH			       
	       ARRAY-BITS-PER-ELEMENT
	       ARRAY-DISPLACED-P
	       ARRAY-ELEMENT-SIZE
	       ARRAY-ELEMENTS-PER-Q
	       ARRAY-HAS-LEADER-P
	       ARRAY-INDEXED-P
	       ARRAY-INDIRECT-P
	       ARRAY-INITIALIZE
	       ARRAY-LEADER
	       ARRAY-LEADER-LENGTH
	       ARRAY-LENGTH
	       ARRAY-TYPE
	       ARRAY-TYPES
	       ART-16B
	       ART-1B					       
	       ART-2B						
	       ART-32B					       
	       ART-4B					       
	       ART-8B					       
	       ART-COMPLEX
	       ART-COMPLEX-FLOAT
	       ART-COMPLEX-DOUBLE-FLOAT			       
	       ART-COMPLEX-SINGLE-FLOAT
	       ART-DOUBLE-FLOAT				       
	       ART-ERROR
	       ART-EXTENDED-FIX
	       ART-FAT-STRING				       
	       ART-FIX
	       ART-FLOAT
	       ART-HALF-FIX				       
	       ART-Q					      
	       ART-Q-LIST				       
	       ART-REG-PDL
	       ART-SINGLE-FLOAT				       
	       ART-SPECIAL-PDL				       
	       ART-STACK-GROUP-HEAD			       
	       ART-STRING
	       AS-1
	       AS-1-FORCE
	       AS-2
	       AS-3
	       ASSIGN-ALTERNATE
	       ASSIGN-VALUES
	       ASSIGN-VALUES-INIT-DELTA
	       BEEP
	       BIGP
	       BIND
	       BITBLT
	       BITMAP-OF-PICTURE-FILE
	       BOUNDP-GLOBALLY
	       BOUNDP-IN-CLOSURE
	       BREAKON
	       BUG
	       BUILD-COMMAND-TABLE		;UCL
	       BUILD-MENU			;UCL
	       CAAR-SAFE
	       CADR-SAFE
	       CALLRPC				;for Remote Procedure Call
	       CALLRPC-SPEC			;for Remote Procedure Call
	       CANCEL-PRINT-REQUEST
	       CAR-LOCATION
	       CAR-SAFE
	       CALL
	       CATCH-ALL				       
	       CATCH-CONTINUATION			      
	       CATCH-CONTINUATION-IF
	       CATCH-ERROR
	       CATCH-ERROR-RESTART			      
	       CATCH-ERROR-RESTART-EXPLICIT-IF		       
	       CATCH-ERROR-RESTART-IF
	       CDAR-SAFE
	       CDDR-SAFE
	       CDR-ERROR					
	       CDR-NEXT
	       CDR-NIL
	       CDR-NORMAL
	       CDR-SAFE
	       CHAR-KEYPAD
	       CHAR-KEYPAD-BIT			;ab 6-24-87
	       CHAR-MOUSE-BIT			;ab 6-24-87
	       CHAR-MOUSE-BUTTON
	       CHAR-MOUSE-CLICKS
	       CHECK-ARG					
	       CIRCULAR-LIST
	       CLEAR-MAR
	       CLEAR-RESOURCE
	       CLOSE-ALL-FILES				     
	       CLOSURE
	       CLOSURE-ALIST				       
	       CLOSURE-BINDINGS			       
	       CLOSURE-FUNCTION			       
	       CLOSURE-VARIABLES				
	       CLOSUREP
	       CODE-MOUSE-CHAR
	       COMMENT
	       COMMON-LISP-ON-P
	       COMPILEDP			;jlm 4/25/89
	       COMPILE-ENCAPSULATIONS
	       COMPILE-ENCAPSULATIONS-FLAG
	       COMPILE-FLAVOR-METHODS				
	       COMPILE-LAMBDA
	       COND-EVERY
	       CONDITION					
	       CONDITION-BIND					
	       CONDITION-BIND-DEFAULT				
	       CONDITION-BIND-DEFAULT-IF		       
	       CONDITION-BIND-IF			       
	       CONDITION-CALL					
	       CONDITION-CALL-IF				
	       CONDITION-CASE				       
	       CONDITION-CASE-IF				
	       CONDITION-RESUME
	       CONDITION-RESUME-IF			       
	       CONDITION-TYPEP					
	       CONS-IN-AREA
	       CONTENTS
	       CONTINUE-WHOPPER
	       COPY				;jlm 4/13/89
	       COPY-ARRAY-CONTENTS
	       COPY-ARRAY-CONTENTS-AND-LEADER			
	       COPY-ARRAY-PORTION
	       COPY-BITMAP-TO-FILE
	       COPY-CFG-MODULE
	       COPY-CLOSURE
	       COPY-DIRECTORY
	       COPY-FILE
	       COPY-NEWER-FILES			;ab 6.6.88
	       COPY-SYSTEM
	       COPYLIST*				       
	       COSD
	       CURRENT-PROCESS					
	       CURRENT-STACK-GROUP			       
	       CURRENT-STACK-GROUP-RESUMER
	       DATA-TYPE
	       DEALLOCATE-RESOURCE
	       DEALLOCATE-WHOLE-RESOURCE
	       DEBUG-IO				       
	       DEF
	       DEFAULT-CONS-AREA
	       DEFCOMMAND
	       DEFDECL
	       DEFF
	       DEFF-MACRO					
	       DEFFLAVOR
	       DEFFUNCTION
	       DEFINE-LOOP-MACRO				
	       DEFINE-LOOP-PATH			       
	       DEFINE-LOOP-SEQUENCE-PATH
	       DEFINE-SITE-ALIST-USER-OPTION		       
	       DEFINE-SITE-HOST-LIST				
	       DEFINE-SITE-USER-OPTION			       
	       DEFINE-SITE-VARIABLE				
	       DEFINE-USER-OPTION				
	       DEFMACRO-DISPLACE			       
	       DEFMETHOD				       
	       DEFMETHOD-INSTANCE		
	       DEFPACKAGE
	       DEFPROP
	       DEFRESOURCE
	       DEFSELECT
	       DEFSIGNAL					
	       DEFSIGNAL-EXPLICIT
	       DEFSTRUCT-DEFINE-TYPE
	       DEFSUBST
	       DEFSYSTEM
	       DEFUN-METHOD
	       DEFWHOPPER					
	       DEFWINDOW-RESOURCE				
	       DEFWRAPPER
	       DELETE-DIRECTORY
	       DELETE-INITIALIZATION
	       DELETE-SETF-METHOD		;jlm 4/13/89
	       DESCRIBE-AREA				       
	       DESCRIBE-DEFSTRUCT			       
	       DESCRIBE-FLAVOR				       
	       DESCRIBE-PACKAGE			       
	       DESCRIBE-PARTITION
	       DESCRIBE-REGION
	       DESCRIBE-SYSTEM
	       DESTRUCTURING-BIND
	       DIRED
	       DISK-RESTORE
	       DISK-SAVE
	       DISPATCH
	       DISPLACE
	       DISPLACED-ARRAY-P		;jlm 4/25/89
	       DO-ALL-PACKAGES
	       DO-FOREVER
	       DO-LOCAL-EXTERNAL-SYMBOLS
	       DO-LOCAL-SYMBOLS				
	       DONT-OPTIMIZE
	       DRIBBLE-ALL					
	       DRIBBLE-END					
	       DRIBBLE-START
	       DUMP-FORMS-TO-FILE
	       EH
	       EH-ARG						
	       EH-ERROR				       
	       EH-FRAME					
	       EH-FUN					       
	       EH-LOC						
	       EH-SG						
	       EH-VAL
	       END-TRAINING-SESSION
	       EQ-HASH-TABLE-MIXIN
	       EQUAL-HASH-TABLE-MIXIN
	       ERROR-MESSAGE-HOOK
	       ERROR-RESTART
	       ERROR-RESTART-LOOP
	       ERRORP
	       ERRSET
	       FALSE
	       FASD-UPDATE-FILE
	       FASL-APPEND
	       FASLOAD
	       FDEFINE
	       FDEFINEDP				       
	       FDEFINITION
	       FDEFINITION-LOCATION
	       FED
	       FERROR
	       FILE-RETRY-NEW-PATHNAME				
	       FILE-RETRY-NEW-PATHNAME-IF		       
	       FIND-EXTERNAL-SYMBOL
	       FIND-PROCESS
	       FIND-STRUCTURE-HEADER
	       FIND-STRUCTURE-LEADER
	       FIND-SYSTEM
	       FIND-WINDOW
	       FINGER
	       FIRSTN
	       FIXNUMP
	       FLATC
	       FLATSIZE
	       FLAVOR-ALLOWS-INIT-KEYWORD-P
;	       FLAVOR-INSPECT
	       FLONUM
	       FLONUMP
	       FOLLOW-CELL-FORWARDING
	       FOLLOW-STRUCTURE-FORWARDING
	       FONT
	       FORMAT-MACRO
	       FORWARD-VALUE-CELL
	       FQUERY
	       FSIGNAL
	       FTP
	       FULL-GC
	       FUNCALL-WITH-MAPPING-TABLE
	       FUNCTION-CELL-LOCATION
	       FUNCTION-DOCUMENTATION
	       FUNCTION-NAME
	       FUNDEFINE
	       G-L-P
	       GC-AND-DISK-SAVE
	       GC-IMMEDIATELY
	       GC-OFF					       
	       GC-ON
	       GC-STATUS
	       GET-DEFAULT-PRINTER
	       GET-DEFAULT-IMAGE-PRINTER
	       GET-HANDLER-FOR
	       GET-LIST-POINTER-INTO-ARRAY	
	       GET-LIST-POINTER-INTO-STRUCT	
	       GET-LOCATIVE-POINTER-INTO-ARRAY
	       GET-PRINTER-DEVICE
	       GET-SITE-OPTION
	       GETDECL
	       GETL
	       GLOSSARY
	       GRIND-TOP-LEVEL
	       GRINDEF
	       HAIPART
	       HARDCOPY-BIT-ARRAY
	       HARDCOPY-FILE				       
	       HARDCOPY-STATUS				       
	       HARDCOPY-STREAM
	       HASH-TABLE-MIXIN
	       HAULONG
	       HOSTAT
	       IGNORE-ERRORS
	       INHIBIT-FDEFINE-WARNINGS
	       INHIBIT-SCHEDULING-FLAG
	       INHIBIT-STYLE-WARNINGS
	       INHIBIT-STYLE-WARNINGS-SWITCH
	       INIT-FILE-PATHNAME
	       INITIALIZATIONS
	       INSPECT-FLAVOR
	       INSPECT*
	       INSTALL-NEW-PROGRAM		;for LOAD-DISTRIBUTION-TAPE
	       INSTALL-PRIM
	       INSTANCE
	       INSTANCE-VARIABLE-BOUNDP
	       INSTANCEP
	       INSTANTIATE-FLAVOR
	       INTERN-LOCAL
	       KEYWORD-EXTRACT			;sys external?
	       KILL-PACKAGE
	       LET-CLOSED
	       LET-GLOBALLY				       
	       LET-GLOBALLY-IF					
	       LET-IF
	       LETF-GLOBALLY
	       LEXICAL-CLOSURE
	       LEXPR-CONTINUE-WHOPPER
	       LEXPR-FUNCALL-WITH-MAPPING-TABLE
	       LEXPR-SEND
	       LISP-MODE
	       LIST*-IN-AREA
	       LIST-ARRAY-LEADER
	       LIST-IN-AREA
	       LIST-MATCH-P
	       LIST-PRINTERS
	       LISTARRAY
	       LISTF
	       LOAD-AND-SAVE-PATCHES
	       LOAD-PATCHES
	       LOCAL-DECLARATIONS
	       LOCATE-IN-CLOSURE			       
	       LOCATE-IN-INSTANCE
	       LOCATION-BOUNDP
	       LOCATION-MAKUNBOUND
	       LOCATIVE
	       LOCATIVEP
	       LOCF
	       LOG1
	       LOGIN
	       LOGIN-EVAL
	       LOGIN-FDEFINE					
	       LOGIN-FORMS				       
	       LOGIN-SETQ
	       LOGOUT
	       LOGOUT-LIST
	       LOOP-FINISH
	       LSH
	       MACRO
	       MACRO-COMPILED-PROGRAM
	       MACROEXPAND-ALL
	       MAKE-AREA
	       MAKE-ARRAY-INTO-NAMED-STRUCTURE
	       MAKE-COMMAND			;globalized in ucl
	       MAKE-CONDITION
	       MAKE-INSTANCE
	       MAKE-PLANE
	       MAKE-PROCESS
	       MAKE-STACK-GROUP
	       MAKE-SYSTEM
	       MAKUNBOUND-GLOBALLY
	       MAKUNBOUND-IN-CLOSURE
	       MAP-RESOURCE
	       MAPATOMS					
	       MAPATOMS-ALL
	       MAPHASH-RETURN
	       MAR-BREAK
	       MAR-MODE
	       METER
	       METER-ANALYZE
	       MEXP
	       MICROCODE-FUNCTION
	       NAMED-LAMBDA					
	       NAMED-STRUCTURE
	       NAMED-STRUCTURE-INVOKE			       
	       NAMED-STRUCTURE-P			      
	       NAMED-STRUCTURE-SYMBOL
	       NAMED-SUBST	
	       NEQ
	       NEW-USER
	       NLEFT
	       NLISTP		
	       NSUBSTRING
	       NSYMBOLP
	       NTH-SAFE
	       NTH-VALUE
	       NTHCDR-SAFE
	       NUMBER-INTO-ARRAY
	       OBSOLETE-FUNCTION-WARNING-SWITCH
	       ONCE-ONLY
	       OPEN-CODE-MAP-SWITCH
	       PACKAGE-CELL-LOCATION
	       PACKAGE-EXTERNAL-SYMBOLS
	       PACKAGE-PREFIX-PRINT-NAME
	       PARSE-BODY			;jlm 4/13/89
	       PARSE-NUMBER
	       PATHNAME-PLIST
	       PEEK
	       PERMANENT-STORAGE-AREA
	       PKG-BIND					
	       PKG-FIND-PACKAGE
	       PKG-GLOBAL-PACKAGE
	       PKG-GOTO
	       PKG-GOTO-GLOBALLY
	       PKG-KEYWORD-PACKAGE
	       PKG-SYSTEM-PACKAGE
	       PLANE-AREF					
	       PLANE-ASET
	       PLANE-DEFAULT
	       PLANE-EXTENSION					
	       PLANE-ORIGIN				       
	       PLANE-REF				       
	       PLANE-STORE
	       PPRINT-DEF
	       PRIN1-THEN-SPACE
	       PRINT-BITMAP
	       PRINT-BITMAP-AND-WAIT
	       PRINT-DISK-LABEL
	       PRINT-ERROR-MODE
	       PRINT-FILE
	       PRINT-FILE-AND-WAIT
	       PRINT-GRAPHICS
	       PRINT-HERALD					
	       PRINT-LOADED-BAND				
	       PRINT-LOGIN-HISTORY				
	       PRINT-NOTIFICATIONS
	       PRINT-SENDS
	       PRINT-STREAM
	       PRINT-SYSTEM-MODIFICATIONS
	       PROCESS-ALLOW-SCHEDULE				
	       PROCESS-DISABLE					
	       PROCESS-ENABLE
	       PROCESS-INITIAL-FORM				
	       PROCESS-INITIAL-STACK-GROUP
	       PROCESS-LOCK					
	       PROCESS-NAME
	       PROCESS-PRESET				       
	       PROCESS-RESET				       
	       PROCESS-RESET-AND-ENABLE
	       PROCESS-RUN-FUNCTION				
	       PROCESS-RUN-RESTARTABLE-FUNCTION		
	       PROCESS-SLEEP
	       PROCESS-STACK-GROUP			       
	       PROCESS-UNLOCK					
	       PROCESS-WAIT
	       PROCESS-WAIT-ARGUMENT-LIST		       
	       PROCESS-WAIT-FUNCTION			       
	       PROCESS-WAIT-WITH-TIMEOUT		       
	       PROCESS-WHOSTATE
	       PROFILE
	       PROFILE-SETQ
	       PROGW
	       PROMPT-AND-READ
	       PROPERTY-CELL-LOCATION
	       PUSH-END
	       PUTDECL
	       PUTHASH
	       PUTPROP				; jlm 4/11/89
	       Q-DATA-TYPES			;sys external?
	       QSEND
	       QSENDS-OFF
	       QSENDS-ON
	       QUERY-IO
	       QUOTIENT
	       READ-CHECK-INDENTATION
	       READ-DELIMITED-STRING
	       READ-FOR-TOP-LEVEL
	       READ-METER			;sys external?
	       READ-PRESERVE-DELIMITERS
	       READFILE
	       READLINE-OR-NIL
	       READLINE-TRIM				       
	       READLIST
	       REAL
	       REALP
	       RECOMPILE-FLAVOR
	       REGISTERRPC			;for Remote Procedure Call
	       REINITIALIZE-RESOURCE
	       REMMETHOD
	       REMOVE-PRINTER-DEVICE
	       REPORT-ALL-SHUTDOWNS
	       REPORT-LAST-SHUTDOWN
	       RESET-INITIALIZATIONS
	       RETURN-ARRAY
	       RETURN-STORAGE
	       ROT
	       ROTL
	       RPCINFO				;for Remote Procedure Call
	       RUBOUT-HANDLER
	       RUBOUT-HANDLER-OPTIONS
	       RUN-IN-MACLISP-SWITCH
	       SELECT
	       SELECT-MATCH
	       SELECTOR
	       SELECTQ-EVERY
	       SELF
	       SEND
	       SET-CHARACTER-TRANSLATION
	       SET-CURRENT-BAND
	       SET-CURRENT-MICROLOAD
	       SET-DEFAULT-PRINTER
	       SET-DEFAULT-IMAGE-PRINTER
	       SET-ERROR-MODE
	       SET-GLOBALLY					
	       SET-IN-CLOSURE					
	       SET-IN-INSTANCE
	       SET-LISP-MODE
	       SET-MAR
	       SET-MEMORY-SIZE
	       SET-SYNTAX-#-MACRO-CHAR
	       SET-SYNTAX-FROM-DESCRIPTION
	       SET-SYNTAX-MACRO-CHAR
	       SETQ-GLOBALLY
	       SETSYNTAX
	       SETSYNTAX-SHARP-MACRO
	       SG-RETURN-UNSAFE			;eh?
	       SHOWMOUNT			;for Network File System
	       SHOW-CFG-SUMMARY
	       SHOW-PRINT-QUEUE
	       SIGNAL
	       SIGNAL-CONDITION			       
	       SIGNAL-PROCEED-CASE
	       SIGNED-LDB			;jlm 4/13/89
	       SIND
	       SITE-NAME
	       SMALL-FLOAT					
	       SMALL-FLOATP
	       SMALL-FLONUM
	       SORT-GROUPED-ARRAY				
	       SORT-GROUPED-ARRAY-GROUP-KEY			
	       SORTCAR
	       STABLE-SORTCAR
	       STACK-GROUP
	       STACK-GROUP-PRESET			       
	       STACK-GROUP-RESUME				
	       STACK-GROUP-RETURN
	       START-TRAINING-SESSION
	       STEP-FORM
	       STEP-VALUE
	       STEP-VALUES
	       STORE-ARRAY-LEADER			       
	       STORE-CONDITIONAL
	       STREAM-COPY-UNTIL-EOF
	       STREAM-DEFAULT-HANDLER
	       STRING-APPEND
	       STRING-APPEND-A-OR-AN
	       STRING-CAPITALIZE-WORDS
	       STRING-COMPARE
	       STRING-NCONC
	       STRING-PLURALIZE			     
	       STRING-REMOVE-FONTS
	       STRING-REVERSE-SEARCH-NOT-SET
	       STRING-REVERSE-SEARCH-SET
	       STRING-SEARCH-NOT-SET
	       STRING-SEARCH-SET
	       STRING-SELECT-A-OR-AN
	       STRING-SUBST-CHAR
	       STRUCTURE
	       STRUCTURE-BOXED-SIZE
	       STRUCTURE-FORWARD			       
	       STRUCTURE-TOTAL-SIZE
	       SUB-APROPOS
	       SUBSTRING-AFTER-CHAR
	       SWAPHASH
	       SYMEVAL-GLOBALLY			       
	       SYMEVAL-IN-CLOSURE			       
	       SYMEVAL-IN-INSTANCE			       
	       SYMEVAL-IN-STACK-GROUP
	       SYSTEM-SHUTDOWN
	       TAND                            ;clm 6/13/88
	       TELNET
	       TFTP
	       TI-SHOW-LEGAL-NOTICE
	       TIMEIT
	       TIME-DIFFERENCE				       
	       TIME-INCREMENT
	       TIME-LESSP
	       TRACE-COMPILE-FLAG
	       TRACE-OUTPUT
	       TRAINING-OFF			;ab 7-9-87
	       TRAINING-ON			;ab 7-9-87
	       TRANSLATED-PATHNAME
	       TRUE
	       TURN-COMMON-LISP-ON			       
	       TURN-ZETALISP-ON
	       TYI					       
	       TYIPEEK
	       TYPE-SPECIFIER-P			;jlm 4/13/89
	       UNADVISE				       
	       UNADVISE-WITHIN
	       UNBREAKON
	       UNCOMPILE			;jlm 4/13/89
	       UNDEFFLAVOR				       
	       UNDEFMETHOD				      
	       UNDEFUN
	       UNDELETE-FILE				       
	       UNSPECIAL
	       UNWIND-ALL
	       UPDATE-SITE-CONFIGURATION-INFO
	       USER-ID
	       USER-NAME		;jlm 4/13/89
	       USING-RESOURCE
	       VALUE-CELL-LOCATION
	       VARIABLE-BOUNDP				       
	       VARIABLE-LOCATION			       
	       VARIABLE-MAKUNBOUND
	       VIEW-DOCUMENTATION		;globalized by ucl
	       VIEW-FILE
	       VIEW-MAIL
	       VT100
	       WHAT-FILES-CALL
	       WHERE-IS				       
	       WHO-CALLS				       
	       WHO-USES
	       WHOIS
	       WITH-COMMON-LISP-ON			       
	       WITH-INPUT-EDITING
	       WITH-LISP-MODE
	       WITH-LOCK
	       WITH-OPEN-FILE-CASE			       
	       WITH-OPEN-FILE-RETRY			       
	       WITH-OPEN-FILE-SEARCH
	       WITH-OPEN-STREAM-CASE
	       WITH-SELF-VARIABLES-BOUND
	       WITH-STACK-LIST				       
	       WITH-STACK-LIST*
	       WITH-TIMEOUT				       
	       WITH-ZETALISP-ON
	       WITHOUT-INTERRUPTS
	       WORKING-STORAGE-AREA
	       WRITE-METER			;sys external?
	       WRITE-USER-OPTIONS		;obsolete - remove in Rel 3.1
	       XOR				;jlm 4/13/89
	       ZDT
	       ZETALISP-ON-P
	       ZUNDERFLOW
	       @DEFINE
	       ))
