; -*-  Mode:Common-Lisp; Package:System-Internals; Base:8.; Patch-File:t; Cold-Load:T -*-

;;;                           RESTRICTED RIGHTS LEGEND

;;;Use, duplication, or disclosure by the Government is subject to
;;;restrictions as set forth in subdivision (c)(1)(ii) of the Rights in
;;;Technical Data and Computer Software clause at 52.227-7013.
;;;
;;;                     TEXAS INSTRUMENTS INCORPORATED.
;;;                              P.O. BOX 2909
;;;                           AUSTIN, TEXAS 78769
;;;                                 MS 2151
;;;
;;; Copyright (C) 1987-1989 Texas Instruments Incorporated.  All rights reserved.

;; This file contains LISPM Kernel patches needed for the addin support.

;;;
;;; Edit History
;;;
;;;                   Patch
;;;   Date    Author  Number   Description
;;;------------------------------------------------------------------------------
;;; 01.13.88	MBC		Change SOUND-CHIP to SOUND.
;;; 01-26-88    ab             o Added *LOAD-ENET*.

;; When NIL, choose :COND fspec definition at load time.
;; When non-NIL, construct definition that does run-time test.
(DEFPARAMETER *RUN-TIME-DISPATCH* t) 

;; For each of the load feature variables below:
;;   When NIL, DEFINE-WHEN *IGNORES* the enclosed (presumably resource-specific) routines;
;;             DEFINE-UNLESS *WILL* define the enclosed routines.
;;   When :ALWAYS, both DEFINE-WHEN and DEFINE-UNLESS *WILL* define the enclosed routines.
;;   When non-NIL, DEFINE-WHEN *WILL* define the enclosed routines;
;;                 DEFINE-UNLESS *IGNORES* the enclosed routines.

(DEFPARAMETER *load-sib* :always)
(DEFPARAMETER *load-disk* :always)
(DEFPARAMETER *load-nvram* :always)
(DEFPARAMETER *load-keyboard* :always)
(DEFPARAMETER *load-mouse* :always)
(DEFPARAMETER *load-rtc* :always)
(DEFPARAMETER *load-sound* :always)
(DEFPARAMETER *load-nubus* :always)
(DEFPARAMETER *load-enet* :always)