;;; -*- Mode:Common-Lisp; Package:USER; Base:10 -*-

;;;                           RESTRICTED RIGHTS LEGEND

;;;Use, duplication, or disclosure by the Government is subject to
;;;restrictions as set forth in subdivision (c)(1)(ii) of the Rights in
;;;Technical Data and Computer Software clause at 52.227-7013.
;;;
;;;                     TEXAS INSTRUMENTS INCORPORATED.
;;;                              P.O. BOX 2909
;;;                           AUSTIN, TEXAS 78769
;;;                                 MS 2151
;;;
;;; Copyright (C) 1985- 1989 Texas Instruments Incorporated. All rights reserved.

(eval-when (load eval)
  (unless (find-package "MAIL")
	  (make-package "MAIL" :size 700)))

(defsystem MAIL-DAEMON
  (:name "Mail-Daemon")
  (:short-name "Mailer")
  (:pathname-default "SYS:MAIL-DAEMON;")
  (:patchable "SYS:PATCH.MAIL-DAEMON;" PATCH)
  (:warnings-pathname-default "SYS:CWARNS;MAIL-DAEMON.LISP")
  (:module definitions ("options" "definitions"))
  (:module basic ("name" "address" "header"))
  (:module main ("server" "client" "message" "mailer"))
  (:module compile-flavor-methods ("compile-flavor-methods"))
  (:compile-load definitions)
  (:compile-load basic (:fasload definitions))
  (:compile-load main (:fasload definitions basic))
  (:compile-load compile-flavor-methods (:fasload definitions basic main))
  )

;;; 04-24-89 DAB Added all function, variables, flavors and instances that are documented to export list.

(export '(mail:print-mail-queue    ;function  ; DAB 04-24-89
	   mail:reset-mail-daemon  ;function
	   mail:*log-enabled*      ;variable
	   mail:message            ;flavor
	   )
	'mail)

(eval-when (load eval)
  (import '(
	    zwei::*interval*
	    zwei::*msg*
	    zwei::*mail-buffer*
	    zwei::*user-mail-reading-mode*
	    zwei::*sticky-mail-window-configuration-p*
	    zwei::*sticky-mail-buffer-selection-p*
	    zwei::*mail-summary-window-fraction*
	    zwei::*default-mail-summary-template*
	    zwei::*default-mx-mail-summary-template*
	    zwei::*mail-summary-template*
	    zwei::*user-mail-summary-template*
	    zwei::*mail-summary-attribute-char-alist*
	    zwei::*user-default-mail-file*
	    zwei::*always-check-inboxes*
	    zwei::*save-mail-file-in-background*
	    zwei::*mail-file-versions-kept*
	    zwei::*reformat-headers-automatically*
	    zwei::*reformat-headers-include-list*
	    zwei::*reformat-headers-exclude-list*
	    zwei::*reformat-headers-case*
	    zwei::*reformat-headers-body-goal-column*
	    zwei::*yank-message-headers-include-list*
	    zwei::*yank-message-prefix*
	    zwei::*delete-message-after-copy*
	    zwei::*choose-from-all-mail-keywords-p*
	    zwei::*unsent-message-query-p*
	    zwei::*two-window-reply*
	    zwei::*default-print-message-printer*
	    zwei::*mail-mode-hook*
	    zwei::*default-bcc-string*
	    zwei::*default-fcc-string*
	    zwei::*default-reply-to-string*
	    zwei::*default-other-mail-file*
	    zwei::*unix-inbox-pathname*
	    zwei::*inhibit-mail-file-format-warnings*
	    zwei::*forwarded-message-begin*
	    zwei::*forwarded-message-end*
	    zwei::*dont-reply-to*
	    zwei::*default-in-reply-to-template*
	    zwei::*in-reply-to-template*
	    zwei::*upcase-message-keywords-p*
	    zwei::*backup-file-append-string*
	    zwei::*reformat-one-header-hook*
	    zwei::*box-summary-lines*
	    zwei::define-mail-template
	    zwei::define-mail-filter
	    zwei::preload-mail-file
	    zwei::message-node
	    zwei::message-interval
	    zwei::*mail-template*
	    zwei::*reply-template*
	    zwei::*reply-template-1*
	    zwei::*reply-to-sender-template*
	    zwei::*reply-to-all-template*
 	    zwei::*forward-template*
	    zwei::*resend-template*
	    zwei::*preload-mail-file-p*
	    zwei::*reply-to-all-header-types*
	    zwei::*kill-mail-buffers-at-logout-p*
	    zwei::*mail-summary-mode*
	    )
	   'mail)
)
