;;;-*- Mode:Common-Lisp; Package:MAIL; Base:10 -*-

;;;                           RESTRICTED RIGHTS LEGEND

;;;Use, duplication, or disclosure by the Government is subject to
;;;restrictions as set forth in subdivision (c)(1)(ii) of the Rights in
;;;Technical Data and Computer Software clause at 52.227-7013.
;;;
;;;                     TEXAS INSTRUMENTS INCORPORATED.
;;;                              P.O. BOX 2909
;;;                           AUSTIN, TEXAS 78769
;;;                                 MS 2151
;;;
;;; Copyright (C) 1985- 1989 Texas Instruments Incorporated. All rights reserved.

(defvar *PROBE-FOR-NEW-MAIL-P* t
  "When T, probe inboxes defined by mail files and notify of new mail")

(defvar *MAIL-BACKGROUND-SLEEP-TIME* (* 20 60)
  "Time in seconds for the mail delivery daemon to sleep")

(defvar *INBOX-PROBE-SLEEP-TIME* (* 10 60)
  "Time in seconds between probes and notifications of new mail")

(defvar *MAILING-LIST-HOST* nil
  "Host to check for mailing lists")

(defvar *MAILING-LIST-DIRECTORY* "mailing-lists"
  "Name of the top level directory that contains the mailing lists")

(defvar *TRY-MAIL-NOW-P* t
  "Attempt to send mail in foreground before queueing.")

(defvar *DEFAULT-BLIND-COPY-ADDRESS-LIST* '())

(defvar *MAIL-USER-PERSONAL-NAME* nil
  "Overrides the PERSONAL-NAME user attribute in Name Space.  Personal name of logged in user for
generating mail addresses.")

(defvar *USER-MAIL-ADDRESS* nil
  "Overrides the MAIL-ADDRESS user attribute in Name Space.  Preferred mailing address of logged in user.")

(defvar *RETURN-PATH-ALWAYS-LOCAL* nil
  "When T, always use the local machine and user-id for return path; otherwise return-path
is the user's mail address as specified in USER namespace object or MAIL:*USER-MAIL-ADDRESS*.")

(defvar *REJECT-MAIL-CONNECTIONS* nil
  "If non nil and lm is not a mail server reject mail server connections")

(defvar *POSTMASTER-ADDRESS* nil
  "Address for person maintaining the mail system")

(defvar *FOLD-ADDRESS-HEADER-COLUMN* 60)

