;;; -*- Mode:Common-Lisp; Package:ZWEI; Base:10 -*-

;;;                           RESTRICTED RIGHTS LEGEND

;;;Use, duplication, or disclosure by the Government is subject to
;;;restrictions as set forth in subdivision (c)(1)(ii) of the Rights in
;;;Technical Data and Computer Software clause at 52.227-7013.
;;;
;;;                     TEXAS INSTRUMENTS INCORPORATED.
;;;                              P.O. BOX 2909
;;;                           AUSTIN, TEXAS 78769
;;;                                 MS 2151
;;;
;;; Copyright (C) 1989 Texas Instruments Incorporated. All rights reserved.
;;;

(eval-when (load eval)
  (unless (find-package "MAIL")
	  (make-package "MAIL")))


(defsystem MAIL-READER
  (:name "Mail-Reader")
  (:short-name "Bandy")				;Just a nickname
  (:short-name "Mail-Reader")			;Last one becomes the real short name
  (:pathname-default "SYS:MAIL-READER;")
  (:patchable "SYS:PATCH.MAIL-READER;" PATCH)
  (:warnings-pathname-default "SYS:CWARNS;MAIL-READER.LISP")
  (:DOCUMENTATION "Manage electronic mail messages")
  (:DEFAULT-MENU-COLUMN :PROGRAMS)
  (:DEFAULT-SYSTEM-KEY #\M)
  (:INSTANCE-TYPE    :EVAL)
  (:INSTANCE-FINDER  (ZWEI:READ-MAIL))
  (:INSTANCE-CREATOR NIL)
  (:module options ("options"))
  (:module definitions ("definitions"))
  (:module main ("bandy"))
  (:module parts ("message" "buffer" "display" "help" "summary" "file" "filter"
		  "filter-summary" "send-mail" "command" "misc" "bug-report"))
  (:module suggestions "suggestions")
  (:module compile-flavor-methods "compile-flavor-methods")
  (:compile-load options)
  (:compile-load definitions (:fasload options))
  (:compile-load main (:fasload options definitions))
  (:compile-load parts (:fasload options definitions main))
  (:compile-load suggestions (:fasload options definitions main parts))
  (:compile-load compile-flavor-methods)
  )


(export '(
	  *interval*
	  *msg*
	  *mail-buffer*
	  *user-mail-reading-mode*
	  *sticky-mail-window-configuration-p*
	  *sticky-mail-buffer-selection-p*
	  *mail-summary-window-fraction*
	  *default-mail-summary-template*
	  *mail-summary-template*
	  *mail-summary-attribute-char-alist*
	  *user-default-mail-file*
	  *always-check-inboxes*
	  *save-mail-file-in-background*
	  *mail-file-versions-kept*
	  *reformat-headers-automatically*
	  *reformat-headers-include-list*
	  *reformat-headers-exclude-list*
	  *reformat-headers-case*
	  *reformat-headers-body-goal-column*
	  *yank-message-headers-include-list*
	  *yank-message-prefix*
	  *delete-message-after-copy*
	  *choose-from-all-mail-keywords-p*
	  *unsent-message-query-p*
	  *two-window-reply*
	  *default-print-message-printer*
	  *mail-mode-hook*
	  *default-bcc-string*
	  *default-fcc-string*
	  *default-reply-to-string*
	  *default-other-mail-file*
	  *unix-inbox-pathname*
	  *inhibit-mail-file-format-warnings*
	  *forwarded-message-begin*
	  *forwarded-message-end*
	  *dont-reply-to*
	  *default-in-reply-to-template*
	  *in-reply-to-template*
	  *upcase-message-keywords-p*
	  *backup-file-append-string*
	  *reformat-one-header-hook*
	  *box-summary-lines*
	  *preload-mail-file-p*
	  *mail-summary-window-fraction*
	  define-mail-filter
	  define-mail-template
	  preload-mail-file
	  message-node
	  message-interval
	  *mail-template*  ; DAB 04-24-89
	  *reply-template*
	  *reply-template-1*
	  *reply-to-sender-template*
	  *reply-to-all-template*
	  *forward-template*
	  *resend-template*
	  insert-default-header-fields
	  insert-header-field
	  insert-address-list
	  mail:submit-mail
	  mail:add-mail-inbox-probe
	  mail:remove-mail-inbox-probe
	  )
	'mail)
