;;; -*- Mode:Common-Lisp; Package:ZWEI; Base:10 -*-

;;;                           RESTRICTED RIGHTS LEGEND

;;;Use, duplication, or disclosure by the Government is subject to
;;;restrictions as set forth in subdivision (c)(1)(ii) of the Rights in
;;;Technical Data and Computer Software clause at 52.227-7013.
;;;
;;;                     TEXAS INSTRUMENTS INCORPORATED.
;;;                              P.O. BOX 2909
;;;                           AUSTIN, TEXAS 78769
;;;                                 MS 2151
;;;
;;; Copyright (C) 1985- 1989 Texas Instruments Incorporated. All rights reserved.

;; las - 2-8-1988 - added conditionals for mini/development bands

;; SUGGESTIONS MENUS

(when (fboundp 'sugg:suggestions-build-menu)
  (SUGG::SUGGESTIONS-BUILD-MENU
    (make-comtab-menu-name '*read-mail-comtab*)
    "Menu of Mail Reader commands (Read-Mail mode in ZMACS)"
    `(("IMPORTANT COMMANDS" :no-select t :font SUGG:MENU-SUBTITLE-STD-FONT)
      ("Help" . com-read-mail-help)
      ("Mail Menu" #\Mouse-r-1 :documentation
       "Display menu of mail commands for dealing with buffers, windows, mail files, and inboxes")
      ("Message Command Menu" #\Mouse-m-1
       :documentation ,(mail-short-documentation 'com-message-menu))
      ("Save Mail File" . com-save-mail-file)
      ("Get New Mail" #\G
       :documentation ,(mail-short-documentation 'com-get-new-mail))
      ("List Mail Buffers" . com-list-mail-buffers)
      ("Other Mail Buffer" #\O
       :documentation ,(mail-short-documentation 'com-other-mail-buffer))
      ("Filter Messages" #\=
       :documentation ,(mail-short-documentation 'com-filter-messages))
      ("Toggle Window Config" #\C-W
       :documentation ,(mail-short-documentation 'com-toggle-mail-window-configuration))
      ("Change Inboxes" . com-change-inboxes)
      ("Exit" #\Q
       :documentation ,(mail-short-documentation 'com-exit-mail-reader))
      
      ("" :no-select t)
      ("   MESSAGE SELECTION" :no-select t :font SUGG:MENU-SUBTITLE-STD-FONT)
      ("Next" #\N
       :documentation ,(mail-short-documentation 'com-next-undeleted-message))
      ("Previous" #\P
       :documentation ,(mail-short-documentation 'com-previous-undeleted-message))
      ("Next with Keyword" #\S-N
       :documentation ,(mail-short-documentation 'com-next-message-with-keyword))
      ("Previous with Keyword" #\S-P
       :documentation ,(mail-short-documentation 'com-previous-message-with-keyword))
      ("Jump to Message" #\J
       :documentation ,(mail-short-documentation 'com-jump-to-message))
      ("First Message" #\<
       :documentation ,(mail-short-documentation 'com-first-message))
      ("Last Message" #\>
       :documentation ,(mail-short-documentation 'com-last-message))
      ("Search All" #\M-S
       :documentation ,(mail-short-documentation 'com-mail-incremental-search))
      ("Reverse Search All" #\M-R
       :documentation ,(mail-short-documentation 'com-mail-reverse-incremental-search))
      ("" :no-select t)
      ("   MESSAGE OPERATIONS" :no-select t :font SUGG:MENU-SUBTITLE-STD-FONT)
      ("View" #\V
       :documentation ,(mail-short-documentation 'com-view-message))
      ("Keywords" #\K
       :documentation ,(mail-short-documentation 'com-change-message-keywords))
      ("Reminder" #\!
       :documentation ,(mail-short-documentation 'com-toggle-reminder-message))
      ("Delete" #\D
       :documentation ,(mail-short-documentation 'com-delete-message))
      ("Undelete" #\U
       :documentation ,(mail-short-documentation 'com-undelete-message))
      ("Print (mark)" #\C-Sh-P
       :documentation ,(mail-short-documentation 'com-print-message))
      ("Apply (mark)" #\A
       :documentation ,(mail-short-documentation 'com-mail-mark-for-apply))
      ("Execute" #\X
       :documentation ,(mail-short-documentation 'com-mail-execute))
      ("Copy to Mail File" #\C
       :documentation ,(mail-short-documentation 'com-copy-message-to-mail-file))
      ("Copy to Text File" #\C-C
       :documentation ,(mail-short-documentation 'com-copy-message-to-text-file))
      ("Edit" #\E
       :documentation ,(mail-short-documentation 'com-edit-message))
      
      ("" :no-select t)
      ("   MAIL TEMPLATES" :no-select t :font SUGG:MENU-SUBTITLE-STD-FONT)
      ("Send Mail" . com-mail)
      ("Reply To All" . com-reply-to-all)
      ("Reply To Sender" #\R
       :documentation ,(mail-short-documentation 'com-reply-to-sender))
      ("Forward" #\F
       :documentation ,(mail-short-documentation 'com-forward-message))
      ("Mail Template Menu" . com-mail-template-menu)
      
      ;;("MISCELLANEOUS" :no-select t :font SUGG:MENU-SUBTITLE-STD-FONT)
      )
    nil nil #'zmacs-suggestions-menu-filter))


(eval-when (load)
  (when (fboundp 'sugg:suggestions-build-menu)
    (pushnew '(read-mail-mode read-mail-comtab-menu) sugg::*suggestions-zmacs-modes*
	     :test #'equal)))

(when (fboundp 'sugg:suggestions-build-menu)
  (SUGG:SUGGESTIONS-BUILD-MENU
    (make-comtab-menu-name '*read-mail-control-x-comtab*) 
    "Menu of Control-X commands unique to Read-Mail mode."
    '(("MAIL Control-X COMMANDS " :no-select t :font SUGG:MENU-SUBTITLE-STD-FONT)
      ("C-X S Sort Messages     " #\S   :documentation "Sort messages or return to original order.") 
      ("C-X M Send Mail         " #\M   :documentation "Compose a new mail message for sending.")
      ("C-X C-M List Mail Buffers" #\C-M :documentation "Print an organized list of all mail buffers.")
      ("C-X C-S Save Mail File  " #\C-S :documentation "Save changes to mail file.")
      ("C-X C-W Write Mail File " #\C-W :documentation "Write mail buffer to a different file.")
      ("" :no-select t)
      ("Other C-X keys perform  " :no-select t :font SUGG:MENU-SUBTITLE-STD-FONT)
      ("  standard ZMACS commands" :no-select t :font SUGG:MENU-SUBTITLE-STD-FONT))))


(when (fboundp 'sugg:suggestions-build-menu)
  (SUGG:SUGGESTIONS-BUILD-MENU
    (make-comtab-menu-name '*read-comma-list-comtab*)
    "Menu of commands for completion of items in a comma delimited string."
    
    `(("<Comma delimited string>" :documentation
       "Type in a string to the minibuffer to use as an argument for this command."
       :font sugg:mouse-comment-std-font)
      ("" :no-select ignore)
      ("EDIT MINIBUFFER INPUT" :no-select ignore :font sugg:menu-subtitle-std-font)
      ,@common-cursor-char-commands
      ,@common-cursor-word-commands
      ,@common-delete-char-commands
      ("" :no-select ignore)
      ("SPECIAL INPUT" :no-select ignore :font sugg:menu-subtitle-std-font)
      ("M-C-Y  Last Command     " #\c-m-y :documentation
       "Copy last minibuffer command back into the minibuffer for editing")
      ("" :no-select ignore)
      ("COMPLETE INPUT" :no-select ignore :font sugg:menu-subtitle-std-font)
      ("ESCAPE Complete item" #\Escape :documentation
       "Complete current minibuffer typein as far as possible and wait for more.")
      ("SPACE  Complete to SPACE" #\Space :documentation
       "Insert a space in the minibuffer; complete typein as far as possible up to the next space; then wait for more.")
      (",      Start next item    " #\, :documentation
       "Begin next item in comma delimited string.")
      ("" :no-select ignore)
      ("COMPLETION INFO" :no-select ignore :font sugg:menu-subtitle-std-font)
      ("C-? List Completions    " #\c-? :documentation
       "Displays a mouse sensitive list of all possible completions of what has been entered in the minibuffer so far.")
      ("" :no-select ignore)
      ("DO IT" :no-select ignore :font sugg:menu-subtitle-std-font)
      ("RETURN Complete And Exit" #\Newline :documentation
       "Complete current minibuffer typein as far as possible then use it as-is.")
      ("ABORT  Abort this Input " #\Abort :documentation
       "Abort the minibuffer typein and abort the command that put you in the minibuffer"))
    nil "Comma Delimited String Menu" #'zmacs-suggestions-menu-filter))


(eval-when (load)
  (UNLESS (si:addin-p)
    (unless (memeq '*read-mail-comtab* *every-comtab*)
      (push-end '*read-mail-comtab* *every-comtab*))
    (unless (memeq '*read-mail-control-x-comtab* *every-comtab*)
      (push-end '*read-mail-control-x-comtab* *every-comtab*))
    (unless (memeq '*read-comma-list-comtab* *every-comtab*)
      (push-end '*read-comma-list-comtab* *every-comtab*))
    (make-comtab-name-list)))
