;;; -*- Mode:Common-Lisp; Package:SYSTEM-INTERNALS; Base:10; Fonts:(CPTFONT) -*-

1;;;                            RESTRICTED RIGHTS LEGEND

;;; Use,  duplication, or  disclosure  by  the  Government is subject to restrictions
;;; as set forth in subdivision (c)(1)(ii) of the Rights in Technical Data and
;;; Computer Software clause at 52.227-7013. 
;;;
;;; TEXAS INSTRUMENTS INCORPORATED, P.O. BOX 2909 AUSTIN, TEXAS 78769  
;;; Copyright (C) 1989 Texas Instruments Incorporated. All rights reserved.*

;;; This defsystem for defsystem/make-system itself is only defined to be able
;;; to compile itself.  Loading this new stuff ontop of itself would cause trouble.
;;; So, if you want to load make-system, you have to that manually.

(FORMAT t "~% This DEFSYSTEM for defsystem/make-system/patch-system only knows how
 to compile itself.  If we tried to load this within make-system, things would
 likely break.  These files need to be loaded manually.~%")

(DEFSYSTEM MAKE-SYSTEM
  (:NAME "Make-System")
  (:SHORT-NAME "MAKE-SYSTEM")
  (:NICKNAMES "DEFSYSTEM" "PATCH-SYSTEM")
  (:PATHNAME-DEFAULT "SYS:MAKE-SYSTEM;")
  (:Patchable "sys:patch.make-system;" patch)
  (:WARNINGS-PATHNAME-DEFAULT "SYS:CWARNS;MAKE-SYSTEM.LISP")
  
  (:MODULE DEFS "DEFS")
  (:MODULE REST ("DEFSYS" "PATCH" "MAKSYS" "MAKSYS-FROM-FILE"))
  (:COMPILE-LOAD DEFS)
  (:COMPILE REST (:FASLOAD DEFS)))  ;doing a compile-load here would likely break things.
  
;***************************************************************************************

;;; The following stub for making make-system is being scrubbed for now.  Instead, we will create
;;; a normal defsystem (above) which only knows how to compile itself ... but will
;;; not load anything except it's defs (to compile right).

;(unless (fboundp 'si:make-system)
;   (defun MAKE-SYSTEM (SYSTEM &REST KEYWORDS)
;      "Temporary make-system to initially make make-system make itself
;This function only lives until the real make-system gets loaded"
;     (let ((sys (intern (string-upcase (string system)) pkg-keyword-package)))
;       (if (member sys '(:make-system :defsystem))
;	   (MAKE-MAKE-SYSTEM KEYWORDS)
;	   (format t "~2% The only system that can be made right now is 'MAKE-SYSTEM,~
;                       ~%     which will cause the REAL make-system to be built.")))))

;(DEFUN MAKE-MAKE-SYSTEM (&optional KEYWORDS)
;   "This is a fake make-system function that is used to make the system \"make-system\", 
;since the real make-system software is not able to build itself.  This is VERY
;primitive in that it will simply compile and/or load all of the make-system files
;when make-system is called with the system name 'MAKE-SYSTEM or 'DEFSYSTEM.
;It only support keywords (:recompile :reload :noload :noconfirm :nowarn)"
  
;  (let* ((make-system-pathnames '("sys:maksys;defs"
;				  "sys:maksys;defsys"
;				  "sys:maksys;patch"
;				  "sys:maksys;maksys"
;				  "sys:maksys;maksys-from-file"))
;	 (compile-dependencies '("baz:maksys;defs"))
;	 (supported-keywords '(:recompile :reload :noload :noconfirm :nowarn))
;	 (compile-p (member :recompile keywords))
;	 (load-p (not (member :noload keywords)))
;	 (noconfirm-p (member :noconfirm keywords))
;	 (nowarn-p (member :nowarn keywords))
;	 (something-to-do-p (or compile-p load-p)))
    
;    (if (set-difference keywords supported-keywords)
;	(progn
;	  (beep)
;	  (format t "~2%~5T When making system 'MAKE-SYSTEM, only the following keywords are supported.~
;                      ~%~5T ~s"
;		  supported-keywords))

;	(when (and something-to-do-p
;		   (not nowarn-p)
;		   (not noconfirm-p))
;	   (unless (y-or-n-p (format nil "~% ~:[~;Compile~]~:[~; and~]~:[~; Load~] the following MAKE-SYSTEM files? ~
;                        ~2%~{~10T~a~%~}~%" compile-p (and compile-p load-p) load-p make-system-pathnames))
;	       (return-from make-make-system nil)))
;    (when something-to-do-p
;         (format t "~2%")
;	 (DOLIST (file make-system-pathnames)
;	    (when compile-p
;	       (format t "; Compiling ~a " file)
;	       (compile-file file)
;	       (format t "~%")
;	       )       
;	    (when (or load-p (member file compile-dependencies :test 'string-equal))
;	       (let ((inhibit-fdefine-warnings nowarn-p))
;	;	 (format t "; Loading ~a~%" file)
;		 (load file)
;		 ))))))) 

