;;; -*- Mode:Common-Lisp; Base:10; Package:User; -*-

;;;                           RESTRICTED RIGHTS LEGEND

;;;Use, duplication, or disclosure by the Government is subject to
;;;restrictions as set forth in subdivision (c)(1)(ii) of the Rights in
;;;Technical Data and Computer Software clause at 52.227-7013.
;;;
;;;                     TEXAS INSTRUMENTS INCORPORATED.
;;;                              P.O. BOX 2909
;;;                           AUSTIN, TEXAS 78769
;;;                                 MS 2151
;;;
;;; Copyright (C) 1987- 1989 Texas Instruments Incorporated. All rights reserved.

(DEFPACKAGE micronet
  (:use TICL LISP SYSTEM)
  (:nicknames MNET ADDIN ADD AC ADDIN-COMM)
  (:prefix-name "ADD")
  )

(LOAD "SYS: MICRONET;public-symbols")
(EXPORT *addin-public-symbols* 'micronet)


(DEFSYSTEM Micronet
  (:name "Micronet")
  (:short-name "Addin-Comm")
  (:pathname-default "SYS: MICRONET;")
  (:warnings-pathname-default "SYS:  CWARNS; micronet.lisp")
  (:patchable "SYS:  PATCH.MICRONET;" patch)
  ;;
  ;; MODULES
  (:module templates ("addin-qcom"))

  (:module acb-defs ("acb-defs" "queues"))
  (:module channel-defs ("channel-defs"))
  (:module addin-defs ("acb-defs" "channel-defs"))
  (:module public-symbols "public-symbols")	;KTN 7.17.88

  ;;
  ;; DEPENDENCIES
  (:readfile templates)
  (:compile-load-init acb-defs
		      (templates)
		      (:readfile templates)
		      (:readfile templates))

  (:compile-load-init channel-defs
		      (templates acb-defs)
		      ((:readfile templates) (:fasload acb-defs))
		      ((:readfile templates) (:fasload acb-defs)))
  (:auxiliary public-symbols)			;KTN 7.17.88
  )

(DEFSYSTEM Micronet-Comm
  (:name "Micronet Comm")
  (:pathname-default "SYS: MICRONET;")
  (:warnings-pathname-default "SYS:  CWARNS; micronet-comm.lisp")
  (:patchable "SYS:  PATCH.MICRONET-COMM;" patch)
  ;;
  ;; MODULES
  (:module micronet-defs (micronet addin-defs))

  (:module comm ("acb-functions" "basic-comm" "micronet-ports" "micronet-medium"))
  (:module inits ("micronet-inits"))

  (:skip :fasload micronet-defs)
  (:compile-load-init comm
		     (micronet-defs)
		     (:fasload micronet-defs)
		     (:fasload micronet-defs))

  (:compile-load-init inits
		      (micronet-defs comm)
		      (:fasload micronet-defs comm)
		      (:fasload micronet-defs comm))
  )
