;;; -*- Mode:Common-Lisp; Base:10; Package:Addin; -*-

;;;                           RESTRICTED RIGHTS LEGEND

;;;Use, duplication, or disclosure by the Government is subject to
;;;restrictions as set forth in subdivision (c)(1)(ii) of the Rights in
;;;Technical Data and Computer Software clause at 52.227-7013.
;;;
;;;                     TEXAS INSTRUMENTS INCORPORATED.
;;;                              P.O. BOX 2909
;;;                           AUSTIN, TEXAS 78769
;;;                                 MS 2151
;;;
;;; Copyright (C) 1987- 1989 Texas Instruments Incorporated. All rights reserved.

;;; Public symbols in ADDIN-COMM package.

(DEFVAR user:*addin-public-symbols*
	'(
	  ;; Variables
	  *acb-status-ready*
	  
	  ;; ACB command accessors
	  opcode subopcode error-code
	  requestor-complete servicer-complete command-complete input-complete
	  parm-bytes data-bytes
	  
	  ;; ACB parm accessors
	  16b-parm-number 32b-parm-number
	  parm-8b parm-16b parm-32b
	  copy-parms-8b copy-parms-16b copy-parms-32b copy-parms-string
          get-acb-string
	  load-parms-8b load-parms-16b load-parms-32b
	  with-unloaded-parms-8b with-unloaded-parms-16b with-unloaded-parms-32b
	  
	  ;; Misc ACB support
	  get-acb return-acb get-acb-fast return-acb-fast
	  init-acb check-errors physical-address

	  ;; Queueing
	  make-q clr-q q-end q-elem q-empty q-locked-p get-q-lock
	  find-q q-length q-member q-acb deq-acb *q-debug*
	  
	  ;; Misc channel support
	  *Number-of-Channels* *no-interrupt* *channel-list* find-channel  
	  
	  ;; Channel communication
	  send-command send-command-and-wait-complete
	  send-command-and-wait-received
	  wait-command-complete wait-input-complete
	  
	  ;; Channel comm macros
	  with-acb
	  
	  ;; Debug
	  print-acb print-all-acbs print-q print-all-qs
	  addin-memory-status))


;;; Misc

(SETF (GET 'add:with-acb 'zwei:lisp-indent-offset) '(2. 2.))

