;;; -*- Mode: Common-Lisp; Package: User; Base: 10.; Patch-File: T -*-
;;; Patch file for NFS version 3.1
;;; Reason: Modified byte-count and element-count to use ash instead of lsh
;;; to handle file size bigger than 4 mb.
;;; Written 11/16/87 09:09:21 by HMCCREARY,
;;; while running on BOOTES from band LOD1
;;; With IO 3.46, PATHNAME 3.17, FILE 3.16, SYSTEM 3.114, METER 3.7, SERIAL 3.2, CHAOSNET 3.25,
;;;  ETHERNET 3.4, GC 3.24, IMAGEN 3.0, MAIL-DAEMON 3.8, NETWORK-SUPPORT 3.21, PROFILE 3.6,
;;;  SUGGESTIONS 3.7, UCL 3.4, ZWEI 3.34, STREAMER-TAPE 3.17, DEBUG-TOOLS 3.6, FONT-EDITOR 3.1,
;;;  GLOSSARY 3.1, INPUT-EDITOR 3.0, MAIL-READER 3.23, NAMESPACE-EDITOR 3.7, NVRAM 3.6,
;;;  TELNET 3.7, TV 3.33, NAMESPACE 3.15, COMPILER 3.35, PRINTER 3.10, SYSLOG 3.1,
;;;  VT100 3.14, VISIDOC 1.0, IP 2.76, Experimental BUG 8.0, RPC 3.1, NFS 3.0,  microcode 230,
;;;  Band Name: Release 3.2 - 10/22 +IP

#!C
; From file NFS_STREAM.LISP#> NFS; MR-X:
#10R NETWORK-FILE-SYSTEM#:
(COMPILER-LET ((*PACKAGE* (FIND-PACKAGE "NETWORK-FILE-SYSTEM"))
                          (SI:*LISP-MODE* :COMMON-LISP)
                          (*READTABLE* SYS:COMMON-LISP-READTABLE)
                          (SI:*READER-SYMBOL-SUBSTITUTIONS* SYS::*COMMON-LISP-SYMBOL-SUBSTITUTIONS*))
  (COMPILER#:PATCH-SOURCE-FILE "SYS: NFS; NFS_STREAM.#"


(proclaim '(inline byte-count))
(DEFUN-METHOD BYTE-COUNT NFS-STREAM-MIXIN (element-count)
   "returns ELEMENT-COUNT (which is measured in :BYTE-SIZE elements) as an equivalent 8-bit byte length"
   (ash (ash element-count (rest (assoc byte-size byte-size-position-alist)))	   ;ELEMENT-COUNT => bit count
	-3))                                                                       ;bit count => BYTE-COUNT

))

#!C
; From file NFS_STREAM.LISP#> NFS; MR-X:
#10R NETWORK-FILE-SYSTEM#:
(COMPILER-LET ((*PACKAGE* (FIND-PACKAGE "NETWORK-FILE-SYSTEM"))
                          (SI:*LISP-MODE* :COMMON-LISP)
                          (*READTABLE* SYS:COMMON-LISP-READTABLE)
                          (SI:*READER-SYMBOL-SUBSTITUTIONS* SYS::*COMMON-LISP-SYMBOL-SUBSTITUTIONS*))
  (COMPILER#:PATCH-SOURCE-FILE "SYS: NFS; NFS_STREAM.#"


(proclaim '(inline element-count))
(DEFUN-METHOD ELEMENT-COUNT NFS-STREAM-MIXIN (byte-count)
   "Returns BYTE-COUNT (which is measured in 8-bit bytes) as an equivalent :BYTE-SIZE element length"
   (ash (ash byte-count +3)                                        ; BYTE-COUNT => bit count
	(- (rest (assoc byte-size byte-size-position-alist)))))	   ; bit count => ELEMENT COUNT

))
