;;; -*- Mode: Common-Lisp; Package: User; Base: 10.; Patch-File: T -*-

;;; Reason: Added explicit (:METHOD NFS-BUFFERED-INPUT-CHARACTER-STREAM :SET-BUFFER-POINTER) method
;;; because mixin order in flavor definition caused the wrong  :SET-BUFFER-POINTER method
;;; to be inherited.
;;; Reason: Added explicit (:METHOD NFS-BUFFERED-INPUT-CHARACTER-STREAM :SET-BUFFER-POINTER) because
;;; the mixin order in the flavor was causing the wrong :SET-BUFFER-POINTER method to be
;;; inherited.

;;;                           RESTRICTED RIGHTS LEGEND
;;;
;;; Use, duplication, or disclosure by the Government is subject to
;;; restrictions as set forth in subdivision (c)(1)(ii) of the Rights in
;;; Technical Data and Computer Software clause at 52.227-7013.
;;;
;;;   TEXAS INSTRUMENTS INCORPORATED      
;;;   P.O. BOX 2909, M/S 2151             
;;;   AUSTIN, TEXAS 78769                 
;;;
;;; Copyright (C) 1988 Texas Instruments Incorporated.
;;; All rights reserved.

;;; Written 01/30/89 17:38:23 by CORNISH,
;;; while running on Bravo from band LOD1
;;; With SYSTEM 5.9, VIRTUAL-MEMORY 5.5, EH 5.3, MAKE-SYSTEM 5.3, MICRONET 5.5, LOCAL-FILE 5.0,
;;;  BASIC-PATHNAME 5.3, NETWORK-SUPPORT-COLD 5.1, BASIC-NAMESPACE 5.8, NETWORK-NAMESPACE 5.0,
;;;  DISK-IO 5.9, DISK-LABEL 5.1, BASIC-FILE 5.4, MAC-PATHNAME 5.0, NETWORK-PATHNAME 5.0,
;;;  COMPILER 5.2, TV 5.24, DATALINK 5.7, CHAOSNET 5.6, GC 5.4, MEMORY-AUX 5.1, NVRAM 5.1,
;;;  SYSLOG 5.2, STREAMER-TAPE 5.7, UCL 5.0, INPUT-EDITOR 5.0, METER 5.1, ZWEI 5.12,
;;;  DEBUG-TOOLS 5.1, Experimental NETWORK-SUPPORT 5.1, Experimental NETWORK-SERVICE 5.1,
;;;  DATALINK-DISPLAYS 5.0, FONT-EDITOR 5.0, SERIAL 5.0, PRINTER 5.12, MAC-PRINTER-TYPES 5.4,
;;;  PRINTER-TYPES 5.5, IMAGEN 5.1, SUGGESTIONS 5.0, MAIL-DAEMON 5.5, MAIL-READER 5.6,
;;;  TELNET 5.2, VT100 5.1, NAMESPACE-EDITOR 5.1, PROFILE 5.1, VISIDOC 5.4, IP 3.40,
;;;  Experimental BUG 10.6, RPC 3.2, NFS 3.3,  microcode 398, Band Name: Rel 5.0 + IP 10/7

#!C
; From file NFS_STREAM.LISP NFS; SYS:
#10R NETWORK-FILE-SYSTEM#:
(COMPILER-LET ((*PACKAGE* (FIND-PACKAGE "NETWORK-FILE-SYSTEM"))
                          (SI:*LISP-MODE* :COMMON-LISP)
                          (*READTABLE* SYS:COMMON-LISP-READTABLE)
                          (SI:*READER-SYMBOL-SUBSTITUTIONS* SYS::*COMMON-LISP-SYMBOL-SUBSTITUTIONS*))
  (COMPILER#:PATCH-SOURCE-FILE "SYS: NFS;NFS_STREAM.#"



;;; The :SET-BUFFER-POINTER method in the SYS:BUFFERED-INPUT-CHARACTER-STREAM mixin to
;;; NFS-BUFFERED-INPUT-CHARACTER-STREAM flavor shadows the correct :SET-BUFFER-POINTER method in
;;; the NFS-BUFFERED-INPUT-STREAM mixin.  Therefore, this explicit method for NFS-BUFFERED-INPUT-CHARACTER-STREAM
;;; is needed.  Otherwise, we would have to reverse the ordering of mixins in the NFS-BUFFERED-INPUT-CHARACTER-STREAM
;;; flavor (with heaven knows what consequences).
(DEFMETHOD (NFS-BUFFERED-INPUT-CHARACTER-STREAM :SET-BUFFER-POINTER) (new-element-no) 
   (setf next-element-no new-element-no))

))
