;;; -*- Mode: Common-Lisp; Package: User; Base: 10.; Patch-File: T -*-

;;; Reason: If MAKE-FILEID returns a negative SXHASH value, then that value is masked to
;;; fit in 32 bits.  Otherwise, the unsigned 32-bit integer XDR filter complains.

;;;                           RESTRICTED RIGHTS LEGEND
;;;
;;; Use, duplication, or disclosure by the Government is subject to
;;; restrictions as set forth in subdivision (c)(1)(ii) of the Rights in
;;; Technical Data and Computer Software clause at 52.227-7013.
;;;
;;;   TEXAS INSTRUMENTS INCORPORATED      
;;;   P.O. BOX 2909, M/S 2151             
;;;   AUSTIN, TEXAS 78769                 
;;;
;;; Copyright (C) 1988 Texas Instruments Incorporated.
;;; All rights reserved.

;;; Written 03/22/89 13:34:47 by CORNISH,
;;; while running on Bravo from band LOD1
;;; With SYSTEM 5.9, VIRTUAL-MEMORY 5.5, EH 5.4, MAKE-SYSTEM 5.4, MICRONET 5.6, LOCAL-FILE 5.0,
;;;  BASIC-PATHNAME 5.4, NETWORK-SUPPORT-COLD 5.2, BASIC-NAMESPACE 5.8, NETWORK-NAMESPACE 5.0,
;;;  DISK-IO 5.10, DISK-LABEL 5.1, BASIC-FILE 5.5, MAC-PATHNAME 5.1, Experimental NETWORK-PATHNAME 5.1,
;;;  COMPILER 5.3, TV 5.27, DATALINK 5.7, CHAOSNET 5.6, GC 5.4, MEMORY-AUX 5.1, NVRAM 5.1,
;;;  SYSLOG 5.2, STREAMER-TAPE 5.7, UCL 5.0, INPUT-EDITOR 5.1, METER 5.1, ZWEI 5.14,
;;;  DEBUG-TOOLS 5.1, Experimental NETWORK-SUPPORT 5.1, Experimental NETWORK-SERVICE 5.1,
;;;  DATALINK-DISPLAYS 5.0, FONT-EDITOR 5.0, SERIAL 5.0, PRINTER 5.12, MAC-PRINTER-TYPES 5.4,
;;;  PRINTER-TYPES 5.5, IMAGEN 5.3, SUGGESTIONS 5.0, MAIL-DAEMON 5.7, MAIL-READER 5.6,
;;;  TELNET 5.3, VT100 5.1, NAMESPACE-EDITOR 5.2, PROFILE 5.1, VISIDOC 5.6, IP 3.42,
;;;  Experimental BUG 10.8, Experimental RPC 6.0, NFS 3.7,  microcode 414, Band Name: Rel 5.0 + IP 10/7

#!C
; From file MISC_FUNCTIONS.LISP NFS; SYS:
#10R NETWORK-FILE-SYSTEM#:
(COMPILER-LET ((*PACKAGE* (FIND-PACKAGE "NETWORK-FILE-SYSTEM"))
                          (SI:*LISP-MODE* :COMMON-LISP)
                          (*READTABLE* SYS:COMMON-LISP-READTABLE)
                          (SI:*READER-SYMBOL-SUBSTITUTIONS* SYS::*COMMON-LISP-SYMBOL-SUBSTITUTIONS*))
  (COMPILER#:PATCH-SOURCE-FILE "sys: NFS; MISC_FUNCTIONS.#"


(DEFUN MAKE-FILEID (pathname)
   "returns a pseudo-NFS fileid for PATHNAME"
   (declare (values fileid))
   (when (root-directory-p pathname)
     (return-from make-fileid 1234))
   (setf pathname (pathname pathname))
   (let* ((directory (fs::lookup-directory (pathname-directory pathname) t))
	  (file      (when (typep directory 'fs::file)
		       (fs::lookup-file directory
					(pathname-name    pathname)
					(pathname-type    pathname)
					(pathname-version pathname))))
	  (map       (when (typep file 'fs::file)
		       (fs::file-map file))))
     (if (and (eq 'lisp:map (named-structure-p map))
	      (plusp (fs::map-nblocks map)))
	 (fs::map-block-location map 0)	   ; get starting virtual block address
	 (logand #xFFFFFFFF (- (sxhash (send pathname :string-for-host))))))	   ; 22 Mar 89 Mac
   )
))
