;;; -*- Mode: Common-Lisp; Package: SYS; Base: 8.; Patch-File: T -*-

;;; Reason:  Fix code generated by COMPILE-FILE for instance variable references near the end of a flavor method that references a large number of constants.  

;;;                           RESTRICTED RIGHTS LEGEND
;;;
;;; Use, duplication, or disclosure by the Government is subject to
;;; restrictions as set forth in subdivision (c)(1)(ii) of the Rights in
;;; Technical Data and Computer Software clause at 52.227-7013.
;;;
;;;   TEXAS INSTRUMENTS INCORPORATED      
;;;   P.O. BOX 2909, M/S 2151             
;;;   AUSTIN, TEXAS 78769                 
;;;
;;; Copyright (C) 1989 Texas Instruments Incorporated.
;;; All rights reserved.

;;; Patch file for BASIC-FILE version 6.3
;;; Written 09/29/89 12:27:46 by BERGER,
;;; while running on ARIES from band LODX
;;; With SYSTEM 6.15, VIRTUAL-MEMORY 6.1, EH 6.4, MAKE-SYSTEM 6.0, MICRONET 6.0, LOCAL-FILE 6.0,
;;;  BASIC-PATHNAME 6.1, NETWORK-SUPPORT-COLD 6.0, BASIC-NAMESPACE 6.2, NETWORK-NAMESPACE 6.0,
;;;  DISK-IO 6.1, DISK-LABEL 6.0, BASIC-FILE 6.2, MAC-PATHNAME 6.0, NETWORK-PATHNAME 6.0,
;;;  COMPILER 6.10, TV 6.15, DATALINK 6.0, CHAOSNET 6.0, GC 6.3, MEMORY-AUX 6.0, NVRAM 6.1,
;;;  SYSLOG 6.1, STREAMER-TAPE 6.4, UCL 6.0, INPUT-EDITOR 6.0, METER 6.1, ZWEI 6.5,
;;;  DEBUG-TOOLS 6.3, NETWORK-SUPPORT 6.0, NETWORK-SERVICE 6.1, DATALINK-DISPLAYS 6.0,
;;;  FONT-EDITOR 6.1, SERIAL 6.0, PRINTER 6.3, MAC-PRINTER-TYPES 6.1, PRINTER-TYPES 6.1,
;;;  IMAGEN 6.0, SUGGESTIONS 6.0, MAIL-DAEMON 6.2, MAIL-READER 6.2, TELNET 6.0, VT100 6.0,
;;;  NAMESPACE-EDITOR 6.0, PROFILE 6.1, VISIDOC 6.4, TI-CLOS 6.20, CLEH 6.5, IP 3.49,
;;;  Experimental CLX 6.2, CLUE 6.10, X11M 6.13, Experimental BUG 11.15, VISIDOC-SERVER 6.1,
;;;  DECNET 1.70,  microcode 429, Band Name: Rel 6.0 + SLE 8/30

#!C
; From file LOAD.LISP#> BASIC-FILE; SYS:
#8R SYSTEM#:
(COMPILER-LET ((*PACKAGE* (FIND-PACKAGE "SYSTEM"))
                          (SI:*LISP-MODE* :COMMON-LISP)
                          (*READTABLE* COMMON-LISP-READTABLE)
                          (SI:*READER-SYMBOL-SUBSTITUTIONS* *COMMON-LISP-SYMBOL-SUBSTITUTIONS*))
  (COMPILER#:PATCH-SOURCE-FILE "SYS: BASIC-FILE; LOAD.#"


(DEFUN FEF-CONVERT-ADDRESSES (FEF &AUX ILEN LIM-PC)
;;Convert indirect addressing used for flavor instance variables
;;in machine instructions to direct addressing.
;;9-13-85 CLM
;;  3/06/86 JK  - Update for VM2 instruction set.
;;  7/27/89 DNG - Fix handling of PUSH-LONG-FEF instructions -- if the address 
;;		is changed to a SELF-MAP address, then the op code must be changed 
;;		to PUSH.  [SPR 10424]
  (SETQ LIM-PC (FEF-LIMIT-PC FEF))
  (DO ((PC (FEF-INITIAL-PC FEF) (+ PC ILEN)))
      ((>= PC LIM-PC))

    (LET* ((INSN (FEF-INSTRUCTION FEF PC))
	   (OP (ASH INSN -11))
	   (REG (LDB si:%%QMI-REGISTER INSN)))	;New symbolic constants will eventually be in SYS - jk
      (SETQ ILEN (FEF-INSTRUCTION-LENGTH FEF PC))
      (WHEN (AND (= ILEN 1)			;Not a long-branch
		 (< OP #o160)
		 (OR (< REG si:%QMI-REG-LEX)	;FEF base register
		     (= OP #o70)))		;Push-long-FEF
	;; Now see if instruction has a destination
	(LET* ((NAME (AREF (compiler:INSTRUCTION-DECODE-TABLE) OP))
	       (NO-REG (GET NAME 'Compiler:NO-REG)))
	  (WHEN (OR (NULL NO-REG)
		    (= OP #o70))
	    (LET* ((OFFSET (LDB si:%%QMI-FEF-OFFSET INSN))
		   (FEF-DATA (%P-pointer-OFFSET FEF OFFSET))
		   (FEF-dtp (%P-data-type-OFFSET FEF OFFSET)))
;; GRH		   (FEF-DATA (%P-ldb-OFFSET sys:%%q-pointer  FEF OFFSET))
;;		   (FEF-dtp (%P-ldb-OFFSET sys:%%q-data-type  FEF OFFSET)))
	      (WHEN (=  FEF-DTP sys:DTP-Self-Ref-Pointer) 
		(LET ((FLAG (LDB (BYTE 3 #o21) FEF-DATA))	        ;Flag bit of the SRP word
		      (INDEX (LDB si:%%SELF-REF-INDEX FEF-DATA)))	;Pointer field of the SRP word
		  (COND
		    
		    ((OR (= FLAG 2)		;MAP-LEADER-FLAG is set, so can't use SELF-MAPPING-TABLE
			 (= FLAG 1))		;MONITOR-FLAG is set, so SRP is a monitor ptr (these never appear in methods)
		     NIL)
		    
		    ((> INDEX 37) NIL)		;Pointer is too big for INSN address field.
		    
		    ((= FLAG 4)			;RELOCATE-FLAG is set
		     (WHEN (= OP #o70) ; change PUSH-LONG-FEF to PUSH
		       (SETQ INSN '#.(COMPILER::LAP-VALUE 'PUSH)))
		     (SETF (FEF-INSTRUCTION FEF PC)       
			   (DPB (DPB si:%QMI-REG-IVAR si:%%QMI-REGISTER
				     (+ INDEX (BYTE-MASK si:%%QMI-IVAR-MAPPED)))
				(BYTE #o11 0)
				INSN)))		;Offset in SELF-MAPPING-TABLE
		    
		    ((= FLAG 0)			;RELOCATE-FLAG is not set
		     (WHEN (= OP #o70) ; change PUSH-LONG-FEF to PUSH
		       (SETQ INSN '#.(COMPILER::LAP-VALUE 'PUSH)))
		     (SETF (FEF-INSTRUCTION FEF PC)
			   (DPB (DPB si:%QMI-REG-IVAR si:%%QMI-REGISTER INDEX)
				(BYTE #o11 0)
				INSN)))		;Offset in SELF (unmapped)
		    (T NIL))
		  )))))))
 
    ))
))
