;;; -*- Mode: Common-Lisp; Package: FS; Base: 10.; Patch-File: T -*-

;;; Reason: Fixed extract-attribute-list to handle :syntax as a valid attribute. [10249]

;;;                           RESTRICTED RIGHTS LEGEND
;;;
;;; Use, duplication, or disclosure by the Government is subject to
;;; restrictions as set forth in subdivision (c)(1)(ii) of the Rights in
;;; Technical Data and Computer Software clause at 52.227-7013.
;;;
;;;   TEXAS INSTRUMENTS INCORPORATED      
;;;   P.O. BOX 2909, M/S 2151             
;;;   AUSTIN, TEXAS 78769                 
;;;
;;; Copyright (C) 1989 Texas Instruments Incorporated.
;;; All rights reserved.

;;; Written 10/04/89 07:08:39 by BERGER,
;;; while running on ARIES from band LODX
;;; With SYSTEM 6.17, VIRTUAL-MEMORY 6.2, EH 6.5, MAKE-SYSTEM 6.1, MICRONET 6.0, LOCAL-FILE 6.1,
;;;  BASIC-PATHNAME 6.1, NETWORK-SUPPORT-COLD 6.0, BASIC-NAMESPACE 6.2, NETWORK-NAMESPACE 6.0,
;;;  DISK-IO 6.1, DISK-LABEL 6.0, BASIC-FILE 6.3, MAC-PATHNAME 6.0, NETWORK-PATHNAME 6.0,
;;;  COMPILER 6.12, TV 6.15, DATALINK 6.0, CHAOSNET 6.1, GC 6.3, MEMORY-AUX 6.0, NVRAM 6.1,
;;;  SYSLOG 6.1, STREAMER-TAPE 6.4, UCL 6.0, INPUT-EDITOR 6.0, METER 6.1, ZWEI 6.5,
;;;  DEBUG-TOOLS 6.3, NETWORK-SUPPORT 6.0, NETWORK-SERVICE 6.1, DATALINK-DISPLAYS 6.0,
;;;  FONT-EDITOR 6.1, SERIAL 6.0, PRINTER 6.3, MAC-PRINTER-TYPES 6.1, PRINTER-TYPES 6.1,
;;;  IMAGEN 6.0, SUGGESTIONS 6.0, MAIL-DAEMON 6.2, MAIL-READER 6.2, TELNET 6.0, VT100 6.0,
;;;  NAMESPACE-EDITOR 6.0, PROFILE 6.1, VISIDOC 6.4, TI-CLOS 6.24, CLEH 6.5, IP 3.50,
;;;  Experimental CLX 6.3, CLUE 6.17, X11M 6.14, Experimental BUG 11.15, VISIDOC-SERVER 6.1,
;;;   microcode 429, Band Name: Rel 6.0 + SLE 8/30

#!C
; From file OPEN.LISP#> BASIC-FILE; SYS:
#10R FILE-SYSTEM#:
(COMPILER-LET ((*PACKAGE* (FIND-PACKAGE "FILE-SYSTEM"))
                          (SI:*LISP-MODE* :COMMON-LISP)
                          (*READTABLE* COMMON-LISP-READTABLE)
                          (SI:*READER-SYMBOL-SUBSTITUTIONS* SYS::*COMMON-LISP-SYMBOL-SUBSTITUTIONS*))
  (COMPILER#:PATCH-SOURCE-FILE "SYS: BASIC-FILE; OPEN.#"


(DEFUN EXTRACT-ATTRIBUTE-LIST (STREAM &AUX WO PLIST PATH MODE ERROR)
  "Return the attribute list read from STREAM.
STREAM can be reading either a text file or a XLD file."
  (SETQ WO (SEND STREAM :WHICH-OPERATIONS))
  (COND
    ((MEMBER :SYNTAX-PLIST WO :TEST #'EQ) (SETQ PLIST (SEND STREAM :SYNTAX-PLIST)))
    ((NOT (SEND STREAM :CHARACTERS)) (SETQ PLIST (SI:QFASL-STREAM-PROPERTY-LIST STREAM)))
    ;; If the file supports :READ-INPUT-BUFFER, check for absense of a plist
    ;; without risk that :LINE-IN will read the whole file
    ;; if the file contains no Return characters.
    ((AND (MEMBER :READ-INPUT-BUFFER WO :TEST #'EQ)
	(MULTIPLE-VALUE-BIND (BUFFER START END)
	  (SEND STREAM :READ-INPUT-BUFFER)
	  (AND BUFFER
	     (NOT
	      (SEARCH "-*-" BUFFER :START2 START :END2 END :TEST #'CHAR-EQUAL))))) ;MBC 1.21.86
     NIL)
    ;; If stream does not support :SET-POINTER, there is no hope
    ;; of parsing a plist, so give up on it.
    ((NOT (MEMBER :SET-POINTER WO :TEST #'EQ)) NIL)
    (T
     (DO ((LINE)
	  (EOF))
	 (NIL)
       (MULTIPLE-VALUE-SETQ (LINE EOF)
	 (SEND STREAM :LINE-IN ()))
       (COND
	 ((NULL LINE) (SEND STREAM :SET-POINTER 0.) (RETURN ()))
	 ((SEARCH "-*-" LINE :TEST #'CHAR-EQUAL)   ;Don't be font sensitive! 1.21.86 MBC
	  (SETQ LINE (FILE-GRAB-WHOLE-PROPERTY-LIST LINE STREAM))
	  (SEND STREAM :SET-POINTER 0.)
	  (SETF (VALUES PLIST ERROR) (FILE-PARSE-PROPERTY-LIST LINE)) (RETURN ()))
	 ((OR EOF (STRING-SEARCH-NOT-SET '(#\SPACE #\TAB) LINE))
	  (SEND STREAM :SET-POINTER 0.) (RETURN ()))))))
  ;; The following expression causes the proper thing to
  ;; happen when the Lisp dialect is specified in the 
  ;; Symbolics or LMI way.
  (WHEN (and plist (EQ (GETF PLIST :MODE) :LISP))   ; DAB 10-04-89
    (LET ((NEW-MODE (OR (GETF PLIST :SYNTAX) (GETF PLIST :READTABLE))))
      (WHEN NEW-MODE
	(SETF (GETF PLIST :MODE) (IF (EQ NEW-MODE :TRADITIONAL)
				     :ZETALISP
				     NEW-MODE)))))
  (AND PLIST (NOT (GETF PLIST :MODE))		;1.29.87 MBC
       (MEMBER :PATHNAME WO :TEST #'EQ)
       (SETQ PATH (SEND STREAM :PATHNAME))
       (let ((can-type (SEND PATH :CANONICAL-TYPE)))
	 (setf mode
	       (if (eq can-type :LISP)
		   (get ZWEI:*INTERVAL* :MODE)
		   (cdr (ASSOC can-type *FILE-TYPE-MODE-ALIST* :TEST #'EQ))))
	 (SETF (GETF PLIST :MODE) MODE)))
  (VALUES PLIST ERROR))
))
