;;; -*- Mode: Common-Lisp; Package: FS; Base: 10.; Patch-File: T -*-

;;; Reason: Modified make-pathname to merge TYPE from defaults. [10941]

;;;                           RESTRICTED RIGHTS LEGEND
;;;
;;; Use, duplication, or disclosure by the Government is subject to
;;; restrictions as set forth in subdivision (c)(1)(ii) of the Rights in
;;; Technical Data and Computer Software clause at 52.227-7013.
;;;
;;;   TEXAS INSTRUMENTS INCORPORATED      
;;;   P.O. BOX 2909, M/S 2151             
;;;   AUSTIN, TEXAS 78769                 
;;;
;;; Copyright (C) 1989 Texas Instruments Incorporated.
;;; All rights reserved.

;;; Written 02/02/90 08:05:17 by BERGER,
;;; while running on Pasteur from band LOD2
;;; With SYSTEM 6.28, VIRTUAL-MEMORY 6.3, EH 6.5, MAKE-SYSTEM 6.2, MICRONET 6.0, LOCAL-FILE 6.1,
;;;  BASIC-PATHNAME 6.2, NETWORK-SUPPORT-COLD 6.2, BASIC-NAMESPACE 6.7, NETWORK-NAMESPACE 6.1,
;;;  DISK-IO 6.2, DISK-LABEL 6.0, BASIC-FILE 6.7, MAC-PATHNAME 6.0, NETWORK-PATHNAME 6.0,
;;;  COMPILER 6.14, TV 6.23, DATALINK 6.0, CHAOSNET 6.5, GC 6.3, MEMORY-AUX 6.0, NVRAM 6.2,
;;;  SYSLOG 6.2, STREAMER-TAPE 6.5, UCL 6.0, INPUT-EDITOR 6.0, METER 6.1, ZWEI 6.12,
;;;  DEBUG-TOOLS 6.4, NETWORK-SUPPORT 6.1, NETWORK-SERVICE 6.2, DATALINK-DISPLAYS 6.0,
;;;  FONT-EDITOR 6.1, SERIAL 6.0, PRINTER 6.3, MAC-PRINTER-TYPES 6.1, PRINTER-TYPES 6.2,
;;;  IMAGEN 6.1, SUGGESTIONS 6.1, MAIL-DAEMON 6.4, MAIL-READER 6.7, TELNET 6.1, VT100 6.0,
;;;  NAMESPACE-EDITOR 6.4, PROFILE 6.2, VISIDOC 6.7, TI-CLOS 6.34, CLEH 6.5, IP 3.57,
;;;  Experimental CLX 6.8, CLUE 6.46, X11M 6.20, Experimental BUG 11.18,  microcode 648,
;;;  Band Name: rel6.0 1/23

#!C
; From file PARSE.LISP#> PATHNAME; SYS:
#10R FILE-SYSTEM#:
(COMPILER-LET ((*PACKAGE* (FIND-PACKAGE "FILE-SYSTEM"))
                          (SI:*LISP-MODE* :COMMON-LISP)
                          (*READTABLE* COMMON-LISP-READTABLE)
                          (SI:*READER-SYMBOL-SUBSTITUTIONS* SYS::*COMMON-LISP-SYMBOL-SUBSTITUTIONS*))
  (COMPILER#:PATCH-SOURCE-FILE "SYS: PATHNAME; PARSE.#"


(DEFUN MAKE-PATHNAME (&REST OPTIONS &OPTIONAL &KEY (DEFAULTS T)
  (HOST (IF (EQ DEFAULTS T)
	  (DEFAULT-HOST *DEFAULT-PATHNAME-DEFAULTS*)
	  (DEFAULT-HOST DEFAULTS)))
  &ALLOW-OTHER-KEYS)
  "Create a pathname, specifying components as keyword arguments.
If DEFAULTS is a pathname or a defaults list, the pathname is defaulted from it.
If DEFAULTS is T (the default), the host is defaulted from
*DEFAULT-PATHNAME-DEFAULTS* and the other components are not defaulted at all."
  (DECLARE (SPECIAL *DEFAULT-PATHNAME-DEFAULTS*))
  (DECLARE
   (ARGLIST &KEY &OPTIONAL (DEFAULTS T) HOST DEVICE RAW-DEVICE DIRECTORY RAW-DIRECTORY NAME
	    RAW-NAME TYPE RAW-TYPE VERSION CANONICAL-TYPE ORIGINAL-TYPE))
  (IF (NOT (SYMBOLP DEFAULTS))
	(MERGE-PATHNAME-DEFAULTS (APPLY (SAMPLE-PATHNAME HOST) :NEW-PATHNAME OPTIONS) DEFAULTS
				 *name-specified-default-type* :newest
				 ;;Steele say to always merge types. This causing problems with UNIX
                                 ;; users. The fix below attempts to satisfy both. [10941]
				 (if (typep (send (si:parse-host host) :sample-pathname )
					    '(UNIX-UCB-PATHNAME UNIX-PATHNAME))
				     *merge-unix-types*
				     T )  ; DAB 02-01-90 Always merge type. 
				 )
	(APPLY (SAMPLE-PATHNAME HOST) :NEW-PATHNAME OPTIONS))
  
  )
))
