;;; -*- Mode: Common-Lisp; Package: User; Base: 10.; Patch-File: T -*-

;;; Reason: Added SST and MASS to systems list.

;;;                           RESTRICTED RIGHTS LEGEND
;;;
;;; Use, duplication, or disclosure by the Government is subject to
;;; restrictions as set forth in subdivision (c)(1)(ii) of the Rights in
;;; Technical Data and Computer Software clause at 52.227-7013.
;;;
;;;   TEXAS INSTRUMENTS INCORPORATED      
;;;   P.O. BOX 2909, M/S 2151             
;;;   AUSTIN, TEXAS 78769                 
;;;
;;; Copyright (C) 1988 Texas Instruments Incorporated.
;;; All rights reserved.

;;; Written 01/05/89 12:55:11 by FISH,
;;; while running on DaVinci from band LOD2
;;; With SYSTEM 5.9, VIRTUAL-MEMORY 5.5, EH 5.2, MAKE-SYSTEM 5.1, MICRONET 5.5, LOCAL-FILE 5.0,
;;;  BASIC-PATHNAME 5.2, NETWORK-SUPPORT-COLD 5.1, BASIC-NAMESPACE 5.5, NETWORK-NAMESPACE 5.0,
;;;  DISK-IO 5.9, DISK-LABEL 5.1, BASIC-FILE 5.3, MAC-PATHNAME 5.0, NETWORK-PATHNAME 5.0,
;;;  COMPILER 5.1, TV 5.17, DATALINK 5.7, CHAOSNET 5.6, GC 5.3, MEMORY-AUX 5.1, NVRAM 5.1,
;;;  SYSLOG 5.0, STREAMER-TAPE 5.6, UCL 5.0, INPUT-EDITOR 5.0, METER 5.0, ZWEI 5.8,
;;;  DEBUG-TOOLS 5.0, NETWORK-SUPPORT 5.0, NETWORK-SERVICE 5.0, DATALINK-DISPLAYS 5.0,
;;;  FONT-EDITOR 5.0, SERIAL 5.0, PRINTER 5.10, MAC-PRINTER-TYPES 5.2, PRINTER-TYPES 5.2,
;;;  IMAGEN 5.1, SUGGESTIONS 5.0, MAIL-DAEMON 5.1, MAIL-READER 5.3, TELNET 5.1, VT100 5.0,
;;;  NAMESPACE-EDITOR 5.1, PROFILE 5.1, VISIDOC 5.4, IP 3.34, Experimental BUG 10.2,
;;;  Experimental SEYMOUR3 2.0, Experimental SLAP 3.12,  microcode 1, Band Name: rel5/10-7/slap

#!C
; From file UPDATE-BUG.LISP#> BUG; VIRGO:
#10R USER#:
(COMPILER-LET ((*PACKAGE* (FIND-PACKAGE "USER"))
                          (SI:*LISP-MODE* :COMMON-LISP)
                          (*READTABLE* SYS:COMMON-LISP-READTABLE)
                          (SI:*READER-SYMBOL-SUBSTITUTIONS* SYS::*COMMON-LISP-SYMBOL-SUBSTITUTIONS*))
  (COMPILER#:PATCH-SOURCE-FILE "SYS: BUG; UPDATE-BUG.#"


(DEFPARAMETER systems-list
      '(
	("BUILD" :value "BUILD" :documentation
	 	"BUILD PROCEDURES")
	("BUGS" :value "BUGS" :documentation
	 	"SPR SYSTEM")
        ("CHAOSNET" :value "CHAOSNET" :documentation 
	 	"CHAOSNET")
	("CM" :value "CM" :documentation 
	 	"CONFIGURATION MANAGEMENT")
	("COLOR GRAPHICS" :value "COLOR_GRAPHICS" :documentation 
	 	"COLOR GARPHICS")
	("COMPILER" :value "COMPILER" :documentation
	 	"COMPILER")
	("CONVERSE" :value "CONVERSE" :documentation
	 	"CONVERSE MAIL")
	("DEBUGGER" :value "DEGUGGER" :documentation
		"DEBUGGER UTILITY")
	("DIAGNOSTICS" :value "DIAGNOSTICS" :documentation
	 	"DIAGNOSTICS")
	("DUPLICATE" :value "DUPLICATE" :documentation
		"DUPLICATE SPR REPORT")
	("ERROR HANDLER" :value "ERROR_HANDLER" :documentation
	 	"ERROR HANDLER")
	("FILE SERVER" :value "FILE_SERVER" :documentation
	 	"FILE SERVER")
	("FILE SYSTEM" :value "FILE_SYSTEM" :documentation 
	 	"FILE SYSTEM")
	("FINDER" :value "FINDER" :documentation
                "FINDER")
	("FONT EDITOR" :value "FONT_EDITOR" :documentation 
	 	"FONT EDITOR")
	("FORMATTER" :value "FORMATTER" :documentation 
	 	"FORMATTER")
	("GENASYS" :value "GENASYS" :documentation 
	 	"GENASYS")
	("GRAPHICS EDITOR" :value "GRAPHICS_EDITOR" :documentation 
	 	"GRAPHICS EDITOR")
	("GRAPHICS WINDOW" :value "GRAPHICS_WINDOW" :documentation 
	 	"GRAPHICS WINDOW SYSTEM")
	("GLOSSARY" :value "GLOSSARY" :documentation 
	 	"GLOSSARY")
	("GRASPER" :value "GRASPER" :documentation 
	 	"GRASPER")
	("HARDWARE" :value "HARDWARE" :documentation 
	 	"FOR HARDWARE BUGS")
	("INPUT EDITOR" :value "INPUT_EDITOR" :documentation 
	 	"INPUT EDITOR")
	("INPUT/OUTPUT" :value "INPUT_OUTPUT" :documentation 
	 	"INPUT/OUTPUT")
	("INSPECTOR" :value "INSPECTOR" :documentation 
	 	"INSPECTOR")
	("INTEGRATION TEST" :value "INTEGRATION_TEST" :documentation 
	 	"INTEGRATION TEST")
	("KERNEL" :value "KERNEL" :documentation 
	 	"KERNEL")
	("LX" :value "LX" :documentation 
	 	"LISP/UNIX")
	("MAC MX" :value "MACMX" :documentation
                "C code for the Macintosh to run microExplorer")
	("MAIL" :value "MAIL" :documentation 
	 	"MAIL SYSTEM")
	("MAILER" :value "MAILER" :documentation 
	 	"MAILER OF MAIL SYSTEM")
	("MAKE SYSTEM" :value "MAKE_SYSTEM" :documentation 
	 	"MAKE SYSTEM, DEFSYSTEM")
	("MANUALS" :value "MANUALS" :documentation 
	 	"MANUALS")
        ("MASS" :value "MASS" :documentation 
	 	"MASS")
	("MEMORY MANAGEMENT" :value "MEMORY_MGT" :documentation 
	 	"GARBAGE COLLECTION, MEMORY MANAGEMENT")
	("MICROCODE" :value "MICROCODE" :documentation 
	 	"MICROCODE")
	("MISC" :value "MISC" :documentation 
	 	"MISCELLANEOUS")
	("MX" :value "MX" :documentation 
	 	"microExplorer")
	("MX-WINDOW" :value "MX_WINDOW" :documentation
                "microExplorer window system")
	("NETCONFIG" :value "NETCONFIG" :documentation 
	 	"NETWORK CONFIGURATION")
	("NETWORK" :value "NETWORK" :documentation 
	 	"NETWORKING SOFTWARE")
	("NEW USER" :value "NEW_USER" :documentation 
	 	"NEW USER UTILITY")
	("NLMENU" :value "NLMENU" :documentation 
	 	"NATURAL LANGUAGE MENU")
	("NFS" :value "NFS" :documentation 
	 	"NETWORK FILE SYSTEM")
	("NVRAM" :value "NVRAM" :documentation 
	 	"FOR REPORT LAST SHUTDOWN ETC...")
	("PATCH" :value "PATCH" :documentation 
	 	"PATCH CONTROL")
	("PEEK" :value "PEEK" :documentation 
	 	"DEBUG PEEK")
	("PERFORMANCE" :value "PERFORMANCE" :documentation 
	 	"PERFORMANCE")
	("PORTS" :value "PORTS" :documentation 
	 	"PORTS")
	("PRINTER" :value "PRINTER" :documentation 
	 	"PRINTER")
	("PRINT SERVER" :value "PRINT_SERVER" :documentation 
	 	"PRINT SERVER")
	("PROFILE" :value "PROFILE" :documentation 
	 	"USER PROFILE UTILITY")
	("PROLOG" :value "PROLOG" :documentation 
	 	"PROLOG")
	("RPC"  :value "RPC" :documentation 
                "REMOTE PROCEDURE CALL")
	("RTMS" :value "RTMS" :documentation 
	 	"RELATIONAL TABLE MANAGEMENT SYSTEM")
	("SNA1" :value "SNA1" :documentation 
	 	"SYSTEM NETWORK ARCHITECTURE 1")
	("SNA2" :value "SNA2" :documentation 
	 	"SYSTEM NETWORK ARCHITECTURE 2")
        ("SST" :value "SST" :documentation 
	 	"Symbolic Spreadsheet Toolkit")
	("STEPPER" :value "STEPPER" :documentation 
	 	"DEBUG STEPPER")
	("STREAMS" :value "STREAMS" :documentation 
	 	"I/O STREAMS")
	("SUGGESTIONS" :value "SUGGESTIONS" :documentation 
	 	"SUGGESTIONS MODE")
	("SYSTEM TEST" :value "SYSTEM_TEST" :documentation 
	 	"SYSTEM TEST")
	("TAPE" :value "TAPE" :documentation 
	 	"TAPE")
	("TCP/IP" :value "TCP_IP" :documentation 
	 	"TCP/IP")
	("TELNET" :value "TELNET" :documentation 
	 	"TELNET")
	("TOOLS" :value "TOOLS" :documentation 
	 	"TOOLS")
	("TREE EDITOR" :value "TREE_EDITOR" :documentation 
	 	"TREE EDITOR")
	("TEST BRIDGE" :value "TESTBRIDGE")
	("TEST VIEW" :value "TESTVIEW")
        ("TEST BENCH" :value "TESTBENCH")
	("TEST BUILDER" :value "TESTBUILDER")
	("UCL" :value "UCL" :documentation 
	 	"UNIVERSAL COMMAND LOOP")
	("UNASSIGNED" :value "UNASSIGNED" :documentation 
	 	"UNASSIGNED")
	("USERIF" :value "USERIF" :documentation 
	 	"USER INTERFACE - CONSISTENCY")
	("VIRTUAL MACHINE" :value "VIRTUAL_MACHINE" :documentation 
	 	"VIRTUAL MACHINE")
	("VISIDOC" :value "VISIDOC" :documentation 
	 	"VISIDOC")
	("VT100" :value "VT100" :documentation 
	 	"VT100 TERMINAL EMULATOR")
	("WINDOW DEBUGGR" :value "WINDOW_DEBUGGER" :documentation 
	 	"WINDOW DEBUGGER")
	("WINDOW SYSTEM" :value "WINDOW_SYSTEM" :documentation 
	 	"WINDOW SYSTEM")
	("ZMACS" :value "ZMACS" :documentation 
	 	"ZMACS EDITOR")
	("ZMAIL" :value "ZMAIL" :documentation 
	 	"ZMAIL")
	)
  "An item-list for the various Explorer Software systems'")
))
