;;; -*- Mode: Common-Lisp; Package: User; Base: 10.; Patch-File: T -*-

;;; Reason: Added new 4S categories for update-bug

;;;                           RESTRICTED RIGHTS LEGEND
;;;
;;; Use, duplication, or disclosure by the Government is subject to
;;; restrictions as set forth in subdivision (c)(1)(ii) of the Rights in
;;; Technical Data and Computer Software clause at 52.227-7013.
;;;
;;;   TEXAS INSTRUMENTS INCORPORATED      
;;;   P.O. BOX 2909, M/S 2151             
;;;   AUSTIN, TEXAS 78769                 
;;;
;;; Copyright (C) 1988 Texas Instruments Incorporated.
;;; All rights reserved.

;;; Written 01/27/89 09:28:27 by SILLS,
;;; while running on URSA from band LODC
;;; With Experimental SYSTEM 6.0, Experimental VIRTUAL-MEMORY 6.0, Experimental EH 6.0,
;;;  Experimental MAKE-SYSTEM 6.0, Experimental MICRONET 6.0, Experimental LOCAL-FILE 6.0,
;;;  Experimental BASIC-PATHNAME 6.0, Experimental NETWORK-SUPPORT-COLD 6.0, Experimental BASIC-NAMESPACE 6.0,
;;;  Experimental NETWORK-NAMESPACE 6.0, Experimental DISK-IO 6.0, Experimental DISK-LABEL 6.0,
;;;  Experimental BASIC-FILE 6.0, Experimental MAC-PATHNAME 6.0, Experimental NETWORK-PATHNAME 6.0,
;;;  Experimental COMPILER 6.0, Experimental TV 6.0, Experimental DATALINK 6.0, Experimental CHAOSNET 6.0,
;;;  Experimental GC 6.0, Experimental MEMORY-AUX 6.0, Experimental NVRAM 6.0, Experimental SYSLOG 6.0,
;;;  Experimental STREAMER-TAPE 6.0, Experimental CLEH 1.0, Experimental UCL 6.0,
;;;  Experimental INPUT-EDITOR 6.0, Experimental METER 6.0, Experimental ZWEI 6.0,
;;;  Experimental DEBUG-TOOLS 6.0, Experimental NETWORK-SUPPORT 6.0, Experimental NETWORK-SERVICE 6.0,
;;;  DATALINK-DISPLAYS 6.0, Experimental FONT-EDITOR 6.0, Experimental SERIAL 6.0,
;;;  Experimental PRINTER 6.0, Experimental MAC-PRINTER-TYPES 6.0, Experimental PRINTER-TYPES 6.0,
;;;  Experimental IMAGEN 6.0, Experimental SUGGESTIONS 6.0, Experimental MAIL-DAEMON 6.0,
;;;  Experimental MAIL-READER 6.0, Experimental TELNET 6.0, Experimental VT100 6.0,
;;;  Experimental NAMESPACE-EDITOR 6.0, Experimental PROFILE 6.0, VISIDOC 6.0, Experimental TI-CLOS 14.4,
;;;  IP 3.38, Experimental BUG 10.5,  microcode 413, Band Name: Rel 6.0 *A

#!C
; From file UPDATE-BUG.LISP#> BUG; PISCES:
#10R USER#:
(COMPILER-LET ((*PACKAGE* (FIND-PACKAGE "USER"))
                          (SI:*LISP-MODE* :COMMON-LISP)
                          (*READTABLE* SYS:COMMON-LISP-READTABLE)
                          (SI:*READER-SYMBOL-SUBSTITUTIONS* SYS::*COMMON-LISP-SYMBOL-SUBSTITUTIONS*))
  (COMPILER#:PATCH-SOURCE-FILE "BUG: BUG; UPDATE-BUG.#"


(DEFPARAMETER systems-list
      '(
	("BUILD" :value "BUILD" :documentation
	 	"BUILD PROCEDURES")
	("BUGS" :value "BUGS" :documentation
	 	"SPR SYSTEM")
        ("CHAOSNET" :value "CHAOSNET" :documentation 
	 	"CHAOSNET")
	("CLOS" :value "CLOS" :documentation 
	 	"COMMON LISP")
	("CLEH" :value "CLEH" :documentation 
	 	"COMMON LISP ERROR HANDLER")
	("CLX" :value "CLX" :documentation 
	 	"COMMON LISP INTERFACE TO X-WINDOWS")
	("CLUE" :value "CLUE" :documentation 
	 	"COMMON LISP USER ENVIRONMENT")
	("CM" :value "CM" :documentation 
	 	"CONFIGURATION MANAGEMENT")
	("COLOR GRAPHICS" :value "COLOR_GRAPHICS" :documentation 
	 	"COLOR GARPHICS")
	("COMPILER" :value "COMPILER" :documentation
	 	"COMPILER")
	("CONVERSE" :value "CONVERSE" :documentation
	 	"CONVERSE MAIL")
	("DEBUGGER" :value "DEGUGGER" :documentation
		"DEBUGGER UTILITY")
	("DIAGNOSTICS" :value "DIAGNOSTICS" :documentation
	 	"DIAGNOSTICS")
	("DUPLICATE" :value "DUPLICATE" :documentation
		"DUPLICATE SPR REPORT")
	("ERROR HANDLER" :value "ERROR_HANDLER" :documentation
	 	"ERROR HANDLER")
	("FILE SERVER" :value "FILE_SERVER" :documentation
	 	"FILE SERVER")
	("FILE SYSTEM" :value "FILE_SYSTEM" :documentation 
	 	"FILE SYSTEM")
	("FINDER" :value "FINDER" :documentation
                "FINDER")
	("FONT EDITOR" :value "FONT_EDITOR" :documentation 
	 	"FONT EDITOR")
	("FORMATTER" :value "FORMATTER" :documentation 
	 	"FORMATTER")
	("GENASYS" :value "GENASYS" :documentation 
	 	"GENASYS")
	("GRAPHICS EDITOR" :value "GRAPHICS_EDITOR" :documentation 
	 	"GRAPHICS EDITOR")
	("GRAPHICS WINDOW" :value "GRAPHICS_WINDOW" :documentation 
	 	"GRAPHICS WINDOW SYSTEM")
	("GLOSSARY" :value "GLOSSARY" :documentation 
	 	"GLOSSARY")
	("GRASPER" :value "GRASPER" :documentation 
	 	"GRASPER")
	("HARDWARE" :value "HARDWARE" :documentation 
	 	"FOR HARDWARE BUGS")
	("INPUT EDITOR" :value "INPUT_EDITOR" :documentation 
	 	"INPUT EDITOR")
	("INPUT/OUTPUT" :value "INPUT_OUTPUT" :documentation 
	 	"INPUT/OUTPUT")
	("INSPECTOR" :value "INSPECTOR" :documentation 
	 	"INSPECTOR")
	("INTEGRATION TEST" :value "INTEGRATION_TEST" :documentation 
	 	"INTEGRATION TEST")
	("KERNEL" :value "KERNEL" :documentation 
	 	"KERNEL")
	("LX" :value "LX" :documentation 
	 	"LISP/UNIX")
	("MAC MX" :value "MACMX" :documentation
                "C code for the Macintosh to run microExplorer")
	("MAIL" :value "MAIL" :documentation 
	 	"MAIL SYSTEM")
	("MAILER" :value "MAILER" :documentation 
	 	"MAILER OF MAIL SYSTEM")
	("MAKE SYSTEM" :value "MAKE_SYSTEM" :documentation 
	 	"MAKE SYSTEM, DEFSYSTEM")
	("MANUALS" :value "MANUALS" :documentation 
	 	"MANUALS")
        ("MASS" :value "MASS" :documentation 
	 	"MASS")
	("MEMORY MANAGEMENT" :value "MEMORY_MGT" :documentation 
	 	"GARBAGE COLLECTION, MEMORY MANAGEMENT")
	("MICROCODE" :value "MICROCODE" :documentation 
	 	"MICROCODE")
	("MISC" :value "MISC" :documentation 
	 	"MISCELLANEOUS")
	("MX" :value "MX" :documentation 
	 	"microExplorer")
	("MX-WINDOW" :value "MX_WINDOW" :documentation
                "microExplorer window system")
	("NAMESPACE" :value "NAMESPACE" :documentation 
	 	"NAMESPACE")
	("NETWORK" :value "NETWORK" :documentation 
	 	"NETWORKING SOFTWARE")
	("NEW USER" :value "NEW_USER" :documentation 
	 	"NEW USER UTILITY")
	("NLMENU" :value "NLMENU" :documentation 
	 	"NATURAL LANGUAGE MENU")
	("NFS" :value "NFS" :documentation 
	 	"NETWORK FILE SYSTEM")
	("NVRAM" :value "NVRAM" :documentation 
	 	"FOR REPORT LAST SHUTDOWN ETC...")
	("PATCH" :value "PATCH" :documentation 
	 	"PATCH CONTROL")
	("PEEK" :value "PEEK" :documentation 
	 	"DEBUG PEEK")
	("PERFORMANCE" :value "PERFORMANCE" :documentation 
	 	"PERFORMANCE")
	("PORTS" :value "PORTS" :documentation 
	 	"PORTS")
	("PRINTER" :value "PRINTER" :documentation 
	 	"PRINTER")
	("PRINT SERVER" :value "PRINT_SERVER" :documentation 
	 	"PRINT SERVER")
	("PROFILE" :value "PROFILE" :documentation 
	 	"USER PROFILE UTILITY")
	("PROLOG" :value "PROLOG" :documentation 
	 	"PROLOG")
	("RPC"  :value "RPC" :documentation 
                "REMOTE PROCEDURE CALL")
	("RTMS" :value "RTMS" :documentation 
	 	"RELATIONAL TABLE MANAGEMENT SYSTEM")
	("SNA1" :value "SNA1" :documentation 
	 	"SYSTEM NETWORK ARCHITECTURE 1")
	("SNA2" :value "SNA2" :documentation 
	 	"SYSTEM NETWORK ARCHITECTURE 2")
        ("SST" :value "SST" :documentation 
	 	"Symbolic Spreadsheet Toolkit")
	("STEPPER" :value "STEPPER" :documentation 
	 	"DEBUG STEPPER")
	("STREAMS" :value "STREAMS" :documentation 
	 	"I/O STREAMS")
	("SUGGESTIONS" :value "SUGGESTIONS" :documentation 
	 	"SUGGESTIONS MODE")
	("SYSTEM TEST" :value "SYSTEM_TEST" :documentation 
	 	"SYSTEM TEST")
	("TAPE" :value "TAPE" :documentation 
	 	"TAPE")
	("TCP/IP" :value "TCP_IP" :documentation 
	 	"TCP/IP")
	("TELNET" :value "TELNET" :documentation 
	 	"TELNET")
	("TOOLS" :value "TOOLS" :documentation 
	 	"TOOLS")
	("TREE EDITOR" :value "TREE_EDITOR" :documentation 
	 	"TREE EDITOR")
	("TEST BRIDGE" :value "TESTBRIDGE")
	("TEST VIEW" :value "TESTVIEW")
        ("TEST BENCH" :value "TESTBENCH")
	("TEST BUILDER" :value "TESTBUILDER")
	("UCL" :value "UCL" :documentation 
	 	"UNIVERSAL COMMAND LOOP")
	("UNASSIGNED" :value "UNASSIGNED" :documentation 
	 	"UNASSIGNED")
	("USERIF" :value "USERIF" :documentation 
	 	"USER INTERFACE - CONSISTENCY")
	("VIRTUAL MACHINE" :value "VIRTUAL_MACHINE" :documentation 
	 	"VIRTUAL MACHINE")
	("VISIDOC" :value "VISIDOC" :documentation 
	 	"VISIDOC")
	("VT100" :value "VT100" :documentation 
	 	"VT100 TERMINAL EMULATOR")
	("WINDOW DEBUGGR" :value "WINDOW_DEBUGGER" :documentation 
	 	"WINDOW DEBUGGER")
	("WINDOW SYSTEM" :value "WINDOW_SYSTEM" :documentation 
	 	"WINDOW SYSTEM")
	("X WINDOWS" :value "X_WINDOWS" :documentation 
	 	"X WINDOW SYSTEM")
	("X SERVER" :value "X_SERVER" :documentation 
	 	"X WINDOW SYSTEM SERVER")
	("ZMACS" :value "ZMACS" :documentation 
	 	"ZMACS EDITOR")
	("ZMAIL" :value "ZMAIL" :documentation 
	 	"ZMAIL")
	)
  "An item-list for the various Explorer Software systems'")
))

#!C
; From file DEFSYSTEM.LISP#> BUG; PISCES:
#10R USER#:
(COMPILER-LET ((*PACKAGE* (FIND-PACKAGE "USER"))
                          (SI:*LISP-MODE* :COMMON-LISP)
                          (*READTABLE* SYS:COMMON-LISP-READTABLE)
                          (SI:*READER-SYMBOL-SUBSTITUTIONS* SYS::*COMMON-LISP-SYMBOL-SUBSTITUTIONS*))
  (COMPILER#:PATCH-SOURCE-FILE "BUG: BUG; DEFSYSTEM.#"


(DEFSYSTEM BUG
  (:NAME "Explorer Bug System")
  (:short-name "BUG")
  (:PATHNAME-DEFAULT "BUG:BUG;")
  (:warnings-pathname-default "sys:cwarns;bug.lisp")
  (:patchable "BUG:PATCH.BUG;" PATCH)
  (:MODULE u-bug "update-bug")
  (:MODULE s-protect  "soft-protect")
  (:MODULE q-spr "query-spr")
  (:COMPILE-LOAD u-bug)
  (:COMPILE-LOAD s-protect)
  (:COMPILE-LOAD q-spr))
))
