;;; -*- Mode: Common-Lisp; Package: User; Base: 10.; Patch-File: T -*-

;;; Reason: Added #\m-c-shift-s keystroke to retrieve extra data file for SPR's.
;;; This file is used to archive additional info, comments, or whatever.

;;;                           RESTRICTED RIGHTS LEGEND
;;;
;;; Use, duplication, or disclosure by the Government is subject to
;;; restrictions as set forth in subdivision (c)(1)(ii) of the Rights in
;;; Technical Data and Computer Software clause at 52.227-7013.
;;;
;;;   TEXAS INSTRUMENTS INCORPORATED      
;;;   P.O. BOX 2909, M/S 2151             
;;;   AUSTIN, TEXAS 78769                 
;;;
;;; Copyright (C) 1989 Texas Instruments Incorporated.
;;; All rights reserved.

;;; Written 03/28/89 09:24:32 by MARKY,
;;; while running on LIBRA from band LODA
;;; With Experimental SYSTEM 6.0, Experimental VIRTUAL-MEMORY 6.0, Experimental EH 6.0,
;;;  Experimental MAKE-SYSTEM 6.0, Experimental MICRONET 6.0, Experimental LOCAL-FILE 6.0,
;;;  Experimental BASIC-PATHNAME 6.0, Experimental NETWORK-SUPPORT-COLD 6.0, Experimental BASIC-NAMESPACE 6.0,
;;;  Experimental NETWORK-NAMESPACE 6.0, Experimental DISK-IO 6.0, Experimental DISK-LABEL 6.0,
;;;  Experimental BASIC-FILE 6.0, Experimental MAC-PATHNAME 6.0, Experimental NETWORK-PATHNAME 6.0,
;;;  Experimental COMPILER 6.0, Experimental TV 6.0, Experimental DATALINK 6.0, Experimental CHAOSNET 6.0,
;;;  Experimental GC 6.0, Experimental MEMORY-AUX 6.0, Experimental NVRAM 6.0, Experimental SYSLOG 6.0,
;;;  Experimental STREAMER-TAPE 6.0, Experimental CLEH 1.0, Experimental UCL 6.0,
;;;  Experimental INPUT-EDITOR 6.0, Experimental METER 6.0, Experimental ZWEI 6.0,
;;;  Experimental DEBUG-TOOLS 6.0, Experimental NETWORK-SUPPORT 6.0, Experimental NETWORK-SERVICE 6.0,
;;;  Experimental DATALINK-DISPLAYS 6.0, Experimental FONT-EDITOR 6.0, Experimental SERIAL 6.0,
;;;  Experimental PRINTER 6.0, Experimental MAC-PRINTER-TYPES 6.0, Experimental PRINTER-TYPES 6.0,
;;;  Experimental IMAGEN 6.0, Experimental SUGGESTIONS 6.0, Experimental MAIL-DAEMON 6.0,
;;;  Experimental MAIL-READER 6.0, Experimental TELNET 6.0, Experimental VT100 6.0,
;;;  Experimental NAMESPACE-EDITOR 6.0, Experimental PROFILE 6.0, Experimental VISIDOC 6.0,
;;;  Experimental BUG 11.3, IP 3.42, Experimental TI-CLOS 14.36, Experimental CLX 3.0,
;;;  Experimental X11M 1.57, Experimental CLUE 16.0, Experimental RPC 6.0, NFS 3.5,
;;;   microcode 416, Band Name: Release 6.0 2/16

;;; by may. code-read ls

#!C
; From file UPDATE-BUG.LISP#> BUG; SYS:
#10R USER#:
(COMPILER-LET ((*PACKAGE* (FIND-PACKAGE "USER"))
                          (SI:*LISP-MODE* :COMMON-LISP)
                          (*READTABLE* SYS:COMMON-LISP-READTABLE)
                          (SI:*READER-SYMBOL-SUBSTITUTIONS* SYS::*COMMON-LISP-SYMBOL-SUBSTITUTIONS*))
  (COMPILER#:PATCH-SOURCE-FILE "SYS: BUG; UPDATE-BUG.#"



;; may 03/28/89 Added function below
(DEFUN bug-info-filename (spr-number)
  "Returns the filename where extra info that does not
fit into bug report should be stored."
  (FORMAT nil "v:spr$device:[data.Bug_info]P~d.dat" spr-number))

;; may 03/28/89 Added function below
(DEFUN zwei:find-spr-info (&optional (spr-number nil))
  "Find File that is used to store extra info for SPR SPR-NUMBER."
  (OR spr-number
      (SETQ spr-number (IF (> zwei:*numeric-arg* 1)
			   zwei:*numeric-arg*
			   (zwei:TYPEIN-LINE-READLINE "Enter SPR number for info file:" spr-number))))
  (zwei:FIND-FILE (PATHNAME (bug-info-filename spr-number)))
  (zwei:MAYBE-DISPLAY-DIRECTORY :READ)
  zwei:DIS-TEXT)

(zwei:bind-key #\c-m-\s 'zwei:find-spr-info) ;; may 03/28/89 
  
))
