;;; -*- Mode: Common-Lisp; Package: chaos; Base: 10.; Patch-File: T -*-

;;; Reason: The function File-server-direct-output was missing from source.

;;;                           RESTRICTED RIGHTS LEGEND
;;;
;;; Use, duplication, or disclosure by the Government is subject to
;;; restrictions as set forth in subdivision (c)(1)(ii) of the Rights in
;;; Technical Data and Computer Software clause at 52.227-7013.
;;;
;;;   TEXAS INSTRUMENTS INCORPORATED      
;;;   P.O. BOX 2909, M/S 2151             
;;;   AUSTIN, TEXAS 78769                 
;;;
;;; Copyright (C) 1989 Texas Instruments Incorporated.
;;; All rights reserved.

;;; Patch file for CHAOSNET version 6.4
;;; Written 11/01/89 13:27:26 by BERGER,
;;; while running on ARIES from band LODX
;;; With SYSTEM 6.23, VIRTUAL-MEMORY 6.2, EH 6.5, MAKE-SYSTEM 6.2, MICRONET 6.0, LOCAL-FILE 6.1,
;;;  BASIC-PATHNAME 6.2, NETWORK-SUPPORT-COLD 6.2, BASIC-NAMESPACE 6.6, NETWORK-NAMESPACE 6.0,
;;;  DISK-IO 6.1, DISK-LABEL 6.0, BASIC-FILE 6.5, MAC-PATHNAME 6.0, NETWORK-PATHNAME 6.0,
;;;  COMPILER 6.14, TV 6.18, DATALINK 6.0, CHAOSNET 6.1, GC 6.3, MEMORY-AUX 6.0, NVRAM 6.2,
;;;  SYSLOG 6.2, STREAMER-TAPE 6.4, UCL 6.0, INPUT-EDITOR 6.0, METER 6.1, ZWEI 6.8,
;;;  DEBUG-TOOLS 6.3, NETWORK-SUPPORT 6.0, NETWORK-SERVICE 6.2, DATALINK-DISPLAYS 6.0,
;;;  FONT-EDITOR 6.1, SERIAL 6.0, PRINTER 6.3, MAC-PRINTER-TYPES 6.1, PRINTER-TYPES 6.2,
;;;  IMAGEN 6.1, SUGGESTIONS 6.1, MAIL-DAEMON 6.3, MAIL-READER 6.5, TELNET 6.0, VT100 6.0,
;;;  NAMESPACE-EDITOR 6.4, PROFILE 6.2, VISIDOC 6.5, TI-CLOS 6.26, CLEH 6.5, IP 3.55,
;;;  Experimental CLX 6.6, CLUE 6.27, X11M 6.15, Experimental BUG 11.15,  microcode 429,
;;;  Band Name: rel6.0 10/23

#!C
; From file QFILE-SERVER.LISP#> CHAOSNET; SYS:
#10R FILE-SYSTEM#:
(COMPILER-LET ((*PACKAGE* (FIND-PACKAGE "FILE-SYSTEM"))
                          (SI:*LISP-MODE* :COMMON-LISP)
                          (*READTABLE* COMMON-LISP-READTABLE)
                          (SI:*READER-SYMBOL-SUBSTITUTIONS* SYS::*COMMON-LISP-SYMBOL-SUBSTITUTIONS*))
  (COMPILER#:PATCH-SOURCE-FILE "SYS: CHAOSNET; QFILE-SERVER.#"


(defun file-server-direct-output (fh direct-file-id &optional BIND? filepos &rest ignore)	; 09-02-87 DAB IO Support
  (let ((losep
	  (catch 'open-opt-lost
	    (progn
	      (if (null fh)
		  (open-err "ICO F Inconsistent file direction for File IO direct output")
		  ;; FHN given. must be real read or write.
		  (let* ((comdata (get fh server-instance))
			 (type (server-dataproc-comm-iotype comdata))
			 )
		    (if (null comdata)
			(open-err "UFH F No open data channel for this file handle: " fh))
		    (unless (eq type 'output)
		      (open-err "ICO F File handle type inconsistent with open mode"))
		    ))
	      
	      (let ((opening (find-symbol direct-file-id)))
		(unless opening
		  (open-err "IPS F Bad filename syntax: " opening))
		(when filepos
		  (funcall (symbol-value opening) :set-pointer filepos))
		(format conn-stream "~A ~A DIRECT-OUTPUT" tid (or fh ""))
		(let ((servi (get fh server-instance)))
		  (if BIND?
		      (progn
			(push opening server-openings)
			(setf (server-dataproc-comm-binp servi) (not (funcall (symbol-value opening) :characters)))
			(setf (server-dataproc-comm-tid servi) tid)
			(setf (server-dataproc-comm-opening servi) (symbol-value opening))
			(rplaca (server-dataproc-comm-cell servi) 'write))
		      (rplaca (server-dataproc-comm-cell servi) 'wsync)
		      )
		  )))
	    ())))
    (if losep (format conn-stream "~A ~A ERROR ~A" tid (or fh "") losep)))    
  )
))
