;;; -*- Mode: Common-Lisp; Package: FS; Base: 10.; Patch-File: T -*-

;;; Reason: Fixed a problem in change-props-1 introduced by Chaos patch 6-3. Server will see "file server got an error, method :pathname Unclaimed" error. [10778]

;;;                           RESTRICTED RIGHTS LEGEND
;;;
;;; Use, duplication, or disclosure by the Government is subject to
;;; restrictions as set forth in subdivision (c)(1)(ii) of the Rights in
;;; Technical Data and Computer Software clause at 52.227-7013.
;;;
;;;   TEXAS INSTRUMENTS INCORPORATED      
;;;   P.O. BOX 2909, M/S 2151             
;;;   AUSTIN, TEXAS 78769                 
;;;
;;; Copyright (C) 1989 Texas Instruments Incorporated.
;;; All rights reserved.

;;; Patch file for CHAOSNET version 6.5
;;; Written 11/13/89 07:41:29 by BERGER,
;;; while running on ARIES from band LODX
;;; With SYSTEM 6.23, VIRTUAL-MEMORY 6.2, EH 6.5, MAKE-SYSTEM 6.2, MICRONET 6.0, LOCAL-FILE 6.1,
;;;  BASIC-PATHNAME 6.2, NETWORK-SUPPORT-COLD 6.2, BASIC-NAMESPACE 6.6, NETWORK-NAMESPACE 6.0,
;;;  DISK-IO 6.1, DISK-LABEL 6.0, BASIC-FILE 6.5, MAC-PATHNAME 6.0, NETWORK-PATHNAME 6.0,
;;;  COMPILER 6.14, TV 6.18, DATALINK 6.0, CHAOSNET 6.1, GC 6.3, MEMORY-AUX 6.0, NVRAM 6.2,
;;;  SYSLOG 6.2, STREAMER-TAPE 6.4, UCL 6.0, INPUT-EDITOR 6.0, METER 6.1, ZWEI 6.8,
;;;  DEBUG-TOOLS 6.3, NETWORK-SUPPORT 6.0, NETWORK-SERVICE 6.2, DATALINK-DISPLAYS 6.0,
;;;  FONT-EDITOR 6.1, SERIAL 6.0, PRINTER 6.3, MAC-PRINTER-TYPES 6.1, PRINTER-TYPES 6.2,
;;;  IMAGEN 6.1, SUGGESTIONS 6.1, MAIL-DAEMON 6.3, MAIL-READER 6.5, TELNET 6.0, VT100 6.0,
;;;  NAMESPACE-EDITOR 6.4, PROFILE 6.2, VISIDOC 6.5, TI-CLOS 6.26, CLEH 6.5, IP 3.55,
;;;  Experimental CLX 6.6, CLUE 6.27, X11M 6.15, Experimental BUG 11.15, DECNET 1.70,
;;;   microcode 429, Band Name: rel6.0 10/23

#!C
; From file QFILE-SERVER.LISP#> CHAOSNET; SYS:
#10R FILE-SYSTEM#:
(COMPILER-LET ((*PACKAGE* (FIND-PACKAGE "FILE-SYSTEM"))
                          (SI:*LISP-MODE* :COMMON-LISP)
                          (*READTABLE* COMMON-LISP-READTABLE)
                          (SI:*READER-SYMBOL-SUBSTITUTIONS* SYS::*COMMON-LISP-SYMBOL-SUBSTITUTIONS*))
  (COMPILER#:PATCH-SOURCE-FILE "SYS: CHAOSNET; QFILE-SERVER.#"

(defun change-props-1 (actor fh strings)
  (declare (special *mac-nfs-copy-fhandle*  *mac-nfs-copy-creation-date* ))   ; DAB 11-01-89
  (loop with sym for string in strings as spacex =
	(position #\Space (the string (string string)) :test #'char=) unless spacex do
	(format conn-stream "~A ~A ERROR STX F Ill formated property spec: ~A" tid fh string) nconc
	(list* (setq sym (si::intern1 (subseq (string string) 0 spacex)  pkg-keyword-package))
	       (server-convert-known-file-property string (1+ spacex) sym) ())
	into plist finally
	(trap-lossage (error "Change properties")
		      (let ((m (apply actor :change-properties () plist)))
			;; DAB 11-01-89 The following two variables are used in NFS-MX to increase
                        ;; performance. We need to set them here to force
                        ;; the correct creation date on the destination file.
 			(when (mac-host-p (send (send actor :truename) :host))  ; DAB 11-13-89 We only need to do this on MX.
			  (setf *mac-nfs-copy-fhandle*  (send actor :truename))  ; DAB 11-13-89 Actor is already a pathname
			  (setf *mac-nfs-copy-creation-date* (second (member :creation-date plist))))
			
			
			(if (errorp m)
			    (format conn-stream "~A ~A ERROR LOS F ~A" tid fh m)
			    (format conn-stream "~A ~A CHANGE-PROPERTIES" tid fh)))
	  (format conn-stream "~A ~A ERROR SYS F Internal error:~% ~A" tid fh trap-error))))


))
