;;; -*- Mode: Common-Lisp; Package: FS; Base: 10.; Patch-File: T -*-

;;; Reason: Bind *print-length* to nil in (host-unit :command) [5726]

;;;                           RESTRICTED RIGHTS LEGEND
;;;
;;; Use, duplication, or disclosure by the Government is subject to
;;; restrictions as set forth in subdivision (c)(1)(ii) of the Rights in
;;; Technical Data and Computer Software clause at 52.227-7013.
;;;
;;;   TEXAS INSTRUMENTS INCORPORATED      
;;;   P.O. BOX 2909, M/S 2151             
;;;   AUSTIN, TEXAS 78769                 
;;;
;;; Copyright (C) 1989 Texas Instruments Incorporated.
;;; All rights reserved.

;;; Patch file for CHAOSNET version 6.7
;;; Written 05/24/90 07:36:40 by BERGER,
;;; while running on Pasteur from band LOD2
;;; With SYSTEM 6.32, VIRTUAL-MEMORY 6.3, EH 6.7, MAKE-SYSTEM 6.3, MICRONET 6.0, LOCAL-FILE 6.2,
;;;  BASIC-PATHNAME 6.4, NETWORK-SUPPORT-COLD 6.2, BASIC-NAMESPACE 6.7, NETWORK-NAMESPACE 6.1,
;;;  DISK-IO 6.3, DISK-LABEL 6.0, BASIC-FILE 6.11, MAC-PATHNAME 6.0, NETWORK-PATHNAME 6.2,
;;;  COMPILER 6.14, TV 6.25, DATALINK 6.0, CHAOSNET 6.6, GC 6.3, MEMORY-AUX 6.0, NVRAM 6.2,
;;;  SYSLOG 6.2, STREAMER-TAPE 6.6, UCL 6.0, INPUT-EDITOR 6.0, METER 6.1, ZWEI 6.16,
;;;  DEBUG-TOOLS 6.4, NETWORK-SUPPORT 6.1, NETWORK-SERVICE 6.2, DATALINK-DISPLAYS 6.0,
;;;  FONT-EDITOR 6.1, SERIAL 6.0, PRINTER 6.6, MAC-PRINTER-TYPES 6.2, PRINTER-TYPES 6.2,
;;;  IMAGEN 6.1, SUGGESTIONS 6.1, MAIL-DAEMON 6.6, MAIL-READER 6.8, TELNET 6.1, VT100 6.0,
;;;  NAMESPACE-EDITOR 6.4, PROFILE 6.3, VISIDOC 6.7, TI-CLOS 6.46, CLEH 6.5, IP 3.62,
;;;  Experimental CLX 6.11, CLUE 6.104, X11M 6.24, Experimental BUG 11.19,  microcode 648,
;;;  Band Name: rel6.0 1/23

#!C
; From file QFILE.LISP#> CHAOSNET; SYS:
#10R FILE-SYSTEM#:
(COMPILER-LET ((*PACKAGE* (FIND-PACKAGE "FILE-SYSTEM"))
                          (SI:*LISP-MODE* :COMMON-LISP)
                          (*READTABLE* COMMON-LISP-READTABLE)
                          (SI:*READER-SYMBOL-SUBSTITUTIONS* SYS::*COMMON-LISP-SYMBOL-SUBSTITUTIONS*))
  (COMPILER#:PATCH-SOURCE-FILE "SYS: CHAOSNET; QFILE.#"


(defmethod (host-unit :command) (mark-p stream-or-handle simple-p &rest commands &aux handle stream)
  (declare (values pkt success string))
  (when control-connection
    (setq last-use-time (time))
    (cond
      ((stringp stream-or-handle) (setq handle stream-or-handle))
      (stream-or-handle (setq stream stream-or-handle
			      handle (send stream :file-handle))
			(and mark-p (setq mark-p (send stream :direction)))))
    (let ((pkt (chaos:get-pkt)) (transaction-id (file-make-transaction-id simple-p)) success
	  whostate string
	  (*print-length* nil))  ; DAB 05-24-90
      ;; Make up a packet containing the command to be sent over
      (apply #'chaos:set-pkt-string pkt transaction-id " " (or handle "") " " commands)
      (let ((string (chaos:pkt-string pkt))
	    (from 0))
	(setq from
	      (position #\Space (the string (string string)) :start
			(1+ (position #\Space (the string (string string)) :test #'char-equal))
			:test #'char-equal))
	(setq whostate
	      (subseq (string string) (1+ from) (string-search-set '(#\Space #\Newline) string (1+ from))) )
	;; Make the whostate look pretty.
	(do ((i 1 (1+ i))
	     (len (length whostate)))
	    ((= i len))
	  (setf (aref whostate i) (char-downcase (aref whostate i)))))
      (chaos:send-pkt control-connection pkt %file-command-opcode)
      (and (eq mark-p :output) (send stream :write-synchronous-mark))
      ;; Get the portion of the response after the transaction ID.
      (cond
	(simple-p (and (eq mark-p :input) (send stream :read-until-synchronous-mark))
		  (values () t ""))
	((setq pkt (file-wait-for-transaction transaction-id control-connection whostate))
	 (setq string
	       (nsubstring (chaos:pkt-string pkt)
			   (1+
			     (position #\Space (the string (string (chaos:pkt-string pkt))) :test
				       #'char-equal))))
	 (setq success
	       (let ((from
		       (if handle
			   (file-check-handle handle string)
			   (1+ (string-search-set '(#\Space #\Newline) string)))))
		 (not
		   (string-equal "ERROR" string :start2 from :end1 5 :end2
				 (string-search-set '(#\Space #\Newline) string from)))))
	 (and success (eq mark-p :input) (send stream :read-until-synchronous-mark))
	 (values pkt success string))))))
))
