;;; -*- Mode: Common-Lisp; Package: sys; Base: 10.; Patch-File: T -*-

;;; Reason: Bind *read-base* to 10 in Receive-band.

;;;                           RESTRICTED RIGHTS LEGEND
;;;
;;; Use, duplication, or disclosure by the Government is subject to
;;; restrictions as set forth in subdivision (c)(1)(ii) of the Rights in
;;; Technical Data and Computer Software clause at 52.227-7013.
;;;
;;;   TEXAS INSTRUMENTS INCORPORATED      
;;;   P.O. BOX 2909, M/S 2151             
;;;   AUSTIN, TEXAS 78769                 
;;;
;;; Copyright (C) 1989 Texas Instruments Incorporated.
;;; All rights reserved.

;;; Patch file for CHAOSNET version 6.8
;;; Written 05/24/90 14:09:03 by BERGER,
;;; while running on Pasteur from band LOD2
;;; With SYSTEM 6.35, VIRTUAL-MEMORY 6.3, EH 6.8, MAKE-SYSTEM 6.3, MICRONET 6.0, LOCAL-FILE 6.2,
;;;  BASIC-PATHNAME 6.4, NETWORK-SUPPORT-COLD 6.2, BASIC-NAMESPACE 6.7, NETWORK-NAMESPACE 6.1,
;;;  DISK-IO 6.3, DISK-LABEL 6.0, BASIC-FILE 6.11, MAC-PATHNAME 6.0, NETWORK-PATHNAME 6.2,
;;;  COMPILER 6.14, TV 6.25, DATALINK 6.0, CHAOSNET 6.7, GC 6.4, MEMORY-AUX 6.0, NVRAM 6.3,
;;;  SYSLOG 6.2, STREAMER-TAPE 6.6, UCL 6.0, INPUT-EDITOR 6.0, METER 6.2, ZWEI 6.17,
;;;  DEBUG-TOOLS 6.4, NETWORK-SUPPORT 6.1, NETWORK-SERVICE 6.2, DATALINK-DISPLAYS 6.0,
;;;  FONT-EDITOR 6.1, SERIAL 6.0, PRINTER 6.6, MAC-PRINTER-TYPES 6.2, PRINTER-TYPES 6.2,
;;;  IMAGEN 6.1, SUGGESTIONS 6.1, MAIL-DAEMON 6.6, MAIL-READER 6.8, TELNET 6.1, VT100 6.0,
;;;  NAMESPACE-EDITOR 6.5, PROFILE 6.3, VISIDOC 6.7, TI-CLOS 6.47, CLEH 6.5, IP 3.62,
;;;  Experimental CLX 6.11, CLUE 6.104, X11M 6.24, Experimental BUG 11.19,  microcode 648,
;;;  Band Name: rel6.0 1/23

#!C
; From file BAND.LISP#> CHAOSNET; sys:
#10R SYSTEM#:
(COMPILER-LET ((*PACKAGE* (FIND-PACKAGE "SYSTEM"))
                          (SI:*LISP-MODE* :COMMON-LISP)
                          (*READTABLE* COMMON-LISP-READTABLE)
                          (SI:*READER-SYMBOL-SUBSTITUTIONS* *COMMON-LISP-SYMBOL-SUBSTITUTIONS*))
  (COMPILER#:PATCH-SOURCE-FILE "SYS: CHAOSNET; BAND.#"


(DEFUN RECEIVE-BAND (FROM-MACHINE FROM-PART TO-UNIT TO-PART
				  &OPTIONAL (SUBSET-START 0) SUBSET-N-BLOCKS
				  &AUX CONN PKT STR REMOTE-PART-SIZE (WINDOW (if (si:mx-p)
										 *mx-receive-band-window-size*
										 *exp-receive-band-window-size* ))
				  FROM-UNIT PART-COMMENT PART-BASE PART-SIZE
				  user-type partition-name-string);03.13.87 DAB
  
  "Read the FROM-PART partition  from FROM-MACHINE into local partition TO-PART.
   If SUBSET-START or SUBSET-N-BLOCKS is specified, they say which part of the partition 
   to transfer.  SUBSET-START and SUBSET-N-BLOCKS are in hundreds of blocks.  If a 
   transfer dies, use the last number it printed  as SUBSET-START, to
   resume where it left off.  FROM-MACHINE is a string consisting of the name of the
   remote machine or the remote machine, colon, remote unit number.  If no unit number
   is specified the default unit of the REMOTE machine is used."
  (SETQ SUBSET-START (* SUBSET-START 100))
  (WHEN SUBSET-N-BLOCKS
	(SETQ SUBSET-N-BLOCKS (* SUBSET-N-BLOCKS 100)))
  (UNWIND-PROTECT
      (PROGN
	(SETQ TO-UNIT (DECODE-UNIT-ARGUMENT TO-UNIT "receive-band"))
	(when (closurep to-unit)   ;03-02-88 DAB Check to make sure it is a local unit.
	  (ferror () "TO-UNIT must be a local unit number."))
	(MULTIPLE-VALUE-SETQ (PART-BASE PART-SIZE NIL to-part nil partition-name-string)  ;03.19.87 DAB      
			     (FIND-DISK-PARTITION-FOR-WRITE TO-PART () TO-UNIT))
	(MULTIPLE-VALUE-SETQ (nil nil nil nil nil from-part) ;12-13-88 DAB
			     (FIND-DISK-PARTITION-FOR-read from-PART () from-machine))
	;; Parse machine and unit number.
	
	(LET ((TEM (POSITION #\: (THE STRING (STRING FROM-MACHINE)) :TEST #'CHAR-EQUAL)))
	  (UNLESS (NULL TEM)
		  (SETQ FROM-UNIT (READ-FROM-STRING FROM-MACHINE () () :START (1+ TEM)))
		  (SETQ FROM-MACHINE (SUBSEQ (STRING FROM-MACHINE) 0 TEM) )))
	
	;; If the partition was found and the user ok'd writing to it . . .
        (setf (values from-part user-type) ;03.13.87 DAB
	      (parse-partition-name from-part :keyword))
	(WHEN PART-BASE	      
	      ;; Connect to remote machine.
	      (SETQ CONN
		    (CHAOS:CONNECT FROM-MACHINE
				   (FORMAT () "BAND-TRANSFER READ ~a ~d ~d ~a ~a ~a" FROM-PART
					   FROM-UNIT 
					   (LIST SUBSET-START
						 (IF SUBSET-N-BLOCKS
						     (MIN SUBSET-N-BLOCKS PART-SIZE)
						     (- PART-SIZE SUBSET-START)))
					   nil nil user-type)   ;03.12.87 DAB
				   WINDOW))
	      
	      ;; Receive packet containing size and comment.
	      
	      (SETQ PKT (CHAOS:GET-NEXT-PKT CONN))
	      
	      ;; Get the data in the form of a string, fetch the partition size, then
	      ;; return the packet.
	      
	      (SETQ STR (CHAOS:PKT-STRING PKT))
	      (SETQ REMOTE-PART-SIZE (LET ((*READ-BASE* 10)  ; DAB 12-06-89Bind *read-base* to 10.
					   (*print-BASE* 10))
				       (READ-FROM-STRING STR T)))
	      (CHAOS:RETURN-PKT PKT)
	      
	      ;; Verify that the local partition is large enough.
	      
	      (WHEN (> REMOTE-PART-SIZE PART-SIZE)
		    (RETURN-FROM RECEIVE-BAND
		      (FORMAT T "~% Does not fit in local partition, ~d > ~d"
			      REMOTE-PART-SIZE PART-SIZE)))
	      
	      ;; Revise partition size to be the actual size, then fetch
	      ;; the partition comment.
	      
	      (SETQ PART-SIZE REMOTE-PART-SIZE)
	      (SETQ PART-COMMENT
		    (READ-FROM-STRING STR () () :START
				      (1+
					(POSITION #\SPACE (THE STRING (STRING STR))
						  :TEST #'CHAR-EQUAL))))
	      
	      ;; Everything looks good.  Let's transfer the partition.
	      
	      (FORMAT T
		      "~& Receiving partition ~s on unit ~d from ~a ~
                   into partition ~s unit ~d:~%  ~d blocks, ~s~%"
		      FROM-PART 
		      (or FROM-UNIT "*DEFAULT-DISK-UNIT*")  ; DAB 05-03-89
		      FROM-MACHINE partition-name-string TO-UNIT PART-SIZE ;03.19.87 DAB
		      PART-COMMENT)
	      
	      ;; Put "Incomplete Copy" into the comment field so that you can
	      ;; tell that the data is incomplete.
	      
	      (UPDATE-PARTITION-COMMENT  partition-name-string "Incomplete Copy" TO-UNIT ) ;03.19.87 DAB 
	      
	      ;; Transfer the data from Chaos to the partition.
	      
	      (PARTITION-NET-TRANSFER TO-UNIT PART-BASE PART-SIZE CONN T () T
				      SUBSET-START SUBSET-N-BLOCKS)
	      
	      ;; Transfer complete, close net connection.
	      
	      (CHAOS::CLOSE-CONN CONN "Done")
	      
	      ;; Set partition comment.
	      
	      (UNLESS SUBSET-N-BLOCKS
		      (UPDATE-PARTITION-COMMENT partition-name-string  PART-COMMENT TO-UNIT ))))
    
    ;; Unwind-protect-forms
    
    (DISPOSE-OF-UNIT TO-UNIT)
    (WHEN CONN
	  (CHAOS:REMOVE-CONN CONN)))
  (RETURN-FROM RECEIVE-BAND
    (IF PART-BASE
	(PROGN
	  (FORMAT T "~%") T)))
  ())
))
