;;; -*- Mode: Common-Lisp; Package: chaos; Base: 10.; Patch-File: T -*-

;;; Reason: Added new function Expand-Connection-table to allow users to expand connection tables.[11261]

;;;                           RESTRICTED RIGHTS LEGEND
;;;
;;; Use, duplication, or disclosure by the Government is subject to
;;; restrictions as set forth in subdivision (c)(1)(ii) of the Rights in
;;; Technical Data and Computer Software clause at 52.227-7013.
;;;
;;;   TEXAS INSTRUMENTS INCORPORATED      
;;;   P.O. BOX 149149, M/S 2151             
;;;   AUSTIN, TEXAS 78714-9149                 
;;;
;;; Copyright (C) 1989 Texas Instruments Incorporated.
;;; All rights reserved.

;;; Written 06/27/90 12:30:50 by BERGER,
;;; while running on ARIES from band LODA
;;; With SYSTEM 6.41, VIRTUAL-MEMORY 6.3, EH 6.8, MAKE-SYSTEM 6.5, MICRONET 6.0, LOCAL-FILE 6.2,
;;;  BASIC-PATHNAME 6.5, NETWORK-SUPPORT-COLD 6.2, BASIC-NAMESPACE 6.8, NETWORK-NAMESPACE 6.1,
;;;  DISK-IO 6.4, DISK-LABEL 6.1, BASIC-FILE 6.14, MAC-PATHNAME 6.0, NETWORK-PATHNAME 6.2,
;;;  COMPILER 6.18, TV 6.32, DATALINK 6.0, CHAOSNET 6.8, GC 6.4, MEMORY-AUX 6.0, NVRAM 6.4,
;;;  SYSLOG 6.2, STREAMER-TAPE 6.6, UCL 6.1, INPUT-EDITOR 6.1, METER 6.2, ZWEI 6.27,
;;;  DEBUG-TOOLS 6.5, NETWORK-SUPPORT 6.1, NETWORK-SERVICE 6.3, DATALINK-DISPLAYS 6.0,
;;;  FONT-EDITOR 6.1, SERIAL 6.0, PRINTER 6.8, MAC-PRINTER-TYPES 6.2, PRINTER-TYPES 6.2,
;;;  IMAGEN 6.1, SUGGESTIONS 6.1, MAIL-DAEMON 6.6, MAIL-READER 6.9, TELNET 6.1, VT100 6.0,
;;;  NAMESPACE-EDITOR 6.6, PROFILE 6.3, VISIDOC 6.7, TI-CLOS 6.53, CLEH 6.5, IP 3.65,
;;;  Experimental BUG 11.19, Experimental CLX 7.0, Experimental CLUE 7.6, X11M 6.32,
;;;   microcode 483, Band Name: Chaos Table kludge

#!C
; From file chaos-ncp.LISP#> CHAOSNET; sys:
#10R CHAOS#:
(lisp:COMPILER-LET ((*PACKAGE* (FIND-PACKAGE "CHAOS"))
                          (SI:*LISP-MODE* :COMMON-LISP)
                          (*READTABLE* COMMON-LISP-READTABLE)
                          (SI:*READER-SYMBOL-SUBSTITUTIONS* SYS::*COMMON-LISP-SYMBOL-SUBSTITUTIONS*))
  (COMPILER#:PATCH-SOURCE-FILE "SYS: CHAOSNET; chaos-ncp.#"

(defun Expand-Connection-table (&optional (expand? T))
  "Expands (or contracts) the CHAOSNET connection table. When EXPAND? is T the table is doubled, when nil the 
   table is decrease to half it current size."
  (declare (special maximum-index MAXIMUM-INDEX-LOG-2-MINUS-1
		    index-conn UNIQUIZER-TABLE  ))
  (let ((amount (if expand? (* maximum-index 2) (max (/ maximum-index 2) 128.))))
    (when (yes-or-no-p "Note:This functions will terminate all existing network connections 
 and the network will be temporarily disabled.
 Expanding the table should only be done when absolutely necessary because it will affect performance.

 ~:[Contracting~;Expanding~] table from ~d to ~d. Are you sure?" expand? maximum-index amount)
      (without-interrupts
	(chaos:reset ())  ; The netwrok must be disabled first.
	(setf maximum-index amount) ;main index used when excessing table.
	(setf MAXIMUM-INDEX-LOG-2-MINUS-1 (1- (HAULONG MAXIMUM-INDEX)))
	(setf index-conn (MAKE-ARRAY MAXIMUM-INDEX :AREA chaos:CHAOS-AREA))
	(setf UNIQUIZER-TABLE  (MAKE-ARRAY MAXIMUM-INDEX :ELEMENT-TYPE
					   '(UNSIGNED-BYTE 16) :AREA chaos:CHAOS-AREA))
	(chaos:reset t))))) ;Turn on the network


))
