;;; -*- Mode: Common-Lisp; Package: User; Base: 10.; Patch-File: T -*-
;;; Written 06/12/89 14:48:43 by MCCREARY,
;;; Reason: Fixed DEFINE-CONDITION so that more than one parent-type is accepted.
;;; while running on Jules-Verne from band LOD9
;;; With SYSTEM 6.5, VIRTUAL-MEMORY 6.1, EH 6.1, MAKE-SYSTEM 6.0, MICRONET 6.0, LOCAL-FILE 6.0,
;;;  BASIC-PATHNAME 6.0, NETWORK-SUPPORT-COLD 6.0, BASIC-NAMESPACE 6.0, NETWORK-NAMESPACE 6.0,
;;;  DISK-IO 6.0, DISK-LABEL 6.0, BASIC-FILE 6.1, MAC-PATHNAME 6.0, NETWORK-PATHNAME 6.0,
;;;  COMPILER 6.2, TV 6.6, DATALINK 6.0, CHAOSNET 6.0, GC 6.2, MEMORY-AUX 6.0, NVRAM 6.0,
;;;  SYSLOG 6.0, STREAMER-TAPE 6.1, UCL 6.0, INPUT-EDITOR 6.0, METER 6.0, ZWEI 6.0,
;;;  DEBUG-TOOLS 6.0, NETWORK-SUPPORT 6.0, NETWORK-SERVICE 6.0, DATALINK-DISPLAYS 6.0,
;;;  FONT-EDITOR 6.1, SERIAL 6.0, PRINTER 6.1, MAC-PRINTER-TYPES 6.1, PRINTER-TYPES 6.0,
;;;  IMAGEN 6.0, SUGGESTIONS 6.0, MAIL-DAEMON 6.2, MAIL-READER 6.0, TELNET 6.0, VT100 6.0,
;;;  NAMESPACE-EDITOR 6.0, PROFILE 6.1, VISIDOC 6.1, TI-CLOS 6.5, CLEH 6.2, IP 3.46,
;;;  Experimental BUG 11.7, Experimental CLX 6.1, CLUE 6.4, X11M 6.1,  microcode 429,
;;;  Band Name: Release 6.0 + SLE 6/5

#!C
; From file CL-CONDITIONS.LISP#> CLEH; MR-X:
#10R CONDITIONS#:
(COMPILER-LET ((*PACKAGE* (FIND-PACKAGE "CONDITIONS"))
                          (SI:*LISP-MODE* :COMMON-LISP)
                          (*READTABLE* SYS:COMMON-LISP-READTABLE)
                          (SI:*READER-SYMBOL-SUBSTITUTIONS* SYS::*COMMON-LISP-SYMBOL-SUBSTITUTIONS*))
  (COMPILER#:PATCH-SOURCE-FILE "SYS: CLEH; CL-CONDITIONS.#"


(DEFMACRO define-condition (name parent-types &optional slot-specs &rest options)
  "DEFINE-CONDITION defines a new condition type called NAME, which is a
subtype of PARENT-TYPES.  Except as otherwise noted, the arguments
are not evaluated.  Objects of condition type, NAME, will have all of the indicated
SLOTS, plus any additional slots that would be available in objects of PARENT-TYPES.
If the SLOTS list is omitted, the empty list is assumed.  Each SLOT-SPEC must 
have the form:
    { :INITARG initarg-name | :INITFORM initform | :READER reader-function-name }

  The valid OPTIONS in DEFINE-CONDITION are:
    (:DOCUMENTATION doc-string)
DOC-STRING should be a string which describes the purpose of the condition type or 
NIL.  If this option is omitted, NIL is assumed.    (DOCUMENTATION name 'TYPE) will 
retrieve this information.
    (:REPORT exp)
The REPORT option defines a function which describes the condition type.  If EXP is a
literal string, it is a shorthand for (LAMBDA (CONDITION STREAM) (WRITE-STRING exp STREAM))
If EXP is not a literal string, it must be a suitable argument to the
special form, FUNCTION.  The expression (FUNCTION exp) will be evaluated
in the current lexical environment.  It should return a function of two
arguments, a condition and a stream, which prints on the stream a
description of the condition.  This function is called whenever the
condition is printed while *PRINT-ESCAPE* is NIL.
  The :REPORT option is processed after the new condition type has been
defined, so use of the slot reader functions within the report function is
permitted.  If this option is not specified, information about how to
report this type of condition will be inherited from the PARENT-TYPE."
  ;; 05/08/89 clm - redefined so that this now uses CLOS.
  ;; 06/12/89 clm - fixed so that more than one parent-type is accepted [spr 10034].
  (LET (class-options
	report-function )
    (DO ((o options (CDR o)))
	((NULL o))
      (LET ((option (CAR o)))
	(CASE (CAR option)
	  (:documentation (setq class-options (list option)))
	  
	  (:REPORT (SETQ report-function (IF (STRINGP (CADR option))
					     `(LAMBDA (condition stream)
						(DECLARE (IGNORE condition))
						(WRITE-STRING ,(CADR option) stream))
					     (CADR option))))
	  )))
    ;; Finally, the expansion ...
    (IF report-function (SETF (report-function name) `#',report-function))
    (push (list :metaclass 'ticlos:flavor-class) class-options)
    `(PROGN 
	    (TICLOS:DEFCLASS ,name
		     ,parent-types
		      ,slot-specs
	      ,@class-options)
	    ,(IF report-function
		 `(ticlos:DEFMETHOD ticlos:print-object ((X ,name) report-stream)
		    (if *print-escape*
			(ticlos:call-next-method)
			(,report-function X report-stream))
		    X
		    )))))
))
