;;; -*- Mode:Common-Lisp; Package:System; Base:10; Patch-file:T -*-

;;; Reason: Fix (SETF (DOCUMENTATION object) value).  [SPR 10089]


;;;                           RESTRICTED RIGHTS LEGEND
;;;
;;; Use, duplication, or disclosure by the Government is subject to
;;; restrictions as set forth in subdivision (c)(1)(ii) of the Rights in
;;; Technical Data and Computer Software clause at 52.227-7013.
;;;
;;;   TEXAS INSTRUMENTS INCORPORATED      
;;;   P.O. BOX 2909, M/S 2151             
;;;   AUSTIN, TEXAS 78769                 
;;;
;;; Copyright (C) 1989 Texas Instruments Incorporated.
;;; All rights reserved.

;;; Patch file for TI-CLOS version 6.14
;;; Written 07/05/89 19:51:28 by GRAY,
;;; while running on Kelvin from band LOD2
;;; With SYSTEM 6.10, VIRTUAL-MEMORY 6.1, EH 6.3, MAKE-SYSTEM 6.0, MICRONET 6.0, LOCAL-FILE 6.0,
;;;  BASIC-PATHNAME 6.0, NETWORK-SUPPORT-COLD 6.0, BASIC-NAMESPACE 6.1, NETWORK-NAMESPACE 6.0,
;;;  DISK-IO 6.0, DISK-LABEL 6.0, BASIC-FILE 6.2, MAC-PATHNAME 6.0, NETWORK-PATHNAME 6.0,
;;;  Inconsistent COMPILER 6.7, TV 6.12, DATALINK 6.0, CHAOSNET 6.0, GC 6.3, MEMORY-AUX 6.0,
;;;  NVRAM 6.1, SYSLOG 6.1, STREAMER-TAPE 6.3, UCL 6.0, INPUT-EDITOR 6.0, Inconsistent METER 6.1,
;;;  ZWEI 6.3, DEBUG-TOOLS 6.3, NETWORK-SUPPORT 6.0, NETWORK-SERVICE 6.1, DATALINK-DISPLAYS 6.0,
;;;  FONT-EDITOR 6.1, SERIAL 6.0, PRINTER 6.2, MAC-PRINTER-TYPES 6.1, PRINTER-TYPES 6.0,
;;;  IMAGEN 6.0, SUGGESTIONS 6.0, MAIL-DAEMON 6.2, MAIL-READER 6.0, TELNET 6.0, VT100 6.0,
;;;  NAMESPACE-EDITOR 6.0, PROFILE 6.1, VISIDOC 6.2, Inconsistent TI-CLOS 6.13, CLEH 6.4,
;;;  IP 3.47, Experimental BUG 11.10, Experimental CLX 6.2, CLUE 6.6, X11M 6.1, Experimental DOCUMENTER 619.0,
;;;  Experimental GRAPHICS-WINDOW 6.0, Inconsistent GED 6.2,  microcode 429, Band Name: 6.0 SLE 6/5 + u429 6/8

;;; BUG REPORT NUMBER:  10089
;;;
;;; PROBLEM:  (SETF DOCUMENTATION) does not work for a class.  The code:
;;;      
;;;	 (defclass class1 () ())
;;;	 (setf (documenation (find-class 'class1)) "New Documentation")
;;;      
;;;    gets the error:
;;;      
;;;	 A second argument, FUNCTION, was supplied in a call to (SETF
;;;        DOCUMENTATION) of a class object.
;;;      
;;;	 While in (METHOD (SETF DOCUMENTATION) (T STANDARD-CLASS))
;;;		Arg 0 (NEW-VALUE): "New Documentation"
;;;		Arg 1 (DOBJ):      #<STANDARD-CLASS CLASS1>
;;;		Arg 2 (DOC-TYPE):  FUNCTION
;;;
;;; SOLUTION:  Fixed function SYS:SET-DOCUMENTATION to not pass a third 
;;;	argument when it did not receive one.

#!C
; From file DESCRIBE.LISP#> CLOS; MR-X:
#10R SYSTEM#:
(COMPILER-LET ((*PACKAGE* (FIND-PACKAGE "SYSTEM"))
                          (SI:*LISP-MODE* :COMMON-LISP)
                          (*READTABLE* COMMON-LISP-READTABLE)
                          (SI:*READER-SYMBOL-SUBSTITUTIONS* *COMMON-LISP-SYMBOL-SUBSTITUTIONS*))
  (COMPILER#:PATCH-SOURCE-FILE "SYS: CLOS; DESCRIBE.#"


;; DNG 07/05/89 - Fixed to call (SETF DOCUMENTATION) with the same number of 
;;		arguments as received.  [SPR 10089]
(defun set-documentation (symbol type-or-value &optional (value nil value-supplied))
  (if value-supplied
      (funcall #'(setf documentation) value symbol type-or-value)
    (funcall #'(setf documentation) type-or-value symbol)))
))
