;;; -*- Mode:Common-Lisp; Package:TICLOS; Base:10; Patch-file:T -*-

;;; Reason: Prevent error on message :SUPERS-CHANGED not handled when updating a hybrid 
;;; class that has a flavor as a subclass.  [SPR 10611]

;;;                           RESTRICTED RIGHTS LEGEND
;;;
;;; Use, duplication, or disclosure by the Government is subject to
;;; restrictions as set forth in subdivision (c)(1)(ii) of the Rights in
;;; Technical Data and Computer Software clause at 52.227-7013.
;;;
;;;   TEXAS INSTRUMENTS INCORPORATED      
;;;   P.O. BOX 149149, M/S 2151             
;;;   AUSTIN, TEXAS 78714
;;;
;;; Copyright (C) 1989 Texas Instruments Incorporated.
;;; All rights reserved.

;;; Patch file for TI-CLOS version 6.23
;;; Written 09/21/89 16:44:21 by GRAY,
;;; while running on Kelvin from band LOD2
;;; With SYSTEM 6.15, VIRTUAL-MEMORY 6.1, EH 6.4, MAKE-SYSTEM 6.0, MICRONET 6.0, LOCAL-FILE 6.0,
;;;  BASIC-PATHNAME 6.1, NETWORK-SUPPORT-COLD 6.0, BASIC-NAMESPACE 6.2, NETWORK-NAMESPACE 6.0,
;;;  DISK-IO 6.1, DISK-LABEL 6.0, BASIC-FILE 6.2, MAC-PATHNAME 6.0, NETWORK-PATHNAME 6.0,
;;;  COMPILER 6.10, TV 6.15, DATALINK 6.0, CHAOSNET 6.0, GC 6.3, MEMORY-AUX 6.0, NVRAM 6.1,
;;;  SYSLOG 6.1, STREAMER-TAPE 6.4, UCL 6.0, INPUT-EDITOR 6.0, METER 6.1, ZWEI 6.5,
;;;  DEBUG-TOOLS 6.3, NETWORK-SUPPORT 6.0, NETWORK-SERVICE 6.1, DATALINK-DISPLAYS 6.0,
;;;  FONT-EDITOR 6.1, SERIAL 6.0, PRINTER 6.3, MAC-PRINTER-TYPES 6.1, PRINTER-TYPES 6.1,
;;;  IMAGEN 6.0, SUGGESTIONS 6.0, MAIL-DAEMON 6.2, MAIL-READER 6.2, TELNET 6.0, VT100 6.0,
;;;  NAMESPACE-EDITOR 6.0, PROFILE 6.1, VISIDOC 6.4, Inconsistent TI-CLOS 6.22, CLEH 6.5,
;;;  IP 3.48, Experimental CLX 6.2, CLUE 6.10, X11M 6.13, Experimental BUG 11.15,
;;;  Experimental DOCUMENTER 701.0,  microcode 430, Band Name: 6.0+Scribe,&c,u430 9/6

;;; BUG REPORT NUMBER:  10611
;;;
;;; PROBLEM:  User received error message 
;;;	  >>Error: The object #<FLAVOR-CLASS W-VIEW> received a :SUPERS-CHANGED 
;;;		message, which went unclaimed.
;;;	when re-loading a DEFCLASS for a hybrid class which is included in a DEFFLAVOR.
;;;
;;; SOLUTION:  Add a do-nothing definition for (:METHOD FLAVOR-CLASS :SUPERS-CHANGED).
;;;	It doesn't need to do anything because (METHOD ADD-NAMED-CLASS (HYBRID-CLASS))
;;;	calls SI:DEFFLAVOR1 which takes care of updating the flavors dependencies.
;;;
;;; DEPENDENCIES:  [none]
;;;
;;; CODEREAD:


#!C
; From file FLAVOR-METACLASS.LISP#> SYS6.CLOS; Kelvin:
#10R TICLOS#:
(COMPILER-LET ((*PACKAGE* (FIND-PACKAGE "TICLOS"))
                          (SI:*LISP-MODE* :COMMON-LISP)
                          (*READTABLE* SYS:COMMON-LISP-READTABLE)
                          (SI:*READER-SYMBOL-SUBSTITUTIONS* SYS::*COMMON-LISP-SYMBOL-SUBSTITUTIONS*))
  (COMPILER#:PATCH-SOURCE-FILE "SYS: CLOS; FLAVOR-METACLASS.#"


;; 9/21/89 DNG - Added this method to fix SPR 10611.
;; For flavors, don't need to do anything here because 
;; (METHOD ADD-NAMED-CLASS (HYBRID-CLASS)) calls SI:DEFFLAVOR1 to take care of 
;; updating all associated flavors.
(defmethod (flavor-class :supers-changed) ignore)


))
