;;; -*- Mode: Common-Lisp; Package: TICLOS; Base: 10.; Patch-File: T -*-

;;; Reason: Modified (method print-object ((pobj array) stream)) to check if pobj is a structure array. If so, handle appropriately.[10874]

;;;                           RESTRICTED RIGHTS LEGEND
;;;
;;; Use, duplication, or disclosure by the Government is subject to
;;; restrictions as set forth in subdivision (c)(1)(ii) of the Rights in
;;; Technical Data and Computer Software clause at 52.227-7013.
;;;
;;;   TEXAS INSTRUMENTS INCORPORATED      
;;;   P.O. BOX 2909, M/S 2151             
;;;   AUSTIN, TEXAS 78769                 
;;;
;;; Copyright (C) 1989 Texas Instruments Incorporated.
;;; All rights reserved.

;;; Written 12/28/89 09:15:33 by BERGER,
;;; while running on ARIES from band LOD1
;;; With SYSTEM 6.28, VIRTUAL-MEMORY 6.3, EH 6.5, MAKE-SYSTEM 6.2, MICRONET 6.0, LOCAL-FILE 6.1,
;;;  BASIC-PATHNAME 6.2, NETWORK-SUPPORT-COLD 6.2, BASIC-NAMESPACE 6.7, NETWORK-NAMESPACE 6.1,
;;;  DISK-IO 6.2, DISK-LABEL 6.0, BASIC-FILE 6.7, MAC-PATHNAME 6.0, NETWORK-PATHNAME 6.0,
;;;  COMPILER 6.14, TV 6.22, DATALINK 6.0, CHAOSNET 6.5, GC 6.3, MEMORY-AUX 6.0, NVRAM 6.2,
;;;  SYSLOG 6.2, STREAMER-TAPE 6.5, UCL 6.0, INPUT-EDITOR 6.0, METER 6.1, ZWEI 6.11,
;;;  DEBUG-TOOLS 6.4, NETWORK-SUPPORT 6.1, NETWORK-SERVICE 6.2, DATALINK-DISPLAYS 6.0,
;;;  FONT-EDITOR 6.1, SERIAL 6.0, PRINTER 6.3, MAC-PRINTER-TYPES 6.1, PRINTER-TYPES 6.2,
;;;  IMAGEN 6.1, SUGGESTIONS 6.1, MAIL-DAEMON 6.4, MAIL-READER 6.6, TELNET 6.0, VT100 6.0,
;;;  NAMESPACE-EDITOR 6.4, PROFILE 6.2, VISIDOC 6.7, TI-CLOS 6.26, CLEH 6.5, IP 3.57,
;;;  Experimental CLX 6.8, CLUE 6.41, X11M 6.19, Experimental BUG 11.17,  microcode 475,
;;;  Band Name: REl 6.0 SLE 12/28

#!C
; From file NEW-PRINT-OBJECT.LISP#> CLOS; SYS:
#10R TICLOS#:
(COMPILER-LET ((*PACKAGE* (FIND-PACKAGE "TICLOS"))
                          (SI:*LISP-MODE* :COMMON-LISP)
                          (*READTABLE* SYS:COMMON-LISP-READTABLE)
                          (SI:*READER-SYMBOL-SUBSTITUTIONS* SYS::*COMMON-LISP-SYMBOL-SUBSTITUTIONS*))
  (COMPILER#:PATCH-SOURCE-FILE "SYS: CLOS; NEW-PRINT-OBJECT.#"


(defmethod print-object ((pobj array) stream)
  (declare (special *print-structure*))
  (print-structured-object
    pobj stream
    #'(lambda (pobj stream)
	(if (stringp pobj)
	    (if (<= (array-active-length pobj) (array-total-size pobj))
		(si:print-quoted-string pobj stream t)
	      (si:print-random-object pobj stream t (or si:*prindepth* 0)
				      si:*which-operations* ))
	    (if (named-structure-p pobj) ; DAB 12-28-89 An array can be a structure, if so try to get the
		(let (nss)               ; print-function and use it. [10874]
		  (ignore-errors (setq nss (named-structure-p pobj)))
		  (cond
		    ((and (symbolp nss)
			  (if (boundp '*print-structure* )
			      *print-structure* T)
			  (or (get nss 'named-structure-invoke)
			      (get nss :named-structure-invoke))
			  (member :print-self
				  (named-structure-invoke pobj :which-operations)
				  :test #'eq))
		     (named-structure-invoke pobj :print-self stream (or si:*prindepth* 0)
					     *print-escape*))
		    (t				   ;Named structure that doesn't print itself
		     (si:print-named-structure nss pobj (or si:*prindepth* 0) stream
					       si:*which-operations* ))))
		(si:print-array pobj stream t  (or si:*prindepth* 0) si:*which-operations* ))))))
))
