;;; -*- Mode: Common-Lisp; Package: User; Base: 10.; Patch-File: T -*-
;;; Written 05/26/89 08:13:23 by MCCREARY,
;;; Reason: Fixes FIND-RIGHT-METHOD; problem occurred when hit an individual-hash-table.
;;; Weren't checking the value obtained from the table before doing another
;;; level of searching.
;;; while running on Jules-Verne from band LODA
;;; With SYSTEM 6.0, VIRTUAL-MEMORY 6.0, EH 6.0, MAKE-SYSTEM 6.0, MICRONET 6.0, LOCAL-FILE 6.0,
;;;  BASIC-PATHNAME 6.0, NETWORK-SUPPORT-COLD 6.0, BASIC-NAMESPACE 6.0, NETWORK-NAMESPACE 6.0,
;;;  DISK-IO 6.0, DISK-LABEL 6.0, BASIC-FILE 6.0, MAC-PATHNAME 6.0, NETWORK-PATHNAME 6.0,
;;;  COMPILER 6.0, TV 6.0, DATALINK 6.0, CHAOSNET 6.0, GC 6.0, MEMORY-AUX 6.0, NVRAM 6.0,
;;;  SYSLOG 6.0, STREAMER-TAPE 6.0, UCL 6.0, INPUT-EDITOR 6.0, METER 6.0, ZWEI 6.0,
;;;  DEBUG-TOOLS 6.0, NETWORK-SUPPORT 6.0, NETWORK-SERVICE 6.0, DATALINK-DISPLAYS 6.0,
;;;  FONT-EDITOR 6.0, SERIAL 6.0, PRINTER 6.0, MAC-PRINTER-TYPES 6.0, PRINTER-TYPES 6.0,
;;;  IMAGEN 6.0, SUGGESTIONS 6.0, MAIL-DAEMON 6.0, MAIL-READER 6.0, TELNET 6.0, VT100 6.0,
;;;  NAMESPACE-EDITOR 6.0, PROFILE 6.0, VISIDOC 6.0, TI-CLOS 6.2, CLEH 6.0, IP 3.45,
;;;  Experimental BUG 11.4, CLX 6.0, CLUE 6.0, X11M 6.0, Experimental CLUSO 9.0,  microcode 429,
;;;  Band Name: Release 6.0 + SLE 5/22

#!C
; From file METHOD-HASH-TABLE.LISP#> CLOS; MR-X:
#10R TICLOS#:
(COMPILER-LET ((*PACKAGE* (FIND-PACKAGE "TICLOS"))
                          (SI:*LISP-MODE* :COMMON-LISP)
                          (*READTABLE* SYS:COMMON-LISP-READTABLE)
                          (SI:*READER-SYMBOL-SUBSTITUTIONS* SYS::*COMMON-LISP-SYMBOL-SUBSTITUTIONS*))
  (COMPILER#:PATCH-SOURCE-FILE "SYS: CLOS; METHOD-HASH-TABLE.#"


(defun find-right-method (ht &rest args &aux arg  ignor)
  ;; 05/24/89 clm - fix test for individual-hash-table so that if the result
  ;;                of the GETHASH is not a hash table return that value.
  ;;                It is either a locative to the method we want, or NIL
  ;;                indicating no method exists.
  (loop
    (multiple-value-setq (ht ignor )
      (gethash (sys:%class-description  (setf arg (pop args))) ht))
    (cond ((null ht ) (return nil))
	  ((locativep ht) (return ht))
	  ((individual-hash-table-p ht)
	   (setf ht (or (gethash arg (individual-dispatch-hash-table-ht ht))
			(car (individual-dispatch-hash-table-default-value ht))))
	   (unless (hash-table-p ht)     ;this combines both of the following but
	     (return ht))                ;will it allow something bad through
	                                      ;GETHASH on next iteration
	   ))
    (when (null args) (return ht))))
))
