;;; -*- Mode: Common-Lisp; Package: ticlos; Base: 10.; Patch-File: T -*-

;;; Reason: Modified re-init-class to obsolete class when slot accessors change [10777]. Required microcode 431 or greater.

;;;                           RESTRICTED RIGHTS LEGEND
;;;
;;; Use, duplication, or disclosure by the Government is subject to
;;; restrictions as set forth in subdivision (c)(1)(ii) of the Rights in
;;; Technical Data and Computer Software clause at 52.227-7013.
;;;
;;;   TEXAS INSTRUMENTS INCORPORATED      
;;;   P.O. BOX 2909, M/S 2151             
;;;   AUSTIN, TEXAS 78769                 
;;;
;;; Copyright (C) 1989 Texas Instruments Incorporated.
;;; All rights reserved.

;;; Written 01/17/90 12:40:35 by BERGER,
;;; while running on ARIES from band LODA
;;; With SYSTEM 6.28, VIRTUAL-MEMORY 6.3, EH 6.5, MAKE-SYSTEM 6.2, MICRONET 6.0, LOCAL-FILE 6.1,
;;;  BASIC-PATHNAME 6.2, NETWORK-SUPPORT-COLD 6.2, BASIC-NAMESPACE 6.7, NETWORK-NAMESPACE 6.1,
;;;  DISK-IO 6.2, DISK-LABEL 6.0, BASIC-FILE 6.7, MAC-PATHNAME 6.0, NETWORK-PATHNAME 6.0,
;;;  COMPILER 6.14, TV 6.22, DATALINK 6.0, CHAOSNET 6.5, GC 6.3, MEMORY-AUX 6.0, NVRAM 6.2,
;;;  SYSLOG 6.2, STREAMER-TAPE 6.5, UCL 6.0, INPUT-EDITOR 6.0, METER 6.1, ZWEI 6.12,
;;;  DEBUG-TOOLS 6.4, NETWORK-SUPPORT 6.1, NETWORK-SERVICE 6.2, DATALINK-DISPLAYS 6.0,
;;;  FONT-EDITOR 6.1, SERIAL 6.0, PRINTER 6.3, MAC-PRINTER-TYPES 6.1, PRINTER-TYPES 6.2,
;;;  IMAGEN 6.1, SUGGESTIONS 6.1, MAIL-DAEMON 6.4, MAIL-READER 6.6, TELNET 6.0, VT100 6.0,
;;;  NAMESPACE-EDITOR 6.4, PROFILE 6.2, VISIDOC 6.7, TI-CLOS 6.29, CLEH 6.5, IP 3.57,
;;;  Experimental CLX 6.8, CLUE 6.46, X11M 6.20, Experimental BUG 11.17,  microcode 9,
;;;  Band Name: REl 6.0 SLE 12/28

#!C
; From file CLASS.LISP#> CLOS; SYS:
#10R TICLOS#:
(COMPILER-LET ((*PACKAGE* (FIND-PACKAGE "TICLOS"))
                          (SI:*LISP-MODE* :COMMON-LISP)
                          (*READTABLE* SYS:COMMON-LISP-READTABLE)
                          (SI:*READER-SYMBOL-SUBSTITUTIONS* SYS::*COMMON-LISP-SYMBOL-SUBSTITUTIONS*))
  (COMPILER#:PATCH-SOURCE-FILE "SYS: CLOS; CLASS.#"


(defun re-init-class (class temp-class-description )
  (declare (special temp-class-description))
  (let* (
	 (temp-class (sys:make-flavor-instance (class-name (class-of class))
					       :class-description temp-class-description))
	 (old-cpl (internal-class-precedence-list class))
	 (old-class-description (class-description class))
	 (environment (class-description-environment old-class-description))
	 
	 (new-cpl (loop for super in (compute-class-precedence-list temp-class environment)
			collect (class-named super nil environment))))
    ;;check if the class need to be made obsolete
    (setf (class-description-class-precedence-list temp-class-description) new-cpl)
    (let ((new-slots (collect-slot-descriptions temp-class)))
      (flet ((instance-slot-names (slots)
		(collect-body (dolist (s slots)
				(when (eq :instance (slot-allocation s))
				  (collect (slot-name s))))))
	     (instance-slot-readers (slots)   ; DAB 01-17-90 
				    (collect-body (dolist (s slots)
						    (collect
						      (if (and (eq :instance (slot-allocation s))
							       (slot-readers s))
							  (list (slot-name s) (slot-readers s))
							  T)))))
	     (instance-slot-writers (slots)  ; DAB 01-17-90
				    (collect-body (dolist (s slots)
						    (collect
						      (if (and (eq :instance (slot-allocation s))
							       (slot-writers s))
							  (list (slot-name s) (slot-writers s))
							  T)))))
	     )
	(if  (or (set-exclusive-or (instance-slot-names (class-all-slots class))
				  (instance-slot-names  new-slots))
		 ;;DAB 01-17-90 Now let check if accessors have been removed or added. 
                 ;; This is alos require the class to be rebuilt. [10777]
		 (block exit
		   (mapcar #'(lambda (list1 list2)
			       (unless (equal list1 list2) (return-from exit T)))
			   (instance-slot-readers (class-direct-slots class))
			   (instance-slot-readers  (class-direct-slots temp-class))
			   )
		   nil)
		 (block exit
		   (mapcar #'(lambda (list1 list2)
			       (unless (equal list1 list2) (return-from exit T)))
			   (instance-slot-writers (class-direct-slots class))
			   (instance-slot-writers  (class-direct-slots temp-class)))
		   nil)
		 )

		
	    (progn
	      ;;the class needs to be made obsolete
	      (make-instances-obsolete class)
	      (setf (class-all-slots class) nil))
	    (progn
	      (setf (class-all-slots class)
		    (reinit-effective-slots class new-slots temp-class))))
	(setf (class-description-class-precedence-list (class-description class))
	      (cons class (cdr new-cpl)))
	(unless (equal (cdr old-cpl) (cdr new-cpl))
	  ;;All the combined method are to be recomputed
	  ;;However, how can we make sure it is not done more than it needs to be?
	  (map-specializer-direct-generic-functions
	     #'(lambda (gf)
		  (declare (si:downward-function))
		  (uncache-effective-methods gf class))
	     class)
	  ;; Need to also uncache any methods that were or will be inherited from 
	  ;; classes that are either added to or removed from the class precedence 
	  ;; list, or are even just in a different order.  [SPR 9798]
	  (uncache-inherited-methods class old-cpl new-cpl)
	  )
	
	class))))
))
