;;; -*- Mode:Common-Lisp; Package:TICLOS; Base:10; Patch-file:T -*-

;;; Reason: Modified CHECK-LAMBDA-LIST to allow the full lambda-list syntax for DEFGENERIC forms
;;;         as specified by X3J13 document 88-002R.  In particular, explicit keywords 
;;;         may be specified for &key variables.  [SPR 10865]

;;;                           RESTRICTED RIGHTS LEGEND
;;;
;;; Use, duplication, or disclosure by the Government is subject to
;;; restrictions as set forth in subdivision (c)(1)(ii) of the Rights in
;;; Technical Data and Computer Software clause at 52.227-7013.
;;;
;;;   TEXAS INSTRUMENTS INCORPORATED      
;;;   P.O. BOX 149149, M/S 2151             
;;;   AUSTIN, TEXAS 78714-9149                 
;;;
;;; Copyright (C) 1989 Texas Instruments Incorporated.
;;; All rights reserved.

;;; Written 01/26/90 09:48:23 by BAF,
;;; while running on PCAI from band LOD6
;;; With SYSTEM 6.28, VIRTUAL-MEMORY 6.3, EH 6.5, MAKE-SYSTEM 6.2, MICRONET 6.0, LOCAL-FILE 6.1,
;;;  BASIC-PATHNAME 6.2, NETWORK-SUPPORT-COLD 6.2, BASIC-NAMESPACE 6.7, NETWORK-NAMESPACE 6.1,
;;;  DISK-IO 6.2, DISK-LABEL 6.0, BASIC-FILE 6.7, MAC-PATHNAME 6.0, NETWORK-PATHNAME 6.0,
;;;  COMPILER 6.14, TV 6.23, DATALINK 6.0, CHAOSNET 6.5, GC 6.3, MEMORY-AUX 6.0, NVRAM 6.2,
;;;  SYSLOG 6.2, STREAMER-TAPE 6.5, UCL 6.0, INPUT-EDITOR 6.0, METER 6.1, ZWEI 6.12,
;;;  DEBUG-TOOLS 6.4, NETWORK-SUPPORT 6.1, NETWORK-SERVICE 6.2, DATALINK-DISPLAYS 6.0,
;;;  FONT-EDITOR 6.1, SERIAL 6.0, PRINTER 6.3, MAC-PRINTER-TYPES 6.1, PRINTER-TYPES 6.2,
;;;  IMAGEN 6.1, SUGGESTIONS 6.1, MAIL-DAEMON 6.4, MAIL-READER 6.7, TELNET 6.1, VT100 6.0,
;;;  NAMESPACE-EDITOR 6.4, PROFILE 6.2, VISIDOC 6.7, TI-CLOS 6.33, CLEH 6.5, IP 3.57,
;;;  Experimental BUG 11.18, Experimental CLX 6.8, CLUE 6.46, X11M 6.1,  microcode 604,
;;;  Band Name: Release 6.0 patched 1-19-90

#!C
; From file *Buffer-1*
#10R TICLOS#:
(COMPILER-LET ((*PACKAGE* (FIND-PACKAGE "TICLOS"))
                          (SI:*LISP-MODE* :COMMON-LISP)
                          (*READTABLE* SYS:COMMON-LISP-READTABLE)
                          (SI:*READER-SYMBOL-SUBSTITUTIONS* SYS::*COMMON-LISP-SYMBOL-SUBSTITUTIONS*))
  (COMPILER#:PATCH-SOURCE-FILE "SYS: CLOS; GENERIC.#"


(defun CHECK-LAMBDA-LIST (oll &optional (method-p))
  ;;Check the lambda-list of a generic-function or a method
  ;;returns number of required, number of optionals, restp, 
  ;;keyword-list and allow-other-keys-p
  (declare (values nreq nopt rest-p allow-other-keys-p key-list keyp))
  (let ((nreq 0)
	(nopt 0)
	(allow-other-keys-p nil)
	(rest-p)
	(key-list)
	(keyp nil))
    (with-lambda-list oll
	:required #'(lambda (l) (when (not (member  l lambda-list-keywords :test #'eq))
				  (incf nreq)))
	;; [&optional {var | (var)}*]
	:optionals #'(lambda (l)
		       (when (not (member l lambda-list-keywords :test #'eq))
			 (if (or (symbolp l)
				 (and (consp l)
				      (symbolp (car l))
				      (or method-p (null (cdr l)) )))
			     (incf nopt)
			     (bug) )) )
	:rest #'(lambda (name) (setf rest-p name))
	:keys-before #'(lambda () (setf keyp t))
	;; [&key {var | ({var | (keyword var)})}* [&allow-other-keys]]
	:keys #'(lambda (l)
		  (when (not (member  l lambda-list-keywords :test #'eq))
		    (push (cond ((symbolp l)
				 (intern l *keyword-package*) )
				((or (not (consp l))
				     (and (cdr l) (not method-p)))
				 (bug) )
				((consp (car l))
				 (caar l) )
				(t
				 (intern (car l) *keyword-package*) ))
			  key-list)
		    ))
	:allow-other-keys-key #'(lambda() (setf allow-other-keys-p t)))
    (values nreq nopt rest-p allow-other-keys-p key-list keyp)))
))
