;;; -*- Mode: Common-Lisp; Package: User; Base: 10.; Patch-File: T -*-

;;; Reason: Modified (:property method sys:function-spec-handler) to treat sys:compiler-fdefinedp exactly 
;;; as it treats sys:fdefinedp.

;;;                           RESTRICTED RIGHTS LEGEND
;;;
;;; Use, duplication, or disclosure by the Government is subject to
;;; restrictions as set forth in subdivision (c)(1)(ii) of the Rights in
;;; Technical Data and Computer Software clause at 52.227-7013.
;;;
;;;   TEXAS INSTRUMENTS INCORPORATED      
;;;   P.O. BOX 149149, M/S 2151             
;;;   AUSTIN, TEXAS 78714-9149                 
;;;
;;; Copyright (C) 1989 Texas Instruments Incorporated.
;;; All rights reserved.

;;; Written 02/06/90 12:26:20 by FLORMAN,
;;; while running on PCAI from band LOD6
;;; With SYSTEM 6.28, VIRTUAL-MEMORY 6.3, EH 6.6, MAKE-SYSTEM 6.2, MICRONET 6.0, LOCAL-FILE 6.1,
;;;  BASIC-PATHNAME 6.3, NETWORK-SUPPORT-COLD 6.2, BASIC-NAMESPACE 6.7, NETWORK-NAMESPACE 6.1,
;;;  DISK-IO 6.2, DISK-LABEL 6.0, BASIC-FILE 6.7, MAC-PATHNAME 6.0, NETWORK-PATHNAME 6.0,
;;;  COMPILER 6.14, TV 6.23, DATALINK 6.0, CHAOSNET 6.5, GC 6.3, MEMORY-AUX 6.0, NVRAM 6.2,
;;;  SYSLOG 6.2, STREAMER-TAPE 6.5, UCL 6.0, INPUT-EDITOR 6.0, METER 6.1, ZWEI 6.12,
;;;  DEBUG-TOOLS 6.4, NETWORK-SUPPORT 6.1, NETWORK-SERVICE 6.2, DATALINK-DISPLAYS 6.0,
;;;  FONT-EDITOR 6.1, SERIAL 6.0, PRINTER 6.3, MAC-PRINTER-TYPES 6.1, PRINTER-TYPES 6.2,
;;;  IMAGEN 6.1, SUGGESTIONS 6.1, MAIL-DAEMON 6.4, MAIL-READER 6.7, TELNET 6.1, VT100 6.0,
;;;  NAMESPACE-EDITOR 6.4, PROFILE 6.2, VISIDOC 6.7, TI-CLOS 6.35, CLEH 6.5, IP 3.57,
;;;  Experimental BUG 11.18, Experimental CLX 6.8, CLUE 6.46, X11M 6.1,  microcode 604,
;;;  Band Name: Release 6.0 patched 1-19-90

#!C
; From file FUNCTION-SPEC.LISP#> CLOS; Hotel:
#10R TICLOS#:
(COMPILER-LET ((*PACKAGE* (FIND-PACKAGE "TICLOS"))
                          (SI:*LISP-MODE* :COMMON-LISP)
                          (*READTABLE* SYS:COMMON-LISP-READTABLE)
                          (SI:*READER-SYMBOL-SUBSTITUTIONS* SYS::*COMMON-LISP-SYMBOL-SUBSTITUTIONS*))
  (COMPILER#:PATCH-SOURCE-FILE "SYS: CLOS; FUNCTION-SPEC.#"


(defun (:property method sys:function-spec-handler) (function function-spec &optional arg1 arg2)
  (let* ((gname (second function-spec))
	 (rest (nthcdr 2 function-spec))
	 (qualifiers
	   (collect-body
	     (loop (when (listp (car rest))
		     (return))
		   (collect  (pop rest)))))
	 (specializer-names (pop rest)))
    (if (eq function 'sys:validate-function-spec)
	;; This checks for syntactic validity without requiring that the generic 
	;; function and classes be defined.  Thus, this indicates whether the name 
	;; is acceptable to FDEFINEDP but does not necessarily mean that FDEFINE 
	;; would be valid.  This interpretation is necessary for 
	;; SYS:DWIMIFY-PACKAGE-1 to work right.
	(and (null rest)
	     (consp specializer-names)
	     (or (sys:typep-structure-or-flavor gname 'generic-function)
		 (sys:validate-function-spec gname))
	     (every #'(lambda (x) (or (symbolp x)
				      (sys:classp x)
				      (individual-typep x)))
		    (the list specializer-names)))
      (let ((gfunc (if (sys:typep-structure-or-flavor gname 'generic-function)
		       gname
		     (let ((def (sys:fdefinition-safe gname t)))
		       (and def
			    (generic-function-p def)
			    (get-generic-function-object def)))))
	    (specializers (ignore-errors (mapcar #'canonicalize-class-spec specializer-names))))
	(cond
	  ((eq function 'sys:dwimify)
	   (catch 'sys:dwimify-package
	     (flet ((try-method-spec (new-spec)
			;; Ask the user if this is OK; throws to 'sys:dwimify-package if yes.
			(sys:dwimify-package-2 new-spec nil arg1 arg2 t)
			))
	       (let* ((fname (if gfunc gname (sys:dwimify-package gname 'generic-function-p)))
		      (class-names
			(mapcar #'(lambda (name)
				    (if (or (sys:classp name) (individual-typep name))
					name
				      (sys:dwimify-package name 'find-class)))
				(let ((n (length (generic-function-argument-precedence-order
						   (get-generic-function-object fname)))))
				  (cond ((< n (length specializer-names))
					 (firstn n specializer-names))
					((> n (length specializer-names))
					 (append specializer-names
						 (make-list (- n (length specializer-names))
							    :initial-element 't)))
					(t specializer-names))))))
		 (declare (list class-names))
		 (try-method-spec `(method ,fname ,@qualifiers ,class-names))
		 (when qualifiers
		   (try-method-spec `(method ,fname ,class-names)))
		 (let ((combination (clos:generic-function-method-combination gfunc)))
		   (unless (equal combination '(standard))
		     (try-method-spec `(method ,fname ,(first combination) ,class-names))))
		 (try-method-spec `(method ,fname :around ,class-names))
		 (try-method-spec `(method ,fname :before ,class-names))
		 (try-method-spec `(method ,fname :after ,class-names))
		 (dolist (class-name class-names)
		   (dolist (super (if (consp class-name)
				      (and (individual-typep class-name)
					   (class-precedence-list (class-of (second class-name))))
				    (cdr (class-precedence-list (class-named class-name)))))
		     (try-method-spec `(method ,fname ,(substitute (class-name super)
								   class-name class-names
								   :count 1 :test #'eq)))))
		 (multiple-value-bind (handlerp defn)
		     (fdefinedp `(handler ,fname ,class-names))
		   (when handlerp
		     (try-method-spec (function-name defn))))
		 nil)))) ; end of dwimify
	  ((not (and gfunc specializers))
	   (cond  ((eq function 'sys:fdefinedp) nil)
		  ((eq function 'sys:compiler-fdefinedp) nil)	; BAF 2/6/90
		  ((eq function 'get) arg2)
		  ((null gfunc)
		   (ferror 'sys:invalid-function-spec
			   "The generic function ~s is not defined." (second function-spec)))
		  (t (when (consp specializer-names)
		       (dolist (name specializer-names)
			 (when (and (symbolp name)
				    (not (class-named name t)))
			   (ferror 'sys:invalid-function-spec
				   "Undefined class ~S in function spec ~S." name function-spec))))
		     (ferror 'sys:invalid-function-spec
			     "Invalid qualifier or specializer syntax in function spec ~S"
			     function-spec))))
	  ((eq function 'sys:fdefine)
	   (add-method gfunc
		       (make-method qualifiers specializers arg1
				    ;; Note: we need the original DEFMETHOD lambda-list which
				    ;; was stored by PARSE-METHOD in the :DESCRIPTIVE-ARGLIST
				    ;; field of the debug info, not the real arglist of the FEF.
				    (arglist arg1 nil)))
	   function-spec)
	  (t (let ((meth-spec (get-method-spec-object
				gfunc qualifiers specializers
				(and (member function '( sys:fdefinition-location
							putprop sys:push-property) :test #'eq)
				     function-spec)
				(member function '(sys:fdefinedp get sys:function-parent) :test #'eq ))))
	       (case function
		 (sys:fdefinedp
		  (and meth-spec
		       (let ((def (method-spec-object-function meth-spec)))
			 (and def (values t def)))))
		 (sy