;;; -*- Mode: Common-Lisp; Package: User; Base: 10.; Patch-File: T -*-

;;; Reason: Expanded error message in ENSURE-GENERIC-FUNCTION was not handling (setf xx) fpec properly.

;;;                           RESTRICTED RIGHTS LEGEND
;;;
;;; Use, duplication, or disclosure by the Government is subject to
;;; restrictions as set forth in subdivision (c)(1)(ii) of the Rights in
;;; Technical Data and Computer Software clause at 52.227-7013.
;;;
;;;   TEXAS INSTRUMENTS INCORPORATED      
;;;   P.O. BOX 2909, M/S 2151             
;;;   AUSTIN, TEXAS 78769                 
;;;
;;; Copyright (C) 1989 Texas Instruments Incorporated.
;;; All rights reserved.

;;; Patch file for TI-CLOS version 6.45
;;; Written 05/11/90 14:42:41 by BERGER,
;;; while running on Pasteur from band LOD3
;;; With SYSTEM 6.31, VIRTUAL-MEMORY 6.3, EH 6.7, Inconsistent MAKE-SYSTEM 6.3, MICRONET 6.0,
;;;  LOCAL-FILE 6.2, BASIC-PATHNAME 6.4, NETWORK-SUPPORT-COLD 6.2, BASIC-NAMESPACE 6.7,
;;;  NETWORK-NAMESPACE 6.1, DISK-IO 6.3, DISK-LABEL 6.0, BASIC-FILE 6.10, MAC-PATHNAME 6.0,
;;;  NETWORK-PATHNAME 6.1, COMPILER 6.14, TV 6.24, DATALINK 6.0, CHAOSNET 6.6, GC 6.3,
;;;  MEMORY-AUX 6.0, NVRAM 6.2, SYSLOG 6.2, STREAMER-TAPE 6.5, UCL 6.0, INPUT-EDITOR 6.0,
;;;  METER 6.1, ZWEI 6.14, DEBUG-TOOLS 6.4, NETWORK-SUPPORT 6.1, NETWORK-SERVICE 6.2,
;;;  DATALINK-DISPLAYS 6.0, FONT-EDITOR 6.1, SERIAL 6.0, PRINTER 6.4, MAC-PRINTER-TYPES 6.2,
;;;  PRINTER-TYPES 6.2, IMAGEN 6.1, SUGGESTIONS 6.1, MAIL-DAEMON 6.6, MAIL-READER 6.7,
;;;  TELNET 6.1, VT100 6.0, NAMESPACE-EDITOR 6.4, PROFILE 6.3, VISIDOC 6.7, TI-CLOS 6.44,
;;;  CLEH 6.5, IP 3.62, Experimental CLX 6.11, CLUE 6.98, X11M 6.22, Experimental BUG 11.19,
;;;  Experimental FOO 3.0, Experimental BAR 3.0, Experimental BAZ 3.0, Experimental FOOBAR 1.0,
;;;   microcode 648, Band Name: rel6.0 1/23

#!C
; From file META-OBJECT.LISP#> CLOS; Hotel:
#10R TICLOS#:
(COMPILER-LET ((*PACKAGE* (FIND-PACKAGE "TICLOS"))
                          (SI:*LISP-MODE* :COMMON-LISP)
                          (*READTABLE* SYS:COMMON-LISP-READTABLE)
                          (SI:*READER-SYMBOL-SUBSTITUTIONS* SYS::*COMMON-LISP-SYMBOL-SUBSTITUTIONS*))
  (COMPILER#:PATCH-SOURCE-FILE "SYS: CLOS; META-OBJECT.#"

(define-without-redefinition-query ENSURE-GENERIC-FUNCTION ; previously defined in file "generic".
;; 12/29/88 DNG - Pass :NAME option to MODIFY-GENERIC-FUNCTION.
;;  1/11/89 DNG - Redesigned to use ENSURE-GENERIC-FUNCTION-USING-CLASS.
;;  4/03/89 DNG - Moved error checking to here instead of using
;;		(METHOD ENSURE-GENERIC-FUNCTION-USING-CLASS (FUNCTION)) in order to handle 
;;		interpreted previous definition [SPR 9581] and to conform to p. 3-53 of 89-003.
;;  5/08/89 DNG - Use environment in finding old definition.
(defun ENSURE-GENERIC-FUNCTION (fspec &rest options
				   &key environment &allow-other-keys)
  "Define a generic function or update its options."
  (declare (arglist function-spec &key lambda-list argument-precedence-order
		    declare documentation generic-function-class
		    method-combination method-class environment))
  (let ((old-def (or (and (compiler:environment-remote-p environment)
			  (let ((compiler:*compile-file-environment*
				  (compiler:env-global-env environment)))
			    (compiler:file-local-def fspec)))
		     (sys:fdefinition-safe fspec t))))
    (unless (or (null old-def)
		(generic-function-p old-def))
      (let ((debug-st (si:get-debug-info-struct fspec)))
	(if (symbolp (si:get-debug-info-field debug-st :name))  ; DAB 05-11-90 handle (setf xxx) fspec.
	    (cerror "Discard the current definition of ~s and create a generic function."
		    "~s is not a generic function. ~%The current definition of ~a is in the package ~a and defined in the file ~a.~% It has an  arglist of  ~a and a documentation string of ~s."
		    fspec (si:get-debug-info-field debug-st :name)
		    (symbol-package (si:get-debug-info-field debug-st :name))
		    (get (si:get-debug-info-field debug-st :name) :source-file-name)
		    (si:get-debug-info-field debug-st :arglist)
		    (si:get-debug-info-field debug-st :documentation))
	    (cerror "Discard the current definition of ~s and create a generic function."
		    "~s is not a generic function." fspec)
	    )
      )
      (setq old-def nil))
    (apply #'ensure-generic-function-using-class old-def fspec options)))
 )


))
