;;; -*- Mode: Common-Lisp; Package: User; Base: 10.; Patch-File: T -*-

;;; Reason: Fixed (:METHOD STANDARD-CLASS :REMOVE-METHOD) to not leave empty alist entries in the method lists of
;;; generic functions [SPR 11223].

;;;                           RESTRICTED RIGHTS LEGEND
;;;
;;; Use, duplication, or disclosure by the Government is subject to
;;; restrictions as set forth in subdivision (c)(1)(ii) of the Rights in
;;; Technical Data and Computer Software clause at 52.227-7013.
;;;
;;;   TEXAS INSTRUMENTS INCORPORATED      
;;;   P.O. BOX 2909, M/S 2151             
;;;   AUSTIN, TEXAS 78769                 
;;;
;;; Copyright (C) 1989 Texas Instruments Incorporated.
;;; All rights reserved.

;;; Written 06/12/90 14:29:32 by FLORMAN,
;;; while running on PCAI from band LOD6
;;; With SYSTEM 6.38, VIRTUAL-MEMORY 6.3, EH 6.8, MAKE-SYSTEM 6.3, MICRONET 6.0, LOCAL-FILE 6.2,
;;;  BASIC-PATHNAME 6.5, NETWORK-SUPPORT-COLD 6.2, BASIC-NAMESPACE 6.8, NETWORK-NAMESPACE 6.1,
;;;  DISK-IO 6.3, DISK-LABEL 6.1, BASIC-FILE 6.13, MAC-PATHNAME 6.0, NETWORK-PATHNAME 6.2,
;;;  COMPILER 6.18, TV 6.26, DATALINK 6.0, CHAOSNET 6.8, GC 6.4, MEMORY-AUX 6.0, NVRAM 6.3,
;;;  SYSLOG 6.2, STREAMER-TAPE 6.6, UCL 6.0, INPUT-EDITOR 6.0, METER 6.2, ZWEI 6.22,
;;;  DEBUG-TOOLS 6.5, NETWORK-SUPPORT 6.1, NETWORK-SERVICE 6.3, DATALINK-DISPLAYS 6.0,
;;;  FONT-EDITOR 6.1, SERIAL 6.0, PRINTER 6.9, MAC-PRINTER-TYPES 6.2, PRINTER-TYPES 6.2,
;;;  IMAGEN 6.1, SUGGESTIONS 6.1, MAIL-DAEMON 6.6, MAIL-READER 6.8, TELNET 6.1, VT100 6.0,
;;;  NAMESPACE-EDITOR 6.6, PROFILE 6.3, VISIDOC 6.7, TI-CLOS 6.51, CLEH 6.5, IP 3.65,
;;;  Experimental CLX 6.11, CLUE 6.105, X11M 6.30, Experimental BUG 11.19, RPC 6.2,
;;;  NFS 3.11,  microcode 483, Band Name: customized Rel 6.1

#!C
; From file GENERIC.LISP#> CLOS; Hotel:
#10R TICLOS#:
(COMPILER-LET ((*PACKAGE* (FIND-PACKAGE "TICLOS"))
                          (SI:*LISP-MODE* :COMMON-LISP)
                          (*READTABLE* SYS:COMMON-LISP-READTABLE)
                          (SI:*READER-SYMBOL-SUBSTITUTIONS* SYS::*COMMON-LISP-SYMBOL-SUBSTITUTIONS*))
  (COMPILER#:PATCH-SOURCE-FILE "SYS: CLOS; GENERIC.#"


(defmethod (standard-generic-function :remove-method) (method)
  (check-type method method)
  (let ((gfunc self))
    (unless (= (length (method-parameter-specializers method)) (length argument-precedence-order))
      (error "The number of specializers of method ~s does not match the 
number expected by the generic function ~s." method gfunc))
    (let* ((keys (reorder-parameter-specializers gfunc (method-parameter-specializers method)))
	   (recombine-methods t))

      (labels ((method-list-without-method (alist args)
		(let ((entry (assoc (car args) alist :test #'class-eql)))
		  (cond ((null entry)
			 (error "The method ~s has not been not found in the generic-function ~s."
				method gfunc) )
			((null (setf (cdr entry)
				     (if (cdr args)
					 (method-list-without-method (cdr entry) (cdr args))
					 (delete method (the list (cdr entry))
						 :test #'eq
						 :key #'method-spec-object-method
						 :count 1) )) )
			 (delete entry (the list alist) :test #'eq) )
			(t alist )) ))
	       )
	(setf (generic-function-method-list gfunc)
	      (method-list-without-method (generic-function-method-list gfunc) keys)) )	; BAF 6/12/90

      (dolist (k keys )
	 (unless (consp k)
	   (remove-method-on-specializer k  method)
	   (unless (or (typep k 'built-in-class)
		       (class-description-instance-size (class-description k)))
	     ;; When REMOVE-METHOD is called from MAKE-INSTANCES-OBSOLETE, the new 
	     ;; class description has not yet been composed, so we can't build 
	     ;; mapping tables for it yet.
	     (setq recombine-methods nil))))
       (let ((forward (getf (method-plist method) 'forwarded-from)))
	 (when (and forward
		      (eq method (method-forwarded-method forward)))
	    ;; Remove combined method that pointed to the method being removed.
	   (remove-method gfunc forward)))
      (when (and (generic-function-method-hash-table gfunc) (not (handlerp method)))
	(if recombine-methods
	    (recombine-methods gfunc keys)
	  (dolist (k keys)
	    (unless (or (consp k) (typep k 'built-in-class))
	      (uncache-effective-methods gfunc k))))))
    gfunc))

))
