;;; -*- Mode: Common-Lisp; Package: User; Base: 10.; Patch-File: T -*-

;;; Reason: Fixed SI::MAKE-CLASS-DEFINITION to only pass the name from the :INCLUDE clause to SI:ADD-STRUCTURE-CLASS
;;; rather than the whole clause, wich may contain slot redeclarations.

;;;                           RESTRICTED RIGHTS LEGEND
;;;
;;; Use, duplication, or disclosure by the Government is subject to
;;; restrictions as set forth in subdivision (c)(1)(ii) of the Rights in
;;; Technical Data and Computer Software clause at 52.227-7013.
;;;
;;;   TEXAS INSTRUMENTS INCORPORATED      
;;;   P.O. BOX 2909, M/S 2151             
;;;   AUSTIN, TEXAS 78769                 
;;;
;;; Copyright (C) 1989 Texas Instruments Incorporated.
;;; All rights reserved.

;;; Written 06/15/90 10:41:03 by FLORMAN,
;;; while running on PCAI from band LOD6
;;; With SYSTEM 6.41, VIRTUAL-MEMORY 6.3, EH 6.8, MAKE-SYSTEM 6.4, MICRONET 6.0, LOCAL-FILE 6.2,
;;;  BASIC-PATHNAME 6.5, NETWORK-SUPPORT-COLD 6.2, BASIC-NAMESPACE 6.8, NETWORK-NAMESPACE 6.1,
;;;  DISK-IO 6.4, DISK-LABEL 6.1, BASIC-FILE 6.13, MAC-PATHNAME 6.0, NETWORK-PATHNAME 6.2,
;;;  COMPILER 6.18, TV 6.26, DATALINK 6.0, CHAOSNET 6.8, GC 6.4, MEMORY-AUX 6.0, NVRAM 6.3,
;;;  SYSLOG 6.2, STREAMER-TAPE 6.6, UCL 6.0, INPUT-EDITOR 6.0, METER 6.2, ZWEI 6.22,
;;;  DEBUG-TOOLS 6.5, NETWORK-SUPPORT 6.1, NETWORK-SERVICE 6.3, DATALINK-DISPLAYS 6.0,
;;;  FONT-EDITOR 6.1, SERIAL 6.0, PRINTER 6.8, MAC-PRINTER-TYPES 6.2, PRINTER-TYPES 6.2,
;;;  IMAGEN 6.1, SUGGESTIONS 6.1, MAIL-DAEMON 6.6, MAIL-READER 6.8, TELNET 6.1, VT100 6.0,
;;;  NAMESPACE-EDITOR 6.6, PROFILE 6.3, VISIDOC 6.7, TI-CLOS 6.52, CLEH 6.5, IP 3.65,
;;;  Experimental CLX 6.12, CLUE 6.105, X11M 6.30, Experimental BUG 11.19, RPC 6.2,
;;;  NFS 3.11,  microcode 486, Band Name: customized Rel 6.1


#!C
; From file STRUCTURE-METACLASS.LISP#> CLOS; Hotel:
#10R TICLOS#:
(COMPILER-LET ((*PACKAGE* (FIND-PACKAGE "TICLOS"))
                          (SI:*LISP-MODE* :COMMON-LISP)
                          (*READTABLE* SYS:COMMON-LISP-READTABLE)
                          (SI:*READER-SYMBOL-SUBSTITUTIONS* SYS::*COMMON-LISP-SYMBOL-SUBSTITUTIONS*))
  (COMPILER#:PATCH-SOURCE-FILE "SYS: CLOS; STRUCTURE-METACLASS.#"

system:
(defun make-class-definition ()
  (using-defstruct-special-variables)
  (when (eq type 'common-lisp-structure)
    (push `(and (fboundp 'add-structure-class) ; this line needed for backward comptibility of XLD files
		(add-structure-class 
		  ',name
		  ,(and (consp include) `(quote ,(list (car include))))
		  ',(mapcar #'(lambda (x)
				(let ((slot-name (car x))
				      (initform (defstruct-slot-description-init-code (cdr x)))
				      (slot-type (defstruct-slot-description-type (cdr x))))
				  (if (emptyp slot-type)
				      (if (emptyp initform)
					  slot-name
					(list slot-name initform))
				    (list slot-name
					  initform
					  (if (emptyp slot-type) 't slot-type)))))
			    slot-alist)))
	  returns)))


system:
(defun add-structure-class (class-name direct-supers slots)
  (when (fboundp 'ticlos:add-named-class-internal)
    (if (consp direct-supers)
	(setq direct-supers (list (first direct-supers))) )	; BAF 6/15/90
    (ticlos:add-named-class-internal
      'ticlos:structure-class
      class-name
      (or direct-supers '(ticlos:structure-object))
      (mapcar #'(lambda (x) 
		  (if (atom x)
		      (ticlos:internal-make-slot-description
			:name x :initform nil :allocation :instance :type 't)
		    ;; x is (slot-name initform [ slot-type ] )
		    (ticlos:internal-make-slot-description
		      :name (first x)
		      :initform (and (cdr x) (not (emptyp (second x))) (list (second x)))
		      :allocation :instance
		      :type (if (null (cddr x)) 't (third x))
		      )))
	      slots)
      ;; Note: no need to include :DOCUMENTATION here because the DOCUMENTATION 
      ;; method for STRUCTURE-CLASS will know where to find it.
      nil
      )))

))

#!C
; From file *Buffer-1*
#10R TICLOS#:
(COMPILER-LET ((*PACKAGE* (FIND-PACKAGE "TICLOS"))
                          (SI:*LISP-MODE* :COMMON-LISP)
                          (*READTABLE* SYS:COMMON-LISP-READTABLE)
                          (SI:*READER-SYMBOL-SUBSTITUTIONS* SYS::*COMMON-LISP-SYMBOL-SUBSTITUTIONS*))
  (COMPILER#:PATCH-SOURCE-FILE NIL


(eval-when (eval load)
  (when (fboundp 'map-subclasses)
    (map-subclasses #'(lambda (class)
			(let ((desc (slot-value class 'class-description)))
			  (setf (class-description-direct-supers desc)
				(list (first (class-description-direct-supers desc))) )) )
		    (find-class 'structure-object))
    ))
))
