;;; -*- Mode:Common-Lisp; Package:TICLOS; Base:10; Patch-file:T -*-

;;; Reason: Fix slot writer methods for slots with :ALLOCATION :CLASS.  [SPR 9891]


;;; Copyright (C) 1989 Texas Instruments Incorporated. All rights reserved.

;;; Patch file for TI-CLOS version 6.6
;;; Written 06/15/89 19:19:23 by GRAY,
;;; while running on Kelvin from band LOD2
;;; With SYSTEM 6.6, VIRTUAL-MEMORY 6.1, EH 6.2, MAKE-SYSTEM 6.0, MICRONET 6.0, LOCAL-FILE 6.0,
;;;  BASIC-PATHNAME 6.0, NETWORK-SUPPORT-COLD 6.0, BASIC-NAMESPACE 6.1, NETWORK-NAMESPACE 6.0,
;;;  DISK-IO 6.0, DISK-LABEL 6.0, BASIC-FILE 6.2, MAC-PATHNAME 6.0, NETWORK-PATHNAME 6.0,
;;;  Inconsistent COMPILER 6.4, TV 6.8, DATALINK 6.0, CHAOSNET 6.0, GC 6.2, MEMORY-AUX 6.0,
;;;  NVRAM 6.0, SYSLOG 6.0, STREAMER-TAPE 6.2, UCL 6.0, INPUT-EDITOR 6.0, METER 6.0,
;;;  ZWEI 6.2, Inconsistent DEBUG-TOOLS 6.3, NETWORK-SUPPORT 6.0, NETWORK-SERVICE 6.0,
;;;  DATALINK-DISPLAYS 6.0, FONT-EDITOR 6.1, SERIAL 6.0, PRINTER 6.1, MAC-PRINTER-TYPES 6.1,
;;;  PRINTER-TYPES 6.0, IMAGEN 6.0, SUGGESTIONS 6.0, MAIL-DAEMON 6.2, MAIL-READER 6.0,
;;;  TELNET 6.0, VT100 6.0, NAMESPACE-EDITOR 6.0, PROFILE 6.1, VISIDOC 6.2, TI-CLOS 6.5,
;;;  CLEH 6.4, IP 3.46, Experimental BUG 11.8, Experimental CLX 6.1, CLUE 6.5, X11M 6.1,
;;;  Experimental DOCUMENTER 6.0,  microcode 429, Band Name: 6.0 SLE 6/5 + u429 6/8

;;; BUG REPORT NUMBER:  9891
;;;
;;; PROBLEM:  CLOS slot writer methods for slots with :ALLOCATION :CLASS were 
;;;	not working correctly.  The instance was stored in the slot instead of the
;;;	correct value.
;;;
;;; SOLUTION:  Function WRITE-CLASS-SLOT had its arguments in the wrong order; 
;;;	swap them so the value is the first argument.

#!C
; From file METHOD-HASH-TABLE.LISP#> CLOS; MR-X:
#10R TICLOS#:
(COMPILER-LET ((*PACKAGE* (FIND-PACKAGE "TICLOS"))
                          (SI:*LISP-MODE* :COMMON-LISP)
                          (*READTABLE* SYS:COMMON-LISP-READTABLE)
                          (SI:*READER-SYMBOL-SUBSTITUTIONS* SYS::*COMMON-LISP-SYMBOL-SUBSTITUTIONS*))
  (COMPILER#:PATCH-SOURCE-FILE "SYS: CLOS; METHOD-HASH-TABLE.#"


;;  6/15/89 DNG - Fix order of arguments.  [SPR 9891]
(defun write-class-slot (value instance)
  (declare (ignore instance))
  ;;We use the first mapping table, because both of them have the same value.
  (setf (contents (COMPILER:%LOCAL-SLOT
		    SYS:LOCAL-FOR-FIRST-MAPPING-TABLE)) value))
))
