;;; -*- Mode: Common-Lisp; Package: User; Base: 10.; Patch-File: T -*-

;;; Reason: allocate-event: Optimized implementation for Explorer.

;;;                           RESTRICTED RIGHTS LEGEND
;;;
;;; Use, duplication, or disclosure by the Government is subject to
;;; restrictions as set forth in subdivision (c)(1)(ii) of the Rights in
;;; Technical Data and Computer Software clause at 52.227-7013.
;;;
;;;   TEXAS INSTRUMENTS INCORPORATED      
;;;   P.O. BOX 149149, M/S 2151             
;;;   AUSTIN, TEXAS 78714-9149                 
;;;
;;; Copyright (C) 1989 Texas Instruments Incorporated.
;;; All rights reserved.

;;; Patch file for CLUE version 6.103
;;; Written 05/15/90 17:37:17 by KK,
;;; while running on RIGI from band PB28
;;; With SYSTEM 6.31, GC 6.3, VIRTUAL-MEMORY 6.3, MICRONET 6.0, MICRONET-COMM 6.3,
;;;  DISK-IO 6.3, DISK-LABEL 6.0, BASIC-PATHNAME 6.4, MAC-PATHNAME 6.0, NETWORK-SUPPORT-COLD 6.2,
;;;  BASIC-NAMESPACE 6.7, BASIC-FILE 6.10, RPC 6.2, NFS-MX 6.7, EH 6.7, MAKE-SYSTEM 6.3,
;;;  MEMORY-AUX 6.0, COMPILER 6.14, TV 6.24, NVRAM 6.2, UCL 6.0, INPUT-EDITOR 6.0,
;;;  MACTOOLBOX 2.17, METER 6.1, ZWEI 6.14, DEBUG-TOOLS 6.4, WINDOW-MX 6.10, PRINTER 6.4,
;;;  MAC-PRINTER-TYPES 6.2, CLIPBOARD 6.1, TI-CLOS 6.44, CLEH 6.5, NETWORK-PATHNAME 6.2,
;;;  NETWORK-NAMESPACE 6.1, DATALINK 6.0, CHAOSNET 6.6, NETWORK-SUPPORT 6.1, NETWORK-SERVICE 6.2,
;;;  DATALINK-DISPLAYS 6.0, MX-DATALINK 6.1, NAMESPACE-EDITOR 6.4, IP 3.62, NFS-MX-SERVER 6.0,
;;;  MX-SERIAL 6.1, PRINTER-TYPES 6.2, IMAGEN 6.1, MAIL-DAEMON 6.6, MAIL-READER 6.8,
;;;  TELNET 6.1, VT100 6.0, STREAMER-TAPE 6.5, DECNET 1.72, VISIDOC 6.7, PROFILE 6.3,
;;;  Experimental CLX 6.11, CLUE 6.102, Experimental BUG 11.19, Experimental SC 3.0,
;;;  Experimental CLIO 24.0,  microcode 139, Band Name: microExplorer Network + SLE (11/28)

#!C
; From file EVENTS.LISP#> CLUE; Hotel:
#10R CLUEI#:
(COMPILER-LET ((*PACKAGE* (FIND-PACKAGE "CLUEI"))
                          (SI:*LISP-MODE* :COMMON-LISP)
                          (*READTABLE* SYS:COMMON-LISP-READTABLE)
                          (SI:*READER-SYMBOL-SUBSTITUTIONS* SYS::*COMMON-LISP-SYMBOL-SUBSTITUTIONS*))
  (COMPILER#:PATCH-SOURCE-FILE "SYS: CLUE; EVENTS.#"


#+ explorer
(let ((nil-event (make-instance 'event)))
  (declare (type event nil-event))
  (with-slots
    (
     above-sibling atom border-width character child
     code colormap configure-p contact count data display drawable event-window focus-p
     format height hint-p installed-p key keymap keysym kind major minor mode name
     new-p override-redirect-p parent place plist property requestor root root-x root-y
     same-screen-p selection send-event-p sequence state target time type width
     window x y
     )
    (the event nil-event)		
    (setf
      above-sibling            nil
      atom                     nil
      border-width             nil
      character                nil
      child                    nil
      code                     nil
      colormap                 nil
      configure-p              nil
      contact                  nil
      count                    nil
      data                     nil
      display                  nil
      drawable                 nil
      event-window             nil
      focus-p                  nil
      format                   nil
      height                   nil
      hint-p                   nil
      installed-p              nil
      key                      nil
      keymap                   nil
      keysym                   nil
      kind                     nil
      major                    nil
      minor                    nil
      mode                     nil
      name                     nil
      new-p                    nil
      override-redirect-p      nil
      parent                   nil
      place                    nil
      plist                    nil
      property                 nil
      requestor                nil
      root                     nil
      root-x                   nil
      root-y                   nil
      same-screen-p            nil
      selection                nil
      send-event-p             nil
      sequence                 nil
      state                    nil
      target                   nil
      time                     nil
      type                     nil
      width                    nil
      window                   nil
      x                        nil
      y                        nil
      ))

  (defun allocate-event ()
    (let ((event (or (xlib::atomic-pop *event-cache*)
		     (make-instance 'event))))
      (si:%blt-typed
	(1+ (si:%pointer nil-event))
	(1+ (si:%pointer event))
	49 1)
      event)))

))
