;;; -*- Mode: Common-Lisp; Package: User; Base: 10.; Patch-File: T -*-

;;; Reason: handle-event (shell): Avoid unnecessary resize of content when :configure-notify signals only
;;; a change in top-level border-width. 

;;;                           RESTRICTED RIGHTS LEGEND
;;;
;;; Use, duplication, or disclosure by the Government is subject to
;;; restrictions as set forth in subdivision (c)(1)(ii) of the Rights in
;;; Technical Data and Computer Software clause at 52.227-7013.
;;;
;;;   TEXAS INSTRUMENTS INCORPORATED      
;;;   P.O. BOX 2909, M/S 2151             
;;;   AUSTIN, TEXAS 78769                 
;;;
;;; Copyright (C) 1989 Texas Instruments Incorporated.
;;; All rights reserved.

;;; Written 10/03/89 20:20:26 by KK,
;;; while running on Quintillian from band LOD2
;;; With SYSTEM 6.17, VIRTUAL-MEMORY 6.2, EH 6.5, MAKE-SYSTEM 6.1, MICRONET 6.0, LOCAL-FILE 6.1,
;;;  BASIC-PATHNAME 6.1, NETWORK-SUPPORT-COLD 6.0, BASIC-NAMESPACE 6.2, NETWORK-NAMESPACE 6.0,
;;;  DISK-IO 6.1, DISK-LABEL 6.0, BASIC-FILE 6.3, MAC-PATHNAME 6.0, NETWORK-PATHNAME 6.0,
;;;  COMPILER 6.12, TV 6.15, DATALINK 6.0, CHAOSNET 6.1, GC 6.3, MEMORY-AUX 6.0, NVRAM 6.1,
;;;  SYSLOG 6.1, STREAMER-TAPE 6.4, UCL 6.0, INPUT-EDITOR 6.0, METER 6.1, ZWEI 6.5,
;;;  DEBUG-TOOLS 6.3, NETWORK-SUPPORT 6.0, NETWORK-SERVICE 6.1, DATALINK-DISPLAYS 6.0,
;;;  FONT-EDITOR 6.1, SERIAL 6.0, PRINTER 6.3, MAC-PRINTER-TYPES 6.1, PRINTER-TYPES 6.1,
;;;  IMAGEN 6.0, SUGGESTIONS 6.0, MAIL-DAEMON 6.2, MAIL-READER 6.2, TELNET 6.0, VT100 6.0,
;;;  NAMESPACE-EDITOR 6.0, PROFILE 6.1, VISIDOC 6.4, TI-CLOS 6.24, CLEH 6.5, IP 3.50,
;;;  Experimental CLX 6.3, CLUE 6.17, X11M 6.14, Experimental BUG 11.15, Experimental SC 2.0,
;;;  Experimental CLIO 6.0, Experimental CLIO-TEST 5.0,  microcode 429, Band Name: Rel 6.0 + SLE 9/8

#!C
; From file SHELLS.LISP#> CLUE; MR-X:
#10R CLUEI#:
(COMPILER-LET ((*PACKAGE* (FIND-PACKAGE "CLUEI"))
                          (SI:*LISP-MODE* :COMMON-LISP)
                          (*READTABLE* SYS:COMMON-LISP-READTABLE)
                          (SI:*READER-SYMBOL-SUBSTITUTIONS* SYS::*COMMON-LISP-SYMBOL-SUBSTITUTIONS*))
  (COMPILER#:PATCH-SOURCE-FILE "SYS: PATCH.CLUE; CLUE-6-1.#"


(defmethod handle-event :before ((shell shell) (event event))
  (with-slots (key) event
    (case key
      (:configure-notify
       ;; Update geometry slots to reflect reality
       (with-slots ((new-x            x)
		    (new-y            y)
		    (new-width        width)
		    (new-height       height)
		    (new-border-width border-width)) event
	 (with-slots (x y width height border-width) shell	   
	   (without-requests shell		;no configure request side-effect
	     ;; Use move/resize protocol so that any auxilliary methods will fire
	     ;; Call only if geometry actually changed 
	     (unless (and (= x new-x) (= y new-y))
	       (move shell new-x new-y))

	     ;; Note: The only effect of a new border-width would be on the layout
	     ;; of siblings, but for top-level contact, this is handled by window manager.
	     ;; Therefore, consider only width/height when propagating new size.
	     (unless (and (= width new-width) (= height new-height))
	       (resize shell new-width new-height new-border-width))))))
      
      (:map-notify
       ;; Update state to reflect reality
       (without-requests shell
	 (setf (contact-state shell) :mapped)))
      
      (:unmap-notify
       ;; Update state to reflect reality
       (without-requests shell
	 (setf (contact-state shell) :iconic))))))

))
