;;; -*- Mode: Common-Lisp; Package: User; Base: 10.; Patch-File: T -*-
;;; Written 10/11/89 18:17:50 by KK,
;;; Reason: change-priority: Use priority/sibling returned from manage-priority. Correctly test for managed-p. Avoid redundant
;;; priority change for top-level contact.
;;; while running on RIGI from band n817
;;; With SYSTEM 6.19, GC 6.3, VIRTUAL-MEMORY 6.2, MICRONET 6.0, MICRONET-COMM 6.1,
;;;  DISK-IO 6.1, DISK-LABEL 6.0, BASIC-PATHNAME 6.2, MAC-PATHNAME 6.0, NETWORK-SUPPORT-COLD 6.1,
;;;  BASIC-NAMESPACE 6.4, BASIC-FILE 6.4, RPC 6.1, NFS-MX 6.3, EH 6.5, MAKE-SYSTEM 6.2,
;;;  MEMORY-AUX 6.0, COMPILER 6.12, TV 6.15, NVRAM 6.2, UCL 6.0, INPUT-EDITOR 6.0,
;;;  MACTOOLBOX 2.7, METER 6.1, ZWEI 6.5, DEBUG-TOOLS 6.3, WINDOW-MX 6.8, PRINTER 6.3,
;;;  MAC-PRINTER-TYPES 6.1, CLIPBOARD 6.1, TI-CLOS 6.24, CLEH 6.5, NETWORK-PATHNAME 6.0,
;;;  NETWORK-NAMESPACE 6.0, DATALINK 6.0, CHAOSNET 6.1, NETWORK-SUPPORT 6.0, NETWORK-SERVICE 6.1,
;;;  DATALINK-DISPLAYS 6.0, MX-DATALINK 6.1, NAMESPACE-EDITOR 6.2, IP 3.50, NFS-MX-SERVER 6.0,
;;;  MX-SERIAL 6.1, PRINTER-TYPES 6.2, IMAGEN 6.1, MAIL-DAEMON 6.3, MAIL-READER 6.5,
;;;  TELNET 6.0, VT100 6.0, STREAMER-TAPE 6.4, DECNET 1.70, VISIDOC 6.5, PROFILE 6.2,
;;;  Experimental SC 2.0, Experimental CLX 6.4, CLUE 6.20,  microcode 138, Band Name: microExplorer Network (8/17)

#!C
; From file INTRINSICS.LISP#> CLUE; Hotel:
#10R CLUEI#:
(COMPILER-LET ((*PACKAGE* (FIND-PACKAGE "CLUEI"))
                          (SI:*LISP-MODE* :COMMON-LISP)
                          (*READTABLE* SYS:COMMON-LISP-READTABLE)
                          (SI:*READER-SYMBOL-SUBSTITUTIONS* SYS::*COMMON-LISP-SYMBOL-SUBSTITUTIONS*))
  (COMPILER#:PATCH-SOURCE-FILE "SYS: CLUE; INTRINSICS.#"


(defun change-priority (contact priority &key sibling accept-p)
  "Change CONTACT's stacking order"
  (declare (type contact contact)
	   (type (member :above :below :top-if :bottom-if :opposite) priority)
	   (type (or null contact) sibling)
	   (values success-p priority sibling))
  
  ;; Refuse request, with no compromise, if unrealized
  (when (realized-p contact)
    (multiple-value-bind (success-p new-priority new-sibling)
	(if (managed-p contact)
	    (manage-priority (contact-parent contact) contact priority sibling)
	    (values t priority sibling))
      
      (when (and (or success-p accept-p)
		 (not (top-level-p contact)))	       ; Already done, if top-level
	(setf (window-priority contact new-sibling) new-priority))
      
      (values success-p new-priority new-sibling))))

))
