;;; -*- Mode: Common-Lisp; Package: User; Base: 10.; Patch-File: T -*-
;;; Patch file for CLUE version 6.30
;;; Reason: using-gcontext: Wrap &body with unwind-protect.
;;; Written 11/06/89 17:10:14 by KK,
;;; while running on RIGI from band n817
;;; With SYSTEM 6.22, GC 6.3, VIRTUAL-MEMORY 6.2, MICRONET 6.0, MICRONET-COMM 6.1,
;;;  DISK-IO 6.1, DISK-LABEL 6.0, BASIC-PATHNAME 6.2, MAC-PATHNAME 6.0, NETWORK-SUPPORT-COLD 6.2,
;;;  BASIC-NAMESPACE 6.4, BASIC-FILE 6.4, RPC 6.1, NFS-MX 6.3, EH 6.5, MAKE-SYSTEM 6.2,
;;;  MEMORY-AUX 6.0, COMPILER 6.14, TV 6.17, NVRAM 6.2, UCL 6.0, INPUT-EDITOR 6.0,
;;;  MACTOOLBOX 2.7, METER 6.1, ZWEI 6.7, DEBUG-TOOLS 6.3, WINDOW-MX 6.9, PRINTER 6.3,
;;;  MAC-PRINTER-TYPES 6.1, CLIPBOARD 6.1, TI-CLOS 6.26, CLEH 6.5, NETWORK-PATHNAME 6.0,
;;;  NETWORK-NAMESPACE 6.0, DATALINK 6.0, CHAOSNET 6.1, NETWORK-SUPPORT 6.0, NETWORK-SERVICE 6.2,
;;;  DATALINK-DISPLAYS 6.0, MX-DATALINK 6.1, NAMESPACE-EDITOR 6.3, IP 3.54, NFS-MX-SERVER 6.0,
;;;  MX-SERIAL 6.1, PRINTER-TYPES 6.2, IMAGEN 6.1, MAIL-DAEMON 6.3, MAIL-READER 6.5,
;;;  TELNET 6.0, VT100 6.0, STREAMER-TAPE 6.4, DECNET 1.70, VISIDOC 6.5, PROFILE 6.2,
;;;  Experimental SC 2.0, Experimental CLX 6.6, CLUE 6.29,  microcode 138, Band Name: microExplorer Network (8/17)

#!C
; From file GC-CACHE.LISP#> CLUE; Hotel:
#10R XLIB#:
(COMPILER-LET ((*PACKAGE* (FIND-PACKAGE "XLIB"))
                          (SI:*LISP-MODE* :COMMON-LISP)
                          (*READTABLE* SYS:COMMON-LISP-READTABLE)
                          (SI:*READER-SYMBOL-SUBSTITUTIONS* SYS::*COMMON-LISP-SYMBOL-SUBSTITUTIONS*))
  (COMPILER#:PATCH-SOURCE-FILE "SYS: CLUE; GC-CACHE.#"


(defmacro using-gcontext ((gcontext &rest options &key drawable default clip-ordering &allow-other-keys)
			  &body body)
  ;; Equivalent to `(let ((gcontext (create-gcontext ,@options))) ,@body (free-gcontext ,gcontext))
  ;; Except more efficient because gcontexts are cached.

  (declare-arglist
    (gcontext &rest options &key default drawable
	      function plane-mask foreground background
	      line-width line-style cap-style join-style fill-style fill-rule
	      arc-mode tile stipple ts-x ts-y font subwindow-mode
	      exposures clip-x clip-y clip-mask clip-ordering
	      dash-offset dashes &allow-other-keys)
		   &body body)
  (setq options (copy-list options))
  (remf options :clip-ordering)
  (remf options :default)
  (remf options :drawable)

  (unless drawable (required-arg drawable))

  (let ((setfs nil)
	(value (gensym))
	(drawable-arg (and (getf options :font) (gensym))))
    (do* ((option options (cddr option))
	  (name (car option) (car option)))
	 ((endp option) (setq setfs (nreverse setfs)))
      ;; The CLX GContext stuff was engineered to make NIL values mean
      ;; "unknown value".  Wrap SETF's with checks to ignore keyword
      ;; options with NIL values.
      (let ((val (cadr option))
	    (accessor `(,(xintern 'gcontext- name) ,gcontext ,@(when (eq name :clip-mask)
							   `(,clip-ordering)))))
	(cond ((constantp val)			; Optimize for constant value
	       (when (eval val)
		 (push `(setf ,accessor ,val) setfs)))
	      ((atom val)			; Optimize for variable value
	       (push `(when ,val (setf ,accessor ,val)) setfs))
	      (t (push `(let ((,value ,val))	; Don't evaluate value expression twice
			  (when ,value (setf ,accessor ,value)))
		       setfs)))))
    (when drawable-arg
      (push `(setf (gcontext-display ,gcontext) (drawable-display ,drawable-arg))
	    setfs))

    (if (and default (null setfs))
	`(let ((,gcontext ,default)) ,@body)
      `(let ((,gcontext (allocate-gcontext))
	     ,@(when drawable-arg
		 (prog1 `((,drawable-arg ,drawable))
			(setq drawable drawable-arg))))
	 (declare (type gcontext ,gcontext))
	 (replace (gcontext-local-state ,gcontext)
		  (gcontext-local-state ,(or default '(the gcontext *default-gcontext*))))
	 ,@setfs
	 (setq ,gcontext (find-gcontext ,gcontext ,drawable))
	 (unwind-protect
	     (progn ,@body)
	   (return-gcontext ,gcontext))))))

))
