;;; -*- Mode: Common-Lisp; Package: User; Base: 10.; Patch-File: T -*-
;;; Patch file for CLUE version 6.31
;;; Reason: apply-callback: no longer binds special variable *contact*.
;;; Written 11/06/89 17:19:23 by KK,
;;; while running on RIGI from band n817
;;; With SYSTEM 6.22, GC 6.3, VIRTUAL-MEMORY 6.2, MICRONET 6.0, MICRONET-COMM 6.1,
;;;  DISK-IO 6.1, DISK-LABEL 6.0, BASIC-PATHNAME 6.2, MAC-PATHNAME 6.0, NETWORK-SUPPORT-COLD 6.2,
;;;  BASIC-NAMESPACE 6.4, BASIC-FILE 6.4, RPC 6.1, NFS-MX 6.3, EH 6.5, MAKE-SYSTEM 6.2,
;;;  MEMORY-AUX 6.0, COMPILER 6.14, TV 6.17, NVRAM 6.2, UCL 6.0, INPUT-EDITOR 6.0,
;;;  MACTOOLBOX 2.7, METER 6.1, ZWEI 6.7, DEBUG-TOOLS 6.3, WINDOW-MX 6.9, PRINTER 6.3,
;;;  MAC-PRINTER-TYPES 6.1, CLIPBOARD 6.1, TI-CLOS 6.26, CLEH 6.5, NETWORK-PATHNAME 6.0,
;;;  NETWORK-NAMESPACE 6.0, DATALINK 6.0, CHAOSNET 6.1, NETWORK-SUPPORT 6.0, NETWORK-SERVICE 6.2,
;;;  DATALINK-DISPLAYS 6.0, MX-DATALINK 6.1, NAMESPACE-EDITOR 6.3, IP 3.54, NFS-MX-SERVER 6.0,
;;;  MX-SERIAL 6.1, PRINTER-TYPES 6.2, IMAGEN 6.1, MAIL-DAEMON 6.3, MAIL-READER 6.5,
;;;  TELNET 6.0, VT100 6.0, STREAMER-TAPE 6.4, DECNET 1.70, VISIDOC 6.5, PROFILE 6.2,
;;;  Experimental SC 2.0, Experimental CLX 6.6, CLUE 6.29,  microcode 138, Band Name: microExplorer Network (8/17)

#!C
; From file INTRINSICS.LISP#> CLUE; Hotel:
#10R CLUEI#:
(COMPILER-LET ((*PACKAGE* (FIND-PACKAGE "CLUEI"))
                          (SI:*LISP-MODE* :COMMON-LISP)
                          (*READTABLE* SYS:COMMON-LISP-READTABLE)
                          (SI:*READER-SYMBOL-SUBSTITUTIONS* SYS::*COMMON-LISP-SYMBOL-SUBSTITUTIONS*))
  (COMPILER#:PATCH-SOURCE-FILE "SYS: CLUE; INTRINSICS.#"


(defmacro apply-callback (contact name &rest args)
  "Invoke callback functions associated with NAME for CONTACT,
   using ARGS followed by the callback arguments."
  (let ((functions (gensym))
	(instance  (gensym)))
    `(let* ((,instance  ,contact)
	    (,functions (callback-p ,instance ,name)))
       
	(when ,functions
	  (catch :abort-callback
	    (do* ((functions ,functions         (rest functions))
		  (function  (first ,functions) (first functions)))
		 
		 ((null (rest functions))
		  ;; Return value(s) of last callback function
		  (apply (first function) ,@args (rest function)))
	      
	      (apply (first function) ,@args (rest function))))))))

))
