;;; -*- Mode: Common-Lisp; Package: User; Base: 10.; Patch-File: T -*-
;;; Patch file for CLUE version 6.35
;;; Reason: class-all-superclasses: Enhanced to work for ordinary CLOS classes. 
;;; Written 11/28/89 18:10:02 by KK,
;;; while running on RIGI from band n817
;;; With SYSTEM 6.23, GC 6.3, VIRTUAL-MEMORY 6.2, MICRONET 6.0, MICRONET-COMM 6.1,
;;;  DISK-IO 6.1, DISK-LABEL 6.0, BASIC-PATHNAME 6.2, MAC-PATHNAME 6.0, NETWORK-SUPPORT-COLD 6.2,
;;;  BASIC-NAMESPACE 6.6, BASIC-FILE 6.6, RPC 6.2, NFS-MX 6.4, EH 6.5, MAKE-SYSTEM 6.2,
;;;  MEMORY-AUX 6.0, COMPILER 6.14, TV 6.19, NVRAM 6.2, UCL 6.0, INPUT-EDITOR 6.0,
;;;  MACTOOLBOX 2.7, METER 6.1, ZWEI 6.8, DEBUG-TOOLS 6.3, WINDOW-MX 6.9, PRINTER 6.3,
;;;  MAC-PRINTER-TYPES 6.1, CLIPBOARD 6.1, TI-CLOS 6.26, CLEH 6.5, NETWORK-PATHNAME 6.0,
;;;  NETWORK-NAMESPACE 6.0, DATALINK 6.0, CHAOSNET 6.5, NETWORK-SUPPORT 6.0, NETWORK-SERVICE 6.2,
;;;  DATALINK-DISPLAYS 6.0, MX-DATALINK 6.1, NAMESPACE-EDITOR 6.4, IP 3.56, NFS-MX-SERVER 6.0,
;;;  MX-SERIAL 6.1, PRINTER-TYPES 6.2, IMAGEN 6.1, MAIL-DAEMON 6.3, MAIL-READER 6.6,
;;;  TELNET 6.0, VT100 6.0, STREAMER-TAPE 6.4, DECNET 1.70, VISIDOC 6.5, PROFILE 6.2,
;;;  Experimental SC 2.0, Experimental CLX 6.7, CLUE 6.34,  microcode 138, Band Name: microExplorer Network (8/17)

#!C
; From file CLASS-ALL-SUPERCLASSES.LISP HD1:CLUE: RIGI:
#10R CLUEI#:
(COMPILER-LET ((*PACKAGE* (FIND-PACKAGE "CLUEI"))
                          (SI:*LISP-MODE* :COMMON-LISP)
                          (*READTABLE* SYS:COMMON-LISP-READTABLE)
                          (SI:*READER-SYMBOL-SUBSTITUTIONS* SYS::*COMMON-LISP-SYMBOL-SUBSTITUTIONS*))
  (COMPILER#:PATCH-SOURCE-FILE "SYS: CLUE; DEFCONTACT.#"


(defun class-all-superclasses (class)
  "Return class names for all superclasses specified in the defclass/defcontact form(s)
   defining CLASS and its superclasses. This omits class names such as STANDARD-OBJECT
   and T."
  #-(and ti clos)
  (get class 'parent-classes)
  
  #+(and ti clos)
  (or
    ;; Class defined by defcontact?
    (get class 'parent-classes)

    ;; Ordinary CLOS class?
    (let* ((supers (mapcar #'clos:class-name (cdr (clos:class-precedence-list (find-class class)))))
	   (last   (position 'standard-object supers)))
      (when (plusp last)
	(rplacd (nthcdr (1- last) supers) nil)
	supers))))
))
