;;; -*- Mode: Common-Lisp; Package: User; Base: 10.; Patch-File: T -*-

;;; Reason: Many changes to interactive-stream. [12/08/89]

;;;                           RESTRICTED RIGHTS LEGEND
;;;
;;; Use, duplication, or disclosure by the Government is subject to
;;; restrictions as set forth in subdivision (c)(1)(ii) of the Rights in
;;; Technical Data and Computer Software clause at 52.227-7013.
;;;
;;;   TEXAS INSTRUMENTS INCORPORATED      
;;;   P.O. BOX 2909, M/S 2151             
;;;   AUSTIN, TEXAS 78769                 
;;;
;;; Copyright (C) 1989 Texas Instruments Incorporated.
;;; All rights reserved.

;;; Written 12/04/89 11:11:50 by MARKY,
;;; while running on LIBRA from band LODB
;;; With SYSTEM 6.23, VIRTUAL-MEMORY 6.2, EH 6.5, MAKE-SYSTEM 6.2, MICRONET 6.0, LOCAL-FILE 6.1,
;;;  BASIC-PATHNAME 6.2, NETWORK-SUPPORT-COLD 6.2, BASIC-NAMESPACE 6.6, NETWORK-NAMESPACE 6.0,
;;;  DISK-IO 6.1, DISK-LABEL 6.0, BASIC-FILE 6.6, MAC-PATHNAME 6.0, NETWORK-PATHNAME 6.0,
;;;  COMPILER 6.14, TV 6.19, DATALINK 6.0, CHAOSNET 6.5, GC 6.3, MEMORY-AUX 6.0, NVRAM 6.2,
;;;  SYSLOG 6.2, STREAMER-TAPE 6.4, UCL 6.0, INPUT-EDITOR 6.0, METER 6.1, ZWEI 6.8,
;;;  DEBUG-TOOLS 6.3, NETWORK-SUPPORT 6.0, NETWORK-SERVICE 6.2, DATALINK-DISPLAYS 6.0,
;;;  FONT-EDITOR 6.1, SERIAL 6.0, PRINTER 6.3, MAC-PRINTER-TYPES 6.1, PRINTER-TYPES 6.2,
;;;  IMAGEN 6.1, SUGGESTIONS 6.1, MAIL-DAEMON 6.3, MAIL-READER 6.6, TELNET 6.0, VT100 6.0,
;;;  NAMESPACE-EDITOR 6.4, PROFILE 6.2, VISIDOC 6.5, TI-CLOS 6.26, CLEH 6.5, IP 3.56,
;;;  Experimental CLX 6.7, CLUE 6.32, X11M 6.16, Experimental BUG 11.17, MMON 6.2,
;;;  Experimental SC 2.0, Experimental CONFORMANCE-CHECKER 2.0, Experimental DOCUMENTER 6.0,
;;;   microcode 429, Band Name: REL6-mmon-11/15/89

;;; Changes :
;;; New functions: lozenge-width, prompt-if-any, handle-asynchronous-characters-p,
;;; make-interactive-stream (this is not new, just never coded, it is described in manual)

#!C
; From file STREAM.LISP#> CLUE; Hotel:
#10R CLUEI#:
(COMPILER-LET ((*PACKAGE* (FIND-PACKAGE "CLUEI"))
                          (SI:*LISP-MODE* :COMMON-LISP)
                          (*READTABLE* SYS:COMMON-LISP-READTABLE)
                          (SI:*READER-SYMBOL-SUBSTITUTIONS* SYS::*COMMON-LISP-SYMBOL-SUBSTITUTIONS*))
  (COMPILER#:PATCH-SOURCE-FILE "SYS: CLUE; STREAM.#"


#+(and Explorer CLOS)	;; may 12/04/89 Hook READ function into interactive-stream
(DEFMETHOD (interactive-stream :rubout-handler) (options function &rest args)
  ;Args are args to FUNCTION, the first arg being the stream.
  (APPLY #'stream-rubout-handler zl:self options function args)
  )
#+(and Explorer CLOS) ;; may 12/04/89 needed for ucl:handle-read-function in break loop
(DEFMETHOD (interactive-stream :preemptable-read) (options function &rest args)
  "This just does the same thing as :rubout-handler for now ..."
  ;Args are args to FUNCTION, the first arg being the stream.
  (APPLY #'stream-rubout-handler zl:self options function args)
  )

;; may 12/04/89 Fix cosmetics.
(defun draw-lozenged-string (window gcontext x0 y0 string font)
  "Display string inside a lozenge at X0 Y0."
  (declare (values right-coordinate bottom-coordinate))
  (multiple-value-bind (width ascent DESCENT)	;; may 11/22/89 
      (text-extents font string)
    (let* (;; Put some pixels to the top and bottom of the string and still stay inside lineheight.
	   (lozenge-height (+ ascent descent))	;; may 11/22/89  
	   (wid (+ lozenge-height width))
	   (xpos (+ x0 (floor lozenge-height 2)))	;; may 11/29/89 was ceiling
	   ;;(ypos (+ y0 descent))	;; may 11/22/89 
	   )
      ;; Put the string then the box around it.
      (using-gcontext (gc :drawable (contact-root window) :default gcontext :font font)
	(draw-glyphs window gc xpos
		     y0 ;ypos ;; may 12/04/89 
		     string))
      (draw-lozenge window gcontext wid lozenge-height x0 (- y0 ascent 1))	;; may 11/29/89 was 2
      (values wid lozenge-height))))

;; may 11/29/89 Added for #\rubout calculation.
(DEFUN lozenge-width (CHAR font); gcontext)
  ;; Tied closely to DRAW-LOZENGED-STRING calulations : (let (( .. (wid (+ lozenge-height width)) ..)))
  (LET ((ch-name (CHAR-NAME char)))
    (multiple-value-bind (width ascent descent)
	(text-extents font ch-name)
      (+ ascent descent width))))


;; may 11/30/89 From code in simple-rubout-handler.
;; Need to be able to get the width of the prompt string.
(DEFUN prompt-if-any (STREAM &optional prompt)
  "Print prompt on STREAM. *rhb* must be bound.
PROMPT defaults to the :reprompt or :prompt option
in *rhb* options - whichever is found first, if any."
  (SETQ prompt (or prompt
		   (getf (rhb-options *rhb*) :reprompt)
		   (getf (rhb-options *rhb*) :prompt)))
  (cond ((null prompt))
	((stringp prompt)
	 (IF stream
	     (stream-write-string stream prompt)
	     prompt)) ;; just return string if stream is nil, as format would do
	#+explorer ;; explorer error-handler hack
	;; old zetalisp required 2 arguments to prompt and read.
	((eq prompt 'sys:prompt-and-read-prompt-function)
	 (funcall prompt stream nil))
	(t
	 (funcall prompt stream))))


;; may 12/01/89 Added recording for output history.  Although we
;; (original author, actually) are using the size of #\n to calculate
;; pixels and the actual char #\space to put in history - it is only
;; intended to work for fixed-width fonts.  Variable fonts require a
;; good guess - but anything is better than NO guess at all.
(defmethod (interactive-stream :increment-cursorpos) (dx dy &optional units)
  "UNITS can be :pixel (default) or :character.
This is called by format:format-ctl-tab and anyone else that
won't mind the output history being recorded as the number of space chars
needed to redisplay the same cursor movement, if possible."
  ;; A good test of this is (si:print-herald), then control-l
  (declare (notinline char-width))
  (LET (newx newy
	(ch-width (char-width font (char-int #\n))))
    (if (eq units ':character)
	(SETQ newx (+ cursor-x (* dx ch-width))
	      newy (+ cursor-y (* dy line-height)))
	;; else assume pixels (default)
	(SETQ newx (+ cursor-x dx)
	      newy (+ cursor-y dy)))
    (UNLESS *no-stream-history-p*
      (DOTIMES (i (CEILING (MAX 0 (- newx cursor-x)) ch-width))
	(VECTOR-PUSH-EXTEND #\space (car output-history))))
    (stream-move-cursor zl:self newx newy)))

;; may 12/04/89 Added to prevent asynchronous chars, like BREAK from
;; being handled twice.
#+ti
(defun handle-asynchronous-characters-p (char)
  ;; This handles things like abort, break, system and terminal for TI Explorers
  (or (assoc char tv:kbd-intercepted-characters)
      (assoc char tv:kbd-global-asynchronous-characters)
      (assoc char tv:kbd-standard-asynchronous-characters)))

;; may 11/29/89
;; 1. added lozenge string rubout ability
;; 2. able to rubout newline onto previous line
;; 3. added tab rubout ability
;; 4. added (Aaron Larson) fixes to handle uppercase c-l an c-u chars
;; 5. prevented stream-history for code after display for control-l key
;;    by moving redisplay of prompt and current *rhb* into display function.
;; 6. Allowed BREAK/RESUME to work (mostly) - si:*use-old-break* t or nil
;; 7. added #\clear-screen
(defun simple-rubout-handler-edit (contact)
  ;; This is the "guts" of the rubout handler, where the editing occurs
  ;; This needs LOTS more editing commands!
  (do ((rubbed-out-some nil)
       (*rubout-handler* 'tyi)
       (ch))
      (nil) ;; forever
    (setq ch (stream-read-char contact))
    (case ch
      ((#\control-u #\control-U)				;CLEAR-INPUT flushes all buffered input
       (setf (rhb-fill-pointer *rhb*) 0)
       (setq rubbed-out-some t)			;Will need to throw out
       (stream-write-char contact ch)		;Echo and advance to new line
       (stream-write-char contact #\Newline))
      ((#\control-l #\control-L)				;Retype ALL visible area
	 (display contact))	;; may 12/01/89
      ;; may 12/04/89 Added
      #+ti ((#\clear-screen)						;Retype buffered input
       (stream-clear-output contact)
       (prompt-if-any contact)
       (stream-write-string contact (rhb-buffer *rhb*) 0 (rhb-fill-pointer *rhb*)))
      (#\Rubout
       (let ((len (rhb-fill-pointer *rhb*)))
	 (unless (zerop len)
	   (setf (rhb-fill-pointer *rhb*) (setq len (1- len)))
	   ;; may 12/04/89 Change output-history, too, for control-l
	   (LET* ((THIS-LINE (CAR (SLOT-VALUE CONTACT 'OUTPUT-HISTORY)))
		  (THIS-LINE-LEN (AND THIS-LINE (LENGTH THIS-LINE))))
	     (WHEN (PLUSP THIS-LINE-LEN)
	       (SETF (FILL-POINTER THIS-LINE) (1- THIS-LINE-LEN))))
	   (LET* ((rub-ch (aref (rhb-buffer *rhb*) len))
		  (new-y (stream-cursor-y contact))
		  (new-x (cond ((graphic-char-p rub-ch)	;; may 11/29/89 
				(- (stream-cursor-x contact)
				   (char-width (stream-font contact)
					       (char-int rub-ch))))
			       ((CHAR= rub-ch #\tab)
				(- (stream-cursor-x contact)
				   (stream-tab-width contact)))
			       ((CHAR= rub-ch #\newline)
				(SETQ new-y (MAX 0 (- new-y (stream-line-height contact))))
				;; return new-x at end of previous line
				(+ (text-width (stream-font contact)
					       (rhb-buffer *rhb*) 
					       :start 0 :end (rhb-fill-pointer *rhb*))
				   (text-width (stream-font contact) (prompt-if-any nil)))) ;; returns 0 for nil prompt
			       (t (- (stream-cursor-x contact)
				     (lozenge-width rub-ch (stream-lozenge-font contact)))))))	;; may 11/29/89 
	     (set-cursorpos contact :x new-x :y new-y)
	     (clear-eol contact)
	     (setq rubbed-out-some t))
	   (when (zerop len) ;; when all rubbed out
	     (setf (rhb-scan-pointer *rhb*) 0)
	     (throw 'rubout-handler t)))))
      (otherwise
       (if (plusp (char-bits ch))
	   (bell (contact-display contact)) ;; unknown command
	 ;; Echo character
	 #+ti
	 (WHEN (handle-asynchronous-characters-p ch)
	   (setf (rhb-scan-pointer *rhb*) 0)
	   (stream-fresh-line contact)
	   (prompt-if-any contact (GET (rhb-options *rhb*) :reprompt))
	   (THROW 'rubout-handler t))
	 (let ((fill-pointer (rhb-fill-pointer *rhb*)))
	   (stream-write-char contact ch)
	   ;; Put character in buffer, after first ensuring its big enough
	   (when (> (setf (rhb-fill-pointer *rhb*) (1+ fill-pointer))
		    (array-total-size (rhb-buffer *rhb*)))
	     (setf (rhb-buffer *rhb*)
		   (adjust-array (rhb-buffer *rhb*) (* 2 fill-pointer))))
	   (setf (aref (rhb-buffer *rhb*) fill-pointer) ch)
	   (cond (rubbed-out-some
		  ;; Make the reader closure re-read all input from the beginning
		  (setf (rhb-scan-pointer *rhb*) 0)
		  (throw 'rubout-handler t))
		 (t
		  ;; New character at the end of the buffer, just return it.
		  (setf (rhb-scan-pointer *rhb*) (rhb-fill-pointer *rhb*))
		  (return ch)))))))))


(defmethod end-of-page ((interactive-stream interactive-stream))
  ;; Scroll up one line
  (with-slots (cursor-x cursor-y height width line-height output-history-top (gc gcontext))
	      (the interactive-stream interactive-stream)
    (let* ((bottom-line (min cursor-y height))
	   (clear-height (- height bottom-line)))
      (copy-area interactive-stream gc 0 line-height width bottom-line
		 interactive-stream 0 0)
      (when (plusp clear-height)
	(clear-area interactive-stream :x 0 :y bottom-line
		    :width width :height clear-height))
      (pop output-history-top))
    (decf cursor-y line-height)
    #+IGNORE ;; may 12/04/89 (for sn) This draw-cursor is an extra.
    (draw-cursor interactive-stream cursor-x cursor-y gc)))

;; may 11/30/89 from (Aaron Larson) & (sayuri nishimura) & myself
;; 1. Fixes chopped off initial cursor display bug.
;; 2. together with change in simple-rubout-handler-edit fixes missing
;;    initial rubout-handler prompt.
(defmethod display ((self interactive-stream) &optional x y width height &key)
  (declare (ignore x y width height))
  (let ((win self)
	(*no-stream-history-p* t))	;; may 11/30/89 moved here from inside DO
    (clear-area win)
    (with-slots (cursor-x cursor-y line-height font gcontext
			  output-history output-history-top) self
      (setf cursor-x 0
	    cursor-y (- line-height (max-char-descent font)))
      ;;display the cursor
      (draw-cursor self cursor-x cursor-y gcontext :fill-p t)	;; may 11/30/89 had cursor-x twice
      (do ((history output-history-top (cdr history)))
	  ((eq history output-history))
	  (stream-write-string self (car history))
          (stream-move-cursor self 0 (+ cursor-y line-height)))
      (stream-write-string self (car output-history) 0
			   (fill-pointer (car output-history)))
      ;; may 12/08/89 *rhb* may not be bound so below is NOT equivalent to above.
      ;;(prompt-if-any self)
      ;;(stream-write-string self (rhb-buffer *rhb*) 0 (rhb-fill-pointer *rhb*))
      )))

;; may 11/30/89 (for sn) Keeps output-history manageable and fixes
;; some more-processing bugs.
(defmethod stream-new-line ((self interactive-stream))
  (with-slots (cursor-x cursor-y line-height output-history 
			(contact-height height) more-height font) self
    ;; may 11/30/89 This method replaced form below in some places.
    (SETF CURSOR-X 0
	  CURSOR-Y (+ CURSOR-Y LINE-HEIGHT))
    ;; Free up some space
    (when (and (< 512 (array-total-size (car output-history)))
	       (< (fill-pointer (car output-history)) 256))
      (adjust-array (car output-history) 256))
    (unless *no-stream-history-p*
	    (pop output-history)
	    (unless (car output-history)
		    (setf (car output-history)
			  (make-array 256 :fill-pointer 0 :element-type 'string-char :adjustable t)))
	    (setf (fill-pointer (car output-history)) 0))
    (when (> (+ cursor-y (max-char-descent font)) contact-height)
	  ;; [10/16/89 sn] it is possible to get here because display is called when
	  ;;; the window gets smaller
	  #+ignore
	  (when *no-stream-history-p*
	     (error "EOP during refresh")) ;; should never get here...
	  (end-of-page self))
    (when (and more-height (not *no-stream-history-p*)
	       (minusp (decf more-height line-height)))
	  (more-processing self))))

;; may 12/04/89 (for sn)
;; This fixes the extra cursor in col 0 since now using stream-new-line
;; and bug with control-l when screen had line-wrap.
(defmethod stream-write-char ((self interactive-stream) character)
  (when (integerp character)		   ;; Kludge for old zetalisp code
    (setq character (int-char character)))
  (with-slots ( cursor-x cursor-y (contact-width width) gcontext font
	       output-history  tab-width lozenge-font) self
    (draw-cursor self cursor-x cursor-y gcontext :erase-p t) 
    (if (graphic-char-p character)
	(let ((width (char-width font (char-int character))))
	  (when (> (+ cursor-x width) contact-width) ;; Wrap on wide lines
	    (let ((*no-stream-history-p* t))	;; may 11/30/89 
	      (stream-new-line self)))		;; may 12/04/89 
	  (draw-glyph self gcontext cursor-x cursor-y (char-int character)
		      :width width :size 8 :translate #'xlib::translate-default)
	    (incf cursor-x width)
	    (unless *no-stream-history-p*
	      (vector-push-extend character (car output-history))))
      (progn ;; Undrawable character
	(case character
	  (#\newline (stream-new-line self))
	  (#\backspace (let ((width (char-width font (font-default-char font))))
			 
		  (setf cursor-x (max 0 (- cursor-x width))))
		(unless *no-stream-history-p*
		  (vector-push-extend character (car output-history))))
	  (#\tab (setf cursor-x (+ cursor-x tab-width))
		 (unless *no-stream-history-p*
		   (vector-push-extend character (car output-history))))
	  (otherwise
	   (unless *no-stream-history-p*
	     (vector-push-extend character (car output-history)))
	   (incf cursor-x
		 (draw-lozenged-string self gcontext cursor-x cursor-y
				       (string (or (char-name character)
						   (format nil "~:@C" (char-int character))))
				       lozenge-font))))))
    (draw-cursor self cursor-x cursor-y gcontext))
  character)

;; may 11/30/89 (for sn), Modified to hide output-history for stream-write-char.
(defmethod stream-write-string ((self interactive-stream) string &optional (start 0) end)
  (unless end (setq end (length string)))
  (do ((i start new-end)
       (new-end end end)
       (index 0))
      ((>= i end) string)
    (declare (type integer i)
	     (type (or null integer) index))
    (with-slots ((contact-width width) cursor-x cursor-y font gcontext) self
      (draw-cursor self cursor-x cursor-y gcontext :erase-p t)
      ;; may 12/04/89 Change to wrap on max instead of average and hide newline from history.
      (when (> (+ cursor-x (xlib:max-char-width font)) contact-width) ;; Wrap on wide lines
	(let ((*no-stream-history-p* t))
	  (stream-new-line self)))
      (let ((line-width (- contact-width cursor-x))
	    (string-width 0))
	(multiple-value-setq (string-width index)
	  (text-width font string :start i :end end))
	(when index (setq new-end index))
	(when (> string-width line-width) ;; Clip strings longer than remaing line width
	  (setq new-end (text-within-width line-width font string :start i :end new-end)
		string-width line-width))
	(setq index
	      (draw-glyphs self gcontext cursor-x cursor-y
			   string :start i :end new-end :width string-width))
	(incf cursor-x string-width))
      (draw-cursor self cursor-x cursor-y gcontext)
      ;; do special characters not printed	
      (when index
	(LET ((*no-stream-history-p* t))	;; may 12/04/89 
	  (stream-write-char self (aref string index))
	  (setf new-end (+ index 1))))))
  ;; Save history
  (unless *no-stream-history-p*
    (with-slots (output-history) self
      (let* ((history (car output-history))
	     (j (fill-pointer history))
	     (h (+ j (- end start))))
	;; Grow history if necessary
	(when (> h (array-total-size history))
	  (setq history (adjust-array history (+ h 80)))
	  (setf (car output-history) history))
	(setf (fill-pointer history) h)
	(replace history string :start1 j :end1 h :start2 start :end2 end))))
  )

;;;;;;;


(defmethod stream-save-key ((stream interactive-stream))
  (with-event (character display)
    (let ((char character))
      (when (characterp char)
	;; translate return to newline.
	#+(and unix allegro)	;; may 12/04/89  added (for al)
	(if (char= char #\return)
	    (setq char #\newline))
	(append-characters display char)))
    t))

(defmethod stream-move-cursor ((self interactive-stream) &optional x y)
  (with-slots (cursor-x cursor-y gcontext font) self
    (let ((oldx cursor-x)
	  (oldy cursor-y))
      (when x (setf cursor-x x))
      (when y (setf cursor-y y))	;; may 12/04/89
      (let ((newx cursor-x)
	    (newy cursor-y))
	(draw-cursor self oldx oldy gcontext :erase-p t)
	(draw-cursor self newx newy gcontext :fill-p t)
	;; ********************* NEED TO ADD CURSOR OBJECT *****************
	newx newy oldx oldy nil
	))))

(defun simple-rubout-handler (contact options function)
  ;; A rubout handler in the common-windows tradition
  ;; Options include:
  ;; :full-rubout flag    If the user erases all of the characters then presses
  ;;                      the rubout character once more, control is returned
  ;;			  from the input editor immediately.  Two values are
  ;;			  returned: NIL and FLAG.  In the absence of this option,
  ;;			  the input editor simply waits for more characters.
  ;;
  ;; :prompt string	  string to display or function of one argument (the contact)
  ;; :reprompt string
  ;; :initial-input string
  ;; :initial-input-pointer card16
  (let ((*rhb* (allocate-rhb)))
    (unwind-protect
	(progn
	  (setf (rhb-options *rhb*) options)
	  (setf (rhb-fill-pointer *rhb*) 0)	   ; number of characters in the buffer
	  (setf (rhb-scan-pointer *rhb*) 0)	   ; number of characters sent to application

	  ;; PROMPT option
	  (prompt-if-any contact (getf options :prompt))	;; may 12/04/89 

	  ;; INITIAL-INPUT option
	  (let ((initial-input (getf options :initial-input)))
	    (when initial-input
	      (let* ((initial-input-pointer (getf options :initial-input-pointer 0))
		     (length (- (length initial-input) initial-input-pointer))
		     (size (array-total-size (rhb-buffer *rhb*))))
		(when (> length size)
		  (setf (rhb-buffer *rhb*) (adjust-array (rhb-buffer *rhb*) (+ length size))))
		(replace (rhb-buffer *rhb*) initial-input :start1 initial-input-pointer)
		(setf (rhb-fill-pointer *rhb*) length)
		(stream-write-string contact initial-input initial-input-pointer))))

	  (when (slot-value (the interactive-stream contact) 'unreadp) ; Make sure type ahead is processed
	    (simple-rubout-handler-edit contact)		    ; by rubout handler, not just by TYI
	    (setf (rhb-scan-pointer *rhb*) 0))
	  (do ((*rubout-handler* 'read)	   ;Establish rubout handler
	       #+ti (si:rubout-handler t)  ;Needed for explorer compatability
	       )
	      (nil)
	    (catch 'rubout-handler		; Throw here when rubbing out
	      (progn
		#+cleh				; Hopefully, someday everyone will use this
		(conditions:handler-case
		    (return (funcall function))
		  (error (condition) (princ condition)))
		#+(and lispm (not cleh))
		(si:catch-error			; If a read-error occurs, print a message and loop back
		  (return			; Exit rubbout handler when read function returns
		    (funcall function)))	; Call read function
		#+(and kcl (not cleh))
		(multiple-value-bind (tag value)
		    (si:error-set `(funcall ',function))
		  (unless tag (return value)))
		#+(and excl (not cleh))
		(multiple-value-bind (tag value)
		    (excl:error-set (funcall function) :announce)
		  (unless tag (return value)))
		#-(or cleh lispm kcl excl)
		(return (funcall function))
		;; We come here after read errors (catch-error caught)
		(STREAM-fresh-line contact)		; Echo the rubout handler buffer	;; may 11/30/89 (for sn)
		(stream-write-string contact (rhb-buffer *rhb*) 0 (rhb-fill-pointer *rhb*))
		(loop (stream-read-char contact))))	; and force user to edit it
	    ;; Come here on throw to 'rubout-handler
	    ;; Maybe return when user rubs all the way back
	    (and (zerop (rhb-fill-pointer *rhb*))
		 (let ((full-rubout-option (getf options :full-rubout)))
		   (and full-rubout-option (return (values nil full-rubout-option)))))))
      (deallocate-rhb *rhb*))))

;; may 12/04/89 Added function documented in manual but never coded?
(DEFUN cluei:make-interactive-stream (&rest keywords
				&key (type 'interactive-stream)
				&allow-other-keys)
  "Creates and returns an interactive-stream contact STREAM. The contact-display
associated with the returned stream is automatically created. Keywords can include
any that are understood by OPEN-CONTACT-DISPLAY, MAKE-CONTACT for the TYPE of
stream to be created, and for XLIB:CREATE-WINDOW."
  ;; must have a :parent for make-contact
  (SETF (GETF keywords :parent)
	(OR (GETF keywords :parent)
	    ;; may 12/04/89 
	    ;; This does not seem right ? How can we open a display - there may be a display
	    ;; already opened. The doc in the manual says the display is created automatically.
	    ;; I think the :parent had better be a display in the normal case!
	    (open-contact-display
	      'cluei:lisp-listener ;; this is (not?) used by resource database
	      ;; for the width & height of the listener - this is the PARENT of the
	      ;; listener ... 
	      :authorization-data 	(GETF keywords :authorization-data)
	      :authorization-name 	(GETF keywords :authorization-name)
	      :class 			(GETF keywords :class)
	      :before-actions 		(GETF keywords :before-actions)
	      :default-screen 		(OR (GETF keywords :default-screen) 0)
	      :display 			(GETF keywords :display)
	      :host 			(OR (GETF keywords :host)
					    *default-host*
					    "lm")
	      :protocol 		(GETF keywords :protocol)
	      :root-class 		(OR (GETF keywords :root-class) 'cluei:root)
	      )))
  (SETF (GETF keywords :name) (OR (GETF keywords :name) 'cluei:listener)) ;; used by resource database
  (PROG1 (APPLY #'make-contact type keywords)
	 ;; Realize it or else the :prompt rubout handler option will cause access
	 ;; gcontext before :exposure when it is created by REALIZE .
	 (update-state (GETF keywords :parent))
	 ))
))




