;;; -*- Mode: Common-Lisp; Package: User; Base: 10.; Patch-File: T -*-

;;; Reason: change-geometry: Accept trivially if parent not realized.

;;;                           RESTRICTED RIGHTS LEGEND
;;;
;;; Use, duplication, or disclosure by the Government is subject to
;;; restrictions as set forth in subdivision (c)(1)(ii) of the Rights in
;;; Technical Data and Computer Software clause at 52.227-7013.
;;;
;;;   TEXAS INSTRUMENTS INCORPORATED      
;;;   P.O. BOX 2909, M/S 2151             
;;;   AUSTIN, TEXAS 78769                 
;;;
;;; Copyright (C) 1989 Texas Instruments Incorporated.
;;; All rights reserved.

;;; Written 02/12/90 16:32:25 by ARELLANO,
;;; while running on Quintillian from band LOD2
;;; With SYSTEM 6.29, VIRTUAL-MEMORY 6.3, EH 6.6, MAKE-SYSTEM 6.2, MICRONET 6.0, LOCAL-FILE 6.1,
;;;  BASIC-PATHNAME 6.3, NETWORK-SUPPORT-COLD 6.2, BASIC-NAMESPACE 6.7, NETWORK-NAMESPACE 6.1,
;;;  DISK-IO 6.2, DISK-LABEL 6.0, BASIC-FILE 6.7, MAC-PATHNAME 6.0, NETWORK-PATHNAME 6.0,
;;;  COMPILER 6.14, TV 6.23, DATALINK 6.0, CHAOSNET 6.5, GC 6.3, MEMORY-AUX 6.0, NVRAM 6.2,
;;;  SYSLOG 6.2, STREAMER-TAPE 6.5, UCL 6.0, INPUT-EDITOR 6.0, METER 6.1, ZWEI 6.12,
;;;  DEBUG-TOOLS 6.4, NETWORK-SUPPORT 6.1, NETWORK-SERVICE 6.2, DATALINK-DISPLAYS 6.0,
;;;  FONT-EDITOR 6.1, SERIAL 6.0, PRINTER 6.3, MAC-PRINTER-TYPES 6.1, PRINTER-TYPES 6.2,
;;;  IMAGEN 6.1, SUGGESTIONS 6.1, MAIL-DAEMON 6.4, MAIL-READER 6.7, TELNET 6.1, VT100 6.0,
;;;  NAMESPACE-EDITOR 6.4, PROFILE 6.2, VISIDOC 6.7, TI-CLOS 6.37, CLEH 6.5, IP 3.57,
;;;  Experimental CLX 6.8, CLUE 6.48, X11M 6.20, Experimental BUG 11.18, Experimental SC 3.0,
;;;  Experimental CLIO 15.0,  microcode 429, Band Name: REL 6.0 + SLE 11/28

#!C
; From file INTRINSICS.LISP#> CLUE; Hotel:
#10R CLUEI#:
(COMPILER-LET ((*PACKAGE* (FIND-PACKAGE "CLUEI"))
                          (SI:*LISP-MODE* :COMMON-LISP)
                          (*READTABLE* SYS:COMMON-LISP-READTABLE)
                          (SI:*READER-SYMBOL-SUBSTITUTIONS* SYS::*COMMON-LISP-SYMBOL-SUBSTITUTIONS*))
  (COMPILER#:PATCH-SOURCE-FILE "SYS: CLUE; INTRINSICS.#"


(defun change-geometry (contact &key x y width height border-width accept-p)
  "Geometry management.  Nil values indicate parameters the geometry manager can change at will.
   Returns T when the request is granted, NIL when refused or NIL x y width height border-width
   when a compromise is offered. When ACCEPT-P, always take the geometry manager's compromise."
  (declare (type contact contact)
	   (type (or null int16) x y)
	   (type (or null card16) width height border-width)
	   (type boolean accept-p)
	   (values success-p x y width height border-width))
  (unless (destroyed-p contact)
    (let ((accept-p (or accept-p (top-level-p contact))))
      (with-slots ((contact-x x)
		   (contact-y y)
		   (contact-width width)
		   (contact-height height)
		   (contact-border-width border-width)
		   (contact-parent parent)) (the basic-contact contact)
	(multiple-value-bind (success-p x1 y1 width1 height1 border-width1)
	    (if (and (managed-p contact) (realized-p contact-parent))
		(manage-geometry contact-parent contact x y width height border-width)
		(values t
			(or x contact-x) (or y contact-y)
			(or width contact-width) (or height contact-height)
			(or border-width contact-border-width)))
	  (if (or success-p (and accept-p x1))
	      (xlib:with-state (contact)
		(unless success-p ;; Accept a compromise geometry
		  (unless (manage-geometry contact-parent contact x1 y1 width1 height1 border-width1)
		    (error "manage-geometry failed to accept its own compromise geometry")))
		(when (or (not (= contact-x x1))
			  (not (= contact-y y1)))
		  (move contact x1 y1))
		(when (or (not (= contact-width width1))
			  (not (= contact-height height1))
			  (not (= contact-border-width border-width1)))
		  (resize contact width1 height1 border-width1))))

	  (values success-p x1 y1 width1 height1 border-width1))))))

))
