;;; -*- Mode: Common-Lisp; Package: User; Base: 10.; Patch-File: T -*-

;;; Reason: interactive-stream: fix CLOS problem by reloading defcontact form after compiling with CLOS 6.12.

;;;                           RESTRICTED RIGHTS LEGEND
;;;
;;; Use, duplication, or disclosure by the Government is subject to
;;; restrictions as set forth in subdivision (c)(1)(ii) of the Rights in
;;; Technical Data and Computer Software clause at 52.227-7013.
;;;
;;;   TEXAS INSTRUMENTS INCORPORATED      
;;;   P.O. BOX 2909, M/S 2151             
;;;   AUSTIN, TEXAS 78769                 
;;;
;;; Copyright (C) 1989 Texas Instruments Incorporated.
;;; All rights reserved.

;;; Patch file for CLUE version 6.7
;;; Written 07/05/89 13:23:41 by KK,
;;; while running on Sierra from band LOD2
;;; With SYSTEM 6.10, VIRTUAL-MEMORY 6.1, EH 6.3, MAKE-SYSTEM 6.0, MICRONET 6.0, LOCAL-FILE 6.0,
;;;  BASIC-PATHNAME 6.0, NETWORK-SUPPORT-COLD 6.0, BASIC-NAMESPACE 6.1, NETWORK-NAMESPACE 6.0,
;;;  DISK-IO 6.0, DISK-LABEL 6.0, BASIC-FILE 6.2, MAC-PATHNAME 6.0, NETWORK-PATHNAME 6.0,
;;;  COMPILER 6.6, TV 6.12, DATALINK 6.0, CHAOSNET 6.0, GC 6.3, MEMORY-AUX 6.0, NVRAM 6.1,
;;;  SYSLOG 6.1, STREAMER-TAPE 6.3, UCL 6.0, INPUT-EDITOR 6.0, METER 6.1, ZWEI 6.3,
;;;  DEBUG-TOOLS 6.3, NETWORK-SUPPORT 6.0, NETWORK-SERVICE 6.1, DATALINK-DISPLAYS 6.0,
;;;  FONT-EDITOR 6.1, SERIAL 6.0, PRINTER 6.2, MAC-PRINTER-TYPES 6.1, PRINTER-TYPES 6.0,
;;;  IMAGEN 6.0, SUGGESTIONS 6.0, MAIL-DAEMON 6.2, MAIL-READER 6.0, TELNET 6.0, VT100 6.0,
;;;  NAMESPACE-EDITOR 6.0, PROFILE 6.1, VISIDOC 6.2, Inconsistent TI-CLOS 6.12, CLEH 6.4,
;;;  IP 3.47, Experimental BUG 11.10, Experimental CLX 6.2, CLUE 6.6, X11M 6.6, Experimental SC 1.3,
;;;   microcode 429, Band Name: Release 6.0 + SLE 6/5

#!C
; From file STREAM.LISP#> CLUE; MR-X:
#10R CLUE#:
(COMPILER-LET ((*PACKAGE* (FIND-PACKAGE "CLUE"))
                          (SI:*LISP-MODE* :COMMON-LISP)
                          (*READTABLE* SYS:COMMON-LISP-READTABLE)
                          (SI:*READER-SYMBOL-SUBSTITUTIONS* SYS::*COMMON-LISP-SYMBOL-SUBSTITUTIONS*))
  (COMPILER#:PATCH-SOURCE-FILE "CLUE: CLUE; STREAM.#"


(defcontact interactive-stream (contact #+(and Explorer CLOS) TICLOS:FUNDAMENTAL-CHARACTER-OUTPUT-STREAM
					#+(and Explorer CLOS) TICLOS:FUNDAMENTAL-CHARACTER-INPUT-STREAM)
  ((gcontext :type (or null gcontext) :initform nil :reader stream-gcontext)
   (font :type font :reader stream-font
	 :initform 'fixed)
   (cursor-x :initform 0 :type integer :reader stream-cursor-x)	   ; Cursor X
   (cursor-y :initform 0 :type integer :reader stream-cursor-y)	   ; Cursor Y
   (line-height :initform 0 :type integer :accessor stream-line-height) ; rasters per character line.
   (tab-width :initform 0 :type integer :accessor stream-tab-width)   ; Number of pixels in a tab
   (lozenge-font :type font :accessor stream-lozenge-font
		 :initform 'micro)
   (unreadp :type boolean :initform nil)	; True if a character was unread (already echoed)
   (more-height :initform t :type (or boolean card16) :accessor stream-more-height)
				; When this is non-nil, Every time a new line is output, this is
				; decremented by LINE-HEIGHT.  When this is less than zero,
				; MORE-PROCESSING is called.  MORE-HEIGHT gets set to
				; the value of (RESET-MORE-HEIGHT stream) in STREAM-READ-CHAR,
   				; STREAM-CLEAR-OUTPUT and :after REALIZE.
   (rubout-handler-function :initform 'simple-rubout-handler	   ; Rubbout handler function
			    :accessor stream-rubout-handler-function)
   (output-history-top :initform nil)	   ; Points to the output history line at the top of the window
   (output-history :initform nil)	   ; Circular List of strings
   (output-history-size :initform 100)
   )
  (:resources
    gcontext
    font
    (event-mask :initform '(:exposure))
    cursor-x cursor-y more-height line-height tab-width lozenge-font
    rubout-handler-function output-history-size
    (background :initform :black))
  )

))
