;;; -*- Mode: Common-Lisp; Package: User; Base: 10.; Patch-File: T -*-

;;; Reason: wm-shell: add initargs for non-resource hints (wm-group, wm-keyboard-input)

;;;                           RESTRICTED RIGHTS LEGEND
;;;
;;; Use, duplication, or disclosure by the Government is subject to
;;; restrictions as set forth in subdivision (c)(1)(ii) of the Rights in
;;; Technical Data and Computer Software clause at 52.227-7013.
;;;
;;;   TEXAS INSTRUMENTS INCORPORATED      
;;;   P.O. BOX 149149, M/S 2151             
;;;   AUSTIN, TEXAS 78714-9149                 
;;;
;;; Copyright (C) 1989 Texas Instruments Incorporated.
;;; All rights reserved.

;;; Patch file for CLUE version 6.71
;;; Written 03/14/90 12:05:23 by KK,
;;; while running on RIGI from band PB28
;;; With SYSTEM 6.30, GC 6.3, VIRTUAL-MEMORY 6.3, MICRONET 6.0, MICRONET-COMM 6.2,
;;;  DISK-IO 6.2, DISK-LABEL 6.0, BASIC-PATHNAME 6.4, MAC-PATHNAME 6.0, NETWORK-SUPPORT-COLD 6.2,
;;;  BASIC-NAMESPACE 6.7, BASIC-FILE 6.8, RPC 6.2, NFS-MX 6.5, EH 6.6, MAKE-SYSTEM 6.2,
;;;  MEMORY-AUX 6.0, COMPILER 6.14, TV 6.24, NVRAM 6.2, UCL 6.0, INPUT-EDITOR 6.0,
;;;  MACTOOLBOX 2.14, METER 6.1, ZWEI 6.13, DEBUG-TOOLS 6.4, WINDOW-MX 6.10, PRINTER 6.3,
;;;  MAC-PRINTER-TYPES 6.1, CLIPBOARD 6.1, TI-CLOS 6.40, CLEH 6.5, NETWORK-PATHNAME 6.1,
;;;  NETWORK-NAMESPACE 6.1, DATALINK 6.0, CHAOSNET 6.5, NETWORK-SUPPORT 6.1, NETWORK-SERVICE 6.2,
;;;  DATALINK-DISPLAYS 6.0, MX-DATALINK 6.1, NAMESPACE-EDITOR 6.4, IP 3.58, NFS-MX-SERVER 6.0,
;;;  MX-SERIAL 6.1, PRINTER-TYPES 6.2, IMAGEN 6.1, MAIL-DAEMON 6.5, MAIL-READER 6.7,
;;;  TELNET 6.1, VT100 6.0, STREAMER-TAPE 6.5, DECNET 1.72, VISIDOC 6.7, PROFILE 6.2,
;;;  Experimental CLX 6.8, CLUE 6.69, Experimental BUG 11.18, Experimental SC 3.0,
;;;  Experimental CLIO 18.0,  microcode 139, Band Name: microExplorer Network + SLE (11/28)

#!C
; From file SHELLS.LISP#> CLUE; Hotel:
#10R CLUEI#:
(COMPILER-LET ((*PACKAGE* (FIND-PACKAGE "CLUEI"))
                          (SI:*LISP-MODE* :COMMON-LISP)
                          (*READTABLE* SYS:COMMON-LISP-READTABLE)
                          (SI:*READER-SYMBOL-SUBSTITUTIONS* SYS::*COMMON-LISP-SYMBOL-SUBSTITUTIONS*))
  (COMPILER#:PATCH-SOURCE-FILE "SYS: CLUE; SHELLS.#"


(defmethod initialize-instance :after ((shell wm-shell) &key
				       wm-base-height wm-base-width wm-delta-height wm-delta-width              
				       wm-initial-state wm-gravity
				       wm-max-aspect wm-max-height wm-max-width            
				       wm-min-aspect wm-min-height wm-min-width
				       wm-user-specified-position-p wm-user-specified-size-p
				       wm-group wm-keyboard-input
				       &allow-other-keys)

  ;; Initialize hints from initargs
  (when wm-base-height (setf (wm-base-height shell) wm-base-height))
  (when wm-base-width (setf (wm-base-width shell) wm-base-width))
  (when wm-delta-height (setf (wm-delta-height shell) wm-delta-height))
  (when wm-delta-width (setf (wm-delta-width shell) wm-delta-width))  
  (when wm-initial-state (setf (wm-initial-state shell) wm-initial-state))
  (when wm-gravity (setf (wm-gravity shell) wm-gravity))
  (when wm-max-aspect (setf (wm-max-aspect shell) wm-max-aspect))
  (when wm-max-height (setf (wm-max-height shell) wm-max-height))
  (when wm-max-width (setf (wm-max-width shell) wm-max-width))  
  (when wm-min-aspect (setf (wm-min-aspect shell) wm-min-aspect))
  (when wm-min-height (setf (wm-min-height shell) wm-min-height))
  (when wm-min-width (setf (wm-min-width shell) wm-min-width))
  (when wm-user-specified-position-p (setf (wm-user-specified-position-p shell) wm-user-specified-position-p))
  (when wm-user-specified-size-p (setf (wm-user-specified-size-p shell) wm-user-specified-size-p))
  (when wm-group (setf (wm-group shell) wm-group))
  (when wm-keyboard-input (setf (wm-keyboard-input shell) wm-keyboard-input)))

))
