;;; -*- Mode: Common-Lisp; Package: User; Base: 10.; Patch-File: T -*-

;;; Reason: Update shell position correctly when resized by window mgr.

;;;                           RESTRICTED RIGHTS LEGEND
;;;
;;; Use, duplication, or disclosure by the Government is subject to
;;; restrictions as set forth in subdivision (c)(1)(ii) of the Rights in
;;; Technical Data and Computer Software clause at 52.227-7013.
;;;
;;;   TEXAS INSTRUMENTS INCORPORATED      
;;;   P.O. BOX 149149, M/S 2151             
;;;   AUSTIN, TEXAS 78714-9149                 
;;;
;;; Copyright (C) 1989 Texas Instruments Incorporated.
;;; All rights reserved.

;;; Patch file for CLUE version 7.9
;;; Written 06/27/90 11:32:17 by KK,
;;; while running on RIGI from band P614
;;; With SYSTEM 6.41, GC 6.4, VIRTUAL-MEMORY 6.3, MICRONET 6.0, MICRONET-COMM 6.4,
;;;  DISK-IO 6.4, DISK-LABEL 6.1, BASIC-PATHNAME 6.5, MAC-PATHNAME 6.0, NETWORK-SUPPORT-COLD 6.2,
;;;  BASIC-NAMESPACE 6.8, BASIC-FILE 6.14, RPC 6.2, NFS-MX 6.9, EH 6.8, MAKE-SYSTEM 6.5,
;;;  MEMORY-AUX 6.0, COMPILER 6.18, TV 6.32, NVRAM 6.4, UCL 6.1, INPUT-EDITOR 6.1,
;;;  MACTOOLBOX 2.25, METER 6.2, ZWEI 6.27, DEBUG-TOOLS 6.5, WINDOW-MX 6.12, PRINTER 6.8,
;;;  MAC-PRINTER-TYPES 6.2, CLIPBOARD 6.1, TI-CLOS 6.53, CLEH 6.5, NETWORK-PATHNAME 6.2,
;;;  NETWORK-NAMESPACE 6.1, DATALINK 6.0, CHAOSNET 6.8, NETWORK-SUPPORT 6.1, NETWORK-SERVICE 6.3,
;;;  DATALINK-DISPLAYS 6.0, MX-DATALINK 6.1, NAMESPACE-EDITOR 6.6, IP 3.65, NFS-MX-SERVER 6.0,
;;;  MX-SERIAL 6.2, PRINTER-TYPES 6.2, IMAGEN 6.1, MAIL-DAEMON 6.6, MAIL-READER 6.9,
;;;  TELNET 6.1, VT100 6.0, STREAMER-TAPE 6.6, DECNET 1.72, VISIDOC 6.7, PROFILE 6.3,
;;;  Experimental BUG 11.19, Experimental CLX 7.1, Experimental CLUE 7.5, Experimental SC 4.0,
;;;  Experimental CLIO 30.0,  microcode 191, Band Name: Rel 6.2 internal

#!C
; From file SHELLS.LISP#> CLUE; MR-X:
#10R CLUEI#:
(lisp:COMPILER-LET ((*PACKAGE* (FIND-PACKAGE "CLUEI"))     ; DAB 06-25-90 Added package prefix because of CLIO.[11237]
                          (SI:*LISP-MODE* :COMMON-LISP)
                          (*READTABLE* SYS:COMMON-LISP-READTABLE)
                          (SI:*READER-SYMBOL-SUBSTITUTIONS* SYS::*COMMON-LISP-SYMBOL-SUBSTITUTIONS*))
  (COMPILER#:PATCH-SOURCE-FILE "SYS: CLUE; SHELLS.#"


(defcontact wm-shell (shell)
  ((hints                :type     (or null wm-hints)
			 :initform nil 
			 :initarg  :wm-hints
			 :accessor shell-hints)
   
   (normal-hints         :type     (or null wm-size-hints)
			 :initform nil 
			 :initarg  :wm-normal-hints
			 :accessor shell-normal-hints)
   
   (protocols-used       :type     (or null list) 
			 :initform nil 
			 :initarg  :wm-protocols-used
			 :accessor wm-protocols-used)
   
   (title                :type     (or null string)
			 :initform nil 
			 :initarg  :wm-title
			 :accessor wm-title)

   (reparented-p         :type     boolean
			 :initform nil))

  (:resources
    (event-mask       :initform #.(make-event-mask :structure-notify))
    
    (wm-base-height   :type (or null card16))
    (wm-base-width    :type (or null card16))             
    (wm-delta-height  :type (or null card16))                 
    (wm-delta-width   :type (or null card16))              
    (wm-gravity       :type (or null (member :north-west :north  :north-east
					      :west       :center :east
					      :south-west :south  :south-east)))          
    (wm-initial-state :type (or null (member :normal :iconic)))
    (wm-max-aspect    :type (or null number))             
    (wm-max-height    :type (or null card16))             
    (wm-max-width     :type (or null card16))            
    (wm-min-aspect    :type (or null number))             
    (wm-min-height    :type (or null card16))             
    (wm-min-width     :type (or null card16))            
     wm-title
    (wm-user-specified-position-p :type boolean)
    (wm-user-specified-size-p     :type boolean))
    
  (:documentation
    "Base class for shells which interact with the window manager."))

))

#!C
; From file SHELLS.LISP#> CLUE; MR-X:
#10R CLUEI#:
(lisp:COMPILER-LET ((*PACKAGE* (FIND-PACKAGE "CLUEI"))     ; DAB 06-25-90 Added package prefix because of CLIO.[11237]
                          (SI:*LISP-MODE* :COMMON-LISP)
                          (*READTABLE* SYS:COMMON-LISP-READTABLE)
                          (SI:*READER-SYMBOL-SUBSTITUTIONS* SYS::*COMMON-LISP-SYMBOL-SUBSTITUTIONS*))
  (COMPILER#:PATCH-SOURCE-FILE "SYS: CLUE; SHELLS.#"


(defmethod handle-event :before ((shell wm-shell) (event event))
  (with-slots (key) event
    (case key
      (:reparent-notify
       (setf (slot-value shell 'reparented-p) t))
      
      (:configure-notify
       ;; Update geometry slots to reflect change made interactively by user.
       (with-slots (x y width height border-width send-event-p) event
	 (without-requests shell   ; No configure request side-effect
	   ;; Use move/resize protocol so that any auxiliary methods will fire.
	   (resize shell width height border-width)

	   ;; Ensure shell coordinates are w.r.t root.
	   (let ((new-x x) (new-y y))
	     (when (and (not send-event-p) (slot-value shell 'reparented-p))
	       (multiple-value-setq (new-x new-y)
		 (translate-coordinates shell (- border-width) (- border-width) (contact-root shell))))
	     (move shell new-x new-y)))))
      
      ((:map-notify :unmap-notify)
       ;; Ignore if in response to (setf contact-state)
       (unless (boundp '*ignore-map-notify*)
	 
	 ;; Update state to reflect change made interactively by user.
	 (without-requests shell
	   (setf (contact-state shell) (if (eq key :map-notify) :mapped :iconic))))))))

))
