;;; -*- Mode: Common-Lisp; Package: User; Base: 10.; Patch-File: T -*-

;;; Reason: def-char-info-accessors: fix indexing error in char-width, etc.

;;;                           RESTRICTED RIGHTS LEGEND
;;;
;;; Use, duplication, or disclosure by the Government is subject to
;;; restrictions as set forth in subdivision (c)(1)(ii) of the Rights in
;;; Technical Data and Computer Software clause at 52.227-7013.
;;;
;;;   TEXAS INSTRUMENTS INCORPORATED      
;;;   P.O. BOX 149149, M/S 2151             
;;;   AUSTIN, TEXAS 78714-9149                 
;;;
;;; Copyright (C) 1989 Texas Instruments Incorporated.
;;; All rights reserved.

;;; Patch file for CLX version 6.9
;;; Written 03/26/90 20:49:34 by KK,
;;; while running on RIGI from band PB28
;;; With SYSTEM 6.31, GC 6.3, VIRTUAL-MEMORY 6.3, MICRONET 6.0, MICRONET-COMM 6.2,
;;;  DISK-IO 6.2, DISK-LABEL 6.0, BASIC-PATHNAME 6.4, MAC-PATHNAME 6.0, NETWORK-SUPPORT-COLD 6.2,
;;;  BASIC-NAMESPACE 6.7, BASIC-FILE 6.8, RPC 6.2, NFS-MX 6.6, EH 6.6, MAKE-SYSTEM 6.2,
;;;  MEMORY-AUX 6.0, COMPILER 6.14, TV 6.24, NVRAM 6.2, UCL 6.0, INPUT-EDITOR 6.0,
;;;  MACTOOLBOX 2.14, METER 6.1, ZWEI 6.13, DEBUG-TOOLS 6.4, WINDOW-MX 6.10, PRINTER 6.3,
;;;  MAC-PRINTER-TYPES 6.1, CLIPBOARD 6.1, TI-CLOS 6.42, CLEH 6.5, NETWORK-PATHNAME 6.1,
;;;  NETWORK-NAMESPACE 6.1, DATALINK 6.0, CHAOSNET 6.5, NETWORK-SUPPORT 6.1, NETWORK-SERVICE 6.2,
;;;  DATALINK-DISPLAYS 6.0, MX-DATALINK 6.1, NAMESPACE-EDITOR 6.4, IP 3.58, NFS-MX-SERVER 6.0,
;;;  MX-SERIAL 6.1, PRINTER-TYPES 6.2, IMAGEN 6.1, MAIL-DAEMON 6.5, MAIL-READER 6.7,
;;;  TELNET 6.1, VT100 6.0, STREAMER-TAPE 6.5, DECNET 1.72, VISIDOC 6.7, PROFILE 6.2,
;;;  Experimental CLX 6.8, CLUE 6.86, Experimental BUG 11.18, Experimental SC 3.0,
;;;  Experimental CLIO 19.0,  microcode 139, Band Name: microExplorer Network + SLE (11/28)

#!C
; From file FONTS.LISP#> CLX; Hotel:
#10R XLIB#:
(COMPILER-LET ((*PACKAGE* (FIND-PACKAGE "XLIB"))
                          (SI:*LISP-MODE* :COMMON-LISP)
                          (*READTABLE* SYS:COMMON-LISP-READTABLE)
                          (SI:*READER-SYMBOL-SUBSTITUTIONS* SYS::*COMMON-LISP-SYMBOL-SUBSTITUTIONS*))
  (COMPILER#:PATCH-SOURCE-FILE "SYS: CLX; FONTS.#"


(eval-when (eval compile) ;; I'd rather use macrolet, but Symbolics doesn't like it...

(defmacro def-char-info-accessors (useless-name &body fields)
  `(within-definition (,useless-name def-char-info-accessors)
     ,@(do ((field fields (cdr field))
	    (n 0 (1+ n))
	    (name) (type)
	    (result nil))
	   ((endp field) result)
	 (setq name (xintern 'char- (caar field)))
	 (setq type (cadar field))
	 (flet ((from (form)
		  (if (eq type 'int16)
		      form
		      `(,(xintern 'int16-> type) ,form))))
	   (push
	     `(defun ,name (font index)
		(declare (type font font)
			 (type array-index index))
		(declare-values ,type)
		(let ((char-info-vector (font-char-infos font))
		      (char-entry (index+ (index* 6 (index- index (font-min-char font)))
					  ,n)))
		  (declare (type char-info-vec char-info-vector)
			   (type array-index char-entry))
		  (the ,type
		       ,(from
			  `(the int16
				(if (index< char-entry (length char-info-vector))
				    ;; Variable width font
				    (aref char-info-vector char-entry)
				    ;; Fixed width font
				    (aref (the char-info-vec (font-max-bounds font))
					  ,n)))))))
	     result)
	   (push `(proclaim '(inline ,name)) result)
	   (setq name (xintern 'min-char- (caar field)))
	   (push
	     `(defun ,name (font)
		(declare (type font font))
		(declare-values ,type)
		(the ,type ,(from `(the int16
					(aref (the char-info-vec (font-min-bounds font))
					      ,n)))))
	     result)
	   (push `(proclaim '(inline ,name)) result)
	   (setq name (xintern 'max-char- (caar field)))
	   (push
	     `(defun ,name (font)
		(declare (type font font))
		(declare-values ,type)
		(the ,type ,(from `(the int16
					(aref (the char-info-vec (font-max-bounds font))
					      ,n)))))
	     result)
	   (push `(proclaim '(inline ,name)) result)))
	  
     (defun make-char-info
	    (&key ,@(mapcar
		      #'(lambda (field)
			  `(,(car field) (required-arg ,(car field))))
		      fields))
       (declare ,@(mapcar #'(lambda (field) `(type ,@(reverse field))) fields))
       (let ((result (make-array ,(length fields) :element-type 'int16)))
	 (declare-array char-info-vec result)
	 ,@(do* ((field fields (cdr field))
		 (var (caar field) (caar field))
		 (type (cadar field) (cadar field))
		 (n 0 (1+ n))
		 (result nil))
		((endp field) (nreverse result))
	     (push `(setf (aref result ,n)
			  ,(if (eq type 'int16)
			       var
			       `(,(xintern type '->int16) ,var)))
		   result))
	 result))))
) ;; End eval-when

))

#!C
; From file FONTS.LISP#> CLX; Hotel:
#10R XLIB#:
(COMPILER-LET ((*PACKAGE* (FIND-PACKAGE "XLIB"))
                          (SI:*LISP-MODE* :COMMON-LISP)
                          (*READTABLE* SYS:COMMON-LISP-READTABLE)
                          (SI:*READER-SYMBOL-SUBSTITUTIONS* SYS::*COMMON-LISP-SYMBOL-SUBSTITUTIONS*))
  (COMPILER#:PATCH-SOURCE-FILE "SYS: CLX; FONTS.#"


(def-char-info-accessors ignore
  (left-bearing int16)
  (right-bearing int16)
  (width int16)
  (ascent int16)
  (descent int16)
  (attributes card16))

))
