;;; -*- Mode: Common-Lisp; Package: compiler; Base: 10.; Patch-File: T -*-

;;; Reason: Added check for (listp list) to ensure that we don't try a dolist on something that isn't a list.   

;;;                           RESTRICTED RIGHTS LEGEND
;;;
;;; Use, duplication, or disclosure by the Government is subject to
;;; restrictions as set forth in subdivision (c)(1)(ii) of the Rights in
;;; Technical Data and Computer Software clause at 52.227-7013.
;;;
;;;   TEXAS INSTRUMENTS INCORPORATED      
;;;   P.O. BOX 2909, M/S 2151             
;;;   AUSTIN, TEXAS 78769                 
;;;
;;; Copyright (C) 1989 Texas Instruments Incorporated.
;;; All rights reserved.

;;; Written 05/31/90 07:58:28 by BERGER,
;;; while running on Pasteur from band LOD3
;;; With SYSTEM 6.35, VIRTUAL-MEMORY 6.3, EH 6.8, MAKE-SYSTEM 6.3, MICRONET 6.0, LOCAL-FILE 6.2,
;;;  BASIC-PATHNAME 6.5, NETWORK-SUPPORT-COLD 6.2, BASIC-NAMESPACE 6.8, NETWORK-NAMESPACE 6.1,
;;;  DISK-IO 6.3, DISK-LABEL 6.0, BASIC-FILE 6.13, MAC-PATHNAME 6.0, NETWORK-PATHNAME 6.2,
;;;  COMPILER 6.14, TV 6.25, DATALINK 6.0, CHAOSNET 6.8, GC 6.4, MEMORY-AUX 6.0, NVRAM 6.3,
;;;  SYSLOG 6.2, STREAMER-TAPE 6.6, UCL 6.0, INPUT-EDITOR 6.0, METER 6.2, ZWEI 6.18,
;;;  DEBUG-TOOLS 6.4, NETWORK-SUPPORT 6.1, NETWORK-SERVICE 6.3, DATALINK-DISPLAYS 6.0,
;;;  FONT-EDITOR 6.1, SERIAL 6.0, PRINTER 6.7, MAC-PRINTER-TYPES 6.2, PRINTER-TYPES 6.2,
;;;  IMAGEN 6.1, SUGGESTIONS 6.1, MAIL-DAEMON 6.6, MAIL-READER 6.8, TELNET 6.1, VT100 6.0,
;;;  NAMESPACE-EDITOR 6.5, PROFILE 6.3, VISIDOC 6.7, TI-CLOS 6.47, CLEH 6.5, IP 3.65,
;;;  Experimental CLX 6.11, CLUE 6.104, X11M 6.24, Experimental BUG 11.19,  microcode 648,
;;;  Band Name: rel 6.0 + SLE 5/30

#!C
; From file P1FUNS.LISP#> COMPILER; SYS:
#10R COMPILER#:
(COMPILER-LET ((*PACKAGE* (FIND-PACKAGE "COMPILER"))
                          (SI:*LISP-MODE* :COMMON-LISP)
                          (*READTABLE* COMMON-LISP-READTABLE)
                          (SI:*READER-SYMBOL-SUBSTITUTIONS* SYS::*COMMON-LISP-SYMBOL-SUBSTITUTIONS*))
  (COMPILER#:PATCH-SOURCE-FILE "SYS: COMPILER; P1FUNS.#"


(DEFUN LOAD-TIME-EVAL-P (LIST LEVEL) ; does this list include a #, marker?
  ;;  7/7/87 DNG - Original version; part of fix for SPR 4918.
  ;; 12/06/89 RJF/clm - Added check for (listp list) to ensure that we don't
  ;;                    try a dolist on something that isn't a list.  That now
  ;;                    (i.e., Rel7) causes a microcode trap.
  ;; 12/15/89 RJF/clm - Further refinement of the above fix.
  (OR (EQ (CAR LIST) EVAL-AT-LOAD-TIME-MARKER)
      (AND (< LEVEL 5)	; to avoid looping forever on a recursive list
	   (LET ((LIMIT 100)
		 (LEVEL (1+ LEVEL))
                 (list (cdr list)))
	     (when (listp list)  ;12/06/89
	       (do ((arg list (cdr arg)))
		   ((or (null arg)
			(not (listp arg)))  ;12/15/89
		    (return nil))
		   (WHEN (AND (CONSP (car arg))
			      (LOAD-TIME-EVAL-P (car arg) LEVEL))
		     (RETURN T))
		   (WHEN (ZEROP (DECF LIMIT)) ; to avoid looping forever on a circular list
		     (RETURN NIL))
		   )
	       )))))
))
