;;; -*- Mode: Common-Lisp; Package: SYS; Base: 10.; Patch-File: T -*-

;;; Reason: Modified LE-COM-CONTROL-E to modified the partition comments when partition START changes. This will flag the user that the data is no longer valid.

;;;                           RESTRICTED RIGHTS LEGEND
;;;
;;; Use, duplication, or disclosure by the Government is subject to
;;; restrictions as set forth in subdivision (c)(1)(ii) of the Rights in
;;; Technical Data and Computer Software clause at 52.227-7013.
;;;
;;;   TEXAS INSTRUMENTS INCORPORATED      
;;;   P.O. BOX 2909, M/S 2151             
;;;   AUSTIN, TEXAS 78769                 
;;;
;;; Copyright (C) 1989 Texas Instruments Incorporated.
;;; All rights reserved.

;;; Patch file for DISK-LABEL version 6.1
;;; Written 06/08/90 14:06:41 by BERGER,
;;; while running on Pasteur from band LOD3
;;; With SYSTEM 6.35, VIRTUAL-MEMORY 6.3, EH 6.8, MAKE-SYSTEM 6.3, MICRONET 6.0, LOCAL-FILE 6.2,
;;;  BASIC-PATHNAME 6.5, NETWORK-SUPPORT-COLD 6.2, BASIC-NAMESPACE 6.8, NETWORK-NAMESPACE 6.1,
;;;  DISK-IO 6.3, DISK-LABEL 6.0, BASIC-FILE 6.13, MAC-PATHNAME 6.0, NETWORK-PATHNAME 6.2,
;;;  COMPILER 6.14, TV 6.25, DATALINK 6.0, CHAOSNET 6.8, GC 6.4, MEMORY-AUX 6.0, NVRAM 6.3,
;;;  SYSLOG 6.2, STREAMER-TAPE 6.6, UCL 6.0, INPUT-EDITOR 6.0, METER 6.2, ZWEI 6.18,
;;;  DEBUG-TOOLS 6.4, NETWORK-SUPPORT 6.1, NETWORK-SERVICE 6.3, DATALINK-DISPLAYS 6.0,
;;;  FONT-EDITOR 6.1, SERIAL 6.0, PRINTER 6.6, MAC-PRINTER-TYPES 6.2, PRINTER-TYPES 6.2,
;;;  IMAGEN 6.1, SUGGESTIONS 6.1, MAIL-DAEMON 6.6, MAIL-READER 6.8, TELNET 6.1, VT100 6.0,
;;;  NAMESPACE-EDITOR 6.5, PROFILE 6.3, VISIDOC 6.7, TI-CLOS 6.47, CLEH 6.5, IP 3.65,
;;;  Experimental CLX 6.11, CLUE 6.104, X11M 6.24, Experimental BUG 11.19,  microcode 656,
;;;  Band Name: rel 6.0 + SLE 5/30

#!C
; From file DISK-LABEL-EDITOR.LISP#> DISK-IO; Hotel:
#10R SYSTEM#:
(COMPILER-LET ((*PACKAGE* (FIND-PACKAGE "SYSTEM"))
                          (SI:*LISP-MODE* :COMMON-LISP)
                          (*READTABLE* COMMON-LISP-READTABLE)
                          (SI:*READER-SYMBOL-SUBSTITUTIONS* *COMMON-LISP-SYMBOL-SUBSTITUTIONS*))
  (COMPILER#:PATCH-SOURCE-FILE "SYS: DISK-IO; DISK-LABEL-EDITOR.#"


(DEFUN LE-COM-CONTROL-E ()
  (SETQ LE-SOMETHING-CHANGED T)
  ;; something probably will...
  (CONDITION-CASE ()				;add condition call. SYS:ABort will now only abort this command.
      (IF (< LE-ITEM-NUMBER (LENGTH LE-STRUCTURE))
	  (LET ((ITEM (NTH LE-ITEM-NUMBER LE-STRUCTURE)))
	    (LET ((NAME (FIRST ITEM))
		  (VALUE (SECOND ITEM)))
	      
	      (LET ((*print-base* 10.))
		(FORMAT USER:*TERMINAL-IO* "Change ~a from ~s to: " NAME VALUE))
	      (SETQ VALUE
		    (IF (NUMBERP VALUE)
			(LET ((*read-base* 10.))
			  (EVAL
			    (WITH-INPUT-EDITING (USER:*TERMINAL-IO* '((:NO-INPUT-SAVE T)))
			      (READ USER:*TERMINAL-IO*))))
			(zlc:READLINE USER:*TERMINAL-IO* () '((:NO-INPUT-SAVE T)))))
	      ;; Avoid lossage in lowercase partition names.
	      (IF (MEMBER NAME '(PARTITION-NAME CURRENT-BAND CURRENT-MICROLOAD system-band system-microload) :TEST #'EQ)
		  (SETQ VALUE
			(IF *PARTITION-NAME-CASE-SENSITIVE*
			    (STRING VALUE)
			    (STRING-UPCASE VALUE))))
	      (CASE NAME
		    (VOLUME-NAME (PUT-DISK-STRING LE-DISK-LABEL VALUE %DL-VOLUME-NAME 16.))
		    (DRIVE-NAME (PUT-DISK-STRING LE-DISK-LABEL VALUE %DL-DEVICE-NAME 12.))
		    (COMMENT
		     (PUT-DISK-STRING LE-DISK-LABEL VALUE %DL-COMMENT 96.))
		    (N-BYTES-PER-BLOCK
		     (PUT-DISK-FIXNUM LE-DISK-LABEL
				      (DPB VALUE %%BYTES-PER-BLOCK
					   (GET-DISK-FIXNUM LE-DISK-LABEL %BYTES-PER))
				      %BYTES-PER))
		    (N-BYTES-PER-SECTOR
		     (PUT-DISK-FIXNUM LE-DISK-LABEL
				      (DPB VALUE %%BYTES-PER-SECTOR
					   (GET-DISK-FIXNUM LE-DISK-LABEL %BYTES-PER))
				      %BYTES-PER))
		    (N-SECTORS-PER-TRACK
		     (PUT-DISK-FIXNUM LE-DISK-LABEL
				      (DPB VALUE %%SECTORS-PER-TRACK
					   (GET-DISK-FIXNUM LE-DISK-LABEL %SECTOR-HEADS))
				      %SECTOR-HEADS))
		    (N-HEADS
		     (PUT-DISK-FIXNUM LE-DISK-LABEL
				      (DPB VALUE %%NUMBER-OF-HEADS
					   (GET-DISK-FIXNUM LE-DISK-LABEL %SECTOR-HEADS))
				      %SECTOR-HEADS))
		    (N-CYLINDERS
		     (PUT-DISK-FIXNUM LE-DISK-LABEL
				      (DPB VALUE %%NUMBER-OF-CYLINDERS
					   (GET-DISK-FIXNUM LE-DISK-LABEL %CYLINDERS))
				      %CYLINDERS))
		    (N-SECTORS-FOR-DEFECTS
		     (PUT-DISK-FIXNUM LE-DISK-LABEL
				      (DPB VALUE %%NUMBER-OF-SECTORS-FOR-DEFECTS
					   (GET-DISK-FIXNUM LE-DISK-LABEL %CYLINDERS))
				      %CYLINDERS))
		    (CURRENT-MICROLOAD
		     (cond (*le-prim-style-edit*
			    (FORMAT USER:*TERMINAL-IO*
				    "Editing this field only changes the disk label, not the System Load defaults.")
			    (when (fquery '(:beep t :stream user:*terminal-io*)
					  "Change ~a to ~a anyway ? " name value)
			      (setq *le-mcr-or-lod-changed* t)
			      (SETF VALUE (PAD-NAME-FIELD VALUE 4))
			      (SET-DEFAULT-MICROLOAD LE-DISK-LABEL VALUE)))
			   (t
			    (SETF VALUE (PAD-NAME-FIELD VALUE 4))
			    ;(PUT-DISK-STRING LE-DISK-LABEL VALUE %DL-CURRENT-MICROLOAD 4) ;rel3
			    (SET-DEFAULT-MICROLOAD LE-DISK-LABEL VALUE))))
		    (CURRENT-BAND
		     (cond (*le-prim-style-edit*
			    (FORMAT USER:*TERMINAL-IO*
				    "Editing this field only changes the disk label, not the System Load defaults.")
			    (when (fquery '(:beep t :stream user:*terminal-io*)
					  "Change ~a to ~a anyway ? " name value)
			      (setq *le-mcr-or-lod-changed* t)
			      (SETF VALUE (PAD-NAME-FIELD VALUE 4))
			      (SET-DEFAULT-LOAD-BAND LE-DISK-LABEL VALUE)))
			   (t
			    (SETF VALUE (PAD-NAME-FIELD VALUE 4))
			    ;(PUT-DISK-STRING LE-DISK-LABEL VALUE %DL-CURRENT-BAND 4) ;rel3
			    (SET-DEFAULT-LOAD-BAND LE-DISK-LABEL VALUE))))

		    ;mrr 3.14.87
		    (system-microload (setq *le-mcr-or-lod-changed* t
					    *le-mcr-name* value))
		    (system-microload-unit (setq *le-mcr-or-lod-changed* t
						  *le-mcr-unit* value))
		    (system-band (setq *le-mcr-or-lod-changed* t
				       *le-lod-name* value))
		    (system-band-unit (setq *le-mcr-or-lod-changed* t
					    *le-lod-unit* value)) 
		     
		    (N-PARTITIONS
		     (PUT-DISK-FIXNUM LE-DISK-LABEL VALUE (+ %PT-BASE %PT-NUMBER-OF-PARTITIONS)))
		    (WORDS-PER-PART (CHANGE-PARTITION-MAP LE-DISK-LABEL VALUE))
		    (PARTITION-TABLE-NAME (SETF VALUE (PAD-NAME-FIELD VALUE 4))


		  (PUT-DISK-STRING LE-DISK-LABEL VALUE %DL-PARTITION-TABLE-NAME 4))
		    (PARTITION-TABLE-START
		     (PUT-DISK-FIXNUM LE-DISK-LABEL VALUE %DL-PARTITION-TABLE-START))
		    (PARTITION-TABLE-LENGTH
		     (IF (>= *MAX-PTBL-SIZE* VALUE)
			 (PUT-DISK-FIXNUM LE-DISK-LABEL VALUE %DL-PARTITION-TABLE-LENGTH)
			 (PROGN
			   (FORMAT USER:*TERMINAL-IO*
				   "Partition table length cannot exceed SI:*MAX-PTBL-SIZE*, ~d."
				   *MAX-PTBL-SIZE*)
			   (BEEP)
			   (zlc:READLINE USER:*TERMINAL-IO* () '((:NO-INPUT-SAVE T))))))
		    (SAVE-AREA-NAME (SETF VALUE (PAD-NAME-FIELD VALUE 4))
				    (PUT-DISK-STRING LE-DISK-LABEL VALUE %DL-SAVE-AREA-NAME 4))
		    (SAVE-AREA-START (PUT-DISK-FIXNUM LE-DISK-LABEL VALUE %DL-SAVE-AREA-START))
		    (SAVE-AREA-LENGTH (PUT-DISK-FIXNUM LE-DISK-LABEL VALUE %DL-SAVE-AREA-LENGTH))
		    ;; These occur in multiple instances
		    ((PARTITION-NAME PARTITION-START PARTITION-SIZE PARTITION-COMMENT PARTITION-TYPE)
		     (LET ((PLOC (LE-CURRENT-PARTITION)))
		       (CASE NAME
			     (PARTITION-NAME
			      ;if prim-style and an explorer-type mcr or load name change, set flag. mrr 3.13.87
			      (when  *le-prim-style-edit*
				(let* ((ploc (le-current-partition))
				       (att (get-disk-fixnum le-disk-label (+ ploc %pd-attributes))))
				  (and (= (cpu-type) (ldb %%cpu-type-code att))
				       (or (= %bt-microload (ldb %%band-type-code att))
					   (= %bt-load-band (ldb %%band-type-code att)))))
				(setq *le-mcr-or-lod-changed* t))	
			      (SETF VALUE (PAD-NAME-FIELD VALUE 4))
			      (PUT-DISK-STRING LE-DISK-LABEL VALUE (+ PLOC %PD-NAME) 4))
			     (PARTITION-TYPE (PUT-DISK-FIXNUM LE-DISK-LABEL VALUE (+ PLOC %PD-ATTRIBUTES)))
			     (PARTITION-START
			      (IF (RESERVED-BLOCKS-OVERWRITE-PROTECTION PLOC NAME VALUE)
				  (PUT-DISK-FIXNUM LE-DISK-LABEL VALUE (+ PLOC %PD-START)))
			      (unless (string-equal (get-DISK-STRING LE-DISK-LABEL (+ PLOC %PD-NAME) 4)
						    "page")
				;;change partition comment to let the user know there may be
				;;unwanted side-effects from this action  DAB 06-08-90
 				(let ((word-add (+ ploc %pd-comment))
				      (N-Char (* 4 (- (GET-DISK-FIXNUM LE-DISK-LABEL
								       (+ %PT-BASE
									  %PT-SIZE-OF-PARTITION-ENTRIES))
						      %PD-COMMENT))))
				  (PUT-DISK-STRING LE-DISK-LABEL
						   (string-append "*Invalid data*:"
								  (get-disk-string le-disk-label word-add n-char))
						   word-add n-char
						   )))
			      )
			      (PARTITION-SIZE
			      (IF (RESERVED-BLOCKS-OVERWRITE-PROTECTION PLOC NAME VALUE)
				  (PUT-DISK-FIXNUM LE-DISK-LABEL VALUE (+ PLOC %PD-LENGTH)))
			      )
			     (PARTITION-COMMENT
			      (PUT-DISK-STRING LE-DISK-LABEL VALUE (+ PLOC %PD-COMMENT)
					       (* 4
						  (-
						    (GET-DISK-FIXNUM LE-DISK-LABEL
								     (+ %PT-BASE
									%PT-SIZE-OF-PARTITION-ENTRIES))
						    %PD-COMMENT)))))))
		    (OTHERWISE (FERROR () "No editor for ~S" NAME)))))
	  (BEEP))
    (ABORT (VALUES () T)))
  (LE-DISPLAY-LABEL LE-DISK-LABEL LE-UNIT))
))
