;;; -*- Mode: Common-Lisp; Package: User; Base: 8.; Patch-File: T -*-
;;; Written 06/02/89 16:29:22 by MARKY,
;;; Reason: Changed fed:display-label to NOT truncate last char of 
;;; displayed SAMPLE string.
;;; while running on LIBRA from band LODA
;;; With SYSTEM 6.3, VIRTUAL-MEMORY 6.1, EH 6.0, MAKE-SYSTEM 6.0, MICRONET 6.0, LOCAL-FILE 6.0,
;;;  BASIC-PATHNAME 6.0, NETWORK-SUPPORT-COLD 6.0, BASIC-NAMESPACE 6.0, NETWORK-NAMESPACE 6.0,
;;;  DISK-IO 6.0, DISK-LABEL 6.0, BASIC-FILE 6.0, MAC-PATHNAME 6.0, NETWORK-PATHNAME 6.0,
;;;  COMPILER 6.2, TV 6.6, DATALINK 6.0, CHAOSNET 6.0, GC 6.1, MEMORY-AUX 6.0, NVRAM 6.0,
;;;  SYSLOG 6.0, STREAMER-TAPE 6.0, UCL 6.0, INPUT-EDITOR 6.0, METER 6.0, ZWEI 6.0,
;;;  DEBUG-TOOLS 6.0, NETWORK-SUPPORT 6.0, NETWORK-SERVICE 6.0, DATALINK-DISPLAYS 6.0,
;;;  FONT-EDITOR 6.0, SERIAL 6.0, PRINTER 6.1, MAC-PRINTER-TYPES 6.1, PRINTER-TYPES 6.0,
;;;  IMAGEN 6.0, SUGGESTIONS 6.0, MAIL-DAEMON 6.2, MAIL-READER 6.0, TELNET 6.0, VT100 6.0,
;;;  NAMESPACE-EDITOR 6.0, PROFILE 6.1, VISIDOC 6.0, TI-CLOS 6.5, CLEH 6.0, IP 3.45,
;;;  Experimental BUG 11.6, CLX 6.0, CLUE 6.0, X11M 6.1,  microcode 429, Band Name: Release 6.0 + SLE 5/22

;;; SPR 7187,9848

#!C
; From file FED.LISP#> FONT-EDITOR; SYS:
#8R FED#:
(COMPILER-LET ((*PACKAGE* (FIND-PACKAGE "FED"))
                          (SI:*LISP-MODE* :COMMON-LISP)
                          (*READTABLE* SYS:COMMON-LISP-READTABLE)
                          (SI:*READER-SYMBOL-SUBSTITUTIONS* SYS::*COMMON-LISP-SYMBOL-SUBSTITUTIONS*))
  (COMPILER#:PATCH-SOURCE-FILE "SYS: FONT-EDITOR; FED.#"



;;; Add additional information to label window - namely
;;;   fd-rotation value, space-width value
;;; Add use of multiple fonts to make mouse-selectable fields stand out.
;;; Add change-of-mode capability via mouse-sensitive current mode indicator.
(DEFUN DISPLAY-LABEL ()
  "Redisplay the label window of this FED window's frame."
  (DECLARE (:SELF-FLAVOR FED))
  (SEND label-window :expose)

  ;; Clean up the state of the window, to make it the ordinary one for the default font.
  (SETF (W:SHEET-LINE-HEIGHT LABEL-WINDOW)
	(W:FONT-CHAR-HEIGHT (W:SCREEN-DEFAULT-FONT (W:SHEET-GET-SCREEN SELF))))
  (SETF (W:SHEET-BASELINE LABEL-WINDOW)
	(W:FONT-BASELINE (W:SCREEN-DEFAULT-FONT (W:SHEET-GET-SCREEN LABEL-WINDOW))))
  (W:SHEET-SET-FONT LABEL-WINDOW
		    (W:SCREEN-DEFAULT-FONT (W:SHEET-GET-SCREEN LABEL-WINDOW)))
  (SEND LABEL-WINDOW :CLEAR-SCREEN)
  ;; Avoid inexplicable **MORE** from FED-TYO.
  (SETF (W:SHEET-MORE-VPOS LABEL-WINDOW) NIL)
  (send label-window :set-vsp 1)                                      ;makes mouse boxes look better -dkm 4/24/87

  (LET* ((*STANDARD-OUTPUT* LABEL-WINDOW)
;	 (SECOND-LINE-HEIGHT (SEND LABEL-WINDOW :SECOND-LINE-HEIGHT))  ;not used anymore  -dkm 4/24/87
	 (CURRENT-FONT-LINE-HEIGHT (or (and current-font (fd-line-spacing (FONT-GET-FD CURRENT-FONT))) 0))     ;-dkm 4/24/87
	 (FONT-FITS-P (<= CURRENT-FONT-LINE-HEIGHT 25.)))  ;max height font can be to show them a sample string. -dkm 4/24/87
    (SEND label-window :set-current-font 1)
    (SEND label-window :item 'document-item " Mode: ")
    (SEND label-window :set-current-font 0)
    (SEND LABEL-WINDOW :ITEM 'mouse-edit-mode
		   (SEND SELF :DRAW-MODE-STRING))
    (PRINC " ")
    (SEND label-window :set-current-font 1)
    (SEND label-window :item 'document-item " Font: ")
    (SEND label-window :set-current-font 0)
    (SEND LABEL-WINDOW :ITEM 'FONT
	  (OR CURRENT-FONT "None"))
    (SEND label-window :set-current-font 1)
    ;; Now describe the current character.
    ;; We have to print SOMETHING even if there is no current character
    ;; so that there is someplace to put the mouse sensitive items.
    ;; On the other hand, if there is no current FONT, omit these things
    ;; because we don't WANT to tempt the user to try to specify a character.
    (COND (CURRENT-FONT
	   (LET ((*PRINT-BASE* 10.) (*NOPOINT T)
		 (FD (FONT-GET-FD CURRENT-FONT)))
	     (SEND label-window :item 'document-item "  Total Ht: ")
	     (SEND label-window :set-current-font 0)
	     (SEND LABEL-WINDOW :ITEM 'LINE-HEIGHT
		   (FD-LINE-SPACING FD))
	     (SEND label-window :set-current-font 1)
	     (SEND label-window :item 'document-item "  Above Base: ")
	     (SEND label-window :set-current-font 0)
	     (SEND LABEL-WINDOW :ITEM 'BASELINE
		   (FD-BASELINE FD))
	     (SEND label-window :set-current-font 1)
	     (SEND label-window :item 'document-item "  Blinker: ")
	     (SEND label-window :set-current-font 0)
	     (SEND LABEL-WINDOW :ITEM 'BLINKER-WIDTH
		   (FD-BLINKER-WIDTH FD))
	     (SEND label-window :set-current-font 1)
	     (PRINC "x")
	     (SEND label-window :set-current-font 0)
	     (SEND LABEL-WINDOW :ITEM 'BLINKER-HEIGHT
		   (FD-BLINKER-HEIGHT FD))
	     (SEND label-window :set-current-font 1)
	     (SEND label-window :item 'document-item "  Rotate: ")
	     (SEND label-window :item 'rotation
		   (fd-rotation fd))
	     (SEND label-window :item 'document-item "  Space: ")
	     (SEND label-window :item 'space-width
		   (fd-space-width fd))
	     (COMMENT "great help for debugging"
		      (COND (current-character
		    (LET ((cd (AREF fd (CHAR-INT current-character))))
		      (COND (cd
			     (PROG nil
				   (PRINC "  (Ar-Ht: ")
				   (SEND label-window :item 'array-height
					 (ARRAY-DIMENSION cd 0))
				   (PRINC "  Ar-Wd: ")
				   (SEND label-window :item 'array-width
					 (ARRAY-DIMENSION cd 1))
				   (PRINC "  Kern: ")
				   (SEND label-window :item 'kern
					 (cd-char-left-kern cd)))
			     (PRINC ")"))))))   )
	     (SEND label-window :set-current-font 0))
	   
;	   (AND CURRENT-FONT				;This isn't necessary anymore.   -dkm 4/24/87
;		(SETF (W:SHEET-BASELINE LABEL-WINDOW)
;		      (MAX (W:SHEET-BASELINE LABEL-WINDOW)
;			   (FD-BASELINE (FONT-GET-FD CURRENT-FONT)))))

	   (SEND label-window :set-vsp 12.) ;pushes second line down a ways for the CRLF. -dkm 4/24/87

	   (W:SHEET-CRLF LABEL-WINDOW)
	   ;; This font is already current, but setting it now
	   ;; makes the vertical position come out right.
	   (SEND label-window :set-vsp 1.)  ;this makes the mouse box the items better. -dkm 4/24/87
	   (W:SHEET-SET-FONT LABEL-WINDOW
			      (W:SCREEN-DEFAULT-FONT (W:SHEET-GET-SCREEN LABEL-WINDOW)))

	   ;; this used to make the mouse sensitive items come out the right height     not needed anymore  -dkm 4/24/87
;	   (SETF (W:SHEET-LINE-HEIGHT LABEL-WINDOW) second-line-height))

	   (COMMENT (W:sheet-increment-bitpos label-window 0 (- (W:sheet-line-height label-window)
							(W:sheet-baseline label-window))))
	   (SEND label-window :set-current-font 2)
	   (IF UNSAVED-CHANGES
	       (SEND label-window :item 'document-item " CHG ")
	       (PRINC "     "))
	   (SEND label-window :set-current-font 1)
	   (SEND label-window :item 'document-item "  Char:  ")
	   (SEND label-window :set-current-font 0)
	   (IF CURRENT-CHARACTER
	       (SEND LABEL-WINDOW :ITEM 'CHAR-BY-NUMBER NIL
		     "~3D" (CHAR-INT CURRENT-CHARACTER))	 ; change to decimal representation
	       (SEND LABEL-WINDOW :ITEM 'CHAR-BY-NUMBER "nnn"))
	   (PRINC " ")
	   (LET ((OLD-X (W:SHEET-CURSOR-X LABEL-WINDOW))
		 (ADJ-Y (IF FONT-FITS-P                          ;adj-y added to box actual output text  -dkm 4/24/87
			    (- CURRENT-FONT-LINE-HEIGHT (W:SHEET-BASELINE LABEL-WINDOW) 1)
			    0)))
	     (COND ((NULL CURRENT-CHARACTER)
		    (PRINC "None")
		    (SETQ adj-y 0))				  ;No characters yet, don't adjust y  -dkm 4/24/87
		   (T
		    (IF (= CURRENT-CHARACTER #\SP)
			(PRINC "Space")
			(format label-window "~:@C" current-character)) 
		    (WRITE-CHAR #\ )
		    (if FONT-FITS-P     ;-dkm 4/23/87
			(FED-TYO LABEL-WINDOW CURRENT-CHARACTER CURRENT-FONT)
			(write-char #\space))))
	     (SEND LABEL-WINDOW :PRIMITIVE-ITEM-OUTSIDE 'CHAR NIL
		   OLD-X
		   (MIN (W:SHEET-CURSOR-Y LABEL-WINDOW)		 ;use adj-y to determine top of box  -dkm 4/24/87
			(- (W:SHEET-CURSOR-Y LABEL-WINDOW) ADJ-Y))
		   (+ 2 (W:SHEET-CURSOR-X LABEL-WINDOW))
		   (+ (W:SHEET-CURSOR-Y LABEL-WINDOW)
		      (W:SHEET-LINE-HEIGHT LABEL-WINDOW))))
	   (W:SHEET-SET-FONT LABEL-WINDOW
			      (W:SCREEN-DEFAULT-FONT (W:SHEET-GET-SCREEN LABEL-WINDOW)))

;	   (AND CURRENT-FONT                   			; No need to mess with the baseline.    dkm 4/23/87
;		(SETF (W:SHEET-BASELINE LABEL-WINDOW)
;		      (MAX (W:SHEET-BASELINE LABEL-WINDOW)
;			   (FD-BASELINE (FONT-GET-FD CURRENT-FONT)))))

	   (SEND label-window :set-current-font 1)
	   (SEND label-window :item 'document-item "  Width: ")
	   (SEND label-window :set-current-font 0)
	   (SEND label-window :item 'width NIL "~D" (- CHAR-BOX-X2 CHAR-BOX-X1))
	    
	   (cond (FONT-FITS-P   ;only write out sample string if it fits  -dkm 4/23/87
		  
		  (SEND label-window :set-current-font 1)
		  (SEND label-window :item 'document-item "  Sample: ")
		  
		  ;; Make the sample string area mouse sensitive
		  ;; regardless of whether we display any sample string
		  ;; or how wide it appears.
		  (SEND LABEL-WINDOW :PRIMITIVE-ITEM-OUTSIDE 'SAMPLE-STRING NIL
			(W:SHEET-CURSOR-X LABEL-WINDOW)
			(min (w:sheet-cursor-y label-window)    ;changed to box actual size of sample string -dkm 4/24/87
			     (- (W:SHEET-CURSOR-Y LABEL-WINDOW)
				(- current-font-line-height (w:sheet-baseline label-window) 1)))
			(W:SHEET-INSIDE-RIGHT LABEL-WINDOW)
			(+ (W:SHEET-CURSOR-Y LABEL-WINDOW)
			   (W:SHEET-LINE-HEIGHT LABEL-WINDOW)))
		  (COND ((AND SAMPLE-STRING)
			 (AND (BOUNDP CURRENT-FONT) (SYMBOL-VALUE CURRENT-FONT)
			      (W:SHEET-SET-FONT LABEL-WINDOW (SYMBOL-VALUE CURRENT-FONT)))
			 (CATCH 'tv:line-overflow
;;;			   (DOTIMES (I (max (1- (LENGTH SAMPLE-STRING)) 0))
			   (DOTIMES (I (LENGTH SAMPLE-STRING))	;; may 06/02/89 
			     (FED-TYO LABEL-WINDOW (AREF SAMPLE-STRING I) CURRENT-FONT))))))
		 (T (send label-window :set-current-font 0)
		    (princ "  (Font is too large to show sample string)" LABEL-WINDOW)))
	   )))
  (W:SHEET-SET-FONT LABEL-WINDOW
		     (W:SCREEN-DEFAULT-FONT (W:SHEET-GET-SCREEN LABEL-WINDOW))))

))
