;;; -*- Mode: Common-Lisp; Package: SI; Base: 8.; Patch-File: T -*-
;;; Written 06/02/89 09:55:23 by FISH,
;;; Reason: Changed get-space-size-info to add train space into generations
;;; sizes so that the generation sizes are correctly known.
;;; while running on DaVinci from band LOD2
;;; With SYSTEM 6.0, VIRTUAL-MEMORY 6.0, EH 6.0, MAKE-SYSTEM 6.0, MICRONET 6.0, LOCAL-FILE 6.0,
;;;  BASIC-PATHNAME 6.0, NETWORK-SUPPORT-COLD 6.0, BASIC-NAMESPACE 6.0, NETWORK-NAMESPACE 6.0,
;;;  DISK-IO 6.0, DISK-LABEL 6.0, BASIC-FILE 6.0, MAC-PATHNAME 6.0, NETWORK-PATHNAME 6.0,
;;;  COMPILER 6.0, TV 6.0, DATALINK 6.0, CHAOSNET 6.0, GC 6.0, MEMORY-AUX 6.0, NVRAM 6.0,
;;;  SYSLOG 6.0, STREAMER-TAPE 6.0, UCL 6.0, INPUT-EDITOR 6.0, METER 6.0, ZWEI 6.0,
;;;  DEBUG-TOOLS 6.0, NETWORK-SUPPORT 6.0, NETWORK-SERVICE 6.0, DATALINK-DISPLAYS 6.0,
;;;  FONT-EDITOR 6.0, SERIAL 6.0, PRINTER 6.0, MAC-PRINTER-TYPES 6.0, PRINTER-TYPES 6.0,
;;;  IMAGEN 6.0, SUGGESTIONS 6.0, MAIL-DAEMON 6.0, MAIL-READER 6.0, TELNET 6.0, VT100 6.0,
;;;  NAMESPACE-EDITOR 6.0, PROFILE 6.0, VISIDOC 6.0, TI-CLOS 6.0, CLEH 6.0, IP 3.45,
;;;  Experimental BUG 11.6, CLX 6.0, CLUE 6.0, X11M 6.0, Experimental SEYMOUR3 2.0,
;;;  Experimental SLAP 3.15,  microcode 2, Band Name: rel6/5-22/seymour

#!C
; From file GC-AREA-SUPPORT.LISP#> MEMORY-MANAGEMENT; SYS:
#8R SYSTEM#:
(COMPILER-LET ((*PACKAGE* (FIND-PACKAGE "SYSTEM"))
                          (SI:*LISP-MODE* :COMMON-LISP)
                          (*READTABLE* COMMON-LISP-READTABLE)
                          (SI:*READER-SYMBOL-SUBSTITUTIONS* *COMMON-LISP-SYMBOL-SUBSTITUTIONS*))
  (COMPILER#:PATCH-SOURCE-FILE "SYS: MEMORY-MANAGEMENT; GC-AREA-SUPPORT.#"


(DEFUN get-space-size-info (&optional (space-size-struct *tem-space-size-info*))
  (LET ((gen0-alloc 0)      (gen0-used 0)
	(gen1-alloc 0)      (gen1-used 0)
	(gen2-alloc 0)      (gen2-used 0)
	(gen3-alloc 0)      (gen3-used 0)
	(copy-alloc 0)      (copy-used 0)
	(static-alloc 0)    (static-used 0)
	(stat-reg-alloc 0)  (stat-reg-used 0)
	(stat-area-alloc 0) (stat-area-used 0)
	(fixed-alloc 0)     (fixed-used 0)
	(old-alloc 0)       (old-used 0)
	(train-alloc 0)     (train-used 0)
	(areas 0)           (regions 0)
	reg-bits alloc used)
    (LOOP FOR area-sym IN area-list
	  FOR area = (SYMBOL-VALUE area-sym) DO
	  (INCF areas)
	  (LOOP FOR region = (AREF #'area-region-list area) THEN (AREF #'region-list-thread region)
		UNTIL (MINUSP region) DO
		(INCF regions)
		(SETQ alloc (AREF #'region-length region)
		      used (AREF #'region-free-pointer region)
		      reg-bits (AREF #'region-bits region))
		(SELECT (region-space-type region reg-bits)
		  (:new (SELECT (region-generation region reg-bits)
			  (3 (PROGN (INCF gen3-alloc alloc)
				    (INCF gen3-used used)))
			  (2 (PROGN (INCF gen2-alloc alloc)
				    (INCF gen2-used used)))
			  (1 (PROGN (INCF gen1-alloc alloc)
				    (INCF gen1-used used)))
			  (0 (PROGN (INCF gen0-alloc alloc)
				    (INCF gen0-used used)))))
		  (:static (COND ((area-static-p area (AREF #'area-region-bits area))
				  (INCF stat-area-alloc alloc)
				  (INCF stat-area-used used))
				 (t (INCF stat-reg-alloc alloc)
				    (INCF stat-reg-used used))))
		  (:old (PROGN (INCF old-alloc alloc)
			       (INCF old-used used)))
		  (:copy (PROGN (INCF copy-alloc alloc)
				(INCF copy-used used)))
		  (:fixed (PROGN (INCF static-alloc alloc)
				 (INCF static-used used)
				 (INCF fixed-alloc alloc))
			  (INCF fixed-used used))
		  (:train (PROGN (INCF train-alloc alloc)
				 (INCF train-used used)
				 (SELECT (region-generation region reg-bits)
				   (3 (PROGN (INCF gen3-alloc alloc)
					     (INCF gen3-used used)))
				   (2 (PROGN (INCF gen2-alloc alloc)
					     (INCF gen2-used used)))
				   (1 (PROGN (INCF gen1-alloc alloc)
					     (INCF gen1-used used)))
				   (0 (PROGN (INCF gen0-alloc alloc)
					     (INCF gen0-used used))))))
		  (:otherwise (FERROR nil "Invalid region type")))))
    (SETF (new-alloc space-size-struct)
	  (+ gen0-alloc gen1-alloc gen2-alloc gen3-alloc))
    (SETF (new-used space-size-struct)
	  (+ gen0-used gen1-used gen2-used gen3-used))
    (SETF (gen0-alloc space-size-struct) gen0-alloc)
    (SETF (gen0-used space-size-struct) gen0-used)
    (SETF (gen1-alloc space-size-struct) gen1-alloc)
    (SETF (gen1-used space-size-struct) gen1-used)
    (SETF (gen2-alloc space-size-struct) gen2-alloc)
    (SETF (gen2-used space-size-struct) gen2-used)
    (SETF (gen3-alloc space-size-struct) gen3-alloc)
    (SETF (gen3-used space-size-struct) gen3-used)
    (SETF (copy-alloc space-size-struct) copy-alloc)
    (SETF (copy-used space-size-struct) copy-used)
    (SETF (static-alloc space-size-struct)
	  (+ stat-reg-alloc stat-area-alloc fixed-alloc))
    (SETF (static-used space-size-struct)
	  (+ stat-reg-used stat-area-used fixed-used))
    (SETF (stat-reg-alloc space-size-struct) stat-reg-alloc)
    (SETF (stat-reg-used space-size-struct) stat-reg-used)
    (SETF (stat-area-alloc space-size-struct) stat-area-alloc)
    (SETF (stat-area-used space-size-struct) stat-area-used)
    (SETF (fixed-alloc space-size-struct) fixed-alloc)
    (SETF (fixed-used space-size-struct) fixed-used)
    (SETF (old-alloc space-size-struct) old-alloc)
    (SETF (old-used space-size-struct) old-used)
    (SETF (train-alloc space-size-struct) train-alloc)
    (SETF (train-used space-size-struct) train-used)
    (SETF (areas space-size-struct) areas)
    (SETF (regions space-size-struct) regions))
  space-size-struct)
))
