;;; -*- Mode: Common-Lisp; Package: SI; Base: 8.; Patch-File: T -*-
;;; Written 06/19/89 15:30:04 by FISH,
;;; Reason: Changed gc-process to add use of GC-PROMOTE-GEN-2 to control whether generation 2
;;; promotes or not, and to makes highest non-EAS generation collection have large threshold. 
;;; while running on DaVinci from band LOD2
;;; With SYSTEM 6.5, VIRTUAL-MEMORY 6.1, EH 6.2, MAKE-SYSTEM 6.0, MICRONET 6.0, LOCAL-FILE 6.0,
;;;  BASIC-PATHNAME 6.0, NETWORK-SUPPORT-COLD 6.0, BASIC-NAMESPACE 6.0, NETWORK-NAMESPACE 6.0,
;;;  DISK-IO 6.0, DISK-LABEL 6.0, BASIC-FILE 6.2, MAC-PATHNAME 6.0, NETWORK-PATHNAME 6.0,
;;;  COMPILER 6.2, TV 6.7, DATALINK 6.0, CHAOSNET 6.0, GC 6.2, MEMORY-AUX 6.0, NVRAM 6.0,
;;;  SYSLOG 6.0, STREAMER-TAPE 6.2, UCL 6.0, INPUT-EDITOR 6.0, METER 6.0, ZWEI 6.1,
;;;  DEBUG-TOOLS 6.0, NETWORK-SUPPORT 6.0, NETWORK-SERVICE 6.0, DATALINK-DISPLAYS 6.0,
;;;  FONT-EDITOR 6.1, SERIAL 6.0, PRINTER 6.1, MAC-PRINTER-TYPES 6.1, PRINTER-TYPES 6.0,
;;;  IMAGEN 6.0, SUGGESTIONS 6.0, MAIL-DAEMON 6.2, MAIL-READER 6.0, TELNET 6.0, VT100 6.0,
;;;  NAMESPACE-EDITOR 6.0, PROFILE 6.1, VISIDOC 6.1, TI-CLOS 6.5, CLEH 6.3, IP 3.46,
;;;  Experimental BUG 11.7, CLX 6.0, CLUE 6.0, X11M 6.1, Experimental SEYMOUR3 2.0,
;;;  Experimental SLAP 3.15, Experimental GENASYS 3.31,  microcode 429, Band Name: rel6/5-22/seym/ptchs

#!C
; From file GC-DEFS.LISP#> MEMORY-MANAGEMENT; MR-X:
#8R SYSTEM#:
(COMPILER-LET ((*PACKAGE* (FIND-PACKAGE "SYSTEM"))
                          (SI:*LISP-MODE* :COMMON-LISP)
                          (*READTABLE* COMMON-LISP-READTABLE)
                          (SI:*READER-SYMBOL-SUBSTITUTIONS* *COMMON-LISP-SYMBOL-SUBSTITUTIONS*))
  (COMPILER#:PATCH-SOURCE-FILE "SYS: MEMORY-MANAGEMENT; GC-DEFS.#"


(DEFVAR GC-PROMOTE-GEN-2 T
  "Controls whether a incremental non-EAS generation 2 collection is promoting")
))

#!C
; From file GC.LISP#> MEMORY-MANAGEMENT; MR-X:
#8R SYSTEM#:
(COMPILER-LET ((*PACKAGE* (FIND-PACKAGE "SYSTEM"))
                          (SI:*LISP-MODE* :COMMON-LISP)
                          (*READTABLE* COMMON-LISP-READTABLE)
                          (SI:*READER-SYMBOL-SUBSTITUTIONS* *COMMON-LISP-SYMBOL-SUBSTITUTIONS*))
  (COMPILER#:PATCH-SOURCE-FILE "SYS: MEMORY-MANAGEMENT; GC.#"


(DEFUN gc-process ()
  (LET (THRESHOLD USED-VIRTUAL-ADDRESS-SPACE RESERVE
	(VA-RESERVE 0.)
	(LAG-PREVIOUS-GENERATION-HIGH NIL)
	(PREVIOUS-GENERATION-HIGH 1)
	(C 200000.)
	(B
	  (ROUND (* GC-FRACTION-OF-RAM-FOR-GENERATION-ZERO
		    (SYSTEM:SYSTEM-COMMUNICATION-AREA
		      SYSTEM:%SYS-COM-MEMORY-SIZE)))))
    (SETF *GC-MAX-BUCKET-SIZE* (MIN 2500000.
				    (* B 8.)))
    (SETF (AREF FLIP-SIZE 0) B
	  (AREF FLIP-SIZE 1) 0
	  (AREF FLIP-SIZE 2) 0
	  (AREF FLIP-SIZE 3) 0)
    (DO ()
	(NIL)					;Do forever
      (OR %GC-FLIP-READY (PROCESS-WAIT "Await scavenge" 'SYMBOL-VALUE '%GC-FLIP-READY))
      (GC-RECLAIM-OLDSPACE)
      (SETF B (ROUND (* GC-FRACTION-OF-RAM-FOR-GENERATION-ZERO
			(SYSTEM:SYSTEM-COMMUNICATION-AREA
			  SYSTEM:%SYS-COM-MEMORY-SIZE))))
      (SETF (AREF FLIP-SIZE 0) B)
      (IF EXTENDED-ADDRESS-SPACE
	  (SETF *GC-MAX-INCREMENTAL-GENERATION* 3)
	  (IF (> *GC-MAX-INCREMENTAL-GENERATION* 2)
	      (SETF *GC-MAX-INCREMENTAL-GENERATION* 2)))
      (MULTIPLE-VALUE-BIND (W D used-active PDL)
	  (GET-GENERATION-SIZES)
	(SETF USED-VIRTUAL-ADDRESS-SPACE 0)
	(DOTIMES (I 8.) (INCF USED-VIRTUAL-ADDRESS-SPACE (AREF D I)))
	(MULTIPLE-VALUE-BIND (USABLE-SWAP-SPACE SWAP-SPACE-FREE)
	    (SWAP-SPACE-INFO)
	  (SETF SWAP-SPACE-FREE	
		(* (- SWAP-SPACE-FREE
		      (COUNT-PAGES-NEEDING-WRITABLE-PAGING-STORE (NOT EXTENDED-ADDRESS-SPACE)))
		   PAGE-SIZE))			; Also check phys mem.
	  (SETF RESERVE (FLOOR (* 95. (MIN (SETF VA-RESERVE (- *max-virtual-address* USED-VIRTUAL-ADDRESS-SPACE 2097152.))
					   SWAP-SPACE-FREE))
			       100.))
	  (COND ((= *GC-MAX-INCREMENTAL-GENERATION* 0)
		 (SETF THRESHOLD 0))
		((= *GC-MAX-INCREMENTAL-GENERATION* 1)
		 (SETF THRESHOLD (FLOOR (+ (* 16. (AREF D 1))
					   (- (* 16. RESERVE)
					      (* 16. B)
					      (* 16. C)
					      (* 22. (AREF D 0))))
					35.)))		 
		((= *GC-MAX-INCREMENTAL-GENERATION* 2)
		 (SETF THRESHOLD (FLOOR (+ (* 16. (AREF D 1))
					   (- (* 16. RESERVE)
					      (* 16. B)
					      (* 32. C)
					      (* 25. (AREF D 0))
					      (* 19. (AREF D 2))))
					38.))
		 ;; CHECK FOR NEED TO SHUT DOWN GENERATION 2.
		 (IF (AND LAG-PREVIOUS-GENERATION-HIGH
			  (= LAG-PREVIOUS-GENERATION-HIGH 2.)
			  (NOT GC-PROMOTE-GEN-2)
			  (> (AREF D 1) THRESHOLD))
		     ;; SHUT DOWN GENERATION 2
		     (SETF *GC-MAX-INCREMENTAL-GENERATION* 1)))
		(T
		 (SETF THRESHOLD (FLOOR (+ (* 16. (AREF D 1))
					   (- (* 16. RESERVE)
					      (* 16. B)
					      (* 48. C)
					      (* 28. (AREF D 0))
					      (* 22. (AREF D 2))
					      (* 19. (AREF USED-ACTIVE 3 3))
					      (AREF USED-ACTIVE 3 0)
					      (AREF USED-ACTIVE 3 1)
					      (AREF USED-ACTIVE 3 2)
					      (AREF D 4.)))
					41.))))
	  ;; DON'T LET GENERATION 1 GET LARGER THAN 20% OF RAM SIZE UNLESS IT IS THE MAX INCREMENTAL GENERATION.
	  (IF (/= *GC-MAX-INCREMENTAL-GENERATION* 1.)
	      (SETF THRESHOLD (MIN THRESHOLD (* 2. B))))
	  (SETF (AREF FLIP-SIZE 1) THRESHOLD)
	  (SETF LAG-PREVIOUS-GENERATION-HIGH PREVIOUS-GENERATION-HIGH)
	  (COND ((OR PREVIOUS-GENERATION-HIGH
		     (= 0 *GC-MAX-INCREMENTAL-GENERATION*)
		     (AND (< (AREF D 1) THRESHOLD)
			  (NOT (AND (ACTIVE-OVERSIZED-P (AREF USED-ACTIVE 3. 0))
				    (> (- (+ (AREF USED-ACTIVE 3. 2.) (AREF USED-ACTIVE 3. 3.)) PDL)
					(FLOOR (* 3. *GC-MAX-BUCKET-SIZE*)
					       2.)))))) 
		 ;; THIS LEG WILL FLIP GENERATION 0.
		 (WRITE-METER '%GC-SAFETY-PAD
			      (FLOOR (* 8. (MAX (- VA-RESERVE
						   (FLOOR (* 17. B)
							  16.)
						   C
						   (FLOOR (* (AREF D 0) 355.)
							  256.)
						   (FLOOR (* (AREF D 1) 19.)
							  16.))
						0.))
				     10.))
		 (SETF PREVIOUS-GENERATION-HIGH NIL)
		 (WHEN (AND (ACTIVE-OVERSIZED-P (AREF USED-ACTIVE 3. 0))
			    (<= (- (+ (AREF USED-ACTIVE 3. 2.) (AREF USED-ACTIVE 3. 3.)) PDL)
				(FLOOR (* 3. *GC-MAX-BUCKET-SIZE*)
				       2.)))
		   (SHIFT-GEN-THREE))

		 (GC-FLIP-NOW 1 (* 16. B)))
		(T
		 ;; THIS LEG WILL FLIP GENERATION 1 AND POSSIBLY GENERATIONS 2 AND 3.
		 (SETF PREVIOUS-GENERATION-HIGH 1)
		 ;; FLIP GENERATION 1 WITH PROMOTION.
		 (WRITE-METER '%GC-SAFETY-PAD
			      (FLOOR (* 8. (MAX (- VA-RESERVE
						   (FLOOR (* C 33.)
							  16.)
						   (FLOOR (* (AREF D 1) 355.)
							  256.)
						   (FLOOR (* (AREF D 2) 19.)
							  16.)
						   (FLOOR (* (AREF D 0) 17.)
							  256.))
						0.))
				     10.))		 
		 (GC-FLIP-NOW 3 (* 16. C))
		 (WHEN (> *GC-MAX-INCREMENTAL-GENERATION* 1.)
		   ;; WAIT IN THIS LEG SO WE CAN LOOK AT THE RESULTS
		   (PROCESS-WAIT "Await scavenge" 'SYMBOL-VALUE '%GC-FLIP-READY)
		   (GC-RECLAIM-OLDSPACE)
		   ;; GET UPDATED SIZE INFORMATION
		   (MULTIPLE-VALUE-SETQ (W D USED-ACTIVE PDL) (GET-GENERATION-SIZES))
		   (SETF USED-VIRTUAL-ADDRESS-SPACE 0)
		   (DOTIMES (I 8.) (INCF USED-VIRTUAL-ADDRESS-SPACE (AREF D I)))
		   (MULTIPLE-VALUE-SETQ (USABLE-SWAP-SPACE SWAP-SPACE-FREE) (SWAP-SPACE-INFO))
		   (SETF SWAP-SPACE-FREE	
			 (* (- SWAP-SPACE-FREE
			       (COUNT-PAGES-NEEDING-WRITABLE-PAGING-STORE (NOT EXTENDED-ADDRESS-SPACE)))
			    PAGE-SIZE))
		   (SETF RESERVE (FLOOR (* 95. (MIN (SETF VA-RESERVE (- *max-virtual-address*
									USED-VIRTUAL-ADDRESS-SPACE 2097152.))
						    SWAP-SPACE-FREE))
					100.))
		   (COND ((= *GC-MAX-INCREMENTAL-GENERATION* 2)
			  (SETF THRESHOLD (FLOOR (+ (* 16. (AREF D 2))
						    (- (* 16. RESERVE)
						       (* 16. B)
						       (* 32. C)
						       (* 25. (AREF D 0))
						       (* 22. (AREF D 1))))
						 35.))
			  (SETF (AREF FLIP-SIZE 2.) THRESHOLD) 
			  (WHEN (> (AREF D 2) THRESHOLD)
			    ;; FLIP GENERATION 2 (PROMOTION CONTROLLED BY GC-PROMOTE-GEN-2)
			    (SETF PREVIOUS-GENERATION-HIGH 2)
			    (IF GC-PROMOTE-GEN-2
				(GC-FLIP-NOW 5. (* 16. C))
				(GC-FLIP-NOW 4. (* 16. C)))))
			 (T
			  ;; THIS LEG IS EAS
			  (SETF THRESHOLD (FLOOR (+ (* 16. (AREF D 2))
						    (- (* 16. RESERVE)
						       (* 16. B)
						       (* 48. C)
						       (* 28. (AREF D 0))
						       (* 25. (AREF D 1))
						       (* 19. (AREF USED-ACTIVE 3 3))
						       (AREF USED-ACTIVE 3 0)
						       (AREF USED-ACTIVE 3 1)
						       (AREF USED-ACTIVE 3 2)
						       (AREF D 4.)))
						 38.))
			  ;; DON'T LET GENERATION 2 GET LARGER THAN 40% OF RAM SIZE.
			  (SETF THRESHOLD (MIN THRESHOLD (* 4. B)))		  
			  (SETF (AREF FLIP-SIZE 2.) THRESHOLD)
			  (WHEN (OR (> (AREF D 2) THRESHOLD)
				    (AND (ACTIVE-OVERSIZED-P (AREF USED-ACTIVE 3. 0))
					 (> (- (+ (AREF USED-ACTIVE 3. 2.) (AREF USED-ACTIVE 3. 3.)) PDL)
					    (FLOOR (* 3. *GC-MAX-BUCKET-SIZE*)
						   2.))))
			    ;; FLIP GENERATION 2 WITH PROMOTION.
			    (WRITE-METER '%GC-SAFETY-PAD
					 (FLOOR (* 8. (MAX (- VA-RESERVE
							      (FLOOR (* C 33.)
								     16.)
							      (FLOOR (* (AREF D 2) 355.)
								     256.)
							      (FLOOR (* (AREF USED-ACTIVE 3 3) 19.)
								     16.)
							      (FLOOR (+ (AREF D 4)
									(AREF USED-ACTIVE 3 0)
									(AREF USED-ACTIVE 3 1)
									(AREF USED-ACTIVE 3 2))
								     16.)
							      (FLOOR (* (+ (AREF D 0) (AREF D 1)) 17.)
								     256.))
							   0.))
						10.))		    
			    (GC-FLIP-NOW 5. (* 16. C))
			    ;; WAIT IN THIS LEG SO WE CAN LOOK AT THE RESULTS
			    (PROCESS-WAIT "Await scavenge" 'SYMBOL-VALUE '%GC-FLIP-READY)
			    (GC-RECLAIM-OLDSPACE)
			    ;; GET UPDATED SIZE INFORMATION
			    (MULTIPLE-VALUE-SETQ (W D USED-ACTIVE PDL) (GET-GENERATION-SIZES))
			    (SETF USED-VIRTUAL-ADDRESS-SPACE 0)
			    (DOTIMES (I 8.) (INCF USED-VIRTUAL-ADDRESS-SPACE (AREF D I)))
			    (MULTIPLE-VALUE-SETQ (USABLE-SWAP-SPACE SWAP-SPACE-FREE) (SWAP-SPACE-INFO))
			    (SETF SWAP-SPACE-FREE	
				  (* (- SWAP-SPACE-FREE
					(COUNT-PAGES-NEEDING-WRITABLE-PAGING-STORE (NOT EXTENDED-ADDRESS-SPACE)))
				     PAGE-SIZE))
			    (SETF RESERVE (FLOOR (* 95. (MIN (SETF VA-RESERVE (- *max-virtual-address*
										 USED-VIRTUAL-ADDRESS-SPACE 2097152.))
							     SWAP-SPACE-FREE))
						 100.))
			    (SETF THRESHOLD (FLOOR (+ (* 16. (AREF USED-ACTIVE 3 3))
						      (- (* 16 RESERVE)
							 (* 16. B)
							 (* 48. C)
							 (* 28. (AREF D 0))
							 (* 25. (AREF D 1))
							 (* 22. (AREF D 2))
							 (AREF USED-ACTIVE 3 0)
							 (AREF USED-ACTIVE 3 1)
							 (AREF USED-ACTIVE 3 2)
							 (AREF D 4.)))
						   35.))
			    (SETF THRESHOLD (MIN THRESHOLD
						 (+ (FLOOR (* 3. *GC-MAX-BUCKET-SIZE*)
							   2.)
						    PDL)))
			    (SETF (AREF FLIP-SIZE 3.) THRESHOLD)
			    (WHEN (OR (> (AREF USED-ACTIVE 3 3) THRESHOLD)
				      (AND (ACTIVE-OVERSIZED-P (AREF USED-ACTIVE 3. 0))
					   (> (- (+ (AREF USED-ACTIVE 3. 2.) (AREF USED-ACTIVE 3. 3.)) PDL)
					      (FLOOR (* 3. *GC-MAX-BUCKET-SIZE*)
						     2.))))
			      (WRITE-METER '%GC-SAFETY-PAD
					   (FLOOR (* 8. (MAX (- VA-RESERVE
								C
								(FLOOR (* (AREF USED-ACTIVE 3 3) 3.)
								       16.)
								(FLOOR (+ (AREF D 0) (AREF D 1) (AREF D 2) (AREF D 4)
									  (AREF USED-ACTIVE 3 0) (AREF USED-ACTIVE 3 1)
									  (AREF USED-ACTIVE 3 2))
								       16.)
								(AREF USED-ACTIVE 3 3))
							     0.))
						  10.))
			      ;; FLIP GENERATION 3 WITH EXPORT, SET LARGE BIAS.
			      (GC-FLIP-NOW 7. (* 32. B))
			      ;; FIRE OFF THE IDLE SCAVENGER IMMEDIATELY
			      (SETF %scavenger-ws-enable NIL)
			      ;; SHIFT GENERATION 3 IF THE USAGE 0 BUCKET IS OVERSIZED.
			      (WHEN (ACTIVE-OVERSIZED-P (AREF USED-ACTIVE 3 0))
				(SHIFT-GEN-THREE))))))))))))))

(EVAL-WHEN (LOAD)
  (SETF *GC-MAX-INCREMENTAL-GENERATION* 2.)
  (when (si:gc-active-p)
    (GC-OFF)
    (GC-ON)))

))
