;;; -*- Mode: Common-Lisp; Package: SI; Base: 8.; Patch-File: T -*-
;;; Written 06/27/90 15:32:56 by COURTS,
;;; Reason: Add GC-MONITOR for periodic stats collection.
;;; while running on jomama from band LOD1
;;; With SYSTEM 6.28, VIRTUAL-MEMORY 6.3, EH 6.5, MAKE-SYSTEM 6.2, MICRONET 6.0, LOCAL-FILE 6.1,
;;;  BASIC-PATHNAME 6.2, NETWORK-SUPPORT-COLD 6.2, BASIC-NAMESPACE 6.7, NETWORK-NAMESPACE 6.1,
;;;  DISK-IO 6.2, DISK-LABEL 6.0, BASIC-FILE 6.8, MAC-PATHNAME 6.0, NETWORK-PATHNAME 6.0,
;;;  COMPILER 6.14, TV 6.22, DATALINK 6.0, CHAOSNET 6.5, GC 6.3, MEMORY-AUX 6.0, NVRAM 6.2,
;;;  SYSLOG 6.2, STREAMER-TAPE 6.5, UCL 6.0, INPUT-EDITOR 6.0, METER 6.1, ZWEI 6.11,
;;;  DEBUG-TOOLS 6.4, NETWORK-SUPPORT 6.1, NETWORK-SERVICE 6.2, DATALINK-DISPLAYS 6.0,
;;;  FONT-EDITOR 6.1, SERIAL 6.0, PRINTER 6.3, MAC-PRINTER-TYPES 6.2, PRINTER-TYPES 6.2,
;;;  IMAGEN 6.1, SUGGESTIONS 6.1, MAIL-DAEMON 6.4, MAIL-READER 6.6, TELNET 6.0, VT100 6.0,
;;;  NAMESPACE-EDITOR 6.4, PROFILE 6.2, VISIDOC 6.7, TI-CLOS 6.26, CLEH 6.5, IP 3.57,
;;;  Experimental SNRL 4.0, Experimental SST-WINDOWS 1.0, Experimental SNRL-ADD-ONS 1.0,
;;;  Experimental CONFLICT-RESOLUTION 46.0, Experimental QUERY 1.0, MMON 6.2, Experimental GRAPHICS-WINDOW 1.0,
;;;  Experimental GRAPHICAL-SORT 3.0, Experimental VIEWS 34.4, Inconsistent SPREADSHEET 26.8,
;;;  Experimental W-SPREADSHEET 17.4, Experimental SPREADSHEET-VIEW 10.0,  microcode 432,
;;;  Band Name: R6.0++SST+MMON 6/27/90

#!C
; From file GC.LISP#> MEMORY-MANAGEMENT; Hotel:
#8R SYSTEM#:
(COMPILER-LET ((*PACKAGE* (FIND-PACKAGE "SYSTEM"))
                          (SI:*LISP-MODE* :COMMON-LISP)
                          (*READTABLE* COMMON-LISP-READTABLE)
                          (SI:*READER-SYMBOL-SUBSTITUTIONS* *COMMON-LISP-SYMBOL-SUBSTITUTIONS*))
  (COMPILER#:PATCH-SOURCE-FILE "SYS: MEMORY-MANAGEMENT; GC.#"


;;
;; GC Monitor 6/27/90


(DEFVAR MONITOR-FILE NIL)
(DEFVAR MONITOR-DELAY NIL)
(DEFVAR GC-MONITOR-ACTIVE-P NIL)
(DEFVAR GC-MONITOR NIL)

(DEFUN GC-MONITOR ()
  (DO ()
      (NIL)					;Do forever
    (WITH-OPEN-FILE (*STANDARD-OUTPUT* MONITOR-FILE
				       :DIRECTION :OUTPUT
				       :IF-EXISTS :APPEND
				       :IF-DOES-NOT-EXIST :CREATE)
      (GC-STATUS)
      (TIME-STATS :RESET T))
    (SLEEP MONITOR-DELAY)))


(DEFUN GC-MONITOR-ON (STATUS-FILE &OPTIONAL (TIME-DELAY 3600.))
  "This function activates the GC-MONITOR. STATUS-FILE is
the pathname for the file to be used to save periodic status
snapshots. TIME-DELAY is the delay between snapshots in seconds."
  (SETF MONITOR-FILE STATUS-FILE)
  (SETF MONITOR-DELAY TIME-DELAY)
  (UNLESS GC-MONITOR-ACTIVE-P
    (WHEN (NULL GC-MONITOR)
      (SETQ GC-MONITOR (MAKE-PROCESS 'GC-MONITOR :PRIORITY 1)))
    (UNLESS (SEND GC-MONITOR :arrest-reasons)
      (PROCESS-PRESET GC-MONITOR #'GC-MONITOR)
      (PROCESS-ENABLE GC-MONITOR))
    (SETF GC-MONITOR-ACTIVE-P T)
    (PROCESS-ALLOW-SCHEDULE)
    t))

(DEFUN GC-MONITOR-OFF ()
  (WHEN GC-MONITOR-ACTIVE-P
    (PROCESS-DISABLE GC-MONITOR)
    (SETF GC-MONITOR-ACTIVE-P NIL)))

))
