;;; -*- Mode: Common-Lisp; Package: SI; Base: 8.; Patch-File: T -*-
;;; Patch file for GC version 6.6
;;; Reason: EAS changes:
;;;  o Avoid microcode crash which occurred when area was stripped down to only deport regions.
;;;  o Support use of GC-EXTERNAL as midnight collector.
;;; Written 06/27/90 15:39:25 by COURTS,
;;; while running on jomama from band LOD1
;;; With SYSTEM 6.28, VIRTUAL-MEMORY 6.3, EH 6.5, MAKE-SYSTEM 6.2, MICRONET 6.0, LOCAL-FILE 6.1,
;;;  BASIC-PATHNAME 6.2, NETWORK-SUPPORT-COLD 6.2, BASIC-NAMESPACE 6.7, NETWORK-NAMESPACE 6.1,
;;;  DISK-IO 6.2, DISK-LABEL 6.0, BASIC-FILE 6.8, MAC-PATHNAME 6.0, NETWORK-PATHNAME 6.0,
;;;  COMPILER 6.14, TV 6.22, DATALINK 6.0, CHAOSNET 6.5, GC 6.3, MEMORY-AUX 6.0, NVRAM 6.2,
;;;  SYSLOG 6.2, STREAMER-TAPE 6.5, UCL 6.0, INPUT-EDITOR 6.0, METER 6.1, ZWEI 6.11,
;;;  DEBUG-TOOLS 6.4, NETWORK-SUPPORT 6.1, NETWORK-SERVICE 6.2, DATALINK-DISPLAYS 6.0,
;;;  FONT-EDITOR 6.1, SERIAL 6.0, PRINTER 6.3, MAC-PRINTER-TYPES 6.2, PRINTER-TYPES 6.2,
;;;  IMAGEN 6.1, SUGGESTIONS 6.1, MAIL-DAEMON 6.4, MAIL-READER 6.6, TELNET 6.0, VT100 6.0,
;;;  NAMESPACE-EDITOR 6.4, PROFILE 6.2, VISIDOC 6.7, TI-CLOS 6.26, CLEH 6.5, IP 3.57,
;;;  Experimental SNRL 4.0, Experimental SST-WINDOWS 1.0, Experimental SNRL-ADD-ONS 1.0,
;;;  Experimental CONFLICT-RESOLUTION 46.0, Experimental QUERY 1.0, MMON 6.2, Experimental GRAPHICS-WINDOW 1.0,
;;;  Experimental GRAPHICAL-SORT 3.0, Experimental VIEWS 34.4, Inconsistent SPREADSHEET 26.8,
;;;  Experimental W-SPREADSHEET 17.4, Experimental SPREADSHEET-VIEW 10.0,  microcode 432,
;;;  Band Name: R6.0++SST+MMON 6/27/90

#!C
; From file GC.LISP#> MEMORY-MANAGEMENT; Hotel:
#8R SYSTEM#:
(COMPILER-LET ((*PACKAGE* (FIND-PACKAGE "SYSTEM"))
                          (SI:*LISP-MODE* :COMMON-LISP)
                          (*READTABLE* COMMON-LISP-READTABLE)
                          (SI:*READER-SYMBOL-SUBSTITUTIONS* *COMMON-LISP-SYMBOL-SUBSTITUTIONS*))
  (COMPILER#:PATCH-SOURCE-FILE "SYS: MEMORY-MANAGEMENT; GC.#"


;; HRC 6/27/90. Change to GC-EXTERNAL to provide a :SILENT keyword  so that
;; it may be used in a midnight collector.  (Northwest aitlines.)
(DEFUN GC-EXTERNAL (&key (silent nil))
  (WHEN EXTENDED-ADDRESS-SPACE
    ;; 1. TURN OFF THE INCREMENTAL COLLECTOR.
    (with-gc-notifications-inhibited (GC-OFF))
    ;; 2. COLLECT THE EXTERNAL WORLDS
    (LET ((NUMBER-DONE 0.)
	  (NUMBER-TO-DO (LENGTH EXTENDED-ADDRESS-SPACE))
	  (NUMBER-IN-PROCESS 0.))
      (DOLIST (WORLD (COPY-LIST EXTENDED-ADDRESS-SPACE))
	;; 2.1 CHECK TO SEE IF WE HAVE ENOUGH SPACE TO BE ABLE TO SAFELY FAULT THE NEXT WORLD IN.
	(LET (USED-VIRTUAL-ADDRESS-SPACE RESERVE)
	  (MULTIPLE-VALUE-BIND (W D USED-ACTIVE)
	      (GET-GENERATION-SIZES)
	    (DECLARE (IGNORE W))
	    (SETF USED-VIRTUAL-ADDRESS-SPACE 0)
	    (DOTIMES (I 8.) (INCF USED-VIRTUAL-ADDRESS-SPACE (AREF D I)))
	    (MULTIPLE-VALUE-BIND (USABLE-SWAP-SPACE SWAP-SPACE-FREE)
		(SWAP-SPACE-INFO)
	      (DECLARE (IGNORE USABLE-SWAP-SPACE))
	      (SETF SWAP-SPACE-FREE	
		    (* (- SWAP-SPACE-FREE
			  (COUNT-PAGES-NEEDING-WRITABLE-PAGING-STORE (NOT EXTENDED-ADDRESS-SPACE)))
		       PAGE-SIZE))		; Also check phys mem.
	      (SETF RESERVE (MIN (- *max-virtual-address* USED-VIRTUAL-ADDRESS-SPACE 2097152.)
				 SWAP-SPACE-FREE))
	      (IF (< RESERVE (FLOOR (* 12. (+ (AREF D 0) (AREF D 1) (AREF D 2) (AREF USED-ACTIVE 3 3) (AREF USED-ACTIVE 7 3)
					      (* 2. (READ-METER '%MAX-EXTERNAL-WORLD-SIZE))))
				    10.))
		  ;; TIME TO CLEAN THINGS UP.
		  (PROGN
		    (IF (NOT SILENT)
			(FORMAT T "~%Collecting the next ~d. external worlds with ~d. more to go."
			       NUMBER-IN-PROCESS (- NUMBER-TO-DO NUMBER-DONE NUMBER-IN-PROCESS)))
		    (INCF NUMBER-DONE NUMBER-IN-PROCESS)
		    (SETF NUMBER-IN-PROCESS 0.)
		    (GC-IMMEDIATELY :MAX-GEN 3 :PROMOTE T :EXPORT T :silent silent))))))
	;; 2.2 FAULT THE NEXT WORLD IN.
	(DO ((REGION (AREF WORLD %ENTRY-REGIONS) (AREF REGION-WORLD-LIST-THREAD REGION)))
	    ((= 0 REGION))
	  (DO ((ADDR (REGION-ORIGIN REGION) (%MAKE-POINTER-OFFSET DTP-FIX ADDR 1))
	       (MAX-ADDR (%MAKE-POINTER-OFFSET DTP-FIX (REGION-ORIGIN REGION) (REGION-FREE-POINTER REGION))))
	      ((= ADDR MAX-ADDR))
	    (WHEN (= (%P-LDB %%Q-DATA-TYPE ADDR) DTP-FIX)
	      ;; DON'T LOOK WHILE I DO THIS.
	      (WITHOUT-INTERRUPTS
		(%IMPORT-OBJECT (%MAKE-POINTER DTP-LOCATIVE ADDR))))))
	;; 2.3 CHANGE THE WORLD TO STATE 2.
	(SETF (AREF WORLD %WORLD-RECORD-STATE) 2.)
	;; 2.4 MAKE THE EXIT REGIONS OF THIS WORLD NEWSPACE SO THEY WILL GO TO OLDSPACE, BE RECLAIMED, AND NOT BE SCAVENGED.
	(DO ((REGION (AREF WORLD %EXIT-REGIONS) (AREF REGION-WORLD-LIST-THREAD REGION)))
	    ((= 0 REGION))
	  (SETF (AREF #'REGION-BITS REGION) (%LOGDPB %REGION-SPACE-NEW %%REGION-SPACE-TYPE (AREF #'REGION-BITS REGION))))
	;; 2.5 BUMP THE IN PROCESS COUNTER
	(INCF NUMBER-IN-PROCESS))
      ;; 3. ONE FINAL GC.
      (IF (NOT SILENT)
	      (FORMAT T "~%Collecting the last ~d. external worlds." NUMBER-IN-PROCESS))
      (GC-IMMEDIATELY :MAX-GEN 3 :PROMOTE T :EXPORT T :silent silent))
    ;; 5. TURN THE INCREMENTAL COLLECTOR BACK ON AND EXIT.
    (with-gc-notifications-inhibited (GC-ON))))
))

#!C
; From file GC.LISP#> MEMORY-MANAGEMENT; Hotel:
#8R SYSTEM#:
(COMPILER-LET ((*PACKAGE* (FIND-PACKAGE "SYSTEM"))
                          (SI:*LISP-MODE* :COMMON-LISP)
                          (*READTABLE* COMMON-LISP-READTABLE)
                          (SI:*READER-SYMBOL-SUBSTITUTIONS* *COMMON-LISP-SYMBOL-SUBSTITUTIONS*))
  (COMPILER#:PATCH-SOURCE-FILE "SYS: MEMORY-MANAGEMENT; GC.#"

;; HRC 6/27/90.  Change to gc-reclaim-oldspace-area to prevent stripping  an
;; area down  to  only  deport  regions  to  avoid a crash condition in the microcode.
(DEFUN gc-reclaim-oldspace-area (area)
  ;; Deletes all old-space regions of a specified area, unthreading from the lists
  ;; and returning the regions to the free list.
  ;; Note that if an area has only one oldspace region, we change its type to NEW but
  ;; leave it as the one region in the area.
  (CHECK-ARG area (AND (NUMBERP area) (>= area 0) (< area Size-Of-Area-Arrays)) "an area number")
  (WITHOUT-INTERRUPTS
    (UNLESS %Gc-Flip-Ready (FERROR nil "You cannot reclaim oldspace now; GC is still in progress"))
    (DO ((region (AREF #'area-region-list area) (AREF #'region-list-thread region))
	 (region-to-free)
	 (prev-region nil region)
	 (deport-only T)
	 bits new-region)
	(NIL)
      LP
      (WHEN (MINUSP region)
	(WHEN DEPORT-ONLY
	  ;; The area has been stripped down to only deport regions.
	  ;; Fabricate a new empty region and put it at the front so
	  ;; the deport ucode will not try to strip the area bare.
	  (SETQ new-region
		(%make-region 
		  (%LOGDPB 0 %%region-scavenge-enable
			   (%LOGDPB %Region-Meta-Bit-Not-Oldspace %%region-oldspace-meta-bit
				    (%LOGDPB %region-space-new %%region-space-type
					     (area-region-bits area))))
		  (area-region-size area)))
	  (SETF (AREF #'REGION-AREA-MAP new-region) area)                                  ;;Rjf
	  (SETF (AREF #'region-list-thread new-region) (AREF #'AREA-REGION-LIST area))
	  (SETF (AREF #'AREA-REGION-LIST area) new-region))
	(RETURN nil))
      (SETQ bits (AREF #'region-bits region))
      ;; If region is oldspace, we will reclaim it.
      (WHEN (OR (region-oldspace-p region bits)
		(REGION-OLDSPACE-A-P REGION BITS))
	;; Free this region.  First advance vars for next iteration
	(SETQ region-to-free region
	      region (AREF #'region-list-thread region))
	;; Before freeing region, un-link it from region list.
	(IF (AND (= region-to-free (AREF #'area-region-list area))
		 (last-area-region region-to-free))
	    ;; Only region is oldspace.  We can't leave area with no regions,
	    ;; but can't just convert it to NEWSPACE because the level 1 maps
	    ;; will still say OLDSPACE.  We will make a new NEWSPACE region
	    ;; and link it in here.
	    (PROGN
	      (SETQ new-region
		    (%make-region 
		      (%LOGDPB 0 %%region-scavenge-enable
			       (%LOGDPB %Region-Meta-Bit-Not-Oldspace %%region-oldspace-meta-bit
					(%LOGDPB %region-space-new %%region-space-type
						 bits)))
		      (AREF #'region-length region-to-free)))
	      (SETF DEPORT-ONLY NIL)
	      (SETF (AREF #'REGION-AREA-MAP new-region) area)                                  ;;Rjf
	      (SETF (AREF #'region-list-thread new-region) region)
	      (SETF (AREF #'AREA-REGION-LIST area) new-region))
	    ;; Not only region in area.  Just un-link.
	    (IF prev-region
		(SETF (AREF #'REGION-LIST-THREAD prev-region) region)
		(SETF (AREF #'AREA-REGION-LIST area) region)))
	;; Now free up the swap space, return region to free pool, and go to next loop iteration.
	(deallocate-swap-space region-to-free)
	(%gc-free-region region-to-free)
	(GO LP))
      (WHEN (region-copyspace-p region)
	;; Release as much space as possible from a copy space
	;; region since we already have a new space consing region
	;; if this is generation 0 and new consing will be in
	;; generation 0 if it is a higher generation.
	(deallocate-end-of-region region)
	;;; Change this region to NEW space.
	(%make-region-dynamic region))
      (UNLESS (AND (region-train-a-p region bits)
		   (= (LDB %%region-extra-pdl-bit bits) 1))
	;; not a deport region.
	(SETF DEPORT-ONLY NIL))
      )))
))

#!C
; From file GC.LISP#> MEMORY-MANAGEMENT; Hotel:
#8R SYSTEM#:
(COMPILER-LET ((*PACKAGE* (FIND-PACKAGE "SYSTEM"))
                          (SI:*LISP-MODE* :COMMON-LISP)
                          (*READTABLE* COMMON-LISP-READTABLE)
                          (SI:*READER-SYMBOL-SUBSTITUTIONS* *COMMON-LISP-SYMBOL-SUBSTITUTIONS*))
  (COMPILER#:PATCH-SOURCE-FILE "SYS: MEMORY-MANAGEMENT; GC.#"

;; HRC 6/27/90.  If EAS is  on and  this is  a MAX-GEN  3 collection don't attempt safety checks.
(DEFUN gc (&key (max-gen 3) (first-gen 0) (promote nil) (train-off t) (export nil)
	   (type :immediate) before-disk-save duplicate-pnames
	   (silent nil) after-system-build debug)
  "Perform a garbage collection.  All generations up to and including
:MAX-GEN will be collected.  If the :PROMOTE keyword is true, survivors
from lower generations will be promoted into higher generations.  The default
is not to promote.
  Before starting the collection, GC will try to verify if there is enough free
virtual memory to do a collection given the :MAX-GEN and :PROMOTE parameters.
If so, the collection will proceed.  If not, the user will be queried (when
the :SILENT keyword is NIL) and given the option of choosing a collection with
a safer :MAX-GEN/:PROMOTE combination.  If the :SILENT keyword is true, GC will 
just change the :MAX-GEN/:PROMOTE combination to a safe one and proceed (or in
rare cases, just return NIL if no GC seems safe).  A true :SILENT keyword value
also suppresses all status notifications.
  The TYPE keyword permits some control over the type of GC performed.
It can be :IMMEDIATE or :FULL.  If :FULL, the FULL-GC-INITIALIZATION-LIST is
run before starting the GC.
  The BEFORE-DISK-SAVE keyword, when non-nil, means that you intend to do a
disk-save right after the GC.  This knowledge allows GC to perform additional 
services that would normally only be done before a disk-save, such as dismounting 
the file system and clearing the namespace.
  If the :EXPORT keyword is true and :MAX-GEN is 3 and the EXTENDED-ADDRESS-SPACE variable is not
nil then the current contents of generation 3, usage 3 will exported to external
worlds.
  The DUPLICATE-PNAMES keyword will collapse duplicate symbol print names if they
exist.  This is useful in reclaiming space after the loading of large systems."
  (DECLARE (ARGLIST (&key (max-gen 2) (promote nil) (:type :immediate) (train-off t) (export nil)
			  (silent nil) before-disk-save duplicate-pnames))
	   (SPECIAL GC-System-Build-Forms-Before GC-System-Build-Forms-After))
  (WHEN EXTENDED-ADDRESS-SPACE
    (WRITE-METER '%GC-SAFETY-PAD 0.))
  (WHEN (> max-gen %region-max-generation)
    (SETQ max-gen %region-max-generation))

  (LET (gc-was-on-flag space-sizes)
    (UNLESS (AND EXTENDED-ADDRESS-SPACE
		 (= MAX-GEN 3))
      ;; Ensure that collection can be done (or that user knows it may fail).
      (MULTIPLE-VALUE-SETQ (max-gen promote)
	(verify-gc-safe max-gen promote type silent)))
    (UNLESS max-gen (RETURN-FROM gc nil))
    ;; Assure our oldspace-exists flags are right.
    (gc-maybe-set-flip-ready)
    ;; Turn off automatic GC.
    (WHEN (gc-active-p)
      (IF silent
	  (with-gc-notifications-inhibited (GC-OFF))
	  (GC-OFF))
      (SETQ gc-was-on-flag t))
    ;; Do after-system-build stuff before anything else
    (WHEN after-system-build
      (MAPC #'EVAL GC-System-Build-Forms-Before))
    (WHEN (EQ type :full)
      ;; (FULL-GC :max-gen 3) will turn off training.
      (WHEN (AND (= max-gen 3) train-off)
	(TRAINING-OFF :clear-train-space nil :silent t :reset-counters NIL))
      ;; Run list of forms that releases large data structures.
      (IF silent
	  (INITIALIZATIONS 'Full-Gc-Initialization-List t)
	  (with-batch-gc-notifications
	    (gc-report "Running FULL-GC initializations.")
	    (LET ((qld-mini-done (IF debug nil t)))
	      (DECLARE (SPECIAL qld-mini-done))
	      (INITIALIZATIONS 'Full-Gc-Initialization-List t)))))
    (WHEN (AND duplicate-pnames promote
	       (>= max-gen 2))
      (IF silent
	  (collapse-duplicate-pnames)
	  (with-batch-gc-notifications (collapse-duplicate-pnames))))
    (WHEN before-disk-save
      ;;7/19/88 clm - process a logout before a disk-save 
      (unless silent
	(with-batch-gc-notifications
	  (gc-report "Processing logout")))
      (Logout);Undo user inits and get username off screen.
      (when (fboundp 'Fs::Lmfs-Close-All-Files)
	(unless silent
	  (with-batch-gc-notifications
	    (gc-report "Shutting down file system")))
	;;Close any open streams our local file system
	;; is serving.  Not done by file sys dismount,
	;; but may be redundant considering what comes next.
	(Fs::Lmfs-Close-All-Files)
	)
      (IF (FBOUNDP 'fs:dismount-file-system) (fs:dismount-file-system))
      (IF (FBOUNDP 'name:clear-namespaces) (name:clear-namespaces))
      (when (fboundp 'fs:clear-pathnames-before-gc) (fs:clear-pathnames-before-gc))
      )
    ;; Perform the collection...
    (WITH-LOCK (Gc-Flip-Lock)
      (with-batch-gc-notifications
       (unwind-protect
	(LET-GLOBALLY ((gc-report (IF silent nil gc-report))
		       (Gc-Batch-Mode type)
		       (Inhibit-Scavenging-Flag nil))
	  ;; When oldspace exists, we're not done with a previous GC cycle, so
	  ;; just finish it (by reclaiming oldspace).  Otherwise, start new cycle
	  ;; and do a complete collection.
	  (WHEN Gc-Oldspace-Exists (gc-reclaim-oldspace))
	  (SETQ space-sizes (make-space-size-info))
	  (DO* ((gen first-gen (1+ gen)))        
	       ((> gen max-gen))
	    (if (PLUSP (gen-size-allocated gen (get-space-size-info space-sizes)))
		(progn
		  (gc-flip-now (+ gen gen (IF (OR (AND promote (/= gen 3))
						  (AND promote EXPORT (= GEN 3) EXTENDED-ADDRESS-SPACE))
					      1 0)))
		  (gc-reclaim-oldspace))
                (GC-REPORT "GC: Generation ~O currently empty, no garbage collection necessary." gen) )))     ;;RJF
	;; Some cleanup...
	(WHEN before-disk-save
	  (when (fboundp 'fs:clear-pathnames-before-gc) (fs:restore-pathnames-after-gc)))
	(WHEN (EQ type :full)
	  (INITIALIZATIONS 'After-Full-Gc-Initialization-List t))
	) ; end of unwind-protect
	(WHEN after-system-build
	  (MAPC #'EVAL GC-System-Build-Forms-After))))
    (WHEN gc-was-on-flag
      (IF silent
	  (with-gc-notifications-inhibited
	    (LET ((gc-gen (1+ %gc-generation-number)))
	      (GC-ON)
	      (PROCESS-WAIT "Await flip"	;give gc process chance to run
			    #'(lambda () (= %gc-generation-number gc-gen)))))
	  (GC-ON)))))
))
