;;; -*- Mode: Common-Lisp; Package: User; Base: 10.; Patch-File: T -*-
;;; Written 04/15/88 15:08:59 by FISCHER,
;;; Reason: Fix for problem of multiple GED's existing and menus causing
;;; the wrong GED to be exposed.
;;; while running on F-ASTAIRE from band LODC
;;; With SYSTEM 4.57, VIRTUAL-MEMORY 4.1, EH 4.2, MAKE-SYSTEM 4.4, MICRONET 4.4, Experimental LOCAL-FILE 4.0,
;;;  BASIC-PATHNAME 4.10, DISK-IO 4.6, Experimental DISK-LABEL 4.0, BASIC-FILE 4.6,
;;;  MAC-PATHNAME 4.3, Experimental NETWORK-PATHNAME 4.0, COMPILER 4.7, NETWORK-NAMESPACE 4.3,
;;;  TV 4.73, DATALINK 4.14, CHAOSNET 4.15, GC 4.3, Experimental MEMORY-AUX 4.0, NVRAM 4.4,
;;;  Experimental SYSLOG 4.0, Experimental STREAMER-TAPE 4.2, UCL 4.1, Experimental INPUT-EDITOR 4.0,
;;;  METER 4.3, ZWEI 4.17, DEBUG-TOOLS 4.2, NETWORK-SUPPORT 4.5, Experimental NETWORK-SERVICE 4.0,
;;;  Experimental DATALINK-DISPLAYS 4.0, Experimental FONT-EDITOR 4.0, Experimental SERIAL 4.0,
;;;  PRINTER 4.7, Experimental PRINTER-TYPES 4.2, Experimental IMAGEN 4.0, Experimental SUGGESTIONS 4.0,
;;;  MAIL-DAEMON 4.6, MAIL-READER 4.5, TELNET 4.1, VT100 4.4, NAMESPACE-EDITOR 4.5,
;;;  PROFILE 4.4, VISIDOC 4.4, NAMESPACE 4.18, NETWORK-SUPPORT-COLD 4.1, IP 3.12,
;;;  Experimental BUG 10.0, GRAPHICS-WINDOW 4.0, GED 4.0,  microcode 300, Band Name: pre 4.1 + IP 4/11

#!C
; From file GRAPHICS-EDITOR-PANES.LISP#> GED; SYS:
#10R GED#:
(COMPILER-LET ((*PACKAGE* (FIND-PACKAGE "GED"))
                          (SI:*LISP-MODE* :COMMON-LISP)
                          (*READTABLE* SYS:COMMON-LISP-READTABLE)
                          (SI:*READER-SYMBOL-SUBSTITUTIONS* SYS::*COMMON-LISP-SYMBOL-SUBSTITUTIONS*))
  (COMPILER#:PATCH-SOURCE-FILE "SYS: GED; GRAPHICS-EDITOR-PANES.#"


;; Fixes problem when multiple instances of GED exist of these variables not being
;; reset when a different GED is selected.  Problem is that GED's :after :select method
;; does not get called due to selection-substitute (I think).  May be related to patch made
;; above to the ged-graphics-window-pane flavor.  See also file: GED-UTILITY-METHODS.LISP
;;  Effect was pop-up menus were causing first instantiated GED to be exposed, regardless of
;; which GED was in use.  Caused real problems when using multiple
;; screens, color & monochrome, and a GED on each.
;; Added 03/25/88 KJF.  Patch made 04/15/88. KJF.
(DEFMETHOD (ged-graphics-window-pane :after :select) (&REST IGNORE)
  "The :after :select method for the graphics-editor flavor does not always
get called due to selection-substitute.  So do important things here."
  (SETQ *ged* superior
	*application-window* superior)
;;; >>> Need to decide if anything else needs to be done here.  See GED's :after :select!!!!!
  )
))
