;;; -*- Mode: Common-Lisp; Package: tv; Base: 8.; Patch-File: T -*-

;;; Reason: Fixed RH-SEARCH-FOR-MATCHING-LEFT-PAREN. It would go into an infinite loop on the form )9()) [5596].

;;;                           RESTRICTED RIGHTS LEGEND
;;;
;;; Use, duplication, or disclosure by the Government is subject to
;;; restrictions as set forth in subdivision (c)(1)(ii) of the Rights in
;;; Technical Data and Computer Software clause at 52.227-7013.
;;;
;;;   TEXAS INSTRUMENTS INCORPORATED      
;;;   P.O. BOX 149149, M/S 2151             
;;;   AUSTIN, TEXAS 78714-9149                 
;;;
;;; Copyright (C) 1989 Texas Instruments Incorporated.
;;; All rights reserved.

;;; Written 06/21/90 07:36:04 by berger,
;;; while running on ARIES from band LODX
;;; With SYSTEM 6.41, VIRTUAL-MEMORY 6.3, EH 6.8, MAKE-SYSTEM 6.5, MICRONET 6.0, LOCAL-FILE 6.2,
;;;  BASIC-PATHNAME 6.5, NETWORK-SUPPORT-COLD 6.2, BASIC-NAMESPACE 6.8, NETWORK-NAMESPACE 6.1,
;;;  DISK-IO 6.4, DISK-LABEL 6.1, BASIC-FILE 6.13, MAC-PATHNAME 6.0, NETWORK-PATHNAME 6.2,
;;;  COMPILER 6.18, TV 6.30, DATALINK 6.0, CHAOSNET 6.8, GC 6.4, MEMORY-AUX 6.0, NVRAM 6.4,
;;;  SYSLOG 6.2, STREAMER-TAPE 6.6, UCL 6.1, INPUT-EDITOR 6.0, METER 6.2, ZWEI 6.22,
;;;  DEBUG-TOOLS 6.5, NETWORK-SUPPORT 6.1, NETWORK-SERVICE 6.3, DATALINK-DISPLAYS 6.0,
;;;  FONT-EDITOR 6.1, SERIAL 6.0, PRINTER 6.8, MAC-PRINTER-TYPES 6.2, PRINTER-TYPES 6.2,
;;;  IMAGEN 6.1, SUGGESTIONS 6.1, MAIL-DAEMON 6.6, MAIL-READER 6.8, TELNET 6.1, VT100 6.0,
;;;  NAMESPACE-EDITOR 6.6, PROFILE 6.3, VISIDOC 6.7, TI-CLOS 6.53, CLEH 6.5, IP 3.65,
;;;  Experimental BUG 11.19, Experimental CLX 7.0, Experimental CLUE 7.2, X11M 6.31,
;;;  Experimental Z-TO-C 3.0, VISIDOC-SERVER 6.2,  microcode 483, Band Name: Rel 6.1 *b +SLE 6/18

#!C
; From file COMMAND-LOOP.LISP#> INPUT-EDITOR; sys:
#8R TV#:
(COMPILER-LET ((*PACKAGE* (FIND-PACKAGE "TV"))
                          (SI:*LISP-MODE* :COMMON-LISP)
                          (*READTABLE* COMMON-LISP-READTABLE)
                          (SI:*READER-SYMBOL-SUBSTITUTIONS* SYS::*COMMON-LISP-SYMBOL-SUBSTITUTIONS*))
  (COMPILER#:PATCH-SOURCE-FILE "SYS: INPUT-EDITOR; COMMAND-LOOP.#"

(DEFUN-RH RH-SEARCH-FOR-MATCHING-LEFT-PAREN (POS)
  "Search for a left paren matching a hypothetical right paren at POS.  TV:RH-BLINK-RIGHT-PAREN
uses this function BEFORE inserting right parens in order to blink the matching left paren."
  (LOOP with save-pos = pos  ; DAB 06-21-90 When thrown out of RH-SEARCH-BACKWARD-PARENS-HELP the original POS is returned.
	FOR new-pos = (CATCH 'FAILED (RH-SEARCH-BACKWARD-PARENS-HELP pos))
	WHILE new-pos
	IF (or (= new-pos pos)
	       (= new-pos save-pos))  ; DAB 06-21-90 Case of throw to 'failed [5536]
	RETURN (MULTIPLE-VALUE-BIND (found which-char)
		   (rh-search-backward-for-chars '(#\( #\) #\") 0 POS)
		 (WHEN (AND FOUND (CHAR= which-char #\())
		   found))
	ELSE DO
	(SETQ pos new-pos)))

))
