;;; -*- Mode: Common-Lisp; Package: MAIl; Base: 10.; Patch-File: T -*-

;;; Reason: Modified (BASIC-ADDRESS :HOST-FOR-QUEUE) to rebind user-id to it global value when this function is called from the servers. Otherwise  use-primary-mail-servers may not return the appropriate site option. [10791]

;;;                           RESTRICTED RIGHTS LEGEND
;;;
;;; Use, duplication, or disclosure by the Government is subject to
;;; restrictions as set forth in subdivision (c)(1)(ii) of the Rights in
;;; Technical Data and Computer Software clause at 52.227-7013.
;;;
;;;   TEXAS INSTRUMENTS INCORPORATED      
;;;   P.O. BOX 2909, M/S 2151             
;;;   AUSTIN, TEXAS 78769                 
;;;
;;; Copyright (C) 1989 Texas Instruments Incorporated.
;;; All rights reserved.

;;; Patch file for MAIL-DAEMON version 6.4
;;; Written 11/30/89 13:19:01 by BERGER,
;;; while running on ARIES from band LODX
;;; With SYSTEM 6.26, VIRTUAL-MEMORY 6.3, EH 6.5, MAKE-SYSTEM 6.2, MICRONET 6.0, LOCAL-FILE 6.1,
;;;  BASIC-PATHNAME 6.2, NETWORK-SUPPORT-COLD 6.2, BASIC-NAMESPACE 6.7, NETWORK-NAMESPACE 6.0,
;;;  DISK-IO 6.1, DISK-LABEL 6.0, BASIC-FILE 6.6, MAC-PATHNAME 6.0, NETWORK-PATHNAME 6.0,
;;;  COMPILER 6.14, TV 6.19, DATALINK 6.0, CHAOSNET 6.5, GC 6.3, MEMORY-AUX 6.0, NVRAM 6.2,
;;;  SYSLOG 6.2, STREAMER-TAPE 6.5, UCL 6.0, INPUT-EDITOR 6.0, METER 6.1, ZWEI 6.8,
;;;  DEBUG-TOOLS 6.3, NETWORK-SUPPORT 6.0, NETWORK-SERVICE 6.2, DATALINK-DISPLAYS 6.0,
;;;  FONT-EDITOR 6.1, SERIAL 6.0, MAC-PRINTER-TYPES 6.1, PRINTER-TYPES 6.2, IMAGEN 6.1,
;;;  SUGGESTIONS 6.1, MAIL-DAEMON 6.3, MAIL-READER 6.6, TELNET 6.0, VT100 6.0, NAMESPACE-EDITOR 6.4,
;;;  PROFILE 6.2, VISIDOC 6.5, TI-CLOS 6.26, CLEH 6.5, IP 3.56, Experimental CLX 6.7,
;;;  CLUE 6.35, X11M 6.17, Experimental BUG 11.17, PRINTER 6.3, Experimental SHRINK-TOOLS 6.1,
;;;   microcode 429, Band Name: rel6.0 10/23

#!C
; From file ADDRESS.LISP#> MAIL-DAEMON; SYS:
#10R MAIL#:
(COMPILER-LET ((*PACKAGE* (FIND-PACKAGE "MAIL"))
                          (SI:*LISP-MODE* :COMMON-LISP)
                          (*READTABLE* SYS:COMMON-LISP-READTABLE)
                          (SI:*READER-SYMBOL-SUBSTITUTIONS* SYS::*COMMON-LISP-SYMBOL-SUBSTITUTIONS*))
  (COMPILER#:PATCH-SOURCE-FILE "SYS: MAIL-DAEMON; ADDRESS.#"


(defmethod (BASIC-ADDRESS :HOST-FOR-QUEUE) (&optional (interactive *interactive-delivery-in-progress*))
  "Determine the host to deliver this address to.  Any necessary processing of the
address should already be done (canonical, verify, stripped, expanded, etc.)  Return
an host object, :SERVER (deliver to a primary server), :UUCP (deliver to a UUCP
gateway), or NIL (undeliverable)."
  (let-if ;; DAB 11-30-89 This function is called by the mail server who bind user-id to "mailer"
    ;;In this case we must change the local binded user-id to it global value, otherwise use-primary-mail-servers
    ;;may not return the appropriate value if the USER value is different from SITE. [10791]
    (and (string-equal (string user-id) "Mailer") (symeval-globally 'user-id))
    ((user-id (symeval-globally 'user-id)))
    
    (let* ((host (send self :destination-host))
	   use-primary)
      
      (cond ((eq (use-primary-mail-servers) :always)  ;; check primary-servers first spr 6643 - nn
	     :server)
	    
	    ((send self :uucp-address-p)
	     :uucp)
	    
	    ((and host (local-host-p host))
	     si:local-host)
	    
	    ;; Check whether to use a server. 
	    ((progn  
	       (setq use-primary (use-primary-mail-servers))
	       (or ;; (eq use-primary :always)           no need check :always here  spr 6643 - nn
		 (and (not interactive)
		      (eq use-primary :after-first-attempt))
		 (and (null host)
		      (eq use-primary :unknown-addresses))))
	     :server)
	    
	    (t
	     host)))))
))
