;;; -*- Mode: Common-Lisp; Package: zwei; Base: 8.; Patch-File: T -*-

;;; Reason: Modified PRETTY-DESCRIPTION-STRING to handle band names greater than 72 characters.[10991]

;;;                           RESTRICTED RIGHTS LEGEND
;;;
;;; Use, duplication, or disclosure by the Government is subject to
;;; restrictions as set forth in subdivision (c)(1)(ii) of the Rights in
;;; Technical Data and Computer Software clause at 52.227-7013.
;;;
;;;   TEXAS INSTRUMENTS INCORPORATED      
;;;   P.O. BOX 2909, M/S 2151             
;;;   AUSTIN, TEXAS 78769                 
;;;
;;; Copyright (C) 1989 Texas Instruments Incorporated.
;;; All rights reserved.

;;; Written 05/08/90 13:05:42 by BERGER,
;;; while running on Pasteur from band LOD3
;;; With SYSTEM 6.31, VIRTUAL-MEMORY 6.3, EH 6.7, Inconsistent MAKE-SYSTEM 6.3, MICRONET 6.0,
;;;  LOCAL-FILE 6.2, BASIC-PATHNAME 6.4, NETWORK-SUPPORT-COLD 6.2, BASIC-NAMESPACE 6.7,
;;;  NETWORK-NAMESPACE 6.1, DISK-IO 6.3, DISK-LABEL 6.0, BASIC-FILE 6.10, MAC-PATHNAME 6.0,
;;;  NETWORK-PATHNAME 6.1, COMPILER 6.14, TV 6.24, DATALINK 6.0, CHAOSNET 6.6, GC 6.3,
;;;  MEMORY-AUX 6.0, NVRAM 6.2, SYSLOG 6.2, STREAMER-TAPE 6.5, UCL 6.0, INPUT-EDITOR 6.0,
;;;  METER 6.1, ZWEI 6.14, DEBUG-TOOLS 6.4, NETWORK-SUPPORT 6.1, NETWORK-SERVICE 6.2,
;;;  DATALINK-DISPLAYS 6.0, FONT-EDITOR 6.1, SERIAL 6.0, PRINTER 6.4, MAC-PRINTER-TYPES 6.2,
;;;  PRINTER-TYPES 6.2, IMAGEN 6.1, SUGGESTIONS 6.1, MAIL-DAEMON 6.6, MAIL-READER 6.7,
;;;  TELNET 6.1, VT100 6.0, NAMESPACE-EDITOR 6.4, PROFILE 6.3, VISIDOC 6.7, TI-CLOS 6.44,
;;;  CLEH 6.5, IP 3.62, Experimental CLX 6.11, CLUE 6.98, X11M 6.22, Experimental BUG 11.19,
;;;  Experimental FOO 3.0, Experimental BAR 3.0, Experimental BAZ 3.0, Experimental FOOBAR 1.0,
;;;   microcode 648, Band Name: rel6.0 1/23

#!C
; From file BUG-REPORT.LISP#> MAIL-READER; SYS:
#8R ZWEI#:
(COMPILER-LET ((*PACKAGE* (FIND-PACKAGE "ZWEI"))
                          (SI:*LISP-MODE* :COMMON-LISP)
                          (*READTABLE* SYS:COMMON-LISP-READTABLE)
                          (SI:*READER-SYMBOL-SUBSTITUTIONS* SYS::*COMMON-LISP-SYMBOL-SUBSTITUTIONS*))
  (COMPILER#:PATCH-SOURCE-FILE "SYS: MAIL-READER; BUG-REPORT.#"


(DEFUN PRETTY-DESCRIPTION-STRING (description)
  ;; Insert CR after every 72 characters in description string.
  (LET ((NEW-DESCRIPTION DESCRIPTION))
    (LOOP WITH LINE-START = 0
	  FOR START = 0 THEN (+ COMMA-POS 2)
	  AS PREV-COMMA-POS = NIL THEN COMMA-POS
	  AS COMMA-POS = (lisp:SEARCH ", " (THE STRING NEW-DESCRIPTION)
				      :START2 START
				      :TEST #'CHAR-EQUAL)
	  WHEN (> (- (OR COMMA-POS (LENGTH NEW-DESCRIPTION )) LINE-START) 72.)
	  UNLESS (NULL PREV-COMMA-POS)
	  DO 
	      (SETF (AREF NEW-DESCRIPTION (1+ PREV-COMMA-POS)) #\NEWLINE)
	      (SETQ LINE-START (+ PREV-COMMA-POS 2))
	      ;;DAB 05-08-90 Band names can exceed 72 characters on the MX. We must check here.
              ;;If it is greater than 72,put a newline after comma-pos.
	      (if (> (- (OR COMMA-POS (LENGTH NEW-DESCRIPTION ))  line-start)
		     72.)
		  (progn (SETF (AREF NEW-DESCRIPTION (1+ comma-pos)) #\NEWLINE)
			 (SETQ LINE-START (+ COMMA-POS 2)))
		  (SETQ COMMA-POS PREV-COMMA-POS))
	  UNTIL (NULL COMMA-POS))
    NEW-DESCRIPTION))
))
