;;; -*- Mode: Common-Lisp; Package: User; Base: 10.; Patch-File: T -*-

;;; Reason: Conditionalize the number of lines in the menu-pane based on the width of
;;; the mouse-sheet so's all commands are available on a small-screen mX.

;;;                           RESTRICTED RIGHTS LEGEND
;;;
;;; Use, duplication, or disclosure by the Government is subject to
;;; restrictions as set forth in subdivision (c)(1)(ii) of the Rights in
;;; Technical Data and Computer Software clause at 52.227-7013.
;;;
;;;   TEXAS INSTRUMENTS INCORPORATED      
;;;   P.O. BOX 2909, M/S 2151             
;;;   AUSTIN, TEXAS 78769                 
;;;
;;; Copyright (C) 1989 Texas Instruments Incorporated.
;;; All rights reserved.

;;; Patch file for METER version 6.1
;;; Written 06/30/89 16:32:52 by GRENINGER,
;;; while running on Salk from band LODA
;;; With SYSTEM 6.9, VIRTUAL-MEMORY 6.1, EH 6.3, MAKE-SYSTEM 6.0, MICRONET 6.0, LOCAL-FILE 6.0,
;;;  BASIC-PATHNAME 6.0, NETWORK-SUPPORT-COLD 6.0, BASIC-NAMESPACE 6.1, NETWORK-NAMESPACE 6.0,
;;;  DISK-IO 6.0, DISK-LABEL 6.0, BASIC-FILE 6.2, MAC-PATHNAME 6.0, NETWORK-PATHNAME 6.0,
;;;  COMPILER 6.6, TV 6.11, DATALINK 6.0, CHAOSNET 6.0, GC 6.3, MEMORY-AUX 6.0, NVRAM 6.1,
;;;  SYSLOG 6.1, STREAMER-TAPE 6.3, UCL 6.0, INPUT-EDITOR 6.0, METER 6.0, ZWEI 6.3,
;;;  DEBUG-TOOLS 6.3, NETWORK-SUPPORT 6.0, NETWORK-SERVICE 6.0, DATALINK-DISPLAYS 6.0,
;;;  FONT-EDITOR 6.1, SERIAL 6.0, PRINTER 6.1, MAC-PRINTER-TYPES 6.1, PRINTER-TYPES 6.0,
;;;  IMAGEN 6.0, SUGGESTIONS 6.0, MAIL-DAEMON 6.2, MAIL-READER 6.0, TELNET 6.0, VT100 6.0,
;;;  NAMESPACE-EDITOR 6.0, PROFILE 6.1, VISIDOC 6.2, TI-CLOS 6.9, CLEH 6.4, IP 3.47,
;;;  Experimental BUG 11.10, Experimental CLX 6.1, CLUE 6.5, X11M 6.1, Experimental GRAPHICS-WINDOW 6.0,
;;;  Experimental GED 6.1, Experimental SC 1.3, Experimental CLUSO 9.0,  microcode 428,
;;;  Band Name: Release 6.0 + SLE 6/5

#!C
; From file METER_TREE.LISP#> METER; MR-X:
#10R METER#:
(COMPILER-LET ((*PACKAGE* (FIND-PACKAGE "METER"))
                          (SI:*LISP-MODE* :COMMON-LISP)
                          (*READTABLE* SYS:COMMON-LISP-READTABLE)
                          (SI:*READER-SYMBOL-SUBSTITUTIONS* SYS::*COMMON-LISP-SYMBOL-SUBSTITUTIONS*))
  (COMPILER#:PATCH-SOURCE-FILE "SYS: METER; METER_TREE.#"


(DEFFLAVOR call-tree-inspector
	   ()
	   (w:process-mixin
	    w:select-mixin
	    w:bordered-constraint-frame-with-shared-io-buffer
	    w:stream-mixin)
  (:documentation "Frame for displaying meter call-tree's")
  (:default-init-plist
;;;    :edges-from :mouse
    :minimum-width  100
    :minimum-height 100
    :superior w:mouse-sheet
    :save-bits t
    :expose-p nil
    :panes
    '((call-tree-pane call-tree-pane :label nil)
      (menu-pane call-tree-menu :label nil :item-list
		 (("Run time" :value run-time :documentation "Display run-time")
		  ("Real time" :value real-time :documentation "Display real-time")
		  ("Page faults" :value page-faults :documentation "Display Number of Page faults")
		  ("Inclusive Run time" :value inclusive-run-time :documentation
		   "Display Run-time used by a function and the functions called by that function")
		  ("Inclusive Page faults" :value inclusive-page-faults :documentation
		   "Display Number of Page Faults in a function and by the functions called by that function")
;;		  ("Print the Call Tree" :funcall print-the-call-tree :documentation
;;		   "Print the displayed Call Tree on the default printer")
		  ))
      (display-pane  call-display-pane :label "Call-tree inspector"))
    :constraints
    `((normal (call-tree-pane menu-pane display-pane)
	      ((display-pane 8. :lines))
	      ((menu-pane ,(IF (< (tv:sheet-width w:mouse-sheet) 800) 2 1) :lines))
	      ((call-tree-pane :even))))))

))
