;;; -*- Mode: Common-Lisp; Package:micronet; Base: 10.; Patch-File: T -*-

;;; Reason: Recompiled flavor methods for add:misc-handler to fix a method combination problem in the MX Deliver Bands(i. e. K920). [10857]

;;;                           RESTRICTED RIGHTS LEGEND
;;;
;;; Use, duplication, or disclosure by the Government is subject to
;;; restrictions as set forth in subdivision (c)(1)(ii) of the Rights in
;;; Technical Data and Computer Software clause at 52.227-7013.
;;;
;;;   TEXAS INSTRUMENTS INCORPORATED      
;;;   P.O. BOX 149149, M/S 2151             
;;;   AUSTIN, TEXAS 78714-9149                 
;;;
;;; Copyright (C) 1989 Texas Instruments Incorporated.
;;; All rights reserved.

;;; Written 02/02/90 14:00:53 by BERGER,
;;; while running on MX29 from band N102
;;; With SYSTEM 6.28, GC 6.3, VIRTUAL-MEMORY 6.3, MICRONET 6.0, MICRONET-COMM 6.1,
;;;  DISK-IO 6.2, DISK-LABEL 6.0, BASIC-PATHNAME 6.3, MAC-PATHNAME 6.0, NETWORK-SUPPORT-COLD 6.2,
;;;  BASIC-NAMESPACE 6.7, BASIC-FILE 6.4, RPC 6.1, NFS-MX 6.1, EH 6.4, MAKE-SYSTEM 6.0,
;;;  MEMORY-AUX 6.0, COMPILER 6.10, TV 6.15, NVRAM 6.1, UCL 6.0, INPUT-EDITOR 6.0,
;;;  MACTOOLBOX 2.7, METER 6.1, ZWEI 6.5, DEBUG-TOOLS 6.3, WINDOW-MX 6.7, PRINTER 6.3,
;;;  MAC-PRINTER-TYPES 6.1, CLIPBOARD 6.1, TI-CLOS 6.20, CLEH 6.5, NETWORK-PATHNAME 6.0,
;;;  NETWORK-NAMESPACE 6.0, DATALINK 6.0, CHAOSNET 6.0, NETWORK-SUPPORT 6.0, NETWORK-SERVICE 6.1,
;;;  DATALINK-DISPLAYS 6.0, MX-DATALINK 6.1, NAMESPACE-EDITOR 6.0, IP 3.47, NFS-MX-SERVER 6.0,
;;;  MX-SERIAL 6.1, PRINTER-TYPES 6.1, IMAGEN 6.0, MAIL-DAEMON 6.2, MAIL-READER 6.2,
;;;  TELNET 6.0, VT100 6.0, STREAMER-TAPE 6.4, DECNET 1.69, VISIDOC 6.2, PROFILE 6.1,
;;;  Experimental CLX 6.2, CLUE 6.10, Experimental BUG 11.14,  microcode 138, Band Name: esmicroExplorer Network + SLE (8/15)

#!C
; From file BASIC-COMM.LISP#> MICRONET; SYS:
#10R MICRONET#:
(COMPILER-LET ((*PACKAGE* (FIND-PACKAGE "MICRONET"))
                          (SI:*LISP-MODE* :COMMON-LISP)
                          (*READTABLE* COMMON-LISP-READTABLE)
                          (SI:*READER-SYMBOL-SUBSTITUTIONS* SYS::*COMMON-LISP-SYMBOL-SUBSTITUTIONS*))
  (COMPILER#:PATCH-SOURCE-FILE "SYS: MICRONET; BASIC-COMM.#"


(defmethod (misc-handler :handle-opcode) (opcode cmd)
  (declare (ignore cmd))
  (if (fboundp 'tv:notify)  ; DAB 02-02-90 We may be in the Deliver Band - Notify is not avialable
	(tv:notify nil "Unknown misc command opcode received:~d" opcode)
	(format T "Unknown misc command opcode received:~d" opcode)))

(compile-flavor-methods misc-handler)


(eval-when (load)
  ;; ; DAB 02-02-90 The fix below will add a dumy method to handle opcode 16. Opcode 16
  ;; is generated from the clipbroad code. Since Deliver Bands do not have clipbroad installed
  ;; an error occurs when the user attempts to leave LISP and RETURN from the MX.
  (unless (boundp 'mactoolbox:*CLIPBOARD-TEMP-HANDLE* )
    (defmethod (ADD:MISC-HANDLER :CASE :HANDLE-OPCODE 16) (cmd)
      (declare (ignore cmd)))))

))

