;;; -*- Mode: Common-Lisp; Package: NAme; Base: 10.; Patch-File: T -*-
;;; Patch file for BASIC-NAMESPACE version 6.1
;;; Reason:  Fixed initialize-sys-host to work with :SYS-HOST-VERSION-ALIST on the microExplorer.
;;; Written 06/15/89 13:07:19 by BERGER,
;;; while running on ARIES from band LODX
;;; With SYSTEM 6.5, VIRTUAL-MEMORY 6.1, EH 6.2, MAKE-SYSTEM 6.0, MICRONET 6.0, LOCAL-FILE 6.0,
;;;  BASIC-PATHNAME 6.0, NETWORK-SUPPORT-COLD 6.0, BASIC-NAMESPACE 6.0, NETWORK-NAMESPACE 6.0,
;;;  DISK-IO 6.0, DISK-LABEL 6.0, BASIC-FILE 6.2, MAC-PATHNAME 6.0, NETWORK-PATHNAME 6.0,
;;;  COMPILER 6.2, TV 6.8, DATALINK 6.0, CHAOSNET 6.0, GC 6.2, MEMORY-AUX 6.0, NVRAM 6.0,
;;;  SYSLOG 6.0, STREAMER-TAPE 6.2, UCL 6.0, INPUT-EDITOR 6.0, METER 6.0, ZWEI 6.1,
;;;  DEBUG-TOOLS 6.0, NETWORK-SUPPORT 6.0, NETWORK-SERVICE 6.0, DATALINK-DISPLAYS 6.0,
;;;  FONT-EDITOR 6.1, SERIAL 6.0, PRINTER 6.1, MAC-PRINTER-TYPES 6.1, PRINTER-TYPES 6.0,
;;;  IMAGEN 6.0, SUGGESTIONS 6.0, MAIL-DAEMON 6.2, MAIL-READER 6.0, TELNET 6.0, VT100 6.0,
;;;  NAMESPACE-EDITOR 6.0, PROFILE 6.1, VISIDOC 6.1, TI-CLOS 6.5, CLEH 6.3, IP 3.46,
;;;  Experimental BUG 11.7, Experimental CLX 6.1, CLUE 6.5, NIL X11M 6.1, DECNET 1.68,
;;;  RPC 6.1, NFS 3.8,  microcode 429, Band Name: Release 6.0 + SLE 6/5

#!C
; From file BOOT.LISP#> NAMESPACE; SYS:
#10R NAME#:
(COMPILER-LET ((*PACKAGE* (FIND-PACKAGE "NAME"))
                          (SI:*LISP-MODE* :COMMON-LISP)
                          (*READTABLE* SYS:COMMON-LISP-READTABLE)
                          (SI:*READER-SYMBOL-SUBSTITUTIONS* SYS::*COMMON-LISP-SYMBOL-SUBSTITUTIONS*))
  (COMPILER#:PATCH-SOURCE-FILE "SYS: NAMESPACE; BOOT.#"


(DEFUN INITIALIZE-SYS-HOST ()
  "Setup SYS host to point to the desired physical host as determined by the following algorithm:

   1) If the SITE OPTION :SYS-HOST-VERSION-ALIST is defined in the format of ((version host-string) ...) , then
      the major version number is used to ASSOC in to the :SYS-HOST-VERSION-ALIST alist value to get the
      desired host-string. The default for this option is NIL. (No attribute)
  
   2) Else If the SITE OPTION :SYS-HOST is defined, it value is used (must be a string).

   3) Else the SYS host is not changed.
 "
  (LET ((SYS-SITE-OPTION
	  (or (SECOND (ASSOC (sys:get-system-version) (get-SITE-OPTION :SYS-HOST-VERSION-ALIST)))	;; may 06/12/89 
	      (GET-SITE-OPTION :SYS-HOST))))
    (WHEN (AND SYS-SITE-OPTION
	       ;; Test below will think "sys" and "sys4" hosts are different even though "sys" may
	       ;; translate to "sys4" ...
	       (NOT (EQ (SI:PARSE-HOST SYS-SITE-OPTION T)
			(SI:PARSE-HOST "SYS" T))))
      (NET:SET-LOGICAL-HOST "SYS" SYS-SITE-OPTION :LOCAL-ONLY T))))
))
