;;; -*- Mode: Common-Lisp; Package: NAME; Base: 10.; Patch-File: T -*-

;;; Reason: Fixed initialize-local-host and run-standalone to call init-the-clock.

;;;                           RESTRICTED RIGHTS LEGEND
;;;
;;; Use, duplication, or disclosure by the Government is subject to
;;; restrictions as set forth in subdivision (c)(1)(ii) of the Rights in
;;; Technical Data and Computer Software clause at 52.227-7013.
;;;
;;;   TEXAS INSTRUMENTS INCORPORATED      
;;;   P.O. BOX 2909, M/S 2151             
;;;   AUSTIN, TEXAS 78769                 
;;;
;;; Copyright (C) 1989 Texas Instruments Incorporated.
;;; All rights reserved.

;;; Written 07/25/89 06:52:29 by BERGER,
;;; while running on ARIES from band LOD1
;;; With SYSTEM 6.13, VIRTUAL-MEMORY 6.1, EH 6.4, MAKE-SYSTEM 6.0, MICRONET 6.0, LOCAL-FILE 6.0,
;;;  BASIC-PATHNAME 6.1, NETWORK-SUPPORT-COLD 6.0, BASIC-NAMESPACE 6.1, NETWORK-NAMESPACE 6.0,
;;;  DISK-IO 6.1, DISK-LABEL 6.0, BASIC-FILE 6.2, MAC-PATHNAME 6.0, NETWORK-PATHNAME 6.0,
;;;  COMPILER 6.10, TV 6.15, DATALINK 6.0, CHAOSNET 6.0, GC 6.3, MEMORY-AUX 6.0, NVRAM 6.1,
;;;  SYSLOG 6.1, STREAMER-TAPE 6.4, UCL 6.0, INPUT-EDITOR 6.0, METER 6.1, ZWEI 6.5,
;;;  DEBUG-TOOLS 6.3, NETWORK-SUPPORT 6.0, NETWORK-SERVICE 6.1, DATALINK-DISPLAYS 6.0,
;;;  FONT-EDITOR 6.1, SERIAL 6.0, PRINTER 6.3, MAC-PRINTER-TYPES 6.1, PRINTER-TYPES 6.1,
;;;  IMAGEN 6.0, SUGGESTIONS 6.0, MAIL-DAEMON 6.2, MAIL-READER 6.2, TELNET 6.0, VT100 6.0,
;;;  NAMESPACE-EDITOR 6.0, PROFILE 6.1, VISIDOC 6.2, TI-CLOS 6.19, CLEH 6.5, IP 3.47,
;;;  Experimental CLX 6.2, CLUE 6.10, X11M 6.13, Experimental BUG 11.10,  microcode 429,
;;;  Band Name: 6.0 7/19 +clock

#!C
; From file BOOT.LISP#> NAMESPACE; SYS:
#10R NAME#:
(COMPILER-LET ((*PACKAGE* (FIND-PACKAGE "NAME"))
                          (SI:*LISP-MODE* :COMMON-LISP)
                          (*READTABLE* SYS:COMMON-LISP-READTABLE)
                          (SI:*READER-SYMBOL-SUBSTITUTIONS* SYS::*COMMON-LISP-SYMBOL-SUBSTITUTIONS*))
  (COMPILER#:PATCH-SOURCE-FILE "SYS: NAMESPACE; BOOT.#"


(DEFUN INITIALIZE-LOCAL-HOST (&OPTIONAL TRACE)
  (WHEN TRACE
    (FORMAT T "~&Initializing the network ...~%"))
  (SETUP-LOCAL-HOST)
  (INITIALIZATIONS 'NET:*NETWORK-WARM-INITIALIZATION-LIST* T)
  (WHEN TRACE
    (FORMAT T "~&Setting up SYS host ...~%"))
  (INITIALIZE-SYS-HOST)
  (WHEN TRACE
    (FORMAT T "~&Setting up SITE options ...~%"))
  ;;Reinitialize the CLOCK. network should be up and ready by now. 
  ;;This used to be done on NET:*NETWORK-WARM-INITIALIZATION-LIST* but IP would not be up at that time.
  ;;You would get an error when your time servers were IP based.
  (time:init-the-clock)  ; DAB 07-25-89
  (INITIALIZATIONS 'SI:SITE-OPTION-INITIALIZATION-LIST T))

(DEFUN RUN-STANDALONE ()
  "Initialize namespaces to use only the local distribution namespace.  
   This is useful if you can't get to any namespace servers and need to continue
   working at your local machine (saving files, etc.)."
  (INITIALIZE-DISTRIBUTION-NAMESPACE NIL T)
  ;;04-20-88 DAB Added. Use to be in Initialize-distribution-namespace. Needs to be here in order to reset routing tables. 
  (INITIALIZATIONS 'NET:*NETWORK-WARM-INITIALIZATION-LIST* T)
  (time:init-the-clock)  ; DAB 07-24-89
  :STANDALONE)

(delete-initialization "Initialize the Clock" () 'net:*network-warm-initialization-list*)

))
