;;; -*- Mode: Common-Lisp; Package: NAME; Base: 10.; Patch-File: T -*-

;;; Reason:  Fixes "window Lock" problems on the MX when NEtwork initialization alternative menu timeouts.DB,MY[9904]

;;;                           RESTRICTED RIGHTS LEGEND
;;;
;;; Use, duplication, or disclosure by the Government is subject to
;;; restrictions as set forth in subdivision (c)(1)(ii) of the Rights in
;;; Technical Data and Computer Software clause at 52.227-7013.
;;;
;;;   TEXAS INSTRUMENTS INCORPORATED      
;;;   P.O. BOX 2909, M/S 2151             
;;;   AUSTIN, TEXAS 78769                 
;;;
;;; Copyright (C) 1989 Texas Instruments Incorporated.
;;; All rights reserved.

;;; Patch file for BASIC-NAMESPACE version 6.3
;;; Written 10/04/89 07:41:27 by BERGER,
;;; while running on ARIES from band LODX
;;; With SYSTEM 6.17, VIRTUAL-MEMORY 6.2, EH 6.5, MAKE-SYSTEM 6.1, MICRONET 6.0, LOCAL-FILE 6.1,
;;;  BASIC-PATHNAME 6.1, NETWORK-SUPPORT-COLD 6.0, BASIC-NAMESPACE 6.2, NETWORK-NAMESPACE 6.0,
;;;  DISK-IO 6.1, DISK-LABEL 6.0, BASIC-FILE 6.3, MAC-PATHNAME 6.0, NETWORK-PATHNAME 6.0,
;;;  COMPILER 6.12, TV 6.15, DATALINK 6.0, CHAOSNET 6.1, GC 6.3, MEMORY-AUX 6.0, NVRAM 6.1,
;;;  SYSLOG 6.1, STREAMER-TAPE 6.4, UCL 6.0, INPUT-EDITOR 6.0, METER 6.1, ZWEI 6.5,
;;;  DEBUG-TOOLS 6.3, NETWORK-SUPPORT 6.0, NETWORK-SERVICE 6.1, DATALINK-DISPLAYS 6.0,
;;;  FONT-EDITOR 6.1, SERIAL 6.0, PRINTER 6.3, MAC-PRINTER-TYPES 6.1, PRINTER-TYPES 6.1,
;;;  IMAGEN 6.0, SUGGESTIONS 6.0, MAIL-DAEMON 6.2, MAIL-READER 6.2, TELNET 6.0, VT100 6.0,
;;;  NAMESPACE-EDITOR 6.0, PROFILE 6.1, VISIDOC 6.4, TI-CLOS 6.24, CLEH 6.5, IP 3.50,
;;;  Experimental CLX 6.3, CLUE 6.17, X11M 6.14, Experimental BUG 11.15, VISIDOC-SERVER 6.1,
;;;   microcode 429, Band Name: Rel 6.0 + SLE 8/30

#!C
; From file BOOT.LISP#> NAMESPACE; SYS:
#10R NAME#:
(COMPILER-LET ((*PACKAGE* (FIND-PACKAGE "NAME"))
                          (SI:*LISP-MODE* :COMMON-LISP)
                          (*READTABLE* SYS:COMMON-LISP-READTABLE)
                          (SI:*READER-SYMBOL-SUBSTITUTIONS* SYS::*COMMON-LISP-SYMBOL-SUBSTITUTIONS*))
  (COMPILER#:PATCH-SOURCE-FILE "SYS: NAMESPACE; BOOT.#"


(DEFUN IDENTIFY-SELF  (&OPTIONAL (MY-NAME (COMPLETE-MACHINE-NAME))
		       (BROADCAST-INITIALLY *BROADCAST-INITIALLY*)
		       DEBUG
		       (CATCH-ERRORS *CATCH-ERRORS-WHILE-BOOTING*))
  
  
  ;; cold-loaded without W
  (UNLESS *WINDOW-SYSTEM-CHOOSE-FUNCTION*
    (SETF *WINDOW-SYSTEM-CHOOSE-FUNCTION* (SYMBOL-REF "W" "MENU-CHOOSE")))
  (UNLESS *CURRENT-WINDOW-VAR* 
    (SETF *CURRENT-WINDOW-VAR* (SYMBOL-REF "W" "MOUSE-WINDOW")))
  
  (SETF MY-NAME (STRING-UPCASE MY-NAME))

  (LET* (NEW-NETWORK-NS
	 (DOMAIN "")
	 (WHO-AM-I-NAME (STRING-UPCASE (ACTUAL-WHO-AM-I-NAME MY-NAME)))
	 (PERMANENT-DOMAIN-CHANGE T)
	 SERVER-NAME
	 SERVER
	 (SYSTEM-TYPE :LISPM)
         (CONTROLLER-NUMBER 1)
	 ME
         CHOICE
         ALLOW-SAVE-OPTION
	 (SECONDARY-TITLE-STRING
	   (FORMAT NIL "~%    Choose a network initialization alternative:               [T/O=~D mins]" *IDENTIFY-TIMEOUT*))
	 (MAIN-TITLE-STRING ">>> No Explorer Nameserver knows this machine as")
	 (MAIN-TITLE-FORMAT-STRING "~A ~A. ~A")
	 (MAIN-TITLE (FORMAT NIL MAIN-TITLE-FORMAT-STRING MAIN-TITLE-STRING WHO-AM-I-NAME SECONDARY-TITLE-STRING))
         (BEG-NOP-TITLE SECONDARY-TITLE-STRING)
	 (NEG-EXPL-SERVER ">>> Unsuccessful at becoming a client of an Explorer server because:~%      ~A. ~A")
	 (NEG-SYM-SERVER  ">>> Unsuccessful at contacting a Symbolics server because:~%      ~A. ~A")    
	 (NEG-LOCAL-SERVER  ">>> Unsuccessful at loading a local namespace because:~%      ~A. ~A")    
	 (NEG-CONVERT      ">>> Unsuccessful at converting an existing configuration because:  ~%      ~A. ~A")
	 (AFTER-NAME-CHANGE ">>> The name of this machine is now ~A. ~A")
	 (NETWORK-TYPE (CAR *AVAILABLE-NETWORK-TYPES*))
	 (TITLE (IF BROADCAST-INITIALLY MAIN-TITLE BEG-NOP-TITLE))
	 (SITEINFO-PATH "LM:SITE;SITEINFO.XFASL")
         (RETRY-STRING "Try (again) to locate an Explorer Nameserver that knows about ~A ")
	 (MAIN-MENU-LAYOUT
	   `(("" :NO-SELECT T)
	     (,(PAD "Change the name of this machine and return to this menu")  :VALUE :NEW-NAME)
	     ("" :NO-SELECT T)
	     (,(PAD (FORMAT NIL RETRY-STRING WHO-AM-I-NAME))  :VALUE :RETRY)
	     ("" :NO-SELECT T)
	     (,(PAD "Try to contact a specific Explorer Nameserver directly")  :VALUE :DIRECT)
	     ("" :NO-SELECT T)
	     (,(PAD "Convert an existing Network Configuration file into a namespace") :VALUE :CONVERT)
	     ("" :NO-SELECT T)
	     (,(PAD "Create a new network namespace after booting") :VALUE :CREATE)
	     ("" :NO-SELECT T)
	     (,(PAD "Try to contact a specific non-Explorer nameserver") :VALUE :FOREIGN)
	     ("" :NO-SELECT T)
             (,(PAD "Try loading local files to use this machine as a temporary nameserver  ") :VALUE :FORCE-LOCAL)
	     ("" :NO-SELECT T)
	     ("" :NO-SELECT T)
	     (,(PAD "Run stand-alone (no networking)  [* DEFAULT *]") :VALUE NIL)))
	 (WINDOWS (AND *WINDOW-SYSTEM-CHOOSE-FUNCTION* (FBOUNDP *WINDOW-SYSTEM-CHOOSE-FUNCTION*)))
         (NET-ADDR-DOC-STRING "Enter an address which matches the network type chosen;
  The address can be a number or a string respresenting an alternate format."))
    
    (WHEN *NON-STANDARD-BOOT-ALTERNATIVE*
      (SETF DOMAIN       (SECOND  *NON-STANDARD-BOOT-ALTERNATIVE*)
	    NETWORK-TYPE (THIRD   *NON-STANDARD-BOOT-ALTERNATIVE*)
	    SERVER       (FOURTH  *NON-STANDARD-BOOT-ALTERNATIVE*)
	    ME           (FIFTH  *NON-STANDARD-BOOT-ALTERNATIVE*)
	    CONTROLLER-NUMBER (SIXTH *NON-STANDARD-BOOT-ALTERNATIVE*)))
    
    (LOOP 
      DO
      (SETQ *NET-DOMAIN* NIL)
      (SELECT 
	(SETF CHOICE
	      (COND
		((NOT WINDOWS)
                 :COLD)

		((NULL *network-environment*)
		 :no-networking)
		
		(*NON-STANDARD-BOOT-ALTERNATIVE*
		 (CAR *NON-STANDARD-BOOT-ALTERNATIVE*))
		
		(BROADCAST-INITIALLY :RETRY)
		
		(:OTHERWISE
		 (LET ((current-window (OR (SYMBOL-VALUE (FIND-SYMBOL "SELECTED-WINDOW" 'W))	; may 08/03/89 
					   *terminal-io*)))				        ; DAB 10-04-89
		   (WITH-TIMEOUT ((* *IDENTIFY-TIMEOUT* 60 60)

				  ;; may 08/03/89 
				  ;; The whole idea here is to deexpose the menu instance w:menu-choose allocates.
				  ;; The commented code above does not work on MX since the mouse cannot be warped
				  ;; on top of the menu  so that (eval tv:mouse-window) will be the menu instance.
				  ;; Since w:menu-choose is a temporary window, when it exposes, it will lock the
				  ;; currently selected window by pushing itself in the lock instance.
				  ;; The lock allows the menu instance to use its temporary bit-array to save and
				  ;; restore the window bits underneath.
				  ;; The comment below by LSS has been around since rel3 and seems unecessary since
				  ;; the default is '(:mouse) which should have worked on Explorer even then?
				  ;; 
				  ;; (need to possibly remove defvar and exports of *CURRENT-WINDOW-VAR* in code )
				  ;; 
				  (LET ((MENU (FIND TITLE (SEND CURRENT-WINDOW :LOCK)
						    :KEY #'(LAMBDA (W)
							     (FUNCALL (FIND-SYMBOL "LABEL-STRING" 'TV) (SEND W :LABEL)))
						    :TEST #'STRING-EQUAL)))
				    (AND MENU (SEND MENU :DEEXPOSE)))
				  :TIMEOUT)
		     (FUNCALL *WINDOW-SYSTEM-CHOOSE-FUNCTION*
			      MAIN-MENU-LAYOUT
			      :LABEL TITLE
			      ;; SPECIFY NEAR-MODE TO OVERCOME A WINDOW-LOCK PROBLEM - LSS
			      :NEAR-MODE `(:POINT ,(SEND (SYMBOL-VALUE
							   (FIND-SYMBOL "DEFAULT-SCREEN" 'W))
							 :WIDTH) 0)
			      :ITEM-ALIGNMENT :LEFT      
			      :DEFAULT-ITEM (fourth MAIN-MENU-LAYOUT))))
		 ))) ;; may 12-19-88 FOURTH was SECOND
	
        (:COLD
	 (FORMAT T "~%~% *** Running stand-alone in a cold climate. ***~%~%")
	 (RETURN))

        (:no-networking
	 (FORMAT T "~%~% *** Running stand-alone (no networking). ***~%~%")
	 (RETURN))
	
	(:TIMEOUT
	 (FORMAT T "~%~% *** MENU TIMEOUT: Running stand-alone (no networking). ***~%~%")
	 (RETURN))
	
	(:CREATE
	 (FORMAT T "~%~% *** To create a new network namespace after booting has completed, 
     select the Namespace Editor from the System Menu.~2%")
	 (RETURN))
	
	(:CONVERT
	 (WHEN (CVV-WITH-ABORT
		 :HANDLE
		 `(""
		   (,(LOCF DOMAIN)   "Namespace name" 
		    :DOCUMENTATION "L: input a new value from the keyboard, R: edit this value;
 Enter a name to call the new namespace to be created."
		    :STRING)
		   (,(LOCF SITEINFO-PATH) "Pathname of a NetConfig Siteinfo file" 
		    :DOCUMENTATION
		    "L: input a new value from the keyboard, R: edit this value;
 If the pathname contains the host of an unknown host, you will be asked for its address."
		    :STRING)
                   "")
		 :EXTRA-WIDTH 15
		 :LABEL "Convert siteinfo file into network namespace")
	   
	   
	   (CONDITION-CASE-IF CATCH-ERRORS (CONDITION)
	       (PROGN
		
		(LET* ((COLON-IX (POSITION #\: SITEINFO-PATH))
		       (HOST-NAME (IF COLON-IX (SUBSEQ SITEINFO-PATH 0 COLON-IX)
				      (SETF SITEINFO-PATH (STRING-APPEND "SITEINFO-HOST:" SITEINFO-PATH))
				      "SITEINFO-HOST"))
		       INNER-ABORT)
		  (UNLESS (SI:PARSE-HOST HOST-NAME T)
		    (IF (CVV-WITH-ABORT
			  :HANDLE
			  `(""
			    (,(LOCF NETWORK-TYPE) "Network type for remote file access" :CHOOSE ,*AVAILABLE-NETWORK-TYPES*)
			    (,(LOCF ME)     ,(FORMAT NIL "Network address of this host [~A]" (RELATIVE-MACHINE-NAME))
			     :DOCUMENTATION ,NET-ADDR-DOC-STRING :SEXP)
			    (,(LOCF SERVER) ,(FORMAT NIL "Network address of the remote host [~A]" HOST-NAME)
			     :DOCUMENTATION ,NET-ADDR-DOC-STRING :SEXP)
			    ""
			    (,(LOCF SYSTEM-TYPE) ,(FORMAT NIL "System software type of the remote host [~A]" HOST-NAME)
			     :MENU *CONVERT-SYSTEM-TYPES*)
			    "")
			  :EXTRA-WIDTH 15
			  :LABEL "Enter information required to get a remote siteinfo file")
			;; THEN create this host in the Distribution namespace
			(THEN
			  (INITIALIZE-DISTRIBUTION-NAMESPACE (LIST (LIST NETWORK-TYPE ME)) T NIL)
			  
			  (ADD-OBJECT HOST-NAME :HOST :NAMESPACE *DISTRIBUTION-NAME*
				      :ATTRIBUTES (LIST '(:ADDRESSES :GROUP) (LIST (LIST NETWORK-TYPE SERVER))
							'(:SERVICES :GROUP) (LIST (GET-FILE-SERVICE NETWORK-TYPE))
							:SYSTEM-TYPE SYSTEM-TYPE)
				      :PRE-DELETE T))
			;; ELSE
			(SETF INNER-ABORT T)))
		  
		  (UNLESS INNER-ABORT
		    (IF DEBUG
			(FERROR NIL "SOME DUMMY NAMED ~A PUT YOU IN DEBUG MODE" USER-ID)
			;; else
                        (LET ((USER-ID "BOOT"))
			  (COMPILER-LET ((INHIBIT-STYLE-WARNINGS-SWITCH T))
    			    (NET:CONVERT-SITEINFO DOMAIN SITEINFO-PATH))))
		    (SETF *NET-DOMAIN* DOMAIN) 
		    (RETURN (SETF NEW-NETWORK-NS T)))))
	     
	     (ERROR
	      (SETF TITLE (FORMAT NIL NEG-CONVERT
				  (SEND CONDITION :SEND-IF-HANDLES :REPORT-STRING) SECONDARY-TITLE-STRING))))))
	
	(:NEW-NAME
	 (WHEN (CVV-WITH-ABORT
		 :HANDLE
		 `(""
		   (,(LOCF MY-NAME) "New machine (pack) name" :STRING)
		   (*DEFAULT-WHO-AM-I-DOMAIN* "Desired namespace (optional)" :STRING)
		   (,(LOCF PERMANENT-DOMAIN-CHANGE) "Save desired namespace in pack-name?" :BOOLEAN)
		   "")
		 :EXTRA-WIDTH 15
		 :LABEL "Change machine name")

           (WHEN (OR (ZEROP (LENGTH *DEFAULT-WHO-AM-I-DOMAIN*))
		     (STRING-EQUIV *DEFAULT-WHO-AM-I-DOMAIN* "nil"))
	     (SETQ *DEFAULT-WHO-AM-I-DOMAIN* NIL))

           (SETF MY-NAME (STRING-UPCASE MY-NAME))
	   (WHEN (STRINGP *DEFAULT-WHO-AM-I-DOMAIN*)
	     (SETF *DEFAULT-WHO-AM-I-DOMAIN* (STRING-UPCASE *DEFAULT-WHO-AM-I-DOMAIN*)))
           (WHEN (AND *DEFAULT-WHO-AM-I-DOMAIN* PERMANENT-DOMAIN-CHANGE)
	     (SETF MY-NAME (RELATIVE-NAME MY-NAME)))
           (SETF WHO-AM-I-NAME (ACTUAL-WHO-AM-I-NAME MY-NAME))
	   (WHEN PERMANENT-DOMAIN-CHANGE
	     (SETF MY-NAME WHO-AM-I-NAME))
	   
           ;; Replace the string in the menu that mentions the machine name
           (LOOP FOR ENTRY IN MAIN-MENU-LAYOUT DO
		 (WHEN (MEMBER :RETRY ENTRY :TEST 'EQ)
		   (RPLACA ENTRY (PAD (FORMAT NIL RETRY-STRING WHO-AM-I-NAME)))))
	   
           (UNLESS (OR DEBUG (NOT (VALIDATE-PARM 'MY-NAME MY-NAME :NO-ERROR)))
             (if (and (si:get-configuration) (si:config-host-name-p))
		 (si:set-cfg-host-name MY-NAME)
		 (SI:SET-PACK-HOST-NAME MY-NAME))
	     (INITIALIZE-DISTRIBUTION-NAMESPACE NIL T NIL))
	   (SETF TITLE
		 (FORMAT NIL AFTER-NAME-CHANGE (IF DEBUG MY-NAME (COMPLETE-MACHINE-NAME)) SECONDARY-TITLE-STRING))
	   ))      
	(:RETRY
	 (CONDITION-CASE-IF CATCH-ERRORS (CONDITION)
	     (COND
	      (DEBUG (FERROR NIL "DEBUG :RETRY"))
               
	      ((or (not (boundp 'net:controller-list))	  ; DAB 03-09-89
		   (null net:controller-list))
	       ;; don't try to go out on ETHERNET (and pop up menu) if no hardware exists !!!
	       (FERROR NIL "No Controller"))
	      
	      ((AND (MULTIPLE-VALUE-SETQ (DOMAIN SERVER-NAME SERVER ME) (WHO-AM-I MY-NAME))
		    (NULL SERVER-NAME))		; => short-circuit who-am-i
	       (SETQ *NET-DOMAIN* DOMAIN)
	       (BUILD-NS-SEARCH-LIST)
	       (RETURN))
	      
	      ((NULL DOMAIN)			;;; No response
	       (SETF TITLE (FORMAT NIL MAIN-TITLE-FORMAT-STRING MAIN-TITLE-STRING WHO-AM-I-NAME SECONDARY-TITLE-STRING)))
	      
	      ((let ((*rpc-timeout* 2500)   ;07-11-88 DAB
		     (*rpc-validate-timeout* 15))
		 (CREATE-PUBLIC-NAMESPACE DOMAIN SERVER-NAME SERVER ME))
	       (FORMAT T "~2% *** Successfully contacted a server (~A) for namespace ~A~2%"
		       (STRING-UPCASE SERVER-NAME) (STRING-UPCASE DOMAIN))
	       (RETURN (SETF NEW-NETWORK-NS T)))
	      
	      (:OTHERWISE
	       (FERROR NIL "???")))
	   
	   (ERROR
	    (if (and (boundp 'net:controller-list) net:controller-list)  ; DAB 03-09-89
		(SETF TITLE (FORMAT NIL NEG-EXPL-SERVER (SEND CONDITION :REPORT-STRING)  SECONDARY-TITLE-STRING))
		;;ELSE No ethernet broad. 01-10-89 DAB  Error coming back is FUNCTION NIL undefined.
		(SETF TITLE (FORMAT NIL NEG-EXPL-SERVER "the Ethernet Controller is not available"
				    SECONDARY-TITLE-STRING)))))
	 )
	(:DIRECT
	 (WHEN (OR *NON-STANDARD-BOOT-ALTERNATIVE*
		   (PROGN
		     (CVV-WITH-ABORT
		       :HANDLE
		       `(""
			 (,(LOCF DOMAIN) "Namespace name" :STRING)
			 (,(LOCF NETWORK-TYPE) "Network type" :CHOOSE ,*AVAILABLE-NETWORK-TYPES*)
			 (,(LOCF ME)     "Network address of this machine" 
			            :DOCUMENTATION ,NET-ADDR-DOC-STRING :SEXP)
			 (,(LOCF SERVER) "Network address of the Explorer Nameserver" 
			            :DOCUMENTATION ,NET-ADDR-DOC-STRING :SEXP)
			 (,(LOCF CONTROLLER-NUMBER) "Ethernet Controller number for these addresses" :SEXP)
			 "")
                       :EXTRA-WIDTH 10
		       :LABEL "Contact Explorer Nameserver")))
	   
           (CONDITION-CASE-IF CATCH-ERRORS (CONDITION)
	     (PROGN
	      (when (or (not (boundp 'net:controller-list))	  ; DAB 03-09-89
			(null net:controller-list))
		;; don't try to go out on ETHERNET (and pop up menu) if no hardware exists !!!
		(FERROR NIL "No Controller"))
               (VALIDATE-PARM "Namespace name" DOMAIN)
	       (VALIDATE-PARM "Network address of this machine" ME)
	       (VALIDATE-PARM "Network address of the Explorer Nameserver" SERVER)
               (WHEN DEBUG (FERROR NIL "DEBUG :DIRECT"))
  	       (WHEN (CREATE-PUBLIC-NAMESPACE DOMAIN "BOOTSTRAP-NAMESPACE-SERVER"
						     (BUILD-ADDRESS-LIST NETWORK-TYPE SERVER CONTROLLER-NUMBER)
						     (BUILD-ADDRESS-LIST NETWORK-TYPE ME CONTROLLER-NUMBER))
	           (SETF ALLOW-SAVE-OPTION (NOT *NON-STANDARD-BOOT-ALTERNATIVE*))
                   (FORMAT T "~2% *** Successfully contacted a server for namespace ~A~2%" DOMAIN)
	           (RETURN (SETF NEW-NETWORK-NS T))))
	     (ERROR
  	         (SETF *NON-STANDARD-BOOT-ALTERNATIVE* NIL)	;allow some other choice
		  (if (and (boundp 'net:controller-list ) net:controller-list) ;01-10-89
		      (SETF TITLE (FORMAT NIL NEG-EXPL-SERVER (SEND CONDITION :REPORT-STRING) SECONDARY-TITLE-STRING))
		      ;;ELSE No ethernet broad. 01-10-89 DAB  Error coming back is FUNCTION NIL undefined.
		      (SETF TITLE (FORMAT NIL NEG-EXPL-SERVER "the Ethernet Controller is not available"
					  SECONDARY-TITLE-STRING)))))))
	
	(:FOREIGN
	 (WHEN (OR *NON-STANDARD-BOOT-ALTERNATIVE*
	           (CVV-WITH-ABORT
		       :HANDLE
		       `(""
			 (,(LOCF ME)     "Chaos address of this machine" :NUMBER)
			 (,(LOCF SERVER) "Chaos address of the Symbolics Nameserver" :NUMBER)
			 (,(LOCF CONTROLLER-NUMBER) "Ethernet Controller number for these addresses" :SEXP)
			 "")
                       :EXTRA-WIDTH 10
		       :LABEL "Contact Symbolics nameserver"))
           (CONDITION-CASE-IF CATCH-ERRORS (CONDITION)
             (PROGN
               (WHEN DEBUG (FERROR NIL "DEBUG :SYMBOLICS"))
	       (when (or (not (boundp 'net:controller-list))	  ; DAB 03-09-89
			(null net:controller-list))
		;; don't try to go out on ETHERNET (and pop up menu) if no hardware exists !!!
		(FERROR NIL "No Controller"))
	       (UNLESS (SETF DOMAIN (SETUP-SYMBOLICS-CLIENT SERVER ME CONTROLLER-NUMBER))
		 (FERROR NIL "No server responded to WHO-AM-I"))
  	       (SETF ALLOW-SAVE-OPTION (NOT *NON-STANDARD-BOOT-ALTERNATIVE*))
               (FORMAT T "~2% *** Successfully contacted a server for namespace ~A~2%" DOMAIN)
	       (RETURN (SETQ NEW-NETWORK-NS T)))
	   (ERROR
	       (SETF *NON-STANDARD-BOOT-ALTERNATIVE* NIL)	;allow some other choice
	       (if (and (boundp 'net:controller-list) net:controller-list) ;01-10-89
		   (SETF TITLE (FORMAT NIL NEG-SYM-SERVER (SEND CONDITION :REPORT-STRING) SECONDARY-TITLE-STRING))
		   ;;ELSE No ethernet broad. 01-10-89 DAB  Error coming back is FUNCTION NIL undefined.
		   (SETF TITLE (FORMAT NIL NEG-SYM-SERVER
				       "the Ethernet Controller is not available"
				       SECONDARY-TITLE-STRING)))))))
	
        (:FORCE-LOCAL
	   (WHEN (OR *NON-STANDARD-BOOT-ALTERNATIVE*
		       (CVV-WITH-ABORT :HANDLE
	                  `(""
			    (,(LOCF DOMAIN) "Name of the local namespace to try loading" :STRING)
			    "")
			  :EXTRA-WIDTH 20
			  :LABEL "Force local namespace load"))
           (CONDITION-CASE-IF CATCH-ERRORS (CONDITION)
              (PROGN
		 (FORCE-LOCAL-SERVER-BOOT DOMAIN :STANDALONE T)
		 (IF (LIST-OBJECT (RELATIVE-NAME MY-NAME) :HOST
				  :NAMESPACE DOMAIN :BRIEF T :CHASE-ALIASES NIL :MERGE-ALIASES NIL)
		     (THEN
                        (SETQ *NET-DOMAIN* DOMAIN)
                        (FORMAT T "~2% *** Successfully started a local server for namespace ~A~2%" DOMAIN)
 	                (SETF ALLOW-SAVE-OPTION (NOT *NON-STANDARD-BOOT-ALTERNATIVE*))
			(RETURN (SETQ NEW-NETWORK-NS T)))
		     (ELSE
		        (FERROR NIL "There is still no network namespace which contains a host called ~A"
				(RELATIVE-NAME MY-NAME)))))

	     (ERROR 
	       (SETF *NON-STANDARD-BOOT-ALTERNATIVE* NIL)	;allow some other choice
	       (SETF TITLE (FORMAT NIL NEG-LOCAL-SERVER (SEND CONDITION :REPORT-STRING) SECONDARY-TITLE-STRING))))))
	
	(NIL
	 (FORMAT T "~%~% *** Running stand-alone (no networking). ***~%~%")
         (SETF ALLOW-SAVE-OPTION (NOT *NON-STANDARD-BOOT-ALTERNATIVE*))
	 (RETURN)))
      
      (SETF BROADCAST-INITIALLY NIL))		;NEXT TIME AROUND, BE SURE AND ASK
    
    ;; Note that we havn't set this if they set *NON-STANDARD-BOOT-ALTERNATIVE* on a previous pass
    (WHEN (AND ALLOW-SAVE-OPTION 
               (WITH-TIMEOUT ((* *IDENTIFY-TIMEOUT* 60 60) NIL)
  	         (YES-OR-NO-P "Should your choice be the default for booting a disk-saved version of this band?")))
      (SETF *NON-STANDARD-BOOT-ALTERNATIVE*
	    (LIST CHOICE DOMAIN NETWORK-TYPE SERVER ME CONTROLLER-NUMBER)))

    NEW-NETWORK-NS))
))
