;;; -*- Mode: Common-Lisp; Package: SYS; Base: 10.; Patch-File: T -*-

;;; Reason:  Modified CREATE-PUBLIC-NAMESPACE to call initialize-distribution-namespace after we are certain we can connect to name server. [9547]

;;;                           RESTRICTED RIGHTS LEGEND
;;;
;;; Use, duplication, or disclosure by the Government is subject to
;;; restrictions as set forth in subdivision (c)(1)(ii) of the Rights in
;;; Technical Data and Computer Software clause at 52.227-7013.
;;;
;;;   TEXAS INSTRUMENTS INCORPORATED      
;;;   P.O. BOX 2909, M/S 2151             
;;;   AUSTIN, TEXAS 78769                 
;;;
;;; Copyright (C) 1989 Texas Instruments Incorporated.
;;; All rights reserved.

;;; Written 10/16/89 12:20:41 by BERGER,
;;; while running on ARIES from band LODA
;;; With SYSTEM 6.20, VIRTUAL-MEMORY 6.2, EH 6.5, MAKE-SYSTEM 6.2, MICRONET 6.0, LOCAL-FILE 6.1,
;;;  BASIC-PATHNAME 6.2, NETWORK-SUPPORT-COLD 6.2, BASIC-NAMESPACE 6.4, NETWORK-NAMESPACE 6.0,
;;;  DISK-IO 6.1, DISK-LABEL 6.0, BASIC-FILE 6.4, MAC-PATHNAME 6.0, NETWORK-PATHNAME 6.0,
;;;  COMPILER 6.12, TV 6.15, DATALINK 6.0, CHAOSNET 6.1, GC 6.3, MEMORY-AUX 6.0, NVRAM 6.2,
;;;  SYSLOG 6.2, STREAMER-TAPE 6.4, UCL 6.0, INPUT-EDITOR 6.0, METER 6.1, ZWEI 6.7,
;;;  DEBUG-TOOLS 6.3, NETWORK-SUPPORT 6.0, NETWORK-SERVICE 6.2, DATALINK-DISPLAYS 6.0,
;;;  FONT-EDITOR 6.1, SERIAL 6.0, PRINTER 6.3, MAC-PRINTER-TYPES 6.1, PRINTER-TYPES 6.2,
;;;  IMAGEN 6.1, SUGGESTIONS 6.0, MAIL-DAEMON 6.3, MAIL-READER 6.5, TELNET 6.0, VT100 6.0,
;;;  NAMESPACE-EDITOR 6.3, PROFILE 6.2, VISIDOC 6.5, TI-CLOS 6.25, CLEH 6.5, IP 3.54,
;;;  Experimental CLX 6.5, CLUE 6.25, X11M 6.15, Experimental BUG 11.15, DECNET 1.70,
;;;   microcode 429, Band Name: rel6.0 10/13 DNA

#!C
; From file BOOT.LISP#> NAMESPACE; SYS:
#10R NAME#:
(COMPILER-LET ((*PACKAGE* (FIND-PACKAGE "NAME"))
                          (SI:*LISP-MODE* :COMMON-LISP)
                          (*READTABLE* SYS:COMMON-LISP-READTABLE)
                          (SI:*READER-SYMBOL-SUBSTITUTIONS* SYS::*COMMON-LISP-SYMBOL-SUBSTITUTIONS*))
  (COMPILER#:PATCH-SOURCE-FILE "SYS: NAMESPACE; BOOT.#"


(DEFUN CREATE-PUBLIC-NAMESPACE (DOMAIN SERVER-NAME SERVER ME)
  (LET* ((NET-NS (FIND-KNOWN-NAMESPACE DOMAIN))
	 BOOTED-NS
         (QUALIFIED-SERVER-NAME (FULL-NAME SERVER-NAME *DISTRIBUTION-NAME*))
	 DOMAIN-OBJ
         SERVER-LIST
	 (BOOTSTRAP-SERVER-LIST (LIST QUALIFIED-SERVER-NAME)))
    
    ;; I think it is ok (and desirable) to throw this away for the
    ;; case where we are trying again after a partially successful bootstrap operation
    (WHEN NET-NS
      (DELETE-NAMESPACE (SEND NET-NS :DOMAIN-NAME))
      (SETF NET-NS NIL))

    (UNLESS (LISTP SERVER)
      (SETF SERVER (LIST :CHAOS SERVER)))
    (UNLESS (LISTP ME)
      (SETF ME (LIST :CHAOS ME)))
    
    (UNWIND-PROTECT
     (UNLESS NET-NS
      (ADD-OBJECT SERVER-NAME :HOST :NAMESPACE *DISTRIBUTION-NAME*
		  :ATTRIBUTES (LIST '(:ADDRESSES :GROUP) (LIST SERVER)
         		            '(:SERVICES :GROUP) (LIST (GET-FILE-SERVICE (CAR SERVER)))))
      
      ;; Go ahead and get a cache built, so subsequent lookups won't have to be repeated
      (SETF NET-NS
	    (ADD-NAMESPACE DOMAIN :PUBLIC NIL :BOOTSTRAP-SERVERS BOOTSTRAP-SERVER-LIST))

      (SEND NET-NS :REMOTE-CALL)		;this will get the namespace object & servers cached
      
      (INITIALIZE-DISTRIBUTION-NAMESPACE (LIST ME) T NIL)  ; DAB 10-16-89MOved from above UNWIND-PROTECT

      ;; Set up the other servers as bootstrap servers too.  This is because recursive
      ;; namespace calls use only the bootstrap server list and if the orignal answering
      ;; server goes down, they are stuck.  Do this here so if we get an error they can
      ;; start over
      (WHEN (SETF DOMAIN-OBJ (SEND NET-NS :DOMAIN-QUERY))
	(SETF SERVER-LIST (GET-ATTRIBUTE-VALUE DOMAIN-OBJ :SERVERS)))
      (LOOP FOR SERVER IN SERVER-LIST 
         WITH UNQUALIFIED-SERVER-NAME
	 WITH FORMATTED-SERVER-OBJ DO
	 (SETF UNQUALIFIED-SERVER-NAME (SPLIT-NAME SERVER))
         (WHEN (SETF FORMATTED-SERVER-OBJ (NAME:LIST-OBJECT UNQUALIFIED-SERVER-NAME :HOST :NAMESPACE NET-NS))
	   (ADD-OBJECT UNQUALIFIED-SERVER-NAME :HOST :NAMESPACE *DISTRIBUTION-NAME*
		       :ATTRIBUTES (THIRD FORMATTED-SERVER-OBJ))
           (LET ((FULL-NAME (FULL-NAME UNQUALIFIED-SERVER-NAME *DISTRIBUTION-NAME*)))
              (UNLESS (MEMBER FULL-NAME BOOTSTRAP-SERVER-LIST :TEST 'STRING-EQUIV)
   	         (PUSH-END FULL-NAME BOOTSTRAP-SERVER-LIST)))))

      (SEND NET-NS :NEW-BOOTSTRAP-SERVERS BOOTSTRAP-SERVER-LIST)
      (SETF BOOTED-NS NET-NS))

      ;; clean-up clause
      (WHEN (AND NET-NS (NULL BOOTED-NS))
	(DELETE-NAMESPACE (SEND NET-NS :DOMAIN-NAME))))
    
    (UNLESS (ON-SEARCH-LIST DOMAIN)
      (PUSH NET-NS *NAMESPACE-SEARCH-LIST*))

    (SETQ *NET-DOMAIN* DOMAIN)
    NET-NS))
))
