;;; -*- Mode: Common-Lisp; Package: name; Base: 10.; Patch-File: T -*-

;;; Reason: Modified (SIMPLE-NAMESPACE :INIT) to handle case where user really whated to create a new personal namespace but forgot to say yes for :new. [9923]

;;;                           RESTRICTED RIGHTS LEGEND
;;;
;;; Use, duplication, or disclosure by the Government is subject to
;;; restrictions as set forth in subdivision (c)(1)(ii) of the Rights in
;;; Technical Data and Computer Software clause at 52.227-7013.
;;;
;;;   TEXAS INSTRUMENTS INCORPORATED      
;;;   P.O. BOX 2909, M/S 2151             
;;;   AUSTIN, TEXAS 78769                 
;;;
;;; Copyright (C) 1989 Texas Instruments Incorporated.
;;; All rights reserved.

;;; Patch file for BASIC-NAMESPACE version 6.8
;;; Written 05/24/90 14:48:13 by BERGER,
;;; while running on Pasteur from band LOD2
;;; With SYSTEM 6.35, VIRTUAL-MEMORY 6.3, EH 6.8, MAKE-SYSTEM 6.3, MICRONET 6.0, LOCAL-FILE 6.2,
;;;  BASIC-PATHNAME 6.4, NETWORK-SUPPORT-COLD 6.2, BASIC-NAMESPACE 6.7, NETWORK-NAMESPACE 6.1,
;;;  DISK-IO 6.3, DISK-LABEL 6.0, BASIC-FILE 6.11, MAC-PATHNAME 6.0, NETWORK-PATHNAME 6.2,
;;;  COMPILER 6.14, TV 6.25, DATALINK 6.0, CHAOSNET 6.7, GC 6.4, MEMORY-AUX 6.0, NVRAM 6.3,
;;;  SYSLOG 6.2, STREAMER-TAPE 6.6, UCL 6.0, INPUT-EDITOR 6.0, METER 6.2, ZWEI 6.17,
;;;  DEBUG-TOOLS 6.4, NETWORK-SUPPORT 6.1, NETWORK-SERVICE 6.2, DATALINK-DISPLAYS 6.0,
;;;  FONT-EDITOR 6.1, SERIAL 6.0, PRINTER 6.6, MAC-PRINTER-TYPES 6.2, PRINTER-TYPES 6.2,
;;;  IMAGEN 6.1, SUGGESTIONS 6.1, MAIL-DAEMON 6.6, MAIL-READER 6.8, TELNET 6.1, VT100 6.0,
;;;  NAMESPACE-EDITOR 6.5, PROFILE 6.3, VISIDOC 6.7, TI-CLOS 6.47, CLEH 6.5, IP 3.62,
;;;  Experimental CLX 6.11, CLUE 6.104, X11M 6.24, Experimental BUG 11.19,  microcode 648,
;;;  Band Name: rel6.0 1/23

#!C
; From file SIMPLE.LISP#> NAMESPACE; Hotel:
#10R NAME#:
(COMPILER-LET ((*PACKAGE* (FIND-PACKAGE "NAME"))
                          (SI:*LISP-MODE* :COMMON-LISP)
                          (*READTABLE* SYS:COMMON-LISP-READTABLE)
                          (SI:*READER-SYMBOL-SUBSTITUTIONS* SYS::*COMMON-LISP-SYMBOL-SUBSTITUTIONS*))
  (COMPILER#:PATCH-SOURCE-FILE "SYS: NAMESPACE; SIMPLE.#"


(DEFMETHOD (SIMPLE-NAMESPACE :INIT)
	   (PLIST)
  
  "Set up the namespace instance"
  (UNLESS (STRINGP DOMAIN-NAME)
     (FERROR NIL "Illegal namespace name ~A - string required" DOMAIN-NAME))

  (LET* ((PATHNAME (OR (GET PLIST :NAMESPACE-FILE-PATHNAME)
		      (DEFAULT-PERSONAL-PATHNAME DOMAIN-NAME)))
        (CHANGE-WINDOW (OR (GET PLIST :CHANGES-BEFORE-SAVE)
                           *DEFAULT-SIMPLE-CHANGE-WINDOW*))
        (AUTO-SAVE (GET-WITH-DEFAULT PLIST :AUTO-SAVE-ENABLED T))
        (NEW-OBJECT (OR (GET PLIST :SETUP-FROM-OBJECT)
			(BUILD-OBJECT DOMAIN-NAME :NAMESPACE
				           (LIST :TYPE *SIMPLE-TYPE*
						 :USAGE (GET PLIST :USAGE)
						 :NAMESPACE-FILE-PATHNAME PATHNAME
                                                 :CHANGES-BEFORE-SAVE CHANGE-WINDOW
						 :AUTO-SAVE-ENABLED AUTO-SAVE
						 :READ-ONLY (GET PLIST :READ-ONLY)))))

	(UPDATE-DOMAIN-OBJECT T)
	(USER-ID "NAMESPACE")
	)
    (tagbody
     retry
    (IF (GET PLIST :NEW)
	(THEN 
	  (FS:CREATE-DIRECTORY PATHNAME :RECURSIVE T)
	  (WHEN (PROBE-FILE PATHNAME)
	     (NOTIFY "WARNING:  Personal namespace ~A is being initialized without using existing database files"
			DOMAIN-NAME))
          (SEND SELF :MAKE-NAMESPACE-HASH-TABLE)
	  (SETF IMAGE (MAKE-SIMPLE :NAMESPACE NAMESPACE)))
	(ELSE
	  (SEND SELF :LOAD PATHNAME)
	  (condition-case (condition) ; DAB 02-08-90 [9923] User may be entering a new namespace but forgot to say YES to NEW
			  (SETF UPDATE-DOMAIN-OBJECT (INTERNAL-CHANGE DOMAIN-NAME NEW-OBJECT))
	    (sys:wrong-type-argument
	     (if (y-or-n-p "The Personal or Simple namespace ~a does not exist. Do you what to create it?" self)
		 (progn 
		   (setf (get plist :new) T)
		   (go retry))
		 (FERROR NIL "The Personal or Simple namespace ~a does not exist." self) 
		 )))
	    )))

    (WHEN UPDATE-DOMAIN-OBJECT
      (SEND SELF :INTERNAL-ADD-OBJECT NEW-OBJECT))))
))
