;;; -*- Mode: Common-Lisp; Package: NET; Base: 10.; Patch-File: T -*-

;;; Reason:  Medium :connect was calling clear-host-connection-failures with a bad argument.

;;;                           RESTRICTED RIGHTS LEGEND
;;;
;;; Use, duplication, or disclosure by the Government is subject to
;;; restrictions as set forth in subdivision (c)(1)(ii) of the Rights in
;;; Technical Data and Computer Software clause at 52.227-7013.
;;;
;;;   TEXAS INSTRUMENTS INCORPORATED      
;;;   P.O. BOX 2909, M/S 2151             
;;;   AUSTIN, TEXAS 78769                 
;;;
;;; Copyright (C) 1989 Texas Instruments Incorporated.
;;; All rights reserved.

;;; Patch file for NETWORK-SUPPORT-COLD version 6.1
;;; Written 10/04/89 08:38:19 by BERGER,
;;; while running on ARIES from band LODX
;;; With SYSTEM 6.17, VIRTUAL-MEMORY 6.2, EH 6.5, MAKE-SYSTEM 6.1, MICRONET 6.0, LOCAL-FILE 6.1,
;;;  BASIC-PATHNAME 6.1, NETWORK-SUPPORT-COLD 6.0, BASIC-NAMESPACE 6.2, NETWORK-NAMESPACE 6.0,
;;;  DISK-IO 6.1, DISK-LABEL 6.0, BASIC-FILE 6.3, MAC-PATHNAME 6.0, NETWORK-PATHNAME 6.0,
;;;  COMPILER 6.12, TV 6.15, DATALINK 6.0, CHAOSNET 6.1, GC 6.3, MEMORY-AUX 6.0, NVRAM 6.1,
;;;  SYSLOG 6.1, STREAMER-TAPE 6.4, UCL 6.0, INPUT-EDITOR 6.0, METER 6.1, ZWEI 6.5,
;;;  DEBUG-TOOLS 6.3, NETWORK-SUPPORT 6.0, NETWORK-SERVICE 6.1, DATALINK-DISPLAYS 6.0,
;;;  FONT-EDITOR 6.1, SERIAL 6.0, PRINTER 6.3, MAC-PRINTER-TYPES 6.1, PRINTER-TYPES 6.1,
;;;  IMAGEN 6.0, SUGGESTIONS 6.0, MAIL-DAEMON 6.2, MAIL-READER 6.2, TELNET 6.0, VT100 6.0,
;;;  NAMESPACE-EDITOR 6.0, PROFILE 6.1, VISIDOC 6.4, TI-CLOS 6.24, CLEH 6.5, IP 3.50,
;;;  Experimental CLX 6.3, CLUE 6.17, X11M 6.14, Experimental BUG 11.15, VISIDOC-SERVER 6.1,
;;;   microcode 429, Band Name: Rel 6.0 + SLE 8/30

#!C
; From file MEDIUM.LISP#> NETWORK-SUPPORT; SYS:
#10R NET#:
(COMPILER-LET ((*PACKAGE* (FIND-PACKAGE "NET"))
                          (SI:*LISP-MODE* :COMMON-LISP)
                          (*READTABLE* COMMON-LISP-READTABLE)
                          (SI:*READER-SYMBOL-SUBSTITUTIONS* SYS::*COMMON-LISP-SYMBOL-SUBSTITUTIONS*))
  (COMPILER#:PATCH-SOURCE-FILE "SYS: NETWORK-SUPPORT; MEDIUM.#"


(defmethod (MEDIUM :CONNECT) (host logical-contact-name &rest args &key
			        (error t)
				&allow-other-keys
				&aux (error-loop-counter 0)  ; DAB 05-02-89
				)
  "Return a connection from si:local-host to host on this medium."
  (declare (arglist host logical-contact-name &rest args &key
			        (error t)
				stream-type
				window-size
				timeout
				timeout-after-open
				&allow-other-keys
				))
  
  (block connect
    (error-restart
      (sys:network-error "Retry connection on medium ~a" self)
      
      (setf  error-loop-counter (1+ error-loop-counter))  ; DAB 05-02-89
      
      (do ((implementation (send self :sorted-implementation-list) (rest implementation))
	   (condition))
	  ((null implementation) condition)
	
	(setf condition
	      ;; Catch condition to return.
	      (condition-case-if
		(not error)
		(condition)

		  ;; Restart to retry the implementation just tried.
		  (si:error-restart-if
		   (< (length implementation-list) 1)
		   (sys:network-error "Retry connection on medium ~a implementation ~a"
				      self (first implementation))
		    
		    (when (send (first implementation)
				:connection-possible-p host si:local-host logical-contact-name)
		      (when *medium-notify* (format t "~&Trying ~s" self))

		      ;; Restart to retry the next implementation.
		      (catch-error-restart-if
			(< 1 (length implementation))
			(sys:network-error "Try connection on medium ~a implementation ~a"
					   self (second implementation))
			
			(when (> error-loop-counter 1) ;this must mean we got thrown here from the debugger,
			  ;; proceed try again option.  ; DAB 05-02-89
			  (clear-host-connection-failures host))  ; DAB 10-04-89

			(condition-case-if (and *try-all-medium-implementations*
						(< 1 (length implementation)))
					   (condition)
			    
			    (let ((connection (lexpr-send (first implementation) :connect
							  host logical-contact-name args)))
			      (when connection
				(return-from connect connection)))
			  
			  (sys:network-error condition)))))
		
		(sys:network-error condition)))))))
))
