;;; -*- Mode: Common-Lisp; Package: FS; Base: 10.; Patch-File: T -*-

;;; Reason: Modified file-get-password-etc-1 to support a new host attribute called :host-preferred-case-userid,which will determine if the host preferrs lowercase userids.

;;;                           RESTRICTED RIGHTS LEGEND
;;;
;;; Use, duplication, or disclosure by the Government is subject to
;;; restrictions as set forth in subdivision (c)(1)(ii) of the Rights in
;;; Technical Data and Computer Software clause at 52.227-7013.
;;;
;;;   TEXAS INSTRUMENTS INCORPORATED      
;;;   P.O. BOX 2909, M/S 2151             
;;;   AUSTIN, TEXAS 78769                 
;;;
;;; Copyright (C) 1989 Texas Instruments Incorporated.
;;; All rights reserved.

;;; Written 10/06/89 13:38:49 by BERGER,
;;; while running on ARIES from band LODA
;;; With SYSTEM 6.20, VIRTUAL-MEMORY 6.2, EH 6.5, MAKE-SYSTEM 6.2, MICRONET 6.0, LOCAL-FILE 6.1,
;;;  BASIC-PATHNAME 6.2, NETWORK-SUPPORT-COLD 6.1, BASIC-NAMESPACE 6.4, NETWORK-NAMESPACE 6.0,
;;;  DISK-IO 6.1, DISK-LABEL 6.0, BASIC-FILE 6.4, MAC-PATHNAME 6.0, NETWORK-PATHNAME 6.0,
;;;  COMPILER 6.12, TV 6.15, DATALINK 6.0, CHAOSNET 6.1, GC 6.3, MEMORY-AUX 6.0, NVRAM 6.2,
;;;  SYSLOG 6.2, STREAMER-TAPE 6.4, UCL 6.0, INPUT-EDITOR 6.0, METER 6.1, ZWEI 6.5,
;;;  DEBUG-TOOLS 6.3, NETWORK-SUPPORT 6.0, NETWORK-SERVICE 6.1, DATALINK-DISPLAYS 6.0,
;;;  FONT-EDITOR 6.1, SERIAL 6.0, PRINTER 6.3, MAC-PRINTER-TYPES 6.1, PRINTER-TYPES 6.2,
;;;  IMAGEN 6.1, SUGGESTIONS 6.0, MAIL-DAEMON 6.3, MAIL-READER 6.5, TELNET 6.0, VT100 6.0,
;;;  NAMESPACE-EDITOR 6.2, PROFILE 6.2, VISIDOC 6.5, TI-CLOS 6.25, CLEH 6.5, IP 3.50,
;;;  Experimental CLX 6.4, CLUE 6.19, X11M 6.14, Experimental BUG 11.15, VISIDOC-SERVER 6.1,
;;;   microcode 429, Band Name: Rel 6.0 10/5

#!C
; From file LOGIN.LISP#> NETWORK-SUPPORT; SYS:
#10R FILE-SYSTEM#:
(COMPILER-LET ((*PACKAGE* (FIND-PACKAGE "FILE-SYSTEM"))
                          (SI:*LISP-MODE* :COMMON-LISP)
                          (*READTABLE* COMMON-LISP-READTABLE)
                          (SI:*READER-SYMBOL-SUBSTITUTIONS* SYS::*COMMON-LISP-SYMBOL-SUBSTITUTIONS*))
  (COMPILER#:PATCH-SOURCE-FILE "SYS: NETWORK-SUPPORT; LOGIN.#"


(defun file-get-password-etc-1 (host &optional uid directory-flag always-prompt &rest fields)

  (unless (typep host 'si:basic-host)
    (setq host (si:parse-host host)))
  (unless directory-flag
    (let ((preferred-case (net:get-host-attribute host ':host-preferred-case-userid))) ; DAB 10-06-89
      (setq uid (or (cdr (assoc host user-unames :test 'eq))
		    uid
		    (if (eql preferred-case :lower) ; DAB 10-06-89 Down case for host that preferred lowercase
			(string-downcase user-id)  user-id)))))

  (let* ((info (lookup-password-etc uid host))
	 (pw (first info))
	 (use-pw (and pw (not always-prompt)))
         (new-value-alist (cdr info))
	 new-info
	 enable-capabilities-flag
         fields-needed)
    
    ;; Determine which of the fields requested are not already known
    (if (and new-value-alist (not always-prompt))
      (dolist (field fields)
         (let ((field-name (if (consp field) (car field) field)))
            (unless (assoc field-name new-value-alist :test 'equal)
	       (push-end field fields-needed))))
      ;; else
      (setq fields-needed fields))

    (if (and use-pw (null fields-needed))
	;; we have all the information requested
	(apply 'values uid pw (extract-needed-fields fields new-value-alist))
	;; else we need to ask the user for some things
	(multiple-value-setq (new-info enable-capabilities-flag)
	      (input-user-information uid host directory-flag use-pw fields-needed))

        ;; Update the alist of the names and values of the new fields
        (loop for new-field-value in (cddr new-info)
	      for field in fields-needed do
          (let* ((field-name (if (consp field) (car field) field))
		 (old-pair  (assoc field-name new-value-alist :test 'equal)))
             (if old-pair
		 (setf (second old-pair) new-field-value)
     	         (push (list field-name new-field-value) new-value-alist))))
	  
        ;; Save the new information
	(unless use-pw
	  (setq pw (second new-info))
          (unless directory-flag (file-host-user-id (car new-info) host)))
	
        (when record-passwords-flag
           (apply 'store-password-etc (car new-info) host pw new-value-alist))

        ;; Return the requested values
        (let ((return-fields (extract-needed-fields fields new-value-alist)))
  	  (apply 'values (car new-info) pw (push-end enable-capabilities-flag return-fields))))))
))
