;;; -*- Mode: Common-Lisp; Package: FS; Base: 10.; Patch-File: T -*-

;;; Reason: Fixed LMFS-DIRECTORY to handle directory :root.[10927]

;;;                           RESTRICTED RIGHTS LEGEND
;;;
;;; Use, duplication, or disclosure by the Government is subject to
;;; restrictions as set forth in subdivision (c)(1)(ii) of the Rights in
;;; Technical Data and Computer Software clause at 52.227-7013.
;;;
;;;   TEXAS INSTRUMENTS INCORPORATED      
;;;   P.O. BOX 2909, M/S 2151             
;;;   AUSTIN, TEXAS 78769                 
;;;
;;; Copyright (C) 1989 Texas Instruments Incorporated.
;;; All rights reserved.

;;; Patch file for NETWORK-PATHNAME version 6.1
;;; Written 02/14/90 13:17:28 by berger,
;;; while running on Pasteur from band LOD2
;;; With SYSTEM 6.29, VIRTUAL-MEMORY 6.3, EH 6.6, MAKE-SYSTEM 6.2, MICRONET 6.0, LOCAL-FILE 6.1,
;;;  BASIC-PATHNAME 6.3, NETWORK-SUPPORT-COLD 6.2, BASIC-NAMESPACE 6.7, NETWORK-NAMESPACE 6.1,
;;;  DISK-IO 6.2, DISK-LABEL 6.0, BASIC-FILE 6.7, MAC-PATHNAME 6.0, NETWORK-PATHNAME 6.0,
;;;  COMPILER 6.14, TV 6.23, DATALINK 6.0, CHAOSNET 6.5, GC 6.3, MEMORY-AUX 6.0, NVRAM 6.2,
;;;  SYSLOG 6.2, STREAMER-TAPE 6.5, UCL 6.0, INPUT-EDITOR 6.0, METER 6.1, ZWEI 6.12,
;;;  DEBUG-TOOLS 6.4, NETWORK-SUPPORT 6.1, NETWORK-SERVICE 6.2, DATALINK-DISPLAYS 6.0,
;;;  FONT-EDITOR 6.1, SERIAL 6.0, PRINTER 6.3, MAC-PRINTER-TYPES 6.1, PRINTER-TYPES 6.2,
;;;  IMAGEN 6.1, SUGGESTIONS 6.1, MAIL-DAEMON 6.5, MAIL-READER 6.7, TELNET 6.1, VT100 6.0,
;;;  NAMESPACE-EDITOR 6.4, PROFILE 6.2, VISIDOC 6.7, TI-CLOS 6.37, CLEH 6.5, IP 3.57,
;;;  Experimental CLX 6.8, CLUE 6.50, X11M 6.20, Experimental BUG 11.18, RPC 6.2,
;;;  NFS 3.10,  microcode 648, Band Name: rel6.0 1/23

#!C
; From file LMFS.LISP#> PATHNAME; SYS:
#10R FILE-SYSTEM#:
(COMPILER-LET ((*PACKAGE* (FIND-PACKAGE "FILE-SYSTEM"))
                          (SI:*LISP-MODE* :COMMON-LISP)
                          (*READTABLE* COMMON-LISP-READTABLE)
                          (SI:*READER-SYMBOL-SUBSTITUTIONS* SYS::*COMMON-LISP-SYMBOL-SUBSTITUTIONS*))
  (COMPILER#:PATCH-SOURCE-FILE "SYS: PATHNAME; LMFS.#"


(DEFUN LMFS-DIRECTORY (DIRECTORY)
  (LET ((ABSOLUTE-PATHNAME T))
    (unless (consp directory) (setf directory (list directory))) ; DAB 02-14-90 Handle :root
    (WITH-OUTPUT-TO-STRING (S)
      (DOLIST (ONE-COMPONENT DIRECTORY)
	(CASE ONE-COMPONENT
	  ((:RELATIVE :ROOT) (SETQ ABSOLUTE-PATHNAME ()))
	  (:UP (SEND S :TYO #\<))
	  (:WILD (WHEN ABSOLUTE-PATHNAME
		   (SEND S :TYO #\>))
	   (SEND S :TYO #\*) (SETQ ABSOLUTE-PATHNAME T))
	  (:WILD-INFERIORS (WHEN ABSOLUTE-PATHNAME
			     (SEND S :TYO #\>))
	   (SEND S :STRING-OUT "**") (SETQ ABSOLUTE-PATHNAME T))
	  (OTHERWISE (WHEN ABSOLUTE-PATHNAME
		       (SEND S :TYO #\>))
	   (SEND S :STRING-OUT ONE-COMPONENT) (SETQ ABSOLUTE-PATHNAME T))));FAKE THINGS OUT.
      (WHEN DIRECTORY
	(SEND S :TYO #\>)))))
))
