;;; -*- Mode: Common-Lisp; Package: NEt; Base: 10.; Patch-File: T -*-

;;; Reason: Fixed user-activity-string. Condition-case for :wrong-type-arg needed the SYS package prefix. 

;;;                           RESTRICTED RIGHTS LEGEND
;;;
;;; Use, duplication, or disclosure by the Government is subject to
;;; restrictions as set forth in subdivision (c)(1)(ii) of the Rights in
;;; Technical Data and Computer Software clause at 52.227-7013.
;;;
;;;   TEXAS INSTRUMENTS INCORPORATED      
;;;   P.O. BOX 2909, M/S 2151             
;;;   AUSTIN, TEXAS 78769                 
;;;
;;; Copyright (C) 1989 Texas Instruments Incorporated.
;;; All rights reserved.

;;; Written 10/13/89 14:05:27 by BERGER,
;;; while running on ARIES from band LODA
;;; With SYSTEM 6.20, VIRTUAL-MEMORY 6.2, EH 6.5, MAKE-SYSTEM 6.2, MICRONET 6.0, LOCAL-FILE 6.1,
;;;  BASIC-PATHNAME 6.2, NETWORK-SUPPORT-COLD 6.2, BASIC-NAMESPACE 6.4, NETWORK-NAMESPACE 6.0,
;;;  DISK-IO 6.1, DISK-LABEL 6.0, BASIC-FILE 6.4, MAC-PATHNAME 6.0, NETWORK-PATHNAME 6.0,
;;;  COMPILER 6.12, TV 6.15, DATALINK 6.0, CHAOSNET 6.1, GC 6.3, MEMORY-AUX 6.0, NVRAM 6.2,
;;;  SYSLOG 6.2, STREAMER-TAPE 6.4, UCL 6.0, INPUT-EDITOR 6.0, METER 6.1, ZWEI 6.7,
;;;  DEBUG-TOOLS 6.3, NETWORK-SUPPORT 6.0, NETWORK-SERVICE 6.1, DATALINK-DISPLAYS 6.0,
;;;  FONT-EDITOR 6.1, SERIAL 6.0, PRINTER 6.3, MAC-PRINTER-TYPES 6.1, PRINTER-TYPES 6.2,
;;;  IMAGEN 6.1, SUGGESTIONS 6.0, MAIL-DAEMON 6.3, MAIL-READER 6.5, TELNET 6.0, VT100 6.0,
;;;  NAMESPACE-EDITOR 6.3, PROFILE 6.2, VISIDOC 6.5, TI-CLOS 6.25, CLEH 6.5, IP 3.54,
;;;  Experimental CLX 6.5, CLUE 6.25, X11M 6.15, Experimental BUG 11.15, DECNET 1.70,
;;;   microcode 429, Band Name: rel6.0 10/13 DNA

#!C
; From file FINGER.LISP#> NETWORK-SERVICE; SYS:
#10R NET#:
(COMPILER-LET ((*PACKAGE* (FIND-PACKAGE "NET"))
                          (SI:*LISP-MODE* :COMMON-LISP)
                          (*READTABLE* COMMON-LISP-READTABLE)
                          (SI:*READER-SYMBOL-SUBSTITUTIONS* SYS::*COMMON-LISP-SYMBOL-SUBSTITUTIONS*))
  (COMPILER#:PATCH-SOURCE-FILE "SYS: NETWORK-SERVICE; FINGER.#"


(defun user-activity-string ()
  (let ((w
	  (do ((w tv:selected-window (send w :superior))
	       (w1 nil w))
	      ((or (null w) (typep w 'tv:standard-screen))
	       w1))))
    (condition-case ()
	(if (and w (send w :operation-handled-p :user-activity-string))  ;02-01-88 DAB
	    (send w :user-activity-string)
	    (cond 
	      ((condition-case ()
		   (typep w (read-from-string "ZWEI:ZMACS-FRAME"))
		 (sys:package-not-found nil))
	       "Zmacs")
	      ((condition-case ()
		   (typep w (read-from-string "TV:PEEK-FRAME"))
		 (sys:package-not-found nil))
	       "Peek")
	      ((condition-case ()
		   (typep w (read-from-string "ZWEI:CONVERSE-FRAME"))
		 (sys:package-not-found nil))
	       "Converse")
	      ((condition-case ()
		   (typep w (read-from-string "TV:INSPECT-FRAME"))
		 (sys:package-not-found nil))
	       "Inspect")
	      ((condition-case ()
		   (typep w (read-from-string "W:LISP-LISTENER"))
		 (sys:package-not-found nil))
	       "Lisp")
	      ((condition-case ()
		   (typep w (read-from-string "USER:TELNET"))  ;12-08-87 DAB
		 (sys:package-not-found nil))
	       "Telnet")
	      ((condition-case ()
		   (typep w (read-from-string "TELNET::VT100-FRAME"))
		 (sys:package-not-found nil))
	       "VT100")
	      ((condition-case ()
		   (typep w (read-from-string "FED:FED-FRAME"))
		 (sys:package-not-found nil))
	       "Font Edit")
	      (t "??User Activity??")))
      (sys:wrong-type-arg "??User Activity??"))))
))
