;;; -*- Mode: Common-Lisp; Package: User; Base: 10.; Patch-File: T -*-

;;; Reason: Modified peek-host-menu-internal to handle case were typeout-window is expose but not cleared and user mouses on another item. [10692] 

;;;                           RESTRICTED RIGHTS LEGEND
;;;
;;; Use, duplication, or disclosure by the Government is subject to
;;; restrictions as set forth in subdivision (c)(1)(ii) of the Rights in
;;; Technical Data and Computer Software clause at 52.227-7013.
;;;
;;;   TEXAS INSTRUMENTS INCORPORATED      
;;;   P.O. BOX 2909, M/S 2151             
;;;   AUSTIN, TEXAS 78769                 
;;;
;;; Copyright (C) 1989 Texas Instruments Incorporated.
;;; All rights reserved.

;;; Patch file for NETWORK-SUPPORT version 6.1
;;; Written 12/01/89 09:29:44 by BERGER,
;;; while running on ARIES from band LODX
;;; With SYSTEM 6.26, VIRTUAL-MEMORY 6.3, EH 6.5, MAKE-SYSTEM 6.2, MICRONET 6.0, LOCAL-FILE 6.1,
;;;  BASIC-PATHNAME 6.2, NETWORK-SUPPORT-COLD 6.2, BASIC-NAMESPACE 6.7, NETWORK-NAMESPACE 6.0,
;;;  DISK-IO 6.1, DISK-LABEL 6.0, BASIC-FILE 6.6, MAC-PATHNAME 6.0, NETWORK-PATHNAME 6.0,
;;;  COMPILER 6.14, TV 6.19, DATALINK 6.0, CHAOSNET 6.5, GC 6.3, MEMORY-AUX 6.0, NVRAM 6.2,
;;;  SYSLOG 6.2, STREAMER-TAPE 6.5, UCL 6.0, INPUT-EDITOR 6.0, METER 6.1, ZWEI 6.8,
;;;  DEBUG-TOOLS 6.3, NETWORK-SUPPORT 6.0, NETWORK-SERVICE 6.2, DATALINK-DISPLAYS 6.0,
;;;  FONT-EDITOR 6.1, SERIAL 6.0, PRINTER 6.3, MAC-PRINTER-TYPES 6.1, PRINTER-TYPES 6.2,
;;;  IMAGEN 6.1, SUGGESTIONS 6.1, MAIL-DAEMON 6.4, MAIL-READER 6.6, TELNET 6.0, VT100 6.0,
;;;  NAMESPACE-EDITOR 6.4, PROFILE 6.2, VISIDOC 6.5, TI-CLOS 6.26, CLEH 6.5, IP 3.56,
;;;  Experimental CLX 6.7, CLUE 6.35, X11M 6.17, Experimental BUG 11.17, RPC 6.2,
;;;  NFS 3.9,  microcode 429, Band Name: REL 6.0 + SLE 11/28

#!C
; From file PEEKN.LISP#> NETWORK-SUPPORT; Hotel:
#10R NET#:
(COMPILER-LET ((*PACKAGE* (FIND-PACKAGE "NET"))
                          (SI:*LISP-MODE* :COMMON-LISP)
                          (*READTABLE* COMMON-LISP-READTABLE)
                          (SI:*READER-SYMBOL-SUBSTITUTIONS* SYS::*COMMON-LISP-SYMBOL-SUBSTITUTIONS*))
  (COMPILER#:PATCH-SOURCE-FILE "SYS: NETWORK-SUPPORT; PEEKN.#"


(defun peek-host-menu-internal (host item &optional (offset 0) &rest additional-stuff)
  "Menu for interesting operations on hosts in a PEEK display.
HOST may be a host object.
ITEM is the item containing the sensitive area clicked on to get this menu.
OFFSET and ADDITIONAL-STUFF are hairy, for the INSERT-HOST-STATUS choice."
  (when (numberp host)
					   ;RLA - no longer know what kind of address
    (ferror nil "Host addresses are no longer supported here"))
  (let ((menu-list
	  '(("Reset"
	     :value reset :documentation "Reset all connections for this host"
	     )
	    ("Host Status One" :value hostat-one :documentation
	     "Show Host Status for selected host in typeout window.")
	    ("Insert Host Status" :value hostat-insert :documentation
	     "Insert static Host Status for selected host in the display.")
	    ("Remove Host Status" :value hostat-remove :documentation "Remove static Host Status.")
	    ("Describe" :value hostat-describe :documentation "Describe selected host.")
	    ("Inspect" :value hostat-inspect :documentation "Inspect selected host."))))
      
    (let ((choice
	    (W::menu-choose
	      menu-list
	      :label
	      (string-append "HOST "
			     (if (numberp host)
				 (format () "~D" host)
				 (funcall host :name)))))
	  (*terminal-io* (if (typep tv:selected-window 'tv:typeout-window) ; DAB 12-01-89
			     ;;In this case the typeout-window is exposed from a previous request,
			     ;;by not cleared.  DAB 12-01-89 [10692]
			     tv:selected-window
			     (send tv:selected-window :typeout-window))))
      (case choice
	(reset (send host :reset))
	(hostat-one (send tv:selected-window :force-kbd-input `(HOST:host-status ,host)))
	(hostat-all (send tv:selected-window :force-kbd-input `(HOST:host-status)))
	((hostat-insert hostat-remove)
	 (setf (array-leader item (+ tv:scroll-item-leader-offset offset))
	       (eq choice 'hostat-insert))
	 (setf (array-leader item (+ tv:scroll-item-leader-offset offset 1)) host)
	 (dotimes (i (length additional-stuff))
	   (setf (array-leader item (+ tv:scroll-item-leader-offset offset i 2))
		 (nth i additional-stuff)))
	 (setf (send tv:selected-window :needs-redisplay) t))
	(hostat-describe (send tv:selected-window :force-kbd-input `(describe ,host)))
	(hostat-inspect (send tv:selected-window :force-kbd-input `(inspect ,host)))
	(nil)
	(otherwise (beep))))))
))
