;;; -*- Mode: Common-Lisp; Package: NSE; Base: 10.; Patch-File: T -*-

;;; Reason: Added timeout to KIll-nse-buffers. [9878]

;;;                           RESTRICTED RIGHTS LEGEND
;;;
;;; Use, duplication, or disclosure by the Government is subject to
;;; restrictions as set forth in subdivision (c)(1)(ii) of the Rights in
;;; Technical Data and Computer Software clause at 52.227-7013.
;;;
;;;   TEXAS INSTRUMENTS INCORPORATED      
;;;   P.O. BOX 2909, M/S 2151             
;;;   AUSTIN, TEXAS 78769                 
;;;
;;; Copyright (C) 1989 Texas Instruments Incorporated.
;;; All rights reserved.

;;; Patch file for NAMESPACE-EDITOR version 6.1
;;; Written 10/04/89 07:57:39 by BERGER,
;;; while running on ARIES from band LODX
;;; With SYSTEM 6.17, VIRTUAL-MEMORY 6.2, EH 6.5, MAKE-SYSTEM 6.1, MICRONET 6.0, LOCAL-FILE 6.1,
;;;  BASIC-PATHNAME 6.1, NETWORK-SUPPORT-COLD 6.0, BASIC-NAMESPACE 6.2, NETWORK-NAMESPACE 6.0,
;;;  DISK-IO 6.1, DISK-LABEL 6.0, BASIC-FILE 6.3, MAC-PATHNAME 6.0, NETWORK-PATHNAME 6.0,
;;;  COMPILER 6.12, TV 6.15, DATALINK 6.0, CHAOSNET 6.1, GC 6.3, MEMORY-AUX 6.0, NVRAM 6.1,
;;;  SYSLOG 6.1, STREAMER-TAPE 6.4, UCL 6.0, INPUT-EDITOR 6.0, METER 6.1, ZWEI 6.5,
;;;  DEBUG-TOOLS 6.3, NETWORK-SUPPORT 6.0, NETWORK-SERVICE 6.1, DATALINK-DISPLAYS 6.0,
;;;  FONT-EDITOR 6.1, SERIAL 6.0, PRINTER 6.3, MAC-PRINTER-TYPES 6.1, PRINTER-TYPES 6.1,
;;;  IMAGEN 6.0, SUGGESTIONS 6.0, MAIL-DAEMON 6.2, MAIL-READER 6.2, TELNET 6.0, VT100 6.0,
;;;  NAMESPACE-EDITOR 6.0, PROFILE 6.1, VISIDOC 6.4, TI-CLOS 6.24, CLEH 6.5, IP 3.50,
;;;  Experimental CLX 6.3, CLUE 6.17, X11M 6.14, Experimental BUG 11.15, VISIDOC-SERVER 6.1,
;;;   microcode 429, Band Name: Rel 6.0 + SLE 8/30

#!C
; From file UTILITY-FUNCTIONS.LISP#> NAMESPACE-EDITOR; SYS:
#10R NSE#:
(COMPILER-LET ((*PACKAGE* (FIND-PACKAGE "NSE"))
                          (SI:*LISP-MODE* :COMMON-LISP)
                          (*READTABLE* SYS:COMMON-LISP-READTABLE)
                          (SI:*READER-SYMBOL-SUBSTITUTIONS* SYS::*COMMON-LISP-SYMBOL-SUBSTITUTIONS*))
  (COMPILER#:PATCH-SOURCE-FILE "SYS: NAMESPACE-EDITOR; UTILITY-FUNCTIONS.#"


(defun KILL-NSE-BUFFERS (&optional (timeout 3600.)) ; DAB 08-02-89
  "Kill all NSE Buffers in the current buffer history. The user is ask to proceed when NSE buffers exist.
 It will automatically proceed if the user does not response in TIMEOUT (in 60th of a second)."
  (let ((nse-buffers-list))
    (dolist (buffer *zmacs-buffer-list*)
      (when (search "Namespace Edit Buffer for" (buffer-name buffer)
		    :start2 0
		    :end2 25)
	(push buffer nse-buffers-list)))
    (when nse-buffers-list
      (cond
	((not (with-timeout (timeout T)
		(yes-or-no-p
		  "About to Kill Namespace Edit Buffers (automatically proceed in ~d seconds).  Proceed?"
		  (if (numberp timeout) (/ timeout 60.)))))
	 (signal-condition eh:*abort-object*))
	(t (dolist (buffer nse-buffers-list)
	     (send buffer :kill)))))))
))
