;;; -*- Mode: Common-Lisp; Package: NSe; Base: 10.; Patch-File: T -*-

;;; Reason: Added new verify and edit function to support new host attribute :host-preferred-case-userid.

;;;                           RESTRICTED RIGHTS LEGEND
;;;
;;; Use, duplication, or disclosure by the Government is subject to
;;; restrictions as set forth in subdivision (c)(1)(ii) of the Rights in
;;; Technical Data and Computer Software clause at 52.227-7013.
;;;
;;;   TEXAS INSTRUMENTS INCORPORATED      
;;;   P.O. BOX 2909, M/S 2151             
;;;   AUSTIN, TEXAS 78769                 
;;;
;;; Copyright (C) 1989 Texas Instruments Incorporated.
;;; All rights reserved.

;;; Patch file for NAMESPACE-EDITOR version 6.3
;;; Written 10/06/89 14:02:59 by BERGER,
;;; while running on ARIES from band LODA
;;; With SYSTEM 6.20, VIRTUAL-MEMORY 6.2, EH 6.5, MAKE-SYSTEM 6.2, MICRONET 6.0, LOCAL-FILE 6.1,
;;;  BASIC-PATHNAME 6.2, NETWORK-SUPPORT-COLD 6.1, BASIC-NAMESPACE 6.4, NETWORK-NAMESPACE 6.0,
;;;  DISK-IO 6.1, DISK-LABEL 6.0, BASIC-FILE 6.4, MAC-PATHNAME 6.0, NETWORK-PATHNAME 6.0,
;;;  COMPILER 6.12, TV 6.15, DATALINK 6.0, CHAOSNET 6.1, GC 6.3, MEMORY-AUX 6.0, NVRAM 6.2,
;;;  SYSLOG 6.2, STREAMER-TAPE 6.4, UCL 6.0, INPUT-EDITOR 6.0, METER 6.1, ZWEI 6.5,
;;;  DEBUG-TOOLS 6.3, NETWORK-SUPPORT 6.0, NETWORK-SERVICE 6.1, DATALINK-DISPLAYS 6.0,
;;;  FONT-EDITOR 6.1, SERIAL 6.0, PRINTER 6.3, MAC-PRINTER-TYPES 6.1, PRINTER-TYPES 6.2,
;;;  IMAGEN 6.1, SUGGESTIONS 6.0, MAIL-DAEMON 6.3, MAIL-READER 6.5, TELNET 6.0, VT100 6.0,
;;;  NAMESPACE-EDITOR 6.2, PROFILE 6.2, VISIDOC 6.5, TI-CLOS 6.25, CLEH 6.5, IP 3.50,
;;;  Experimental CLX 6.4, CLUE 6.19, X11M 6.14, Experimental BUG 11.15, VISIDOC-SERVER 6.1,
;;;   microcode 429, Band Name: Rel 6.0 10/5

#!C
; From file NETWORK-ATTRIBUTE-MLISTS.LISP#> NAMESPACE-EDITOR; SYS:
#10R NSE#:
(COMPILER-LET ((*PACKAGE* (FIND-PACKAGE "NSE"))
                          (SI:*LISP-MODE* :COMMON-LISP)
                          (*READTABLE* SYS:COMMON-LISP-READTABLE)
                          (SI:*READER-SYMBOL-SUBSTITUTIONS* SYS::*COMMON-LISP-SYMBOL-SUBSTITUTIONS*))
  (COMPILER#:PATCH-SOURCE-FILE "SYS: NAMESPACE-EDITOR; NETWORK-ATTRIBUTE-MLISTS.#"


(defparameter *host-attribute-mlist*
	      (list `(:addresses
		       :value (:addresses :group)
		       :documentation ,(get-doc :addresses :host))
		    `(:aliases
		       :value (:aliases :group)
		       :documentation ,(get-doc :aliases :host))
		    `(:boot-init-file
		       :documentation ,(get-doc :boot-init-file :host))
		    `(,name:*alias-of*
		      :documentation ,(get-doc name:*alias-of* :host))
		    `(:bitmap-printer
		       :documentation ,(get-doc :bitmap-printer :host))
		    `(:default-device
		       :documentation ,(get-doc :default-device :host))
		    `(:default-file-server
		       :documentation ,(get-doc :default-file-server :host))
		    `(:directory-translations
		       :value (:directory-translations :group)
		       :documentation ,(get-doc :directory-translations :host))
		    `(:file-control-lifetime
		       :documentation ,(get-doc :file-control-lifetime :host))
		    `(:file-server-type
		       :documentation ,(get-doc :file-server-type :host))
		    `(:ftp-implementation-type
		       :documentation ,(get-doc :ftp-implementation-type :host))
		    `(:ftp-prompt-for-account
		       :documentation ,(get-doc :ftp-prompt-for-account :host))
		    `(:host-translation
		       :documentation ,(get-doc :host-translation :host))
		    `(:host-preferred-case-userid  ; DAB 10-06-89
		       :documentation ,(get-doc  :host-preferred-case-userid :host))
;		    `(:ip-addr-subnet-bits
;		       :documentation ,(get-doc :ip-addr-subnet-bits :host))
		    `(:ip-access-list
		       :value (:ip-access-list :group)
		       :documentation ,(get-doc :ip-access-list :host))
		    `(:location
		       :documentation ,(get-doc :location :host))
		    `(:medium-desirability
		       :value (:medium-desirability :group)
		       :documentation ,(get-doc :medium-desirability :host))
		    `(:machine-type
		       :documentation ,(get-doc :machine-type :host))
		    `(:mail-gateway-host
		       :documentation ,(get-doc :mail-gateway-host :host))
		    `(:namespace-search-list
		       :documentation ,(get-doc :namespace-search-list :host))
		    `(:pathname-flavor
		       :documentation ,(get-doc :pathname-flavor :host))
		    `(:primary-device
		       :documentation ,(get-doc :primary-device :host))
		    `(:printer
		       :documentation ,(get-doc :printer :host))
		    `(:reject-mail
		       :documentation ,(get-doc :reject-mail :host))
		    `(:service-desirability
		       :value (:service-desirability :group)
		       :documentation ,(get-doc :service-desirability :host))
		    `(:services
		       :value (:services :group)
		       :documentation ,(get-doc :services :host))
		    `(:short-name
		       :documentation ,(get-doc :short-name :host))
		    `(:site
		       :documentation ,(get-doc :site :host))
		    `(:site-device
		       :documentation ,(get-doc :site-device :host))
		    `(:site-directory
		       :documentation ,(get-doc :site-directory :host))
		    `(:string-for-printing
		       :documentation ,(get-doc :string-for-printing :host))
		    `(:sys-host
		       :documentation ,(get-doc :sys-host :host))
		    `(:system-type
		       :documentation ,(get-doc :system-type :host))
		    `(:terminal-f-arguments
		       :value (:terminal-f-arguments :group)
		       :documentation ,(get-doc :terminal-f-arguments :host))
		    `(:timezone
		       :documentation ,(get-doc :timezone :host))
		    `(:translations-file
		       :documentation ,(get-doc :translations-file :host))
		    `(:use-primary-mail-servers
		       :documentation ,(get-doc :use-primary-mail-servers :host)) 
		    `(:other :documentation "Choose a different attribute.")))
))

#!C
; From file NSE-NAMESPACE.LISP#> NAMESPACE-EDITOR; SYS:
#10R NSE#:
(COMPILER-LET ((*PACKAGE* (FIND-PACKAGE "NSE"))
                          (SI:*LISP-MODE* :COMMON-LISP)
                          (*READTABLE* SYS:COMMON-LISP-READTABLE)
                          (SI:*READER-SYMBOL-SUBSTITUTIONS* SYS::*COMMON-LISP-SYMBOL-SUBSTITUTIONS*))
  (COMPILER#:PATCH-SOURCE-FILE "SYS: NAMESPACE-EDITOR; NSE-NAMESPACE.#"


(define-nse-expert-editor '(:HOST :ANY :HOST-preferred-case-userid) :network  ; DAB 10-06-89 New 
  :incremental-verification-routine 'VERIFY-HOST-preferred-case-for-userid-FROM-MLIST 
  :namespace-verification-routine 'VERIFY-HOST-preferred-case-for-userid-FROM-MLIST
  :edit-routine 'HOST-preferred-case-userid-MLIST 
  :documentation-string
  "The host's preferred case for userids. Valid values :UPPER or :LOWER, default is :UPPER."
 )
))

#!C
; From file NETWORK-MODE-EXPERT-EDITORS.LISP#> NAMESPACE-EDITOR; SYS:
#10R NSE#:
(COMPILER-LET ((*PACKAGE* (FIND-PACKAGE "NSE"))
                          (SI:*LISP-MODE* :COMMON-LISP)
                          (*READTABLE* SYS:COMMON-LISP-READTABLE)
                          (SI:*READER-SYMBOL-SUBSTITUTIONS* SYS::*COMMON-LISP-SYMBOL-SUBSTITUTIONS*))
  (COMPILER#:PATCH-SOURCE-FILE "SYS: NAMESPACE-EDITOR; NETWORK-MODE-EXPERT-EDITORS.#"



(defun VERIFY-HOST-preferred-case-for-userid-FROM-MLIST ()  ; DAB 10-06-89
  (or (member *value* '(:UPPER :LOWER))
      (give-mlist-error)))

(defun HOST-preferred-case-userid-MLIST ()    ; DAB 10-06-89
  (menu-choose-with-handler
    '(:UPPER :LOWER)
    (format nil "Choose preferred case for userid for ~s" (object-name *object*))))


))
