;;; -*- Mode: Common-Lisp; Package: NSE; Base: 10.; Patch-File: T -*-

;;; Reason:  Modified SIDE-EFFECT-FOR-MACHINE-TYPE to add side effect to microexplorer to include ftp-implemenation-type.

;;;                           RESTRICTED RIGHTS LEGEND
;;;
;;; Use, duplication, or disclosure by the Government is subject to
;;; restrictions as set forth in subdivision (c)(1)(ii) of the Rights in
;;; Technical Data and Computer Software clause at 52.227-7013.
;;;
;;;   TEXAS INSTRUMENTS INCORPORATED      
;;;   P.O. BOX 2909, M/S 2151             
;;;   AUSTIN, TEXAS 78769                 
;;;
;;; Copyright (C) 1989 Texas Instruments Incorporated.
;;; All rights reserved.

;;; Written 10/24/89 12:58:54 by BERGER,
;;; while running on ARIES from band LODX
;;; With SYSTEM 6.22, VIRTUAL-MEMORY 6.2, EH 6.5, MAKE-SYSTEM 6.2, MICRONET 6.0, LOCAL-FILE 6.1,
;;;  BASIC-PATHNAME 6.2, NETWORK-SUPPORT-COLD 6.2, BASIC-NAMESPACE 6.6, NETWORK-NAMESPACE 6.0,
;;;  DISK-IO 6.1, DISK-LABEL 6.0, BASIC-FILE 6.4, MAC-PATHNAME 6.0, NETWORK-PATHNAME 6.0,
;;;  COMPILER 6.14, TV 6.17, DATALINK 6.0, CHAOSNET 6.1, GC 6.3, MEMORY-AUX 6.0, NVRAM 6.2,
;;;  SYSLOG 6.2, STREAMER-TAPE 6.4, UCL 6.0, INPUT-EDITOR 6.0, METER 6.1, ZWEI 6.7,
;;;  DEBUG-TOOLS 6.3, NETWORK-SUPPORT 6.0, NETWORK-SERVICE 6.2, DATALINK-DISPLAYS 6.0,
;;;  FONT-EDITOR 6.1, SERIAL 6.0, PRINTER 6.3, MAC-PRINTER-TYPES 6.1, PRINTER-TYPES 6.2,
;;;  IMAGEN 6.1, SUGGESTIONS 6.1, MAIL-DAEMON 6.3, MAIL-READER 6.5, TELNET 6.0, VT100 6.0,
;;;  NAMESPACE-EDITOR 6.3, PROFILE 6.2, VISIDOC 6.5, TI-CLOS 6.26, CLEH 6.5, IP 3.54,
;;;  Experimental CLX 6.6, CLUE 6.27, X11M 6.15, Experimental BUG 11.15,  microcode 429,
;;;  Band Name: rel6.0 10/23

#!C
; From file NETWORK-MODE-EXPERT-EDITORS.LISP#> NAMESPACE-EDITOR; SYS:
#10R NSE#:
(COMPILER-LET ((*PACKAGE* (FIND-PACKAGE "NSE"))
                          (SI:*LISP-MODE* :COMMON-LISP)
                          (*READTABLE* SYS:COMMON-LISP-READTABLE)
                          (SI:*READER-SYMBOL-SUBSTITUTIONS* SYS::*COMMON-LISP-SYMBOL-SUBSTITUTIONS*))
  (COMPILER#:PATCH-SOURCE-FILE "SYS: NAMESPACE-EDITOR; NETWORK-MODE-EXPERT-EDITORS.#"


(defun SIDE-EFFECT-FOR-MACHINE-TYPE ()
  "For the machine-type specified for the host, force a reasonable value for the system-type."
  (let ((start-bp (copy-bp (buffer-point *buffer*)))
	(machine-type (copy-list *value*)))
    (selector machine-type equal
      (:EXPLORER (software-constraint '(:EXPLORER :LISPM :LOGICAL) :EXPLORER))
      (:SYMBOLICS-36XX (software-constraint '(:SYMBOLICS :LOGICAL) :SYMBOLICS))
      (:LM-2 (software-constraint '(:LISPM :SYMBOLICS :LOGICAL) :SYMBOLICS))
      ((:LAMBDA :CADR) (software-constraint '(:LISPM :LOGICAL) :LISPM))
      (:VAX (software-constraint '(:VMS :VMS4 :UNIX :UNIX-UCB :LOGICAL) :VMS))
      (:NU-MACHINE (software-constraint '(:UNIX :UNIX-UCB :LOGICAL) :UNIX))
      (:MACINTOSH (software-constraint '(:UNIX-UCB :MAC-OS) :MAC-OS))
      (:MICROEXPLORER (software-constraint '(:UNIX-UCB :MICROEXPLORER) :UNIX-UCB)
		      ;; ADD MAC-PATHNAME KLUDGE
		      (unless (equal (nse:get-attribute-value *object* :pathname-flavor)
				     'fs:mac-pathname)
			(nse:edit-attribute :object (object-name *object*)
					    :class (get-class *object*)
					    :attribute :pathname-flavor
					    :value 'fs:mac-pathname
					    :buffer *buffer*))
		      ;;Add FTP-implementation-type  ; DAB 10-24-89
		      (unless (equal (nse:get-attribute-value *object* :ftp-implementation-type)
				     :microexplorer)
			(nse:edit-attribute :object (object-name *object*)
					    :class (get-class *object*)
					    :attribute  :ftp-implementation-type
					    :value :microexplorer
					    :buffer *buffer*))
		      (dolist (att '(:default-device :primary-device))
			(unless (nse:get-attribute-value *object* att)
			  (nse:add-attribute :object-name (object-name *object*)
					     :class (get-class *object*)
					     :default-attribute att
					     :default-value :fake-nil     ; a mis-guided kludge
					     :give-error nil
					     :buffer *buffer*))))
      (:SUN (software-constraint '(:UNIX-UCB :LOGICAL) :UNIX-UCB))
      (:APOLLO (software-constraint '(:UNIX-UCB :UNIX :LOGICAL) :UNIX-UCB))
      (:DEC20 (software-constraint '(:TOPS20 :LOGICAL) :TOPS20))
      (:DEC10 (software-constraint '(:TENEX :LOGICAL) :TENEX))
      (:MULTICS (software-constraint '(:MULTICS :LOGICAL) :MULTICS))
      (:ITS (software-constraint '(:ITS :LOGICAL) :ITS))
      (:MSDOS (software-constraint '(:MSDOS :LOGICAL) :MSDOS)))
    ;; TAKE AWAY MAC-PATHNAME KLUDGE
    (when (and machine-type
	       (not (eq machine-type :microexplorer))
	       (nse:get-attribute-value *object* :pathname-flavor)
	       (eq (nse:get-attribute-value *object* :pathname-flavor) 'fs:mac-pathname))
      (nse:edit-attribute :class (get-class *object*)
			  :object (object-name *object*)
			  :attribute :pathname-flavor
			  :value nil
			  :add-if-not-there-p nil
			  :buffer *buffer*))
    (move-bp (buffer-point *buffer*) (beg-line start-bp))))
))
