;;; -*- Mode: Common-Lisp; Package: NSE; Base: 10.; Patch-File: T -*-

;;; Reason: Modified DEFAULT-ATTRIBUTE-FORMAT-STRING  to handle newline characters in string.

;;;                           RESTRICTED RIGHTS LEGEND
;;;
;;; Use, duplication, or disclosure by the Government is subject to
;;; restrictions as set forth in subdivision (c)(1)(ii) of the Rights in
;;; Technical Data and Computer Software clause at 52.227-7013.
;;;
;;;   TEXAS INSTRUMENTS INCORPORATED      
;;;   P.O. BOX 2909, M/S 2151             
;;;   AUSTIN, TEXAS 78769                 
;;;
;;; Copyright (C) 1989 Texas Instruments Incorporated.
;;; All rights reserved.

;;; Patch file for NAMESPACE-EDITOR version 6.6
;;; Written 06/08/90 15:51:34 by BERGER,
;;; while running on Pasteur from band LOD3
;;; With SYSTEM 6.35, VIRTUAL-MEMORY 6.3, EH 6.8, MAKE-SYSTEM 6.3, MICRONET 6.0, LOCAL-FILE 6.2,
;;;  BASIC-PATHNAME 6.5, NETWORK-SUPPORT-COLD 6.2, BASIC-NAMESPACE 6.8, NETWORK-NAMESPACE 6.1,
;;;  DISK-IO 6.3, DISK-LABEL 6.0, BASIC-FILE 6.13, MAC-PATHNAME 6.0, NETWORK-PATHNAME 6.2,
;;;  COMPILER 6.14, TV 6.25, DATALINK 6.0, CHAOSNET 6.8, GC 6.4, MEMORY-AUX 6.0, NVRAM 6.3,
;;;  SYSLOG 6.2, STREAMER-TAPE 6.6, UCL 6.0, INPUT-EDITOR 6.0, METER 6.2, ZWEI 6.18,
;;;  DEBUG-TOOLS 6.4, NETWORK-SUPPORT 6.1, NETWORK-SERVICE 6.3, DATALINK-DISPLAYS 6.0,
;;;  FONT-EDITOR 6.1, SERIAL 6.0, PRINTER 6.6, MAC-PRINTER-TYPES 6.2, PRINTER-TYPES 6.2,
;;;  IMAGEN 6.1, SUGGESTIONS 6.1, MAIL-DAEMON 6.6, MAIL-READER 6.8, TELNET 6.1, VT100 6.0,
;;;  NAMESPACE-EDITOR 6.5, PROFILE 6.3, VISIDOC 6.7, TI-CLOS 6.47, CLEH 6.5, IP 3.65,
;;;  Experimental CLX 6.11, CLUE 6.104, X11M 6.24, Experimental BUG 11.19,  microcode 656,
;;;  Band Name: rel 6.0 + SLE 5/30

#!C
; From file HELPER-FUNCTIONS.LISP#> NAMESPACE-EDITOR; Hotel:
#10R NSE#:
(COMPILER-LET ((*PACKAGE* (FIND-PACKAGE "NSE"))
                          (SI:*LISP-MODE* :COMMON-LISP)
                          (*READTABLE* SYS:COMMON-LISP-READTABLE)
                          (SI:*READER-SYMBOL-SUBSTITUTIONS* SYS::*COMMON-LISP-SYMBOL-SUBSTITUTIONS*))
  (COMPILER#:PATCH-SOURCE-FILE "SYS: NAMESPACE-EDITOR; HELPER-FUNCTIONS.#"


(defun DEFAULT-ATTRIBUTE-FORMAT-STRING (line-stream format-arg-list line-node)
  ;; format arg list is '(attribute-name attribute-value).  If there is a group attribute,
  ;; the attribute-name is in the form '(attribute-name :group). . . the whole thing is
  ;; '((attribute-name :group) value).  We only want to print the attribute-name.  Also,
  ;; we want to change the object-node to have the GROUP instance variable set to T.
  (let ((attribute (copy-list (first format-arg-list)))
	(zmacs-suggestions-on-p
	  (and (boundp 'SYSTEM::*suggestions-menus-on?*) SYSTEM::*suggestions-menus-on?*
	       (assoc 'zwei:zmacs-frame sugg::*windows-recognized-by-suggestions*))))
    (when (group-p attribute)
      (setf attribute (car attribute))
      (setf (first format-arg-list) attribute)
      (when line-node
	(send line-node :set-group-attribute-p t)))
    (cond
      (line-node
       (let ((deleted-p (send line-node :deleted-p)))
	 (cond
	   (deleted-p (format line-stream "d"))
	   (t (format line-stream " ")))
	 (cond
	   ((send line-node :group-attribute-p) (format line-stream "G"))
	   (t (format line-stream " ")))
	 (cond
	   ((send line-node :new-attribute-p)
	    (cond
	      ((eq (send line-node :num-pluses) 2) (format line-stream "++"))
	      (t (format line-stream "+ "))))
	   (t
	    (cond
	      ((send line-node :num-stars)
	       (case (send line-node :num-stars)
		 (0 (format line-stream "  "))
		 (1 (format line-stream "* "))
		 (2 (format line-stream "**"))))
	      (t (format line-stream "  ")))))
	 (format line-stream "~15t")))
      (t (format line-stream "~19t")))
    ;; WRITE THE ATTRIBUTE NAME.
    (let* ((object-string (format nil "~s" (first format-arg-list)))
	   (object-length (length object-string))
	   (desired-length (if zmacs-suggestions-on-p
			       30 ;;else
			       35))
	   (best-length
	     (if *truncate-attribute-lines-nicely*
		 (- desired-length 2)
		 ;;ELSE
		 (max (- desired-length 2) object-length)))
	   (truncated-name ""))
      (cond
	((<= object-length best-length) (setf truncated-name object-string)
					(format line-stream "~Va" desired-length truncated-name)
					(when (and (not *truncate-attribute-lines-nicely*) (> object-length (- desired-length 2)))
					  (format line-stream "  ")))
	(t (setf truncated-name (nsubstring object-string 0 (- best-length 3)))
	   (format line-stream "~a" truncated-name) (format line-stream "...  "))))
    ;; WRITE THE ATTRIBUTE-VALUE
    (let* ((object-string (format nil "~s" (second format-arg-list)))
	   (object-length (length object-string))
	   (newline-p (position #\newline object-string :test #'char=))
	   (desired-length (if zmacs-suggestions-on-p
			       54	   ;else
			       72))
	   (best-length
	     (if *truncate-attribute-lines-nicely*
		 (min (- desired-length 2) object-length)
		 ;;ELSE
		 (max (- desired-length 2) object-length)))
	   (truncated-name ""))
     (when  (and newline-p (< newline-p best-length))  ; DAB 06-08-90 Handle Newlines in strings.
       (setf best-length (+ 3 newline-p)))
        

      (cond
	((<= object-length best-length) (setf truncated-name object-string)
					(format line-stream "~Va" desired-length truncated-name))
	(t (setf truncated-name (nsubstring object-string 0 (- best-length 3)))
	   (format line-stream "~a" truncated-name) (format line-stream "...  "))))))
))
