;;; -*- Mode: Common-Lisp; Package: User; Base: 8.; Patch-File: T -*-

;;; Reason: Fixes for MSC overtempature and for Microexplorer crash records. - RJF

;;;                           RESTRICTED RIGHTS LEGEND
;;;
;;; Use, duplication, or disclosure by the Government is subject to
;;; restrictions as set forth in subdivision (c)(1)(ii) of the Rights in
;;; Technical Data and Computer Software clause at 52.227-7013.
;;;
;;;   TEXAS INSTRUMENTS INCORPORATED      
;;;   P.O. BOX 2909, M/S 2151             
;;;   AUSTIN, TEXAS 78769                 
;;;
;;; Copyright (C) 1989 Texas Instruments Incorporated.
;;; All rights reserved.

;;; Written 05/23/90 10:35:15 by FISH,
;;; while running on DaVinci from band LOD2
;;; With SYSTEM 6.31, VIRTUAL-MEMORY 6.3, EH 6.7, MAKE-SYSTEM 6.3, MICRONET 6.0, LOCAL-FILE 6.2,
;;;  BASIC-PATHNAME 6.4, NETWORK-SUPPORT-COLD 6.2, BASIC-NAMESPACE 6.7, NETWORK-NAMESPACE 6.1,
;;;  DISK-IO 6.3, DISK-LABEL 6.0, BASIC-FILE 6.10, MAC-PATHNAME 6.0, NETWORK-PATHNAME 6.2,
;;;  COMPILER 6.14, TV 6.24, DATALINK 6.0, CHAOSNET 6.6, GC 6.3, MEMORY-AUX 6.0, NVRAM 6.2,
;;;  SYSLOG 6.2, STREAMER-TAPE 6.5, UCL 6.0, INPUT-EDITOR 6.0, METER 6.1, ZWEI 6.15,
;;;  DEBUG-TOOLS 6.4, NETWORK-SUPPORT 6.1, NETWORK-SERVICE 6.2, DATALINK-DISPLAYS 6.0,
;;;  FONT-EDITOR 6.1, SERIAL 6.0, PRINTER 6.5, MAC-PRINTER-TYPES 6.2, PRINTER-TYPES 6.2,
;;;  IMAGEN 6.1, SUGGESTIONS 6.1, MAIL-DAEMON 6.6, MAIL-READER 6.8, TELNET 6.1, VT100 6.0,
;;;  NAMESPACE-EDITOR 6.4, PROFILE 6.3, VISIDOC 6.7, TI-CLOS 6.46, CLEH 6.5, IP 3.62,
;;;  Experimental CLX 6.11, CLUE 6.104, X11M 6.24, Experimental BUG 11.19,  microcode 483,
;;;  Band Name: Rel 6.0 + SLE 5/21

#!C
; From file ANALYSIS-FUNCTIONS.LISP#> NVRAM; Hotel:
#8R SYSTEM#:
(COMPILER-LET ((*PACKAGE* (FIND-PACKAGE "SYSTEM"))
                          (SI:*LISP-MODE* :COMMON-LISP)
                          (*READTABLE* COMMON-LISP-READTABLE)
                          (SI:*READER-SYMBOL-SUBSTITUTIONS* *COMMON-LISP-SYMBOL-SUBSTITUTIONS*))
  (COMPILER#:PATCH-SOURCE-FILE "SYS: NVRAM; ANALYSIS-FUNCTIONS.#"


(Defun Ca-Interpret-Nupi-Special-Event (Special-Event-Bitmap Formatter-Number)
  (Format () "~%~@?~a~%~@?~a~%~@?~a~%~@?~a" Crec-Fmt-A ""
	  (If (Ldb-Test %%Nupi-Error-Status-Overtemperature Special-Event-Bitmap)
	    (Format () "Overtemperature on formatter ~d." Formatter-Number)
	    (Select Special-Event-Bitmap
	       (#o1 "Unrecoverable NuBus error encountered while fetching command block")
	       (#o2 "Overtemperature detected") 
	       (#o4 "Illegal access to NUPI control register")
	       (#o10 "Multiple commands issued to one device, formatter, or to NUPI")
	       (#o20 "Illegal command found in command block")
	       (#o40 "Power Loss has been detected by MSC")
	       (#o100 "Command aborted with no command block updates")
	       (#o200 "Illegal interrupt encountered on NuBus access")
	       (#o400 "Invalid Special Event address") 
	       (#o1000 "Hardware Error")
	       (#o2000 "Invalid SCSI operation attempted")
	       (Otherwise (Format () "Unknown special event code = #x~16r" Special-Event-Bitmap))))
	  Crec-Fmt-A "" (Format () "RQB address:       #x~16r" (- Vma #o4))
			;;8-18-86, RJF
	  Crec-Fmt-A "" (Format () "RQB command word:  #x~16r" M-T) Crec-Fmt-A ""
	  (Format () "RQB status word:   #x~16r" Md)))
))

#!C
; From file INITS.LISP#> NVRAM; MR-X:
#8R SYSTEM#:
(COMPILER-LET ((*PACKAGE* (FIND-PACKAGE "SYSTEM"))
                          (SI:*LISP-MODE* :COMMON-LISP)
                          (*READTABLE* COMMON-LISP-READTABLE)
                          (SI:*READER-SYMBOL-SUBSTITUTIONS* *COMMON-LISP-SYMBOL-SUBSTITUTIONS*))
  (COMPILER#:PATCH-SOURCE-FILE "SYS: NVRAM; INITS.#"


(Defun Record-Load-Unit ()
  "Records name of Load band for this boot in NVRAM."
  (When (And (Nvram-Accessible-P) (Nvram-Initialized-P))
   ;; If load partition name is 0, then was default boot and we need to fix.
   ;; Othewise, it was written correctly by Ucode crash record allocation routine.
    (When (= (Read-Current-Crash-Field Cro-Load-Part) #o0)
     ;; Need to fix unit number and name of current band.
      (if (and (mx-p) (eq load-unit #xff))
	  (Write-Current-Crash-Field Cro-Load-Unit *DEFAULT-DISK-UNIT*)
	  (Write-Current-Crash-Field Cro-Load-Unit Load-Unit))
      (Write-Current-Crash-Field Cro-Load-Part
	 (Dpb (CHAR-INT (Aref *Loaded-Band* #o3)) (Byte #o10 #o30)
	      (Dpb (CHAR-INT (Aref *Loaded-Band* #o2)) (Byte #o10 #o20)
		   (Dpb (CHAR-INT (Aref *Loaded-Band* #o1)) (Byte #o10 #o10)
			(CHAR-INT (Aref *Loaded-Band* #o0)))))))))
))

#!C
; From file INITS.LISP#> NVRAM; MR-X:
#8R SYSTEM#:
(COMPILER-LET ((*PACKAGE* (FIND-PACKAGE "SYSTEM"))
                          (SI:*LISP-MODE* :COMMON-LISP)
                          (*READTABLE* COMMON-LISP-READTABLE)
                          (SI:*READER-SYMBOL-SUBSTITUTIONS* *COMMON-LISP-SYMBOL-SUBSTITUTIONS*))
  (COMPILER#:PATCH-SOURCE-FILE "SYS: NVRAM; INITS.#"


(Defun Record-Microload-Unit ()
  "Records name of MCR band for this boot in NVRAM."
  (When (And (Nvram-Accessible-P) (Nvram-Initialized-P))
    (Write-Current-Crash-Field CRO-Ucode-Unit *mcr-unit*)
    (Write-Current-Crash-Field CRO-Ucode-Part
	 (Dpb (CHAR-INT (Aref *Loaded-MCR-Band* #o3)) (Byte #o10 #o30)
	      (Dpb (CHAR-INT (Aref *Loaded-MCR-Band* #o2)) (Byte #o10 #o20)
		   (Dpb (CHAR-INT (Aref *Loaded-MCR-Band* #o1)) (Byte #o10 #o10)
			(CHAR-INT (Aref *Loaded-MCR-Band* #o0))))))))
))

#!C
; From file INITS.LISP#> NVRAM; Hotel:
#8R SYSTEM#:
(COMPILER-LET ((*PACKAGE* (FIND-PACKAGE "SYSTEM"))
                          (SI:*LISP-MODE* :COMMON-LISP)
                          (*READTABLE* COMMON-LISP-READTABLE)
                          (SI:*READER-SYMBOL-SUBSTITUTIONS* *COMMON-LISP-SYMBOL-SUBSTITUTIONS*))
  (COMPILER#:PATCH-SOURCE-FILE "SYS: NVRAM; INITS.#"


(DEFUN record-system-info-in-NVRAM ()
  (Record-System-Version)
  (Record-Load-Unit)
  (if (mx-p) (Record-Microload-Unit))
  (Record-Boot-Time)
  (Record-Progress Crec-Progress-Time-Initialized)
  (WHEN (AND (resource-present-p :NVRAM) (nvram-accessible-p))
    (WHEN (FBOUNDP 'calculate-config-checksum)
      (Write-Nvram-Field Nvram-Config-Checksum (calculate-config-checksum)))))
))
