;;; -*- Mode: Common-Lisp; Package: PRINTER; Base: 10.; Patch-File: T -*-

;;; Reason: Changed GET-TEMP-SCREEN-IMAGE-FILE to use the canonical type when building the pathname.

;;;                           RESTRICTED RIGHTS LEGEND
;;;
;;; Use, duplication, or disclosure by the Government is subject to
;;; restrictions as set forth in subdivision (c)(1)(ii) of the Rights in
;;; Technical Data and Computer Software clause at 52.227-7013.
;;;
;;;   TEXAS INSTRUMENTS INCORPORATED      
;;;   P.O. BOX 2909, M/S 2151             
;;;   AUSTIN, TEXAS 78769                 
;;;
;;; Copyright (C) 1989 Texas Instruments Incorporated.
;;; All rights reserved.

;;; Patch file for PRINTER version 6.3
;;; Written 07/07/89 07:39:11 by BERGER,
;;; while running on ARIES from band LOD1
;;; With SYSTEM 6.10, VIRTUAL-MEMORY 6.1, EH 6.3, MAKE-SYSTEM 6.0, MICRONET 6.0, LOCAL-FILE 6.0,
;;;  BASIC-PATHNAME 6.0, NETWORK-SUPPORT-COLD 6.0, BASIC-NAMESPACE 6.1, NETWORK-NAMESPACE 6.0,
;;;  DISK-IO 6.0, DISK-LABEL 6.0, BASIC-FILE 6.2, MAC-PATHNAME 6.0, NETWORK-PATHNAME 6.0,
;;;  COMPILER 6.6, TV 6.12, DATALINK 6.0, CHAOSNET 6.0, GC 6.3, MEMORY-AUX 6.0, NVRAM 6.1,
;;;  SYSLOG 6.1, STREAMER-TAPE 6.4, UCL 6.0, INPUT-EDITOR 6.0, METER 6.1, ZWEI 6.3,
;;;  DEBUG-TOOLS 6.3, NETWORK-SUPPORT 6.0, NETWORK-SERVICE 6.1, DATALINK-DISPLAYS 6.0,
;;;  FONT-EDITOR 6.1, SERIAL 6.0, PRINTER 6.2, MAC-PRINTER-TYPES 6.1, PRINTER-TYPES 6.0,
;;;  IMAGEN 6.0, SUGGESTIONS 6.0, MAIL-DAEMON 6.2, MAIL-READER 6.0, TELNET 6.0, VT100 6.0,
;;;  NAMESPACE-EDITOR 6.0, PROFILE 6.1, VISIDOC 6.2, TI-CLOS 6.10, CLEH 6.4, IP 3.47,
;;;  Experimental BUG 11.10, Experimental CLX 6.2, CLUE 6.8, X11M 6.1,  microcode 429,
;;;  Band Name: 6.0 + patches 6/26

#!C
; From file UTILITIES.LISP#> PRINTER; SYS:
#10R PRINTER#:
(COMPILER-LET ((*PACKAGE* (FIND-PACKAGE "PRINTER"))
                          (SI:*LISP-MODE* :COMMON-LISP)
                          (*READTABLE* SYS:COMMON-LISP-READTABLE)
                          (SI:*READER-SYMBOL-SUBSTITUTIONS* SYS::*COMMON-LISP-SYMBOL-SUBSTITUTIONS*))
  (COMPILER#:PATCH-SOURCE-FILE "SYS: PRINTER; UTILITIES.#"


(DEFUN GET-TEMP-SCREEN-IMAGE-FILE (USER TYPE)
  "The file where a temporary screen image is saved"
  (UNLESS (AND *PRINTER-FILE-HOST* *PRINTER-DIRECTORY-NAME*)
    (SET-UP-PRINTER-FILE-HOST-AND-DIRECTORY))
  (let* ((pathname
	   (send				;11-16-87 DAB Bug 6172,5579
	     (FS:MERGE-PATHNAME-DEFAULTS
	       (MAKE-PATHNAME :DIRECTORY *PRINTER-DIRECTORY-NAME*
			      :HOST *PRINTER-FILE-HOST*
			      :NAME (STRING-APPEND "I" (STRING-DOWNCASE USER)
						   (format nil "-~a" (get-universal-time)) ; DAB 01-25-89
						   )   
			      :canonical-TYPE type     ; DAB 07-07-89
			      :VERSION :NEWEST))
	     :merge-device))			;03-18-88 DAB 
	 ;(probe-result (open pathname :direction :probe :deleted t :error nil)) ; DAB 01-25-89
	 )
    pathname))
))
