;;; -*- Mode: Common-Lisp; Package: User; Base: 10.; Patch-File: T -*-
;;; Patch file for PROFILE version 6.3
;;; Reason: Added rpc variables *callrpc-timeout* and *callrpc-retrys* so that users will
;;; feel more inclined to taylor rpc operation to their specific environments.
;;; Written 04/11/90 15:33:01 by W,
;;; while running on MX61 from band n817
;;; With SYSTEM 6.31, GC 6.3, VIRTUAL-MEMORY 6.3, MICRONET 6.0, MICRONET-COMM 6.3,
;;;  DISK-IO 6.2, DISK-LABEL 6.0, BASIC-PATHNAME 6.4, MAC-PATHNAME 6.0, NETWORK-SUPPORT-COLD 6.2,
;;;  BASIC-NAMESPACE 6.7, BASIC-FILE 6.10, RPC 6.2, NFS-MX 6.6, EH 6.6, MAKE-SYSTEM 6.2,
;;;  MEMORY-AUX 6.0, COMPILER 6.14, TV 6.24, NVRAM 6.2, UCL 6.0, INPUT-EDITOR 6.0,
;;;  MACTOOLBOX 2.17, METER 6.1, ZWEI 6.13, DEBUG-TOOLS 6.4, WINDOW-MX 6.10, PRINTER 6.4,
;;;  MAC-PRINTER-TYPES 6.2, CLIPBOARD 6.1, TI-CLOS 6.42, CLEH 6.5, NETWORK-PATHNAME 6.1,
;;;  NETWORK-NAMESPACE 6.1, DATALINK 6.0, CHAOSNET 6.5, NETWORK-SUPPORT 6.1, NETWORK-SERVICE 6.2,
;;;  DATALINK-DISPLAYS 6.0, MX-DATALINK 6.1, NAMESPACE-EDITOR 6.4, IP 3.60, NFS-MX-SERVER 6.0,
;;;  MX-SERIAL 6.1, PRINTER-TYPES 6.2, IMAGEN 6.1, MAIL-DAEMON 6.6, MAIL-READER 6.7,
;;;  TELNET 6.1, VT100 6.0, STREAMER-TAPE 6.5, DECNET 1.72, VISIDOC 6.7, PROFILE 6.2,
;;;   microcode 138, Band Name: rel6+ 4/3/90
;;;  Code read: DAB, SBW.

#!C
; From file VARIABLES.LISP#> PROFILE; Sys:
#10R PROFILE#:
(COMPILER-LET ((*PACKAGE* (FIND-PACKAGE "PROFILE"))
                          (SI:*LISP-MODE* :COMMON-LISP)
                          (*READTABLE* SYS:COMMON-LISP-READTABLE)
                          (SI:*READER-SYMBOL-SUBSTITUTIONS* SYS::*COMMON-LISP-SYMBOL-SUBSTITUTIONS*))
  (COMPILER#:PATCH-SOURCE-FILE "SYS: PROFILE; VARIABLES.#"


(WHEN (si:find-package "RPC")

  (profile:define-profile-variable *callrpc-timeout* (:network)
    :DECLARE-SPECIAL-P T
    :CVV-TYPE  :non-negative-fixnum
    :GET-VALUE (EVAL (find-symbol '*callrpc-timeout* 'RPC))
    :SET-EFFECT (SET (find-symbol '*callrpc-timeout* 'RPC) *callrpc-timeout*)
    :DOCUMENTATION "retry count (0 => no retries after initial try) for :CALL  and :BROADCAST messages to CLIENT before
signaling RPC:CALL-TIMEOUT [see also RPC:*CALLRPC-TIMEOUT*]"
    :FORM-FOR-INIT-FILE
    (LAMBDA (VAR)
      `(PROGN
	 (when (find-package "RPC")
	 (PROFILE-SETQ ,VAR (SET (find-symbol '*callrpc-timeout* 'RPC) ,*callrpc-timeout*))))))
  
  (profile:define-profile-variable *callrpc-retrys* (:network)
    :DECLARE-SPECIAL-P T
    :CVV-TYPE  :non-negative-fixnum
    :GET-VALUE (EVAL (find-symbol '*callrpc-retrys* 'RPC))
    :SET-EFFECT (SET (find-symbol '*callrpc-retrys* 'RPC) *callrpc-retrys*)
    :documentation "timeout in seconds for each  :CALL or :BROADCAST to a CLIENT object before retry
where retries used double this timeout value [see also RPC:*CALLRPC-RETRYS* and
RPC:*PMAP-GETPORT-TIMEOUT*]"
    :FORM-FOR-INIT-FILE
    (LAMBDA (VAR)
      `(PROGN
	 (when (find-package "RPC")
	 (PROFILE-SETQ ,VAR (SET (find-symbol '*callrpc-retrys* 'RPC) ,*callrpc-retrys*))))))

  )
))
