;;; -*- Mode:Common-Lisp; Package:Compiler; Base:10; Patch-file:T -*-

;;; Reason: Fix COMPILE-FILE to not save all DEFUNs in the compile-time environment.

;;;                           RESTRICTED RIGHTS LEGEND
;;;
;;; Use, duplication, or disclosure by the Government is subject to
;;; restrictions as set forth in subdivision (c)(1)(ii) of the Rights in
;;; Technical Data and Computer Software clause at 52.227-7013.
;;;
;;;   TEXAS INSTRUMENTS INCORPORATED      
;;;   P.O. BOX 2909, M/S 2151             
;;;   AUSTIN, TEXAS 78769                 
;;;
;;; Copyright (C) 1989 Texas Instruments Incorporated.
;;; All rights reserved.

;;; Patch file for REL6F version 6.4
;;; Written 04/06/89 14:57:08 by GRAY,
;;; while running on Kelvin from band LODA
;;; With Experimental REL6F 6.3, Experimental SYSTEM 6.0, Experimental VIRTUAL-MEMORY 6.0,
;;;  Experimental EH 6.0, Experimental MAKE-SYSTEM 6.0, Experimental MICRONET 6.0,
;;;  Experimental LOCAL-FILE 6.0, Experimental BASIC-PATHNAME 6.0, Experimental NETWORK-SUPPORT-COLD 6.0,
;;;  Experimental BASIC-NAMESPACE 6.0, Experimental NETWORK-NAMESPACE 6.0, Experimental DISK-IO 6.0,
;;;  Experimental DISK-LABEL 6.0, Experimental BASIC-FILE 6.0, Experimental MAC-PATHNAME 6.0,
;;;  Experimental NETWORK-PATHNAME 6.0, Experimental COMPILER 6.0, Experimental TV 6.0,
;;;  Experimental DATALINK 6.0, Experimental CHAOSNET 6.0, Experimental GC 6.0, Experimental MEMORY-AUX 6.0,
;;;  Experimental NVRAM 6.0, Experimental SYSLOG 6.0, Experimental STREAMER-TAPE 6.0,
;;;  Experimental CLEH 1.0, Experimental UCL 6.0, Experimental INPUT-EDITOR 6.0, Experimental METER 6.0,
;;;  Experimental ZWEI 6.0, Experimental DEBUG-TOOLS 6.0, Experimental NETWORK-SUPPORT 6.0,
;;;  Experimental NETWORK-SERVICE 6.0, Experimental DATALINK-DISPLAYS 6.0, Experimental FONT-EDITOR 6.0,
;;;  Experimental SERIAL 6.0, Experimental PRINTER 6.0, Experimental MAC-PRINTER-TYPES 6.0,
;;;  Experimental PRINTER-TYPES 6.0, Experimental IMAGEN 6.0, Experimental SUGGESTIONS 6.0,
;;;  Experimental MAIL-DAEMON 6.0, Experimental MAIL-READER 6.0, Experimental TELNET 6.0,
;;;  Experimental VT100 6.0, Experimental NAMESPACE-EDITOR 6.0, Experimental PROFILE 6.0,
;;;  VISIDOC 6.0, IP 3.42, Experimental BUG 11.4, Inconsistent TI-CLOS 15.2, Experimental CLX 3.0,
;;;  Experimental X11M 1.66, Experimental CLUE 18.0, Experimental RPC 6.0, NFS 3.5,
;;;  Experimental DOCUMENTER 615.0,  microcode 418, Band Name: Rel 6.0 + 4S 4/4

#!C
; From file COMPILE.LISP#> COMPILER; MR-X:
#10R COMPILER#:
(COMPILER-LET ((*PACKAGE* (FIND-PACKAGE "COMPILER"))
                          (SI:*LISP-MODE* :COMMON-LISP)
                          (*READTABLE* COMMON-LISP-READTABLE)
                          (SI:*READER-SYMBOL-SUBSTITUTIONS* SYS::*COMMON-LISP-SYMBOL-SUBSTITUTIONS*))
  (COMPILER#:PATCH-SOURCE-FILE "SYS: COMPILER; COMPILE.#"


(DEFUN QC-TRANSLATE-FUNCTION (FUNCTION-SPEC EXP QC-TF-PROCESSING-MODE QC-TF-OUTPUT-MODE
			      &OPTIONAL (NAME-FOR-FUNCTION FUNCTION-SPEC) PASS-1-ONLY)
  "Compile one function.  All styles of the compiler come through here.
QC-TF-PROCESSING-MODE should be MACRO-COMPILE or MICRO-COMPILE.
QC-TF-OUTPUT-MODE is used by LAP to determine where to put the compiled code.
 It is COMPILE-TO-CORE for making an actual FEF; QFASL, REL, or
 QFASL-NO-FDEFINE to simply dump a FEF without trying to define a function.
EXP is the lambda-expression.
NAME-FOR-FUNCTION is what the fef's name field should say;
 if omitted, FUNCTION-SPEC is used for that too.
In MACRO-COMPILE mode, the return value is the value of QLAPP for the first function."
  ;;  7/15/85 - Don't call PEEP when HOLDPROG is NIL.
  ;;  2/01/86 - Moved binding of some special variables from QCOMPILE0 to around its call.
  ;;  3/13/86 - Bind *BARF-DEFAULTS* to NIL.
  ;;  4/25/86 - Set *LAST-ADDRESS-READ* if not already set by COMPILE-STREAM.
  ;;  5/06/86 - Fix to allow EXP in DEBUG-INFO-AREA.
  ;;  5/24/86 DNG - Split out CHECK-FOR-UNUSED-VARIABLES as a separate function.
  ;;  5/28/86 DNG - Use a lexical closure instead of a dynamic closure for ERROR-MESSAGE-HOOK.
  ;;  6/21/86 DNG - Change to use *LOCAL-ENVIRONMENT* instead of LOCAL-MACROS.
  ;;  7/10/86 DNG - Revised to use COMPILAND structure instead of COMPILER-QUEUE-ENTRY.
  ;;  7/30/86 DNG - New argument PASS-1-ONLY.
  ;;  9/24/86 DNG - Modify "give up" handling to skip the rest of the queue.
  ;;  9/25/86 DNG - Removed the second call to OBJECT-OPERATION-WITH-WARNINGS because it was
  ;;		masking warnings recorded by the call in BREAKOFF.
  ;; 11/14/86 DNG - Watch out for write-protected area SOURCE-CODE-AREA.
  ;;  2/07/87 DNG - Use new function WRITE-PROTECTED-AREA-P .
  ;;  3/07/87 DNG - Clear QCMP-OUTPUT array to facilitate GC.
  ;;  7/22/87 DNG - Eliminate use of *LAST-ADDRESS-READ*.
  ;;  7/30/87 DNG - For in-memory compile, bind MACRO-CONS-AREA to QCOMPILE-TEMPORARY-AREA
  ;;		instead of BACKGROUND-CONS-AREA.
  ;;  7/26/88 JHO - Added   FILE-LOCAL-DECLARATIONS-DEF-ALIST to LET
  ;;  8/16/88 clm - Use only FILE-LOCAL-DECLARATIONS-DEF-ALIST to keep track of DEFinitions
  ;;                (no longer keep same info in FILE-LOCAL-DECLARATIONS).
  ;; 10/25/88 DNG - Remove binding of *LOCAL-ENVIRONMENT*.
  ;;  3/16/89 DNG - Don't need binding of FILE-LOCAL-DECLARATIONS-DEF-ALIST anymore.
  ;;  4/06/89 DNG - Add binding of *LOCAL-ENVIRONMENT*.
  (OBJECT-OPERATION-WITH-WARNINGS (NAME-FOR-FUNCTION)
    (LET* ((DEFAULT-CONS-AREA QCOMPILE-TEMPORARY-AREA)
	   (ERROR-MESSAGE-HOOK
	     ;; Note: this function cannot reference special variables because
	     ;; it will be executed by the error handler in a different stack group.
	     ;; Construct a lexical closure over the function name.
	     (AND NAME-FOR-FUNCTION
		  #'(LAMBDA ()
		      (FORMAT T "Error occurred while compiling ~S"
			      NAME-FOR-FUNCTION))))
	   COMPILER-QUEUE
	   (WARN-CATCHER NIL)
	   (COMPILING-COMMON-LISP (COMMON-LISP-ON-P))
	   (VAL NIL)
	   (THIS-FUNCTION-BARF-SPECIAL-LIST NIL)
	   (GIVE-UP-NAME NAME-FOR-FUNCTION)
	   ( *BARF-DEFAULTS* NIL ))
      (IF (ARRAYP EXP)
	  (SETQ COMPILER-QUEUE (CONS EXP NIL))
	(PROGN
	  (SETQ COMPILER-QUEUE
		(CONS (MAKE-COMPILAND 
			:FUNCTION-SPEC FUNCTION-SPEC
			:FUNCTION-NAME NAME-FOR-FUNCTION
			:DEFINITION    EXP
			:DECLARATIONS  LOCAL-DECLARATIONS)
		      NIL))
	  ))
      (LOOP ; for each FEF to be generated
	(WHEN (NULL COMPILER-QUEUE) (RETURN))
	(LET* ((CURRENT (FIRST COMPILER-QUEUE))
	       (*CURRENT-COMPILAND* CURRENT)
	       (OPTIMIZE-SWITCH (COMPILAND-OPTIMIZE CURRENT))
	       )
	  (SETQ NAME-FOR-FUNCTION (COMPILAND-FUNCTION-NAME CURRENT))
	  (UNLESS (EQ (CAR-SAFE NAME-FOR-FUNCTION) ':INTERNAL)
	    (SETQ GIVE-UP-NAME NAME-FOR-FUNCTION))
	  (progn ;OBJECT-OPERATION-WITH-WARNINGS (NAME-FOR-FUNCTION)
	    (MULTIPLE-VALUE-BIND ( NIL ERROR-CAUGHT )
	      (CATCH-ERROR-RESTART (ERROR "Give up on compiling ~S" GIVE-UP-NAME)
		;;
		;;		Pass 1
		;;
		(WHEN (OR (COMPILAND-EXP2 CURRENT) ; pass 1 already done
			  (LET (( VARS NIL )
				( VAR-BIT (ASH (MAX SPECIAL-VAR-BIT DATA-ALTERATION-BIT) 1) )
				( ALTERED-VAR-SET 0 )
				( USED-VAR-SET 0 )
				( PROPAGATE-VAR-SET 0 )
				( SUBST-VAR-SET 0 )
				( LOCAL-FUNCTIONS NIL )
				( PROGDESCS NIL )
				( RETPROGDESC NIL )
				( GOTAGS NIL )
				( 1-IF-LIVE-CODE 1 )
				( FILE-LOCAL-DECLARATIONS FILE-LOCAL-DECLARATIONS )
				( MACRO-CONS-AREA (IF (AND (EQ QC-TF-OUTPUT-MODE 'COMPILE-TO-CORE)
							   (SI:AREA-TEMPORARY-P DEFAULT-CONS-AREA))
						      BACKGROUND-CONS-AREA
						    DEFAULT-CONS-AREA) ) ; for PRE-OPTIMIZE
				( *LOCAL-ENVIRONMENT*
				 ;; Bind this so that the SETF of FILE-LOCAL-DEF below will be temporary.
				 (LIST* (ENV-VARS *LOCAL-ENVIRONMENT*)
					(CONS NIL (ENV-FUNCTIONS *LOCAL-ENVIRONMENT*))
					(CDDR *LOCAL-ENVIRONMENT*)))
				)

			    (UNLESS (LISTP (COMPILAND-FUNCTION-SPEC CURRENT)) ; non-NIL symbol
			      (LET ((*COMPILE-FILE-ENVIRONMENT* *LOCAL-ENVIRONMENT*))
				(setf (file-local-def (COMPILAND-FUNCTION-SPEC CURRENT))
				      (COMPILAND-DEFINITION CURRENT))) )

			    (LET ((RESULT (QCOMPILE1 CURRENT)))  ; do pass 1 on top-level function
			      (SETF (COMPILAND-USED-VAR-SET CURRENT) USED-VAR-SET)
			      (SETF (COMPILAND-ALTERED-VAR-SET CURRENT) ALTERED-VAR-SET)
			      (IF PASS-1-ONLY ; return partially compiled result
				  (PROGN (SETQ VAL CURRENT)
					 (SETQ PASS-1-ONLY NIL) ; only applies to first queue entry
					 NIL) ; don't do pass 2 yet
				RESULT) )))
		  ;; pass 1 succeded; continue.
		  ;;
		  ;;		Pass 2
		  ;;
		  (QCOMPILE2 CURRENT)	   ; pass 2 on sub-function
		  (WHEN HOLDPROG
		    ;;
		    ;;		Peephole optimizer
		    ;;
		    (WHEN (AND PEEP-ENABLE
			       (>= (OPT-SPEED-OR-SPACE OPTIMIZE-SWITCH)
				   (OPT-COMPILATION-SPEED OPTIMIZE-SWITCH))
			       (NEQ QC-TF-PROCESSING-MODE 'MICRO-COMPILE))
		      (record-individual-time 'peep
			(PEEP QCMP-OUTPUT (COMPILAND-FUNCTION-SPEC CURRENT))))
		    ;;
		    ;;		QLAPP
		    ;;
		    (COND ((EQ QC-TF-PROCESSING-MODE 'MACRO-COMPILE)
			   (LET* ((LAP-CODE (G-L-P QCMP-OUTPUT))
				  (LAP-RESULT
				    (record-individual-time 'qlapp
				      (IF (EQ QC-TF-OUTPUT-MODE 'BOTH)
					  (PROGN
					    (QLAPP LAP-CODE 'QFASL)
					    (QLAPP LAP-CODE 'COMPILE-TO-CORE))
					(QLAPP LAP-CODE QC-TF-OUTPUT-MODE)))))
			     (UNLESS VAL (SETQ VAL LAP-RESULT))))
			  ((EQ QC-TF-PROCESSING-MODE 'MICRO-COMPILE)
			   (LET ((DEFAULT-CONS-AREA BACKGROUND-CONS-AREA))
			     (MICRO-COMPILE (G-L-P QCMP-OUTPUT) QC-TF-OUTPUT-MODE)))
			  #+compiler:debug
			  (T (BARF QC-TF-PROCESSING-MODE "invalid compile mode" 'BARF))
			  )
		    ) ; end HOLDPROG
		  (UNLESS (SI:AREA-TEMPORARY-P DEFAULT-CONS-AREA)
		    ;; When TGC is in use, clear out the active portion of this
		    ;; array as soon as we are finished with it so that the
		    ;; contents can be garbage-collected.
		    (ARRAY-INITIALIZE QCMP-OUTPUT NIL)
		    (SETF (FILL-POINTER QCMP-OUTPUT) 0))
		  NIL))
	      (WHEN ERROR-CAUGHT
		(WHEN (< *RETURN-STATUS* FATAL)
		  (SETQ *RETURN-STATUS* FATAL))
		;; If compilation of a function is aborted, then can't meaningfully
		;; continue compiling its children, so return out of the loop.
		(RETURN) )
	    )))
	(POP COMPILER-QUEUE)) ; end of LOOP
      VAL)))
))
