;;; -*- Mode:Common-Lisp; Package:Compiler; Base:10; Patch-file:T -*-

;;; Reason: Fix compiler for recording of compile-time definition of DEFWRAPPER and other 
;;; macros whose name is a list.

;;;                           RESTRICTED RIGHTS LEGEND
;;;
;;; Use, duplication, or disclosure by the Government is subject to
;;; restrictions as set forth in subdivision (c)(1)(ii) of the Rights in
;;; Technical Data and Computer Software clause at 52.227-7013.
;;;
;;;   TEXAS INSTRUMENTS INCORPORATED      
;;;   P.O. BOX 2909, M/S 2151             
;;;   AUSTIN, TEXAS 78769                 
;;;
;;; Copyright (C) 1989 Texas Instruments Incorporated.
;;; All rights reserved.

;;; Written 05/19/89 13:53:29 by GRAY,
;;; while running on Kelvin from band LOD2
;;; With Experimental REL6H 6.17, SYSTEM 6.0, Experimental VIRTUAL-MEMORY 6.0, Experimental EH 6.0,
;;;  Experimental MAKE-SYSTEM 6.0, Experimental MICRONET 6.0, Experimental LOCAL-FILE 6.0,
;;;  Experimental BASIC-PATHNAME 6.0, Experimental NETWORK-SUPPORT-COLD 6.0, Experimental BASIC-NAMESPACE 6.0,
;;;  Experimental NETWORK-NAMESPACE 6.0, Experimental DISK-IO 6.0, Experimental DISK-LABEL 6.0,
;;;  Experimental BASIC-FILE 6.0, Experimental MAC-PATHNAME 6.0, Experimental NETWORK-PATHNAME 6.0,
;;;  COMPILER 6.0, Experimental TV 6.0, Experimental DATALINK 6.0, Experimental CHAOSNET 6.0,
;;;  Experimental GC 6.0, Experimental MEMORY-AUX 6.0, Experimental NVRAM 6.0, Experimental SYSLOG 6.0,
;;;  Experimental STREAMER-TAPE 6.0, Experimental CLEH 1.0, Experimental UCL 6.0,
;;;  Experimental INPUT-EDITOR 6.0, Experimental METER 6.0, Experimental ZWEI 6.0,
;;;  Experimental DEBUG-TOOLS 6.0, Experimental NETWORK-SUPPORT 6.0, Experimental NETWORK-SERVICE 6.0,
;;;  DATALINK-DISPLAYS 6.0, Experimental FONT-EDITOR 6.0, Experimental SERIAL 6.0,
;;;  Experimental PRINTER 6.0, Experimental MAC-PRINTER-TYPES 6.0, Experimental PRINTER-TYPES 6.0,
;;;  Experimental IMAGEN 6.0, Experimental SUGGESTIONS 6.0, Experimental MAIL-DAEMON 6.0,
;;;  Experimental MAIL-READER 6.0, Experimental TELNET 6.0, Experimental VT100 6.0,
;;;  Experimental NAMESPACE-EDITOR 6.0, Experimental PROFILE 6.0, VISIDOC 6.0, Experimental TI-CLOS 17.6,
;;;  Experimental CLX 5.0, Experimental CLUE 20.0, Experimental X11M 3.0, Experimental RPC 6.0,
;;;  Experimental NFS 6.0, Experimental BUG 11.4, IP 3.45, Experimental DOCUMENTER 618.0,
;;;   microcode 426, Band Name: Rel6H,Scribe,&c, u426 5/4

#!C
; From file FILE.LISP#> COMPILER; MR-X:
#10R COMPILER#:
(COMPILER-LET ((*PACKAGE* (FIND-PACKAGE "COMPILER"))
                          (SI:*LISP-MODE* :COMMON-LISP)
                          (*READTABLE* COMMON-LISP-READTABLE)
                          (SI:*READER-SYMBOL-SUBSTITUTIONS* SYS::*COMMON-LISP-SYMBOL-SUBSTITUTIONS*))
  (COMPILER#:PATCH-SOURCE-FILE "SYS: COMPILER; FILE.#"



(DEFUN PUTDECL-ALIST (FUNCTION-SPEC VALUE)
  ;;  3/16/89 DNG - Rewritten using environments.
  ;;  5/18/89 DNG - Fix storing of definition of list fspecs other than :PROPERTY.
  (unless (null *compile-file-environment*)
    (cond ((symbolp function-spec)
	   (setf (first (env-functions *compile-file-environment*))
		 (list* (locf (symbol-function FUNCTION-SPEC))
			value
			(first (env-functions *compile-file-environment*)))))
	  ((and (eq (first function-spec) :property)
		(symbolp (second function-spec)))
	   (setf (get-from-environment (second function-spec) (third function-spec)
				       nil *compile-file-environment*)
		 value))
	  (t (function-spec-putprop-in-environment function-spec value
						   fdef-key *compile-file-environment*)))
    )
  value)

))
