;;; -*- Mode: Common-Lisp; Package: User; Base: 10.; Patch-File: T -*-
;;; Written 05/02/89 09:17:18 by swede,
;;; Reason: Fix default who line PLANE MASK and DISPLAY-TYPE
;;; while running on NEWTON from band LOD6
;;; With Experimental REL6H 6.1, Experimental SYSTEM 6.0, Experimental VIRTUAL-MEMORY 6.0,
;;;  Experimental EH 6.0, Experimental MAKE-SYSTEM 6.0, Experimental MICRONET 6.0,
;;;  Experimental LOCAL-FILE 6.0, Experimental BASIC-PATHNAME 6.0, Experimental NETWORK-SUPPORT-COLD 6.0,
;;;  Experimental BASIC-NAMESPACE 6.0, Experimental NETWORK-NAMESPACE 6.0, Experimental DISK-IO 6.0,
;;;  Experimental DISK-LABEL 6.0, Experimental BASIC-FILE 6.0, Experimental MAC-PATHNAME 6.0,
;;;  Experimental NETWORK-PATHNAME 6.0, Experimental COMPILER 6.0, Experimental TV 6.0,
;;;  Experimental DATALINK 6.0, Experimental CHAOSNET 6.0, Experimental GC 6.0, Experimental MEMORY-AUX 6.0,
;;;  Experimental NVRAM 6.0, Experimental SYSLOG 6.0, Experimental STREAMER-TAPE 6.0,
;;;  Experimental CLEH 1.0, Experimental UCL 6.0, Experimental INPUT-EDITOR 6.0, Experimental METER 6.0,
;;;  Experimental ZWEI 6.0, Experimental DEBUG-TOOLS 6.0, Experimental NETWORK-SUPPORT 6.0,
;;;  Experimental NETWORK-SERVICE 6.0, DATALINK-DISPLAYS 6.0, Experimental FONT-EDITOR 6.0,
;;;  Experimental SERIAL 6.0, Experimental PRINTER 6.0, Experimental MAC-PRINTER-TYPES 6.0,
;;;  Experimental PRINTER-TYPES 6.0, Experimental IMAGEN 6.0, Experimental SUGGESTIONS 6.0,
;;;  Experimental MAIL-DAEMON 6.0, Experimental MAIL-READER 6.0, Experimental TELNET 6.0,
;;;  Experimental VT100 6.0, Experimental NAMESPACE-EDITOR 6.0, Experimental PROFILE 6.0,
;;;  VISIDOC 6.0, Experimental TI-CLOS 16.7,  microcode 423, Band Name: Rel 6.0 5/1

#!C
; From file SHWARM.LISP#> WINDOW; NEWTON:
#10R TV#:
(COMPILER-LET ((*PACKAGE* (FIND-PACKAGE "TV"))
                          (SI:*LISP-MODE* :COMMON-LISP)
                          (*READTABLE* COMMON-LISP-READTABLE)
                          (SI:*READER-SYMBOL-SUBSTITUTIONS* SYS::*COMMON-LISP-SYMBOL-SUBSTITUTIONS*))
  (COMPILER#:PATCH-SOURCE-FILE "SYS: WINDOW; SHWARM.#"


(DEFUN create-acceptable-initial-who-line-screen ()
  ;; First force buffer-address to appropriate, non-color value.
  (SETQ main-screen-buffer-address (IF sib-is-csib
				       CSIB-EXPANS-NO-TRANSP-VA
				       IO-SPACE-VIRTUAL-ADDRESS))
  ;; Make who-line-screen NIL so a new version gets created in #'who-line-setup
  (SETQ who-line-screen nil)
  ;; Don't use make-who-line-screen because appropriate who-line variables
  ;; don't get set (they end up NIL).
  (who-line-setup   ;;tv:make-who-line-screen
    nil  ;; Force unique name to be generated.
    nil
    *initial-who-line-screen-bits-per-pixel* 
    *initial-who-line-screen-display-type* ;; may 05/02/89 Need :both to get plane-mask to 255.
    )
  ;; Return who-line-screen just created
  who-line-screen)
))

#!C
; From file TVDEFS.LISP#> WINDOW; NEWTON:
#10R TV#:
(COMPILER-LET ((*PACKAGE* (FIND-PACKAGE "TV"))
                          (SI:*LISP-MODE* :COMMON-LISP)
                          (*READTABLE* COMMON-LISP-READTABLE)
                          (SI:*READER-SYMBOL-SUBSTITUTIONS* SYS::*COMMON-LISP-SYMBOL-SUBSTITUTIONS*))
  (COMPILER#:PATCH-SOURCE-FILE "SYS: WINDOW; TVDEFS.#"


(DEFPARAMETER *initial-who-line-screen-display-type* :both) ; may 05/02/89 :monochrome)
))

(dolist (s tv:all-the-screens)
  (unless (get s :who-line)
    (when (not (send s :exposed-p))
      (tv:kill-screen s))))

(dolist (s tv:all-the-screens)
  (setf (cadr (member :display-type (send s :eval-inside-yourself 'tv:property-list))) :both)
  (send s :eval-inside-yourself '(setq tv:plane-mask 255.))
  )