;;; -*- Mode: Common-Lisp; Package: User; Base: 10.; Patch-File: T -*-

;;; Reason: Forward the value-cell of PACKAGE READTABLE APPLYHOOK EVALHOOK to equivalent Common-Lisp variables. 
;;; Remove the SPECIAL property of above symbols.
;;; This allows old ZETALISP xlds to run, and keeps CommonLisp usage intact.

;;;                           RESTRICTED RIGHTS LEGEND
;;;
;;; Use, duplication, or disclosure by the Government is subject to
;;; restrictions as set forth in subdivision (c)(1)(ii) of the Rights in
;;; Technical Data and Computer Software clause at 52.227-7013.
;;;
;;;   TEXAS INSTRUMENTS INCORPORATED      
;;;   P.O. BOX 2909, M/S 2151             
;;;   AUSTIN, TEXAS 78769                 
;;;
;;; Copyright (C) 1989 Texas Instruments Incorporated.
;;; All rights reserved.

;;; Written 05/03/89 13:44:53 by SWEDE,
;;; while running on Wright from band LODA
;;; With Experimental REL6H 6.4, Experimental SYSTEM 6.0, Experimental VIRTUAL-MEMORY 6.0,
;;;  Experimental EH 6.0, Experimental MAKE-SYSTEM 6.0, Experimental MICRONET 6.0,
;;;  Experimental LOCAL-FILE 6.0, Experimental BASIC-PATHNAME 6.0, Experimental NETWORK-SUPPORT-COLD 6.0,
;;;  Experimental BASIC-NAMESPACE 6.0, Experimental NETWORK-NAMESPACE 6.0, Experimental DISK-IO 6.0,
;;;  Experimental DISK-LABEL 6.0, Experimental BASIC-FILE 6.0, Experimental MAC-PATHNAME 6.0,
;;;  Experimental NETWORK-PATHNAME 6.0, Experimental COMPILER 6.0, Experimental TV 6.0,
;;;  Experimental DATALINK 6.0, Experimental CHAOSNET 6.0, Experimental GC 6.0, Experimental MEMORY-AUX 6.0,
;;;  Experimental NVRAM 6.0, Experimental SYSLOG 6.0, Experimental STREAMER-TAPE 6.0,
;;;  Experimental CLEH 1.0, Experimental UCL 6.0, Experimental INPUT-EDITOR 6.0, Experimental METER 6.0,
;;;  Experimental ZWEI 6.0, Experimental DEBUG-TOOLS 6.0, Experimental NETWORK-SUPPORT 6.0,
;;;  Experimental NETWORK-SERVICE 6.0, DATALINK-DISPLAYS 6.0, Experimental FONT-EDITOR 6.0,
;;;  Experimental SERIAL 6.0, Experimental PRINTER 6.0, Experimental MAC-PRINTER-TYPES 6.0,
;;;  Experimental PRINTER-TYPES 6.0, Experimental IMAGEN 6.0, Experimental SUGGESTIONS 6.0,
;;;  Experimental MAIL-DAEMON 6.0, Experimental MAIL-READER 6.0, Experimental TELNET 6.0,
;;;  Experimental VT100 6.0, Experimental NAMESPACE-EDITOR 6.0, Experimental PROFILE 6.0,
;;;  VISIDOC 6.0, Experimental TI-CLOS 17.1, Experimental CLX 5.0, Experimental CLUE 20.0,
;;;  Experimental X11M 3.0, Experimental RPC 6.0, Experimental NFS 6.0, Experimental BUG 1.0,
;;;  IP 3.42,  microcode 598, Band Name: Rel 6.0 + SLE 5/3

#!C
; From file PATCH-6-7.LISP#> PATCH.REL6G; MR-X:
#10R USER#:
(COMPILER-LET ((*PACKAGE* (FIND-PACKAGE "USER"))
                          (SI:*LISP-MODE* :COMMON-LISP)
                          (*READTABLE* SYS:COMMON-LISP-READTABLE)
                          (SI:*READER-SYMBOL-SUBSTITUTIONS* SYS::*COMMON-LISP-SYMBOL-SUBSTITUTIONS*))
  (COMPILER#:PATCH-SOURCE-FILE "SYS: CMINT_TOOLS; MOVE-VARIABLES.#"

(eval-when (load)
  (si:%p-store-data-type-and-pointer
    (si:%pointer (locf (symbol-value 'LISP:PACKAGE))) si:dtp-one-q-forward (value-cell-location 'LISP:*PACKAGE*))
  
  (si:%p-store-data-type-and-pointer
    (si:%pointer (locf (symbol-value 'LISP:READTABLE))) si:dtp-one-q-forward (value-cell-location 'LISP:*READTABLE*))
  
  
  (si:%p-store-data-type-and-pointer
    (si:%pointer (locf (symbol-value 'LISP:APPLYHOOK))) si:dtp-one-q-forward (value-cell-location 'LISP:*APPLYHOOK*))
  
  (si:%p-store-data-type-and-pointer
    (si:%pointer (locf (symbol-value 'LISP:EVALHOOK))) si:dtp-one-q-forward (value-cell-location 'LISP:*EVALHOOK*))
  
  (remprop 'LISP:PACKAGE 'special)
  (remprop 'LISP:READTABLE 'special)
  (remprop 'LISP:EVALHOOK 'special)
  (remprop 'LISP:APPLYHOOK 'special)
  )

  
))

