;;; -*- Mode: Common-Lisp; Package: RPC; Base: 10.; Patch-File: T -*-
;;; Written 04/18/89 10:33:13 by BERGER,
;;; Reason: Fixed UNIX-LISP-UT  to adjust the time for daylight savings.
;;; while running on MX29 from band NB22
;;; With SYSTEM 5.29, GC 5.4, VIRTUAL-MEMORY 5.5, MICRONET 5.6, MICRONET-COMM 5.14,
;;;  DISK-IO 5.11, BASIC-PATHNAME 5.4, MAC-PATHNAME 5.1, NETWORK-SUPPORT-COLD 5.3,
;;;  BASIC-NAMESPACE 5.10, BASIC-FILE 5.5, RPC 5.6, NFS 5.20, EH 5.4, MAKE-SYSTEM 5.4,
;;;  MEMORY-AUX 5.1, MACTOOLBOX 1.36, COMPILER 5.4, TV 5.28, NVRAM 5.2, UCL 5.0, INPUT-EDITOR 5.1,
;;;  METER 5.1, ZWEI 5.14, DEBUG-TOOLS 5.1, WINDOW-MX 5.38, PRINTER 5.12, MAC-PRINTER-TYPES 5.5,
;;;  NETWORK-PATHNAME 5.1, NETWORK-NAMESPACE 5.2, DATALINK 5.10, CHAOSNET 5.6, NETWORK-SUPPORT 5.1,
;;;  NETWORK-SERVICE 5.1, DATALINK-DISPLAYS 5.0, NAMESPACE-EDITOR 5.2, IP 3.42, NFS-SERVER 5.3,
;;;  PRINTER-TYPES 5.5, IMAGEN 5.3, MAIL-DAEMON 5.8, MAIL-READER 5.6, TELNET 5.3,
;;;  VT100 5.1, STREAMER-TAPE 5.8, DECNET 1.64, VISIDOC 5.6, PROFILE 5.1, DISK-LABEL 5.2,
;;;  MX-SERIAL 1.1, MX-DATALINK 2.2,  microcode 97, Band Name: microExplorer Network (11/22)

#!C
; From file CONSTANTS.LISP#> RPC; SYS
#10R REMOTE-PROCEDURE-CALL#:
(COMPILER-LET ((*PACKAGE* (FIND-PACKAGE "REMOTE-PROCEDURE-CALL"))
                          (SI:*LISP-MODE* :COMMON-LISP)
                          (*READTABLE* SYS:COMMON-LISP-READTABLE)
                          (SI:*READER-SYMBOL-SUBSTITUTIONS* SYS::*COMMON-LISP-SYMBOL-SUBSTITUTIONS*))
  (COMPILER#:PATCH-SOURCE-FILE "SYS: RPC; constants.#"


(DEFCONSTANT 0000GMT-1JAN04DST (encode-universal-time 0 0 5 1 1 1904 0))

))

#!C
; From file MISC_FUNCTIONS.LISP#> RPC; SYS
#10R REMOTE-PROCEDURE-CALL#:
(COMPILER-LET ((*PACKAGE* (FIND-PACKAGE "REMOTE-PROCEDURE-CALL"))
                          (SI:*LISP-MODE* :COMMON-LISP)
                          (*READTABLE* SYS:COMMON-LISP-READTABLE)
                          (SI:*READER-SYMBOL-SUBSTITUTIONS* SYS::*COMMON-LISP-SYMBOL-SUBSTITUTIONS*))
  (COMPILER#:PATCH-SOURCE-FILE "SYS: RPC; MISC_FUNCTIONS.#"


(DEFUN UNIX-LISP-UT (unix-universal-time &optional (read-host si:local-host))
   "Convert UNIX-UNIVERSAL-TIME (seconds since 0000GMT 1 January 1970) into
Lisp universal time (seconds since 0000GMT 1 January 1900)."
   (declare (values lisp-universal-time))
   (let ((UT (+ unix-universal-time    ; DAB 04-18-89 First build the time without daylight savings.
		(IF (mac-host-p read-host)
		    0000GMT-1JAN04 
		    0000GMT-1JAN70))))
     (if (and (mac-host-p read-host) (time:ut-daylight-savings-p  UT)) ; DAB 04-18-89 Then check if it needs readjusting.
	      (+ unix-universal-time
		 0000GMT-1JAN04DST) ; DAB 04-18-89
	      UT))
   )
))
