;;; -*- Mode: Common-Lisp; Package: User; Base: 10.; Patch-File: T -*-
;;; Written 05/18/89 17:10:15 by HAGY,
;;; Reason: Fixing XDR integer filter to distinquish between signed and unsigned integers.
;;;    Code Readers: LER, LEH   05/18/89
;;; while running on Zwingli from band LOD2
;;; With SYSTEM 6.0, VIRTUAL-MEMORY 6.0, EH 6.0, MAKE-SYSTEM 6.0, MICRONET 6.0, LOCAL-FILE 6.0,
;;;  BASIC-PATHNAME 6.0, NETWORK-SUPPORT-COLD 6.0, BASIC-NAMESPACE 6.0, NETWORK-NAMESPACE 6.0,
;;;  DISK-IO 6.0, DISK-LABEL 6.0, BASIC-FILE 6.0, MAC-PATHNAME 6.0, NETWORK-PATHNAME 6.0,
;;;  COMPILER 6.0, TV 6.0, DATALINK 6.0, CHAOSNET 6.0, GC 6.0, MEMORY-AUX 6.0, NVRAM 6.0,
;;;  SYSLOG 6.0, STREAMER-TAPE 6.0, UCL 6.0, INPUT-EDITOR 6.0, METER 6.0, ZWEI 6.0,
;;;  DEBUG-TOOLS 6.0, NETWORK-SUPPORT 6.0, NETWORK-SERVICE 6.0, DATALINK-DISPLAYS 6.0,
;;;  FONT-EDITOR 6.0, SERIAL 6.0, PRINTER 6.0, MAC-PRINTER-TYPES 6.0, PRINTER-TYPES 6.0,
;;;  IMAGEN 6.0, SUGGESTIONS 6.0, MAIL-DAEMON 6.0, MAIL-READER 6.0, TELNET 6.0, VT100 6.0,
;;;  NAMESPACE-EDITOR 6.0, PROFILE 6.0, VISIDOC 6.0, TI-CLOS 6.0, CLEH 6.0, Experimental RPC 6.0,
;;;  BN 3.2, LX 3.3, NFS 3.0,  microcode 427, Band Name: Exp 6.0, LX 3.0 5/15

#!C
; From file XDR_STREAM.LISP#> RPC; SYS:
#10R REMOTE-PROCEDURE-CALL#:
(COMPILER-LET ((*PACKAGE* (FIND-PACKAGE "REMOTE-PROCEDURE-CALL"))
                          (SI:*LISP-MODE* :COMMON-LISP)
                          (*READTABLE* SYS:COMMON-LISP-READTABLE)
                          (SI:*READER-SYMBOL-SUBSTITUTIONS* SYS::*COMMON-LISP-SYMBOL-SUBSTITUTIONS*))
  (COMPILER#:PATCH-SOURCE-FILE "SYS: RPC; XDR_STREAM.#"


(DEFUN-METHOD XDR-PUTLONG-SIGNED XDR-STREAM (integer)
   ;; writes four least significant bytes from INTEGER to stream most significant byte first
   (declare (values ignore))
   (send self :byte-out (ldb INT-X000-BSPEC integer))
   (send self :byte-out (ldb INT-0X00-BSPEC integer))
   (send self :byte-out (ldb INT-00X0-BSPEC integer))
   (send self :byte-out (logand #xFF integer))
   )

))

#!C
; From file FILTER_PRIMITIVES.LISP#> RPC; MR-X:
#10R REMOTE-PROCEDURE-CALL#:
(COMPILER-LET ((*PACKAGE* (FIND-PACKAGE "REMOTE-PROCEDURE-CALL"))
                          (SI:*LISP-MODE* :COMMON-LISP)
                          (*READTABLE* SYS:COMMON-LISP-READTABLE)
                          (SI:*READER-SYMBOL-SUBSTITUTIONS* SYS::*COMMON-LISP-SYMBOL-SUBSTITUTIONS*))
  (COMPILER#:PATCH-SOURCE-FILE "SYS: RPC; FILTER_PRIMITIVES.#"


(DEFUN-METHOD XDR-INTEGER-INTERNAL XDR-STREAM (operation integer)
   "If stream is open for input, reads an XDR Integer (or Enumeration) from stream and stores a
Lisp integer as contents of INTEGER which must be a locative.  If open for output, writes INTEGER
[a signed integer value representable in 32 bits or a locative of such a value] to stream as an XDR
Integer. On the Explorer, an XDR enumeration is identical to an XDR integer."
   (declare (values ignore)
	    (arglist integer-or-enumeration)
	    (ignore operation))
   ;; an XDR Integer is four bytes, two's complement, most significant byte first
   (ecase transfer-direction
     (:DECODE   (setf (contents integer) (extend-sign (xdr-getlong) 31)))
     (:ENCODE   (xdr-putlong-signed (value-of integer))))
   );xdr-integer-internal

))

#!C
; From file FILTER_PRIMITIVES.LISP#> RPC; MR-X:
#10R REMOTE-PROCEDURE-CALL#:
(COMPILER-LET ((*PACKAGE* (FIND-PACKAGE "REMOTE-PROCEDURE-CALL"))
                          (SI:*LISP-MODE* :COMMON-LISP)
                          (*READTABLE* SYS:COMMON-LISP-READTABLE)
                          (SI:*READER-SYMBOL-SUBSTITUTIONS* SYS::*COMMON-LISP-SYMBOL-SUBSTITUTIONS*))
  (COMPILER#:PATCH-SOURCE-FILE "SYS: RPC; FILTER_PRIMITIVES.#"


(DEFMETHOD (XDR-STREAM :XDR-HYPER) (integer)
   "If stream is open for input, reads an XDR Hyper from stream and stores a Lisp integer as contents of
INTEGER which must be a locative.  If open for output, writes INTEGER [a signed integer value
representable in 64 bits or a locative of such a value] to stream as an XDR Hyper."
   (declare (values ignore))

   ;; an XDR Hyper is eight bytes, two's complement, most significant byte first
   (ecase transfer-direction
     (:DECODE
      (let* ((high (xdr-getlong))	   ; make sure we read these in order
	     (low  (xdr-getlong)))
	(setf (contents integer) (extend-sign (dpb high INT-XXXX0000-BSPEC low) 63))))

     (:ENCODE
      (xdr-putlong-signed (ldb INT-XXXX0000-BSPEC (value-of integer)))
      (xdr-putlong-signed (value-of integer))))
   );xdr-hyper

))
