;;; -*- Mode: Common-Lisp; Package: User; Base: 10.; Patch-File: T -*-

;;; Reason: added initialization "Start Port Map Servers" to ensure that the
;;; micronet port-map-server gets started at boot time on a
;;; non-network development band.

;;;                           RESTRICTED RIGHTS LEGEND
;;;
;;; Use, duplication, or disclosure by the Government is subject to
;;; restrictions as set forth in subdivision (c)(1)(ii) of the Rights in
;;; Technical Data and Computer Software clause at 52.227-7013.
;;;
;;;   TEXAS INSTRUMENTS INCORPORATED      
;;;   P.O. BOX 149149, M/S 2151             
;;;   AUSTIN, TEXAS 78714-9149                 
;;;
;;; Copyright (C) 1989 Texas Instruments Incorporated.
;;; All rights reserved.

;;; Written 09/29/89 16:19:25 by sbw,
;;; while running on MX61 from band d929
;;; With SYSTEM 6.14, GC 6.3, VIRTUAL-MEMORY 6.1, MICRONET 6.0, MICRONET-COMM 6.1,
;;;  DISK-IO 6.1, DISK-LABEL 6.0, BASIC-PATHNAME 6.1, MAC-PATHNAME 6.0, NETWORK-SUPPORT-COLD 6.0,
;;;  BASIC-NAMESPACE 6.2, BASIC-FILE 6.2, RPC 6.1, NFS-MX 6.1, EH 6.4, MAKE-SYSTEM 6.0,
;;;  MEMORY-AUX 6.0, COMPILER 6.10, TV 6.15, NVRAM 6.1, UCL 6.0, INPUT-EDITOR 6.0,
;;;  MACTOOLBOX 2.7, METER 6.1, ZWEI 6.5, DEBUG-TOOLS 6.3, WINDOW-MX 6.7, PRINTER 6.3,
;;;  MAC-PRINTER-TYPES 6.1, CLIPBOARD 6.1, TI-CLOS 6.20, CLEH 6.5, NETWORK-PATHNAME 6.0,
;;;  NETWORK-NAMESPACE 6.0, DATALINK 6.0, CHAOSNET 6.0, NETWORK-SUPPORT 6.0, NETWORK-SERVICE 6.1,
;;;  DATALINK-DISPLAYS 6.0, MX-DATALINK 6.1, NAMESPACE-EDITOR 6.0, IP 3.47, NFS-MX-SERVER 6.0,
;;;  MX-SERIAL 6.1, PRINTER-TYPES 6.1, IMAGEN 6.0, MAIL-DAEMON 6.2, MAIL-READER 6.2,
;;;  TELNET 6.0, VT100 6.0, STREAMER-TAPE 6.4, DECNET 1.69, VISIDOC 6.2, PROFILE 6.1,
;;;  Experimental CLX 6.2, CLUE 6.10, Experimental BUG 11.14,  microcode 138, Band Name: microExplorer Network + SLE (8/17)

;;; Readded "Start Port Map Servers" initialization.  In development band (non-network)
;;; micronet portmap server was not getting started.  We were relying on nfs:start-nfs-server to call
;;; start-port-map-server, but the nfs-server system does not exist in development bands.  Note:
;;;now the portmap server will get started twice in network bands, but this should be harmless.
;;;This fixes str# 10669.
;;;Code read: BJ

#!C
; From file INITIALIZATIONS.LISP#> RPC; SYS:
#10R REMOTE-PROCEDURE-CALL#:
(COMPILER-LET ((*PACKAGE* (FIND-PACKAGE "REMOTE-PROCEDURE-CALL"))
                          (SI:*LISP-MODE* :COMMON-LISP)
                          (*READTABLE* SYS:COMMON-LISP-READTABLE)
                          (SI:*READER-SYMBOL-SUBSTITUTIONS* SYS::*COMMON-LISP-SYMBOL-SUBSTITUTIONS*))
  (COMPILER#:PATCH-SOURCE-FILE "SYS: RPC; INITIALIZATIONS.#"


(add-initialization "Start Port Map Servers"
		    '(dolist (protocol-no (all-protocol-no))
		       (if (null (rpc:find-server-processes 'rpc:port-map-server protocol-no))
			   (rpc:start-port-map-server protocol-no) 
			   (rpc:reset-and-enable-server-process 'rpc:port-map-server protocol-no)))
		    '(:warm :first))
))


