;;; -*- Mode: Common-Lisp; Package: MT; Base: 10.; Patch-File: T -*-

;;; Reason: Fixed (TAPE-MIXIN :VERIFY-DIRECTORY). It was probing the wrong file during remote-tape.

;;;                           RESTRICTED RIGHTS LEGEND
;;;
;;; Use, duplication, or disclosure by the Government is subject to
;;; restrictions as set forth in subdivision (c)(1)(ii) of the Rights in
;;; Technical Data and Computer Software clause at 52.227-7013.
;;;
;;;   TEXAS INSTRUMENTS INCORPORATED      
;;;   P.O. BOX 2909, M/S 2151             
;;;   AUSTIN, TEXAS 78769                 
;;;
;;; Copyright (C) 1989 Texas Instruments Incorporated.
;;; All rights reserved.

;;; Written 06/21/89 07:48:34 by BERGER,
;;; while running on ARIES from band LOD1
;;; With SYSTEM 6.6, VIRTUAL-MEMORY 6.1, EH 6.3, MAKE-SYSTEM 6.0, MICRONET 6.0, LOCAL-FILE 6.0,
;;;  BASIC-PATHNAME 6.0, NETWORK-SUPPORT-COLD 6.0, BASIC-NAMESPACE 6.1, NETWORK-NAMESPACE 6.0,
;;;  DISK-IO 6.0, DISK-LABEL 6.0, BASIC-FILE 6.2, MAC-PATHNAME 6.0, NETWORK-PATHNAME 6.0,
;;;  COMPILER 6.2, TV 6.10, DATALINK 6.0, CHAOSNET 6.0, GC 6.2, MEMORY-AUX 6.0, NVRAM 6.0,
;;;  SYSLOG 6.0, STREAMER-TAPE 6.2, UCL 6.0, INPUT-EDITOR 6.0, METER 6.0, ZWEI 6.2,
;;;  Experimental DEBUG-TOOLS 6.2, NETWORK-SUPPORT 6.0, NETWORK-SERVICE 6.0, DATALINK-DISPLAYS 6.0,
;;;  FONT-EDITOR 6.1, SERIAL 6.0, PRINTER 6.1, MAC-PRINTER-TYPES 6.1, PRINTER-TYPES 6.0,
;;;  IMAGEN 6.0, SUGGESTIONS 6.0, MAIL-DAEMON 6.2, MAIL-READER 6.0, TELNET 6.0, VT100 6.0,
;;;  NAMESPACE-EDITOR 6.0, PROFILE 6.1, VISIDOC 6.2, TI-CLOS 6.5, CLEH 6.4, IP 3.46,
;;;  Experimental BUG 11.10, Experimental CLX 6.1, CLUE 6.5, X11M 6.1, DECNET 1.68,
;;;  RPC 6.1, NFS 3.8,  microcode 429, Band Name: Release 6.0 6/16

#!C
; From file DISPLAY.LISP#> STREAMER-TAPE; SYS:
#10R MT#:
(COMPILER-LET ((*PACKAGE* (FIND-PACKAGE "MT"))
                          (SI:*LISP-MODE* :COMMON-LISP)
                          (*READTABLE* SYS:COMMON-LISP-READTABLE)
                          (SI:*READER-SYMBOL-SUBSTITUTIONS* SYS::*COMMON-LISP-SYMBOL-SUBSTITUTIONS*))
  (COMPILER#:PATCH-SOURCE-FILE "SYS: STREAMER-TAPE; DISPLAY.#"


(DEFMETHOD (TAPE-MIXIN :VERIFY-DIRECTORY) ()
  "Verify Directory on tape until extra EOF is encountered."
  (LET ((FINI :ABORTED)
	(backup-window self)
	result)
    (declare (special backup-window))
    (SETQ DOIT ())
    (UNLESS RESTORE-SELECTIVE-NAME
      (SETF RESTORE-SELECTIVE-NAME (GUESS-DIRECTORY :WILD)))
    (UNLESS BACKUP-DIRECTORY-NAME
      (SETF BACKUP-DIRECTORY-NAME (GUESS-DIRECTORY :WILD)))
    (CATCH 'VMF-DOIT
      (TV:CHOOSE-VARIABLE-VALUES
	`((RESTORE-SELECTIVE-NAME "Source Pathname" :DOCUMENTATION ,DOC-RMF-SEL
				  :directory-PATHNAME RESTORE-SELECTIVE-NAME)
	  (BACKUP-DIRECTORY-NAME "Destination Pathname" :DOCUMENTATION ,DOC-VF-PATH
				 :directory-PATHNAME BACKUP-DIRECTORY-NAME)
	  (*USE-ORIGINAL-HOST* "Use host name from tape?" :DOCUMENTATION ,DOC-VMF-ORIGINAL-HOST
			       :BOOLEAN))
	:WIDTH 80 :MARGIN-CHOICES '(("Do it" (AND (SETQ DOIT T) (THROW 'VMF-DOIT ()))) "Abort")
	:LABEL "Verify Directory" :SUPERIOR BACKUP-WINDOW))
    (WHEN DOIT
      (FORMAT (SEND SELF :OUT-STREAM) "~&Verifying Directory with ~A" BACKUP-DIRECTORY-NAME)
      (cond (*remote-tape-p*
	     (if (probe-directory BACKUP-DIRECTORY-NAME )  ; DAB 06-21-89 
		 (setq result (tape-service-req *remote-hostname*  $VERIFY-dire))
		 (FORMAT *standard-output* "~%  Directory ~s -> [Does not exist] " BACKUP-DIRECTORY-NAME)) )
	    (t (setq result (VERIFY BACKUP-DIRECTORY-NAME () :SELECTIVE-SOURCE-PATTERN RESTORE-SELECTIVE-NAME
			   :USE-ORIGINAL-HOST *USE-ORIGINAL-HOST*))  ) ) ;; cond
      (if result
	  (FORMAT (SEND SELF :OUT-STREAM) "~&Verify Directory completed SUCCESSFULLY.~%")
	  (FORMAT (SEND SELF :OUT-STREAM) "~&Verify Directory FAILED.~%"))
      (SETQ FINI :MUTE))
    FINI))
))
