;;; -*- Mode: Common-Lisp; Package: User; Base: 10.; Patch-File: T -*-

;;; Reason: Change to refresh suggestions-off-frame for (MMON-P) warm boots
;;; (MMON-P) cold boots are handled in a separate window patch.

;;;                           RESTRICTED RIGHTS LEGEND
;;;
;;; Use, duplication, or disclosure by the Government is subject to
;;; restrictions as set forth in subdivision (c)(1)(ii) of the Rights in
;;; Technical Data and Computer Software clause at 52.227-7013.
;;;
;;;   TEXAS INSTRUMENTS INCORPORATED      
;;;   P.O. BOX 2909, M/S 2151             
;;;   AUSTIN, TEXAS 78769                 
;;;
;;; Copyright (C) 1989 Texas Instruments Incorporated.
;;; All rights reserved.

;;; Written 10/20/89 09:26:29 by marky,
;;; while running on LIBRA from band LODA
;;; With SYSTEM 6.20, VIRTUAL-MEMORY 6.2, EH 6.5, MAKE-SYSTEM 6.2, MICRONET 6.0, LOCAL-FILE 6.1,
;;;  BASIC-PATHNAME 6.2, NETWORK-SUPPORT-COLD 6.2, BASIC-NAMESPACE 6.4, NETWORK-NAMESPACE 6.0,
;;;  DISK-IO 6.1, DISK-LABEL 6.0, BASIC-FILE 6.4, MAC-PATHNAME 6.0, NETWORK-PATHNAME 6.0,
;;;  COMPILER 6.12, TV 6.15, DATALINK 6.0, CHAOSNET 6.1, GC 6.3, MEMORY-AUX 6.0, NVRAM 6.2,
;;;  SYSLOG 6.2, STREAMER-TAPE 6.4, UCL 6.0, INPUT-EDITOR 6.0, METER 6.1, ZWEI 6.7,
;;;  DEBUG-TOOLS 6.3, NETWORK-SUPPORT 6.0, NETWORK-SERVICE 6.1, DATALINK-DISPLAYS 6.0,
;;;  FONT-EDITOR 6.1, SERIAL 6.0, PRINTER 6.3, MAC-PRINTER-TYPES 6.1, PRINTER-TYPES 6.2,
;;;  IMAGEN 6.1, SUGGESTIONS 6.0, MAIL-DAEMON 6.3, MAIL-READER 6.5, TELNET 6.0, VT100 6.0,
;;;  NAMESPACE-EDITOR 6.3, PROFILE 6.2, VISIDOC 6.5, TI-CLOS 6.25, CLEH 6.5, IP 3.54,
;;;  Experimental CLX 6.5, CLUE 6.25, X11M 6.15, Experimental BUG 11.15, Inconsistent MMON 6.1,
;;;   microcode 429, Band Name: clogged

;;; SPR 9802. See also window patch 6.16 to tv:cold-window-initializations

#!C
; From file SET-UP-SUGGESTIONS.LISP#> SUGGESTIONS; Hotel:
#10R SUGG#:
(COMPILER-LET ((*PACKAGE* (FIND-PACKAGE "SUGG"))
                          (SI:*LISP-MODE* :COMMON-LISP)
                          (*READTABLE* SYS:COMMON-LISP-READTABLE)
                          (SI:*READER-SYMBOL-SUBSTITUTIONS* SYS::*COMMON-LISP-SYMBOL-SUBSTITUTIONS*))
  (COMPILER#:PATCH-SOURCE-FILE "SYS: SUGGESTIONS; SET-UP-SUGGESTIONS.#"

(DEFUN decide-if-suggestions-visible ()
  "Disable the Suggestions utility for those machines that don't 
have monitors large enough to display Sugg windows and still have 
any useful screen space left."
  (cond ((or (tv:mac-system-p)
	     (si:mp-system-p)) ;;Right now, the only machine we do this for is the Macintosh. and the MP
	 (w:remove-terminal-key #\s-help)
	 (w:delete-from-system-menu-column :user-aids "Suggestions")
	 (LET ((inhibit-fdefine-warnings t))
	   (EVAL '(DEFUN esc-suggestions-menus (&rest ignore) nil))))
	(t
	 (resize-window-for-suggestions-off-frame W:initial-lisp-listener)
	 (when (eq W:selected-window W:initial-lisp-listener)
	   (send suggestions-off-frame :expose)
	   (WHEN (AND (TV:MMON-P) 			;; may 10/19/89
		      (NOT SI:COLD-BOOTING))		;; may 10/19/89 See tv:cold-window-initializations
	     (SEND SUGGESTIONS-OFF-FRAME :REFRESH))	;; may 10/19/89
	   ))))

))


