;;; -*- Mode: Common-Lisp; Package: SYSLOG; Base: 8.; Patch-File: T -*-

;;; Reason: Fixed add-1 to handle boundary condition.

;;;                           RESTRICTED RIGHTS LEGEND
;;;
;;; Use, duplication, or disclosure by the Government is subject to
;;; restrictions as set forth in subdivision (c)(1)(ii) of the Rights in
;;; Technical Data and Computer Software clause at 52.227-7013.
;;;
;;;   TEXAS INSTRUMENTS INCORPORATED      
;;;   P.O. BOX 2909, M/S 2151             
;;;   AUSTIN, TEXAS 78769                 
;;;
;;; Copyright (C) 1989 Texas Instruments Incorporated.
;;; All rights reserved.

;;; Written 06/22/89 13:58:34 by BERGER,
;;; while running on ARIES from band LOD1
;;; With SYSTEM 6.9, VIRTUAL-MEMORY 6.1, EH 6.3, MAKE-SYSTEM 6.0, MICRONET 6.0, LOCAL-FILE 6.0,
;;;  BASIC-PATHNAME 6.0, NETWORK-SUPPORT-COLD 6.0, BASIC-NAMESPACE 6.1, NETWORK-NAMESPACE 6.0,
;;;  DISK-IO 6.0, DISK-LABEL 6.0, BASIC-FILE 6.2, MAC-PATHNAME 6.0, NETWORK-PATHNAME 6.0,
;;;  COMPILER 6.4, TV 6.11, DATALINK 6.0, CHAOSNET 6.0, GC 6.3, MEMORY-AUX 6.0, NVRAM 6.0,
;;;  SYSLOG 6.0, STREAMER-TAPE 6.3, UCL 6.0, INPUT-EDITOR 6.0, METER 6.0, ZWEI 6.3,
;;;  Experimental DEBUG-TOOLS 6.3, NETWORK-SUPPORT 6.0, NETWORK-SERVICE 6.0, DATALINK-DISPLAYS 6.0,
;;;  FONT-EDITOR 6.1, SERIAL 6.0, PRINTER 6.1, MAC-PRINTER-TYPES 6.1, PRINTER-TYPES 6.0,
;;;  IMAGEN 6.0, SUGGESTIONS 6.0, MAIL-DAEMON 6.2, MAIL-READER 6.0, TELNET 6.0, VT100 6.0,
;;;  NAMESPACE-EDITOR 6.0, PROFILE 6.1, VISIDOC 6.2, TI-CLOS 6.8, CLEH 6.4, IP 3.46,
;;;  Experimental BUG 11.10, Experimental CLX 6.1, CLUE 6.5, X11M 6.1, RPC 6.1, NFS 3.8,
;;;   microcode 429, Band Name: Release 6.0 6/16

#!C
; From file LOG-AND-DUMP.LISP#> SYSLOG; sys:
#8R SYSLOG#:
(COMPILER-LET ((*PACKAGE* (FIND-PACKAGE "SYSLOG"))
                          (SI:*LISP-MODE* :COMMON-LISP)
                          (*READTABLE* SYS:COMMON-LISP-READTABLE)
                          (SI:*READER-SYMBOL-SUBSTITUTIONS* SYS::*COMMON-LISP-SYMBOL-SUBSTITUTIONS*))
  (COMPILER#:PATCH-SOURCE-FILE "SYS: SYSLOG; LOG-AND-DUMP.#"


(DEFUN ADD-1 (RCD)
  "Real workhorse for adding a record to the system log."
  (SETF *LOG-BUSY* T)
  (LET ((HEAD (GET-HEAD)) (TAIL (GET-TAIL)) (START 0) (END (GET-LENGTH))
	(SIZE (+ 2 (LENGTH RCD))))		;room for record seperators.
    (COND
      ((<= TAIL HEAD)				;first pass, tail follow head
       (IF (> SIZE (- END HEAD))
	   (PROGN
	     (WHEN (= TAIL START)
	       (DELETE-1 TAIL ()))
	     (PUT-HEAD START)			;wrap around head pointer
	     (ADD-1 RCD))
	   (COPY-RECORD RCD HEAD)))		;updates head pointer
      (T					;Normal, head follows tail
       (COND
	 ((>= SIZE (- TAIL HEAD))  ; DAB 06-22-89 Changed > to >= to handle boundary problem.
	  (DELETE-1 TAIL ()) (ADD-1 RCD))	;remove one message starting at tail
	 (T (COPY-RECORD RCD HEAD)))))))
))
