;;; -*- Mode:Common-Lisp; Package:System; Base:10; Patch-file:T -*-

;;; Reason: Export NIL from the GLOBAL package.  [SPR 10423]
;;; Reason: Export NIL from the GLOBAL package.  [SPR 10423]

;;;                           RESTRICTED RIGHTS LEGEND
;;;
;;; Use, duplication, or disclosure by the Government is subject to
;;; restrictions as set forth in subdivision (c)(1)(ii) of the Rights in
;;; Technical Data and Computer Software clause at 52.227-7013.
;;;
;;;   TEXAS INSTRUMENTS INCORPORATED      
;;;   P.O. BOX 149149, M/S 2151             
;;;   AUSTIN, TEXAS 78714
;;;
;;; Copyright (C) 1989 Texas Instruments Incorporated.
;;; All rights reserved.

;;; Written 08/28/89 14:49:36 by GRAY,
;;; while running on Kelvin from band LOD2
;;; With SYSTEM 6.14, VIRTUAL-MEMORY 6.1, EH 6.4, MAKE-SYSTEM 6.0, MICRONET 6.0, LOCAL-FILE 6.0,
;;;  BASIC-PATHNAME 6.1, NETWORK-SUPPORT-COLD 6.0, BASIC-NAMESPACE 6.2, NETWORK-NAMESPACE 6.0,
;;;  DISK-IO 6.1, DISK-LABEL 6.0, BASIC-FILE 6.2, MAC-PATHNAME 6.0, NETWORK-PATHNAME 6.0,
;;;  COMPILER 6.10, TV 6.15, DATALINK 6.0, CHAOSNET 6.0, GC 6.3, MEMORY-AUX 6.0, NVRAM 6.1,
;;;  SYSLOG 6.1, STREAMER-TAPE 6.4, UCL 6.0, INPUT-EDITOR 6.0, METER 6.1, ZWEI 6.5,
;;;  DEBUG-TOOLS 6.3, NETWORK-SUPPORT 6.0, NETWORK-SERVICE 6.1, DATALINK-DISPLAYS 6.0,
;;;  FONT-EDITOR 6.1, SERIAL 6.0, PRINTER 6.3, MAC-PRINTER-TYPES 6.1, PRINTER-TYPES 6.1,
;;;  IMAGEN 6.0, SUGGESTIONS 6.0, MAIL-DAEMON 6.2, MAIL-READER 6.2, TELNET 6.0, VT100 6.0,
;;;  NAMESPACE-EDITOR 6.0, PROFILE 6.1, VISIDOC 6.3, TI-CLOS 6.20, CLEH 6.5, IP 3.47,
;;;  Experimental BUG 11.15, Experimental CLX 6.2, CLUE 6.5, X11M 6.13, Experimental DOCUMENTER 6.0,
;;;   microcode 430, Band Name: 6.0,Scribe,XNS,&c u429 7/14

;;; BUG REPORT NUMBER:  10423
;;;
;;; PROBLEM:  
;;;	The package "GLOBAL" does not include the symbol NIL.  This will cause
;;;	serious problems for Zetalisp programs that use the GLOBAL package.
;;;
;;; SOLUTION:  The following fixup code removes the bogus internal symbol 
;;;	GLOBAL::NIL and exports LISP:NIL from the GLOBAL package.  A source fix is 
;;;	not required because the problem was caused by a previous patch [6.13].
;;;
;;; DEPENDENCIES:  Must be loaded after patch System 6.13.

(LET ((SYM (FIND-SYMBOL "NIL" "GLOBAL")))
  (UNLESS (EQ SYM 'LISP:NIL)
    (UNINTERN SYM "GLOBAL"))
  (IMPORT '(LISP:NIL) "GLOBAL")	
  (EXPORT '(LISP:NIL) "GLOBAL"))
