;;; -*- Mode:Common-Lisp; Package:System; Base:10; Patch-file:T -*-

;;; Reason: Fix so that PACKAGE and READTABLE are defined as type specifiers in Zetalisp 
;;; mode.  [SPR 10461]

;;;                           RESTRICTED RIGHTS LEGEND
;;;
;;; Use, duplication, or disclosure by the Government is subject to
;;; restrictions as set forth in subdivision (c)(1)(ii) of the Rights in
;;; Technical Data and Computer Software clause at 52.227-7013.
;;;
;;;   TEXAS INSTRUMENTS INCORPORATED      
;;;   P.O. BOX 149149, M/S 2151             
;;;   AUSTIN, TEXAS 78714
;;;
;;; Copyright (C) 1989 Texas Instruments Incorporated.
;;; All rights reserved.

;;; Patch file for SYSTEM version 6.20
;;; Written 10/05/89 13:54:26 by GRAY,
;;; while running on Kelvin from band LOD2
;;; With Inconsistent SYSTEM 6.19, VIRTUAL-MEMORY 6.2, EH 6.5, MAKE-SYSTEM 6.2, MICRONET 6.0,
;;;  LOCAL-FILE 6.1, BASIC-PATHNAME 6.2, NETWORK-SUPPORT-COLD 6.1, BASIC-NAMESPACE 6.4,
;;;  NETWORK-NAMESPACE 6.0, DISK-IO 6.1, DISK-LABEL 6.0, BASIC-FILE 6.4, MAC-PATHNAME 6.0,
;;;  NETWORK-PATHNAME 6.0, Inconsistent COMPILER 6.12, TV 6.15, DATALINK 6.0, CHAOSNET 6.1,
;;;  GC 6.3, MEMORY-AUX 6.0, NVRAM 6.2, SYSLOG 6.1, STREAMER-TAPE 6.4, UCL 6.0, INPUT-EDITOR 6.0,
;;;  METER 6.1, ZWEI 6.5, DEBUG-TOOLS 6.3, NETWORK-SUPPORT 6.0, NETWORK-SERVICE 6.1,
;;;  DATALINK-DISPLAYS 6.0, FONT-EDITOR 6.1, SERIAL 6.0, PRINTER 6.3, MAC-PRINTER-TYPES 6.1,
;;;  PRINTER-TYPES 6.2, IMAGEN 6.1, SUGGESTIONS 6.0, MAIL-DAEMON 6.3, MAIL-READER 6.5,
;;;  TELNET 6.0, VT100 6.0, NAMESPACE-EDITOR 6.2, PROFILE 6.2, VISIDOC 6.5, Inconsistent TI-CLOS 6.24,
;;;  CLEH 6.5, IP 3.50, Experimental CLX 6.3, CLUE 6.18, X11M 6.14, Experimental BUG 11.15,
;;;  Experimental DOCUMENTER 701.0,  microcode 430, Band Name: 6.0+Scribe,&c,u430 9/6

;;; BUG REPORT NUMBER:  10461
;;;
;;; PROBLEM:  In Zetalisp mode, the symbols PACKAGE and READTABLE were not 
;;;	being recognized as valid type specifiers by TYPEP.  This used to work in 
;;;	previous releases, but was broken in release 6 as a consequence of 
;;;	introducing separate Zetalisp versions of these two symbols.
;;;
;;; SOLUTION:  Add DEFTYPE declarations to declare ZLC:PACKAGE as a synonym 
;;;	for LISP:PACKAGE and ZLC:READTABLE a synonym for LISP:READTABLE.
;;;
;;; DEPENDENCIES: [none]

#!C
; From file ZETALISP-SUPPORT.LISP#> KERNEL; Hotel:
#10R SYSTEM#:
(COMPILER-LET ((*PACKAGE* (FIND-PACKAGE "SYSTEM"))
                          (SI:*LISP-MODE* :COMMON-LISP)
                          (*READTABLE* COMMON-LISP-READTABLE)
                          (SI:*READER-SYMBOL-SUBSTITUTIONS* *COMMON-LISP-SYMBOL-SUBSTITUTIONS*))
  (COMPILER#:PATCH-SOURCE-FILE "SYS: KERNEL; ZETALISP-SUPPORT.#"


;;  10/5/89 DNG - added to fix SPR 10461.
(unless (eq 'zlc:package 'lisp:package)
  (deftype zlc:package () 'lisp:package))
(unless (eq 'zlc:readtable 'lisp:readtable)
  (deftype zlc:readtable () 'lisp:readtable))
))
