;;; -*- Mode: Common-Lisp; Package: User; Base: 10.; Patch-File: T -*-

;;; Reason: Insert an entry containing 'TICLOS::CLASS-DEF into the support vector so that the microcode will
;;; properly handle (TYPEP x 'y) when x is an instance of a hybrid class and y is the name of a flavor
;;; included in that class.
;;; 
;;; Note: Explorer II microcode #486 or MX microcode #193 (or later) must be used for this patch to have
;;;       any effect.  TYPEP in the above situation will still fail for compiled code on an Explorer I.

;;;                           RESTRICTED RIGHTS LEGEND
;;;
;;; Use, duplication, or disclosure by the Government is subject to
;;; restrictions as set forth in subdivision (c)(1)(ii) of the Rights in
;;; Technical Data and Computer Software clause at 52.227-7013.
;;;
;;;   TEXAS INSTRUMENTS INCORPORATED      
;;;   P.O. BOX 2909, M/S 2151             
;;;   AUSTIN, TEXAS 78769                 
;;;
;;; Copyright (C) 1989 Texas Instruments Incorporated.
;;; All rights reserved.

;;; Written 06/14/90 11:59:49 by FLORMAN,
;;; while running on PCAI from band LOD6
;;; With SYSTEM 6.40, VIRTUAL-MEMORY 6.3, EH 6.8, MAKE-SYSTEM 6.4, MICRONET 6.0, LOCAL-FILE 6.2,
;;;  BASIC-PATHNAME 6.5, NETWORK-SUPPORT-COLD 6.2, BASIC-NAMESPACE 6.8, NETWORK-NAMESPACE 6.1,
;;;  DISK-IO 6.4, DISK-LABEL 6.1, BASIC-FILE 6.13, MAC-PATHNAME 6.0, NETWORK-PATHNAME 6.2,
;;;  COMPILER 6.18, TV 6.26, DATALINK 6.0, CHAOSNET 6.8, GC 6.4, MEMORY-AUX 6.0, NVRAM 6.3,
;;;  SYSLOG 6.2, STREAMER-TAPE 6.6, UCL 6.0, INPUT-EDITOR 6.0, METER 6.2, ZWEI 6.22,
;;;  DEBUG-TOOLS 6.5, NETWORK-SUPPORT 6.1, NETWORK-SERVICE 6.3, DATALINK-DISPLAYS 6.0,
;;;  FONT-EDITOR 6.1, SERIAL 6.0, PRINTER 6.8, MAC-PRINTER-TYPES 6.2, PRINTER-TYPES 6.2,
;;;  IMAGEN 6.1, SUGGESTIONS 6.1, MAIL-DAEMON 6.6, MAIL-READER 6.8, TELNET 6.1, VT100 6.0,
;;;  NAMESPACE-EDITOR 6.6, PROFILE 6.3, VISIDOC 6.7, TI-CLOS 6.52, CLEH 6.5, IP 3.65,
;;;  Experimental CLX 6.12, CLUE 6.105, X11M 6.30, Experimental BUG 11.19, RPC 6.2,
;;;  NFS 3.11,  microcode 14, Band Name: customized Rel 6.1

#!Z
; From file LROY-QCOM.LISP#> UCODE; Hotel:
#8R SYSTEM#:
(COMPILER-LET ((*PACKAGE* (FIND-PACKAGE "SYSTEM"))
                          (SI:*LISP-MODE* :ZETALISP)
                          (*READTABLE* STANDARD-READTABLE)
                          (SI:*READER-SYMBOL-SUBSTITUTIONS* *ZETALISP-SYMBOL-SUBSTITUTIONS*))
  (COMPILER#:PATCH-SOURCE-FILE "SYS: UCODE; LROY-QCOM.#"


(Defsysconst %SVC-CLOS-CLASS-DEF                  163)		;#o163       - Clos property indicator for class name

))

#!C
; From file TYPES.LISP#> KERNEL; Hotel:
#10R SYSTEM#:
(COMPILER-LET ((*PACKAGE* (FIND-PACKAGE "SYSTEM"))
                          (SI:*LISP-MODE* :COMMON-LISP)
                          (*READTABLE* COMMON-LISP-READTABLE)
                          (SI:*READER-SYMBOL-SUBSTITUTIONS* *COMMON-LISP-SYMBOL-SUBSTITUTIONS*))
  (COMPILER#:PATCH-SOURCE-FILE "SYS: KERNEL; TYPES.#"


(si:%add-to-support-vector 'ticlos::class-def si:%SVC-CLOS-CLASS-DEF t)

))
