;;; -*- Mode: Common-Lisp; Package: User; Base: 8.; Patch-File: T -*-
;;; Written 06/07/89 08:53:18 by FISH,
;;; Reason: Changed equalp-array to correctly work with named-structures and 
;;; different types of arrays. [spr 8801]
;;; while running on DaVinci from band LOD2
;;; With SYSTEM 6.3, VIRTUAL-MEMORY 6.1, EH 6.0, MAKE-SYSTEM 6.0, MICRONET 6.0, LOCAL-FILE 6.0,
;;;  BASIC-PATHNAME 6.0, NETWORK-SUPPORT-COLD 6.0, BASIC-NAMESPACE 6.0, NETWORK-NAMESPACE 6.0,
;;;  DISK-IO 6.0, DISK-LABEL 6.0, BASIC-FILE 6.0, MAC-PATHNAME 6.0, NETWORK-PATHNAME 6.0,
;;;  COMPILER 6.2, TV 6.6, DATALINK 6.0, CHAOSNET 6.0, GC 6.1, MEMORY-AUX 6.0, NVRAM 6.0,
;;;  SYSLOG 6.0, STREAMER-TAPE 6.0, UCL 6.0, INPUT-EDITOR 6.0, METER 6.0, ZWEI 6.0,
;;;  DEBUG-TOOLS 6.0, NETWORK-SUPPORT 6.0, NETWORK-SERVICE 6.0, DATALINK-DISPLAYS 6.0,
;;;  FONT-EDITOR 6.1, SERIAL 6.0, PRINTER 6.1, MAC-PRINTER-TYPES 6.1, PRINTER-TYPES 6.0,
;;;  IMAGEN 6.0, SUGGESTIONS 6.0, MAIL-DAEMON 6.2, MAIL-READER 6.0, TELNET 6.0, VT100 6.0,
;;;  NAMESPACE-EDITOR 6.0, PROFILE 6.1, VISIDOC 6.0, TI-CLOS 6.5, CLEH 6.0, IP 3.45,
;;;  Experimental BUG 11.6, CLX 6.0, CLUE 6.0, X11M 6.1, Experimental SEYMOUR3 2.0,
;;;  Experimental SLAP 3.15, TI-PROLOG 2.17,  microcode 429, Band Name: rel6/5-22/seym/ptchs

#!C
; From file ARRAYS.LISP#> Kernel; SYS:
#8R SYSTEM#:
(COMPILER-LET ((*PACKAGE* (FIND-PACKAGE "SYSTEM"))
                          (SI:*LISP-MODE* :COMMON-LISP)
                          (*READTABLE* COMMON-LISP-READTABLE)
                          (SI:*READER-SYMBOL-SUBSTITUTIONS* *COMMON-LISP-SYMBOL-SUBSTITUTIONS*))
  (COMPILER#:PATCH-SOURCE-FILE "SYS: Kernel; ARRAYS.#"


(DEFUN equalp-array (array1 array2)
  (AND (cond ((or (named-structure-p array1) 
	          (named-structure-p array2))
	      (eq (type-of array1) (type-of array2)))
	     (T T))
       (LET ((rank (ARRAY-RANK array1)))
	 (DO ((i 1 (1+ i)))
	     ((= i rank) t)
	   (UNLESS (= (%P-CONTENTS-OFFSET array1 i) (%P-CONTENTS-OFFSET array2 i))
	     (RETURN nil))))
       (LET ((len (LENGTH array1)))
	 (AND (= len (LENGTH array2))
	      (DOTIMES (i len t)
		(UNLESS (EQUALP (ar-1-force array1 i) (ar-1-force array2 i))
		  (RETURN nil)))))))
))
