;;; -*- Mode: Common-Lisp; Package: TELNET; Base: 10.; Patch-File: T -*-

;;; Reason: Fixed parse-path to handler path format <host name>/<port number> .[10908]

;;;                           RESTRICTED RIGHTS LEGEND
;;;
;;; Use, duplication, or disclosure by the Government is subject to
;;; restrictions as set forth in subdivision (c)(1)(ii) of the Rights in
;;; Technical Data and Computer Software clause at 52.227-7013.
;;;
;;;   TEXAS INSTRUMENTS INCORPORATED      
;;;   P.O. BOX 2909, M/S 2151             
;;;   AUSTIN, TEXAS 78769                 
;;;
;;; Copyright (C) 1989 Texas Instruments Incorporated.
;;; All rights reserved.

;;; Patch file for TELNET version 6.1
;;; Written 01/19/90 15:18:00 by BERGER,
;;; while running on ARIES from band LOD1
;;; With SYSTEM 6.28, VIRTUAL-MEMORY 6.3, EH 6.5, MAKE-SYSTEM 6.2, MICRONET 6.0, LOCAL-FILE 6.1,
;;;  BASIC-PATHNAME 6.2, NETWORK-SUPPORT-COLD 6.2, BASIC-NAMESPACE 6.7, NETWORK-NAMESPACE 6.1,
;;;  DISK-IO 6.2, DISK-LABEL 6.0, BASIC-FILE 6.7, MAC-PATHNAME 6.0, NETWORK-PATHNAME 6.0,
;;;  COMPILER 6.14, TV 6.23, DATALINK 6.0, CHAOSNET 6.5, GC 6.3, MEMORY-AUX 6.0, NVRAM 6.2,
;;;  SYSLOG 6.2, STREAMER-TAPE 6.5, UCL 6.0, INPUT-EDITOR 6.0, METER 6.1, ZWEI 6.12,
;;;  DEBUG-TOOLS 6.4, NETWORK-SUPPORT 6.1, NETWORK-SERVICE 6.2, DATALINK-DISPLAYS 6.0,
;;;  FONT-EDITOR 6.1, SERIAL 6.0, PRINTER 6.3, MAC-PRINTER-TYPES 6.1, PRINTER-TYPES 6.2,
;;;  IMAGEN 6.1, SUGGESTIONS 6.1, MAIL-DAEMON 6.4, MAIL-READER 6.6, TELNET 6.0, VT100 6.0,
;;;  NAMESPACE-EDITOR 6.4, PROFILE 6.2, VISIDOC 6.7, TI-CLOS 6.32, CLEH 6.5, IP 3.57,
;;;  Experimental CLX 6.8, CLUE 6.46, X11M 6.20, Experimental BUG 11.18,  microcode 431,
;;;  Band Name: REl 6.0 SLE 12/28

#!C
; From file NVT.LISP#> TELNET; SYS:
#10R TELNET#:
(COMPILER-LET ((*PACKAGE* (FIND-PACKAGE "TELNET"))
                          (SI:*LISP-MODE* :COMMON-LISP)
                          (*READTABLE* SYS:COMMON-LISP-READTABLE)
                          (SI:*READER-SYMBOL-SUBSTITUTIONS* SYS::*COMMON-LISP-SYMBOL-SUBSTITUTIONS*))
  (COMPILER#:PATCH-SOURCE-FILE "SYS: TELNET; NVT.#"


(DEFUN PARSE-PATH (&OPTIONAL PATH CONTACT-NAME ARPA-SOCKET) 		  
  "Parse a TELNET pathname."
  (LET (HOST SPECIFIED-CONTACT CONTACT-PORT SLASH-P VALID-CONTACT-PORT)
  (IF (AND PATH  (SYMBOLP PATH))
      (SETQ PATH (STRING PATH)))
  (COND
    ((INTEGERP PATH)
     (SETQ HOST PATH))
    ((NULL PATH)			   ; nil: use associated machine
     (SETQ HOST SI:ASSOCIATED-MACHINE))  
    ((NOT (STRINGP PATH))		   ; a host object
     (SETQ HOST PATH))  
    (T					   ; a pathname
     (SETF SLASH-P
	   (POSITION TELNET-SLASH-DELIMITER (THE STRING (STRING PATH)) :TEST #'CHAR-EQUAL))
     (COND				   ; no slash
       ((NULL SLASH-P)			   ; "host-name" or "host-address"
	(LET ((NUMBER (OR (PARSE-integer PATH :radix 8. :junk-allowed T)
			  (NET:IP-ADDRESS-PARSER PATH NIL)))
	      (HST (SI:PARSE-HOST PATH)))
	  (IF NUMBER (SETF HOST NUMBER))
	  (IF HST (SETF HOST HST))
	  ))	
       (T				   
	(SETF SPECIFIED-CONTACT
	      (COND	                           ; slash
		((PARSE-INTEGER PATH :START	   ; host-name/port-number
				(1+ SLASH-P) :junk-allowed T)) 
		(T (SUBSEQ PATH (1+ SLASH-P))))	   ; host-name/contact-string
	      HOST (SUBSEQ PATH 0 SLASH-P))
	(SETF HOST (SI:PARSE-HOST HOST))
	(WHEN (NULL (NET:FIND-LOGICAL-CONTACT-NAME specified-contact))
	  (SETF CONTACT-PORT (STRING-APPEND "CONTACT-" (FORMAT NIL "~D" SPECIFIED-CONTACT)))
	  ;;although the contact name "Telnet" is a string we support this
	  ;;for Internet as well as Chaosnet.
	  (UNLESS (and (stringp specified-contact)
		       (STRING-EQUAL SPECIFIED-CONTACT CONTACT-NAME))
		       
	    (WHEN (NULL (NET:FIND-LOGICAL-CONTACT-NAME CONTACT-PORT))
	      (SETF VALID-CONTACT-PORT CONTACT-PORT)
	      (COND ((NUMBERP SPECIFIED-CONTACT)
		     (NET:DEFINE-LOGICAL-CONTACT-NAME CONTACT-PORT (LIST :tcp SPECIFIED-CONTACT)))
		    (T (NET:DEFINE-LOGICAL-CONTACT-NAME CONTACT-PORT (LIST :CHAOS SPECIFIED-CONTACT))))))))
       )))				   ;cond
  (VALUES HOST NIL
	  (COND ((AND (NULL VALID-CONTACT-PORT)
		      (NET:FIND-LOGICAL-CONTACT-NAME CONTACT-PORT)) CONTACT-PORT)
		((AND (NULL VALID-CONTACT-PORT)
		      (NET:FIND-LOGICAL-CONTACT-NAME SPECIFIED-CONTACT)) SPECIFIED-CONTACT)
		((NULL VALID-CONTACT-PORT) CONTACT-NAME)
		(t VALID-CONTACT-PORT)) 
	  (IF (NULL SPECIFIED-CONTACT) ARPA-SOCKET SPECIFIED-CONTACT))
  )                                        ;let
  )
))
