;;; -*- Mode: Common-Lisp; Package: SI; Base: 8.; Patch-File: T -*-

;;; Reason: Changed Page-in-words to make-sure the address is valid
;;; before touching on it.

;;;                           RESTRICTED RIGHTS LEGEND
;;;
;;; Use, duplication, or disclosure by the Government is subject to
;;; restrictions as set forth in subdivision (c)(1)(ii) of the Rights in
;;; Technical Data and Computer Software clause at 52.227-7013.
;;;
;;;   TEXAS INSTRUMENTS INCORPORATED      
;;;   P.O. BOX 2909, M/S 2151             
;;;   AUSTIN, TEXAS 78769                 
;;;
;;; Copyright (C) 1989 Texas Instruments Incorporated.
;;; All rights reserved.

;;; Patch file for VIRTUAL-MEMORY version 6.2
;;; Written 10/02/89 12:35:09 by FISH,
;;; while running on DaVinci from band LOD2
;;; With SYSTEM 6.16, VIRTUAL-MEMORY 6.1, EH 6.5, MAKE-SYSTEM 6.0, MICRONET 6.0, LOCAL-FILE 6.0,
;;;  BASIC-PATHNAME 6.1, NETWORK-SUPPORT-COLD 6.0, BASIC-NAMESPACE 6.2, NETWORK-NAMESPACE 6.0,
;;;  DISK-IO 6.1, DISK-LABEL 6.0, BASIC-FILE 6.3, MAC-PATHNAME 6.0, NETWORK-PATHNAME 6.0,
;;;  COMPILER 6.12, TV 6.15, DATALINK 6.0, CHAOSNET 6.0, GC 6.3, MEMORY-AUX 6.0, NVRAM 6.1,
;;;  SYSLOG 6.1, STREAMER-TAPE 6.4, UCL 6.0, INPUT-EDITOR 6.0, METER 6.1, ZWEI 6.5,
;;;  DEBUG-TOOLS 6.3, NETWORK-SUPPORT 6.0, NETWORK-SERVICE 6.1, DATALINK-DISPLAYS 6.0,
;;;  FONT-EDITOR 6.1, SERIAL 6.0, PRINTER 6.3, MAC-PRINTER-TYPES 6.1, PRINTER-TYPES 6.1,
;;;  IMAGEN 6.0, SUGGESTIONS 6.0, MAIL-DAEMON 6.2, MAIL-READER 6.2, TELNET 6.0, VT100 6.0,
;;;  NAMESPACE-EDITOR 6.0, PROFILE 6.1, VISIDOC 6.4, TI-CLOS 6.20, CLEH 6.5, IP 3.47,
;;;  Experimental CLX 6.2, CLUE 6.10, X11M 6.13, Experimental BUG 11.15, Experimental SEYMOUR3 2.0,
;;;  Experimental SLAP 3.15,  microcode 465, Band Name: rel6 7/25 seymour

#!C
; From file PAGE.LISP#> MEMORY-MANAGEMENT; Hotel:
#8R SYSTEM#:
(COMPILER-LET ((*PACKAGE* (FIND-PACKAGE "SYSTEM"))
                          (SI:*LISP-MODE* :COMMON-LISP)
                          (*READTABLE* COMMON-LISP-READTABLE)
                          (SI:*READER-SYMBOL-SUBSTITUTIONS* *COMMON-LISP-SYMBOL-SUBSTITUTIONS*))
  (COMPILER#:PATCH-SOURCE-FILE "SYS: MEMORY-MANAGEMENT; PAGE.#"


(DEFUN page-in-words (start-address num-words)
  (UNLESS (ZEROP num-words)
    (WITHOUT-INTERRUPTS
      ;; Get pointer field as fixnum
      (SETQ start-address (%POINTER start-address))
      (DO ((addr
	     ;; Address of 1st page (must stay a fixnum)
	     (LOGAND (- page-size) start-address)
	     ;; Next page (must stay a fixnum)
	     (%MAKE-POINTER-OFFSET dtp-fix addr page-size))
	   ;; Loop controlled by N, which is NUM-WORDS plus number of
	   ;; words between page boundary and ADDRESS.  This
	   ;; guarantees we will touch all pages in the interval.
	   (n (+ num-words (LOGAND (1- page-size) start-address)) (- n page-size)))
	  ((NOT (PLUSP n)))
	;; Reference page to bring it in.
	(if (pointer-valid-p addr)
	    (%P-LDB 1 addr)
	    (FERROR nil "Invalid Address #x~16r in page-in-words" addr)) ))))
))
