;;; -*- Mode: Common-Lisp; Package: ZWEI; Base: 10.; Patch-File: T -*-

;;; Reason: Fixed GET-STUFF-FROM-DOC-SERVER to ignore errors trying to parse strings for ":". It was assuming this was a package prefix. May not always be the case.

;;;                           RESTRICTED RIGHTS LEGEND
;;;
;;; Use, duplication, or disclosure by the Government is subject to
;;; restrictions as set forth in subdivision (c)(1)(ii) of the Rights in
;;; Technical Data and Computer Software clause at 52.227-7013.
;;;
;;;   TEXAS INSTRUMENTS INCORPORATED      
;;;   P.O. BOX 2909, M/S 2151             
;;;   AUSTIN, TEXAS 78769                 
;;;
;;; Copyright (C) 1989 Texas Instruments Incorporated.
;;; All rights reserved.

;;; Written 08/24/89 13:27:26 by BERGER,
;;; while running on ARIES from band LOD1
;;; With SYSTEM 6.14, VIRTUAL-MEMORY 6.1, EH 6.4, MAKE-SYSTEM 6.0, MICRONET 6.0, LOCAL-FILE 6.0,
;;;  BASIC-PATHNAME 6.1, NETWORK-SUPPORT-COLD 6.0, BASIC-NAMESPACE 6.2, NETWORK-NAMESPACE 6.0,
;;;  DISK-IO 6.1, DISK-LABEL 6.0, BASIC-FILE 6.2, MAC-PATHNAME 6.0, NETWORK-PATHNAME 6.0,
;;;  COMPILER 6.10, TV 6.15, DATALINK 6.0, CHAOSNET 6.0, GC 6.3, MEMORY-AUX 6.0, NVRAM 6.1,
;;;  SYSLOG 6.1, STREAMER-TAPE 6.4, UCL 6.0, INPUT-EDITOR 6.0, METER 6.1, ZWEI 6.5,
;;;  DEBUG-TOOLS 6.3, NETWORK-SUPPORT 6.0, NETWORK-SERVICE 6.1, DATALINK-DISPLAYS 6.0,
;;;  FONT-EDITOR 6.1, SERIAL 6.0, PRINTER 6.3, MAC-PRINTER-TYPES 6.1, PRINTER-TYPES 6.1,
;;;  IMAGEN 6.0, SUGGESTIONS 6.0, MAIL-DAEMON 6.2, MAIL-READER 6.2, TELNET 6.0, VT100 6.0,
;;;  NAMESPACE-EDITOR 6.0, PROFILE 6.1, VISIDOC 6.2, TI-CLOS 6.20, CLEH 6.5, IP 3.47,
;;;  Experimental CLX 6.2, CLUE 6.10, X11M 6.13, Experimental BUG 11.15, DECNET 1.69,
;;;  VISIDOC-SERVER 6.0,  microcode 429, Band Name: Rel 6.0 + SLE 7/28

#!C
; From file CLIENT.LISP#> VISIDOC; SYS:
#10R ZWEI#:
(COMPILER-LET ((*PACKAGE* (FIND-PACKAGE "ZWEI"))
                          (SI:*LISP-MODE* :COMMON-LISP)
                          (*READTABLE* SYS:COMMON-LISP-READTABLE)
                          (SI:*READER-SYMBOL-SUBSTITUTIONS* SYS::*COMMON-LISP-SYMBOL-SUBSTITUTIONS*))
  (COMPILER#:PATCH-SOURCE-FILE "SYS: VISIDOC; CLIENT.#"
(DEFUN GET-STUFF-FROM-DOC-SERVER (stuff &OPTIONAL &KEY MANUAL NTH FORCED-GET)
  "Retrieves the text from the network server for online documentation and returns it. Parameters are:
STUFF = string to retrieve
:MANUAL = manual name from which to retrieve the information (:LISP, :IO, :NETWORK, etc)
:NTH = which item (if there are multiple items)
:FORCED-GET = read the information for STUFF even if there is a node already in the namespace (t)
                    (default is NIL)
Returns one of:
NIL if no item exists with the name STUFF;
Node instance if this item had been read in before and :FORCED-GET is nil;
LIST of object followed by strings and lists if it had not been read in before or :FORCED-GET is non-nil;
LIST of object followed by keyword :MULTIPLE-ATTRIBUTES if we can't determine 
  which of multiple definitions is requested. "
  (LET (OBJECT NODES INDEX more? ignr temp-stuff)  ; DAB 08-29-89
    (SETQ STUFF (STRING-TRIM '(#\SPACE) STUFF))
    (WHEN (AND (SETQ index (STRING-SEARCH-SET '(#\:) stuff))
	       (PLUSP index)
	       (FIND-PACKAGE (ignore-errors  ; DAB 08-24-89 Error can occur is this is a topic heading
                                             ; that may look like <<"(:Button [Button])" 
			       (READ-FROM-STRING stuff t nil :end index))))
      (SETQ temp-stuff (SUBSEQ stuff (1+ index))))
    (or (MULTIPLE-VALUE-SETQ (object ignr more?)
	  (NAME::FIND-OBJECT STUFF *DOC-NAMESPACE* manual))
	;;If we did not get it below, try it without the package perfix.
	(and temp-stuff  ; DAB 08-29-89
	     (MULTIPLE-VALUE-SETQ (object ignr more?)
	       (NAME::FIND-OBJECT temp-STUFF *DOC-NAMESPACE* manual))
	     (setf stuff temp-stuff)))
    (IF (AND object (NOT more?))
      (PROGN
	(IF FORCED-GET
	  (READ-REMOTE-OBJECT STUFF MANUAL NTH OBJECT)
	  (IF (SETQ NODES (NAME::GET-ATTRIBUTE-VALUE OBJECT :NODE))
	    (PROGN
	      (IF NTH
		(PROGN
		  (DOLIST (NODE NODES)
		    (IF (EQL NTH (SEND NODE :NTH))
		      (RETURN-FROM GET-STUFF-FROM-DOC-SERVER `(:node ,NODE))))
		  (RETURN-FROM GET-STUFF-FROM-DOC-SERVER
		     (READ-REMOTE-OBJECT STUFF MANUAL NTH OBJECT)))
		(IF (AND (= (LENGTH NODES) 1) (= (SEND (FIRST NODES) :MAX-NTH) 0))
		  (RETURN-FROM GET-STUFF-FROM-DOC-SERVER (CONS :node NODES))
		  (RETURN-FROM GET-STUFF-FROM-DOC-SERVER
		     (IF (= (LENGTH NODES) (1+ (SEND (FIRST NODES) :MAX-NTH)))
		       (LIST :nodes NODES)
		       (LIST :MULTIPLE-ATTRIBUTES OBJECT
			     (ENTRIES-ALIST STUFF (NAME::OBJECT-CLASS OBJECT))))))))
	    (READ-REMOTE-OBJECT STUFF MANUAL NTH))))
      (READ-REMOTE-OBJECT STUFF MANUAL NTH))))


))
