;;; -*- Mode: Common-Lisp; Package: User; Base: 10.; Patch-File: T -*-
;;; Patch file for WINDOW-MX version 5.34
;;; Reason: Simplify (mac:dr) and (mac:print-list) usage.
;;; Written 02/07/89 23:57:45 by GRENINGER,
;;; while running on MX23 from band TEST
;;; With SYSTEM 5.27, GC 5.4, VIRTUAL-MEMORY 5.5, MICRONET 5.5, MICRONET-COMM 5.13,
;;;  DISK-IO 5.9, BASIC-PATHNAME 5.4, MAC-PATHNAME 5.1, NETWORK-SUPPORT-COLD 5.1,
;;;  BASIC-NAMESPACE 5.8, BASIC-FILE 5.4, RPC 5.6, NFS 5.14, EH 5.3, MAKE-SYSTEM 5.3,
;;;  MEMORY-AUX 5.1, MACTOOLBOX 1.35, COMPILER 5.3, TV 5.24, NVRAM 5.1, UCL 5.0, INPUT-EDITOR 5.0,
;;;  METER 5.1, ZWEI 5.12, DEBUG-TOOLS 5.1, WINDOW-MX 5.31, PRINTER 5.12, MAC-PRINTER-TYPES 5.4,
;;;  Experimental NETWORK-PATHNAME 5.1, NETWORK-NAMESPACE 5.0, DATALINK 5.7, CHAOSNET 5.6,
;;;  Experimental NETWORK-SUPPORT 5.1, Experimental NETWORK-SERVICE 5.1, DATALINK-DISPLAYS 5.0,
;;;  NAMESPACE-EDITOR 5.1, IP 3.41, NFS-SERVER 5.3, PRINTER-TYPES 5.5, IMAGEN 5.2,
;;;  MAIL-DAEMON 5.6, MAIL-READER 5.6, TELNET 5.2, VT100 5.1, STREAMER-TAPE 5.7, DECNET 1.49,
;;;  VISIDOC 5.4, PROFILE 5.1, DISK-LABEL 5.1, Experimental MX-SERIAL 1.1,  microcode 96,
;;;  Band Name: NB22+1/8 patches

#!C
; From file FUNCTION-NAME.LISP#> WINDOW-MX; SYS:
#10R MACINTOSH#:
(COMPILER-LET ((*PACKAGE* (FIND-PACKAGE "MACINTOSH"))
                          (SI:*LISP-MODE* :COMMON-LISP)
                          (*READTABLE* SYS:COMMON-LISP-READTABLE)
                          (SI:*READER-SYMBOL-SUBSTITUTIONS* SYS::*COMMON-LISP-SYMBOL-SUBSTITUTIONS*))
  (COMPILER#:PATCH-SOURCE-FILE "SYS: WINDOW-MX; FUNCTION-NAME.#"


(DEFVAR *list-to-print* nil)
))

#!C
; From file FUNCTION-NAME.LISP#> WINDOW-MX; SYS:
#10R MACINTOSH#:
(COMPILER-LET ((*PACKAGE* (FIND-PACKAGE "MACINTOSH"))
                          (SI:*LISP-MODE* :COMMON-LISP)
                          (*READTABLE* SYS:COMMON-LISP-READTABLE)
                          (SI:*READER-SYMBOL-SUBSTITUTIONS* SYS::*COMMON-LISP-SYMBOL-SUBSTITUTIONS*))
  (COMPILER#:PATCH-SOURCE-FILE "SYS: WINDOW-MX; FUNCTION-NAME.#"


(DEFUN dr (&optional (debugging-classes-to-enable nil) and-return)
  "Reset debugging info."
  (LET ((c *calls*))
    (COND
      ((NULL debugging-classes-to-enable)  ; Turn debugging on, all classes enabled.
       (SETF *tracing-off* nil)
       (SETF *enabled-debugging-classes* *all-debugging-classes*)
       (SETF debugging-classes-to-enable t))
      ((EQ debugging-classes-to-enable t)  ; Turn debugging off but leave enabled
       (SETF *tracing-off* t)
       (SETF debugging-classes-to-enable nil))
      (t				   ; Turn debugging on, may specify one or
					   ; more classes to
       (WHEN (SYMBOLP debugging-classes-to-enable) ; enable.
	 (SETF debugging-classes-to-enable (LIST debugging-classes-to-enable)))
       (LOOP FOR debugging-class IN debugging-classes-to-enable
	     UNLESS (MEMBER debugging-class *all-debugging-classes*)
	     DO (FERROR nil "~a not a debugging-class-name" debugging-class))
       (SETF *tracing-off* nil)
       (SETF *enabled-debugging-classes* debugging-classes-to-enable)))
    ;;  Prevent the :fatal class of debug traces from ever being turned off...
    (UNLESS (MEMBER :fatal *enabled-debugging-classes*)
      (PUSH :fatal *enabled-debugging-classes*))
    ;;  If we must return *calls*'s contents, break the circular chain... 
    (WHEN and-return
      (RPLACD (NTHCDR (- *length-of-circular-list* 2) *calls*)  nil))
       ;;  Wipe out *calls* with a new circular list of NILs...
    (SETF *calls* (MAKE-LIST *length-of-circular-list*))
    (RPLACD (LAST *calls*) *calls*)
    ;;  Return the contents of *calls* if so requested...
    (WHEN and-return
      (SETF *list-to-print* c)
      (LOOP for e IN c counting e))))

))

#!C
; From file FUNCTION-NAME.LISP#> WINDOW-MX; SYS:
#10R MACINTOSH#:
(COMPILER-LET ((*PACKAGE* (FIND-PACKAGE "MACINTOSH"))
                          (SI:*LISP-MODE* :COMMON-LISP)
                          (*READTABLE* SYS:COMMON-LISP-READTABLE)
                          (SI:*READER-SYMBOL-SUBSTITUTIONS* SYS::*COMMON-LISP-SYMBOL-SUBSTITUTIONS*))
  (COMPILER#:PATCH-SOURCE-FILE "SYS: WINDOW-MX; FUNCTION-NAME.#"


(DEFUN print-list (&key (name "junk")
		     (filename (make-PATHNAME 
				  :defaults (rest (assoc si:local-host *default-pathname-defaults*))
				  :name name  :type "dr"))
		     (editor-p t)
		     (list-to-print *list-to-print*) length level)
  (LET ((*print-pretty* t) (*print-length* length) (*print-level* level) (i 0)
	universal-time real-list
	(s (IF editor-p (ZWEI:MAKE-FILE-BUFFER-STREAM FILENAME)
			 (OPEN filename :direction :output :if-exists
				    :new-version))))
    (UNWIND-PROTECT
	(PROGN
	  (WHEN editor-p (SEND s :delete-text) (CLOSE s) (SETF s (ZWEI:MAKE-FILE-BUFFER-STREAM FILENAME)))
	  (SEND s :line-out ";;; -*- Mode:Common-Lisp; Package:USER; Fonts:(CPTFONTB) -*-")
	  (LOOP for rest-of-list on list-to-print
		until (FIRST rest-of-list)
		finally
		(FORMAT t "
Printing a ~d entry list:" (LENGTH rest-of-list))
		(DOLIST (entry rest-of-list)
		  (WHEN entry
		    (SETF universal-time (FIRST entry)
			  real-list (REST entry))
		    (TYPECASE universal-time
		      (integer
		       (FORMAT t " ~d" (INCF i))
		       (FORMAT s "~%~%~%~%")
		       (time:print-universal-time universal-time s)
		       (FORMAT s "~%~s" real-list))
		      (t
		       (FORMAT t " ~d" (INCF i))
		       (FORMAT s "~%~%~%~%~s" entry)))))))
      ;; but always...
      (CLOSE s))))

))
