;;; -*- Mode: Common-Lisp; Package: User; Base: 10.; Patch-File: T -*-
;;; Written 02/13/89 10:45:47 by GRENINGER,
;;; Reason: Support TERM ctrl-S on an mX.
;;; while running on MX23 from band TEST
;;; With SYSTEM 5.27, GC 5.4, VIRTUAL-MEMORY 5.5, MICRONET 5.6, MICRONET-COMM 5.13,
;;;  DISK-IO 5.9, BASIC-PATHNAME 5.4, MAC-PATHNAME 5.1, NETWORK-SUPPORT-COLD 5.1,
;;;  BASIC-NAMESPACE 5.8, BASIC-FILE 5.5, RPC 5.6, NFS 5.16, EH 5.3, MAKE-SYSTEM 5.3,
;;;  MEMORY-AUX 5.1, MACTOOLBOX 1.35, COMPILER 5.3, Inconsistent TV 5.27, NVRAM 5.1,
;;;  UCL 5.0, INPUT-EDITOR 5.0, METER 5.1, ZWEI 5.12, DEBUG-TOOLS 5.1, Inconsistent WINDOW-MX 5.34,
;;;  PRINTER 5.12, MAC-PRINTER-TYPES 5.4, Experimental NETWORK-PATHNAME 5.1, NETWORK-NAMESPACE 5.0,
;;;  DATALINK 5.7, CHAOSNET 5.6, Experimental NETWORK-SUPPORT 5.1, Experimental NETWORK-SERVICE 5.1,
;;;  DATALINK-DISPLAYS 5.0, NAMESPACE-EDITOR 5.1, IP 3.41, NFS-SERVER 5.3, PRINTER-TYPES 5.5,
;;;  IMAGEN 5.3, MAIL-DAEMON 5.6, MAIL-READER 5.6, TELNET 5.2, VT100 5.1, STREAMER-TAPE 5.7,
;;;  DECNET 1.50, VISIDOC 5.4, PROFILE 5.1, DISK-LABEL 5.1, Experimental MX-SERIAL 1.1,
;;;   microcode 96, Band Name: NB22+1/8 patches

#!C
; From file MAC-WINDOWS.LISP#> WINDOW-MX; SYS:
#10R MACINTOSH#:
(COMPILER-LET ((*PACKAGE* (FIND-PACKAGE "MACINTOSH"))
                          (SI:*LISP-MODE* :COMMON-LISP)
                          (*READTABLE* SYS:COMMON-LISP-READTABLE)
                          (SI:*READER-SYMBOL-SUBSTITUTIONS* SYS::*COMMON-LISP-SYMBOL-SUBSTITUTIONS*))
  (COMPILER#:PATCH-SOURCE-FILE "SYS: WINDOW-MX; MAC-WINDOWS.#"



(DEFUN after-tv-initialized (&optional (cold-booting t))
  (LET (new-screens-descriptor new-ll width height needs-resizing
	 resize-screens-at-boot-p)
    (COND
      (*last-selected-exp-screens-id*		    ; Screens saved in band.
       ;;  Move all the deexposed screens' buffer arrays to the Mac, rebuilding
       ;;  the Mac's data structures on the way...
       (MULTIPLE-VALUE-SETQ (width height resize-screens-at-boot-p)
	 (SEND *mac* :GetScreenSize))
       (SETF needs-resizing nil)
       (SETF *last-selected-Exp-screens-ID* nil)
       (LOOP FOR i FROM 1 TO *largest-screen-id-ever-assigned*
	     FOR screen = (the-screen (AREF *Mac-resident-Explorer-screens* i))
	     WHEN screen DO
	     (restore-a-screens-bit-array-to-the-Mac screen i t)
	     (WHEN (OR (/= width (w:sheet-width screen))
		       (/= height (w:sheet-height screen)))
	       (SETF needs-resizing t))
	     (UNLESS *last-selected-Exp-screens-ID*
	       (SETF *last-selected-Exp-screens-ID* i)))
       ;;  Resize the existing screens to fit the Mac's preferred size, if necessary...
       (WHEN (AND needs-resizing resize-screens-at-boot-p)
	 (LOOP FOR i FROM *largest-screen-id-ever-assigned* DOWNTO 1
	       FOR screen = (the-screen (AREF *mac-resident-explorer-screens* i))
	       WHEN screen DO
	       (SETF w:mouse-sheet screen
		     w:default-screen screen)
	       (resize-screen i height width)))
       
       ;;  Make the lowest-numbered screen the default-screen...
       (SETF w:default-screen
	     (the-screen (AREF *mac-resident-explorer-screens*
			       *last-selected-Exp-screens-ID*)))

       ;;  Decide who should be the initial lisp listener...
       (SETF new-ll
	   (OR (LOOP FOR inferior IN (tv:sheet-inferiors w:default-screen)
		   WHEN (TYPEP inferior 'w:lisp-listener)
		   RETURN inferior)
	       (w:make-window 'w:lisp-listener
			  :superior w:default-screen
			  :process si:initial-process)))

       ;;  Expose the screens in reverse order so the default-screen stays on the mac's
             ;;  monitor...
       (LOOP for i from *largest-screen-id-ever-assigned* DOWNTO 1
	     FOR screen = (the-screen (AREF *mac-resident-explorer-screens* i))
	     WHEN screen
	     DO 
	     (SETF w:mouse-sheet screen)
	     (SEND screen :expose)))
      
      
      (t					    ; Clean restart.
       (IF (NULL (make-a-Mac-resident-Explorer-screen))
	   (si:%crash 25 #'after-tv-initialized nil))

       (SETF new-screens-descriptor
	   (AREF *mac-resident-explorer-screens* *last-selected-exp-screens-id*))
       (SETF w:default-screen (the-screen new-screens-descriptor))
       (COND (cold-booting
	    ;; Force new listener to be Listener #1
	    (SETF (GET 'w:lisp-listener 'tv:unnamed-window-instance-count) 0)
	    (SETF new-ll (w:make-window 'w:lisp-listener
			     :superior w:default-screen
			     :process si:initial-process)))
	   (t
	    (SETF new-ll (w:make-window 'w:lisp-listener
				  :superior w:default-screen))))))

    (WHEN (AND si:cold-booting (si:mx-p))
      (clean-up-explorer-windows))

    (FILL (THE array tv:*previously-selected-screens*) nil)
    (tv:setup-previously-selected-screens-array)

    ;;  Get this Mac's descriptions for all the standard fonts...
    (map-Lispm-fonts)
    (fixup-fonts)
    (SETF tv:initial-lisp-listener new-ll)
    (UNLESS cold-booting
      (SEND new-ll :select))))


(progn
  (FILL (THE array tv:*previously-selected-screens*) nil)
  (tv:setup-previously-selected-screens-array))
))

#!C
; From file MAC-WINDOWS.LISP#> WINDOW-MX; SYS:
#10R MACINTOSH#:
(COMPILER-LET ((*PACKAGE* (FIND-PACKAGE "MACINTOSH"))
                          (SI:*LISP-MODE* :COMMON-LISP)
                          (*READTABLE* SYS:COMMON-LISP-READTABLE)
                          (SI:*READER-SYMBOL-SUBSTITUTIONS* SYS::*COMMON-LISP-SYMBOL-SUBSTITUTIONS*))
  (COMPILER#:PATCH-SOURCE-FILE "SYS: WINDOW-MX; MAC-WINDOWS.#"



(DEFUN deactivate-Mac-screen (screen)
  (LET ((exp-screen-id (POSITION screen *mac-resident-explorer-screens*
				 :key #'mac:the-screen)))
    (send-adjust-screen-size
      Exp-screen-id (tv:Mac-explorer-window-id screen)
      0 0)			   ; Height = width = 0 ==> destroy!
    (SETF (AREF *Mac-resident-Explorer-screens* Exp-screen-id) nil)
    (deallocate-Mac-Explorer-screen-id Exp-screen-id)
    (tv:remove-from-previously-selected-screens screen)
    ;;  Completely forget about a "deactivated" screen's buffer array...
    (SETF *undisplaced-Mac-window-arrays*
          (DELETE screen *undisplaced-Mac-window-arrays*
	        :key #'REST :test 'EQ))))


))

#!C
; From file MAC-WINDOWS.LISP#> WINDOW-MX; SYS:
#10R MACINTOSH#:
(COMPILER-LET ((*PACKAGE* (FIND-PACKAGE "MACINTOSH"))
                          (SI:*LISP-MODE* :COMMON-LISP)
                          (*READTABLE* SYS:COMMON-LISP-READTABLE)
                          (SI:*READER-SYMBOL-SUBSTITUTIONS* SYS::*COMMON-LISP-SYMBOL-SUBSTITUTIONS*))
  (COMPILER#:PATCH-SOURCE-FILE "SYS: WINDOW-MX; MAC-WINDOWS.#"



(DEFUN select-a-screen (screen-id-or-screen-or-window)
  (LET (new-screen screen-id selected-window)
    ;;  Figure out the screen/id which we are selecting...
    (IF (NUMBERP screen-id-or-screen-or-window)
	(SETF screen-id-or-screen-or-window (ABS screen-id-or-screen-or-window)
	      new-screen (the-screen (AREF Mac::*Mac-resident-Explorer-screens*
				      screen-id-or-screen-or-window))
	      screen-id screen-id-or-screen-or-window)
      ;; else...
      (IF (TYPEP screen-id-or-screen-or-window 'mac-screen)
	  (LOOP FOR i FROM 0 TO *largest-screen-id-ever-assigned*
		WHEN (EQ screen-id-or-screen-or-window
			 (the-screen (AREF Mac::*Mac-resident-Explorer-screens* i)))
		DO
		(SETF new-screen screen-id-or-screen-or-window
		      screen-id i
		      selected-window (the-last-selected-window (AREF Mac::*Mac-resident-Explorer-screens* i))))
	;; else...
	(SETF new-screen (w:sheet-get-screen screen-id-or-screen-or-window)
	      screen-id (LOOP FOR i FROM 0 TO *largest-screen-id-ever-assigned*
			      WHEN (EQ new-screen
				       (the-screen (AREF Mac::*Mac-resident-Explorer-screens* i)))
			      RETURN i))))
    ;;  Now select it, if necessary...
    (UNLESS (AND w:selected-window
		 (EQ new-screen (w:sheet-get-screen w:selected-window)))
      (IF (mac-window-p new-screen)
	  (SETF *last-selected-Exp-screens-ID* screen-id))
      (WHEN w:mouse-sheet
	(toggle-mouse new-screen)
	(PROCESS-SLEEP 1))		   ; Let the mouse sheet change.
      (WHEN selected-window
	(SEND selected-window :select))
      (remember-call :selection w:mouse-sheet w:default-screen
		     *last-selected-Exp-screens-ID*)) t))


))

#!C
; From file MAC-WINDOWS.LISP#> WINDOW-MX; SYS:
#10R MACINTOSH#:
(COMPILER-LET ((*PACKAGE* (FIND-PACKAGE "MACINTOSH"))
                          (SI:*LISP-MODE* :COMMON-LISP)
                          (*READTABLE* SYS:COMMON-LISP-READTABLE)
                          (SI:*READER-SYMBOL-SUBSTITUTIONS* SYS::*COMMON-LISP-SYMBOL-SUBSTITUTIONS*))
  (COMPILER#:PATCH-SOURCE-FILE "SYS: WINDOW-MX; MAC-WINDOWS.#"



(DEFUN define-mac-resident-exp-screen (screen)
  "Called by tv:make-screen when it detects that a Mac-resident
Explorer screen is being defined."
  (DECLARE (SPECIAL Mac::Mac-Explorer-screen-ID-for-screen-being-created not-visible-p))
  (LET ((window-id (tv:Mac-Explorer-window-id screen))
	(inhibit-scheduling-flag t))
    (WHEN (EQ window-id t)
      (SETF window-id (give-a-window-an-id screen)))
    (PUSH (CONS (SEND screen :buffer) screen)
	  *undisplaced-Mac-window-arrays*)
    (SETF (AREF *Mac-resident-Explorer-screens*
		Mac-Explorer-screen-ID-for-screen-being-created)
	  (make-explorer-screen :the-screen screen))
    (send-adjust-screen-size
      Mac-Explorer-screen-ID-for-screen-being-created
      window-id
      (tv:sheet-width screen) (tv:sheet-height screen) (NOT not-visible-p))
    (SETF (AREF *is-the-bit-array-Mac-resident?* window-id) 1)
    (tv:add-to-previously-selected-screens screen) 
    (activate-Mac-window screen)))



))
