;;; -*- Mode: Common-Lisp; Package: User; Base: 10.; Patch-File: T -*-

;;; Reason: Don't clean up deactivated windows when reorganizing the bitmap cache.  Pad the
;;; ACB size used by :GetModifiedRectangles to protect against the Mac destroying the
;;; next ACB because it has more bitmaps in its cache than the mX thinks it does.
;;; (SPRs 9854 and 9917)

;;;                           RESTRICTED RIGHTS LEGEND
;;;
;;; Use, duplication, or disclosure by the Government is subject to
;;; restrictions as set forth in subdivision (c)(1)(ii) of the Rights in
;;; Technical Data and Computer Software clause at 52.227-7013.
;;;
;;;   TEXAS INSTRUMENTS INCORPORATED      
;;;   P.O. BOX 2909, M/S 2151             
;;;   AUSTIN, TEXAS 78769                 
;;;
;;; Copyright (C) 1989 Texas Instruments Incorporated.
;;; All rights reserved.

;;; Written 06/12/89 09:03:47 by GRENINGER,
;;; while running on MX23 from band P526
;;; With SYSTEM 6.5, GC 6.2, VIRTUAL-MEMORY 6.1, MICRONET 6.0, MICRONET-COMM 6.0,
;;;  DISK-IO 6.0, DISK-LABEL 6.0, BASIC-PATHNAME 6.0, MAC-PATHNAME 6.0, NETWORK-SUPPORT-COLD 6.0,
;;;  BASIC-NAMESPACE 6.0, BASIC-FILE 6.1, RPC 6.1, NFS 6.0, EH 6.1, MAKE-SYSTEM 6.0,
;;;  MEMORY-AUX 6.0, COMPILER 6.2, TV 6.6, NVRAM 6.0, UCL 6.0, INPUT-EDITOR 6.0, MACTOOLBOX 2.0,
;;;  METER 6.0, ZWEI 6.0, DEBUG-TOOLS 6.0, WINDOW-MX 6.1, PRINTER 6.1, MAC-PRINTER-TYPES 6.1,
;;;  CLIPBOARD 6.0, NETWORK-PATHNAME 6.0, NETWORK-NAMESPACE 6.0, DATALINK 6.0, CHAOSNET 6.0,
;;;  NETWORK-SUPPORT 6.0, NETWORK-SERVICE 6.0, DATALINK-DISPLAYS 6.0, MX-DATALINK 6.0,
;;;  NAMESPACE-EDITOR 6.0, IP 3.46, NFS-SERVER 6.0, MX-SERIAL 6.0, PRINTER-TYPES 6.0,
;;;  IMAGEN 6.0, MAIL-DAEMON 6.2, MAIL-READER 6.0, TELNET 6.0, VT100 6.0, STREAMER-TAPE 6.0,
;;;  DECNET 1.67, VISIDOC 6.0, PROFILE 6.1, TI-CLOS 6.5, CLEH 6.0, CLX 6.0, CLUE 6.0,
;;;  Experimental BUG 11.7,  microcode 137, Band Name: Release 6.0 mx 5/26

#!C
; From file MAC-MESSAGES.LISP#> WINDOW-MX; MR-X:
#10R MACINTOSH#:
(COMPILER-LET ((*PACKAGE* (FIND-PACKAGE "MACINTOSH"))
                          (SI:*LISP-MODE* :COMMON-LISP)
                          (*READTABLE* SYS:COMMON-LISP-READTABLE)
                          (SI:*READER-SYMBOL-SUBSTITUTIONS* SYS::*COMMON-LISP-SYMBOL-SUBSTITUTIONS*))
  (COMPILER#:PATCH-SOURCE-FILE "SYS: WINDOW-MX; MAC-MESSAGES.#"


(DEFUN print-modified-rectangles (&optional dump-p (stream t))
  (LET* (nbytes-free-space acb-image16 acb-image32 start-of-free-space)
    (SETF nbytes-free-space (get-modified-rectangles))
    (SETF acb-image16 *modified-rectangles*)
    (SETF start-of-free-space (- *total-mac-bit-array-cache-size* nbytes-free-space))
    (WHEN dump-p
      (SETF acb-image32 (MAKE-ARRAY (FLOOR (LENGTH acb-image16) 2)
				  :element-type '(unsigned-byte 32)
				  :displaced-to acb-image16))
      (FORMAT stream "~% ~8,'0x" (AREF acb-image32 10))
      (LOOP for ii from 1 to *n-descriptors*
	    for i32 from 11 by 4
	    do
	    (FORMAT stream "~% ~8,'0x ~8,'0x ~8,'0x ~8,'0x "
		(AREF acb-image32 (+ i32 0)) (AREF acb-image32 (+ i32 1))
		(AREF acb-image32 (+ i32 2)) (AREF acb-image32 (+ i32 3)))
	    finally (FORMAT t "~%")))

    
    (FORMAT stream "~%(~d descriptors, ~d bytes of free space starting at ~d)"
	    *n-descriptors* nbytes-free-space start-of-free-space)
    (LOOP for ii from 1 to *n-descriptors*
	  for i32 from 11 by 4
	  for i16 = (LSH i32 1)
	  for wid = (LSH (AREF acb-image16 (+ i16 1)) -8)
	  for macs-displ = (LOGAND #xFFFFFF (+ (ASH (AREF acb-image16 (+ i16 1)) 16)
					  (AREF acb-image16 i16)))
	  for time-of-last-update = (+ (ASH (AREF acb-image16 (+ i16 3)) 16)
				       (AREF acb-image16 (+ i16 2)))
	  for top = (AREF acb-image16 (+ i16 5))
	  for left = (AREF acb-image16 (+ i16 4))
	  for bottom = (AREF acb-image16 (+ i16 7))
	  for right = (AREF acb-image16 (+ i16 6))
	  for window = (AREF *all-windows-and-screens* wid)
	  for size = (IF window (* (CEILING (tv:sheet-width window) 8) (tv:sheet-height window)) 0)
	  do
	  (FORMAT stream "~%~s
     WID= ~3d.  Updated at ~d.  Modified rect = (~3d,~3d) (~4d,~3d).  Cache locations ~6d to ~6d."
		  window WID time-of-last-update top left bottom right macs-displ (+ macs-displ size)))))
))

#!C
; From file MAC-MESSAGES.LISP#> WINDOW-MX; MR-X:
#10R MACINTOSH#:
(COMPILER-LET ((*PACKAGE* (FIND-PACKAGE "MACINTOSH"))
                          (SI:*LISP-MODE* :COMMON-LISP)
                          (*READTABLE* SYS:COMMON-LISP-READTABLE)
                          (SI:*READER-SYMBOL-SUBSTITUTIONS* SYS::*COMMON-LISP-SYMBOL-SUBSTITUTIONS*))
  (COMPILER#:PATCH-SOURCE-FILE "SYS: WINDOW-MX; MAC-MESSAGES.#"


(DEFUN acquire-Nbytes-of-cache-space (nbytes-to-acquire)
  (LET* (nbytes-free-space acb-image16)
    (SETF nbytes-free-space (get-modified-rectangles))
    (SETF acb-image16 *modified-rectangles*)
    (LOOP with nbytes-acquired = nbytes-free-space
	  when (>= nbytes-acquired nbytes-to-acquire) return t
	  for oldest-dbase =
	  (LOOP with oldest-age = #x10000000 and oldest-dbase
		for i from 1 to *n-descriptors*
		for dbase from 22 by 8
		for age = (+ (ASH (AREF acb-image16 (+ dbase 3)) 16)
			     (AREF acb-image16 (+ dbase 2)))
		for wid = (LSH (AREF acb-image16 (+ dbase 1)) -8)
		for window = (AREF *all-windows-and-screens* wid)
		when (AND (< age oldest-age) window
			  (NOT (TYPEP window 'mac-screen))
			  (NOT (LOOP for sup first tv:selected-window then
				     (tv:sheet-superior sup)
				     until (NULL sup)
				     when (EQ window tv:selected-window)
				     do; (FORMAT t "~%~s rejected #1." window)
				     (RETURN t)))
			  (NOT (LOOP for sup first window then
				     (tv:sheet-superior sup)
				     until (NULL sup)
				     when (EQ sup tv:selected-window)
				     do; (FORMAT t "~%~s rejected #2." window)
				     (RETURN t)))
			  )
		do
		(SETF oldest-age age)
		(SETF oldest-dbase dbase)
		finally (RETURN oldest-dbase))
	  when (NULL oldest-dbase) return NIL
	  for oldest-wid = (LSH (AREF acb-image16 (+ oldest-dbase 1)) -8)
	  for oldest-window = (AREF *all-windows-and-screens* oldest-wid)
	  when (NULL oldest-window)
	  do
	  (LET ((si:cold-load-stream-owns-keyboard t)
		  (*terminal-io* si:cold-load-stream))
	      (eh:save-screen-for-cold-load-stream t)
	      (CERROR "Proceed, throwing away recent updates for window-id ~d"
		      "Mac has bitarray cached for window-id ~d not currently assigned to a window"
		      oldest-wid)
	      (eh:restore-screen-for-cold-load-stream))
	  (SEND *mac* :deallocatebitarray oldest-wid)
	  (SETF (AREF acb-image16 (+ oldest-dbase 2)) 0
		(AREF acb-image16 (+ oldest-dbase 3)) #x1000)
	  (SETF nbytes-acquired (get-modified-rectangles))
	  (SETF acb-image16 *modified-rectangles*)
	  else do
#|
	  (WITH-STACK-LIST (modified-area-descriptor (AREF acb-image16 (+ oldest-dbase 5))
						     (AREF acb-image16 (+ oldest-dbase 4))
						     (AREF acb-image16 (+ oldest-dbase 7))
						     (AREF acb-image16 (+ oldest-dbase 6)))
|#
          (WITH-STACK-LIST (modified-area-descriptor 0 0 (tv:sheet-width oldest-window) (tv:sheet-height oldest-window))
	    (retrieve-a-bit-array-from-the-Mac oldest-window modified-area-descriptor))
	  (INCF nbytes-acquired (* (CEILING (tv:sheet-width oldest-window) 8) (tv:sheet-height oldest-window)))
	  (SETF (AREF acb-image16 (+ oldest-dbase 2)) 0
		(AREF acb-image16 (+ oldest-dbase 3)) #x1000))))
))

#!C
; From file MAC-MESSAGES.LISP#> WINDOW-MX; MR-X:
#10R MACINTOSH#:
(COMPILER-LET ((*PACKAGE* (FIND-PACKAGE "MACINTOSH"))
                          (SI:*LISP-MODE* :COMMON-LISP)
                          (*READTABLE* SYS:COMMON-LISP-READTABLE)
                          (SI:*READER-SYMBOL-SUBSTITUTIONS* SYS::*COMMON-LISP-SYMBOL-SUBSTITUTIONS*))
  (COMPILER#:PATCH-SOURCE-FILE "SYS: WINDOW-MX; MAC-MESSAGES.#"


(DEFUN reorganize-bit-array-cache (nbytes-of-cache-needed)
  (LET (true-mouse-cursor)
    ;;  Change the Mac's mouse cursor to the watch while we thrash bitmaps...
    (SETF true-mouse-cursor tv:mouse-blinker)
    (SEND *mac* :set-mouse-blinker (- 4 mac-mouse-cursor-offset))
    (IF (< (get-modified-rectangles) nbytes-of-cache-needed)
	(IF (acquire-nbytes-of-cache-space nbytes-of-cache-needed)
	    (get-modified-rectangles)
	   ;; else...
	  (retrieve-all-bit-arrays-from-the-mac)))
    ;;  Restore the Mac's mouse cursor to what the Explorer thinks it is...
    (WHEN (TYPEP (tv:blinker-sheet true-mouse-cursor) '(OR mac-window mac-screen))
      (SEND true-mouse-cursor :create-Mac-image-of-Explorer-mouse-cursor nil nil))))

))

#!C
; From file BASIC-COMM-METHODS.LISP#> WINDOW-MX; MR-X:
#10R MACINTOSH#:
(COMPILER-LET ((*PACKAGE* (FIND-PACKAGE "MACINTOSH"))
                          (SI:*LISP-MODE* :COMMON-LISP)
                          (*READTABLE* SYS:COMMON-LISP-READTABLE)
                          (SI:*READER-SYMBOL-SUBSTITUTIONS* SYS::*COMMON-LISP-SYMBOL-SUBSTITUTIONS*))
  (COMPILER#:PATCH-SOURCE-FILE "SYS: WINDOW-MX; BASIC-COMM-METHODS.#"


(DEFMETHOD (mac-flavor :GetModifiedRectangles)
	   (&aux (add:*no-interrupt* inhibit-scheduling-flag))
  (LET (acb n-windows-with-mac-resident-bitmaps acb-image)
    (SETF n-windows-with-mac-resident-bitmaps
	  (LOOP for (ARRAY . window) in *undisplaced-mac-window-arrays*
		for wid = (tv:sheet-window-id window)
		count (AND (INTEGERP wid)
			   (NOT (AREF *has-the-Mac-forgotten-my-redirection?* wid)))))
    (SETF acb (add:get-acb-fast (+ 4 (* 16 n-windows-with-mac-resident-bitmaps) 128)))
    (SETF (add:opcode acb) #x08)
    (add:transmit-packet-and-wait acb channel)
    (SETF acb-image (MAKE-ARRAY (ARRAY-TOTAL-SIZE acb) :element-type '(unsigned-byte 16)))
    (COPY-ARRAY-CONTENTS acb acb-image)
    (add:return-acb acb t)
    acb-image))

))
