;;; -*- Mode: Common-Lisp; Package: User; Base: 10.; Patch-File: T -*-

;;; Reason: Make si:during-cold-boot do nothing if si:cold-booting is NIL
;;; so all window images can be preserved across a warm boot [SPR 9990].

;;;                           RESTRICTED RIGHTS LEGEND
;;;
;;; Use, duplication, or disclosure by the Government is subject to
;;; restrictions as set forth in subdivision (c)(1)(ii) of the Rights in
;;; Technical Data and Computer Software clause at 52.227-7013.
;;;
;;;   TEXAS INSTRUMENTS INCORPORATED      
;;;   P.O. BOX 2909, M/S 2151             
;;;   AUSTIN, TEXAS 78769                 
;;;
;;; Copyright (C) 1989 Texas Instruments Incorporated.
;;; All rights reserved.

;;; Written 06/29/89 13:01:24 by GRENINGER,
;;; while running on MX23 from band P608
;;; With SYSTEM 6.9, GC 6.3, VIRTUAL-MEMORY 6.1, MICRONET 6.0, MICRONET-COMM 6.1,
;;;  DISK-IO 6.0, DISK-LABEL 6.0, BASIC-PATHNAME 6.0, MAC-PATHNAME 6.0, NETWORK-SUPPORT-COLD 6.0,
;;;  BASIC-NAMESPACE 6.1, BASIC-FILE 6.2, RPC 6.1, NFS 6.0, EH 6.3, MAKE-SYSTEM 6.0,
;;;  MEMORY-AUX 6.0, COMPILER 6.6, TV 6.11, NVRAM 6.1, UCL 6.0, INPUT-EDITOR 6.0,
;;;  MACTOOLBOX 2.3, METER 6.0, ZWEI 6.3, DEBUG-TOOLS 6.3, Inconsistent WINDOW-MX 6.4,
;;;  PRINTER 6.1, MAC-PRINTER-TYPES 6.1, CLIPBOARD 6.0, NETWORK-PATHNAME 6.0, NETWORK-NAMESPACE 6.0,
;;;  DATALINK 6.0, CHAOSNET 6.0, NETWORK-SUPPORT 6.0, NETWORK-SERVICE 6.1, DATALINK-DISPLAYS 6.0,
;;;  MX-DATALINK 6.1, NAMESPACE-EDITOR 6.0, IP 3.47, NFS-SERVER 6.0, MX-SERIAL 6.0,
;;;  PRINTER-TYPES 6.0, IMAGEN 6.0, MAIL-DAEMON 6.2, MAIL-READER 6.0, TELNET 6.0,
;;;  VT100 6.0, STREAMER-TAPE 6.3, DECNET 1.69, VISIDOC 6.2, PROFILE 6.1, TI-CLOS 6.9,
;;;  CLEH 6.4, Experimental CLX 6.1, CLUE 6.5, Experimental BUG 11.10,  microcode 138,
;;;  Band Name: Rel 6.0 mxnet 6/8

#!C
; From file MAC-WINDOWS.LISP#> WINDOW-MX; SYS:
#10R MACINTOSH#:
(COMPILER-LET ((*PACKAGE* (FIND-PACKAGE "MACINTOSH"))
                          (SI:*LISP-MODE* :COMMON-LISP)
                          (*READTABLE* SYS:COMMON-LISP-READTABLE)
                          (SI:*READER-SYMBOL-SUBSTITUTIONS* SYS::*COMMON-LISP-SYMBOL-SUBSTITUTIONS*))
  (COMPILER#:PATCH-SOURCE-FILE "SYS: WINDOW-MX; MAC-WINDOWS.#"


(DEFUN si:during-cold-boot ()
  "This should be on the cold-initialization-list of bands saved with the
Mac window system loaded."
  (UNLESS si:cold-booting
    (RETURN-FROM si:during-cold-boot))
  (SETF tv:*set-mouse-to-selected-screen* nil)
  (SETF *ignore-commands-for-the-mac* nil)
  (SETF tv:initial-lisp-listener nil)
  (SETQ *mac-keyboard-p* t)
  (FILL (THE array tv:mouse-buttons-buffer) 0)
  (setup-basic-comm)
  (SETF *total-mac-bit-array-cache-size*
        (get-total-cache-size))
  
  ;;  Reset all the resource allocation controls for Mac-Explorer windows and screens.
;;;  (SETF *list-of-free-window-ids* nil
;;;	*largest-window-id-ever-assigned* -1)
;;;  (SETF *list-of-free-screen-ids* nil
;;;	*largest-screen-id-ever-assigned* 0)

;;;  (SETF *old-previously-selected-windows* 
;;;            (COPY tv:previously-selected-windows)
;;;	*old-mac-resident-explorer-screens*
;;;	    (COPY *mac-resident-explorer-screens*))

;;;  (SETF *mac-resident-explorer-screens* 
;;;	    (MAKE-ARRAY (1+ ages-array-size)))
;;;  (SETF *undisplaced-mac-window-arrays* nil) 

  ;;  Reset our data structures to say there are NO windows on the Mac...
  (FILL (THE array *is-the-bit-array-Mac-resident?*) 0)
  (mac:remember-call :warm  *largest-window-id-ever-assigned*)
  (LOOP for window-id from 0 to *largest-window-id-ever-assigned*
	when (AND (AREF *all-windows-and-screens* window-id)
		  (NULL (AREF *has-the-Mac-forgotten-my-redirection?* window-id)))
	do (SETF (AREF *has-the-Mac-forgotten-my-redirection?* window-id)
		 (AREF *all-windows-and-screens* window-id)))
  ;;  Create a descriptor for the Explorer's monitor...
  (COND ((si:mx-p)
	 (SETF (AREF *mac-resident-explorer-screens* 0)
	       (make-explorer-screen
		 :the-screen nil
		 :the-last-selected-window nil)))
	(t				   ;lashup
	 (SETF (AREF *mac-resident-explorer-screens* 0)
	       (make-explorer-screen
		 :the-screen w:main-screen
		 :the-last-selected-window
		 (LOOP for w in (SEND tv:main-screen :inferiors)
		       do (WHEN (TYPEP w 'w:lisp-listener)
			    (RETURN w)))))))
  ;; (delete :mouse mac:*all-debugging-classes*)
  ;; (mac:dr)
;;  (mac:remember-call :fatal
;;		 (listarray mac:*all-windows-and-screens*)
;;		 (listarray mac:*has-the-Mac-forgotten-my-redirection?*)
;;		 (listarray mac:*is-the-bit-array-Mac-resident?*))
  )

))
