;;; -*- Mode:Common-Lisp; Package:USER; Base:10; Patch-file:T; Fonts:(COURIER HL12B HL12BI COURIER MEDFNB) -*-
;;; Written 07/27/89 10:09:40 by GRENINGER,
;;; Reason: Guarantee the Explorer-side always knows the state of the Mac-side
;;; bit-array cache without having to continually ask. [SPR 10194]
;;; while running on MX23 from band G719
;;; With SYSTEM 6.14, GC 6.3, VIRTUAL-MEMORY 6.1, MICRONET 6.0, MICRONET-COMM 6.1,
;;;  DISK-IO 6.1, DISK-LABEL 6.0, BASIC-PATHNAME 6.1, MAC-PATHNAME 6.0, NETWORK-SUPPORT-COLD 6.0,
;;;  BASIC-NAMESPACE 6.2, BASIC-FILE 6.2, RPC 6.1, NFS-MX 6.1, EH 6.4, MAKE-SYSTEM 6.0,
;;;  MEMORY-AUX 6.0, COMPILER 6.10, TV 6.15, NVRAM 6.1, UCL 6.0, INPUT-EDITOR 6.0,
;;;  MACTOOLBOX 2.3, METER 6.1, ZWEI 6.5, DEBUG-TOOLS 6.3, WINDOW-MX 6.5, PRINTER 6.3,
;;;  MAC-PRINTER-TYPES 6.1, CLIPBOARD 6.1, TI-CLOS 6.20, CLEH 6.5, NETWORK-PATHNAME 6.0,
;;;  NETWORK-NAMESPACE 6.0, DATALINK 6.0, CHAOSNET 6.0, NETWORK-SUPPORT 6.0, NETWORK-SERVICE 6.1,
;;;  DATALINK-DISPLAYS 6.0, MX-DATALINK 6.1, NAMESPACE-EDITOR 6.0, IP 3.47, NFS-MX-SERVER 6.0,
;;;  MX-SERIAL 6.1, PRINTER-TYPES 6.1, IMAGEN 6.0, MAIL-DAEMON 6.2, MAIL-READER 6.2,
;;;  TELNET 6.0, VT100 6.0, STREAMER-TAPE 6.4, DECNET 1.69, VISIDOC 6.2, PROFILE 6.1,
;;;   microcode 138, Band Name: microExplorer Network (6/29)

#!C
; From file VARIABLES.LISP#> WINDOW-MX; MR-X:
#10R MACINTOSH#:
(COMPILER-LET ((*PACKAGE* (FIND-PACKAGE "MACINTOSH"))
                          (SI:*LISP-MODE* :COMMON-LISP)
                          (*READTABLE* SYS:COMMON-LISP-READTABLE)
                          (SI:*READER-SYMBOL-SUBSTITUTIONS* SYS::*COMMON-LISP-SYMBOL-SUBSTITUTIONS*))
  (COMPILER#:PATCH-SOURCE-FILE "SYS: WINDOW-MX; VARIABLES.#"


(DEFVAR *emulated-cache* (LIST (LIST 0 0))
  "A list of cache-entries, one for each allocated chunk of cache.  First entry is junk for
easier updating.")

))

#!C
; From file DEFINITIONS.LISP#> WINDOW-MX; MR-X:
#10R MACINTOSH#:
(COMPILER-LET ((*PACKAGE* (FIND-PACKAGE "MACINTOSH"))
                          (SI:*LISP-MODE* :COMMON-LISP)
                          (*READTABLE* SYS:COMMON-LISP-READTABLE)
                          (SI:*READER-SYMBOL-SUBSTITUTIONS* SYS::*COMMON-LISP-SYMBOL-SUBSTITUTIONS*))
  (COMPILER#:PATCH-SOURCE-FILE "SYS: WINDOW-MX; DEFINITIONS.#"



(DEFUN figure-out-redirection (screen-array-of-window)

  (LET (array-displaced-to offset array-and-window window window-id
	(list-of-undisplaced-Mac-window-arrays *undisplaced-Mac-window-arrays*))

    ;;  Get the ultimately-displaced-to-array first...
    (MULTIPLE-VALUE-SETQ (array-displaced-to offset)
      (chase-displaced-pointers screen-array-of-window))

    ;;  See it if is the buffer of a Mac-resident screen or
    ;;  the bit-array of a window possessing a Mac-resident bit array...
    (SETF array-and-window
	  (ASSOC array-displaced-to list-of-undisplaced-Mac-window-arrays :test 'EQ))
    
    ;;
    (IF array-and-window
      (MULTIPLE-VALUE-BIND (y-offset x-offset)
	  (FLOOR offset (ARRAY-DIMENSION array-displaced-to 1))
	(SETF window (REST array-and-window)
	      window-id (tv:Mac-explorer-window-id window))
	(WHEN (EQ window-id t)
	  (SETF window-id (give-a-window-an-id window)))
	(VALUES window-id x-offset y-offset))
      ;; else...
      (VALUES screen-array-of-window 0 0))))


(WHEN (FDEFINEDP 'setup-this-window-on-the-mac)
  (FUNDEFINE 'setup-this-window-on-the-mac))

))



#!C
; From file DEFINITIONS.LISP#> WINDOW-MX; MR-X:
#10R MACINTOSH#:
(COMPILER-LET ((*PACKAGE* (FIND-PACKAGE "MACINTOSH"))
                          (SI:*LISP-MODE* :COMMON-LISP)
                          (*READTABLE* SYS:COMMON-LISP-READTABLE)
                          (SI:*READER-SYMBOL-SUBSTITUTIONS* SYS::*COMMON-LISP-SYMBOL-SUBSTITUTIONS*))
  (COMPILER#:PATCH-SOURCE-FILE "SYS: WINDOW-MX; DEFINITIONS.#"


(DEFSTRUCT (cache-entry (:type list)) start-adr nbytes wid)


;;; ab 1/6/88
;;; These used to be in obsolete REDEFINE-%-PRIMITIVES file.


))

#!C
; From file MAC-WINDOWS.LISP#> WINDOW-MX; MR-X:
#10R MACINTOSH#:
(COMPILER-LET ((*PACKAGE* (FIND-PACKAGE "MACINTOSH"))
                          (SI:*LISP-MODE* :COMMON-LISP)
                          (*READTABLE* SYS:COMMON-LISP-READTABLE)
                          (SI:*READER-SYMBOL-SUBSTITUTIONS* SYS::*COMMON-LISP-SYMBOL-SUBSTITUTIONS*))
  (COMPILER#:PATCH-SOURCE-FILE "SYS: WINDOW-MX; MAC-WINDOWS.#"


(DEFUN emulate-cache-initialization (total-cache-size)
  (SETF *emulated-cache*
	(LIST (LIST total-cache-size total-cache-size)
	      (make-cache-entry :start-adr total-cache-size
				:nbytes 0
				:wid -1)))
  (SETF *nbytes-free-space* total-cache-size))


(DEFUN emulate-cache-deallocation
       (window-id &aux (old-free-space *nbytes-free-space*))
  (LOOP for entries on *emulated-cache*
	for entry = (SECOND entries)
	until (NULL entry)
	when (= (cache-entry-wid entry) window-id) do
	(INCF *nbytes-free-space* (cache-entry-nbytes entry))
	(RPLACD entries (CDDR entries))  
	(remember-call :rects old-free-space *nbytes-free-space*
		       (cache-entry-nbytes entry)) 
	(RETURN))
  *nbytes-free-space*)
    

(DEFUN emulate-cache-compaction ()
  (LOOP with end-last-entry = 0
	with old-free-space = *nbytes-free-space*
	for entries on (REST *emulated-cache*)
	for entry = (FIRST entries)
	until (NULL (SECOND entries))
	do
	(WHEN (> (cache-entry-start-adr entry) end-last-entry)
	  (SETF (cache-entry-start-adr entry) end-last-entry))
	(SETF end-last-entry (+ (cache-entry-start-adr entry)
				(cache-entry-nbytes entry)))
	finally
	(SETF *nbytes-free-space* (- *total-mac-bit-array-cache-size*
				     end-last-entry))
	(remember-call :rects old-free-space *nbytes-free-space*)
	(RETURN *nbytes-free-space*)))


(DEFUN emulate-cache-allocation (window-id new-width new-height)
  "Returns T if able to allocate, else returns nil."
  (LET ((size-needed (* (CEILING new-width 16) 2 new-height))
	(old-free-space *nbytes-free-space*))
    (remember-call :rects *emulated-cache*)
    (LOOP with end-of-previous-entry = 0 and success-p
	  and old-entry-entries and hole-entries
	  for last-entries first *emulated-cache* then entries
	  for entries = (REST last-entries)
	  for entry = (FIRST entries)
	  until (NULL entry)
	  do
	  
	  (WHEN (= (cache-entry-wid entry) window-id)
	    (IF (= (cache-entry-nbytes entry) size-needed)
		;;  If ENTRY is window-id's existing entry and is exactly the size
		;;  needed, do nothing, just return T...
		(RETURN t)
	      
	      ;;  ...else ENTRY is not the right size, so remember it for later.
	      ;;  We'll delete it if we can successfully allocate a new entry...
	      (SETF old-entry-entries last-entries)))
	  
	  ;;  Check the hole in front of ENTRY.  If big enough, and we
	  ;;  haven't allocated space for WINDOW-ID yet, remember it for doing
	  ;;  so...
	  (WHEN (AND (NULL hole-entries)
		     (>= (- (cache-entry-start-adr entry) end-of-previous-entry)
			 size-needed))
	    (SETF hole-entries last-entries))
	  
	  ;;  Always remember where the start of the next hole is...
	  (SETF end-of-previous-entry (+ (cache-entry-start-adr entry)
					 (cache-entry-nbytes entry)))
	  
	  finally
	  
	  (remember-call :rects success-p old-free-space *nbytes-free-space* size-needed)
	  (WHEN hole-entries
	    ;;  Now allocate an entry of size-needed
	    (SETF entry (FIRST hole-entries))
	    (RPLACD hole-entries
		    (CONS (make-cache-entry
			    :start-adr (+ (cache-entry-start-adr entry)
					  (cache-entry-nbytes entry))
			    :nbytes size-needed
			    :wid window-id)
			  (REST hole-entries)))
	    (DECF *nbytes-free-space* size-needed)

	    ;;  If successful in allocating a new entry and found an old entry for
	    ;;  WINDOW-ID, delete it...
	    (WHEN old-entry-entries
	      ;;  In case we just added an entry in front of the one we planned to
	      ;;  delete, make sure we delete the right entry...
	      (WHEN (EQ old-entry-entries hole-entries)
		(SETF old-entry-entries (REST old-entry-entries)))
	      (INCF *nbytes-free-space*
		    (cache-entry-nbytes (SECOND old-entry-entries)))
	      (RPLACD old-entry-entries (CDDR old-entry-entries)))
	    (RETURN t))
	  
	  ;;  We couldn't allocate an entry, yet total free space is sufficient,
	  ;;  so compact the cache and try again...
	  (WHEN (>= *nbytes-free-space* size-needed)
	    (emulate-cache-compaction)
	    (SETF success-p (emulate-cache-allocation window-id new-width new-height)))
	  
	  (RETURN success-p))))


;;;
;;;  Initialize the emulated cache from the last info given us by the Mac...
;;;
(DEFUN believe-the-mac ()
  (emulate-cache-initialization *total-mac-bit-array-cache-size*)
  (LOOP with acb-image16 = *modified-rectangles*
	for ii from 0
	for i32 from 11 by 4
	for i16 = (LSH i32 1)
	for wid = (LSH (AREF acb-image16 (+ i16 1)) -8)
	for macs-displ = (LOGAND #xffffff (+ (ASH (AREF acb-image16 (+ i16 1)) 16)
					     (AREF acb-image16 i16)))
	for time-of-last-update = (+ (ASH (AREF acb-image16 (+ i16 3)) 16)
				     (AREF acb-image16 (+ i16 2)))
	for window = (AREF *all-windows-and-screens* wid)
	for size = (IF window (* (CEILING (tv:sheet-width window) 16) 2
				 (tv:sheet-height window)) 0)
	until (AND (ZEROP wid) (ZEROP macs-displ) (ZEROP time-of-last-update)) do
	(emulate-cache-allocation
	  wid (tv:sheet-width window) (tv:sheet-height window)))
  *emulated-cache*)

))

#!C
; From file BASIC-COMM-METHODS.LISP#> WINDOW-MX; MR-X:
#10R MACINTOSH#:
(COMPILER-LET ((*PACKAGE* (FIND-PACKAGE "MACINTOSH"))
                          (SI:*LISP-MODE* :COMMON-LISP)
                          (*READTABLE* SYS:COMMON-LISP-READTABLE)
                          (SI:*READER-SYMBOL-SUBSTITUTIONS* SYS::*COMMON-LISP-SYMBOL-SUBSTITUTIONS*))
  (COMPILER#:PATCH-SOURCE-FILE "SYS: WINDOW-MX; BASIC-COMM-METHODS.#"


(DEFMETHOD (mac-flavor :GetModifiedRectangles)
	   (&aux (add:*no-interrupt* inhibit-scheduling-flag))
  (LET (acb n-windows-with-mac-resident-bitmaps acb-image)
    (SETF n-windows-with-mac-resident-bitmaps
	  (LOOP for (ARRAY . window) in *undisplaced-mac-window-arrays*
		for wid = (tv:sheet-window-id window)
		count (AND (INTEGERP wid)
			   (NOT (AREF *has-the-Mac-forgotten-my-redirection?* wid)))))
    (SETF acb (add:get-acb (+ 4 (* 16 n-windows-with-mac-resident-bitmaps) 128)))
    (SETF (add:opcode acb) #x08)
    (add:transmit-packet-and-wait acb channel)
    (SETF acb-image (MAKE-ARRAY (ARRAY-TOTAL-SIZE acb) :element-type '(unsigned-byte 16)))
    (COPY-ARRAY-CONTENTS acb acb-image)
    (add:return-acb acb t)
    acb-image))

))

#!C
; From file BASIC-COMM-METHODS.LISP#> WINDOW-MX; MR-X:
#10R MACINTOSH#:
(COMPILER-LET ((*PACKAGE* (FIND-PACKAGE "MACINTOSH"))
                          (SI:*LISP-MODE* :COMMON-LISP)
                          (*READTABLE* SYS:COMMON-LISP-READTABLE)
                          (SI:*READER-SYMBOL-SUBSTITUTIONS* SYS::*COMMON-LISP-SYMBOL-SUBSTITUTIONS*))
  (COMPILER#:PATCH-SOURCE-FILE "SYS: WINDOW-MX; BASIC-COMM-METHODS.#"


(DEFMETHOD (mac-flavor :AdjustBitArray)
	   (window width height contents-matter &aux (add:*no-interrupt* inhibit-scheduling-flag))
  "Causes the Mac to create a graphport to hold the bit array of window.
If it already exists then the Mac will resize it to width,height. If width and
height are zero then the graphport will have no bit array."

  (LET (return-value nbytes-at-end-of-cache
	(acb (add:get-acb-fast 8)))
    
    (add:load-parms acb 16
		    (Mac-window-id window)
		    width
		    height
		    (IF contents-matter 1 0))
    
    (SETF (add:opcode acb) #x10)
    (add:transmit-packet-and-wait acb channel)
    
    (SETF return-value (NOT (ZEROP (ADD:PARM-16B acb 0))))
    (SETF nbytes-at-end-of-cache (add:parm-32b acb 1))
    (add:return-acb acb t)
    (VALUES return-value nbytes-at-end-of-cache)))

))

#!C
; From file MX-TV-MODULE-OPS.LISP#> WINDOW-MX; MR-X:
#10R TV#:
(COMPILER-LET ((*PACKAGE* (FIND-PACKAGE "TV"))
                          (SI:*LISP-MODE* :COMMON-LISP)
                          (*READTABLE* COMMON-LISP-READTABLE)
                          (SI:*READER-SYMBOL-SUBSTITUTIONS* SYS::*COMMON-LISP-SYMBOL-SUBSTITUTIONS*))
  (COMPILER#:PATCH-SOURCE-FILE "SYS: WINDOW-MX; MX-TV-MODULE-OPS.#"


mac:
(DEFUN setup-bitarrays-on-Mac-for-bitblt (from-w to-w)
  
  ;;  FROM-W and TO-W are either window-ids or arrays involved in a bitblt.
  ;;  This function guarantees that all bit-arrays needed are Mac-resident
  ;;  before the actual copy begins.

  (DECLARE (SPECIAL *emulated-cache*))
  
  (LET ((total-cache-space-needed 0) window)
    
    ;;  We know that the windows involved have bit arrays just by our being here.
    ;;  So if the Mac has any knowledge of such a window, it has already
    ;;  allocated cache space for its bit array.  We need to acquire more cache
    ;;  space only if the Mac knows nothing about a window.
    (WITH-STACK-LIST (window-ids (AND (INTEGERP from-w) from-w)
				 (AND (INTEGERP to-w) to-w))
      (DOLIST (window-id? window-ids)    
	(WHEN (AND window-id?
		   (ZEROP (AREF *is-the-bit-array-mac-resident?* window-id?))
		   (AREF *has-the-mac-forgotten-my-redirection?* window-id?))
	  (SETF window (AREF *all-windows-and-screens* window-id?))
	  (INCF total-cache-space-needed
		(* (CEILING (tv:sheet-width window) 16) 2
		   (tv:sheet-height window)))))
      
      ;;  Make sure we have enough free cache space...
      (WHEN (< *nbytes-free-space* total-cache-space-needed)
	(APPLY #'reorganize-bit-array-cache total-cache-space-needed window-ids)
	(WHEN (< *nbytes-free-space* total-cache-space-needed)
	  (FERROR nil "Cannot acquire ~d bytes in cache to hold ~
~@[~s ~]~:[~;and ~]~@[~s.~]"
		  total-cache-space-needed
		  (AND (INTEGERP from-w) (AREF *all-windows-and-screens* from-w))
		  (AND (INTEGERP from-w) (INTEGERP to-w))
		  (AND (INTEGERP to-w) (AREF *all-windows-and-screens* to-w)))))
      
      ;;  Make sure the bit-arrays involved are Mac resident...
      (DOLIST (window-id? window-ids)
	(WHEN window-id?
	  (move-a-windows-bit-array-to-the-mac window-id?))))))


))

#!C
; From file MX-TV-MODULE-OPS.LISP#> WINDOW-MX; MR-X:
#10R TV#:
(COMPILER-LET ((*PACKAGE* (FIND-PACKAGE "TV"))
                          (SI:*LISP-MODE* :COMMON-LISP)
                          (*READTABLE* COMMON-LISP-READTABLE)
                          (SI:*READER-SYMBOL-SUBSTITUTIONS* SYS::*COMMON-LISP-SYMBOL-SUBSTITUTIONS*))
  (COMPILER#:PATCH-SOURCE-FILE "SYS: WINDOW-MX; MX-TV-MODULE-OPS.#"


mac:
(DEFUN setup-bitarrays-on-Mac-for-bitblt (from-w to-w)
  
  ;;  FROM-W and TO-W are either window-ids or arrays involved in a bitblt.
  ;;  This function guarantees that all bit-arrays needed are Mac-resident
  ;;  before the actual copy begins.

  (DECLARE (SPECIAL *emulated-cache*))
  
  (LET ((total-cache-space-needed 0) window)
    
    ;;  We know that the windows involved have bit arrays just by our being here.
    ;;  So if the Mac has any knowledge of such a window, it has already
    ;;  allocated cache space for its bit array.  We need to acquire more cache
    ;;  space only if the Mac knows nothing about a window.
    (WITH-STACK-LIST (window-ids (AND (INTEGERP from-w) from-w)
				 (AND (INTEGERP to-w) to-w))
      (DOLIST (window-id? window-ids)    
	(WHEN (AND window-id?
		   (ZEROP (AREF *is-the-bit-array-mac-resident?* window-id?))
		   (AREF *has-the-mac-forgotten-my-redirection?* window-id?))
	  (SETF window (AREF *all-windows-and-screens* window-id?))
	  (INCF total-cache-space-needed
		(* (CEILING (tv:sheet-width window) 16) 2
		   (tv:sheet-height window)))))
      
      ;;  Make sure we have enough free cache space...
      (WHEN (< *nbytes-free-space* total-cache-space-needed)
	(APPLY #'reorganize-bit-array-cache total-cache-space-needed window-ids)
	(WHEN (< *nbytes-free-space* total-cache-space-needed)
	  (FERROR nil "Cannot acquire ~d bytes in cache to hold ~
~@[~s ~]~:[~;and ~]~@[~s.~]"
		  total-cache-space-needed
		  (AND (INTEGERP from-w) (AREF *all-windows-and-screens* from-w))
		  (AND (INTEGERP from-w) (INTEGERP to-w))
		  (AND (INTEGERP to-w) (AREF *all-windows-and-screens* to-w)))))
      
      ;;  Make sure the bit-arrays involved are Mac resident...
      (DOLIST (window-id? window-ids)
	(WHEN window-id?
	  (move-a-windows-bit-array-to-the-mac window-id?))))))

(DEFUN Mac-bitblt (alu width height from-array from-x from-y to-array to-x to-y)
  (LET* (from-w from-x-offset from-y-offset to-w to-x-offset to-y-offset
	(inhibit-scheduling-flag t))
    
    (MULTIPLE-VALUE-SETQ (alu from-array from-x from-y)
      (mac:handle-forcing-of-destination-bits alu from-array from-x from-y))
    
    (MULTIPLE-VALUE-SETQ (from-w from-x-offset from-y-offset)
      (mac:figure-out-redirection from-array))
    (MULTIPLE-VALUE-SETQ (to-w to-x-offset to-y-offset)
      (mac:figure-out-redirection to-array))
    (mac:remember-call :bit-arrays self from-w from-x-offset from-y-offset
	           to-w to-x-offset to-y-offset)
    (COND
      ((AND (ARRAYP from-w) (ARRAYP to-w))
       (with-real-microcode
         (si:bitblt
           alu width height from-array from-x from-y to-array to-x to-y)))
      
      (t
       (mac:setup-bitarrays-on-Mac-for-bitblt from-w to-w)
       (mac:send-bitblt alu width height
	            from-w (+ from-x from-x-offset) (+ from-y from-y-offset)
	            to-w (+ to-x to-x-offset) (+ to-y to-y-offset) from-array from-x from-y)))))

))

#!C
; From file MAC-MESSAGES.LISP#> WINDOW-MX; MR-X:
#10R MACINTOSH#:
(COMPILER-LET ((*PACKAGE* (FIND-PACKAGE "MACINTOSH"))
                          (SI:*LISP-MODE* :COMMON-LISP)
                          (*READTABLE* SYS:COMMON-LISP-READTABLE)
                          (SI:*READER-SYMBOL-SUBSTITUTIONS* SYS::*COMMON-LISP-SYMBOL-SUBSTITUTIONS*))
  (COMPILER#:PATCH-SOURCE-FILE "SYS: WINDOW-MX; MAC-MESSAGES.#"



(DEFUN arrest-all-but-me (arg)
  (SETF *stop-driving-it-crazy* (NOT arg))
  (DOLIST (p si:all-processes)
    (OR (NULL p)
	(EQ p tv:kbd-process)
	(EQ p tv:mouse-process)
	(EQ p tv:screen-manager-background-process)
	(EQ p current-process)
	(SEND p (IF arg :revoke-arrest-reason :arrest-reason) :user))))


))

#!C
; From file MAC-MESSAGES.LISP#> WINDOW-MX; MR-X:
#10R MACINTOSH#:
(COMPILER-LET ((*PACKAGE* (FIND-PACKAGE "MACINTOSH"))
                          (SI:*LISP-MODE* :COMMON-LISP)
                          (*READTABLE* SYS:COMMON-LISP-READTABLE)
                          (SI:*READER-SYMBOL-SUBSTITUTIONS* SYS::*COMMON-LISP-SYMBOL-SUBSTITUTIONS*))
  (COMPILER#:PATCH-SOURCE-FILE "SYS: WINDOW-MX; MAC-MESSAGES.#"



(DEFUN get-modified-rectangles (&optional dont-check)
  (LET (old-free-space)
    (SETF *modified-rectangles* (SEND *mac* :getmodifiedrectangles))
    (SETF *n-descriptors* (LSH (AREF *modified-rectangles* 21) -8))
    (SETF *nbytes-free-space* (LOGAND #xFFFFFF (+ (ASH (AREF *modified-rectangles* 21) 16)
						  (AREF *modified-rectangles* 20))))
    (UNLESS (OR dont-check (= (SETF old-free-space (emulate-cache-compaction))
			      *nbytes-free-space*))
      (arrest-all-but-me nil)
      (remember-call :fatal "forget it")
      (mac:dr t t)
      (CERROR "Believe the Mac" "Explorer thinks ~d free bytes, Mac says ~d."
	      old-free-space *nbytes-free-space*)
      (believe-the-mac)
      (arrest-all-but-me t))
    (remember-call :rects *modified-rectangles* old-free-space *nbytes-free-space*)
    (VALUES *nbytes-free-space*)))

))

#!C
; From file MAC-MESSAGES.LISP#> WINDOW-MX; MR-X:
#10R MACINTOSH#:
(COMPILER-LET ((*PACKAGE* (FIND-PACKAGE "MACINTOSH"))
                          (SI:*LISP-MODE* :COMMON-LISP)
                          (*READTABLE* SYS:COMMON-LISP-READTABLE)
                          (SI:*READER-SYMBOL-SUBSTITUTIONS* SYS::*COMMON-LISP-SYMBOL-SUBSTITUTIONS*))
  (COMPILER#:PATCH-SOURCE-FILE "SYS: WINDOW-MX; MAC-MESSAGES.#"


			       
(DEFUN print-modified-rectangles (&key dump-p (stream t) rects)
  (LET* (nbytes-free-space acb-image16 acb-image32 start-of-free-space n-descriptors)
    (UNLESS rects
      (get-modified-rectangles)
      (SETF rects *modified-rectangles*))
    (SETF acb-image16 rects
	  nbytes-free-space (LOGAND #xFFFFFF (+ (ASH (AREF acb-image16 21) 16)
						(AREF acb-image16 20)))
	  n-descriptors (LSH (AREF acb-image16 21) -8))
    (SETF start-of-free-space (- *total-mac-bit-array-cache-size* nbytes-free-space))
    (WHEN dump-p
      (SETF acb-image32 (MAKE-ARRAY (FLOOR (LENGTH acb-image16) 2)
				  :element-type '(unsigned-byte 32)
				  :displaced-to acb-image16))
      (FORMAT stream "~% ~8,'0x" (AREF acb-image32 10))
      (LOOP for ii from 1 to n-descriptors
	    for i32 from 11 by 4
	    do
	    (FORMAT stream "~% ~8,'0x ~8,'0x ~8,'0x ~8,'0x "
		(AREF acb-image32 (+ i32 0)) (AREF acb-image32 (+ i32 1))
		(AREF acb-image32 (+ i32 2)) (AREF acb-image32 (+ i32 3)))
	    finally (FORMAT t "~%")))

    
    (FORMAT stream "~%(~d descriptors, ~d bytes of free space starting at ~d)"
	    n-descriptors nbytes-free-space start-of-free-space)
    (LOOP with last-blocks-end = 0
	  for ii from 0
	  for i32 from 11 by 4
	  for i16 = (LSH i32 1)
	  for wid = (LSH (AREF acb-image16 (+ i16 1)) -8)
	  for macs-displ = (LOGAND #xFFFFFF (+ (ASH (AREF acb-image16 (+ i16 1)) 16)
					  (AREF acb-image16 i16)))
	  for time-of-last-update = (+ (ASH (AREF acb-image16 (+ i16 3)) 16)
				       (AREF acb-image16 (+ i16 2)))
	  for top = (AREF acb-image16 (+ i16 5))
	  for left = (AREF acb-image16 (+ i16 4))
	  for bottom = (AREF acb-image16 (+ i16 7))
	  for right = (AREF acb-image16 (+ i16 6))
	  for window = (AREF *all-windows-and-screens* wid)
	  for size = (IF window (* (CEILING (tv:sheet-width window) 16) 2 (tv:sheet-height window)) 0)
	  until (AND (ZEROP wid) (ZEROP macs-displ) (ZEROP time-of-last-update)) do
	  (WHEN (/= last-blocks-end macs-displ)
	    (FORMAT stream "~%**** Mismatched blocks ****"))
	  (SETF last-blocks-end (+ macs-displ size))
	  (FORMAT stream "~%~s
     WID= ~3d.  Updated at ~d.  Modified rect = (~3d,~3d) (~4d,~3d).  Cache locations ~6d to ~6d."
		  window WID time-of-last-update top left bottom right macs-displ last-blocks-end)
	  finally (WHEN (/= ii n-descriptors)
		    (FORMAT stream "~%**** Found ~d descriptors, Mac claimed there were ~d ****"
			    ii n-descriptors))
	  (WHEN (/= last-blocks-end start-of-free-space)
	    (FORMAT stream "~%**** Free space start =/ end of last block ****")))))

))

#!C
; From file MAC-MESSAGES.LISP#> WINDOW-MX; MR-X:
#10R MACINTOSH#:
(COMPILER-LET ((*PACKAGE* (FIND-PACKAGE "MACINTOSH"))
                          (SI:*LISP-MODE* :COMMON-LISP)
                          (*READTABLE* SYS:COMMON-LISP-READTABLE)
                          (SI:*READER-SYMBOL-SUBSTITUTIONS* SYS::*COMMON-LISP-SYMBOL-SUBSTITUTIONS*))
  (COMPILER#:PATCH-SOURCE-FILE "SYS: WINDOW-MX; MAC-MESSAGES.#"



(DEFUN acquire-Nbytes-of-cache-space (nbytes-to-acquire wids-not-to-touch)
  (LET* (nbytes-free-space acb-image16)
    (SETF nbytes-free-space (get-modified-rectangles))
    (SETF acb-image16 *modified-rectangles*)
    (LOOP when (>= *nbytes-free-space* nbytes-to-acquire)
	       do
	       ;;  Compact the Mac's bit-array cache...
	       (remember-call :rects *nbytes-free-space*)
	       (get-modified-rectangles)
	       (RETURN t)

	  for oldest-dbase =
	  (LOOP with oldest-age = #x10000000 and oldest-dbase
		for i from 1 to *n-descriptors*
		for dbase from 22 by 8
		for age = (+ (ASH (AREF acb-image16 (+ dbase 3)) 16)
			     (AREF acb-image16 (+ dbase 2)))
		for wid = (LSH (AREF acb-image16 (+ dbase 1)) -8)
		for window = (AREF *all-windows-and-screens* wid)
		when (AND (< age oldest-age)
			  window
			  (NOT (TYPEP window 'mac-screen))
			  (NOT (MEMBER wid wids-not-to-touch))
			  (NOT (LOOP for sup first tv:selected-window then
				     (tv:sheet-superior sup)
				     until (NULL sup)
				     when (EQ window tv:selected-window)
				     do; (FORMAT t "~%~s rejected #1." window)
				     (RETURN t)))
			  (NOT (LOOP for sup first window then
				     (tv:sheet-superior sup)
				     until (NULL sup)
				     when (EQ sup tv:selected-window)
				     do; (FORMAT t "~%~s rejected #2." window)
				     (RETURN t)))
			  )
		do
		(SETF oldest-age age)
		(SETF oldest-dbase dbase)
		finally (RETURN oldest-dbase))
	  when (NULL oldest-dbase) return NIL
	  for oldest-wid = (LSH (AREF acb-image16 (+ oldest-dbase 1)) -8)
	  for oldest-window = (AREF *all-windows-and-screens* oldest-wid)
	  when (NULL oldest-window)
	  do
	  (LET ((si:cold-load-stream-owns-keyboard t)
		  (*terminal-io* si:cold-load-stream))
	      (eh:save-screen-for-cold-load-stream t)
	      (CERROR "Proceed, throwing away recent updates for window-id ~d"
		      "Mac has bitarray cached for window-id ~d not currently assigned to a window"
		      oldest-wid)
	      (eh:restore-screen-for-cold-load-stream))
	  (SEND *mac* :deallocatebitarray oldest-wid)
	  (SETF (AREF acb-image16 (+ oldest-dbase 2)) 0
		(AREF acb-image16 (+ oldest-dbase 3)) #x1000)
	  (emulate-cache-deallocation oldest-wid)
	  else do

#|
	  (WITH-STACK-LIST (modified-area-descriptor (AREF acb-image16 (+ oldest-dbase 5))
						     (AREF acb-image16 (+ oldest-dbase 4))
						     (AREF acb-image16 (+ oldest-dbase 7))
						     (AREF acb-image16 (+ oldest-dbase 6)))
|#
          (WITH-STACK-LIST (modified-area-descriptor 0 0 (tv:sheet-width oldest-window)
						     (tv:sheet-height oldest-window))
	    (retrieve-a-bit-array-from-the-Mac oldest-window modified-area-descriptor))
	  (remember-call :rects oldest-window *nbytes-free-space*)
	  ;;  Remove this window's entry from further consideration by giving it
	  ;;  a very large time-of-last-update...
	  (SETF (AREF acb-image16 (+ oldest-dbase 2)) 0
		(AREF acb-image16 (+ oldest-dbase 3)) #x1000))))

))

#!C
; From file MAC-MESSAGES.LISP#> WINDOW-MX; MR-X:
#10R MACINTOSH#:
(COMPILER-LET ((*PACKAGE* (FIND-PACKAGE "MACINTOSH"))
                          (SI:*LISP-MODE* :COMMON-LISP)
                          (*READTABLE* SYS:COMMON-LISP-READTABLE)
                          (SI:*READER-SYMBOL-SUBSTITUTIONS* SYS::*COMMON-LISP-SYMBOL-SUBSTITUTIONS*))
  (COMPILER#:PATCH-SOURCE-FILE "SYS: WINDOW-MX; MAC-MESSAGES.#"



(DEFUN reorganize-bit-array-cache (nbytes-of-cache-needed &rest wids-not-to-touch)
  (LET (true-mouse-cursor)
    ;;  Change the Mac's mouse cursor to the watch while we thrash bitmaps...
    (SETF true-mouse-cursor tv:mouse-blinker)
    (SEND *mac* :set-mouse-blinker (- 4 mac-mouse-cursor-offset))

    (WHEN(< *nbytes-free-space* nbytes-of-cache-needed)
      (UNLESS (acquire-nbytes-of-cache-space
		nbytes-of-cache-needed wids-not-to-touch)
	(retrieve-all-bit-arrays-from-the-mac)))

    ;;  Restore the Mac's mouse cursor to what the Explorer thinks it is...
    (WHEN (TYPEP (tv:blinker-sheet true-mouse-cursor) '(OR mac-window mac-screen))
      (SEND true-mouse-cursor :create-Mac-image-of-Explorer-mouse-cursor nil nil))))


;;;##########################################################
;;;
;;;     			Bit array movement to/from the Mac
;;;
;;;##########################################################

))

#!C
; From file MAC-MESSAGES.LISP#> WINDOW-MX; MR-X:
#10R MACINTOSH#:
(COMPILER-LET ((*PACKAGE* (FIND-PACKAGE "MACINTOSH"))
                          (SI:*LISP-MODE* :COMMON-LISP)
                          (*READTABLE* SYS:COMMON-LISP-READTABLE)
                          (SI:*READER-SYMBOL-SUBSTITUTIONS* SYS::*COMMON-LISP-SYMBOL-SUBSTITUTIONS*))
  (COMPILER#:PATCH-SOURCE-FILE "SYS: WINDOW-MX; MAC-MESSAGES.#"



(DEFUN resize-bit-array-and-handle-cache-overflow
       (window window-id contents-matter-p)
  (DECLARE (SPECIAL *emulated-cache*))
  (LET* ((width (tv:sheet-width window))
	 (height (tv:sheet-height window))
	 (inhibit-scheduling-flag t) success-p
	 total-cache-space-needed nbytes-at-end-of-cache)
    (IF (NULL (tv:sheet-bit-array window))
	(SETF width (- width))
      ;; else...
      (SETF total-cache-space-needed
		(* (CEILING width 16) 2 height))
      ;;  If we're unable to get space in the emulated cache, reorganize the cache,
      ;;  then get the emulated space...
      (UNLESS (emulate-cache-allocation window-id width height)
	(WHEN (< *nbytes-free-space* total-cache-space-needed)
	  (reorganize-bit-array-cache total-cache-space-needed window-id)
	  (WHEN (< *nbytes-free-space* total-cache-space-needed)
	    (FERROR nil "Cannot acquire ~d bytes in cache to hold the ~dx~d bit-array of ~a."
		    total-cache-space-needed height width window))
	  (emulate-cache-allocation window-id width height))))
    
    ;;  We know there's enough total free cache space for this window's bit array,
    ;;  but we don't know how much compacted free cache space there is.  This is
    ;;  OK, since the :AdjustBitArray command compacts the cache if necessary...
    (MULTIPLE-VALUE-SETQ (success-p nbytes-at-end-of-cache)
      (SEND *mac* :adjustbitarray window-id width height contents-matter-p))
    
    (UNLESS success-p
      (remember-call :fatal "forget it")
      (dr t t)
      (CERROR "onward" "Exp thinks there are ~d free bytes but :AdjustBitArray needed ~d, found ~d."
	      *nbytes-free-space* total-cache-space-needed nbytes-at-end-of-cache)
      (get-modified-rectangles t)		       ; Compact the cache, update *nbytes-free-space*.
      (believe-the-mac)				       ; Rebuild the emulated cache.
      (resize-bit-array-and-handle-cache-overflow window window-id contents-matter-p))
    
    (remember-call :bit-arrays window window-id width height
		   (AREF *has-the-Mac-forgotten-my-redirection?* window-id)
		   (AREF *is-the-bit-array-mac-resident?* window-id)
		   *nbytes-free-space* nbytes-at-end-of-cache
		   *emulated-cache*)))

))

#!C
; From file MAC-MESSAGES.LISP#> WINDOW-MX; MR-X:
#10R MACINTOSH#:
(COMPILER-LET ((*PACKAGE* (FIND-PACKAGE "MACINTOSH"))
                          (SI:*LISP-MODE* :COMMON-LISP)
                          (*READTABLE* SYS:COMMON-LISP-READTABLE)
                          (SI:*READER-SYMBOL-SUBSTITUTIONS* SYS::*COMMON-LISP-SYMBOL-SUBSTITUTIONS*))
  (COMPILER#:PATCH-SOURCE-FILE "SYS: WINDOW-MX; MAC-MESSAGES.#"



(DEFUN get-total-cache-size ()
  (LET (cache-size)
    (SETF cache-size (SEND *mac* :TotalCacheSize))
    (emulate-cache-initialization cache-size)
    (remember-call :bit-arrays cache-size)
    cache-size))

;;;  10-03-88  LG  5.13	Handle the possibility that WINDOW has a NULL screen-array
;;;  			correctly.

))

#!C
; From file MAC-MESSAGES.LISP#> WINDOW-MX; MR-X:
#10R MACINTOSH#:
(COMPILER-LET ((*PACKAGE* (FIND-PACKAGE "MACINTOSH"))
                          (SI:*LISP-MODE* :COMMON-LISP)
                          (*READTABLE* SYS:COMMON-LISP-READTABLE)
                          (SI:*READER-SYMBOL-SUBSTITUTIONS* SYS::*COMMON-LISP-SYMBOL-SUBSTITUTIONS*))
  (COMPILER#:PATCH-SOURCE-FILE "SYS: WINDOW-MX; MAC-MESSAGES.#"


(DEFUN retrieve-a-bit-array-from-the-mac (window &optional modified-area-descriptor)

  (LET* (window-id bit-array mac-does-not-know-about-this-window
	 )
    (UNLESS (OR *ignore-commands-for-the-mac*
		(NULL window)	      
		(TYPEP window 'w:screen))
      (SETF window-id (tv:mac-explorer-window-id window)
	    bit-array (tv:sheet-bit-array window))
      (SETF mac-does-not-know-about-this-window
	    (AND (AREF *has-the-mac-forgotten-my-redirection?* window-id)
		 (ZEROP (AREF *is-the-bit-array-mac-resident?* window-id))))
      (UNLESS modified-area-descriptor
	(SETF modified-area-descriptor (get-a-modified-area-descriptor window-id window)))
      (UNLESS mac-does-not-know-about-this-window
	;;  Make sure this window's inferiors have all been processed before it is...
	(LOOP for inferior in (tv:sheet-inferiors window)
	      do (retrieve-a-bit-array-from-the-mac inferior))
	;;  Copy the selected window's bit array from the Mac back to the Explorer...
	;;  We may have already done this window -- do nothing if we have...
	(remember-call :bit-arrays window window-id
		       mac-does-not-know-about-this-window
		       (tv:sheet-screen-array window) bit-array
		       (AREF *is-the-bit-array-mac-resident?* window-id)
		       (AREF *has-the-mac-forgotten-my-redirection?* window-id)
		       modified-area-descriptor)
	(UNLESS (ZEROP (AREF *is-the-bit-array-mac-resident?* window-id))
	  (WHEN bit-array
	    (LET ((top 0) (left 0) width-to-retrieve height-to-retrieve)
	      (IF modified-area-descriptor
		  (SETF top (FIRST modified-area-descriptor)
			left (SECOND modified-area-descriptor)
			width-to-retrieve (- (THIRD modified-area-descriptor) top)
			height-to-retrieve (- (FOURTH modified-area-descriptor) left))
		;; else...
		(IF (AND *gba-window* (EQ window (FIRST *gba-window*)))
		    (SETF width-to-retrieve (SECOND *gba-window*)
			  height-to-retrieve (THIRD *gba-window*))
		  ;; else...
		  (SETF width-to-retrieve (tv:sheet-width window)
			height-to-retrieve (tv:sheet-height window))))
	      (UNLESS (OR (ZEROP width-to-retrieve) (ZEROP height-to-retrieve))
		(send-bitblt
		  tv:alu-seta width-to-retrieve height-to-retrieve
		  window-id top left
		  bit-array top left
		  bit-array))))
	  (SETF (AREF *is-the-bit-array-mac-resident?* window-id) 0))
	;;; Tell the Mac we're killing this window, regardless of whether or not there
	;;; was a Mac-resident bit array.  Remember to whom the window was redirected
	;;; when it was retrieved from the Mac.
	(SEND *mac* :deallocatebitarray window-id)
	(SETF (AREF *has-the-mac-forgotten-my-redirection?* window-id)
	      (IF (tv:sheet-screen-array window)
		  (AREF *all-windows-and-screens*
			(figure-out-redirection
			  (tv:sheet-screen-array window)))
		;; else...
		window))
	;;  If the Mac knew about this window at all (and we've decided that it did),
	;;  then it allocated space in the cache for its bit-array iff the Explorer
	;;  passed it a positive width in a :AdjustBitArray command, which the Explorer
	;;  does iff the window has a bit array.  So the :DeallocateBitArray command
	;;  above actually freed up cache space iff this window has a bit array.
	(WHEN (tv:sheet-bit-array window)
	  (emulate-cache-deallocation window-id))
	(remember-call :bit-arrays window window-id bit-array *gba-window*
		       (tv:sheet-height window) (tv:sheet-width window)
		       (AREF *is-the-bit-array-mac-resident?* window-id)
		       (AREF *has-the-mac-forgotten-my-redirection?* window-id))
	))))


))

#!C
; From file MAC-MESSAGES.LISP#> WINDOW-MX; MR-X:
#10R MACINTOSH#:
(COMPILER-LET ((*PACKAGE* (FIND-PACKAGE "MACINTOSH"))
                          (SI:*LISP-MODE* :COMMON-LISP)
                          (*READTABLE* SYS:COMMON-LISP-READTABLE)
                          (SI:*READER-SYMBOL-SUBSTITUTIONS* SYS::*COMMON-LISP-SYMBOL-SUBSTITUTIONS*))
  (COMPILER#:PATCH-SOURCE-FILE "SYS: WINDOW-MX; MAC-MESSAGES.#"



(DEFUN retrieve-a-screens-bit-array-from-the-Mac (screen)
  (UNLESS *ignore-commands-for-the-Mac*
    (LET ((window-id (mac-window-p screen))
          (buffer-array (SEND screen :buffer)))
      (send-bitblt
	    tv:alu-seta
	    (tv:sheet-width screen)
	    (tv:sheet-height screen)
	    window-id 0 0
	    buffer-array 0 0)
      (SEND *mac* :DeallocateBitArray window-id)
      (emulate-cache-deallocation window-id)
      (SETF (AREF *is-the-bit-array-Mac-resident?* window-id) 0)
      (SETF (AREF *has-the-Mac-forgotten-my-redirection?* window-id) screen)
      (remember-call :bit-arrays screen window-id)
      window-id)))

))

#!C
; From file MAC-MESSAGES.LISP#> WINDOW-MX; MR-X:
#10R MACINTOSH#:
(COMPILER-LET ((*PACKAGE* (FIND-PACKAGE "MACINTOSH"))
                          (SI:*LISP-MODE* :COMMON-LISP)
                          (*READTABLE* SYS:COMMON-LISP-READTABLE)
                          (SI:*READER-SYMBOL-SUBSTITUTIONS* SYS::*COMMON-LISP-SYMBOL-SUBSTITUTIONS*))
  (COMPILER#:PATCH-SOURCE-FILE "SYS: WINDOW-MX; MAC-MESSAGES.#"



(DEFUN retrieve-all-bit-arrays-from-the-Mac
       (&optional and-dont-restore-p window-id-of-screen-not-to-retrieve)
  (UNLESS *ignore-commands-for-the-Mac*
    (LET* (screens (inhibit-scheduling-flag t))
      (remember-call :bit-arrays self)
      ;;  Find all Mac-resident screens and their exposed windows...
      (SETF screens
	(LOOP FOR i FROM 1 TO *largest-screen-id-ever-assigned*
	      FOR screen = (the-screen (AREF *Mac-resident-Explorer-screens* i))
	      COLLECT screen INTO screens
	      FINALLY (RETURN screens)))
      (w:delaying-screen-management
	;;  Retrieve all Mac-resident bit arrays, deallocate all GrafPorts...
	(LOOP FOR wid FROM 0 TO *largest-window-id-ever-assigned*
	      FOR window = (AREF *all-windows-and-screens* wid)
	      DO
	      (retrieve-a-bit-array-from-the-Mac window))
	
	;;  We just flagged every window-id currently in use by setting the
	;;  corresponding entry in the array *has-the-Mac-forgotten-my-redirection?*.
	;;  This will cause make-bit-array-mac-resident to send the Mac a
	;;  RedirectDrawing message to reestablish cognizance of the window's
	;;  redirection by the Mac...
	
	;; Empty the Mac's bit-array cache by retrieving all screens' buffer-arrays, too...
	(LOOP FOR screen IN screens
	      WHEN (AND screen
			(NEQ (mac-window-p screen)
			     window-id-of-screen-not-to-retrieve))
	      DO
	      (retrieve-a-screens-bit-array-from-the-Mac screen))
        
	;;  Once the bit-array cache has been cleared out, the Mac loses all
	;;  knowledge of redirections.  Each time a window is defined to the
	;;  Mac by AdjustBitArray we must check whether or not the Mac knows
	;;  the window's current redirection, and, if not, tell it.  We
	;;  cannot tell the Mac all the redirections now because the Mac
	;;  knows redirections only in terms of one window's GrafPort using
	;;  another window's Mac-resident bitarray, and at this time there
	;;  are no Mac-resident bitarrays.  Redirections are meaningful only
        ;;  within the context of the cacheing scheme.
	
	
	;;  Now that bit array storage is cleaned out, restore all the screens...
	(UNLESS and-dont-restore-p
	  (LOOP FOR i FROM 1 TO *largest-screen-id-ever-assigned*
	        FOR screen = (the-screen (AREF *Mac-resident-Explorer-screens* i))
	        WHEN (AND screen
			(NEQ (mac-window-p screen)
			     window-id-of-screen-not-to-retrieve))
	        DO (restore-a-screens-bit-array-to-the-Mac screen i))))

      ;;  Verify that *nbytes-free-space* accurately reflects the free space in
      ;;  the cache, make sure it is compacted...
      (get-modified-rectangles)
      )))


))

#!C
; From file MAC-MESSAGES.LISP#> WINDOW-MX; MR-X:
#10R MACINTOSH#:
(COMPILER-LET ((*PACKAGE* (FIND-PACKAGE "MACINTOSH"))
                          (SI:*LISP-MODE* :COMMON-LISP)
                          (*READTABLE* SYS:COMMON-LISP-READTABLE)
                          (SI:*READER-SYMBOL-SUBSTITUTIONS* SYS::*COMMON-LISP-SYMBOL-SUBSTITUTIONS*))
  (COMPILER#:PATCH-SOURCE-FILE "SYS: WINDOW-MX; MAC-MESSAGES.#"


			       
(DEFUN send-redirect-drawing (window &optional contents-matter-p)
  (UNLESS *ignore-commands-for-the-mac*
    (LET* (w	  		       ; window-id to which we are redirected.
	   wid			       ; window-id of this window.
	   windows-screen-array	       ; screen-array of this window
	   window-containing-last-saved-image
	   x-offset y-offset
	   (inhibit-scheduling-flag t))
      (dump-draw-char-cache)
      
      ;;  Get specified window's id, handle redirection of a deactivated window...
      (SETF wid (tv:mac-explorer-window-id window))
      (SETF windows-screen-array (tv:sheet-screen-array window))
      (WHEN (EQ t wid)
	(SETF wid (give-a-window-an-id window)))
 
      (IF (NULL windows-screen-array)
	  (retrieve-a-bit-array-from-the-mac window)
	;; else...
	;; Figure out to whom we are indirected and where, make its bit-array
	;; Mac-resident if we're indirected to ourself...
	(MULTIPLE-VALUE-SETQ (w x-offset y-offset)
	  (figure-out-redirection windows-screen-array))
	
	;;  If the window is redirected to an array as yet not associated with any Mac
	;;  window,  handle this gracefully if the array is this window's bit array.
	;;  This catches a deactivated window nicely...
	(WHEN (ARRAYP w)
	  (mac:remember-call :fatal
			     (NEQ (chase-displaced-pointers windows-screen-array)
				  (tv:sheet-bit-array window)))
	  (IF (NEQ (chase-displaced-pointers windows-screen-array)
		   (tv:sheet-bit-array window))
	      (CERROR "onward" "window indirected to unknown array")
	    ;; else we are redirected to ourself...
	    (remember-bit-array window (tv:sheet-bit-array window))
	    (SETF w wid
		  x-offset 0
		  y-offset 0)
	    (SETF (AREF *has-the-mac-forgotten-my-redirection?* w) window)))

	;;  Refresh the Mac's knowledge of WINDOW if necessary...
	(SETF window-containing-last-saved-image
	      (AREF *has-the-mac-forgotten-my-redirection?* wid))
	(WHEN window-containing-last-saved-image
	  (resize-bit-array-and-handle-cache-overflow
	    window wid contents-matter-p)
	  ;;  The Mac is now fully cognizant of this window...
	  (SETF (AREF *has-the-mac-forgotten-my-redirection?* wid) nil))
	;;  Always make sure that the bit array of the window to whom we are
	;;  Now being redirected is Mac-resident...
	(move-a-windows-bit-array-to-the-mac w)
	;;  Tell the Mac about the current redirection of WINDOW...
	(SEND *mac* :redirectdrawing wid w x-offset y-offset)
	(remember-call :bit-arrays window wid
		       window-containing-last-saved-image
		       (AREF *is-the-bit-array-mac-resident?* w)
		       w x-offset y-offset))
	)))

))

#!C
; From file MAC-MESSAGES.LISP#> WINDOW-MX; MR-X:
#10R MACINTOSH#:
(COMPILER-LET ((*PACKAGE* (FIND-PACKAGE "MACINTOSH"))
                          (SI:*LISP-MODE* :COMMON-LISP)
                          (*READTABLE* SYS:COMMON-LISP-READTABLE)
                          (SI:*READER-SYMBOL-SUBSTITUTIONS* SYS::*COMMON-LISP-SYMBOL-SUBSTITUTIONS*))
  (COMPILER#:PATCH-SOURCE-FILE "SYS: WINDOW-MX; MAC-MESSAGES.#"



(DEFUN send-adjust-bit-array (window window-id contents-matter-p)
  "Change the size the the Mac-resident window to match the size of the
Explorer-resident window (it just changed).  Allocate a Mac-resident bit-array if
the Explorer-resident window has one and the Mac-resident does not.  Signal a lack
of an Explorer-resident bit array by passing a negative width."
  (UNLESS *ignore-commands-for-the-mac*
    (dump-draw-char-cache)
    (LET (bit-array)     
      (SETF bit-array (tv:sheet-bit-array window))
      ;;  If the specified window's bit-array is not Mac-resident then we need to
      ;;  make IT Mac-resident, not the bit-array being used as
      ;;  make-bit-array-Mac-resident now does.
      ;;  Handle a deactivated window...
      (WHEN (EQ t window-id)
	(SETF window-id (give-a-window-an-id window)))
      (resize-bit-array-and-handle-cache-overflow window window-id contents-matter-p)
      (WHEN bit-array
	(WHEN (ZEROP (AREF *is-the-bit-array-mac-resident?* window-id))
	  (send-bitblt
		tv:alu-seta
		(IF (AND *gba-window* (EQ window (FIRST *gba-window*)))
		    (SECOND *gba-window*)
		  (tv:sheet-width window))
		(IF (AND *gba-window* (EQ window (FIRST *gba-window*)))
		    (THIRD *gba-window*)
		  (tv:sheet-height window))
		bit-array 0 0
		window-id 0 0
		nil 0 0 t)
	  (SETF (AREF *is-the-bit-array-mac-resident?* window-id) 1))
	;; Make sure window is on the *undisplaced-Mac-window-arrays* list...
	(remember-bit-array window bit-array)))))

))

#!C
; From file MAC-MESSAGES.LISP#> WINDOW-MX; MR-X:
#10R MACINTOSH#:
(COMPILER-LET ((*PACKAGE* (FIND-PACKAGE "MACINTOSH"))
                          (SI:*LISP-MODE* :COMMON-LISP)
                          (*READTABLE* SYS:COMMON-LISP-READTABLE)
                          (SI:*READER-SYMBOL-SUBSTITUTIONS* SYS::*COMMON-LISP-SYMBOL-SUBSTITUTIONS*))
  (COMPILER#:PATCH-SOURCE-FILE "SYS: WINDOW-MX; MAC-MESSAGES.#"



(DEFUN send-adjust-screen-size (Explorer-screen-ID Explorer-window-ID width height
				   &optional (visibility t))
  (DECLARE (SPECIAL *emulated-cache*))
  (UNLESS *ignore-commands-for-the-Mac*
    (remember-call :selection self)
    (LET* ((inhibit-scheduling-flag t)
	   total-cache-space-needed)
      (dump-draw-char-cache)
      (SETF total-cache-space-needed
	    (* (CEILING width 16) 2 height))
      (WHEN (< *nbytes-free-space* total-cache-space-needed)
	(reorganize-bit-array-cache total-cache-space-needed Explorer-window-ID)
	(WHEN (< *nbytes-free-space* total-cache-space-needed)
	  (FERROR nil "Cannot acquire ~d bytes in cache to hold the ~dx~d bit-array of ~a."
		  total-cache-space-needed height width
		  (AREF *all-windows-and-screens* Explorer-window-ID))))
      (IF (ZEROP total-cache-space-needed)
	  (emulate-cache-deallocation Explorer-window-id)
	;; else...
	(emulate-cache-allocation Explorer-window-id width height))
      (SEND *mac* :AdjustScreenSize Explorer-screen-ID
	    Explorer-window-ID width height visibility))))
  

))

;;
;;  When this patch is loaded we gotta initialize the *emulated-cache* as
;;  best we can...
;;

(pushnew :rects mac:*all-debugging-classes*)
(mac:get-modified-rectangles t)
(mac:believe-the-mac)

