;;; -*- Mode: Common-Lisp; Package: User; Base: 10.; Patch-File: T -*-

;;; Reason: Set a newly created window's window-id slot to T in (sheet :init) iff it is NIL.
;;; [SPR 10156]

;;;                           RESTRICTED RIGHTS LEGEND
;;;
;;; Use, duplication, or disclosure by the Government is subject to
;;; restrictions as set forth in subdivision (c)(1)(ii) of the Rights in
;;; Technical Data and Computer Software clause at 52.227-7013.
;;;
;;;   TEXAS INSTRUMENTS INCORPORATED      
;;;   P.O. BOX 2909, M/S 2151             
;;;   AUSTIN, TEXAS 78769                 
;;;
;;; Copyright (C) 1989 Texas Instruments Incorporated.
;;; All rights reserved.

;;; Written 06/30/89 13:16:07 by GRENINGER,
;;; while running on Salk from band LODA
;;; With SYSTEM 6.9, VIRTUAL-MEMORY 6.1, EH 6.3, MAKE-SYSTEM 6.0, MICRONET 6.0, LOCAL-FILE 6.0,
;;;  BASIC-PATHNAME 6.0, NETWORK-SUPPORT-COLD 6.0, BASIC-NAMESPACE 6.1, NETWORK-NAMESPACE 6.0,
;;;  DISK-IO 6.0, DISK-LABEL 6.0, BASIC-FILE 6.2, MAC-PATHNAME 6.0, NETWORK-PATHNAME 6.0,
;;;  COMPILER 6.6, TV 6.11, DATALINK 6.0, CHAOSNET 6.0, GC 6.3, MEMORY-AUX 6.0, NVRAM 6.1,
;;;  SYSLOG 6.1, STREAMER-TAPE 6.3, UCL 6.0, INPUT-EDITOR 6.0, METER 6.0, ZWEI 6.3,
;;;  DEBUG-TOOLS 6.3, NETWORK-SUPPORT 6.0, NETWORK-SERVICE 6.0, DATALINK-DISPLAYS 6.0,
;;;  FONT-EDITOR 6.1, SERIAL 6.0, PRINTER 6.1, MAC-PRINTER-TYPES 6.1, PRINTER-TYPES 6.0,
;;;  IMAGEN 6.0, SUGGESTIONS 6.0, MAIL-DAEMON 6.2, MAIL-READER 6.0, TELNET 6.0, VT100 6.0,
;;;  NAMESPACE-EDITOR 6.0, PROFILE 6.1, VISIDOC 6.2, TI-CLOS 6.9, CLEH 6.4, IP 3.47,
;;;  Experimental BUG 11.10, Experimental CLX 6.1, CLUE 6.5, X11M 6.1, Experimental GRAPHICS-WINDOW 6.0,
;;;  Experimental GED 6.1, Experimental SC 1.3, Experimental CLUSO 9.0,  microcode 428,
;;;  Band Name: Release 6.0 + SLE 6/5

#!C
; From file SHEET.LISP#> WINDOW; SYS:
#10R TV#:
(COMPILER-LET ((*PACKAGE* (FIND-PACKAGE "TV"))
                          (SI:*LISP-MODE* :COMMON-LISP)
                          (*READTABLE* COMMON-LISP-READTABLE)
                          (SI:*READER-SYMBOL-SUBSTITUTIONS* SYS::*COMMON-LISP-SYMBOL-SUBSTITUTIONS*))
  (COMPILER#:PATCH-SOURCE-FILE "SYS: WINDOW; SHEET.#"


(DEFMETHOD (SHEET :INIT)
           (INIT-PLIST
            &AUX BOTTOM RIGHT SAVE-BITS (VSP 2) (MORE-P T)
            (CHARACTER-WIDTH NIL) (CHARACTER-HEIGHT NIL)
            (REVERSE-VIDEO-P NIL) (INTEGRAL-P NIL)
            (BLINKER-P T) (BLINK-FL 'RECTANGULAR-BLINKER)
            (DESELECTED-VISIBILITY :ON))
  ;; Process options
  (DOPLIST ((CAR INIT-PLIST) VAL OP)
    (CASE OP
      ((:LEFT :X) (SETQ X-OFFSET VAL))
      ((:TOP  :Y) (SETQ Y-OFFSET VAL))
      (:POSITION  (SETQ X-OFFSET (FIRST  VAL)
			Y-OFFSET (SECOND VAL)))
      (:RIGHT     (SETQ RIGHT    VAL))
      (:BOTTOM    (SETQ BOTTOM   VAL))
      (:SIZE  (AND VAL (SETQ WIDTH    (FIRST  VAL)
			     HEIGHT   (SECOND VAL))))
      (:EDGES (AND VAL (SETQ X-OFFSET (FIRST  VAL)
			     Y-OFFSET (SECOND VAL)
			     RIGHT    (THIRD  VAL)
			     BOTTOM   (FOURTH VAL)
			     ;; Override any specified height,
			     ;; probably from default plist.
			     HEIGHT NIL WIDTH NIL))
	      (UNLESS (> RIGHT X-OFFSET)
		(FERROR
		  NIL
		  "Specified edges give width ~S"  (- RIGHT  X-OFFSET)))
	      (UNLESS (> BOTTOM Y-OFFSET)
		(FERROR
		  NIL
		  "Specified edges give height ~S" (- BOTTOM Y-OFFSET))))
      (:CHARACTER-WIDTH               (SETQ CHARACTER-WIDTH       VAL))
      (:CHARACTER-HEIGHT              (SETQ CHARACTER-HEIGHT      VAL))
      (:BLINKER-P                     (SETQ BLINKER-P             VAL))
      (:REVERSE-VIDEO-P               (SETQ REVERSE-VIDEO-P       VAL))
      (:MORE-P                        (SETQ MORE-P                VAL))
      (:VSP                           (SETQ VSP                   VAL))
      (:BLINKER-FLAVOR                (SETQ BLINK-FL              VAL))
      (:BLINKER-DESELECTED-VISIBILITY (SETQ DESELECTED-VISIBILITY VAL))
      (:INTEGRAL-P                    (SETQ INTEGRAL-P            VAL))
      (:SAVE-BITS                     (SETQ SAVE-BITS             VAL))
      (:RIGHT-MARGIN-CHARACTER-FLAG     (SETF (SHEET-RIGHT-MARGIN-CHARACTER-FLAG)     VAL))
      (:BACKSPACE-NOT-OVERPRINTING-FLAG (SETF (SHEET-BACKSPACE-NOT-OVERPRINTING-FLAG) VAL))
      (:CR-NOT-NEWLINE-FLAG             (SETF (SHEET-CR-NOT-NEWLINE-FLAG)             VAL))
      (:TRUNCATE-LINE-OUT-FLAG          (SETF (SHEET-TRUNCATE-LINE-OUT-FLAG)          VAL))
      ;; Set keypad-enable to 0 if val is either NIL or is 0.  Otherwise set to 1.
      (:KEYPAD-ENABLE (SETF (SHEET-KEYPAD-ENABLE) (IF (FIXNUMP VAL)
						      (IF (= VAL 0) 0 1)
						      ;;ELSE
						      (IF VAL 1 0))))
      (:TAB-NCHARS                      (SETF (SHEET-TAB-NCHARS)                      VAL))
      (:DEEXPOSED-TYPEIN-ACTION       (SEND SELF :SET-DEEXPOSED-TYPEIN-ACTION VAL))
      ))
  (SHEET-DEDUCE-AND-SET-SIZES
    RIGHT BOTTOM VSP INTEGRAL-P CHARACTER-WIDTH CHARACTER-HEIGHT)
  (COND ((OR (EQ SAVE-BITS 'T) BIT-ARRAY)
	 (LET ((DIMS (LIST (TRUNCATE
                             (* 32.
                                (SETQ LOCATIONS-PER-LINE
                                      (SHEET-LOCATIONS-PER-LINE SUPERIOR)))
                             (SCREEN-BITS-PER-PIXEL (SHEET-GET-SCREEN SELF)))
			   HEIGHT))
	       (ARRAY-TYPE (SHEET-ARRAY-TYPE (OR SUPERIOR SELF))))
	   (SETQ BIT-ARRAY
		 (IF BIT-ARRAY
		     (GROW-BIT-ARRAY BIT-ARRAY (CAR DIMS) (CADR DIMS) WIDTH)
		     ;;ELSE
		     (MAKE-ARRAY `(,(CADR DIMS) ,(CAR DIMS)) :TYPE ARRAY-TYPE)))
           ;; Use a portion of the superior's screen array.
	   (SETQ SCREEN-ARRAY (MAKE-ARRAY `(,(CADR DIMS) ,(CAR DIMS))
					  :TYPE ARRAY-TYPE
					  :DISPLACED-TO BIT-ARRAY
					  :DISPLACED-INDEX-OFFSET 0))))
	((EQ SAVE-BITS :DELAYED)
	 (SETF (SHEET-FORCE-SAVE-BITS) 1)))
  (SETQ MORE-VPOS (AND MORE-P (SHEET-DEDUCE-MORE-VPOS SELF)))
  (COND (SUPERIOR
	 (OR BIT-ARRAY
	     (LET ((ARRAY (SHEET-SUPERIOR-SCREEN-ARRAY)))
	       (SETQ OLD-SCREEN-ARRAY
		     (MAKE-ARRAY
		       `(,HEIGHT ,(ARRAY-DIMENSION ARRAY 1))
		       :TYPE (ARRAY-TYPE ARRAY)
		       :DISPLACED-TO ARRAY
		       :DISPLACED-INDEX-OFFSET
		       (+ X-OFFSET (* Y-OFFSET (ARRAY-DIMENSION ARRAY 1)))))
	       (SETQ LOCATIONS-PER-LINE (SHEET-LOCATIONS-PER-LINE SUPERIOR))))
	 (AND BLINKER-P
	      (APPLY #'MAKE-BLINKER SELF BLINK-FL
		     :FOLLOW-P T
		     :DESELECTED-VISIBILITY DESELECTED-VISIBILITY
		     (AND (CONSP BLINKER-P) BLINKER-P)))))
  (when (AND (mac-screen-p (sheet-get-screen self))	; An mX window...
	     (NULL window-id))				; Not already setup by grow-bit-array...
    ;;  Just mark the window as being a deactivated Mac window.  Window id and such
    ;;  will get allocated when it gets activated.  Also add its bit array to the mX's
    ;;  *undisplaced-Mac-window-arrays* list.
    (SETF window-id t)
    (remember-bit-array self))
  (SETF (SHEET-OUTPUT-HOLD-FLAG) 1)
  
;;;>>> changed char and erase aluf
  (OR (VARIABLE-BOUNDP CHAR-ALUF)
      (if (color-system-p self)
	  (SETQ CHAR-ALUF  ALU-TRANSP)
	  (setq char-aluf  (IF reverse-video-p alu-back alu-transp))
	  ))
  (OR (VARIABLE-BOUNDP ERASE-ALUF)
      (if (color-system-p self)
	  (SETQ ERASE-ALUF ALU-BACK)
	  (setq erase-aluf (IF reverse-video-p alu-transp alu-back))
	  ))
;;; new code added to support color reverse video:
  (SETQ color-reverse-video-state reverse-video-p)
;;; now flip the colors if reverse-video is true. NOTE - check the instance variable, not the AUX variable, since the
;;; instance variable is inittable.
  
  (WHEN (AND color-reverse-video-state (color-system-p self))
    (SEND self :complement-bow-mode)
    )
  
;; Setup the color map based on who and what we are.
  (UNLESS color-map  ;; If one already specified, don't change it.
    (IF (TYPEP self 'screen)  ;; If we're a screen, we have our own copy.
	;; Note: Doing a create-color-map here will give screens a color map with the Window System
	;; version number, not the System version number (as is for *default-color-map*).  See MAP.LISP
	(SETQ color-map (create-color-map)) ;; or (copy-color-map *default-color-map*))
	(IF (NULL superior)  ;; If no superior, which may never be the case??, get a copy from somewhere.
	    (SETQ color-map (copy-color-map (OR (AND default-screen (sheet-color-map default-screen))
						*default-color-map*)))
	    ;; If our superior is a screen, make a copy of its map for us to use.  This is the case for TOP
	    ;; level windows (like the ZMACS frame or the Listener) .
	    (IF (TYPEP (sheet-superior self) 'screen)
		(SETQ color-map (copy-color-map (sheet-color-map superior)))
		;; Otherwise, we always want to get a pointer to our superior's map.
		(SETQ color-map (sheet-color-map superior))))))
;; This is how it was being done for Release 3.2.  The problem was each TOP level window (like the ZMACS
;; frame or the Listener) was getting a pointer to the screen's (mouse-sheet's) color map instead of a COPY
;; of it.  02/21/88 KJF
;;;;; >>> set up to make a color map on the superior screen, and copy it down to everyone else
;;  (UNLESS color-map
;;        (if (null superior)
;;          (SETQ color-map (copy-color-map (OR (AND tv:mouse-sheet (sheet-color-map tv:mouse-sheet))
;;						*default-color-map*)))
;;          ; else
;;          (setq color-map (sheet-color-map superior))
;;        )
;;  )
  (SEND SELF :UPDATE-TIME-STAMP)
  SELF)

))
