;;; -*- Mode: Common-Lisp; Package: TV; Base: 10.; Patch-File: T -*-

;;; Reason: Added without-interrupts around copy-array-portion in WHO-LINE-RUN-STATE-UPDATE to make sure strings do not change out from under us.

;;;                           RESTRICTED RIGHTS LEGEND
;;;
;;; Use, duplication, or disclosure by the Government is subject to
;;; restrictions as set forth in subdivision (c)(1)(ii) of the Rights in
;;; Technical Data and Computer Software clause at 52.227-7013.
;;;
;;;   TEXAS INSTRUMENTS INCORPORATED      
;;;   P.O. BOX 2909, M/S 2151             
;;;   AUSTIN, TEXAS 78769                 
;;;
;;; Copyright (C) 1989 Texas Instruments Incorporated.
;;; All rights reserved.

;;; Patch file for TV version 6.14
;;; Written 07/10/89 06:44:51 by BERGER,
;;; while running on ARIES from band LOD1
;;; With SYSTEM 6.10, VIRTUAL-MEMORY 6.1, EH 6.3, MAKE-SYSTEM 6.0, MICRONET 6.0, LOCAL-FILE 6.0,
;;;  BASIC-PATHNAME 6.1, NETWORK-SUPPORT-COLD 6.0, BASIC-NAMESPACE 6.1, NETWORK-NAMESPACE 6.0,
;;;  DISK-IO 6.0, DISK-LABEL 6.0, BASIC-FILE 6.2, MAC-PATHNAME 6.0, NETWORK-PATHNAME 6.0,
;;;  COMPILER 6.6, TV 6.12, DATALINK 6.0, CHAOSNET 6.0, GC 6.3, MEMORY-AUX 6.0, NVRAM 6.1,
;;;  SYSLOG 6.1, STREAMER-TAPE 6.4, UCL 6.0, INPUT-EDITOR 6.0, METER 6.1, ZWEI 6.3,
;;;  DEBUG-TOOLS 6.3, NETWORK-SUPPORT 6.0, NETWORK-SERVICE 6.1, DATALINK-DISPLAYS 6.0,
;;;  FONT-EDITOR 6.1, SERIAL 6.0, PRINTER 6.3, MAC-PRINTER-TYPES 6.1, PRINTER-TYPES 6.1,
;;;  IMAGEN 6.0, SUGGESTIONS 6.0, MAIL-DAEMON 6.2, MAIL-READER 6.0, TELNET 6.0, VT100 6.0,
;;;  NAMESPACE-EDITOR 6.0, PROFILE 6.1, VISIDOC 6.2, TI-CLOS 6.10, CLEH 6.4, IP 3.47,
;;;  Experimental BUG 11.10, Experimental CLX 6.2, CLUE 6.8, X11M 6.1, RPC 6.1, NFS 3.8,
;;;   microcode 429, Band Name: 6.0 + patches 6/26

#!C
; From file WHOLIN.LISP#> WINDOW; SYS:
#10R TV#:
(COMPILER-LET ((*PACKAGE* (FIND-PACKAGE "TV"))
                          (SI:*LISP-MODE* :COMMON-LISP)
                          (*READTABLE* COMMON-LISP-READTABLE)
                          (SI:*READER-SYMBOL-SUBSTITUTIONS* SYS::*COMMON-LISP-SYMBOL-SUBSTITUTIONS*))
  (COMPILER#:PATCH-SOURCE-FILE "SYS: WINDOW; WHOLIN.#"


(DEFUN WHO-LINE-RUN-STATE-UPDATE
       (&AUX P)			;Separate variable since other can be setq'ed
				; asynchronously by other processes.
  (SETQ LAST-WHO-LINE-PROCESS
	(SETQ P (OR WHO-LINE-PROCESS
		 (PROGN (AND (NULL SELECTED-IO-BUFFER)
			     (NOT (NULL SELECTED-WINDOW))   ;This can happen.
			     (SETQ SELECTED-IO-BUFFER
				   (FUNCALL SELECTED-WINDOW :IO-BUFFER)))
		   (AND SELECTED-IO-BUFFER
			(IO-BUFFER-LAST-OUTPUT-PROCESS
			  SELECTED-IO-BUFFER))))))
  (SETQ WHO-LINE-RUN-STATE (COND ((NULL SELECTED-WINDOW)
				  "No selected window")
				 ((NULL P)
				  "No current process")
				 ((ASSOC P ACTIVE-PROCESSES :TEST #'EQ)
				  (PROCESS-WHOSTATE P))
				 ((NOT (NULL (SI:PROCESS-ARREST-REASONS P)))
				  "Arrest")
				 (T "Stop")))
  (cond
    (si:*sib-present* (WHO-LINE-UPDATE T))
    (t (without-interrupts  ; DAB 07-10-89 Make sure string does not change out from under us.
	 (copy-array-portion who-line-run-state 0 (LENGTH who-line-run-state)
			     mac-who-string 0 (- si:%MX-Who-State-String-Max 1)))))
  )
))
