;;; -*- Mode: Common-Lisp; Package: User; Base: 10.; Patch-File: T -*-

;;; Reason: Correct problem with negative clip origin.

;;;                           RESTRICTED RIGHTS LEGEND
;;;
;;; Use, duplication, or disclosure by the Government is subject to
;;; restrictions as set forth in subdivision (c)(1)(ii) of the Rights in
;;; Technical Data and Computer Software clause at 52.227-7013.
;;;
;;;   TEXAS INSTRUMENTS INCORPORATED      
;;;   P.O. BOX 2909, M/S 2151             
;;;   AUSTIN, TEXAS 78769                 
;;;
;;; Copyright (C) 1989 Texas Instruments Incorporated.
;;; All rights reserved.

;;; Patch file for X11M version 6.10
;;; Written 07/07/89 19:42:46 by buehring,
;;; while running on Spud from band LOD4
;;; With SYSTEM 6.10, VIRTUAL-MEMORY 6.1, EH 6.3, MAKE-SYSTEM 6.0, MICRONET 6.0, LOCAL-FILE 6.0,
;;;  BASIC-PATHNAME 6.1, NETWORK-SUPPORT-COLD 6.0, BASIC-NAMESPACE 6.1, NETWORK-NAMESPACE 6.0,
;;;  DISK-IO 6.0, DISK-LABEL 6.0, BASIC-FILE 6.2, MAC-PATHNAME 6.0, NETWORK-PATHNAME 6.0,
;;;  COMPILER 6.7, TV 6.12, DATALINK 6.0, CHAOSNET 6.0, GC 6.3, MEMORY-AUX 6.0, NVRAM 6.1,
;;;  SYSLOG 6.1, STREAMER-TAPE 6.4, UCL 6.0, INPUT-EDITOR 6.0, METER 6.1, ZWEI 6.3,
;;;  DEBUG-TOOLS 6.3, NETWORK-SUPPORT 6.0, NETWORK-SERVICE 6.1, DATALINK-DISPLAYS 6.0,
;;;  FONT-EDITOR 6.1, SERIAL 6.0, PRINTER 6.3, MAC-PRINTER-TYPES 6.1, PRINTER-TYPES 6.1,
;;;  IMAGEN 6.0, SUGGESTIONS 6.0, MAIL-DAEMON 6.2, MAIL-READER 6.1, TELNET 6.0, VT100 6.0,
;;;  NAMESPACE-EDITOR 6.0, PROFILE 6.1, VISIDOC 6.2, TI-CLOS 6.11, CLEH 6.4, IP 3.47,
;;;  Experimental BUG 11.10, Experimental CLX 6.2, CLUE 6.5, X11M 6.8,  microcode 429,
;;;  Band Name: Release 6.0 + SLE  6/26

#!C
; From file SYSDEPENDENT.LISP#> X11M.SERVER; MR-X:
#10R X11#:
(COMPILER-LET ((*PACKAGE* (FIND-PACKAGE "X11"))
                          (SI:*LISP-MODE* :COMMON-LISP)
                          (*READTABLE* SYS:COMMON-LISP-READTABLE)
                          (SI:*READER-SYMBOL-SUBSTITUTIONS* SYS::*COMMON-LISP-SYMBOL-SUBSTITUTIONS*))
  (COMPILER#:PATCH-SOURCE-FILE "SYS: X11M.SERVER; SYSDEPENDENT.#"


(DEFUN X-BITBLT-CLIPPED (X-ALU WIDTH HEIGHT SOURCE SOURCE-X SOURCE-Y DEST DEST-X DEST-Y)
  "Clip the width and height to the destination array, adjust for negative x/y coordinates, 
 and perform a bitblt."
  
  (LET ((DEST-WIDTH  (ARRAY-WIDTH  DEST))
	(DEST-HEIGHT (ARRAY-HEIGHT DEST))
	(SOURCE-WIDTH (ARRAY-WIDTH SOURCE))
	(SOURCE-HEIGHT (ARRAY-HEIGHT SOURCE))
	(WIDTH-SIGN WIDTH)
	(HEIGHT-SIGN HEIGHT))
    (SETQ WIDTH (ABS WIDTH))
    (SETQ HEIGHT (ABS HEIGHT))

    (WHEN (AND (< DEST-X DEST-WIDTH) (< DEST-Y DEST-HEIGHT))
      ;; If destination coord < 0, pretend copy begins outside of destination
      (WHEN (MINUSP DEST-X)
	(SETQ WIDTH (+ WIDTH DEST-X)
	      SOURCE-X (- SOURCE-X DEST-X)
	      DEST-X 0))
      (WHEN (MINUSP DEST-Y)
	(SETQ HEIGHT (+ HEIGHT DEST-Y)
	      SOURCE-Y (- SOURCE-Y DEST-X)
	      DEST-Y 0))
      ;; If source coord < 0, pretend copy begins from ouside source
      (WHEN (MINUSP SOURCE-X)
	(SETQ WIDTH (+ WIDTH SOURCE-X)
	      DEST-X (- DEST-X SOURCE-X)
	      SOURCE-X 0))
      (WHEN (MINUSP SOURCE-Y)
	(SETQ HEIGHT (+ HEIGHT SOURCE-Y)
	      DEST-Y (- DEST-Y SOURCE-Y)
	      SOURCE-Y 0))
      ;; Skip everything if any start point is beyond width/height of array
      (WHEN (AND (< DEST-X DEST-WIDTH) (< DEST-Y DEST-HEIGHT)
		 (< SOURCE-X SOURCE-WIDTH) (< SOURCE-Y SOURCE-HEIGHT))
	;; Adjust width to stay within array
	(WHEN (> (+ DEST-X WIDTH) DEST-WIDTH)
	  (SETQ WIDTH (- DEST-WIDTH DEST-X)))
	;; Adjust height to stay within array
	(WHEN (> (+ DEST-Y HEIGHT) DEST-HEIGHT)
	  (SETQ HEIGHT (- DEST-HEIGHT DEST-Y)))
	;; Set sign of width/height back to that specified by the caller.
	(WHEN (MINUSP WIDTH-SIGN)
	  (SETQ WIDTH (- WIDTH)))
	(WHEN (MINUSP HEIGHT-SIGN)
	  (SETQ HEIGHT (- HEIGHT)))
	(X-BITBLT X-ALU WIDTH HEIGHT SOURCE SOURCE-X SOURCE-Y DEST DEST-X DEST-Y)))))

))
