;;; -*- Mode: Common-Lisp; Package: User; Base: 10.; Patch-File: T -*-

;;; Reason: Fixes problem wherein a button-up event was not always
;;;  delivered to a client who had done a grab pointer.
;;;  Fixes SPRs 11076 and 11080.

;;;                           RESTRICTED RIGHTS LEGEND
;;;
;;; Use, duplication, or disclosure by the Government is subject to
;;; restrictions as set forth in subdivision (c)(1)(ii) of the Rights in
;;; Technical Data and Computer Software clause at 52.227-7013.
;;;
;;;   TEXAS INSTRUMENTS INCORPORATED      
;;;   P.O. BOX 2909, M/S 2151             
;;;   AUSTIN, TEXAS 78769                 
;;;
;;; Copyright (C) 1989 Texas Instruments Incorporated.
;;; All rights reserved.

;;; Written 05/18/90 13:29:34 by HAGY,
;;; while running on Zwingli from band LOD1
;;; With SYSTEM 6.25, VIRTUAL-MEMORY 6.2, EH 6.5, MAKE-SYSTEM 6.2, MICRONET 6.0, LOCAL-FILE 6.1,
;;;  BASIC-PATHNAME 6.2, NETWORK-SUPPORT-COLD 6.2, BASIC-NAMESPACE 6.7, NETWORK-NAMESPACE 6.0,
;;;  DISK-IO 6.1, DISK-LABEL 6.0, BASIC-FILE 6.6, MAC-PATHNAME 6.0, NETWORK-PATHNAME 6.0,
;;;  COMPILER 6.14, TV 6.19, DATALINK 6.0, CHAOSNET 6.5, GC 6.3, MEMORY-AUX 6.0, NVRAM 6.2,
;;;  SYSLOG 6.2, STREAMER-TAPE 6.5, UCL 6.0, INPUT-EDITOR 6.0, METER 6.1, ZWEI 6.8,
;;;  DEBUG-TOOLS 6.3, NETWORK-SUPPORT 6.0, NETWORK-SERVICE 6.2, DATALINK-DISPLAYS 6.0,
;;;  FONT-EDITOR 6.1, SERIAL 6.0, PRINTER 6.3, MAC-PRINTER-TYPES 6.1, PRINTER-TYPES 6.2,
;;;  IMAGEN 6.1, SUGGESTIONS 6.1, MAIL-DAEMON 6.3, MAIL-READER 6.6, TELNET 6.0, VT100 6.0,
;;;  NAMESPACE-EDITOR 6.4, PROFILE 6.2, VISIDOC 6.5, TI-CLOS 6.26, CLEH 6.5, IP 3.56,
;;;  Experimental CLX 6.7, CLUE 6.34, X11M 6.23, Experimental BUG 11.17,  microcode 430,
;;;  Band Name: REL 6.0 + SLE 11/28

#!C
; From file EVENTS.LISP#> X11M.SERVER; Hotel:
#10R X11#:
(COMPILER-LET ((*PACKAGE* (FIND-PACKAGE "X11"))
                          (SI:*LISP-MODE* :COMMON-LISP)
                          (*READTABLE* SYS:COMMON-LISP-READTABLE)
                          (SI:*READER-SYMBOL-SUBSTITUTIONS* SYS::*COMMON-LISP-SYMBOL-SUBSTITUTIONS*))
  (COMPILER#:PATCH-SOURCE-FILE "SYS: X11M.SERVER; EVENTS.#"


(DEFUN DELIVER-GRABBED-EVENT (EVENT THIS-DEV OTHER-DEV DEACTIVATE-GRAB)
  (DECLARE (TYPE EVENT-RECORD EVENT)
           (TYPE DEVICE THIS-DEV OTHER-DEV)
           (TYPE BOOLEAN DEACTIVATE-GRAB))
  (EVENT-TRACE-ENTERING "DELIVER-GRABBED-EVENT")
  (LET ((GRAB (DEVICE.GRAB THIS-DEV))
        (DELIVERIES 0))
    (DECLARE (TYPE GRAB-RECORD GRAB)
             (TYPE INTEGER DELIVERIES))
    (WHEN (OR (NULL (GRAB-RECORD.OWNER-EVENTS GRAB))
              (NOT (PLUSP (SETQ DELIVERIES (DELIVER-DEVICE-EVENTS
                                        (SPRITE.WINDOW SPRITE) EVENT GRAB NIL)))))
      ;; Either there is no grabber or there is a grabber & we could not
      ;;   deliver the event to the window
      (FIX-UP-EVENT-FROM-WINDOW EVENT (GRAB-RECORD.WINDOW GRAB) NIL T)
      (SETQ DELIVERIES (TRY-CLIENT-EVENTS (GRAB-RECORD.CLIENT GRAB) EVENT 1
                                          (GRAB-RECORD.EVENT-MASK GRAB)
                                          (AREF FILTERS (EVENT-U.TYPE EVENT))
                                          GRAB)))
    (IF (AND (PLUSP DELIVERIES)
             (= (EVENT-U.TYPE EVENT) MOTION-NOTIFY-EVENT))
	(SETQ MOTION-HINT-WINDOW (GRAB-RECORD.WINDOW GRAB))
        ;;ELSE
        (WHEN (AND (PLUSP DELIVERIES)
                   (NULL DEACTIVATE-GRAB))
          (LET ((SYNC-STATE (SYNC.STATE (DEVICE.SYNC THIS-DEV))))
            (WHEN (= SYNC-STATE FREEZE-BOTH-NEXT-EVENT)
              (SETF (SYNC.FROZEN (DEVICE.SYNC OTHER-DEV)) T)
              (IF (AND (= (SYNC.STATE (DEVICE.SYNC OTHER-DEV)) FREEZE-BOTH-NEXT-EVENT)
                       (EQ (GRAB-RECORD.CLIENT (DEVICE.GRAB OTHER-DEV))
                           (GRAB-RECORD.CLIENT (DEVICE.GRAB THIS-DEV))))
                  (SETF (SYNC.STATE (DEVICE.SYNC OTHER-DEV)) FROZEN-NO-EVENT)
                  ;;ELSE
                  (SETF (SYNC.OTHER (DEVICE.SYNC OTHER-DEV)) (DEVICE.GRAB THIS-DEV))))
            (WHEN (OR (= SYNC-STATE FREEZE-BOTH-NEXT-EVENT)
                      (= SYNC-STATE FREEZE-NEXT-EVENT))
              (SETF (SYNC.STATE  (DEVICE.SYNC THIS-DEV)) FROZEN-WITH-EVENT)
              (SETF (SYNC.FROZEN (DEVICE.SYNC THIS-DEV)) T)
              (SETF (SYNC.EVENT  (DEVICE.SYNC THIS-DEV)) EVENT))))))
  (EVENT-TRACE-LEAVING "DELIVER-GRABBED-EVENT"))
))
