;;; -*- Mode: Common-Lisp; Package: ZWEI; Base: 8.; Patch-File: T -*-

;;; Reason: Relevant-function-name was specical cases the following function(FUNCALL LEXPR-FUNCALL APPLY SEND LEXPR-SEND zlc:map MAPC MAPCAR MAPLIST MAPCAN MAPCON) and would return the function passed as the argument as the relevant function. This caused CRTL-SHIFT-D and CTRL-SHIFT-A to return argument list of the function following #' even when the cursor is position to the left. Now this special handling will only occur when the ZWEI variable *arglist-for-well-known-functions* is T, otherwise the function to the left os the cursor is returned for all cases. [10705]

;;;                           RESTRICTED RIGHTS LEGEND
;;;
;;; Use, duplication, or disclosure by the Government is subject to
;;; restrictions as set forth in subdivision (c)(1)(ii) of the Rights in
;;; Technical Data and Computer Software clause at 52.227-7013.
;;;
;;;   TEXAS INSTRUMENTS INCORPORATED      
;;;   P.O. BOX 2909, M/S 2151             
;;;   AUSTIN, TEXAS 78769                 
;;;
;;; Copyright (C) 1989 Texas Instruments Incorporated.
;;; All rights reserved.

;;; Patch file for ZWEI version 6.10
;;; Written 12/07/89 09:15:06 by BERGER,
;;; while running on ARIES from band LODX
;;; With SYSTEM 6.26, VIRTUAL-MEMORY 6.3, EH 6.5, MAKE-SYSTEM 6.2, MICRONET 6.0, LOCAL-FILE 6.1,
;;;  BASIC-PATHNAME 6.2, NETWORK-SUPPORT-COLD 6.2, BASIC-NAMESPACE 6.7, NETWORK-NAMESPACE 6.0,
;;;  DISK-IO 6.2, DISK-LABEL 6.0, BASIC-FILE 6.6, MAC-PATHNAME 6.0, NETWORK-PATHNAME 6.0,
;;;  COMPILER 6.14, TV 6.19, DATALINK 6.0, CHAOSNET 6.5, GC 6.3, MEMORY-AUX 6.0, NVRAM 6.2,
;;;  SYSLOG 6.2, STREAMER-TAPE 6.5, UCL 6.0, INPUT-EDITOR 6.0, METER 6.1, Inconsistent ZWEI 6.9,
;;;  DEBUG-TOOLS 6.3, NETWORK-SUPPORT 6.1, NETWORK-SERVICE 6.2, DATALINK-DISPLAYS 6.0,
;;;  FONT-EDITOR 6.1, SERIAL 6.0, PRINTER 6.3, MAC-PRINTER-TYPES 6.1, PRINTER-TYPES 6.2,
;;;  IMAGEN 6.1, SUGGESTIONS 6.1, MAIL-DAEMON 6.4, MAIL-READER 6.6, TELNET 6.0, VT100 6.0,
;;;  NAMESPACE-EDITOR 6.4, PROFILE 6.2, Inconsistent VISIDOC 6.7, TI-CLOS 6.26, CLEH 6.5,
;;;  IP 3.56, Experimental CLX 6.7, CLUE 6.35, X11M 6.18, Experimental BUG 11.17,
;;;  Experimental GLOSSARY 2.0,  microcode 429, Band Name: REL 6.0 + SLE 11/28

#!C
; From file DEFS.LISP#> ZMACS; SYS:
#8R ZWEI#:
(COMPILER-LET ((*PACKAGE* (FIND-PACKAGE "ZWEI"))
                          (SI:*LISP-MODE* :COMMON-LISP)
                          (*READTABLE* SYS:COMMON-LISP-READTABLE)
                          (SI:*READER-SYMBOL-SUBSTITUTIONS* SYS::*COMMON-LISP-SYMBOL-SUBSTITUTIONS*))
  (COMPILER#:PATCH-SOURCE-FILE "SYS: ZMACS; DEFS.#"


(defvar *Arglist-for-well-known-functions* nil  ; DAB 12-07-89
  ;;Used in RELEVANT-FUNCTION-NAME to determine which function is most relevant. Normally it is the function to the 
  ;;left of the cursor but for function to accept a function definition as an argument (i.e. (apply #'print ...))
  ;;the user may what to get the arg string of passed function even when the cursor is to the left of the #'.
  "This variable is used when displaying the argument list of a function. When NIL the function to the left of the cursor is used. When T and the function to the left is one of the following:FUNCALL,LEXPR-FUNCALL,APPLY,SEND,LEXPR-SEND,zlc:map,MAPC,MAPCAR,MAPLIST,MAPCAN,MAPCON the function passed is used.")
))

#!C
; From file PRIMIT.LISP#> ZMACS; SYS:
#8R ZWEI#:
(COMPILER-LET ((*PACKAGE* (FIND-PACKAGE "ZWEI"))
                          (SI:*LISP-MODE* :COMMON-LISP)
                          (*READTABLE* SYS:COMMON-LISP-READTABLE)
                          (SI:*READER-SYMBOL-SUBSTITUTIONS* SYS::*COMMON-LISP-SYMBOL-SUBSTITUTIONS*))
  (COMPILER#:PATCH-SOURCE-FILE "SYS: ZMACS; PRIMIT.#"


(DEFUN RELEVANT-FUNCTION-NAME (BP &OPTIONAL STRINGP (FUNCTION-ONLY T)
			       (FUNCALL-SPECIAL T) SUBSTITUTE-SECTION-NAME
			       &AUX START-BP X)
  "Return a function spec obtained from the text around BP.
STRINGP = T says print the spec into a string and return that.
FUNCTION-ONLY means only consider actually defined functions (default T).
FUNCALL-SPECIAL (default T) means if BP points inside a FUNCALL or SEND,
  see if it looks like sending a message and try to return
  a function spec for an existing method it might call.
SUBSTITUTE-SECTION-NAME means that for situations in which the relevant
  function would normally be DEFUN, DEFPACKAGE, or some other top-level
  defining form, instead of returning that defining form we return the
  name of the section it defines."
  ;; If we are in or next to a #' or what follows it,
  ;; set START-BP to point before it.  Otherwise START-BP is NIL.
  ;; We do not here detect #' preceding a list we are in; that is detected later.
  (COND ((LOOKING-AT BP "#'")
	 (SETQ START-BP BP))
	((LOOKING-AT (FORWARD-CHAR BP -1 T) "#'")
	 (SETQ START-BP (FORWARD-CHAR BP -1 T)))
	((LOOKING-AT (FORWARD-CHAR BP -2 T) "#'")
	 (SETQ START-BP (FORWARD-CHAR BP -2 T)))
	(T
	 (SETQ START-BP (FORWARD-SEXP BP -1 T))
	 (IF (NOT (LOOKING-AT START-BP "#'"))
	     (SETQ START-BP NIL)
	     (IF (BP-< (FORWARD-SEXP START-BP 1 T 0 (FORWARD-CHAR BP 1)) BP)
		 (SETQ START-BP NIL)))))
  ;; If START-BP was set, and the following thing is a good function, use that.
  (IF (AND START-BP
	   (LET ((SI::READ-INTERN-FUNCTION 'FIND-SYMBOL))
	     (DECLARE (SPECIAL SI::READ-INTERN-FUNCTION))
	     (SETQ X (BP-READ-OBJECT (FORWARD-CHAR START-BP 2))))
	   (OR (NOT FUNCTION-ONLY)
	       (ZMACS-DEFINEDP X)))
      (IF STRINGP
	  (WITH-OUTPUT-TO-STRING (*STANDARD-OUTPUT*)
	    (PRIN1 X))
	  X)
      ;; Otherwise, look up in list structure to find either
      ;; a function we are in a call to, or a level preceded by #'.
      (PROGN
	(SETQ START-BP (FORWARD-DEFUN BP -1 T))
	(DO ((BP1 BP)
	     (FIRST-TIME T NIL)
	     (FN-START)
	     (FN-END)
	     (X))
	    ((NULL (SETQ BP1 (FORWARD-SEXP BP1 -1 NIL 1 START-BP NIL)))
	     ;; If bp is at beginning of a defun, get the function it defines.
	     (AND FIRST-TIME
		  (TYPEP (BP-NODE BP) 'SECTION-NODE)
		  (SETQ X (SECTION-NODE-NAME (BP-NODE BP)))
		  (NOT (STRINGP X))
		  (IF STRINGP
		      (WITH-OUTPUT-TO-STRING (*STANDARD-OUTPUT*)
			(PRIN1 X))
		      X)))
	  ;; If this level of list structure is preceded by #',
	  ;; maybe return this whole list.
	  (AND (LOOKING-AT (FORWARD-CHAR BP1 -2 T) "#'")
	       (SETQ X (BP-READ-OBJECT BP1))
	       (OR (NOT FUNCTION-ONLY)
		   (ZMACS-DEFINEDP X))
	       (RETURN (IF STRINGP
			   (WITH-OUTPUT-TO-STRING (*STANDARD-OUTPUT*)
			     (PRIN1 X))
			   X)))
	  ;; Otherwise consider the function which is the car of this list.
	  (OR (SETQ FN-START (FORWARD-CHAR BP1))
	      (RETURN NIL))
	  (OR (SETQ FN-END (FORWARD-SEXP FN-START))
	      (RETURN NIL))
	  (COND ((AND (EQ (BP-LINE FN-START) (BP-LINE FN-END))
		      (LET ((SI::READ-INTERN-FUNCTION 'FIND-SYMBOL))
			(DECLARE (SPECIAL SI::READ-INTERN-FUNCTION))
			(SETQ X (BP-READ-OBJECT FN-START)))
		      (SYMBOLP X)
		      (OR (NOT FUNCTION-ONLY)
			  (ZMACS-DEFINEDP X)
			  (SI:MEMQ-ALTERNATED 'ARGLIST (SYMBOL-PLIST X))))
		 ;; If default is DEFUN, etc., get the function being defined.
		 (AND (TYPEP (BP-NODE FN-START) 'SECTION-NODE)
		      (= (BP-INDEX FN-START) 1)
		      (EQ (BP-LINE FN-START)
			  (SECTION-NODE-DEFUN-LINE (BP-NODE FN-START)))
		      (NOT (STRINGP (SECTION-NODE-NAME (BP-NODE FN-START))))
		      SUBSTITUTE-SECTION-NAME
		      (SETQ X (SECTION-NODE-NAME (BP-NODE FN-START))))
		 ;; Rather than one of certain well-known functionals,
		 ;; use the function to be passed to it.
		 (AND *Arglist-for-well-known-functions*  ; DAB 12-07-89 Only do this when the user wants.
		      (OR (MEMBER X '(FUNCALL LEXPR-FUNCALL APPLY SEND LEXPR-SEND	
					      zlc:map MAPC MAPCAR MAPLIST MAPCAN MAPCON)
				  :TEST #'EQ))
		      FUNCALL-SPECIAL
		      (SETQ FN-START (FORWARD-OVER *WHITESPACE-CHARS* FN-END))
		      (SETQ FN-END (FORWARD-SEXP FN-START))
		      (EQ (BP-LINE FN-START) (BP-LINE FN-END))
		      (LET* ((SI::READ-INTERN-FUNCTION 'FIND-SYMBOL)
			     (Y (BP-READ-OBJECT FN-START)))
			(DECLARE (SPECIAL SI::READ-INTERN-FUNCTION))
			(AND (CONSP Y)
			     (MEMBER (CAR Y) '(QUOTE FUNCTION) :TEST #'EQ)
			     (SYMBOLP (SETQ Y (CADR Y)))
			     (OR (NOT FUNCTION-ONLY)
				 (ZMACS-DEFINEDP Y))
			     (SETQ X Y))))
		 (RETURN (IF STRINGP
			     (WITH-OUTPUT-TO-STRING (*STANDARD-OUTPUT*)
			       (PRIN1 X))
			     X))))))))
))
