;;; -*- Mode: Common-Lisp; Package: User; Base: 8.; Patch-File: T -*-

;;; Reason: Prevent endless beeping if user tries to put dired buffer in ZTOP mode.

;;;                           RESTRICTED RIGHTS LEGEND
;;;
;;; Use, duplication, or disclosure by the Government is subject to
;;; restrictions as set forth in subdivision (c)(1)(ii) of the Rights in
;;; Technical Data and Computer Software clause at 52.227-7013.
;;;
;;;   TEXAS INSTRUMENTS INCORPORATED      
;;;   P.O. BOX 2909, M/S 2151             
;;;   AUSTIN, TEXAS 78769                 
;;;
;;; Copyright (C) 1989 Texas Instruments Incorporated.
;;; All rights reserved.

;;; Written 01/10/90 15:07:11 by MARKY,
;;; while running on LIBRA from band LODB
;;; With SYSTEM 6.23, VIRTUAL-MEMORY 6.2, EH 6.5, MAKE-SYSTEM 6.2, MICRONET 6.0, LOCAL-FILE 6.1,
;;;  BASIC-PATHNAME 6.2, NETWORK-SUPPORT-COLD 6.2, BASIC-NAMESPACE 6.6, NETWORK-NAMESPACE 6.0,
;;;  DISK-IO 6.1, DISK-LABEL 6.0, BASIC-FILE 6.6, MAC-PATHNAME 6.0, NETWORK-PATHNAME 6.0,
;;;  COMPILER 6.14, TV 6.19, DATALINK 6.0, CHAOSNET 6.5, GC 6.3, MEMORY-AUX 6.0, NVRAM 6.2,
;;;  SYSLOG 6.2, STREAMER-TAPE 6.4, UCL 6.0, INPUT-EDITOR 6.0, METER 6.1, ZWEI 6.8,
;;;  DEBUG-TOOLS 6.3, NETWORK-SUPPORT 6.0, NETWORK-SERVICE 6.2, DATALINK-DISPLAYS 6.0,
;;;  FONT-EDITOR 6.1, SERIAL 6.0, PRINTER 6.3, MAC-PRINTER-TYPES 6.1, PRINTER-TYPES 6.2,
;;;  IMAGEN 6.1, SUGGESTIONS 6.1, MAIL-DAEMON 6.3, MAIL-READER 6.6, TELNET 6.0, VT100 6.0,
;;;  NAMESPACE-EDITOR 6.4, PROFILE 6.2, VISIDOC 6.5, TI-CLOS 6.28, CLEH 6.5, IP 3.56,
;;;  Experimental CLX 6.7, CLUE 6.45, X11M 6.16, Experimental BUG 11.17, MMON 6.2,
;;;  Experimental SC 2.0, Experimental CLIO 12.0, Experimental CONFORMANCE-CHECKER 2.0,
;;;   microcode 429, Band Name: REL6-mmon-11/15/89

;;; SPR 10897 

#!C
; From file STREAM.LISP#> ZMACS; Hotel:
#8R ZWEI#:
(COMPILER-LET ((*PACKAGE* (FIND-PACKAGE "ZWEI"))
                          (SI:*LISP-MODE* :COMMON-LISP)
                          (*READTABLE* SYS:COMMON-LISP-READTABLE)
                          (SI:*READER-SYMBOL-SUBSTITUTIONS* SYS::*COMMON-LISP-SYMBOL-SUBSTITUTIONS*))
  (COMPILER#:PATCH-SOURCE-FILE "SYS: ZMACS; STREAM.#"


(DEFUN MAKE-ZTOP-COMMAND-HOOK (BUFFER WINDOW &AUX ZTOP-STREAM HOOK-CLOSURE HOOK)
  (when (eq :dired (node-special-type buffer)) (barf "Inappropriate mode for DIRED buffer"))	;; may 01/09/90 
  (SETQ *CURRENT-COMMAND-TYPE* 'ZTOP-MODE)
  (COND ((SETQ HOOK (ASSOC BUFFER *ZTOP-COMMAND-HOOK-ALIST* :TEST #'EQ))
	 (SETQ HOOK (CDR HOOK)
	       HOOK-CLOSURE (SYMBOL-FUNCTION HOOK)
	       ZTOP-STREAM (SYMEVAL-IN-CLOSURE HOOK-CLOSURE '*ZTOP-STREAM*))
	 (SEND ZTOP-STREAM :SET-STREAM-WINDOW WINDOW))
	(T
	 (SETQ ZTOP-STREAM
	       (LET ((INIT-PLIST (LIST :*STREAM-SHEET* WINDOW
				       :*ZMACS-SG* SYSTEM:%CURRENT-STACK-GROUP
				       :BUFFER BUFFER)))
		 (INSTANTIATE-FLAVOR 'ZTOP-STREAM-FROM-WINDOW (LOCF INIT-PLIST)
				     T NIL W:SHEET-AREA)))
	 (SEND BUFFER :PUTPROP ZTOP-STREAM 'ZTOP-STREAM)
	 (SETQ HOOK-CLOSURE (LET-CLOSED ((*ZTOP-INTERVAL* BUFFER)
					 (*ZTOP-STREAM* ZTOP-STREAM))
			      #'(LAMBDA (IGNORE)
				  (AND (EQ *INTERVAL* *ZTOP-INTERVAL*)
				       (SEND *ZTOP-STREAM* :COMMAND-HOOK *CURRENT-COMMAND-TYPE*))))
	       HOOK (GENSYM))
	 (FDEFINE HOOK HOOK-CLOSURE T NIL)
	 (SETF (GET HOOK 'COMMAND-HOOK-PRIORITY) 1000)
	 (PUSH (CONS BUFFER HOOK) *ZTOP-COMMAND-HOOK-ALIST*)
	 (SETQ *ZTOP-EDITING* NIL
	       *ZTOP-READING-INPUT* T
	       *ZTOP-ACTIVATION-NEEDED* NIL)))
  HOOK)
))
