;;; -*- Mode: Common-Lisp; Package: User; Base: 8.; Patch-File: T -*-

;;; Reason: Customization changes for ED function using new generic function EDIT-THING.
;;; Also Allow ctrl-meta-. on terminal and system keys and change to split off a new
;;; 'long-documentation function from COM-LONG-DOCUMENTATION.
;;;                           RESTRICTED RIGHTS LEGEND
;;;
;;; Use, duplication, or disclosure by the Government is subject to
;;; restrictions as set forth in subdivision (c)(1)(ii) of the Rights in
;;; Technical Data and Computer Software clause at 52.227-7013.
;;;
;;;   TEXAS INSTRUMENTS INCORPORATED      
;;;   P.O. BOX 2909, M/S 2151             
;;;   AUSTIN, TEXAS 78769                 
;;;
;;; Copyright (C) 1989 Texas Instruments Incorporated.
;;; All rights reserved.

;;; Written 05/21/90 14:15:33 by MARKY,
;;; while running on LIBRA from band LODB
;;; With SYSTEM 6.23, VIRTUAL-MEMORY 6.2, EH 6.5, MAKE-SYSTEM 6.2, MICRONET 6.0, LOCAL-FILE 6.1,
;;;  BASIC-PATHNAME 6.2, NETWORK-SUPPORT-COLD 6.2, BASIC-NAMESPACE 6.6, NETWORK-NAMESPACE 6.0,
;;;  DISK-IO 6.1, DISK-LABEL 6.0, BASIC-FILE 6.6, MAC-PATHNAME 6.0, NETWORK-PATHNAME 6.0,
;;;  COMPILER 6.14, TV 6.19, DATALINK 6.0, CHAOSNET 6.5, GC 6.3, MEMORY-AUX 6.0, NVRAM 6.2,
;;;  SYSLOG 6.2, STREAMER-TAPE 6.4, UCL 6.0, INPUT-EDITOR 6.0, METER 6.1, ZWEI 6.8,
;;;  DEBUG-TOOLS 6.3, NETWORK-SUPPORT 6.0, NETWORK-SERVICE 6.2, DATALINK-DISPLAYS 6.0,
;;;  FONT-EDITOR 6.1, SERIAL 6.0, PRINTER 6.3, MAC-PRINTER-TYPES 6.1, PRINTER-TYPES 6.2,
;;;  IMAGEN 6.1, SUGGESTIONS 6.1, MAIL-DAEMON 6.3, MAIL-READER 6.6, TELNET 6.0, VT100 6.0,
;;;  NAMESPACE-EDITOR 6.4, PROFILE 6.2, VISIDOC 6.5, TI-CLOS 6.26, CLEH 6.5, IP 3.56,
;;;  Experimental CLX 6.7, CLUE 6.32, X11M 6.16, Experimental BUG 11.17, MMON 6.2,
;;;   microcode 429, Band Name: REL6-mmon-11/15/89

;;; 1. Change to allow ctrl-meta-. edit system and terminal keys, too.
;;; 2. Changes/additions to edit-thing to customize the behavior of the 'ED function.

#!C
; From file ZMACS.LISP#> ZMACS; Hotel:
#8R ZWEI#:
(COMPILER-LET ((*PACKAGE* (FIND-PACKAGE "ZWEI"))
                          (SI:*LISP-MODE* :COMMON-LISP)
                          (*READTABLE* SYS:COMMON-LISP-READTABLE)
                          (SI:*READER-SYMBOL-SUBSTITUTIONS* SYS::*COMMON-LISP-SYMBOL-SUBSTITUTIONS*))
  (COMPILER#:PATCH-SOURCE-FILE "SYS: ZMACS; ZMACS.#"


(DEFCOM COM-EDIT-ZMACS-COMMAND "Edit the function installed on a specified key.
Meta-X and Control-X sequences are permissible too.
Relevant Zmacs variables:
  Edit Definition Is Read Only
  Find Patch Definitions Too" ()
 (let-globally  ((tv:kbd-global-asynchronous-characters nil)) ;; edit term and system keys, too. may 05/21/90 
  (PROMPT-LINE "Key whose command to edit: ")
  (CLEAR-PROMPTS)
  (ALWAYS-DISPLAY-PROMPTS)
  (DO ((COMTAB *COMTAB*)
       (KEY (INPUT-WITH-PROMPTS *STANDARD-INPUT* :READ-MOUSE-OR-KBD)
	    (INPUT-WITH-PROMPTS *STANDARD-INPUT* :TYI))
       (COMMAND))
      (NIL)
    (RECORD-MINI-BUFFER-VALUE T)
    (SETQ COMMAND (COMMAND-LOOKUP KEY COMTAB))
    (IF (EQUAL KEY #\c-m-Y)		  ; From patch 94.163, ddd/gsl 3/1/84.
	(IF COMMAND
	    (PROGN
	      (BEEP)
	      (IF (FQUERY '(:CHOICES (((T "Yank") #\Y #\y)	  ;gsl 4-13-85
				      ((NIL "Edit") #\E #\e)))
			  "Do you want to yank or edit? ")
		  (SETQ KEY :YANK)))
	    (SETQ KEY :YANK)))
    (COND ((EQ KEY :YANK)
	   (LET ((*OUTER-LEVEL-MINI-BUFFER-COMMAND* *MINI-BUFFER-COMMAND*))
	     (COM-POP-MINIBUFFER-HISTORY)))	  ;gsl 4-13-85
	  ((AND (PREFIX-COMMAND-P COMMAND)
		(NOT *NUMERIC-ARG-P*))
	   (SETQ COMTAB (SYMEVAL-IN-CLOSURE COMMAND 'COMTAB)))
	  ;; may 05/21/90  Start patch ... (in lowercase)
	  ((and
	     (MEMBER COMMAND '(NIL :UNDEFINED) :TEST #'EQ)
	     (member key '(#\term #\system) :test #'char-equal)
	     (let* ((async-key key)
		    (key (char-upcase (INPUT-WITH-PROMPTS *STANDARD-INPUT* :TYI)))
		    (command (cadr (selector async-key char-equal
				     (#\term   (assoc key tv:*terminal-keys* :test #'char=))
				     (#\system (assoc key tv:*system-keys*
						      :test #'(lambda (item1 item2)
								(and item1 item2 (char= item1 item2)))))))))
	       ;; no code for numeric-args here ... I don't think it is necessary?
	       (cond (command
		      (when (consp command) ;; probably a form, not a symbol to funcall
			(let ((real-command (car command)))
			  (if (y-or-n-p "~s is installed on ~c-~c. Edit ~s ?"
					command async-key key real-command)
			      (setq command real-command)
			      (return dis-none))
			  (unless (and real-command (symbolp real-command) (FBOUNDP real-command))
			    (barf "~s is not defined."))))
		      
		      (SEND *QUERY-IO* :REMAKE-INCOMPLETE)
		      (FORMAT *QUERY-IO* "(~S)" COMMAND)
		      (return (EDIT-DEFINITION command)))
		     (t t ;; fall into error below ..
			))))
	   ;; may 05/21/90  ... End patch
	   (SEND *QUERY-IO* :REMAKE-INCOMPLETE)
	   (FORMAT *QUERY-IO* "is not a defined key.")
	   (BARF))
	  ((AND (SYMBOLP COMMAND) (NOT (FBOUNDP COMMAND)))
	   (BARF "~S is not implemented." COMMAND))
	  (T
	   (SETQ COMMAND (FUNCTION-NAME COMMAND))
	   (OR *NUMERIC-ARG-P*
	       (LET ((COMPLETION (CASE COMMAND
				       (COM-EXTENDED-COMMAND
					(GET-EXTENDED-COMMAND "Edit Extended command:" *COMTAB*))
				       (COM-ANY-EXTENDED-COMMAND
					(GET-ANY-EXTENDED-COMMAND "Edit command:")))))
		 (COND ((STRINGP COMPLETION)
			(BARF))
		       (COMPLETION
			(SETQ COMMAND (CDR COMPLETION)))
		       (T
			(SEND *QUERY-IO* :REMAKE-INCOMPLETE)
			(FORMAT *QUERY-IO* "(~S)" COMMAND)))))
	   (RETURN (EDIT-DEFINITION COMMAND))))))
  (IF *EDIT-DEFINITION-IS-READ-ONLY*
      (MAKE-BUFFER-READ-ONLY *INTERVAL*))
  DIS-NONE)


;;; may 05/21/90  for DNG
;;; Define a new version of function ZWEI::EDIT-THING that permits 
;;; users to customize the behavior of the ED function by writing methods for 
;;; the generic function ZWEI:FIND-SOURCE.
;;;  Also added the find-source methods below.

(DEFUN EDIT-THING (THING &AUX (*CURRENT-COMMAND* 'ZED))
  "Select buffer or file according to THING.  Used within the editor.
If THING is T, select a newly created buffer.
If it is a string or pathname, find that file.
If it is a zmacs-buffer, visit that buffer.
If it is a list whose car is CALLERS-TO-BE-EDITED
 or FUNCTIONS-TO-BE-EDITED,
 make possibilities for them and visit the first one.
If it is a function or function spec, visit that function's definition."
  (MUST-REDISPLAY *WINDOW* DIS-TEXT)
  (COND ((EQ THING T)
	 (MAKE-BUFFER-CURRENT (CREATE-ONE-BUFFER-TO-GO)))
	(t (multiple-value-bind (name kind pathname function)
	       (find-source thing)
	     (cond (function
		    (funcall function thing))
		   (name
		    (edit-definition name (list name) nil pathname
				     (case kind
				       (FUNCTION 'defun)
				       (VARIABLE 'defvar)
				       (TYPE 'clos:defclass)
				       (STRUCTURE 'defstruct)
				       (SETF 'defun)
				       (otherwise (if (and (symbolp kind) (fboundp kind))
						      kind
						    nil)))))
		   (pathname (FIND-DEFAULTED-FILE pathname))
		   (t (BARF "Don't know how to edit ~S" THING)))))))

(clos:defgeneric find-source (object)
  (declare (values name kind pathname handler))
  (:documentation "This is used by the ED function to find the source file for the object to be edited.
Methods can be added to specify what ED should do with objects of a particular class.
Methods can return a symbol or function spec to be edited, with an optional 
second value indicating the kind of definition -- FUNCTION, VARIABLE, etc. 
like the second argument of DOCUMENTATION.  Alternatively, a file pathname can 
be returned as the third value with the first two values NIL.  If all 3 values 
are NIL, a \"Don't know how to edit\" error is reported."
		  ))

(defmethod find-source ((thing t))
  (values nil nil nil))
(defmethod find-source ((thing string))
  (values nil nil thing))

(defmethod find-source ((thing pathname))
  (values nil nil
	  (if (eq (send thing :type) :unspecific)
	      (send thing :source-pathname)
	    (if (eq (send thing :version) :unspecific)
		(send thing :new-version :newest)
	      thing))))

(defmethod find-source ((thing ZMACS-BUFFER))
  (values nil nil nil #'MAKE-BUFFER-CURRENT))
(defmethod find-source ((thing symbol))
  (values thing nil nil))

(defmethod find-source ((thing cons))
  (let ((name nil) (kind nil) (function nil))
    (cond ((EQ (CAR THING) 'CALLERS-TO-BE-EDITED)
	   (setq function
		 #'(lambda (thing)
		     (LIST-ZMACS-CALLERS-TO-BE-EDITED "callers" NIL T
						      (SETUP-ZMACS-CALLERS-TO-BE-EDITED (CDR THING))))))
	  ((EQ (CAR THING) 'FUNCTIONS-TO-BE-EDITED)
	   (setq function
		 #'(lambda (thing)
		     (LIST-ZMACS-CALLERS-TO-BE-EDITED "functions waiting to be edited" NIL T
						      (SETUP-ZMACS-CALLERS-TO-BE-EDITED (CDR THING))))))
	  ((EQ (CAR THING) 'DIRECTORY)
	   (setq function
		 #'(lambda (thing)
		     (IF (= (LENGTH (CDR THING)) 1)
			 (DIRECTORY-EDIT (CADR THING))
		       (DIRECTORY-EDIT-MULTIPLE NIL (CDR THING))))))
	  ((EQ (CAR THING) 'SOURCE-COMPARE-MERGE)
	   (setq function
		 #'(lambda (thing)
		     (APPLY 'SOURCE-COMPARE-MERGE-1 (CDR THING)))))
	  ((SYSTEM:VALIDATE-FUNCTION-SPEC THING)
	   (setq name thing))
	  ((FUNCTIONP THING T)
	   (setq name (FUNCTION-NAME THING))
	   (setq kind 'function)))
    (values name kind nil function)))

(defmethod find-source ((thing function))
  (values (FUNCTION-NAME THING) 'function))

(defmethod find-source ((thing clos:generic-function))
  (values (clos:generic-FUNCTION-NAME THING) 'function))

(defmethod find-source ((thing clos:class))
  (values (clos:class-name THING) 'clos:defclass))

(defmethod find-source ((thing ticlos:flavor-class))
  (values (clos:class-name THING) 'defflavor))

(defmethod find-source ((thing ticlos:structure-class))
  (values (clos:class-name THING) 'defstruct))

(defmethod find-source ((thing ticlos:class-description))
  (find-source (ticlos:class-description-class-object thing)))

(defmethod find-source ((thing clos:method))
  (find-source (clos:method-function THING)))

(defmethod find-source ((thing package))
  (values (intern (package-name thing) *user-package*)
	  'defpackage))

(defmethod find-source ((thing clos:standard-object))
  (find-source (clos:class-of thing)))

(defmethod find-source ((thing clos:structure-object))
  (values (named-structure-p thing) 'defstruct))

(defmethod find-source ((thing si:vanilla-flavor))
  (values (type-of thing) 'defflavor))

(defmethod find-source ((thing sys:system))
  (let ((keyword (sys:system-symbolic-name thing)))
    (values keyword
	    'defsystem
	    (sys:get-source-file-name keyword 'defsystem))))
;; may 05/21/90  ... End patch

))

#!C
; From file MOUSE.LISP#> ZMACS; Hotel:
#8R ZWEI#:
(COMPILER-LET ((*PACKAGE* (FIND-PACKAGE "ZWEI"))
                          (SI:*LISP-MODE* :COMMON-LISP)
                          (*READTABLE* SYS:COMMON-LISP-READTABLE)
                          (SI:*READER-SYMBOL-SUBSTITUTIONS* SYS::*COMMON-LISP-SYMBOL-SUBSTITUTIONS*))
  (COMPILER#:PATCH-SOURCE-FILE "SYS: ZMACS; MOUSE.#"


(DEFUN READ-FUNCTION-NAME-COMMAND-HOOK (CHAR-OR-T)
  (DECLARE (SPECIAL READ-FUNCTION-NAME-MUST-BE-DEFINED
		    READ-FUNCTION-NAME-OLD-GLOBAL-MOUSE-CHAR-BLINKER-HANDLER
		    READ-FUNCTION-NAME-OLD-GLOBAL-MOUSE-CHAR-BLINKER-DOCUMENTATION-STRING
		    READ-FUNCTION-NAME-OLD-MOUSE-FONT-CHAR
		    READ-FUNCTION-NAME-OLD-MOUSE-X-OFFSET
		    READ-FUNCTION-NAME-OLD-MOUSE-Y-OFFSET))
  (COND ((AND (NEQ CHAR-OR-T T)
	      (BP-= (INTERVAL-FIRST-BP (WINDOW-INTERVAL *MINI-BUFFER-WINDOW*))
		    (INTERVAL-LAST-BP (WINDOW-INTERVAL *MINI-BUFFER-WINDOW*))))
	 (WITHOUT-INTERRUPTS                                                                ;;gsl
	   (SETQ *GLOBAL-MOUSE-CHAR-BLINKER-HANDLER* (IF READ-FUNCTION-NAME-MUST-BE-DEFINED
							 #'BLINK-FUNCTION
							 #'BLINK-ATOM)
		 *GLOBAL-MOUSE-CHAR-BLINKER-DOCUMENTATION-STRING* "Click left on highlighted name to select it."
		 *MOUSE-HOOK* #'(LAMBDA (WINDOW CHAR IGNORE IGNORE &AUX TEM)
				  (AND (CHAR= CHAR #\MOUSE-L)
				       (MULTIPLE-VALUE-BIND (FCTN LINE START END)
					   (ATOM-UNDER-MOUSE WINDOW)
					 (WHEN (AND LINE
						    (OR (FBOUNDP (SETQ TEM FCTN))
							(GET TEM :SOURCE-FILE-NAME)
							(GET TEM 'ZMACS-BUFFERS)
							(STRING-IN-AARRAY-P TEM *ZMACS-COMPLETION-AARRAY*)
                                                        (keywordp fctn) ;; may 05/08/89 Allow keywords
							(member 'compiler::init-system-var-properties	;; may 05/21/90
								(SYMBOL-PLIST tem) :test #'eq) 		;; may 05/21/90
							(AND (NOT READ-FUNCTION-NAME-MUST-BE-DEFINED) TEM)))
					   (LET ((INT (WINDOW-INTERVAL *MINI-BUFFER-WINDOW*)))
					     (DELETE-INTERVAL INT)
					     (INSERT (INTERVAL-FIRST-BP INT) LINE START END))
					   (THROW 'RETURN-FROM-COMMAND-LOOP
						  (SUBSEQ LINE START END))))))
		 *MOUSE-FONT-CHAR* 0
		 *MOUSE-X-OFFSET* 4
		 *MOUSE-Y-OFFSET* 0
		 *SAVED-MOUSE-STATE* (LIST *GLOBAL-MOUSE-CHAR-BLINKER-HANDLER*              ;;gsl
					   *GLOBAL-MOUSE-CHAR-BLINKER-DOCUMENTATION-STRING* ;;gsl
					   *MOUSE-HOOK* *MOUSE-FONT-CHAR*                   ;;gsl
					   *MOUSE-X-OFFSET* *MOUSE-Y-OFFSET*)))             ;;gsl
	 (W:MOUSE-SET-BLINKER-DEFINITION :CHARACTER *MOUSE-X-OFFSET* *MOUSE-Y-OFFSET*
					  :ON :SET-CHARACTER *MOUSE-FONT-CHAR*))
	(T
	 (WITHOUT-INTERRUPTS                                                                ;;gsl
	   (SEND *GLOBAL-MOUSE-CHAR-BLINKER* :SET-VISIBILITY NIL)
	   (SETQ *SAVED-MOUSE-STATE*                                                             ;;gsl & next 6 lines
		 (LIST READ-FUNCTION-NAME-OLD-GLOBAL-MOUSE-CHAR-BLINKER-HANDLER
		       READ-FUNCTION-NAME-OLD-GLOBAL-MOUSE-CHAR-BLINKER-DOCUMENTATION-STRING
		       NIL
		       READ-FUNCTION-NAME-OLD-MOUSE-FONT-CHAR
		       READ-FUNCTION-NAME-OLD-MOUSE-X-OFFSET
		       READ-FUNCTION-NAME-OLD-MOUSE-Y-OFFSET)
		 *GLOBAL-MOUSE-CHAR-BLINKER-HANDLER*
		 READ-FUNCTION-NAME-OLD-GLOBAL-MOUSE-CHAR-BLINKER-HANDLER
		 *GLOBAL-MOUSE-CHAR-BLINKER-DOCUMENTATION-STRING*
		 READ-FUNCTION-NAME-OLD-GLOBAL-MOUSE-CHAR-BLINKER-DOCUMENTATION-STRING
		 *MOUSE-HOOK* NIL
		 *MOUSE-FONT-CHAR* READ-FUNCTION-NAME-OLD-MOUSE-FONT-CHAR
		 *MOUSE-X-OFFSET* READ-FUNCTION-NAME-OLD-MOUSE-X-OFFSET
		 *MOUSE-Y-OFFSET* READ-FUNCTION-NAME-OLD-MOUSE-Y-OFFSET))
	 (W:MOUSE-SET-BLINKER-DEFINITION :CHARACTER *MOUSE-X-OFFSET* *MOUSE-Y-OFFSET*
					  :ON :SET-CHARACTER *MOUSE-FONT-CHAR*)))
  (SYSTEM:MOUSE-WAKEUP))

(DEFUN BLINK-FUNCTION (BLINKER WINDOW CHAR X Y LINE INDEX &OPTIONAL NOT-DEFINED-OK &AUX SYMBOL BEG END SHEET)
  (COND ((> W:MOUSE-SPEED *BLINKING-FUNCTION-MAXIMUM-MOUSE-SPEED*)
	 (W:BLINKER-SET-VISIBILITY BLINKER NIL))	;Moving too fast, forget it
	(T
	 (MULTIPLE-VALUE-SETQ (SYMBOL NIL BEG END)
	   (ATOM-UNDER-MOUSE WINDOW CHAR X Y LINE INDEX))
	 (COND ((AND (NOT (NULL BEG))
		     (OR NOT-DEFINED-OK
			 (FBOUNDP SYMBOL)
                         (keywordp symbol) ;; may 05/08/89 Allow keywords, too
			 (member 'compiler::init-system-var-properties (SYMBOL-PLIST symbol) :test #'eq) ;; may 05/21/90  
			 (GET SYMBOL 'ZMACS-BUFFERS)
			 (GET SYMBOL :SOURCE-FILE-NAME)
			 (STRING-IN-AARRAY-P SYMBOL *ZMACS-COMPLETION-AARRAY*)))
		(SETQ SHEET (WINDOW-SHEET WINDOW))
		(W:BLINKER-SET-SHEET BLINKER SHEET)
		(SHEET-SET-BLINKER-CURSORPOS SHEET
					     BLINKER
					     (- X (W:SHEET-STRING-LENGTH SHEET LINE BEG INDEX))
					     Y)
		(W:BLINKER-SET-SIZE BLINKER
				     (W:SHEET-STRING-LENGTH SHEET LINE BEG END)
				     (W:FONT-CHAR-HEIGHT (AREF (W:SHEET-FONT-MAP SHEET) (CHAR-FONT CHAR))))
		(W:BLINKER-SET-VISIBILITY BLINKER T))
	       (T
		(W:BLINKER-SET-VISIBILITY BLINKER NIL))))))

(DEFUN READ-FUNCTION-NAME (PROMPT &OPTIONAL DEFAULT MUST-BE-DEFINED STRINGP HELP ;;gsl 3-14-85
			   &AUX EXPLICIT-PACKAGE-P PROMPT-WITHOUT-DEFAULT
			   (*MINI-BUFFER-DEFAULT-STRING*
			     (and default (prin1-to-string 	;; may 05/09/90
					    DEFAULT)))
			   (READ-FUNCTION-NAME-MUST-BE-DEFINED
			     MUST-BE-DEFINED)
			   (READ-FUNCTION-NAME-OLD-GLOBAL-MOUSE-CHAR-BLINKER-HANDLER
			     *GLOBAL-MOUSE-CHAR-BLINKER-HANDLER*)
			   (READ-FUNCTION-NAME-OLD-GLOBAL-MOUSE-CHAR-BLINKER-DOCUMENTATION-STRING
			     *GLOBAL-MOUSE-CHAR-BLINKER-DOCUMENTATION-STRING*)
			   (READ-FUNCTION-NAME-OLD-MOUSE-FONT-CHAR *MOUSE-FONT-CHAR*)
			   (READ-FUNCTION-NAME-OLD-MOUSE-X-OFFSET *MOUSE-X-OFFSET*)
			   (READ-FUNCTION-NAME-OLD-MOUSE-Y-OFFSET *MOUSE-Y-OFFSET*))
  "Read a function name using mini buffer or mouse.
PROMPT is a string that goes in the mode line.
DEFAULT is a function spec to return if the user types just Return.
MUST-BE-DEFINED can be T (allow only defined functions), NIL (allow anything)
 or AARRAY-OK (allow anything either defined as a function
 or known as a section by the editor).
STRINGP can be T, NIL, ALWAYS-READ or MULTIPLE-OK.
 T means if user types text, just return a string; don't try to intern it.
 ALWAYS-READ means intern the user's string afresh now;
  don't use the symbol or list recorded in the completion aarray.
 MULTIPLE-OK means it is ok to return more than one possible function
  the user could have meant, if they differ only in their package.

The first value is a list of function specs (only one, unless STRINGP is MULTIPLE-OK).
 If STRINGP is T, this is NIL.
The second value is the string the user typed, sans package prefix.
The third value is T if the user typed a package prefix."
  (DECLARE (VALUES COMPLETIONS STRING EXPLICIT-PACKAGE-P))
  (DECLARE (SPECIAL READ-FUNCTION-NAME-MUST-BE-DEFINED
		    READ-FUNCTION-NAME-OLD-GLOBAL-MOUSE-CHAR-BLINKER-HANDLER
		    READ-FUNCTION-NAME-OLD-GLOBAL-MOUSE-CHAR-BLINKER-DOCUMENTATION-STRING
		    READ-FUNCTION-NAME-OLD-MOUSE-FONT-CHAR
		    READ-FUNCTION-NAME-OLD-MOUSE-X-OFFSET
		    READ-FUNCTION-NAME-OLD-MOUSE-Y-OFFSET))
  (SYS:WITH-SUGGESTIONS-MENUS-FOR ZWEI:READ-FUNCTION-NAME
    (WHEN (EQ MUST-BE-DEFINED T)
      (SETQ STRINGP 'ALWAYS-READ))
    (SETQ PROMPT-WITHOUT-DEFAULT PROMPT
	  PROMPT (FORMAT NIL "~A~:[:~; (Default: ~S)~]" PROMPT DEFAULT DEFAULT))
    (LET ((NAME (LET ((*POST-COMMAND-HOOK* (APPEND *POST-COMMAND-HOOK* '(READ-FUNCTION-NAME-COMMAND-HOOK)))
		      (*MINI-BUFFER-VALUE-HISTORY* *DEFINITION-NAME-HISTORY*))
		  (LET ((*BATCH-UNDO-SAVE* T))
		    (DELETE-INTERVAL (WINDOW-INTERVAL *MINI-BUFFER-WINDOW*)))
		  (UNWIND-PROTECT
		      (PROGN
			(READ-FUNCTION-NAME-COMMAND-HOOK NIL)
			(COMPLETING-READ-FROM-MINI-BUFFER PROMPT *ZMACS-COMPLETION-AARRAY*
							  (OR (NEQ STRINGP 'ALWAYS-READ)
							      'ALWAYS-STRING)
							  NIL HELP)) ;;gsl 3-14-85
		    (READ-FUNCTION-NAME-COMMAND-HOOK T))))
	  SYM
	  ERROR-P)
      (COND ((EQUAL NAME "")
	     (UNLESS DEFAULT (BARF))
	     (SETQ SYM DEFAULT
		   NAME (IF (SYMBOLP NAME)
			    (STRING NAME)
			    (WITH-OUTPUT-TO-STRING (*STANDARD-OUTPUT*) (PRINC DEFAULT)))))
	    ((CONSP NAME)
	     (SETQ SYM (CDR NAME)
		   NAME (CAR NAME))
	     (WHEN (AND (CONSP SYM)
			(NEQ STRINGP 'MULTIPLE-OK))
	       (SETQ SYM (CAR SYM))))
	    ((EQ STRINGP T)			;If returning a string, don't intern it
	     (SETQ SYM NAME))
	    (T
	     ;; If the string that was specified started with a package prefix,
	     ;; return a flag saying so.
	     ;; SYMBOL-FROM-STRING will flush the prefix from NAME.
	     (LET ((NON-LETTER-INDEX (STRING-SEARCH-NOT-SET " ABCDEFGHIJKLMNOPQRSTUVWXYZ-" NAME)))
	       (COND ((AND NON-LETTER-INDEX
			   (plusp non-letter-index) ;; may 05/08/89 Allow keywords with no package prefix
			   (CHAR= (AREF NAME NON-LETTER-INDEX) #\:))
		      (SETQ EXPLICIT-PACKAGE-P T))))
	     (MULTIPLE-VALUE-SETQ (SYM NAME ERROR-P)
	       (SYMBOL-FROM-STRING NAME NIL T))
	     (COND ((AND (CONSP SYM)
			 (EQ STRINGP 'MULTIPLE-OK))
		    (SETQ SYM (CONS SYM NIL))))
	     (COND (ERROR-P
		    (BARF "Read error")))))
      (COND ((AND (EQ MUST-BE-DEFINED T)
		  (NOT (OR (FDEFINEDP SYM)
			   (AND (SYMBOLP SYM)
				(SI:MEMQ-ALTERNATED 'ARGLIST (SYMBOL-PLIST SYM))))))
	     (COND ((NOT (DOLIST (SPEC (PACKAGE-LOOKALIKE-SYMBOLS SYM))
			   (COND ((FQUERY '(:SELECT T)
					  ;; Always print prefix
					  ;; Don't leave PACKAGE in keyword during query.
					  (LET ((*PACKAGE* PKG-KEYWORD-PACKAGE))
					    (FORMAT NIL "Do you mean ~S? " SPEC)))
				  (RETURN (SETQ SYM SPEC))))))
		    (BARF "~S is not defined" SYM)))))
      (PUSH-ON-HISTORY SYM *DEFINITION-NAME-HISTORY*)
      (PROMPT-LINE "~A ~S" PROMPT-WITHOUT-DEFAULT
		   (IF (AND (EQ STRINGP 'MULTIPLE-OK)
			    (NOT (ATOM SYM)))
		       (FIRST SYM)
		       SYM))
      (VALUES SYM NAME EXPLICIT-PACKAGE-P))))

))

#!C
; From file COMF.LISP#> ZMACS; MR-X:
#8R ZWEI#:
(COMPILER-LET ((*PACKAGE* (FIND-PACKAGE "ZWEI"))
                          (SI:*LISP-MODE* :COMMON-LISP)
                          (*READTABLE* SYS:COMMON-LISP-READTABLE)
                          (SI:*READER-SYMBOL-SUBSTITUTIONS* SYS::*COMMON-LISP-SYMBOL-SUBSTITUTIONS*))
  (COMPILER#:PATCH-SOURCE-FILE "SYS: ZMACS; COMF.#"



;; may 01/20/89 Changed documentation string and 'structure test.
;; may 04/20/89 Allowed meta-sh-d to get at special compiler arglist/function documentation.
;; may 07/13/89 Allowed values to print out if they are a cons and changed doc string.
;;     also allowed compiler::init-system-var-properties variables to be documented.
;; may 01/02/90 Added defsubst code since ARGLIST function does not do the right thing.
;; may 01/02/90 Added check for unbound variables so that the documentation could be found.
;;
;; TEST cases :  ticlos:describe-object, zlc:memq tv:before-blinker-blink tv:sheet-plane-mask
;; w:default-screen zwei:*DIRED-FUNCTION-TO-APPLY* si:STREAM-INPUT-OPERATIONS si:%COUNT-FIRST-LEVEL-MAP-RELOADS
;; lists: (short) tv:all-the-screens (long) si:*ALL-FLAVOR-NAMES* 
;; si:%call ticlos:call-next-method (:property sys:%call compiler:p2)
;; tv:add-escape-key (:method tv:sheet :init) (:method tv:SHEET :ACTIVATE) eh:maclisp-error

;; TEST code :			     
;;(defun test (&optional (pkg 'si))
;;  (do-symbols (name (find-package pkg) nil)
;;      (long-documentation name ))))

(DEFUN zwei::long-documentation (name &optional (STREAM t))
  "Print long documentation for almost anything."
  (LET (doc temp)
    (COND-EVERY
      (;; function
       ;; (fdefinedp '(:method tv:sheet :init)) => t 
       ;; (functionp '(:method tv:sheet :init)) => nil
       (OR (FUNCTIONP name t) (FDEFINEDP name) 	                ;; may 7-11-88 added (fdefinedp name)
	   ;; for special compiler functions like: (ticlos:call-next-method) 	;; may 04/20/89 
	   (AND (SYMBOLP name) (DOCUMENTATION name))) 		;; may 04/20/89 
       (MULTIPLE-VALUE-BIND (args return macro-p) (ARGLIST name)		    
	 (IF ;; (SETQ TEMP (GET NAME 'SI::DEFSTRUCT-SLOT)) 				;; may 01/25/89 obsolete
	   ;; (FORMAT STREAM "~%~S is a defstruct accessor macro for ~s" NAME (CAR TEMP))   ;; may 01/25/89 sort of ...
	   (AND (SETQ temp (si:function-parent name))					;; may 01/25/89 
		(GET temp 'si::defstruct-description)) 					;; may 01/25/89 
	   (FORMAT stream "~%~S is a defstruct accessor function for ~s" name temp) 	;; may 01/25/89
	   ;; may 01/02/90 arglist (3rd return value) does NOT return SUBST for a defsubst
	   ;; like tv:before-blinker-blink or :OUTSIDE-ACCESSIBLE-INSTANCE-VARIABLES like tv:sheet-plane-mask ???
	   ;; Also added ticlos:generic-function-p for ticlos:describe-object, etc. Added form below :
	   (unless macro-p
	     (setq macro-p (and (symbolp name) ;; else FBOUNDP blows up on '(:method tv:sheet :init)
				(FBOUNDP name) ;; else FDEFINITION blows up on SI:%CALL
				(si:COMPILED-SUBST? (fdefinition (si:unencapsulate-function-spec name)))
				'SUBST)))
	   (FORMAT stream "~%~s is a ~:[~;GENERIC ~]~:[function~;~:*~a~]" ;; may 01/02/90 
		   name (ticlos:generic-function-p name)		;; may 01/02/90 Added ticlos:generic-function-p
		   macro-p ;;(AND macro-p (STRING-DOWNCASE macro-p))	;; may 01/02/90 Remove string-downcase
		   ))
	 (FORMAT stream "~%arguments  ~A~%" args)
	 (WHEN return
	   (FORMAT stream "returns  ~{~A  ~}~%" return)))
       (WHEN (SETQ doc (DOCUMENTATION name))
	 (FORMAT stream "~A~%" doc)))
      (;; flavor
       (SETQ temp (GET name 'si::flavor))
       (FORMAT stream "~%~s is a flavor~%" name)
       (WHEN (AND (SETQ temp (si::flavor-plist temp))
		  (SETQ doc (SECOND (MEMBER :documentation temp :test #'EQ))))
	 (FORMAT stream "~a~%" doc)))
      (;; class  - added class documentation - TAC 08-30-89
       (SETQ temp (and (symbolp name) ;; else blows up on '(:method tv:sheet :init)
		       (ticlos::class-named name t)))	;; may 01/02/90
       (FORMAT stream "~%~s is a class~%" name)
       (WHEN
	 (SETQ doc (DOCUMENTATION temp)) 				
	 (FORMAT stream "~a~%" doc)))
      (;; structure
       (SETQ temp (GET name 'si::defstruct-description))
       (FORMAT stream "~%~s is a structure~%" name)
       (WHEN
	 (SETQ doc (DOCUMENTATION name 'structure)) 				;; may 01/25/89 
	 (FORMAT stream "~a~%" doc)))
      (;; other ...
       (AND (SETQ temp (GET name :documentation)) (NEQ doc temp))
       (FORMAT stream "~%~s is a ~a~%" name (TYPE-OF name))
       (FORMAT stream "~a~%" temp))
      (;; variable
       ;;(AND (SYMBOLP name) (BOUNDP name))	;; may 01/02/90 
       (AND (SYMBOLP name) (get name 'special)) ;; may 01/02/90 include :unbound defvars
       ;; may 01/02/90  Added print bindings and now we actually print the value
       (let ((*print-circle* t)	
	     (*print-level* (or *print-level* 5))
	     (*print-length* (or *print-length* 30.)))
	 (FORMAT stream "~%~s is a ~a~%"
		 NAME
		 ;;; try:  si:qld-mini-done si:STREAM-INPUT-OPERATIONS
		 ;;; and si:%COUNT-FIRST-LEVEL-MAP-RELOADS which is both 
		 (COND ((get name 'compiler:system-constant) "system constant") ;; may 01/02/90 
		       ((car (member 'compiler::init-system-var-properties (SYMBOL-PLIST name) :test #'eq)) ;; may 01/02/90 
			"system init variable")	;; may 01/02/90 
		       (t "variable")))
	 ;(IF (CONSP
  	     (SETQ TEMP (if (boundp name) (SYMBOL-VALUE NAME) :unbound)) ;)	;; may 01/02/90 include :unbound defvars
	 ;   (FORMAT stream "Value is a ~A~%" (TYPE-OF TEMP))
 	     (FORMAT stream "Value is ~s~%" TEMP)) 
       (FORMAT stream "~@[~a~%~]" (GETF (GET name 'sys::documentation-property) 'variable))) ;; may 7-11-88
      (;; condition
       (SETQ temp (GET name 'eh::make-condition-function))
       (FORMAT stream "~%~S is an ~:[undocumented ~]error condition~%" name
	       (SETQ doc (DOCUMENTATION temp)))
       (WHEN doc
	 (FORMAT stream "~a~%" doc)))
      (otherwise				;(FORMAT *QUERY-IO* "~&~S was not found." NAME)
       (FORMAT stream "~&~S has no documentation." name)
       ))
    nil))
))

#!C
; From file COMF.LISP#> ZMACS; MR-X:
#8R ZWEI#:
(COMPILER-LET ((*PACKAGE* (FIND-PACKAGE "ZWEI"))
                          (SI:*LISP-MODE* :COMMON-LISP)
                          (*READTABLE* SYS:COMMON-LISP-READTABLE)
                          (SI:*READER-SYMBOL-SUBSTITUTIONS* SYS::*COMMON-LISP-SYMBOL-SUBSTITUTIONS*))
  (COMPILER#:PATCH-SOURCE-FILE "SYS: ZMACS; COMF.#"


;; COM-LONG-DOCUMENTATION redefined by patch 94.215.
;; may 01/20/89 Changed documentation string and 'structure test.
;; may 04/20/89 Allowed meta-sh-d to get at special compiler arglist/function documentation.
;; may 12/22/89 Moved guts to new function zwei::long-documentation so that general-inspector could call it.
(DEFCOM COM-LONG-DOCUMENTATION  
  "Reads the name from the mini-buffer or mouse (the default is the \"current\" function from the buffer) 
and displays the function's arguments, whether it is a function, variable, flavor, structure, condition, etc., 
and its documentation and its value."  ;; by OREN/STENGER. Patched in by gsl
  ()
  (LET* ((name (read-function-name "Document" (relevant-function-name (point)) 'aarray-ok))
	 ;; may 01/02/90 Bind package to nil to force it to print out - UNLESS describing symbol '*package*
	 (*package* (if (eq '*package* name) *package*) nil))
    (long-documentation name))
  dis-none)
))

