;;; -*- Mode: Common-Lisp; Package: ZWEI; Base: 8.; Patch-File: T -*-

;;; Reason: Modified REVERT-FILE-BUFFER to get the proper generic pathname.[9821]

;;;                           RESTRICTED RIGHTS LEGEND
;;;
;;; Use, duplication, or disclosure by the Government is subject to
;;; restrictions as set forth in subdivision (c)(1)(ii) of the Rights in
;;; Technical Data and Computer Software clause at 52.227-7013.
;;;
;;;   TEXAS INSTRUMENTS INCORPORATED      
;;;   P.O. BOX 2909, M/S 2151             
;;;   AUSTIN, TEXAS 78769                 
;;;
;;; Copyright (C) 1989 Texas Instruments Incorporated.
;;; All rights reserved.

;;; Patch file for ZWEI version 6.17
;;; Written 05/24/90 08:27:38 by BERGER,
;;; while running on Pasteur from band LOD2
;;; With SYSTEM 6.32, VIRTUAL-MEMORY 6.3, EH 6.7, MAKE-SYSTEM 6.3, MICRONET 6.0, LOCAL-FILE 6.2,
;;;  BASIC-PATHNAME 6.4, NETWORK-SUPPORT-COLD 6.2, BASIC-NAMESPACE 6.7, NETWORK-NAMESPACE 6.1,
;;;  DISK-IO 6.3, DISK-LABEL 6.0, BASIC-FILE 6.11, MAC-PATHNAME 6.0, NETWORK-PATHNAME 6.2,
;;;  COMPILER 6.14, TV 6.25, DATALINK 6.0, CHAOSNET 6.6, GC 6.3, MEMORY-AUX 6.0, NVRAM 6.2,
;;;  SYSLOG 6.2, STREAMER-TAPE 6.6, UCL 6.0, INPUT-EDITOR 6.0, METER 6.1, ZWEI 6.16,
;;;  DEBUG-TOOLS 6.4, NETWORK-SUPPORT 6.1, NETWORK-SERVICE 6.2, DATALINK-DISPLAYS 6.0,
;;;  FONT-EDITOR 6.1, SERIAL 6.0, PRINTER 6.6, MAC-PRINTER-TYPES 6.2, PRINTER-TYPES 6.2,
;;;  IMAGEN 6.1, SUGGESTIONS 6.1, MAIL-DAEMON 6.6, MAIL-READER 6.8, TELNET 6.1, VT100 6.0,
;;;  NAMESPACE-EDITOR 6.4, PROFILE 6.3, VISIDOC 6.7, TI-CLOS 6.46, CLEH 6.5, IP 3.62,
;;;  Experimental CLX 6.11, CLUE 6.104, X11M 6.24, Experimental BUG 11.19,  microcode 648,
;;;  Band Name: rel6.0 1/23

#!C
; From file ZMACS.LISP#> ZMACS; Hotel:
#8R ZWEI#:
(COMPILER-LET ((*PACKAGE* (FIND-PACKAGE "ZWEI"))
                          (SI:*LISP-MODE* :COMMON-LISP)
                          (*READTABLE* SYS:COMMON-LISP-READTABLE)
                          (SI:*READER-SYMBOL-SUBSTITUTIONS* SYS::*COMMON-LISP-SYMBOL-SUBSTITUTIONS*))
  (COMPILER#:PATCH-SOURCE-FILE "SYS: ZMACS; ZMACS.#"


(DEFUN REVERT-FILE-BUFFER (BUFFER PNAME CONNECT-FLAG SELECT-FLAG QUIETLY-FLAG &AUX GENERIC-PATHNAME PATHNAME-STRING
  TRUENAME NEW-MODE PATHNAME )
  (COND
    ((AND (NULL (BUFFER-FILE-ID BUFFER)) (NULL PNAME))
     (BARF "The buffer ~A is not associated with a file." (BUFFER-NAME BUFFER))))
  (MULTIPLE-VALUE-SETQ (PATHNAME PATHNAME-STRING)
    (EDITOR-FILE-NAME PNAME))
  (COND
    (CONNECT-FLAG (SETF (BUFFER-NAME BUFFER) PATHNAME-STRING)
     (SETF (BUFFER-PATHNAME BUFFER) PATHNAME)))
  (SETQ GENERIC-PATHNAME (SEND PNAME :GENERIC-PATHNAME))
  (SETF (BUFFER-GENERIC-PATHNAME BUFFER) GENERIC-PATHNAME)
  (WITH-OPEN-FILE-CASE (STREAM PATHNAME)
     (:NO-ERROR (SETQ TRUENAME (SEND STREAM :TRUENAME))
      (WHEN (MEMBER (SEND PATHNAME :TYPE) '(NIL :UNSPECIFIC) :TEST #'EQ)
	(MULTIPLE-VALUE-SETQ (PATHNAME PATHNAME-STRING)
	  (EDITOR-FILE-NAME
	   (IF (EQUALP (SEND TRUENAME :NAME) (SEND PATHNAME :NAME))
	     (SEND PATHNAME :NEW-TYPE (SEND TRUENAME :TYPE))
	     PATHNAME))))
      (COND
	(CONNECT-FLAG (SETF (BUFFER-NAME BUFFER) PATHNAME-STRING)
	 (SETF (BUFFER-PATHNAME BUFFER) PATHNAME) (SIMILAR-BUFFER-FILES-WARNING BUFFER)))
      (OR QUIETLY-FLAG (FORMAT *QUERY-IO* "~&Reading ~A" TRUENAME))
      (LET ((THIS-VERSION (SEND TRUENAME :VERSION))
	    (INSTALLED-TRUENAME (FILE-LOADED-TRUENAME TRUENAME))
	    INSTALLED-VERSION)
	(AND INSTALLED-TRUENAME (NUMBERP THIS-VERSION)
	   (NUMBERP (SETQ INSTALLED-VERSION (SEND INSTALLED-TRUENAME :VERSION)))
	   (NOT QUIETLY-FLAG) (/= INSTALLED-VERSION THIS-VERSION)
	   (FORMAT *QUERY-IO* " (installed version is ~D)" INSTALLED-VERSION)))
      (FS:READ-ATTRIBUTE-LIST BUFFER STREAM) (SETF (BUFFER-PACKAGE BUFFER) NIL)
      (INITIALIZE-BUFFER-PACKAGE BUFFER)
      (UNLESS (SEND BUFFER :GET-ATTRIBUTE :MODE)
	(SEND BUFFER :SET-ATTRIBUTE :MODE
	   (OR (AND (EQ (SEND PATHNAME :CANONICAL-TYPE) :LISP) (LISP-MODE 'T))
	      (CDR
	       (ASSOC (SEND PATHNAME :CANONICAL-TYPE) FS::*FILE-TYPE-MODE-ALIST* :TEST #'string-EQUAL))
	      *DEFAULT-MAJOR-MODE*)))
      (SETQ NEW-MODE
	    (OR (GET-FILE-MAJOR-MODE (SEND BUFFER :GET-ATTRIBUTE :MODE)) 'FUNDAMENTAL-MODE))
      (LET-IF QUIETLY-FLAG ((*INTERVAL* NIL))
	 (IF (EQ BUFFER *INTERVAL*)
	   (COMPUTE-BUFFER-PACKAGE BUFFER))
	 (AND NEW-MODE (SEND BUFFER :SET-MAJOR-MODE NEW-MODE)))
      (PRESERVE-BUFFER-POINT (BUFFER)
	 (WITH-READ-ONLY-SUPPRESSED (BUFFER)
	    (LET ((*BATCH-UNDO-SAVE* T))
	      (DISCARD-UNDO-INFORMATION BUFFER)
	      (DELETE-INTERVAL BUFFER)
	      (SETF (BUFFER-TICK BUFFER) (TICK))
	      (SETF (BUFFER-FILE-READ-TICK BUFFER) *TICK*)
	      (LET ((FONTS (SET-BUFFER-FONTS BUFFER))
		    FONTS-P)
		(SETQ FONTS-P (OR (CDR FONTS) (SEND BUFFER :GET-ATTRIBUTE :DIAGRAM)))
		(LET ((BUFFER-STREAM
		       (INTERVAL-STREAM-INTO-BP (INTERVAL-FIRST-BP BUFFER) FONTS-P)))
		  (WHEN SELECT-FLAG
		    (SEND BUFFER :ACTIVATE)
		    (MAKE-BUFFER-CURRENT BUFFER)
		    (DOTIMES (I (+ 5 (WINDOW-N-PLINES *WINDOW*)))
		      (MULTIPLE-VALUE-BIND (LINE EOFFLG) (SEND STREAM :LINE-IN LINE-LEADER-SIZE)
			(COND
			  ((NOT EOFFLG) (SEND BUFFER-STREAM :LINE-OUT LINE))
			  (:ELSE (SEND BUFFER-STREAM :STRING-OUT LINE) (RETURN NIL)))))
		    (REDISPLAY *WINDOW* :START (INTERVAL-FIRST-BP BUFFER) NIL))
		  (IF (NOT CONNECT-FLAG)
		    (STREAM-COPY-UNTIL-EOF STREAM BUFFER-STREAM LINE-LEADER-SIZE)
		    (PROGN
		      (IF (EQ CONNECT-FLAG 'NOSECTIONIZE)
			(STREAM-COPY-UNTIL-EOF STREAM BUFFER-STREAM LINE-LEADER-SIZE)
			(SECTIONIZE-FILE-BUFFER BUFFER *ZMACS-COMPLETION-AARRAY* 'ZMACS-BUFFERS
						NIL NIL STREAM FONTS-P BUFFER-STREAM))
		      (SET-BUFFER-FILE-ID BUFFER (SEND STREAM :INFO))
		      (DOLIST (WINDOW (SEND BUFFER :WINDOWS))
			(AND FONTS
			   (REDEFINE-FONTS WINDOW FONTS (SEND BUFFER :GET-ATTRIBUTE :VSP)))
			(REDEFINE-WINDOW-OVERPRINTING-FLAG WINDOW
							   (SEND BUFFER :GET-ATTRIBUTE
							      :BACKSPACE))
			(REDEFINE-WINDOW-TAB-NCHARS WINDOW
						    (SEND BUFFER :GET-ATTRIBUTE :TAB-WIDTH))))))
		(SETF (BUFFER-FILE-READ-TICK BUFFER) *TICK*)
		(NOT-MODIFIED BUFFER)))))
      (UNLESS QUIETLY-FLAG
	(IF (SEND STREAM :OPERATION-HANDLED-P :READ-POINTER)
	  (LET ((NCHARS (SEND STREAM :READ-POINTER)))
	    (IF (< NCHARS 5000)
	      (FORMAT *QUERY-IO* " -- ~D characters." NCHARS)
	      (FORMAT *QUERY-IO* " -- ~DK characters." (ROUND NCHARS 1024.))))  ;07-28-88 DAB Wrong base.
	  (FORMAT *QUERY-IO* " -- done."))))
     (FS::FILE-NOT-FOUND (WHEN *FIND-FILE-NOT-FOUND-IS-AN-ERROR*
			   (BARF STREAM))
      (OR QUIETLY-FLAG (FORMAT *QUERY-IO* "(New File)"))
      (LET ((*BATCH-UNDO-SAVE* T))
	(DISCARD-UNDO-INFORMATION BUFFER)
	(DELETE-INTERVAL BUFFER))
      (AND CONNECT-FLAG (SET-BUFFER-FILE-ID BUFFER T))
      (SEND BUFFER :SET-ATTRIBUTE :MODE
	 (OR (AND (EQ (SEND PATHNAME :CANONICAL-TYPE) :LISP) (LISP-MODE 'T))
	    (CDR
	     (ASSOC (SEND PATHNAME :CANONICAL-TYPE) FS::*FILE-TYPE-MODE-ALIST* :TEST #'string-EQUAL))
	    *DEFAULT-MAJOR-MODE*))
      (SETF (BUFFER-PACKAGE BUFFER) (FIND-PACKAGE (OR *DEFAULT-PACKAGE* *PACKAGE*)))
      (LET ((MODE (GET-FILE-MAJOR-MODE (SEND BUFFER :GET-ATTRIBUTE :MODE))))
	(LET-IF QUIETLY-FLAG ((*INTERVAL* NIL))
	   (IF (EQ BUFFER *INTERVAL*)
	     (COMPUTE-BUFFER-PACKAGE BUFFER))
	   (AND MODE (SEND BUFFER :SET-MAJOR-MODE MODE)))))
     (FS::FILE-ERROR (BARF STREAM)))
  (SETF (BUFFER-TICK BUFFER) (TICK)))		;Buffer is same as file

))

#!C
; From file PATED.LISP#> ZMACS; SYS:
#8R ZWEI#:
(COMPILER-LET ((*PACKAGE* (FIND-PACKAGE "ZWEI"))
                          (SI:*LISP-MODE* :COMMON-LISP)
                          (*READTABLE* SYS:COMMON-LISP-READTABLE)
                          (SI:*READER-SYMBOL-SUBSTITUTIONS* SYS::*COMMON-LISP-SYMBOL-SUBSTITUTIONS*))
  (COMPILER#:PATCH-SOURCE-FILE "SYS: ZMACS; PATED.#"


(DEFUN READ-PATCH-SYSTEM-NAME () "Read and return the name of a system to patch, using the minibuffer.
We provide completion and a default based on the selected buffer."
  (LET* ((DEFAULT (SI:SYSTEM-NAME (PATCHABLE-SYSTEM-OF-PATHNAME
				    (SEND *INTERVAL* :generic-PATHNAME))))  ; DAB 05-08-90 WAS :pathname
	 (SELECTED-SYSTEM (COMPLETING-READ-FROM-MINI-BUFFER	
			    (IF DEFAULT
				(FORMAT NIL "System to patch (default ~A)" DEFAULT)
				"System to patch")
			    ;;create an alist of all possible system names for patchable systems  -dkm  7/87
			    (MAPCAR #'(LAMBDA (X) (LIST X))					 ;make alist of system names
				    (LOOP FOR X IN SI:PATCH-SYSTEMS-LIST			 ;all patch structures
					  AS  NAME = (SI:PATCH-NAME X)				 ;patch system name
					  AS  SYS  = (SI:FIND-SYSTEM-NAMED NAME)		 ;defsystem structure
					  NCONC (COPY-LIST					 ;make a copy for nconc
						  (REMOVE-DUPLICATES				 ;remove duplicates
						    (CONS (STRING (SI:SYSTEM-SYMBOLIC-NAME SYS)) ;name in defsystem
							  (CONS (SI:SYSTEM-NAME SYS)		 ;long name in defsystem
								(SI:SYSTEM-NICKNAMES SYS)))	 ;nicknames in defsystem
						    :TEST 'STRING-EQUAL)))))))
    ;; patch-system will always be a cons if they typed in something- or "" if they took the default.
    (IF (CONSP SELECTED-SYSTEM)
	(CAR SELECTED-SYSTEM)
	(IF DEFAULT
	    DEFAULT
	    (BARF)))))
))
