;;; -*- Mode: Common-Lisp; Package: ZWEI; Base: 8.; Patch-File: T -*-
;;; Written 06/04/90 08:40:42 by BERGER,
;;; Reason: Modified DIRED-PATHNAME-DIRECTORY-LINE to check device for MX pathnames.[10597]
;;; while running on MX29 from band n817
;;; With SYSTEM 6.35, GC 6.4, VIRTUAL-MEMORY 6.3, MICRONET 6.0, MICRONET-COMM 6.4,
;;;  DISK-IO 6.3, DISK-LABEL 6.0, BASIC-PATHNAME 6.5, MAC-PATHNAME 6.0, NETWORK-SUPPORT-COLD 6.2,
;;;  BASIC-NAMESPACE 6.8, BASIC-FILE 6.13, RPC 6.2, NFS-MX 6.7, EH 6.8, MAKE-SYSTEM 6.3,
;;;  MEMORY-AUX 6.0, COMPILER 6.18, TV 6.25, NVRAM 6.3, UCL 6.0, INPUT-EDITOR 6.0,
;;;  MACTOOLBOX 2.21, METER 6.2, ZWEI 6.19, DEBUG-TOOLS 6.4, WINDOW-MX 6.10, PRINTER 6.7,
;;;  MAC-PRINTER-TYPES 6.2, CLIPBOARD 6.1, TI-CLOS 6.49, CLEH 6.5, NETWORK-PATHNAME 6.2,
;;;  NETWORK-NAMESPACE 6.1, DATALINK 6.0, CHAOSNET 6.8, NETWORK-SUPPORT 6.1, NETWORK-SERVICE 6.3,
;;;  DATALINK-DISPLAYS 6.0, MX-DATALINK 6.1, NAMESPACE-EDITOR 6.5, IP 3.65, NFS-MX-SERVER 6.0,
;;;  MX-SERIAL 6.1, PRINTER-TYPES 6.2, IMAGEN 6.1, MAIL-DAEMON 6.6, MAIL-READER 6.8,
;;;  TELNET 6.1, VT100 6.0, STREAMER-TAPE 6.6, DECNET 1.72, VISIDOC 6.7, PROFILE 6.3,
;;;   microcode 138, Band Name: microExplorer Network (8/17)

#!C
; From file DIRED.LISP#> ZMACS; SYS:
#8R ZWEI#:
(COMPILER-LET ((*PACKAGE* (FIND-PACKAGE "ZWEI"))
                          (SI:*LISP-MODE* :COMMON-LISP)
                          (*READTABLE* SYS:COMMON-LISP-READTABLE)
                          (SI:*READER-SYMBOL-SUBSTITUTIONS* SYS::*COMMON-LISP-SYMBOL-SUBSTITUTIONS*))
  (COMPILER#:PATCH-SOURCE-FILE "SYS: ZMACS; DIRED.#"


(DEFUN DIRED-PATHNAME-DIRECTORY-LINE (PATHNAME &AUX DIR-PATHNAME)
  "Return the line in the DIRED buffer for PATHNAME's parent directory, or NIL if none."
  (SETQ DIR-PATHNAME (SEND PATHNAME :NEW-PATHNAME
			   :NAME :UNSPECIFIC
			   :TYPE :UNSPECIFIC
			   :VERSION :UNSPECIFIC))
  (IF (EQ (SEND (DIRED-BUFFER-DIRECTORY-PATHNAME *INTERVAL*) :NEW-PATHNAME
		;;DAB 06-04-90 Device is important on MX. Use the correct device in this case. [10597]
		:DEVICE (if (typep (DIRED-BUFFER-DIRECTORY-PATHNAME *INTERVAL*) 'fs:mac-pathname)  ; DAB 06-04-90
			    (send (DIRED-BUFFER-DIRECTORY-PATHNAME *INTERVAL*) :device)
			    :UNSPECIFIC)
		:NAME :UNSPECIFIC
		:TYPE :UNSPECIFIC
		:VERSION :UNSPECIFIC)
	  (SEND PATHNAME :NEW-PATHNAME
		:DEVICE (if (typep pathname 'fs:mac-pathname)
			    (send pathname :device)
			    :UNSPECIFIC)
		:NAME :UNSPECIFIC
		:TYPE :UNSPECIFIC
		:VERSION :UNSPECIFIC))
      (LINE-PREVIOUS (LINE-PREVIOUS (LINE-PREVIOUS (DIRED-FIRST-PATHNAME-LINE))))
      (DO ((LINE (BP-LINE (INTERVAL-FIRST-BP *INTERVAL*)) (LINE-NEXT LINE)))
	  ((NULL LINE))
	(AND (GETF (LINE-PLIST LINE) :DIRECTORY)
	     (DIRED-LINE-PATHNAME LINE)
	     (EQ (SEND (DIRED-LINE-PATHNAME LINE) :PATHNAME-AS-DIRECTORY)
		 DIR-PATHNAME)
	     (RETURN (AND (GETF (LINE-PLIST LINE) 'CONTENTS-PRESENT)
			  LINE))))))
))
