;;; -*- Mode: Common-Lisp; Package: User; Base: 8.; Patch-File: T -*-

;;; Reason: Made com-quick-arglist understand CLOS method specs.

;;;                           RESTRICTED RIGHTS LEGEND
;;;
;;; Use, duplication, or disclosure by the Government is subject to
;;; restrictions as set forth in subdivision (c)(1)(ii) of the Rights in
;;; Technical Data and Computer Software clause at 52.227-7013.
;;;
;;;   TEXAS INSTRUMENTS INCORPORATED      
;;;   P.O. BOX 2909, M/S 2151             
;;;   AUSTIN, TEXAS 78769                 
;;;
;;; Copyright (C) 1989 Texas Instruments Incorporated.
;;; All rights reserved.

;;; Patch file for ZWEI version 6.21
;;; Written 06/05/90 11:15:11 by MARKY,
;;; while running on LIBRA from band LODB
;;; With SYSTEM 6.23, VIRTUAL-MEMORY 6.2, EH 6.5, MAKE-SYSTEM 6.2, MICRONET 6.0, LOCAL-FILE 6.1,
;;;  BASIC-PATHNAME 6.2, NETWORK-SUPPORT-COLD 6.2, BASIC-NAMESPACE 6.6, NETWORK-NAMESPACE 6.0,
;;;  DISK-IO 6.1, DISK-LABEL 6.0, BASIC-FILE 6.6, MAC-PATHNAME 6.0, NETWORK-PATHNAME 6.0,
;;;  COMPILER 6.14, TV 6.19, DATALINK 6.0, CHAOSNET 6.5, GC 6.3, MEMORY-AUX 6.0, NVRAM 6.2,
;;;  SYSLOG 6.2, STREAMER-TAPE 6.4, UCL 6.0, INPUT-EDITOR 6.0, METER 6.1, ZWEI 6.8,
;;;  DEBUG-TOOLS 6.3, NETWORK-SUPPORT 6.0, NETWORK-SERVICE 6.2, DATALINK-DISPLAYS 6.0,
;;;  FONT-EDITOR 6.1, SERIAL 6.0, PRINTER 6.3, MAC-PRINTER-TYPES 6.1, PRINTER-TYPES 6.2,
;;;  IMAGEN 6.1, SUGGESTIONS 6.1, MAIL-DAEMON 6.3, MAIL-READER 6.6, TELNET 6.0, VT100 6.0,
;;;  NAMESPACE-EDITOR 6.4, PROFILE 6.2, VISIDOC 6.5, TI-CLOS 6.26, CLEH 6.5, IP 3.56,
;;;  Experimental CLX 6.7, CLUE 6.32, X11M 6.16, Experimental BUG 11.17, MMON 6.2,
;;;   microcode 429, Band Name: REL6-mmon-11/15/89

;;; SPR 10450. Added CLOS methods capability to c-sh-a (com-quick-arglist)

#!C
; From file COMF.LISP#> ZMACS; Hotel:
#8R ZWEI#:
(COMPILER-LET ((*PACKAGE* (FIND-PACKAGE "ZWEI"))
                          (SI:*LISP-MODE* :COMMON-LISP)
                          (*READTABLE* SYS:COMMON-LISP-READTABLE)
                          (SI:*READER-SYMBOL-SUBSTITUTIONS* SYS::*COMMON-LISP-SYMBOL-SUBSTITUTIONS*))
  (COMPILER#:PATCH-SOURCE-FILE "SYS: ZMACS; COMF.#"


(DEFUN QUICK-ARGLIST (&OPTIONAL (STREAM *QUERY-IO*))
  (IF *NUMERIC-ARG-P*
      (LET ((NAME (READ-FUNCTION-NAME "Arglist" (RELEVANT-FUNCTION-NAME (POINT)) T)))
	(PRINT-ARGLIST NAME STREAM))
      (LET ((SYMBOL (RELEVANT-FUNCTION-NAME (POINT))))
	(COND ((COND ((MEMBER SYMBOL '(FUNCALL FUNCALL-SELF SEND
	       			       LEXPR-FUNCALL LEXPR-FUNCALL-SELF LEXPR-SEND <-)
			      :TEST #'EQ)
		      (LET ((TEMP-SYMBOL (RELEVANT-METHOD-NAME
					   (POINT)
					   (IF (MEMBER SYMBOL '(FUNCALL-SELF
								 LEXPR-FUNCALL-SELF)
						       :TEST #'EQ)
					       1 2))))
			(AND TEMP-SYMBOL (SETQ SYMBOL TEMP-SYMBOL))))
		     ((EQ SYMBOL 'DEFMETHOD)
;; may 06/05/90 Start patch ...
		      ;; IF SUBSTITUTE-SECTION-NAME is T, then RELEVANT-FUNCTION-NAME
		      ;; performs the equivalent of RELEVANT-DEFMETHOD-METHOD-NAME for FLAVOR
		      ;; methods and for CLOS methods the portion of (:PROPERTY :LISP GET-SECTION-NAME)
		      ;; which calls READ-FROM-STRING.
		      (setq symbol (relevant-function-name (point) nil t t t))
		      nil)
;;; Don't call RELEVANT-DEFMETHOD-METHOD-NAME - it does NOT understand CLOS methods
;;;			    (LET ((METHOD-SYMBOL (RELEVANT-DEFMETHOD-METHOD-NAME (POINT))))
;;;			      (COND (METHOD-SYMBOL
;;;				     (SETQ SYMBOL METHOD-SYMBOL)
;;;				     T))))))
		     )	       
;; may 06/05/90 End patch ...
	       (MULTIPLE-VALUE-BIND (ARGLIST NAME RETLIST) (METHOD-ARGLIST SYMBOL)
		 (COND ((EQ STREAM *QUERY-IO*)
			(FORMAT *QUERY-IO* "~&")
			(SEND STREAM :SEND-IF-HANDLES :TYPEOUT-STAYS)))
		 (FORMAT STREAM "~S: ~:A~@[  ~:A~]" (OR NAME SYMBOL) ARGLIST RETLIST)))
	      ((AND SYMBOL
		    (OR (FDEFINEDP SYMBOL)
			(SI:MEMQ-ALTERNATED 'ARGLIST (SYMBOL-PLIST SYMBOL))))
	       (PRINT-ARGLIST SYMBOL STREAM))
	      ;; Looked hard but couldn't find a defined function
	      ((BARF "~@[~a~]~A" symbol (if symbol " is not defined." "No relevant function.")))))))
))
