;;; -*- Mode: Common-Lisp; Package: zwei; Base: 8.; Patch-File: T -*-

;;; Reason: Added error handling to COM-SOURCE-COMPARE. [11158]

;;;                           RESTRICTED RIGHTS LEGEND
;;;
;;; Use, duplication, or disclosure by the Government is subject to
;;; restrictions as set forth in subdivision (c)(1)(ii) of the Rights in
;;; Technical Data and Computer Software clause at 52.227-7013.
;;;
;;;   TEXAS INSTRUMENTS INCORPORATED      
;;;   P.O. BOX 149149, M/S 2151             
;;;   AUSTIN, TEXAS 78714-9149                 
;;;
;;; Copyright (C) 1989 Texas Instruments Incorporated.
;;; All rights reserved.

;;; Patch file for ZWEI version 6.23
;;; Written 06/21/90 08:09:23 by BERGER,
;;; while running on ARIES from band LODX
;;; With SYSTEM 6.41, VIRTUAL-MEMORY 6.3, EH 6.8, MAKE-SYSTEM 6.5, MICRONET 6.0, LOCAL-FILE 6.2,
;;;  BASIC-PATHNAME 6.5, NETWORK-SUPPORT-COLD 6.2, BASIC-NAMESPACE 6.8, NETWORK-NAMESPACE 6.1,
;;;  DISK-IO 6.4, DISK-LABEL 6.1, BASIC-FILE 6.13, MAC-PATHNAME 6.0, NETWORK-PATHNAME 6.2,
;;;  COMPILER 6.18, TV 6.30, DATALINK 6.0, CHAOSNET 6.8, GC 6.4, MEMORY-AUX 6.0, NVRAM 6.4,
;;;  SYSLOG 6.2, STREAMER-TAPE 6.6, UCL 6.1, INPUT-EDITOR 6.0, METER 6.2, ZWEI 6.22,
;;;  DEBUG-TOOLS 6.5, NETWORK-SUPPORT 6.1, NETWORK-SERVICE 6.3, DATALINK-DISPLAYS 6.0,
;;;  FONT-EDITOR 6.1, SERIAL 6.0, PRINTER 6.8, MAC-PRINTER-TYPES 6.2, PRINTER-TYPES 6.2,
;;;  IMAGEN 6.1, SUGGESTIONS 6.1, MAIL-DAEMON 6.6, MAIL-READER 6.8, TELNET 6.1, VT100 6.0,
;;;  NAMESPACE-EDITOR 6.6, PROFILE 6.3, VISIDOC 6.7, TI-CLOS 6.53, CLEH 6.5, IP 3.65,
;;;  Experimental BUG 11.19, Experimental CLX 7.0, Experimental CLUE 7.2, X11M 6.31,
;;;  Experimental Z-TO-C 3.0, VISIDOC-SERVER 6.2,  microcode 483, Band Name: Rel 6.1 *b +SLE 6/18

#!C
; From file ZMACS.LISP#> ZMACS; Sys:
#8R ZWEI#:
(COMPILER-LET ((*PACKAGE* (FIND-PACKAGE "ZWEI"))
                          (SI:*LISP-MODE* :COMMON-LISP)
                          (*READTABLE* SYS:COMMON-LISP-READTABLE)
                          (SI:*READER-SYMBOL-SUBSTITUTIONS* SYS::*COMMON-LISP-SYMBOL-SUBSTITUTIONS*))
  (COMPILER#:PATCH-SOURCE-FILE "SYS: ZMACS; ZMACS.#"


(DEFCOM COM-SOURCE-COMPARE "Compare two files or buffers.
The output goes on the screen, and also into a buffer named *Source Compare ...*." ()
  (LET (FILE-1 FILE-2 NAME-1 NAME-2 KIND DEFAULT
	(error-string "Source Compare unsuccessful because ~a."))  ; DAB 06-21-90 Added error handling.
    (UNWIND-PROTECT
	(PROGN
	  (MULTIPLE-VALUE-SETQ (FILE-1 NAME-1 KIND DEFAULT)
	    (GET-BUFFER-OR-FILE-FILE "Compare" NIL))
	  (MULTIPLE-VALUE-SETQ (FILE-2 NAME-2)
	    (GET-BUFFER-OR-FILE-FILE (FORMAT NIL "Compare ~A ~A with" KIND NAME-1)
				     DEFAULT))
	  (LET ((*STANDARD-OUTPUT* (MAKE-BUFFER-WINDOW-OR-BROADCAST-STREAM
				     (FORMAT NIL "*Source Compare ~A / ~A*" NAME-1 NAME-2)
				     NIL T)))
	    (cond ((errorp file-1) (format t error-string (send file-1 :report-string)))  ; DAB 06-21-90
		  ((errorp file-2) (format t error-string (send file-2 :report-string))) ; DAB 06-21-90
		  (t
		   (SRCCOM::DESCRIBE-SRCCOM-SOURCES FILE-1 FILE-2 *STANDARD-OUTPUT*)
		   (SRCCOM:SOURCE-COMPARE-FILES FILE-1 FILE-2 *STANDARD-OUTPUT* (SRCCOM::QUERY-TYPE))
		   (FORMAT T "~&Done.")))))
      (AND (not (errorp file-1))  ; DAB 06-21-90
	   FILE-1 (SEND (SRCCOM:FILE-STREAM FILE-1) :CLOSE))
      (AND (not (errorp file-2))  ; DAB 06-21-90
	   FILE-2 (SEND (SRCCOM:FILE-STREAM FILE-2) :CLOSE))))
  DIS-NONE)
))
