;;; -*- Mode: Common-Lisp; Package: zwei; Base: 8.; Patch-File: T -*-

;;; Reason: Modified PRINT-BUFFER-1 and com-print-region to pass :tab-width to print-stream. [9249]

;;;                           RESTRICTED RIGHTS LEGEND
;;;
;;; Use, duplication, or disclosure by the Government is subject to
;;; restrictions as set forth in subdivision (c)(1)(ii) of the Rights in
;;; Technical Data and Computer Software clause at 52.227-7013.
;;;
;;;   TEXAS INSTRUMENTS INCORPORATED      
;;;   P.O. BOX 149149, M/S 2151             
;;;   AUSTIN, TEXAS 78714-9149                 
;;;
;;; Copyright (C) 1989 Texas Instruments Incorporated.
;;; All rights reserved.

;;; Patch file for ZWEI version 6.24
;;; Written 06/21/90 10:25:57 by BERGER,
;;; while running on ARIES from band LODX
;;; With SYSTEM 6.41, VIRTUAL-MEMORY 6.3, EH 6.8, MAKE-SYSTEM 6.5, MICRONET 6.0, LOCAL-FILE 6.2,
;;;  BASIC-PATHNAME 6.5, NETWORK-SUPPORT-COLD 6.2, BASIC-NAMESPACE 6.8, NETWORK-NAMESPACE 6.1,
;;;  DISK-IO 6.4, DISK-LABEL 6.1, BASIC-FILE 6.13, MAC-PATHNAME 6.0, NETWORK-PATHNAME 6.2,
;;;  COMPILER 6.18, TV 6.30, DATALINK 6.0, CHAOSNET 6.8, GC 6.4, MEMORY-AUX 6.0, NVRAM 6.4,
;;;  SYSLOG 6.2, STREAMER-TAPE 6.6, UCL 6.1, INPUT-EDITOR 6.0, METER 6.2, ZWEI 6.22,
;;;  DEBUG-TOOLS 6.5, NETWORK-SUPPORT 6.1, NETWORK-SERVICE 6.3, DATALINK-DISPLAYS 6.0,
;;;  FONT-EDITOR 6.1, SERIAL 6.0, PRINTER 6.8, MAC-PRINTER-TYPES 6.2, PRINTER-TYPES 6.2,
;;;  IMAGEN 6.1, SUGGESTIONS 6.1, MAIL-DAEMON 6.6, MAIL-READER 6.8, TELNET 6.1, VT100 6.0,
;;;  NAMESPACE-EDITOR 6.6, PROFILE 6.3, VISIDOC 6.7, TI-CLOS 6.53, CLEH 6.5, IP 3.65,
;;;  Experimental BUG 11.19, Experimental CLX 7.0, Experimental CLUE 7.2, X11M 6.31,
;;;  Experimental Z-TO-C 3.0, VISIDOC-SERVER 6.2,  microcode 483, Band Name: Rel 6.1 *b +SLE 6/18

#!C
; From file ZMACS.LISP#> ZMACS; sys:
#8R ZWEI#:
(COMPILER-LET ((*PACKAGE* (FIND-PACKAGE "ZWEI"))
                          (SI:*LISP-MODE* :COMMON-LISP)
                          (*READTABLE* SYS:COMMON-LISP-READTABLE)
                          (SI:*READER-SYMBOL-SUBSTITUTIONS* SYS::*COMMON-LISP-SYMBOL-SUBSTITUTIONS*))
  (COMPILER#:PATCH-SOURCE-FILE "SYS: ZMACS; ZMACS.#"


(DEFCOM COM-PRINT-REGION "Prints the region on the default hardcopy device." ()
  (LET ((*STANDARD-OUTPUT* *QUERY-IO*))
    (IF (FBOUNDP 'PRINT-STREAM)
	(REGION (BP0 BP1)
	  (LET* ((INTERVAL (MAKE-INTERVAL BP0 BP1))
		 (FONTS (SEND *INTERVAL* :GET-ATTRIBUTE :FONTS))
		 (tab-width (SEND *INTERVAL* :GET-ATTRIBUTE :tab-width))  ; DAB 06-21-90 Pass tab-width to print-file 
		 (STREAM (IF (ATOM FONTS) 
			     (INTERVAL-STREAM INTERVAL)
			     (INTERVAL-STREAM INTERVAL NIL NIL T))))
	    (PRINT-STREAM STREAM
			  :HEADER-NAME (WITH-OUTPUT-TO-STRING (*STANDARD-OUTPUT*)
					 (PRINC "ZWEI Buffer ")
					 ;; Print the pathname, or else the buffer name.
					 (PRINC (OR (BUFFER-PATHNAME *INTERVAL*)
						    (BUFFER-NAME *INTERVAL*)))
					 ;; Print last visited version number, if one is recorded.
					 (AND (CONSP (BUFFER-FILE-ID *INTERVAL*))
					      (TYPEP (CAR (BUFFER-FILE-ID *INTERVAL*)) 'PATHNAME)
					      (FORMAT T " (~D)"
						      (SEND (CAR (BUFFER-FILE-ID *INTERVAL*)) :VERSION))))
			  :FONT-LIST (IF (ATOM FONTS) (LIST FONTS) FONTS)
			  :tab-width tab-width  ; DAB 06-21-90
			  )) ;;98.30 ddd.
	  (FORMAT T " -- Queued Request."))
	(PROGN
	  (BEEP)
	  (FORMAT T "Unable to print a region - the printer functions are not loaded."))))
  DIS-NONE)


(DEFUN PRINT-BUFFER-1 (INTERVAL &OPTIONAL (*STANDARD-OUTPUT* *QUERY-IO*))
  "Print INTERVAL's contents on default printer.
The value supplied for *STANDARD-OUTPUT* is used for printing
notes about the progress of the printing."
  (IF (FBOUNDP 'PRINT-STREAM)
      (LET* ((FONTS (SEND INTERVAL :GET-ATTRIBUTE :FONTS))
	     (tab-width (SEND INTERVAL :GET-ATTRIBUTE :tab-width))	; DAB 06-21-90 Pass tab-width to print-file 
	     (STREAM (IF (ATOM FONTS)
			 (INTERVAL-STREAM INTERVAL)
			 (INTERVAL-STREAM INTERVAL NIL NIL T))))
	(PRINT-STREAM STREAM
		      :HEADER-NAME
		      (WITH-OUTPUT-TO-STRING (*STANDARD-OUTPUT*)
			(PRINC "ZWEI Buffer ")
			;; Print the pathname, or else the buffer name.
			(PRINC (OR (BUFFER-PATHNAME INTERVAL)
				   (BUFFER-NAME INTERVAL)))
			;; Print last visited version number, if one is recorded.
			(AND (CONSP (BUFFER-FILE-ID INTERVAL))
			     (TYPEP (CAR (BUFFER-FILE-ID INTERVAL)) 'PATHNAME)
			     (FORMAT T " (~D)"
				     (SEND (CAR (BUFFER-FILE-ID INTERVAL)) :VERSION))))
		      :tab-width tab-width  ; DAB 06-21-90
			  )
	(FORMAT T " -- Queued Request."))
      (PROGN
	(BEEP)
;	(if (si:addin-p)
;	    (format t "Unable to print a buffer - Must use print file services.")
	    (FORMAT T "Unable to print a buffer - the printer functions are not loaded.")))
  T)
))
