;;; -*- Mode: Common-Lisp; Package: zwei; Base: 8.; Patch-File: T -*-

;;; Reason: COPY-FILE-1 was not handling pathnames with wild cards correctly. [6660]

;;;                           RESTRICTED RIGHTS LEGEND
;;;
;;; Use, duplication, or disclosure by the Government is subject to
;;; restrictions as set forth in subdivision (c)(1)(ii) of the Rights in
;;; Technical Data and Computer Software clause at 52.227-7013.
;;;
;;;   TEXAS INSTRUMENTS INCORPORATED      
;;;   P.O. BOX 149149, M/S 2151             
;;;   AUSTIN, TEXAS 78714-9149                 
;;;
;;; Copyright (C) 1989 Texas Instruments Incorporated.
;;; All rights reserved.

;;; Patch file for ZWEI version 6.25
;;; Written 06/21/90 14:29:57 by BERGER,
;;; while running on ARIES from band LODX
;;; With SYSTEM 6.41, VIRTUAL-MEMORY 6.3, EH 6.8, MAKE-SYSTEM 6.5, MICRONET 6.0, LOCAL-FILE 6.2,
;;;  BASIC-PATHNAME 6.5, NETWORK-SUPPORT-COLD 6.2, BASIC-NAMESPACE 6.8, NETWORK-NAMESPACE 6.1,
;;;  DISK-IO 6.4, DISK-LABEL 6.1, BASIC-FILE 6.13, MAC-PATHNAME 6.0, NETWORK-PATHNAME 6.2,
;;;  COMPILER 6.18, TV 6.30, DATALINK 6.0, CHAOSNET 6.8, GC 6.4, MEMORY-AUX 6.0, NVRAM 6.4,
;;;  SYSLOG 6.2, STREAMER-TAPE 6.6, UCL 6.1, INPUT-EDITOR 6.0, METER 6.2, ZWEI 6.22,
;;;  DEBUG-TOOLS 6.5, NETWORK-SUPPORT 6.1, NETWORK-SERVICE 6.3, DATALINK-DISPLAYS 6.0,
;;;  FONT-EDITOR 6.1, SERIAL 6.0, PRINTER 6.8, MAC-PRINTER-TYPES 6.2, PRINTER-TYPES 6.2,
;;;  IMAGEN 6.1, SUGGESTIONS 6.1, MAIL-DAEMON 6.6, MAIL-READER 6.8, TELNET 6.1, VT100 6.0,
;;;  NAMESPACE-EDITOR 6.6, PROFILE 6.3, VISIDOC 6.7, TI-CLOS 6.53, CLEH 6.5, IP 3.65,
;;;  Experimental BUG 11.19, Experimental CLX 7.0, Experimental CLUE 7.2, X11M 6.31,
;;;  Experimental Z-TO-C 3.0, VISIDOC-SERVER 6.2,  microcode 483, Band Name: Rel 6.1 *b +SLE 6/18

#!C
; From file FILES.LISP#> ZMACS; sys:
#8R ZWEI#:
(COMPILER-LET ((*PACKAGE* (FIND-PACKAGE "ZWEI"))
                          (SI:*LISP-MODE* :COMMON-LISP)
                          (*READTABLE* SYS:COMMON-LISP-READTABLE)
                          (SI:*READER-SYMBOL-SUBSTITUTIONS* SYS::*COMMON-LISP-SYMBOL-SUBSTITUTIONS*))
  (COMPILER#:PATCH-SOURCE-FILE "SYS: ZMACS; FILES.#"


(DEFUN COPY-FILE-1 (COPY-MODE COPY-CREATION-DATE?)
  (LET* ((FILE-TYPE-STRING (CASE COPY-MODE
				 ((T) "Copy text file")
				 ((NIL) "Copy binary file")
				 (OTHERWISE "Copy file")))
	 (DEFAULT-PATHNAME (DEFAULT-PATHNAME))
	 (PATHNAME (READ-DEFAULTED-PATHNAME (FORMAT NIL "~A:" FILE-TYPE-STRING)
					    DEFAULT-PATHNAME)) 
	 (TO-SPEC (READ-UNDEFAULTED-PATHNAME-STRING
		    (FORMAT NIL "Copy file ~A to:" PATHNAME)
		    PATHNAME))
	 temp-path)				; DAB 06-21-90
    (IF (SEND PATHNAME :WILD-P)
	(LET ((DIR (CDR (FS:DIRECTORY-LIST PATHNAME)))
	      (TO-PATHNAME (MERGE-PATHNAMES TO-SPEC PATHNAME))
	      (COPY-FUNCTION #'COPY-FILE)
	      DIR-ENTRIES
	      (create-directories-option ()))
	  ;; See if there are any subdirectories in the list.
	  ;; All directory-handling stuff added by rpm (from dkm) on 11-25-86.
	  (DOLIST (ELT DIR)				    
	     (AND (GETF (CDR ELT) :DIRECTORY)
		  (PUSH ELT DIR-ENTRIES)))
	  ;; If so, ask if they want to copy them.
	  (WHEN DIR-ENTRIES
	    (COND ((LET ((*QUERY-IO* *STANDARD-OUTPUT*))
		     (Y-OR-N-P "Copy Directories too? "))
		   (LET ((*QUERY-IO* *STANDARD-OUTPUT*))
		     (setf create-directories-option  ; DAB 06-21-90 Get :create-directories option up front.
			 (fquery '(:choices (((t "yes") #\y #\t #\space #\hand-up)
					     ((nil "no") #\n #\rubout #\hand-down)
					     ((:query "query") #\q)))
				 "Create directories?")))
						 
		   ;(SETQ COPY-FUNCTION #'COPY-DIRECTORY)  ; DAB 06-21-90 Move to dolist below.
		   )  
		  (T
		   ;;Remove subdirectories from dir list.
		   (DOLIST (ELT DIR-ENTRIES)		    
		      (SETQ DIR (DELETE ELT DIR)))
		   (SETQ DIR-ENTRIES NIL))))
	  (FORMAT T "~&Files ~:[~;and Directories ~]to be copied:~%" DIR-ENTRIES)
	  (MAPC *DIRECTORY-SINGLE-FILE-LISTER* DIR)
	  (WHEN (LET ((*QUERY-IO* *STANDARD-OUTPUT*))
		  (Y-OR-N-P "Copy them? "))
	    (DOLIST (ELT DIR)
	      (CONDITION-CASE (ERROR)
		  (progn
		   ;;We must check each entry before deciding to use copy-file or copy-directory.  ; DAB 06-21-90
		  (if (GETF (CDR ELT) :DIRECTORY)
		      (progn (SETQ COPY-FUNCTION #'COPY-DIRECTORY)
			     ;;Since the pathname is in the form lm:dir;dir2.directory#1 we must convert it so CD can use it.
			     (setf temp-path (send (send (car elt) :pathname-as-directory)
						   :new-pathname :name :wild :type :wild :version :newest)))
		      (setf COPY-FUNCTION #'COPY-FILE)
		      (setf temp-path (car elt)))
		  (FUNCALL COPY-FUNCTION		   
			   temp-path;(CAR ELT)
			   (SEND TO-PATHNAME :TARGET-TRANSLATE-WILD-PATHNAME PATHNAME temp-path) ; DAB 06-21-90
			   :COPY-CREATION-DATE COPY-CREATION-DATE?
			   :COPY-AUTHOR COPY-CREATION-DATE?
			   :CHARACTERS COPY-MODE
			   :REPORT-STREAM *STANDARD-OUTPUT*
			   :create-directories  create-directories-option
			   :DIRECTORY-LIST ELT)	;Speeds it up a touch.
		  )
		((FS:FILE-ERROR SYSTEM:REMOTE-NETWORK-ERROR)
		 (FORMAT T "~&Copy failure: ~A" ERROR))))
	    (FORMAT T "~&Done.~%")))
	(CONDITION-CASE (VALUE)
	    (COPY-FILE PATHNAME
		       TO-SPEC
		       :COPY-CREATION-DATE COPY-CREATION-DATE?
		       :COPY-AUTHOR COPY-CREATION-DATE?
		       :CHARACTERS COPY-MODE
		       :REPORT-STREAM *QUERY-IO*)
	  ((FS:FILE-ERROR SYSTEM:REMOTE-NETWORK-ERROR)
	   (BARF VALUE))))))
))
