;;; -*- Mode: Common-Lisp; Package: zwei; Base: 8.; Patch-File: T -*-

;;; Reason: Modified DIRED-LINE-FILE-SIZE  to handle byte-size of :default [9598]

;;;                           RESTRICTED RIGHTS LEGEND
;;;
;;; Use, duplication, or disclosure by the Government is subject to
;;; restrictions as set forth in subdivision (c)(1)(ii) of the Rights in
;;; Technical Data and Computer Software clause at 52.227-7013.
;;;
;;;   TEXAS INSTRUMENTS INCORPORATED      
;;;   P.O. BOX 149149, M/S 2151             
;;;   AUSTIN, TEXAS 78714-9149                 
;;;
;;; Copyright (C) 1989 Texas Instruments Incorporated.
;;; All rights reserved.

;;; Written 06/22/90 09:58:18 by BERGER,
;;; while running on ARIES from band LODX
;;; With SYSTEM 6.41, VIRTUAL-MEMORY 6.3, EH 6.8, MAKE-SYSTEM 6.5, MICRONET 6.0, LOCAL-FILE 6.2,
;;;  BASIC-PATHNAME 6.5, NETWORK-SUPPORT-COLD 6.2, BASIC-NAMESPACE 6.8, NETWORK-NAMESPACE 6.1,
;;;  DISK-IO 6.4, DISK-LABEL 6.1, BASIC-FILE 6.13, MAC-PATHNAME 6.0, NETWORK-PATHNAME 6.2,
;;;  COMPILER 6.18, TV 6.31, DATALINK 6.0, CHAOSNET 6.8, GC 6.4, MEMORY-AUX 6.0, NVRAM 6.4,
;;;  SYSLOG 6.2, STREAMER-TAPE 6.6, UCL 6.1, INPUT-EDITOR 6.1, METER 6.2, ZWEI 6.25,
;;;  DEBUG-TOOLS 6.5, NETWORK-SUPPORT 6.1, NETWORK-SERVICE 6.3, DATALINK-DISPLAYS 6.0,
;;;  FONT-EDITOR 6.1, SERIAL 6.0, PRINTER 6.8, MAC-PRINTER-TYPES 6.2, PRINTER-TYPES 6.2,
;;;  IMAGEN 6.1, SUGGESTIONS 6.1, MAIL-DAEMON 6.6, MAIL-READER 6.8, TELNET 6.1, VT100 6.0,
;;;  NAMESPACE-EDITOR 6.7, PROFILE 6.3, VISIDOC 6.7, TI-CLOS 6.53, CLEH 6.5, IP 3.65,
;;;  Experimental BUG 11.19, Experimental CLX 7.0, Experimental CLUE 7.3, X11M 6.31,
;;;   microcode 483, Band Name: Rel 6.1 *b +SLE 6/18

#!C
; From file DIRED.LISP#> ZMACS; SYS:
#8R ZWEI#:
(COMPILER-LET ((*PACKAGE* (FIND-PACKAGE "ZWEI"))
                          (SI:*LISP-MODE* :COMMON-LISP)
                          (*READTABLE* SYS:COMMON-LISP-READTABLE)
                          (SI:*READER-SYMBOL-SUBSTITUTIONS* SYS::*COMMON-LISP-SYMBOL-SUBSTITUTIONS*))
  (COMPILER#:PATCH-SOURCE-FILE "SYS: ZMACS; DIRED.#"


(DEFUN DIRED-LINE-FILE-SIZE (LINE &AUX PLIST BYTE-SIZE BLOCK-SIZE)
  "Return size, in bits, of file described by LINE."
  (SETQ PLIST (LOCF (LINE-PLIST LINE)))
  (COND ((GET PLIST :LINK-TO) -1)		     ;Sort links together in this mode
	((SETQ BYTE-SIZE (GET PLIST :BYTE-SIZE))
	 (unless (numberp byte-size) ; DAB 06-22-90 Handle the case of :byte-size :default . [9598]
	   (setf (values nil byte-size)
		 (fs:DETERMINE-IF-TYPE-KNOWN
		   (send (DIRED-LINE-PATHNAME line) :CANONICAL-TYPE)
		   (send (DIRED-LINE-PATHNAME line) :type)
		   T 8))
	   )
	 (* BYTE-SIZE (GET PLIST :LENGTH-IN-BYTES)))
	((GET PLIST :LENGTH-in-bytes)  ; DAB 12-07-89 have they have a length-in-bytes property, user it. [10849]
	 (GET PLIST :LENGTH-IN-BYTES))
	((SETQ BLOCK-SIZE (GET PLIST :BLOCK-SIZE))
	 (* BLOCK-SIZE (GET PLIST :LENGTH-IN-BLOCKS)))
	(:ELSE 0)))
))
