;;; -*- Mode: Common-Lisp; Package: ZWEI; Base: 8.; Patch-File: T -*-

;;; Reason: Modified add-patch-internal to include LISP package prefix for compiler-let. [11237]

;;;                           RESTRICTED RIGHTS LEGEND
;;;
;;; Use, duplication, or disclosure by the Government is subject to
;;; restrictions as set forth in subdivision (c)(1)(ii) of the Rights in
;;; Technical Data and Computer Software clause at 52.227-7013.
;;;
;;;   TEXAS INSTRUMENTS INCORPORATED      
;;;   P.O. BOX 149149, M/S 2151             
;;;   AUSTIN, TEXAS 78714-9149                 
;;;
;;; Copyright (C) 1989 Texas Instruments Incorporated.
;;; All rights reserved.

;;; Patch file for ZWEI version 6.27
;;; Written 06/25/90 07:26:39 by BERGER,
;;; while running on ARIES from band LODX
;;; With SYSTEM 6.41, VIRTUAL-MEMORY 6.3, EH 6.8, MAKE-SYSTEM 6.5, MICRONET 6.0, LOCAL-FILE 6.2,
;;;  BASIC-PATHNAME 6.5, NETWORK-SUPPORT-COLD 6.2, BASIC-NAMESPACE 6.8, NETWORK-NAMESPACE 6.1,
;;;  DISK-IO 6.4, DISK-LABEL 6.1, BASIC-FILE 6.13, MAC-PATHNAME 6.0, NETWORK-PATHNAME 6.2,
;;;  COMPILER 6.18, TV 6.31, DATALINK 6.0, CHAOSNET 6.8, GC 6.4, MEMORY-AUX 6.0, NVRAM 6.4,
;;;  SYSLOG 6.2, STREAMER-TAPE 6.6, UCL 6.1, INPUT-EDITOR 6.1, METER 6.2, ZWEI 6.26,
;;;  DEBUG-TOOLS 6.5, NETWORK-SUPPORT 6.1, NETWORK-SERVICE 6.3, DATALINK-DISPLAYS 6.0,
;;;  FONT-EDITOR 6.1, SERIAL 6.0, PRINTER 6.8, MAC-PRINTER-TYPES 6.2, PRINTER-TYPES 6.2,
;;;  IMAGEN 6.1, SUGGESTIONS 6.1, MAIL-DAEMON 6.6, MAIL-READER 6.8, TELNET 6.1, VT100 6.0,
;;;  NAMESPACE-EDITOR 6.7, PROFILE 6.3, VISIDOC 6.7, TI-CLOS 6.53, CLEH 6.5, IP 3.65,
;;;  Experimental BUG 11.19, Experimental CLX 7.0, Experimental CLUE 7.5, X11M 6.32,
;;;   microcode 483, Band Name: Rel 6.1 *b +SLE 6/18

#!C
; From file PATED.LISP#> ZMACS; SYS:
#8R ZWEI#:
(COMPILER-LET ((*PACKAGE* (FIND-PACKAGE "ZWEI"))
                          (SI:*LISP-MODE* :COMMON-LISP)
                          (*READTABLE* SYS:COMMON-LISP-READTABLE)
                          (SI:*READER-SYMBOL-SUBSTITUTIONS* SYS::*COMMON-LISP-SYMBOL-SUBSTITUTIONS*))
  (COMPILER#:PATCH-SOURCE-FILE "SYS: ZMACS; PATED.#"


(DEFUN ADD-PATCH-INTERVAL (BP1 BP2 IN-ORDER-P DEFUN-NAME BUFFER &AUX NEW-PATCH-BUFFER-P)
  (GET-INTERVAL BP1 BP2 IN-ORDER-P)
  (VALIDATE-PATCH-BUFFER)
  (SETQ NEW-PATCH-BUFFER-P (NULL *PATCH-BUFFER*))
  (AND NEW-PATCH-BUFFER-P
       (CREATE-NEW-PATCH (READ-PATCH-SYSTEM-NAME)))
  (IF (STRINGP DEFUN-NAME)
      (FORMAT *QUERY-IO* "~&Adding ~A to patch file ~A~:[~;~%(New patch file.)~]"
	      DEFUN-NAME (PATCH-VERSION-DESCRIPTION) NEW-PATCH-BUFFER-P)
      (FORMAT *QUERY-IO* "~&Adding ~S to patch file ~A~:[~;~%(New patch file.)~]"
	      DEFUN-NAME (PATCH-VERSION-DESCRIPTION) NEW-PATCH-BUFFER-P))
  (LET ((BP (INTERVAL-LAST-BP *PATCH-BUFFER*)))
    ;; Put into the patch buffer, making sure the right package and base will be used.
    (MULTIPLE-VALUE-BIND (VARS VALS)
	(SEND BUFFER :ATTRIBUTE-BINDINGS)
      (PROGV VARS VALS
	; DAB 06-25-90 Added package prefix because of CLIO.[11237]
	(INSERT BP (FORMAT NIL "~%#!~A~%; From file ~A~%#~DR ~A#:
\(lisp:COMPILER-LET ((*PACKAGE* (FIND-PACKAGE \"~:*~A\"))
                          (SI:*LISP-MODE* ~S)
                          (*READTABLE* ~S)
                          (SI:*READER-SYMBOL-SUBSTITUTIONS* ~S))
\  (COMPILER#:PATCH-SOURCE-FILE ~S~%

"
			   (IF (EQL (SEND *INTERVAL* :MAJOR-MODE) 'COMMON-LISP-MODE)
			       "C"
			       "Z")
			   (BUFFER-NAME BUFFER)
			   *READ-BASE*
			   (PACKAGE-NAME *PACKAGE*)
			   (IF (EQL (SEND *INTERVAL* :MAJOR-MODE) 'COMMON-LISP-MODE)
			       :COMMON-LISP
			       :ZETALISP)
			   (IF (EQL (SEND *INTERVAL* :MAJOR-MODE) 'COMMON-LISP-MODE)
			       'SI::COMMON-LISP-READTABLE
			       'SI::STANDARD-READTABLE)
			   (IF (EQL (SEND *INTERVAL* :MAJOR-MODE) 'COMMON-LISP-MODE)
			       'SI:*COMMON-LISP-SYMBOL-SUBSTITUTIONS*
			       'SI:*ZETALISP-SYMBOL-SUBSTITUTIONS*)
			   (WHEN (BUFFER-GENERIC-PATHNAME BUFFER)
			     (SEND (get-buffer-logical-pathname-for-patch  ; DAB 03-14-89
				     (BUFFER-GENERIC-PATHNAME BUFFER))
				   :STRING-FOR-PRINTING))))))
    (INSERT-INTERVAL BP BP1 BP2 T)
    (INSERT BP "
))
"))
  ;; Mark all sections that the region contains part of
  ;; as having been patched.
  (INTERVAL-LINES (BP1 BP2) (START-LINE END-LINE)
    (DO ((LINE START-LINE (LINE-NEXT LINE))
	 (LAST-SECTION))
	((EQ LINE END-LINE))
      (LET ((SECTION (LINE-NODE LINE)))
	(UNLESS (EQ LAST-SECTION SECTION)
	  (SETF (GET SECTION 'PATCH-TICK) *TICK*))
	(SETQ LAST-SECTION SECTION)))))
))
