;;; -*- Mode: Common-Lisp; Package: User; Base: 8.; Patch-File: T -*-

;;; Reason: Changed READ-FUNCTION-NAME to return EXPLICIT-PACKAGE-P when default is taken
;;; and DEFAULT contains a pkg other than the current *package*. This allows
;;; meta-.'ing with the default being the symbol 'chaos:listen in some other 
;;; package than 'chaos. Otherwise 'chaos:listen gets converted to "LISTEN" 
;;; and then to 'lisp:listen, which is wrong.

;;;                           RESTRICTED RIGHTS LEGEND
;;;
;;; Use, duplication, or disclosure by the Government is subject to
;;; restrictions as set forth in subdivision (c)(1)(ii) of the Rights in
;;; Technical Data and Computer Software clause at 52.227-7013.
;;;
;;;   TEXAS INSTRUMENTS INCORPORATED      
;;;   P.O. BOX 149149, M/S 2151             
;;;   AUSTIN, TEXAS 78714-9149                 
;;;
;;; Copyright (C) 1989 Texas Instruments Incorporated.
;;; All rights reserved.

;;; Written 06/29/90 13:57:20 by MARKY,
;;; while running on LIBRA from band LODA
;;; With SYSTEM 6.41, VIRTUAL-MEMORY 6.3, EH 6.8, MAKE-SYSTEM 6.5, MICRONET 6.0, LOCAL-FILE 6.2,
;;;  BASIC-PATHNAME 6.5, NETWORK-SUPPORT-COLD 6.2, BASIC-NAMESPACE 6.8, NETWORK-NAMESPACE 6.1,
;;;  DISK-IO 6.4, DISK-LABEL 6.1, BASIC-FILE 6.14, MAC-PATHNAME 6.0, NETWORK-PATHNAME 6.2,
;;;  COMPILER 6.18, TV 6.32, DATALINK 6.0, CHAOSNET 6.8, GC 6.7, MEMORY-AUX 6.0, NVRAM 6.4,
;;;  SYSLOG 6.2, STREAMER-TAPE 6.6, UCL 6.1, INPUT-EDITOR 6.1, METER 6.2, ZWEI 6.27,
;;;  DEBUG-TOOLS 6.5, NETWORK-SUPPORT 6.1, NETWORK-SERVICE 6.3, DATALINK-DISPLAYS 6.0,
;;;  FONT-EDITOR 6.1, SERIAL 6.0, PRINTER 6.8, MAC-PRINTER-TYPES 6.2, PRINTER-TYPES 6.2,
;;;  IMAGEN 6.1, SUGGESTIONS 6.1, MAIL-DAEMON 6.6, MAIL-READER 6.9, TELNET 6.1, VT100 6.0,
;;;  NAMESPACE-EDITOR 6.7, PROFILE 6.3, VISIDOC 6.7, TI-CLOS 6.53, CLEH 6.5, IP 3.65,
;;;  Experimental BUG 11.19, Experimental CLX 7.1, X11M 6.33, Experimental CLUE 7.14,
;;;  Experimental CLIO 1.0, Experimental SC 4.0, Experimental SCIFI 1.0,  microcode 483,
;;;  Band Name: Rel 6.1 *b +SLE 6/18

#!C
; From file MOUSE.LISP#> ZMACS; Hotel:
#8R ZWEI#:
(COMPILER-LET ((*PACKAGE* (FIND-PACKAGE "ZWEI"))
                          (SI:*LISP-MODE* :COMMON-LISP)
                          (*READTABLE* SYS:COMMON-LISP-READTABLE)
                          (SI:*READER-SYMBOL-SUBSTITUTIONS* SYS::*COMMON-LISP-SYMBOL-SUBSTITUTIONS*))
  (COMPILER#:PATCH-SOURCE-FILE "SYS: ZMACS; MOUSE.#"


(DEFUN READ-FUNCTION-NAME (PROMPT &OPTIONAL DEFAULT MUST-BE-DEFINED STRINGP HELP ;;gsl 3-14-85
			   &AUX EXPLICIT-PACKAGE-P PROMPT-WITHOUT-DEFAULT
			   (*MINI-BUFFER-DEFAULT-STRING*
			     (and default (prin1-to-string 	;; may 05/09/90
					    DEFAULT)))
			   (READ-FUNCTION-NAME-MUST-BE-DEFINED
			     MUST-BE-DEFINED)
			   (READ-FUNCTION-NAME-OLD-GLOBAL-MOUSE-CHAR-BLINKER-HANDLER
			     *GLOBAL-MOUSE-CHAR-BLINKER-HANDLER*)
			   (READ-FUNCTION-NAME-OLD-GLOBAL-MOUSE-CHAR-BLINKER-DOCUMENTATION-STRING
			     *GLOBAL-MOUSE-CHAR-BLINKER-DOCUMENTATION-STRING*)
			   (READ-FUNCTION-NAME-OLD-MOUSE-FONT-CHAR *MOUSE-FONT-CHAR*)
			   (READ-FUNCTION-NAME-OLD-MOUSE-X-OFFSET *MOUSE-X-OFFSET*)
			   (READ-FUNCTION-NAME-OLD-MOUSE-Y-OFFSET *MOUSE-Y-OFFSET*))
  "Read a function name using mini buffer or mouse.
PROMPT is a string that goes in the mode line.
DEFAULT is a function spec to return if the user types just Return.
MUST-BE-DEFINED can be T (allow only defined functions), NIL (allow anything)
 or AARRAY-OK (allow anything either defined as a function
 or known as a section by the editor).
STRINGP can be T, NIL, ALWAYS-READ or MULTIPLE-OK.
 T means if user types text, just return a string; don't try to intern it.
 ALWAYS-READ means intern the user's string afresh now;
  don't use the symbol or list recorded in the completion aarray.
 MULTIPLE-OK means it is ok to return more than one possible function
  the user could have meant, if they differ only in their package.

The first value is a list of function specs (only one, unless STRINGP is MULTIPLE-OK).
 If STRINGP is T, this is NIL.
The second value is the string the user typed, sans package prefix.
The third value is T if the user typed a package prefix
or if the default has an explicit package prefix and the default is taken."	;; may 06/29/90 Added
  (DECLARE (VALUES COMPLETIONS STRING EXPLICIT-PACKAGE-P))
  (DECLARE (SPECIAL READ-FUNCTION-NAME-MUST-BE-DEFINED
		    READ-FUNCTION-NAME-OLD-GLOBAL-MOUSE-CHAR-BLINKER-HANDLER
		    READ-FUNCTION-NAME-OLD-GLOBAL-MOUSE-CHAR-BLINKER-DOCUMENTATION-STRING
		    READ-FUNCTION-NAME-OLD-MOUSE-FONT-CHAR
		    READ-FUNCTION-NAME-OLD-MOUSE-X-OFFSET
		    READ-FUNCTION-NAME-OLD-MOUSE-Y-OFFSET))
  (SYS:WITH-SUGGESTIONS-MENUS-FOR ZWEI:READ-FUNCTION-NAME
    (WHEN (EQ MUST-BE-DEFINED T)
      (SETQ STRINGP 'ALWAYS-READ))
    (SETQ PROMPT-WITHOUT-DEFAULT PROMPT
	  PROMPT (FORMAT NIL "~A~:[:~; (Default: ~S)~]" PROMPT DEFAULT DEFAULT))
    (LET ((NAME (LET ((*POST-COMMAND-HOOK* (APPEND *POST-COMMAND-HOOK* '(READ-FUNCTION-NAME-COMMAND-HOOK)))
		      (*MINI-BUFFER-VALUE-HISTORY* *DEFINITION-NAME-HISTORY*))
		  (LET ((*BATCH-UNDO-SAVE* T))
		    (DELETE-INTERVAL (WINDOW-INTERVAL *MINI-BUFFER-WINDOW*)))
		  (UNWIND-PROTECT
		      (PROGN
			(READ-FUNCTION-NAME-COMMAND-HOOK NIL)
			(COMPLETING-READ-FROM-MINI-BUFFER PROMPT *ZMACS-COMPLETION-AARRAY*
							  (OR (NEQ STRINGP 'ALWAYS-READ)
							      'ALWAYS-STRING)
							  NIL HELP)) ;;gsl 3-14-85
		    (READ-FUNCTION-NAME-COMMAND-HOOK T))))
	  SYM
	  ERROR-P)
      (COND ((EQUAL NAME "")
	     (UNLESS DEFAULT (BARF))
	     (SETQ SYM DEFAULT
		   NAME (princ-to-string default))	;; may 06/29/90 
	           ;; may 06/29/90 (SYMBOLP NAME) *must* be nil since it is equal to "" so the code below was half-dead.
		   ;;(IF (SYMBOLP NAME)
	           ;;    (STRING NAME)
		   ;;    (WITH-OUTPUT-TO-STRING (*STANDARD-OUTPUT*) (PRINC DEFAULT)))
	     ;; may 06/29/90 Must return EXPLICIT-PACKAGE-P if DEFAULT had one, else
	     ;; COM-EDIT-DEFINITION tries to convert chaos:listen into lisp:listen when
	     ;; chaos:listen is the default and the current package is not 'CHAOS.
	     (setq explicit-package-p (and (symbolp default) (neq *package* (symbol-package default)))))
	    ((CONSP NAME)
	     (SETQ SYM (CDR NAME)
		   NAME (CAR NAME))
	     (WHEN (AND (CONSP SYM)
			(NEQ STRINGP 'MULTIPLE-OK))
	       (SETQ SYM (CAR SYM))))
	    ((EQ STRINGP T)			;If returning a string, don't intern it
	     (SETQ SYM NAME))
	    (T
	     ;; If the string that was specified started with a package prefix,
	     ;; return a flag saying so.
	     ;; SYMBOL-FROM-STRING will flush the prefix from NAME.
	     (LET ((NON-LETTER-INDEX (STRING-SEARCH-NOT-SET " ABCDEFGHIJKLMNOPQRSTUVWXYZ-" NAME)))
	       (COND ((AND NON-LETTER-INDEX
			   (plusp non-letter-index) ;; may 05/08/89 Allow keywords with no package prefix
			   (CHAR= (AREF NAME NON-LETTER-INDEX) #\:))
		      (SETQ EXPLICIT-PACKAGE-P T))))
	     (MULTIPLE-VALUE-SETQ (SYM NAME ERROR-P)
	       (SYMBOL-FROM-STRING NAME NIL T))
	     (COND ((AND (CONSP SYM)
			 (EQ STRINGP 'MULTIPLE-OK))
		    (SETQ SYM (CONS SYM NIL))))
	     (COND (ERROR-P
		    (BARF "Read error")))))
      (COND ((AND (EQ MUST-BE-DEFINED T)
		  (NOT (OR (FDEFINEDP SYM)
			   (AND (SYMBOLP SYM)
				(SI:MEMQ-ALTERNATED 'ARGLIST (SYMBOL-PLIST SYM))))))
	     (COND ((NOT (DOLIST (SPEC (PACKAGE-LOOKALIKE-SYMBOLS SYM))
			   (COND ((FQUERY '(:SELECT T)
					  ;; Always print prefix
					  ;; Don't leave PACKAGE in keyword during query.
					  (LET ((*PACKAGE* PKG-KEYWORD-PACKAGE))
					    (FORMAT NIL "Do you mean ~S? " SPEC)))
				  (RETURN (SETQ SYM SPEC))))))
		    (BARF "~S is not defined" SYM)))))
      (PUSH-ON-HISTORY SYM *DEFINITION-NAME-HISTORY*)
      (PROMPT-LINE "~A ~S" PROMPT-WITHOUT-DEFAULT
		   (IF (AND (EQ STRINGP 'MULTIPLE-OK)
			    (NOT (ATOM SYM)))
		       (FIRST SYM)
		       SYM))
      (VALUES SYM NAME EXPLICIT-PACKAGE-P)))) 

))
