;;; -*- Mode: Common-Lisp; Package: ZWEI; Base: 8.; Patch-File: T -*-

;;; Reason:  Updated TI's new mailing address in (BUG-REPORT-OBJECT :BUG-REPORT-BODY).

;;;                           RESTRICTED RIGHTS LEGEND
;;;
;;; Use, duplication, or disclosure by the Government is subject to
;;; restrictions as set forth in subdivision (c)(1)(ii) of the Rights in
;;; Technical Data and Computer Software clause at 52.227-7013.
;;;
;;;   TEXAS INSTRUMENTS INCORPORATED      
;;;   P.O. BOX 2909, M/S 2151             
;;;   AUSTIN, TEXAS 78769                 
;;;
;;; Copyright (C) 1989 Texas Instruments Incorporated.
;;; All rights reserved.

;;; Written 07/13/89 13:08:25 by BERGER,
;;; while running on ARIES from band LOD1
;;; With SYSTEM 6.12, VIRTUAL-MEMORY 6.1, EH 6.3, MAKE-SYSTEM 6.0, MICRONET 6.0, LOCAL-FILE 6.0,
;;;  BASIC-PATHNAME 6.1, NETWORK-SUPPORT-COLD 6.0, BASIC-NAMESPACE 6.1, NETWORK-NAMESPACE 6.0,
;;;  DISK-IO 6.0, DISK-LABEL 6.0, BASIC-FILE 6.2, MAC-PATHNAME 6.0, NETWORK-PATHNAME 6.0,
;;;  COMPILER 6.9, TV 6.12, DATALINK 6.0, CHAOSNET 6.0, GC 6.3, MEMORY-AUX 6.0, NVRAM 6.1,
;;;  SYSLOG 6.1, STREAMER-TAPE 6.4, UCL 6.0, INPUT-EDITOR 6.0, METER 6.1, ZWEI 6.3,
;;;  DEBUG-TOOLS 6.3, NETWORK-SUPPORT 6.0, NETWORK-SERVICE 6.1, DATALINK-DISPLAYS 6.0,
;;;  FONT-EDITOR 6.1, SERIAL 6.0, PRINTER 6.3, MAC-PRINTER-TYPES 6.1, PRINTER-TYPES 6.1,
;;;  IMAGEN 6.0, SUGGESTIONS 6.0, MAIL-DAEMON 6.2, MAIL-READER 6.2, TELNET 6.0, VT100 6.0,
;;;  NAMESPACE-EDITOR 6.0, PROFILE 6.1, VISIDOC 6.2, TI-CLOS 6.17, CLEH 6.4, IP 3.47,
;;;  Experimental BUG 11.10, Experimental CLX 6.2, CLUE 6.9, X11M 6.1,  microcode 429,
;;;  Band Name: 6.0 + patches 6/26

#!C
; From file BUG-REPORT-TEMPLATE.LISP#> ZMACS; SYS:
#8R ZWEI#:
(COMPILER-LET ((*PACKAGE* (FIND-PACKAGE "ZWEI"))
                          (SI:*LISP-MODE* :COMMON-LISP)
                          (*READTABLE* SYS:COMMON-LISP-READTABLE)
                          (SI:*READER-SYMBOL-SUBSTITUTIONS* SYS::*COMMON-LISP-SYMBOL-SUBSTITUTIONS*))
  (COMPILER#:PATCH-SOURCE-FILE "SYS: ZMACS; BUG-REPORT-TEMPLATE.#"


(defmethod (BUG-REPORT-OBJECT :BUG-REPORT-BODY) ()
  ;; Returns a string with the bug report body (no headers like to: cc: subject:)

  (string-append
    "      EXPLORER (TM) BUG REPORT" #\return #\return
    "DATE-TIME   : " date-time #\return
    "PRIORITY    : " priority     "     (H)igh (M)edium (L)ow" #\return
    "TYPE        : " type         "     (B)ug  (D)esign (M)anual" #\return
    "MACHINE-TYPE: " machine-type "     (M)icroExplorer" #\return #\return
    "DESCRIPTION-OF-PROBLEM:" #\return "   " user-description #\return #\return
    "WORK-AROUND:" #\return "   " work-around #\return #\return
    "CUSTOMER-ID: " tracking-id #\return #\return
    "NAME       : " name #\return
    "LOCATION   : " location #\return
    "ADDRESS    : " postal-address #\return
    "PHONE      : " phone #\return
    "NET-ADDRESS: " mail-address #\return #\return
    (if (and backtrace
	     (plusp (length backtrace)))
	(string-append "BACKTRACE:" #\return #\return backtrace #\return)
	"")
    "SOFTWARE-CONFIGURATION:" #\return #\return software-configuration #\return #\return
    "HARDWARE-CONFIGURATION:" #\return hardware-configuration #\return
    "
		    ********************************
		    *         Return to:           *
		    *                              *
		    *  EXPLORER BUG REPORTS        *
		    *  c/o Explorer Project Manager*
		    *  TEXAS INSTRUMENTS, MS 2201  *
		    *  P.O. Box 149149             *
		    *  Austin, Texas   78714-9149  *
		    ********************************" #\return))
))
