;;; -*- Mode: Common-Lisp; Package: User; Base: 10.; Patch-File: T -*-

;;; Reason: Corrected several bugs not fixed in patch 6.1


;;;                           RESTRICTED RIGHTS LEGEND
;;;
;;; Use, duplication, or disclosure by the Government is subject to
;;; restrictions as set forth in subdivision (c)(1)(ii) of the Rights in
;;; Technical Data and Computer Software clause at 52.227-7013.
;;;
;;;   TEXAS INSTRUMENTS INCORPORATED      
;;;   P.O. BOX 2909, M/S 2151             
;;;   AUSTIN, TEXAS 78769                 
;;;
;;; Copyright (C) 1989 Texas Instruments Incorporated.
;;; All rights reserved.

;;; Written 10/11/89 11:36:36 by File Server,
;;; while running on LIBRA from band LOD1
;;; With SYSTEM 6.20, VIRTUAL-MEMORY 6.2, EH 6.5, MAKE-SYSTEM 6.2, MICRONET 6.0, LOCAL-FILE 6.1,
;;;  BASIC-PATHNAME 6.2, NETWORK-SUPPORT-COLD 6.2, BASIC-NAMESPACE 6.4, NETWORK-NAMESPACE 6.0,
;;;  DISK-IO 6.1, DISK-LABEL 6.0, BASIC-FILE 6.4, MAC-PATHNAME 6.0, NETWORK-PATHNAME 6.0,
;;;  COMPILER 6.12, TV 6.15, DATALINK 6.0, CHAOSNET 6.1, GC 6.3, MEMORY-AUX 6.0, NVRAM 6.2,
;;;  SYSLOG 6.2, STREAMER-TAPE 6.4, UCL 6.0, INPUT-EDITOR 6.0, METER 6.1, ZWEI 6.5,
;;;  DEBUG-TOOLS 6.3, NETWORK-SUPPORT 6.0, NETWORK-SERVICE 6.1, DATALINK-DISPLAYS 6.0,
;;;  FONT-EDITOR 6.1, SERIAL 6.0, PRINTER 6.3, MAC-PRINTER-TYPES 6.1, PRINTER-TYPES 6.2,
;;;  IMAGEN 6.1, SUGGESTIONS 6.0, MAIL-DAEMON 6.3, MAIL-READER 6.5, TELNET 6.0, VT100 6.0,
;;;  NAMESPACE-EDITOR 6.3, PROFILE 6.2, VISIDOC 6.5, TI-CLOS 6.25, CLEH 6.5, IP 3.52,
;;;  Experimental CLX 6.4, CLUE 6.20, X11M 6.14, Experimental BUG 11.15,  microcode 429,
;;;  Band Name: Rel 6.0 + SLE 9/8


;; Corrected SPR's 6880 7427 8029 9442 7118 9887 10310 and many unreported bugs.

(UNLESS (si:mx-p) ;; don't load any of this patch ...

#!C
; From file EDIT-DISK-PARTITIONS.LISP#> ZMACS; SYS:
#10R ZWEI#:
 (COMPILER-LET ((*PACKAGE* (FIND-PACKAGE "ZWEI"))
                          (SI:*LISP-MODE* :COMMON-LISP)
                          (*READTABLE* SYS:COMMON-LISP-READTABLE)
                          (SI:*READER-SYMBOL-SUBSTITUTIONS* SYS::*COMMON-LISP-SYMBOL-SUBSTITUTIONS*))
  (COMPILER#:PATCH-SOURCE-FILE "SYS: ZMACS; EDIT-DISK-PARTITIONS.#"


 (defun get-disk-label-buffer ()
  (CAR (MEMBER nil *zmacs-buffer-list*
	       :test #'(lambda (ignore buffer)
			 (typep buffer 'zwei-disk-label-buffer)))))	;; may 06/09/89 

;; may 05/31/89 NEW
 (defun get-disk-config-buffer ()
  (CAR (MEMBER nil *zmacs-buffer-list*
	       :test #'(lambda (ignore buffer)
			 (typep buffer 'zwei-disk-config-buffer)))))	;; may 06/09/89 

 (DEFMETHOD (zwei-disk-config-buffer :update-config-top-of-buffer) (cfg-overhead)
  (let ((disk-label-interval (car (send (get-disk-label-buffer) :inferiors))))
    (WITH-READ-ONLY-SUPPRESSED (*interval*)
      (move-bp (point) (send *interval* :first-bp))
      
      (move-bp (point) (list (line-next (bp-line (point))) 0))
      (com-beginning-of-line)
      (com-kill-line)
      (format (bp-line (point)) format-disk-line
	      (send disk-label-interval :disk-name)
	      (send disk-label-interval :real-unit-number))
      
      (move-bp (point) (list (line-next (bp-line (point))) 0))
      (com-beginning-of-line)
      (com-kill-line)
      (format (bp-line (point)) format-cfg-line1
	      (send cfg-overhead :name)
	      (send cfg-overhead :generation)
	      (send cfg-overhead :revision))

      (move-bp (point) (list (line-next (bp-line (point))) 0))
      (com-beginning-of-line)
      (com-kill-line)
      (format (bp-line (point)) format-cfg-comment-line
	      (send cfg-overhead :comments))))
  (com-recenter-window)
  )

 (defcom com-change-cfg-revision
	"Change the configuration revision of the specified configuration module."()
  (let* ((cfg-overhead (getf (line-plist (bp-line (point))) :cfg-overhead))
	 (new-origin (typein-line-read-with-default
		       (format nil "~d" (send cfg-overhead :revision))
		       "Change Revision: Type in new revision and press return")))
    (if (not (stringp new-origin))
	(setq new-origin (string new-origin)))
    (send cfg-overhead :set-revision new-origin)
    (send *interval* :update-config-top-of-buffer cfg-overhead))	;; may 06/05/89 
  dis-text)

 (defcom com-change-cfg-generation
	"Change the configuration generation of the specified configuration module."()
  (let* ((cfg-overhead (getf (line-plist (bp-line (point))) :cfg-overhead))
	 (new-origin (typein-line-read-with-default
		       (format nil "~d" (send cfg-overhead :generation))
		       "Change the Generation: Type in new revision and press return")))
    (if (not (stringp new-origin))
	(setq new-origin (string new-origin)))
    (send cfg-overhead :set-generation new-origin)
    (send *interval* :update-config-top-of-buffer cfg-overhead))	;; may 06/05/89 
  dis-text)

;; may 08/08/89 Added "(max of 64. bytes)"
 (defcom com-change-cfg-comments
	"Change the configuration comments of the specified configuration module."()
  (let* ((cfg-overhead (getf (line-plist (bp-line (point))) :cfg-overhead))
	 (new-origin (typein-line-readline-with-default
		       (format nil "~d" (send cfg-overhead :comments))
		       "Change the comments: Type in new revision (max of 64. bytes) and press return")))
    (send cfg-overhead :set-comments new-origin)
    (send *interval* :update-config-top-of-buffer cfg-overhead))	;; may 06/05/89 
  dis-text)

;; may 02/14/89 Renamed and rewrote old function com-show-data. 
;; It is now show-partition-data and also sets point to PARTITION-FOR-POINT.
 (defun show-partition-data (partition-for-point)
  "Redisplay the PARTITION data and set the point 
to the line that contains PARTITION-FOR-POINT."
  (LET* ((bp (point)) 
	 (disk-partition-data (getf (line-plist (bp-line bp)) :partition))
	 (disk-label-interval (DISK-LABEL-INTERVAL bp)))
    ;; Delete section node displaying :partition lines for disk-label-interval
    ;; then insert same section which will use newly updated data in disk-label-interval
    ;; structure changed by caller.
    (WITH-READ-ONLY-SUPPRESSED (*interval*)
      (delete-interval (SEND disk-label-interval :partition-data-first-bp)
		       (SEND disk-label-interval :last-bp) t)
      (DISCARD-UNDO-INFORMATION disk-label-interval)
      ;; Now regenerate deleted interval
;      (move-bp bp (send disk-label-interval :last-bp)) ;; last-bp is NOT updated by delete-interval
      (move-bp bp (interval-last-bp *interval*)) ;; *ASSUMES* only one node inferior in buffer
      (check-partition-length disk-label-interval)
      (send disk-label-interval :insert-partition-descriptions BP) ;; may 02/10/89
      ;; Position point to new line just inserted.
      ;; Use partition-for-point if supplied, else use partition formerly at point
      (SETQ partition-for-point (OR partition-for-point disk-partition-data))
      (DO ((line (bp-line (SEND disk-label-interval :partition-data-first-bp)) (line-next line)))
	  ((or (null line)	;; may 06/06/89 
	       (EQ partition-for-point (getf (line-plist line) :partition)))
	   (or (null line)	;; may 06/06/89 
	       (move-bp (point) line 0))))
      (must-redisplay *window* dis-all)
      )))

;; may 02/16/89 Rewrote
 (defcom com-kill-partition
	"Delete the current partition from the display." ()
  (LET* ((disk-partition-data (barf-if-not (bp-line (point)) :partition))
	 (disk-label-interval (send disk-partition-data :disk-label-interval))
	 (partition-list (send disk-label-interval :partition-list))
	 (point-partition (GETF (line-plist (line-previous (bp-line (point)))) :partition)))
    ;; may 06/06/89 Return the line above (within reason) that is a :partition
    ;; ignoring messages about overlapping blocks, etc.
    (when (null point-partition)
      ;; line above may be an "overlapping blocks" or other message
      (loop with line = (line-previous (bp-line (point)))
	    with stop-line = (bp-line (SEND disk-label-interval :partition-data-first-bp))
	    until (eq line stop-line)
	    do (progn
		 (setq point-partition (GETF (line-plist line) :partition))
		 (if point-partition
		     (return)
		     (setq line (line-previous line))))))
			  
    (let ((cfg-partition (send disk-label-interval :cfg-name)))
      (when (and cfg-partition
		 (string-equal cfg-partition (send disk-partition-data :name)))
	;; deleting DEFAULT CONFIG PARITION, remove name for com-update-disk-labels
	(send disk-label-interval :set-cfg-name nil)))
	
    (WITH-READ-ONLY-SUPPRESSED (*interval*)
      (send disk-label-interval :set-partition-list
	    (delete disk-partition-data partition-list :test #'eq))
      (show-partition-data point-partition)
      ))
  dis-text)


 (defmethod (zwei-disk-label-buffer :revert) (&rest ignore)
  "Revert the disk-label-editor buffer"
  ;; See also : find-or-create-disk-label-buffer 
  (let* ((disk-label-buffer *interval*)
	 (disk-label-interval (car (send disk-label-buffer :inferiors)))	;; UN-reverted buffer
	 (disk-name-string (send disk-label-interval :get :user-entered-name)))	;; save disk-name-string
    (setq disk-label-interval (send disk-label-buffer :revert-1 )) 		;; reverted buffer
    (setf (send disk-label-interval :get :user-entered-name) (copy disk-name-string))	;; may 06/09/89 
    (check-partition-length disk-label-interval)
    (WITH-READ-ONLY-SUPPRESSED (disk-label-buffer)
      (send disk-label-interval :insert-partition-descriptions last-bp))))

;;; ********************************************************************************

;; may 08/15/89 added #\space doc
 (defcom com-edit-disk-label-help
	"Supply documentation for Disk Partition Editor"()
  (format t "~:|~%           EDIT DISK PARTITION HELP~%~
             ~%  The Disk Partition Editor is a utility that allows you to modify~
             ~%  the disk label for each of your disks.  When~
             ~%  the utility is initially entered the current values are listed in~
             ~%  the edit buffer. Changes to the actual disk labels~
             ~%  are not made until you give the explicit command to update them.~%~
             ~%     Keystroke       Command~%~
	     ~%        SPACE  - Move cursor down one line.~
             ~%        CTRL-O - Insert new partition after to the current partition.~
             ~%        CTRL-K - Delete  the current partition.~
             ~%        ABORT  - Exit the disk partition editor and lose changes (delete buffer).~
             ~%        END    - Exit the disk partition editor but keep the buffer.~%~
             ~%  The partition properties are  ~%~
             ~%        E - Expandable~
             ~%        c - Contractable~
             ~%        P - delete Protected~
             ~%        L - Logical partition~
             ~%        C - Copy protected~
             ~%        D - Default (disk label default)~
             ~%        d - Diagnostic~%~
             ~%  When changing the orgin and size fields you may type numeric LISP~
             ~%  expressions in the minibuffer to help calculate the desired number.
             ~%  You may notice that the default values are calculated for you to~
             ~%  try to make the partition fit properly for the origin and size.~%~
             ~%  If the current partition is a METR band or a Syslog, Describe will~
             ~%  will offer to display the relevant information.~
             ~%~
             ")
  dis-none)

;; may 08/10/89 Added. Broke out of disk-unit-complete.
 (defun parse-local-host (string &optional (return-number-if-possible t) &aux index)
  "Check STRING is in format: NUMBER or LOCALHOST:NUMBER
Basically pre-processes value to prevent opening up a net
connection to a local disk. Also allows null STRING default.
If parse is successful, returns string or a number, depending on
RETURN-NUMBER-IF-POSSIBLE, stripped of \"LOCALHOST:\"."
  (cond (;; convert nil "" or "lm" to si:*default-disk-unit*. Just return number
	 (or (null string)
	     (NUMBERP string)
	     (equal string "")  		;; create default
	     (equal string "lm"))	;; may 05/25/89 
	 (setq string (if return-number-if-possible 
			  si:*default-disk-unit*
			  (format nil "~a" si:*default-disk-unit*))))
	;; "<n>"
	((setq index (si:parse-number string 0 nil nil t)) ;; if a number
	 (when return-number-if-possible (setq string index)))
	;; Convert "lm:<n>" to <n>
	((setq index (lisp:search "lm:" string :test #'string-equal))
	 (setq string (subseq string (+ 3 index)))
	 (when return-number-if-possible
	   (setq string (parse-local-host string t))))
	;; Convert "<si:local-host>:<n>" to <n>
	((let ((local-name (format nil "~a:" si:local-host-name)))
	   (and (setq index (lisp:search local-name string :test #'string-equal))
		(setq string (subseq string (+ (length local-name) index)))
		(when return-number-if-possible
		  (setq string (parse-local-host string t)))))))
  string)

;; may 08/10/89 Moved guts to new function : parse-local-host.
 (defun disk-unit-complete (string)
  "Check STRING is in format: NUMBER or HOST:NUMBER and suitable
for use by si:decode-unit-argument function. Returns same values
as si:decode-unit-argument. See its documentation. 
Basically pre-processes value to prevent opening up a net
connection to a local disk. Also allows null STRING default."
  (setq string (parse-local-host string nil))	;; may 08/10/89 
  (multiple-value-bind (disk-unit decoded-p)
      (si:decode-unit-argument string "editing label")
    (list disk-unit decoded-p string)))

 (defcom com-edit-disk-partition
	"Edit Disk Partition"
	()
  (if (si:mx-p)
      (barf "Editing disk partitions is not supported on this system")
      (let (disk-name disk-unit
	    ;; Get a disk unit string in form "host:unit" or just UNIT
	    ;; that si:decode-unit-argument can understand, but first be sure
	    ;; that "lm:" in the string maps to si:local-host-name or else
	    ;; we will be talking to the local disk label via the net.
	    disk-list
	    (current-buffer (get-disk-label-buffer)))
	(when current-buffer (make-buffer-current current-buffer))	;; may 08/14/89 
	(setq disk-list
	      (disk-unit-complete
		(typein-line-readline
		  "Enter Disk Unit to edit HOST:UNIT  (Default is ~a) " si:*default-disk-unit*)))
	(SETQ disk-unit (FIRST disk-list)
	      disk-name (THIRD disk-list))
	(make-buffer-current (find-or-create-disk-label-buffer disk-unit disk-name))
	))
  dis-none)

;; may 08/04/89 Fixed :set-default-property which must be sent to the
;; selected-partition not the disk-label-interval. This (and the lod case) is
;; the only case where two different kinds of defaults are set together
;; - the config and the disk-label or menu-boot default. SPR 10310
;; 
 (defcom com-change-default-mcr-partition
	"Change the default MCR partition for the indicated disk."()
  (let* ((disk-label-interval (car (send *interval* :inferiors)))
	 (cfg-overhead (SEND disk-label-interval :cfg-overhead))
	 (default-name nil)
	 selected-partition ;; must be on THIS disk in editor in order to be
	 ;; used as the name of the default-mcr. If you want to change the
	 ;; name to "mcra" on ANOTHER disk - use the cfig edit buffer where
	 ;; the expanded line for the appropriate module allows editing of
	 ;; both the name and unit number.
	 )
    ;; get mcr name from user
    (setq default-name (subseq (string (typein-line-read-with-default
					 default-name
					 "Change default MCR: Type in new name and press return:"))
			       0 4))
    ;; If a partition named DEFAULT-NAME cannot be found on THIS disk
    ;; and the DEFAULT CONFIG PARTITION *IS* on this disk, the mcr name
    ;; must be wrong. Else if the DEFAULT CONFIG PARTITION is on some OTHER disk,
    ;; we will could check THAT disk but we should NEVER be called except from the
    ;; FORMAT-CFG-LINE of the disk-label-editor which is NOT displayed or mouseable
    ;; unless the DEFAULT CONFIG PARTITION is on the SAME disk.
    ;; 
    (unless (SETQ selected-partition  ;; may 08/04/89 
		  (dolist (partition (send disk-label-interval :partition-list))
		    (if (and (equal default-name (send partition :name))
			     (equal (send partition :type) sys:%BT-MICROLOAD))
			(return partition))))	;; may 08/04/89
      (Barf "This is not a microload partition"))
    
    (if (and cfg-overhead ;; then we are editing, or have loaded in SOME cfig partition ...
	     (string-equal (send cfg-overhead :name)
			   (send disk-label-interval :cfg-name))) ;; the DEFAULT CONFIG = CONFIG
	(let* ((default-boot (send disk-label-interval :default-boot-parameters)))
	  (send (send (nth default-boot (send cfg-overhead :cfg-module-data)) :cfg-data-items)
		:set-boot-partition-name default-name)
	  (send disk-label-interval :set-selected-mcr default-name)
	  (if (not (equal (send disk-label-interval :default-boot) default-message))
	      (format t default-warning-message)))
	(progn ;; else we are changing default MCR on a cfig band that is NOT being edited
	  (send disk-label-interval :set-selected-mcr default-name)
	  ;; may 08/04/89 Set the "D" in the disk-partition-data instance
	  (send selected-partition :set-default-property t)	;; may 08/04/89
	  (format t default-warning-message))
	)
    (rewrite-disk-line disk-label-interval))
  (com-recenter-window)
  dis-text)


 (defcom com-change-default-load-partition
	"Change the default LOD partition for the indicated disk."()
  (let* ((disk-label-interval (car (send *interval* :inferiors)))
	 (cfg-overhead (SEND disk-label-interval :cfg-overhead))
	 (default-name nil)
	 selected-partition
	 )
    (setf default-name (subseq (string (typein-line-read-with-default
					 default-name
					 "Change default LOAD: Type in new name and press return:"))
			       0 4))
    (unless (SETQ selected-partition		;; may 08/04/89 
		  (dolist (partition (send disk-label-interval :partition-list))
		    (if (and (equal default-name (send partition :name))
			     (equal (send partition :type) sys:%BT-LOAD-BAND)) ;; may 02/16/89 was 0
			(return partition))))	;; may 08/04/89 
      (barf "This is not a load partition"))
    
    (if (and cfg-overhead ;; then we are editing, or have loaded in SOME cfig partition ...
	     (string-equal (send cfg-overhead :name)
			   (send disk-label-interval :cfg-name))) ;; the DEFAULT CONFIG = CONFIG
	;; Update the current cfg-overhead - it 
	(let* ((default-boot (send disk-label-interval :default-boot-parameters)))
	  (send (send (nth default-boot (send cfg-overhead :cfg-module-data)) :cfg-data-items)
		:set-boot-partition-name default-name)
	  (send disk-label-interval :set-selected-lod default-name)
	  (if (not (equal (send disk-label-interval :default-boot) default-message))
	      (format t default-warning-message)))
	(progn ;; else we are changing default load on a cfig band that is NOT being edited
	  (send disk-label-interval :set-selected-lod default-name)
	  ;; may 08/04/89 Set the "D" in the disk-partition-data instance
	  (send selected-partition :set-default-property t)	;; may 08/04/89
	  (format t default-warning-message))
	)
    (rewrite-disk-line disk-label-interval))
  (com-recenter-window)
  dis-text)

;; may 08/11/89 Added for spr 9887
 (DEFUN barf-if-LABL-partition (partition operation new-value &aux is-labl-p)
  "Call whenever user tries to change name origin or length of
 the LABL partition or tries to occupy blocks that LABL does."
  ;; Allow only valid changes to LABL partition and only changes that
  ;; will not invalidate/overlap the LABL partition.
  (when (xor (setq is-labl-p (string= "LABL" (send partition :original-name))) ;; this is LABL partition
	     (CASE operation
	       (:origin (= 0 (eval new-value)))
	       (:attribute (= sys:%bt-volume-label (eval new-value)))
	       (:size   (= 2 (eval new-value)))
	       (:name 	(STRING= "LABL" new-value))))
    (if is-labl-p
	(barf "You cannot change the ~s property of the LABL partition" operation)
	(barf "This partition will overlap/invalidate the disk label (Blocks 0 and 1)."))))

 (defcom com-change-partition-attribute
	"Change the attribute of the specified partition."()
  (LET* ((disk-partition-data (barf-if-not (bp-line (point)) :partition))
	 (new-type (w:menu-choose
		     (mapcar #'(lambda (item)
				 (list (symbol-name (car item)) (eval (cadr item))))
			     si:partition-types)
		     :label "Attribute Types")))
    (when new-type
      (barf-if-LABL-partition disk-partition-data :attribute new-type)	;; may 08/11/89 
      (send disk-partition-data :set-type new-type)
      (rewrite-partition-line disk-partition-data)))
  dis-line)

;; may 08/14/89 Removed reference to cfg-overhead (that used to be) in the
;; inferiors of the disk-config-buffer. Cleaned up selection of config buffer to
;; update it then return back to disk-label-buffer.
 (defcom com-change-partition-name
	"Change the name of the specified partition."()
  (LET* ((disk-partition-data (barf-if-not (bp-line (point)) :partition))
	 (rewrite-disk nil) (rewrite-cfig nil)	;; may 06/05/89 
	 new-name
	 (disk-label-buffer *interval*)
	 (disk-label-interval (car (send disk-label-buffer :inferiors)))
	 (cfg-overhead (send disk-label-interval :cfg-overhead))
	 (disk-config-buffer (get-disk-config-buffer))	;; may 06/05/89
	 )

    (SETQ new-name (string (typein-line-read-with-default-case-sensitive
			     (send disk-partition-data :name)
			     (format nil	;; may 06/05/89 Allows tilde-return construct to work 
				     "Change Partition Name: Type in new name and press return. ~
                              Use quotes (\"name\") for lowercase"))))

    (barf-if-LABL-partition disk-partition-data :name new-name)	;; may 08/11/89 
    
    ;; Don't uppercase if in string since LX bands must be in lower case.
    (if (equal (char new-name 0) #\")
	(setq new-name (subseq new-name 1 (position #\" new-name :from-end t)))
	(setq new-name (string-upcase new-name)))
    (setq new-name (subseq new-name 0 (min 4 (length new-name))))
    
    ;; update config overhead in disk label buffer
    (when (and cfg-overhead
	       (equal (send disk-partition-data :name)
		      (send disk-label-interval :cfg-name)))
      (send disk-label-interval :set-cfg-name new-name);; may 06/05/89 Change rewrite-disk-line needs
      ;; in order to rewrite this line we need to save the point so that
      ;; (rewrite-partition-line will succeed). It is safer to set a flag
      ;; and call this later since rewrite-disk-line positions the point automatically.
      (setq rewrite-disk t)
      
      ;; Rewrite the cfig buffer line to "see" the name change.
      (setq rewrite-cfig (and disk-config-buffer t))
      )
    
    ;; update data name AFTER comparisons to config overhead names have been made.
    (send disk-partition-data :set-name new-name)
    
    (when rewrite-cfig
      ;; must select cfig buffer in order to change it.
      (send disk-config-buffer :select) 
      (send disk-config-buffer :update-config-top-of-buffer cfg-overhead)	;; may 06/05/89 
      (send disk-label-buffer :select)
      )
    (rewrite-partition-line disk-partition-data) ;; must do before calling rewrite-disk-line.

    (when rewrite-disk 
      (rewrite-disk-line disk-label-interval))	;; may 06/05/89

    (com-recenter-window))
  dis-text)

 (defcom com-change-partition-origin
	"Change the origin of the specified partition."()
  (LET* ((disk-partition-data (barf-if-not (bp-line (point)) :partition))
	 (new-origin (TYPEIN-READ-WITH-DEFAULT-IN-PROMPT ;; may 02/10/89
		       (send disk-partition-data :origin) ;; may 02/0/89 
		       (send *interval* :send-if-handles
			     :suggest disk-partition-data :origin) ;; may 02/10/89 
		       "Change Partition Origin: ")))

    (barf-if-LABL-partition disk-partition-data :origin new-origin)	;; may 08/11/89

    (send disk-partition-data :set-origin (EVAL new-origin)) ;; allow (+ 200 1024) forms, too
    (rewrite-partition-line disk-partition-data)
    (if (equal (send disk-partition-data :origin) (send disk-partition-data :begining-origin))
	(send disk-partition-data :set-invalid-origin nil)
	(send disk-partition-data :set-invalid-origin T))
    (show-partition-data disk-partition-data) ;; needed since (rewrite-partition-line disk-partition-data)
    dis-text))

 (defcom com-change-partition-blocks
	"Change the block allocation of the specified partition."()
  (LET* ((disk-partition-data (barf-if-not (bp-line (point)) :partition))
	 (new-size (TYPEIN-READ-WITH-DEFAULT-IN-PROMPT ;; may 02/10/89
			    (send disk-partition-data :size) ;; may 02/0/89 
			    (send *interval* :send-if-handles
				  :suggest disk-partition-data :size) ;; may 02/10/89 
			    "Change Partition Size: ")))
    ;; Be sure LABL partition is not changed from length 2
    (barf-if-labl-partition disk-partition-data :size new-size)

    (send disk-partition-data :set-size (eval new-size))
    (rewrite-partition-line disk-partition-data)
    (if (>= (send disk-partition-data :size) (send disk-partition-data :begining-safe-length))
	(send disk-partition-data :set-invalid-length nil)
	(send disk-partition-data :set-invalid-length T))
    (show-partition-data disk-partition-data))
  dis-text)

 (defun edit-config-character-item ()
  "Change the character item in the configuration band"
  (let* (new-name
	 (character-item (getf (line-plist (bp-line (point))) :cfg-data))
	 (field (car (getf (line-plist (bp-line (point))) :field)))
	 (format-line (cdr (getf (line-plist (bp-line (point))) :field)))
	 (*read-base* (if (string-equal field ':ram-base)
			  16.
			  *read-base*))
	 (*print-base* (if (string-equal field ':ram-base)
			   16.
			   *print-base*)))
    (if (and (string-equal field ':character-item)
	     (string-equal 
	       (subseq (send character-item :character-item) 0 9)
	       "load unit")
	     (not (numberp
		    (send (send *interval* :get :disk-label-interval) :unit-number))))	;; may 05/31/89 
	(barf "Cannot edit \"Load Unit\" across the network"))
    (setq new-name (typein-line-readline-with-default 
		     (subseq (bp-line (point)) (1+ (position #\: (bp-line (point)))))
		     "Change Character Data: Type in new Data and press return"))
    (setq new-name (string-left-trim " " new-name))	;; may 06/05/89 
    (setq new-name (cond ((string-equal field ':ram-base) (parse-number new-name 0 nil 16))
			 ((string-equal field ':boot-partition-slot) (parse-number new-name))
			 ((string-equal field ':boot-partition-unit) (parse-number new-name)) 
			 (t new-name)))
    (if (equal (type-of character-item) 'disk-cfg-character-data)
	(let ((old-item (send character-item :character-item)))
	  (setq new-name (concatenate 'string (subseq old-item 0 (1+ (position #\: old-item))) new-name))
	  (send character-item :set-character-item (subseq new-name 0 (min 32 (length new-name)))))
	(set-in-instance character-item field new-name))
    
    (WITH-READ-ONLY-SUPPRESSED (*interval*)
      (com-beginning-of-line)
      ;; may 08/04/89 Redid this since it fails on very last line when editing twice
;      (com-kill-line)
;      (format (bp-line (point))
;	      format-line
;	      new-name)
      (delete-interval (point) (END-LINE (POINT) 0 T))		;; may 08/07/89 
      (insert-moving (point) (format nil format-line new-name))	;; may 08/04/89 
      (com-beginning-of-line)					;; may 08/04/89 
      ))
  (com-recenter-window)
  dis-text)

 (defcom com-show-cfg-data
	"Expand the data being shown about the current line." ()
  (let ((disk-cfg-data (barf-if-not (bp-line (point)) :partition))
	character-data
	cfg-data-items
	(*print-base* 10.)
	(*read-base* 10.)
	field-item
	save-bp	;; may 08/15/89 
	(line (bp-line (point))))
    (setf cfg-data-items (send disk-cfg-data :cfg-data-items))
    (COND ((PLUSP (com-kill-config-sub-lines)))
	  (t
	   (setq save-bp (copy-bp (point)))	;; may 08/15/89 
	   (com-end-of-line)
	   (WITH-READ-ONLY-SUPPRESSED (*interval*)
	     (insert-moving (point) #\return)

	     (insert-moving (point)
			    (format nil format-cfg-data-line1
				    (send cfg-data-items :ram-base)))
	     (setf (getf (line-plist (bp-line (point))) :cfg-data) cfg-data-items )
	     (setf (getf (line-plist (bp-line (point))) :partition) disk-cfg-data)
	     (setf field-item (cons 'ram-base format-cfg-data-line1))
	     (setf (getf (line-plist (bp-line (point))) :field) field-item)
	     (setf (getf (line-plist (bp-line (point))) :tab-list) cfg-item-tab-list)
	     (insert-moving (point) #\return)
	     
	     (insert-moving (point)
			    (format nil format-cfg-data-line2
				    (send cfg-data-items :boot-partition-name)))
	     (setf (getf (line-plist (bp-line (point))) :cfg-data) cfg-data-items )
	     (setf (getf (line-plist (bp-line (point))) :partition) disk-cfg-data)
	     (setf field-item (cons 'boot-partition-name format-cfg-data-line2))
	     (setf (getf (line-plist (bp-line (point))) :field) field-item)
	     (setf (getf (line-plist (bp-line (point))) :tab-list) cfg-item-tab-list)
	     (insert-moving (point) #\return)
	     
	     (insert-moving (point)
			    (format nil format-cfg-data-line3
				    (send cfg-data-items :boot-partition-unit)))
	     (setf (getf (line-plist (bp-line (point))) :cfg-data) cfg-data-items )
	     (setf (getf (line-plist (bp-line (point))) :partition) disk-cfg-data)
	     (setf field-item (cons 'boot-partition-unit format-cfg-data-line3))
	     (setf (getf (line-plist (bp-line (point))) :field) field-item)
	     (setf (getf (line-plist (bp-line (point))) :tab-list) cfg-item-tab-list)
	     (insert-moving (point) #\return)
	     
	     (insert-moving (point)
			    (format nil format-cfg-data-line4
				    (send cfg-data-items :boot-partition-slot)))
	     (setf (getf (line-plist (bp-line (point))) :cfg-data) cfg-data-items )
	     (setf (getf (line-plist (bp-line (point))) :partition) disk-cfg-data)
	     (setf field-item (cons 'boot-partition-slot format-cfg-data-line4))
	     (setf (getf (line-plist (bp-line (point))) :field) field-item)
	     (setf (getf (line-plist (bp-line (point))) :tab-list) cfg-item-tab-list)
	     (insert-moving (point) #\return)
	     
	     (insert-moving (point)
			    (format nil format-cfg-data-line5
				    (send cfg-data-items :hardware-id)))
	     (setf (getf (line-plist (bp-line (point))) :cfg-data) cfg-data-items )
	     (setf (getf (line-plist (bp-line (point))) :partition) disk-cfg-data)
	     (setf field-item (cons 'hardware-id format-cfg-data-line5))
	     (setf (getf (line-plist (bp-line (point))) :field) field-item)
	     (setf (getf (line-plist (bp-line (point))) :tab-list) cfg-item-tab-list)
	     (insert-moving (point) #\return)
	     
	     (insert-moving (point)
			    (format nil format-cfg-data-line6
				    (send cfg-data-items :software-id)))
	     (setf (getf (line-plist (bp-line (point))) :cfg-data) cfg-data-items )
	     (setf (getf (line-plist (bp-line (point))) :partition) disk-cfg-data)
	     (setf field-item (cons 'software-id format-cfg-data-line6))
	     (setf (getf (line-plist (bp-line (point))) :field) field-item)
	     (setf character-data (send cfg-data-items :character-data))
	     (setf (getf (line-plist (bp-line (point))) :tab-list) cfg-item-tab-list)
	     (dolist (char-item character-data)
	       (insert-moving (point) #\return)
	       
	       (insert-moving (point)
			      (format nil format-cfg-character-line
				      (send char-item :character-item)))
	       (setf (getf (line-plist (bp-line (point))) :cfg-data) char-item )
	       (setf field-item (cons 'character-item format-cfg-character-line))
	       (setf (getf (line-plist (bp-line (point))) :field) field-item)
	       (setf (getf (line-plist (bp-line (point))) :tab-list) cfg-item-tab-list)
	       (setf (getf (line-plist (bp-line (point))) :partition) disk-cfg-data))
;	     (insert-moving (point) #\return)
	     (com-beginning-of-line)
	     
	     (if (eq line (bp-line (send *interval* :last-bp)))
		 (send *interval* :set-last-bp  (point)))
	     )
	   ;; may 08/15/89 Restore point to module line so that
	   ;; the buffer does not leave point at end of long
	   ;; display of sub-lines
	   (move-bp (point) save-bp)	;; may 08/15/89 
	   )))
  (must-redisplay *window* dis-all)  
  dis-all)

;; may 08/07/89 Same problem as EDIT-CONFIG-CHARACTER-ITEM if item edited
;; was the last line of the entire buffer. This can't happen here but I changed
;; the code to prevent setting a bad example.
;; If something on the PARTITION-LINE is changed this function is called
;; to re-write the line.)
 (defun rewrite-partition-line (disk-partition-data)
  (WITH-READ-ONLY-SUPPRESSED (*interval*)
    (com-beginning-of-line)
;    (com-kill-line)
    (delete-interval (point) (END-LINE (POINT) 0 T))	;; may 08/07/89
    (insert-moving (point)				;; may 08/07/89 
		   (format nil				;; may 08/07/89 
			   format-partition-line
			   (send disk-partition-data :name)
			   (si:le-get-partition-type (send disk-partition-data :type))
			   (send disk-partition-data :origin)
			   (send disk-partition-data :size)
			   (print-cpu-name (send disk-partition-data :cpu-type))
			   (let (flags)
			     (if (send disk-partition-data :expandable-property)
				 (push-end '#\E flags)
				 (push-end '#\space flags))
			     (if (send disk-partition-data :contractable-property)
				 (push-end '#\c flags)
				 (push-end '#\space flags))
			     (if (send disk-partition-data :delete-protected-property)
				 (push-end '#\P flags)
				 (push-end '#\space flags))
			     (if (send disk-partition-data :logical-property)
				 (push-end '#\L flags)
				 (push-end '#\space flags))
			     (if (send disk-partition-data :copy-protected-property)
				 (push-end '#\C flags)
				 (push-end '#\space flags))
			     (if (send disk-partition-data :default-property)
				 (push-end '#\D flags)
				 (push-end '#\space flags))
			     (if (send disk-partition-data :diagnostic-property)
				 (push-end '#\d flags)
				 (push-end '#\space flags))
			     flags)
			   (send disk-partition-data :comment)))
    (com-beginning-of-line))
  (com-recenter-window))


;; may 08/07/89 Same problem as EDIT-CONFIG-CHARACTER-ITEM if item edited
;; was the last line of the entire buffer.
 (defun rewrite-cfg-module-line (disk-cfg-data)
  (WITH-READ-ONLY-SUPPRESSED (*interval*)
    (com-beginning-of-line)
;    (com-kill-line)
    (delete-interval (point) (END-LINE (POINT) 0 T))	;; may 08/07/89
    (insert-moving (point)				;; may 08/07/89 
		   (format nil;(bp-line (point))	;; may 08/07/89 
			   format-cfg-partition-line
			   (send disk-cfg-data :module-number)
			   (send disk-cfg-data :offset)
			   (send disk-cfg-data :length)
			   (send disk-cfg-data :boot-timeout)
			   (send disk-cfg-data :number-of-entries)
			   (print-cpu-name (send disk-cfg-data :board-type))
			   (send disk-cfg-data :bootable-processor)
			   (send disk-cfg-data :valid-slots)
			   ))
    (com-beginning-of-line))
  (com-recenter-window))


;; may 08/09/89 Moved modified "*" to modeline since format-cfg-line not always displayed
 (defparameter format-disk-line
              (format nil "Disk Name:  ~~~dt~~s~~~dtDisk Unit:  ~~2d" 
		      disk-name-column disk-unit-column
		      ))

 (defparameter format-cfg-line
	      (format nil "~~~dt Configuration Band:~~s~~~dtMicrocode:~~s~~~dtUnit:~~2d~~~dtLoadband:~~s~~~dtUnit:~~2d"	;; may 08/09/89 moved * to format-disk-line
		      cfg-name-column default-mcr-column default-mcr-unit-column default-lod-column
		      default-lod-unit-column)); disk-label-modified ))	;; may 08/09/89 


;; may 08/09/89 Now called from (:method disk-label-interval :revert-1)
;; This requires that *interval*
;; be setup when this is called from :revert-1 before *interval* is changed from
;; the old buffer. In this case the last-bp is passed in to the bp argument.
 (defun rewrite-disk-line (disk-label-interval &optional (bp (point)))
  (let ((*interval* (send disk-label-interval :superior)))	;; may 08/07/89 
    (WITH-READ-ONLY-SUPPRESSED (*interval*)
      (move-bp bp (send disk-label-interval :disk-header-line-bp)) ;; start of 3 lines to update
      (delete-interval bp (END-LINE bp 2 T))	;; may 08/07/89 delete 3 lines total
      
      (insert-moving bp				;; may 08/07/89 
		     (format nil format-disk-line (send disk-label-interval :disk-name)
			     (send disk-label-interval :real-unit-number)))
      (SETF (getf (line-plist (bp-line bp)) :disk) disk-label-interval
	    (getf (line-plist (bp-line bp)) :tab-list) disk-tab-list)
      (insert-moving bp #\return)
      
      ;; may 08/04/89 Make a blank line if DEFAULT CONFIG PARTITION is non-existant SPR 7427
      ;; The cfg-name *ALWAYS* points to (si:find-default-cfg)
      (when (and (send disk-label-interval :cfg-NAME)			;; may 08/04/89
		 (equal (send disk-label-interval :get :cfg-UNIT)	;; may 08/14/89 
			(send disk-label-interval :unit-number)))	;; may 08/14/89
	;; Here the DEFAULT CONFIG PARTITION is on the disk being edited and is local.
	(insert-moving bp				;; may 08/07/89 
		       (format nil format-cfg-line (send disk-label-interval :cfg-name)
			       (send disk-label-interval :selected-mcr)
			       (send disk-label-interval :selected-mcr-unit)
			       (send disk-label-interval :selected-lod)
			       (send disk-label-interval :selected-lod-unit)
			       ;; may 08/09/89 does not belong here ...
			       ;; (send disk-label-interval :modified-p)
			       )))
      ;; Notice we are outside the WHEN above... We ALSO keep on the same line
      ;; the properties for the EDIT CONFIG PARTITION being edited, which may or may
      ;; not be the same one as the DEFAULT CONFIG PARTITION named :cfg-name.
      ;; Every time a cfig partition is read by :read-cfg-data the :cfg-partition
      ;; property is updated, the the code calls (rewrite-disk-line disk-label-interval)
      ;; to update it here, too. We used to allow editing the default cfig partition
      ;; by clicking here, (changed default-cfg-menu) but this gets ticklish when
      ;; the DEFAULT CONFIG PARTITION is NOT on the same disk. You
      ;; can edit it from the cfig partition line where it is displayed anyway.
      ;;
      (setf (getf (line-plist (bp-line bp)) :partition) ;; may 02/15/89
	    (SEND disk-label-interval :get :cfg-partition))
      (SETF (getf (line-plist (bp-line bp)) :disk) disk-label-interval
	    (getf (line-plist (bp-line bp)) :cfg-overhead) (send disk-label-interval :cfg-overhead)
	    (getf (line-plist (bp-line bp)) :tab-list) cfg-header-tab-list)
      (insert-moving bp #\return)
      
      (insert-moving bp				;; may 08/07/89
		     (format nil default-boot-message (send disk-label-interval :default-boot)))
      )))

 (defcom com-edit-config-band
	"Edit a Configuration Partition" ()
  (DECLARE (SPECIAL *reverting-cfg-partition-info*)) ;; bound ONLY in (zwei-disk-config-buffer :revert)
  (let* ((disk-config-buffer (get-disk-config-buffer))	;; may 05/31/89 
	 line disk-partition-data revert-flag
	 disk-label-interval cfg-overhead)

    ;; *NOTE* We may be called 3 ways :
    ;; 1. (future) keystroke or meta-x Edit config band 
    ;; 2. from disk-label-buffer menu - (point) is a ptr to cfg partition line
    ;; 3. from (zwei-disk-config-buffer :revert) - *BUT* when called the disk-LABEL-buffer will
    ;; be selected. In this case *reverting-cfg-partition-info* will be bound. 

    ;; Get disk-label-interval and disk-partition-data ...
    (CASE (TYPE-OF (window-interval *window*))
      (zwei-disk-label-buffer
       ;; Called from disk-label-buffer via menu or possibly keystroke
       ;; If mouse was on header line with :disk property - edit the default cfg band
       ;; else edit the band under mouse. If called from :revert then cursor could be
       ;; anywhere so :revert MUST provide *reverting-cfg-partition-info* !
       (SETQ line (bp-line (point)))
       ;; Allow editing of cfg partition in header line
       ;; Code used to put a disk-label-interval on :partition prop in disk-label-buffer
       ;; Code now puts the actual partition instance instead.
       (COND ((AND (BOUNDP '*reverting-cfg-partition-info*) ;; called from :revert		   
		   *reverting-cfg-partition-info*)
	      (setf disk-label-interval (CAR *reverting-cfg-partition-info*)
		    disk-partition-data (CADR *reverting-cfg-partition-info*)
		    revert-flag t))
	     ;; else some arbitrary cfg partition ...
	     ;; may 08/14/89 The (:method disk-label-interval :after :init) 
	     ;; sets this up the DEFAULT CONFIG PARTITION as a default for us since it should
	     ;; only try to (si:find-default-cfg) once. On a remote or disk other than the one
	     ;; the DEFAULT CONFIG PARTITION is on, disk-partition-data will be nil.
	     ((SETF disk-partition-data (getf (line-plist line) :partition)) 
	      (setf disk-label-interval (send disk-partition-data :disk-label-interval))
	      (unless (numberp (send disk-label-interval :unit-number))
		;(equal (send disk-label-interval :get :cfg-unit)   
		;	(send disk-label-interval :unit-number))
		(barf "Can't edit config partitions on remote host.")))
	     ))
      (t ;; called directly by keystroke (future)
       (barf "Use ~s instead." (MAKE-COMMAND-NAME 'com-edit-disk-partition))))

    ;; At this point disk-partition-data is the EDIT CONFIG PARTITION , possibly same as
    ;; the DEFAULT CONFIG PARTITION. If the partition origin or length has been edited
    ;; then we cannot read it to edit it - barf.
    (UNLESS revert-flag
      (when (or (send disk-partition-data :invalid-origin)
		(send disk-partition-data :invalid-length))
	(barf "This Partition has changed and must be written to disk. CANNOT EDIT NOW.")
	))

    ;; Don't do this until after BARF's above so we don't have 
    ;; empty disk-config-buffers created.
    (unless disk-config-buffer
      (setq revert-flag t)
      (setf disk-config-buffer (make-instance
				 'zwei-disk-Config-buffer
				 :name DISK-CONFIG-BUFFER-NAME)) ;; may 02/08/89
      (send disk-config-buffer :activate)) ;; only needed when 1st created to put on other histories

    ;; This is what we are currently editing or what the (disk-label-interval :after :init)
    ;; method set up initially as the cfg-overhead.
    (setf cfg-overhead (send disk-label-interval :cfg-overhead))
    
    ;; may 08/09/89 At this point we need to see if the cfg-overhead 
    ;; is what we want. If just moused from disk-label-buffer to get
    ;; to the disk-config-buffer - just go there - it is fine. If the revert-flag
    ;; is set then we must revert the disk-config-buffer. This is also necessary
    ;; when the EDIT CONFIG PARTITION the user wants to
    ;; edit -> (send disk-partition-data :original-name)
    ;; is not the same as the partition currently being edited in the disk-config-buffer,
    ;; which is -> (send (send disk-label-interval :cfg-overhead) :name).
    ;; 
    (when (OR revert-flag
	      (null cfg-overhead) ;; never edited cfig band yet & default-config band not on THIS disk.
	      (and (not (equal (send disk-partition-data :original-name) ;; what we have chosen to edit
			       (send cfg-overhead :name))) ;; what we are currently editing
		   (yes-or-no-p "The partition ~s is different than current partition ~s. ~
                      ~%Do you want to discard the changes and edit ~:2*~s?"
				(send disk-partition-data :original-name)
				(send cfg-overhead :name)))
	      )
      (setf (send disk-label-interval :cfg-overhead)	;; may 08/09/89 Update both ptr's
	    (setq cfg-overhead
		  (send disk-label-interval :read-cfg-data
			(send disk-partition-data :original-name)
			(or (send disk-label-interval :get :cfg-partition-unit)	;; may 08/10/89
			    ;; if above is nil the cfg-overhead was nil. reading cfg band on THIS disk
			    (send disk-label-interval :unit-number))
			)))
      
      ;; may 08/08/89 Update the :cfg-overhead property of the FORMAT-CFG-LINE, too.
      ;; Since we MUST be in disk-label-buffer, we can do this :
      (rewrite-disk-line disk-label-interval)

      (make-buffer-current disk-config-buffer)	;; may 08/08/89 
      (send disk-config-buffer :revert-1 disk-label-interval cfg-overhead)
      (send disk-config-buffer :insert-cfg-partition-descriptions cfg-overhead
	    (interval-last-bp disk-config-buffer)) ;; may 02/09/89
      ;; may 08/08/89 Enclosed above two lines in WHEN. Keeps from de-expanding
      ;; disk-config-buffer in process of being edited when selected from
      ;; the disk-label-buffer.
      )
    (make-buffer-current disk-config-buffer)
    )
  dis-all)

 (defmethod (zwei-disk-label-buffer :revert-1) (&optional disk-unit decoded-p);; may 08/14/89 
  "Read disk information and format DLE buffer."
  (if (not disk-unit) ;; we are called from (zwei-disk-label-buffer :revert)
      (setf disk-unit (send (car inferiors) :unit-number)
	    decoded-p (send (car inferiors) :decoded)))
  (setf inferiors '())
  (setf read-only-p t)
  (set-buffer-file-id self "Disk label buffer")
  (WITH-READ-ONLY-SUPPRESSED (self)
    (delete-interval self)
    (DISCARD-UNDO-INFORMATION self)
    (let (disk-label-interval-instance)
      ;; may 08/11/89 added condition-case for legal remote host but illegal disk unit. SPR 7118
      (CONDITION-CASE (condition)
	    (SETQ disk-label-interval-instance
		  (make-instance 'disk-label-interval
				 :superior self
				 :unit-number disk-unit
				 :decoded decoded-p))
	(ERROR
	 (si:DISPOSE-OF-UNIT disk-unit)
	 (SEND self :kill)
	 (barf (SEND condition :string-for-printing))))
      (SETF last-bp (create-bp (bp-line first-bp) 0 :moves))	;; may 08/07/89 Clear interval of text
      (send disk-label-interval-instance :revert-1 last-bp)  ;; updates last-bp of BUFFER 
      (push-end disk-label-interval-instance inferiors) ;; first ( and last ) inferior node.
      disk-label-interval-instance)) ;; return value for (zwei-disk-label-buffer :revert)
    )


 (defmethod (disk-label-interval :revert-1) (bp) ;; may 02/13/89 added BP
  ;; Init first-bp &last-bp in disk-label-interval not in *interval*, although
  ;; last-bp is the same so changes update both for last-bp.
  (SETF first-bp (create-bp (bp-line bp) 0 :normal)
	last-bp bp) ;; passed in to be updated!

  (insert-moving last-bp #\return)	;; blank line at top of buffer
  ;; Save bp to the start of the disk-header-line since rewrite-disk-line
  ;; is called from mouse-clicks, too.
  (setf disk-header-line-bp (copy-bp last-bp :normal))

  (rewrite-disk-line self last-bp)	;; may 08/09/89 This replaces several lines of code.
  (insert-moving last-bp #\return) ; get to beginning of blank line

  (insert-moving last-bp #\return) ; blank line after default-boot-message
  )

;; may 08/07/89 SPR 8029 - prevent calling 1- on nil entry-number.
;; Also added unit-number arg to allow reading from another disk.
;; This method gathers information from a configuration band
 (defmethod (disk-label-interval :read-cfg-data) (cfg-band-name
						 unit)	;; may 08/10/89
  "This method should be followed by (rewrite-disk-line <disk-label-interval>)
since the :cfg-partition property is stored on one of those lines. Sets the :cfg-partition and
:cfg-partition-unit properties of the <disk-label-interval>"
  ;; may 08/10/89 Keep track if we are reading from our unit-number or somewhere else
  (setf (send self :get :cfg-partition-unit) unit)

  ;; may 08/10/89 Modified below from :putprop in (disk-label-interval :after :init)
  ;; Using the :original-name since user could have modified it.
  (setf (send self :get :cfg-partition)
	(when (eql unit unit-number)
	  ;; Then partition is on THIS disk and we have it already. This method is going
	  ;; to read the CONTENTS of this partition ( from the disk ) and store
	  ;; that data in the cfg-overhead. The loop below updates the ptr to the
	  ;; disk-partition-data which DESCRIBES the partition in relation to the disk label
	  ;; but knows nothing about its CONTENTS.
	  ;; i.e, a cfg partition description : (send self :get :cfg-partition)
	  ;;      a cfg partition contents    : (send self :cfg-overhead)
	  (loop for partition in partition-list with cfg-band
		until (setq cfg-band (and (equal sys:%BT-CONFIGURATION-BAND
						 (send partition :type))
					  (string-equal cfg-band-name (send partition :original-name))
					  partition))
		finally (return cfg-band))))
  
  "Read the information from the configuration band"
  (let (cfg-info)
    (si:with-rqb  (cfg-data (si:read-cfg-partition cfg-band-name unit))	;; may 08/10/89 
      (let (cfg-data-list
	    item)
	(setq cfg-info
	      (make-instance 'disk-cfg-overhead
			     ;;:name (send (send self :get :cfg-partition) :name)	;; may 08/10/89 
			     :name cfg-band-name ;; may 08/09/89 Its passed in - use it !
			     :generation (si:Get-disk-String-byte-addr cfg-data si:%CFG-GENERATION 2.)
			     :revision (si:Get-disk-String-byte-addr cfg-data si:%CFG-REVISION 2.)
			     :comments (si:Get-disk-string-byte-addr cfg-data si:%CFG-TITLE 64.)
			     :module-0 si:%cfg-slot-list-offset
			     :module-1 (+ si:%cfg-slot-list-offset si:%cfg-slot-list-entry-size)
			     :module-2 (+ si:%cfg-slot-list-offset (* 2 si:%cfg-slot-list-entry-size))
			     :module-3 (+ si:%cfg-slot-list-offset (* 3 si:%cfg-slot-list-entry-size))
			     :module-4 (+ si:%cfg-slot-list-offset (* 4 si:%cfg-slot-list-entry-size))
			     :module-5 (+ si:%cfg-slot-list-offset (* 5 si:%cfg-slot-list-entry-size))
			     :module-6 (+ si:%cfg-slot-list-offset (* 6 si:%cfg-slot-list-entry-size))
			     :module-7 (+ si:%cfg-slot-list-offset (* 7 si:%cfg-slot-list-entry-size))
			     :module-8 (+ si:%cfg-slot-list-offset (* 8 si:%cfg-slot-list-entry-size))
			     :module-9 (+ si:%cfg-slot-list-offset (* 9 si:%cfg-slot-list-entry-size))
			     :module-A (+ si:%cfg-slot-list-offset (* 10 si:%cfg-slot-list-entry-size))
			     :module-B (+ si:%cfg-slot-list-offset (* 11 si:%cfg-slot-list-entry-size))
			     :module-C (+ si:%cfg-slot-list-offset (* 12 si:%cfg-slot-list-entry-size))
			     :module-D (+ si:%cfg-slot-list-offset (* 13 si:%cfg-slot-list-entry-size))
			     :module-E (+ si:%cfg-slot-list-offset (* 14 si:%cfg-slot-list-entry-size))
			     :module-F (+ si:%cfg-slot-list-offset (* 15 si:%cfg-slot-list-entry-size))
			     ))
	(dotimes (slot-index 16 cfg-data-list)
	  (let* ((slot-base (+ si:%CFG-SLOT-LIST-OFFSET (* slot-index si:%CFG-SLOT-LIST-ENTRY-SIZE)))
		 (start-and-length (si:get-disk-fixnum cfg-data (/ slot-base 4.)))
		 (block-length (* (ldb (byte 16. 16.) start-and-length) 1024))
		 (block-start  (* (ldb (byte 16. 0) start-and-length) 1024))
		 (number-entries (si:get-disk-fixnum cfg-data
						     (/ (+ slot-base si:%CFG-NUMBER-ENTRIES-OFFSET) 4.)))
		 (board-type (ldb (byte 16. 16.)
				  (si:get-disk-fixnum cfg-data (/ (+ slot-base si:%CFG-MODULE-CRC) 4.))))
		 (temp (si:get-disk-fixnum cfg-data (/ (+ slot-base si:%CFG-MODULE-SLOTS) 4.)))
		 (module-slots (ldb (byte 16. 0) temp))
		 (module-flags (ldb (byte 16. 16.) temp))
		 (slot-and-unit (si:get-disk-fixnum cfg-data
						    (/ (+ block-start si:%CFG-BOOT-DEVICE-OFFSET) 4.)))	
		 
		 (boot-slot (ldb (byte 8. 24.) slot-and-unit))
		 (boot-unit (ldb (byte 24. 0) slot-and-unit))
		 (boot-name (si:get-disk-string-byte-addr
			      cfg-data
			      (+ block-start si:%CFG-BOOT-PARTITION-NAME-OFFSET) 4.))
		 (entry-start  (/ block-start 1024))
		 (pn (si:get-entry-by-block cfg-data entry-start 0))
		 cfg-data-item
		 (entry-list nil))
	    (if (or (= boot-slot #xFF)	   ;both values are WILD   ;06.12.87 DAB
		    (= boot-unit #xFFFFFF))	   ;both values are WILD
		(setf boot-slot #\* boot-unit #\*)
		(setf boot-slot (ldb (byte 8. 24.) slot-and-unit)
		      boot-unit (ldb (byte 24. 0) slot-and-unit)))
	    (setq item
		  (make-instance 'disk-cfg-data
				 :module-number slot-base
				 :offset (/ block-start 1024)
				 :beginning-offset (/ block-start 1024)
				 :length (/ block-length 1024)
				 :beginning-safe-length (/ block-length 1024)
				 :boot-timeout (si:get-disk-fixnum
						 cfg-data
						 (/ (+ slot-base si:%CFG-BOOT-TIMEOUT-OFFSET) 4.))
				 :number-of-entries number-entries
				 :board-type  board-type
				 :valid-slots (decode-slots module-slots)
				 :bootable-processor (if (equal module-flags 1) "bootable"  "slave")
				 :invalid-offset nil
				 :invalid-length nil
				 :cfg-data-items
				    (setq cfg-data-item
					  ;; may 08/10/89 Added (or (loop ...)) to search
					  ;; for a pointer to an already existing instance
					  ;; of disk-cfg-data. This happens in LX systems where
					  ;; two module pointers point to the same module.
					  ;; We must *NOT* make two different modules or else
					  ;; they will BOTH be written and the last one will
					  ;; clobber changes made in the first.
					  (or (loop for module in cfg-data-list	
						    with create-offset = entry-start 
						    as   module-offset = (send module :offset)
						    when (= create-offset module-offset)
						    do   (return (send module :cfg-data-items)))

					      (MAKE-INSTANCE
						'disk-cfg-data-item
						:module-number slot-base
						:ram-base (si:get-disk-fixnum
							    cfg-data
							    (/ (+ block-start si:%CFG-RAM-BASE-OFFSET) 4.))
						:boot-partition-slot boot-slot
						:boot-partition-unit boot-unit
						:boot-partition-name boot-name
						:hardware-id pn
						:software-id (si:get-entry-by-block cfg-data entry-start 1))
					      ))
				    :cfg-overhead cfg-info))
	    (if (not (equal (send item :length) 0))
		(push-end item cfg-data-list))
	    (send cfg-data-item :set-character-data
		  (dotimes (entry (- number-entries 2) entry-list)
		    (push-end (MAKE-INSTANCE
				'disk-cfg-character-data
				:character-item (si:get-entry-by-block cfg-data entry-start (+ entry 2)))
			      entry-list)
		    (if (and (string-equal
			       (subseq (si:get-entry-by-block cfg-data entry-start (+ entry 2)) 0 9)
			       "load unit")
			     (numberp unit)
			     (not (string-equal (SUBSEQ
						  (si:get-entry-by-block cfg-data entry-start
									 (+ entry 2)) 12 ) "*")))
			(setf (send (car (last entry-list)) :character-item)
			      (concatenate 'string
					   (subseq (si:get-entry-by-block cfg-data entry-start
									  (+ entry 2)) 0 12)
					   (format nil "~s" (si:translate-physical-to-logical
							      (subseq (si:get-entry-by-block
									cfg-data entry-start
									(+ entry 2)) 12 ))))))     
		    ))	    
	    ) ;;; let*
	  )
	(setf (send cfg-info :cfg-module-data) cfg-data-list)
	(multiple-value-bind (ignore entry-number ignore)	;; may 08/09/89 second not third!
	    (si:find-module-from-rqb cfg-data :type (si:cpu-type) :entry-number nil)
	  ;; may 08/10/89 Since we are passed in a unit-number that is valid
	  ;; I believe that entry-number cannot be nil but to be safe ...
	  (send self :set-default-boot-parameters (and entry-number	;; may 08/09/89 SPR 8029
						       (1- entry-number)))
	  )))
    cfg-info))


 (defmethod (disk-label-interval :after :init)(ignore)
  (si:with-rqb (disk-label (si:read-disk-label unit-number))
   (let* ( temp
	  (words-per-partition (si:Get-disk-Fixnum disk-label
						   (+ si:%pt-base si:%PT-Size-of-Partition-Entries)))
	  (number-of-partitions (si:Get-disk-fixnum disk-label
						    (+ si:%pt-base si:%PT-Number-of-Partitions))))
     (if (numberp unit-number)
	 (setf real-unit-number unit-number)
	 (setf real-unit-number (symeval-in-closure unit-number 'si:remote-disk-unit)))
    (setf disk-name (si:get-disk-string disk-label si:%dl-volume-name 16))
    (setf disk-type (si:get-disk-string disk-label si:%DL-DEVICE-NAME 12))
    (setf comments (si:get-disk-string disk-label si:%DL-comment 96))
    (setf version (format nil "~a Version ~d"
			  (si:get-disk-string disk-label si:%dl-base 4)
			  (si:get-disk-fixnum disk-label si:%DL-version)))
    (let ((temp (si:get-disk-fixnum disk-label si:%bytes-per)))
      (setf bytes-per-block (ldb si:%%bytes-per-block temp))
      (setf bytes-per-sector (ldb si:%%bytes-per-sector temp)))
    (let ((temp (si:get-disk-fixnum disk-label si:%sector-heads)))
      (setf sectors-per-track (ldb si:%%sectors-per-track temp))
      (setf heads (ldb si:%%number-of-heads temp)))
    (let ((temp (si:get-disk-fixnum disk-label si:%cylinders)))
      (setf cylinders (ldb si:%%number-of-cylinders temp))
      (setf sectors-for-defects (ldb si:%%number-of-sectors-for-defects temp)))
    (if (numberp unit-number)  ;; if not a remote disk
	(if (equal unit-number (si:nvram-default-unit)) ; check nvram for default
	    ;;;          unit equal to the unit the user requested
	    (setf default-boot default-message)
	    (setf default-boot not-default-message))
	(setf default-boot remote-disk-message))
    (setf name (format nil "Disk ~a" disk-name))
    (setf size-of-entry
		  (si:GET-DISK-FIXNUM disk-label (+ si:%pt-base si:%PT-SIZE-OF-PARTITION-ENTRIES)))
    (setf defun-line (bp-line (point)))
    ;; may 08/10/89 These are set later in this method ...
;    (setf selected-mcr (subseq (si:find-default-microload disk-label) 0 4))	;; may 06/05/89 
;    (setf selected-lod (si:find-default-load disk-label))
    (do ((next-partition 0 (1+ next-partition))
	 (loc (+ si:%pt-base si:%PT-Partition-Descriptors) (+ loc words-per-partition)))
	((eql next-partition number-of-partitions))
      (send self :sort-partitions
	    (prog1
	    (setf temp (make-instance 'disk-partition-data
			       :name (si:get-disk-string disk-label loc 4)
			       :original-name (si:get-disk-string disk-label loc 4)
			       :type (ldb si:%%band-type-code
					  (si:get-disk-fixnum disk-label (+ loc si:%PD-Attributes)))
			       :size (si:get-disk-fixnum disk-label (+ loc si:%pd-length))
			       :data-length (if (equal (ldb si:%%band-type-code
						(si:get-disk-fixnum disk-label (+ loc si:%PD-Attributes))) 0)
						(si:measured-size-of-partition
						  (concatenate 'string
							       (si:get-disk-string disk-label loc 4) "."
							       (print-cpu-name (ldb si:%%cpu-type-code
									        (si:get-disk-fixnum disk-label
										  (+ loc si:%pd-attributes)))))
						  unit-number)
						  (si:get-disk-fixnum disk-label (+ loc si:%pd-length))	
						  )
			       :origin (si:get-disk-fixnum disk-label (+ loc si:%PD-Start))
			       :begining-origin (si:get-disk-fixnum disk-label (+ loc si:%PD-Start))
			       :cpu-type (ldb si:%%cpu-type-code (si:get-disk-fixnum disk-label
										  (+ loc si:%pd-attributes)))
			       :comment (when (> words-per-partition si:%pd-comment)
					  (si:get-disk-string disk-label
							      (+ loc si:%PD-Comment)
							      (* 4 (- words-per-partition si:%PD-Comment))))
			       :disk-label-interval self
			       :default-property (LDB-TEST si:%%DEFAULT-INDICATOR
							   (si:get-disk-fixnum disk-label
									       (+ loc si:%pd-attributes)))
			       :expandable-property (LDB-TEST si:%%EXPANDABLE
							      (si:get-disk-fixnum disk-label
										  (+ loc si:%pd-attributes)))
			       :contractable-property (LDB-TEST si:%%CONTRACTABLE
								(si:get-disk-fixnum disk-label
										    (+ loc si:%pd-attributes)))
			       :delete-protected-property (LDB-TEST si:%%DELETE-PROTECTED
								     (si:get-disk-fixnum disk-label
										    (+ loc si:%pd-attributes)))
			       :logical-property (LDB-TEST si:%%LOGICAL-PARTITION
							   (si:get-disk-fixnum disk-label
									       (+ loc si:%pd-attributes)))
			       :copy-protected-property (LDB-TEST si:%%COPY-PROTECTED
								  (si:get-disk-fixnum disk-label
										   (+ loc si:%pd-attributes)))
			       :diagnostic-property (LDB-TEST si:%%DIAGNOSTIC-INDICATOR
							      (si:get-disk-fixnum disk-label
										  (+ loc si:%pd-attributes)))
			       ))
	    (send temp :set-begining-safe-length (send temp :data-length))
	    (if (equal 0 (length (send temp :comment)))
		( send temp :set-comment " "))))
      ;; We only have :cfg-partition property and the cfg-name instance variable
      ;; in the disk-label-interval instance
      ;; if (si:find-default-cfg) is non-nil
;      (and (equal sys:%BT-CONFIGURATION-BAND (send temp :type)) ;; may 02/03/89 
;	   (send temp :Default-property)
;	   (setf cfg-name (send temp :name))
;	   (send self :putprop temp :cfg-partition))
      )
    ;; may 08/09/89 Modified to make the cfg-name instance-var point to the
    ;; DEFAULT CONFIG PARTITION, not the one that MIGHT be it on THIS disk.
    (multiple-value-bind (default-cfg-name default-cfg-unit)	;; may 08/10/89
	;; CFIG bands can't be edited on remote host.
	(and (numberp unit-number) ;; then host is local		;; may 08/10/89
	     (si:find-default-cfg))		;; may 08/09/89
      (if default-cfg-name
	  (setf cfg-name (subseq default-cfg-name 0 4))
	  (setf cfg-name nil))
      (setf (send self :get :cfg-unit) default-cfg-unit) ;; save for #'rewrite-disk-line 
      (when (and cfg-name
		 (equal default-cfg-unit unit-number))	;; then host is local & cfg-unit is on THIS disk.
	
	(let (mcr-name mcr-unit load-name load-unit)
	  ;; Above is redundant since cfg-name is the instance var but this is clearer and
	  ;; allows a ctrs-s search on cfg-name to come here.
	  
	  (send self :set-cfg-overhead (send self :read-cfg-data cfg-name (send self :unit-number)))
	  
	  (multiple-value-setq (mcr-name mcr-unit)
	    (si:get-cfg-boot-data cfg-name (send self :unit-number)))
	  (setq mcr-name (subseq mcr-name 0 4))	;; may 06/05/89 
	  (send self :set-selected-mcr mcr-name)
	  (send self :set-selected-mcr-unit mcr-unit)
	  (multiple-value-setq (load-name load-unit)
	    (si:get-cfg-load-data cfg-name (send self :unit-number)))
	  (send self :set-selected-lod load-name)
	  (send self :set-selected-lod-unit load-unit)
	  ))))
   ))

;; may 08/08/89 New. Taken from  com-disk-label-exit. Allows disk-config-buffer
;; to be killed too when disk-label-buffer is killed from c-x b or from typeout item.
 (DEFMETHOD (zwei-disk-label-buffer :before :KILL) ()
  (when (car inferiors) ;; nil if error occurs in middle of (zwei-disk-label-buffer :revert-1)
    (UNLESS (send (car inferiors) :decoded)
      (si:DISPOSE-OF-UNIT (send (car inferiors) :unit-number))))
  (let ((disk-config-buffer (get-disk-config-buffer)))
    (and disk-config-buffer (kill-buffer disk-config-buffer t))))

 (defun build-cfg-rqb (disk-label-interval)	;; may 05/31/89 
  "Put the information from the configuration band"
  (let ((cfg-data
	  (si:read-cfg-partition
	    (send (send disk-label-interval :get :cfg-partition);; may 05/31/89 
		  :name)
	    (send disk-label-interval :unit-number)))	;; may 05/31/89 
	(cfg-overhead (send disk-label-interval :cfg-overhead))	;; may 08/14/89 
	cfg-data-list
	cfg-data-items
	item
	block-start)
    (si:put-disk-String-byte-addr cfg-data (send cfg-overhead :generation) si:%CFG-GENERATION 2.)
    (si:put-disk-String-byte-addr cfg-data (send cfg-overhead :revision) si:%CFG-REVISION 2.)
    ;; (si:get-disk-string-byte-addr cfg-data  si:%CFG-TITLE 64.)
    (si:put-disk-string-byte-addr cfg-data (send cfg-overhead :comments) si:%CFG-TITLE
				  ;; may 08/10/89 Prevent disk-update from making string
				  ;; longer and full of 0-chars
				  (min (length (send cfg-overhead :comments))	;; may 08/10/89 
				       64.))
    (setq cfg-data-list (send cfg-overhead :cfg-module-data))
    (do ((slot-index 0 (1+ slot-index))
	 (data-list cfg-data-list (cdr data-list)))
	((>= slot-index 16))
      (let* ((slot-base (+ si:%CFG-SLOT-LIST-OFFSET (* slot-index si:%CFG-SLOT-LIST-ENTRY-SIZE)))
	     (entry (car data-list)))
	(if entry
	    (progn
	      (Let* ((temp (dpb (send entry :length)
				(byte 16 16)
				(si:get-disk-fixnum cfg-data (/ slot-base 4.)))))
		(si:Put-disk-Fixnum cfg-data temp (/ slot-base 4.)))
	      (Let* ((temp (dpb (send entry :offset)
				(byte 16 0)
				(si:get-disk-fixnum cfg-data (/ slot-base 4.)))))
		(si:Put-disk-Fixnum cfg-data temp (/ slot-base 4.)))
	      (si:put-disk-fixnum cfg-data (send entry :number-of-entries)
				  (/ (+ slot-base si:%CFG-NUMBER-ENTRIES-OFFSET) 4.))
	      ;; may 08/10/89 duplicate LET statement removed
;	      (Let* ((temp (dpb (send entry :board-type)
;				(byte 16 16)
;				(si:get-disk-fixnum cfg-data (/ (+ slot-base si:%CFG-MODULE-CRC) 4.)))))
;		(si:Put-disk-Fixnum cfg-data temp (/ (+ slot-base si:%CFG-MODULE-CRC) 4.)))
	      (Let* ((temp (dpb (send entry :board-type)
				(byte 16 16)
				(si:get-disk-fixnum cfg-data (/ (+ slot-base si:%CFG-MODULE-CRC) 4.)))))
		(si:Put-disk-Fixnum cfg-data temp (/ (+ slot-base si:%CFG-MODULE-CRC) 4.)))
	      (si:put-disk-fixnum cfg-data (send entry :boot-timeout)
				  (/ (+ slot-base si:%CFG-BOOT-TIMEOUT-OFFSET) 4.))
	      (Let* ((temp (send entry :bootable-processor))
		     (temp1 (dpb (if (equal temp "bootable")
				     1
				     2)
				 (byte 16 16)
				 (si:get-disk-fixnum cfg-data (/ (+ slot-base si:%CFG-MODULE-SLOTS) 4.)))))
		(si:Put-disk-Fixnum cfg-data temp1 (/ (+ slot-base si:%CFG-MODULE-SLOTS) 4.)))
	      (Let* ((temp (send entry :valid-slots))
		     (temp1 (dpb (recode-slots temp)
				 (byte 16 0)
				 (si:get-disk-fixnum cfg-data (/ (+ slot-base si:%CFG-MODULE-SLOTS) 4.)))))
		(si:Put-disk-Fixnum cfg-data temp1 (/ (+ slot-base si:%CFG-MODULE-SLOTS) 4.)))
	      (setq block-start (* (send entry :offset) 1024.))
	      (setq cfg-data-items (send entry :cfg-data-items))
	      (Let* ((temp (dpb (if (or (equal (send cfg-data-items :boot-partition-slot) #\*)
					(equal (send cfg-data-items :boot-partition-unit) #\*))
				    #xFF
				    (send cfg-data-items :boot-partition-slot))
				(byte 8. 24.)
				(si:get-disk-fixnum cfg-data
						    (/ (+ block-start si:%CFG-BOOT-DEVICE-OFFSET) 4.)))))
		(si:Put-disk-Fixnum cfg-data temp (/ (+ block-start si:%CFG-BOOT-DEVICE-OFFSET) 4.)))
	      (Let* ((temp (dpb (if (or (equal (send cfg-data-items :boot-partition-slot) #\*)
					(equal (send cfg-data-items :boot-partition-unit) #\*))
				    #xFFFFFF
				    (send cfg-data-items :boot-partition-unit))
				(byte 24. 0)
				(si:get-disk-fixnum cfg-data
						    (/ (+ block-start si:%CFG-BOOT-DEVICE-OFFSET) 4.)))))
		(si:Put-disk-Fixnum cfg-data temp (/ (+ block-start si:%CFG-BOOT-DEVICE-OFFSET) 4.)))
	      (Si:put-disk-string-byte-addr cfg-data (send cfg-data-items :boot-partition-name)
					    (+ block-start si:%CFG-BOOT-PARTITION-NAME-OFFSET) 4.)
	      (si:put-entry-by-block cfg-data (send entry :offset) 0
				     (si:pad-string (send cfg-data-items :hardware-id) #\space 32))
	      (si:put-disk-fixnum cfg-data (send cfg-data-items :ram-base)
				  (/ (+ block-start si:%CFG-RAM-BASE-OFFSET) 4.))
	      (si:put-entry-by-block cfg-data  (send entry :offset) 1
				     (si:pad-string (send cfg-data-items :software-id) #\space 32))
	      (setq item (send entry :number-of-entries))
	      (dotimes (entry-item (- item 2) )
		(if (and (string-equal 
			   (subseq (send (nth entry-item (send cfg-data-items :character-data))
					 :character-item) 0 9)
			   "load unit")
			 (numberp (send disk-label-interval :unit-number))	;; may 05/31/89 
			(not (string-equal (subseq (send (nth entry-item (send cfg-data-items :character-data))
							  :character-item) 12 ) "*")))
		    (setf (send (nth entry-item (send cfg-data-items :character-data))
							  :character-item)
			  (concatenate 'string
				       (subseq (send (nth entry-item (send cfg-data-items :character-data))
							  :character-item) 0 12)
				        (si:translate-logical-to-physical
					  (parse-number 
					    (subseq (send (nth entry-item
							       (send cfg-data-items :character-data))
							  :character-item) 12 ))))))
		(si:put-entry-by-block cfg-data (send entry :offset) (+ entry-item 2)
				       (si:pad-string
					 (send (nth entry-item (send cfg-data-items :character-data))
					       :character-item) #\space 32)))
	      (si:set-crc-codes cfg-data slot-index))
	    (progn
	      (Let* ((temp (dpb 0
				(byte 16 16)
				(si:get-disk-fixnum cfg-data (/ slot-base 4.)))))
		(si:Put-disk-Fixnum cfg-data temp (/ slot-base 4.)))
	      (Let* ((temp (dpb 0
				(byte 16 0)
				(si:get-disk-fixnum cfg-data (/ slot-base 4.)))))
		(si:Put-disk-Fixnum cfg-data temp (/ slot-base 4.)))
	      (si:set-crc-codes cfg-data slot-index))
	    )))
    cfg-data))


;; may 08/08/89 Added buffer name to be less ambiguous
 (defcom com-disk-config-abort
  "Exit disk configuration editor, delete edit buffer, and do not write cfg band." ()
  (let ((disk-config-buffer *interval*))
    (when (yes-or-no-p "Killing ~s buffer. Do you want to abort the edit session?"	;; may 05/31/89 
		    (send disk-config-buffer :name))				;; may 08/08/89 
      (com-select-previous-buffer)
      (kill-buffer disk-config-buffer t)))
  dis-none)

;; may 08/14/89 Modified from  com-disk-config-exit since now also called from
;;  com-disk-label-exit, too.
 (defun maybe-save-config-buffer (disk-config-buffer)
  (when (and 
	  ;;(send disk-config-buffer :modified-p) ;; currently (:method file-buffer :modified-P)
	  (yes-or-no-p "Killing ~s. Do you want to write the Config Band?"
		       (send disk-config-buffer :name)	;; may 08/14/89 
		       ))	;; may 08/11/89 
      (com-update-disk-config)))

 (defcom com-disk-config-exit
	"Write the disk configuration if necessary and exit disk config mode."()
  (let ((disk-config-buffer (get-disk-config-buffer)))	;; may 05/31/89 
    (maybe-save-config-buffer disk-config-buffer)	;; may 08/14/89 
    (com-select-previous-buffer)
    (kill-buffer disk-config-buffer t))
  dis-none)

;; may 05/31/89 
 (defcom com-update-disk-config
	"Make the disk configuration changes indicated in the Disk Config Buffer." ()
  (LET* ((disk-config-buffer (get-disk-config-buffer))
	 (disk-label-interval (send disk-config-buffer :get :disk-label-interval)))
    (si:with-rqb (rqb (build-cfg-rqb disk-label-interval))	;; may 08/14/89 
      (si:write-cfg-partition
	rqb
	(send (send disk-label-interval :get :cfg-partition) :name)
	(send disk-label-interval :unit-number) ;; cfig partiton MUST be on same unit as disk label
	)))
  dis-none)


;; called from com-disk-label-exit via END key or meta-x update disk labels
 (defcom com-update-disk-labels
	"Make the disk label changes indicated in the Disk Label Buffer." ()
  (let ((disk-label-interval (car (send *interval* :inferiors))) ;; may 02/14/89 
	*overlap-error* *end-of-disk-error*)
    (declare (special *overlap-error* *end-of-disk-error*))
    (si:with-rqb (rqb (build-rqb disk-label-interval))
      ;; may 08/14/89 Consolidated code ...
      (and (or (check-label rqb disk-label-interval)
	       (yes-or-no-p
		 "You may not be able to boot from the disk if this label is written ~
               ~%Do you want to write the label?")
	       (barf "Disk label not updated."))
	   (progn
	     (si:write-disk-label rqb (send disk-label-interval :unit-number))
	     (when (and ;;(send disk-label-interval :modified-p) ;; this is never t, nor is it implemented
		     ;; may 08/14/89 
		     ;; We are ONLY going to change the MCR and LOAD defaults.
		     ;; If a disk-config-buffer has been generated and is the same as
		     ;; the default config partition we could possibly skip this step
		     ;; and just ask the user if he wants to save that, but this is too much
		     ;; trouble. The :cfg-unit may be a different unit than
		     ;; :unit-number *BUT* then he could not have edited it anyway.
		     (send disk-label-interval :cfg-name)
		     ;; Above works even if cfg-name has changed since we wrote the
		     ;; label above and now the 'si functions below can find the newly-named bands.
		     )
	       (si:set-cfg-boot-data (send disk-label-interval :cfg-name)
				     (send disk-label-interval :unit-number)
				     :boot-name (send disk-label-interval :selected-mcr))
	       (si:set-cfg-load-data (send disk-label-interval :cfg-name)
				     (send disk-label-interval :unit-number)
				     :load-name (send disk-label-interval :selected-lod))
	       (send disk-label-interval :set-modified-p nil)
	       ;; may 06/09/89 Provide some feedback ...
	       (format *query-io* "~&Disk label for unit ~d updated."
		       (send disk-label-interval :unit-number)))))))
  dis-none)

 (defcom com-disk-label-exit
	"Write the disk labels if necessary and exit disk label mode."()
  (let ((disk-label-buffer (get-disk-label-buffer)) ;*interval*) *interval* wrong during c-m-y
	(disk-config-buffer (get-disk-config-buffer)))	;; may 08/14/89 
    (when disk-config-buffer				   ;; may 08/14/89 
      (maybe-save-config-buffer disk-config-buffer))	   ;; may 08/14/89 added

    (when disk-label-buffer	;; may 08/14/89
      (when (yes-or-no-p "Killing ~s buffer. Do you want to write the disk label?"	;; may 05/31/89 
			 (send disk-label-buffer :name))				;; may 08/08/89 
	(com-update-disk-labels)))
    (com-select-previous-buffer)
    ;; moved to :before :kill method	;; may 08/08/89 
;    (UNLESS (send (car (send disk-label-buffer :inferiors)) :decoded)
;      (si:DISPOSE-OF-UNIT (send (car (send disk-label-buffer :inferiors)) :unit-number)))
;    (let ((disk-config-buffer (get-disk-config-buffer)))
;      (and disk-config-buffer (kill-buffer disk-config-buffer t)))	;; may 05/31/89 
    (kill-buffer disk-label-buffer t))
  dis-none)

 (defcom com-disk-label-abort
	"Exit disk label editor, delete edit buffer, and do not write labels." ()
  (when (yes-or-no-p "Do you want to abort the edit session?")	;; may 08/11/89 
    (let ((disk-label-buffer *interval*))
      (com-select-previous-buffer)
      ;; moved to :before :kill method	;; may 08/08/89 
;	(UNLESS (send (car (send disk-label-buffer :inferiors)) :decoded)
;	  (si:DISPOSE-OF-UNIT (send (car (send disk-label-buffer :inferiors)) :unit-number)))
;	(when disk-label-buffer
;	  (let ((disk-config-buffer (get-disk-config-buffer)))
;	    (and disk-config-buffer (kill-buffer disk-config-buffer t))	;; may 05/31/89 
      (kill-buffer disk-label-buffer t)
      ))
  dis-none)

 (defvar default-cfg-menu
	'(("Change default mcr partition" . com-change-default-mcr-partition)
	  ("Change default load partition" . com-change-default-load-partition)
	  ;; may 08/15/89 Disallow editing cfg band from FORMAT-CFG-LINE
	  ;; since it is possible a few lines down on the partition line anyway.
;;	  ("Edit Configuration Parameters" . com-edit-config-band)	;; may 08/14/89 
          ))

;; Cleanup and changed references to cfg-overhead from the inferiors of the
;; disk-config-buffer to (send disk-label-interval :cfg-overhead)
;;; This is the main method that fills the CONFIG buffer with data.
 (defmethod (zwei-disk-config-buffer :revert-1) (disk-label-interval overhead &optional &rest ignore)	   
  "Format Configuration editing buffer."

    (setf inferiors '())
    (setf read-only-p t)

    ;; For a config buffer 
    (setf (send self :get :disk-label-interval) disk-label-interval) ;; may 02/08/89 

    (WITH-READ-ONLY-SUPPRESSED (self)
      (delete-interval self)
      (DISCARD-UNDO-INFORMATION self) ;; may 02/09/89 added
      (insert-moving last-bp #\return)	;; line 1

      (insert-moving last-bp		;; line 2
		     (format nil format-disk-line (send disk-label-interval :disk-name)
			     (send disk-label-interval :real-unit-number)))
      (insert-moving last-bp #\return)

      (insert-moving last-bp		;; line 3
		 (format nil format-cfg-line1 (send overhead :name)
			 (send overhead :generation)
			 (send overhead :revision)))

      (setf (getf (line-plist (bp-line last-bp)) :cfg-overhead) overhead)
      (setf (getf (line-plist (bp-line last-bp)) :tab-list) cfg-info-tab-list)
      (insert-moving last-bp #\return)

      (insert-moving last-bp
		 (format nil format-cfg-comment-line (send overhead :comments)))
      (setf (getf (line-plist (bp-line last-bp)) :cfg-overhead) overhead)
      (setf (getf (line-plist (bp-line last-bp)) :tab-list) cfg-comment-tab-list)
      (insert-moving last-bp #\return)
      )     
  )

;; may 08/14/89 Changed cfg-overhead reference to come from disk-label-interval
;; instead of inferiors of disk-config-buffer. Added code to select config-buffer
;; to update it, then return to disk-label-buffer to upate it, too.
 (defcom com-change-disk-name
	"Change the name of the disk unit."()
  (LET* ((disk-config-buffer (get-disk-config-buffer))	;; may 06/05/89
	 (disk-label-interval (barf-if-not (bp-line (point)) :disk))
	 (disk-label-buffer *interval*)
	 (cfg-overhead (send disk-label-interval :cfg-overhead))	;; may 08/14/89 
	 (new-name (string (typein-line-readLINE-with-default  ;; may 02/03/89 
			     (SEND disk-label-interval :disk-name)	;; may 02/03/89 
			     "Change Disk Name: Type in new name and press return"))))
    (setq new-name (subseq new-name 0 (min 16 (length new-name))))
    (send disk-label-interval :set-disk-name new-name)
    ;; update config buffer - if it exists
    (when cfg-overhead
      ;; must select cfig buffer in order to change it ( bad design again )
      (send disk-config-buffer :select)
      (send disk-config-buffer :update-config-top-of-buffer cfg-overhead)	;; may 06/05/89 
      (send disk-label-buffer :select)	;; may 08/14/89 
      )
    (rewrite-disk-line disk-label-interval) ;; may 02/03/89
    )
  (must-redisplay *window* dis-text)
  dis-text)

 (DEFUN find-or-create-disk-label-buffer (disk-unit disk-name-string)
  (LET (disk-label-interval 
	(disk-label-buffer (get-disk-label-buffer)))
    ;; may 05/25/89 start patch ...
    ;; Only ONE disk-label buffer can exist at any one time
    ;; and if we do find a buffer already exists we must kill it
    ;; and start over if we are passed in a NEW disk unit.
    (WHEN disk-label-buffer
      (setq disk-label-interval (car (send disk-label-buffer :inferiors)))	;; may 08/08/89 
      (IF (and disk-label-interval  ;; may 08/09/89 
	       ;; If nil, last attempt to edit remote label
	       ;; was to a non-existent disk unit. Debugger is entered
	       ;; before inferiors get set up so we must kill the disk-label-buffer
	       ;; only partially created. We can have a unit-number that
	       ;; is never disposed, but the 'remote-disk-conn closure
	       ;; value is nil anyway and that is what the 'chaos:remote-disk-handler
	       ;; would try to close anyway - and it can't if it is nil.
	       (eql disk-unit (send disk-label-interval :unit-number))
	       (send (car (send disk-label-buffer :inferiors)) :unit-number))			     
	  (RETURN-FROM find-or-create-disk-label-buffer disk-label-buffer)
	  ;; must also select that buffer if meta-x edit disk partition is
	  ;; called from another buffer for com-disk-label-exit to work.
	  (make-buffer-current disk-label-buffer)
	  (com-disk-label-exit) ;; kill this buffer and offer to write it out
	  ))
    ;; may 05/25/89 end patch ...
    (SETQ disk-label-buffer (make-instance
			      'zwei-disk-label-buffer
			      :name "Disk Label Buffer"))	;; may 05/25/89
    ;; may 08/15/89 This is done in (zwei-disk-label-buffer :AFTER :INIT) and
    ;; later by (ZMACS-BUFFER :after :INIT)
    ;;(setf (buffer-saved-major-mode  disk-label-buffer) 'disk-label-mode) ;; may 02/08/89 

    (send disk-label-buffer :activate)

    ;; Rest of method is very similar to (zwei-disk-label-buffer :revert)
    (setq disk-label-interval (send disk-label-buffer :revert-1 disk-unit
				    (if (numberp disk-unit) nil t)))
    (send disk-label-buffer :select)
    (check-partition-length disk-label-interval)
    (setf (send disk-label-interval :get :user-entered-name) (copy disk-name-string))
    (WITH-READ-ONLY-SUPPRESSED (*interval*)
      (send disk-label-interval :insert-partition-descriptions
	    (interval-last-bp disk-label-buffer)))
    disk-label-buffer ;; return buffer
    ))



;; may 08/11/89 New. Modified from old com-transmit-band.
 (defun copy-partition (from-unit from-part to-unit to-part
		  &key disk-label-unit disk-label-interval)
  "Selects the correct function to most efficiently copy a disk partition.
  Inside disk-label-editor DISK-LABEL-UNIT should be the :user-entered-name
  of the disk-label-editor-buffer else it should be nil or unsupplied.
  Inside disk-label-editor DISK-LABEL-INTERVAL should be the disk-label-interval
  of the disk-label-editor-buffer else it should be nil or unsupplied."
  (let (copy-safe disk-partition-data)
    ;; may 08/10/89 Don't open up net connection to local host. Rewrote all below.
    ;; Using parse-local-host to see if local-or-remote so that we do not have to
    ;; handle disposing of closure units that disk-unit-complete returns.
    (setq from-unit (parse-local-host from-unit t)
	  to-unit   (parse-local-host to-unit t))

    (setq copy-safe
	  (cond ((eq (type-of to-unit) (type-of from-unit))
		 ;; if local-to-local or remote-to-remote
		 (si:copy-disk-partition from-unit from-part to-unit to-part))
		((numberp from-unit)
		 ;; then local to remote
		 (si:transmit-band from-part from-unit to-unit to-part)) ;; note swapped FROM args
		(t ;; the remote to local
		 (si:receive-band from-unit from-part to-unit to-part))))

    (when (AND
	    ; copy-safe
	    ;; I took this out since remote-to-remote can error out
	    ;; and leave "Incomplete Copy" but we don't see the display update. 
	    disk-label-unit disk-label-interval
	    (equal (parse-local-host disk-label-unit t) to-unit))

      (UNLESS copy-safe (FORMAT t "~& Error *** Partition copy did not terminate correctly."))

      ;; in editor and to-unit is displayed - update displayed partition info
      (multiple-value-bind (origin size ignore name attributes ignore comment) 
	  (si:find-disk-partition to-part nil to-unit)
	;; may 08/10/89 comment is NOT returned above, maybe it used to be?
	(unless comment
	  (setq comment (si:partition-comment to-part to-unit)) ;; this is rather expensive ...

	(SETQ disk-partition-data
	      (LOOP for partition in (SEND disk-label-interval :partition-list)
		    when (AND (STRING-EQUAL (SEND partition :original-name)
					    (SUBSEQ to-part 0 4))
			      (= (SEND partition :begining-origin) origin))
		    do (RETURN partition)))

	(setf (send disk-partition-data :type) (ldb si:%%band-type-code attributes))
	(setf (send disk-partition-data :begining-safe-length)
	      (if (equal (ldb si:%%band-type-code Attributes) sys:%BT-LOAD-BAND) ;; may 02/16/89 0
		  (si:measured-size-of-partition
		    (concatenate 'string name  "."
				 (print-cpu-name (ldb si:%%cpu-type-code
						      attributes)))
		    to-unit)  ;10-03-88 DAB [8762] Was using wrong unit number.
		  size))
	(setf (send disk-partition-data :cpu-type) (ldb si:%%cpu-type-code attributes))
	(if (equal (length comment) 0)
	    (setf (send disk-partition-data :comment) " ")
	    (setf (send disk-partition-data :comment) comment)
	    )
	(setf (send disk-partition-data :default-property)
	      (LDB-TEST si:%%DEFAULT-INDICATOR attributes))
	(setf (send disk-partition-data :expandable-property)
	      (LDB-TEST  si:%%EXPANDABLE attributes))
	(setf (send disk-partition-data :contractable-property)
	      (LDB-TEST   si:%%CONTRACTABLE attributes))
	(setf (send disk-partition-data :delete-protected-property)
	      (LDB-TEST si:%%DELETE-PROTECTED attributes))
	(setf (send disk-partition-data :logical-property)
	      (LDB-TEST  si:%%LOGICAL-PARTITION attributes))
	(setf (send disk-partition-data :copy-protected-property)
	      (LDB-TEST si:%%COPY-PROTECTED attributes))
	(setf (send disk-partition-data :diagnostic-property)
	      (LDB-TEST si:%%DIAGNOSTIC-INDICATOR attributes))
	;; The point may or may not be at the destination partiton line
	;; but it must be placed there for rewrite-partition-line to work.
	(LET* ((bp (SEND disk-label-interval :partition-data-first-bp))
	       (found-line (AND bp (SEARCH bp (SEND disk-partition-data :original-name)))))
	  (AND found-line (move-bp (point) found-line)))
	  
	(rewrite-partition-line disk-partition-data)
	(com-recenter-window)    
	)))
    (WHEN disk-label-unit
      (format t "~2&Press the space bar to continue."))
    (values copy-safe)
    ))

;; This command invokes the SI:TRANSMIT-BAND function unless the
;; destination is the local machine, when SI:COPY-DISK-PARTITION function
;; is used for efficiency.
;; may 08/11/89 Competely rewrote to use copy-partition and fix bugs.
 (defcom com-transmit-band
	 "Transmit the current partition to a user specified partition."()
  (LET* ((disk-partition-data (barf-if-not (bp-line (point)) :partition))
	 (invalid-origin (send disk-partition-data :invalid-origin))
	 (invalid-length (send disk-partition-data :invalid-length))
	 (disk-label-interval (send disk-partition-data :disk-label-interval))
	 (partition-unit (send disk-label-interval :get :user-entered-name))
	 partition-name target-partition)
    (when (or invalid-origin invalid-length)
      (barf "The label must be written before you can do this. Origin or length has changed."))
    (setf partition-name (concatenate 'string (send disk-partition-data :name)
				      "."
				      (print-cpu-name (send disk-partition-data :cpu-type))))
    (setf target-partition (typein-line-read-with-default
			     (format nil "(~s ~s)"  partition-unit partition-name)
			     "Transmit partition ~a, specify destination."
			     (list partition-unit partition-name)))

    (copy-partition partition-unit partition-name (CAR target-partition) (CADR target-partition)
	       :disk-label-unit partition-unit
	       :disk-label-interval disk-label-interval)
    dis-none))

;; This command invokes the SI:RECIEVE-BAND function unless the
;; source on is the local machine, when SI:COPY-DISK-PARTITION function
;; is used for efficiency.
;; may 08/11/89 Competely rewrote to use copy-partition and fix bugs.
 (defcom com-receive-band
	"Receive a user specified partition into the current partition." ()
  (LET* ((disk-partition-data (barf-if-not (bp-line (point)) :partition))
	 (disk-label-interval (send disk-partition-data :disk-label-interval))
	 (partition-unit (send disk-label-interval :get :user-entered-name))
	 (partition-name (concatenate 'string (send disk-partition-data :name)
				      "."
				      (print-cpu-name (send disk-partition-data :cpu-type))))
	 target-partition 
	 ;; may 06/09/89 Added invalid name check, too
	 (invalid-name (not (equal (send disk-partition-data :name)
				   (send disk-partition-data :original-name))))
	 (invalid-origin (send disk-partition-data :invalid-origin))
	 (invalid-length (send disk-partition-data :invalid-length)))
    (when (or invalid-origin invalid-length invalid-name)
      (barf "The label must be written before you can do this. Origin or length has changed."))

    (setf target-partition (typein-line-read-with-default
			     (format nil "(~s ~s)"  partition-unit partition-name)
			     "Receive partition into ~@a, specify source. "
			     (list partition-unit partition-name)))

    (copy-partition (CAR target-partition) (CADR target-partition) partition-unit partition-name
	       :disk-label-unit partition-unit
	       :disk-label-interval disk-label-interval)
  dis-none))

 (defcom com-compare-disk-partition
	"Compare the current partition with a user specified partition." ()
  (LET* ((disk-partition-data (barf-if-not (bp-line (point)) :partition))
	 (partition-unit (send (send disk-partition-data :disk-label-interval) :get :user-entered-name))
	 (partition-name (concatenate 'string (send disk-partition-data :name)
				      "."
				      (print-cpu-name (send disk-partition-data :cpu-type))))
	 (target-partition (typein-line-read-with-default
			     (format nil "(~s ~s)" partition-unit partition-name)
			     (format nil "Compare partition ~s with: (\"unit-number\" ~
                                     \"partition-name\")"(list partition-unit partition-name))
			     )))
    (format t (si:compare-disk-partition partition-unit
					 partition-name
					 (car target-partition)
					 (cadr target-partition))))
  (format t "~2&Press the space bar to continue.")	;; may 08/15/89 
  dis-text)

))

) ;; end of si:mx-p conditional

