;;; -*- Mode: Common-Lisp; Package: User; Base: 8.; Patch-File: T -*-

;;; Reason: Changed meta-x Edit compiler warnings to allow user to delete warnings
;;; and make warning files default to .lisp as does make-system code.

;;;                           RESTRICTED RIGHTS LEGEND
;;;
;;; Use, duplication, or disclosure by the Government is subject to
;;; restrictions as set forth in subdivision (c)(1)(ii) of the Rights in
;;; Technical Data and Computer Software clause at 52.227-7013.
;;;
;;;   TEXAS INSTRUMENTS INCORPORATED      
;;;   P.O. BOX 2909, M/S 2151             
;;;   AUSTIN, TEXAS 78769                 
;;;
;;; Copyright (C) 1989 Texas Instruments Incorporated.
;;; All rights reserved.

;;; Patch file for ZWEI version 6.7
;;; Written 10/11/89 12:43:37 by MARKY,
;;; while running on LIBRA from band LOD1
;;; With SYSTEM 6.20, VIRTUAL-MEMORY 6.2, EH 6.5, MAKE-SYSTEM 6.2, MICRONET 6.0, LOCAL-FILE 6.1,
;;;  BASIC-PATHNAME 6.2, NETWORK-SUPPORT-COLD 6.2, BASIC-NAMESPACE 6.4, NETWORK-NAMESPACE 6.0,
;;;  DISK-IO 6.1, DISK-LABEL 6.0, BASIC-FILE 6.4, MAC-PATHNAME 6.0, NETWORK-PATHNAME 6.0,
;;;  COMPILER 6.12, TV 6.15, DATALINK 6.0, CHAOSNET 6.1, GC 6.3, MEMORY-AUX 6.0, NVRAM 6.2,
;;;  SYSLOG 6.2, STREAMER-TAPE 6.4, UCL 6.0, INPUT-EDITOR 6.0, METER 6.1, ZWEI 6.6,
;;;  DEBUG-TOOLS 6.3, NETWORK-SUPPORT 6.0, NETWORK-SERVICE 6.1, DATALINK-DISPLAYS 6.0,
;;;  FONT-EDITOR 6.1, SERIAL 6.0, PRINTER 6.3, MAC-PRINTER-TYPES 6.1, PRINTER-TYPES 6.2,
;;;  IMAGEN 6.1, SUGGESTIONS 6.0, MAIL-DAEMON 6.3, MAIL-READER 6.5, TELNET 6.0, VT100 6.0,
;;;  NAMESPACE-EDITOR 6.3, PROFILE 6.2, VISIDOC 6.5, TI-CLOS 6.25, CLEH 6.5, IP 3.52,
;;;  Experimental CLX 6.4, CLUE 6.20, X11M 6.14, Experimental BUG 11.15,  microcode 429,
;;;  Band Name: Rel 6.0 + SLE 9/8


;;; SPR's 5326 and 8777 (also 5277 - changes do not affect bug reported - user error)
;;;
;;; SPR 5326 : Don't bother asking whether or not to edit warnings IFF only ONE file has warnings
;;;            UNLESS an argument is provided - this allows deletion of single warning and
;;; SPR 8777 : Provided :delete option. This is needed since occasions arise when a file is
;;; compiled and there are warnings that the user does NOT want to fix. These warnings will
;;; make edit warnings prompt you. If the user decides that he wants to IGNORE these warnings
;;; then he should be able to do so and remove the needless promptings. 
;;;   Also made COM-DUMP-COMPILER-WARNINGS & COM-LOAD-COMPILER-WARNINGS agree with
;;; (:PROPERTY :WARNINGS-PATHNAME-DEFAULT DEFSYSTEM-MACRO)
;;; (:PROPERTY :BATCH MAKE-SYSTEM-KEYWORD) and
;;; (:PROPERTY :DEFAULTED-BATCH MAKE-SYSTEM-KEYWORD)
;;; - now they ALL use the .lisp extension as a default. ZMACS was using the .cwarns
;;; but the generator of the file was NOT!

#!C
; From file POSS.LISP#> ZMACS; SYS:
#8R ZWEI#:
(COMPILER-LET ((*PACKAGE* (FIND-PACKAGE "ZWEI"))
                          (SI:*LISP-MODE* :COMMON-LISP)
                          (*READTABLE* SYS:COMMON-LISP-READTABLE)
                          (SI:*READER-SYMBOL-SUBSTITUTIONS* SYS::*COMMON-LISP-SYMBOL-SUBSTITUTIONS*))
  (COMPILER#:PATCH-SOURCE-FILE "SYS: ZMACS; POSS.#"


;; may 02/02/89 Rewrote to provide :skip :proceed and :delete options
;; Also no longer query's user if only ONE file has any warnings unless
;; *numeric-arg-p* is true - in order to get OLD functionality.
(DEFUN COM-EDIT-WARNINGS-QUERY (files)
  "Returns FILES ( possibly modified ) after interrogating user about each file."
  (LET ((*QUERY-IO* *TERMINAL-IO*))
    (VALUES
      (IF (AND (= 1 (LENGTH files)) (NULL *numeric-arg-p*))
	  files ;; don't bother asking if only ONE file has any warnings
	  ;; else
	  (DOLIST (pathname files)
	    (case (fquery '(:choices (((t "Edit this warning.") #\Y #\SPACE #\T #\)
				      ((nil "Don't edit this warning. Go to next warning.") #\N)
				      ((:EDIT "Edit remaining warnings.") #\E)
				      ((:DELETE  "Delete warnings for this file.") #\D)
				      ((:SKIP "Skip remaining warnings.") #\S #\RUBOUT #\)))
			  "Edit warnings for ~A? " (WARNINGS-PATHNAME-AS-STRING PATHNAME)) 
	      (nil (setf files (delete pathname files)))
	      (:edit (return files))
	      (:delete (si:SET-FILE-WARNINGS-OPERATION-ALIST pathname nil)  ;; remove ALL warnings from pathname plist
		       (setf files (delete pathname files)))
	      (:skip (return (butlast files (- (length files) (position pathname files)))))))
	  files))))


(DEFCOM COM-EDIT-WARNINGS "Edit warnings from compilations and similar operations.
First you are asked which files' warnings you wish to edit.
If only ONE file has warnings this query is skipped unless you provide a 
numeric argument.
Then a list of all warnings for those files is placed in the buffer *Warnings*,
and you move through that buffer in a small top window, with the corresponding
code appearing in the bottom window." ()
  (MAPC 'SI:FILTER-WARNINGS (SI:WARNINGS-PATHNAMES))
  ;; Call si:warnings-pathnames again in case some files no longer have any warnings.
  (LET ((FILES (SI:WARNINGS-PATHNAMES)))
    (IF (MEMBER (BUFFER-GENERIC-PATHNAME *INTERVAL*) FILES :TEST #'EQ)
	(SETQ FILES (CONS (BUFFER-GENERIC-PATHNAME *INTERVAL*)
			  (REMOVE (BUFFER-GENERIC-PATHNAME *INTERVAL*)
				  (THE LIST FILES) :TEST #'EQ))))
    (COND ((NULL FILES)
	   (FORMAT *QUERY-IO* "~&No files have warnings.")
	   DIS-NONE)
;	  ((NULL (SETQ FILES (REMOVE-IF-NOT 'COM-EDIT-WARNINGS-QUERY FILES)))
	  ((NULL (SETQ FILES (COM-EDIT-WARNINGS-QUERY FILES))) ;; may 02/02/89 
	   (FORMAT T "~&No other files have warnings.")
	   DIS-NONE)
	  (T
	   (SEND *STANDARD-OUTPUT* :MAKE-COMPLETE)
	   (EDIT-FILES-WARNINGS FILES)))))


;; next two defcom's changed to MATCH with :
;; (:PROPERTY :WARNINGS-PATHNAME-DEFAULT DEFSYSTEM-MACRO)
;; (:PROPERTY :BATCH MAKE-SYSTEM-KEYWORD) and
;; (:PROPERTY :DEFAULTED-BATCH MAKE-SYSTEM-KEYWORD)
(DEFCOM COM-LOAD-COMPILER-WARNINGS "Load a cwarns file into the warnings database.
Use Edit Warnings or Edit Compiler Warnings after this command." ()
  (LET* ((PATHNAME (READ-DEFAULTED-PATHNAME "Load warnings from file:"
					    (SEND (FS:DEFAULT-PATHNAME (PATHNAME-DEFAULTS))
						  :NEW-PATHNAME
						  :TYPE :LISP 	;; may 02/02/89 was :cwarns
						  :VERSION NIL)
					    nil :NEWEST))) 	;; may 02/02/89 was :cwarns
    (FORMAT *QUERY-IO* "~&~A loaded." (LOAD PATHNAME NIL NIL NIL T)))
  DIS-NONE) 

(DEFCOM COM-DUMP-COMPILER-WARNINGS "Writes out the compiler-warnings database as a cwarns file." ()
  (LET ((PATHNAME (READ-DEFAULTED-PATHNAME "Write compiler warnings to File:"
					   (SEND (FS:DEFAULT-PATHNAME (PATHNAME-DEFAULTS))
						 :NEW-PATHNAME
						 :TYPE :LISP)	;; may 02/02/89 was :cwarns
					   nil 			;; may 02/02/89 was :cwarns
					   :NEWEST
					   :WRITE)))
    (SI:DUMP-WARNINGS PATHNAME)
    (PRINT-FILE-WRITTEN PATHNAME))
  DIS-NONE) 

))
