;;; -*- Mode: Common-Lisp; Package: ZWEI; Base: 8.; Patch-File: T -*-

;;; Reason: Modified (RESTORABLE-LINE-DIAGRAM-MIXIN :STRING-FOR-FILE) to add space between epsilon and page count and added package identifier to flavor name. [9306]

;;;                           RESTRICTED RIGHTS LEGEND
;;;
;;; Use, duplication, or disclosure by the Government is subject to
;;; restrictions as set forth in subdivision (c)(1)(ii) of the Rights in
;;; Technical Data and Computer Software clause at 52.227-7013.
;;;
;;;   TEXAS INSTRUMENTS INCORPORATED      
;;;   P.O. BOX 2909, M/S 2151             
;;;   AUSTIN, TEXAS 78769                 
;;;
;;; Copyright (C) 1989 Texas Instruments Incorporated.
;;; All rights reserved.

;;; Patch file for ZWEI version 6.9
;;; Written 12/04/89 08:59:19 by BERGER,
;;; while running on ARIES from band LODX
;;; With SYSTEM 6.26, VIRTUAL-MEMORY 6.3, EH 6.5, MAKE-SYSTEM 6.2, MICRONET 6.0, LOCAL-FILE 6.1,
;;;  BASIC-PATHNAME 6.2, NETWORK-SUPPORT-COLD 6.2, BASIC-NAMESPACE 6.7, NETWORK-NAMESPACE 6.0,
;;;  DISK-IO 6.2, DISK-LABEL 6.0, BASIC-FILE 6.6, MAC-PATHNAME 6.0, NETWORK-PATHNAME 6.0,
;;;  COMPILER 6.14, TV 6.19, DATALINK 6.0, CHAOSNET 6.5, GC 6.3, MEMORY-AUX 6.0, NVRAM 6.2,
;;;  SYSLOG 6.2, STREAMER-TAPE 6.5, UCL 6.0, INPUT-EDITOR 6.0, METER 6.1, ZWEI 6.8,
;;;  DEBUG-TOOLS 6.3, NETWORK-SUPPORT 6.1, NETWORK-SERVICE 6.2, DATALINK-DISPLAYS 6.0,
;;;  FONT-EDITOR 6.1, SERIAL 6.0, PRINTER 6.3, MAC-PRINTER-TYPES 6.1, PRINTER-TYPES 6.2,
;;;  IMAGEN 6.1, SUGGESTIONS 6.1, MAIL-DAEMON 6.4, MAIL-READER 6.6, TELNET 6.0, VT100 6.0,
;;;  NAMESPACE-EDITOR 6.4, PROFILE 6.2, VISIDOC 6.6, TI-CLOS 6.26, CLEH 6.5, IP 3.56,
;;;  Experimental CLX 6.7, CLUE 6.35, X11M 6.18, Experimental BUG 11.17, VISIDOC-SERVER 6.1,
;;;   microcode 429, Band Name: REL 6.0 + SLE 11/28

#!C
; From file FONT.LISP#> ZMACS; SYS:
#8R ZWEI#:
(COMPILER-LET ((*PACKAGE* (FIND-PACKAGE "ZWEI"))
                          (SI:*LISP-MODE* :COMMON-LISP)
                          (*READTABLE* SYS:COMMON-LISP-READTABLE)
                          (SI:*READER-SYMBOL-SUBSTITUTIONS* SYS::*COMMON-LISP-SYMBOL-SUBSTITUTIONS*))
  (COMPILER#:PATCH-SOURCE-FILE "SYS: ZMACS; FONT.#"


(DEFMETHOD (RESTORABLE-LINE-DIAGRAM-MIXIN :STRING-FOR-FILE) (LINE)
  (IF (SEND SELF :FIRST-LINE-P LINE)
      (FORMAT NIL "# ~D ~a:~A~%~A"  ; DAB 12-04-89 Added space between <eps># ~d, added package identifier.

	      (SEND SELF :NUMBER-OF-LINES)
	      (symbol-package (TYPE-OF SELF)) ; DAB 12-04-89
	      (TYPE-OF SELF)
	      (SEND SELF :CONTENTS LINE))
      (SEND SELF :CONTENTS LINE)))
))


#!C
; From file METH.LISP#> ZMACS; SYS:
#8R ZWEI#:
(COMPILER-LET ((*PACKAGE* (FIND-PACKAGE "ZWEI"))
                          (SI:*LISP-MODE* :COMMON-LISP)
                          (*READTABLE* SYS:COMMON-LISP-READTABLE)
                          (SI:*READER-SYMBOL-SUBSTITUTIONS* SYS::*COMMON-LISP-SYMBOL-SUBSTITUTIONS*))
  (COMPILER#:PATCH-SOURCE-FILE "SYS: ZMACS; METH.#"

(DEFMETHOD (INTERVAL-STREAM-WITH-FONTS :TYI) (&OPTIONAL EOF &AUX CH)
  (COND ((STRINGP *FONT-FLAG*)
	 (SETQ CH (AREF *FONT-FLAG* *INDEX*))
	 (AND (>= (SETQ *INDEX* (1+ *INDEX*)) *STOP-INDEX*)
	      (SETQ *FONT-FLAG* NIL
		    *INDEX* 0
		    *STOP-INDEX* (IF (EQ *LINE* *LAST-LINE*)
				     *LAST-INDEX*
				     (LINE-LENGTH *LINE*))))
	 (CHAR-INT CH))
	((NULL *INDEX*)
	 (AND EOF (FERROR NIL (IF (STRINGP EOF)
				  EOF
				  "Unexpected end-of-file encountered; please check parentheses."))))
	((EQ *FONT-FLAG* T)
	 (SETQ *FONT-FLAG* NIL)
	 (+ (CHAR-INT #\0) **FONT**))
	((OR (NUMBERP *FONT-FLAG*)
	     (CHARACTERP *FONT-FLAG*))
	 (PROG1 (CHAR-INT *FONT-FLAG*)
		(SETQ *FONT-FLAG* NIL)))
	((< *INDEX* *STOP-INDEX*)
	 (SETQ CH (AREF *LINE* *INDEX*))
	 (COND ((/= **FONT** (CHAR-FONT CH))
		(COND ((MEMBER (CHAR-FONT CH) (G-L-P *FONT-STACK*) :TEST #'EQ)
		       (SETQ **FONT** (VECTOR-POP *FONT-STACK*))
		       (SETQ *FONT-FLAG* (CHAR-INT #\*)))
		      (T
		       (INTERVAL-WITH-FONTS-IO-PUSH-FONT)
		       (SETQ **FONT** (CHAR-FONT CH))
		       (SETQ *FONT-FLAG* T)))
		(CHAR-CODE #\))
	       (T
		(SETQ *INDEX* (1+ *INDEX*))
		(AND (= (SETQ CH (CHAR-CODE CH)) (CHAR-CODE #\))
		     (SETQ *FONT-FLAG* CH))
		CH)))
	((EQ *LINE* *LAST-LINE*)
	 (SETQ *INDEX* NIL)
	 (AND EOF (FERROR NIL (IF (STRINGP EOF)
				  EOF
				  "Unexpected end-of-file encountered; please check parentheses."))))
	((SETQ CH (ANTICIPATE-FONT-POP))
	 (CHAR-INT CH))
	(T
	 (IF (SETQ CH (GETF (LINE-PLIST *LINE*) :DIAGRAM))
	     (LET* ((STRING (SEND CH :STRING-FOR-FILE *LINE*))
		    (LENGTH (LENGTH STRING)))
	       (AND (PLUSP LENGTH)
		    (SETQ *FONT-FLAG* STRING
			  *INDEX* 0
			  *STOP-INDEX* LENGTH))
	       (do* ((diagram-name (GETF (LINE-PLIST *line*) :DIAGRAM))
		     (next-line (SETQ *LINE* (LINE-NEXT *LINE*)) )
		     (new-diagram (GETF (LINE-PLIST (line-next *line*)) :DIAGRAM)
				  (GETF (LINE-PLIST (line-next *line*)) :DIAGRAM)))
		    ((or (null new-diagram) (neq  new-diagram diagram-name))
		     )
		 (setf next-line (SETQ *LINE* (LINE-NEXT *LINE*)))
	       ))
	     (SETQ *LINE* (LINE-NEXT *LINE*))
	     (SETQ *INDEX* 0
		   *STOP-INDEX* (IF (EQ *LINE* *LAST-LINE*)
				    *LAST-INDEX*
				    (LINE-LENGTH *LINE*))))
	     
	     
	     (CHAR-CODE #\NEWLINE))))



))
