;;;-*- Mode:COMMON-LISP; Package:SYSTEM-INTERNALS; Base:8 -*-

;;;                           RESTRICTED RIGHTS LEGEND

;;;Use, duplication, or disclosure by the Government is subject to
;;;restrictions as set forth in subdivision (c)(1)(ii) of the Rights in
;;;Technical Data and Computer Software clause at 52.227-7013.
;;;
;;;                     TEXAS INSTRUMENTS INCORPORATED.
;;;                              P.O. BOX 2909
;;;                           AUSTIN, TEXAS 78769
;;;                                 MS 2151
;;;
;;; Copyright (C) 1985- 1989 Texas Instruments Incorporated. All rights reserved.

;;;
;;;   
;;;	02.15.88 MBC	Remove compile-flavor-methods all together.  Its last two c-f-m were
;;;			on logical and lispm.  These are now in their respective source files.
;;;  	  11-11-86  MBC  New distinct defsystems.
;;;       01/20/87  HW   Added "tenex-family"
;;;       01/29/87  HW   Added "ITS"
;;;        2/24/87  JK   Moved BASIC-STREAM module to the FILE defsystem because of dependencies there.
;;;     03.05.87  DAB   Changed :patchable and added :warnings-pathname-default
;;;	04.06.87  MBC	Remove CANONICALIZE-COLD-LOAD-PATHNAMES; it is now in Finish-Build.
;;;     07.15.87  LS    Changed PATHNAME to PATHNAME-COLD so io;defs doesn't redefine existing system
;;;     02-26-88  ab    Broke into four defsystems, BASIC-PATHNAME, Lispm-Pathname, MAC-Pathname,
;;;                     and NETWORK-PATHNAME.
;;;     03-02-88  ab    Merge Lispm-Pathname and Basic-Pathname

(Defsystem Basic-PATHNAME
  (:Name "Basic Pathname")
  (:Pathname-Default "sys:pathname;")
  (:patchable "SYS: PATCH.Basic-PATHNAME;" PATCH)
  (:warnings-pathname-default "SYS: CWARNS; Basic-PATHNAME.lisp")

  (:Module Pathdefs ("Pathmacros"))
  (:Module Basic-Pathnames ("Basic-Flavors" "Parse" "Canonical-Types"
			    "File-Access-Mixin"))
  ;(:module canonicalize ("canonicalize-cold-load-pathnames"))

  (:Module Rest-Pathnames ("Pnmap" "Logical" "Driver" "local"))  
  
  (:Compile-Load Pathdefs)
  (:Compile-Load Basic-Pathnames (:Fasload Pathdefs) (:Fasload Pathdefs))
  (:Compile-Load Rest-Pathnames
		 (:Fasload Pathdefs Basic-Pathnames)
		 (:Fasload Pathdefs Basic-Pathnames))
  ;(:compile canonicalize)
  )


;; Rest of these depend on (require) BASIC-PATHNAME

(DEFSYSTEM MAC-Pathname
  (:Name "Macintosh Pathname Support")
  (:Pathname-Default "sys:pathname;")
  (:patchable "SYS: PATCH.Mac-PATHNAME;" PATCH)
  (:warnings-pathname-default "SYS: CWARNS; Mac-PATHNAME.lisp")

  (:Module Aux ("mac"))
  
  (:compile-load Aux)
  )

(Defsystem Network-PATHNAME
  (:Name "Network Pathname Support")
  (:Pathname-Default "sys:pathname;")
  (:patchable "SYS: PATCH.Net-PATHNAME;" PATCH) ;changed from network-pathname KTN.7-1-88
  (:warnings-pathname-default "SYS: CWARNS; Network-PATHNAME.lisp")

  (:Module Aux ("ITS" "tenex-family" "Vms" "LMFS" "unix"))
  (:module compile-flavor-methods ("compile-flavor-methods-2"))
  
  (:compile-load Aux)
  (:compile-load compile-flavor-methods (:fasload aux))
  )