;; Pathnames -*-Mode:Common-LISP;Package:FS; Base:8; COLD-LOAD:T -*-

;;;                           RESTRICTED RIGHTS LEGEND

;;;Use, duplication, or disclosure by the Government is subject to
;;;restrictions as set forth in subdivision (c)(1)(ii) of the Rights in
;;;Technical Data and Computer Software clause at 52.227-7013.
;;;
;;;                     TEXAS INSTRUMENTS INCORPORATED.
;;;                              P.O. BOX 2909
;;;                           AUSTIN, TEXAS 78769
;;;                                 MS 2151
;;;
;;; Copyright (C) 1985- 1989 Texas Instruments Incorporated. All rights reserved.
;;;  ** (c) Copyright 1980 Massachusetts Institute of Technology **



;;; Mcaros that were in Pathnm originaly  RnB





(DEFSUBST PATHNAME-DEVICE (P)
  (FUNCALL (IF (TYPEP P 'PATHNAME)
	     P
	     (PARSE-PATHNAME P))
	   :DEVICE))  


(DEFSUBST PATHNAME-DIRECTORY (P)
  (FUNCALL (IF (TYPEP P 'PATHNAME)
	     P
	     (PARSE-PATHNAME P))
	   :DIRECTORY))  	


(DEFSUBST PATHNAME-NAME (P)
  (FUNCALL (IF (TYPEP P 'PATHNAME)
	     P
	     (PARSE-PATHNAME P))
	   :NAME))  


(DEFSUBST PATHNAME-TYPE (P)
  (FUNCALL (IF (TYPEP P 'PATHNAME)
	     P
	     (PARSE-PATHNAME P))
	   :TYPE))  


(DEFSUBST PATHNAME-VERSION (P)
  (FUNCALL (IF (TYPEP P 'PATHNAME)
	     P
	     (PARSE-PATHNAME P))
	   :VERSION))  


(DEFSUBST PATHNAME-PLIST (P)
  (PATHNAME-PROPERTY-LIST (IF (TYPEP P 'PATHNAME)
			    P
			    (PARSE-PATHNAME P))))  


(DEFSUBST PATHNAME-PROPERTY-LIST (P)
  (SYMEVAL-IN-INSTANCE P 'SI:PROPERTY-LIST))  



(DEFUN DESCRIBE-PATHNAME (PATHNAME)
  (IF (TYPEP PATHNAME 'PATHNAME)
    (DESCRIBE PATHNAME)
    (DESCRIBE (PARSE-PATHNAME PATHNAME))))  

(DEFSUBST FAST-NEW-PATHNAME (PATHNAME NEW-DEVICE NEW-DIRECTORY NEW-NAME NEW-TYPE NEW-VERSION)
  "Modify those fields of PATHNAME that are supplied as non-NIL arguments."
  (SEND PATHNAME :NEW-PATHNAME (IF NEW-DEVICE
				 :DEVICE)
     NEW-DEVICE (IF NEW-DIRECTORY
		  :DIRECTORY)
     NEW-DIRECTORY (IF NEW-NAME
		     :NAME)
     NEW-NAME (IF NEW-TYPE
		:TYPE)
     NEW-TYPE (IF NEW-VERSION
		:VERSION)
     NEW-VERSION))


(DEFSUBST MAKE-PATHNAME-INSTANCE (FLAVOR-NAME &REST OPTIONS)
  (LET ((LOCAL-OPTIONS OPTIONS))
    (INSTANTIATE-FLAVOR FLAVOR-NAME (LOCF LOCAL-OPTIONS) T T PATHNAME-AREA)))

(DEFMACRO CACHE-IN-VARIABLE (VARIABLE . BODY)
  `(OR ,VARIABLE (SETQ ,VARIABLE (PROGN
				   . ,BODY)
		       ,VARIABLE (COPY-INTO-PATHNAME-AREA ,VARIABLE))))



(DEFMACRO DEFINE-CANONICAL-TYPE (CANONICAL-TYPE DEFAULT-SURFACE-TYPE &BODY SYSTEM-SURFACE-TYPES)
  "Defines a keyword CANONICAL-TYPE as a canonical type.
DEFAULT-SURFACE-TYPE is the string that it corresponds to.
SYSTEM-SURFACE-TYPES overrides that default for specific kinds of file systems.
Each element of it is a list whose CAR is a file-system keyword
(:ITS, :UNIX, etc). and whose remaining elements are surface strings,
all of which correspond to this canonical type.
The first surface string in each list is the preferred one for that system."
  `(DEFINE-CANONICAL-TYPE-1 ',CANONICAL-TYPE ',DEFAULT-SURFACE-TYPE ',SYSTEM-SURFACE-TYPES))
