;;;-*- Mode:common-LISP; Package:USER; Base:10 -*-

;;;                           RESTRICTED RIGHTS LEGEND

;;;Use, duplication, or disclosure by the Government is subject to
;;;restrictions as set forth in subdivision (c)(1)(ii) of the Rights in
;;;Technical Data and Computer Software clause at 52.227-7013.
;;;
;;;                     TEXAS INSTRUMENTS INCORPORATED.
;;;                              P.O. BOX 2909
;;;                           AUSTIN, TEXAS 78769
;;;                                 MS 2151
;;;
;;; Copyright (c) 1984-1989 Texas Instruments Incorporated  All Rights Reserved 

;;; 08-19-88  DAB  Added mac-printer
;;;  02/02/87  HW  Added make-package.
;;; 03.05.87  DAB  Changed :patchable and added :warnings-pathname-default
;;; 06.24.87  LAS  Changed make-package to defpackage
;;; 07.29.87   HW  Added postscript-printer

(DEFSYSTEM mac-PRINTER-TYPES
  (:PACKAGE PRINTER)
  (:NAME "MAC Printer Types")
  (:SHORT-NAME "MPRNTERT")
  (:PATHNAME-DEFAULT "SYS: PRINTER-types;")
  (:patchable "sys: patch.mac-printer-types;" PATCH) ;03.05.87 DAB
  (:warnings-pathname-default "SYS: CWARNS; mac-printer-types.lisp") ;03.05.87 DAB
  (:MODULE basic-printer "basic-printer-device")
  (:MODULE MACPR "mac-printer")    ;08-19-88 DAB
  (:MODULE exports "exports")
  (:COMPILE-LOAD basic-printer)
  (:COMPILE-LOAD MACPR (:FASLOAD  basic-printer))  ;08-19-88 DAB
  (:COMPILE-LOAD exports)
   )

(DEFSYSTEM PRINTER-TYPES
  (:PACKAGE PRINTER)
  (:NAME "Printer Types")
  (:SHORT-NAME "PRNTERT")
  (:PATHNAME-DEFAULT "SYS: PRINTER-types;")
  (:patchable "sys: patch.printer-types;" PATCH) ;03.05.87 DAB
  (:warnings-pathname-default "SYS: CWARNS; printer-types.lisp") ;03.05.87 DAB
  (:MODULE basic-printer "basic-printer-device")
  (:MODULE ti855 "ti855")
  (:MODULE ti880 "ti880")
  (:MODULE ti2015 "ti2015")
  (:MODULE postscript-printer "postscript-printer")	;hw 7/29
  (:MODULE AUX        "SYS:printer-types;EHANDLER.PS")  ;12-19-88 DAB Not necessary, but a good debugging tools.
  (:MODULE ti820 "ti820")
  (:MODULE talaris "talaris")
  (:MODULE exports "exports")
  (:COMPILE-LOAD basic-printer)
  (:COMPILE-LOAD ti855 (:FASLOAD  basic-printer))
  (:COMPILE-LOAD ti880 (:FASLOAD  basic-printer))
  (:COMPILE-LOAD ti820 (:FASLOAD  basic-printer))
  (:COMPILE-LOAD postscript-printer (:FASLOAD basic-printer))	;hw 7/29
  (:COMPILE-LOAD ti2015 (:FASLOAD  basic-printer ti855))
  (:COMPILE-LOAD talaris (:FASLOAD basic-printer))
  (:COMPILE-LOAD exports)
  (:AUXILIARY AUX)  ;12-19-88 DAB
   )

;; before loading PRINTER, must load SERIAL --mjf




