;;;-*- Mode:common-LISP; Package:USER; Base:10 -*-

;;;                           RESTRICTED RIGHTS LEGEND

;;;Use, duplication, or disclosure by the Government is subject to
;;;restrictions as set forth in subdivision (c)(1)(ii) of the Rights in
;;;Technical Data and Computer Software clause at 52.227-7013.
;;;
;;;                     TEXAS INSTRUMENTS INCORPORATED.
;;;                              P.O. BOX 2909
;;;                           AUSTIN, TEXAS 78769
;;;                                 MS 2151
;;;
;;; Copyright (c) 1984- 1989 Texas Instruments Incorporated  All Rights Reserved 

;;;  02/02/87  HW  Added make-package.
;;; 03.05.87  DAB  Changed :patchable and added :warnings-pathname-default
;;; 06.24.87  LAS  Changed make-package to defpackage
;;; 07.29.87   HW  Added postscript-printer

(DEFPACKAGE "PRINTER"
  (:USE "LISP" "TICL")
  (:SIZE 600))


(DEFSYSTEM PRINTER
  (:PACKAGE PRINTER)
  (:NAME "Printer")
  (:SHORT-NAME "PRNTER")
  (:PATHNAME-DEFAULT "SYS: PRINTER;")
  (:patchable "sys: patch.printer;" PATCH) ;03.05.87 DAB
  (:warnings-pathname-default "SYS: CWARNS; printer.lisp") ;03.05.87 DAB
  (:MODULE utils "utilities")
  (:MODULE requests "requests")
  (:MODULE server "server")
  (:MODULE print-funcs "print-functions")
  (:MODULE screen "screen-image")
  (:MODULE menu "system-menu")
  (:MODULE exports "exports")
  (:COMPILE-LOAD utils) 
  (:COMPILE-LOAD requests (:FASLOAD utils))
  (:COMPILE-LOAD server (:FASLOAD utils requests))
  (:COMPILE-LOAD print-funcs (:FASLOAD utils requests))
  (:COMPILE-LOAD screen (:FASLOAD utils requests))
  (:COMPILE-LOAD menu (:FASLOAD utils requests screen))
  (:COMPILE-LOAD exports)
   )

;; before loading PRINTER, must load SERIAL --mjf




