;;; -*- Mode:Common-Lisp; Package:USER; Fonts:(COURIER HL12B HL12BI); Base:10 -*-

;;;                           RESTRICTED RIGHTS LEGEND

;;;Use, duplication, or disclosure by the Government is subject to
;;;restrictions as set forth in subdivision (c)(1)(ii) of the Rights in
;;;Technical Data and Computer Software clause at 52.227-7013.
;;;
;;;                     TEXAS INSTRUMENTS INCORPORATED.
;;;                              P.O. BOX 2909
;;;                           AUSTIN, TEXAS 78769
;;;                                 MS 2151
;;;
;;; Copyright (c) 1984- 1989 Texas Instruments Incorporated.  All Rights Reserved.


(DEFPACKAGE "PROFILE"  (:USE "LISP" "TICL" "ZLC"))

(DEFSYSTEM PROFILE (:NAME "User Profile Utility")
	   (:NAME "User Profile")
	   (:PATHNAME-DEFAULT "SYS:PROFILE;")
	   (:WARNINGS-PATHNAME-DEFAULT "SYS:CWARNS;PROFILE.LISP")
	   (:PATCHABLE "SYS:PATCH.PROFILE;" PATCH)  ;;need to have this executed for the actual build
	   (:DOCUMENTATION "Enter facility to modify working Explorer environment")
	   (:DEFAULT-MENU-COLUMN :USER-AIDS)
	   (:DEFAULT-SYSTEM-KEY #\U)
	   (:INSTANCE-TYPE   :FLAVOR)
	   (:INSTANCE-FINDER PROFILE::PROFILE-FRAME)
	   (:INSTANCE-CREATOR T)
	   (:MODULE FORMS ("setf-forms"))
	   (:MODULE UTILITY ("utility"))
	   (:MODULE CVV "cvv-additions")
           (:MODULE WINDOW "window")
	   (:MODULE VARIABLES ("variables"))
	   (:MODULE SAM ("sam"))
	   (:COMPILE-LOAD FORMS)
	   (:COMPILE-LOAD-INIT UTILITY (FORMS) (:FASLOAD FORMS) (:FASLOAD FORMS))
           (:COMPILE-LOAD-INIT CVV (UTILITY) (:FASLOAD UTILITY) (:FASLOAD UTILITY))
           (:COMPILE-LOAD-INIT VARIABLES (CVV) (:FASLOAD CVV) (:FASLOAD CVV))
           (:COMPILE-LOAD-INIT WINDOW (UTILITY) (:FASLOAD UTILITY) (:FASLOAD VARIABLES))
	   (:COMPILE-LOAD-INIT SAM (UTILITY) (:FASLOAD UTILITY) (:FASLOAD VARIABLES))) 
