;;  -*- Mode:Common-Lisp; Package:Net; Base:10.; Fonts:(cptfont); Patch-File: t -*-

;;---------------------------------------------------------------------------------
;;                             ETHERNET BROADBAND HACK
;;---------------------------------------------------------------------------------

;;  This patch will allow all ethernet controllers to operate on a broadband
;;  network.  By enabling the TONO-CRS (Transmit on No Carrier Sense) bit of the
;;  the Intel 82586 chip, it is possible to transmit while connected to a 
;;  transceiver that does not feed back a carrier-sense signal (i.e. broadband).
;;  This hack will not work on non-82586 Ethernet cards (like Apple's card for
;;  the Macintosh II).  The menuboot display will still show "Network offline",
;;  but a Lisp band disk-saved with this hack will know better.
;;
;;  29 JAN 88   MMG


(Defparameter Broadband-Mode  T)  ; set net:broadband-mode to nil to turn it off

;; This initialization list is called during boot:

(Add-Initialization "Enable Network Controllers"
		    '(Progn
		       (Net:Reset-Ethernet t t)
		       (When Broadband-Mode
			   (Net:Send-All-Controllers :Set-Enet-Tono-Crs T)
		           (Net:Send-All-Controllers :Reset)))
		    :Head-of-List 'Net:*Network-System-Initialization-List*)
