 ;;-*-mode:common-lisp ;  Package:DASH ; fonts: medfnt, medfnb ; base:10.-*-
;
;===============================================================================
;
;   Written by Nichael Lynn Cramer
;
;===============================================================================
;
;   This data and information is proprietary to, and a valuable trade secret of
;   Texas Instruments, Incorporated, a Delaware corporation.  It is given in
;   confidence by Texas Instruments, and may not be used as the basis of
;   manufacture, or be reproduced or copied, or be distributed to any other
;   party, in whole or in part, without the prior written consent of Texas
;   Instruments.
;
;===============================================================================
;
;   (c) Unpublished Copyright 1984 by Texas Instruments.  All rights reserved.
;
;===============================================================================
;
(defmethod (editable-circular-dial-entity :smart-simple-make-ticks-list)
	   (SIZE)
  (let* ((DIGITS (floor (/ (log MAX-HAND-VALUE) (log 10.))))
	 (TEN-POWER (expt 10. DIGITS))
	 (RANGE (if (= TEN-POWER 0.)
		    MAX-HAND-VALUE
		  (/ (float MAX-HAND-VALUE) TEN-POWER)))
	 (LNGTH (- (round (/ SIZE 10.0))))
	 (WDTH (round (/ SIZE 50.0))))
    (setq TICKS
	  (cond ((<= RANGE 5.0)
		 (if (equal dash:DIAL-ANGLE-AT-MAX-VAL 360.)
		     (loop for COUNT from 0. below MAX-HAND-VALUE
			   by (/ TEN-POWER 10.0)
			   for TICK-NUM first 0. then (1+ TICK-NUM)
			   collect  (if (= (rem TICK-NUM 5.) 0.)
					(list COUNT
					      (round (* 1.5 LNGTH))
					      (round (* 2.0 WDTH)))
				      (list COUNT LNGTH WDTH)) )
		   (loop for COUNT from 0. to MAX-HAND-VALUE
			   by (/ TEN-POWER 10.0)
			   for TICK-NUM first 0. then (1+ TICK-NUM)
			   collect  (if (= (rem TICK-NUM 5.) 0.)
					(list COUNT
					      (round (* 1.5 LNGTH))
					      (round (* 2.0 WDTH)))
				      (list COUNT LNGTH WDTH)) )))
		(t
		 (if (equal dash:DIAL-ANGLE-AT-MAX-VAL 360.)
		     (loop for COUNT from 0. below MAX-HAND-VALUE
			   by (/ TEN-POWER 2.0)
			   for TICK-NUM first 0. then (1+ TICK-NUM)
			   collect  (if (= (rem TICK-NUM 2.) 0.)
					(list COUNT
					      (round (* 1.5 LNGTH))
					      (round (* 2.0 WDTH)))
				      (list COUNT LNGTH WDTH)))
		   (loop for COUNT from 0. to MAX-HAND-VALUE
			   by (/ TEN-POWER 2.0)
			   for TICK-NUM first 0. then (1+ TICK-NUM)
			   collect  (if (= (rem TICK-NUM 2.) 0.)
					(list COUNT
					      (round (* 1.5 LNGTH))
					      (round (* 2.0 WDTH)))
				      (list COUNT LNGTH WDTH)))))
		))
    )
  )

(defmethod (editable-circular-dial-entity :smart-simple-make-labels-list)
	   (SIZE)
  (let* ((DIGITS (floor (/ (log MAX-HAND-VALUE) (log 10.))))
	 (TEN-POWER (expt 10. DIGITS))
	 (RANGE (if (= TEN-POWER 0.)
		    MAX-HAND-VALUE
		  (/ (float MAX-HAND-VALUE) TEN-POWER)))
	 (TEMP-LABELS (cond ((<= RANGE 1.5)
			     (if (equal dash:DIAL-ANGLE-AT-MAX-VAL 360.)
				 (loop for LABEL-VALUE from 0.
				       below MAX-HAND-VALUE 
				       by (/ TEN-POWER 10.0)
				       collecting (if (= (rem LABEL-VALUE 1.) 0.)						      (round LABEL-VALUE)
						    LABEL-VALUE))
			       (loop for LABEL-VALUE from 0.
				       to MAX-HAND-VALUE 
				       by (/ TEN-POWER 10.0)
				       collecting (if (= (rem LABEL-VALUE 1.) 0.)
						      (round LABEL-VALUE)
						    LABEL-VALUE))))
			    ((<= RANGE 4.0)
			     (if (equal dash:DIAL-ANGLE-AT-MAX-VAL 360.)
				 (loop for LABEL-VALUE from 0.
				       below MAX-HAND-VALUE
				       by (/ TEN-POWER 2.0)
				       collecting (if (= (rem LABEL-VALUE 1.) 0.)
						      (round LABEL-VALUE)
						    LABEL-VALUE))
			       (loop for LABEL-VALUE from 0.
				     to MAX-HAND-VALUE
				     by (/ TEN-POWER 2.0)
				     collecting (if (= (rem LABEL-VALUE 1.) 0.)
						    (round LABEL-VALUE)
						  LABEL-VALUE))))
			    (t
			     (if (equal dash:DIAL-ANGLE-AT-MAX-VAL 360.)
				 (loop for LABEL-VALUE from 0.
				       below MAX-HAND-VALUE 
				       by TEN-POWER
				       collecting (if (= (rem LABEL-VALUE 1.) 0.)
						      (round LABEL-VALUE)
						    LABEL-VALUE))
			       (loop for LABEL-VALUE from 0.
				     to MAX-HAND-VALUE 
				     by TEN-POWER
				     collecting (if (= (rem LABEL-VALUE 1.) 0.)
						    (round LABEL-VALUE)
						  LABEL-VALUE)))))))
    (setq LABELS
	  (loop for LABEL-VALUE in TEMP-LABELS
		collecting (multiple-value-bind (RIMX RIMY)
			       (send self :convert-dial-value-to-window-coordinates
					     LABEL-VALUE LABELS-BASE-DISTANCE)
			     (multiple-value-bind (STRX STRY)
				 (send self :convert-dial-value-to-window-coordinates
					       LABEL-VALUE (+ (* 0.15 SIZE)
							      LABELS-BASE-DISTANCE))
			       (list LABEL-VALUE
				     (- STRX RIMX
					(* (string-length (format nil "~D"
								  LABEL-VALUE))
					   (round (/ (/ (send DEFAULT-LABELS-FONT
							       :horz-spacing)
							 2.0)
						     FONT-SCALE))))
				     (- STRY RIMY
					(round (/ (/ (send DEFAULT-LABELS-FONT
							    :vert-spacing)
					      2.0)
						  FONT-SCALE))))))))
   )
 )

1;***********************************************************************
;1;************************************************************NLC12FEB85*
(defmethod (editable-sector-dial-entity :smart-simple-make-ticks-list)
	   (SIZE)
  (let* ((DIGITS (floor (/ (log MAX-HAND-VALUE) (log 10.))))
	 (TEN-POWER (expt 10. DIGITS))
	 (RANGE (if (= TEN-POWER 0.)
		    MAX-HAND-VALUE
		  (/ (float MAX-HAND-VALUE) TEN-POWER)))
	 (LNGTH (- (round (/ SIZE 10.0))))
	 (WDTH (round (/ SIZE 50.0))))
    (setq TICKS
	  (cond ((<= RANGE 3.0)
		 (loop for COUNT from 0. to MAX-HAND-VALUE
		                         by (/ TEN-POWER 10.0)
		       for TICK-NUM first 0. then (1+ TICK-NUM)
		       collect  (if (= (rem TICK-NUM 5.) 0.)
				    (list COUNT
					  (round (* 1.5 LNGTH))
					  (round (* 2.0 WDTH)))
				  (list COUNT LNGTH WDTH)) ))
		(t
		 (loop for COUNT from 0. to MAX-HAND-VALUE
		                         by (/ TEN-POWER 2.0)
		       for TICK-NUM first 0. then (1+ TICK-NUM)
		       collect  (if (= (rem TICK-NUM 2.) 0.)
				    (list COUNT
					  (round (* 1.5 LNGTH))
					  (round (* 2.0 WDTH)))
				  (list COUNT LNGTH WDTH))))
		))
    )
  )

(defmethod (editable-sector-dial-entity :smart-simple-make-labels-list)
	   (SIZE)
  (let* ((DIGITS (floor (/ (log MAX-HAND-VALUE) (log 10.))))
	 (TEN-POWER (expt 10. DIGITS))
	 (RANGE (if (= TEN-POWER 0.)
		    MAX-HAND-VALUE
		  (/ (float MAX-HAND-VALUE) TEN-POWER)))
	 (TEMP-LABELS (cond ((<= RANGE 1.1)
			     (loop for LABEL-VALUE from 0.
				   to MAX-HAND-VALUE 
				   by (/ TEN-POWER 5.0)
				   collecting (if (= (rem LABEL-VALUE 1.) 0.)
						  (round LABEL-VALUE)
						LABEL-VALUE)))
			    ((<= RANGE 4.0)
			     (loop for LABEL-VALUE from 0.
				   to MAX-HAND-VALUE
				   by (/ TEN-POWER 2.0)
				   collecting (if (= (rem LABEL-VALUE 1.) 0.)
						  (round LABEL-VALUE)
						LABEL-VALUE)))
			    ((<= RANGE 6.5)
			     (loop for LABEL-VALUE from 0.
				   to MAX-HAND-VALUE 
			     by TEN-POWER
			     collecting (if (= (rem LABEL-VALUE 1.) 0.)
					    (round LABEL-VALUE)
					  LABEL-VALUE)))(t
			     (loop for LABEL-VALUE from 0.
				   to MAX-HAND-VALUE 
			     by (* TEN-POWER 2.)
			     collecting (if (= (rem LABEL-VALUE 1.) 0.)
					    (round LABEL-VALUE)
					  LABEL-VALUE))))))
    (setq LABELS
	  (loop for LABEL-VALUE in TEMP-LABELS
		collecting (multiple-value-bind (RIMX RIMY)
			       (send self :convert-dial-value-to-window-coordinates
					     LABEL-VALUE LABELS-BASE-DISTANCE)
			     (multiple-value-bind (STRX STRY)
				 (send self :convert-dial-value-to-window-coordinates
					       LABEL-VALUE (+ (* 0.15 SIZE)
							      LABELS-BASE-DISTANCE))
			       (list LABEL-VALUE
				     (- STRX RIMX
					(* (string-length (format nil "~D"
								  LABEL-VALUE))
					   (round (/ (/ (send DEFAULT-LABELS-FONT
							       :horz-spacing)
							 2.0)
						     FONT-SCALE))))
				     (- STRY RIMY
					(round (/ (/ (send DEFAULT-LABELS-FONT
							    :vert-spacing)
						      2.0)
						  FONT-SCALE))))
			       )
			     )
		)
	  )
    )
  )

;1;***********************************************************************
;1;************************************************************NLC13FEB85*
(defmethod (editable-lineal-dial-entity :smart-simple-make-lineal-ticks-list)
	   (SIZE)
  (let* ((DIGITS (floor (/ (log MAX-BAR-VALUE) (log 10.))))
	 (TEN-POWER (expt 10. DIGITS))
	 (RANGE (if (= TEN-POWER 0.)
		    MAX-BAR-VALUE
		  (/ (float MAX-BAR-VALUE) TEN-POWER))))
    (setq TICKS
	  (cond ((<= RANGE 2.0)
		 (loop for COUNT from 0. to MAX-BAR-VALUE
		       by (/ TEN-POWER 10.0)
		       for TICK-NUM first 0. then (1+ TICK-NUM)
		       collect  (list COUNT
				      (if (= (rem TICK-NUM 5.) 0.)
					  (max 1. (round (* SIZE 0.10)))
					(max 1. (round (* SIZE 0.05))))
				      (max 1. (round (* SIZE 0.01))))))
		((<= RANGE 6.0)
		 (loop for COUNT from 0. to MAX-BAR-VALUE
		       by (/ TEN-POWER 2.0)
		       for TICK-NUM first 0. then (1+ TICK-NUM)
		       collect  (list COUNT
					  (if (= (rem TICK-NUM 2.) 0.)
					      (max 1. (round (* SIZE 0.10)))
					    (max 1. (round (* SIZE 0.05))))
					  (max 1. (round (* SIZE 0.01))))))
		(t
		 (loop for COUNT from 0. to MAX-BAR-VALUE
		       by TEN-POWER
		       for TICK-NUM first 0. then (1+ TICK-NUM)
		       collect  (list COUNT
				      (max 1. (round (* SIZE 0.10)))
				      (max 1. (round (* SIZE 0.01))))))
		))
    )
  )

(defmethod (editable-lineal-dial-entity :smart-simple-make-lineal-labels-list)
	   (SIZE)
  (let* ((DIGITS (floor (/ (log MAX-BAR-VALUE) (log 10.))))
	 (TEN-POWER (expt 10. DIGITS))
	 (RANGE (if (= TEN-POWER 0.)
		    MAX-BAR-VALUE
		  (/ (float MAX-BAR-VALUE) TEN-POWER)))
	 (TEMP-LABELS (cond ((<= RANGE 2.0)
			     (loop for LABEL-VALUE from 0.
				   to MAX-BAR-VALUE 
				   by (/ TEN-POWER 2.0)
				   collecting (if (= (rem LABEL-VALUE 1.)
						     0.)
						  (round LABEL-VALUE)
						LABEL-VALUE)))
			    ((<= RANGE 6.0)
			     (loop for LABEL-VALUE from 0.
				   to MAX-BAR-VALUE
				   by TEN-POWER
				   collecting (if (= (rem LABEL-VALUE 1.)
						     0.)
						  (round LABEL-VALUE)
						LABEL-VALUE)))
			    (t
			     (loop for LABEL-VALUE from 0.
				   to MAX-BAR-VALUE 
				   by (* TEN-POWER 2.)
				   collecting (if (= (rem LABEL-VALUE 1.)
						     0.)
						  (round LABEL-VALUE)
						LABEL-VALUE))))))
    (setq LABELS
	  (loop for LABEL-VALUE in TEMP-LABELS
		collecting (case MAX-TOWARDS
			     (:up (list LABEL-VALUE
					(round (- (+ (/ BAR-WIDTH 2.0)
						    (round (* SIZE .10))
						    (* (string-length
							 (format nil
								 "~D"
								 LABEL-VALUE))
						       (/ (send
							     DEFAULT-LABELS-FONT
							     :horz-spacing)
							   FONT-SCALE)))))
					(round (/ (* (send DEFAULT-LABELS-FONT
							   :vert-spacing)
						     -0.5)
						  FONT-SCALE))))
			     (:right (list LABEL-VALUE
					   (round (- (* (string-length
							 (format nil
								 "~D" LABEL-VALUE))
						       (* (/ (send
								DEFAULT-LABELS-FONT
								:horz-spacing)
							      FONT-SCALE)
							  0.5))))
					   (round (- (+ (* BAR-WIDTH 0.50)
						       (* SIZE 0.10)
						       (/ (send
							     DEFAULT-LABELS-FONT
							     :vert-spacing)
							   FONT-SCALE))))))
			     )))
    )
  )
