;;; -*- Mode:Common-Lisp; Package:zwei; Base:10; Fonts:(CPTFONT HL12B HL12I MEDFNB) -*-

(defun 4EN-MAIL* (template)
  (let ((fcn (get-mail-template-function template)))
    (when fcn
      (let ((zmacs-window (find-or-create-idle-zmacs-window)))
	(w:await-window-exposure)
	(send zmacs-window :force-kbd-input `(:execute  ,fcn))
	(send zmacs-window :select)))))


(define-mail-template 4DEFAULT-REPLY-NEWS-TEMPLATE* "Mail" :mail
  "Reply to a news message."

  (let ((stream (interval-stream *interval*)))
    (format stream "From:        ~@[~a~]" news:*default-from-field*)
    (format stream "~%To:          ~@[~a~]" news:*default-to-field*)
    (format stream "~%Subject:     ~@[~a~]" news:*default-subject-field*)
    (format stream "~%Newsgroups:  ~@[~a~]" news:*default-newsgroup-field*)
    (format stream "~%In-reply-to: ~@[~a~]" news:*default-message-id-field*)
    (when news:*default-include-text*
      (news:en-nntp-body news:*default-newsgroup-component*)
      (format stream "~2%In article ~a you write:" news:*default-message-id-field*)
      (loop
	(multiple-value-bind (line eof) (news:read-nntp-stream news:*nntp-stream*)
	  (cond
	    (eof (return :eof))
	    (t (format stream "~%~a~a" zwei:*yank-message-prefix* line))))))
    (format stream "~%"))
  (putprop zwei:*interval* news:*en* :return-to-window-after-send))
