;;; -*- Mode:Common-Lisp; Package:FILE-SYSTEM; Base:10; Fonts:(MEDFNT HL12B HL12BI) -*-
;;;===============================================================================
;;;                                    RESTRICTED RIGHTS LEGEND 
;;; Use,  duplication, or  disclosure  by  the  Government is subject to restrictions
;;; as set forth in subdivision (c)(1)(ii) of the Rights in Technical Data and
;;; Computer Software clause at 52.227-7013. 
;;;
;;; TEXAS INSTRUMENTS INCORPORATED, P.O. BOX 2909 AUSTIN, TEXAS 78769  
;;; Copyright (C) 1986, Texas Instruments Incorporated. All rights reserved.
;;;===============================================================================

;;;
;;; Change history:
;;;
;;;  Date	Author	Description
;;; -------------------------------------------------------------------------------------
;;; 11/10/87	LGO	Created

(DEFUN user:expunge-all (&optional directory)
  "2Expunge directory and all sub-directories*"
  (LABELS ((map-sub-directories (f function args)
	     (LET* ((file-name (LM-NAMESTRING () () (DIRECTORY-FULL-NAME f)
					    :wild :wild :wild))
		    (result (OR (APPLY function file-name args) 0)))
	       (WHEN (PLUSP result)
		 (FORMAT t "~%Expunged ~4d blocks from ~a" result file-name))
	       (DOLIST (file (read-directory-files f))
		 (WHEN (fs:file-attribute file :directory)
		   (INCF result (map-sub-directories file function args))))
	       result)))
    (LET ((dir (LOOKUP-DIRECTORY (AND directory (STRING directory)) t)))
      (IF (NULL dir)			   ;1Don't crap out if directory is bad*
	  (FORMAT t "~%Directory not found: ~s" directory)
	(map-sub-directories dir #'expunge-directory nil)))))