;;; -*- Mode: Common-Lisp; Package: User; Base: 10 -*-

(DEFVAR *fix-explorer-time-wait-time* (* 60 (* 60 60)))

(DEFVAR *fix-explorer-time-process* nil)

(DEFUN init-fix-explorer-time ()
  (UNLESS *fix-explorer-time-process*
    (SETF *fix-explorer-time-process* (MAKE-PROCESS "Fix Explorer Time" ':simple-p nil :regular-pdl-size 3072.))
    (PROCESS-PRESET *fix-explorer-time-process* 'fix-explorer-time-process)
    (PROCESS-RESET-AND-ENABLE *fix-explorer-time-process*)))

(DEFUN fix-explorer-time-process ()
  "Reset the time on the Explorer screen every hour."
  (DO-FOREVER
    (CONDITION-CASE (jrg-error)
	(TIME:initialize-timebase)
      (ERROR nil))
    (PROCESS-SLEEP *fix-explorer-time-wait-time* "Snoozing an hour")))

(ADD-INITIALIZATION "Fix Explorer Time" '(init-fix-explorer-time))

(init-fix-explorer-time)
