;; -*- Mode:Common-Lisp; Package:DEMO; Lowercase:YES; Base:10 -*-

;;; Makes the screen look cracked.  Run (CRAZE)
;;; Ancient MIT CADR hack, converted to Common-Lisp.

(defsubst frandom () (/ (random 65535.) (float 65536.)))

(defvar fooz (* pi 2 (frandom)))
(defvar foox (cos fooz))
(defvar fooy (sin fooz))
(defvar spokes 29.)
(defvar thetaz (/ (* pi 2) spokes))
(defvar thetax (cos thetaz))
(defvar thetay (sin thetaz))

(defun clipped-line (x0 y0 x1 y1 xl yl xh yh &aux clipped-p)
  (if (< x0 xl) (setq x0 xl clipped-p t))
  (if (< x1 xl) (setq x1 xl clipped-p t))
  (if (> x0 xh) (setq x0 xh clipped-p t))
  (if (> x1 xh) (setq x1 xh clipped-p t))
  (if (< y0 yl) (setq y0 yl clipped-p t))
  (if (< y1 yl) (setq y1 yl clipped-p t))
  (if (> y0 yh) (setq y0 yh clipped-p t))
  (if (> y1 yh) (setq y1 yh clipped-p t))
  (send *standard-output* :draw-line x0 y0 x1 y1 1 w:black tv:alu-xor)
  clipped-p)

(defun crack (p x0 y0 x1 y1 xl yl xh yh &aux x y)
  (if (> (frandom) p)
      (clipped-line x0 y0 x1 y1 xl yl xh yh)
      (progn
	(setq p (* p p)
	      x (floor (+ x0 (* (frandom) (- x1 x0))))
	      y (floor (+ y0 (* (frandom) (- y1 y0)))))
	(or (crack p x0 y0 x y xl yl xh yh)
	    (crack p x y x1 y1 xl yl xh yh)))))

(defun jag-ray (p pl x0 y0 dx dy xl yl xh yh &optional last-ray
		&aux x1 y1 this-ray)
  (do ()
      ((clipped-line x0 y0
		     (setq x1 (floor (+ x0 (* 2 (frandom) dx))))
		     (setq y1 (floor (+ y0 (* 2 (frandom) dy))))
		     xl yl xh yh)
       (reverse this-ray))
    (setq x0 x1 y0 y1)
    (setq this-ray (cons (cons x1 y1) this-ray))
    (setq p (+ p (* (- pl p) .1)))
    (if (< (frandom) p)
	(setq last-ray (jag-ray p pl
				x0 y0 
				(- (* dx thetax) (* dy thetay))     
				(+ (* dy thetax) (* dx thetay))     
				xl yl xh yh last-ray)))
    (when last-ray
      (if (< (frandom) (- 1.0 (/ p pl)))
	  (crack .85 x1 y1 (caar last-ray) (cdar last-ray) xl yl xh yh))
      (setq last-ray (cdr last-ray)))))
   

(defun outspoken (x0 y0 xl yl xh yh &aux (dx foox) (dy fooy) ray ray0)
  (dotimes (n spokes)
    (setq ray (jag-ray 0 .15 x0 y0 
		       (/ (* dx (- xh xl)) 23.)
		       (/ (* dy (- yh yl)) 23.)
		       xl yl xh yh ray))
    (if (= n 0) (setq ray0 ray))
    (psetq dx (- (* dx thetax) (* dy thetay))
	   dy (+ (* dy thetax) (* dx thetay))))
  (dotimes (n (min (length ray) (length ray0)))
    (crack .85 (caar ray) (cdar ray) (caar ray0) (cdar ray0) xl yl xh yh)
    (setq ray (cdr ray) ray0 (cdr ray0))))


(defun craze (&optional (*standard-output* *standard-output*))
  (multiple-value-bind (xl yl xh yh)
      (send *standard-output* :inside-edges)
    (outspoken (+ xl (floor (* (- xh xl) (+ .15 (* .7 (frandom))))))
	       (+ yl (floor (* (- yh yl) (+ .15 (* .7 (frandom))))))
	       xl yl xh yh)))

(DEFDEMO "craze" "Crack the screen" (craze))
