;;; -*- Mode:Common-Lisp; Package:DEMO; Base:8; Fonts:(MEDFNT HL12B HL12I MEDFNB) -*-

;;; Copyright (C) 1986, Texas Instruments Incorporated. All rights reserved.

;;;                           RESTRICTED RIGHTS LEGEND

;;;Use, duplication, or disclosure by the Government is subject to
;;;restrictions as set forth in subdivision (b)(3)(ii) of the Rights in
;;;Technical Data and Computer Software clause at 52.227-7013.
;;;
;;;                     TEXAS INSTRUMENTS INCORPORATED.
;;;                              P.O. BOX 2909
;;;                           AUSTIN, TEXAS 78769
;;;                                 MS 2151
;;;
;;; Copyright (C) 1985, Texas Instruments Incorporated. All rights reserved.

(defun qix (&optional (length 100) (stream *terminal-io*) (times NIL))
;;; (with-real-time
  (unwind-protect
   (let* ((list (make-list (1+ length)))
	  (history (nthcdr (1- length) list)))
     ;; Make history a circular list.
     (si:%p-store-cdr-code (cdr history) cdr-error)
     (si:%p-store-cdr-code history cdr-normal)
     (rplacd history list)
     (send stream :clear-screen)
     (loop repeat length
	   for h = history then (cdr h)
	   do (setf (car h) (make-list 4)))
     (multiple-value-bind (xlim ylim)
	 (send stream :inside-size)
       (loop with x1 = 0
	     and y1 = (1- ylim)
	     and x2 = 0
	     and y2 = (1- ylim)
	     and dx1 = 5
	     and dy1 = 12
	     and dx2 = 12
	     and dy2 = 5
	     with tem
	     until (or (send stream :tyi-no-hang)
		       (if times (= (setf times (1- times)) 0) NIL))
	     when (caar history)
	     do (send stream :draw-line
		      (first (car history))
		      (second (car history))
		      (third (car history))
		      (fourth (car history))
		      tv:alu-xor)
	     do (setf (first (car history)) x1)
	     (setf (second (car history)) y1)
	     (setf (third (car history)) x2)
	     (setf (fourth (car history)) y2)
	     (setf history (cdr history))
	     (send stream :draw-line x1 y1 x2 y2 tv:alu-xor)
	     (setf dx1 (1- (+ dx1 (random 3)))
		   dy1 (1- (+ dy1 (random 3)))
		   dx2 (1- (+ dx2 (random 3)))
		   dy2 (1- (+ dy2 (random 3))))
	     (cond ((> dx1 12) (setf dx1 12))
		   ((< dx1 -12) (setf dx1 -12)))
	     (cond ((> dy1 12) (setf dy1 12))
		   ((< dy1 -12) (setf dy1 -12)))
	     (cond ((> dx2 12) (setf dx2 12))	
		   ((< dx2 -12) (setf dx2 -12)))
	     (cond ((> dy2 12) (setf dy2 12))
		   ((< dy2 -12) (setf dy2 -12)))
	     (cond ((or (>= (setf tem (+ x1 dx1)) xlim)
			(minusp tem))
		    (setf dx1 (- dx1))))
	     (cond ((or (>= (setf tem (+ x2 dx2)) xlim)
			(minusp tem))
		    (setf dx2 (- dx2))))
	     (cond ((or (>= (setf tem (+ y1 dy1)) ylim)
			(minusp tem))
		    (setf dy1 (- dy1))))
	     (cond ((or (>= (setf tem (+ y2 dy2)) ylim)
			(minusp tem))
		    (setf dy2 (- dy2))))
	     (setf x1 (+ x1 dx1)
		     y1 (+ y1 dy1)
		     x2 (+ x2 dx2)
		     y2 (+ y2 dy2))
	  finally (loop repeat length
			when (caar history)
			 do (send stream :draw-line
				  (first (car history))
				  (second (car history))
				  (third (car history))
				  (fourth (car history))
				  tv:alu-xor)
			do (setf history (cdr history))))))
    (send stream :clear-screen)))                                  ; took out the "with-real-time"

(defdemo "Qix" "Not the arcade game" (qix))

