
(TRES FILE
 "       Description: Test Results File
    This file contains one or more records for each data set
 entered as engineering, test, maintenance, or other data,
 according to specifications for the data in a Data Collection
 operation (DCop). As these operations used to be called \"test\"
 operations, the file was named the \"test results\" file.
    Data entered for a lot (e.g. Probe or Break data), via automated
 interfaces or manually, for non-lot-related general data, or
 for scheduled maintenance tasks all are stored as TRES records.

"
 ((TRESKEY FIELD
   "treskey

    Type: Character, Size: 14, Usage: Key

 Primary key for tres file: includes test operation id
 and revDate to permit tres records for a specified test id
 to be read in reverse chronological order. Also includes
 sequence number to allow multiple records for one set of
 results.")
  (TESTOPNO FIELD
   "testopno

    Type: Character, Size: 8, Usage: Non-Key

 test operation number for current recipe.")
  (REVDATE FIELD
   "revdate

    Type: Byte Array, Number of Elements: 4, Element Size: 1

 Manipulated date/time integer.
 Logical complement of field \"daterev\".")
  (SEQNO FIELD
   "seqno

    Type: Integer, Size: 2, Usage: Non-Key

 Record sequence number, as INTEGER*2.
 seqno2

    Type: Integer, Size: 2, Usage: Non-Key

 Record sequence number, as INTEGER*2.
 seqno3

    Type: Integer, Size: 2, Usage: Non-Key

 Record sequence number, as INTEGER*2.")
  (LOTKEY FIELD
   "lotkey

    Type: Character, Size: 18, Usage: Key

 Secondary key: includes lot id and inverse of daterev to
 permit history records for a given lot to be scanned in
 reverse chronological order.  If there is no lot associated
 with this test, lotId is blank.")
  (LOTID FIELD
   "lotid

    Type: Character, Size: 12, Usage: Non-Key

 Unique lot identifier; composed of two subfields, lotnum
 and sublotid.")
  (REV2DATE FIELD
   "rev2date

    Type: Byte Array, Number of Elements: 4, Element Size: 1

 Manipulated date/time integer.")
  (SEQNO2 FIELD
   "seqno2

    Type: Integer, Size: 2, Usage: Non-Key

 Record sequence number, as INTEGER*2.")
  (EQPKEY FIELD
   "eqpkey

    Type: Character, Size: 14, Usage: Key

 Equipment id from trackin, + reverse date. 3rd & final TRES key.")
  (EQPID FIELD
   "eqpid

    Type: Character, Size: 8, Usage: Non-Key

 Equipment id of the individual machine of the specified equipment
 type that was selected by the operator to process the lot
 through the current recipe.")
  (REV3DATE FIELD
   "rev3date

    Type: Byte Array, Number of Elements: 4, Element Size: 1

 Manipulated date/time integer.")
  (SEQNO3 FIELD
   "seqno3

    Type: Integer, Size: 2, Usage: Non-Key

 Record sequence number, as INTEGER*2.")
  (TESTTYPE FIELD
   "testtype

    Type: Character, Size: 6, Usage: Non-Key

 Type of test; copied from test record.")
  (ENTTIME FIELD
   "enttime

    Type: Date, Size: 4, Usage: Non-Key

 Date/Time of test data entry, as determined by Entertest.")
  (DEVNAME FIELD
   "devname

    Type: Character, Size: 32, Usage: Non-Key

 Device name for the \"specific\" or base device for the lot,
 or Task id for records from a scheduled (non-lot) task.")
  (DEVFUNCNAME FIELD
   "devfuncname

    Type: Character, Size: 29, Usage: Non-Key

 Device name part.")
  (DEVVERS FIELD "devvers

    Type: Character, Size: 3, Usage: Non-Key

 Device version code.")
  (PROID FIELD "proid

    Type: Character, Size: 11, Usage: Non-Key

 Process id.")
  (PRONAME FIELD "proname

    Type: Character, Size: 8, Usage: Non-Key

 Process name part.")
  (PROVERS FIELD "provers

    Type: Character, Size: 3, Usage: Non-Key

 Process version code.")
  (PROKIND FIELD
   "prokind

    Type: Byte, Size: 1, Usage: Non-Key

 Kind of process currently being run.
 Possible values are:
    TYP__PKNOPROCESS - no process is currently being run.
    TYP__PKNORMAL - a normal process
    TYP__PKREWORK - a rework mini-process
    TYP__PKRECOV  - a recovery mini-process")
  (STEPNO FIELD
   "stepno

    Type: Integer, Size: 4, Usage: Non-Key

 Current process step number.")
  (RECPID FIELD
   "recpid

    Type: Character, Size: 8, Usage: Non-Key

 Gives the recipe id of the recipe currently being run on lot.
 Composed of two subfields, recpnum and recpvers.")
  (RECPNUM FIELD
   "recpnum

    Type: Character, Size: 5, Usage: Non-Key

 Recipe number part of recpid.")
  (RECPVERS FIELD
   "recpvers

    Type: Character, Size: 3, Usage: Non-Key

 Version number part of currecpid. This is set at lot trackin
 time:  if the process step calls for the \"active\" version of
 the recipe, the trackin function searches the recipe file to
 find the version number of this \"active\" recipe version,
 Even if the active version changes before trackout,
 the version being executed on the lot remains the same.")
  (TESTINDEX FIELD
   "testindex

    Type: Integer, Size: 4, Usage: Non-Key

 Test index in the current recipe.")
  (PRODAREA FIELD
   "prodarea

    Type: Character, Size: 10, Usage: Non-Key

 Production area where the test data was collected.  If test not
 associated with one lot, field is based on operator workcenter
 location.")
  (EMPIDENTERTEST FIELD
   "empidentertest

    Type: Character, Size: 12, Usage: Non-Key

 - user id of the last operator who entered or corrected
   test results for the lot.")
  (INPUTTYPE FIELD
   "inputtype

    Type: Character, Size: 1, Usage: Non-Key

 Is input Manual ('M') or Automatic ('A')?")
  (CONVRATE FIELD
   "convrate

    Type: Real, Size: 4, Usage: Non-Key

 \"convrate\" is the number of output parts yielded by one
 input part (e.g. #die per wafer at probe) according to device
 standards.")
  (STARTPARTS FIELD
   "startparts

    Type: Integer, Size: 4, Usage: Non-Key

 if material is wafers, or procstate = 'M',
       startparts = hist.stepStSz
 if material = die,
       startparts = hist.dieIn")
  (MATIDENT FIELD
   "matident

    Type: Character, Size: 1, Usage: Non-Key

 'U' or 'I' - is the material tested identified or un-?")
  (PARMPTR FIELD
   "parmptr

    Type: Character Array, Number of Elements: 20, Element Size: 1

 parameter pointers.")
  (PARMVAL FIELD
   "parmval

    Type: Character Array, Number of Elements: 20, Element Size: 15

 Values of parameters.")
  (ENTSTATE FIELD
   "entstate

    Type: Integer, Size: 4, Usage: Non-Key

 Indicates the state of the test operation entry at the time
 of writing the TRES record.")
  (VALID FIELD "valid

    Type: Integer, Size: 4, Usage: Non-Key

 Is this data still valid?")
  (DATAWHERE FIELD
   "datawhere

    Type: Character, Size: 1, Usage: Non-Key

 Where is the data (if any)?
 'R' = in the record
 'F' = in a Standard Interface File (SIF)
 'P' = in a parent record (other TRES record)
 'C' = in chained records
 'A' = in an archive (bulk data file-to-tape)")
  (PARENTREC FIELD
   "parentrec

    Type: Character, Size: 14, Usage: Non-Key

 Points to \"parent\" record, if any, for this record.
 (1) - Default: same as tresKey; points to itself.
 (2) - Chained: points to 1st chained record (seqNo = 0)
 (3) - Post entry: points to 1st (in-step) record.
 (4) - Multi-lot, or non-lot: this is a lot's tres record,
       but the data came from a non- or multi-lot tres
       record, to which this points.")
  (NUMRESULTS FIELD
   "numresults

    Type: Integer, Size: 4, Usage: Non-Key

 Number of results for whole data set - not just this record.")
  (MAXSEQNO FIELD
   "maxseqno

    Type: Integer, Size: 4, Usage: Non-Key

 SeqNo of last record used to store the results; 0-N. If N > 0
 this is the N+1st member of a chained set of records. If not chained, this
 field is 0.")
  (RESULTSPERREC FIELD
   "resultsperrec

    Type: Integer, Size: 4, Usage: Non-Key

 0 for non-chained records.
 Number of results per record, when records are chained.")
  (RECRESNUMBASE FIELD
   "recresnumbase

    Type: Integer, Size: 4, Usage: Non-Key

 (Number-1) of the first result in THIS record, counting from the
 first one in the first record. Therefore, 0 in non-chained
 records; result (i+recResNumBase) is in position i in this record.")
  (SIFILEID FIELD
   "sifileid

    Type: Character, Size: 48, Usage: Non-Key

 S tandard  I nterface  F ile  Id = Path//Name
 A full description, either explicitly or via a logical name
 prefix, of the name & location of the SIFile holding the data.
 Composed of:")
  (SIFILEPATH FIELD
   "sifilepath

    Type: Character, Size: 35, Usage: Non-Key

 Either, a logical name,
 Or, a Node::Disk:[directory.subdir] prefix.")
  (SIFILENAME FIELD
   "sifilename

    Type: Character, Size: 13, Usage: Non-Key

 File name, XXXXXXXXX.AAA.")
  (ARCHIVEID FIELD "archiveid

    Type: Character, Size: 35, Usage: Non-Key
")
  (NOWAFS FIELD
   "nowafs

    Type: Integer, Size: 4, Usage: Non-Key

 Count of wafers tested so far; list of wafer id's in \"wafnums\"")
  (WAFSTOTEST FIELD
   "wafstotest

    Type: Integer, Size: 4, Usage: Non-Key

 Count of total wafers which the test operation said to test.")
  (WAFINDEXC FIELD
   "wafindexc

    Type: Character, Size: 50, Usage: Non-Key

 For the ith wafer, ICHAR(wafindexc(i:i)) is the position
 of the wafer in the actl.wafnums array.")
  (WAF1STFREEITEM FIELD
   "waf1stfreeitem

    Type: Character, Size: 50, Usage: Non-Key

 For the ith wafer, ICHAR(waf1stFreeItem(i:i)) is the position
 of the first site or item for that wafer with missing data. If there
 is data for all items, the value is CHAR(255). If the wafer
 has not been tested yet, the value is CHAR(0).")
  (WAFNUMS FIELD
   "wafnums

    Type: Character Array, Number of Elements: 50, Element Size: 12

 Holds  the wafer numbers of all wafers that have been tested,
 both fab wafers and control wafers. Wafer numbers are normally
 recorded in order of testing.")
  (NUMDIMS FIELD
   "numdims

    Type: Integer, Size: 4, Usage: Non-Key

 Number of dimensions which the test data array has.
 counter for dimnumvalues, below.")
  (DIMNUMVALUES FIELD
   "dimnumvalues

    Type: Integer Array, Number of Elements: 4, Element Size: 4

 For dimension i, j=dimNumValues(i) is the ACTUAL number of values
 for this side of the array.  If i is the WAFERs dimension, then
 j is noWafers to be tested; if i is the ITEMs dimension, j is noTestDi;
 if i is the SITES dimension, j is number of sites to test.
 This information is present in the TEST record as MAXIMUM values;
 it is suitably modified in case of wafers or sites, and is
 copied to the TRES record to dynamically size the TRES data array.")
  (NOCALC FIELD
   "nocalc

    Type: Integer, Size: 4, Usage: Non-Key

 Number of valid derived results - copied from TEST record.")
  (NOTESTDI FIELD
   "notestdi

    Type: Integer, Size: 4, Usage: Non-Key

 Counter field for 'di' structure.
 Number of data items for this test.")
  (WARNLEVELVALID FIELD
   "warnlevelvalid

    Type: Integer, Size: 4, Usage: Non-Key

 Are the fields in dResWarnLevel valid?")
  (DRESWARNLEVEL FIELD
   "dreswarnlevel

    Type: Byte Array, Number of Elements: 99, Element Size: 1

 Each value is an integer giving the warning level
 associated with the calculation of the corresponding
 derived result; if > 0, the result was out of spec.
 Only valid when \"warnlevelvalid\" field is .true.")
  (DERIVRES FIELD
   "derivres

    Type: Real Array, Number of Elements: 99, Element Size: 4

 Values derived by calculation from test results
 field marker, start of results section")
  (RECRESCNT FIELD
   "recrescnt

    Type: Integer, Size: 4, Usage: Non-Key

 Count of number of bytes of test results elements used
 in the tResArr array below.")
  (TRESARR FIELD
   "tresarr

    Type: Byte Array, Number of Elements: 2000, Element Size: 1

 Part or all of the test data, stored as consecutive bytes.")
  (DI STRUCTURE "No help available."))) 
