
(UBOM FILE
 "       Description:
 Used by the Multipart Assembly module.
 This file acts as a parallel, 'auxiliary' file to the ACTL file.
 It serves as an extension of the ACTL arrays specifying the ids of
 the main parts (wafers, substrates etc.) in a lot.
 It contains one or more records for every record in the ACTL file
 which has associated Unit Bill(s) of Materials, as indicated by
 the lot's material identification field actl_matIdent (='B').

"
 ((UNITID FIELD
   "unitid

    Type: Character, Size: 12, Usage: Key

 Serial number of the substrate or network.")
  (NUMBEROFENTRIES FIELD
   "numberofentries

    Type: Integer, Size: 4, Usage: Non-Key

 Number of used slots in the following parallel arrays")
  (POSITIONID FIELD
   "positionid

    Type: Character Array, Number of Elements: 30, Element Size: 4

 This is a label/location character string, by which a
 component device is referenced locally, as in the device BOM.")
  (COMPONENTDEVICEID FIELD
   "componentdeviceid

    Type: Character Array, Number of Elements: 30, Element Size: 32

 The product id of an individual component.")
  (MATTYPECODE FIELD
   "mattypecode

    Type: Character Array, Number of Elements: 30, Element Size: 1

 Material type code, e.g. 'W' , 'D', etc.")
  (MATIDENT FIELD
   "matident

    Type: Character Array, Number of Elements: 30, Element Size: 1

 Material identification of this component, e.g. 'U', 'I', etc.")
  (SOURCELOTID FIELD
   "sourcelotid

    Type: Character Array, Number of Elements: 30, Element Size: 12

 Lot id of the inventory lot from which this component was drawn.")
  (COMPONENTID FIELD
   "componentid

    Type: Character Array, Number of Elements: 30, Element Size: 12

 Blank for unidentified components.
 For identified components the component id may or may not be
 recorded here. Source lot id may be sufficient for traceability.
 Component id becomes relevant when the component is rekitted
 or unkitted (= removed from the unit).")
  (QUANTITY FIELD
   "quantity

    Type: Integer Array, Number of Elements: 30, Element Size: 4

 Number of components of this device id in this hybrid unit
 position. If the same type of component device is used in more
 than one position, multiple entries in the Bill of Materials
 are used.")
  (MANUALFLAG FIELD
   "manualflag

    Type: Character Array, Number of Elements: 30, Element Size: 5

 Field to be used for optional manual flagging of this entry,
 e.g. to record a component rework count (blue dots).")
  (SALVAGECODE FIELD
   "salvagecode

    Type: Character Array, Number of Elements: 30, Element Size: 1

 Indicates the 'removable' and 'reclaimable' attributes
 of this component device/position. Possible values are:
 TYP__DBOMNONREMOVABLE     - Non-removable
 TYP__DBOMNONRECLAIMABLE   - Removable/Non-reclaimable
 TYP__DBOMRECLAIMUNIDENT   - Removable/Reclaimable unidentified
                           material
 TYP__DBOMRECLAIMIDENT     - Removable/Reclaimable identified
                           material. Part may or may not be
                           identified in kitting operation. If not,
                           identify when removing part.

 Note: The salvage code of the substrate position is always
 non-removable. Also, 'components' not associated with a particular
 position are non-removable.")
  (NUMBEROFACTIONS FIELD
   "numberofactions

    Type: Integer, Size: 4, Usage: Non-Key

 Number of action set up via the Special Branch Recovery menu
 function and not yet executed.")
  (ACTION FIELD
   "action

    Type: Character Array, Number of Elements: 10, Element Size: 1

 Type of hybrid operation to be performed. The possible types are:
 TYP__OPERACTIONCODEREMOVE    = 'M'
 TYP__OPERACTIONCODEADD       = 'A'
 TYP__OPERACTIONCODEREPLACE   = 'R'
 TYP__OPERACTIONCODETRIM      = 'T'
 TYP__OPERACTIONCODESPAREBOND = 'S'
 TYP__OPERACTIONCODEUNKIT     = 'U'
 actionpositionid

    Type: Character Array, Number of Elements: 10, Element Size: 4

 Position id on hybrid unit, designated by PROMIS user as
 requiring this type of operation. Position id is not
 relevant for the TYP__OPERACTIONCODEUNKIT (unkit) operation.
 actionprocessid

    Type: Character Array, Number of Elements: 10, Element Size: 11

 Process where the action designated by PROMIS user is to occur.
 actionstepno

    Type: Integer Array, Number of Elements: 10, Element Size: 4

 Step number in \"process id\" where the action designated by
 PROMIS user is to take place.")
  (ACTIONPOSITIONID FIELD
   "actionpositionid

    Type: Character Array, Number of Elements: 10, Element Size: 4

 Position id on hybrid unit, designated by PROMIS user as
 requiring this type of operation. Position id is not
 relevant for the TYP__OPERACTIONCODEUNKIT (unkit) operation.")
  (ACTIONPROCESSID FIELD
   "actionprocessid

    Type: Character Array, Number of Elements: 10, Element Size: 11

 Process where the action designated by PROMIS user is to occur.")
  (ACTIONSTEPNO FIELD
   "actionstepno

    Type: Integer Array, Number of Elements: 10, Element Size: 4

 Step number in \"process id\" where the action designated by
 PROMIS user is to take place.")
  (REFPOSITIONID FIELD
   "refpositionid

    Type: Character Array, Number of Elements: 10, Element Size: 4

 Reference Position id on hybrid unit, used for certain hybrid
 actions."))) 
