
(VRDF FILE
 "       Description:
         VaRiable Definition File (VRDF) -- contains all the valid variables
         defined in the MNP subsystem, with one record per variable
         describing that variable's attributes (e.g., variable number,
         name, short and long column headings, calculation formulas, etc.)

"
 ((VARIABLENUMBER FIELD
   "variablenumber

    Type: Integer, Size: 4, Usage: Key

   ! Key field defining the unique identification number
   ! assigned to each output variable in the MNP subsystem.
   ! The value for this field is read in by subprogram VRDFCre
   ! from the input ASCII file  (i.e., 'VAR NUMBER' record).
   ! It is this integer-number that is specified by the user
   ! when selecting the output variables to include in a
   ! particular report during report definition
   ! (i.e., using the \"Report Definition\" option of the MNP subsystem menu).")
  (DESCRIPTION FIELD
   "description

    Type: Character, Size: 40, Usage: Non-Key

   ! Description/name given to the particular output variable.
   ! The value for this field is read in by subprogram VRDFCre
   ! from the input ASCII file  (i.e, 'DESCRIPTION' record).")
  (DEFAULTFLDWIDTH FIELD
   "defaultfldwidth

    Type: Integer, Size: 4, Usage: Non-Key

   ! Default print-field size for the particular output variable
   ! (this default value is arbitrarily assigned for a given output variable,
   ! based on the expected probable maximum value for that particular variable
   ! in a typical operating environment).
   ! The value for this field is read in by subprogram VRDFCre
   ! from the input ASCII file  (i.e., 'FIELD WIDTH (DEF)' record).
   ! During report definition, this is the default value shown
   ! when the user is prompted for the desired size of the print-field
   ! (i.e., rpdf.outputVarSize()) for this particular output variable.")
  (DEFAULTHEADWIDTH FIELD
   "defaultheadwidth

    Type: Integer, Size: 4, Usage: Non-Key

   ! Number of characters in the longest \"component\"
   ! of the long-heading description specified below.
   ! The value for this field is calculated by subprogram VRDFCre
   ! based on the actual description contained in LHeading below.
   ! At report generation, the value in this field determines whether
   ! the short-heading or long-heading should be used as the column heading
   ! for the particular output variable in the report being generated,
   ! as follows:
   !    - if the desired size of the print-field for the output variable
   !      as specified by the user during report definition
   !      (i.e., rpdf.outputVarSize()) is greater than or equal to
   !      the DefaultHeadWidth value corresponding to that output variable,
   !      then the LHeading description is used;
   !    - otherwise, the SHeading description is used,
   !      to economize on column space.")
  (MINIMUMFLDWIDTH FIELD
   "minimumfldwidth

    Type: Integer, Size: 4, Usage: Non-Key

   ! Number of characters in the longest \"component\"
   ! of the short-heading description specified below.
   ! The value for this field is calculated by subprogram VRDFCre
   ! based on the actual description contained in SHeading below.
   ! During report definition, this is the minimum value allowed
   ! when the user is prompted for the desired size of the print-field
   ! (i.e., rpdf.outputVarSize()) for this particular output variable.")
  (LHEADING FIELD
   "lheading

    Type: Character, Size: 64, Usage: Non-Key

   ! Long-heading description for the particular output variable,
   ! which may be used as its column heading in a report;
   ! may consist of multiple components/layers
   ! separated by the delimiter MNP__VARLHEADINGDELIMITER (='@').
   ! The value for this field is read in by subprogram VRDFCre
   ! from the input ASCII file  (i.e., 'LONG HEADING' record).
   ! At report generation, the report generator automatically determines,
   ! for each output variable included in the report,
   ! whether it is appropriate to use the LHeading or SHeading
   ! of that output variable as its column heading
   ! (see general rule for determining this, under DefaultHeadWidth above).
   ! Note: Regardless of whether LHeading or SHeading is used,
   !       two or more of its components may occupy
   !       a single column-heading-layer on the actual report
   !       if the total length of these components is less than or equal to
   !       the specific print-field size (i.e., rpdf.outputVarSize())
   !       specified by the user for the output variable
   !       in that particular report")
  (SHEADING FIELD
   "sheading

    Type: Character, Size: 40, Usage: Non-Key

   ! Short-heading description for the particular output variable,
   ! which may be used as its column heading in a report;
   ! may consist of multiple components/layers
   ! separated by the delimiter MNP__VARSHEADINGDELIMITER (='-').
   ! The value for this field is read in by subprogram VRDFCre
   ! from the input ASCII file  (i.e., 'SHORT HEADING' record).
   ! For an explanation of how this SHeading field is used
   ! at report generation, see the corresponding comment for LHeading above.")
  (OUTPUTFORMAT FIELD
   "outputformat

    Type: Character, Size: 2, Usage: Non-Key

   ! Indicates the format of the output variable when printed on a report;
   ! i.e., whether it should be in integer format,
   ! or in decimal format (with the specified number of digits
   ! after the decimal point).
   ! The value for this field is read in by subprogram VRDFCre
   ! from the input ASCII file  (i.e., 'OUTPUT FORMAT' record).
   ! Valid values are: 'I', or 'Dn' (where n is a 1-digit number > 0).")
  (PRIMEORCALCFLAG FIELD
   "primeorcalcflag

    Type: Character, Size: 1, Usage: Non-Key

   ! Indicates whether the output variable is a Prime variable
   ! (i.e., already stored in the Summary Data file; no calculation required)
   ! or a Calculated variable (i.e., calculated from one or more
   ! prime variables).
   ! The value for this field is read in by subprogram VRDFCre
   ! from the input ASCII file  (i.e., 'TYPE OF VAR (P/C)' record).
   ! Valid values are:  'P' for Prime, or 'C' for Calculated.")
  (SPECIALLOGICFLAG FIELD
   "speciallogicflag

    Type: Integer, Size: 4, Usage: Non-Key

   ! Indicates the special logic required for the output variable's
   ! calculation, which depends on the variable's general classification
   ! as defined below.
   ! The value for this field is read in by subprogram VRDFCre
   ! from the input ASCII file  (i.e., 'SPECIAL LOGIC' record).
   ! Valid values are 1 thru 4, defined as follows:
   !   - 1 = BOH       (e.g., \"Prime BOH\")
   !   - 2 = EOH       (e.g., \"Prime EOH\")
   !   - 3 = Activity  (e.g., \"Average Outs\") i.e., calculate shifts,
   !                                                then add up shifts
   !   - 4 = Activity  (e.g., \"Average BOH\")  i.e., add up shifts,
   !                                                then calculate")
  (CUMVARFLAG FIELD
   "cumvarflag

    Type: Integer, Size: 4, Usage: Non-Key

   ! Indicates whether the output variable requires \"cum\"-type calculation
   ! or not.
   ! The value for this field is read in by subprogram VRDFCre
   ! from the input ASCII file  (i.e., 'CUM VARIABLE FLAG' record).
   ! Valid values are:
   !   - for non-cum-type variables: 0
   !   - for     cum-type variables: 1000, 1001, 1010, 1011,
   !                                 1100, 1101, 1110, 1111.
   !     note that for cum-type variables, each digit
   !     has a different significance as defined below:
   !       - 1st digit:  0 means no cum;          1 means cum
   !       - 2nd digit:  0 means straight cum;    1 means reverse cum
   !       - 3rd digit:  0 means cum by addition; 1 means cum by multiplication
   !       - 4th digit:  0 means continuous cum;  1 means segmented cum.")
  (CUMSUMOFLINEFLAG FIELD
   "cumsumoflineflag

    Type: Integer, Size: 4, Usage: Non-Key

   ! Indicates which \"Cumulative\"-type calculation the output variable
   ! requires as it appears in a 'Cumulative' sum of line in the report.
   ! The value for this field is read in by subprogram VRDFCre
   ! from the input ASCII file  (i.e., 'CSUM (CUM) FLAG' record).
   ! Valid values are:
   !     0 : add up (calculated) values of this output variable from
   !         (relevant) detail lines.
   !     1 : Multiply (calculated) values of this output variable from
   !         (relevant) detail lines.
   !     2 : leave blank, most probably this output variable not
   !         applicable for cum sum of line.
   ! Note: if   CumSumOfLineFlag = 1,
   !       then AvgSumOfLineFlag must not be 0")
  (AVGSUMOFLINEFLAG FIELD
   "avgsumoflineflag

    Type: Integer, Size: 4, Usage: Non-Key

   ! Indicates which \"Average\"-type calculation the output variable
   ! requires as it appears in an 'Average' sum of line in the report.
   ! The value for this field is read in by subprogram VRDFCre
   ! from the input ASCII file  (i.e., 'ASUM (AVG) FLAG' record).
   ! Valid values are:
   !     0 : add up (calculated) values of this output variable from
   !         (relevant) detail lines then divide by counter, i.e.
   !         number of detail lines.
   !     1 : aggregate raw data (prime variables) from (relevant)
   !         detail lines then apply calculation formula.
   !     2 : leave blank, most probably this output variable not
   !         applicable for average sum of line.
   ! Note: if   CumSumOfLineFlag = 1,
   !       then AvgSumOfLineFlag must not be 0")
  (RESTRICTIONFLAG FIELD
   "restrictionflag

    Type: Integer, Size: 4, Usage: Non-Key

   ! Indicates whether there is any restriction in the choice of this
   ! output variable, e.g. if the (relevant) summary data file is NOT
   ! by shift, user should not be allowed to include 'shift average'
   ! type output variable in the report.
   ! The value for this field is read in by subprogram VRDFCre
   ! from the input ASCII file  (i.e., 'RESTRICTION FLAG' record).
   ! Valid values are:
   !     0 : no restriction
   !     1 : summary data file must be by shift")
  (CALCFLAG FIELD
   "calcflag

    Type: Character, Size: 1, Usage: Non-Key

   ! Indicates whether the Calculated variable should be derived through
   ! integer arithmetic or real*8 arithmetic.
   ! The value for this field is read in by subprogram VRDFCre
   ! from the input ASCII file  (i.e., 'INTEGER OR REAL' record).
   ! Valid values are: 'I' for Integer, or 'R' for Real.
   ! Note: if at least one IRLEflag() = 'R' or 'W',
   !       then CalcFlag should be 'R'")
  (PRIMEVARIABLECOUNT FIELD
   "primevariablecount

    Type: Integer, Size: 4, Usage: Non-Key

   ! The number of prime variables specified/used
   ! in calculating the value of the output variable;
   ! i.e., the number of Prime variables actually stored
   ! in the Name() array below.
   ! The value for this field is read in by subprogram VRDFCre
   ! from the input ASCII file  (i.e., 'NUM OF PRIME VAR' record).")
  (NAME FIELD
   "name

    Type: Character Array, Number of Elements: 25, Element Size: 31

   ! Array containing the names of all the prime variables used
   ! in calculating the value of the output variable.
   ! The prime variable name/s specified for this array
   ! is/are read in by subprogram VRDFCre from the input ASCII file
   ! (i.e., 'PRIME VAR NAMEn' record).
   ! The valid values for each array element Name(i) specified
   ! must be one of the following:
   !   - a valid name contained in the MNP__VARTBL_PRIMEVARNAME() table
   !     defined in MNP:VARTBL.FOR.
   !   - the character string 'WORKHOUR'
   !   - the character string 'LITERAL n' where n is a 1-digit number.
   ! The number of names read in and contained in this array
   ! must be exactly the same number as the previously-entered value
   ! for PrimeVariableCount above.
   ! All array elements Name(i), if any, for which i > PrimeVariableCount,
   ! are left blank.")
  (RECTYPE FIELD
   "rectype

    Type: Integer Array, Number of Elements: 25, Element Size: 4

   ! Array indicating whether the corresponding prime variable specified
   ! in the Name() array above belongs to a record-type-1 or a record-type-2
   ! SUMM file record.
   ! The appropriate value for each array element RecType(i)
   ! (for i from 1 thru the value in PrimeVariableCount above)
   ! is determined from MNP:VARTBL.FOR by function Mnp_VRDFRtn_ScanVarTbl
   ! in subprogram VRDFCre, as follows:
   !    RecType(i) = MNP__VARTBL_PRIMEVARRECTYPE(n),
   !    where n is the same index value for which
   !    Name(i) = MNP__VARTBL_PRIMEVARNAME(n).")
  (IRLEFLAG FIELD
   "irleflag

    Type: Character Array, Number of Elements: 25, Element Size: 1

   ! Array indicating whether the corresponding prime variable specified
   ! in the Name() array above is an integer, real, literal, EOH-type,
   ! or workhour variable.
   ! The appropriate value for each array element IRLEflag(i)
   ! (for i from 1 thru the value in PrimeVariableCount above)
   ! is determined by subprogram VRDFCre as follows:
   !   - if Name(i) = 'WORKHOUR',  then IRLEflag(i) = 'W'
   !   - if Name(i) = 'LITERAL n', then IRLEflag(i) = 'L'
   !   - if Name(i) is not equal to either of the two above cases,
   !     then IRLEflag(i) is determined from MNP:VARTBL.FOR by function
   !     Mnp_VRDFRtn_ScanVarTbl in subprogram VRDFCre, as follows:
   !        IRLEflag(i) = MNP__VARTBL_PRIMEVARTYPE(n),
   !        where n is the same index value for which
   !        Name(i) = MNP__VBARTBL_PRIMEVARNAME(n).
   ! The valid values for each array element IRLEflag(i) are:
   !   - 'I' for Integer
   !   - 'R' for Real
   !   - 'L' for Literal
   !   - 'E' for EOH-type
   !   - 'W' for Workhour
   !   - ' '  (valid only for array elements IRLEflag(i), if any,
   !           for which i > PrimeVariableCount)")
  (POSITION FIELD
	    "position

    Type: Integer Array, Number of Elements: 25, Element Size: 4

   ! Array indicating the relative position (as defined in MNP:RECMAP.FOR)
   ! of the corresponding prime variable specified in the Name() array above
   ! The appropriate value for each array element Position(i)
   ! (for i from 1 thru the value in PrimeVariableCount above)
   ! is determined by subprogram VRDFCre as follows:
   !   - if Name(i) = 'WORKHOUR',  then Position(i) = 0
   !   - if Name(i) = 'LITERAL n', then Position(i) = the integer value 'n'
   !   - if Name(i) is not equal to either of the two above cases,
   !     then Position(i) is determined from MNP:VARTBL.FOR by function
   !     Mnp_VRDFRtn_ScanVarTbl in subprogram VRDFCre, as follows:
   !        Position(i) = MNP__VARTBL_PRIMEVARPOSITION(n),
   !        where n is the same index value for which
   !        Name(i) = MNP__VBARTBL_PRIMEVARNAME(n).
   ! The valid values for each array element Position(i)
   ! must be one of the following:
   !   - the integer value of the corresponding parameter defined
   !     in MNP:RECMAP.FOR, or the integer value 'n' if Name(i) = 'LITERAL n'
   !   - 0  (valid only for array elements RecType(i)
   !         whose corresponding Name(i) = 'WORKHOUR';
   !         and for array elements RecType(i), if any,
   !         for which i > PrimeVariableCount)")
  (CALCDESCRIPTION1 FIELD
   "calcdescription1

    Type: Character, Size: 52, Usage: Non-Key

   ! 1st line of description of the calculation logic required
   ! in calculating the value of the output variable.
   ! This description is read in by subprogram VRDFCre from the
   ! input ASCII file (i.e., 'CALC DESCRIPTION1' record),
   ! and is then translated into CalcFormula1 below
   ! to facilitate the calculation during report generation.
   ! The format for CalcDescritpion1 is 'XX = AA $ BB $ CC ...'  where:
   !   - XX equals either 'T1', 'T2', 'T3', indicating an intermediate result;
   !     or 'VR', indicating the final result for the output variable
   !   - AA, BB, etc. are 2-digit indices ('01' for 1, '02' for 2, etc.)
   !     referring to the corresponding prime variable in the Name() array
   !     above
   !   - $ represents an arithmetic operator ('+', '-', '*', or '/')
   ! NOTE: This format MUST be adhered to strictly;
   !       otherwise, the resulting CalcFormula1
   !       and the entire calculation logic for the output variable
   !       will be incorrect.
   ! CalcDescription1 can never be blank; i.e., at least one calculation
   ! description line must be specified for the output variable.")
  (CALCFORMULA1 FIELD
   "calcformula1

    Type: Integer Array, Number of Elements: 22, Element Size: 4

   ! Array containing the numeric codes defining the 1st line of formula
   ! of the calculation logic, as translated from CalcDescription1 above.
   ! This array is derived by function Mnp_VRDFRtn_CalcDecode
   ! in subprogram VRDFCre.
   ! At report generation, the report generator deciphers the numeric codes
   ! in CalcFormula1 and performs the indicated arithmetic operation(s)
   ! on the particular prime variable(s) specified,
   ! and stores the result in the intermediate or final storage area indicated.")
  (CALCDESCRIPTION2 FIELD
   "calcdescription2

    Type: Character, Size: 52, Usage: Non-Key

   ! 2nd line of description of the calculation logic required
   ! in calculating the value of the output variable.
   ! The comments for CalcDescription1 above apply similarly for this field,
   ! (except that CalcDescription2 is optional, i.e., it may be blank.)")
  (CALCFORMULA2 FIELD
   "calcformula2

    Type: Integer Array, Number of Elements: 22, Element Size: 4

   ! Array containing the numeric codes defining the 2nd line of formula
   ! of the calculation logic, as translated from CalcDescription2 above.
   ! The comments for CalcFormula1 above apply similarly for this field,
   ! (except that the CalcFormula2() array will contain zeroes
   !  if CalcDescription2 is blank.)")
  (CALCDESCRIPTION3 FIELD
   "calcdescription3

    Type: Character, Size: 52, Usage: Non-Key

   ! 3rd line of description of the calculation logic required
   ! in calculating the value of the output variable.
   ! The comments for CalcDescription1 above apply similarly for this field,
   ! (except that CalcDescription3 is optional, i.e., it may be blank.)")
  (CALCFORMULA3 FIELD
   "calcformula3

    Type: Integer Array, Number of Elements: 22, Element Size: 4

   ! Array containing the numeric codes defining the 3rd line of formula
   ! of the calculation logic, as translated from CalcDescription3 above.
   ! The comments for CalcFormula1 above apply similarly for this field,
   ! (except that the CalcFormula3() array will contain zeroes
   !  if CalcDescription3 is blank.)")
  (CALCDESCRIPTION4 FIELD
   "calcdescription4

    Type: Character, Size: 52, Usage: Non-Key

   ! 4th line of description of the calculation logic required
   ! in calculating the value of the output variable.
   ! The comments for CalcDescription1 above apply similarly for this field,
   ! (except that CalcDescription4 is optional, i.e., it may be blank.)")
  (CALCFORMULA4 FIELD
   "calcformula4

    Type: Integer Array, Number of Elements: 22, Element Size: 4

   ! Array containing the numeric codes defining the 4th line of formula
   ! of the calculation logic, as translated from CalcDescription4 above.
   ! The comments for CalcFormula1 above apply similarly for this field,
   ! (except that the CalcFormula4() array will contain zeroes
   !  if CalcDescription4 is blank.)")
  (CALCDESCRIPTION5 FIELD
   "calcdescription5

    Type: Character, Size: 52, Usage: Non-Key

   ! 5th line of description of the calculation logic required
   ! in calculating the value of the output variable.
   ! The comments for CalcDescription1 above apply similarly for this field,
   ! (except that CalcDescription5 is optional, i.e., it may be blank.)")
  (CALCFORMULA5 FIELD
   "calcformula5

    Type: Integer Array, Number of Elements: 22, Element Size: 4

   ! Array containing the numeric codes defining the 5th line of formula
   ! of the calculation logic, as translated from CalcDescription5 above.
   ! The comments for CalcFormula1 above apply similarly for this field,
   ! (except that the CalcFormula5() array will contain zeroes
   !  if CalcDescription5 is blank.)")
  (CALCDESCRIPTION6 FIELD
   "calcdescription6

    Type: Character, Size: 52, Usage: Non-Key

   ! 6th line of description of the calculation logic required
   ! in calculating the value of the output variable.
   ! The comments for CalcDescription1 above apply similarly for this field,
   ! (except that CalcDescription6 is optional, i.e., it may be blank.)")
  (CALCFORMULA6 FIELD
   "calcformula6

    Type: Integer Array, Number of Elements: 22, Element Size: 4

   ! Array containing the numeric codes defining the 6th line of formula
   ! of the calculation logic, as translated from CalcDescription6 above.
   ! The comments for CalcFormula1 above apply similarly for this field,
   ! (except that the CalcFormula6() array will contain zeroes
   !  if CalcDescription6 is blank.)")
  (CALCDESCRIPTION7 FIELD
   "calcdescription7

    Type: Character, Size: 52, Usage: Non-Key

   ! 7th line of description of the calculation logic required
   ! in calculating the value of the output variable.
   ! The comments for CalcDescription1 above apply similarly for this field,
   ! (except that CalcDescription7 is optional, i.e., it may be blank.)")
  (CALCFORMULA7 FIELD
   "calcformula7

    Type: Integer Array, Number of Elements: 22, Element Size: 4

   ! Array containing the numeric codes defining the 7th line of formula
   ! of the calculation logic, as translated from CalcDescription7 above.