;;; -*- Mode:Common-lisp; Package:user; Base:10.; Fonts: MEDFNT,HL12B -*-

(USER:ADD-HELP-FUNCTION (LIST "VIEW" "SHOW" "LIST" "TYPE")
		   "FILE"
		   'FS:VIEW-FILE)
(USER:ADD-HELP-FUNCTION (LIST "EDIT" "LIST")
		   "DIRECTORY"
		   'DIRED)
(USER:ADD-HELP-FUNCTION (LIST "VIEW" "SHOW")
		   "PRINT QUEUE"
		   'PRINTER:SHOW-PRINT-QUEUE)
(USER:ADD-HELP-FUNCTION (LIST "VIEW" "SHOW" "PRINT")
		   "LOGIN HISTORY"
		   'SI:PRINT-LOGIN-HISTORY)
(USER:ADD-HELP-FUNCTION (LIST "GET")
		   "DECODED TIME"
		   'TIME:GET-DECODED-TIME)
(USER:ADD-HELP-FUNCTION (LIST "GET")
		   "UNIVERSAL TIME"
		   'TIME:GET-UNIVERSAL-TIME)
(USER:ADD-HELP-FUNCTION (LIST "PRINT" "SHOW")
		   "CURRENT TIME"
		   'TIME:PRINT-CURRENT-TIME)
(USER:ADD-HELP-FUNCTION (LIST "PRINT" "SHOW")
		   "CURRENT DATE"
		   'TIME:PRINT-CURRENT-DATE)
(USER:ADD-HELP-FUNCTION (LIST "PRINT" "SHOW")
		   "TIME SPECIFIED BY UNITS"
		   'TIME:PRINT-TIME)
(USER:ADD-HELP-FUNCTION (LIST "PRINT" "SHOW")
		   "DATE SPECIFIED BY UNITS"
		   'TIME:PRINT-DATE)
(USER:ADD-HELP-FUNCTION (LIST "CHANGE")
		   "UNIVERSAL TO DECODED TIME"
		   'TIME:DECODE-UNIVERSAL-TIME)
(USER:ADD-HELP-FUNCTION (LIST "CHANGE")
		   "DECODED TO UNIVERSAL TIME"
		   'TIME:ENCODE-UNIVERSAL-TIME)
(USER:ADD-HELP-FUNCTION (LIST "INITIALIZE")
		   "TIME"
		   'TIME:INITIALIZE-TIMEBASE)
(USER:ADD-HELP-FUNCTION (LIST "INITIALIZE")
		   "FILE SYSTEM"
		   'FS:INITIALIZE-FILE-SYSTEM)
(USER:ADD-HELP-FUNCTION (LIST "BOOT")
		   "FILE SYSTEM"
		   'FS:BOOT-FILE-SYSTEM)
(USER:ADD-HELP-FUNCTION (LIST "EXPAND")
		   "FILE SYSTEM"
		   'FS:EXPAND-FILE-SYSTEM)
(USER:ADD-HELP-FUNCTION (LIST "RECOVER")
		   "FILE SYSTEM"
		   'FS:LM-SALVAGE)
(USER:ADD-HELP-FUNCTION (LIST "CHECK" "PROBE" "VIEW")
		   "DIRECTORY STRUCTURE"
		   'FS:DEBUG)
(USER:ADD-HELP-FUNCTION (LIST "PRINT" "SHOW")
		   "DATE SPECIFIED IN UNIVERSAL FORM"
		   'TIME:PRINT-UNIVERSAL-DATE)
(USER:ADD-HELP-FUNCTION (LIST "PRINT" "SHOW")
		   "TIME SPECIFIED IN UNIVERSAL FORM"
		   'TIME:PRINT-UNIVERSAL-TIME)
(USER:ADD-HELP-FUNCTION (LIST "PRINT" "SHOW")
		   "TIME SPECIFIED IN UNIVERSAL FORM NO SECS"
		   'TIME:PRINT-BRIEF-UNIVERSAL-TIME)
(USER:ADD-HELP-FUNCTION (LIST "SET")
		   "LOCAL TIME"
		   'TIME:SET-LOCAL-TIME)
(USER:ADD-HELP-FUNCTION (LIST "GET" "SHOW")
		   "TIME IN 60TH OF SECONDS"
		   'TIME:TIME)
(USER:ADD-HELP-FUNCTION (LIST "GET" "SHOW")
		   "60TH OF SECONDS SINCE BOOT"
		   'TIME:GET-INTERNAL-RUN-TIME)
(USER:ADD-HELP-FUNCTION (LIST "GET" "SHOW")
		   "MICROSECOND-TIME"
		   'TIME:MICROSECOND-TIME)
(USER:ADD-HELP-FUNCTION (LIST "TEST IF")
		   "TIME1 LESS THAN TIME2"
		   'TIME:TIME-LESSP)
(USER:ADD-HELP-FUNCTION (LIST "ADD")
		   "POSITIVE TIME INTERVAL"
		   'TIME:TIME-INCREMENT)
(USER:ADD-HELP-FUNCTION (LIST "ADD")
		   "NEGATIVE TIME INTERVAL"
		   'TIME:TIME-DIFFERENCE)
(USER:ADD-HELP-FUNCTION (LIST "VIEW" "SHOW")
		   "REMOTE PRINT QUEUE"
		   'PRINTER:SHOW-PRINT-QUEUE-ON-REMOTE-HOST)
(USER:ADD-HELP-FUNCTION "INITIALIZE"
		   "DISK SYSTEM"
		   'SI:INITIALIZE-DISK-SYSTEM)
(USER:ADD-HELP-FUNCTION (LIST "SAVE" "WRITE")
		   "MODIFIED FILES"
		   'ZWEI:SAVE-ALL-FILES)
(USER:ADD-HELP-FUNCTION (LIST "EDIT" "MODIFY" "UPDATE" "CHANGE")
		   "LABEL"
		   'SI:EDIT-DISK-LABEL)
(USER:ADD-HELP-FUNCTION (LIST "VIEW" "SHOW" "LIST" "PRINT")
		   (LIST "HERALD")
		   'SI:PRINT-HERALD)
(USER:ADD-HELP-FUNCTION (LIST "VIEW" "SHOW" "LIST" "PRINT" "DESCRIBE" "DISPLAY")
		   (LIST "LOGICAL UNITS" "DISK UNITS")
		   'SI:ALL-UNITS)
(USER:ADD-HELP-FUNCTION (LIST "DESCRIBE")
		   "AREA"
		   'SI:DESCRIBE-AREA)
(USER:ADD-HELP-FUNCTION (LIST "VIEW" "SHOW" "LIST" "PRINT" "DISPLAY")
		   (LIST "CONFIGURATION" "DISK TYPES")
		   'SI:PRINT-DISK-TYPE-TABLE)
(USER:ADD-HELP-FUNCTION (LIST "SET" "VERBOSE")
		   (LIST "PRINT HERALD")
		   'SI:SET-VERBOSE-PRINT-HERALD)

(USER:ADD-HELP-FUNCTION (LIST "PRINT")
		   (LIST "FILE")
		   'SI:PRINT-FILE)
(USER:ADD-HELP-FUNCTION (LIST "PRINT" "SHOW")
		   (LIST "SYSTEM MODIFICATIONS")
		   'SI:PRINT-SYSTEM-MODIFICATIONS)
(USER:ADD-HELP-FUNCTION (LIST "GET" "SHOW")
		   (LIST "SYSTEM VERSION")
		   'SI:GET-SYSTEM-VERSION)
(USER:ADD-HELP-FUNCTION (LIST "GET" "SHOW")
		   (LIST "SYSTEM INFORMATION")
		   'SI:SYSTEM-VERSION-INFO)
(USER:ADD-HELP-FUNCTION (LIST "VIEW" "SHOW" "LIST" "PRINT")
		   (LIST "LABEL")
		   'SI:PRINT-DISK-LABEL)
(USER:ADD-HELP-FUNCTION (LIST "COMPILE")
		   (LIST "FILE")
		   'QC-FILE)
(USER:ADD-HELP-FUNCTION (LIST "LOAD")
		   (LIST "FILE")
		   'LOAD)
(USER:ADD-HELP-FUNCTION (LIST "VIEW" "SHOW" "LIST" "PRINT")
		   (LIST "XFASL")
		   'SI:UNFASL-PRINT)
(USER:ADD-HELP-FUNCTION (LIST "WRITE")
		   (LIST "XFASL DESCRIPTION")
		   'SI:UNFASL-FILE)
(USER:ADD-HELP-FUNCTION (LIST "DESCRIBE" "VIEW" "SHOW" "LIST")
		   (LIST "DEFSTRUCT")
		   'DESCRIBE-DEFSTRUCT)
(USER:ADD-HELP-FUNCTION (LIST "DEFINE")
		   (LIST "TYPE")
		   'DEFTYPE)
(USER:ADD-HELP-FUNCTION (LIST "ESTIMATE")
		   (LIST "DUMP SIZE")
		   'SI:ESTIMATE-DUMP-SIZE)
(USER:ADD-HELP-FUNCTION (LIST "ESTIMATE")
		   (LIST "MODIFIED PAGES")
		   'SI:ESTIMATE-MODIFIED-CORE-PAGES)
(USER:ADD-HELP-FUNCTION (LIST "VIEW" "SHOW" "LIST")
		   (LIST "INIT KEYWORDS")
		   'SI:FLAVOR-ALL-ALLOWED-INIT-KEYWORDS)
(USER:ADD-HELP-FUNCTION (LIST "DESCRIBE" "VIEW" "SHOW" "LIST")
		   (LIST "FLAVOR")
		   'DESCRIBE-FLAVOR)
(USER:ADD-HELP-FUNCTION (LIST "READ")
		   (LIST "STREAM" "OBJECT")
		   'READ)
(USER:ADD-HELP-FUNCTION (LIST "READ")
		   (LIST "CHARACTER")
		   'TYI)
(USER:ADD-HELP-FUNCTION (LIST "READ")
		   (LIST "IGNORE")
		   'READ-FOR-TOP-LEVEL)
(USER:ADD-HELP-FUNCTION (LIST "READ" "VALIDATE" "CHECK")
		   (LIST "STREAM (VALIDATE INDENTATION)")
		   'READ-CHECK-INDENTATION)
(USER:ADD-HELP-FUNCTION (LIST "READ")
		   (LIST "LINE" "SENTENCE")
		   'READLINE)
(USER:ADD-HELP-FUNCTION (LIST "READ")
		   (LIST "LINE (DISCARD SPACES)" "SENTENCE (DISCARD SPACES)")
		   'READLINE-TRIM)
(USER:ADD-HELP-FUNCTION (LIST "READ")
		   (LIST "STRING")
		   'READ-FROM-STRING)
(USER:ADD-HELP-FUNCTION (LIST "PRINT" "WRITE")
		   (LIST "WITH SLASHIFICATION")
		   'PRIN1)
(USER:ADD-HELP-FUNCTION (LIST "PRINT" "WRITE")
		   (LIST "WITH SLASHIFICATION AND SPACE")
		   'PRIN1-THEN-SPACE)
(USER:ADD-HELP-FUNCTION (LIST "PRINT" "WRITE")
		   (LIST "NEW LINE")
		   'PRINT)
(USER:ADD-HELP-FUNCTION (LIST "PRINT" "WRITE")
		   (LIST "WITHOUT SLASHIFICATION")
		   'PRINC)
(USER:ADD-HELP-FUNCTION (LIST "WRITE")
		   (LIST "CHARACTER")
		   'TYO)
(USER:ADD-HELP-FUNCTION (LIST "WRITE")
		   (LIST "CARRIGE RETURN")
		   'TERPRI)
(USER:ADD-HELP-FUNCTION (LIST "COPY")
		   (LIST "STREAM")
		   'STREAM-COPY-UNTIL-EOF)
(USER:ADD-HELP-FUNCTION (LIST "BEEP")
		   (LIST "BEEPER")
		   'BEEP)
(USER:ADD-HELP-FUNCTION (LIST "PRINT" )
		   (LIST "OBJECT")
		   'SI:PRINT-OBJECT)
(USER:ADD-HELP-FUNCTION (LIST "PRINT")
		   (LIST "LIST")
		   'SI:PRINT-LIST)
(USER:ADD-HELP-FUNCTION (LIST "ADD" "CONFIGURE")
		   (LIST "DISK")
		   'SI:CONFIGURE-DISK-SYSTEM)
(USER:ADD-HELP-FUNCTION (LIST "SET" "ASSIGN")
		   (LIST "DEFAULT FONT")
		   'TV:SET-DEFAULT-FONT)
(USER:ADD-HELP-FUNCTION (LIST "SHOW" "LIST" "VIEW" "DISPLAY" "REPORT")
		   (LIST "LAST SHUTDOWN" "CRASH")
		   'SI:REPORT-LAST-SHUTDOWN)
(USER:ADD-HELP-FUNCTION (LIST "SHOW" "LIST" "VIEW" "DISPLAY" "REPORT")
		   (LIST "ALL SHUTDOWNS" "CRASHES")
		   'SI:REPORT-ALL-SHUTDOWNS)
(USER:ADD-HELP-FUNCTION (LIST "STOP" "SHUT DOWN")
		   (LIST "EXPLORER")
		   'SI:SHUTDOWN)
(USER:ADD-HELP-FUNCTION (LIST "SET" "ASSIGN" "EXPAND")
		   (LIST "PRINT HERALD")
		   'SI:SET-VERBOSE-PRINT-HERALD)
(USER:ADD-HELP-FUNCTION (LIST "SET" "ASSIGN")
		   (LIST "DEFAULT DISK UNIT" "NVRAM")
		   'SI:SETUP-NVRAM)
(USER:ADD-HELP-FUNCTION (LIST "OPEN")
		   (LIST "FILE")
		   'OPEN)
(USER:ADD-HELP-FUNCTION (LIST "CLOSE")
		   (LIST "FILE")
		   'CLOSE)
(USER:ADD-HELP-FUNCTION (LIST "DELETE")
		   (LIST "FILE")
		   'DELETE-FILE)
(USER:ADD-HELP-FUNCTION (LIST "UNDELETE" "RECOVER")
		   (LIST "FILE")
		   'UNDELETE-FILE)
(USER:ADD-HELP-FUNCTION (LIST "RENAME")
		   (LIST "FILE")
		   'RENAME-FILE)
(USER:ADD-HELP-FUNCTION (LIST "COPY")
		   (LIST "FILE")
		   'COPY-FILE)
(USER:ADD-HELP-FUNCTION (LIST "PROBE" "TEST IF")
		   (LIST "FILE EXISTS")
		   'PROBE-FILE)
(USER:ADD-HELP-FUNCTION (LIST "CLOSE")
		   (LIST "ALL FILES")
		   'FS:CLOSE-ALL-FILES)
(USER:ADD-HELP-FUNCTION (LIST "LOAD")
		   (LIST "TEXT FILE")
		   'READFILE)
(USER:ADD-HELP-FUNCTION (LIST "LOAD")
		   (LIST "XFASL" "BINARY FILE")
		   'FASLOAD)
(USER:ADD-HELP-FUNCTION (LIST "VIEW" "SHOW" "LIST")
		   (LIST "FILE ATTRIBUTES")
		   'FS:FILE-ATTRIBUTE-LIST)
(USER:ADD-HELP-FUNCTION (LIST "GET")
		   (LIST "PATHNAME HOST")
		   'FS:GET-PATHNAME-HOST)
(USER:ADD-HELP-FUNCTION (LIST "VIEW" "SHOW" "LIST")
		   (LIST "STREAM ATTRIBUTES")
		   'FS:EXTRACT-ATTRIBUTE-LIST)
(USER:ADD-HELP-FUNCTION (LIST "COPY")
		   (LIST "FILE ATTRIBUTES")
		   'FS:READ-ATTRIBUTE-LIST)
(USER:ADD-HELP-FUNCTION (LIST "VIEW" "SHOW" "LIST")
		   (LIST "FILE ATTRIBUTE BINDINGS")
		   'FS:FILE-ATTRIBUTE-BINDINGS)
(USER:ADD-HELP-FUNCTION (LIST "VIEW" "SHOW" "LIST")
		   (LIST "DIRECTORY")
		   'FS:DIRECTORY-LIST)
(USER:ADD-HELP-FUNCTION (LIST "EXPUNGE" "CLEANUP")
		   (LIST "DIRECTORY")
		   'FS:EXPUNGE-DIRECTORY)
(USER:ADD-HELP-FUNCTION (LIST "CREATE")
		   (LIST "DIRECTORY")
		   'FS:CREATE-DIRECTORY)
(USER:ADD-HELP-FUNCTION (LIST "CHANGE" "MODIFY")
		   (LIST "FILE PROPERTIES")
		   'FS:CHANGE-FILE-PROPERTIES)
(USER:ADD-HELP-FUNCTION (LIST "VIEW" "SHOW" "LIST")
		   (LIST "FILE PROPERTIES")
		   'FS:FILE-PROPERTIES)
(USER:ADD-HELP-FUNCTION (LIST "SET" "ASSIGN")
		   (LIST "WORKING DIRECTORY")
		   'FS:SET-HOST-WORKING-DIRECTORY)
(USER:ADD-HELP-FUNCTION (LIST "MAKE" "CREATE")
		   (LIST "PATHNAME DEFAULTS")
		   'FS:MAKE-PATHNAME-DEFAULTS)
(USER:ADD-HELP-FUNCTION (LIST "COPY")
		   (LIST "PATHNAME DEFAULTS")
		   'FS:COPY-PATHNAME-DEFAULTS)
(USER:ADD-HELP-FUNCTION (LIST "COPY")
		   (LIST "DIRECTORY")
		   'FS:COPY-DIRECTORY)
(USER:ADD-HELP-FUNCTION (LIST "VIEW" "SHOW" "LIST")
		   (LIST "PATHNAME DEFAULTS")
		   'FS:PATHNAME-DAFAULTS)
(USER:ADD-HELP-FUNCTION (LIST "VIEW" "SHOW" "LIST")
		   (LIST "DEFAULT HOST")
		   'FS:DEFAULT-HOST)
(USER:ADD-HELP-FUNCTION (LIST "DESCRIBE" "VIEW" "SHOW" "LIST")
		   (LIST "HOST")
		   'SI:DESCRIBE-HOST)
(USER:ADD-HELP-FUNCTION (LIST "SET" "ASSIGN")
		   (LIST "PATHNAME DEFAULTS")
		   'FS:SET-DEFAULT-PATHNAME)
(USER:ADD-HELP-FUNCTION (LIST "PARSE")
		   (LIST "PATHNAME")
		   'FS:PARSE-PATHNAME)
(USER:ADD-HELP-FUNCTION (LIST "CREATE" "MERGE")
		   (LIST "PATHNAME FROM DEFAULTS")
		   'FS:MERGE-PATHNAME-DEFAULTS)
(USER:ADD-HELP-FUNCTION (LIST "MAKE" "CREATE")
		   (LIST "PATHNAME")
		   'FS:MAKE-PATHNAME)
(USER:ADD-HELP-FUNCTION (LIST "VIEW" "SHOW" "LIST")
		   (LIST "HOME DIRECTORY")
		   'FS:USER-HOMEDIR)
(USER:ADD-HELP-FUNCTION (LIST "VIEW" "SHOW" "LIST")
		   (LIST "INIT FILE")
		   'FS:INIT-FILE-PATHNAME)
(USER:ADD-HELP-FUNCTION (LIST "VIEW" "SHOW" "LIST" "DESCRIBE")
		   (LIST "PATHNAME")
		   'FS:DESCRIBE-PATHNAME)
(USER:ADD-HELP-FUNCTION (LIST "VIEW" "SHOW" "LIST" "DESCRIBE")
		   (LIST "PROPERTY LIST")
		   'FS:PATHNAME-PLIST)
(USER:ADD-HELP-FUNCTION (LIST "ADD" "CREATE" "MAKE")
		   (LIST "LOGICAL PATHNAME")
		   'FS:ADD-LOGICAL-PATHNAME-HOST)
(USER:ADD-HELP-FUNCTION (LIST "LOAD")
		   (LIST "PATCHES")
		   'LOAD-PATCHES)
(USER:ADD-HELP-FUNCTION (LIST "SET" )
		   (LIST "SYSTEM HOST")
		   'SI:SET-SYS-HOST)
(USER:ADD-HELP-FUNCTION (LIST "COPY" "RECEIVE")
		   (LIST "REMOTE BAND" "REMOTE PARTITION")
		   'SI:RECEIVE-BAND)
(USER:ADD-HELP-FUNCTION (LIST "SEND" "TRANSMIT")
		   (LIST "BAND" "PARTITION")
		   'SI:TRANSMIT-BAND)
(USER:ADD-HELP-FUNCTION (LIST "COMPARE" "VERIFY")
		   (LIST "REMOTE BAND" "REMOTE PARTITION")
		   'SI:COMPARE-BAND)
(USER:ADD-HELP-FUNCTION (LIST "COPY")
		   (LIST "LOCAL BAND" "LOCAL PARTITION")
		   'SI:COPY-DISK-PARTITION)
(USER:ADD-HELP-FUNCTION (LIST "COPY")
		   (LIST "DISK LABEL")
		   'SI:COPY-DISK-LABEL)
(USER:ADD-HELP-FUNCTION (LIST "COMPARE" "VERIFY")
		   (LIST "LOCAL BANDS" "LOCAL PARTITIONS")
		   'SI:COMPARE-DISK-PARTITION)
(USER:ADD-HELP-FUNCTION (LIST "VIEW" "SHOW" "LIST" "DESCRIBE")
		   (LIST "PARTITION")
		   'DESCRIBE-PARTITION)
(USER:ADD-HELP-FUNCTION (LIST "BOOT" "RESTORE")
		   (LIST "DISK" "PARTITION")
		   'DISK-RESTORE)
(USER:ADD-HELP-FUNCTION (LIST "SET")
		   (LIST "LOAD BAND")
		   'SET-CURRENT-BAND)
(USER:ADD-HELP-FUNCTION (LIST "SET")
		   (LIST "PACK NAME")
		   'SI:SET-PACK-NAME)
(USER:ADD-HELP-FUNCTION (LIST "SET")
		   (LIST "PARTITION ATTRIBUTE")
		   'SI:SET-PARTITION-ATTRIBUTE)
(USER:ADD-HELP-FUNCTION (LIST "SET")
		   (LIST "PARTITION PROPERTY")
		   'SI:SET-PARTITION-PROPERTY)
(USER:ADD-HELP-FUNCTION (LIST "SET")
		   (LIST "PARTITION COMMENT")
		   'SI:UPDATE-PARTITION-COMMENT)
(USER:ADD-HELP-FUNCTION (LIST "GET" "FIND")
		   (LIST "DISK PARTITION")
		   'SI:FIND-DISK-PARTITION)
(USER:ADD-HELP-FUNCTION (LIST "GET" "FIND")
		   (LIST "DISK PARTITION WITH ERROR CHECKING")
		   'SI:FIND-DISK-PARTITION-FOR-READ)
(USER:ADD-HELP-FUNCTION (LIST "GET" "FIND")
		   (LIST "DISK PARTITION WITH CONFIRMATION")
		   'SI:FIND-DISK-PARTITION-FOR-WRITE)
(USER:ADD-HELP-FUNCTION (LIST "GET" "FIND")
		   (LIST "HOST DISK NAME")
		   'SI:GET-HOST-PACK-NAME)
(USER:ADD-HELP-FUNCTION (LIST "GET" "FIND")
		   (LIST "PACK NAME")
		   'SI:GET-PACK-NAME)
(USER:ADD-HELP-FUNCTION (LIST "GET" "FIND")
		   (LIST "MCR VERSION FROM COMMENT")
		   'SI:GET-UCODE-VERSION-FROM-COMMENT)
(USER:ADD-HELP-FUNCTION (LIST "GET" "FIND")
		   (LIST "MCR VERSION OF BAND")
		   'SI:GET-UCODE-VERSION-OF-BAND)
(USER:ADD-HELP-FUNCTION (LIST "SHOW" "GET")
		   (LIST "USED PARTITION SIZE")
		   'SI:MEASURED-SIZE-OF-PARTITION)
(USER:ADD-HELP-FUNCTION (LIST "SHOW" "GET")
		   (LIST "PARTITION'S COMMENT")
		   'SI:PARTITION-COMMENT)
(USER:ADD-HELP-FUNCTION (LIST "DESCRIBE" "LIST" "SHOW")
		   (LIST "DISK'S PARTITIONS")
		   'SI:PARTITION-LIST)
(USER:ADD-HELP-FUNCTION (LIST "PRINT" "SHOW")
		   (LIST "AVAILABLE BANDS")
		   'SI:PRINT-AVAILABLE-BANDS)
(USER:ADD-HELP-FUNCTION (LIST "SET" "CHANGE")
		   (LIST "MICROCODE")
		   'SET-CURRENT-MICROLOAD)
(USER:ADD-HELP-FUNCTION (LIST "LOAD")
		   (LIST "MICROCODE" "MCR FILE")
		   'SI:LOAD-MCR-FILE)
(USER:ADD-HELP-FUNCTION (LIST "MODIFY" "CHANGE")
		   (LIST "DEFAULT DISK" "NVRAM")
		   'SET-CURRENT-MICROLOAD)
(USER:ADD-HELP-FUNCTION (LIST "VIEW" "SHOW" "LIST")
		   (LIST "LOAD BAND")
		   'SI:CURRENT-BAND)
(USER:ADD-HELP-FUNCTION (LIST "VIEW" "SHOW" "LIST")
		   (LIST "MICROCODE BAND")
		   'SI:CURRENT-MICROLOAD)
(USER:ADD-HELP-FUNCTION (LIST "DUMP" "SAVE" "STORE" "WRITE")
		   (LIST "FORMS" "LISP OBJECT")
		   'DUMP-FORMS-TO-FILE)

(USER:ADD-HELP-FUNCTION (LIST "STATUS")
		   (LIST "GC")
		   'SI:GC-STATUS)
(USER:ADD-HELP-FUNCTION (LIST "STATUS")
		   (LIST "SWAP")
		   'SI:SWAP-STATUS)
(USER:ADD-HELP-FUNCTION (LIST "STATUS")
		   (LIST "FREE ADDRESS SPACE")
		   'SI:GET-FREE-ADDRESS-SPACE)
(USER:ADD-HELP-FUNCTION (LIST "COPY")
		   (LIST "SYSTEM")
		   'SI:COPY-SYSTEM)

(USER:ADD-HELP-FUNCTION (LIST "BIND")
		   (LIST "PACKAGE OVER FORMS")
		   'PKG-BIND)
(USER:ADD-HELP-FUNCTION (LIST "SET" "BIND")
		   (LIST "*PACKAGE*")
		   'PKG-GOTO)
(USER:ADD-HELP-FUNCTION (LIST "SET" "BIND")
		   (LIST "*PACKAGE* GLOBALLY")
		   'PKG-GOTO-GLOBALLY)
(USER:ADD-HELP-FUNCTION (LIST "DEFINE")
		   (LIST "PACKAGE")
		   'DEFPACKAGE)
(USER:ADD-HELP-FUNCTION (LIST "DELETE")
		   (LIST "PACKAGE COMPLETLY")
		   'DELETE-PACKAGE)
(USER:ADD-HELP-FUNCTION (LIST "DELETE")
		   (LIST "PACKAGE FORM LIST")
		   'KILL-PACKAGE)
(USER:ADD-HELP-FUNCTION (LIST "MAKE" "CREATE")
		   (LIST "PACKAGE")
		   'MAKE-PACKAGE)
(USER:ADD-HELP-FUNCTION (LIST "ASSIGN")
		   (LIST "PACKAGE NICKNAMES")
		   'IN-PACKAGE)
(USER:ADD-HELP-FUNCTION (LIST "package")
		   (LIST "LIST ALL")
		   'LIST-ALL-PACKAGES)
(USER:ADD-HELP-FUNCTION (LIST "package")
		   (LIST "MAKE" "CREATE")
		   'MAKE-PACKAGE)
(USER:ADD-HELP-FUNCTION (LIST "package")
		   (LIST "SPECIFY" "IN")
		   'IN-PACKAGE)
(USER:ADD-HELP-FUNCTION (LIST "package")
		   (LIST "FIND PACKAGE")
		   'FIND-PACKAGE)
(USER:ADD-HELP-FUNCTION (LIST "package")
		   (LIST "OTHERS USED")
		   'PACKAGE-USE-LIST)
(USER:ADD-HELP-FUNCTION (LIST "package")
		   (LIST "USED BY OTHERS")
		   'PACKAGE-USED-BY-LIST)
(USER:ADD-HELP-FUNCTION (LIST "package")
		   (LIST "SHADOWING SYMBOLS")
		   'PACKAGE-SHADOWING-SYMBOLS)
(USER:ADD-HELP-FUNCTION (LIST "package")
		   (LIST "NICKNAMES")
		   'PACKAGE-NICKNAMES)
(USER:ADD-HELP-FUNCTION (LIST "package")
		   (LIST "RENAME")
		   'RENAME-PACKAGE)
(USER:ADD-HELP-FUNCTION (LIST "package" "symbols")
		   (LIST "DO SYMBOLS")
		   'DO-SYMBOLS)
(USER:ADD-HELP-FUNCTION (LIST "package" "symbols")
		   (LIST "DO EXTERNAL SYMBOLS")
		   'DO-EXTERNAL-SYMBOLS)
(USER:ADD-HELP-FUNCTION (LIST "package" "symbols")
		   (LIST "DO ALL SYMBOLS")
		   'DO-ALL-SYMBOLS)
(USER:ADD-HELP-FUNCTION (LIST "package" "symbols")
		   (LIST "FIND SYMBOL")
		   'FIND-SYMBOL)
(USER:ADD-HELP-FUNCTION (LIST "package" "symbols")
		   (LIST "FIND SYMBOLS")
		   'FIND-ALL-SYMBOLS)
(USER:ADD-HELP-FUNCTION (LIST "package" "symbols")
		   (LIST "IMPORT")
		   'IMPORT)
(USER:ADD-HELP-FUNCTION (LIST "package" "symbols")
		   (LIST "SHADOW")
		   'SHADOW)
(USER:ADD-HELP-FUNCTION (LIST "package" "symbols")
		   (LIST "SHADOWING IMPORT")
		   'SHADOWING-IMPORT)
(USER:ADD-HELP-FUNCTION (LIST "package" "symbols")
		   (LIST "UNINTERN")
		   'UNINTERN)
(USER:ADD-HELP-FUNCTION (LIST "package" "symbols")
		   (LIST "USE PACKAGE")
		   'USE-PACKAGE)
(USER:ADD-HELP-FUNCTION (LIST "package" "symbols")
		   (LIST "UNUSE PACKAGE")
		   'UNUSE-PACKAGE)
(USER:ADD-HELP-FUNCTION (LIST "package" "symbols")
		   (LIST "EXPORT")
		   'EXPORT)
(USER:ADD-HELP-FUNCTION (LIST "package" "symbols")
		   (LIST "UNEXPORT")
		   'UNEXPORT)
(USER:ADD-HELP-FUNCTION (LIST "GET")
		   (LIST "SYMBOL VALUE")
		   'SYMBOL-VALUE)
(USER:ADD-HELP-FUNCTION (LIST "GET")
		   (LIST "GLOBAL SYMBOL VALUE")
		   'SYMEVAL-GLOBALLY)

(USER:ADD-HELP-FUNCTION (LIST "symbols")
		   (LIST "SYMBOL VALUE")
		   'SYMBOL-VALUE)
(USER:ADD-HELP-FUNCTION (LIST "symbols")
		   (LIST "SYMBOL FUNCTION")
		   'SYMBOL-FUNCTION)
(USER:ADD-HELP-FUNCTION (LIST "GET")
		   (LIST "FUNCTION DEFINITION")
		   'SYMBOL-FUNCTION)
(USER:ADD-HELP-FUNCTION (LIST "symbols")
		   (LIST "UNBIND VARIABLE")
		   'MAKUNBOUND)
(USER:ADD-HELP-FUNCTION (LIST "symbols")
		   (LIST "UNBIND FUNCTION")
		   'FMAKUNBOUND)

(USER:ADD-HELP-FUNCTION (LIST "UNBIND")
		   (LIST "FUNCTION")
		   'FMAKUNBOUND)
(USER:ADD-HELP-FUNCTION (LIST "UNBIND")
		   (LIST "SPECIAL VARIABLE")
		   'MAKUNBOUND)
(USER:ADD-HELP-FUNCTION (LIST "UNBIND")
		   (LIST "SPECIAL OR INSTANCE VARIABLE")
		   'VARIABLE-MAKUNBOUND)
(USER:ADD-HELP-FUNCTION (LIST "UNBIND")
		   (LIST "GLOBAL VARIABLE")
		   'MAKUNBOUND-GLOBALLY)

(USER:ADD-HELP-FUNCTION (LIST "symbols" "predicates")
		   (LIST "BOUNDP")
		   'BOUNDP)
(USER:ADD-HELP-FUNCTION (LIST "TEST IF")
		   (LIST "SPECIAL VARIABLE BOUND")
		   'BOUNDP)
(USER:ADD-HELP-FUNCTION (LIST "TEST IF")
		   (LIST "GENERAL VARIABLE BOUND")
		   'VARIABLE-BOUNDP)
(USER:ADD-HELP-FUNCTION (LIST "TEST IF")
		   (LIST "BOUND GLOBALLY")
		   'BOUNDP-GLOBALLY)
(USER:ADD-HELP-FUNCTION (LIST "symbols" "predicates")
		   (LIST "FBOUNDP")
		   'FBOUNDP)
(USER:ADD-HELP-FUNCTION (LIST "symbols" "predicates")
		   (LIST "SPECIAL FORM")
		   'SPECIAL-FORM-P)

(USER:ADD-HELP-FUNCTION (LIST "modules")
		   (LIST "PROVIDE")
		   'PROVIDE)
(USER:ADD-HELP-FUNCTION (LIST "modules")
		   (LIST "REQUIRE")
		   'REQUIRE)

(USER:ADD-HELP-FUNCTION (LIST "define")
		   (LIST "SETF METHOD")
		   'DEFINE-SETF-METHOD)
(USER:ADD-HELP-FUNCTION (LIST "define")
		   (LIST "MODIFY MACRO")
		   'DEFINE-MODIFY-MACRO)
(USER:ADD-HELP-FUNCTION (LIST "DEFINE")
		   (LIST "SETF OPERATION - MORE COMPLEX")
		   'DEFINE-SETF-METHOD)
(USER:ADD-HELP-FUNCTION (LIST "DELETE")
		   (LIST "SETF DEFINITION")
		   'DELETE-SETF-METHOD)
(USER:ADD-HELP-FUNCTION (LIST "GET")
		   (LIST "SETF DEFINITION")
		   'GET-SETF-METHOD)
(USER:ADD-HELP-FUNCTION (LIST "GET")
		   (LIST "SETF DEFINITION WITH MULTIPLE VALUES")
		   'GET-SETF-METHOD-MULTIPLE-VALUES)
(USER:ADD-HELP-FUNCTION (LIST "DEFINE")
		   (LIST "MACRO THAT MODIFIES ARGUMENTS")
		   'DEFINE-MODIFY-MACRO)

(USER:ADD-HELP-FUNCTION (LIST "define")
		   (LIST "SETF")
		   'DEFSETF)
(USER:ADD-HELP-FUNCTION (LIST "DEFINE")
		   (LIST "SETF OPERATION")
		   'DEFSETF)
(USER:ADD-HELP-FUNCTION (LIST "define" "get")
		   (LIST "GET SETF METHOD")
		   'GET-SETF-METHOD)
(USER:ADD-HELP-FUNCTION (LIST "define" "get")
		   (LIST "GET MULTIPLE METHOD")
		   'GET-SETF-METHOD-MULTIPLE-VALUE)

(USER:ADD-HELP-FUNCTION (LIST "function call")
		   (LIST "APPLY")
		   'APPLY)
(USER:ADD-HELP-FUNCTION (LIST "function call")
		   (LIST "FUNCALL")
		   'FUNCALL)

(USER:ADD-HELP-FUNCTION (LIST "assignment")
		   (LIST "SHIFT AND SET" "SHIFTF")
		   'SHIFTF)
(USER:ADD-HELP-FUNCTION (LIST "SET")
		   (LIST "SHIFT LIST ELEMENTS SPECIFYING LAST")
		   'SHIFTF)
(USER:ADD-HELP-FUNCTION (LIST "assignment")
		   (LIST "ROTATE AND SET" "ROTATEF")
		   'ROTATEF)
(USER:ADD-HELP-FUNCTION (LIST "SET")
		   (LIST "SHIFT LIST ELEMENTS USING LAST")
		   'ROTATEF)

(USER:ADD-HELP-FUNCTION (LIST "assignment")
		   (LIST "SETF")
		   'SETF)
(USER:ADD-HELP-FUNCTION (LIST "assignment")
		   (LIST "PSETF")
		   'PSETF)
(USER:ADD-HELP-FUNCTION (LIST "assignment")
		   (LIST "PARALLEL SETQ" "PSETQ")
		   'PSETQ)
(USER:ADD-HELP-FUNCTION (LIST "SET")
		   (LIST "VARIABLES IN PARALLEL")
		   'PSETQ)
(USER:ADD-HELP-FUNCTION (LIST "assignment")
		   (LIST "SPECIAL VARIABLES" "SET")
		   'SET)
(USER:ADD-HELP-FUNCTION (LIST "SET")
		   (LIST "SYMBOL FORM")
		   'SET)
(USER:ADD-HELP-FUNCTION (LIST "SET")
		   (LIST "VARIABLE")
		   'SETQ)
(USER:ADD-HELP-FUNCTION (LIST "SET")
		   (LIST "GLOBAL VARIABLE")
		   'SETQ-GLOBALLY)
(USER:ADD-HELP-FUNCTION (LIST "SET")
		   (LIST "GLOBAL SYMBOL FORM")
		   'SET-GLOBALLY)
(USER:ADD-HELP-FUNCTION (LIST "SET")
		   (LIST "ANY SETFABLE FORM IN PARALLEL")
		   'PSETF)
(USER:ADD-HELP-FUNCTION (LIST "SET")
		   (LIST "ANY SETFABLE FORM SEQUENTIALLY")
		   'SETF)

(USER:ADD-HELP-FUNCTION (LIST "special forms" "sequencing")
		   (LIST "BLOCK")
		   'BLOCK)
(USER:ADD-HELP-FUNCTION (LIST "special forms" "non-local exits" "sequencing")
		   (LIST "CATCH")
		   'CATCH)
(USER:ADD-HELP-FUNCTION (LIST "special forms" "binding")
		   (LIST "COMPILER LET")
		   'COMPILER-LET)
(USER:ADD-HELP-FUNCTION (LIST "BIND")
		   (LIST "WHEN COMPILED")
		   'COMPILER-LET)
(USER:ADD-HELP-FUNCTION (LIST "special forms" "declarations")
		   (LIST "DECLARE")
		   'DECLARE)
(SI:SET-DOCUMENTATION 'DECLARE 'FUNCTION
 (STRING-APPEND (SI:DOCUMENTATION 'DECLARE 'FUNCTION) "
 The valid declaration specifiers are SPECIAL, TYPE, FTYPE, FUNCTION,
 IGNORE, OPTIMIZE, and DECLARATION."))
 
(USER:ADD-HELP-FUNCTION (LIST "special forms")
		   (LIST "EVAL WHEN")
		   'EVAL-WHEN)
(USER:ADD-HELP-FUNCTION (LIST "special forms" "binding")
		   (LIST "FLET")
		   'FLET)
(USER:ADD-HELP-FUNCTION (LIST "special forms")
		   (LIST "FUNCTION")
		   'FUNCTION)
(USER:ADD-HELP-FUNCTION (LIST "special forms" "sequencing")
		   (LIST "GO")
		   'GO)
(SI:SET-DOCUMENTATION 'GO 'FUNCTION
 (STRING-APPEND (SI:DOCUMENTATION 'GO 'FUNCTION) "  
 As a matter of style, it is recommended that the user think twice before using
 a GO.  Most purposes of GO can be accomplished with one of the iteration primitives,
 nested conditional forms, or RETURN-FROM."))

(USER:ADD-HELP-FUNCTION (LIST "special forms" "conditionals")
		   (LIST "IF")
		   'IF)
(SI:SET-DOCUMENTATION 'IF 'FUNCTION
 (STRING-APPEND (SI:DOCUMENTATION 'IF 'FUNCTION) "  
 The ELSE form may be omitted, in which case if the value of the TEST is NIL
 then nothing is done and the value of the IF form is NIL.  If the value of
 the IF form is important in this situation, then the AND construct may be
 stylistically perferable, depending on the context.  If the value is not
 important, but only the effect, then the WHEN construct may be stylistically
 perferable."))

(USER:ADD-HELP-FUNCTION (LIST "special forms" "binding")
		   (LIST "LABELS")
		   'LABELS)
(USER:ADD-HELP-FUNCTION (LIST "special forms" "binding")
		   (LIST "LET")
		   'LET)
(USER:ADD-HELP-FUNCTION (LIST "BIND")
		   (LIST "VARIABLES IN PARALLEL")
		   'LET)
(USER:ADD-HELP-FUNCTION (LIST "BIND")
		   (LIST "VARIABLES CONDITIONALLY")
		   'LET-IF)
(USER:ADD-HELP-FUNCTION (LIST "BIND")
		   (LIST "VARIABLES GLOBALLY")
		   'LET-GLOBALLY)
(USER:ADD-HELP-FUNCTION (LIST "BIND")
		   (LIST "VARIABLES GLOBALLY ON CONDITION")
		   'LET-GLOBALLY-IF)
(USER:ADD-HELP-FUNCTION (LIST "special forms" "binding")
		   (LIST "LET*")
		   'LET*)
(USER:ADD-HELP-FUNCTION (LIST "BIND")
		   (LIST "VARIABLES SEQUENTIALLY")
		   'LET*)
(USER:ADD-HELP-FUNCTION (LIST "special forms" "binding")
		   (LIST "MACROLET")
		   'MACROLET)
(USER:ADD-HELP-FUNCTION (LIST "special forms" "multiple values")
		   (LIST "MULTIPLE VALUE CALL")
		   'MULTIPLE-VALUE-CALL)
(USER:ADD-HELP-FUNCTION (LIST "special forms" "multiple values")
		   (LIST "MULTIPLE VALUE PROG1")
		   'MULTIPLE-VALUE-PROG1)
(USER:ADD-HELP-FUNCTION (LIST "special forms" "sequencing")
		   (LIST "PROGN")
		   'PROGN)
(USER:ADD-HELP-FUNCTION (LIST "special forms" "sequencing" "binding")
		   (LIST "PROGV")
		   'PROGV)
(USER:ADD-HELP-FUNCTION (LIST "BIND")
		   (LIST "SYMBOLS TO VALUES AND EVALUATE BODY")
		   'PROGV)
(USER:ADD-HELP-FUNCTION (LIST "BIND")
		   (LIST "SYMBOL/VALUE PAIRS AND EVALUATE BODY")
		   'PROGW)
(USER:ADD-HELP-FUNCTION (LIST "special forms")
		   (LIST "QUOTE")
		   'QUOTE)
(USER:ADD-HELP-FUNCTION (LIST "special forms" "sequencing")
		   (LIST "RETURN FROM")
		   'RETURN-FROM)
(USER:ADD-HELP-FUNCTION (LIST "special forms" "assignment")
		   (LIST "SETQ")
		   'SETQ)
(USER:ADD-HELP-FUNCTION (LIST "special forms" "sequencing")
		   (LIST "TAGBODY")
		   'TAGBODY)
(USER:ADD-HELP-FUNCTION (LIST "special forms" "declarations")
		   (LIST "THE")
		   'THE)
(USER:ADD-HELP-FUNCTION (LIST "special forms" "non-local exits" "sequencing")
		   (LIST "THROW")
		   'THROW)
(USER:ADD-HELP-FUNCTION (LIST "special forms" "non-local exits" "sequencing")
		   (LIST "UNWIND PROTECT")
		   'UNWIND-PROTECT)

(USER:ADD-HELP-FUNCTION (LIST "sequencing")
		   (LIST "PROG1")
		   'PROG1)
(USER:ADD-HELP-FUNCTION (LIST "sequencing")
		   (LIST "PROG2")
		   'PROG2)
(USER:ADD-HELP-FUNCTION (LIST "sequencing" "binding" )
		   (LIST "PROG")
		   'PROG)
(USER:ADD-HELP-FUNCTION (LIST "sequencing" "binding" )
		   (LIST "PROG*")
		   'PROG*)
(USER:ADD-HELP-FUNCTION (LIST "sequencing")
		   (LIST "RETURN")
		   'RETURN)

(USER:ADD-HELP-FUNCTION (LIST "conditionals")
		   (LIST "WHEN")
		   'WHEN)
(SI:SET-DOCUMENTATION 'WHEN 'FUNCTION
 (STRING-APPEND (SI:DOCUMENTATION 'WHEN 'FUNCTION) "  
 As a matter of style, WHEN is normally used to conditionally produce some side
 effects, and the value of the WHEN-form is normally not used.  If the value is
 relevant, then it may be stylistically more appropriate to use AND or IF."))

(USER:ADD-HELP-FUNCTION (LIST "conditionals")
		   (LIST "UNLESS")
		   'UNLESS)
(SI:SET-DOCUMENTATION 'UNLESS 'FUNCTION
 (STRING-APPEND (SI:DOCUMENTATION 'UNLESS 'FUNCTION) "  
 As a matter of style, UNLESS is normally used to conditionally produce some side
 effects, and the value of the UNLESS-form is normally not used.  If the value is
 relevant, then it may be stylistically more appropriate to use AND or IF."))

(USER:ADD-HELP-FUNCTION (LIST "conditionals")
		   (LIST "COND")
		   'COND)
(SI:SET-DOCUMENTATION 'COND 'FUNCTION
 (STRING-APPEND (SI:DOCUMENTATION 'COND 'FUNCTION) "  
 As a matter of style, it is desirable to write the last clause (t nil) if the value
 of the COND form is to be used for something.  Similarly, it is in questionable
 taste to let the last clause of a cond be a singleton clause; an explicit t should
 be provided."))

(USER:ADD-HELP-FUNCTION (LIST "conditionals")
		   (LIST "CASE")
		   'CASE)

(USER:ADD-HELP-FUNCTION (LIST "conditionals")
		   (LIST "TYPECASE")
		   'TYPECASE)

(USER:ADD-HELP-FUNCTION (LIST "predicates")
		   (LIST "TYPEP")
		   'TYPEP)
(USER:ADD-HELP-FUNCTION (LIST "predicates")
		   (LIST "SUBTYPEP")
		   'SUBTYPEP)
(USER:ADD-HELP-FUNCTION (LIST "predicates")
		   (LIST "NULL")
		   'NULL)
(USER:ADD-HELP-FUNCTION (LIST "predicates")
		   (LIST "SYMBOLP")
		   'SYMBOLP)
(USER:ADD-HELP-FUNCTION (LIST "TEST IF")
		   (LIST "SYMBOL")
		   'SYMBOLP)
(USER:ADD-HELP-FUNCTION (LIST "TEST IF")
		   (LIST " NOT SYMBOL")
		   'NSYMBOLP)
(USER:ADD-HELP-FUNCTION (LIST "predicates")
		   (LIST "ATOM")
		   'ATOM)
(USER:ADD-HELP-FUNCTION (LIST "predicates")
		   (LIST "CONSP")
		   'CONSP)
(USER:ADD-HELP-FUNCTION (LIST "predicates")
		   (LIST "LISTP")
		   'LISTP)
(USER:ADD-HELP-FUNCTION (LIST "predicates")
		   (LIST "NUMBERP")
		   'NUMBERP)
(USER:ADD-HELP-FUNCTION (LIST "predicates")
		   (LIST "INTEGERP")
		   'INTEGERP)
(USER:ADD-HELP-FUNCTION (LIST "predicates")
		   (LIST "RATIONALP")
		   'RATIONALP)
(USER:ADD-HELP-FUNCTION (LIST "predicates")
		   (LIST "FLOATP")
		   'FLOATP)
(USER:ADD-HELP-FUNCTION (LIST "predicates")
		   (LIST "COMPLEXP")
		   'COMPLEXP)
(USER:ADD-HELP-FUNCTION (LIST "predicates" "characters")
		   (LIST "CHARACTERP")
		   'CHARACTERP)
(USER:ADD-HELP-FUNCTION (LIST "predicates")
		   (LIST "STRINGP")
		   'STRINGP)
(USER:ADD-HELP-FUNCTION (LIST "predicates")
		   (LIST "BIT VECTOR")
		   'BIT-VECTOR-P)
(USER:ADD-HELP-FUNCTION (LIST "predicates")
		   (LIST "VECTORP")
		   'VECTORP)
(USER:ADD-HELP-FUNCTION (LIST "predicates")
		   (LIST "SIMPLE VECTOR")
		   'SIMPLE-VECTOR-P)
(USER:ADD-HELP-FUNCTION (LIST "predicates")
		   (LIST "SIMPLE STRING")
		   'SIMPLE-STRING-P)
(USER:ADD-HELP-FUNCTION (LIST "predicates")
		   (LIST "SIMPLE BIT VECTOR")
		   'SIMPLE-BIT-VECTOR-P)
(USER:ADD-HELP-FUNCTION (LIST "predicates")
		   (LIST "ARRAYP")
		   'ARRAYP)
(USER:ADD-HELP-FUNCTION (LIST "predicates")
		   (LIST "PACKAGEP")
		   'PACKAGEP)
(USER:ADD-HELP-FUNCTION (LIST "predicates")
		   (LIST "FUNCTIONP")
		   'FUNCTIONP)
(USER:ADD-HELP-FUNCTION (LIST "predicates")
		   (LIST "COMPILED FUNCTION")
		   'COMPILED-FUNCTION-P)
(USER:ADD-HELP-FUNCTION (LIST "predicates")
		   (LIST "COMMONP")
		   'COMMONP)
(USER:ADD-HELP-FUNCTION (LIST "predicates" "equality")
		   (LIST "EQ")
		   'EQ)
(USER:ADD-HELP-FUNCTION (LIST "predicates" "equality")
		   (LIST "EQL")
		   'EQL)
(USER:ADD-HELP-FUNCTION (LIST "predicates" "equality")
		   (LIST "EQUAL")
		   'EQUAL)
(USER:ADD-HELP-FUNCTION (LIST "predicates" "equality")
		   (LIST "EQUALP")
		   'EQUALP)
(USER:ADD-HELP-FUNCTION (LIST "predicates")
		   (LIST "NOT")
		   'NOT)
(USER:ADD-HELP-FUNCTION (LIST "predicates")
		   (LIST "AND")
		   'AND)
(USER:ADD-HELP-FUNCTION (LIST "predicates")
		   (LIST "OR")
		   'OR)

(USER:ADD-HELP-FUNCTION (LIST "iteration")
		   (LIST "DO")
		   'DO)
(USER:ADD-HELP-FUNCTION (LIST "iteration")
		   (LIST "DO*")
		   'DO*)
(USER:ADD-HELP-FUNCTION (LIST "iteration")
		   (LIST "DOLIST")
		   'DOLIST)
(USER:ADD-HELP-FUNCTION (LIST "iteration")
		   (LIST "DOTIMES")
		   'DOTIMES)
(USER:ADD-HELP-FUNCTION (LIST "iteration")
		   (LIST "LOOP")
		   'LOOP)
(USER:ADD-HELP-FUNCTION (LIST "iteration" "mapping" "lists")
		   (LIST "MAPCAR")
		   'MAPCAR)
(USER:ADD-HELP-FUNCTION (LIST "iteration" "mapping" "lists")
		   (LIST "MAPLIST")
		   'MAPLIST)
(USER:ADD-HELP-FUNCTION (LIST "iteration" "mapping" "lists")
		   (LIST "MAPC")
		   'MAPC)
(USER:ADD-HELP-FUNCTION (LIST "iteration" "mapping" "lists")
		   (LIST "MAPL")
		   'MAPL)
(USER:ADD-HELP-FUNCTION (LIST "iteration" "mapping" "lists")
		   (LIST "MAPCAN")
		   'MAPCAN)
(USER:ADD-HELP-FUNCTION (LIST "iteration" "mapping" "lists")
		   (LIST "MAPCON")
		   'MAPCON)

(USER:ADD-HELP-FUNCTION (LIST "multiple values")
		   (LIST "VALUES")
		   'VALUES)
(USER:ADD-HELP-FUNCTION (LIST "multiple values")
		   (LIST "VALUES LIST")
		   'VALUES-LIST)
(USER:ADD-HELP-FUNCTION (LIST "multiple values")
		   (LIST "MULTIPLE VALUE LIST")
		   'MULTIPLE-VALUE-LIST)
(USER:ADD-HELP-FUNCTION (LIST "multiple values")
		   (LIST "MULTIPLE VALUES BIND")
		   'MULTIPLE-VALUE-BIND)
(USER:ADD-HELP-FUNCTION (LIST "multiple values")
		   (LIST "MULTIPLE VALUES SETQ")
		   'MULTIPLE-VALUE-SETQ)

(USER:ADD-HELP-FUNCTION (LIST "macros")
		   (LIST "MACRO FUNCTION")
		   'MACRO-FUNCTION)
(USER:ADD-HELP-FUNCTION (LIST "macros")
		   (LIST "DEFMACRO")
		   'DEFMACRO)
(USER:ADD-HELP-FUNCTION (LIST "macros")
		   (LIST "MACRO EXPAND")
		   'MACROEXPAND)
(USER:ADD-HELP-FUNCTION (LIST "macros")
		   (LIST "MACRO EXPAND ONCE")
		   'MACROEXPAND-1)

(USER:ADD-HELP-FUNCTION (LIST "declarations")
		   (LIST "LOCALLY")
		   'LOCALLY)
(USER:ADD-HELP-FUNCTION (LIST "declarations")
		   (LIST "PROCLAIM")
		   'PROCLAIM)

(USER:ADD-HELP-FUNCTION (LIST "symbols")
		   (LIST "GET PROPERTY FROM SYMBOL")
		   'GET)
(USER:ADD-HELP-FUNCTION (LIST "GET")
		   (LIST "PROPERTY FROM SYMBOL")
		   'GET)
(USER:ADD-HELP-FUNCTION (LIST "GET")
		   (LIST "PROPERTIES FROM SYMBOL")
		   'GETL)
(USER:ADD-HELP-FUNCTION (LIST "symbols")
		   (LIST "GET PROPERTY FROM LIST")
		   'GETF)
(USER:ADD-HELP-FUNCTION (LIST "symbols")
		   (LIST "GET PROPERTIES")
		   'GET-PROPERTIES)
(USER:ADD-HELP-FUNCTION (LIST "symbols")
		   (LIST "REMOVE FROM LIST")
		   'REMF)
(USER:ADD-HELP-FUNCTION (LIST "symbols")
		   (LIST "REMOVE PROPERTY")
		   'REMPROP)
(USER:ADD-HELP-FUNCTION (LIST "REMOVE" "DELETE")
		   (LIST "PROPERTY FROM SYMBOL")
		   'REMPROP)
(USER:ADD-HELP-FUNCTION (LIST "symbols")
		   (LIST "LIST PROPERTIES")
		   'SYMBOL-PLIST)
(USER:ADD-HELP-FUNCTION (LIST "GET")
		   (LIST "SYMBOL'S PROPERTY LIST")
		   'SYMBOL-PLIST)
(USER:ADD-HELP-FUNCTION (LIST "symbols")
		   (LIST "PRINT NAME")
		   'SYMBOL-NAME)
(USER:ADD-HELP-FUNCTION (LIST "GET")
		   (LIST "SYMBOL PRINT NAME")
		   'SYMBOL-NAME)
(USER:ADD-HELP-FUNCTION (LIST "symbols")
		   (LIST "MAKE SYMBOL")
		   'MAKE-SYMBOL)
(USER:ADD-HELP-FUNCTION (LIST "symbols")
		   (LIST "COPY SYMBOL")
		   'COPY-SYMBOL)
(USER:ADD-HELP-FUNCTION (LIST "symbols")
		   (LIST "GEN UNINTERNED SYMBOL")
		   'GENSYM)
(USER:ADD-HELP-FUNCTION (LIST "symbols")
		   (LIST "GEN INTERNED SYMBOL")
		   'GENTEMP)

(USER:ADD-HELP-FUNCTION (LIST "MAKE" "CREATE")
		   (LIST "SYMBOL")
		   'MAKE-SYMBOL)
(USER:ADD-HELP-FUNCTION (LIST "COPY")
		   (LIST "SYMBOL")
		   'COPY-SYMBOL)
(USER:ADD-HELP-FUNCTION (LIST "MAKE" "CREATE" "GENERATE")
		   (LIST "UNINTERNED SYMBOL")
		   'GENSYM)
(USER:ADD-HELP-FUNCTION (LIST "MAKE" "CREATE" "GENERATE")
		   (LIST "INTERNED SYMBOL")
		   'GENTEMP)

(USER:ADD-HELP-FUNCTION (LIST "symbols")
		   (LIST "FIND PACKAGE")
		   'SYMBOL-PACKAGE)
(USER:ADD-HELP-FUNCTION (LIST "GET")
		   (LIST "SYMBOL'S PACKAGE")
		   'SYMBOL-PACKAGE)
(USER:ADD-HELP-FUNCTION (LIST "symbols" "predicates")
		   (LIST "KEYWORDP")
		   'KEYWORDP)
(USER:ADD-HELP-FUNCTION (LIST "TEST IF")
		   (LIST "KEYWORD")
		   'KEYWORDP)

(USER:ADD-HELP-FUNCTION (LIST "numbers" "predicates")
		   (LIST "ZEROP")
		   'ZEROP)
(USER:ADD-HELP-FUNCTION (LIST "numbers" "predicates")
		   (LIST "PLUSP")
		   'PLUSP)
(USER:ADD-HELP-FUNCTION (LIST "numbers" "predicates")
		   (LIST "MINUSP")
		   'MINUSP)
(USER:ADD-HELP-FUNCTION (LIST "numbers" "predicates")
		   (LIST "ODDP")
		   'ODDP)
(USER:ADD-HELP-FUNCTION (LIST "numbers" "predicates")
		   (LIST "EVENP")
		   'EVENP)
(USER:ADD-HELP-FUNCTION (LIST "numbers" "number comparisons")
		   (LIST "=")
		   '=)
(USER:ADD-HELP-FUNCTION (LIST "numbers" "number comparisons")
		   (LIST "/=")
		   '/=)
(USER:ADD-HELP-FUNCTION (LIST "numbers" "number comparisons")
		   (LIST "<")
		   '<)
(USER:ADD-HELP-FUNCTION (LIST "numbers" "number comparisons")
		   (LIST ">")
		   '>)
(USER:ADD-HELP-FUNCTION (LIST "numbers" "number comparisons")
		   (LIST "<=")
		   '<=)
(USER:ADD-HELP-FUNCTION (LIST "numbers" "number comparisons")
		   (LIST ">=")
		   '>=)
(USER:ADD-HELP-FUNCTION (LIST "numbers" "number comparisons")
		   (LIST "MAX")
		   'MAX)
(USER:ADD-HELP-FUNCTION (LIST "numbers" "number comparisons")
		   (LIST "MIN")
		   'MIN)
(USER:ADD-HELP-FUNCTION (LIST "numbers" "aritmetic operations")
		   (LIST "+")
		   '+)
(USER:ADD-HELP-FUNCTION (LIST "numbers" "aritmetic operations")
		   (LIST "-")
		   '-)
(USER:ADD-HELP-FUNCTION (LIST "numbers" "aritmetic operations")
		   (LIST "*")
		   '*)
(USER:ADD-HELP-FUNCTION (LIST "numbers" "aritmetic operations")
		   (LIST "/")
		   '/)
(USER:ADD-HELP-FUNCTION (LIST "numbers" "aritmetic operations")
		   (LIST "1+")
		   '1+)
(USER:ADD-HELP-FUNCTION (LIST "numbers" "aritmetic operations")
		   (LIST "1-")
		   '1-)
(USER:ADD-HELP-FUNCTION (LIST "numbers" "aritmetic operations")
		   (LIST "INCF")
		   'INCF)
(USER:ADD-HELP-FUNCTION (LIST "numbers" "aritmetic operations")
		   (LIST "DECF")
		   'DECF)
(USER:ADD-HELP-FUNCTION (LIST "numbers" "aritmetic operations")
		   (LIST "CONJUGATE")
		   'CONJUGATE)
(USER:ADD-HELP-FUNCTION (LIST "numbers" "aritmetic operations")
		   (LIST "GREATEST COMMON DIVISOR")
		   'GCD)
(USER:ADD-HELP-FUNCTION (LIST "numbers" "aritmetic operations")
		   (LIST "LEAST COMMON MULTIPLE")
		   'LCM)
(USER:ADD-HELP-FUNCTION (LIST "numbers" "exponential operations")
		   (LIST "E EXPONENTIAL")
		   'EXP)
(USER:ADD-HELP-FUNCTION (LIST "numbers" "exponential operations")
		   (LIST "EXPONENTIAL")
		   'EXPT)
(USER:ADD-HELP-FUNCTION (LIST "numbers" "exponential operations")
		   (LIST "LOGARITHM")
		   'LOG)
(USER:ADD-HELP-FUNCTION (LIST "numbers" "exponential operations")
		   (LIST "SQUARE ROOT")
		   'SQRT)
(USER:ADD-HELP-FUNCTION (LIST "numbers" "exponential operations")
		   (LIST "INTEGER SQUARE ROOT")
		   'ISQRT)
(USER:ADD-HELP-FUNCTION (LIST "numbers" "trigonometric operations")
		   (LIST "ABSOLUTE NUMBER")
		   'ABS)
(USER:ADD-HELP-FUNCTION (LIST "numbers" "trigonometric operations")
		   (LIST "PHASE")
		   'PHASE)
(USER:ADD-HELP-FUNCTION (LIST "numbers" "trigonometric operations")
		   (LIST "SIGN OF NUMBER")
		   'SIGNUM)
(USER:ADD-HELP-FUNCTION (LIST "numbers" "trigonometric operations")
		   (LIST "SIN")
		   'SIN)
(USER:ADD-HELP-FUNCTION (LIST "numbers" "trigonometric operations")
		   (LIST "COS")
		   'COS)
(USER:ADD-HELP-FUNCTION (LIST "numbers" "trigonometric operations")
		   (LIST "TAN")
		   'TAN)
(USER:ADD-HELP-FUNCTION (LIST "numbers" "trigonometric operations")
		   (LIST "CIS")
		   'CIS)
(USER:ADD-HELP-FUNCTION (LIST "numbers" "trigonometric operations")
		   (LIST "ASIN")
		   'ASIN)
(USER:ADD-HELP-FUNCTION (LIST "numbers" "trigonometric operations")
		   (LIST "ACOS")
		   'ACOS)
(USER:ADD-HELP-FUNCTION (LIST "numbers" "trigonometric operations")
		   (LIST "ATAN")
		   'ATAN)
(USER:ADD-HELP-FUNCTION (LIST "numbers" "trigonometric operations")
		   (LIST "SINH")
		   'SINH)
(USER:ADD-HELP-FUNCTION (LIST "numbers" "trigonometric operations")
		   (LIST "COSH")
		   'COSH)
(USER:ADD-HELP-FUNCTION (LIST "numbers" "trigonometric operations")
		   (LIST "TANH")
		   'TANH)
(USER:ADD-HELP-FUNCTION (LIST "numbers" "trigonometric operations")
		   (LIST "ASINH")
		   'ASINH)
(USER:ADD-HELP-FUNCTION (LIST "numbers" "trigonometric operations")
		   (LIST "ACOSH")
		   'ACOSH)
(USER:ADD-HELP-FUNCTION (LIST "numbers" "trigonometric operations")
		   (LIST "ATANH")
		   'ATANH)
(USER:ADD-HELP-FUNCTION (LIST "numbers" "number type conversion")
		   (LIST "FLOAT")
		   'FLOAT)
(USER:ADD-HELP-FUNCTION (LIST "numbers" "number type conversion")
		   (LIST "RATIONAL")
		   'RATIONAL)
(USER:ADD-HELP-FUNCTION (LIST "numbers" "number type conversion")
		   (LIST "RATIONALIZE")
		   'RATIONALIZE)
(USER:ADD-HELP-FUNCTION (LIST "numbers" "number component extraction")
		   (LIST "NUMERATOR")
		   'NUMERATOR)
(USER:ADD-HELP-FUNCTION (LIST "numbers" "number component extraction")
		   (LIST "DENOMINATOR")
		   'DENOMINATOR)
(USER:ADD-HELP-FUNCTION (LIST "numbers" "number component extraction")
		   (LIST "FLOOR")
		   'FLOOR)
(USER:ADD-HELP-FUNCTION (LIST "numbers" "number component extraction")
		   (LIST "CEILING")
		   'CEILING)
(USER:ADD-HELP-FUNCTION (LIST "numbers" "number component extraction")
		   (LIST "TRUNCATE")
		   'TRUNCATE)
(USER:ADD-HELP-FUNCTION (LIST "numbers" "number component extraction")
		   (LIST "ROUND")
		   'ROUND)
(USER:ADD-HELP-FUNCTION (LIST "numbers" "number component extraction")
		   (LIST "MODULAR")
		   'MOD)
(USER:ADD-HELP-FUNCTION (LIST "numbers" "number component extraction")
		   (LIST "REMAINDER")
		   'REM)
(USER:ADD-HELP-FUNCTION (LIST "numbers" "number component extraction")
		   (LIST "FLOATING-POINT FLOOR")
		   'FFLOOR)
(USER:ADD-HELP-FUNCTION (LIST "numbers" "number component extraction")
		   (LIST "FLOATING POINT CEILING")
		   'FCEILING)
(USER:ADD-HELP-FUNCTION (LIST "numbers" "number component extraction")
		   (LIST "FLOATING POINT TRUNCATE")
		   'FTRUNCATE)
(USER:ADD-HELP-FUNCTION (LIST "numbers" "number component extraction")
		   (LIST "FLOATING POINT ROUND")
		   'FROUND)
(USER:ADD-HELP-FUNCTION (LIST "numbers" "number component extraction")
		   (LIST "DECODE FLOAT")
		   'DECODE-FLOAT)
(USER:ADD-HELP-FUNCTION (LIST "numbers" "number component extraction")
		   (LIST "SCALE FLOAT")
		   'SCALE-FLOAT)
(USER:ADD-HELP-FUNCTION (LIST "numbers" "number component extraction")
		   (LIST "FLOAT RADIX")
		   'FLOAT-RADIX)
(USER:ADD-HELP-FUNCTION (LIST "numbers" "number component extraction")
		   (LIST "FLOAT SIGN")
		   'FLOAT-SIGN)
(USER:ADD-HELP-FUNCTION (LIST "numbers" "number component extraction")
		   (LIST "FLOAT DIGITS")
		   'FLOAT-DIGITS)
(USER:ADD-HELP-FUNCTION (LIST "numbers" "number component extraction")
		   (LIST "FLOAT PRECISION")
		   'FLOAT-PRECISION)
(USER:ADD-HELP-FUNCTION (LIST "numbers" "number component extraction")
		   (LIST "INTEGER DECODE FLOAT")
		   'INTEGER-DECODE-FLOAT)
(USER:ADD-HELP-FUNCTION (LIST "numbers" "number component extraction")
		   (LIST "COMPLEX")
		   'COMPLEX)
(USER:ADD-HELP-FUNCTION (LIST "numbers" "number component extraction")
		   (LIST "REAL PART")
		   'REALPART)
(USER:ADD-HELP-FUNCTION (LIST "numbers" "number component extraction")
		   (LIST "IMAGINARY PART")
		   'IMAGPART)
(USER:ADD-HELP-FUNCTION (LIST "numbers" "number logical operations")
		   (LIST "LOGICAL INCLUSIVE OR")
		   'LOGIOR)
(USER:ADD-HELP-FUNCTION (LIST "numbers" "number logical operations")
		   (LIST "LOGICAL EXCLUSIVE OR")
		   'LOGXOR)
(USER:ADD-HELP-FUNCTION (LIST "numbers" "number logical operations")
		   (LIST "LOGICAL AND")
		   'LOGAND)
(USER:ADD-HELP-FUNCTION (LIST "numbers" "number logical operations")
		   (LIST "LOGICAL EQUIVALENCE" "LOGICAL EXCLUSIVE NOR")
		   'LOGEQV)
(USER:ADD-HELP-FUNCTION (LIST "numbers" "number logical operations")
		   (LIST "LOGICAL NOT AND")
		   'LOGNAND)
(USER:ADD-HELP-FUNCTION (LIST "numbers" "number logical operations")
		   (LIST "LOGICAL NOT OR")
		   'LOGNOR)
(USER:ADD-HELP-FUNCTION (LIST "numbers" "number logical operations")
		   (LIST "AND COMPLIMENT ARG1")
		   'LOGANDC1)
(USER:ADD-HELP-FUNCTION (LIST "numbers" "number logical operations")
		   (LIST "AND COMPLIMENT ARG2")
		   'LOGANDC2)
(USER:ADD-HELP-FUNCTION (LIST "numbers" "number logical operations")
		   (LIST "OR COMPLIMENT ARG1")
		   'LOGORC1)
(USER:ADD-HELP-FUNCTION (LIST "numbers" "number logical operations")
		   (LIST "OR COMPLIMENT ARG2")
		   'LOGORC2)
(USER:ADD-HELP-FUNCTION (LIST "numbers" "number logical operations")
		   (LIST "BOOLE")
		   'BOOLE)
(USER:ADD-HELP-FUNCTION (LIST "numbers" "number logical operations")
		   (LIST "LOGICAL NOT")
		   'LOGNOT)
(USER:ADD-HELP-FUNCTION (LIST "numbers" "number logical operations" "predicates")
		   (LIST "LOGICAL INTEGER TEST")
		   'LOGTEST)
(USER:ADD-HELP-FUNCTION (LIST "numbers" "number logical operations" "predicates")
		   (LIST "LOGICAL BIT TEST")
		   'LOGBITP)
(USER:ADD-HELP-FUNCTION (LIST "numbers" "number logical operations")
		   (LIST "SHIFT INTEGER")
		   'ASH)
(USER:ADD-HELP-FUNCTION (LIST "numbers" "number logical operations")
		   (LIST "COUNT ON/OFF BITS")
		   'LOGCOUNT)
(USER:ADD-HELP-FUNCTION (LIST "numbers" "number logical operations")
		   (LIST "INTEGER LENGTH")
		   'INTEGER-LENGTH)
(USER:ADD-HELP-FUNCTION (LIST "numbers" "number byte manipulation")
		   (LIST "BYTE SPECIFIER")
		   'BYTE)
(USER:ADD-HELP-FUNCTION (LIST "numbers" "number byte manipulation")
		   (LIST "BYTE SIZE")
		   'BYTE-SIZE)
(USER:ADD-HELP-FUNCTION (LIST "numbers" "number byte manipulation")
		   (LIST "BYTE POSITION")
		   'BYTE-POSITION)
(USER:ADD-HELP-FUNCTION (LIST "numbers" "number byte manipulation")
		   (LIST "EXTRACT BYTE")
		   'LDB)
(USER:ADD-HELP-FUNCTION (LIST "numbers" "number byte manipulation" "predicates")
		   (LIST "BITS OF BYTE TEST")
		   'LDB-TEST)
(USER:ADD-HELP-FUNCTION (LIST "numbers" "number byte manipulation")
		   (LIST "BYTE MASK")
		   'MASK-FIELD)
(USER:ADD-HELP-FUNCTION (LIST "numbers" "number byte manipulation")
		   (LIST "DEPOSIT BYTE")
		   'DPB)
(USER:ADD-HELP-FUNCTION (LIST "numbers" "number byte manipulation")
		   (LIST "DEPOSIT BYTE (MASK)")
		   'DEPOSIT-FIELD)
(USER:ADD-HELP-FUNCTION (LIST "numbers" "random numbers")
		   (LIST "MAKE RANDOM STATE")
		   'MAKE-RANDOM-STATE)
(USER:ADD-HELP-FUNCTION (LIST "numbers" "random numbers" "predicates")
		   (LIST "CHECK RANDOM STATE")
		   'RANDOM-STATE-P)
(USER:ADD-HELP-FUNCTION (LIST "characters" "predicates")
		   (LIST "STANDARD CHARACTER")
		   'STANDARD-CHAR-P)
(USER:ADD-HELP-FUNCTION (LIST "characters" "predicates")
		   (LIST "GRAPHIC CHARACTER")
		   'GRAPHIC-CHAR-P)
(USER:ADD-HELP-FUNCTION (LIST "characters" "predicates")
		   (LIST "STRING CHARACTER")
		   'STRING-CHAR-P)
(USER:ADD-HELP-FUNCTION (LIST "characters" "predicates")
		   (LIST "ALPHABETIC CHARACTER")
		   'ALPHA-CHAR-P)
(USER:ADD-HELP-FUNCTION (LIST "characters" "predicates")
		   (LIST "UPPER CASE")
		   'UPPER-CASE-P)
(USER:ADD-HELP-FUNCTION (LIST "characters" "predicates")
		   (LIST "LOWER CASE")
		   'LOWER-CASE-P)
(USER:ADD-HELP-FUNCTION (LIST "characters" "predicates")
		   (LIST "BOTH CASE")
		   'BOTH-CASE-P)
(USER:ADD-HELP-FUNCTION (LIST "characters" "predicates")
		   (LIST "DIGIT CHARACTER")
		   'DIGIT-CHAR-P)
(USER:ADD-HELP-FUNCTION (LIST "characters" "predicates")
		   (LIST "ALPHABETIC OR NUMBERIC")
		   'ALPHANUMBERICP)
(USER:ADD-HELP-FUNCTION (LIST "characters" "predicates")
		   (LIST "CHARACTERS =")
		   'CHAR=)
(USER:ADD-HELP-FUNCTION (LIST "characters" "predicates")
		   (LIST "CHARACTERS NOT =")
		   'CHAR/=)
(USER:ADD-HELP-FUNCTION (LIST "characters" "predicates")
		   (LIST "CHARACTERS <")
		   'CHAR<)
(USER:ADD-HELP-FUNCTION (LIST "characters" "predicates")
		   (LIST "CHARACTERS >")
		   'CHAR>)
(USER:ADD-HELP-FUNCTION (LIST "characters" "predicates")
		   (LIST "CHARACTERS < OR =")
		   'CHAR<=)
(USER:ADD-HELP-FUNCTION (LIST "characters" "predicates")
		   (LIST "CHARACTERS > OR =")
		   'CHAR>=)
(USER:ADD-HELP-FUNCTION (LIST "characters" "predicates")
		   (LIST "CHARACTERS EQUAL")
		   'CHAR-EQUAL)
(USER:ADD-HELP-FUNCTION (LIST "characters" "predicates")
		   (LIST "CHARACTERS NOT EQUAL")
		   'CHAR-NOT-EQUAL)
(USER:ADD-HELP-FUNCTION (LIST "characters" "predicates")
		   (LIST "CHARACTERS LESS")
		   'CHAR-LESSP)
(USER:ADD-HELP-FUNCTION (LIST "characters" "predicates")
		   (LIST "CHARACTERS GREATER")
		   'CHAR-GREATERP)
(USER:ADD-HELP-FUNCTION (LIST "characters" "predicates")
		   (LIST "CHARACTERS NOT GREATER")
		   'CHAR-NOT-GREATERP)
(USER:ADD-HELP-FUNCTION (LIST "characters" "predicates")
		   (LIST "CHARACTERS NOT LESS")
		   'CHAR-NOT-LESSP)
(USER:ADD-HELP-FUNCTION (LIST "characters" "predicates")
		   (LIST "CHARACTERS NOT =")
		   'CHAR/=)
(USER:ADD-HELP-FUNCTION (LIST "characters" "predicates")
		   (LIST "CHARACTERS <")
		   'CHAR<)
(USER:ADD-HELP-FUNCTION (LIST "characters" "predicates")
		   (LIST "CHARACTERS >")
		   'CHAR>)
(USER:ADD-HELP-FUNCTION (LIST "characters" "predicates")
		   (LIST "CHARACTERS < OR =")
		   'CHAR<=)
(USER:ADD-HELP-FUNCTION (LIST "characters" "character constuction")
		   (LIST "CODE ATTRIBUTE")
		   'CHAR-CODE)
(USER:ADD-HELP-FUNCTION (LIST "characters" "character constuction")
		   (LIST "BITS ATTRIBUTE")
		   'CHAR-BITS)
(USER:ADD-HELP-FUNCTION (LIST "characters" "character constuction")
		   (LIST "FONT ATTRIBUTE")
		   'CHAR-FONT)
(USER:ADD-HELP-FUNCTION (LIST "characters" "character constuction")
		   (LIST "MAKE CHARACTER FROM CODE")
		   'CODE-CHAR)
(USER:ADD-HELP-FUNCTION (LIST "characters" "character constuction")
		   (LIST "MAKE CHARACTER FROM CHAR")
		   'MAKE-CHAR)
(USER:ADD-HELP-FUNCTION (LIST "characters" "character conversions")
		   (LIST "COERCE OBJECT TO CHAR")
		   'CHARACTER)
(USER:ADD-HELP-FUNCTION (LIST "characters" "character conversions")
		   (LIST "MAKE UPPER CASE")
		   'CHAR-UPCASE)
(USER:ADD-HELP-FUNCTION (LIST "characters" "character conversions")
		   (LIST "MAKE LOWER CASE")
		   'CHAR-DOWNCASE)
(USER:ADD-HELP-FUNCTION (LIST "characters" "character conversions")
		   (LIST "CONVERT A DIGIT")
		   'DIGIT-CHAR)
(USER:ADD-HELP-FUNCTION (LIST "characters" "character conversions")
		   (LIST "CONVERT CHAR TO INTEGER")
		   'CHAR-INT)
(USER:ADD-HELP-FUNCTION (LIST "characters" "character conversions")
		   (LIST "CONVERT INTEGER TO CHAR")
		   'INT-CHAR)
(USER:ADD-HELP-FUNCTION (LIST "characters" "character conversions")
		   (LIST "CONVERT CHAR TO INTEGER")
		   'CHAR-INT)
(USER:ADD-HELP-FUNCTION (LIST "characters" "character conversions")
		   (LIST "CHARACTER NAME")
		   'CHAR-NAME)
(USER:ADD-HELP-FUNCTION (LIST "characters" "character conversions")
		   (LIST "FIND CHAR FROM NAME")
		   'NAME-CHAR)
(USER:ADD-HELP-FUNCTION (LIST "characters" "character control bits")
		   (LIST "GET CONTROL BIT")
		   'CHAR-BIT)
(USER:ADD-HELP-FUNCTION (LIST "characters" "character control bits")
		   (LIST "SET CONTROL BIT")
		   'SET-CHAR-BIT)
(USER:ADD-HELP-FUNCTION (LIST "sequences")
		   (LIST "FIND ELEMENT BY INDEX")
		   'ELT)
(USER:ADD-HELP-FUNCTION (LIST "sequences")
		   (LIST "SUBSEQUENCE")
		   'SUBSEQ)
(USER:ADD-HELP-FUNCTION (LIST "sequences")
		   (LIST "COPY")
		   'COPY-SEQ)
(USER:ADD-HELP-FUNCTION (LIST "sequences")
		   (LIST "LENGTH")
		   'LENGTH)
(USER:ADD-HELP-FUNCTION (LIST "sequences")
		   (LIST "REVERSE")
		   'REVERSE)
(USER:ADD-HELP-FUNCTION (LIST "sequences")
		   (LIST "DESTRUCTIVE REVERSE")
		   'NREVERSE)
(USER:ADD-HELP-FUNCTION (LIST "sequences")
		   (LIST "MAKE")
		   'MAKE-SEQUENCE)
(USER:ADD-HELP-FUNCTION (LIST "sequences")
		   (LIST "CONCATENATE")
		   'CONCATENATE)
(USER:ADD-HELP-FUNCTION (LIST "sequences")
		   (LIST "MAP")
		   'MAP)
(USER:ADD-HELP-FUNCTION (LIST "sequences" "predicates")
		   (LIST "SOME")
		   'SOME)
(USER:ADD-HELP-FUNCTION (LIST "sequences" "predicates")
		   (LIST "EVERY")
		   'EVERY)
(USER:ADD-HELP-FUNCTION (LIST "sequences" "predicates")
		   (LIST "NOT ANY")
		   'NOTANY)
(USER:ADD-HELP-FUNCTION (LIST "sequences" "predicates")
		   (LIST "NOT EVERY")
		   'NOTEVERY)
(USER:ADD-HELP-FUNCTION (LIST "sequences")
		   (LIST "REDUCE")
		   'REDUCE)
(USER:ADD-HELP-FUNCTION (LIST "sequences" "modifying sequences")
		   (LIST "REPLACE")
		   'REPLACE)
(USER:ADD-HELP-FUNCTION (LIST "sequences" "modifying sequences")
		   (LIST "REMOVE")
		   'REMOVE)
(USER:ADD-HELP-FUNCTION (LIST "sequences" "modifying sequences")
		   (LIST "REMOVE IF")
		   'REMOVE-IF)
(USER:ADD-HELP-FUNCTION (LIST "sequences" "modifying sequences")
		   (LIST "REMOVE IF NOT")
		   'REMOVE-IF-NOT)
(USER:ADD-HELP-FUNCTION (LIST "sequences" "modifying sequences")
		   (LIST "DELETE")
		   'DELETE)
(USER:ADD-HELP-FUNCTION (LIST "sequences" "modifying sequences")
		   (LIST "DELETE IF")
		   'DELETE-IF)
(USER:ADD-HELP-FUNCTION (LIST "sequences" "modifying sequences")
		   (LIST "DELETE IF NOT")
		   'DELETE-IF-NOT)
(USER:ADD-HELP-FUNCTION (LIST "sequences" "modifying sequences")
		   (LIST "REMOVE DUPLICATES")
		   'REMOVE-DUPLICATES)
(USER:ADD-HELP-FUNCTION (LIST "sequences" "modifying sequences")
		   (LIST "DELETE DUPLICATES")
		   'DELETE-DUPLICATES)
(USER:ADD-HELP-FUNCTION (LIST "sequences" "modifying sequences")
		   (LIST "SUBSTITUTE")
		   'SUBSTITUTE)
(USER:ADD-HELP-FUNCTION (LIST "sequences" "modifying sequences")
		   (LIST "SUBSTITUTE IF")
		   'SUBSTITUTE-IF)
(USER:ADD-HELP-FUNCTION (LIST "sequences" "modifying sequences")
		   (LIST "SUBSTITUTE IF NOT")
		   'SUBSTITUTE-IF-NOT)
(USER:ADD-HELP-FUNCTION (LIST "sequences" "modifying sequences")
		   (LIST "DESTRUCTIVE SUBSTITUTE")
		   'NSUBSTITUTE)
(USER:ADD-HELP-FUNCTION (LIST "sequences" "modifying sequences")
		   (LIST "DESTRUCTIVE SUBSTITUTE IF")
		   'NSUBSTITUTE-IF)
(USER:ADD-HELP-FUNCTION (LIST "sequences" "modifying sequences")
		   (LIST "DESTRUCTIVE SUBSTITUTE IF NOT")
		   'NSUBSTITUTE-IF-NOT)
(USER:ADD-HELP-FUNCTION (LIST "sequences" "modifying sequences")
		   (LIST "FILL")
		   'FILL)
(USER:ADD-HELP-FUNCTION (LIST "sequences" "searching sequences")
		   (LIST "FIND")
		   'FIND)
(USER:ADD-HELP-FUNCTION (LIST "sequences" "searching sequences")
		   (LIST "FIND IF")
		   'FIND-IF)
(USER:ADD-HELP-FUNCTION (LIST "sequences" "searching sequences")
		   (LIST "FIND IF NOT")
		   'FIND-IF-NOT)
(USER:ADD-HELP-FUNCTION (LIST "sequences" "searching sequences")
		   (LIST "POSITION")
		   'POSITION)
(USER:ADD-HELP-FUNCTION (LIST "sequences" "searching sequences")
		   (LIST "POSITION IF")
		   'POSITION-IF)
(USER:ADD-HELP-FUNCTION (LIST "sequences" "searching sequences")
		   (LIST "POSITION IF NOT")
		   'POSITION-IF-NOT)
(USER:ADD-HELP-FUNCTION (LIST "sequences" "searching sequences")
		   (LIST "COUNT")
		   'COUNT)
(USER:ADD-HELP-FUNCTION (LIST "sequences" "searching sequences")
		   (LIST "COUNT IF")
		   'COUNT-IF)
(USER:ADD-HELP-FUNCTION (LIST "sequences" "searching sequences")
		   (LIST "COUNT IF NOT")
		   'COUNT-IF-NOT)
(USER:ADD-HELP-FUNCTION (LIST "sequences" "searching sequences")
		   (LIST "MISMATCH")
		   'MISMATCH)
(USER:ADD-HELP-FUNCTION (LIST "sequences" "searching sequences")
		   (LIST "SEARCH")
		   'SEARCH)
(USER:ADD-HELP-FUNCTION (LIST "sequences")
		   (LIST "SORT")
		   'SORT)
(USER:ADD-HELP-FUNCTION (LIST "sequences")
		   (LIST "STABLE SORT")
		   'STABLE-SORT)
(USER:ADD-HELP-FUNCTION (LIST "sequences")
		   (LIST "MERGE")
		   'MERGE)

(USER:ADD-HELP-FUNCTION (LIST "lists")
		   (LIST "CAR")
		   'CAR)
(USER:ADD-HELP-FUNCTION (LIST "lists")
		   (LIST "CDR")
		   'CDR)
(USER:ADD-HELP-FUNCTION (LIST "lists")
		   (LIST "CONS")
		   'CONS)
(USER:ADD-HELP-FUNCTION (LIST "lists" "predicates")
		   (LIST "TREE-EQUAL")
		   'TREE-EQUAL)
(USER:ADD-HELP-FUNCTION (LIST "lists" "predicates")
		   (LIST "ENDP")
		   'ENDP)
(USER:ADD-HELP-FUNCTION (LIST "lists")
		   (LIST "LIST-LENGTH")
		   'LIST-LENGTH)
(USER:ADD-HELP-FUNCTION (LIST "lists")
		   (LIST "NTH")
		   'NTH)
(USER:ADD-HELP-FUNCTION (LIST "lists")
		   (LIST "FIRST")
		   'FIRST)
(USER:ADD-HELP-FUNCTION (LIST "lists")
		   (LIST "SECOND")
		   'SECOND)
(USER:ADD-HELP-FUNCTION (LIST "lists")
		   (LIST "THIRD")
		   'THIRD)
(USER:ADD-HELP-FUNCTION (LIST "lists")
		   (LIST "FOURTH")
		   'FOURTH)
(USER:ADD-HELP-FUNCTION (LIST "lists")
		   (LIST "FIFTH")
		   'FIFTH)
(USER:ADD-HELP-FUNCTION (LIST "lists")
		   (LIST "SIXTH")
		   'SIXTH)
(USER:ADD-HELP-FUNCTION (LIST "lists")
		   (LIST "SEVENTH")
		   'SEVENTH)
(USER:ADD-HELP-FUNCTION (LIST "lists")
		   (LIST "EIGHTH")
		   'EIGHTH)
(USER:ADD-HELP-FUNCTION (LIST "lists")
		   (LIST "NINTH")
		   'NINTH)
(USER:ADD-HELP-FUNCTION (LIST "lists")
		   (LIST "TENTH")
		   'TENTH)
(USER:ADD-HELP-FUNCTION (LIST "lists")
		   (LIST "REST")
		   'REST)
(USER:ADD-HELP-FUNCTION (LIST "lists")
		   (LIST "NTHCDR")
		   'NTHCDR)
(USER:ADD-HELP-FUNCTION (LIST "lists")
		   (LIST "LAST")
		   'LAST)
(USER:ADD-HELP-FUNCTION (LIST "lists")
		   (LIST "LIST")
		   'LIST)
(USER:ADD-HELP-FUNCTION (LIST "lists")
		   (LIST "LIST*")
		   'LIST*)
(USER:ADD-HELP-FUNCTION (LIST "lists")
		   (LIST "MAKE-LIST")
		   'MAKE-LIST)
(USER:ADD-HELP-FUNCTION (LIST "lists")
		   (LIST "APPEND")
		   'APPEND)
(USER:ADD-HELP-FUNCTION (LIST "lists")
		   (LIST "COPY-LIST")
		   'COPY-LIST)
(USER:ADD-HELP-FUNCTION (LIST "lists")
		   (LIST "COPY-ALIST")
		   'COPY-ALIST)
(USER:ADD-HELP-FUNCTION (LIST "lists")
		   (LIST "COPY-TREE")
		   'COPY-TREE)
(USER:ADD-HELP-FUNCTION (LIST "lists")
		   (LIST "REVAPPEND")
		   'REVAPPEND)
(USER:ADD-HELP-FUNCTION (LIST "lists")
		   (LIST "NCONC")
		   'NCONC)
(USER:ADD-HELP-FUNCTION (LIST "lists")
		   (LIST "NRECONC")
		   'NRECONC)
(USER:ADD-HELP-FUNCTION (LIST "lists")
		   (LIST "PUSH")
		   'PUSH)
(USER:ADD-HELP-FUNCTION (LIST "lists")
		   (LIST "PUSHNEW")
		   'PUSHNEW)
(USER:ADD-HELP-FUNCTION (LIST "lists")
		   (LIST "POP")
		   'POP)
(USER:ADD-HELP-FUNCTION (LIST "lists")
		   (LIST "BUTLAST")
		   'BUTLAST)
(USER:ADD-HELP-FUNCTION (LIST "lists")
		   (LIST "NBUTLAST")
		   'NBUTLAST)
(USER:ADD-HELP-FUNCTION (LIST "lists")
		   (LIST "LDIFF")
		   'LDIFF)
(USER:ADD-HELP-FUNCTION (LIST "lists" "alteration of lists")
		   (LIST "RPLACA")
		   'RPLACA)
(USER:ADD-HELP-FUNCTION (LIST "lists" "alteration of lists")
		   (LIST "RPLACD")
		   'RPLACD)
(USER:ADD-HELP-FUNCTION (LIST "lists" "substitution in lists")
		   (LIST "SUBST")
		   'SUBST)
(USER:ADD-HELP-FUNCTION (LIST "lists" "substitution in lists")
		   (LIST "SUBST IF")
		   'SUBST-IF)
(USER:ADD-HELP-FUNCTION (LIST "lists" "substitution in lists")
		   (LIST "SUBST IF NOT")
		   'SUBST-IF-NOT)
(USER:ADD-HELP-FUNCTION (LIST "lists" "substitution in lists")
		   (LIST "NSUBST")
		   'NSUBST)
(USER:ADD-HELP-FUNCTION (LIST "lists" "substitution in lists")
		   (LIST "NSUBST IF")
		   'NSUBST-IF)
(USER:ADD-HELP-FUNCTION (LIST "lists" "substitution in lists")
		   (LIST "NSUBST IF NOT")
		   'NSUBST-IF-NOT)
(USER:ADD-HELP-FUNCTION (LIST "lists" "substitution in lists")
		   (LIST "SUBLIS")
		   'SUBLIS)
(USER:ADD-HELP-FUNCTION (LIST "lists" "substitution in lists")
		   (LIST "NSUBLIS")
		   'NSUBLIS)
(USER:ADD-HELP-FUNCTION (LIST "lists" "lists as sets")
		   (LIST "MEMBER")
		   'MEMBER)
(USER:ADD-HELP-FUNCTION (LIST "lists" "lists as sets")
		   (LIST "MEMBER IF")
		   'MEMBER-IF)
(USER:ADD-HELP-FUNCTION (LIST "lists" "lists as sets")
		   (LIST "MEMBER IF NOT")
		   'MEMBER-IF-NOT)
(USER:ADD-HELP-FUNCTION (LIST "lists" "lists as sets" "predicates")
		   (LIST "TAILP")
		   'TAILP)
(USER:ADD-HELP-FUNCTION (LIST "lists" "lists as sets")
		   (LIST "ADJOIN")
		   'ADJOIN)
(USER:ADD-HELP-FUNCTION (LIST "lists" "lists as sets")
		   (LIST "UNION")
		   'UNION)
(USER:ADD-HELP-FUNCTION (LIST "lists" "lists as sets")
		   (LIST "NUNION")
		   'NUNION)
(USER:ADD-HELP-FUNCTION (LIST "lists" "lists as sets")
		   (LIST "INTERSECTION")
		   'INTERSECTION)
(USER:ADD-HELP-FUNCTION (LIST "lists" "lists as sets")
		   (LIST "NINTERSECTION")
		   'NINTERSECTION)
(USER:ADD-HELP-FUNCTION (LIST "lists" "lists as sets")
		   (LIST "SET DIFFERENCE")
		   'SET-DIFFERENCE)
(USER:ADD-HELP-FUNCTION (LIST "lists" "lists as sets")
		   (LIST "NSET DIFFERENCE")
		   'NSET-DIFFERENCE)
(USER:ADD-HELP-FUNCTION (LIST "lists" "lists as sets")
		   (LIST "SET EXCLUSIVE OR")
		   'SET-EXCLUSIVE-OR)			
(USER:ADD-HELP-FUNCTION (LIST "lists" "lists as sets")
		   (LIST "NSET EXCLUSIVE OR")
		   'NSET-EXCLUSIVE-OR)
(USER:ADD-HELP-FUNCTION (LIST "lists" "lists as sets" "predicates")
		   (LIST "SUBSETP")
		   'SUBSETP)
(USER:ADD-HELP-FUNCTION (LIST "lists" "association lists")
		   (LIST "ACONS")
		   'ACONS)
(USER:ADD-HELP-FUNCTION (LIST "lists" "association lists")
		   (LIST "PAIRLIS")
		   'PAIRLIS)
(USER:ADD-HELP-FUNCTION (LIST "lists" "association lists")
		   (LIST "ASSOC")
		   'ASSOC)
(USER:ADD-HELP-FUNCTION (LIST "lists" "association lists")
		   (LIST "ASSOC IF")
		   'ASSOC-IF)
(USER:ADD-HELP-FUNCTION (LIST "lists" "association lists")
		   (LIST "ASSOC IF NOT")
		   'ASSOC-IF-NOT)
(USER:ADD-HELP-FUNCTION (LIST "lists" "association lists")
		   (LIST "RASSOC")
		   'RASSOC)
(USER:ADD-HELP-FUNCTION (LIST "lists" "association lists")
		   (LIST "RASSOC IF")
		   'RASSOC-IF)
(USER:ADD-HELP-FUNCTION (LIST "lists" "association lists")
		   (LIST "RASSOC IF NOT")
		   'RASSOC-IF-NOT)

(USER:ADD-HELP-FUNCTION (LIST "hash table")
		   (LIST "MAKE")
		   'MAKE-HASH-TABLE)
(USER:ADD-HELP-FUNCTION (LIST "hash table")
		   (LIST "REHASH SIZE")
		   'HASH-TABLE-REHASH-SIZE)
(USER:ADD-HELP-FUNCTION (LIST "hash table")
		   (LIST "REHASH THRESHOLD")
		   'HASH-TABLE-REHASH-THRESHOLD)
;(USER:ADD-HELP-FUNCTION (LIST "hash table")
;		   (LIST "SIZE")
;		   'HASH-TABLE-SIZE)
;(USER:ADD-HELP-FUNCTION (LIST "hash table")
;		   (LIST "TEST")
;		   'HASH-TABLE-TEST)
(USER:ADD-HELP-FUNCTION (LIST "hash table")
		   (LIST "HASH TABLE ?")
		   'HASH-TABLE-P)
(USER:ADD-HELP-FUNCTION (LIST "predicates")
		   (LIST "HASH TABLE")
		   'HASH-TABLE-P)
(USER:ADD-HELP-FUNCTION (LIST "hash table")
		   (LIST "GET ENTRY")
		   'GETHASH)
(USER:ADD-HELP-FUNCTION (LIST "hash table")
		   (LIST "REMOVE ENTRY")
		   'REMHASH)
(USER:ADD-HELP-FUNCTION (LIST "hash table")
		   (LIST "MAP THE ENTRIES")
		   'MAPHASH)
(USER:ADD-HELP-FUNCTION (LIST "hash table")
		   (LIST "CLEAR THE ENTRIES")
		   'CLRHASH)
(USER:ADD-HELP-FUNCTION (LIST "hash table")
		   (LIST "NUMBER OF ENTRIES")
		   'HASH-TABLE-COUNT)
(USER:ADD-HELP-FUNCTION (LIST "hash table")
		   (LIST "COMPUTE HASH CODE")
		   'SXHASH)

(USER:ADD-HELP-FUNCTION (LIST "arrays" "array creation")
		   (LIST "MAKE ARRAY")
		   'MAKE-ARRAY)
(USER:ADD-HELP-FUNCTION (LIST "arrays" "array creation")
		   (LIST "VECTOR")
		   'VECTOR)
(USER:ADD-HELP-FUNCTION (LIST "arrays" "array access")
		   (LIST "GET ARRAY ELEMENT")
		   'AREF)
(USER:ADD-HELP-FUNCTION (LIST "arrays" "array access")
		   (LIST "GET SIMPLE VECTOR ELEMENT")
		   'SVREF)
(USER:ADD-HELP-FUNCTION (LIST "arrays" "array information")
		   (LIST "ELEMENT TYPE")
		   'ARRAY-ELEMENT-TYPE)
(USER:ADD-HELP-FUNCTION (LIST "arrays" "array information")
		   (LIST "NUMBER OF DIMENSIONS" "RANK")
		   'ARRAY-RANK)
(USER:ADD-HELP-FUNCTION (LIST "arrays" "array information")
		   (LIST "SIZE OF DIMENSION")
		   'ARRAY-DIMENSION)
(USER:ADD-HELP-FUNCTION (LIST "arrays" "array information")
		   (LIST "LIST OF DIMENSIONS")
		   'ARRAY-DIMENSIONS)
(USER:ADD-HELP-FUNCTION (LIST "arrays" "array information")
		   (LIST "NUMBER OF ENTRIES")
		   'ARRAY-TOTAL-SIZE)
(USER:ADD-HELP-FUNCTION (LIST "arrays" "array information")
		   (LIST "ARRAY SUBSCRIPTS LEGAL ?")
		   'ARRAY-IN-BOUNDS-P)
(USER:ADD-HELP-FUNCTION (LIST "predicates")
		   (LIST "ARRAY SUBSCRIPTS LEGAL")
		   'ARRAY-IN-BOUNDS-P)
(USER:ADD-HELP-FUNCTION (LIST "arrays" "array information")
		   (LIST "ROW MAJOR INDEX")
		   'ARRAY-ROW-MAJOR-INDEX)
(USER:ADD-HELP-FUNCTION (LIST "arrays" "array information")
		   (LIST "ADJUSTABLE ARRAY ?")
		   'ADJUSTABLE-ARRAY-P)
(USER:ADD-HELP-FUNCTION (LIST "predicates")
		   (LIST "ADJUSTABLE ARRAY")
		   'ADJUSTABLE-ARRAY-P)
(USER:ADD-HELP-FUNCTION (LIST "arrays" "arrays of bits")
		   (LIST "BIT ARRAY ELEMENT")
		   'BIT)
(USER:ADD-HELP-FUNCTION (LIST "arrays" "arrays of bits")
		   (LIST "SIMPLE BIT ARRAY ELEMENT")
		   'SBIT)
(USER:ADD-HELP-FUNCTION (LIST "arrays" "arrays of bits")
		   (LIST "AND")
		   'BIT-AND)
(USER:ADD-HELP-FUNCTION (LIST "arrays" "arrays of bits")
		   (LIST "INCLUSIVE OR")
		   'BIT-IOR)
(USER:ADD-HELP-FUNCTION (LIST "arrays" "arrays of bits")
		   (LIST "EXCLUSIVE OR")
		   'BIT-XOR)
(USER:ADD-HELP-FUNCTION (LIST "arrays" "arrays of bits")
		   (LIST "EQUIVALENCE")
		   'BIT-EQV)
(USER:ADD-HELP-FUNCTION (LIST "arrays" "arrays of bits")
		   (LIST "NOT AND")
		   'BIT-NAND)
(USER:ADD-HELP-FUNCTION (LIST "arrays" "arrays of bits")
		   (LIST "NOT OR")
		   'BIT-NOR)
(USER:ADD-HELP-FUNCTION (LIST "arrays" "arrays of bits")
		   (LIST "COMPLIMENT ARG1 AND")
		   'BIT-ANDC1)
(USER:ADD-HELP-FUNCTION (LIST "arrays" "arrays of bits")
		   (LIST "COMPLIMENT ARG2 AND")
		   'BIT-ANDC2)
(USER:ADD-HELP-FUNCTION (LIST "arrays" "arrays of bits")
		   (LIST "COMPLIMENT ARG1 OR")
		   'BIT-ORC1)
(USER:ADD-HELP-FUNCTION (LIST "arrays" "arrays of bits")
		   (LIST "COMPLIMENT ARG2 OR")
		   'BIT-ORC2)
(USER:ADD-HELP-FUNCTION (LIST "arrays" "arrays of bits")
		   (LIST "INVERT BIT ARRAY")
		   'BIT-NOT)
(USER:ADD-HELP-FUNCTION (LIST "arrays" "array fill pointer")
		   (LIST "ARRAY HAS FILL POINTER ?")
		   'ARRAY-HAS-FILL-POINTER-P)
(USER:ADD-HELP-FUNCTION (LIST "predicates")
		   (LIST "ARRAY HAS FILL POINTER")
		   'ARRAY-HAS-FILL-POINTER-P)
(USER:ADD-HELP-FUNCTION (LIST "arrays" "array fill pointer")
		   (LIST "GET FILL POINTER")
		   'FILL-POINTER)
(USER:ADD-HELP-FUNCTION (LIST "arrays" "array fill pointer")
		   (LIST "PUSH")
		   'VECTOR-PUSH)
(USER:ADD-HELP-FUNCTION (LIST "arrays" "array fill pointer")
		   (LIST "PUSH AND EXTEND")
		   'VECTOR-PUSH-EXTEND)
(USER:ADD-HELP-FUNCTION (LIST "arrays" "array fill pointer")
		   (LIST "POP")
		   'VECTOR-POP)
(USER:ADD-HELP-FUNCTION (LIST "arrays")
		   (LIST "ADJUST")
		   'ADJUST-ARRAY)

(USER:ADD-HELP-FUNCTION (LIST "strings" "string access")
		   (LIST "GET ELEMENT")
		   'CHAR)
(USER:ADD-HELP-FUNCTION (LIST "strings" "string access")
		   (LIST "GET SIMPLE STRING ELEMENT")
		   'SCHAR)
(USER:ADD-HELP-FUNCTION (LIST "strings" "string comparison")
		   (LIST "=")
		   'STRING=)
(USER:ADD-HELP-FUNCTION (LIST "strings" "string comparison")
		   (LIST "CASE INDEPENDENT =")
		   'STRING-EQUAL)
(USER:ADD-HELP-FUNCTION (LIST "strings" "string comparison")
		   (LIST "<")
		   'STRING<)
(USER:ADD-HELP-FUNCTION (LIST "strings" "string comparison")
		   (LIST ">")
		   'STRING>)
(USER:ADD-HELP-FUNCTION (LIST "strings" "string comparison")
		   (LIST "<=")
		   'STRING<=)
(USER:ADD-HELP-FUNCTION (LIST "strings" "string comparison")
		   (LIST ">=")
		   'STRING>=)
(USER:ADD-HELP-FUNCTION (LIST "strings" "string comparison")
		   (LIST "NOT =")
		   'STRING/=)
(USER:ADD-HELP-FUNCTION (LIST "strings" "string comparison")
		   (LIST "CASE INDEPENDENT <")
		   'STRING-LESSP)
(USER:ADD-HELP-FUNCTION (LIST "strings" "string comparison")
		   (LIST "CASE INDEPENDENT >")
		   'STRING-GREATERP)
(USER:ADD-HELP-FUNCTION (LIST "strings" "string comparison")
		   (LIST "CASE INDEPENDENT NOT >")
		   'STRING-NOT-GREATERP)
(USER:ADD-HELP-FUNCTION (LIST "strings" "string comparison")
		   (LIST "CASE INDEPENDENT NOT <")
		   'STRING-NOT-LESSP)
(USER:ADD-HELP-FUNCTION (LIST "strings" "string comparison")
		   (LIST "CASE INDEPENDENT NOT =")
		   'STRING-NOT-EQUAL)
(USER:ADD-HELP-FUNCTION (LIST "predicates")
		   (LIST "STRING =")
		   'STRING=)
(USER:ADD-HELP-FUNCTION (LIST "predicates")
		   (LIST "STRING CASE INDEPENDENT =")
		   'STRING-EQUAL)
(USER:ADD-HELP-FUNCTION (LIST "predicates")
		   (LIST "STRING <")
		   'STRING<)
(USER:ADD-HELP-FUNCTION (LIST "predicates")
		   (LIST "STRING >")
		   'STRING>)
(USER:ADD-HELP-FUNCTION (LIST "predicates")
		   (LIST "STRING <=")
		   'STRING<=)
(USER:ADD-HELP-FUNCTION (LIST "predicates")
		   (LIST "STRING >=")
		   'STRING>=)
(USER:ADD-HELP-FUNCTION (LIST "predicates")
		   (LIST "STRING NOT =")
		   'STRING/=)
(USER:ADD-HELP-FUNCTION (LIST "predicates")
		   (LIST "STRING CASE INDEPENDENT <")
		   'STRING-LESSP)
(USER:ADD-HELP-FUNCTION (LIST "predicates")
		   (LIST "STRING CASE INDEPENDENT >")
		   'STRING-GREATERP)
(USER:ADD-HELP-FUNCTION (LIST "predicates")
		   (LIST "STRING CASE INDEPENDENT NOT >")
		   'STRING-NOT-GREATERP)
(USER:ADD-HELP-FUNCTION (LIST "predicates")
		   (LIST "STRING CASE INDEPENDENT NOT <")
		   'STRING-NOT-LESSP)
(USER:ADD-HELP-FUNCTION (LIST "predicates")
		   (LIST "STRING CASE INDEPENDENT NOT =")
		   'STRING-NOT-EQUAL)

(USER:ADD-HELP-FUNCTION (LIST "strings" "string manipulation")
		   (LIST "CREATE")
		   'MAKE-STRING)
(USER:ADD-HELP-FUNCTION (LIST "strings" "string manipulation")
		   (LIST "TRIM")
		   'STRING-TRIM)
(USER:ADD-HELP-FUNCTION (LIST "strings" "string manipulation")
		   (LIST "LEFT TRIM")
		   'STRING-LEFT-TRIM)
(USER:ADD-HELP-FUNCTION (LIST "strings" "string manipulation")
		   (LIST "RIGHT TRIM")
		   'STRING-RIGHT-TRIM)
(USER:ADD-HELP-FUNCTION (LIST "strings" "string manipulation")
		   (LIST "UPPER CASE")
		   'STRING-UPCASE)
(USER:ADD-HELP-FUNCTION (LIST "strings" "string manipulation")
		   (LIST "LOWER CASE")
		   'STRING-DOWNCASE)
(USER:ADD-HELP-FUNCTION (LIST "strings" "string manipulation")
		   (LIST "CAPITALIZE")
		   'STRING-CAPITALIZE)
(USER:ADD-HELP-FUNCTION (LIST "strings" "string manipulation")
		   (LIST "DESTRUCTIVE UPPER CASE")
		   'NSTRING-UPCASE)
(USER:ADD-HELP-FUNCTION (LIST "strings" "string manipulation")
		   (LIST "DESTRUCTIVE LOWER CASE")
		   'NSTRING-DOWNCASE)
(USER:ADD-HELP-FUNCTION (LIST "strings" "string manipulation")
		   (LIST "DESTRUCTIVE CAPITALIZE")
		   'NSTRING-CAPITALIZE)
(USER:ADD-HELP-FUNCTION (LIST "strings" "string manipulation")
		   (LIST "STRING")
		   'STRING)


(USER:ADD-HELP-FUNCTION (LIST "structures")
		   (LIST "DEFINE A STRUCTURE")
		   'DEFSTRUCT)
(USER:ADD-HELP-FUNCTION (LIST "DEFINE")
		   (LIST "STRUCTURE")
		   'DEFSTRUCT)


(USER:ADD-HELP-FUNCTION (LIST "evaluator")
		   (LIST "EVALUATE")
		   'EVAL)
(USER:ADD-HELP-FUNCTION (LIST "evaluator")
		   (LIST "EVALUATE DEBUG HOOK")
		   'EVALHOOK)
(USER:ADD-HELP-FUNCTION (LIST "evaluator")
		   (LIST "APPLY DEBUG HOOK")
		   'APPLYHOOK)
(USER:ADD-HELP-FUNCTION (LIST "evaluator" "predicates")
		   (LIST "CONSTANTP")
		   'CONSTANTP)

(USER:ADD-HELP-FUNCTION (LIST "streams")
		   (LIST "MAKE SYNONYM STREAM")
		   'MAKE-SYNONYM-STREAM)
(USER:ADD-HELP-FUNCTION (LIST "streams")
		   (LIST "MAKE BROADCAST STREAM")
		   'MAKE-BROADCAST-STREAM)
(USER:ADD-HELP-FUNCTION (LIST "streams")
		   (LIST "MAKE CONCATENATED STREAM")
		   'MAKE-CONCATENATED-STREAM)
(USER:ADD-HELP-FUNCTION (LIST "streams")
		   (LIST "MAKE TWO WAY STREAM")
		   'MAKE-TWO-WAY-STREAM)
(USER:ADD-HELP-FUNCTION (LIST "streams")
		   (LIST "MAKE ECHO STREAM")
		   'MAKE-ECHO-STREAM)
(USER:ADD-HELP-FUNCTION (LIST "streams")
		   (LIST "MAKE STRING INPUT STREAM")
		   'MAKE-STRING-INPUT-STREAM)
(USER:ADD-HELP-FUNCTION (LIST "streams")
		   (LIST "MAKE STRING OUTPUT STREAM")
		   'MAKE-STRING-OUTPUT-STREAM)
(USER:ADD-HELP-FUNCTION (LIST "streams")
		   (LIST "GET OUTPUT STREAM STRING")
		   'GET-OUTPUT-STREAM-STRING)
(USER:ADD-HELP-FUNCTION (LIST "streams")
		   (LIST "WITH OPEN STREAM")
		   'WITH-OPEN-STREAM)
(USER:ADD-HELP-FUNCTION (LIST "streams")
		   (LIST "WITH INPUT FROM STRING")
		   'WITH-INPUT-FROM-STRING)
(USER:ADD-HELP-FUNCTION (LIST "streams")
		   (LIST "WITH OUTPUT TO STRING")
		   'WITH-OUTPUT-TO-STRING)
(USER:ADD-HELP-FUNCTION (LIST "streams" "predicates")
		   (LIST "STREAMP")
		   'STREAMP)
(USER:ADD-HELP-FUNCTION (LIST "streams")
		   (LIST "INPUT STREAM ?")
		   'INPUT-STREAM-P)
(USER:ADD-HELP-FUNCTION (LIST "streams")
		   (LIST "OUTPUT STREAM ?")
		   'OUTPUT-STREAM-P)
(USER:ADD-HELP-FUNCTION (LIST "streams")
		   (LIST "STREAM ELEMENT TYPE")
		   'STREAM-ELEMENT-TYPE)
(USER:ADD-HELP-FUNCTION (LIST "streams")
		   (LIST "CLOSE")
		   'CLOSE)
(USER:ADD-HELP-FUNCTION (LIST "predicates")
		   (LIST "INPUT STREAM")
		   'INPUT-STREAM-P)
(USER:ADD-HELP-FUNCTION (LIST "predicates")
		   (LIST "OUTPUT STREAM")
		   'OUTPUT-STREAM-P)

(USER:ADD-HELP-FUNCTION (LIST "input/output" "readtable")
		   (LIST "COPY READTABLE")
		   'COPY-READTABLE)
(USER:ADD-HELP-FUNCTION (LIST "input/output" "readtable" "predicates")
		   (LIST "READTABLEP")
		   'READTABLEP)
(USER:ADD-HELP-FUNCTION (LIST "input/output" "readtable")
		   (LIST "SET SYNTAX FROM CHAR")
		   'SET-SYNTAX-FROM-CHAR)
(USER:ADD-HELP-FUNCTION (LIST "input/output" "readtable")
		   (LIST "SET MACRO CHARACTER")
		   'SET-MACRO-CHARACTER)
(USER:ADD-HELP-FUNCTION (LIST "input/output" "readtable")
		   (LIST "GET MACRO CHARACTER")
		   'GET-MACRO-CHARACTER)
(USER:ADD-HELP-FUNCTION (LIST "input/output" "readtable")
		   (LIST "MAKE DISPATCH MACRO CHARACTER")
		   'MAKE-DISPATCH-MACRO-CHARACTER)
(USER:ADD-HELP-FUNCTION (LIST "input/output" "readtable")
		   (LIST "SET DISPATCH MACRO CHARACTER")
		   'SET-DISPATCH-MACRO-CHARACTER)
(USER:ADD-HELP-FUNCTION (LIST "input/output" "readtable")
		   (LIST "GET DISPATCH MACRO CHARACTER")
		   'GET-DISPATCH-MACRO-CHARACTER)

(USER:ADD-HELP-FUNCTION (LIST "input/output" "input functions")
		   (LIST "READ")
		   'READ)
(USER:ADD-HELP-FUNCTION (LIST "input/output" "input functions")
		   (LIST "READ PERSERVING WHITESPACE")
		   'READ-PERSERVING-WHITESPACE)
(USER:ADD-HELP-FUNCTION (LIST "input/output" "input functions")
		   (LIST "READ DELIMITED LIST")
		   'READ-DELIMITED-LIST)
(USER:ADD-HELP-FUNCTION (LIST "input/output" "input functions")
		   (LIST "READ LINE")
		   'READ-LINE)
(USER:ADD-HELP-FUNCTION (LIST "input/output" "input functions")
		   (LIST "READ CHAR")
		   'READ-CHAR)
(USER:ADD-HELP-FUNCTION (LIST "input/output" "input functions")
		   (LIST "UNREAD CHAR")
		   'UNREAD-CHAR)
(USER:ADD-HELP-FUNCTION (LIST "input/output" "input functions")
		   (LIST "PEEK CHAR")
		   'PEEK-CHAR)
(USER:ADD-HELP-FUNCTION (LIST "input/output" "input functions" "predicates")
		   (LIST "LISTEN")
		   'LISTEN)
(USER:ADD-HELP-FUNCTION (LIST "input/output" "input functions")
		   (LIST "READ CHAR NO HANG")
		   'READ-CHAR-NO-HANG)
(USER:ADD-HELP-FUNCTION (LIST "input/output" "input functions")
		   (LIST "CLEAR INPUT")
		   'CLEAR-INPUT)
(USER:ADD-HELP-FUNCTION (LIST "input/output" "input functions")
		   (LIST "READ FROM STRING")
		   'READ-FROM-STRING)
(USER:ADD-HELP-FUNCTION (LIST "input/output" "input functions")
		   (LIST "PARSE INTEGER")
		   'PARSE-INTEGER)
(USER:ADD-HELP-FUNCTION (LIST "input/output" "input functions")
		   (LIST "READ BYTE")
		   'READ-BYTE)

(USER:ADD-HELP-FUNCTION (LIST "input/output" "output functions")
		   (LIST "WRITE")
		   'WRITE)
(USER:ADD-HELP-FUNCTION (LIST "input/output" "output functions")
		   (LIST "PRINT WITH ESCAPE CHARS" "PRIN1")
		   'PRIN1)
(USER:ADD-HELP-FUNCTION (LIST "input/output" "output functions")
		   (LIST "NEWLINE THEN PRIN1" "PRINT")
		   'PRINT)
(USER:ADD-HELP-FUNCTION (LIST "input/output" "output functions")
		   (LIST "PRETTY PRINT" "PPRINT")
		   'PPRINT)
(USER:ADD-HELP-FUNCTION (LIST "input/output" "output functions")
		   (LIST "PRINT WITHOUT ESCAPE CHARS" "PRINC")
		   'PRINC)
(USER:ADD-HELP-FUNCTION (LIST "input/output" "output functions")
		   (LIST "WRITE TO STRING")
		   'WRITE-TO-STRING)
(USER:ADD-HELP-FUNCTION (LIST "input/output" "output functions")
		   (LIST "PRIN1 TO STRING")
		   'PRIN1-TO-STRING)
(USER:ADD-HELP-FUNCTION (LIST "input/output" "output functions")
		   (LIST "PRINC TO STRING")
		   'PRINC-TO-STRING)
(USER:ADD-HELP-FUNCTION (LIST "input/output" "output functions")
		   (LIST "WRITE CHAR")
		   'WRITE-CHAR)
(USER:ADD-HELP-FUNCTION (LIST "input/output" "output functions")
		   (LIST "WRITE STRING")
		   'WRITE-STRING)
(USER:ADD-HELP-FUNCTION (LIST "input/output" "output functions")
		   (LIST "WRITE LINE")
		   'WRITE-LINE)
(USER:ADD-HELP-FUNCTION (LIST "input/output" "output functions")
		   (LIST "WRITE NEWLINE" "TERPRI")
		   'TERPRI)
(USER:ADD-HELP-FUNCTION (LIST "input/output" "output functions")
		   (LIST "WRITE NEWLINE IF NOT AT NEWLINE" "FRESH LINE")
		   'FRESH-LINE)
(USER:ADD-HELP-FUNCTION (LIST "input/output" "output functions")
		   (LIST "FINISH OUTPUT")
		   'FINISH-OUTPUT)
(USER:ADD-HELP-FUNCTION (LIST "input/output" "output functions")
		   (LIST "FORCE OUTPUT")
		   'FORCE-OUTPUT)
(USER:ADD-HELP-FUNCTION (LIST "input/output" "output functions")
		   (LIST "CLEAR OUTPUT")
		   'CLEAR-OUTPUT)
(USER:ADD-HELP-FUNCTION (LIST "input/output" "output functions")
		   (LIST "WRITE BYTE")
		   'WRITE-BYTE)
(USER:ADD-HELP-FUNCTION (LIST "input/output" "output functions")
		   (LIST "FORMAT")
		   'FORMAT)
(USER:ADD-HELP-FUNCTION (LIST "input/output" "querying the user" "predicates")
		   (LIST "Y OR N")
		   'Y-OR-N-P)
(USER:ADD-HELP-FUNCTION (LIST "input/output" "querying the user" "predicates")
		   (LIST "YES OR NO")
		   'YES-OR-NO-P)

(USER:ADD-HELP-FUNCTION (LIST "file system" "pathnames")
		   (LIST "PATHNAME")
		   'PATHNAME)
(USER:ADD-HELP-FUNCTION (LIST "file system" "pathnames")
		   (LIST "TRUENAME")
		   'TRUENAME)
(USER:ADD-HELP-FUNCTION (LIST "GET" "SHOW")
		   (LIST "FILE'S TRUENAME")
		   'TRUENAME)
(USER:ADD-HELP-FUNCTION (LIST "file system" "pathnames")
		   (LIST "PARSE NAMESTRING")
		   'PARSE-NAMESTRING)
(USER:ADD-HELP-FUNCTION (LIST "file system" "pathnames")
		   (LIST "MERGE PATHNAMES")
		   'MERGE-PATHNAMES)
(USER:ADD-HELP-FUNCTION (LIST "file system" "pathnames")
		   (LIST "MAKE PATHNAME")
		   'MAKE-PATHNAME)
(USER:ADD-HELP-FUNCTION (LIST "file system" "pathnames" "predicates")
		   (LIST "PATHNAMEP")
		   'PATHNAMEP)
(USER:ADD-HELP-FUNCTION (LIST "file system" "pathnames")
		   (LIST "PATHNAME HOST")
		   'PATHNAME-HOST)
(USER:ADD-HELP-FUNCTION (LIST "file system" "pathnames")
		   (LIST "PATHNAME DEVICE")
		   'PATHNAME-DEVICE)
(USER:ADD-HELP-FUNCTION (LIST "file system" "pathnames")
		   (LIST "PATHNAME DIRECTORY")
		   'PATHNAME-DIRECTORY)
(USER:ADD-HELP-FUNCTION (LIST "file system" "pathnames")
		   (LIST "PATHNAME NAME")
		   'PATHNAME-NAME)
(USER:ADD-HELP-FUNCTION (LIST "file system" "pathnames")
		   (LIST "PATHNAME TYPE")
		   'PATHNAME-TYPE)
(USER:ADD-HELP-FUNCTION (LIST "file system" "pathnames")
		   (LIST "PATHNAME VERSION")
		   'PATHNAME-VERSION)
(USER:ADD-HELP-FUNCTION (LIST "file system" "pathnames")
		   (LIST "NAMESTRING")
		   'NAMESTRING)
(USER:ADD-HELP-FUNCTION (LIST "file system" "pathnames")
		   (LIST "FILE NAMESTRING")
		   'FILE-NAMESTRING)
(USER:ADD-HELP-FUNCTION (LIST "file system" "pathnames")
		   (LIST "DIRECTORY NAMESTRING")
		   'DIRECTORY-NAMESTRING)
(USER:ADD-HELP-FUNCTION (LIST "file system" "pathnames")
		   (LIST "HOST NAMESTRING")
		   'HOST-NAMESTRING)
(USER:ADD-HELP-FUNCTION (LIST "file system" "pathnames")
		   (LIST "ENOUGH NAMESTRING")
		   'ENOUGH-NAMESTRING)
(USER:ADD-HELP-FUNCTION (LIST "file system" "pathnames")
		   (LIST "USER HOMEDIR PATHNAME")
		   'USER-HOMEDIR-PATHNAME)

(USER:ADD-HELP-FUNCTION (LIST "file system" "file operations")
		   (LIST "OPEN")
		   'OPEN)
(USER:ADD-HELP-FUNCTION (LIST "file system" "file operations")
		   (LIST "WITH OPEN FILE")
		   'WITH-OPEN-FILE)
(USER:ADD-HELP-FUNCTION (LIST "file system" "file operations")
		   (LIST "RENAME FILE")
		   'RENAME-FILE)
(USER:ADD-HELP-FUNCTION (LIST "file system" "file operations")
		   (LIST "PROBE FILE")
		   'PROBE-FILE)
(USER:ADD-HELP-FUNCTION (LIST "file system" "file operations")
		   (LIST "FILE WRITE DATE")
		   'FILE-WRITE-DATE)
(USER:ADD-HELP-FUNCTION (LIST "SHOW" "GET")
		   (LIST "FILE WRITE DATE")
		   'FILE-WRITE-DATE)
(USER:ADD-HELP-FUNCTION (LIST "file system" "file operations")
		   (LIST "FILE AUTHOR")
		   'FILE-AUTHOR)
(USER:ADD-HELP-FUNCTION (LIST "GET" "SHOW")
		   (LIST "FILE AUTHOR")
		   'FILE-AUTHOR)
(USER:ADD-HELP-FUNCTION (LIST "file system" "file operations")
		   (LIST "FILE POSITION")
		   'FILE-POSITION)
(USER:ADD-HELP-FUNCTION (LIST "GET" "SHOW")
		   (LIST "FILE POSITION")
		   'FILE-POSITION)
(USER:ADD-HELP-FUNCTION (LIST "file system" "file operations")
		   (LIST "FILE LENGTH")
		   'FILE-LENGTH)
(USER:ADD-HELP-FUNCTION (LIST "GET" "SHOW")
		   (LIST "FILE LENGTH")
		   'FILE-LENGTH)
(USER:ADD-HELP-FUNCTION (LIST "file system" "file operations")
		   (LIST "LOAD")
		   'LOAD)
(USER:ADD-HELP-FUNCTION (LIST "file system" "file operations")
		   (LIST "DIRECTORY")
		   'DIRECTORY)
(USER:ADD-HELP-FUNCTION (LIST "file system" "file operations")
		   (LIST "DELETE FILE")
		   'DELETE-FILE)

(USER:ADD-HELP-FUNCTION (LIST "errors")
		   (LIST "ERROR")
		   'ERROR)
(USER:ADD-HELP-FUNCTION (LIST "errors")
		   (LIST "CONTINUABLE ERROR")
		   'CERROR)
(USER:ADD-HELP-FUNCTION (LIST "errors")
		   (LIST "WARN")
		   'WARN)
(USER:ADD-HELP-FUNCTION (LIST "errors")
		   (LIST "BREAK")
		   'BREAK)
(USER:ADD-HELP-FUNCTION (LIST "errors")
		   (LIST "CHECK TYPE")
		   'CHECK-TYPE)
(USER:ADD-HELP-FUNCTION (LIST "errors")
		   (LIST "ERROR IF TEST IS NIL" "ASSERT")
		   'ASSERT)
(USER:ADD-HELP-FUNCTION (LIST "errors")
		   (LIST "ERROR CHECKING TYPE CASE" "ETYPECASE")
		   'ETYPECASE)
(USER:ADD-HELP-FUNCTION (LIST "errors")
		   (LIST "CONTINUABLE TYPE CASE" "CTYPECASE")
		   'CTYPECASE)
(USER:ADD-HELP-FUNCTION (LIST "errors")
		   (LIST "ERROR CHECKING CASE" "ECASE")
		   'ECASE)
(USER:ADD-HELP-FUNCTION (LIST "errors")
		   (LIST "CONTINUABLE CASE" "CCASE")
		   'CCASE)

(USER:ADD-HELP-FUNCTION (LIST "compiler")
		   (LIST "COMPILE FUNCTION")
		   'COMPILE)
(USER:ADD-HELP-FUNCTION (LIST "compiler")
		   (LIST "COMPILE FILE")
		   'COMPILE-FILE)
(USER:ADD-HELP-FUNCTION (LIST "compiler")
		   (LIST "DISASSEMBLE")
		   'DISASSEMBLE)

(USER:ADD-HELP-FUNCTION (LIST "documentation")
		   (LIST "GET DOCUMENTATION")
		   'DOCUMENTATION)

(USER:ADD-HELP-FUNCTION (LIST "debugging")
		   (LIST "TRACE")
		   'TRACE)
(USER:ADD-HELP-FUNCTION (LIST "debugging")
		   (LIST "UNTRACE")
		   'UNTRACE)
(USER:ADD-HELP-FUNCTION (LIST "debugging")
		   (LIST "STEP")
		   'STEP)
(USER:ADD-HELP-FUNCTION (LIST "debugging")
		   (LIST "TIME")
		   'TIME)
(USER:ADD-HELP-FUNCTION (LIST "debugging")
		   (LIST "DESCRIBE")
		   'DESCRIBE)
(USER:ADD-HELP-FUNCTION (LIST "debugging")
		   (LIST "INSPECT")
		   'INSPECT)
(USER:ADD-HELP-FUNCTION (LIST "debugging" "STATUS")
		   (LIST "ROOM")
		   'ROOM)
(USER:ADD-HELP-FUNCTION (LIST "debugging")
		   (LIST "EDITOR")
		   'ED)
(USER:ADD-HELP-FUNCTION (LIST "debugging")
		   (LIST "DRIBBLE")
		   'DRIBBLE)
(USER:ADD-HELP-FUNCTION (LIST "debugging")
		   (LIST "APROPOS")
		   'APROPOS)
(USER:ADD-HELP-FUNCTION (LIST "debugging")
		   (LIST "APROPOS LIST")
		   'APROPOS-LIST)

(USER:ADD-HELP-FUNCTION (LIST "time")
		   (LIST "GET DECODED TIME")
		   'GET-DECODED-TIME)
(USER:ADD-HELP-FUNCTION (LIST "time")
		   (LIST "GET UNIVERSAL TIME")
		   'GET-UNIVERSAL-TIME)
(USER:ADD-HELP-FUNCTION (LIST "time")
		   (LIST "DECODE UNIVERSAL TIME")
		   'DECODE-UNIVERSAL-TIME)
(USER:ADD-HELP-FUNCTION (LIST "time")
		   (LIST "ENCODE UNIVERSAL TIME")
		   'ENCODE-UNIVERSAL-TIME)
(USER:ADD-HELP-FUNCTION (LIST "time")
		   (LIST "GET INTERNAL RUN TIME")
		   'GET-INTERNAL-RUN-TIME)
(USER:ADD-HELP-FUNCTION (LIST "time")
		   (LIST "GET INTERNAL REAL TIME")
		   'GET-INTERNAL-REAL-TIME)
(USER:ADD-HELP-FUNCTION (LIST "time")
		   (LIST "SLEEP")
		   'SLEEP)

(USER:ADD-HELP-FUNCTION (LIST "environment")
		   (LIST "LISP IMPLEMENTATION TYPE")
		   'LISP-IMPLEMENTATION-TYPE)
(USER:ADD-HELP-FUNCTION (LIST "environment")
		   (LIST "LISP IMPLEMENTATION VERSION")
		   'LISP-IMPLEMENTATION-VERSION)
(USER:ADD-HELP-FUNCTION (LIST "environment")
		   (LIST "MACHINE TYPE")
		   'MACHINE-TYPE)
(USER:ADD-HELP-FUNCTION (LIST "environment")
		   (LIST "MACHINE VERSION")
		   'MACHINE-VERSION)
(USER:ADD-HELP-FUNCTION (LIST "environment")
		   (LIST "MACHINE INSTANCE")
		   'MACHINE-INSTANCE)
(USER:ADD-HELP-FUNCTION (LIST "environment")
		   (LIST "SOFTWARE TYPE")
		   'SOFTWARE-TYPE)
(USER:ADD-HELP-FUNCTION (LIST "environment")
		   (LIST "SOFTWARE VERSION")
		   'SOFTWARE-VERSION)
(USER:ADD-HELP-FUNCTION (LIST "environment")
		   (LIST "SHORT SITE NAME")
		   'SHORT-SITE-NAME)
(USER:ADD-HELP-FUNCTION (LIST "environment")
		   (LIST "LONG SITE NAME")
		   'LONG-SITE-NAME)
(USER:ADD-HELP-FUNCTION (LIST "environment")
		   (LIST "IDENTITY")
		   'IDENTITY)

(USER:ADD-HELP-FUNCTION (LIST "variables")
		   (LIST "PRINT LENGTH")
		   '*PRINT-LENGTH*)
(USER:ADD-HELP-FUNCTION (LIST "variables")
		   (LIST "PRINT PRETTY")
		   '*PRINT-PRETTY*)
(USER:ADD-HELP-FUNCTION (LIST "variables")
		   (LIST "PRINT ESCAPE")
		   '*PRINT-ESCAPE*)
(USER:ADD-HELP-FUNCTION (LIST "variables")
		   (LIST "PRINT CIRCLE")
		   '*PRINT-CIRCLE*)
(USER:ADD-HELP-FUNCTION (LIST "variables")
		   (LIST "PRINT BASE")
		   '*PRINT-BASE*)
(USER:ADD-HELP-FUNCTION (LIST "variables")
		   (LIST "PRINT RADIX")
		   '*PRINT-RADIX*)
(USER:ADD-HELP-FUNCTION (LIST "variables")
		   (LIST "PRINT CASE")
		   '*PRINT-CASE*)
(USER:ADD-HELP-FUNCTION (LIST "variables")
		   (LIST "PRINT GENSYM")
		   '*PRINT-GENSYM*)
(USER:ADD-HELP-FUNCTION (LIST "variables")
		   (LIST "PRINT LEVEL")
		   '*PRINT-LEVEL*)
(USER:ADD-HELP-FUNCTION (LIST "variables")
		   (LIST "PRINT ARRAY")
		   '*PRINT-ARRAY*)
(USER:ADD-HELP-FUNCTION (LIST "variables")
		   (LIST "READ DEFAULT FLOAT FORMAT")
		   '*READ-DEFAULT-FLOAT-FORMAT*)
(USER:ADD-HELP-FUNCTION (LIST "variables")
		   (LIST "DEFAULT PATHNAME DEFAULTS")
		   '*DEFAULT-PATHNAME-DEFAULTS*)
(USER:ADD-HELP-FUNCTION (LIST "variables")
		   (LIST "LOAD VERBOSE")
		   '*LOAD-VERBOSE*)
(USER:ADD-HELP-FUNCTION (LIST "variables")
		   (LIST "BREAK ON WARNINGS")
		   '*BREAK-ON-WARNINGS*)
(USER:ADD-HELP-FUNCTION (LIST "variables")
		   (LIST "MACRO EXPAND HOOK")
		   '*MACROEXPAND-HOOK*)
(USER:ADD-HELP-FUNCTION (LIST "variables")
		   (LIST "PACKAGE")
		   '*PACKAGE*)
(USER:ADD-HELP-FUNCTION (LIST "variables")
		   (LIST "MODULES")
		   '*MODULES*)
(USER:ADD-HELP-FUNCTION (LIST "variables")
		   (LIST "RANDOM STATE")
		   '*RANDOM-STATE*)
(USER:ADD-HELP-FUNCTION (LIST "variables")
		   (LIST "EVAL HOOK")
		   '*EVALHOOK*)
(USER:ADD-HELP-FUNCTION (LIST "variables")
		   (LIST "APPLY HOOK")
		   '*APPLYHOOK*)
(USER:ADD-HELP-FUNCTION (LIST "variables")
		   (LIST "STANDARD INPUT")
		   '*STANDARD-INPUT*)
(USER:ADD-HELP-FUNCTION (LIST "variables")
		   (LIST "STANDARD OUTPUT")
		   '*STANDARD-OUTPUT*)
(USER:ADD-HELP-FUNCTION (LIST "variables")
		   (LIST "ERROR OUTPUT")
		   '*ERROR-OUTPUT*)
(USER:ADD-HELP-FUNCTION (LIST "variables")
		   (LIST "QUERY IO")
		   '*QUERY-IO*)
(USER:ADD-HELP-FUNCTION (LIST "variables")
		   (LIST "DEBUG IO")
		   '*DEBUG-IO*)
(USER:ADD-HELP-FUNCTION (LIST "variables")
		   (LIST "TERMIANL IO")
		   '*TERMINAL-IO*)
(USER:ADD-HELP-FUNCTION (LIST "variables")
		   (LIST "TRACE OUTPUT")
		   '*TRACE-OUTPUT*)
(USER:ADD-HELP-FUNCTION (LIST "variables")
		   (LIST "READ BASE")
		   '*READ-BASE*)
(USER:ADD-HELP-FUNCTION (LIST "variables")
		   (LIST "READTABLE")
		   '*READTABLE*)
(USER:ADD-HELP-FUNCTION (LIST "variables")
		   (LIST "FEATURES")
		   '*FEATURES*)

(USER:ADD-HELP-FUNCTION (LIST "constants")
		   (LIST "INTERNAL TIME UNITS PER SECOND")
		   'INTERNAL-TIME-UNITS-PER-SECOND)
(USER:ADD-HELP-FUNCTION (LIST "constants")
		   (LIST "LAMBDA LIST KEYWORDS")
		   'LAMBDA-LIST-KEYWORDS)
(USER:ADD-HELP-FUNCTION (LIST "constants")
		   (LIST "LAMBDA PARAMETERS LIMIT")
		   'LAMBDA-PARAMETERS-LIMIT)
(USER:ADD-HELP-FUNCTION (LIST "constants")
		   (LIST "NIL")
		   'NIL)
(USER:ADD-HELP-FUNCTION (LIST "constants")
		   (LIST "PI")
		   'PI)
(USER:ADD-HELP-FUNCTION (LIST "constants")
		   (LIST "T")
		   'T)
(USER:ADD-HELP-FUNCTION (LIST "constants")
		   (LIST "BOOLE CLEAR")
		   'BOOLE-CLR)
(USER:ADD-HELP-FUNCTION (LIST "constants")
		   (LIST "BOOLE SET")
		   'BOOLE-SET)
(USER:ADD-HELP-FUNCTION (LIST "constants")
		   (LIST "BOOLE INTEGER 1")
		   'BOOLE-1)
(USER:ADD-HELP-FUNCTION (LIST "constants")
		   (LIST "BOOLE INTEGER 2")
		   'BOOLE-2)
(USER:ADD-HELP-FUNCTION (LIST "constants")
		   (LIST "BOOLE COMPLEMENT INTEGER 1")
		   'BOOLE-C1)
(USER:ADD-HELP-FUNCTION (LIST "constants")
		   (LIST "BOOLE COMPLEMENT INTEGER 2")
		   'BOOLE-C2)
(USER:ADD-HELP-FUNCTION (LIST "constants")
		   (LIST "BOOLE AND")
		   'BOOLE-AND)
(USER:ADD-HELP-FUNCTION (LIST "constants")
		   (LIST "BOOLE INCLUSIVE OR")
		   'BOOLE-IOR)
(USER:ADD-HELP-FUNCTION (LIST "constants")
		   (LIST "BOOLE EXCLUSIVE OR")
		   'BOOLE-XOR)
(USER:ADD-HELP-FUNCTION (LIST "constants")
		   (LIST "BOOLE EQUIVALENCE" "BOOLE EXCLUSIVE NOR")
		   'BOOLE-EQV)
(USER:ADD-HELP-FUNCTION (LIST "constants")
		   (LIST "BOOLE NOT AND")
		   'BOOLE-NAND)
(USER:ADD-HELP-FUNCTION (LIST "constants")
		   (LIST "BOOLE NOT OR")
		   'BOOLE-NOR)
(USER:ADD-HELP-FUNCTION (LIST "constants")
		   (LIST "BOOLE AND COMPLEMENT INT 1 WITH INT 2")
		   'BOOLE-ANDC1)
(USER:ADD-HELP-FUNCTION (LIST "constants")
		   (LIST "BOOLE AND INT 1 WITH COMPLEMENT INT 2")
		   'BOOLE-ANDC2)
(USER:ADD-HELP-FUNCTION (LIST "constants")
		   (LIST "BOOLE OR COMPLEMENT INT 1 WITH INT 2")
		   'BOOLE-ORC1)
(USER:ADD-HELP-FUNCTION (LIST "constants")
		   (LIST "BOOLE OR INT 1 WITH COMPLEMENT INT 2")
		   'BOOLE-ORC2)
(USER:ADD-HELP-FUNCTION (LIST "constants")
		   (LIST "CALL ARGUMENTS LIMIT")
		   'CALL-ARGUMENTS-LIMIT)
(USER:ADD-HELP-FUNCTION (LIST "constants")
		   (LIST "MULTIPLE VALUES LIMIT")
		   'MULTIPLE-VALUES-LIMIT)
(USER:ADD-HELP-FUNCTION (LIST "constants")
		   (LIST "MOST POSITIVE FIXNUM")
		   'MOST-POSITIVE-FIXNUM)
(USER:ADD-HELP-FUNCTION (LIST "constants")
		   (LIST "MOST NEGATIVE FIXNUM")
		   'MOST-NEGATIVE-FIXNUM)
(USER:ADD-HELP-FUNCTION (LIST "constants")
		   (LIST "MOST POSITIVE SHORT FLOAT")
		   'MOST-POSITIVE-SHORT-FLOAT)
(USER:ADD-HELP-FUNCTION (LIST "constants")
		   (LIST "LEAST POSITIVE SHORT FLOAT")
		   'LEAST-POSITIVE-SHORT-FLOAT)
(USER:ADD-HELP-FUNCTION (LIST "constants")
		   (LIST "LEAST NEGATIVE SHORT FLOAT")
		   'LEAST-NEGATIVE-SHORT-FLOAT)
(USER:ADD-HELP-FUNCTION (LIST "constants")
		   (LIST "MOST NEGATIVE SHORT FLOAT")
		   'MOST-NEGATIVE-SHORT-FLOAT)
(USER:ADD-HELP-FUNCTION (LIST "constants")
		   (LIST "MOST POSITIVE SINGLE FLOAT")
		   'MOST-POSITIVE-SINGLE-FLOAT)
(USER:ADD-HELP-FUNCTION (LIST "constants")
		   (LIST "LEAST POSITIVE SINGLE FLOAT")
		   'LEAST-POSITIVE-SINGLE-FLOAT)
(USER:ADD-HELP-FUNCTION (LIST "constants")
		   (LIST "LEAST NEGATIVE SINGLE FLOAT")
		   'LEAST-NEGATIVE-SINGLE-FLOAT)
(USER:ADD-HELP-FUNCTION (LIST "constants")
		   (LIST "MOST NEGATIVE SINGLE FLOAT")
		   'MOST-NEGATIVE-SINGLE-FLOAT)
(USER:ADD-HELP-FUNCTION (LIST "constants")
		   (LIST "MOST POSITIVE DOUBLE FLOAT")
		   'MOST-POSITIVE-DOUBLE-FLOAT)
(USER:ADD-HELP-FUNCTION (LIST "constants")
		   (LIST "LEAST POSITIVE DOUBLE FLOAT")
		   'LEAST-POSITIVE-DOUBLE-FLOAT)
(USER:ADD-HELP-FUNCTION (LIST "constants")
		   (LIST "LEAST NEGATIVE DOUBLE FLOAT")
		   'LEAST-NEGATIVE-DOUBLE-FLOAT)
(USER:ADD-HELP-FUNCTION (LIST "constants")
		   (LIST "MOST NEGATIVE DOUBLE FLOAT")
		   'MOST-NEGATIVE-DOUBLE-FLOAT)
(USER:ADD-HELP-FUNCTION (LIST "constants")
		   (LIST "MOST POSITIVE LONG FLOAT")
		   'MOST-POSITIVE-LONG-FLOAT)
(USER:ADD-HELP-FUNCTION (LIST "constants")
		   (LIST "LEAST POSITIVE LONG FLOAT")
		   'LEAST-POSITIVE-LONG-FLOAT)
(USER:ADD-HELP-FUNCTION (LIST "constants")
		   (LIST "LEAST NEGATIVE LONG FLOAT")
		   'LEAST-NEGATIVE-LONG-FLOAT)
(USER:ADD-HELP-FUNCTION (LIST "constants")
		   (LIST "MOST NEGATIVE LONG FLOAT")
		   'MOST-NEGATIVE-LONG-FLOAT)
(USER:ADD-HELP-FUNCTION (LIST "constants")
		   (LIST "SHORT FLOAT EPSILON")
		   'SHORT-FLOAT-EPSILON)
(USER:ADD-HELP-FUNCTION (LIST "constants")
		   (LIST "SINGLE FLOAT EPSILON")
		   'SINGLE-FLOAT-EPSILON)
(USER:ADD-HELP-FUNCTION (LIST "constants")
		   (LIST "DOUBLE FLOAT EPSILON")
		   'DOUBLE-FLOAT-EPSILON)
(USER:ADD-HELP-FUNCTION (LIST "constants")
		   (LIST "LONG FLOAT EPSILON")
		   'LONG-FLOAT-EPSILON)
(USER:ADD-HELP-FUNCTION (LIST "constants")
		   (LIST "SHORT FLOAT NEGATIVE EPSILON")
		   'SHORT-FLOAT-NEGATIVE-EPSILON)
(USER:ADD-HELP-FUNCTION (LIST "constants")
		   (LIST "SINGLE FLOAT NEGATIVE EPSILON")
		   'SINGLE-FLOAT-NEGATIVE-EPSILON)
(USER:ADD-HELP-FUNCTION (LIST "constants")
		   (LIST "DOUBLE FLOAT NEGATIVE EPSILON")
		   'DOUBLE-FLOAT-NEGATIVE-EPSILON)
(USER:ADD-HELP-FUNCTION (LIST "constants")
		   (LIST "LONG FLOAT NEGATIVE EPSILON")
		   'LONG-FLOAT-NEGATIVE-EPSILON)
(USER:ADD-HELP-FUNCTION (LIST "constants")
		   (LIST "CHARACTER CODE LIMIT")
		   'CHAR-CODE-LIMIT)
(USER:ADD-HELP-FUNCTION (LIST "constants")
		   (LIST "CHARACTER FONT LIMIT")
		   'CHAR-FONT-LIMIT)
(USER:ADD-HELP-FUNCTION (LIST "constants")
		   (LIST "CHARACTER BITS LIMIT")
		   'CHAR-BITS-LIMIT)
(USER:ADD-HELP-FUNCTION (LIST "constants")
		   (LIST "CHARACTER CONTROL BIT")
		   'CHAR-CONTROL-BIT)
(USER:ADD-HELP-FUNCTION (LIST "constants")
		   (LIST "CHARACTER META BIT")
		   'CHAR-META-BIT)
(USER:ADD-HELP-FUNCTION (LIST "constants")
		   (LIST "CHARACTER SUPER BIT")
		   'CHAR-SUPER-BIT)
(USER:ADD-HELP-FUNCTION (LIST "constants")
		   (LIST "CHARACTER HYPER BIT")
		   'CHAR-HYPER-BIT)
(USER:ADD-HELP-FUNCTION (LIST "constants")
		   (LIST "ARRAY RANK LIMIT")
		   'ARRAY-RANK-LIMIT)
(USER:ADD-HELP-FUNCTION (LIST "constants")
		   (LIST "ARRAY DIMENSION LIMIT")
		   'ARRAY-DIMENSION-LIMIT)
(USER:ADD-HELP-FUNCTION (LIST "constants")
		   (LIST "ARRAY TOTAL SIZE LIMIT")
		   'ARRAY-TOTAL-SIZE-LIMIT)

(COMMENT
(USER:ADD-HELP-FUNCTION (LIST "")
		   (LIST "")
		   )

(SI:SET-DOCUMENTATION '?? 'FUNCTION "NEW DOCUMENTATION")
 )

(user:add-help-function (LIST "zzz-quit-help")
		   (LIST "QUIT HELP WINDOW")
		   'quit)
