;;; -*- Mode:Common-lisp; Package:user; Base:10.; Fonts: MEDFNT,HL12B -*-

(user:add-Zhelp-function "zzz-quit-help"
                     NIL
		    "QUIT HELP WINDOW")

(user:add-zhelp-function "HELP"
                         NIL
                         "Provides help on the operation you are performing.")

(user:add-zhelp-function "COMPLETE"
                         "PATHNAME"
                         "ESCAPE performs pathname completion but does not execute.  END also completes a partial pathname but it does execute if the pathname is complete.")

(user:add-zhelp-function "COMPLETE"
                         "INPUT"
                         "END completes partial input and exits if it is unique.")

(user:add-zhelp-function "INSERT"
                         "DEFAULT PATHNAME"
                         "CTRL-SHIFT-Y inserts default pathname as text when executing one of the file commands.")

(user:add-zhelp-function "SHOW"
                         "WHERE I AM IN THE BUFFER"
                         "CTRL-=")

(user:add-zhelp-function "TEACH ZMACS"
                         NIL
                         "META-X TEACH ZMACS sets up the Zmacs tutorial.")

(user:add-zhelp-function "INSERT"
                         "LAST PATHNAME"
                         "META-SHIFT-Y inserts the last pathname as text when executing one of the file commands.")

(user:add-zhelp-function "COMPLETE"
                         "COMMAND NAME"
                         "CTRL-/ performs Apropos for the possible completions of what has been typed so far.  So does CTRL-? but it only looks for commands that begin with the typed in string.")

(user:add-zhelp-function "READ"
                         "FILE INTO DIFFERENT BUFFER"
                         "CTRL-SHIFT-F will read a file of one name into a buffer of another name.")

(user:add-zhelp-function "RETRIEVE"
                         "MINIBUFFER COMMANDS"
                         "CTRL-X ESCAPE repeats a recent minibuffer command.  A numberic argument can be used and 0 will list the commands that are remembered.")

(user:add-zhelp-function "EVALUATE"
                         "REPLACE INTO BUFFER"
                         "META-X EVALUATE AND REPLACE INTO BUFFER evaluates the symbolic expression after point and places the results into the buffer at point.  The origonal expression is deleted ant the value that is printed out replaces it.")

(user:add-zhelp-function "EVALUATE"
                         "INTO BUFFER"
                         "META-X EVALUATE INTO BUFFER evaluates a form in the minibuffer and inserts the results into the buffer at point.")

(user:add-zhelp-function "EXECUTE"
                         "COMMAND INTO BUFFER"
                         "META-X EXECUTE COMMAND INTO BUFFER executes the following editor command, printing the result into the buffer")

(user:add-zhelp-function "EXECUTE"
                         "LAST UNDONE COMMAND"
                         "CTRL-SHIFT-R or META-X REDO")

(user:add-zhelp-function "SPLIT SCREEN COMMANDS"
                         "CREATE SPLIT SCREEN"
                         "META-X SPLIT SCREEN")
(user:add-zhelp-function "SPLIT SCREEN COMMANDS"
                         "DISPLAY ONLY ONE WINDOW"
                         "CTRL-X 1 will display the window the blinking keyboard cursor is in.")
(user:add-zhelp-function "SPLIT SCREEN COMMANDS"
                         "MOVE TO ANOTHER WINDOW"
                         "CTRL-X O cycles through the windows.  A number argument will go the the specified one.  Or click the mouse on the desired window.")
(user:add-zhelp-function "SPLIT SCREEN COMMANDS"
                         "SCROLL ANOTHER WINDOW"
                         "META-CTRL-V scrolls the other window (left to right, high to low, circular). A positive numeric argument scrolls forward the specified number of lines and a negative backwards.")

(user:add-zhelp-function '("SHOW" "DISPLAY")
                         "CURRENT DEFINITION IN WINDOW"
                         "META-CTRL-R")

(user:add-zhelp-function "SEARCH"
                         "FORWARD"
                         "META-X STRING SEARCH or CTRL-S ESCAPE.  After entering either of these, press HELP for a list of options.")
(user:add-zhelp-function "SEARCH"
                         "BACKWARD"
                         "META-X REVERSE STRING SEARCH or CTRL-R ESCAPE.  After entering either of these, press HELP for a list of options.")
(user:add-zhelp-function "SEARCH"
                         "INCREMENTAL FORWARD"
                         "CTRL-S")
(user:add-zhelp-function "SEARCH"
                         "INCREMENTAL BACKWARD"
                         "CTRL-R")
(user:add-zhelp-function "SEARCH"
                         "YANK LAST INCREMENTAL STRING"
                         "CTRL-S CTRL-S")
(user:add-zhelp-function "SEARCH"
                         "EXTENDED"
                         "META-X EXTENDED STRING SEARCH and META-X EXTENDED REVERSE STRING SEARCH provide extensive capabilities.  Look in the manual for a full explanation")
(user:add-zhelp-function "SEARCH"
                         "LIMITED WILDCARDING"
                         "META-X FIND PATTERN permits ? of one symbolic expression and ?? for one or more.  CTRL-SHIFT-S is the same except ?? permits zero of more.")
(user:add-zhelp-function "LIST"
                         "LINES CONTAINING STRING"
                         "META-X LIST MATCHING LINES")
(user:add-zhelp-function "LIST"
                         "SYMBOLS SATISFYING A PREDICATE"
                         "META-X LIST MATCHING SYMBOLS")

(user:add-zhelp-function "LIST"
                         "DOCUMENTATION"
                         "HELP C displays documentation for the command on a given key,  HELP D for a command, and HELP O for a ZMACS user variable.")

(user:add-zhelp-function "SHOW"
                         "VARIABLE INFORMATION"
                         "CTRL-SHIFT-V")

(user:add-zhelp-function "LIST"
                         "COMBINED METHODS"
                         "META-X LIST COMBINED METHODS lists all methods used for a specified operation on a specified flavor")
(user:add-zhelp-function "LIST"
                         "FLAVOR METHODS"
                         "META-X LIST FLAVOR METHODS")
(user:add-zhelp-function "LIST"
                         "METHODS"
                         "META-X LIST METHODS lists all flavors with methods fo a specified message")
(user:add-zhelp-function "SHOW"
                         "FUNCTION DOCUMENTATION"
                         "META-SHIFT-D provides long documentation for the specified function.  This includes the arguments.  CTRL-SHIFT-D does the same thing for the function presently being looked at.")


(user:add-zhelp-function "FIND"
                         "COMMANDS"
                         "HELP A finds commands whose names contain a given string.  So does META-X APROPOS")
(user:add-zhelp-function "FIND"
                         "FUNCTIONS"
                         "META-X FUNCTION APROPOS list functions whose names contain a specified string.")
(user:add-zhelp-function "FIND"
                         "VARIABLES"
                         "HELP V finds user variables whose names contain a given string.  So does META-X VARIABLE APROPOS.")

(user:add-zhelp-function "LIST"
                         "KEYSTROKES"
                         "HELP L lists the last 60 keystrokes you typed.  So does META-X LIST KEYSTROKE HISTORY.")

(user:add-zhelp-function "UNDO"
                         NIL
                         "HELP U undoes the last command.  CTRL-SHIFT-U also undoes the last command but it does not query you for approval whil HELP U does.")

(user:add-zhelp-function "KEYSTROKE"
                         "FOR A COMMAND"
                         "HELP W and META-X WHERE IS tell what keystroke is associated with a specified command")
(user:add-zhelp-function "KEYSTROKE"
                         "SPECIAL CHARACTERS"
                         "HELP S lists the keystrokes for characters that are not on keycaps.")

(user:add-zhelp-function "SHOW"
                         "SYMBOL'S PACKAGE"
                         "META-X WHERE IS SYMBOL")

(user:add-zhelp-function '("SHOW" "LIST")
                         "FUNCTION ARGUMENTS"
                         "META-X ARGLIST lists the arguments for a specified function.  CTRL-SHIFT-A list the arguments for the function to the left of the cursor."
)

(user:add-zhelp-function "LIST"
                         "BUFFERS"
                         "CTRL-X CTRL-B")
(user:add-zhelp-function '("SELECT" "FIND")
                         "PREVIOUS BUFFER"
                         "META-CTRL-L")
(user:add-zhelp-function '("SELECT" "FIND")
                         "DEFAULT PREVIOUS BUFFER"
                         "CTRL-X META-CTRL-L")
(user:add-zhelp-function '("SELECT" "FIND")
                         "SPECIFIED BUFFER"
                         "CTRL-X B")
(user:add-zhelp-function "CREATE"
                         "BUFFER"
                         "CTRL-X B prompts for a buffer name.  If new name is entered it tells you it does not exist.  Pressing RETURN will create it.")
(user:add-zhelp-function '("FIND" "READ")
                         "FILE"
                         "CTRL-X CTRL-F.  You can use CTRL-X CTRL-V to visit a file in the current buffer, discarding what is already there.")
(user:add-zhelp-function '("SAVE" "WRITE")
                         "FILE"
                         "CTRL-X CTRL-S writes the buffer to the file it origonated from incrementing the version number.  CTRL-X CTRL-W prompts you for a pathname to write the buffer to.")
(user:add-zhelp-function "CURSOR MOVEMENT"
                         "CHARACTER"
                         "CTRL-B or  moves backward a character and CTRL-F or  moves forward a character.")
(user:add-zhelp-function "CURSOR MOVEMENT"
                         "WORD"
                         "META-B or META- moves backward a word and META-F or MTEA- moves forward a word.")
(user:add-zhelp-function "CURSOR MOVEMENT"
                         "SYMBOLIC EXPRESION"
                         "META-CTRL-B or META-CTRL- moves backward an expression, META-X BACKWARD SEXP NO UP moves backward an expression but not over an unbalanced open parenthesis, META-CTRL-F or META-CTRL- moves forward an expression, and META-X FORWARD SEXP NO UP moves forward an expression but not over an unbalanced closing parenthesis.")

(user:add-zhelp-function "CURSOR MOVEMENT"
                         "LINE"
                         "META-M moves back to indentation, CTRL-A or SUPER- moves to beginning of line,  and CTRL-E or SUPER- moves to the end of the line.  META-N moves to the next line and positions where a comment should be added (a ; is entered), META-X DOWN INDENTED LINE moves to the next line to the first nonblank character, and CTRL-N or  moves down a line.  META-P is the opposite of META-N, META-X UP INDENTED LINE is the opposite of DOWN, and CTRL-P or  moves up a line")

(user:add-zhelp-function "CURSOR MOVEMENT"
                         "LISTS"
                         "META-X BACKWARD DOWN LIST, META-CTRL-P moves backwards through a list, META-CTRL-( moves backwards up a list, META-CTRL-D moves down a list, META-CTRL-N moves forward through a list, META-CTRL-) moves forward up a list, and META-) moves over the )")

(user:add-zhelp-function "FIND"
                         "UNBALANCED PARENTHESES"
                         "CTRL-(")

(user:add-zhelp-function "CURSOR MOVEMENT"
                         "DEFINITIONS"
                         "META-CTRL-[ or META-CTRL- moves to the beginning of the definition and META-CTRL-] or META-CTRL- to the end.")

(user:add-zhelp-function "CURSOR MOVEMENT"
                         "SENTENCE"
                         "META-A or META- goes to the beginning of the sentence and META-E or META- to the end.")

(user:add-zhelp-function "CURSOR MOVEMENT"
                         "BUFFER"
                         "META-< or HYPER- moves to the beginning of the buffer and META-> or HYPER- to the end.")

(user:add-zhelp-function "CURSOR MOVEMENT"
                         "SCREEN"
                         "SUPER- moves to the bottom of the screen and SUPER- to the top.")

(user:add-zhelp-function "CURSOR MOVEMENT"
                         "PARAGRAPH"
                         "META-[ moves to the beginning of the paragraph and META-] to the end.")

(user:add-zhelp-function "EVALUATE"		
                         "MINIBUFFER"		
                         "META-ESCAPE")
(user:add-zhelp-function "UNMARK"
                         "REGION"
                         "CTRL-G unmarks a region and also clears partially entered commands in the minibuffer.")
(user:add-zhelp-function "ABORT"
                         NIL
                         "The ABORT key aborts commands that are waiting for input.  CTRL-ABORT aborts almost any operation and CTRL-META-ABORT aborts everything CTRL-ABORT does and more.  This is the most powerful abort.")
(user:add-zhelp-function "CREATE"
                         "DIRECTORY"
                         "META-X CREATE DIRECTORY")

(user:add-zhelp-function "EVALUATE"
                         "REGION"
                         "META-SHIFT-E is defined to be Evaluate Region Verbose.  It evaluates the current region or definition.  CTRL-SHIFT-E also does this and META-X EVALUATE REGION also evaluates a region.  META-CTRL-SHIFT-E also evaluates the current region or definition.")

(user:add-zhelp-function "COMPILE"
                         "REGION"
                         "CTRL-SHIFT-C")

(user:add-zhelp-function "COMPILE"
                         "BUFFER'S CHANGED DEFINITIONS"
                         "META-X COMPILE BUFFER CHANGED DEFINITIONS compiles any definitions in this buffer that have been edited.")

(user:add-zhelp-function "COMPILE"
                         "ALL BUFFER's CHANGED DEFINITIONS"
                         "META-X COMPILE CHANGED DEFINITIONS compiles any definitions in all buffers that have been edited.")

(user:add-zhelp-function "EVALUATE"
                         "BUFFER'S CHANGED DEFINITIONS"
                         "META-X EVALUATE BUFFER CHANGED DEFINITIONS evaluates any definitions in this buffer that have been edited.")

(user:add-zhelp-function "EVALUATE"
                         "ALL BUFFER's CHANGED DEFINITIONS"
                         "META-X EVALUATE CHANGED DEFINITIONS evaluates any definitions in all buffers that have been edited.")

(user:add-zhelp-function "EVALUATE"
                         "BUFFER AND EXIT"
                         "META-CTRL-Z evaluates the entire buffer and exits the editor if there are no errors.")

(user:add-zhelp-function "EVALUATE"
                         "BUFFER"
                         "META-X EVALUATE BUFFER")

(user:add-zhelp-function "COMPILE"
                         "BUFFER AND EXIT"
                         "META-Z compiles the entire buffer and exits the editor if there are no errors.")

(user:add-zhelp-function "COMPILE"
                         "BUFFER"
                         "META-X COMPILE BUFFER")

(user:add-zhelp-function "COMPILE"
                         "FILE"
                         "META-X COMPILE FILE")

(user:add-zhelp-function "UPDATE"
                         "XFASL"
                         "CTRL-X META-CTRL-SHIFT-C updates the XFASL file of the files you are visiting.")

(user:add-zhelp-function "COMPILE"
                         "AND LOAD FILE"
                         "META-X COMPILE AND LOAD FILE")

(user:add-zhelp-function "LOAD"
                         "FILE"
                         "META-X LOAD FILE")

(user:add-zhelp-function "LIST"
                         "CALLERS OF A FUNTION"
                         "META-X LIST CALLERS or MULTIPLE LIST CALLERS")

(user:add-zhelp-function '("EDIT" "FIND")
                         "DEFINITIONS"
                         "META-. edits the definition of a specified function")
(user:add-zhelp-function '("EDIT" "FIND")
                         "KEY FUNCTION"
                         "META-CTRL-. edits the definition of a function installed on a specified key.")

(user:add-zhelp-function "SCROLL"
                         "SCREEN FORWARD"
                         "CTRL-V or CTRL- will scroll forward one screen.  If a numberic argument is provided, they scroll forward the specified number of lines.")

(user:add-zhelp-function "SCROLL"
                         "SCREEN BACKWARD"
                         "META-V or CTRL- will scroll backward one screen.  If a numberic argument is provided, they scroll backward the specified number of lines.")

(user:add-zhelp-function "NUMERIC ARGUMENT"
                         NIL
                         "By pressing CTRL-digit, where digit is 0 through 9, before a command, the command uses the digit as an to do something digit number of times.  The something depends on the command.  For larger numbers you can do CTRL-digit CTRL-digit.  For example the argument 20 would be CTRL-2 CTRL-0.  CTRL-U is called the Universal Argument.  It multiplies the current argument by 4.  For example CTRL-3 CTRL-U CTRL-F moves the cursor forward 12 characters.")

(user:add-zhelp-function "APPEND"
                         "TO BUFFER"
                         "CTRL-X A")

(user:add-zhelp-function "INSERT"
                         "BUFFER"
                         "META-X INSERT BUFFER inserts a copy of teh specified buffer at point.")

(user:add-zhelp-function '("KILL" "REMOVE")
                         "BUFFER"
                         "CTRL-X K")

(user:add-zhelp-function '("KILL" "REMOVE")
                         "OR SAVE BUFFERS"
                         "META-X KILL OR SAVE BUFFERS")

(user:add-zhelp-function "SAVE"
                         "BUFFERS"
                         "META-X KILL OR SAVE BUFFERS")

(user:add-zhelp-function '("KILL" "REMOVE")
                         "SOME BUFFERS"
                         "META-X KILL SOME BUFFERS")

(user:add-zhelp-function "EDIT"
                         "LIST OF BUFFERS"
                         "META-X BUFFER EDIT or META-X EDIT BUFFERS")

(user:add-zhelp-function "EDIT"
                         "BUFFER'S CHANGED DEFINITIONS"
                         "META-X EDIT BUFFER CHANGED DEFINITIONS")

(user:add-zhelp-function "EDIT"
                         "ALL BUFFER'S CHANGED DEFINITIONS"
                         "META-X EDIT CHANGED DEFINITIONS")

(user:add-zhelp-function "LIST"
                         "ALL CHANGED DEFINITIONS"
                         "META-X LIST CHANGED DEFINITIONS")

(user:add-zhelp-function "LIST"
                         "BUFFER'S CHANGED DEFINITIONS"
                         "META-X LIST BUFFER CHANGED DEFINITIONS")

(user:add-zhelp-function "LIST"
                         "SECTIONS"
                         "META-X LIST SECTIONS of a buffer.")

(user:add-zhelp-function "LIST"
                         "MODIFICATIONS"
                         "METX-X LIST MODIFICATIONS in all lines of a buffer.")

(user:add-zhelp-function "UNMODIFY"
                         "BUFFER"
                         "META-~ marks the buffer as not being modified.")

(user:add-zhelp-function "RENAME"
                         "BUFFER"
                         "META-X RENAME BUFFER")

(user:add-zhelp-function "SECTIONIZE"
                         "BUFFER"
                         "META-X SECTIONIZE BUFFER")

(user:add-zhelp-function "READ ONLY"
                         "TOGGLE"
                         "CTRL-X R toggles whether the buffer is read-only or modifiable.")

(user:add-zhelp-function '("VIEW" "SHOW")
                         "BUFFER"
                         "CTRL-V")

(user:add-zhelp-function "PRINT"
                         "ALL BUFFERS"
                         "META-X PRINT ALL BUFFERS")

(user:add-zhelp-function "PRINT"
                         "BUFFER"
                         "META-X PRINT BUFFER.  You can press CTRL-SHIFT-F when prompted to specify a file name.")

(user:add-zhelp-function "PRINT"
                         "CURRENT BUFFER"
                         "META-SHIFT-P")

(user:add-zhelp-function "REVERT"
                         "BUFFER"
                         "CTRL-X CTRL-R")

(user:add-zhelp-function "EDIT" 
                         "COMPILER WARNINGS"
                         "META-X EDIT WARNINGS and META-X EDIT COMPILER WARNINGS")

(user:add-zhelp-function "WARNINGS"
                         "COMPILER"
                         "META-X EDIT WARNINGS and META-X EDIT COMPILER WARNINGS")

(user:add-zhelp-function "EDIT"
                         "FILE WARNINGS"
                         "META-X EDIT FILE WARNINGS")

(user:add-zhelp-function "WARNINGS"
                         "FILE"
                         "META-X EDIT FILE WARNINGS")

(user:add-zhelp-function "EDIT"
                         "SYSTEM WARNINGS"
                         "META-X EDIT SYSTEM WARNINGS")

(user:add-zhelp-function "WARNINGS"
                         "SYSTEM"
                         "META-X EDIT SYSTEM WARNINGS")

(user:add-zhelp-function "EDIT"
                         "NEXT WARNING"
                         "CTRL-SHIFT-W")

(user:add-zhelp-function "WARNINGS"
                         "EDIT NEXT"
                         "CTRL-SHIFT-W")

(user:add-zhelp-function "EDIT"
                         "PREVIOUS WARNING"
                         "META-SHIFT-W")

(user:add-zhelp-function "WARNINGS"
                         "EDIT PREVIOUS"
                         "META-SHIFT-W")

(user:add-zhelp-function "WARNINGS"
                         "GO TO"
                         "CTRL-/ ")

(user:add-zhelp-function "INSERT"
                         "FILE WARNINGS"
                         "META-X INSERT FILE WARNINGS")

(user:add-zhelp-function "WARNINGS"
                         "INSERT FILE'S"
                         "META-X INSERT FILE WARNINGS")

(user:add-zhelp-function "INSERT"
                         "ALL FILES WARNINGS"
                         "META-X INSERT WARNINGS")

(user:add-zhelp-function "WARNINGS"
                         "INSERT ALL FILES'"
                         "META-X INSERT WARNINGS")

(user:add-zhelp-function "DISASSEMBLE"
                         "SPECIFIED FUNCTION"
                         "META-X DISASSEMBLE")
(user:add-zhelp-function "DISASSEMBLE"
                         "CURSOR SPECIFIED FUNCTION"
                         "META-X QUICK DISASSEMBLE")

(user:add-zhelp-function "CURSOR POSITIONING"
                         "MOVE TO REGISTER POSITION"
                         "CTRL-X J")
(user:add-zhelp-function "CURSOR POSITIONING"
                         "MOVE TO DEFAULT PREVIOUS POSITION"
                         "CTRL-X META-CTRL-space bar")
(user:add-zhelp-function "CURSOR POSITIONING"
                         "MOVE TO PREVIOUS POSITION"
                         "META-CTRL-space bar")
(user:add-zhelp-function "CURSOR POSITIONING"
                         "SAVE OR SWAP POINT"
                         "META-space bar")
(user:add-zhelp-function "CURSOR POSITIONING"
                         "SAVE POSITION IN REGISTER"
                         "CTRL-X S")
(user:add-zhelp-function "CURSOR POSITIONING"
                         "SET OR POP MARK"
                         "CTRL-space bar")
(user:add-zhelp-function "CURSOR POSITIONING"
                         "SHOW POINTS"
                         "META-STATUS")
(user:add-zhelp-function "CURSOR POSITIONING"
                         "SHOW REGISTERS"
                         "META-X SHOW SAVED POSITIONS")
(user:add-zhelp-function "CURSOR POSITIONING"
                         "SWAP POINT AND MARK"
                         "CTRL-X CTRL-X")

(user:add-zhelp-function "OMNIPOTENT"
                         NIL
                         "CTRL-Q does many things.  Sometime, when we have the time, I will tell you about them.  Until then, look it up in the manual.")

(user:add-zhelp-function '("INSTALL" "CUSTOMIZE")
                         "COMMAND ON KEY"
                         "META-X INSTALL COMMAND ON KEY")
(user:add-zhelp-function "KEYBOARD MACRO"
                         "START DEFINITION"
                         "CTRL-X (")
(user:add-zhelp-function "KEYBOARD MACRO"
                         "END DEFINITION"
                         "CTRL-X )")
(user:add-zhelp-function "KEYBOARD MACRO"
                         "REPEAT LAST ONE"
                         "CTRL-X E")
(user:add-zhelp-function "KEYBOARD MACRO"
                         "NAME LAST ONE"
                         "META-X NAME LAST KBD MACRO")
(user:add-zhelp-function "KEYBOARD MACRO"
                         "INSTALL AS KEY"
                         "META-X INSTALL MACRO")
(user:add-zhelp-function "KEYBOARD MACRO"
                         "INSTALL AS MOUSE BUTTON"
                         "META-X INSTALL MOUSE MACRO")
(user:add-zhelp-function "KEYBOARD MACRO"
                         "VIEW"
                         "META-X VIEW KBD MACRO")
(user:add-zhelp-function "KEYBOARD MACRO"
                         "DEINSTALL"
                         "META-X DEINSTALL MACRO")
(user:add-zhelp-function "KEYBOARD MACRO"
                         "CREATE INTERACTIVE"
                         "CTRL-X Q")

(user:add-zhelp-function "CUSTOMIZE"
                         "KEY STROKES"
                         "See KEYBOARD MACRO")

(user:add-zhelp-function "CUSTOMIZE"
                         "LIST VARIABLES"
                         "META-X LIST VARIABLES and HELP V (variable apropos) both identify the variables that can be modified by the user.")
(user:add-zhelp-function "CUSTOMIZE"
                         "SET VARIABLE"
                         "META-X SET VARIABLE")
(user:add-zhelp-function "CUSTOMIZE"
                         "LIST BUFFER LOCAL VARIABLES"
                         "META-X LIST LOCAL VARIABLES")
(user:add-zhelp-function "CUSTOMIZE"
                         "MAKE VARIABLE LOCAL TO BUFFER"
                         "META-X MAKE LOCAL VARIABLE")
(user:add-zhelp-function "CUSTOMIZE"
                         "MAKE BUFFER VARIABLE GLOBAL"
                         "META-X KILL LOCAL VARIABLE")

(user:add-zhelp-function "CUSTOMIZE"
                         "WORD ABBREVIATIONS"
                         "see WORD ABBREVIATIONS")

(user:add-zhelp-function "WORD ABBREVIATIONS"
                         "ADD GLOBAL"
                         "CTRL-X +")
(user:add-zhelp-function "WORD ABBREVIATIONS"
                         "ADD MODE"
                         "CTRL-X CTRL-A")
(user:add-zhelp-function "WORD ABBREVIATIONS"
                         "DEFINE"
                         "META-X DEFINE WORD ABBREVS")
(user:add-zhelp-function "WORD ABBREVIATIONS"
                         "EDIT"
                         "META-X EDIT WORD ABBREVS")
(user:add-zhelp-function "WORD ABBREVIATIONS"
                         "EXPAND WHEN MODE IS OFF"
                         "META-CTRL-space bar")
(user:add-zhelp-function "WORD ABBREVIATIONS"
                         "INSERT"
                         "META-X INSERT WORD ABBREVS")
(user:add-zhelp-function "WORD ABBREVIATIONS"
                         "KILL ALL"
                         "META-X KILL ALL WORD ABBREVS")
(user:add-zhelp-function "WORD ABBREVIATIONS"
                         "KILL GLOBAL"
                         "META-X KILL GLOBAL WORD ABBREVS")
(user:add-zhelp-function "WORD ABBREVIATIONS"
                         "KILL MODE"
                         "META-X KILL MODE WORD ABBREVS")
(user:add-zhelp-function "WORD ABBREVIATIONS"
                         "LIST SOME"
                         "META-X LIST SOME WORD ABBREVS")
(user:add-zhelp-function "WORD ABBREVIATIONS"
                         "LIST ALL"
                         "META-X LIST WORD ABBREVS")
(user:add-zhelp-function "WORD ABBREVIATIONS"
                         "MAKE"
                         "META-X MAKE WORD ABBREVS")
(user:add-zhelp-function "WORD ABBREVIATIONS"
                         "LOAD FILE"
                         "META-X READ WORD ABBREVS FILE")
(user:add-zhelp-function "WORD ABBREVIATIONS"
                         "SAVE TO FILE"
                         "META-X SAVE WORD ABBREVS FILE")
(user:add-zhelp-function "WORD ABBREVIATIONS"
                         "UNDO LAST EXPANSION"
                         "META-X UNEXPAND WORD ABBREVS")
(user:add-zhelp-function "WORD ABBREVIATIONS"
                         "ACTIVATE MODE"
                         "META-X WORD ABBREVS MODE")
(user:add-zhelp-function "WORD ABBREVIATIONS"
                         "PREFIX MARK"
                         "META-X WORD ABBREVS PREFIX MARK")
(user:add-zhelp-function "WORD ABBREVIATIONS"
                         "WRITE INCONDENSED FORM"
                         "META-X WRITE WORD ABBREVS FILE")

(user:add-zhelp-function "DELETE"
                         "CHARACTER BACKWARDS"
                         "RUBOUT key")
(user:add-zhelp-function "DELETE"
                         "BLANK LINES AFTER THIS ONE"
                         "CTRL-X CTRL-O")
(user:add-zhelp-function "DELETE"
                         "CHARACTER FORWARD"
                         "CTRL-D")
(user:add-zhelp-function "DELETE"
                         "SPACES AROUND CURSOR"
                         "META-\ ")
(user:add-zhelp-function "DELETE" 
                         "INDENTATION AND RETURN CHAR"
                         "META-^")
(user:add-zhelp-function "DELETE"
                         "LINES CONTAINING STRING"
                         "META-X DELETE MATCHING LINES")
(user:add-zhelp-function "DELETE"
                         "LINES NOT CONTAINING STRING"
                         "META-X DELETE NON MATCHING LINES")
(user:add-zhelp-function "DELETE"
                         "PARENTHESES PAIR"
                         "META-X DELETE ()")
(user:add-zhelp-function "DELETE"
                         "CHAR CHANGING TABS TO SPACES"
                         "META-X TAB HACKING DELETE FORWARD")

(user:add-zhelp-function "KILL"
                         "APPEND TO LAST KILL ENTRY"
                         "META-CTRL-W")
(user:add-zhelp-function "KILL"
                         "SENTENCE BACKWARDS"
                         "CTRL-X RUBOUT")
(user:add-zhelp-function "KILL"
                         "SYMBOLIC EXPRESSION BACKWARDS"
                         "META-CTRL-RUBOUT")
(user:add-zhelp-function "KILL"
                         "SYMBOLIC EXPRESSION BACKWARDS NO UP"
                         "META-X BACKWARD KILL SEXP NO UP")
(user:add-zhelp-function "KILL"
                         "WORD BACKWARDS"
                         "META-RUBOUT")
(user:add-zhelp-function "KILL"
                         "BACKWARD UP LIST"
                         "META-X KILL BACKWARD UP LIST")
(user:add-zhelp-function "KILL"
                         "TO END OF LINE"
                         "CTRL-K")
(user:add-zhelp-function "KILL"
                         "BACK TO START OF LINE"
                         "CLEAR INPUT")
(user:add-zhelp-function "KILL"
                         "REGION"
                         "CTRL-W")
(user:add-zhelp-function "KILL"
                         "FORWARD SENTENCE"
                         "META-K")
(user:add-zhelp-function "KILL"
                         "FORWARD SYMBOLIC EXPRESSION"
                         "META-CTRL-K")
(user:add-zhelp-function "KILL"
                         "FORWARD SYMBOLIC EXPRESSION NO UP"
                         "META-X KILL SEXP NO UP")
(user:add-zhelp-function "KILL"
                         "FORWARD WORD"
                         "META-D")
(user:add-zhelp-function "SAVE"
                         "REGION"
                         "META-W")
(user:add-zhelp-function "POSITION"
                         "TO BEGINNING OF BUFFER"
                         "CTRL-<")
(user:add-zhelp-function "POSITION AND MARK"
                         "CURRENT DEFINITION"
                         "META-CTRL-H")
(user:add-zhelp-function "POSITION"
                         "TO END OF BUFFER"
                         "CTRL->")
(user:add-zhelp-function "POSITION AND MARK"
                         "CURRENT PAGE"
                         "CTRL-X CTRL-P")
(user:add-zhelp-function "POSITION AND MARK"
                         "CURRENT PARAGRAPH"
                         "META-H")
(user:add-zhelp-function "MARK"
                         "SYMBOLIC EXPRESSION"
                         "META-CTRL-@")
(user:add-zhelp-function "POSITION AND MARK"
                         "BUFFER"
                         "CTRL-X H")
(user:add-zhelp-function "MARK"
                         "WORD"
                         "META-@")
(user:add-zhelp-function "MARK"
                         "SET OR POP"
                         "CTRL-space bar.  This command does three different things that I'll tell you about sometime.")

(user:add-zhelp-function "REGISTER"
                         "SAVE TEXT FROM REGION"
                         "CTRL-X X")
(user:add-zhelp-function "REGISTER"
                         "SAVE POSITION"
                         "CTRL-X S")
(user:add-zhelp-function "REGISTER"
                         "LIST"
                         "META-X LIST REGISTERS")
(user:add-zhelp-function "LIST"
                         "REGISTERS"
                         "META-X LIST REGISTERS")
(user:add-zhelp-function "REGISTER"
                         "SHOW ALL"
                         "META-X SHOW ALL REGISTERS")
(user:add-zhelp-function "REGISTER"
                         "SHOW SAVED POSITIONS"
                         "META-X SHOW SAVED POSITIONS")
(user:add-zhelp-function "REGISTER"
                         "VIEW"
                         "META-X VIEW REGISTER")
(user:add-zhelp-function "REGISTER"
                         "GET TEXT FROM REGISTER"
                         "META-X GET REGISTER or CTRL-X G.  The first leaves point before and mark after the text and the second vice-versa.")
(user:add-zhelp-function "REGISTER"
                         "JUMP TO POSITION"
                         "CTRL-X J")
(user:add-zhelp-function "REGISTER"
                         "KILL"
                         "META-X KILL REGISTER")

(user:add-zhelp-function "COPY"
                         "PREVIOUS LINE"
                         "META-X COPY FROM PREVIOUS LINE")
(user:add-zhelp-function "SHOW"
                         "KILL HISTORY"
                         "CTRL-STATUS")
(user:add-zhelp-function '("RETRIEVE" "YANK")
                         "LAST BLOCK"
                         "CTRL-Y")
(user:add-zhelp-function '("RETRIEVE" "YANK")
                         "SOMETHING FROM KILL RING"
                         "META-Y executed immediately after a CTRL-Y or META-Y")
(user:add-zhelp-function "DELETE"
                         "EXCESS FILE VERSIONS"
                         "META-X CLEAN DIRECTORY")
(user:add-zhelp-function "CREATE"
                         "DIRECTORY"
                         "META-X CREATE DIRECTORY")
(user:add-zhelp-function '("SHOW" "DISPLAY")
                         "DIRECTORY"
                         "CTRL-X D")
(user:add-zhelp-function "EXPUNGE"
                         "DIRECTORY"
                         "META-X EXPUNGE DIRECTORY")
(user:add-zhelp-function "LIST"
                         "ALL DIRECTORY NAMES"
                         "META-X LIST ALL DIRECTORY NAMES")
(user:add-zhelp-function "LIST"
                         "FILES IN A DIRESTORY"
                         "META-X LIST FILES")
(user:add-zhelp-function "VIEW"
                         "DIRECTORY"
                         "META-X VIEW DIRECTORY")
(user:add-zhelp-function "VIEW"
                         "LOGIN DIRECTORY"
                         "META-X VIEW LOGIN DIRECTORY")

(user:add-zhelp-function "DIRED"
                         "ENTER"
                         "CTRL-X CTRL-D or META-X DIRED")
(user:add-zhelp-function "DIRED"
                         "HELP"
                         "HELP followed by M")
(user:add-zhelp-function "DIRED"
                         "EDIT FILE"
                         "E")
(user:add-zhelp-function "DIRED"
                         "DIRED OF SUPERIOR DIRECTORY"
                         "<")
(user:add-zhelp-function "DIRED"
                         "MARK FILE TO BE READ IN"
                         "F")
(user:add-zhelp-function "DIRED"
                         "VIEW FILE"
                         "V")
(user:add-zhelp-function "DIRED"
                         "MARK FILE FOR DELETION"
                         "D")
(user:add-zhelp-function "DIRED"
                         "MARK FILES TO HAVE FUNCTION APPLIED"
                         "A")
(user:add-zhelp-function "DIRED"
                         "UNMARK PREVIOUS FILE"
                         "RUBOUT")
(user:add-zhelp-function "DIRED"
                         "UNMARK FILE"
                         "U")
(user:add-zhelp-function "DIRED"
                         "FIND FILES WITH TOO MANY VERSION"
                         "N")
(user:add-zhelp-function "DIRED"
                         "MARK EXCESSIVE VERSIONS FOR DELETION"
                         "H.  If a numeric argument is provided, all files with excessive versions are marked for deletion.")
(user:add-zhelp-function "DIRED"
                         "EXIT"
                         "Q")
(user:add-zhelp-function "DIRED"
                         "EXECUTE MARKED OPERATIONS"
                         "X")
(user:add-zhelp-function "DIRED"
                         "RENAME FILE"
                         "R")
(user:add-zhelp-function "DIRED"
                         "COPY FILE"
                         "C")
(user:add-zhelp-function "DIRED"
                         "COMPILE FILE"
                         "B")
(user:add-zhelp-function "DIRED"
                         "LOAD FILE"
                         "L")
(user:add-zhelp-function "DIRED"
                         "DIRED OF SUBDIRECTORY"
                         "S")
(user:add-zhelp-function "DIRED"
                         "FIND NEXT FILE NOT BACKED UP"
                         "!")
(user:add-zhelp-function "DIRED"
                         "TOGGLE DON'T DELETE FLAG"
                         "@")
(user:add-zhelp-function "DIRED"
                         "TOGGLE DON'T SUPERSEDE FLAG"
                         "#")
(user:add-zhelp-function "DIRED"
                         "TOGGLE DON'T DELETE EXCESS VERSIONS FLAG"
                         "$")
(user:add-zhelp-function "DIRED"
                         "SHOW FILE ATTRIBUTES"
                         ",")
(user:add-zhelp-function "DIRED"
                         "CHANGE FILE PROPERTIES"
                         ".")
(user:add-zhelp-function "DIRED"
                         "SOURCE COMPARE AGAINST HIGHEST VERSION"
                         "=")
(user:add-zhelp-function "DIRED"
                         "SORT BY CREATION DATE"
                         "META-X SORT DECREASING CREATION DATE and META-X SORT INCREASING CREATION DATE")
(user:add-zhelp-function "DIRED"
                         "SORT BY FILENAME"
                         "META-X SORT DECREASING FILENAME and META-X SORT INCREASING FILENAME")
(user:add-zhelp-function "DIRED"
                         "SORT BY REFERENCE DATE"
                         "META-X SORT DECREASING REFERENCE DATE and META-X SORT INCREASING REFERENCE DATE")
(user:add-zhelp-function "DIRED"
                         "SORT BY SIZE"
                         "META-X SORT BY DECREASING SIZE and META-X SORT BY INCREASING SIZE")

(user:add-zhelp-function "LIST"
                         "VARIABLES"
                         "META-X LIST VARIABLES")

(user:add-zhelp-function "CHANGE"
                         "FILE PROPERTIES"
                         "META-X CHANGE FILE PROPERTIES")
(user:add-zhelp-function "COPY"
                         "BINARY FILE"
                         "META-X COPY BINARY FILE")
(user:add-zhelp-function "COPY"
                         "FILE"
                         "META-X COPY FILE.  An argument of 2 copies in binary mode, 3 copies in character mode, 4 does not copy the date or author, 5 does not copy the creation date or the author and copies in binary mode, and 6 does not copy the creation date or author and copies in character mode.")
(user:add-zhelp-function "COPY"
                         "TEXT FILE"
                         "META-X COPY TEXT FILE")
(user:add-zhelp-function "DELETE"
                         "FILE"
                         "META-X DELETE FILE")
(user:add-zhelp-function "DELETE"
                         "EXCESS VERSIONS OF FILE"
                         "META-X REAP FILE")
(user:add-zhelp-function "SET"
                         "VERSION LIMIT"
                         "META-X SET VERSION LIMIT")
(user:add-zhelp-function "UNDELETE"
                         "FILE"
                         "META-X UNDELETE FILE")
(user:add-zhelp-function "FIND"
                         "FILE NO SECTIONIZE"
                         "META-X FIND FILE NO SECTIONIZE")
(user:add-zhelp-function "FIND"
                         "ALL FILES OF A SYSTEM"
                         "META-X FIND SYSTEM FILES")
(user:add-zhelp-function "VIEW"
                         "FILE"
                         "META-X VIEW FILE")
(user:add-zhelp-function "APPEND"
                         "REGION TO FILE"
                         "META-X APPEND TO FILE")
(user:add-zhelp-function "INSERT"
                         "FILE"
                         "META-X INSERT FILE")
(user:add-zhelp-function "INSERT"
                         "FILE NO FONTS"
                         "META-X INSERT FILE NO FONTS")
(user:add-zhelp-function "PREPEND"
                         "REGION TO FILE"
                         "META-X PREPEND TO FILE")
(user:add-zhelp-function "PRINT"
                         "FILE"
                         "META-X PRINT FILE")
(user:add-zhelp-function "PRINT"
                         "REGION"
                         "META-X PRINT REGION")
(user:add-zhelp-function "RENAME"
                         "FILE"
                         "META-X RENAME FILE")
(user:add-zhelp-function "SET"
                         "DEFAULT FILENAME"
                         "META-X SET DEFAULT FILENAME")
(user:add-zhelp-function "CHANGE"
                         "FILE ASSOCIATED WITH BUFFER"
                         "META-X SET VISITED FILENAME")

(user:add-zhelp-function "FILE"
                         "CHANGE PROPERTIES"
                         "META-X CHANGE FILE PROPERTIES")
(user:add-zhelp-function "FILE"
                         "BINARY COPY"
                         "META-X COPY BINARY FILE")
(user:add-zhelp-function "FILE"
                         "COPY"
                         "META-X COPY FILE.  An argument of 2 copies in binary mode, 3 copies in character mode, 4 does not copy the date or author, 5 does not copy the creation date or the author and copies in binary mode, and 6 does not copy the creation date or author and copies in character mode.")
(user:add-zhelp-function "FILE"
                         "TEXTCOPY"
                         "META-X COPY TEXT FILE")
(user:add-zhelp-function "FILE"
                         "DELETE"
                         "META-X DELETE FILE")
(user:add-zhelp-function "FILE"
                         "DELETE EXCESS VERSIONS"
                         "META-X REAP FILE")
(user:add-zhelp-function "FILE"
                         "SET VERSION LIMIT"
                         "META-X SET VERSION LIMIT")
(user:add-zhelp-function "FILE"
                         "UNDELETE"
                         "META-X UNDELETE FILE")
(user:add-zhelp-function "FILE"
                         "FIND WITH NO SECTIONIZE"
                         "META-X FIND FILE NO SECTIONIZE")
(user:add-zhelp-function "FILE"
                         "FIND ALL OF A SYSTEM"
                         "META-X FIND SYSTEM FILES")
(user:add-zhelp-function "FILE"
                         "VIEW"
                         "META-X VIEW FILE")
(user:add-zhelp-function "FILE"
                         "APPEND REGION"
                         "META-X APPEND TO FILE")
(user:add-zhelp-function "FILE"
                         "INSERT"
                         "META-X INSERT FILE")
(user:add-zhelp-function "FILE"
                         "INSERT NO FONTS"
                         "META-X INSERT FILE NO FONTS")
(user:add-zhelp-function "FILE"
                         "PREPEND REGION"
                         "META-X PREPEND TO FILE")
(user:add-zhelp-function "FILE"
                         "PRINT"
                         "META-X PRINT FILE")
(user:add-zhelp-function "FILE"
                         "RENAME"
                         "META-X RENAME FILE")
(user:add-zhelp-function "FILE"
                         "SET DEFAULT FILENAME"
                         "META-X SET DEFAULT FILENAME")
(user:add-zhelp-function "FILE"
                         "CHANGE NAME ASSOCIATED WITH BUFFER"
                         "META-X SET VISITED FILENAME")
(user:add-zhelp-function "FILE"
                         "FIND"
                         "CTRL-X CTRL-F")
(user:add-zhelp-function "FILE"
                         "VISIT"
                         "CTRL-X CTRL-V")
(user:add-zhelp-function "FILE"
                         "SAVE"
                         "CTRL-X CTRL-S")
(user:add-zhelp-function "FILE"
                         "SAVE ALL MODIFIED BUFFERS"
                         "META-X SAVE ALL FILES")
(user:add-zhelp-function "SAVE"
                         "ALL MODIFIED BUFFERS"
                         "MEXT-X SAVE ALL FILES")
(user:add-zhelp-function "FILE"
                         "WRITE TO SPECIFIED FILE"
                         "CTRL-X CTRL-W")
(user:add-zhelp-function '("WRITE" "SAVE")
                         "REGION"
                         "META-X WRITE REGION")

(user:add-zhelp-function "FONTS"
                         "LIST"
                         "META-X LIST FONTS")
(user:add-zhelp-function "FONTS"
                         "SET"
                         "META-X SET FONTS")
(user:add-zhelp-function "FONTS"
                         "CHANGE DEFAULT"
                         "META-CTLR-J")
(user:add-zhelp-function "FONTS"
                         "CHANGE CHARACTER'S"
                         "CTRL-J")
(user:add-zhelp-function "FONTS"
                         "CHANGE REGION'S"
                         "CTRL-X CTRL-J")
(user:add-zhelp-function "FONTS"
                         "CHANGE WORD'S"
                         "META-J")
(user:add-zhelp-function "FONTS"
                         "CHANGE ONE FONT IN REGION"
                         "META-SHIFT-J")
(user:add-zhelp-function "FONTS"
                         "DISPLAY"
                         "META-X DISPLAY FONT")
(user:add-zhelp-function "FONTS"
                         "ACTIVATE MINOR MODE"
                         "META-X ELECTRIC FONT LOCK MODE")
(user:add-zhelp-function "LIST"
                         "FONTS"
                         "META-X LIST FONTS")
(user:add-zhelp-function "SET"
                         "FONTS"
                         "META-X SET FONTS")
(user:add-zhelp-function "CHANGE"
                         "DEFAULT FONT"
                         "META-CTLR-J")
(user:add-zhelp-function "CHANGE"
                         "CHARACTER'S FONT"
                         "CTRL-J")
(user:add-zhelp-function "CHANGE"
                         "REGION'S FONT"
                         "CTRL-X CTRL-J")
(user:add-zhelp-function "CHANGE"
                         "WORD'S FONT"
                         "META-J")
(user:add-zhelp-function "CHANGE"
                         "ONE FONT IN REGION"
                         "META-SHIFT-J")
(user:add-zhelp-function '("DISPLAY" "SHOW")
                         "FONTS"
                         "META-X DISPLAY FONT")

(user:add-zhelp-function "EDIT"
                         "FUNCTIONS THAT CALL THIS ONE"
                         "META-X EDIT CALLERS.  CTRL-SHIFT-P rotates through the functions.  META-X MULTIPLE EDIT CALLERS is simular.")

(user:add-zhelp-function "NEXT"
                         "POSSIBILITY"
                         "CTRL-SHIFT-P")
(user:add-zhelp-function "NEXT"
                         "TOP LEVEL POSSIBILITY"
                         "META-X GO TO NEXT TOP LEVEL POSSIBILITY")

(user:add-zhelp-function "COMPARE"
                         "SOURCE"
                         "META-X SOURCE COMPARE")
(user:add-zhelp-function "COMPARE"
                         "BUFFER TO BUFFER'S FILE"
                         "META-X SOURCE COMPARE CHANGES")
(user:add-zhelp-function "COMPARE"
                         "SOURCE AND MERGE DIFFERENCES"
                         "META-X SOURCE COMPARE MERGE")
(user:add-zhelp-function "TRACE"
                         NIL
                         "META-X TRACE")

(user:add-zhelp-function "COMMENT COMMANDS"
                         "COMMENT REGION"
                         "CTRL-X CTRL-;")
(user:add-zhelp-function "COMMENT COMMANDS"
                         "REMOVE SEMICOLONS FROM REGION"
                         "CTRL-X META-;")
(user:add-zhelp-function "COMMENT COMMANDS"
                         "MOVE TO NEXT LINE AND ADD ;"
                         "META-N")
(user:add-zhelp-function "COMMENT COMMANDS"
                         "FILL LONG"
                         "META-X FILL LONG COMMENT")			
(user:add-zhelp-function "COMMENT COMMANDS"
                         "ALIGN WITH PREVIOUS COMMENT"
                         "META-X INDENT COMMENT RELATIVE")
(user:add-zhelp-function "INDENT"
                         "CURRENT LINE FOR NESTING LEVEL"
                         "META-X INDENT NESTED")
(user:add-zhelp-function "INDENT"
                         "NEW LINE AT PREVIOUS SEXP"
                         "META-X INDENT NEW LINE AT PREVIOUS SEXP")
(user:add-zhelp-function "INDENT"
                         "REGION"
                         "META-CTRL-\ ")
(user:add-zhelp-function "INDENT"
                         "RELATIVE TO PREVIOUS LINE"
                         "META-X INDENT RELATIVE")
(user:add-zhelp-function "INDENT"
                         "RIGIDLY"
                         "CTRL-X CTRL-I")
(user:add-zhelp-function "INDENT"
                         "SYMBOLIC EXPRESSION"
                         "META-CTRL-Q")
(user:add-zhelp-function "INDENT"
                         "UNDER PREVIOUS LINE OR STRING"
                         "META-X INDENT UNDER")
(user:add-zhelp-function "COMMENT COMMANDS"
                         "INDENT"
                         "CTRL-; or META-;")
(user:add-zhelp-function "COMMENT COMMANDS"
                         "INDENT NEW COMMENT LINE"
                         "META-LINEFEED")
(user:add-zhelp-function "COMMENT COMMANDS"
                         "DELETE COMMENT FROM LINE"
                         "META-CTRL-;")
(user:add-zhelp-function "COMMENT COMMANDS"
                         "SET COMMENT COLUMN"
                         "CTRL-X;")
(user:add-zhelp-function "COMMENT COMMANDS"
                         "DELETE COMMENTS FROM REGION"
                         "META-X UNCOMMENT REGION")	
(user:add-zhelp-function "COMMENT COMMANDS"	  
                         "MOVE TO PREVIOUS LINE AND ADD ;"
                         "META-P")

(user:add-zhelp-function "PRETTY PRINT"
                         "DEFINITION"
                         "META-X GRIND DEFINITION")
(user:add-zhelp-function "PRETTY PRINT"
                         "EXPRESSION"
                         "META-X GRIND EXPRESSION")

(user:add-zhelp-function '("SHOW" "DISPLAY")
                         "MACRO EXPANSION"
                         "CTRL-SHIFT-M")
(user:add-zhelp-function '("SHOW" "DISPLAY")
                         "ALL LEVEL MACRO EXPANSION"
                         "META-SHIFT-M")

(user:add-zhelp-function "FLAVORS"
                         "DESCRIBE"
                         "META-X DESCRIBE FLAVOR")
(user:add-zhelp-function "FLAVORS"
                         "EDIT COMBINED METHODS"
                         "META-X EDIT COMBINED METHODS")
(user:add-zhelp-function "FLAVORS"
                         "EDIT FLAVOR COMPONENTS"
                         "META-X EDIT COMPONENTS")
(user:add-zhelp-function "FLAVORS"
                         "EDIT FLAVOR DEPENDENTS"
                         "META-X EDIT DEPENDENTS")
(user:add-zhelp-function "FLAVORS"
                         "EDIT DIRECT DEPENDENTS"
                         "META-X EDIT FLAVOR DIRECT DEPENDENTS")
(user:add-zhelp-function "FLAVORS"
                         "EDIT METHODS"
                         "META-X EDIT FLAVOR METHODS")
(user:add-zhelp-function "FLAVORS"
                         "EDIT ALL METHODS"
                         "META-X EDIT METHODS")
(user:add-zhelp-function "FLAVORS"
                         "LIST COMBINED METHODS"
                         "META-X LIST COMBINED METHODS")
(user:add-zhelp-function "FLAVORS"
                         "LIST COMPONENTS"
                         "META-X LIST FLAVOR COMPONENTS")
(user:add-zhelp-function "FLAVORS"
                         "LIST DEPENDENTS"
                         "META-X LIST FLAVOR DEPENDENTS")
(user:add-zhelp-function "FLAVORS"
                         "LIST DIRECT DEPENDENTS"
                         "META-X LIST FLAVOR DIRECT DEPENDENTS")
(user:add-zhelp-function "FLAVORS"
                         "LIST METHODS"
                         "META-X LIST FLAVOR METHODS")
(user:add-zhelp-function "FLAVORS"
                         "LIST ALL METHODS"
                         "META-X LIST FLAVOR METHODS ALL")
(user:add-zhelp-function "FLAVORS"
                         "LIST METHODS FOR MESSAGE"
                         "META-X LIST METHODS")

(user:add-zhelp-function "SET"
                         "PACKAGE"
                         "META-X SET PACKAGE")

(user:add-zhelp-function "PATCH"
                         "START"
                         "META-X START PATCH")
(user:add-zhelp-function "PATCH"
                         "START PRIVATE"
                         "META-X START PRIVATE PATCH")
(user:add-zhelp-function "PATCH"
                         "ADD TO"
                         "META-X ADD PATCH")
(user:add-zhelp-function "PATCH"
                         "ADD BUFFER'S CHANGED DEFINITIONS"
                         "META-X ADD PATCH BUFFER CHANGED DEFINITIONS")
(user:add-zhelp-function "PATCH"
                         "ADD ALL BUFFER'S CHANGED DEFINITIONS"
                         "META-X ADD PATCH CHANGED DEFINITIONS")
(user:add-zhelp-function "PATCH"
                         "CANCEL"
                         "META-X CANCEL PATCH")
(user:add-zhelp-function "PATCH"
                         "RELEASE"
                         "META-X RELEASE PATCH")
(user:add-zhelp-function "PATCH"
                         "RESUME"
                         "META-X RESUME PATCH")
(user:add-zhelp-function "PATCH"
                         "FINISH AND RELEASE"
                         "META-X FINISH PATCH")
(user:add-zhelp-function "PATCH"
                         "FINISH BUT DON'T RELEASE"
                         "META-X FINISH PATCH UNRELEASED")

(user:add-zhelp-function "SET"
                         "CLOSING PARENTHESES"
                         "META-X CLOSE DEFINITION")

(user:add-zhelp-function "GROW LIST"
                         "BACKWARD"
                         "META-X GROW LIST BACKWARD")
(user:add-zhelp-function "GROW LIST"
                         "FORWARD"
                         "META-X GROW LIST FORWARD")

(user:add-zhelp-function "INSERT"
                         "() FORWARD"
                         "META-(")
(user:add-zhelp-function "INSERT"
                         "() BACKWARD"
                         "META-X MAKE () BACKWARD")

(user:add-zhelp-function '("SHOW" "DISPLAY")
                         "( FOR THIS )"
                         "META-X SHOW LIST START")

(user:add-zhelp-function "COUNT"
                         "LINES IN REGION OR BUFFER"
                         "META-X COUNT LINES")
(user:add-zhelp-function "COUNT"
                         "LINES IN PAGE"
                         "CTRL-X L")
(user:add-zhelp-function "COUNT"
                         "LINES IN REGION"
                         "META-=")
(user:add-zhelp-function "COUNT"
                         "OCCURRENCES OF STRING AFTER HERE"
                         "META-X COUNT OCCURRENCES")
(user:add-zhelp-function "COUNT"
                         "WORDS IN REGION OR BUFFER"
                         "META-X COUNT WORDS")
(user:add-zhelp-function "INSERT"
                         "CURRENT DATE"
                         "META-X INSERT DATA")

(user:add-zhelp-function "MODES"
                         "COMMON LISP"
                         "META-X COMMON LISP MODE")
(user:add-zhelp-function "MODES"
                         "ZETALISP"
                         "META-X ZETALISP MODE")
(user:add-zhelp-function "MODES"
                         "TEXT"
                         "META-X TEXT MODE")
(user:add-zhelp-function "MODES"
                         "FUNDAMENTAL"
                         "META-X FUNDAMENTAL MODE")
(user:add-zhelp-function "MODES"
                         "MACSYMA"
                         "META-X MACSYMA MODE")
(user:add-zhelp-function "MODES"
                         "TREAT [{}] LIKE PARENTHESES"
                         "META-X ANY BRACKET MODE")
(user:add-zhelp-function "MODES"
                         "WORD COMMANDS ACT ON ATOMS"
                         "META-X ATOM WORD MODE")
(user:add-zhelp-function "MODES"
                         "AUTO FILL TEXT"
                         "META-X AUTO FILL MODE")
(user:add-zhelp-function "MODES"
                         "SET FONTS"
                         "META-X ELECTRIC FONT LOCK MODE")
(user:add-zhelp-function "MODES"
                         "UPPER CASE EXCEPT COMMENTS AND STRINGS"
                         "META-X ELECTRIC SHIFT LOCK MODE")
(user:add-zhelp-function "MODES"
                         "OVERWRITE"
                         "META-X OVERWRITE MODE")
(user:add-zhelp-function "MODES"
                         "RETURN INDENTS"
                         "META-X RETURN INDENTS MODE")
(user:add-zhelp-function "MODES"
                         "EXPAND WORD ABBREVIATIONS"
                         "META-X WORD ABBREV MODE")
(user:add-zhelp-function "MODES"
                         "UPPERCASE GLOBAL FUNCTIONS"
                         "META-X UPPERCASE GLOBAL FUNCTIONS MODE")
(user:add-zhelp-function "MODES"
                         "UPPERCASE PREVIOUS GLOBAL FUNCTION"
                         "META-X UPPERCASE PREVIOUS GLOBAL FUNCTION")
(user:add-zhelp-function "MODES"
                         "UPPERCASE GLOBAL FUNCTIONS REGION"
                         "META-X UPPERCASE GLOBAL FUNCTIONS REGION")

(user:add-zhelp-function "ATTRIBUTES"
                         "REPARSE"
                         "META-X REPARSE ATTRIBUTE LIST")
(user:add-zhelp-function "ATTRIBUTES"
                         "UPDATE"
                         "META-X UPDATE ATTRIBUTE LIST")
(user:add-zhelp-function "ATTRIBUTES"
                         "SET BACKSPACE"
                         "META-X SET BACKSPACE")
(user:add-zhelp-function "ATTRIBUTES"
                         "SET BASE"
                         "META-X SET BASE")
(user:add-zhelp-function "ATTRIBUTES"
                         "SET FONTS"
                         "META-X SET FONTS")
(user:add-zhelp-function "ATTRIBUTES"
                         "SET LOWERCASE"
                         "META-X SET LOWERCASE")
(user:add-zhelp-function "ATTRIBUTES"
                         "SET NOFILL"
                         "META-X SET NOFILL")
(user:add-zhelp-function "ATTRIBUTES"
                         "SET PACKAGE"
                         "META-X SET PACKAGE")
(user:add-zhelp-function "ATTRIBUTES"
                         "SET PATCH FILE"
                         "META-X SET PATCH FILE")
(user:add-zhelp-function "ATTRIBUTES"
                         "SET TAB WIDTH"
                         "META-X SET TAB WIDTH")
(user:add-zhelp-function "ATTRIBUTES"
                         "SET VERTICAL INTERLINE SPACING"
                         "META-X SET VSP")

(user:add-zhelp-function "REPLACE"
                         "ATOM"
                         "META-X ATOM QUERY REPLACE")
(user:add-zhelp-function "REPLACE"
                         "STRINGS"
                         "META-X MULTIPLE QUERY REPLACE")
(user:add-zhelp-function "REPLACE"
                         "STRINGS FROM BUFFER"
                         "META-X MULTIPLE QUERY REPLACE FROM BUFFER")
(user:add-zhelp-function "REPLACE"
                         "EXCHANGE STRINGS"
                         "META-X QUERY EXCHANGE")
(user:add-zhelp-function "REPLACE"
                         "QUERY ABOUT EACH OCCURANCE OF STRING"
                         "META-%")
(user:add-zhelp-function "REPLACE"
                         "STRING"
                         "CTRL-%")
(user:add-zhelp-function "TAG (LOGICAL FILE) COMMANDS"
                         "LIST TABLES"
                         "META-X TAG TABLES")
(user:add-zhelp-function "TAG (LOGICAL FILE) COMMANDS"
                         "EXPLANATION"
                         "Tag commands allow you to specify a group of files through which you want to search and replace.  The files are then treated as one file.")
(user:add-zhelp-function "TAG (LOGICAL FILE) COMMANDS"
                         "IDENTIFY CURRENT TABLE"
                         "META-X CURRENT TAG TABLE")
(user:add-zhelp-function "TAG (LOGICAL FILE) COMMANDS"
                         "MOVE TO NEXT TABLE"
                         "META-X NEXT TABLE")
(user:add-zhelp-function "TAG (LOGICAL FILE) COMMANDS"
                         "SELECT ALL BUFFERS FOR TABLE"
                         "META-X SELECT ALL BUFFERS AS TAG TABLE")
(user:add-zhelp-function "TAG (LOGICAL FILE) COMMANDS"
                         "SELECT SYSTEM AS TABLE"
                         "META-X SELECT SYSTEM AS TAG TABLE")
(user:add-zhelp-function "TAG (LOGICAL FILE) COMMANDS"
                         "SELECT TABLE"
                         "META-X SELECT TAG TABLE")
(user:add-zhelp-function "TAG (LOGICAL FILE) COMMANDS"
                         "COMPILE CHANGED DEFINITIONS"
                         "META-X TAGS COMPILE CHANGES DEFINITIONS")
(user:add-zhelp-function "TAG (LOGICAL FILE) COMMANDS"
                         "EDIT CHANGED DEFINITIONS"
                         "META-X TAGS EDIT CHNAGED DEFINITIONS")
(user:add-zhelp-function "TAG (LOGICAL FILE) COMMANDS"
                         "EVALUATE CHANGED DEFINITIONS"
                         "META-X TAGS EVALUATE CHANGED DEFINITIONS")
(user:add-zhelp-function "TAG (LOGICAL FILE) COMMANDS"
                         "LIST CHANGED DEFINITIONS"
                         "META-X TAGS LIST CHANGED DEFINITIONS")
(user:add-zhelp-function "TAG (LOGICAL FILE) COMMANDS"
                         "MULTIPLE QUERY REPLACE"
                         "META-X TAGS MULTIPLE QUERY REPLACE, META-X CONTINUE MULTIPLE QUERY REPLACE, and META-X TAGS MULTIPLE QUERY REPLACE FROM BUFFER")
(user:add-zhelp-function "TAG (LOGICAL FILE) COMMANDS"
                         "QUERY REPLACE"
                         "META-X TAGS QUERY REPLACE and META-X CONTINUE TAGS QUERY REPLACE")
(user:add-zhelp-function "TAG (LOGICAL FILE) COMMANDS"
                         "SEARCH FOR STRING"
                         "META-X TAGS SEARCH")
(user:add-zhelp-function "TAG (LOGICAL FILE) COMMANDS"
                         "LIST DEFINITIONS CONTAINING STRING"
                         "META-X TAGS SEARCH LIST DEFINITIONS")
(user:add-zhelp-function "TAG (LOGICAL FILE) COMMANDS"
                         "SEARCH NEXT OCCURRENCE"
                         "META-X TAGS SEARCH NEXT OCCURRENCE")
(user:add-zhelp-function "TAG (LOGICAL FILE) COMMANDS"
                         "VISIT TABLE"
                         "META-X VISIT TAG TABLE")

(user:add-zhelp-function "TEXT FORMAT COMMANDS"
                         "EXCHANGE CHARACTERS"
                         "CTRL-T or META-X SIMPLE EXCHANGE CHARACTERS")
(user:add-zhelp-function "TEXT FORMAT COMMANDS"
                         "EXCHANGE LINES"
                         "CTRL-X CTRL-T")
(user:add-zhelp-function "TEXT FORMAT COMMANDS"
                         "EXCHANGE REGIONS"
                         "CTRL-X T")
(user:add-zhelp-function "TEXT FORMAT COMMANDS"
                         "EXCHANGE SYMBOLIC EXPRESSIONS"
                         "META-CTRL-T")
(user:add-zhelp-function "TEXT FORMAT COMMANDS"
                         "EXCHANGE WORDS"
                         "META-T")
(user:add-zhelp-function "TEXT FORMAT COMMANDS"
                         "REVERSE FOLLOWING LIST"
                         "META-X REVERSE FOLLOWING LIST")
(user:add-zhelp-function "TEXT FORMAT COMMANDS"
                         "REVERSE LINES"
                         "META-X REVERSE LINES")
(user:add-zhelp-function "TEXT FORMAT COMMANDS"
                         "SET FILL COLUMN"
                         "CTRL-X F")
(user:add-zhelp-function "TEXT FORMAT COMMANDS"
                         "FILL LONG COMMENT"
                         "META-X FILL LONG COMMENT")
(user:add-zhelp-function "TEXT FORMAT COMMANDS"
                         "FILL PARAGRAPH"
                         "META-Q")
(user:add-zhelp-function "TEXT FORMAT COMMANDS"
                         "FILL REGION"
                         "META-G")
(user:add-zhelp-function "TEXT FORMAT COMMANDS"
                         "SET FILL PREFIX"
                         "CTRL-X .")
(user:add-zhelp-function "TEXT FORMAT COMMANDS"
                         "LISP LOWERCASE REGION"
                         "META-X LISP LOWERCASE REGION")
(user:add-zhelp-function "TEXT FORMAT COMMANDS"
                         "LISP UPPERCASE REGION"
                         "META-X LISP UPPERCASE REGION")
(user:add-zhelp-function "TEXT FORMAT COMMANDS"
                         "LOWERCASE REGION"
                         "CTRL-X CTRL-L")
(user:add-zhelp-function "TEXT FORMAT COMMANDS"
                         "UPPERCASE REGION"
                         "CTRL-X CTRL-U")
(user:add-zhelp-function "TEXT FORMAT COMMANDS"
                         "LOWERCASE WORD"
                         "META-L")
(user:add-zhelp-function "TEXT FORMAT COMMANDS"
                         "CAPITALIZE FIRST WORD"
                         "META-C")
(user:add-zhelp-function "TEXT FORMAT COMMANDS"
                         "UPPERCASE WORD"
                         "META-U")
(user:add-zhelp-function "TEXT FORMAT COMMANDS"
                         "CENTER LINE"
                         "META-S")
(user:add-zhelp-function "TEXT FORMAT COMMANDS"
                         "FORMFEED"
                         "META-CLEAR SCREEN")
(user:add-zhelp-function "TEXT FORMAT COMMANDS"
                         "INSERT BLANK LINES"
                         "CTRL-O")
(user:add-zhelp-function "TEXT FORMAT COMMANDS"
                         "RIGHT ADJUST LINE"
                         "META-X RIGHT ADJUST LINE")
(user:add-zhelp-function "TEXT FORMAT COMMANDS"
                         "SET GOAL COLUMN"
                         "CTRL-X CTRL-N")
(user:add-zhelp-function "TEXT FORMAT COMMANDS"
                         "SPLIT LINE"
                         "META-CTRL-O")

(user:add-zhelp-function "SORT"
                         "REGION BY LINES"
                         "META-X SORT LINES")
(user:add-zhelp-function "SORT"
                         "REGION BY PARAGRAPHS"
                         "META-X SORT PARAGRAPHS")
(user:add-zhelp-function "SORT"
                         "REGION BY KEYBOARD MACRO"
                         "META-X SORT VIA KEYBOARD MACRO")

(user:add-zhelp-function "STACK"
                         "LIST VERTICALLY"
                         "META-X STACK LIST VERTICALLY")
(user:add-zhelp-function "INDENT"
                         "NEWLINE AT POINT"
                         "META-O")
(user:add-zhelp-function '("CHANGE" "EDIT")
                         "TAB STOPS"
                         "META-X EDIT TAB STOPS")
(user:add-zhelp-function "TABS"
                         "EDIT STOPS"
                         "METS-X EDIT TAB STOPS")
(user:add-zhelp-function "TABS"
                         "SET WIDTH"
                         "META-X SET TAB WIDTH")
(user:add-zhelp-function "TABS"
                         "REPLACE SPACES WITH TABS"
                         "META-X TABIFY")
(user:add-zhelp-function "TABS"
                         "REPLACE TABS WITH SPACES"
                         "META-X UNTABIFY")

(COMMENT
(user:add-zhelp-function ""
                         ""
                         "")
) 
