;;; -*- mode:Common-Lisp; Package:TV; Base:10 -*-

;;;                           RESTRICTED RIGHTS LEGEND

;;;Use, duplication, or disclosure by the Government is subject to
;;;restrictions as set forth in subdivision (b)(3)(ii) of the Rights in
;;;Technical Data and Computer Software clause at 52.227-7013.
;;;
;;;                     TEXAS INSTRUMENTS INCORPORATED.
;;;                              P.O. BOX 2909
;;;                           AUSTIN, TEXAS 78769
;;;                                 MS 2151
;;;
;;; Copyright (C) 1986, Texas Instruments Incorporated. All rights reserved.
;;;

;; The music interpreter isn't loaded in the standard system.
;; Ensure that its loaded when compiling this file.
(EVAL-WHEN (COMPILE)
  (UNLESS (FBOUNDP 'music-interpreter)
    (LOAD "sys:window;music-interpreter")))

#|

Note lists look like:
( ((note octave length) (note octave length) (note octave length))  ;; three notes played together, one for each voice
  ((note octave length) (note octave length) (note octave length))  ;; three more notes played together
  ...) ;; more notes
;;      voice 0             voice 1              voice 2

note - a#, b-, etc.
octave - 0..7
length - multiples of delay milliseconds.

;; this is how it should be (maybe someday)
note = (note octave duration -modifiers-)
duration = (length n-tuple dotted) or length
    length = 1,2,4,8,16,32,64
    n-tuple >= no. (e.g. 1=standard, 3=triplet)
    dotted = 0,1,2 (no. of dots)

|#

;;; This is kludgey beyond belief.  
;;;
;;; "I have no time, I have no time."  
;;;          - E. Galois
;;;
;;; But at least he could scribble out 60 pages of notes on group theory on the evening
;;; before his death in a duel.  Could I possibly scribble out 60 pages of code in the
;;; week before AAAI?  But then again, most of his results had no proofs, so nothing
;;; says this code has to be working.

;;; c1 is lowest correct note (at 63 hz)				 


;;; 

;;; Bach's 2-part Invention #4
;;; set delay = 150.
#+comment
(defsound :invention-4
  (music-interpreter 150
	 '(
	   ;  (:expression mf)
	   ;  (:metronome 120.)
	   ((D 3) (:REST)) ((E 3)) ((F 3)) ((G 3)) ((A 3)) ((B- 3))
	   ((C# 3)) ((B- 3)) ((A 3)) ((G 3)) ((F 3)) ((E 3))
	   ((F 3) (D 2)) ((:REST) (E 2)) ((A 3) (F 2)) ((:REST) (G 2)) ((D 4) (A 2)) ((:REST) (B- 2))
	   ((G 3) (C# 2)) ((:REST) (B- 2)) ((C# 4) (A 2)) ((:REST) (G 2)) ((E 4) (F 2)) ((:REST) (E 2))
	   ((D 4) (F 2)) ((E 4) (:REST)) ((F 4) (A 2)) ((G 4) (:REST)) ((A 4) (D 3)) ((B- 4) (:REST))
	   ((C# 4) (E 2)) ((B- 4) (:REST)) ((A 4) (G 2)) ((G 4) (:REST)) ((F 4) (C# 3)) ((E 4) (:REST))
	   ((F 4) (D 2)) ((D 4) (:REST)) ((E 4) (D 3)) ((F 4) (:REST)) ((G 4) (F 2)) ((A 4) (:REST))
	   ((B- 3) (G 2)) ((A 4) (:REST)) ((G 4) (A 2)) ((F 4) (:REST)) ((E 4) (B- 2)) ((D 4) (:REST))
	   ((E 4) (C 2)) ((C 4) (:REST)) ((D 4) (C 3)) ((E 4) (:REST)) ((F 4) (E 2)) ((G 4) (:REST))
	   ((A 3) (F 2)) ((G 4) (:REST)) ((F 4) (G 2)) ((E 4) (:REST)) ((D 4) (A 2)) ((C 4) (:REST))
	   ((D 4) (B- 2)) ((E 4) (G 2)) ((F 4) (A 2)) ((D 4) (B- 2)) ((E 4) (C 3)) ((F 4) (D 3))
	   ((G 3) (E 2)) ((:REST) (D 3)) ((:REST) (C 3)) (NIL (B- 3)) (NIL (A 3)) (NIL (G 2))
	   ;; Measure 13
	   ;measure 13
	   ;  (:expression f)
	   ((C 4) (A 2)) ((D 4) (F 2)) ((E 4) (G 2)) ((C 4) (A 2)) ((D 4) (B- 2)) ((E 4) (C 3))
	   ;14
	   ;  (:expression ff)
	   ((F 3) (D 2)) ((:REST) (C 3)) ((:REST) (B- 2)) (NIL (A 3)) ((B- 3) (G 2)) ((B- 3) (F 2))
	   ((B- 3) (E 2)) ((B- 3) (C 2)) ((A 3) (D 2)) ((:REST) (E 2)) ((G 3) (F 2)) ((:REST) (G 2))
	   ((C 4) (A 1)) ((B- 3) (G 2)) ((A 3) (F 2)) ((G 3) (E 2)) ((F 3) (D 2)) ((E 3) (C 2))
	   ((F 3) (D 2)) ((G 3) (B- 1)) ((G 3) (C 2)) ((A 3) (C 2)) ((G 3) (C 1)) ((G 3) (C 1))
	   ((F 3) (F 1)) ((F 3) (F 1)) ((F 3) (F 1)) ((F 3) (F 1)) ((F 3) (F 1)) ((F 3) (F 1)))))

(defsound :invention-4
  (music-interpreter-a 60
     (music-lines
       	'(((d  2) (e  2) (f  2) (g  2) (a  3) (a# 3)
	   (c# 2) (a# 3) (a  3) (g  2) (f  2) (e  2)
	   ((f  2) 2)    ((a  3) 2)    ((d  3) 2)
	   ((g  2) 2)    ((c# 3) 2)    ((e  3) 2)
	   (d  3) (e  3) (f  3) (g  3) (a  4) (a# 4)
	   (c# 3) (a# 4) (a  4) (g  3) (f  3) (e  3)
	   (f  3) (d  3) (e  3) (f  3) (g  3) (a  4)
	   (a# 3) (a  4) (g  3) (f  3) (e  3) (d  3)
	   (e  3) (c  3) (d  3) (e  3) (f  3) (g  3)
	   (a  3) (g  3) (f  3) (e  3) (d  3) (c  3)
	   (d  3) (e  3) (f  3) (d  3) (e  3) (f  3)
	   ((g  2) 2)    ((x  4) 4)
	   (c  3) (d  3) (e  3) (c  3) (d  3) (e  3)
	   ((f  2) 2)    ((x  0) 2)    ((a# 3) 2)
	   ((a#  3) 2)    ((a  3) 2)   ((g  2) 2)
	   (c  3) (a# 3) (a  3) (g  2) (f  2) (e  2)
	   (f  2) (g  2) ((g  2) 3)           (f  2)
	   ((f  2) 2)    ((c  3) 1.5) ((x  0) 0.5)    ((c  3) 1.5) ((x  0) 0.5)
	   ((c  3) 18.)
	   (c  3) (a# 3) (a  3) (g  2) (f  2) (e  2)
	   (c  3) (d  2) (e  2) (f# 2) (g  2) (a  3)
	   (a# 3) (a  3) (g  2) (f  2) (e  2) (d  2)
	   (a# 3) (c  2) (d  2) (e  2) (f  2) (g  2)
	   (a  3) (b  3) (c  3) (d  3) (e  3) (f  3)
	   (g# 2) (f  3) (e  3) (d  3) (c  3) (b  3)
	   (c  3) (b  3) (d  3) (c  3) (b  3) (a  3)
	   (g# 2) (a  3) (g  2) (f# 2) (e  2) (d  2)
	   (c  2) (d  2) (e  2) (f# 2) (g# 2) (a  3)
	   
	   (d  2) (c  3) (b  3) (a  3) (g# 2) (f# 2)
	   (e  2) (f# 2) (g# 2) (a  3) (b  3) (c  3)
	   (f# 2) (e  3) (d  3) (c  3) (b  3) (a  3)
	   (g# 2) (a  3) (b  3) (c  3) (d  3) (e  3)
	   (a  3) (f  3) (e  3) (d  3) (c  3) (b  3)
	   (a  4) (g# 3) (f# 3) (e  3) ((a  4) 2)
	   (a  4) (d  3) ((b  3) 3)           (a  3)
	   ((a  3) 3)           (a  3) (b  3) (c  3)
	   ((d  2) 2)    ((f# 2) 2)    ((a  3) 2)
	   (a# 2) (g  2) (a  3) (a# 3) (c  3) (d  3)
	   (e  2) (d  3) (c  3) (b  3) (a  3) (g  2)
	   ((a  3) 2)    (f  3) (e  3) ((f  3) 2)
	   ((g  2) 2)    ((e  3) 2)    ((x  0) 2)
	   (d  3) (e  3) (f  3) (g  3) (a  4) (a# 4)
	   (c# 3) (a# 4) (a  4) (g  3) (f  3) (e  3)
	   ((f  3) 2)    ((d  3) 2)    ((g  2) 2)
	   (g  2) (d  3) (c# 3) (e  3) (a  3) (c# 3)
	   (d  3) (b  3) ((c# 3) 3)           (d  3)
	   (d  3) (c  3) (a# 3) (a  3) (g  2) (f  2)
	   (a# 3) (c# 2) (d  2) (e  2) (f  2) (g  2)
	   (a  3) (d  3) ((f  2) 2)    (e  2) ((d  2) 0.5) ((x  0) 0.5)
	   ((d  2) 7.)
	   ((x  0.) 5.)
	   
	   )
	  
	  (
	   ((x  2) 12.)
	   (d  1) (e  1) (f  1) (g  1) (a  2) (a# 2)
	   (c# 1) (a# 2) (a  2) (g  1) (f  1) (e  1)
	   ((f  1) 2)    ((a  2) 2)    ((d  2) 2)
	   ((g  1) 2)    ((c# 2) 2)    ((e  2) 2)
	   ((d  1) 2)    ((d  2) 2)    ((f  1) 2)
	   ((g  1) 2)    ((a  2) 2)    ((a# 2) 2)
	   ((c  1) 2)    ((c  2) 2)    ((e  1) 2)
	   ((f  1) 2)    ((g  1) 2)    ((a  2) 2)
	   (a# 2) (g  1) (a  2) (a# 2) (c  2) (d  2)
	   (e  1) (d  2) (c  2) (a# 2) (a  2) (g  1)
	   (a  2) (f  1) (g  1) (a  2) (a# 2) (c  2)
	   (d  1) (c  2) (a# 2) (a  2) (g  1) (f  1)
	   (e  1) (c  1) (d  1) (e  1) (f  1) (g  1)
	   (a  1) (g  1) (f  1) (e  1) (d  1) (c  1)
	   (d  1) (a# 1) ((c  1) 2)    ((c  0) 2)
	   (f  1) (g  1) (a  2) (a# 2) (c  2) (d  2)
	   (e  1) (d  2) (c  2) (a# 2) (a  2) (g  1)
	   (a  2) (a# 2) (c  2) (d  2) (e  2) (f  2)
	   (g  0) (f  1) (e  1) (d  2) (c  2) (a# 2)
	   (a  1) (a# 1) (c  1) (a  1) (a# 1) (c  1)
	   ((f# 0) 2)    ((x  2) 4)
	   (g  0) (a  1) (a# 1) (g  0) (a  1) (a# 1)
	   ((e  0) 2)    ((x  2) 4)
	   ((f  0) 2)    ((f  1) 2)    ((d  1) 2)
	   ((b  1) 2)    ((g# 0) 2)    ((e  0)  2)
	   (a  1) (g# 0) (a  1) (b  1) (c  1) (d  1)
	   ((e  1) 30.)
	   ((e  1) 2)    ((e  2) 2)    ((d  2) 2)
	   ((c  2) 2)    ((b  2) 2)    ((a  2) 2)
	   ((d  2) 2)    ((e  2) 2)    ((f# 2) 2)
	   ((d  2) 2)    ((e  2) 2)    ((e  1) 2)
	   (a  2) (a  1) (a# 1) (c  1) (d  1) (d# 1)
	   (f# 0) (d# 1) (d  1) (c  1) (b  1) (a  1)
	   ((g  0) 2.5)  ((x  0) 0.5) (g  0) (a  1) (a# 1)
	   ((c  0) 2)    ((g  0) 2)    ((c  1) 2)
	   (f  1) (g  1) (a  2) (b  2) (c# 2) (d  2)
	   (e  1) (d  2) (c# 2) (b  2) (a  2) (g  2)
	   ((f  1) 2)    ((a  2) 2)    ((d  2) 2)
	   ((e  1) 2)    ((g  2) 2)    ((c# 2) 2)
	   (d  1) (e  1) (f  1) (g  1) (a  2) (a# 2)
	   (c# 1) (a# 2) (a  2) (g  1) (f  1) (e  1)
	   (f  1) (g  1) ((a  2) 2)    (( a  1) 2)
	   ((a#  1) 3)          (c  1) (a# 1) (g  1)
	   (g  1) (a# 2) (a  2) (g  1) (f  1) (e  1)
	   (f  1) (g  1) ((a  2) 2)    (( a  1) 2)
	   ((d  0) 7.)
	   
	   )
	  ) 0.5)
     ))

(defsound :bouree
  (music-interpreter-a 150
     (music-lines
	  '(
	  (
	                                             (e  2) (f# 2)
	   ((g  2) 2)    (f# 2) (e  2) ((d# 2) 2)    (e  2) (f# 2)
	   ((b  2) 2)    (c# 2) (d# 2) ((e  2) 2)    (d  2) (c  2)
	   ((b  2) 2)    (a  2) (g  1) ((f# 1) 2)    (g  1) (a  2)
	   (b  2) (a  2) (g  1) (f# 1) ((e  1) 2)    (e  2) (f# 2)
	   ((g  2) 2)    (f# 2) (e  2) ((d# 2) 2)    (e  2) (f# 2)
	   ((b  2) 2)    (c# 2) (d# 2) ((e  2) 2)    (d  2) (c  2)
	   ((b  2) 2)    (a  2) (g  1) ((f# 1) 3)           (g  1)
	   ((g  1) 6)
	                                             (e  2) (f# 2)
	   ((g  2) 2)    (f# 2) (e  2) ((d# 2) 2)    (e  2) (f# 2)
	   ((b  2) 2)    (c# 2) (d# 2) ((e  2) 2)    (d  2) (c  2)
	   ((b  2) 2)    (a  2) (g  1) ((f# 1) 2)    (g  1) (a  2)
	   (b  2) (a  2) (g  1) (f# 1) ((e  1) 2)    (e  2) (f# 2)
	   ((g  2) 2)    (f# 2) (e  2) ((d# 2) 2)    (e  2) (f# 2)
	   ((b  2) 2)    (c# 2) (d# 2) ((e  2) 2)    (d  2) (c  2)
	   ((b  2) 2)    (a  2) (g  1) ((f# 1) 3)           (g  1)
	   ((g  1) 6)
	                                             (b  1) (g  1)
           ((d  2) 2)    (a  2) (c  2)  ((b  2) 2)   (g  2) (d  2)
	   ((e  2) 2)    (b  2) (d  2)  ((c  2) 2)   (b  2) (a  2)
	   ((g# 1) 2)    (a  2) (b  2)  ((c  2) 2)   (b  2) (a  2)
	   ((a  2) 6)                                (d  2) (a  2)
	   ((b  2) 2)    (g  2) (d  2)  ((e  2) 2)   (b  2) (d  2)
	   ((c  2) 2)    (a  3) (e  2)  ((f# 2) 2)   (c# 2) (e  2)
	   ((d  2) 2)    (c# 2) (b  2)  ((a# 2) 3)          (b  2)
	   ((b  2)  6)
	                                             (b  3) (f# 2)
           ((g# 2) 2)    (f# 2) (e  2)  ((a  3) 2)   (e  2) (g  2)
	   ((f# 2) 2)    (e  2) (d  2)  ((g  2) 2)   (d  2) (f  2)
	   ((e  2) 2)    (a  3) (e  2)  ((f# 2) 2)   (c# 2) (e  2)
	   ((d# 2) 2)    ((b  2) 4)                  (e  2) (b  2)
	   ((c  2) 2)    (d  2) (a  2)  ((b  2) 2)   (c  2) (g  1)
	   ((a  2) 2)    (b  2) (f# 1)  ((g  1) 2)   (f# 1) (e  1)
	   ((d# 1) 2)    (e  1) (f# 1)  ((g  1) 2)   (f# 1) (e  1)
	   ((e  1) 6)
	                                             (b  1) (g  1)
           ((d  2) 2)    (a  2) (c  2)  ((b  2) 2)   (g  2) (d  2)
	   ((e  2) 2)    (b  2) (d  2)  ((c  2) 2)   (b  2) (a  2)
	   ((g# 1) 2)    (a  2) (b  2)  ((c  2) 2)   (b  2) (a  2)
	   ((a  2) 6)                                (d  2) (a  2)
	   ((b  2) 2)    (g  2) (d  2)  ((e  2) 2)   (b  2) (d  2)
	   ((c  2) 2)    (a  3) (e  2)  ((f# 2) 2)   (c# 2) (e  2)
	   ((d  2) 2)    (c# 2) (b  2)  ((a# 2) 3)          (b  2)
	   ((b  2)  6)
	                                             (b  3) (f# 2)
           ((g# 2) 2)    (f# 2) (e  2)  ((a  3) 2)   (e  2) (g  2)
	   ((f# 2) 2)    (e  2) (d  2)  ((g  2) 2)   (d  2) (f  2)
	   ((e  2) 2)    (a  3) (e  2)  ((f# 2) 2)   (c# 2) (e  2)
	   ((d# 2) 2)    ((b  2) 4)                  (e  2) (b  2)
	   ((c  2) 2)    (d  2) (a  2)  ((b  2) 2)   (c  2) (g  1)
	   ((a  2) 2)    (b  2) (f# 1)  ((g  1) 2)   (f# 1) (e  1)
	   ((d# 1) 2)    (e  1) (f# 1)  ((g  1) 2)   (f# 1) (e  1)
	   ((e  1) 6)
	   
	   )

	  (
	                                             (g  0) (f# 0)
	   ((e  0) 2)    ((a  1) 2)    ((b  1) 2)    ((a  1) 2)
	   ((g  0) 2)    ((f# 0) 2)    ((e  0) 2)    ((f# 0) 2)
	   ((g  0) 2)    ((a  1) 2)    ((b  1) 2)    ((a  1) 2)
	   ((g  0) 2)    ((b  1) 2)    (e  0) (f# 0) (g  0) (f# 0)
	   ((e  0) 2)    ((a  1) 2)    ((b  1) 2)    ((a  1) 2)
	   ((g  0) 2)    ((f# 0) 2)    ((e  0) 2)    ((f# 0) 2)
	   ((g  0) 2)    ((c  1) 2)    ((d  1) 2)    ((d  1) 2)
	   ((g  0) 6)
	                                             (g  0) (f# 0)
	   ((e  0) 2)    ((a  1) 2)    ((b  1) 2)    ((a  1) 2)
	   ((g  0) 2)    ((f# 0) 2)    ((e  0) 2)    ((f# 0) 2)
	   ((g  0) 2)    ((a  1) 2)    ((b  1) 2)    ((a  1) 2)
	   ((g  0) 2)    ((b  1) 2)    (e  0) (f# 0) (g  0) (f# 0)
	   ((e  0) 2)    ((a  1) 2)    ((b  1) 2)    ((a  1) 2)
	   ((g  0) 2)    ((f# 0) 2)    ((e  0) 2)    ((f# 0) 2)
	   ((g  0) 2)    ((c  1) 2)    ((d  1) 2)    ((d  1) 2)
	   ((g  0) 6)                                
	                                             (g  1) (x  0)
	   ((f# 1) 2)    ((d  1) 2)    ((g  0) 2)    ((b  1) 2)
	   ((c  1) 2)    ((g# 0) 2)    ((a  1) 2)    ((d  1) 2)
	   ((e  1) 2)    ((a  1) 2)    ((e  1) 2)    ((e  0) 2)
	   (a  1) (b  1) (a  1) (g  0) ((f# 0) 2)    ((d  1) 2)
	   ((g  1) 2)    ((b  1) 2)    ((c  1) 2)    ((g# 0) 2)
	   ((a  1) 2)    ((c# 1) 2)    ((d  1) 2)    ((a# 1) 2)
	   ((b  1) 2)    ((e  1) 2)    ((f# 1) 2)    ((f# 0) 2)
	   (b  1) (a# 1) (b  1) (c# 1) ((d# 1) 2)
	                                             ((b  1) 2)
           ((e  1) 2)    ((d  1) 2)    ((c# 1) 2)    ((a  1) 2)
	   ((d  1) 2)    ((c  1) 2)    ((b  1) 2)    ((g  0) 2)
	   ((c  1) 2)    ((b  1) 2)    ((a  1) 2)    ((f# 0) 2)
	   ((b  1) 3)           (c  1) (b  1) (a  1) ((g  0) 2)
	   (a  1) (e  1) ((f# 1) 2)    (g  0) (d# 1) ((e  1) 2)
	   (f# 0) (c# 1) ((d# 1) 2)    ((e  0) 2)    ((a  1) 2)
	   ((b  0) 2)    ((a  1) 2)    ((b  1) 4)
	   ((e  0) 6)
	                                             (g  1) (x  0)
	   ((f# 1) 2)    ((d  1) 2)    ((g  0) 2)    ((b  1) 2)
	   ((c  1) 2)    ((g# 0) 2)    ((a  1) 2)    ((d  1) 2)
	   ((e  1) 2)    ((a  1) 2)    ((e  1) 2)    ((e  0) 2)
	   (a  1) (b  1) (a  1) (g  0) ((f# 0) 2)    ((d  1) 2)
	   ((g  1) 2)    ((b  1) 2)    ((c  1) 2)    ((g# 0) 2)
	   ((a  1) 2)    ((c# 1) 2)    ((d  1) 2)    ((a# 1) 2)
	   ((b  1) 2)    ((e  1) 2)    ((f# 1) 2)    ((f# 0) 2)
	   (b  1) (a# 1) (b  1) (c# 1) ((d# 1) 2)
	                                             ((b  1) 2)
           ((e  1) 2)    ((d  1) 2)    ((c# 1) 2)    ((a  1) 2)
	   ((d  1) 2)    ((c  1) 2)    ((b  1) 2)    ((g  0) 2)
	   ((c  1) 2)    ((b  1) 2)    ((a  1) 2)    ((f# 0) 2)
	   ((b  1) 3)           (c  1) (b  1) (a  1) ((g  0) 2)
	   (a  1) (e  1) ((f# 1) 2)    (g  0) (d# 1) ((e  1) 2)
	   (f# 0) (c# 1) ((d# 1) 2)    ((e  0) 2)    ((a  1) 2)
	   ((b  0) 2)    ((a  1) 2)    ((b  1) 4)
	   ((e  0) 6)
	   ))
	  )))

(defsound :MARIENETTE
  (music-interpreter-a 150
     (music-lines
	  '(
	    ( ;;MELODY VOICE
	     (a  4) (x  0) (c  3) (c  3) (b  3) (a  3)
	     (b  3) (x  0) (c  3) ((d  3) 3)
	     (a  4) (x  0) (c  3) (c  3) (b  3) (a  3)
	     (b  3) (x  0) (c  3) ((d  3) 3)
	     ((x  0) 2)    (c  3) ((e  3) 2)    (d  2)
	     (c  3) (x  0) (e  3) ((g  3) 2)    (f  2)
	     (e  2) (x  0) (g  3) ((b  4) 2)    (a  4)
	     (g# 3) ((x  0) 4)                  (e  3)
	     (a  4) (x  0) (c  3) (c  3) (b  3) (a  3)
	     (b  3) (x  0) (c  3) ((d  3) 3)
	     (a  4) (x  0) (c  3) (c  3) (b  3) (a  3)
	     (b  3) (x  0) (c  3) ((d  3) 3)

	     ((x  0) 2)    (e  3) ((g  3) 2)    (f  3)
	     (e  3) (d  3) (c  3) (a# 3) (d  3) (f  3)
	     (a  3) (g# 2) (a  3) ((b  3) 2)    (c  3)
	     ((b  3) 3)           (a  3) ((x  0) 2)
	     (e  3) (x  0) (e  2) (e  2) (d# 2) (e  2)
	     (g# 2) (x  0) (f# 2) (e  2) ((x  0) 2)
	     (e  3) (x  0) (e  2) (e  2) (d# 2) (e  2)
	     (g# 2) (x  0) (f# 2) (e  2) ((x  0) 2)
	     (e  3) (x  0) (e  2) (f  2) (g  2) (a  3)
	     (b  3) (x  0) (e  2) (f  2) (g  2) (a  3)
	     (b  3) (x  0) (e  2) (e  2) (d  2) (c  2)
	     (b  2) (c  2) (d  2) (e  2) ((x  0) 2)
	     (x  0) (x  0) (c  3) (c  3) (b  3) (a  3)
	     (b  3) (x  0) (c  3) ((d  3) 3)
	     (x  0) (x  0) (c  3) (c  3) (b  3) (a  3)
	     (b  3) (x  0) (c  3) ((d  3) 3)

	     ((x  0) 2)    (e  3) ((g  3) 2)    (f  3)
	     (e  3) (d  3) (c  3) (a# 3) (d  3) (f  3)
	     (a  3) (g# 2) (a  3) ((b  3) 2)    (c  3)
	     ((b  3) 3)           (a  3) ((x  0) 2)
	     ((x  0) 2)    (e  3) ((g  3) 2)    (f  3)
	     (e  3) (d  3) (c  3) (a# 3) (d  3) (f  3)
	     (a  3) (g# 2) (a  3) ((b  3) 2)    (c  3)
	     ((b  3) 3)           (a  3) ((x  0) 2)
	     ((x  0) 2)    (a  3) (a  3) (g# 2) (f# 2)
	     ((g# 2) 2)    (a  3) (b  3) (e  2) (f  2)
	     (e  2) (d  2) (c  2) (e  2) (e  3) (f  3)
	     (e  3) (d  3) (c  3) (e  3) (x  0) (e  3)
	     (a  4) (x  0) (e  2) (e  2) (e  2) (e  2)
	     (a  3) ((x  0) 5)

	     ((x  0) 12.)
	     )

	    ( ;;UPPER HARMONY VOICE
	     (c  3) ((x  0) 5)
	     (x  0) (x  0) (a  3) ((g# 2) 3)
	     (c  3) ((x  0) 5)
	     (x  0) (x  0) (a  3) ((g# 2) 3)
	     ((x  0) 3)           ((g# 2) 3)
	     (a  3) ((x  0) 2)    ((b  3) 3)
	     (c  3) ((x  0) 2)    ((d# 3) 3)
	     (e  3) ((x  0) 4)                 (b  3)
	     (c  3) ((x  0) 5)
	     (x  0) (x  0) (a  3) ((g# 2) 3)
	     (c  3) ((x  0) 5)
	     (x  0) (x  0) (a  3) ((g# 2) 3)

	     ((x  0) 3)           ((b  3) 3)
	     (c  3) ((x  0) 5)
	     ((x  0) 6)
	     ((d  2) 3)           (c  2) ((x  0) 2)
	     (b  3) ((x  0) 5)
	     ((x  0) 6)
	     (b  3) ((x  0) 5)
	     ((x  0) 6)
	     (b  3) ((x  0) 2)    ((d# 2) 3)
	     (e  3) ((x  0) 2)    ((d# 2) 3)
	     (e  3) ((x  0) 5)
	     ((x  0) 6)
	     ((x  0) 6)
	     (x  0) (x  0) (a  3) ((g# 2) 3)
	     ((x  0) 6)
	     (x  0) (x  0) (a  3) ((g# 2) 3)

	     ((x  0) 3)           ((b  3) 3)
	     (c  3) ((x  0) 5)
	     ((x  0) 6)
	     ((d  2) 3)           (c  2) ((x  0) 2)
	     ((x  0) 3)           ((b  3) 3)
	     (c  3) ((x  0) 5)
	     ((x  0) 6)
	     ((d  2) 3)           (c  2) ((x  0) 2)
	     ((x  0) 6)
	     ((b  2) 2)    (c  2) (d  2) ((x  0) 2)
	     ((x  0) 6)
	     ((x  0) 5)                          (b  3)
	     (c  3) (x  0) (d  2) (d  2) (d  2) (d  2)
	     (c  2) ((x  0) 5)
	     )

	    ( ;;LOWER HARMNONY VOICE
	     ((x  0) 72.)

	     ((x  0) 3)           ((f  3) 3)
	     (e  3) ((x  0) 5)
	     ((x  0) 6)
	     ((x  0) 6)
	     (g# 3) ((x  0) 5)
	     ((x  0) 6)
	     (g# 3) ((x  0) 5)
	     ((x  0) 6)
	     (g# 3) ((x  0) 2)    ((a  3) 3)
	     (g  2) ((x  0) 2)    ((a  2) 3)
	     (g  2) ((x  0) 5)
	     ((x  0) 6)
	     ((x  0) 24.)

	     ((x  0) 3)           ((f  3) 3)
	     (e  3) ((x  0) 5)
	     ((x  0) 6)
	     ((x  0) 6)
	     ((x  0) 3)           ((f  3) 3)
	     (e  3) ((x  0) 5)
	     ((x  0) 6)
	     ((x  0) 6)
	     )

	    ( ;;BASS VOICE
	     (a  1) (x  0) (x  0) ((e  1) 3)
	     (d  1) (x  0) (c  1) (b  1) (e  1) (e  0)
	     (a  1) (x  0) (x  0) ((e  1) 3)
	     (d  1) (x  0) (c  1) (b  1) (e  1) (e  0)
	     (a  1) ((x  0) 2)    (e  1) (f# 1) (g# 1)
	     (a  2) ((x  0) 2)    (g  1) (a  2) (b  2)
	     (c  2) ((x  0) 2)    (b  1) (c# 1) (d# 1)
	     (e  1) (f  1) (e  1) (d  1) (c  1) (e  1)
	     (a  1) (x  0) (x  0) ((e  1) 3)
	     (d  1) (x  0) (c  1) (b  1) (e  1) (e  0)
	     (a  1) (x  0) (x  0) ((e  1) 3)
	     (d  1) (x  0) (c  1) (b  1) (e  1) (e  0)

	     (a  1) ((x  0) 2)    ((g  1) 3)
	     (c  2) (x  0) (e  1) (f  1) (d  1) (a# 1)
	     (a  1) (g# 0) (a  1) (b  1) (x  0) (c  1)
	     (e  1) (f  0) (e  0) (a  1) ((x  0) 2)
	     (e  1) ((x  0) 2)    (e  1) ((x  0) 2)
   	     (a  2) ((x  0) 2)    (a  2) ((x  0) 2)   
	     (e  1) ((x  0) 2)    (g# 1) ((x  0) 2)
   	     (a  2) ((x  0) 2)    (a  2) ((x  0) 2)
	     (e  1) ((x  0) 2)    ((f  1) 3)
	     (e# 1) ((x  0) 2)    ((f  1) 3)
	     (e# 1) (x  0) (e  1) (e  1) (d  1) (c  1)
	     (b  1) (c  1) (d  1) (e  1) (x  0) (e  0)
	     (a  1) (x  0) (x  0) ((e  1) 3)
	     (d  1) (x  0) (c  1) (b  1) (e  1) (e  0)
	     (a  1) (x  0) (x  0) ((e  1) 3)
	     (d  1) (x  0) (c  1) (b  1) (e  1) (e  0)

	     (a  1) ((x  0) 2)    ((g  1) 3)
	     (c  2) (x  0) (e  1) (f  1) (d  1) (a# 1)
	     (a  1) (g# 0) (a  1) (b  1) (x  0) (c  1)
	     (e  1) (f  0) (e  0) (a  1) ((x  0) 2)
	     (a  1) ((x  0) 2)    ((g  1) 3)
	     (c  2) (x  0) (e  1) (f  1) (d  1) (a# 1)
	     (a  1) (g# 0) (a  1) (b  1) (x  0) (c  1)
	     (e  1) (f  0) (e  0) (a  1) ((x  0) 2)
	     ((e  1) 6)
	     ((e  1) 3)           (e  1) (e  1) (f  1)
	     (e  1) (d  1) (c  1) (e  1) (e  1) (f  1)
	     (e  1) (d  1) (c  1) (e  1) (e  0) (g# 0)
	     (a  1) (x  0) (e  1) (e  1) (e  1) (e  1)
	     (a  1) ((x  0) 2)    (a  0) ((x  0) 2)
	     ))
	    )))

;;; Star Wars theme
;;; set delay = 250.
(defsound :star-wars
  (music-interpreter 200
	 '(((D 3 3))
	   ((G 3) (D 3) (B 2)) ((G 3) (D 3) (B 2)) ((D 4) (B 3) (G 3)) ((D 4) (B 3) (G 3))
	   ((C 4) (G 3) (E 3)) ((B 3)) ((A 3)) ((G 4) (D 4) (B 3)) ((G 4) (D 4) (B 3)) ((D 4) (B 3) (G 3))
	   ((C 4) (G 3) (E 3)) ((B 3)) ((A 3)) ((G 4) (D 4) (B 3)) ((G 4) (D 4) (B 3)) ((D 4) (B 3) (G 3))
	   ((C 4) (A 3) (F 3)) ((B 3)) ((C 4)) ((A 3) (F# 3) (D 3)) ((A 3) (F# 3) (D 3)) ((D 3)) ((:REST)) ((D 3))
	   ((G 3) (D 3) (B 2)) ((G 3) (D 3) (B 2)) ((D 4) (B 3) (G 3)) ((D 4) (B 3) (G 3))
	   ((C 4) (G 3) (E 3)) ((B 3)) ((A 3)) ((G 4) (D 4) (B 3)) ((G 4) (D 4) (B 3)) ((D 4) (B 3) (G 3))
	   ((C 4) (G 3) (E 3)) ((B 3)) ((A 3)) ((G 4) (D 4) (B 3)) ((G 4) (D 4) (B 3)) ((D 4) (B 3) (G 3))
	   ((C 4) (A 3) (F 3)) ((B 3)) ((C 4)) ((A 3) (F# 3) (D 3)) ((A 3) (F# 3) (D 3)) ((D 3)) ((:REST)) ((D 3))
	   ((E 3) (C 3) (G 2)) (NIL (C 3) (G 2)) ((E 3)) ((C 4) (G 3) (E 3)) ((B 3)) ((A 3) (:REST) (:REST)) ((G 3))
	   ((G 3) (E 3)) ((A 3)) ((B 3)) ((A 3)) ((A 3)) ((E 3)) ((F# 3) (D 3) (A 2)) ((D 3)) ((D 3))
	   ((E 3) (C 3) (G 2)) (NIL (C 3) (G 2)) ((E 3)) ((C 4) (G 3) (E 3)) ((B 3)) ((A 3) (:REST) (:REST)) ((G 3))
	   ((D 4) (B- 3) (F 3)) ((A 3) (:REST) (:REST)) ((A 3) (F# 3) (D 3)) ((A 3) (F# 3) (D 3)) ((D 3)) ((:REST))
	   ((D 3)) ((E 3) (C 3) (G 2)) (NIL (C 3) (G 2)) ((E 3)) ((C 4) (G 3) (E 3)) ((B 3)) ((A 3) (:REST) (:REST)) ((G 3))
	   ((G 3) (E 3) (C 3)) ((A 3)) ((B 3)) ((A 3) (E 3) (C 3)) ((E 3) (:REST) (:REST)) ((E 3)) ((F# 3)) ((D 4)) ((D 4))
	   ((G 4) (E- 4) (C 4)) ((F 4) (C 4) (G 3)) ((E- 4) (C 4) (G 3)) ((D 4) (G 3) (:REST)) ((C 4) (G 3))
	   ((B- 3) (:REST)) ((A 3)) ((G 3))
						;16
	   ((D 4) (D 3) (D 2)) ((D 4) (D 3) (D 2)) ((D 4) (D 3) (D 2)) ((D 3) (:REST)) ((D 3)) ((D 3))
	   ((G 3) (D 3) (B 2)) ((G 3) (D 3) (B 2)) ((D 4) (B 3) (G 3)) ((D 4) (B 3) (G 3))
	   ((C 4) (G 3) (E 3)) ((B 3)) ((A 3)) ((G 4) (D 4) (B 3)) ((G 4) (D 4) (B 3)) ((D 4) (B 3) (G 3))
	   ((C 4) (G 3) (E 3)) ((B 3)) ((A 3)) ((G 4) (D 4) (B 3)) ((G 4) (D 4) (B 3)) ((D 4) (B 3) (G 3))
	   ((C 4) (A 3) (F 3)) ((B 3)) ((C 4)) ((A 3) (F# 3) (D 3)) ((A 3) (F# 3) (D 3)) ((D 3)) ((:REST)) ((D 3))
	   ((G 3) (D 3) (B 2)) ((G 3) (D 3) (B 2)) ((D 4) (B 3) (G 3)) ((D 4) (B 3) (G 3))
	   ((C 4) (G 3) (E 3)) ((B 3)) ((A 3)) ((G 4) (D 4) (B 3)) ((G 4) (D 4) (B 3)) ((D 4) (B 3) (G 3))
	   ((C 4) (G 3) (E 3)) ((B 3)) ((A 3)) ((G 4) (D 4) (B 3)) ((G 4) (D 4) (B 3)) ((D 4) (B 3) (G 3))
	   ((C 4) (A 3) (F 3)) ((B 3)) ((C 4)) ((A 3) (F# 3) (D 3)) ((A 3) (F# 3) (D 3)) ((D 4) (D 3) (:REST))
	   ((G 4) (D 4) (B 3)) ((G 4) (D 4) (B 3)) ((G 4) (D 4) (B 3)) ((G 4) (D 4) (B 3)))))


;;; Color My World
;;; set speed = 350.
(defsound :color-my-world
  (music-interpreter 350
	 '(
	   ((F 2)) ((A 2)) ((C 3)) ((E 3)) ((C 3)) ((A 2)) ((F 2)) ((A 2)) ((C 3)) ((E 3)) ((C 3)) ((A 2))
	   ;;2
         ((F 3) (A 2) (F 1)) ((G 3)) ((A 3)) ((A 3)) (NIL (A 2)) (NIL (C 3)) ((F 3) (A 2) (F 1)) (NIL (C 3)) (NIL (E 3))
         ((A 3) (A 2) (C 2)) ((G 3)) ((F 3))
	 ;;3
         ((A 3) (:REST) (A 1)) (NIL (C 3)) (NIL (E 3)) (NIL (A 3)) (NIL (E 3)) (NIL (C 3)) ((:REST) (:REST) (A 1))
         (NIL (C 3)) (NIL (E 3)) ((A 3) (C 3) (C 2)) ((B- 3)) ((C 4))
	 ;;4
         ((B- 3) (:REST) (B- 1)) (NIL (D 3)) (NIL (F 3)) (NIL (B- 3)) (NIL (F 3)) (NIL (D 3)) (NIL (:REST))
         (NIL (D 3)) (NIL (F 3)) ((:REST) (D 3) (F 1)) ((B- 3)) ((F 3))
	 ;;5
         ((G 3) (:REST) (E- 1)) (NIL (B- 2)) (NIL (D 3)) (NIL (F 3)) (NIL (D 3)) (NIL (B- 2)) (NIL (:REST))
         (NIL (B- 2)) (NIL (D 3)) ((:REST) (F 3) (B- 1)) (NIL (D 3)) ((B- 2) (B- 2))
	 ;;6
         ((C 4) (C 3) (A- 1)) (NIL (E- 3)) (NIL (G 3)) (NIL (C 4)) (NIL (G 3)) (NIL (E- 3)) (NIL (C 3))
         (NIL (E- 3)) (NIL (G 3)) ((E- 4)) ((C 4)) ((A- 2))
	 ;;7
         ((B- 3) (B- 2) (G- 1)) (NIL (D- 3)) (NIL (F 3)) (NIL (B- 3)) (NIL (F 3)) (NIL (D- 3)) ((:REST) (B- 2)) (NIL (D- 3))
         (NIL (F 3)) ((B- 3) NIL (D- 2)) ((:REST)) ((B- 3))
	 ;;8
         ((A 3) (C 3) (D 2)) (NIL (E 3)) (NIL (F# 3)) (NIL (A 3)) (NIL (F# 3)) (NIL (E 3))
         ((:REST) (C 3)) ((D 3)) ((E 3)) ((F# 3) NIL (F# 1)) ((G 3)) ((A 3))
	 ;;9
         ((B 3) (B 2) (G 1)) (NIL (D 3)) (NIL (F# 3)) (NIL (G 3)) (NIL (F# 3)) (NIL (D 3)) (NIL (B 2))
	 (NIL (D 3)) (NIL (F# 3)) ((:REST) (B 3) (D 1)) (NIL (F# 3)) ((B 3) (D 3))
	 ;;10
         ((B- 3) (B- 2) (E- 1)) (NIL (D- 3)) (NIL (F 3)) (NIL (G 3)) (NIL (F 3)) (NIL (D- 3)) ((:REST) (B- 2))
         ((E- 3)) ((F 3)) ((G 3) (D 3) (C 1)) ((A- 2)) ((B- 3))
	 ;;11
         ((C 4) (E 3)) ((C 4) (E 3)) ((:REST) (:REST)) ((G 3)) (NIL (B- 2)) (NIL (C 3)) (NIL (E 3) (C 2))
         (NIL (C 3)) (NIL (B- 2)) (NIL (C 3)) (NIL (E 3)) (NIL (G 3))
	 ;;12
         ((E 4) (B- 3) (C 1)) ((D 4)) ((C 4)) ((B- 3) (:REST)) (NIL (C 3)) (NIL (E 3)) ((A 3) (A 3))
         (NIL (E 3)) (NIL (C 3)) (NIL (B- 2) (E 1)) (NIL (E 3)) ((G 3) (:REST))
	 ;;13
         ((F 3) (:REST) (F 1)) (NIL (A 2)) (NIL (C 3)) (NIL (E 3)) (NIL (C 3)) (NIL (A 2)) ((:REST) (B- 2) NIL)
         (NIL (D 3)) ((F 3) (F 3)) ((G 3) (B- 2) (E 1)) (NIL (C 3)) ((E 3) (E 3))
	 ;14
         ((F 3) (F 2) (F 1)) (NIL (A 2)) (NIL (C 3)) (NIL (E 3)) (NIL (C 3)) (NIL (A 2)) ((F 3) (F 2) (F 1))
         ((F 3) (F 2) (F 1)) ((F 3) (F 2) (F 1)) ((F 3) (F 2) (F 1)) ((F 3) (F 2) (F 1)))))

;;
;; The following sounds and music are programed using the byte codes that go to the sound chip! (yech)
;; They're hard to understand, but sound nice.  They must have been ripped out of TI990/4 code.
;;

(defsound :promenade
  (playf '#x(
  (setq t16 500.) (setq t8 250.)
  88 16 90 (:delay t16)
  84 19 (:delay t16)
  8e 12 (:delay t16)
  8d 10 (:delay t8)
  8a 0c (:delay t8)
  
  80 0f (:delay t16)
  8b 10 (:delay t8)
  8a 0c (:delay t8)
  80 0f (:delay t16)
  8e 12 (:delay t16)
  
  8d 10 (:delay t16)
  88 16 (:delay t16)
  84 19 (:delay t16)
  88 16 a0 1e cd 25 b0 d0 (:delay t16)
  
  84 19 ab 21 c1 28 (:delay t16)
  8e 12 a0 ae cd 25 (:delay t16)
  8d 10 a0 14 cb 21 (:delay t8)
  8a 0c (:delay t8)
  80 0f c4 19 (:delay t16)
  
  8d 10 cb 21 (:delay t8)
  8a 0c (:delay t8)
  80 0f ae 12 c4 19 (:delay t16)
  8e 12 a8 16 c0 1e (:delay t16)
  8d 10 cc 1a (:delay t16)
  
  88 16 ab 21 cf 2c (:delay t16)
  84 19 c1 28 (:delay t16) (:delay t16) (:delay t16)
  9f bf df ff )))

(defsound :anitra-dance
  (playf '#x(
	  (setq m8 100.) (setq m16 200.)
	   c9 3f d0 (:delay m16) (:delay m8)
	   df (:delay m8)
	   8c 1a 90 ad 1f b0 c7 2a d0 (:delay m8) (:delay m16)
	   9f bf df (:delay m8)
	   8d 17 90 a5 1c b0 d0 (:delay m8)
	   df (:delay m8)
	   d0 (:delay m8)
	   9f bf df (:delay m8)

	   c9 3f d0 (:delay m8) (:delay m16)
	   df (:delay m8)
	   83 15 90 ac 1a b0 c7 2a d0 (:delay m8) (:delay m16)
	   9f bf df (:delay m8)
	   80 14 90 ad 17 b0 d0 (:delay m8)
	   df (:delay m8)
	   d0 (:delay m8)
	   9f bf df (:delay m8)

	   c9 3f d0 (:delay m8) (:delay m16)
	   df (:delay m8)
	   83 15 90 ac 1a b0 c7 2a d0 (:delay m8) (:delay m16)
	   9f bf df (:delay m8)
	   8d 17 90 a5 1c b0 d0 (:delay m8)
	   df (:delay m8)
	   d0 (:delay m8)
	   9f bf df (:delay m8)

	   c9 3f d0 (:delay m8) (:delay m16)
	   df (:delay m8)
	   8c 1a 90 ad 1f b0 c7 2a d0 (:delay m8) (:delay m16)
	   9f bf df (:delay m8)
	   83 15 90 a5 1c b0 d0 (:delay m8)
	   df (:delay m8)
	   d0 (:delay m8)
	   9f bf df (:delay m8)

	   8e 0f 90 c9 3f d0 (:delay m8)
	   9f (:delay m8)
	   8d 10 90 (:delay m8)
	   9f df (:delay m8)
	   8e 0f 90 ac 1a b0 c7 2a d0 (:delay m8)
	   9f (:delay m8)
	   83 0e 90 (:delay m8)
	   9f bf df (:delay m8)
	   86 0d 90 ad 17 b0 d0 (:delay m8)
	   9f (:delay m8)
	   8e 0b 90 (:delay m8)
	   9f bf df (:delay m8)

	   8a 0a 90 c9 3f d0 (:delay m16)
	   8f 07 (:delay m8)
	   df (:delay m8)
	   8a 0a a3 15 b0 c7 2a d0 (:delay m8) (:delay m16)
	   bf df (:delay m8)
	   8e 0b a0 14 b0 d0 (:delay m8) (:delay m16)
	   bf df (:delay m8)

	   86 0d c9 3f d0 (:delay m16)
	   8f 07 (:delay m8)
	   df (:delay m8)
	   86 0d a3 15 b0 c7 2a d0 (:delay m8) (:delay m16)
	   bf df (:delay m8)
	   83 0e ad 17 b0 d0 (:delay m8) (:delay m16)
	   bf df (:delay m8)

	   8e 0f c9 3f d0 (:delay m8) (:delay m16)
	   df (:delay m8)
	   ac 1a b0 c7 2a d0 (:delay m8) (:delay m16)
	   bf df (:delay m8)
	   9f a3 15 b0 cd 1f d0 (:delay m8) (:delay m16)
	   bf df (:delay m8)

	   90 c9 3f d0 (:delay m16)
	   86 0d (:delay m8)
	   df (:delay m8)
	   8e 0f a0 14 b0 cd 1f d0 (:delay m8) (:delay m16)
	   bf df (:delay m8)
	   8d 11 a3 15 b0 cb 23 d0 (:delay m8) (:delay m16)
	   bf df (:delay m8)

	   8e 12 c9 3f d0 (:delay m16)
	   86 0d (:delay m8)
	   df (:delay m8)
	   8e 12 a8 16 b0 cd 25 d0 (:delay m8) (:delay m16)
	   bf df (:delay m8)
	   b0 d0 (:delay m8) (:delay m16)
	   bf df (:delay m8)

	   80 14 c9 3f d0 (:delay m16)
	   86 0d (:delay m8)
	   df (:delay m8)
	   80 14 ac 1a b0 cd 1f d0 (:delay m8) (:delay m16)
	   bf df (:delay m8)
	   83 15 b0 cb 23 d0 (:delay m8) (:delay m16)
	   bf df (:delay m8)

	   88 16 c9 3f d0 (:delay m16)
	   83 0e (:delay m8)
	   df (:delay m8)
	   88 16 a5 1c b0 c1 28 d0 (:delay m8) (:delay m16)
	   bf df (:delay m8)
	   b0 d0 (:delay m8) (:delay m16)
	   bf df (:delay m8)

	   83 0e b0 (:delay m16)
	   80 0f a0 1e (:delay m16)
	   8e 12 ad 25 (:delay m16)
	   83 0e a5 1c (:delay m16)
	   8e 0f ad 1f (:delay m16)
	   80 14 a1 28 (:delay m16)

	   83 0e a5 1c (:delay m16)
	   8d 10 ad 21 (:delay m16)
	   83 15 a7 2a (:delay m16)
	   83 0e 15 1c (:delay m16)
	   8d 11 ab 23 (:delay m16)
	   88 16 af 2c (:delay m16)

	   83 0e a5 1c (:delay m16)
	   8e 12 ad 25 (:delay m16)
	   8d 17 aa 2f (:delay m16)
	   83 0e a5 1c (:delay m16)
	   80 14 a1 28 (:delay m16)
	   84 19 a7 32 (:delay m16)

	   83 0e a5 1c (:delay m16)
	   83 15 a7 2a (:delay m16)
	   8c 1a a7 35 (:delay m16)
	   83 0e a5 1c (:delay m16)
	   88 16 ad 25 (:delay m16)
	   85 1c aa 2f (:delay m16)

	   83 15 a7 2a (:delay m16)
	   88 16 af 2c (:delay m16)
	   83 15 a7 2a (:delay m16)
	   8e 12 ad 25 (:delay m16)
	   8d 11 ab 23 (:delay m16)
	   8e 0f ad 15 (:delay m16)

	   83 0e a5 1c (:delay m16)
	   8a 0a a3 15 (:delay m16)
	   83 0e a5 1c (:delay m16)
	   8e 0f ad 1f (:delay m16)
	   8d 11 ab 23 (:delay m16)
	   8e 12 ad 25 (:delay m16)

	   83 15 a7 2a (:delay m16)
	   8e 12 ad 25 (:delay m16)
	   8d 11 ab 23 (:delay m16)
	   8e 0f ad 1f (:delay m16)
	   83 0e aa 38 c5 1c d0 (:delay m16) (:delay m16)

	   8a 0a a3 15 c7 2a (:delay m16) (:delay m16) (:delay m8)
   	   9f bf df ff )))
