;;; -*- Mode:Text; Package:PICTURE; Base:10; Fonts:(MEDFNB HL12B HL12BI) -*-

#|

Design notes for an effort in progress but not finished:
  Multiple-object capability for move/copy/delete operations.  All that has been implemented
  is a method named :object-inside-box-p for the basic-object flavor.  Many things remain to
  be done.  Use the box code to implement a mechanism for boxing a region.  In this way one
  can specify the box and move it around to select those objects of interest.  Be sure to
  handle the line thickness properly.  Only create one box instance to handle boxing.  In
  addition to boxing, allow one to select objects by pointing at them.  By combining these
  two approaches together, one should be able to select objects in the easiest way possible.
  Try to not force the user into a menu-driven approach for this operation.  Need to
  implement a method for each object that places the hand icon near the object to indicate that it
  has been selected.  This is easy for most objects, but gets more difficult for the rounded
  corner object since there are so many cases.  Use the hand mouse glyph to indicate that an
  object has been selected.  Need to allow about how one can deselect objects using the same
  mechanisms that can be used to select them (i.e.  boxing and pointing).  Need to add three
  new menu items: multiple move, multiple copy and multiple delete.  Try to fit them to the
  right of their single-object counterparts so that the user will notice them quickly.  Another
  option is to put the `multiple' commands in as a `right mouse click'.  This is less preferable
  since the user may not notice their presence.  Of course a mail message to tex.users should
  help.  Most of these three operations are common and there probably isn't enough code to make it
  necessary to split them off into separate files.  The code to implement this part is
  probably straightforward.  The real problem will be to implement the selection indicator
  code for all objects since there are so many of them (10 of them, with 8 variations on
  rounded corners).  The menu approach to object selection/deselection is one mechanism that
  was rejected, primarily because it doesn't blend well with the other mechanisms that are
  used.

Known problems that need fixing:
  When the user presses the ABORT key the orientation flips back to portrait but the configuration
  stays the same.  The orientation shouldn't change at all.

  When the grid is on and one moves an object which was placed with the grid off, the initial
  position is calculated incorrectly, causing trash pixels to appear on the screen.

  When the grids are too small they disappear.  There needs to be some kind of message to
  tell the user that this has happened.

  There is a problem with margins in landscape orientation.  The constraint checking is still set
  up for portrait orientation.

  Turning off the margins doesn't refresh the entire grid.

  The line thickness is incorrectly allowed for ovals and rounded corners.  What should happen is
  if the line thickness is >= than `thick lines' then `thick lines' should be used for ovals
  and rounded corners.  Otherwise `thin lines' should be used.

  The :DISTANCE-FROM-POINT method for oval-object and rounded-corner-object flavors assumes
  that the object is really a rectangle.  While this is a reasonable simplification, it needs
  to be corrected someday to reflect the true shape of these two objects.


Things to think about doing:
  Look at another way to specify a margin.  The current way has the user enter the distances from
  the left or top edge.  Another way would be to allow the user to enter the distance from the
  nearest edge.  How about both?  Would that be too confusing to the user?

  Implement subpicture mode where one can define a collection of objects to be one unit.

  Implement framing.  See page 108 for an example.  This object is a variation on a hollow
  box object where the frame touches the text.

  Think about how to draw triangles, or other objects not implemented directly by LaTeX.

Other random thoughts:

  Thought about other fonts that one might want.  To make the task easier, just limit
  the fonts to one of the following categories:
        10 point vs 12 point
        tiny, scriptsize, footnotesize, small, normalsize, large, Large, LARGE, huge, Huge,
          or some subset of these.
        Roman, emphatic, bold, italic, slanted, Sans Serif, small caps, typewritter
  Taking all of these together, there are 160 combinations to handle - too many.  The main
  idea of this program is to make pictures easier to draw, not to draw many different kinds
  of fonts.  If fonts are enhanced, don't spend too much time on it since the payback isn't
  that great.  Perhaps something better would be to have a way to insert LaTeX specific code
  into text that doesn't get displayed on the screen, but gets written out to the .TEX and
  .PIC files.  This would be much easier to implement, would not force one to make an edit
  on the .TEX file that gets automatically generated and would also work in most of the cases.
  This would not work if one had text that needed to be in more than one font; it would also not
  display in that font on the screen.

  What I really did was to allow for a small number of fonts styles rm, bf and em which would
  pertain to all of the text associated with a given object.  This was relatively easy and
  should handle most of the cases.  What this doesn't handle, is the case where one wants some
  text in a box in one font and the rest of the text in a different font.  To get this effect one
  must enter the LaTeX commands for the text of the target object and then click right on the
  `Write TeX file' menu item which will write out those LaTeX commands `as is'.  This defeats the
  WYSIWYG theme, but is better than forcing the user to edit the .TEX file.

|#
