;;;-*- Mode:Common-Lisp; Package:USER; Base:10; Fonts:(MEDFNB HL12B HL12BI) -*-



;;; This software was developed at the Texas Instruments Corporation
;;; and is provided "as-is".  Texas Instruments Corporation and the
;;; author disclaim all warranties on the software, including without
;;; limitation, all implied warranties of merchantability and fitness.
;;;
;;; This software does not contain any technical data or information
;;; that is proprietary in nature.  It may be copied, modified, and
;;; distributed on a non-profit basis and with the inclusion of this
;;; notice.
;;;
;;; Copyright (C) 1989, Texas Instruments Incorporated.




;;; Change history:
;;;
;;;  Date      Author	Description
;;; -------------------------------------------------------------------------------------
;;;  4/20/87  1  *TWE	Fixed up the exporting by changing the lists to contain strings
;;;			instead of symbols.
;;;  4/16/87    TWE	Added exporting to the USER package so one doesn't have to enter
;;;			the package prefix so often.
;;; 12/31/86	TWE	Inserted EVAL-WHENs to make the make-system work.
;;; 12/30/86	TWE	Exported some symbols.
;;; 12/29/86	TWE	Initial creation.


#|

This file defines the PICTURE package and all of the symbol-related
things that go on with it.

|#

(EVAL-WHEN (COMPILE LOAD)
  (UNLESS (FIND-PACKAGE 'PICTURE)
    (MAKE-PACKAGE "PICTURE" :SIZE 1000.)))

(EVAL-WHEN (LOAD)
  ;; The idea here is to have two kinds of export lists, one for those symbols
  ;; which should be accessible from other packages, and another for those
  ;; things that a user may want to use from a lisp listener.
  (LET ((PICTURE-EXPORT-LIST (LOOP FOR SYMBOL IN '("DEFINE-UNIT")
                                   COLLECTING (INTERN SYMBOL 'PICTURE)))
        (USER-EXPORT-LIST (LOOP FOR SYMBOL IN '("MAKE-PICTURE")
                                COLLECTING (INTERN SYMBOL 'PICTURE))))
    (EXPORT PICTURE-EXPORT-LIST 'PICTURE)
    (EXPORT USER-EXPORT-LIST    'PICTURE)
    (EXPORT USER-EXPORT-LIST    'USER)))
