;;;-*- Mode:Common-Lisp; Package:USER; Base:10; Fonts:(MEDFNB HL12B HL12BI) -*-



;;; This software was developed at the Texas Instruments Corporation
;;; and is provided "as-is".  Texas Instruments Corporation and the
;;; author disclaim all warranties on the software, including without
;;; limitation, all implied warranties of merchantability and fitness.
;;;
;;; This software does not contain any technical data or information
;;; that is proprietary in nature.  It may be copied, modified, and
;;; distributed on a non-profit basis and with the inclusion of this
;;; notice.
;;;
;;; Copyright (C) 1989, Texas Instruments Incorporated.




;;; Change history:
;;;
;;;  Date      Author	Description
;;; -------------------------------------------------------------------------------------
;;;  3/20/89    TWE	Added the spline stuff.
;;; 10/13/88    TWE	Added the empty box stuff.
;;;  9/22/88    TWE	Changed the :PATHNAME-DEFAULT to use PICTURE:PICTURE; instead of
;;;			SYS:PUBLIC.PICTURE;.  This makes this file more portable.
;;;  7/20/87    TWE	Added the describe command.
;;;  6/22/87    TWE	Added the oval stuff.
;;;  6/19/87    TWE	Added more for circles.  Fixed up the draw-filled-circle method
;;;			and put a form here to load it in.
;;;  6/02/87    TWE	Moved GRID in with TRANSLATIONS so that the new macro defined
;;;			there could be used in the edit/move/copy/delete code.
;;;  6/01/87    TWE	Renamed COPY to COPY-MOVE to make the name more meaningful.
;;;			Moved translations to be at its own level, just below base.
;;;			This was done to handle the empty-line-height variable in a
;;;			reasonable manner.
;;;  5/21/87    TWE	Added more for help, copy and delete.
;;;  5/19/87    TWE	Added the basic line and the grid modules.
;;;  5/07/87    TWE	Added the text module.
;;;  5/05/87    TWE	Added the margins module.
;;;  4/23/87    TWE	Added a dependent objects module for those objects that use
;;;			code which is defined in the `objects' module.  `Vector' is such
;;;			an example since it uses some of the `line' code.
;;;  4/16/87    TWE	Removed the release 2 code and made sure that the bug fixes for
;;;			release 3.1 get loaded.
;;;  1/06/87	TWE	Fixed up the dependencies to be sure and load all previous
;;;			components before starting the current one.
;;; 12/29/86	TWE	Initial creation.


(DEFSYSTEM PICTURE
  (:NAME                       "LaTeX Picture")
  (:SHORT-NAME                 "Picture")
  (:PATHNAME-DEFAULT           "PICTURE:PICTURE;")
  (:MODULE PACKAGE             "DEFINE-PACKAGE")
  (:MODULE DEFS                "BASE")
  (:MODULE PRIMITIVE-DEFS      ("TRANSLATIONS" "GRID"))
  (:MODULE PRIMITIVES          ("DISPLAY-TEXT"
                                "BASIC-BOX" "BASIC-LINE" "BASIC-CIRCLE" "BASIC-CORNER"
                                "EDIT" "COPY-MOVE" "DELETE" "DESCRIBE"))
  (:MODULE OBJECTS             ("BOX" "LINE" "TEXT" "SPLINE" "HOLLOW-CIRCLE" "FILLED-CIRCLE" "OVAL"
                                "CORNER"))
  (:MODULE DEPENDENT-OBJECTS   ("VECTOR" "MARGINS" "EMPTY-BOX"))
  (:MODULE USER1                "USER-INTERFACE")
  (:MODULE USER2                "HELP")
  (:MODULE COMP-FLAV           "COMPILE-FLAVOR-METHODS")
  
  (:COMPILE-LOAD               PACKAGE)
  (:COMPILE-LOAD               DEFS              (:FASLOAD PACKAGE))
  (:COMPILE-LOAD               PRIMITIVE-DEFS    (:FASLOAD PACKAGE DEFS))
  (:COMPILE-LOAD               PRIMITIVES        (:FASLOAD PACKAGE DEFS PRIMITIVE-DEFS))
  (:COMPILE-LOAD               OBJECTS           (:FASLOAD PACKAGE DEFS PRIMITIVE-DEFS PRIMITIVES))
  (:COMPILE-LOAD               DEPENDENT-OBJECTS (:FASLOAD PACKAGE DEFS PRIMITIVE-DEFS PRIMITIVES
                                                           OBJECTS))
  (:COMPILE-LOAD               USER1             (:FASLOAD PACKAGE DEFS PRIMITIVE-DEFS PRIMITIVES
                                                           OBJECTS DEPENDENT-OBJECTS))
  (:COMPILE-LOAD               USER2             (:FASLOAD PACKAGE DEFS PRIMITIVE-DEFS PRIMITIVES
                                                           OBJECTS DEPENDENT-OBJECTS USER1))
  (:COMPILE-LOAD-INIT          COMP-FLAV      (DEFS OBJECTS DEPENDENT-OBJECTS USER1 USER2)
                             (:FASLOAD PACKAGE DEFS OBJECTS DEPENDENT-OBJECTS USER2 USER2)))
