;;; -*- Mode:Common-Lisp; Package:PICTURE; Base:10; Fonts:(MEDFNB HL12B HL12BI) -*-



;;; This software was developed at the Texas Instruments Corporation
;;; and is provided "as-is".  Texas Instruments Corporation and the
;;; author disclaim all warranties on the software, including without
;;; limitation, all implied warranties of merchantability and fitness.
;;;
;;; This software does not contain any technical data or information
;;; that is proprietary in nature.  It may be copied, modified, and
;;; distributed on a non-profit basis and with the inclusion of this
;;; notice.
;;;
;;; Copyright (C) 1989, Texas Instruments Incorporated.




;;; Change history:
;;;
;;;  Date      Author	Description
;;; -------------------------------------------------------------------------------------
;;;  9/11/87    TWE	Fixed up for landscape mode.
;;;  7/20/87    TWE	Initial creation.

#|

This file defines the command that describes objects when one clicks the mouse.

|#

(DEFUN DESCRIBE-OBJECT (MOUSE-X MOUSE-Y)
  (DECLARE (SELF-FLAVOR PICTURE-WINDOW))
  (LET* ((X (TRANSLATE-PIXEL-TO-UNIT MOUSE-X))
         (Y (TRANSLATE-PIXEL-TO-UNIT (- Y-PIXEL-ORIGIN MOUSE-Y)))
         (OBJECT-TO-DESCRIBE (LOOP FOR OBJECT IN DISPLAY-LIST
                                   WITH OBJECT-DISTANCE  = NIL
                                   WITH NEAREST-OBJECT   = NIL
                                   WITH NEAREST-DISTANCE = MOST-POSITIVE-SHORT-FLOAT
                                   WHEN (NOT (EQ OBJECT MARGIN-OBJECT))
                                   DO (PROGN
                                        (SETQ OBJECT-DISTANCE (SEND OBJECT
                                                                    :DISTANCE-FROM-POINT
                                                                    SELF X Y))
                                        (WHEN (< OBJECT-DISTANCE NEAREST-DISTANCE)
                                          (SETQ NEAREST-DISTANCE OBJECT-DISTANCE
                                                NEAREST-OBJECT   OBJECT)
                                          (WHEN (ZEROP OBJECT-DISTANCE)
                                            (RETURN OBJECT))))
                                   FINALLY (RETURN NEAREST-OBJECT)))
        (INTERACTION-PANE (GET-INTERACTION-PANE SELF)))
    ;; Identify the object being described.
    (IF (NULL OBJECT-TO-DESCRIBE)
        ;; There aren't any object.  Nice try.
        (SEND INTERACTION-PANE :LINE-OUT "There are not any objects to describe.")
        ;;1ELSE*
        (SEND INTERACTION-PANE :LINE-OUT (SEND OBJECT-TO-DESCRIBE :NAME))
        (FORMAT INTERACTION-PANE "Base unit is ~A.~%" (UNIT-NAME-STRING BASE-UNIT)))))
