;;; -*- Mode:Common-lisp; Package:user; Base:10.; Fonts: MEDFNT,HL12B -*-

(DEFMACRO THEN (&BODY BODY)
  `(PROGN ,@BODY))

(DEFMACRO ELSE (&BODY BODY)
  `(PROGN ,@BODY))

(DEFCONSTANT PUT-CHOICE-LIST '("Do it2 []*"))

(DEFVAR FILE-CODE-LIST (LIST "A" "B" "C" "D" "E" "F" "G" "H" "I" "J" "K" "L" "M" "N" "O" "P" "Q" "R" "S" "T" "U " "V" "W" "X" "Y" "Z"))

(DEFVAR NUMBER-OF-HOLES 0)
(DEFVAR FREE-SPACE 0)
(DEFVAR TOTAL-SPACE 0)
(DEFUN PUT (&REST PATHNAMES 
            &AUX (DISPLAY NIL) (SINGLE-LINE "") PREVIOUS-VALUE
	    PAGES REMAINDER FILE-ARRAY STREAM MAP BLOCKS SIZE LOC)
  "2Display the Page Usage Table.   Up to 26 pathnames may be passed as arguments.  The
    location of these files will be identified within the PUT display by a letter.*"

  (DECLARE (SPECIAL NUMBER-OF-HOLES FREE-SPACE TOTAL-SPACE))
  
  (SETF FILE-ARRAY (MAKE-ARRAY (ARRAY-LENGTH FS:PAGE-USAGE-TABLE)))
  (DO* ((FILE (CAR PATHNAMES) (CAR REST))
	(REST (CDR PATHNAMES) (CDR REST))
	(CODE-COUNT 0 (1+ CODE-COUNT))
	(FILE-CODE (NTH CODE-COUNT FILE-CODE-LIST) (NTH CODE-COUNT FILE-CODE-LIST)))
       ((NOT FILE))
    (SETF STREAM (OPEN FILE))
    (NSUBST (SEND (TRUENAME STREAM) :STRING-FOR-PRINTING) FILE PATHNAMES)
    (SETF MAP (SYMEVAL-IN-INSTANCE STREAM 'GLOBAL:MAP))
    (SETF BLOCKS (FS:MAP-NBLOCKS MAP))
    (DO* ((INDEX 0 (1+ INDEX)))
	 ((= INDEX BLOCKS))
      (SETF SIZE (FS:MAP-BLOCK-SIZE MAP INDEX))
      (SETF LOC (FS:MAP-BLOCK-LOCATION MAP INDEX))
      (MULTIPLE-VALUE-SETQ (PAGES REMAINDER) (TRUNCATE SIZE 8192.))
      (IF (PLUSP REMAINDER) (INCF PAGES))
      (DO ((INDEX2 0 (1+ INDEX2)))
	  ((= INDEX2 PAGES))
	(SETF (AREF FILE-ARRAY (+ LOC INDEX2)) FILE-CODE)))
    (CLOSE STREAM))
  
  (SETF TOTAL-SPACE (ARRAY-LENGTH FS:PAGE-USAGE-TABLE))
  (SETF NUMBER-OF-HOLES 0)
  (SETF FREE-SPACE 0)
  
  (DO ((INDEX 0 (+ #X40 INDEX)))
      ((= INDEX TOTAL-SPACE))
    
    (SETF SINGLE-LINE (FORMAT NIL " ~4,48X   " INDEX))
    
    (DO ((LINE-INDEX INDEX (1+ LINE-INDEX)))
	((= LINE-INDEX (+ INDEX #X40)))
      
      (IF (NOT (AREF FILE-ARRAY LINE-INDEX))
	  (THEN 
	    (SELECTQ (AREF FS:PAGE-USAGE-TABLE LINE-INDEX)
	      (0 (SETF SINGLE-LINE (STRING-APPEND SINGLE-LINE " "))
		 (INCF FREE-SPACE)
		 (IF (NOT (= PREVIOUS-VALUE 0)) (INCF NUMBER-OF-HOLES)))
	      (1 (SETF SINGLE-LINE (STRING-APPEND SINGLE-LINE "1")))
	      (2 (SETF SINGLE-LINE (STRING-APPEND SINGLE-LINE "2")))
	      (OTHERWISE (SETF SINGLE-LINE (STRING-APPEND SINGLE-LINE "X")))))
	  (ELSE
	    (SETF SINGLE-LINE (STRING-APPEND SINGLE-LINE (AREF FILE-ARRAY LINE-INDEX)))))
      (SETF PREVIOUS-VALUE (AREF FS:PAGE-USAGE-TABLE LINE-INDEX)))
    
    (SETF DISPLAY (APPEND  DISPLAY (LIST SINGLE-LINE))))

  (SETF DISPLAY (APPEND (LIST "") DISPLAY))
  
  (DO ((INDEX (1- (LENGTH PATHNAMES)) (1- INDEX)))
      ((MINUSP INDEX))
    (SETF DISPLAY (APPEND (LIST (STRING-APPEND (NTH INDEX FILE-CODE-LIST)
					       " => "
					       (NTH INDEX PATHNAMES)))
			  DISPLAY)))
  
  (SETF DISPLAY 
	(APPEND
	  (LIST 
	    `(USER:TOTAL-SPACE "NUMBER OF PAGES IN FILE BAND "
			       :documentation "Number of pages in the file band" :NUMBER)
	    `(USER:NUMBER-OF-HOLES "NUMBER OF HOLES "
				   :documentation "Number of holes in table" :NUMBER)
	    `(USER:FREE-SPACE "NUMBER OF PAGES AVAILABLE "
			      :documentation "Number of pages available to use" :NUMBER))
	  DISPLAY
	  ))
  
  (TV:CHOOSE-VARIABLE-VALUES
    DISPLAY
    :LABEL "DISPLAY THE PAGE USAGE TABLE"
    :MARGIN-CHOICES PUT-CHOICE-LIST
    :WIDTH 80.
    :HEIGHT 750.))



