;;; -*- Mode: Common-Lisp; Package: User; Base: 10. -*-

;;;  4/21/87 D.N.G.

#+(or TI LMI)
(eval-when (eval compile load)
(defun QUOTE-SMASHABLE (&quote value)
  "Like QUOTE except that the compiler will not write-protect it,
value-propagate it, constant-fold it, or cause it to share storage with
other EQUAL constants.  This permits the value to be destructively
modified if you think you must do that."
  value)
(defun (:property QUOTE-SMASHABLE compiler:p2) (argl dest)
  (let ((arg (first argl))) ; a QUOTE form
    (compiler:p2
      (if (and compiler:qc-file-in-progress
	       (not compiler:qc-file-load-flag))
	  ;; if in COMPILE-FILE
	  `(quote ,(cons compiler:eval-at-load-time-marker
			 `(si:copy-object ,arg)))
	arg)
      dest)))
)
#-(or TI LMI)
(defmacro QUOTE-SMASHABLE (arg) `(quote ,arg))
