;;; -*- Mode: COMMON-LISP; Package: ZWEI; Base: 10; Fonts: MEDFNT, HL12B, HL12BI; -*-
;;;===============================================================================
;;;                                    RESTRICTED RIGHTS LEGEND 
;;; Use,  duplication, or  disclosure  by  the  Government is subject to restrictions
;;; as set forth in subdivision (c)(1)(ii) of the Rights in Technical Data and
;;; Computer Software clause at 52.227-7013. 
;;;
;;; TEXAS INSTRUMENTS INCORPORATED, P.O. BOX 2909 AUSTIN, TEXAS 78769  
;;; Copyright (C) 1986, Texas Instruments Incorporated. All rights reserved.
;;;===============================================================================

;;;
;;; Change history:
;;;
;;;  Date	Author	Description
;;; -------------------------------------------------------------------------------------
;;; 12/09/87	LGO	Created


(defcom com-replace-macro-expansion "Replace the next s-expression with its macroexpansion." ()
  (let (form)
    (let ((stream (rest-of-interval-stream (point))))
      (setq form (read stream () '*eof*)))
    (and (eq form '*eof*) (barf))
    (setq form (macroexpand-1 form))
    (kill-interval (point) (forward-sexp (point)) t)
    (let* ((stream (interval-stream-into-bp (point))))
      (pprint form stream))
    dis-text))

(set-comtab *standard-comtab*
	    '(#\super-shift-m com-replace-macro-expansion)
	    (make-command-alist
	      '(com-replace-macro-expansion
		 )))