;;; -*- Mode:Common-Lisp; Package:TV; Base:10; Fonts:(CPTFONT CPTFONTB) -*-

;;;                           RESTRICTED RIGHTS LEGEND

;;;Use, duplication, or disclosure by the Government is subject to
;;;restrictions as set forth in subdivision (b)(3)(ii) of the Rights in
;;;Technical Data and Computer Software clause at 52.227-7013.
;;;
;;;                     TEXAS INSTRUMENTS INCORPORATED.
;;;                              P.O. BOX 2909
;;;                           AUSTIN, TEXAS 78769
;;;                                 MS 2151
;;;
;;; Copyright (C) 1985, Texas Instruments Incorporated. All rights reserved.
;	** (c) Copyright 1980 Massachusetts Institute of Technology **

; Copyright (c) 1983 Texas Instruments Incorporated  All Rights Reserved 
 


(DEFMACRO def-beep-speech (name file)
  `(def-beep-function ,name play ,name ,file))

;;This is Steve Ford saying the word BEEP.
(def-beep-speech :human-beep "SYS:PUBLIC.SPEECH;BEEP.SOUND")

;; Makes a sound that almost sounds like a phone ringing.
(def-beep-speech :phone-ringing "SYS:PUBLIC.SPEECH;PHONE_RINGING.SOUND")


;; Says the phrase: HEY, STOP THAT!
(def-beep-speech :hey-stop-that "SYS:PUBLIC.SPEECH;HEY_STOP_THAT.SOUND")

;; Says the phrase: Don't DO that!
(def-beep-speech :dont-do-that "SYS:PUBLIC.SPEECH;DONT_DO_THAT.SOUND")

;; Says the phrase: Don't touch
(def-beep-speech :dont-touch "SYS:PUBLIC.SPEECH;DONT_TOUCH.SOUND")

;; Says the phrase: Keep your hands off!
(def-beep-speech :keep-your-hands-off "SYS:PUBLIC.SPEECH;KEEP_YOUR_HANDS_OFF.SOUND")

;; Says the phrase: Ribbit Ribbit
(def-beep-speech :ribbit "SYS:PUBLIC.SPEECH;ribbit")

;; Pre-load some sounds
(DEFUN preload-speech (&rest speech-names)
  "Preload some speech data, 
where SPEECH-NAMES are the beep function names for speech."
  (DOLIST (name speech-names)
    (LET ((speech (GET name :beep-type)))
      (UNLESS (EQ (CAR speech) 'play)
	(FERROR "~s isn't the name of a speech" name))
      (WHEN (AND (THIRD speech)
		 (NOT (GET (SECOND speech) 'sound-array)))
	(read-speech (THIRD speech) (SECOND speech))))))

(preload-speech :human-beep :phone-ringing :DONT-DO-THAT :DONT-TOUCH :HEY-STOP-THAT :KEEP-YOUR-HANDS-OFF :RIBBIT)









