;;; -*- Mode:Common-Lisp; Package:USER; Patch-file:T; Base:10 -*-

;(DEFSYSTEM Glossary
;  (:name "Glossary")
;  (:short-name "Gloss")
;  (:documentation "Display definitions of terms")
;  (:default-menu-column :USER-AIDS)
;  (:default-system-key  #\Z)
;  (:pathname-default "sys:GLOSSARY;")
;  (:warnings-pathname-default "sys:cwarns;glossary.lisp")
;  (:patchable "SYS:PATCH.GLOSSARY;" PATCH)
;;;  (:initial-status :RELEASED)
;  (:instance-type :FLAVOR)
;  (:instance-finder GLOSS::GLOSSARY-FRAME)
;  (:instance-creator T)
  
;  (:module BASICS "basics")		   ;Required functions and declarations
;  (:module MACROS "macros")		   ;Defstructs and macros that we use
;  (:module INTERNAL "internal")		   ;Glossary flavors and methods
;  (:module DISPLAY "display")		   ;Display flavors and methods
;  (:module INITIALIZATIONS "initializations")	   ;Last file loaded
;  (:module MAIN-GLOSSARY "main-gloss")	   ;Default data file (glossary entries)
;  (:compile-load      BASICS)
;  (:compile-load      MACROS)
;  (:compile           MAIN-GLOSSARY)		   ;Don't load to save some space
;  (:compile-load      INTERNAL (:fasload basics macros) (:fasload BASICS MACROS))
;  (:compile-load      DISPLAY (:fasload  internal) (:fasload INTERNAL))
;  (:compile-load      INITIALIZATIONS (:fasload DISPLAY) (:fasload  DISPLAY)))

(SYS::SET-SYSTEM-ACCESS-LIST 'Glossary
			     :NAME "Glossary"
			     :DOCUMENTATION "Display definitions of terms"
			     :DEFAULT-MENU-COLUMN :USER-AIDS
			     :DEFAULT-SYSTEM-KEY  #\Z
			     :INSTANCE-TYPE    :FLAVOR
			     :INSTANCE-FINDER  'GLOSS::GLOSSARY-FRAME
			     :INSTANCE-CREATOR T)

(W:MODIFY-SYSTEM-ACCESS-SPEC 'Glossary
			     :ASSIGN-DEFAULTS)

(SETF (SYS:SYSTEM-MADE-P 'GLOSSARY) T)

;;;

;(DEFSYSTEM PROFILE
;          (:NAME "User Profile")
;	   (:DOCUMENTATION "Enter facility to modify working Explorer environment")
;	   (:DEFAULT-MENU-COLUMN :USER-AIDS)
;	   (:DEFAULT-SYSTEM-KEY #\U)
;	   (:PATHNAME-DEFAULT "SYS:PROFILE;")
;	   (:WARNINGS-PATHNAME-DEFAULT "SYS:CWARNS;PROFILE.LISP")
;	   (:PATCHABLE "SYS:PATCH.PROFILE;" PATCH)  ;;need to have this executed for the actual build
;	   (:INSTANCE-TYPE :FLAVOR)
;	   (:INSTANCE-FINDER PROFILE::PROFILE-FRAME)
;	   (:INSTANCE-CREATOR T)
	   
;	   (:COMPONENT-SYSTEMS NEW-USER)
;	   (:MODULE FORMS ("setf-forms"))
;	   (:MODULE UTILITY ("utility"))
;	   (:MODULE CVV "cvv-additions")
;           (:MODULE WINDOW "window")
;	   (:MODULE VARIABLES ("variables"))
;	   (:COMPILE-LOAD FORMS)
;	   (:COMPILE-LOAD-INIT UTILITY (FORMS) (:FASLOAD FORMS) (:FASLOAD FORMS))
;           (:COMPILE-LOAD-INIT CVV (UTILITY) (:FASLOAD UTILITY) (:FASLOAD UTILITY))
;           (:COMPILE-LOAD-INIT VARIABLES (CVV) (:FASLOAD CVV) (:FASLOAD CVV))
;           (:COMPILE-LOAD-INIT WINDOW (UTILITY) (:FASLOAD UTILITY) (:FASLOAD VARIABLES))) 

(SYS::SET-SYSTEM-ACCESS-LIST 'PROFILE
			     :NAME "User Profile"
			     :DOCUMENTATION "Enter facility to modify working Explorer environment"
			     :DEFAULT-MENU-COLUMN :USER-AIDS
			     :DEFAULT-SYSTEM-KEY #\U
			     :INSTANCE-TYPE   :FLAVOR
			     :INSTANCE-FINDER 'PROFILE::PROFILE-FRAME
			     :INSTANCE-CREATOR T)

(W:MODIFY-SYSTEM-ACCESS-SPEC 'PROFILE 
			     :ASSIGN-DEFAULTS)

(SETF (SYS:SYSTEM-MADE-P 'PROFILE) T)


;(DEFSYSTEM NEW-USER (:NAME "New User Utility")
;	   (:DOCUMENTATION "Procedure that allows new users to set up directories and profiles")
;	   (:DEFAULT-MENU-COLUMN :USER-AIDS)
;	   (:PATHNAME-DEFAULT "SYS:PROFILE;")
;	   (:PACKAGE 'NEW-USER)
;	   (:INSTANCE-TYPE :EVAL)
;	   (:INSTANCE-FINDER (IF (TYPEP *TERMINAL-IO* 'W:LISP-LISTENER)
;			(NEW-USER)
;			(NEW-USER::NEW-USER-OUTSIDE-LISP-LISTENER)))
;	   (:INSTANCE-CREATOR NIL)
	   
;           (:MODULE MAIN "new-user")
;	   (:COMPILE-LOAD MAIN))

(SYS::SET-SYSTEM-ACCESS-LIST 'NEW-USER 
			     :NAME "New User Utility"
			     :DOCUMENTATION "Procedure that allows new users to set up directories and profiles"
			     :DEFAULT-MENU-COLUMN :USER-AIDS
			     :INSTANCE-TYPE :EVAL
			     :INSTANCE-FINDER '(IF (TYPEP *TERMINAL-IO* 'W:LISP-LISTENER)
						   (NEW-USER)
						   (NEW-USER::NEW-USER-OUTSIDE-LISP-LISTENER))
			     :INSTANCE-CREATOR NIL)

(W:MODIFY-SYSTEM-ACCESS-SPEC 'NEW-USER 
			     :ASSIGN-DEFAULTS)

(SETF (SYS:SYSTEM-MADE-P 'NEW-USER) T)

;;;

;(defsystem suggestions
;  (:name "Suggestions")
;  (:documentation "Turn suggestions menus on or off")
;  (:default-menu-column :USER-AIDS)
;  (:default-system-key #\S)
;  (:pathname-default "sys:suggestions;")
;  (:patchable "sys:patch.suggestions;" patch)
;  (:warnings-pathname-default "sys:cwarns;suggestions.lisp")
;  (:instance-type :EVAL)
;  (:instance-finder (SUGG:SYSTEM-MENU-TOGGLE-SUGGESTIONS-MENUS))
;  (:instance-creator NIL)
  
;  (:module vars "global-variables")
;  (:module defs "basic-suggestions-functions")
;  (:module build-menu "suggestions-build-menu")
;  (:module wrappers "function-wrappers")
;  (:module advise "suggestions-advise")
;  (:module resizing "window-resizing")
;  (:module update "update-menus")
;  (:module simulate-typing "simulate-typing")
;  (:module pop-up-keys "pop-up-keystrokes-process")
;  (:module process "suggestions-process")
;  (:module off-frame "suggestions-off-frame")
;  (:module frame "suggestions-frame")
;  (:module documentation "display-documentation")
;  (:module zmacs-support "zmacs-support")
;  (:module menu-search "menu-search")
;  (:module reorder "reorder-menu")
;  (:module menu-tools "menu-tools")
;  (:module set-up "set-up-suggestions")
;  (:module break-menus "break-suggestions-menus")
;  (:module converse-menus "converse-suggestions-menus")
;  (:module debugger-menus "debugger-suggestions-menus")
;  (:module exception-menus "exception-handling-menus")
;  (:module input-editor-menus "input-editor-suggestions-menus")
;  (:module lisp-menus "lisp-expressions-menus")
;  (:module recursive-ie-menus "recursive-input-editor-menus")
;  (:module stepper-menus "single-stepper-suggestions-menus")
;  (:module zmacs-menus "zmacs-suggestions-menus")
;  (:module inspector-menus "inspector-menus")
;  (:module flavor-inspector "flavor-inspector-menus")
;  (:compile-load vars)
;  (:compile-load defs (:fasload vars) (:fasload vars))
;  (:compile-load build-menu (:fasload defs) (:fasload defs))
;  (:compile-load wrappers (:fasload build-menu) (:fasload build-menu))
;  (:compile-load advise (:fasload wrappers) (:fasload wrappers))
;  (:compile-load resizing (:fasload advise) (:fasload advise))
;  (:compile-load update (:fasload resizing) (:fasload resizing))
;  (:compile-load simulate-typing (:fasload update) (:fasload update))
;  (:compile-load pop-up-keys (:fasload simulate-typing) (:fasload simulate-typing))
;  (:compile-load process (:fasload pop-up-keys) (:fasload pop-up-keys))
;  (:compile-load off-frame (:fasload process) (:fasload process))
;  (:compile-load frame (:fasload off-frame) (:fasload off-frame))
;  (:compile-load documentation (:fasload frame) (:fasload frame))
;  (:compile-load zmacs-support (:fasload documentation) (:fasload documentation))
;  (:compile-load menu-search (:fasload zmacs-support) (:fasload zmacs-support))
;  (:compile-load reorder (:fasload menu-search) (:fasload menu-search))
;  (:compile-load menu-tools (:fasload reorder) (:fasload reorder))
;  (:compile-load set-up (:fasload menu-tools) (:fasload menu-tools))
;  (:compile-load break-menus (:fasload set-up) (:fasload set-up))
;  (:compile-load converse-menus (:fasload break-menus) (:fasload break-menus))
;  (:compile-load debugger-menus (:fasload converse-menus) (:fasload converse-menus))
;  (:compile-load exception-menus (:fasload debugger-menus) (:fasload debugger-menus))
;  (:compile-load input-editor-menus
;		 (:fasload exception-menus) (:fasload exception-menus))
;  (:compile-load lisp-menus (:fasload input-editor-menus) (:fasload input-editor-menus))
;  (:compile-load recursive-ie-menus (:fasload lisp-menus) (:fasload lisp-menus))
;  (:compile-load stepper-menus (:fasload recursive-ie-menus)
;		 (:fasload recursive-ie-menus))
;  (:compile-load zmacs-menus (:fasload stepper-menus) (:fasload stepper-menus))
;  (:compile-load inspector-menus (:fasload zmacs-menus) (:fasload zmacs-menus))
;  (:compile-load flavor-inspector (:fasload inspector-menus) (:fasload inspector-menus)))

(SYS::SET-SYSTEM-ACCESS-LIST 'suggestions
			     :NAME "Suggestions"
			     :DOCUMENTATION "Turn suggestions menus on or off"
			     :DEFAULT-MENU-COLUMN :USER-AIDS
			     :DEFAULT-SYSTEM-KEY #\S
			     :INSTANCE-TYPE :EVAL
			     :INSTANCE-FINDER '(SUGG:SYSTEM-MENU-TOGGLE-SUGGESTIONS-MENUS)
			     :INSTANCE-CREATOR NIL)

(W:MODIFY-SYSTEM-ACCESS-SPEC 'suggestions
			     :ASSIGN-DEFAULTS)

(SETF (SYS:SYSTEM-MADE-P 'SUGGESTIONS) T)


;;; STREAMER-TAPE

;(SI:DEFSYSTEM MAGTAPE-BACKUP
;  (:NAME "Tape Backup")
;  (:SHORT-NAME "Backup")
;  (:DOCUMENTATION "Backup or restore files and directories to or from magnetic tape")
;  (:DEFAULT-MENU-COLUMN :PROGRAMS)
;  (:DEFAULT-SYSTEM-KEY #\B)
;  (:PATHNAME-DEFAULT "sys: STREAMER-TAPE;")
;  (:NOT-IN-DISK-LABEL)
;  (:PACKAGE MT)
;  (:INSTANCE-TYPE    :FLAVOR)
;  (:INSTANCE-FINDER  MT::BACKUP-FRAME)
;  (:INSTANCE-CREATOR T)
  
;  (:MODULE MT-BACKUP ("verify" "part-stream"))
;  (:COMPILE-LOAD MT-BACKUP))

(SYS::SET-SYSTEM-ACCESS-LIST 'MAGTAPE-BACKUP
			     :NAME "Tape Backup"
			     :DOCUMENTATION "Backup or restore files and directories to or from magnetic tape"
			     :DEFAULT-MENU-COLUMN :PROGRAMS
			     :DEFAULT-SYSTEM-KEY #\B
			     :INSTANCE-TYPE :FLAVOR
			     :INSTANCE-FINDER  'MT::BACKUP-FRAME
			     :INSTANCE-CREATOR T)

(W:MODIFY-SYSTEM-ACCESS-SPEC 'MAGTAPE-BACKUP
			     :ASSIGN-DEFAULTS)

(SETF (SYS:SYSTEM-MADE-P 'MAGTAPE-BACKUP) T)


;;; CHAOS-NET

;(defsystem converse
;  (:name "Converse")
;  (:documentation "Send or receive messages from another Explorer monitor")
;  (:default-menu-column :PROGRAMS)
;  (:default-system-key #\C)
;  (:pathname-default "SYS: CHAOSNET;")
;  (:warnings-pathname-default "sys:cwarns;chaosnet.lisp")
;  (:instance-type    :FLAVOR)
;  (:instance-finder  ZWEI::CONVERSE-FRAME)
;  (:instance-creator T)
  
;  (:module source "conver")
;  (:compile-load source))

(SYS::SET-SYSTEM-ACCESS-LIST 'converse
			     :NAME "Converse"
			     :DOCUMENTATION "Send or receive messages from another Explorer monitor"
			     :DEFAULT-MENU-COLUMN :PROGRAMS
			     :DEFAULT-SYSTEM-KEY #\C
			     :INSTANCE-TYPE    :FLAVOR
			     :INSTANCE-FINDER  'ZWEI::CONVERSE-FRAME
			     :INSTANCE-CREATOR T)

(W:MODIFY-SYSTEM-ACCESS-SPEC 'converse
			     :ASSIGN-DEFAULTS)

(SETF (SYS:SYSTEM-MADE-P 'CONVERSE) T)


;;;

;(DEFSYSTEM FONT-EDITOR
;  (:NAME               "Font Editor" )
;  (:SHORT-NAME         "FED")
;  (:DOCUMENTATION      "Create new fonts or modify existing fonts")
;  (:DEFAULT-MENU-COLUMN :PROGRAMS)
;  (:DEFAULT-SYSTEM-KEY #\F)
;  (:PATHNAME-DEFAULT   "SYS:FONT-EDITOR;")
;  (:PATCHABLE          "SYS:PATCH.FONT-EDITOR;" PATCH)
;  (:WARNINGS-PATHNAME-DEFAULT "SYS:CWARNS;FONT-EDITOR.LISP")
;  (:INSTANCE-TYPE      :FLAVOR)
;  (:INSTANCE-FINDER    FED::FED-FRAME)
;  (:INSTANCE-CREATOR   (FED:FED))
  
;  (:MODULE DEFS        ("DEFS"
;	               "FLAVOR-DEFS"))
;  (:MODULE SUPPORT     ("FONT-DESCRIPTOR"
;                        "AST-SUPPORT"
;			"UCL-COMMANDS"))      
;  (:MODULE FLAVORS     ("GRID-MIXIN"
;	                "OTHER-GRID-MIXINS"
;	                "CURSOR"
;		        "BASIC-FED"
;		        "FED"
;			"FED-CHAR-MODIFIERS"
;			"FED-ONLINE-DOC"
;		        "REGISTER-PANE"
;		        "FED-TYPEOUT-WINDOW"
;		        "FED-LABEL-WINDOW"
;			"FED-FRAME"))
;  (:MODULE COMBINE    "COMPILE-FLAVOR-METHODS")
;  (:COMPILE-LOAD DEFS)
;  (:COMPILE-LOAD SUPPORT (:FASLOAD DEFS))
;  (:COMPILE-LOAD FLAVORS (:FASLOAD DEFS))
;  (:COMPILE-LOAD-INIT COMBINE (DEFS FLAVORS) (:FASLOAD DEFS SUPPORT FLAVORS))
;   )

(SYS::SET-SYSTEM-ACCESS-LIST 'FONT-EDITOR
			     :NAME "Font Editor"
			     :DOCUMENTATION "Create new fonts or modify existing fonts"
			     :DEFAULT-MENU-COLUMN :PROGRAMS
			     :DEFAULT-SYSTEM-KEY #\F
			     :INSTANCE-TYPE      :FLAVOR
			     :INSTANCE-FINDER    'FED::FED-FRAME
			     :INSTANCE-CREATOR   '(FED:FED))

(W:MODIFY-SYSTEM-ACCESS-SPEC 'FONT-EDITOR
			     :ASSIGN-DEFAULTS)

(SETF (SYS:SYSTEM-MADE-P 'FONT-EDITOR) T)



;;;

;(defsystem MAIL-READER
;  (:name "Mail Reader")
;  (:short-name "Bandy")				;Just a nickname
;  (:short-name "Mail-Reader")			;Last one becomes the real short name
;  (:documentation "Manage electronic mail messages")
;  (:default-menu-column :PROGRAMS)
;  (:default-system-key #\M)
;  (:pathname-default "SYS:MAIL-READER;")
;  (:patchable "SYS:PATCH.MAIL-READER;" PATCH)
;  (:warnings-pathname-default "SYS:CWARNS;MAIL-READER.LISP")
;  (:instance-type    :EVAL)
;  (:instance-finder  (ZWEI:READ-MAIL))
;  (:instance-creator NIL)
  
;  (:module options ("options"))
;  (:module definitions ("definitions"))
;  (:module main ("bandy"))
;  (:module parts ("message" "buffer" "display" "help" "summary" "file" "filter" "send-mail" "command" "misc" "bug-report"))
;  (:module suggestions "suggestions")
;  (:module compile-flavor-methods "compile-flavor-methods")
;  (:compile-load options)
;  (:compile-load definitions (:fasload options))
;  (:compile-load main (:fasload options definitions))
;  (:compile-load parts (:fasload options definitions main))
;  (:compile-load suggestions (:fasload options definitions main parts))
;  (:compile-load compile-flavor-methods)
;  )

(SYS::SET-SYSTEM-ACCESS-LIST 'MAIL-READER
			     :NAME "Mail Reader"
			     :DOCUMENTATION "Manage electronic mail messages"
			     :DEFAULT-MENU-COLUMN :PROGRAMS
			     :DEFAULT-SYSTEM-KEY #\M
			     :INSTANCE-TYPE    :EVAL
			     :INSTANCE-FINDER  '(ZWEI:READ-MAIL)
			     :INSTANCE-CREATOR NIL)

(W:MODIFY-SYSTEM-ACCESS-SPEC 'MAIL-READER
			     :ASSIGN-DEFAULTS)

(SETF (SYS:SYSTEM-MADE-P 'MAIL-READER) T)

;;

;(defsystem namespace-editor
;  (:name "Namespace Editor")
;  (:short-name "Namespace Editor")
;  (:documentation "View and/or edit an existing namespace, or create a new one")
;  (:default-menu-column :PROGRAMS)
;  (:pathname-default "sys:Namespace-Editor;")
;  (:patchable "sys: patch.namespace-editor;" patch)
;  (:warnings-pathname-default "SYS: CWARNS; nse.lisp") ; las 6-24-87, 7-15/87
;  (:instance-type    :EVAL)
;  (:instance-finder  (NSE::TOP-LEVEL-EDIT-NAMESPACE :SELECT T))
;  (:instance-creator NIL)
  
;  (:module package-declare ("package-declare"))
;  (:module defs ("definitions"))
;  (:module flavor-methods ("flavor-methods"))
;  (:module helper-functions ("helper-functions"))
;  (:module utility-functions ("utility-functions"))
;  (:module commands ("commands"))
;  (:module define-suggestions ("suggestions"))
;  (:module tell-system-about-suggestions ("push-suggestions"))
;  (:module network-mode ("network-mode"))
;  (:module network-mode-definitions ("network-mode-definitions"))
;  (:module network-attribute-mlists ("network-attribute-mlists"))
;  (:module convert-siteinfo ("convert-siteinfo"))
;  (:module NSE-NAMESPACE ("NSE-NAMESPACE"))
;  (:module expert-edit ("expert-edit"))
;  (:module network-mode-expert-editors ("network-mode-expert-editors"))
;  (:module verification ("verification"))

;  ;;======================================================================
;  ;; PACKAGE DECLARATIONS
;  (:compile-load PACKAGE-DECLARE)

;  ;;======================================================================
;  ;; NAMESPACE-EDITOR UTILITY
;  (:compile-load DEFS
;		 ((:fasload package-declare))
;		 ((:fasload package-declare)))
  
;  (:compile-load-init COMMANDS (defs)
;		      ((:fasload package-declare defs))
;		      ((:fasload package-declare defs)))
  
;  (:compile-load-init FLAVOR-METHODS (defs)
;		      ((:fasload package-declare defs))
;		      ((:fasload package-declare defs)))
  
;  (:compile-load-init UTILITY-FUNCTIONS (defs)
;		      ((:fasload package-declare defs))
;		      ((:fasload package-declare defs)))
  
;  (:compile-load-init HELPER-FUNCTIONS (defs)
;		      ((:fasload package-declare defs))
;		      ((:fasload package-declare defs)))


;  ;;======================================================================
;  ;; EXPERT-EDITORS FOR NSE UTILITY
;  (:compile-load-init EXPERT-EDIT (defs)
;		      ((:fasload package-declare defs utility-functions))
;		      ((:fasload package-declare defs utility-functions)))

;  ;;======================================================================
;  ;; NETWORK MODE OF NSE UTILITY

;  (:compile-load NETWORK-MODE-DEFINITIONS
;		 ((:fasload package-declare))
;		 ((:fasload package-declare)))
  
;  (:compile-load-init NETWORK-MODE (commands)
;		      ((:fasload package-declare network-mode-definitions commands))
;		      ((:fasload package-declare network-mode-definitions commands)))

;  ;;======================================================================
;  ;; EXPERT-EDITING FOR NETWORK-MODE
  
;  (:compile-load-init NSE-NAMESPACE (defs expert-edit)
;		      ((:fasload package-declare defs expert-edit utility-functions))
;		      ((:fasload package-declare defs expert-edit utility-functions)))

;  (:compile-load-init NETWORK-ATTRIBUTE-MLISTS (expert-edit nse-namespace)
;		      ((:fasload package-declare network-mode-definitions expert-edit nse-namespace))
;		      ((:fasload package-declare network-mode-definitions expert-edit nse-namespace)))

;  (:compile-load-init NETWORK-MODE-EXPERT-EDITORS (defs)
;		      ((:fasload package-declare defs network-mode-definitions))
;		      ((:fasload package-declare defs network-mode-definitions)))
  
;  (:compile-load-init VERIFICATION (defs)
;		      ((:fasload package-declare defs network-mode-definitions))
;		      ((:fasload package-declare defs network-mode-definitions)))

;  ;;======================================================================
;  ;; CONVERT-SITEINFO UTILITY
;  (:compile-load-init CONVERT-SITEINFO (defs)
;		      ((:fasload package-declare defs network-mode-definitions))
;		      ((:fasload package-declare defs network-mode-definitions)))

;  ;;======================================================================
;  ;; SUGGESTIONS FOR THE NSE
;  (:compile-load-init DEFINE-SUGGESTIONS (commands verification)
;		      ((:fasload package-declare commands verification))
;		      ((:fasload package-declare commands verification)))
  
;  (:compile-load-init TELL-SYSTEM-ABOUT-SUGGESTIONS (define-suggestions)
;		      ((:fasload package-declare define-suggestions))
;		      ((:fasload package-declare define-suggestions))))

(SYS::SET-SYSTEM-ACCESS-LIST 'namespace-editor
			     :NAME "Namespace Editor"
			     :DOCUMENTATION "View and/or edit an existing namespace, or create a new one"
			     :DEFAULT-MENU-COLUMN :PROGRAMS
			     :INSTANCE-TYPE    :EVAL
			     :INSTANCE-FINDER  '(NSE::TOP-LEVEL-EDIT-NAMESPACE :SELECT T)
			     :INSTANCE-CREATOR NIL)

(W:MODIFY-SYSTEM-ACCESS-SPEC 'namespace-editor
			     :ASSIGN-DEFAULTS)

(SETF (SYS:SYSTEM-MADE-P 'NAMESPACE-EDITOR) T)

;;;

;(DEFSYSTEM telnet
;  (:NAME "Telnet")
;  (:DOCUMENTATION "Log in to another machine using the Telnet protocol")
;  (:DEFAULT-MENU-COLUMN :PROGRAMS)
;  (:DEFAULT-SYSTEM-KEY #\T)
;  (:PATHNAME-DEFAULT "SYS:telnet;")
;  (:PATCHABLE "SYS: patch.telnet;" PATCH)
;  (:warnings-pathname-default "sys:cwarns;telnet.lisp")
;  (:INSTANCE-TYPE    :FLAVOR)
;  (:INSTANCE-FINDER  TELNET)
;  (:INSTANCE-CREATOR T)
  
;  (:MODULE nvt-defs "nvt-defs")			
;  (:MODULE nvt "nvt")
;  (:MODULE btd "basic-telnet-defs")		
;  (:MODULE basic-telnet "basic-telnet")
;  (:MODULE telnet-window "telnet-window")	
;  (:MODULE ucl-telnet "ucl-telnet")
;  (:MODULE SERVICE ("TELNET-SERVICE" "TELNET-SERVER"))
;  (:MODULE supdup "supdup")                    
;;  (:MODULE editing-supdup "editing-supdup")

;  (:COMPILE-LOAD nvt-defs)			
;  (:COMPILE-LOAD nvt (:FASLOAD nvt-defs))
;  (:COMPILE-LOAD btd)
;  (:COMPILE-LOAD basic-telnet (:FASLOAD nvt-defs nvt btd))     
;  (:COMPILE-LOAD telnet-window (:FASLOAD nvt-defs nvt btd basic-telnet))
;  (:COMPILE-LOAD ucl-telnet (:FASLOAD nvt-defs nvt btd basic-telnet telnet-window))
;  (:COMPILE-LOAD SERVICE)
;  (:COMPILE-LOAD supdup (:FASLOAD  nvt-defs nvt))
;  ;(:COMPILE-LOAD basic-telnet (:FASLOAD nvt supdup))
;;  (:COMPILE-LOAD ucl-telnet (:FASLOAD nvt basic-telnet))
;;  (:COMPILE-LOAD editing-supdup (:FASLOAD nvt supdup)))
;  )

(SYS::SET-SYSTEM-ACCESS-LIST 'telnet
			     :NAME "Telnet"
			     :DOCUMENTATION "Log in to another machine using the Telnet protocol"
			     :DEFAULT-MENU-COLUMN :PROGRAMS
			     :DEFAULT-SYSTEM-KEY #\T
			     :INSTANCE-TYPE    :FLAVOR
			     :INSTANCE-FINDER  'TELNET
			     :INSTANCE-CREATOR T)

(W:MODIFY-SYSTEM-ACCESS-SPEC 'telnet
			     :ASSIGN-DEFAULTS)

(SETF (SYS:SYSTEM-MADE-P 'TELNET) T)

;;;

;(DEFSYSTEM VT100
;  (:NAME "VT100 Emulator")
;  (:SHORT-NAME "VT100")
;  (:DOCUMENTATION "Emulate operation of a VT100 terminal")
;  (:DEFAULT-MENU-COLUMN :PROGRAMS)
;  (:DEFAULT-SYSTEM-KEY #\V)
;  (:PATHNAME-DEFAULT "SYS:vt100;")
;  ;(:COMPONENT-SYSTEMS TELNET))
;  (:PATCHABLE "SYS:patch.vt100;" PATCH)
;  (:warnings-pathname-default "sys:cwarns;vt100.lisp")
;  (:INSTANCE-TYPE    :FLAVOR)
;  (:INSTANCE-FINDER  TELNET::VT100-FRAME)
;  (:INSTANCE-CREATOR T)
  
;  (:MODULE VT100-AND-LED-PANES "vt100-and-led-panes")
;  (:MODULE AUXILIARY-KEYPAD-PANE "auxiliary-keypad-pane")
;  (:MODULE AUXILIARY-KEYPAD-COMMANDS "auxiliary-keypad-commands")
;  (:MODULE VT100-FRAME "vt100-frame")
;  (:MODULE PROCESS-ESCAPE-SEQUENCE "process-escape-sequence")
;  (:MODULE PROCESSING-FUNCTIONS "processing-functions")
;  (:DO-COMPONENTS)
;  (:COMPILE-LOAD VT100-AND-LED-PANES)
;  (:COMPILE-LOAD AUXILIARY-KEYPAD-PANE)  
;  (:COMPILE-LOAD PROCESS-ESCAPE-SEQUENCE (:FASLOAD VT100-AND-LED-PANES AUXILIARY-KEYPAD-PANE))
;  (:COMPILE-LOAD VT100-FRAME
;		 (:FASLOAD VT100-AND-LED-PANES AUXILIARY-KEYPAD-PANE PROCESS-ESCAPE-SEQUENCE))
;  (:COMPILE-LOAD AUXILIARY-KEYPAD-COMMANDS
;		 (:FASLOAD VT100-FRAME AUXILIARY-KEYPAD-PANE PROCESS-ESCAPE-SEQUENCE))
;  (:COMPILE-LOAD PROCESSING-FUNCTIONS
;		 (:FASLOAD VT100-AND-LED-PANES AUXILIARY-KEYPAD-COMMANDS AUXILIARY-KEYPAD-PANE VT100-FRAME
;			   PROCESS-ESCAPE-SEQUENCE)))

(SYS::SET-SYSTEM-ACCESS-LIST 'VT100
			     :NAME "VT100 Emulator"
			     :DOCUMENTATION "Emulate operation of a VT100 terminal"
			     :DEFAULT-MENU-COLUMN :PROGRAMS
			     :DEFAULT-SYSTEM-KEY #\V
			     :INSTANCE-TYPE    :FLAVOR
			     :INSTANCE-FINDER  'TELNET::VT100-FRAME
			     :INSTANCE-CREATOR T)

(W:MODIFY-SYSTEM-ACCESS-SPEC 'VT100
			     :ASSIGN-DEFAULTS)

(SETF (SYS:SYSTEM-MADE-P 'VT100) T)

;;;

;(DEFSYSTEM ZWEI
;  (:NAME "Zmacs Editor")
;  (:SHORT-NAME "ZMACS")
;  (:DOCUMENTATION "Editor for editing text or writing programs")
;  (:DEFAULT-MENU-COLUMN :PROGRAMS)
;  (:DEFAULT-SYSTEM-KEY #\E)
;  (:PATHNAME-DEFAULT "SYS:ZMACS;")
;  (:PATCHABLE "SYS:PATCH.ZMACS;" "PATCH")
;  (:WARNINGS-PATHNAME-DEFAULT "SYS:CWARNS;ZMACS.LISP")
;  (:INSTANCE-TYPE    :FLAVOR)
;  (:INSTANCE-FINDER  ZWEI::ZMACS-FRAME)
;  (:INSTANCE-CREATOR T)
  
;  (:MODULE FONTS  ("SYS:FONTS;SEARCH") :PACKAGE "FONTS")
;  (:MODULE SETUP  ("SETUP"))	       ;Exporting, shadowing, suggestions, etc.
;  (:MODULE DEFS   ("DEFS"	       ;Structure definitions and declarations.
;	           "MACROS"))	       ;Lisp macros used in the ZWEI source.
;  (:MODULE SCREEN ("SCREEN"))	       ;Interface to screen system.
;  (:MODULE KBDMAC ("KBDMAC"))	       ;Keyboard macro stream.
;  (:MODULE SRCCOM ("SRCCOM"))	       ;Source Compare two files or buffers. 
;  (:MODULE MAIN   ("COMTAB"	       ;Functions regarding comtabs and command loop.
;		   "DISPLA"	       ;Redisplay, and screen-related functions.
;		   "FOR"	       ;Forward-this, forward-that functions.
;		   "INDENT"	       ;Indention functions.
;		   "INSERT"	       ;Insertion, deletion, and related functions.
;		   "METH"	       ;Important methods for windows and buffers.
;		   "PRIMIT"	       ;Random primitives and utilities.
;		   "NPRIM"	       ;More recently written primitives.
;		   "HISTORY"	       ;Kill history, minibuffer history, etc.
;		   "FONT"	       ;Font hacking stuff.
;		   "SEARCH"	       ;Searching functions.
		   
;		   "COMA"	       ;Vanilla editing commands for movement, exchange, etc. 
;		   "COMB"	       ;Editing commands for indentation and such.
;		   "COMC"	       ;Commands for compiling and evaluating.
;		   "COMD"	       ;Register, minibuffer, completion and apropos commands.
;		   "COME"	       ;Includes quantity and tab commands.
;		   "COMF"	       ;Includes pattern-matching, arglists, disassembly. 
;		   "COMG"	       ;Commands for kbd-macro and describe-flavor operations.
;		   "COMH"	       ;More assorted commands, featuring case-changing and commenting.
;		   "COMS"	       ;Commands for searching and replacing.
		   
;		   "DIRED"	       ;Directory editor.
;		   "DOC"	       ;Self-documentation commands and functions.
;		   "FASUPD"	       ;Update fasl file from core.
;		   "FILES"	       ;File commands and utilities.
;		   "HOST"	       ;Define ED:, ED-BUFFER:, ED-FILE: hosts.
;		   "LPARSE"	       ;Parsing lisp code.
;		   "MODES"	       ;Major and minor mode functions and commands.
;		   "MOUSE"	       ;Mouse commands, sans screen interface.
;		   "PATED"	       ;Patch commands.
;		   "POSS"	       ;Visiting lists of possibilities.
;		   "STREAM"	       ;Editor stream.
;		   "SECTIO"	       ;Section-specific commands for ZMACS.
;		   "ZMNEW"	       ;Buffer attribute-list commands.
;		   "ZMACS"))	       ;Multiple-buffer and file commands.

;  (:MODULE AUTOLOADING
;	   ("LIBRARY-COMMANDS"			  ;Tex Mode, Midas Mode.
;	    "SYS:PUBLIC.ZMACS;BDIRED"		  ;Directory Differences editor.
;	    "SYS:PUBLIC.ZMACS;CHAR-SEARCH"	  ;Char Search and Reverse Char Search.
;	    "SYS:PUBLIC.ZMACS;MISC-BROKEN"	  ;Miscellaneous broken commands.
;	    "SYS:PUBLIC.ZMACS;MISC-UNSUPPORTED"	  ;Miscellaneous non-broken commands.
;	    "SYS:PUBLIC.ZMACS;PL1MOD"		  ;PL/I mode commands.
;	    "SYS:PUBLIC.ZMACS;UNSUPPORTED-MODES"  ;Teco, Bolio, Emacs.
;	    ))
  
;  (:MODULE ZYMURG ("ZYMURG"))	       ;Combined methods.
  
;  (:MODULE TUTORIAL ("SYS:TI-EXAMPLES.ZMACS;GETTYSBURG-INSERT.TEXT"
;		     "SYS:TI-EXAMPLES.ZMACS;C-CURVE.LISP"))
  
;  (:AUXILIARY TUTORIAL)
  
;  (:FASLOAD FONTS)
;  (:COMPILE-LOAD SETUP)
;  (:COMPILE-LOAD DEFS   (:FASLOAD SETUP))
;  (:COMPILE-LOAD SCREEN (:FASLOAD SETUP DEFS))
;  (:COMPILE-LOAD KBDMAC (:FASLOAD SETUP DEFS SCREEN))
;  (:COMPILE-LOAD SRCCOM (:FASLOAD SETUP DEFS))
;  (:COMPILE-LOAD MAIN   (:FASLOAD SETUP DEFS SCREEN KBDMAC SRCCOM))
;  (:COMPILE AUTOLOADING (:FASLOAD SETUP DEFS SCREEN KBDMAC MAIN))
;  (:COMPILE-LOAD ZYMURG (:FASLOAD SETUP DEFS SCREEN KBDMAC MAIN)))

(SYS::SET-SYSTEM-ACCESS-LIST 'ZWEI
			     :NAME "Zmacs Editor"
			     :DOCUMENTATION "Editor for editing text or writing programs"
			     :DEFAULT-MENU-COLUMN :PROGRAMS
			     :DEFAULT-SYSTEM-KEY #\E
			     :INSTANCE-TYPE    :FLAVOR
			     :INSTANCE-FINDER  'ZWEI::ZMACS-FRAME
			     :INSTANCE-CREATOR T)

(W:MODIFY-SYSTEM-ACCESS-SPEC 'ZWEI
			     :ASSIGN-DEFAULTS)

(SETF (SYS:SYSTEM-MADE-P 'ZWEI) T)

;;; 

;(DEFSYSTEM LISP-LISTENER
;  (:NAME                "Lisp Listener")
;  (:SHORT-NAME          "Listener")
;  (:DOCUMENTATION       "Evaluate Lisp forms")
;  (:DEFAULT-MENU-COLUMN :PROGRAMS)
;  (:DEFAULT-SYSTEM-KEY  #\L)
;  (:INSTANCE-TYPE       :FLAVOR)
;  (:INSTANCE-FINDER     W:LISTENER-MIXIN)
;  (:INSTANCE-CREATOR    W::LISP-LISTENER))

(SYS::SET-SYSTEM-ACCESS-LIST 'LISP-LISTENER
			     :NAME "Lisp Listener"
			     :DOCUMENTATION "Evaluate Lisp forms"
			     :DEFAULT-MENU-COLUMN :PROGRAMS
			     :DEFAULT-SYSTEM-KEY  #\L
			     :INSTANCE-TYPE       :FLAVOR
			     :INSTANCE-FINDER     'W:LISTENER-MIXIN
			     :INSTANCE-CREATOR    'W::LISP-LISTENER)

(W:MODIFY-SYSTEM-ACCESS-SPEC 'LISP-LISTENER
			     :ASSIGN-DEFAULTS)

(SETF (SYS:SYSTEM-MADE-P 'LISP-LISTENER) T)


;(DEFSYSTEM HARD-COPY-MENU
;  (:NAME                "Hard Copy Menu")
;  (:SHORT-NAME          "Hard Copy")
;  (:DOCUMENTATION       "Print a file or screen image on a selectable printer device")
;  (:DEFAULT-MENU-COLUMN :PROGRAMS)
;  (:DEFAULT-SYSTEM-KEY  #\H)
;  (:INSTANCE-TYPE       :EVAL)
;  (:INSTANCE-FINDER     (PRINTER::SYSTEM-MENU-PRINTER-SELECTION))
;  (:INSTANCE-CREATOR    NIL))

(SYS::SET-SYSTEM-ACCESS-LIST 'HARD-COPY-MENU
			     :NAME                "Hard Copy Menu"
			     :DOCUMENTATION       "Print a file or screen image on a selectable printer device"
			     :DEFAULT-MENU-COLUMN :PROGRAMS
			     :DEFAULT-SYSTEM-KEY  #\H
			     :INSTANCE-TYPE       :EVAL
			     :INSTANCE-FINDER     '(PRINTER::SYSTEM-MENU-PRINTER-SELECTION)
			     :INSTANCE-CREATOR    NIL)

(W:MODIFY-SYSTEM-ACCESS-SPEC 'HARD-COPY-MENU
			     :ASSIGN-DEFAULTS)

(SETF (SYS:SYSTEM-MADE-P 'HARD-COPY-MENU) T)


;(DEFSYSTEM NETWORK
;  (:NAME                "Network")
;  (:SHORT-NAME          "Network")
;  (:DOCUMENTATION       "Menu of items to control or examine the network")
;  (:DEFAULT-MENU-COLUMN :DEBUG)
;  (:INSTANCE-TYPE       :EVAL)
;  (:INSTANCE-FINDER     (NET::CONTROL-MENU NET::CONTROL-MENU "Network Operations"))
;  (:INSTANCE-CREATOR    NIL))

(SYS::SET-SYSTEM-ACCESS-LIST 'NETWORK
			     :NAME                "Network"
			     :DOCUMENTATION       "Menu of items to control or examine the network"
			     :DEFAULT-MENU-COLUMN :DEBUG
			     :INSTANCE-TYPE       :EVAL
			     :INSTANCE-FINDER     '(NET::CONTROL-MENU NET::CONTROL-MENU "Network Operations")
			     :INSTANCE-CREATOR    NIL)

(W:MODIFY-SYSTEM-ACCESS-SPEC 'NETWORK
			     :ASSIGN-DEFAULTS)

(SETF (SYS:SYSTEM-MADE-P 'NETWORK) T)


;(DEFSYSTEM FLAVOR-INSPECTOR
;  (:NAME                "Flavor Inspector")
;  (:SHORT-NAME          "Flavor Inspect")
;  (:DOCUMENTATION       "Browse through flavor structures")
;  (:DEFAULT-MENU-COLUMN :DEBUG)
;  (:INSTANCE-TYPE       :FLAVOR)
;  (:INSTANCE-FINDER     tv:FLAVOR-INSPECTOR)
;  (:INSTANCE-CREATOR    T))

(SYS::SET-SYSTEM-ACCESS-LIST 'FLAVOR-INSPECTOR
			     :NAME                "Flavor Inspector"
			     :DOCUMENTATION       "Browse through flavor structures"
			     :DEFAULT-MENU-COLUMN :DEBUG
			     :INSTANCE-TYPE       :FLAVOR
			     :INSTANCE-FINDER     'tv:FLAVOR-INSPECTOR
			     :INSTANCE-CREATOR    T)

(W:MODIFY-SYSTEM-ACCESS-SPEC 'FLAVOR-INSPECTOR
			     :ASSIGN-DEFAULTS)

(SETF (SYS:SYSTEM-MADE-P 'FLAVOR-INSPECTOR) T)


;(DEFSYSTEM INSPECTOR
;  (:NAME                "Inspector")
;  (:SHORT-NAME          "Inspect")
;  (:DOCUMENTATION       "Browse through data structures")
;  (:DEFAULT-MENU-COLUMN :DEBUG)
;  (:DEFAULT-SYSTEM-KEY  #\I)
;  (:INSTANCE-TYPE       :FLAVOR)
;  (:INSTANCE-FINDER     tv:INSPECT-FRAME)
;  (:INSTANCE-CREATOR    T))

(SYS::SET-SYSTEM-ACCESS-LIST 'INSPECTOR
			     :NAME                "Inspector"
			     :DOCUMENTATION       "Browse through data structures"
			     :DEFAULT-MENU-COLUMN :DEBUG
			     :DEFAULT-SYSTEM-KEY  #\I
			     :INSTANCE-TYPE       :FLAVOR
			     :INSTANCE-FINDER     'tv:INSPECT-FRAME
			     :INSTANCE-CREATOR    T)

(W:MODIFY-SYSTEM-ACCESS-SPEC 'INSPECTOR
			     :ASSIGN-DEFAULTS)

(SETF (SYS:SYSTEM-MADE-P 'INSPECTOR) T)


;(DEFSYSTEM PEEK
;  (:NAME                "Peek")
;  (:SHORT-NAME          "Peek")
;  (:DOCUMENTATION       "Display system activities and their current states")
;  (:DEFAULT-MENU-COLUMN :DEBUG)
;  (:DEFAULT-SYSTEM-KEY  #\P)
;  (:INSTANCE-TYPE       :FLAVOR)
;  (:INSTANCE-FINDER     tv:PEEK-FRAME)
;  (:INSTANCE-CREATOR    T))

(SYS::SET-SYSTEM-ACCESS-LIST 'PEEK
			     :NAME                "Peek"
			     :DOCUMENTATION       "Display system activities and their current states"
			     :DEFAULT-MENU-COLUMN :DEBUG
			     :DEFAULT-SYSTEM-KEY  #\P
			     :INSTANCE-TYPE       :FLAVOR
			     :INSTANCE-FINDER     'tv:PEEK-FRAME
			     :INSTANCE-CREATOR    T)

(W:MODIFY-SYSTEM-ACCESS-SPEC 'PEEK
			     :ASSIGN-DEFAULTS)

(SETF (SYS:SYSTEM-MADE-P 'PEEK) T)


;(DEFSYSTEM TRACE
;  (:NAME                "Trace")
;  (:SHORT-NAME          "Trace")
;  (:DOCUMENTATION       "Trace a function, with option selectable from a menu")
;  (:DEFAULT-MENU-COLUMN :DEBUG)
;  (:INSTANCE-TYPE       :EVAL)
;  (:INSTANCE-FINDER     (W:TRACE-VIA-MENUS))
;  (:INSTANCE-CREATOR    NIL))

(SYS::SET-SYSTEM-ACCESS-LIST 'TRACE
			     :NAME                "Trace"
			     :DOCUMENTATION       "Trace a function, with option selectable from a menu"
			     :DEFAULT-MENU-COLUMN :DEBUG
			     :INSTANCE-TYPE       :EVAL
			     :INSTANCE-FINDER     '(W:TRACE-VIA-MENUS)
			     :INSTANCE-CREATOR    NIL)

(W:MODIFY-SYSTEM-ACCESS-SPEC 'TRACE
			     :ASSIGN-DEFAULTS)

(SETF (SYS:SYSTEM-MADE-P 'TRACE) T)



