;;; -*- Mode:Common-Lisp; Package:XWM; Base:10 -*-

(DEFVAR *cd* nil)

(DEFVAR *c* nil)

;(SETF (find-class 'MY-TEST) nil)

(defcontact my-test (contact)
  ((orientation :initarg :orientation :type (MEMBER :horizontal :vertical :both) :initform :both))
  )

(DEFMETHOD realize :after ((self my-test))
  (display self))

(DEFMETHOD display ((self my-test) &optional x y width height &key)
  (with-slots (orientation) self
    (using-gcontext (gc :drawable self
                        :background 0
                        :foreground 1
                        :line-width 1)
      (DO* ((row 1 (+ row 3))
            (wid (contact-width self))
            (hi  (contact-height self))
            (col 1 (+ col 3)))
           ((AND (>= row hi)
                 (>= col wid)))
        (CASE orientation
          (:horizontal
           (draw-line self gc 0 row wid row))
          (:vertical
           (draw-line self gc col 0 col hi))
          (:both
           (draw-line self gc 0 row wid row)
           (draw-line self gc col 0 col hi)))))))

(DEFUN test (&optional (host "GOLF"))
  (LET* ((d (open-contact-display 'test :host host))
         (c (MAKE-contact 'my-test :parent (display-root d)
                           :x 200 :y 200
                           ;:icon 15x15-resize-image
                           ;:wm-title "Test Contact"
                           :height 200 :width 200
                           :background 0
                           :border 1))
         )
    (SETQ *cd* d)
    (SETQ *c* c)
    (UNWIND-PROTECT
        (PROGN
          (x11:x-select-and-enable)
          (LOOP (process-next-event d)))
      (destroy c)
      (close-display d))))

(DEFUN test2 (&optional (host "GOLF"))
  (LET* ((d (open-contact-display 'test :host host))
         (c1 (MAKE-contact 'my-test :parent (display-root d)
                           :x 100 :y 100                           
                           ;:icon 15x15-resize-image
                           ;:wm-title "Test Contact"
                           :height 100 :width 100
                           :background 0
                           :border 1))
         (c2 (make-contact 'my-test :parent (display-root d)
                           :x 250 :y 100
                           :orientation :horizontal
                           :height 250 :width 220
                           :background 0 :border 1))
         (c3 (make-contact 'my-test :parent (display-root d)
                           :x 0 :y 300
                           :orientation :vertical
                           :height 70 :width 75
                           :background 0 :border 1))
         )
    (SETQ *cd* d)
        (UNWIND-PROTECT
        (PROGN
          (x11:x-select-and-enable)
          (LOOP (process-next-event d)))
      (destroy c1)
      (destroy c2)
      (destroy c3)
      (close-display d))))

