;;;-*- Mode:common-LISP; Package:USER; Base:8 -*-

;;;                           RESTRICTED RIGHTS LEGEND

;;;Use, duplication, or disclosure by the Government is subject to
;;;restrictions as set forth in subdivision (c)(1)(ii) of the Rights in
;;;Technical Data and Computer Software clause at 52.227-7013.

;;;                     TEXAS INSTRUMENTS INCORPORATED.
;;;                              P.O. BOX 2909
;;;                           AUSTIN, TEXAS 78769
;;;                                 MS 2151

;;; Copyright (C) 1984,1989 Texas Instruments Incorporated. All rights reserved.

;;; 04-25-89 DAB Added all function, variables, flavors and instances that are documented to export list.

;;; 03.05.87  DAB  Changed :patchable and added :warnings-pathname-default

(DEFSYSTEM Serial
  (:PACKAGE system-internals)
  (:NAME "Serial")
  (:SHORT-NAME "SERIAL")
  (:PATHNAME-DEFAULT "sys: serial;")
  (:patchable "sys: patch.serial;" PATCH) ;03.05.87 DAB
  (:warnings-pathname-default "SYS: CWARNS; SERIAL.lisp") ;03.05.87 DAB
  (:MODULE macros "serial-macros")
  (:MODULE hards "serial-hardware")
  (:MODULE hardp "parallel-hardware")
  (:MODULE ports "serial-port")
  (:MODULE portp "parallel-port")
  (:MODULE buffs "serial-buffer")
  (:MODULE streamS "serial-stream")
  (:MODULE streamp "parallel-stream")
  (:COMPILE-LOAD macros) 
  (:COMPILE-LOAD hards (:FASLOAD macros))
  (:COMPILE-LOAD hardp (:fasload macros hards))
  (:COMPILE-LOAD ports (:FASLOAD macros hards))
  (:COMPILE-LOAD portp (:fasload macros hardp))
  (:COMPILE-LOAD buffs (:FASLOAD macros hards ports))
  (:COMPILE-LOAD streams (:FASLOAD macros hards ports buffs))
  (:COMPILE-LOAD streamp (:FASLOAD macros hardp portp buffs))
  )

(DEFSYSTEM mx-serial
  (:PACKAGE system-internals)
  (:NAME "mx-Serial")
  (:SHORT-NAME "mx-SERIAL")
  (:PATHNAME-DEFAULT "sys: serial;")
  (:patchable "sys: patch.mx-serial;" PATCH) ;03.05.87 DAB
  (:warnings-pathname-default "SYS: CWARNS; mx-SERIAL.lisp") ;03.05.87 DAB
  (:MODULE streams "mx-serial-stream")
  (:COMPILE-LOAD streams)
  )



(export '(sys:make-serial-stream    ;function  ; DAB 04-25-89
	   sys:make-parallel-stream ;function
	   )
	'sys)