;;; -*- Mode: common-Lisp; Package: MT; Base: 10; Fonts: MEDFNT,HL12B,HL12BI -*-

;;;                           RESTRICTED RIGHTS LEGEND

;;;Use, duplication, or disclosure by the Government is subject to
;;;restrictions as set forth in subdivision (c)(1)(ii) of the Rights in
;;;Technical Data and Computer Software clause at 52.227-7013.
;;;
;;;                     TEXAS INSTRUMENTS INCORPORATED.
;;;                              P.O. BOX 2909
;;;                           AUSTIN, TEXAS 78769
;;;                                 MS 2151
;;;
;;; Copyright (C) 1984-1989 Texas Instruments Incorporated. All rights reserved.

;; Version to support streamer tape off of nupi for Explorer.
;;
;; Revisions:
;;;     09-09-87 DAB    Changed Pick-drive to call insert-device instead of initialize-disk-system.
;;;	08.03.87 MBC	In INITIALIZE-TAPE-DRIVE, save param values on MT:*CURRENT-UNIT*.
;1;  Put old prepare-tape back and marked as obsolete. New version is called prepare-tape-drive.  03/18/87  HW*
;; Fixed for 2K page size.  1-8-87, -ab
;; Add SPACE-TO-Double-EOF, not in any patch.  5-12-86
;; Hooks in mt-run for variable block support (half inch). 5-5-86
;; Add offset-test for Cipher Compatiblity Tape.  5-2-86 MBC
;;     Cipher is a trademark of Cipher Data Products, Inc.
;; Make init-unit-var also set *Nupi-Default-Unit*. 5-1-86 MBC
;;;	Space-to-Eof can now accept number of EOFs greater than 127.  12-9-85 MBC
;; Fix backslash in setup commands. - 11-16-85 MBC
;; LOAD-TAPE command added.  3/19/85 MBC
;; Prepare-Tape & Mode-Select now handle long bit, retension options.  3/13/85
;; QIC-11 selection in mode-select, normal-encoding param also passed on by
;;   Prepare-Tape.  Guess-tape-unit uses array-dimension.  New routine,
;;   get-retry-count returns tape retry (soft errors) count on a given unit.   Also switch
;;   to start using real space-to-eof command instead of ADES kludge. - 3/5/85 MBC
;; Add si:nupi-adaptive-EORM and change si:nupi-EORM for EMULEX.  Modify PREPARE-TAPE
;;   to check for illegal unit and set up current-unit correctly.  Also use
;;   configure-disk-system instead of initialize in GUESS-TAPE-UNIT.
;;   Also hacked run-simple to be use count and unit passed to it.  2/1/85 
;; Prepare-tape replaces setup.  It sets up global unit value and calls mode select. 1/5/85
;; Mode-select & pass-init added, which issues a canned pass thru command. 12/19/84
;; NOT useing real space-to-eof command #x27, due to ADES bug. - 12/10/84 MBC
;; Tension tape command - 10/29/84 MBC
;
; Renamed internal functions:
; WAIT-READY, WAIT-UNIT-READY only return true for now.
; RUN rqb command &optional minus-byte-count unit density ibm-mode
; RUN-SIMPLE command unit &optional count.  For commands that don't transfer data.
; SPACE command unit ntimes, for the three forward spacing commands:
;        SPACE-TO-EOF, SPACE-TO-APPEND, SPACE-FORWARD unit n-blocks.
; SPACE-REV, SPACE-REV-TO-BOF are not supported by the Explorer.
; REWIND, OFFLINE, UNLOAD.

; EXECUTE-MT-RQB actually ISSUES an rqb.
; Normal RQBs are now used for magtape, but
; PRINT-MT-RQB, WIRE-MT-RQB, and UNWIRE-MT-RQB
; must be used with magtape RQBs.
;

(EVAL-WHEN (COMPILE LOAD EVAL) (DEFVAR EMULEX ());flag set by setup
			       ;;
   (DEFVAR *CURRENT-UNIT* ());;
   ;;These nupi commands belong in another file, sys;qdev    8/17/84
   ;;
   ;;
    ;;;  some extra defs not in qdev
   ;;;
   ;nupi device (and formatter) returned status info - low half word
   (DEFPARAMETER SI::%NUPI-LAST-CMD-RQ-DEV-STATUS #o1010);last command issued
   (DEFPARAMETER SI::%NUPI-LAST-OPTS-RQ-DEV-STATUS #o10);last command options issued
   ;nupi device (and formatter) returned status info - high half word
   (DEFPARAMETER SI::%NUPI-TYPE-RQ-DEV-STATUS #o1503);device type (01 = tape, 02 = fixed disk)
   (DEFPARAMETER SI::%NUPI-OFF-LINE-RQ-DEV-STATUS #o1401);off-line
   (DEFPARAMETER SI::%NUPI-ERROR-RQ-DEV-STATUS #o1301);error on last command; status is available
   (DEFPARAMETER SI::%NUPI-FAILED-RQ-DEV-STATUS #o1201);failed self-test
   (DEFPARAMETER SI::%NUPI-HOT-RQ-DEV-STATUS #o1101);over-temperature detected by this formatter
   (DEFPARAMETER SI::%NUPI-WRITE-PROTECTED-RQ-DEV-STATUS #o1001);write protected
   (DEFPARAMETER SI::%NUPI-UNSAFE-RQ-DEV-STATUS #o701);hardware unsafe condition detected
   ;   command scatter bit						
   (DEFPARAMETER SI::%NUPI-CMD-OPTION-SCATTER #o601);;
   ;;
   ;;
   ;;;; some nupi definitions
   (DEFPARAMETER PHYSICAL-UNIT #o30);nupi formater/unit number ??
   (DEFVAR SI::NUPI-ADAPTIVE-EORM ()); #xCA)	   ;TURN OFF THIS KLUDGE
   ;Adaptive kludge: media error - end of recorded media for now 
   ;handle-tape-error in io;disk should look for both
   ;BUT what about REAL media errors on emulex?             ;NOW HANDLE REAL ERRORS ON EMULEX.
   ) 



(DEFVAR FILE-SYSTEM-PACKAGE (FIND-PACKAGE "FS")) 


(EVAL-WHEN (COMPILE LOAD EVAL);This says that the selected drive is ready.
   (DEFUN MT-STATUS-READY ()
     "True if status is available. ?"
     T);always till event driven
   ;This says that the controller is ready.
   (DEFUN MT-COMMAND-READY ()
     "True if controller is ready. ?"
     T);always till event driven
   (DEFUN MT-STATUS-EOF ()
     "True if end-of-file reached on nupi tape"
     (OR (EQ (SI::GET-LAST-ERROR *CURRENT-UNIT*) :EOF)
	(EQ (SI::GET-LAST-ERROR *CURRENT-UNIT*) :END-OF-RECORDED-MEDIA)
	(AND EMULEX (EQ (SI::GET-LAST-ERROR *CURRENT-UNIT*) SI::NUPI-SOFT-ERROR))))
   (DEFSUBST MT-STATUS-EOT (RQB)
     "True if end-of-tape reached on this RQB."
     (MT-CHECK-DEVICE-STATUS RQB SI::%NUPI-MT-SAW-EOT))
   (DEFSUBST MT-STATUS-BOT (RQB)
     "True if beginning-of-tape reached on this RQB."
     (MT-CHECK-DEVICE-STATUS RQB SI::%NUPI-MT-SAW-BOT))
   (DEFUN MT-CHECK-DEVICE-STATUS (RQB CODE)
     (= (LDB SYSTEM:%%NUPI-STATUS-LOW-DEV-ERROR (AREF RQB SYSTEM:%IO-RQ-STATUS)) CODE))
   (DEFSUBST MT-STATUS-ERROR (RQB)
     "True if error bit or any controller or device code is non-zero."
     (OR (LDB-TEST SI::%NUPI-STATUS-HIGH-ERROR (AREF RQB SYSTEM:%IO-RQ-STATUS-HIGH))
	(LDB-TEST SI::%NUPI-STATUS-HIGH-CNTL-ERROR (AREF RQB SYSTEM:%IO-RQ-STATUS-HIGH))
	(NOT (EQUAL (AREF RQB SYSTEM:%IO-RQ-STATUS) 0))))
   (DEFPARAMETER %MT-BYTE-COUNT-AFTER 6);MT RECORD COUNT AFTER   needed for :next-input-buffer lambda
   ;Mag tape command codes.
   (DEFPARAMETER %MT-COMMAND-OFFLINE SYSTEM:%NUPI-COMMAND-UNLOAD);unload tape
   (DEFPARAMETER %MT-COMMAND-LOAD #o52);need to define si:%nupi-command-load #o52 in SYS:SYS;QDEV
   (DEFPARAMETER %MT-COMMAND-READ SYSTEM:%NUPI-COMMAND-READ)
   (DEFPARAMETER %MT-COMMAND-WRITE SYSTEM:%NUPI-COMMAND-WRITE)
   (DEFPARAMETER %MT-COMMAND-WRITE-EOF SYSTEM:%NUPI-COMMAND-WRITE-FILE-MARK)
   (DEFPARAMETER %MT-COMMAND-REWIND SYSTEM:%NUPI-COMMAND-REWIND)
   (DEFPARAMETER %MT-COMMAND-TENSION #o46);Stuff propoer global here .... ---> si:%nupi-command-? tension ?
   (DEFPARAMETER %MT-COMMAND-ERASE SYSTEM:%NUPI-COMMAND-ERASE)
   (DEFPARAMETER %MT-COMMAND-SPACE-BLOCKS SYSTEM:%NUPI-COMMAND-SKIP-TSFB);hex 23 = Tape Space Forward by Blocks
   (DEFPARAMETER %MT-COMMAND-SPACE-EOF SYSTEM:%NUPI-COMMAND-SKIP-TSFF);hex 27 = Tape Space Forward by Filemarks
   (DEFPARAMETER %MT-COMMAND-SPACE-APPEND SYSTEM:%NUPI-COMMAND-SKIP-TSFEOD);hex 29 = Tape Space Forward to End of recorded Data
   ;(DEFCONST %MT-COMMAND-SPACE-REV  si:%nupi-command-skip-reverse)
   ; reverse by Filemarks #x28  NUPI II / SMD
   (DEFparameter %mt-command-space-reverse-by-filemarks si:%nupi-command-skip-reverse-TSFF)
   (defparameter %mt-command-space-reverse-blocks si:%nupi-command-skip-reverse)
   ; reverse by Filemarks #x28  NUPI II /SMD
   (DEFPARAMETER MT-COMMAND-NAMES
      '(%MT-COMMAND-OFFLINE %MT-COMMAND-READ %MT-COMMAND-WRITE %MT-COMMAND-WRITE-EOF
	%MT-COMMAND-SPACE-EOF;	    %MT-COMMAND-WRITE-WITH-EXTENDED-GAP   ; ?
	%MT-COMMAND-REWIND %MT-COMMAND-ERASE))) 

;Lowest-level tape command execution.

;; This must be used rather than SI:WIRE-DISK-RQB so not to hack the CCW list.

;(DEFUN WIRE-MT-RQB (RQB &OPTIONAL (WIRE-P T) SET-MODIFIED &AUX
;  (LONG-ARRAY-FLAG (si:%P-LDB SYSTEM:%%ARRAY-LONG-LENGTH-FLAG RQB))
;  (LOW (- (si:%POINTER RQB) (ARRAY-LEADER-LENGTH RQB) 2))
;  (HIGH (+ (si:%POINTER RQB) 1 LONG-ARRAY-FLAG (FLOOR (ARRAY-TOTAL-SIZE RQB) 2))))
;  (DO ((LOC (LOGAND LOW (- SYSTEM:PAGE-SIZE)) (+ LOC SYSTEM:PAGE-SIZE)))
;      ((>= LOC HIGH)
;       NIL)
;    (SI:WIRE-PAGE LOC WIRE-P SET-MODIFIED)))

(DEFUN WIRE-MT-RQB (RQB &OPTIONAL (WIRE-P T) SET-MODIFIED)
  "Wire a one-page mag-tape RQB.  Any data words will be contained in this page."
  (sys:wire-page (LOGAND (sys:%pointer rqb) (- sys:page-size))
		 wire-p set-modified))

(DEFUN UNWIRE-MT-RQB (RQB)
  (WIRE-MT-RQB RQB ())) 

(DEFSUBST CLEAR-NUPI-ERROR (RQB)
  (SETF (AREF RQB SYSTEM:%IO-RQ-STATUS) 0)
  (SETF (AREF RQB SYSTEM:%IO-RQ-STATUS-HIGH) 0)) 


(DEFUN EXECUTE-MT-RQB (RQB)
  (PROG ()
    FULL-RETRY
    (CLEAR-NUPI-ERROR RQB)
    (SETF (AREF RQB SYSTEM:%IO-RQ-BUFFER) (DPB 0 (BYTE 2 0) (AREF RQB SYSTEM:%IO-RQ-BUFFER)))
; Used to be dangerous to use length not equal to a multiple of 4 but now this makes variable
; lengths to be rounded down!!
    
;    (SETF (AREF RQB SYSTEM:%IO-RQ-TRANSFER-LENGTH)
;	   (DPB 0 (BYTE 2 0) (AREF RQB SYSTEM:%IO-RQ-TRANSFER-LENGTH)))
    (SYSTEM:%IO RQB (si:get-device-descriptor-name *Current-Unit*))
    (WAIT-READY RQB);be nice about cpu time
    (IF (SI::HANDLE-TAPE-ERROR RQB)
      (GO FULL-RETRY)))) 

;; sys:page-size-in-bytes already exists, as does
;; sys:disk-block-byte-size
;;(DEFVAR PAGE-SIZE-IN-BYTES (* SYSTEM:PAGE-SIZE 4)) 	;8 bit bytes.


(DEFUN WAIT-READY (RQB)
  "Await this rqb to finish and mt be ready."
  (OR (SI::%IO-DONE RQB) (PROCESS-WAIT "MagTape" #'(LAMBDA ()
						     (SI::%IO-DONE RQB))))
  ()) 


(DEFUN WAIT-UNIT-READY ()
  "Await selected unit ready"
  (OR (MT-STATUS-READY) (PROCESS-WAIT "MT Unit" #'(LAMBDA ()
						    (MT-STATUS-READY))))
  ()) 


;Use RUN to transfer the contents of an RQB.
;
;Use RUN-SIMPLE to do spacing operations.


(DEFSIGNAL END-OF-TAPE FERROR (UNIT COMMAND BYTE-COUNT DENSITY IBM-MODE RQB)
   "Mag tape runs off end of tape.") 


(DEFPARAMETER SI::%NUPI-CMD-OPTION-VARIABLE.OR.DEVICE-BLOCK 4
   "Variable block mode on reads and writes.  Use device block on space block command.") 


(DEFUN MT-RUN (RQB CMD &OPTIONAL RECORD-SIZE-OR-BLOCK-COUNT UNIT DENSITY IBM-MODE &KEY
	       (VARIABLE-BLOCK-SIZE NIL) &REST IGNORE)
  (declare (ignore density ibm-mode))
;;  (proclaim '(special sys:%io-rq-leader-n-pages))
  ;; use sys:%io-rq-leader-n-blocks, which is already SPECIAL
  
  (COND
    ((NUMBERP UNIT)
     (COND
       (VARIABLE-BLOCK-SIZE		   ;Must be T for REEL half-inch mode.
	(LET ((N-blocks
		(SELECT CMD
		  (%MT-COMMAND-READ
		   ;; on reads wire maximum number of pages
		   (SI:Rqb-N-Blocks RQB))
		  (T (CEILING (- RECORD-SIZE-OR-BLOCK-COUNT)
			      sys:disk-block-byte-size)))))
	  (SI::WIRE-NUPI-RQB RQB N-blocks T T 0)
	  (VARIABLE-BLOCK-SIZE-SCATTER	   ;adjust the scatter table byte count
	    RQB N-blocks (- RECORD-SIZE-OR-BLOCK-COUNT)))
	(SETF (AREF RQB SYSTEM:%IO-RQ-COMMAND-HIGH)
	      (LOGIOR SI::%NUPI-CMD-OPTION-VARIABLE.OR.DEVICE-BLOCK
		      (AREF RQB SYSTEM:%IO-RQ-COMMAND-HIGH)))
	(COND
	  ((> (- RECORD-SIZE-OR-BLOCK-COUNT)
	      (* (SYS:RQB-Nblocks RQB) sys:disk-block-byte-size))
	   (FERROR () "Insufficient RQB byte size: ~d for Record Size: ~d in mt-run"
		   (* (SYSTEM:RQB-Nblocks RQB)  sys:disk-block-byte-size) (- RECORD-SIZE-OR-BLOCK-COUNT)))
	  (T				   ;ok so stuff real byte count back in.
	   (LET ((BYTES (- RECORD-SIZE-OR-BLOCK-COUNT)))
	     (SETF (AREF RQB SYSTEM:%IO-RQ-TRANSFER-LENGTH)
		   (LDB (BYTE 16 0) BYTES))
	     (SETF (AREF RQB SYSTEM:%IO-RQ-TRANSFER-LENGTH-HIGH)
		   (LDB (BYTE 16 16) BYTES))))))
       (T				   ;standard 1/4" tape
	(SI::WIRE-NUPI-RQB RQB RECORD-SIZE-OR-BLOCK-COUNT T T 0)
	(IF (> (SI:Rqb-N-Blocks-Wired RQB) (SI:Rqb-N-Blocks RQB))	   ;sanity check
	    (FERROR 'RQB-TOO-SMALL "More blocks wired than exist"))))
     (SETF (AREF RQB SYSTEM:%IO-RQ-COMMAND-HIGH)
	   (DPB CMD SYSTEM:%%IO-RQ-COMMAND-COMMAND
		(AREF RQB SYSTEM:%IO-RQ-COMMAND-HIGH)))	   ;stuff cmd, preserving options
     (SETF (AREF RQB SYSTEM:%IO-RQ-COMMAND) (SI::GET-REAL-UNIT UNIT))
     (EXECUTE-MT-RQB RQB)
     (SI::UNWIRE-DISK-RQB RQB)
     RQB)
    (T (SIGNAL (MAKE-CONDITION 'EH::BAD-NUMBER-ERROR "Unit ~D is an invalid value." UNIT))))) 
						


(DEFUN RUN-SIMPLE (CMD UNIT &OPTIONAL (COUNT 1) &AUX RQB)
  (UNWIND-PROTECT (DOTIMES (C COUNT)
		    (SETQ RQB (SYSTEM:GET-DISK-RQB))
		    (NUPI-CMD-SETUP RQB CMD 0 UNIT); *CURRENT-UNIT*)	   
		    (WIRE-MT-RQB RQB);wire, no ccw/scatter	
		    (EXECUTE-MT-RQB RQB));nupi-op
    (UNWIRE-MT-RQB RQB)
    (SYSTEM:RETURN-DISK-RQB RQB))
  T) 


(defun SPACE (command &optional (ntimes 1) (unit *CURRENT-UNIT*) &aux (options 0))
  "General tape forward movement command."
  (si:with-rqb (rqb (si:get-disk-rqb))
    (select command
      (%MT-COMMAND-SPACE-BLOCKS
       (when (si:get-pack-name-from-table unit)
	 (setf options  Si:%Nupi-Cmd-Option-Variable.Or.Device-Block)))
      (%MT-COMMAND-SPACE-reverse-BLOCKS
       (when (si:get-pack-name-from-table unit)
	 (setf options  Si:%Nupi-Cmd-Option-Variable.Or.Device-Block)))
      (%MT-COMMAND-SPACE-EOF)
      (%mt-command-space-reverse-by-filemarks) 
      (%MT-COMMAND-SPACE-APPEND 
       (if (> ntimes 1.)
	   (cerror t nil nil "SPACE ~d times to the end of recorded media makes no sense." ntimes)))
      (:otherwise
       (ferror nil "SPACE called with invalid command, #x~16r." command)))
    (nupi-cmd-setup rqb command options unit 4.)
    (SETF (AREF RQB SYSTEM:%IO-RQ-PARAMETER-LIST) NTIMES)
    (SETF (AREF RQB (+ SYSTEM:%IO-RQ-PARAMETER-LIST 1)) 0)
    (wire-mt-rqb rqb)				;wire, no ccw/scatter
    (execute-mt-rqb rqb)))




(DEFUN ERASE (&OPTIONAL (UNIT *CURRENT-UNIT*))
  (RUN-SIMPLE %MT-COMMAND-ERASE UNIT)) 


(DEFUN REWIND (&OPTIONAL (UNIT *CURRENT-UNIT*))
  (RUN-SIMPLE %MT-COMMAND-REWIND UNIT)) 


(DEFUN TENSION (&OPTIONAL (UNIT *CURRENT-UNIT*))
  (RUN-SIMPLE %MT-COMMAND-TENSION UNIT)) 


(DEFUN WRITE-EOF (&OPTIONAL (UNIT *CURRENT-UNIT*))
  (RUN-SIMPLE %MT-COMMAND-WRITE-EOF UNIT)) 


(DEFUN UNLOAD (&OPTIONAL (UNIT *CURRENT-UNIT*))
  (RUN-SIMPLE %MT-COMMAND-OFFLINE UNIT)) 


(DEFUN LOAD-TAPE (&OPTIONAL (UNIT *CURRENT-UNIT*))
  (RUN-SIMPLE %MT-COMMAND-LOAD UNIT)) 


(DEFUN OFFLINE (&OPTIONAL (UNIT *CURRENT-UNIT*))
  (RUN-SIMPLE %MT-COMMAND-OFFLINE UNIT)) 


(DEFUN SPACE-REV (&OPTIONAL &REST IGNORE)
  "Space reverse is not supported on Explorer."
  (CERROR T () () "Space reverse is not supported on Explorer.")) 

(DEFUN SPACE-reverse-by-filemarks (&OPTIONAL (UNIT *CURRENT-UNIT*) (NTIMES 1))
  (multiple-value-bind (quot rem) (floor ntimes 127)
		       (dotimes (i quot)
			 (SPACE %MT-COMMAND-SPACE-EOF 127 UNIT))
		       (if (not (zerop rem))
			   (SPACE %MT-COMMAND-SPACE-reverse-by-filemarks rem UNIT))))

(DEFUN SPACE-reverse-blocks (&OPTIONAL (UNIT *CURRENT-UNIT*) (N-BLOCKS 1))
 "Space backward N-BLOCKS, block size is always 1k byte."
  (SPACE %MT-COMMAND-SPACE-reverse-BLOCKS N-BLOCKS UNIT))

(DEFUN SPACE-REV-TO-BOF (&OPTIONAL &REST IGNORE)
  "Space reverse to bof is not supported on Explorer."
  (CERROR T () () "Space reverse to bof is not supported on Explorer.")) 


(DEFUN SPACE-TO-EOF (&OPTIONAL (UNIT *CURRENT-UNIT*) (NTIMES 1))
  (MULTIPLE-VALUE-BIND (QUOT REM)
    (FLOOR NTIMES 127)
    (DOTIMES (I QUOT)
      (SPACE %MT-COMMAND-SPACE-EOF 127 UNIT))
    (IF (NOT (ZEROP REM))
      (SPACE %MT-COMMAND-SPACE-EOF REM UNIT)))) 


(DEFUN SPACE-FORWARD (&OPTIONAL (UNIT *CURRENT-UNIT*) (N-BLOCKS 1))
  "Space forward N-BLOCKS, block size is always 1k byte."
  (SPACE %MT-COMMAND-SPACE-BLOCKS N-BLOCKS UNIT)) 


(DEFUN SPACE-TO-APPEND (&OPTIONAL (UNIT *CURRENT-UNIT*))
  "Space forward to the end of recorded media, the only place an append is legal."
  (SPACE %MT-COMMAND-SPACE-APPEND 1 UNIT)
  (SI::SET-LAST-ERROR *CURRENT-UNIT* 'END-OF-RECORDED-MEDIA)) 

;Error reporting.


(DEFUN NUPI-CMD-SETUP (RQB CMD OPTIONS UNIT &OPTIONAL (LENGTH ()))
  "Setup a command block for a simple non-scattered nupi tape request.
The CMD, OPTIONS, and UNIT parameters are stuffed into a command block located
at the top of the RQB.   The scatter bit in options is forced inactive.
No signifcant values returned."
  (SETF (AREF RQB SYSTEM:%IO-RQ-COMMAND-HIGH)
	(DPB 0 SI::%NUPI-CMD-OPTION-SCATTER (LOGIOR (LSH CMD 8) OPTIONS)))
   (SETF (AREF RQB SYSTEM:%IO-RQ-COMMAND) (SI::GET-REAL-UNIT UNIT))
  (SETF (AREF RQB SYSTEM:%IO-RQ-STATUS) 0)
  (SETF (AREF RQB SYSTEM:%IO-RQ-STATUS-HIGH) 0)
  (IF LENGTH;then use scatter table for pseudo i/o buffer
    (PROG (PADR)
      (SETF (AREF RQB SYSTEM:%IO-RQ-TRANSFER-LENGTH) LENGTH)
      (SETF (AREF RQB SYSTEM:%IO-RQ-TRANSFER-LENGTH-HIGH) 0)
      (SETQ PADR (+ (SI::GET-PHYSICAL-ADDRESS RQB) (* SYSTEM:%IO-RQ-PARAMETER-LIST 2)));down in rqb
      (SETF (AREF RQB SYSTEM:%IO-RQ-BUFFER) (LDB (BYTE 16 0) PADR))
      (SETF (AREF RQB SYSTEM:%IO-RQ-BUFFER-HIGH) (LDB (BYTE 16 16) PADR))))) 



(DEFUN ZERO-RQB (RQB &OPTIONAL (LONG-WORDS 6))
  (DOTIMES (I (* 2 LONG-WORDS))
    (SETF (AREF RQB I) 0))) 



(DEFUN P-RQB (RQB &OPTIONAL (LONG-WORDS 6) (START-WORD 0))
  (FORMAT T "~%  RQB = ~16r" (SI::GET-PHYSICAL-ADDRESS RQB))
  (SETQ *print-BASE* 16
	*read-base* 16)
  (LET (K)
    (DOTIMES (I LONG-WORDS)
      (SETQ K (* (+ I START-WORD) 2))
      (FORMAT T "~%~16r ~16r" (AREF RQB (+ 1 K)) (AREF RQB K))))) 


(DEFUN STUFF-ADDRESS-WITHIN-RQB (RQB OFFSET-ADDRESS OFFSET)
  "stuff offset-address into offset off of rqb top."
  (PROG (PADR)
    (SETQ PADR (+ (SI::GET-PHYSICAL-ADDRESS RQB) (* OFFSET-ADDRESS 2)));down in rqb
    (SETF (AREF RQB OFFSET) (LDB (BYTE 16 0) PADR))
    (SETF (AREF RQB (1+ OFFSET)) (LDB (BYTE 16 16) PADR)))) 


(DEFUN PASS-INIT (&OPTIONAL &KEY (FILL-SIZE 12) (UNIT *CURRENT-UNIT*) &AUX RQB)
  "Pass thru SCSI init command to initialize ADES tape formatter"
  (UNWIND-PROTECT (PROG
		   (PARMS)
		   (SETQ RQB (SYSTEM:GET-DISK-RQB))
		   (ZERO-RQB RQB 40)
		   (SETQ PARMS SYSTEM:%IO-RQ-PARAMETER-LIST)
		   (SI::WIRE-NUPI-RQB RQB)
		   (NUPI-CMD-SETUP RQB 114 0 UNIT 24);SCSI pass thru read, length = #x18
		   (SETF (AREF RQB PARMS) 0)
		   (SETF (AREF RQB (+ PARMS 1)) 0)
		   (SETF (AREF RQB (+ PARMS 2)) 0)
		   (SETF (AREF RQB (+ PARMS 3)) 0)
		   (STUFF-ADDRESS-WITHIN-RQB RQB (+ PARMS 16) (+ PARMS 4));status info <---
		   (SETF (AREF RQB (+ PARMS 6)) 16)
		   (SETF (AREF RQB (+ PARMS 7)) 0)
		   (STUFF-ADDRESS-WITHIN-RQB RQB (+ PARMS 24) (+ PARMS 8));scsi cmd --->
		   (SETF (AREF RQB (+ PARMS 10)) 6)
		   (SETF (AREF RQB (+ PARMS 11)) 0)
		   (SETF (AREF RQB (+ PARMS 24)) 6);1st two bytes
		   (SETF (AREF RQB (+ PARMS 25)) (LOGIOR 8 (* FILL-SIZE 256)));3rd & (4th byte = fill size)
		   (SETF (AREF RQB (+ PARMS 26)) 0);last two bytes of SCSI cmd
		   (SETF (AREF RQB (+ PARMS 27)) 0);zero these for good measure
		   (EXECUTE-MT-RQB RQB);nupi-op
)
    (SI::UNWIRE-DISK-RQB RQB)
    (SYSTEM:RETURN-DISK-RQB RQB))) 



(DEFUN GET-RETRY-COUNT (&OPTIONAL (UNIT *CURRENT-UNIT*) &AUX RQB RESULT)
  "Pass thru SCSI read sense status command to get info from formatter."
  (UNWIND-PROTECT (PROG (PARMS)
		    (SETQ RESULT ())
		    (SETQ RQB (SYSTEM:GET-DISK-RQB))
		    (ZERO-RQB RQB 40)
		    (SETQ PARMS SYSTEM:%IO-RQ-PARAMETER-LIST)
		    (SI::WIRE-NUPI-RQB RQB)
		    (NUPI-CMD-SETUP RQB 113 0 UNIT 24);SCSI pass thru read, length = #x18
		    ;Be careful of these numbers.  Decimal number of halfwords
		    ;where even numbers are the left (lower) halfword.
		    (STUFF-ADDRESS-WITHIN-RQB RQB (+ PARMS 12) (+ PARMS 0));sense requested info <---
		    (SETF (AREF RQB (+ PARMS 2)) 12)
		    (SETF (AREF RQB (+ PARMS 3)) 0)
		    (STUFF-ADDRESS-WITHIN-RQB RQB (+ PARMS 18) (+ PARMS 4));status info <---
		    (SETF (AREF RQB (+ PARMS 6)) 4)
		    (SETF (AREF RQB (+ PARMS 7)) 0)
		    (STUFF-ADDRESS-WITHIN-RQB RQB (+ PARMS 20) (+ PARMS 8));scsi cmd --->
		    (SETF (AREF RQB (+ PARMS 10)) 6)
		    (SETF (AREF RQB (+ PARMS 11)) 0)
		    (SETF (AREF RQB (+ PARMS 20)) 3);1st two bytes
		    (SETF (AREF RQB (+ PARMS 21)) 0);3rd & (4th byte = fill size)
		    (SETF (AREF RQB (+ PARMS 22)) 11);last two bytes of SCSI cmd
		    (SETF (AREF RQB (+ PARMS 23)) 0);zero these for good measure
		    (EXECUTE-MT-RQB RQB)
		    (SETQ RESULT
			  (+ (LOGAND (AREF RQB (+ SYSTEM:%IO-RQ-PARAMETER-LIST 16)) #o177400)
			     (LOGAND (AREF RQB (+ SYSTEM:%IO-RQ-PARAMETER-LIST 17)) #o377))));LSB & MSB of count
    (SI::UNWIRE-DISK-RQB RQB)
    (SYSTEM:RETURN-DISK-RQB RQB))
  RESULT) 

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;
;;; The following changes were made for 1.1 source release, August 30, 1985.  - MBC   
;;;

;;;
;;; This is no longer used by system, but maybe a user is using it?
;;; 

(DEFUN GUESS-TAPE-UNIT ()
  (OR (PICK-DRIVE)
     (CERROR () ()
	     "Use SI:all-tape-units to get a list of online tape units.  Use SI:Configure-Disk-System to
look for a online tape that wasn't there during boot.  MT:Pick-Drive does both."))) 

  
(DEFUN PREPARE-TAPE-DRIVE (UNIT &OPTIONAL &key (block-mode :fixed) (block-size 512.)	   ;1hw*
			   (tape-type :quarter-inch) (density 0.0))
			   
  "Prepares the tape for the specified unit.
  BLOCK-MODE -- It can be either :fixed or :variable. Variable length block size is supported on half inch tape
  BLOCK-SIZE -- For variable length block mode,  the block size should be 0.
  TAPE-TYPE  -- It can be either :quarter-inch or :half-inch.
  DENSITY    -- It should be 0 for quarter-inch.  For half-inch, it can be either:
                  2 for 1600 bpi or
                  6 for 3200 bpi (default) "
  
  (let ((out-stream *standard-output*))
    
    (INIT-UNIT-VAR UNIT)
    (cond 
      ((or (zerop block-size) (eq block-mode :variable))
       (setq tape-type :half-inch)
       (setq block-size 0.)
       (setq block-mode :variable)
       (if (not (or (eq density 2.) (eq density 6.)))
	   (setq density 6.)) 
       (setup-half-inch-tape :density density)
       (Format out-stream "~&Preparing the tape for a half inch tape drive with variable length block size.")
       )
      
      ((and (eq tape-type :half-inch)
	    (or (eq block-size 512.) (eq block-size 1024.)))
       (setq block-mode :fixed)
       (if (not (or (eq density 2.) (eq density 6.)))
	   (setq density 6.))
       (setup-half-inch-tape :block-size block-size :density density)
       (Format out-stream "~&Preparing the tape for a half inch tape drive with fixed length block size.")
       )
      
      ((AND (EQ BLOCK-SIZE 512.) (EQ TAPE-TYPE :QUARTER-INCH))
       (setq block-mode :fixed)
       (setq density 0.0)
       (setup-quarter-inch-tape)
       )
      
      (t
       (ferror 'si:tape-error "~&Invalid arguments in the prepare-tape function."))
      )
    (setf (get 'mt:*current-unit*  'block-size) BLOCK-SIZE)
    (setf (get 'mt:*current-unit*  'tape-type)  TAPE-TYPE)
    (setf (get 'mt:*current-unit*  'block-mode) BLOCK-MODE)
    (setf (get 'mt:*current-unit*  'density)    density)
    )
  )

(compiler:make-obsolete prepare-tape
			"use INITIALIZE-TAPE-DRIVE or
 PREPARE-TAPE-DRIVE. PREPARE-TAPE-DRIVE is preferred" )  ;1hw*
(defun prepare-tape (unit &optional (streamp t) (normal-encoding t)
		     (long-erase T) (unload-retension nil) (load-retension nil))
  "Just calls Initialize-Tape-Drive; emulates old prepare tape."
  (initialize-tape-drive :unit unit :buffered streamp :long-erase long-erase
			 :density (if normal-encoding 0 4)
			 :unload-retension unload-retension :load-retension load-retension))

(DEFUN INITIALIZE-TAPE-DRIVE (&OPTIONAL &KEY UNIT (DENSITY 0) (BUFFERED T) (SPEED 0)
			      (BLOCK-SIZE 512) (LONG-ERASE T)
                              (UNLOAD-RETENSION NIL) (LOAD-RETENSION NIL) (LOAD-P NIL))
  "Prepare tape by initializing logical unit.
Issue formatter mode select to setup Explorer 14 inch streaming tape drive.
Density defines what tape encoding to use:
 0 - default of formatter
 1 - 12 inch 800 bpi NRZI
 2 - 12 inch 1600 bpi PE
 3 - 12 inch 6250 bpi GRC
 4 - 14 inch QIC-11 (NuMachine, Symbolics)
 5 - 14 inch QIC-24 10000 bpi (Explorer)
 6 - 12 inch 3200 bpi"

  (UNLESS UNIT
    (SETF UNIT (PICK-DRIVE)))
  (when UNIT
    (IF LOAD-P
	(LOAD-TAPE))
    (INIT-UNIT-VAR UNIT)
    (si:with-rqb (rqb (GET-MODE-SELECT-RQB UNIT :BUFFERED BUFFERED :SPEED SPEED :DENSITY
					DENSITY :BLOCK-SIZE BLOCK-SIZE :LONG-ERASE
					LONG-ERASE :UNLOAD-RETENSION UNLOAD-RETENSION
					:LOAD-RETENSION LOAD-RETENSION))
	      (EXECUTE-MT-RQB RQB))
    (setf (get 'mt:*current-unit*  'block-size) BLOCK-SIZE)	   ;8.3.87 record params
					   ;tape mode not known here; should be recorded elsewhere
    (setf (get 'mt:*current-unit*  'block-mode) (if (zerop block-size) :variable :fixed))
    (setf (get 'mt:*current-unit*  'density) density)))

;;;
;;;  Canned setup functions, used by Backup window's :prepare-tape method.
;;;

(DEFUN SETUP-QUARTER-INCH-TAPE (&REST OPTIONS &KEY (UNIT *CURRENT-UNIT*) &ALLOW-OTHER-KEYS)
  "Issue formatter mode select to setup standard Explorer 1/4 inch streaming tape drive."
  (SETF (GETF OPTIONS :UNIT) UNIT)
  (APPLY 'INITIALIZE-TAPE-DRIVE :UNIT UNIT :BUFFERED T :SPEED 0 :DENSITY 0 :BLOCK-SIZE 512
	 OPTIONS)) 


(DEFUN SETUP-SYMBOLICS-QUARTER-INCH-TAPE (&REST OPTIONS &KEY (UNIT *CURRENT-UNIT*) &ALLOW-OTHER-KEYS)
  "Issue formatter mode select to setup Explorer 1/4 inch tape drive in QIC-11 (Symbolics & NuMachine)."
  (SETF (GETF OPTIONS :UNIT) UNIT)
  (APPLY 'INITIALIZE-TAPE-DRIVE :BUFFERED T :SPEED 0 :DENSITY 4 :BLOCK-SIZE 512 OPTIONS)) 


(DEFUN SETUP-HALF-INCH-TAPE (&REST OPTIONS &KEY (UNIT *CURRENT-UNIT*)
			     (BLOCK-SIZE 0) (density 6) &ALLOW-OTHER-KEYS)
  "Issue formatter mode select to setup Explorer 1/2 inch 3200 bpi tape drive."
  (APPLY 'INITIALIZE-TAPE-DRIVE :UNIT UNIT :BUFFERED T :SPEED 0 :density density
	 :BLOCK-SIZE BLOCK-SIZE OPTIONS)) 


(DEFUN INIT-UNIT-VAR (UNIT)
  (declare (special *NUPI-DEFAULT-UNIT*))
  (SETF *CURRENT-UNIT* UNIT
	*NUPI-DEFAULT-UNIT* UNIT)) 


(DEFUN GET-MODE-SELECT-RQB (UNIT &OPTIONAL &KEY (BUFFERED T) (SPEED 0) (DENSITY 6)
			    (BLOCK-SIZE 512) (LONG-ERASE T)
			    (UNLOAD-RETENSION NIL) (LOAD-RETENSION NIL) &AUX RQB)
  "Return an RQB stuffed with parameters ready for issuing mode-select operation.";Issue with execute-mt-rqb, then return rqb.
  ;
  ;BUFFERED       -  set mode to stream (tells formatter to use buffered vs. unbuffered mode).
  ;SPEED          -  1 = low, 0 & 2 = high, 3 = auto-adjust
  ;DENSITY        -  0 formatter defaults (Explorer default), 4 QIC-11 (Symbolics & NuMachine)
  ;                  6 1/2 inch 3200 bpi,  1-3 variations of 1/2 inch
  ;BLOCK-SIZE     -  Size in bytes of blocks on tape, (24 bit field).
  (LET ((PARMS SYSTEM:%IO-RQ-PARAMETER-LIST))
    (SETQ RQB (SYSTEM:GET-DISK-RQB))
    (SI::WIRE-NUPI-RQB RQB)
    (NUPI-CMD-SETUP RQB SYSTEM:%NUPI-COMMAND-FMTR-SETUP 0 UNIT 16)
    (SETF (AREF RQB PARMS) 12);tells NUPI length of parm block
    ;;; This next word in the parameter block is RESERVED in SCSI spec but NUPI uses it!!
    (LET ((HALF-WORD
	   (DPB (IF LONG-ERASE
		  0
		  1)
		(BYTE 1 15);Info for NUPI only.  Not part of 
		(DPB (IF UNLOAD-RETENSION
		       1
		       0)
		     (BYTE 1 14);this SCSI command!!!
		     (DPB (IF LOAD-RETENSION
			    1
			    0)
			  (BYTE 1 13) 0)))))
      (SETF (AREF RQB (+ PARMS 1)) HALF-WORD))
    ;;; From here down we're stuffing params strictly according to SCSI
    ;;; halfword    -     SCSI bytes in parameter list
    ;;;    3                   2,3
    ;;; halfword    -     SCSI bytes in descriptor block
    ;;;    4                   0,1    density, number-of-blocks MSB
    ;;;    5                   2,3    number-of-blocks  (middle, LSB)
    ;;;    6                   4,5    reserved, Block Size MSB
    ;;;    7                   6,7    Block Size (middle, LSB)
    (SETF (AREF RQB (+ PARMS 2)) 0);foramtter params start here
    (LET ((HALF (DPB (IF BUFFERED
		       1
		       0)
		     (BYTE 1 4) 2048)));8 is constant=bytes left (block descriptor)
      (SETF HALF (DPB SPEED (BYTE 2 0) HALF))
      (SETF (AREF RQB (+ PARMS 3)) HALF))
    (SETF (AREF RQB (+ PARMS 4)) (DPB DENSITY (BYTE 8 0) 0))
    (SETF (AREF RQB (+ PARMS 6)) (DPB (LDB (BYTE 8 16) BLOCK-SIZE) (BYTE 8 8) 0));MSB
    (SETF (AREF RQB (+ PARMS 7))
	  (DPB (LDB (BYTE 8 0) BLOCK-SIZE) (BYTE 8 8);middle & LSB
	       (DPB (LDB (BYTE 8 8) BLOCK-SIZE) (BYTE 8 0) 0)))
    RQB)) 


(DEFUN PICK-DRIVE ()
  "Return an online tape drive number.  If there is more than one the user picks.
If the user picks none, then NIL is returned."
  (si:insert-device)   ;09-09-87 DAB INSERT-DEVICE is define in IO patch IO-3-36.
  (LET ((DRIVES (SI::ALL-TAPE-UNITS))
	MENU-CHOICES
	CHOICE)
    (IF DRIVES
      (IF (= 1 (LENGTH DRIVES))
	(CAR DRIVES)
	(PROGN
	  (DOLIST (I DRIVES)
	    (SETF MENU-CHOICES (CONS (LIST (FORMAT () "~a" I) I) MENU-CHOICES)))
	  (SETF CHOICE (w:MENU-CHOOSE MENU-CHOICES :label "Tape Unit"))))
      (WARN-NO-ONLINE-TAPE)))) 


(DEFUN WARN-NO-ONLINE-TAPE ()
  (SIGNAL (MAKE-CONDITION 'EH::OFFLINE-ERROR "Tape unit is offline."))) 

;;; Patch 2.13 MBC 5-2-86

(DEFUN OFFSET-TEST (&OPTIONAL (UNIT *CURRENT-UNIT*))
  "Run this test only with the Compatibility Offset Tape.
Marginal tape heads are indicated by a non-NIL return value."
  (DECLARE (VALUES FAILURE-REASON))
  (REWIND UNIT)
  (LET ((FAILURE-REASON NIL)
	START-TIME
	FINISH-TIME)
    (CONDITION-CASE (ERROR)
       (PROGN
	 (SETF START-TIME (GET-UNIVERSAL-TIME))
	 (SPACE-TO-APPEND UNIT)
	 (SETF FINISH-TIME (GET-UNIVERSAL-TIME)))
       (SYSTEM:TAPE-ERROR
	(IF (MEMBER 'SI::TAPE-MEDIA-ERROR (SEND ERROR :CONDITION-NAMES) :TEST #'EQUAL)
	  (SETF FAILURE-REASON :MEDIA-ERROR)
	  (SIGNAL ERROR))))
    (UNLESS FAILURE-REASON
      (IF FINISH-TIME;Expected time is 170 to 175 seconds.
	(IF (< (- FINISH-TIME START-TIME) 160);or time is too short
	  (SETF FAILURE-REASON :TOOK-TOO-LITTLE-TIME))))
    FAILURE-REASON)) 


;;;This function modifies the scatter table of the mag-tape rqb to allow variable block size transfer.
;;; It modifies the last scatter table entry to reflect transfer length not evenly divisible by
;;; sys:disk-block-word-size
;;; This function should be called immediately after si:wire-nupi-rqb.
;;;  In patch 2.14  MBC

(DEFUN VARIABLE-BLOCK-SIZE-SCATTER (RQB N-blocks RECORD-SIZE)
  (IF (LDB-TEST SYSTEM:%%IO-RQ-COMMAND-SCATTER-BIT (AREF RQB SYSTEM:%IO-RQ-COMMAND-HIGH))
      (DO* ((ENTRY 0 (1+ ENTRY))
	    (ENTRY-LENGTH (GET-ENTRY-LENGTH RQB ENTRY) (GET-ENTRY-LENGTH RQB ENTRY))
	    (CUM-LENGTH ENTRY-LENGTH (+ ENTRY-LENGTH CUM-LENGTH)))
	   ((OR (>= ENTRY N-blocks) (>= CUM-LENGTH RECORD-SIZE))
	    (LET ((BYTES (- ENTRY-LENGTH (- CUM-LENGTH RECORD-SIZE))))
	      (SETF (AREF RQB (+ SYSTEM:%IO-RQ-PARAMETER-LIST 2 (* 4 ENTRY)))
		    (LDB (BYTE 16. 0) BYTES))
	      (SETF (AREF RQB (+ SYSTEM:%IO-RQ-PARAMETER-LIST 3 (* 4 ENTRY)))
		    (LDB (BYTE 16. 16.) BYTES))))
	()				   ;do nothing body
	))) 


(DEFUN GET-ENTRY-LENGTH (RQB ENTRY)
  (DPB (AREF RQB (+ SYSTEM:%IO-RQ-PARAMETER-LIST 3 (* ENTRY 4))) (BYTE 16 16)
       (AREF RQB (+ SYSTEM:%IO-RQ-PARAMETER-LIST 2 (* ENTRY 4))))) 


;;; Not in any patch.  MBC 5-12-86
;;; In IO Manual as (Space-Past-Directory Unit Ntimes)  7/3/86

(DEFUN SPACE-TO-DOUBLE-EOF (&OPTIONAL (UNIT *CURRENT-UNIT*))
  (SI::WITH-RQB (RQB (SYSTEM:GET-DISK-RQB 1))
     (LOOP (SPACE %MT-COMMAND-SPACE-EOF 1 UNIT) (MT-RUN RQB %MT-COMMAND-READ 1 UNIT)
	(IF (MT-STATUS-EOF)
	  (RETURN T))))) 
