;;; -*- Mode: common-Lisp; Package: FS; Base: 10; Fonts: MEDFNT,HL12B,HL12BI -*-

;;;                           RESTRICTED RIGHTS LEGEND

;;;Use, duplication, or disclosure by the Government is subject to
;;;restrictions as set forth in subdivision (c)(1)(ii) of the Rights in
;;;Technical Data and Computer Software clause at 52.227-7013.
;;;
;;;                     TEXAS INSTRUMENTS INCORPORATED.
;;;                              P.O. BOX 2909
;;;                           AUSTIN, TEXAS 78769
;;;                                 MS 2151
;;;
;;; Copyright (C) 1984-1989 Texas Instruments Incorporated. All rights reserved.

; This file defines the old FS:MT- ... type function names for upward compatibility. - 9/19/84 coats
;
; SPACE-TO-EOF, SPACE-TO-APPEND, SPACE-FORWARD
; SPACE-REV, SPACE-REV-TO-BOF are not supported by the Explorer.
; REWIND, OFFLINE, UNLOAD.
;


(DEFUN MAGTAPE-LIST-FILES (&OPTIONAL &REST IGNORE)
  "FS:MAGTAPE-LIST-FILES is obsolete; use MT:MAGTAPE-LIST-FILES"
  (PRINT "FS:MAGTAPE-LIST-FILES is obsolete; use MT:MAGTAPE-LIST-FILES")) 


(DEFUN RESTORE-MAGTAPE (&OPTIONAL &REST IGNORE)
  "FS:RESTORE-MAGTAPE is obsolete; use MT:RESTORE-MAGTAPE"
  (PRINT "FS:RESTORE-MAGTAPE is obsolete; use MT:RESTORE-MAGTAPE")) 

;;AB 7-13-87.  Remove reference to PROCESSOR-TYPE-CODE (old LAMBDA support).
(DEFUN MT-ERASE (&OPTIONAL UNIT)
  "Explorer only.  Old form to erase magtape, just calls MT:ERASE"
  (IF UNIT
      (MT::ERASE UNIT)
      (MT::ERASE)))

(DEFUN MT-REWIND (&OPTIONAL UNIT)
  "Old form to rewind magtape, just calls MT:REWIND"
  (IF UNIT
    (MT::REWIND UNIT)
    (MT::REWIND))) 


(DEFUN MT-WRITE-EOF (&OPTIONAL UNIT)
  "Old form to write an eof to magtape, just calls MT:WRITE-EOF"
  (IF UNIT
    (MT::WRITE-EOF UNIT)
    (MT::WRITE-EOF))) 


(DEFUN MT-UNLOAD (&OPTIONAL UNIT)
  "Old form to unload magtape, just calls MT:UNLOAD"
  (IF UNIT
    (MT::UNLOAD UNIT)
    (MT::UNLOAD))) 


(DEFUN MT-OFFLINE (&OPTIONAL UNIT)
  "Old form to put magtape offline, just calls MT:OFFLINE.
  For EXPLORERs this is an unload."
  (IF UNIT
    (MT::OFFLINE UNIT)
    (MT::OFFLINE))) 


(DEFUN MT-SPACE-REV (&OPTIONAL (NTIMES 1) (UNIT 0))
  "Old form to move magtape in reverse a number of blocks, just calls MT:SPACE-REV.
  For EXPLORERs this is not meaningful."
  (MT::SPACE-REV NTIMES UNIT)) 


(DEFUN MT-SPACE-REV-TO-BOF (&OPTIONAL (UNIT 0) (SKIP-N-FILES 0))
  "Old form to move magtape in reverse to beginning of file, just calls MT:SPACE-REV-TO-BOF.
  For EXPLORERs this is not meaningful."
  (MT::SPACE-REV-TO-BOF UNIT SKIP-N-FILES)) 


(DEFUN MT-SPACE-TO-APPEND (&OPTIONAL UNIT)
  "Old form to position tape for appending, just calls MT:SPACE-TO-APPEND"
  (IF UNIT
    (MT::SPACE-TO-APPEND UNIT)
    (MT::SPACE-TO-APPEND))) 


(DEFUN MT-SPACE-TO-EOF (&OPTIONAL UNIT (NTIMES 1))
  "Old form to space to end of file mark on magtape, just calls MT:SPACE-TO-EOF"
  (IF UNIT
    (MT::SPACE-TO-EOF UNIT NTIMES)
    (MT::SPACE-TO-EOF))) 

