;;; -*- Mode:Common-Lisp; Package:Sugg; Fonts:(Medfnt Hl12b Hl12bi); Base:10. -*-

;;;                           RESTRICTED RIGHTS LEGEND

;;;Use, duplication, or disclosure by the Government is subject to
;;;restrictions as set forth in subdivision (c)(1)(ii) of the Rights in
;;;Technical Data and Computer Software clause at 52.227-7013.
;;;
;;;                     TEXAS INSTRUMENTS INCORPORATED.
;;;                              P.O. BOX 2909
;;;                           AUSTIN, TEXAS 78769
;;;                                 MS 2151
;;;
;;; Copyright (c) 1984-1989 Texas Instruments Incorporated. All rights reserved.

1;; To test this code from a Zmacs buffer:

;;to test the Arrest case do C-M-Break.  One of the Proceed Types will offer to arrest
;;the current process.

;;(send w:initial-lisp-listener :string-out "This should force an 'Output Hold' state")
;;also this provokes the "No Selected Window" advice if you hit Terminal Hold-Output
;;(but not if you click on the menu item for some reason).

;;Test Window Lock by doing 
;; (send (w:make-window 'w:pop-up-text-window :height 200. :width 300) :expose)

;;;To force a more-exception evaluate zwei:*command-alist* in the Lisp Listener
;;;May have to do Terminal-M to turn on more processing first.
;;;Zmacs more-exception is already covered--it has its own version of this default method

;;To try out the Lock stuff
;;(progn (send w:default-screen :eval-inside-yourself '(process-lock (locf w:lock))) (send w:default-screen :eval-inside-yourself '(process-lock (locf w:lock) 'test)))
;;This leaves the screen locked as you can see when you try right click and get "Activate"

;;To force a notification do
;;(push `(,(char-int #\X) zwei:foo "Foo" T) w:*system-keys*)
;;then do SYS X*

(sugg:suggestions-build-menu
  'output-hold-menu  
  "The current process is waiting until typeout can occur on a deexposed window."
  '(("Switch to Window Waiting to Type Out" :eval
     (process-run-function "KBD ESC" #'w:run-escape-function
			   #'w:kbd-esc-output-hold nil)
     :documentation
     "Expose the window that wants to typeout (you may need to select it yourself with the mouse)."
1     ;;;:keystroke-string "TERM HOLD OUTPUT"*
     ))
  nil)  

(sugg:suggestions-build-menu
  'default-more-menu  
  "The default *MORE* exception handler is waiting for the user to issue one of these commands."
  '(("Next Page of Output" #\Space :documentation "See the next page of typeout")
    ("Remove Output" #\Abort :documentation "Remove the rest of the typeout.")
    ("Turn Off MORE Processing" :eval
     (process-run-function "KBD ESC" #'suggestions-kbd-terminal #\M 0)
     :documentation
     "Turn off pausing at end of pages. TERM 1 M turns *MORE* processing back on in this window."
     :keystroke-string "TERM 0 M"))
  nil)  

(sugg:suggestions-build-menu
  'default-notification-menu  
  "Some process got an error--you may or may not be able to just ignore it."
  '(("Select Notifying Window" :eval
     (process-run-function "KBD ESC" #'suggestions-kbd-terminal #\S 0)
     :documentation "Select the window that just posted a notification message."
     :keystroke-string "TERM 0 S"))
  nil "Notification Menu")

(sugg:suggestions-build-menu
  'arrested-process-menu  
  "The current process is arrested and so will not run." 
  '(("Un-Arrest This Process" :eval
     (process-run-function "KBD ESC" #'suggestions-kbd-terminal #\A -1)
     :documentation
     "Un-Arrest the process that is described as arrested in the Who Line"
     :keystroke-string "TERM - A"))
  nil)

(sugg:suggestions-build-menu
  'window-lock-menu  
  "The selected window is locked." 
  '(("Unlock All Windows" :eval
     (process-run-function "KBD ESC" #'suggestions-kbd-terminal #\c-clear-input nil)
     :documentation "Remove any temporary windows and reset all locks."
     :keystroke-string "TERM CTRL-CLEAR-INPUT"))
  nil)

(sugg:suggestions-build-menu
  'lock-menu  
  "The selected window is waiting for a lock to clear on some data structure."
  '(("Unlock All Windows" :eval
     (process-run-function "KBD ESC" #'suggestions-kbd-terminal #\c-clear-input nil)
     :documentation
     "Maybe the locked data structure is a window.  Remove any temporary windows and reset all locks."
     :keystroke-string "TERM CTRL-CLEAR-INPUT"))
  nil)

(sugg:suggestions-build-menu
  'no-selected-window-menu  
  "There is currently no window selected, so no one is reading ordinary keyboard input."
  '(("<Try Clicking Left>" :documentation
     "If this message doesn't go away all by itself, maybe one of the exposed windows can be selected with the mouse.")
    ("Select a Window" :process-eval (tv:system-menu-select-window) :documentation
     "Pops up a menu of selectable windows.")
    ("Unlock All Windows" :eval
     (process-run-function "KBD ESC" #'suggestions-kbd-terminal #\c-clear-input nil)
     :documentation "Remove any temporary windows and reset all locks."
     :keystroke-string "TERM CTRL-CLEAR-INPUT"))
  nil)

(sugg:suggestions-build-menu
  'selected-menu  
  "Get out of the Selected state" 
  '(("Abort All" :eval (process-run-function '(:name "Abort" :priority 50)
					     (send w:selected-window :process)
					     :interrupt #'w:kbd-intercept-abort-all
					     (dpb 0 %%kbd-control #\c-m-abort))
     :documentation "Abort out of all levels immediately"
     :keystroke-string "CTRL-META-ABORT"))
  nil)

