;;; -*- Mode:Common-Lisp; Package:W; Base:10; Fonts:(MEDFNT HL12B HL12BI) -*-

;;;                           RESTRICTED RIGHTS LEGEND

;;;Use, duplication, or disclosure by the Government is subject to
;;;restrictions as set forth in subdivision (c)(1)(ii) of the Rights in
;;;Technical Data and Computer Software clause at 52.227-7013.
;;;
;;;                     TEXAS INSTRUMENTS INCORPORATED.
;;;                              P.O. BOX 2909
;;;                           AUSTIN, TEXAS 78769
;;;                                 MS 2151
;;;
;;; Copyright (C) 1984-1989 Texas Instruments Incorporated. All rights reserved.

(sugg:suggestions-build-menu
  'lisp-listener-top-menu ""
  '(("Lisp:" :no-select ignore :font sugg:*bold-suggestions-font*)
    ("Suggestions Menus Off" :process-eval (sugg:turn-all-suggestions-menus-off)
     :documentation "Switch to a configuration without suggestions menus."
     :keystroke-string "TERM - SUPR-HELP"))
  nil)  

(sugg:suggestions-build-menu
  'lisp-listener-bottom-menu ""
  `(("Help" #\Help :documentation
     "Explains how to get help on available programs, console operations, and command editing")
    ("Lisp Expressions" :suggestions-menu sugg:lisp-expressions)
    ("List Menus" :suggestions-menu w:com-list-menus)
    ,sugg:*menu-tools-menu-item*)
  nil "Lisp Bottom Menu")  

(sugg:suggestions-build-menu
  'w:com-list-menus
  "Displays a list of all the suggestions menus that are available for Lisp Listeners"
  nil nil)

(sugg:suggestions-build-menu
  'w:basic-menu 
  "The most basic command editing operations for Lisp Listeners" 
  '(("Clear Screen" #\Page :documentation
     "Clear all old inputs off the screen so that only the current input is visible.")
    ("Start Input Over" #\Clear-input :documentation
     "Delete the current input so this command can be started over from scratch.")
    ("Forward" #\c-f :documentation "Move the cursor one character forward.")
    ("Backward" #\c-b :documentation "Move the cursor one character backward.")
    ("Forward Word" #\m-f :documentation "Move the cursor forward one word.")
    ("Backward Word" #\m-b :documentation "Move the cursor backward one word.")
    ("Beginning of Line" #\c-a
     :documentation "Move the cursor back to the beginning of the current line.")
    ("End of Line" #\c-e
     :documentation "Move the cursor all the way to the end of the current line.")
    ("Rubout Last Char" #\Rubout
     :documentation "Delete the character before the cursor")
    ("Delete Character" #\c-d
     :documentation "Delete the character currently under the cursor")
    ("Retrieve Last Input" #\c-c :documentation
     "Take the most recently entered command and insert it before the cursor.  
Provide an argument to get a specific input other than the last.")
    ("Retrieve Last Kill" #\c-y :documentation
     "Take the most recently killed string and insert it before the cursor.
Good for transfering code to or from a ZMACS buffer.
Provide an argument to get a specific kill other than the last."))
  '(w:com-list-menus))

(sugg:suggestions-build-menu
  'delete-characters-menu 
  "Move over or delete lisp forms"
  '(("Rubout Last Char" #\Rubout :documentation
     "Delete the character before the cursor")
    ("Delete Character" #\c-d :documentation
     "Delete the character currently under the cursor")
    ("Delete Parens Forward" #\c-m-k :documentation "Delete next lisp form")
    ("Delete Parens Backward" #\c-m-rubout :documentation "Delete previous lisp form"))
  '(w:com-list-menus))

(sugg:suggestions-build-menu
  'move-cursor-menu 
  "Move cursor on screen" 
  '(("Forward" #\c-f :documentation "Move the cursor one character forward.")
    ("Backward" #\c-b :documentation "Move the cursor one character backward")
    ("Forward Word" #\m-f :documentation "Move the cursor forward one word.")
    ("Backward Word" #\m-b :documentation "Move the cursor backward one word.")
    ("Beginning of Line" #\c-a :documentation
     "Move the cursor back to the beginning of the current line.")
    ("End of Line" #\c-e :documentation
     "Move the cursor all the way to the end of the current line.")
    ("Forward Parens" #\c-m-f :documentation
     "Move the cursor forward over one lisp form")
    ("Backward Parens" #\c-m-b :documentation
     "Move the cursor backward over one lisp form")
    ("Delete Parens Forward" #\c-m-k :documentation "Delete next lisp form")
    ("Delete Parens Backward" #\c-m-rubout :documentation "Delete previous lisp form"))
  '(w:com-list-menus))

(sugg:suggestions-build-menu
  'misc-commands-menu 
  "Some commands not included in other menus"
  '(("Quote Next Character" #\c-q :documentation
     "Treat the following control character as a character instead of as a function key.")
    ("Transpose Characters" #\c-t :documentation
     "Transposes the lisp forms to the immediate right and left of the cursor")
    ("Open Line" #\c-o :documentation "Make an open line"))
  '(w:com-list-menus))

(sugg:suggestions-build-menu
  'saved-info-menu 
  "Earlier user inputs and kills are saved for possible recovery." 
  '(("Retry Previous Command" #\c-s :documentation
     "Pop previous command and position the cursor at the point where the error occurred")
    ("Display Output Ring" #\h-status :documentation
     "Display the contents of the output ring")
    ("Display Recent Inputs" #\Status :documentation
     "Display the first line of each of the recent user inputs.
Each entry is numbered, and that entry can be retrieved by giving that number
as an argument (e.g., Control-3) to the Retrieve Input Typed Last command.")
    ("Display Recent Deletions" #\c-status :documentation
     "Display the first line of each of the recent kills.
Each entry is numbered, and that entry can be retrieved by giving that number
as an argument (e.g., Control-3) to the Retrieve Last Kill command.")
    ("Retrieve Input Typed Last" #\c-c :documentation
     "Take the most recently entered command and insert it before the cursor.  
Provide an argument to get a specific input other than the last.")
    ("Retrieve Last Kill" #\c-y :documentation
     "Take the most recently killed string and insert it before the cursor.
Good for transfering code to or from a ZMACS buffer.
Provide an argument to get a specific kill other than the last.")
    ("Retrieve Input Before That" #\m-c :documentation
     "Take the previous command and insert it before the cursor")
    ("Retrieve Kill Before That" #\m-y :documentation
     "Take the string from an earlier kill and insert it before the cursor"))
  '(w:com-list-menus))

(sugg:suggestions-build-menu
  'info-about-this-function-menu 
  "A menu of commands for obtaining documentation about the function that the user has just typed."
  '(("Arguments of this Function" #\c-\a :documentation
     "Display the lambda-list of this function's definition")
    ("Documentation of this Function" #\c-\d :documentation
     "Display a description of this function"))
  '(w:com-list-menus) "Function Info MENU")  

1;;;the C-Break, C-M-Abort, Abort, C-M-Break keys are handled by code stolen from
;;;; the function KBD-ASYNCHRONOUS-INTERCEPT-CHARACTER in Window;Basstr.lisp#290*

(defun system-keys-assoc (window-type alist)
  (loop for item in alist when
	(or (eq window-type (second item)) (eq window-type (fourth item))) return item))

(defun run-escape-function (fcn arg)	
  (declare (special kbd-last-activity-time))
  (let-globally ((kbd-last-activity-time w:kbd-last-activity-time))
		(funcall fcn arg))
  (setq kbd-terminal-time nil)
  (tv:restore-idle-info)) 

(defun sugg:suggestions-kbd-terminal (ch &optional arg &aux fcn ent tem)
  "Handle Terminal typed on keyboard"
  (tv:save-idle-info)
  1;;but something was probably already clobbered, sigh*
  (cond ((setq ent (or (assoc ch *terminal-keys* :test #'eq)
		       (assoc (char-int ch) *terminal-keys* :test #'eq)))
	 (without-interrupts
	   (cond ((member :typeahead (cdddr ent) :test #'eq)
		  (tv:kbd-get-io-buffer)
		  (kbd-snarf-input tv:selected-io-buffer t)
		  (setq kbd-terminal-time (time)))))
	 (setq fcn (second ent))
	 (and (consp fcn) (setq arg fcn fcn #'eval))
	 (cond ((member :keyboard-process (cdddr ent) :test #'eq)
		(funcall fcn arg)
		(setq kbd-terminal-time nil))
	       (t (process-run-function
		    (format nil "Handle Terminal-~:C" ch)
		    #'(lambda (fcn arg)
			 (let ((kbd-last-activity-time w:kbd-last-activity-time))
			  (declare (special kbd-last-activity-time))
			  (funcall fcn arg))
			(setq kbd-terminal-time nil)
			(tv:restore-idle-info))
		    fcn arg))))
	;; quote asynchronous characters
	((or (and (setq tem (tv:kbd-get-io-buffer))
		  (assoc ch (getf (io-buffer-plist tem) :asynchronous-characters
				  kbd-standard-asynchronous-characters)
			 :test #'eq))
	     (assoc ch kbd-global-asynchronous-characters :test #'eq))
	 (unless (io-buffer-full-p tv:kbd-io-buffer)
	   (io-buffer-put tv:kbd-io-buffer ch)))
	1;;((SETQ TEM (ASSQ (DPB 1 %%KBD-CONTROL (LDB %%KBD-CHAR CH))*
	1;;           KBD-STANDARD-ASYNCHRONOUS-CHARACTERS))*
	1;; (APPLY (CADR TEM) (CAR TEM) W:SELECTED-WINDOW (CDDR TEM)))*
	((not (eql ch #\Rubout)) (beep)))
  1;; No unwind-protect needed -- this is for good measure*
  (tv:restore-idle-info))  

(defparameter *switch-programs-menu-contents*
   '(("EXISTING WINDOWS" :no-select ignore :font sugg:menu-subtitle-std-font)
     ("Tape Backup Window      " :eval (process-run-function "KBD SYS" #'kbd-sys-1 #\B)
      :documentation
      "Go to a Tape Backup Window.
If you are currently in one then this command rotates through previous Tape Backup Windows."
      :keystroke-string "System B")
     ("Converse                " :eval (process-run-function "KBD SYS" #'kbd-sys-1 #\C)
      :documentation
      "Go to a Converse Frame.
If you are currently in one then this command rotates through previous Converse Frames."
      :keystroke-string "System C")
     ("Zmacs Editor            " :eval (process-run-function "KBD SYS" #'kbd-sys-1 #\E)
      :documentation
      "Go to a Zmacs Frame.
If you are currently in one then this command rotates through previous Zmacs Frames."
      :keystroke-string "System E")
     ("Font Editor             " :eval (process-run-function "KBD SYS" #'kbd-sys-1 #\F)
      :documentation
      "Go to a Font Editor.
If you are currently in one then this command rotates through previous Font Editors."
      :keystroke-string "System F")
     ("Inspector               " :eval (process-run-function "KBD SYS" #'kbd-sys-1 #\I)
      :documentation
      "Go to a Inspector.
If you are currently in one then this command rotates through previous Inspectors."
      :keystroke-string "System I")
     ("Lisp Listener           " :eval (process-run-function "KBD SYS" #'kbd-sys-1 #\L)
      :documentation
      "Go to a Lisp Listener.
If you are currently in one then this command rotates through previous Lisp Listener."
      :keystroke-string "System L")
     ("Peek                    " :eval (process-run-function "KBD SYS" #'kbd-sys-1 #\P)
      :documentation
      "Go to a Peek Frame.
If you are currently in one then this command rotates through previous Peek Frames."
      :keystroke-string "System P")
     ("Telnet                  " :eval (process-run-function "KBD SYS" #'kbd-sys-1 #\T)
      :documentation
      "Go to a Telnet Window.
If you are currently in one then this command rotates through previous Telnet Windows."
      :keystroke-string "System T")
     ("Vt100 Emulator          " :eval (process-run-function "KBD SYS" #'kbd-sys-1 #\V)
      :documentation
      "Go to a Vt100 Emulator.
If you are currently in one then this command rotates through previous Vt100 Emulator."
      :keystroke-string "System V")
     ("Glossary                " :eval (process-run-function "KBD SYS" #'kbd-sys-1 #\Z)
      :documentation
      "Go to a Glossary Frame.
If you are currently in one then this command rotates through previous Glossary Frames."
      :keystroke-string "System Z")
     ("CREATE NEW WINDOW" :no-select ignore :font sugg:menu-subtitle-std-font)
     ("New Tape Backup Window  " :eval (process-run-function "KBD SYS" #'kbd-sys-1 #\c-b)
      :documentation "Create a new Tape Backup Window."
      :keystroke-string "System Control-B")
     ("New Converse            " :eval (process-run-function "KBD SYS" #'kbd-sys-1 #\c-c)
      :documentation "Create a new Converse Frame." :keystroke-string "System Control-C")
     ("New Zmacs Editor        " :eval (process-run-function "KBD SYS" #'kbd-sys-1 #\c-e)
      :documentation "Create a new Zmacs Frame." :keystroke-string "System Control-E")
     ("New Font Editor         " :eval (process-run-function "KBD SYS" #'kbd-sys-1 #\c-f)
      :documentation "Create a new Font Editor." :keystroke-string "System Control-F")
     ("New Inspector           " :eval (process-run-function "KBD SYS" #'kbd-sys-1 #\c-i)
      :documentation "Create a new Inspector." :keystroke-string "System Control-I")
     ("New Lisp Listener       " :eval (process-run-function "KBD SYS" #'kbd-sys-1 #\c-l)
      :documentation "Create a new Lisp Listener." :keystroke-string "System Control-L")
     ("New Peek                " :eval (process-run-function "KBD SYS" #'kbd-sys-1 #\c-p)
      :documentation "Create a new Peek Frame." :keystroke-string "System Control-P")
     ("New Telnet              " :eval (process-run-function "KBD SYS" #'kbd-sys-1 #\c-t)
      :documentation "Create a new Telnet Window." :keystroke-string "System Control-T")
     ("New Vt100 Emulator      " :eval (process-run-function "KBD SYS" #'kbd-sys-1 #\c-v)
      :documentation "Create a new Vt100 Emulator." :keystroke-string "System Control-V")
     ("New Glossary            " :eval (process-run-function "KBD SYS" #'kbd-sys-1 #\c-z)
      :documentation "Create a new Glossary Frame." :keystroke-string "System Control-Z")
     ("OTHER COMMANDS" :no-select ignore :font sugg:menu-subtitle-std-font)
     ("Go to Error Handler     " :eval
      (process-run-function '(:name "Error Break" :priority 50)
			    (send selected-window :process)
			    :interrupt #'kbd-intercept-error-break #\c-m-break
			    selected-window)
      :documentation "Run the error handler immediately in the current context."
      :keystroke-string #\c-m-break)
     ("Immediate Abort         " :eval
      (process-run-function '(:name "Abort" :priority 50) (send selected-window :process)
			    :interrupt #'kbd-intercept-abort
			    (dpb 0 %%kbd-control #\c-abort))
      :documentation "Throw to command level immediately" :keystroke-string #\c-abort)
     ("Abort All               " :eval
      (process-run-function '(:name "Abort" :priority 50) (send selected-window :process)
			    :interrupt #'kbd-intercept-abort-all
			    (dpb 0 %%kbd-control #\c-m-abort))
      :documentation "Abort out of all levels immediately" :keystroke-string #\c-m-abort)
     ("Break                   " :eval (process-run-function
					 '(:name "Break" :priority 40.)
					 (send w:selected-window ':process)
					 ':interrupt #'break "BREAK")
      :documentation "Get to a read-eval-print loop"
      ;"Go to a Breakpoint in the current context"
      :keystroke-string #\C-break)
     ("Trace                   " :eval (process-run-function "Trace" #'trace-via-menus)
      :documentation "Trace a function.  Options selected from menu.")
     ("List Selectable Windows "
      :eval (process-run-function "KBD SYS" #'kbd-sys-1 #\Help)
      :documentation "Give a short description of the defined systems."
      :keystroke-string "SYS HELP")
     ("Previous Selected Window" :eval
      (process-run-function "KBD TERMINAL" #'sugg:suggestions-kbd-terminal #\S)
      :documentation
      "Select the most recently selected window.  With an argument, select the nth
	   previously selected window and rotate the top n windows.  (Default arg is 2).
	   With an arg of 1, rotate through all the windows.
	   With a negative arg rotate in the other direction.
	   With an argument of 0, select a window that wants to type out."
      :keystroke-string "TERM S")))  

(sugg:suggestions-build-menu
  'switch-programs-menu 
  "Leave the Lisp Listener by selecting another program." 
  *switch-programs-menu-contents*
  '(w:com-list-menus eh:debugger-list-menus))

(sugg:suggestions-build-menu
  'terminal-characteristics-menu 
  "A menu of commands for modifying the settings of the display" 
  '(("Complement Video" :eval
     (process-run-function "KBD ESC" #'sugg:suggestions-kbd-terminal #\C nil)
     :documentation "Change to black-on-white video (or vice versa)."
     :keystroke-string "TERM C")
    ("Complement Mouse Documentation Video" :eval
     (process-run-function "KBD ESC" #'sugg:suggestions-kbd-terminal #\C 0)
     :documentation
     "Change the mouse documentation to black-on-white (or vice versa)."
     :keystroke-string "TERM 0 C")
    ("Turn On *MORE* Processing in the Selected Window" :eval
     (process-run-function "KBD ESC" #'sugg:suggestions-kbd-terminal #\M 1)
     :documentation
     "Stop at end of page. TERM 0 M turns *MORE* processing back off in this window."
     :keystroke-string "TERM 1 M")
    ("Turn Off *MORE* Processing in the Selected Window" :eval
     (process-run-function "KBD ESC" #'sugg:suggestions-kbd-terminal #\M 0)
     :documentation
     "Don't stop at end of page. TERM 1 M turns *MORE* processing back on in this window."
     :keystroke-string "TERM 0 M"))
  '(w:com-list-menus) "Terminal Settings MENU")

(sugg:suggestions-build-menu
  'top-level-variables-menu 
  "Variables maintained by the read-eval-print loop." 
  '(("Previous Form" #\+ :documentation
     "The previous form read by the read-eval-print loop.")
    ("Second to Last Form" :symbol "++" :documentation
     "The previous form read by the read-eval-print loop." :keystroke-string "++")
    ("Third to Last Form" :symbol "+++" :documentation
     "The previous form read by the read-eval-print loop." :keystroke-string "+++")
    ("Result Printed Last" #\* :documentation
     "The first value returned by the previous form.")
    ("Second to Last Result" :symbol "**" :documentation
     "The first value returned by the second to last form evaluated by the read-eval-print loop."
     :keystroke-string "**")
    ("Third to Last Result" :symbol "***" :documentation
     "The first value returned by the third to last form evaluated by the read-eval-print loop."
     :keystroke-string "***")
    ("List of Previous Results" #\/ :documentation
     "Returns a list of all values returned by the previous form"))
  '(w:com-list-menus))    

(sugg:suggestions-build-menu
  'completion-menu 
  "Text completion operations" 
  '(("Apropos Completion" #\s-escape :documentation "Complete substring given")
    ("Spelling Correction Completion" #\h-escape :documentation
     "Complete name given and correct spelling if necessary")
    ("Recognition Completion" #\c-escape :documentation
     "Complete given substring with first recognizable match")
    ("List Recognition Completions" #\c-/ :documentation
     "Display possible completions of name given")
    ("List Apropos Completions" #\s-/ :documentation
     "Display possible completions of substring given")
    ("List Spelling Completions" #\h-/ :documentation
     "Display possible completions of name given, correcting spelling if necessary")
    ("Command Name Auto-Completion" #\Escape :documentation
     "Attempt to complete UCL command names."))
  '(w:com-list-menus))

(sugg:suggestions-build-menu
  'top-level-configuration-menu 
  "Commands for configuring the lisp top level." 
  '(("Help on Command Type-in" :symbol ucl:show-typein-help :documentation
     "Presents various features for typing command names and lisp forms.")
    ("Top Level Configurer" #\c-h-t :documentation
     "Modify the attributes Command and Lisp-typein")
    ("Configure Lisp Typein Modes" #\c-h-\( :documentation
     "Allows modification of the modes used in interpreting and completing typed input.")
    ("Display Commands" #\c-h-help :documentation
     "Displays the currently active commands in a scroll window.")
    ("Edit Commands" #\c-h-status :documentation
     "Allows editing of this programs commands in a scroll window."))
  '(w:com-list-menus) "Configure Top Level MENU")

(sugg:suggestions-build-menu
  'simplified-msg-passing
  "Simplifies sending many messages to the same flavor instance" 
  '(("Turn On Simplified Msg Passing" :symbol rotl documentation
     "Set default instance for abbrev message passing.")
    ("Turn Off Simplified Msg Passing" :symbol "(rotl nil)" :documentation
     "Back to vanilla top-level--no instance assumed."))
  '(w:com-list-menus))

1;;Release 3 does not use ADVISE for functions, but since there is no other means to provide menus
;;for a WINDOW, we need to initialize a set of menus for the Lisp Listener via advise.*
(sugg:initialize-suggestions-for-application w:lisp-listener lisp-listener-top-menu
					     lisp-listener-bottom-menu w:basic-menu
					     w:com-list-menus nil "Lisp Listener")

