;;; -*- Mode:Common-Lisp; Package:SUGG; Base:10; Fonts:(MEDFNT HL12B HL12BI) -*-

;;;                           RESTRICTED RIGHTS LEGEND

;;;Use, duplication, or disclosure by the Government is subject to
;;;restrictions as set forth in subdivision (c)(1)(ii) of the Rights in
;;;Technical Data and Computer Software clause at 52.227-7013.
;;;
;;;                     TEXAS INSTRUMENTS INCORPORATED.
;;;                              P.O. BOX 2909
;;;                           AUSTIN, TEXAS 78769
;;;                                 MS 2151
;;;
;;; Copyright (C) 1984-1989 Texas Instruments Incorporated. All rights reserved.

(setq sugg:*mouse-in-suggestions-pane?* 
      #'(lambda (x) (typep x 'sugg:suggestions-command-menu-mixin)))

(sugg:suggestions-build-menu
  'sugg:lisp-expressions
  "Menus of Lisp functions, global variables, flavors, messages, etc."
  nil nil)

(sugg:suggestions-build-menu
  'customize-terminal-menu
  "Menus of functions for changing default fonts on various screens, enlarging the mouse documentation line, etc."
  '(w:set-default-font
     w:set-standard-font
     w:set-screen-standard-font
     w:set-number-of-who-line-documentation-lines)
  '(sugg:lisp-expressions))

(sugg:suggestions-build-menu
  'disk-bands-menu
  "A menu of functions for examining, selecting, and creating disk-bands."
  '(print-disk-label
     print-herald
     si:set-current-band
     si:set-current-microload
     load-and-save-patches
     disk-save
     si:full-gc
     si:transmit-band
     si:receive-band
     si:compare-band
     describe-partition
     si:estimate-dump-size)
  '(sugg:lisp-expressions))

(sugg:suggestions-build-menu
  'emergency-measures-menu
  "Desperate measures for occasions when all appears lost"
  '(zwei:save-all-files
     ("Reset Chaos" :symbol "(chaos:reset t)" :documentation
      "Worth a try when you can't talk to other machines")
     ("Reset Mouse Process" :symbol "(send w:mouse-process :reset)" :documentation
      "If you can mouse this item, then the mouse process doesn't really need to be reset")
     ("Warm Boot" :symbol si:lisp-reinitialize :documentation
      "Reset the values of various global constants and initialize the error system."))
  '(sugg:lisp-expressions))

(sugg:suggestions-build-menu
  'fonts-menu
  "Some fonts that may be loaded; try M-X List Fonts in Zmacs to check."
  '(fonts:43vxms
    fonts:|5X5|
;    fonts:abacus
    fonts:bigfnt
    fonts:cmb8
    fonts:cmdunh
    fonts:cmold
    fonts:cmr10
    fonts:cmr18
    fonts:cmr5
    fonts:courier ;
;    fonts:color-5x5
;    fonts:color-cptfont
;    fonts:color-gwin-mouse
;    fonts:color-medfnt
;    fonts:color-mouse
    fonts:cptfont
    fonts:cptfontb
;    fonts:cptfontbi ;
;    fonts:ent
;    fonts:gwin-mouse
;    fonts:higher-medfnb ;
;    fonts:higher-tr8 ;
    fonts:hl10
    fonts:hl10b
    fonts:hl12
    fonts:hl12b
    fonts:hl12bi
    fonts:hl12i
    fonts:hl6
    fonts:hl7
;    fonts:icons ;
    fonts:medfnb
    fonts:medfnt
    fonts:mets
;    fonts:metsb ;
;    fonts:metsbi ;
    fonts:metsi
    fonts:mouse
    fonts:search
    fonts:tiny
;    fonts:tog
    fonts:tr10
    fonts:tr10b
    fonts:tr10bi
    fonts:tr10i
    fonts:tr12
    fonts:tr12b
    fonts:tr12bi
    fonts:tr12i
;    fonts:tr18 ;
;    fonts:tr18b ;
    fonts:tr8
    fonts:tr8b
    fonts:tr8i
    fonts:tvfont
    fonts:vt-graphics ;
    fonts:vt-graphics-wider-font ;
    fonts:wider-font ;
    fonts:wider-medfnt ;
    )
  '(sugg:lisp-expressions))

(sugg:suggestions-build-menu
  'suggestions-fns-&-globals-menu
  "User functions and global variables for the Suggestions Menus system."
  '(sugg:turn-off-pop-up-keystrokes
     sugg:turn-on-pop-up-keystrokes
     sugg:*suggestions-expand-who-line*
     sugg:install-menu-items
     sugg:advise-function-to-push-all-menus
     sugg:advise-function-to-push-one-menu
     sugg:suggestions-frame
     sugg:suggestions-off-frame
     sugg:suggestions-advised-functions
     sugg:*windows-recognized-by-suggestions*
     sugg:*all-windows-recognized-by-suggestions*
     sugg:suggestions-process
     sugg:suggestions-io-buffer
     sugg:pop-up-keystrokes-process
     sugg:whats-up)
  '(sugg:lisp-expressions) "Suggestions Symbols Menu")

  
(sugg:suggestions-build-menu
  'interesting-globals-to-inspect
  "A menu of variables whose values are interesting to inspect"
  '(w:all-the-screens
     system:active-processes
     system:all-processes
     current-process
     w:mouse-process
     1;; This brings the Lambdas to a halt due to some bug    area-list*
     ("all-packages" :symbol "(si:list-all-packages)")
     *package*
     ("Previously Selected Window" :symbol "(aref w:previously-selected-windows 0)"
      :documentation "The program that I was using before coming to the Inspector.")
     w:previously-selected-windows
     w:window-resource-names
     w:*terminal-keys*
     w:*system-keys*
     w:selected-window
     tv:selected-io-buffer
     w:mouse-window
     *standard-input*
     *standard-output*
     w:initial-lisp-listener
     w:default-screen
     w:main-screen
     w:who-line-screen
     tv:*system-menu-programs-column*)
  '(sugg:lisp-expressions) "System Symbols Menu")

(sugg:suggestions-build-menu
  'ucl-fns-&-globals-menu
  "User functions and global variables for the Universal Command Loop system."
  '(make-command
     build-command-table
     build-menu
     ucl:get-command
     ucl:universal-commands
     ucl:*all-command-defnames*
     ucl:*default-typein-modes*
;     ucl:typein-mode
     tv:rh-completion-handler
;     ucl:basic-command-loop
;     ucl:command-loop-mixin
     ucl:dwimify-package-p
     ucl:reparse-all-commands
     1;;w:complete-function-alist*
     1;;ucl:save-commands*
     )
  '(sugg:lisp-expressions) "Ucl Symbols Menu")  
