;;; -*- Mode:Common-Lisp; Package:SUGG; Base:10; Fonts:(MEDFNT HL12B HL12BI) -*-

;;;                           RESTRICTED RIGHTS LEGEND

;;;Use, duplication, or disclosure by the Government is subject to
;;;restrictions as set forth in subdivision (c)(1)(ii) of the Rights in
;;;Technical Data and Computer Software clause at 52.227-7013.
;;;
;;;                     TEXAS INSTRUMENTS INCORPORATED.
;;;                              P.O. BOX 2909
;;;                           AUSTIN, TEXAS 78769
;;;                                 MS 2151
;;;
;;; Copyright (c) 1984-1989 Texas Instruments Incorporated. All rights reserved.


(sugg:suggestions-build-menu
  'single-stepper-commands-menu
  "The commands accepted by the Single Stepper"
  '(("Next" #\c-n :documentation "Proceed to next thing evaled.")
    ("Next At This Level" #\Space :documentation
     "Proceed to next thing evaled at same level.")
    ("Eval The Args" #\c-a :documentation
     "Eval the args without stepping	; stop before applying the function.")
    ("Next Up A Level" #\c-u :documentation "Proceed to first thing up one level.")
    ("Continue w/o Stepping" #\c-x :documentation "Continue without further stepping.")
    ("Escape To Editor" #\c-e :documentation "Escape to editor.")
    ("Retype Form" #\c-t :documentation "Retype current form in full.")
    ("Grind Current Form" #\c-g :documentation "Grind current form.")
    ("Break" #\c-b :documentation
     "Enter breakpoint, with the following variables bound:
	   STEP-FORM is the form, STEP-VALUES is the list of values,
	   STEP-VALUE is the first value.  If you change these, it wins.")
    ("Clear & Show" #\c-l :documentation "Clear & show last 10. forms.")
    ("Show Last 10" #\m-l :documentation "Just show last 10. forms (don't clear).")
    ("Clear and Show All" #\c-m-l :documentation "Clear and show all forms.")
    ("<any LISP form>" #\( :documentation
     "Any Lisp form will be read and evaluated, and values printed."))
  nil "Stepper Commands Menu")  

(sugg:suggestions-build-menu
  'single-stepper-top-menu ""
  '(("Single Stepper:" :no-select ignore :font sugg:*bold-suggestions-font*)
    ("" :no-select ignore)("" :no-select ignore)("" :no-select ignore))
  nil)

(sugg:suggestions-build-menu
  'single-stepper-bottom-menu ""
  `(("" :no-select ignore)
    ("Help" #\Help
     :documentation "Displays the step commands and their keyboard equivalents")
    ("Lisp Expressions" :suggestions-menu sugg:lisp-expressions)
    ,sugg:*menu-tools-menu-item*)
  nil "Step Bottom Menu")

(setq sys:single-stepper-commands-menu single-stepper-commands-menu)
(setq sys:single-stepper-top-menu single-stepper-top-menu)
(setq sys:single-stepper-bottom-menu single-stepper-bottom-menu)

1;;This is a work-around that should be removed when this file is put into the debug-utilities defsystem.*

(eval-when (eval compile load)
  (if (not (fdefinedp 'si:step-eval))
      (defun si:step-eval (ignore &optional ignore)
	nil)))  


