;;; -*- Mode:Common-Lisp; Package:Sugg; Fonts:(Medfnt Hl12b Hl12bi); Base:10. -*-

;;;                           RESTRICTED RIGHTS LEGEND

;;;Use, duplication, or disclosure by the Government is subject to
;;;restrictions as set forth in subdivision (c)(1)(ii) of the Rights in
;;;Technical Data and Computer Software clause at 52.227-7013.
;;;
;;;                     TEXAS INSTRUMENTS INCORPORATED.
;;;                              P.O. BOX 2909
;;;                           AUSTIN, TEXAS 78769
;;;                                 MS 2151
;;;
;;; Copyright (c) 1984-1989 Texas Instruments Incorporated. All rights reserved.

(defflavor suggestions-off-pane () (menu-manip-strip))

(defflavor suggestions-off-frame ()
	   (W:bordered-constraint-frame-with-shared-io-buffer)
  (:default-init-plist
    :height *default-height-of-suggestions-off-frame*
    :constraints '((strip (suggestions-off-menu-manip-strip)
			  ((suggestions-off-menu-manip-strip 1 :lines))))
    :panes
    `((suggestions-off-menu-manip-strip
	suggestions-off-pane
	:font-map ,*suggestions-fonts*
	:item-alignment :center
	:scroll-bar-icon-height 0
	:scrolling-p nil
	:item-list
	(("Suggestions Menus On" :process-eval (esc-suggestions-menus nil)
	  :documentation
	  "Switch to a configuration with automatically updated menus of user commands."
	  :keystroke-string "TERM SUPR-HELP")
	 ("System Menu" :process-eval (W:mouse-call-system-menu) :documentation
	  "Bring up the System Menu so you can run other programs besides the Lisp Listener.")
	 ("Help" #\Help :documentation
	  "Explains how to get help on available programs, console operations, and command editing"))))))

(defun set-up-suggestions-off-frame ()
  (declare (special suggestions-off-frame))
  (make-instance 'suggestions-off-frame
		 :bottom (- tv:main-screen-height (W:sheet-height W:who-line-screen)))
;;Remove this code for Mac project.  See DECIDE-IF-SUGGESTIONS-VISIBLE   slm 1/20/88
;  (resize-window-for-suggestions-off-frame W:initial-lisp-listener) 
;  (when (eq W:selected-window W:initial-lisp-listener)
;    (send suggestions-off-frame :expose))
  )

(defmethod (suggestions-off-frame :after :init) (&rest ignore)
  (declare (special suggestions-off-frame))
  (setq suggestions-off-frame self)
  ;;Color support added for 3.2 by SLM.  Code read PMH and KJF.
  (DOLIST (inf tv:inferiors)
    (send inf :set-background-color w:white))
  (send suggestions-off-frame :activate)
  (setq *height-of-suggestions-off-frame* (send self :height)))
