;;; -*- Mode: LISP; Package: USER; Lowercase: T; Base: 10; Fonts: MEDFNT,HL12B,HL12BI -*-

;;;                           RESTRICTED RIGHTS LEGEND

;;;Use, duplication, or disclosure by the Government is subject to
;;;restrictions as set forth in subdivision (c)(1)(ii) of the Rights in
;;;Technical Data and Computer Software clause at 52.227-7013.
;;;
;;;                     TEXAS INSTRUMENTS INCORPORATED.
;;;                              P.O. BOX 2909
;;;                           AUSTIN, TEXAS 78769
;;;                                 MS 2151
;;;
;;; Copyright (C) 1985-1989 Texas Instruments Incorporated. All rights reserved.

;;; 03.05.87  DAB  Changed :patchable and added :warnings-pathname-default

(si:pkg-find-package 'SYSLOG t)

;;;
;;; This is the Explorer SYSTEM ERROR LOGGING defsystem
;;;

;;; This should be loaded AFTER the NVRAM system.

(DEFSYSTEM SYSLOG
  (:NAME "System-Log")
  (:SHORT-NAME "syslog")
  (:PATHNAME-DEFAULT "SYS: SYSLOG;")
  (:PATCHABLE "SYS: PATCH.SYSLOG;" PATCH) ;03.05.87 DAB
  (:WARNINGS-PATHNAME-DEFAULT "SYS: CWARNS; SYSLOG.lisp") ;03.05.87 DAB
  ;; Modules DEFS, BODY are in SYSLOG package
  ;; MONITORS files are in SYS
  (:PACKAGE SYSLOG)
  
  (:MODULE DEFS "DEFS")
  (:MODULE BODY ("log-and-dump"))
  (:MODULE MONITORS 
	   ("hardware-events"
	    "ecm-board-monitor")
	   :PACKAGE SYSTEM)
  (:MODULE EXPORTS "exports")
  (:COMPILE-LOAD DEFS)
  (:COMPILE-LOAD BODY (:FASLOAD DEFS))
  (:COMPILE-LOAD MONITORS (:FASLOAD DEFS BODY))
  (:COMPILE-LOAD EXPORTS)
  )

