;;; -*- Mode:Common-Lisp; Package:USER; Fonts:(CPTFONT HL12B); Base:10 -*-

;;;                           RESTRICTED RIGHTS LEGEND

;;;Use, duplication, or disclosure by the Government is subject to
;;;restrictions as set forth in subdivision (c)(1)(ii) of the Rights in
;;;Technical Data and Computer Software clause at 52.227-7013.
;;;
;;;                     TEXAS INSTRUMENTS INCORPORATED.
;;;                              P.O. BOX 2909
;;;                           AUSTIN, TEXAS 78769
;;;                                 MS 2151
;;;
;;; Copyright (C) 1984- 1989 Texas Instruments Incorporated. All rights reserved.

;; Commented out the supdup files since they are nolonger used in TELNET.
;; Added three new files added to the defsystem:
;; nvt-defs, basic-telnet-defs, telnet-window   
;; All files reflect the addition of a generalized network interface. 

(defpackage TELNET)

(DEFSYSTEM telnet
  (:NAME "Telnet")
  (:PATHNAME-DEFAULT "SYS:telnet;")
  (:PATCHABLE "SYS: patch.telnet;" PATCH)
  (:warnings-pathname-default "sys:cwarns;telnet.lisp")
  (:DOCUMENTATION "Log in to another machine using the Telnet protocol")
  (:DEFAULT-MENU-COLUMN :PROGRAMS)
  (:DEFAULT-SYSTEM-KEY #\T)
  (:INSTANCE-TYPE    :FLAVOR)
  (:INSTANCE-FINDER  TELNET)
  (:INSTANCE-CREATOR T)
  (:MODULE nvt-defs "nvt-defs")			
  (:MODULE nvt "nvt")
  (:MODULE btd "basic-telnet-defs")		
  (:MODULE basic-telnet "basic-telnet")
  (:MODULE telnet-window "telnet-window")	
  (:MODULE ucl-telnet "ucl-telnet")
  (:MODULE SERVICE ("TELNET-SERVICE" "TELNET-SERVER"))
  (:MODULE supdup "supdup")                    
;  (:MODULE editing-supdup "editing-supdup")

  (:COMPILE-LOAD nvt-defs)			
  (:COMPILE-LOAD nvt (:FASLOAD nvt-defs))
  (:COMPILE-LOAD btd)
  (:COMPILE-LOAD basic-telnet (:FASLOAD nvt-defs nvt btd))     
  (:COMPILE-LOAD telnet-window (:FASLOAD nvt-defs nvt btd basic-telnet))
  (:COMPILE-LOAD ucl-telnet (:FASLOAD nvt-defs nvt btd basic-telnet telnet-window))
  (:COMPILE-LOAD SERVICE)
  (:COMPILE-LOAD supdup (:FASLOAD  nvt-defs nvt))
  ;(:COMPILE-LOAD basic-telnet (:FASLOAD nvt supdup))
;  (:COMPILE-LOAD ucl-telnet (:FASLOAD nvt basic-telnet))
;  (:COMPILE-LOAD editing-supdup (:FASLOAD nvt supdup)))
  )



