;;; -*- Mode:Common-Lisp; Package:TELNET; Base:10; Fonts: Courier, Medfnt, Medfnb, Courier, Medfnb;  -*-

;;;                           RESTRICTED RIGHTS LEGEND

;;; Use, duplication, or disclosure by the Government is subject to
;;; restrictions as set forth in subdivision (c)(1)(ii) of the Rights in
;;; Technical Data and Computer Software clause at 52.227-7013.
;;;
;;;                     TEXAS INSTRUMENTS INCORPORATED.
;;;                              P.O. BOX 2909
;;;                           AUSTIN, TEXAS 78769
;;;                                 MS 2151


;;; Copyright (C) 1986- 1989 Texas Instruments Incorporated. All rights reserved.


;; 
;; Login service
;;


(defflavor telnet-service
	   ((net:name :telnet)
	    (net:desirability .75))
	   (net:service-implementation-mixin)
  :gettable-instance-variables
  :settable-instance-variables
  :initable-instance-variables)

(net:define-service-implementation 'telnet-service)

(net:define-service :login (&rest args) (net:medium self args) "Virtual terminal service.")

(net:define-logical-contact-name "telnet" '((:chaos "TELNET") (:tcp 23)))

(defvar *telnet-connect-timeout* (* 10 60))

(defmethod (telnet-service :connect) (medium host &optional (contact-name "telnet") window)
  "Return a stream to the login server on host."
  (unless (net:superior-medium-p medium :byte-stream)
	  (ferror 'net:gni-service-error "Service ~a cannot connect using ~a medium" self medium))
  (net:open-connection-on-medium host medium contact-name
				  :stream-type :character-stream
				  :window-size window
				  :timeout *telnet-connect-timeout*
				  :timeout-after-open nil
				  ))

(compile-flavor-methods telnet-service)
