;;; -*- Mode:Common-Lisp; Package:MACTOOLBOX; Base:10 -*-

;;; For the puposes of the Texas Instruments Contract, this software is in
;;; TBI Category "B". Copyright (C) 1988, 1987, ExperTelligence Incorporated.

;/*                                                                       */
;/*                      RESTRICTED RIGHTS LEGEND                         */
;/*                                                                       */
;/* Use, duplication, or disclosure by the Government is subject to       */
;/* restrictions as set forth in subdivision (b)(3)(ii) of the Rights in  */
;/* Technical Data and Computer Software clause at 52.227-7013.           */
;/*                                                                       */
;/*                           EXPERTELLIGENCE                             */
;/*                            5638 HOLLISTER                             */
;/*                          GOLETA, CA  93117                            */
;/*                                                                       */
;/*  Copyright (C) 1988, 1987, EXPERTELLIGENCE Incorporated.              */
;/*  All rights reserved.                                                 */
;/*                                                                       */

;;; ************************************************************************
;;; Modification History:
;;;   08/16/88 DWB  Changed !GetKeys to HndlPtr type
;;;   08/22/88 rwr  Put Print Mgr. PasCalls in order & gave correct jmp table  
;;;   08/23/88 rwr  Added Palette Mgr/Color Mgr + misc traps
;;;   08/25/88 rwr  Changed !FontMetrics & !FMSwapFont to HndlPtrType 
;;;   08/28/88 rwr  Made !Color2Index return longint, !GetSubTable takes handle
;;;   08/30/88 rwr  Fixed !SndNewChannel
;;;   09/01/88 rwr  Made CMY, HSL, HSV colors HndlPtrTypes
;;;   09/21/88 bj   Changed the result type of NewHandle to rHndlA0_ResCD0.
;;;   01/18/89 MAC  updated !SetMCEntries & !TENew from MACTOOLBOX-1-19 and
;;;                 MACTOOLBOX-1-26.  MACTOOLBOX-1-26 appears to undo 1-19 for
;;;                 !SetMCEntries and to duplicate 1-19 for !TENew. (?)
;;;   01/31/89 BJ   Added Async device and file manager traps.
;;; ************************************************************************

(defvar *trap-table*
	'(
          (#xA000 
          nil 
          nil 
     		    rResultCodeInD0 
				(
     		    ioParamInA0
				) 
				"!Open")


          (#xA001 
          nil 
          nil 
     		    rResultCodeInD0 
				(
     		    ioParamInA0
				) 
				"!Close")

     	  
          (#xA002 
          nil 
          nil 
     		    rResultCodeInD0 
				(
     		    ioParamInA0
				) 
				"!Read")

     	  
          (#xA003 
          nil 
          nil 
     		    rResultCodeInD0 
				(
     		    ioParamInA0
				) 
				"!Write")

     	  
          (#xA004 
          nil 
          nil 
     		    rResultCodeInD0 
				(
     		    ioParamInA0
				) 
				"!Control")

     	  
          (#xA005 
          nil 
          nil 
     		    rResultCodeInD0 
				(
     		    ioParamInA0
				) 
				"!Status")

     	  
          (#xA006 
          nil 
          nil 
     		    rResultCodeInD0 
				(
     		    ioParamInA0
				) 
				"!KillIO")

     	  
          (#xA007 
          nil 
          nil 
     		    rResultCodeInD0 
				(
     		    ioParamInA0
				) 
				"!GetVolInfo")

     	  
          (#xA008 
          nil 
          nil 
     		    rResultCodeInD0 
				(
     		    ioParamInA0
				) 
				"!Create")

     	  
          (#xA009 
          nil 
          nil 
     		    rResultCodeInD0 
				(
     		    ioParamInA0
				) 
				"!Delete")

     	  
          (#xA00A 
          nil 
          nil 
     		    rResultCodeInD0 
				(
     		    ioParamInA0
				) 
				"!OpenRF")

     	  
          (#xA00B 
          nil 
          nil 
     		    rResultCodeInD0 
				(
     		    ioParamInA0
				) 
				"!ReName")

     	  
          (#xA00C 
          nil 
          nil 
     		    rResultCodeInD0 
				(
     		    ioParamInA0
				) 
				"!GetFileInfo")

     	  
          (#xA00D 
          nil 
          nil 
     		    rResultCodeInD0 
				(
     		    ioParamInA0
				) 
				"!SetFileInfo")

     	  
          (#xA00E 
          nil 
          nil 
     		    rResultCodeInD0 
				(
     		    ioParamInA0
				) 
				"!UnMountVol")

     	  
          (#xA00F 
          nil 
          nil 
     		    rResultCodeInD0 
				(
     		    ioParamInA0
				) 
				"!MountVol")

     	  
          (#xA010 
          nil 
          nil 
     		    rResultCodeInD0 
				(
     		    ioParamInA0
				) 
				"!Allocate")

     	  
          (#xA011 
          nil 
          nil 
     		    rResultCodeInD0 
				(
     		    ioParamInA0
				) 
				"!GetEOF")

     	  
          (#xA012 
          nil 
          nil 
     		    rResultCodeInD0 
				(
     		    ioParamInA0
				) 
				"!SetEOF")

     	  
          (#xA013 
          nil 
          nil 
     		    rResultCodeInD0 
				(
     		    ioParamInA0
				) 
				"!FlushVol")

     	  
          (#xA014 
          nil 
          nil 
     		    rResultCodeInD0 
				(
     		    ioParamInA0
				) 
				"!GetVol")

     	  
          (#xA015 
          nil 
          nil 
     		    rResultCodeInD0 
				(
     		    ioParamInA0
				) 
				"!SetVol")

     	  
          (#xA016 
          nil 
          nil 
     		    rResultCodeInD0 
				(
				) 
				"!InitQueue")

     	  
          (#xA017 
          nil 
          nil 
     		    rResultCodeInD0 
				(
     		    ioParamInA0
				) 
				"!Eject")

     	  
          (#xA018 
          nil 
          nil 
     		    rResultCodeInD0 
				(
     		    ioParamInA0
				) 
				"!GetFPos")

     	  
          (#xA019 
          nil 
          nil 
     		    rResultCodeInD0 
				(
     		    PtrInA0
				) 
				"!InitZone")

     	  
          (#xA11A 
          nil 
          nil 
     		    rPtrA0_resCD0 
				(
				) 
				"!GetZone")

     	  
          (#xA01B 
          nil 
          nil 
     		    rResultCodeInD0 
				(
     		    PtrInA0
				) 
				"!SetZone")

     	  
          (#xA01C 
          nil 
          nil 
     		    rLongInD0 
				(
				) 
				"!FreeMem")

     	  
          (#xA01D 
          nil 
          nil 
     		    rLongA0_LongD0 
				(
				) 
				"!MaxMem")

     	  
          (#xA31E 
          nil 
          nil 
     		    rPtrA0_resCD0 
				(
     		    LongInD0
				) 
				"!NewPtr")

     	  
          (#xA01F 
          nil 
          nil 
     		    rResultCodeInD0 
				(
     		    PtrInA0
				) 
				"!DisposPtr")

     	  
          (#xA020 
          nil 
          nil 
     		    rResultCodeInD0 
				(
     		    PtrInA0 
     		    LongInD0
				) 
				"!SetPtrSize")

     	  
          (#xA021 
          nil 
          nil 
     		    rLongInD0 
				(
     		    PtrInA0
				) 
				"!GetPtrSize")

     	  
          (#xA322 
          nil 
          nil 
     		    rHndlA0_ResCD0 
				(
     		    LongInD0
				) 
				"!NewHandle")

     	  
          (#xA023 
          nil 
          nil 
     		    rResultCodeInD0 
				(
     		    macHndlInA0
				) 
				"!DisposHandle")

     	  
          (#xA024 
          nil 
          nil 
     		    rResultCodeInD0 
				(
     		    HndlInA0 
     		    LongInD0
     		    ) 
				"!SetHandleSize")

     	  
          (#xA025 
          nil 
          nil 
     		    rLongInD0 
				(
     		    HndlInA0
				) 
				"!GetHandleSize")

     	  
          (#xA126 
          nil 
          nil 
     		    rPtrA0_resCD0 
				(
     		    HndlInA0
				) 
				"!HandleZone")

     	  
          (#xA127 
          nil 
          nil 
     		    rResultCodeInD0 
				(
     		    macHndlInA0 
     		    LongInD0
     		    ) 
				"!ReAllocHandle")

     	  
          (#xA128 
          nil 
          nil 
     		    rMacHndlInA0 
				(
     		    PtrInA0
				) 
				"!RecoverHandle")

     	  
          (#xA029 
          nil 
          nil 
     		    rResultCodeInD0 
				(
     		    HndlInA0
				) 
				"!HLock")

     	  
          (#xA02A 
          nil 
          nil 
     		    rResultCodeInD0 
				(
     		    HndlInA0
				) 
				"!HUnLock")

     	  
          (#xA02B 
          nil 
          nil 
     		    rResultCodeInD0 
				(
     		    macHndlInA0
				) 
				"!EmptyHandle")

     	  
          (#xA02D 
          nil 
          nil 
     		    rResultCodeInD0 
				(
     		    PtrInA0
				) 
				"!SetApplLimit")

     	  
          (#xA02E 
          nil 
          nil 
     		    rResultCodeInD0 
				(
     		    PtrInA0 
     		    PtrInA1 
     		    LongInD0
				) 
				"!BlockMove")

     	  
          (#xA02F 
          nil 
          nil 
     		    rResultCodeInD0 
				(
     		    IntInA0 
     		    LongInD0
     		    ) 
				"!PostEvent")

     	  
          (#xA030 
          nil 
          nil 
     		    rResultCodeInD0 
				(
     		    PtrInA0 
     		    IntInD0
     		    ) 
				"!OSEventAvailInternal")

     	  
          (#xA031 
          nil 
          nil 
     		    rResultCodeInD0 
				(
     		    PtrInA0 
     		    IntInD0
     		    ) 
				"!GetOSEventInternal")

     	  
          (#xA032 
          nil 
          nil 
     		    rResultCodeInD0 
				(
     		    IntInD0 
     		    IntInMSW_D0
     		    ) 
				"!FlushEventsInternal")

     	  
          (#xA033 
          nil 
          nil 
     		    rResultCodeInD0 
				(
     		    PtrInA0
				) 
				"!VInstall")

     	  
          (#xA034 
          nil 
          nil 
     		    rResultCodeInD0 
				(
     		    PtrInA0
				) 
				"!VRemove")

     	  
          (#xA035 
          nil 
          nil 
     		    rResultCodeInD0 
				(
     		    ioParamInA0
				) 
				"!OffLine")

     	  
          (#xA036 
          nil 
          nil 
     		    rResultCodeInD0 
				(
     		    ) 
				"!MoreMasters")

     	  
          (#xA039 
          nil 
          nil 
     		    rResultCodeInD0 
				(
     		    PtrInA0
				) 
				"!ReadDateTime")

     	  
          (#xA03A 
          nil 
          nil 
     		    rResultCodeInD0 
				(
     		    LongInD0
				) 
				"!SetDateTime")

     	  
          (#xA03B 
          nil 
          nil 
     		    rLongInD0 
				(
     		    LongInA0
				) 
				"!Delay")

     	  
          (#xA03F 
          nil 
          nil 
     		    rResultCodeInD0 
				(
     		    ) 
				"!InitUtil")

     	  
          (#xA040 
          nil 
          nil 
     		    rResultCodeInD0 
				(
     		    LongInD0
				) 
				"!ResrvMem")

     	  
          (#xA041 
          nil 
          nil 
     		    rResultCodeInD0 
				(
     		    ioParamInA0
				) 
				"!SetFilLock")

     	  
          (#xA042 
          nil 
          nil 
     		    rResultCodeInD0 
				(
     		    ioParamInA0
				) 
				"!RstFilLock")

     	  
          (#xA043 
          nil 
          nil 
     		    rResultCodeInD0 
				(
     		    ioParamInA0
				) 
				"!SetFilType")

     	  
          (#xA044 
          nil 
          nil 
     		    rResultCodeInD0 
				(
     		    ioParamInA0
				) 
				"!SetFPos")

     	  
          (#xA045 
          nil 
          nil 
     		    rResultCodeInD0 
				(
     		    ioParamInA0
				) 
				"!FlushFile")

     	  
          (#xA346 
          nil 
          nil 
     		    rPtrInA0 
				(
     		    IntInD0
				) 
				"!GetTrapAddress")

     	  
          (#xA347 
          nil 
          nil 
     		    rDontcare 
				(
     		    PtrInA0 
     		    IntInD0
     		    ) 
				"!SetTrapAddress")

     	  
          (#xA148 
          nil 
          nil 
     		    rPtrInA0 
				(
     		    PtrInA0
				) 
				"!PtrZone")

     	  
          (#xA049 
          nil 
          nil 
     		    rResultCodeInD0 
				(
     		    HndlInA0
				) 
				"!HPurge")

     	  
          (#xA04A 
          nil 
          nil 
     		    rResultCodeInD0 
				(
     		    HndlInA0
				) 
				"!HNoPurge")

     	  
          (#xA04B 
          nil 
          nil 
     		    rResultCodeInD0 
				(
     		    PtrInA0
				) 
				"!SetGrowZone")

     	  
          (#xA04C 
          nil 
          nil 
     		    rLongInD0 
				(
     		    LongInD0
				) 
				"!CompactMem")

     	  
          (#xA04D 
          nil 
          nil 
     		    rResultCodeInD0 
				(
     		    LongInD0
				) 
				"!PurgeMem")

     	  
          (#xA850 
          nil 
          nil 
     		    rDontcare 
				(
     		    ) 
				"!InitCursor")

     	  
          (#xA851 
          nil 
          nil 
     		    rDontcare 
				(
     		    Cursortype
				) 
				"!SetCursor")

     	  
          (#xA852 
          nil 
          nil 
     		    rDontcare 
				(
     		    ) 
				"!HideCursor")

     	  
          (#xA853 
          nil 
          nil 
     		    rDontcare 
				(
     		    ) 
				"!ShowCursor")

     	  
          (#xA855 
          nil 
          nil 
     		    rDontcare 
				(
     		    Recttype 
     		    Pttype
     		    ) 
				"!ShieldCursor")

     	  
          (#xA856 
          nil 
          nil 
     		    rDontcare 
				(
     		    ) 
				"!ObscureCursor")

     	  
          (#xA057 
          nil 
          nil 
     		    rResultCodeInD0 
				(
     		    PtrInA0
				) 
				"!SetApplBase")

     	  
          (#xA858 
          nil 
          nil 
     		    rlngInttype 
				(
     		    lngInttype 
     		    lngInttype
     		    ) 
				"!BitAnd")

     	  
          (#xA859 
          nil 
          nil 
     		    rlngInttype 
				(
     		    lngInttype 
     		    lngInttype
     		    ) 
				"!BitXOr")

     	  
          (#xA85A 
          nil 
          nil 
     		    rlngInttype 
				(
     		    lngInttypE
				) 
				"!BitNot")

     	  
          (#xA85B 
          nil 
          nil 
     		    rlngInttype 
				(
     		    lngInttype 
     		    lngInttype
     		    ) 
				"!BitOr")

     	  
          (#xA85C 
          nil 
          nil 
     		    rlngInttype 
				(
     		    lngInttype 
     		    inttype
     		    ) 
				"!BitShift")

     	  
          (#xA85D 
          nil 
          nil 
     		    rBooltype 
				(
     		    ptrtype 
     		    lngInttype
     		    ) 
				"!BitTst")

     	  
          (#xA85E 
          nil 
          nil 
     		    rDontcare 
				(
     		    ptrtype 
     		    lngInttype
     		    ) 
				"!BitSet")

     	  
          (#xA85F 
          nil 
          nil 
     		    rDontcare 
				(
     		    ptrtype 
     		    lngInttype
     		    ) 
				"!BitClr")

     	  
          (#xA861 
          nil 
          nil 
     		    rinttype 
				(
     		    ) 
				"!Random")

     	  
          (#xA862 
          nil 
          nil 
     		    rDontcare 
				(
     		    lngInttypE
				) 
				"!ForeColor")

     	  
          (#xA863 
          nil 
          nil 
     		    rDontcare 
				(
     		    lngInttypE
				) 
				"!BackColor")

     	  
          (#xA864 
          nil 
          nil 
     		    rDontcare 
				(
     		    inttypE
				) 
				"!ColorBit")

     	  
          (#xA865 
          nil 
          nil 
     		    rBooltype 
				(
     		    inttype 
     		    inttype
     		    ) 
				"!GetPixel")

     	  
          (#xA866 
          nil 
          nil 
     		    rDontcare 
				(
     		    ptrtype 
     		    Strtype
     		    ) 
				"!StuffHex")

     	  
          (#xA867 
          nil 
          nil 
     		    rDontcare 
				(
     		    lngInttype 
     		    lngInttype 
     		    VInt64BittypE
				) 
				"!LongMul")

     	  
          (#xA868 
          nil 
          nil 
     		    rLngInttype 
				(
     		    lngInttype 
     		    lngInttype
     		    ) 
				"!FixMul")

     	  
          (#xA869 
          nil 
          nil 
     		    rLngInttype 
				(
     		    inttype 
     		    inttype
     		    ) 
				"!FixRatio")

     	  
          (#xA86A 
          nil 
          nil 
     		    rinttype 
				(
     		    lngInttypE
				) 
				"!HiWord")

     	  
          (#xA86B 
          nil 
          nil 
     		    rinttype 
				(
     		    lngInttypE
				) 
				"!LoWord")

     	  
          (#xA86C 
          nil 
          nil 
     		    rinttype 
				(
     		    lngInttypE
				) 
				"!FixRound")

     	  
          (#xA86D 
          nil 
          nil 
     		    rDontcare 
				(
     		    GrafPorttypE
				) 
				"!InitPort")

     	  
          (#xA86E 
          nil 
          nil 
     		    rDontcare 
				(
     		    ptrtypE
				) 
				"!InitGraf")

     	  
          (#xA86F 
          nil 
          nil 
     		    rDontcare 
				(
     		    GrafPorttypE
				) 
				"!OpenPort")

     	  
          (#xA870 
          nil 
          nil 
     		    rDontcare 
				(
     		    VPttypE
				) 
				"!LocalToGlobal")

     	  
          (#xA871 
          nil 
          nil 
     		    rDontcare 
				(
     		    VPttypE
				) 
				"!GlobalToLocal")

     	  
          (#xA872 
          nil 
          nil 
     		    rDontcare 
				(
     		    InttypE
				) 
				"!GrafDevice")

     	  
          (#xA873 
          nil 
          nil 
     		    rDontcare 
				(
     		    GrafPorttypE
				) 
				"!SetPort")

     	  
          (#xA874 
          nil 
          nil 
     		    rDontcare 
				(
     		    VptrtypE
				) 
				"!GetPort")

     	  
          (#xA875 
          nil 
          nil 
     		    rDontcare 
				(
     		    BitMaptypE
				) 
				"!SetPortBits")

     	  
          (#xA876 
          nil 
          nil 
     		    rDontcare 
				(
     		    inttype 
     		    inttype
     		    ) 
				"!PortSize")

     	  
          (#xA877 
          nil 
          nil 
     		    rDontcare 
				(
     		    inttype 
     		    inttype
     		    ) 
				"!MovePortTo")

     	  
          (#xA878 
          nil 
          nil 
     		    rDontcare 
				(
     		    inttype 
     		    inttype
     		    ) 
				"!SetOrigin")

     	  
          (#xA879 
          nil 
          nil 
     		    rDontcare 
				(
     		    RgntypE
				) 
				"!SetClip")

     	  
          (#xA87A 
          nil 
          nil 
     		    rDontcare 
				(
     		    RgntypE
				) 
				"!GetClip")

     	  
          (#xA87B 
          nil 
          nil 
     		    rDontcare 
				(
     		    RecttypE
				) 
				"!ClipRect")

     	  
          (#xA87C 
          nil 
          nil 
     		    rDontcare 
				(
     		    PatterntypE
				) 
				"!BackPat")

     	  
          (#xA87D 
          nil 
          nil 
     		    rDontcare 
				(
     		    GrafPorttypE
				) 
				"!ClosePort")

     	  
          (#xA87E 
          nil 
          nil 
     		    rDontcare 
				(
     		    Pttype 
     		    VPttype
     		    ) 
				"!AddPt")

     	  
          (#xA87F 
          nil 
          nil 
     		    rDontcare 
				(
     		    Pttype 
     		    VPttype
     		    ) 
				"!SubPt")

     	  
          (#xA880 
          nil 
          nil 
     		    rDontcare 
				(
     		    VPttype 
     		    inttype 
     		    inttypE
				) 
				"!SetPt")

     	  
          (#xA881 
          nil 
          nil 
     		    rBooltype 
				(
     		    Pttype 
     		    Pttype
     		    ) 
				"!EqualPt")

     	  
          (#xA882 
          nil 
          nil 
     		    rDontcare 
				(
     		    Inttype 
     		    ptrtype 
     		    Pttype 
     		    Pttype
     		    ) 
				"!StdText")

     	  
          (#xA883 
          nil 
          nil 
     		    rDontcare 
				(
     		    chartypE
				) 
				"!DrawChar")

     	  
          (#xA884 
          nil 
          nil 
     		    rDontcare 
				(
     		    StrtypE
				) 
				"!DrawString")

     	  
          (#xA885 
          nil 
          nil 
     		    rDontcare 
				(
     		    ptrtype 
     		    inttype 
     		    inttypE
				) 
				"!DrawText")

     	  
          (#xA886 
          nil 
          nil 
     		    rInttype 
				(
     		    ptrtype 
     		    inttype 
     		    inttypE
				) 
				"!TextWidth")

     	  
          (#xA887 
          nil 
          nil 
     		    rDontcare 
				(
     		    inttypE
				) 
				"!TextFont")

     	  
          (#xA888 
          nil 
          nil 
     		    rDontcare 
				(
     		    inttypE
				) 
				"!TextFace")

     	  
          (#xA889 
          nil 
          nil 
     		    rDontcare 
				(
     		    inttypE
				) 
				"!TextMode")

     	  
          (#xA88A 
          nil 
          nil 
     		    rDontcare 
				(
     		    inttypE
				) 
				"!TextSize")

     	  
          (#xA88B 
          nil 
          nil 
     		    rDontcare 
				(
     		    VFontInfotype
				) 
				"!GetFontInfo")

     	  
          (#xA88C 
          nil 
          nil 
     		    rInttype 
				(
     		    StrtypE
				) 
				"!StringWidth")

     	  
          (#xA88D 
          nil 
          nil 
     		    rInttype 
				(
     		    chartypE
				) 
				"!CharWidth")

     	  
          (#xA88E 
          nil 
          nil 
     		    rDontcare 
				(
     		    lngInttypE
				) 
				"!SpaceExtra")

     	  
          (#xA890 
          nil 
          nil 
     		    rDontcare 
				(
     		    PttypE
				) 
				"!StdLine")

     	  
          (#xA891 
          nil 
          nil 
     		    rDontcare 
				(
     		    inttype 
     		    inttype
     		    ) 
				"!LineTo")

     	  
          (#xA892 
          nil 
          nil 
     		    rDontcare 
				(
     		    inttype 
     		    inttype
     		    ) 
				"!Line")

     	  
          (#xA893 
          nil 
          nil 
     		    rDontcare 
				(
     		    inttype 
     		    inttype
     		    ) 
				"!MoveTo")

     	  
          (#xA894 
          nil 
          nil 
     		    rDontcare 
				(
     		    inttype 
     		    inttype
     		    ) 
				"!Move")

     	  
          (#xA896 
          nil 
          nil 
     		    rDontcare 
				(
     		    ) 
				"!HidePen")

     	  
          (#xA897 
          nil 
          nil 
     		    rDontcare 
				(
     		    ) 
				"!ShowPen")

     	  
          (#xA898 
          nil 
          nil 
     		    rDontcare 
				(
     		    VPenStatetypE
				) 
				"!GetPenState")

     	  
          (#xA899 
          nil 
          nil 
     		    rDontcare 
				(
     		    PenStatetypE
				) 
				"!SetPenState")

     	  
          (#xA89A 
          nil 
          nil 
     		    rDontcare 
				(
     		    VPttypE
				) 
				"!GetPen")

     	  
          (#xA89B 
          nil 
          nil 
     		    rDontcare 
				(
     		    inttype 
     		    inttype
     		    ) 
				"!PenSize")

     	  
          (#xA89C 
          nil 
          nil 
     		    rDontcare 
				(
     		    inttypE
				) 
				"!PenMode")

     	  
          (#xA89D 
          nil 
          nil 
     		    rDontcare 
				(
     		    PatterntypE
				) 
				"!PenPat")

     	  
          (#xA89E 
          nil 
          nil 
     		    rDontcare 
				(
     		    ) 
				"!PenNormal")

     	  
          (#xA8A0 
          nil 
          nil 
     		    rDontcare 
				(
     		    inttype 
     		    Recttype
     		    ) 
				"!StdRect")

     	  
          (#xA8A1 
          nil 
          nil 
     		    rDontcare 
				(
     		    RecttypE
				) 
				"!FrameRect")

     	  
          (#xA8A2 
          nil 
          nil 
     		    rDontcare 
				(
     		    RecttypE
				) 
				"!PaintRect")

     	  
          (#xA8A3 
          nil 
          nil 
     		    rDontcare 
				(
     		    RecttypE
				) 
				"!EraseRect")

     	  
          (#xA8A4 
          nil 
          nil 
     		    rDontcare 
				(
     		    RecttypE
				) 
				"!InvertRect")

     	  
          (#xA8A5 
          nil 
          nil 
     		    rDontcare 
				(
     		    Recttype 
     		    Patterntype
     		    ) 
				"!FillRect")

     	  
          (#xA8A6 
          nil 
          nil 
     		    rBooltype 
				(
     		    Recttype 
     		    Recttype
     		    ) 
				"!EqualRect")

     	  
          (#xA8A7 
          nil 
          nil 
     		    rDontcare 
				(
     		    VRecttype 
     		    inttype 
     		    inttype 
     		    inttype 
     		    inttypE
				) 
				"!SetRect")

     	  
          (#xA8A8 
          nil 
          nil 
     		    rDontcare 
				(
     		    VRecttype 
     		    inttype 
     		    inttypE
				) 
				"!OffSetRect")

     	  
          (#xA8A9 
          nil 
          nil 
     		    rDontcare 
				(
     		    VRecttype 
     		    inttype 
     		    inttypE
				) 
				"!InSetRect")

     	  
          (#xA8AA 
          nil 
          nil 
     		    rBooltype 
				(
     		    Recttype 
     		    Recttype 
     		    VRecttypE
				) 
				"!SectRect")

     	  
          (#xA8AB 
          nil 
          nil 
     		    rDontcare 
				(
     		    Recttype 
     		    Recttype 
     		    VRecttypE
				) 
				"!UnionRect")

     	  
          (#xA8AC 
          nil 
          nil 
     		    rDontcare 
				(
     		    Pttype 
     		    Pttype 
     		    VRecttype
				) 
				"!Pt2Rect")

     	  
          (#xA8AD 
          nil 
          nil 
     		    rBooltype 
				(
     		    Pttype 
     		    Recttype
     		    ) 
				"!PtInRect")

     	  
          (#xA8AE 
          nil 
          nil 
     		    rBooltype 
				(
     		    Recttype
				) 
				"!EmptyRect")

     	  
          (#xA8AF 
          nil 
          nil 
     		    rDontcare 
				(
     		    inttype 
     		    Recttype 
     		    inttype 
     		    inttype
     		    ) 
				"!StdRRect")

     	  
          (#xA8B0 
          nil 
          nil 
     		    rDontcare 
				(
     		    Recttype 
     		    inttype 
     		    inttype
				) 
				"!FrameRoundRect")

     	  
          (#xA8B1 
          nil 
          nil 
     		    rDontcare 
				(
     		    Recttype 
     		    inttype 
     		    inttype
				) 
				"!PaintRoundRect")

     	  
          (#xA8B2 
          nil 
          nil 
     		    rDontcare 
				(
     		    Recttype 
     		    inttype 
     		    inttype
				) 
				"!EraseRoundRect")

     	  
          (#xA8B3 
          nil 
          nil 
     		    rDontcare 
				(
     		    Recttype 
     		    inttype 
     		    inttype
				) 
				"!InvertRoundRect")

     	  
          (#xA8B4 
          nil 
          nil 
     		    rDontcare 
				(
     		    Recttype 
     		    inttype 
     		    inttype 
     		    Patterntype
     		    ) 
				"!FillRoundRect")

     	  
          (#xA8B6 
          nil 
          nil 
     		    rDontcare 
				(
     		    inttype 
     		    Recttype
     		    ) 
				"!StdOval")

     	  
          (#xA8B7 
          nil 
          nil 
     		    rDontcare 
				(
     		    Recttype
				) 
				"!FrameOval")

     	  
          (#xA8B8 
          nil 
          nil 
     		    rDontcare 
				(
     		    Recttype
				) 
				"!PaintOval")

     	  
          (#xA8B9 
          nil 
          nil 
     		    rDontcare 
				(
     		    Recttype
				) 
				"!EraseOval")

     	  
          (#xA8BA 
          nil 
          nil 
     		    rDontcare 
				(
     		    Recttype
				) 
				"!InvertOval")

     	  
          (#xA8BB 
          nil 
          nil 
     		    rDontcare 
				(
     		    Recttype 
     		    Patterntype
     		    ) 
				"!FillOval")

     	  
          (#xA8BC 
          nil 
          nil 
     		    rlngInttype 
				(
     		    inttype
				) 
				"!SlopeFromAngle")

     	  
          (#xA8BD 
          nil 
          nil 
     		    rDontcare 
				(
     		    inttype 
     		    Recttype 
     		    inttype 
     		    inttype
     		    ) 
				"!StdArc")

     	  
          (#xA8BE 
          nil 
          nil 
     		    rDontcare 
				(
     		    Recttype 
     		    inttype 
     		    inttype
				) 
				"!FrameArc")

     	  
          (#xA8BF 
          nil 
          nil 
     		    rDontcare 
				(
     		    Recttype 
     		    inttype 
     		    inttype
				) 
				"!PaintArc")

     	  
          (#xA8C0 
          nil 
          nil 
     		    rDontcare 
				(
     		    Recttype 
     		    inttype 
     		    inttype
				) 
				"!EraseArc")

     	  
          (#xA8C1 
          nil 
          nil 
     		    rDontcare 
				(
     		    Recttype 
     		    inttype 
     		    inttype
				) 
				"!InvertArc")

     	  
          (#xA8C2 
          nil 
          nil 
     		    rDontcare 
				(
     		    Recttype 
     		    inttype 
     		    inttype 
     		    Patterntype
     		    ) 
				"!FillArc")

     	  
          (#xA8C3 
          nil 
          nil 
     		    rDontcare 
				(
     		    Recttype 
     		    Pttype 
     		    Vinttype
				) 
				"!PtToAngle")

     	  
          (#xA8C4 
          nil 
          nil 
     		    rInttype 
				(
     		    lngInttype
				) 
				"!AngleFromSlope")

     	  
          (#xA8C5 
          nil 
          nil 
     		    rDontcare 
				(
     		    inttype 
     		    Polytype
     		    ) 
				"!StdPoly")

     	  
          (#xA8C6 
          nil 
          nil 
     		    rDontcare 
				(
     		    Polytype
				) 
				"!FramePoly")

     	  
          (#xA8C7 
          nil 
          nil 
     		    rDontcare 
				(
     		    Polytype
				) 
				"!PaintPoly")

     	  
          (#xA8C8 
          nil 
          nil 
     		    rDontcare 
				(
     		    Polytype
				) 
				"!ErasePoly")

     	  
          (#xA8C9 
          nil 
          nil 
     		    rDontcare 
				(
     		    Polytype
				) 
				"!InvertPoly")

     	  
          (#xA8CA 
          nil 
          nil 
     		    rDontcare 
				(
     		    Polytype 
     		    Patterntype
     		    ) 
				"!FillPoly")

     	  
          (#xA8CB 
          nil 
          nil 
     		    rhndltype 
				(
     		    ) 
				"!OpenPoly")

     	  
          (#xA8CC 
          nil 
          nil 
     		    rDontcare 
				(
     		    ) 
				"!ClosePoly")

     	  
          (#xA8CD 
          nil 
          nil 
     		    rDontcare 
				(
     		    Polytype
				) 
				"!KillPoly")

     	  
          (#xA8CE 
          nil 
          nil 
     		    rDontcare 
				(
     		    Polytype 
     		    inttype 
     		    inttype
				) 
				"!OffSetPoly")

     	  
          (#xA8CF 
          nil 
          nil 
     		    rDontcare 
				(
     		    Vptrtype 
     		    Vptrtype 
     		    inttype
				) 
				"!PackBits")

     	  
          (#xA8D0 
          nil 
          nil 
     		    rDontcare 
				(
     		    Vptrtype 
     		    Vptrtype 
     		    inttype
				) 
				"!UnpackBits")

     	  
          (#xA8D1 
          nil 
          nil 
     		    rDontcare 
				(
     		    inttype 
     		    Rgntype
     		    ) 
				"!StdRgn")

     	  
          (#xA8D2 
          nil 
          nil 
     		    rDontcare 
				(
     		    Rgntype
				) 
				"!FrameRgn")

     	  
          (#xA8D3 
          nil 
          nil 
     		    rDontcare 
				(
     		    Rgntype
				) 
				"!PaintRgn")

     	  
          (#xA8D4 
          nil 
          nil 
     		    rDontcare 
				(
     		    Rgntype
				) 
				"!EraseRgn")

     	  
          (#xA8D5 
          nil 
          nil 
     		    rDontcare 
				(
     		    Rgntype
				) 
				"!InvertRgn")

     	  
          (#xA8D6 
          nil 
          nil 
     		    rDontcare 
				(
     		    Rgntype 
     		    Patterntype
     		    ) 
				"!FillRgn")

     	  
          (#xA8D8 
          nil 
          nil 
     		    rhndltype 
				(
     		    ) 
				"!NewRgn")

     	  
          (#xA8D9 
          nil 
          nil 
     		    rDontcare 
				(
     		    Rgntype
				) 
				"!DisposeRgn")

     	  
          (#xA8DA 
          nil 
          nil 
     		    rDontcare 
				(
     		    ) 
				"!OpenRgn")

     	  
          (#xA8DB 
          nil 
          nil 
     		    rDontcare 
				(
     		    Rgntype
				) 
				"!CloseRgn")

     	  
          (#xA8DC 
          nil 
          nil 
     		    rDontcare 
				(
     		    Rgntype 
     		    Rgntype
     		    ) 
				"!CopyRgn")

     	  
          (#xA8DD 
          nil 
          nil 
     		    rDontcare 
				(
     		    Rgntype
				) 
				"!SetEmptyRgn")

     	  
          (#xA8DE 
          nil 
          nil 
     		    rDontcare 
				(
     		    Rgntype 
     		    inttype 
     		    inttype 
     		    inttype 
     		    inttype
				) 
				"!SetRectRgn")

     	  
          (#xA8DF 
          nil 
          nil 
     		    rDontcare 
				(
     		    Rgntype 
     		    Recttype
     		    ) 
				"!RectRgn")

     	  
          (#xA8E0 
          nil 
          nil 
     		    rDontcare 
				(
     		    Rgntype 
     		    inttype 
     		    inttype
				) 
				"!OffSetRgn")

     	  
          (#xA8E1 
          nil 
          nil 
     		    rDontcare 
				(
     		    Rgntype 
     		    inttype 
     		    inttype
				) 
				"!InSetRgn")

     	  
          (#xA8E2 
          nil 
          nil 
     		    rBooltype 
				(
     		    Rgntype
				) 
				"!EmptyRgn")

     	  
          (#xA8E3 
          nil 
          nil 
     		    rBooltype 
				(
     		    Rgntype 
     		    Rgntype
     		    ) 
				"!EqualRgn")

     	  
          (#xA8E4 
          nil 
          nil 
     		    rDontcare 
				(
     		    Rgntype 
     		    Rgntype 
     		    Rgntype
				) 
				"!SectRgn")

     	  
          (#xA8E5 
          nil 
          nil 
     		    rDontcare 
				(
     		    Rgntype 
     		    Rgntype 
     		    Rgntype
				) 
				"!UnionRgn")

     	  
          (#xA8E6 
          nil 
          nil 
     		    rDontcare 
				(
     		    Rgntype 
     		    Rgntype 
     		    Rgntype
				) 
				"!DiffRgn")

     	  
          (#xA8E7 
          nil 
          nil 
     		    rDontcare 
				(
     		    Rgntype 
     		    Rgntype 
     		    Rgntype
				) 
				"!XOrRgn")

     	  
          (#xA8E8 
          nil 
          nil 
     		    rBooltype 
				(
     		    Pttype 
     		    Rgntype
     		    ) 
				"!PtInRgn")

     	  
          (#xA8E9 
          nil 
          nil 
     		    rBooltype 
				(
     		    Recttype 
     		    Rgntype
     		    ) 
				"!RectInRgn")

     	  
          (#xA8EA 
          nil 
          nil 
     		    rDontcare 
				(
     		    ptrtype
				) 
				"!SetStdProcs")

     	  
          (#xA8EB 
          nil 
          nil 
     		    rDontcare 
				(
     		    Bitmaptype			       ;***---***
     		    VRecttype 
     		    VRecttype 
     		    inttype 
     		    Rgntype
				) 
				"!StdBits")

     	  
          (#xA8EC 
          nil 
          nil 
     		    rDontcare 
				(
     		    Bitmaptype 
     		    Bitmaptype 
     		    Recttype 
     		    Recttype 
     		    inttype 
     		    Rgntype
     		    ) 
				"!CopyBits")

     	  
          (#xA8ED 
          nil 
          nil 
     		    rInttype 
				(
     		    inttype 
     		    ptrtype 
     		    VPttype 
     		    VPttype 
     		    VFontInfoType
				) 
				"!StdTxMeas")

     	  
          (#xA8EE 
          nil 
          nil 
     		    rDontcare 
				(
     		    ptrtype 
     		    inttype
     		    ) 
				"!StdGetPic")

     	  
          (#xA8EF 
          nil 
          nil 
     		    rDontcare 
				(
     		    Recttype 
     		    inttype 
     		    inttype 
     		    Rgntype
     		    ) 
				"!ScrollRect")

     	  
          (#xA8F0 
          nil 
          nil 
     		    rDontcare 
				(
     		    ptrtype 
     		    inttype
     		    ) 
				"!StdPutPic")

     	  
          (#xA8F1 
          nil 
          nil 
     		    rDontcare 
				(
     		    inttype 
     		    inttype 
     		    hndltype
				) 
				"!StdComment")

     	  
          (#xA8F2 
          nil 
          nil 
     		    rDontcare 
				(
     		    inttype 
     		    inttype 
     		    hndltype
				) 
				"!PicComment")

     	  
          (#xA8F3 
          nil 
          nil 
     		    rHndltype 
				(
     		    Recttype
				) 
				"!OpenPicture")

     	  
          (#xA8F4 
          nil 
          nil 
     		    rDontcare 
				(
     		    ) 
				"!ClosePicture")

     	  
          (#xA8F5 
          nil 
          nil 
     		    rDontcare 
				(
     		    Picttype
				) 
				"!KillPicture")

     	  
          (#xA8F6 
          nil 
          nil 
     		    rDontcare 
				(
     		    Picttype 
     		    Recttype
     		    ) 
				"!DrawPicture")

     	  
          (#xA8F8 
          nil 
          nil 
     		    rDontcare 
				(
     		    VPttype 
     		    Recttype 
     		    Recttype
				) 
				"!ScalePt")

     	  
          (#xA8F9 
          nil 
          nil 
     		    rDontcare 
				(
     		    VPttype 
     		    Recttype 
     		    Recttype
				) 
				"!MapPt")

     	  
          (#xA8FA 
          nil 
          nil 
     		    rDontcare 
				(
     		    VRecttype 
     		    Recttype 
     		    Recttype
				) 
				"!MapRect")

     	  
          (#xA8FB 
          nil 
          nil 
     		    rDontcare 
				(
     		    Rgntype 
     		    Recttype 
     		    Recttype
				) 
				"!MapRgn")

     	  
          (#xA8FC 
          nil 
          nil 
     		    rDontcare 
				(
     		    Polytype 
     		    Recttype 
     		    Recttype
				) 
				"!MapPoly")

     	  
          (#xA8FE 
          nil 
          nil 
     		    rDontcare 
				(
     		    ) 
				"!InitFonts")

     	  
          (#xA8FF 
          nil 
          nil 
     		    rDontcare 
				(
     		    inttype 
     		    VStrtype
     		    ) 
				"!GetFontName")

     	  

          (#xA900 
          nil 
          nil 
     		    rDontcare 
				(
     		    Strtype 
     		    VInttype
     		    ) 
				"!GetFNum")

     	  
          (#xA901 
          nil 
          nil 
     		    rPtrtype 
				(
     		    hndlptrtype     ; ***---*** rwr 8/26/88
				) 
				"!FMSwapFont")


          (#xA902 
          nil 
          nil 
     		    rBooltype 
				(
     		    inttype 
     		    inttype
     		    ) 
				"!RealFont")

     	  
          (#xA903 
          nil 
          nil 
     		    rDontcare 
				(
     		    Booltype
				) 
				"!SetFontLock")

     	  
          (#xA904 
          nil 
          nil 
     		    rDontcare 
				(
     		    WindowRectype
				) 
				"!DrawGrowIcon")

     	  
          (#xA905 
          nil 
          nil 
     		    rMVInttype 
				(
     		    Rgntype 
     		    Pttype 
     		    Recttype 
     		    Recttype 
     		    inttype 
     		    ptrtype
     		    ) 
				"!DragGrayRgn")

     	  
          (#xA906 
          nil 
          nil 
     		    rHndltype 
				(
     		    Strtype
				) 
				"!NewString")

     	  
          (#xA907 
          nil 
          nil 
     		    rDontcare 
				(
     		    hndltype 
     		    Strtype
     		    ) 
				"!SetString")

     	  
          (#xA908 
          nil 
          nil 
     		    rDontcare 
				(
     		    ptrtype 
     		    Booltype
     		    ) 
				"!ShowHide")

     	  
          (#xA909 
          nil 
          nil 
     		    rDontcare 
				(
     		    ptrtype
				) 
				"!CalcVis")

     	  
          (#xA90A 
          nil 
          nil 
     		    rDontcare 
				(
     		    ptrtype 
     		    Rgntype
     		    ) 
				"!CalcVisBehind")      ;***---***

     	  
          (#xA90B 
          nil 
          nil 
     		    rDontcare 
				(
     		    ptrtype
				) 
				"!ClipAbove")

     	  
          (#xA90C 
          nil 
          nil 
     		    rDontcare 
				(
     		    ptrtype 
     		    Rgntype
     		    ) 
				"!PaintOne")

     	  
          (#xA90D 
          nil 
          nil 
     		    rDontcare 
				(
     		    ptrtype 
     		    Rgntype
     		    ) 
				"!PaintBehind")

     	  
          (#xA90E 
          nil 
          nil 
     		    rDontcare 
				(
     		    ptrtype
				) 
				"!SaveOld")

     	  
          (#xA90F 
          nil 
          nil 
     		    rDontcare 
				(
     		    ptrtype 
     		    Booltype
     		    ) 
				"!DrawNew")

     	  
          (#xA910 
          nil 
          nil 
     		    rDontcare 
				(
     		    VPtrtype
				) 
				"!GetWMgrPort")

     	  
          (#xA911 
          nil 
          nil 
     		    rBooltype 
				(
     		    VEvtRectype
				) 
				"!CheckUpDate")

     	  
          (#xA912 
          nil 
          nil 
     		    rDontcare 
				(
     		    ) 
				"!InitWindows")

     	  
          (#xA913 
          nil 
          nil 
     		    rwindPtrtype 
				(
     		    ptrtype 
     		    Recttype 
     		    Strtype 
     		    Booltype 
     		    inttype 
     		    ptrtype 
     		    Booltype 
     		    lngInttype
     		    ) 
				"!NewWindow")

     	  
          (#xA914 
          nil 
          nil 
     		    rDontcare 
				(
     		    WindowRectype
				) 
				"!DisposeWindow")

     	  
          (#xA915 
          nil 
          nil 
     		    rDontcare 
				(
     		    WindowRectype
				) 
				"!ShowWindow")

     	  
          (#xA916 
          nil 
          nil 
     		    rDontcare 
				(
     		    WindowRectype
				) 
				"!HideWindow")

     	  
          (#xA917 
          nil 
          nil 
     		    rlngInttype 
				(
     		    WindowRectype
				) 
				"!GetWRefCon")

     	  
          (#xA918 
          nil 
          nil 
     		    rDontcare 
				(
     		    WindowRectype 
     		    lngInttype
     		    ) 
				"!SetWRefCon")

     	  
          (#xA919 
          nil 
          nil 
     		    rDontcare 
				(
     		    WindowRectype 
     		    VStrtype
     		    ) 
				"!GetWTitle")

     	  
          (#xA91A 
          nil 
          nil 
     		    rDontcare 
				(
     		    WindowRectype 
     		    Strtype
     		    ) 
				"!SetWTitle")

     	  
          (#xA91B 
          nil 
          nil 
     		    rDontcare 
				(
     		    WindowRectype 
     		    inttype 
     		    inttype 
     		    Booltype
     		    ) 
				"!MoveWindow")

     	  
          (#xA91C 
          nil 
          nil 
     		    rDontcare 
				(
     		    WindowRectype 
     		    Booltype
     		    ) 
				"!HiliteWindow")

     	  
          (#xA91D 
          nil 
          nil 
     		    rDontcare 
				(
     		    WindowRectype 
     		    inttype 
     		    inttype 
     		    Booltype
     		    ) 
				"!SizeWindow")

     	  
          (#xA91E 
          nil 
          nil 
     		    rBooltype 
				(
     		    WindowRectype 
     		    Pttype
     		    ) 
				"!TrackGoAway")

     	  
          (#xA91F 
          nil 
          nil 
     		    rDontcare 
				(
     		    WindowRectype
				) 
				"!SelectWindow")

     	  
          (#xA920 
          nil 
          nil 
     		    rDontcare 
				(
     		    WindowRectype
				) 
				"!BringToFront")

     	  
          (#xA921 
          nil 
          nil 
     		    rDontcare 
				(
     		    WindowRectype 
     		    ptrtype
     		    ) 
				"!SendBehind")

     	  
          (#xA922 
          nil 
          nil 
     		    rDontcare 
				(
     		    WindowRectype
				) 
				"!BeginUpDate")

     	  
          (#xA923 
          nil 
          nil 
     		    rDontcare 
				(
     		    WindowRectype
				) 
				"!EndUpDate")

     	  
          (#xA924 
          nil 
          nil 
     		    rwindPtrtype 
				(
     		    ) 
				"!FrontWindow")

     	  
          (#xA925 
          nil 
          nil 
     		    rDontcare 
				(
     		    WindowRectype 
     		    Pttype 
     		    Recttype
				) 
				"!DragWindow")

     	  
          (#xA927 
          nil 
          nil 
     		    rDontcare 
				(
     		    Rgntype
				) 
				"!InvalRgn")

     	  
          (#xA928 
          nil 
          nil 
     		    rDontcare 
				(
     		    Recttype
				) 
				"!InvalRect")

     	  
          (#xA929 
          nil 
          nil 
     		    rDontcare 
				(
     		    Rgntype
				) 
				"!ValidRgn")

     	  
          (#xA92A 
          nil 
          nil 
     		    rDontcare 
				(
     		    Recttype
				) 
				"!ValidRect")

     	  
          (#xA92B 
          nil 
          nil 
     		    rMVInttype 
				(
     		    WindowRectype 
     		    Pttype 
     		    Recttype
				) 
				"!GrowWindow")

     	  
          (#xA92C 
          nil 
          nil 
     		    rInttype 
				(
     		    Pttype 
     		    VWindPtrtype
     		    ) 
				"!FindWindow")

     	  
          (#xA92D 
          nil 
          nil 
     		    rDontcare 
				(
     		    WindowRectype
				) 
				"!CloseWindow")

     	  
          (#xA92E 
          nil 
          nil 
     		    rDontcare 
				(
     		    WindowRectype 
     		    Picttype
     		    ) 
				"!SetWindowPic")

     	  
          (#xA92F 
          nil 
          nil 
     		    rPicttype 
				(
     		    WindowRectype
				) 
				"!GetWindowPic")

     	  
          (#xA930 
          nil 
          nil 
     		    rDontcare 
				(
     		    ) 
				"!InitMenus")

     	  
          (#xA931 
          nil 
          nil 
     		    rhndltype 
				(
     		    inttype 
     		    Strtype
     		    ) 
				"!NewMenu")

     	  
          (#xA932 
          nil 
          nil 
     		    rDontcare 
				(
     		    menuHndletype
				) 
				"!DisposeMenu")

     	  
          (#xA933 
          nil 
          nil 
     		    rDontcare 
				(
     		    menuHndletype 
     		    Strtype
     		    ) 
				"!AppendMenu")

     	  
          (#xA934 
          nil 
          nil 
     		    rDontcare 
				(
     		    ) 
				"!ClearMenuBar")

     	  
          (#xA935 
          nil 
          nil 
     		    rDontcare 
				(
     		    menuHndletype 
     		    inttype
     		    ) 
				"!InsertMenu")

     	  
          (#xA936 
          nil 
          nil 
     		    rDontcare 
				(
     		    inttype
				) 
				"!DeleteMenu")

     	  
          (#xA937 
          nil 
          nil 
     		    rDontcare 
				(
     		    ) 
				"!DrawMenuBar")

     	  
          (#xA938 
          nil 
          nil 
     		    rDontcare 
				(
     		    inttype
				) 
				"!HiliteMenu")

     	  
          (#xA939 
          nil 
          nil 
     		    rDontcare 
				(
     		    menuHndletype 
     		    inttype
     		    ) 
				"!EnableItem")

     	  
          (#xA93A 
          nil 
          nil 
     		    rDontcare 
				(
     		    menuHndletype 
     		    inttype
     		    ) 
				"!DisableItem")

     	  
          (#xA93B 
          nil 
          nil 
     		    rhndltype 
				(
     		    ) 
				"!GetMenuBar")

     	  
          (#xA93C 
          nil 
          nil 
     		    rDontcare 
				(
     		    menuHndletype
				) 
				"!SetMenuBar")

     	  
          (#xA93D 
          nil 
          nil 
     		    rMVInttype 
				(
     		    Pttype
				) 
				"!MenuSelect")

     	  
          (#xA93E 
          nil 
          nil 
     		    rMVInttype 
				(
     		    Chartype
				) 
				"!MenuKey")

     	  
          (#xA93F 
          nil 
          nil 
     		    rDontcare 
				(
     		    menuHndletype 
     		    inttype 
     		    Vinttype
				) 
				"!GetItemIcon")

     	  
          (#xA940 
          nil 
          nil 
     		    rDontcare 
				(
     		    menuHndletype 
     		    inttype 
     		    inttype
				) 
				"!SetItemIcon")

     	  
          (#xA941 
          nil 
          nil 
     		    rDontcare 
				(
     		    menuHndletype 
     		    inttype 
     		    Vinttype
				) 
				"!GetItemStyle")

     	  
          (#xA942 
          nil 
          nil 
     		    rDontcare 
				(
     		    menuHndletype 
     		    inttype 
     		    inttype
				) 
				"!SetItemStyle")

     	  
          (#xA943 
          nil 
          nil 
     		    rDontcare 
				(
     		    menuHndletype 
     		    inttype 
     		    VChartype
				) 
				"!GetItemMark")

     	  
          (#xA944 
          nil 
          nil 
     		    rDontcare 
				(
     		    menuHndletype 
     		    inttype 
     		    Chartype
				) 
				"!SetItemMark")

     	  
          (#xA945 
          nil 
          nil 
     		    rDontcare 
				(
     		    menuHndletype 
     		    inttype 
     		    Booltype
				) 
				"!CheckItem")

     	  
          (#xA946 
          nil 
          nil 
     		    rDontcare 
				(
     		    menuHndletype 
     		    inttype 
     		    VStrtype
				) 
				"!GetItem")

     	  
          (#xA947 
          nil 
          nil 
     		    rDontcare 
				(
     		    menuHndletype 
     		    inttype 
     		    Strtype
				) 
				"!SetItem")

     	  
          (#xA948 
          nil 
          nil 
     		    rDontcare 
				(
     		    menuHndletype
				) 
				"!CalcMenuSize")

     	  
          (#xA949 
          nil 
          nil 
     		    rhndltype 
				(
     		    inttype
				) 
				"!GetMHandle")

     	  
          (#xA94A 
          nil 
          nil 
     		    rDontcare 
				(
     		    inttype
				) 
				"!SetMenuFlash")

     	  
          (#xA94B 
          nil 
          nil 
     		    rDontcare 
				(
     		    Recttype 
     		    hndltype
     		    ) 
				"!PlotIcon")

     	  
          (#xA94C 
          nil 
          nil 
     		    rDontcare 
				(
     		    inttype
				) 
				"!FlashMenuBar")

     	  
          (#xA94D 
          nil 
          nil 
     		    rDontcare 
				(
     		    menuHndletype 
     		    ResTypetype
     		    ) 
				"!AddResMenu")

     	  
          (#xA94E 
          nil 
          nil 
     		    rMVInttype 
				(
     		    Recttype 
     		    Pttype
     		    ) 
				"!PinRect")

     	  
          (#xA94F 
          nil 
          nil 
     		    rlngInttype 
				(
     		    Pttype 
     		    Pttype
     		    ) 
				"!DeltaPoint")

     	  
          (#xA950 
          nil 
          nil 
     		    rInttype 
				(
     		    menuHndletype
				) 
				"!CountMItems")

     	  
          (#xA951 
          nil 
          nil 
     		    rDontcare 
				(
     		    menuHndletype 
     		    ResTypetype 
     		    inttype
				) 
				"!InsertResMenu")

     	  
          (#xA954 
          nil 
          nil 
     		    rCntlHndltype 
				(
     		    WindowRectype 
     		    Recttype 
     		    Strtype 
     		    Booltype 
     		    inttype 
     		    inttype 
     		    inttype 
     		    inttype 
     		    lngInttype
				) 
				"!NewControl")

     	  
          (#xA955 
          nil 
          nil 
     		    rDontcare 
				(
     		    CntlHndltype
				) 
				"!DisposeControl")

     	  
          (#xA956 
          nil 
          nil 
     		    rDontcare 
				(
     		    WindowRectype
				) 
				"!KillControls")

     	  
          (#xA957 
          nil 
          nil 
     		    rDontcare 
				(
     		    CntlHndltype
				) 
				"!ShowControl")

     	  
          (#xA958 
          nil 
          nil 
     		    rDontcare 
				(
     		    CntlHndltype
				) 
				"!HideControl")

     	  
          (#xA959 
          nil 
          nil 
     		    rDontcare 
				(
     		    CntlHndltype 
     		    inttype 
     		    inttype
				) 
				"!MoveControl")

     	  
          (#xA95A 
          nil 
          nil 
     		    rlngInttype 
				(
     		    CntlHndltype
				) 
				"!GetCRefCon")

     	  
          (#xA95B 
          nil 
          nil 
     		    rDontcare 
				(
     		    CntlHndltype 
     		    lngInttype
     		    ) 
				"!SetCRefCon")

     	  
          (#xA95C 
          nil 
          nil 
     		    rDontcare 
				(
     		    CntlHndltype 
     		    inttype 
     		    inttype
				) 
				"!SizeControl")

     	  
          (#xA95D 
          nil 
          nil 
     		    rDontcare 
				(
     		    CntlHndltype 
     		    inttype
     		    ) 
				"!HiliteControl")

     	  
          (#xA95E 
          nil 
          nil 
     		    rDontcare 
				(
     		    CntlHndltype 
     		    VStrtype
     		    ) 
				"!GetCTitle")

     	  
          (#xA95F 
          nil 
          nil 
     		    rDontcare 
				(
     		    CntlHndltype 
     		    Strtype
     		    ) 
				"!SetCTitle")

     	  
          (#xA960 
          nil 
          nil 
     		    rInttype 
				(
     		    CntlHndltype
				) 
				"!GetCtlValue")

     	  
          (#xA961 
          nil 
          nil 
     		    rInttype 
				(
     		    CntlHndltype
				) 
				"!GetCtlMin")

     	  
          (#xA962 
          nil 
          nil 
     		    rInttype 
				(
     		    CntlHndltype
				) 
				"!GetCtlMax")

     	  
          (#xA963 
          nil 
          nil 
     		    rDontcare 
				(
     		    CntlHndltype 
     		    inttype
     		    ) 
				"!SetCtlValue")

     	  
          (#xA964 
          nil 
          nil 
     		    rDontcare 
				(
     		    CntlHndltype 
     		    inttype
     		    ) 
				"!SetCtlMin")

     	  
          (#xA965 
          nil 
          nil 
     		    rDontcare 
				(
     		    CntlHndltype 
     		    inttype
     		    ) 
				"!SetCtlMax")

     	  
          (#xA966 
          nil 
          nil 
     		    rInttype 
				(
     		    CntlHndltype 
     		    Pttype
     		    ) 
				"!TestControl")

     	  
          (#xA967 
          nil 
          nil 
     		    rDontcare 
				(
     		    CntlHndltype 
     		    Pttype 
     		    Recttype 
     		    Recttype 
     		    inttype
				) 
				"!DragControl")

     	  
          (#xA968 
          nil 
          nil 
     		    rInttype 
				(
     		    CntlHndltype 
     		    Pttype 
     		    ptrtype
				) 
				"!TrackControl")

     	  
          (#xA969 
          nil 
          nil 
     		    rDontcare 
				(
     		    WindowRectype
				) 
				"!DrawControls")

     	  
          (#xA96A 
          nil 
          nil 
     		    rPtrtype 
				(
     		    CntlHndltype
				) 
				"!GetCtlAction")

     	  
          (#xA96B 
          nil 
          nil 
     		    rDontcare 
				(
     		    CntlHndltype 
     		    Ptrtype
     		    ) 
				"!SetCtlAction")

     	  
          (#xA96C 
          nil 
          nil 
     		    rInttype 
				(
     		    Pttype 
     		    WindowRectype 
     		    VCntlHndltype
				) 
				"!FindControl")

     	  
          (#xA96E 
          nil 
          nil 
     		    rResultCodeInD0 
				(
     		    PtrInA0 
     		    PtrInA1
     		    ) 
				"!DeQueue")

     	  
          (#xA96F 
          nil 
          nil 
     		    rDontcare 
				(
     		    PtrInA0 
     		    PtrInA1
     		    ) 
				"!EnQueue")

     	  
          (#xA970 
          nil 
          nil 
     		    rBooltype 
				(
     		    inttype 
     		    VEvtRectype
     		    ) 
				"!GetNextEventInternal")


     	  
          (#xA971 
          nil 
          nil 
     		    rBooltype 
				(
     		    inttype 
     		    VEvtRectype
     		    ) 
				"!EventAvailInternal")

     	  
          (#xA972 
          nil 
          nil 
     		    rDontcare 
				(
     		    VPttype
				) 
				"!GetMouse")

     	  
          (#xA973 
          nil 
          nil 
     		    rBooltype 
				(
     		    ) 
				"!StillDown")

     	  
          (#xA974 
          nil 
          nil 
     		    rBooltype 
				(
     		    ) 
				"!Button")

     	  
          (#xA975 
          nil 
          nil 
     		    rlngInttype 
				(
     		    ) 
				"!TickCount")

     	  
          (#xA976 
          nil 
          nil 
     		    rDontcare 
				(
     		    HndlPtrtype			       ;***---***db 8/16/88
				) 
				"!GetKeys")

     	  
          (#xA977 
          nil 
          nil 
     		    rBooltype 
				(
     		    ) 
				"!WaitMouseUp")

     	  
          (#xA979 
          nil 
          nil 
     		    rDontcare 
				(
     		    inttype
				) 
				"!CouldDialog")

     	  
          (#xA97A 
          nil 
          nil 
     		    rDontcare 
				(
     		    inttype
				) 
				"!FreeDialog")

     	  
          (#xA97B 
          nil 
          nil 
     		    rDontcare 
				(
     		    ptrtype
				) 
				"!InitDialogs")

     	  
          (#xA97C 
          nil 
          nil 
     		    rDialogRectype 
				(
     		    inttype 
     		    ptrtype 
     		    ptrtype
				) 
				"!GetNewDialog")

     	  
          (#xA97D 
          nil 
          nil 
     		    rDialogRectype 
				(
     		    ptrtype 
     		    Recttype 
     		    Strtype 
     		    Booltype 
     		    inttype 
     		    ptrtype 
     		    Booltype 
     		    lngInttype 
     		    Hndltype			       ;***---***
				) 
				"!NewDialog")

     	  
          (#xA97E 
          nil 
          nil 
     		    rDontcare 
				(
     		    DialogRectype 
     		    inttype 
     		    inttype 
     		    inttype
     		    ) 
				"!SelIText")

     	  
          (#xA97F 
          nil 
          nil 
     		    rBooltype 
				(
     		    EvtRectype
				) 
				"!IsDialogEvent")

     	  
          (#xA980 
          nil 
          nil 
     		    rBooltype 
				(
     		    EvtRectype 
     		    VPtrtype 
     		    VInttype
				) 
				"!DialogSelect")

     	  
          (#xA981 
          nil 
          nil 
     		    rDontcare 
				(
     		    DialogRectype
				) 
				"!DrawDialog")

     	  
          (#xA982 
          nil 
          nil 
     		    rDontcare 
				(
     		    DialogRectype
				) 
				"!CloseDialog")

     	  
          (#xA983 
          nil 
          nil 
     		    rDontcare 
				(
     		    DialogRectype
				) 
				"!DisposDialog")

     	  
          (#xA985 
          nil 
          nil 
     		    rInttype 
				(
     		    inttype 
     		    ptrtype
     		    ) 
				"!Alert")

     	  
          (#xA986 
          nil 
          nil 
     		    rInttype 
				(
     		    inttype 
     		    ptrtype
     		    ) 
				"!StopAlert")

     	  
          (#xA987 
          nil 
          nil 
     		    rInttype 
				(
     		    inttype 
     		    ptrtype
     		    ) 
				"!NoteAlert")

     	  
          (#xA988 
          nil 
          nil 
     		    rInttype 
				(
     		    inttype 
     		    ptrtype
     		    ) 
				"!CautionAlert")

     	  
          (#xA989 
          nil 
          nil 
     		    rDontcare 
				(
     		    inttype
				) 
				"!CouldAlert")

     	  
          (#xA98A 
          nil 
          nil 
     		    rDontcare 
				(
     		    inttype
				) 
				"!FreeAlert")

     	  
          (#xA98B 
          nil 
          nil 
     		    rDontcare 
				(
     		    Strtype 
     		    Strtype 
     		    Strtype 
     		    Strtype
     		    ) 
				"!ParamText")

     	  
          (#xA98C 
          nil 
          nil 
     		    rDontcare 
				(
     		    ptrtype
				) 
				"!ErrorSound")

     	  
          (#xA98D 
          nil 
          nil 
     		    rDontcare 
				(
     		    DialogRectype 
     		    inttype 
     		    Vinttype 
     		    VHndltype 
     		    VRecttype
				) 
				"!GetDItem")

     	  
          (#xA98E 
          nil 
          nil 
     		    rDontcare 
				(
     		    DialogRectype 
     		    inttype 
     		    inttype 
     		    Hndltype 
     		    Recttype
				) 
				"!SetDItem")

     	  
          (#xA98F 
          nil 
          nil 
     		    rDontcare 
				(
     		    Hndltype 
     		    Strtype
     		    ) 
				"!SetIText")

     	  
          (#xA990 
          nil 
          nil 
     		    rDontcare 
				(
     		    Hndltype 
     		    VStrtype
     		    ) 
				"!GetIText")

     	  
          (#xA991 
          nil 
          nil 
     		    rDontcare 
				(
     		    ptrtype 
     		    VInttype
     		    ) 
				"!ModalDialog")

     	  
          (#xA992 
          SaveResError 
          nil 
     		    rDontcare 
				(
     		    hndltype
				) 
				"!DetachResource")

     	  
          (#xA993 
          nil 
          nil 
     		    rDontcare 
				(
     		    Booltype
				) 
				"!SetResPurge")

     	  
          (#xA994 
          nil 
          nil 
     		    rinttype 
				(
     		    ) 
				"!CurResFile")

     	  
          (#xA995 
          nil 
          nil 
     		    rinttype 
				(
     		    ) 
				"!InitResources")

     	  
          (#xA997 
          SaveResError 
          nil 
     		    rinttype 
				(
     		    Strtype
				) 
				"!OpenResFile")

     	  
          (#xA998 
          nil 
          nil 
     		    rDontcare 
				(
     		    inttype
				) 
				"!UseResFile")

     	  
          (#xA999 
          SaveResError 
          nil 
     		    rDontcare 
				(
     		    inttype
				) 
				"!UpdateResFile")

     	  
          (#xA99A 
          SaveResError 
          nil 
     		    rDontcare 
				(
     		    inttype
				) 
				"!CloseResFile")

     	  
          (#xA99B 
          nil 
          nil 
     		    rDontcare 
				(
     		    Booltype
				) 
				"!SetResLoad")

     	  
          (#xA99C 
          nil 
          nil 
     		    rinttype 
				(
     		    ResTypetype
				) 
				"!CountResources")

     	  
          (#xA99D 
          SaveResError 
          nil 
     		    rhndltype 
				(
     		    ResTypetype 
     		    inttype
     		    ) 
				"!GetIndResource")

     	  
          (#xA99E 
          nil 
          nil 
     		    rinttype 
				(
     		    ) 
				"!CountTypes")

     	  
          (#xA99F 
          nil 
          nil 
     		    rDontcare 
				(
     		    VRestype 
     		    inttype
     		    ) 
				"!GetIndType")

     	  
          (#xA9A0 
          SaveResError 
          nil 
     		    rhndltype 
				(
     		    ResTypetype 
     		    inttype
     		    ) 
				"!GetResource")

     	  
          (#xA9A1 
          SaveResError 
          nil 
     		    rhndltype 
				(
     		    ResTypetype 
     		    Strtype
     		    ) 
				"!GetNamedResource")

     	  
          (#xA9A2 
          SaveResError 
          nil 
     		    rDontcare 
				(
     		    hndltype
				) 
				"!LoadResource")

     	  
          (#xA9A3 
          SaveResError 
          nil 
     		    rDontcare 
				(
     		    hndltype
				) 
				"!ReleaseResource")

     	  
          (#xA9A4 
          SaveResError 
          nil 
     		    rinttype 
				(
     		    hndltype
				) 
				"!HomeResFile")

     	  
          (#xA9A5 
          SaveResError 
          nil 
     		    rlngInttype 
				(
     		    hndltype
				) 
				"!SizeResource")

     	  
          (#xA9A6 
          SaveResError 
          nil 
     		    rinttype 
				(
     		    hndltype
				) 
				"!GetResAttrs")

     	  
          (#xA9A7 
          SaveResError 
          nil 
     		    rinttype 
				(
     		    hndltype 
     		    inttype
     		    ) 
				"!SetResAttrs")

     	  
          (#xA9A8 
          SaveResError 
          nil 
     		    rinttype 
				(
     		    hndltype 
     		    Vinttype 
     		    VRestype 
     		    VStrtype
     		    ) 
				"!GetResInfo")

     	  
          (#xA9A9 
          SaveResError 
          nil 
     		    rDontcare 
				(
     		    hndltype 
     		    inttype 
     		    Strtype
				) 
				"!SetResInfo")

     	  
          (#xA9AA 
          SaveResError 
          nil 
     		    rDontcare 
				(
     		    hndltype
				) 
				"!ChangedResource")

     	  
          (#xA9AB 
          SaveResError 
          nil 
     		    rinttype 
				(
     		    hndltype 
     		    ResTypetype 
     		    inttype 
     		    Strtype
     		    ) 
				"!AddResource")

     	  
          (#xA9AD 
          SaveResError 
          nil 
     		    rDontcare 
				(
     		    hndltype
				) 
				"!RmveResource")

     	  
          (#xA9AF 
          nil 
          nil 
     		    rinttype 
				(
     		    ) 
				"!ResError")

     	  
          (#xA9B0 
          SaveResError 
          nil 
     		    rDontcare 
				(
     		    hndltype
				) 
				"!WriteResource")

     	  
          (#xA9B1 
          SaveResError 
          nil 
     		    rDontcare 
				(
     		    Strtype
				) 
				"!CreateResFile")

     	  
          (#xA9B2 
          nil 
          nil 
     		    rBooltype 
				(
     		    EvtRectype
				) 
				"!SystemEvent")

     	  
          (#xA9B3 
          nil 
          nil 
     		    rDontcare 
				(
     		    EvtRectype 
     		    WindowRectype
     		    ) 
				"!SystemClick")

     	  
          (#xA9B4 
          nil 
          nil 
     		    rDontcare 
				(
     		    ) 
				"!SystemTask")

     	  
          (#xA9B5 
          nil 
          nil 
     		    rDontcare 
				(
     		    lngInttype
				) 
				"!SystemMenu")

     	  
          (#xA9B6 
          nil 
          nil 
     		    rInttype 
				(
     		    Strtype
				) 
				"!OpenDeskAcc")

     	  
          (#xA9B7 
          nil 
          nil 
     		    rDontcare 
				(
     		    inttype
				) 
				"!CloseDeskAcc")

     	  
          (#xA9B8 
          nil 
          nil 
     		    rhndltype 
				(
     		    inttype
				) 
				"!GetPattern")

     	  
          (#xA9B9 
          nil 
          nil 
     		    rhndltype 
				(
     		    inttype
				) 
				"!GetCursor")

     	  
          (#xA9BA 
          nil 
          nil 
     		    rhndltype 
				(
     		    inttype
				) 
				"!GetString")

     	  
          (#xA9BB 
          nil 
          nil 
     		    rhndltype 
				(
     		    inttype
				) 
				"!GetIcon")

     	  
          (#xA9BC 
          nil 
          nil 
     		    rhndltype 
				(
     		    inttype
				) 
				"!GetPicture")

     	  
          (#xA9BD 
          nil 
          nil 
     		    rwindPtrtype 
				(
     		    inttype 
     		    ptrtype 
     		    ptrtype			       ;***---*** 7/29/88 DB
				) 
				"!GetNewWindow")

     	  
          (#xA9BE 
          nil 
          nil 
     		    rhndltype 
				(
     		    inttype 
     		    WindowRectype
     		    ) 
				"!GetNewControl")

     	  
          (#xA9BF 
          nil 
          nil 
     		    rhndltype 
				(
     		    inttype
				) 
				"!GetMenu")

     	  
          (#xA9C0 
          nil 
          nil 
     		    rhndltype 
				(
     		    inttype
				) 
				"!GetNewMBar")

     	  
          (#xA9C1 
          nil 
          nil 
     		    rInttype 
				(
     		    ResTypetype
				) 
				"!UniqueID")

     	  
          (#xA9C2 
          nil 
          nil 
     		    rBooltype 
				(
     		    inttype
				) 
				"!SystemEdit")

     	  
          (#xA9C6 
          nil 
          nil 
     		    rDontcare 
				(
     		    LongInD0 
     		    PtrInA0
     		    ) 
				"!Secs2Date")

     	  
          (#xA9C7 
          nil 
          nil 
     		    rLongInD0 
				(
     		    PtrInA0
				) 
				"!Date2Secs")

     	  
          (#xA9C8 
          nil 
          nil 
     		    rDontcare 
				(
     		    inttype
				) 
				"!SysBeep")

     	  
          (#xA9CB 
          nil 
          nil 
     		    rHndltype 
				(
     		    TERectype
				) 
				"!TEGetText")

     	  
          (#xA9CC 
          nil 
          nil 
     		    rDontcare 
				(
     		    ) 
				"!TEInit")

     	  
          (#xA9CD 
          nil 
          nil 
     		    rDontcare 
				(
     		    TERectype
				) 
				"!TEDispose")

     	  
          (#xA9CE 
          nil 
          nil 
     		    rDontcare 
				(
     		    ptrtype 
     		    lngInttype 
     		    Recttype 
     		    inttype
     		    ) 
				"!TextBox")

     	  
          (#xA9CF 
          nil 
          nil 
     		    rDontcare 
				(
     		    ptrtype 
     		    lngInttype 
     		    TERectype
				) 
				"!TESetText")

     	  
          (#xA9D0 
          nil 
          nil 
     		    rDontcare 
				(
     		    TERectype
				) 
				"!TECalText")

     	  
          (#xA9D1 
          nil 
          nil 
     		    rDontcare 
				(
     		    lngInttype 
     		    lngInttype 
     		    TERectype
				) 
				"!TESetSelect")

     	  
          (#xA9D2				       ; MACTOOLBOX-1-19, MACTOOLBOX-1-26
	   nil 
	   nil 
	   rTERectype
	   (
	    Recttype 
	    Recttype
	    ) 
	   "!TENew")

     	  
          (#xA9D3 
          nil 
          nil 
     		    rDontcare 
				(
     		    Recttype 
     		    TERectype
     		    ) 
				"!TEUpdate")

     	  
          (#xA9D4 
          nil 
          nil 
     		    rDontcare 
				(
     		    Pttype 
     		    Booltype 
     		    TERectype
				) 
				"!TEClick")

     	  
          (#xA9D5 
          nil 
          nil 
     		    rDontcare 
				(
     		    TERectype
				) 
				"!TECopy")

     	  
          (#xA9D6 
          nil 
          nil 
     		    rDontcare 
				(
     		    TERectype
				) 
				"!TECut")

     	  
          (#xA9D7 
          nil 
          nil 
     		    rDontcare 
				(
     		    TERectype
				) 
				"!TEDelete")

     	  
          (#xA9D8 
          nil 
          nil 
     		    rDontcare 
				(
     		    TERectype
				) 
				"!TEActivate")

     	  
          (#xA9D9 
          nil 
          nil 
     		    rDontcare 
				(
     		    TERectype
				) 
				"!TEDeactivate")

     	  
          (#xA9DA 
          nil 
          nil 
     		    rDontcare 
				(
     		    TERectype
				) 
				"!TEIdle")

     	  
          (#xA9DB 
          nil 
          nil 
     		    rDontcare 
				(
     		    TERectype
				) 
				"!TEPaste")

     	  
          (#xA9DC 
          nil 
          nil 
     		    rDontcare 
				(
     		    Chartype 
     		    TERectype
     		    ) 
				"!TEKey")

     	  
          (#xA9DD 
          nil 
          nil 
     		    rDontcare 
				(
     		    inttype 
     		    inttype 
     		    TERectype
				) 
				"!TEScroll")

     	  
          (#xA9DE 
          nil 
          nil 
     		    rDontcare 
				(
     		    ptrtype 
     		    lngInttype 
     		    TERectype
				) 
				"!TEInsert")

     	  
          (#xA9DF 
          nil 
          nil 
     		    rDontcare 
				(
     		    inttype 
     		    TERectype
     		    ) 
				"!TESetJust")

     	  
          (#xA9E0 
          nil 
          nil 
     		    rlngInttype 
				(
     		    hndltype 
     		    lngInttype 
     		    ptrtype 
     		    lngInttype 
     		    ptrtype 
     		    lngInttype
     		    ) 
				"!Munger")

     	  
          (#xA9E1 
          nil 
          nil 
     		    rHndlA0_resCD0 
				(
     		    HndlInA0
				) 
				"!HandToHand")

     	  
          (#xA9E2 
          nil 
          nil 
     		    rResultCodeInD0 
				(
     		    PtrInA0 
     		    HndlInA1 
     		    LongInD0
				) 
				"!PtrToXHand")

     	  
          (#xA9E3 
          nil 
          nil 
     		    rHndlA0_resCD0 
				(
     		    PtrInA0 
     		    LongInD0
     		    ) 
				"!PtrToHand")

     	  
          (#xA9E4 
          nil 
          nil 
     		    rResultCodeInD0 
				(
     		    HndlInA0 
     		    HndlInA1
     		    ) 
				"!HandAndHand")

     	  
          (#xA9EF 
          nil 
          nil 
     		    rResultCodeInD0 
				(
     		    PtrInA0 
     		    HndlInA1 
     		    LongInD0
				) 
				"!PtrAndHand")

     	  
          (#xA9F6 
          SaveResError 
          nil 
     		    rinttype 
				(
     		    inttype
				) 
				"!GetResFileAttrs")

     	  
          (#xA9F7 
          SaveResError 
          nil 
     		    rinttype 
				(
     		    inttype 
     		    inttype
     		    ) 
				"!SetResFileAttrs")

     	  
          (#xA9F9 
          nil 
          nil 
     		    rptrtype 
				(
     		    ) 
				"!_InfoScrap")

     	  
          (#xA9FA 
          nil 
          nil 
     		    rLngInttype 
				(
     		    ) 
				"!UnloadScrap")

     	  
          (#xA9FB 
          nil 
          nil 
     		    rLngInttype 
				(
     		    ) 
				"!LoadScrap")

     	  
          (#xA9FC 
          nil 
          nil 
     		    rLngInttype 
				(
     		    ) 
				"!ZeroScrap")

     	  
          (#xA9FD 
          nil 
          nil 
     		    rLngInttype 
				(
     		    Hndltype 
     		    ResTypetype 
     		    VLngInttype
				) 
				"!GetScrap")

     	  
          (#xA9FE 
          nil 
          nil 
     		    rLngInttype 
				(
     		    lngInttype 
     		    ResTypetype 
     		    ptrtype
				) 
				"!PutScrap")

     	  
          (#xA9FF 
          nil 
          nil 
     		    rDontcare 
				(
     		    ) 
				"!Debugger")

     	  
          (#xA9EA 		        ; /* _Pack4 */
          selector 
          1 
     		    rDontcare 
				(
     		    Pttype 
     		    Strtype 
     		    Strtype 
     		    ptrtype 
     		    vSFReplytype		       ;***---***
				) 
				"!SFPutFile")

     	  
          (#xA9EA 		         ;/* _Pack4 */
          selector 
          2 
     		    rDontcare 
				(
     		    Pttype 
     		    Strtype 
     		    ptrtype 
     		    Inttype 
     		    SFtypeListtype 
     		    ptrtype 
     		    vSFReplytype		       ;***---***
				) 
				"!SFGetFile")

     	  
          (#xA9EA 		         ;/* _Pack4 */
          selector 
          3 
     		    rDontcare 
				(
     		    Pttype 
     		    Strtype 
     		    Strtype 
     		    ptrtype 
     		    vSFReplytype		       ;***---***
     		    Inttype 
     		    ptrtype
				) 
				"!SFPPutFile")

     	  
          (#xA9EA 		         ;/* _Pack4 */
          selector 
          4 
     		    rDontcare 
				(
     		    Pttype 
     		    Strtype 
     		    ptrtype 
     		    Inttype 
     		    SFtypeListtype 
     		    ptrtype 
     		    vSFReplytype		       ;***---***
     		    Inttype 
     		    ptrtype
				) 
				"!SFPGetFile")

     	  
          (#xA9ED 		         ;/* _Pack6 */
          selector 
          0 
     		    rDontCare 
				(
     		    lngInttype 
     		    inttype 
     		    VStrtype
				) 
				"!IUDateString")

     	  
          (#xA9ED 		         ;/* _Pack6 */
          selector 
          14 
     		    rDontCare 
				(
     		    lngInttype 
     		    inttype 
     		    VStrtype 
     		    hndltype
     		    ) 
				"!IUDatePString")

     	  
          (#xA9ED 		         ;/* _Pack6 */
          selector 
          2 
     		    rDontCare 
				(
     		    lngInttype 
     		    Booltype 
     		    VStrtype
				) 
				"!IUTimeString")

     	  
          (#xA9ED 		         ;/* _Pack6 */
          selector 
          16 
     		    rDontCare 
				(
     		    lngInttype 
     		    Booltype 
     		    VStrtype 
     		    hndltype
     		    ) 
				"!IUTimePString")

     	  
          (#xA9ED 		         ;/* _Pack6 */
          selector 
          4 
     		    rBooltype 
				(
     		    ) 
				"!IUMetric")

     	  
          (#xA9ED 		         ;/* _Pack6 */
          selector 
          6 
     		    rhndltype 
				(
     		    inttype
				) 
				"!IUGetIntl")

     	  
          (#xA9ED 		         ;/* _Pack6 */
          selector 
          8 
     		    rDontCare 
				(
     		    inttype 
     		    inttype 
     		    hndltype
				) 
				"!IUSetIntl")

     	  

          (#xA9ED 		         ;/* _Pack6 */
          selector 
          10 
     		    rInttype 
				(
     		    ptrtype 
     		    ptrtype 
     		    inttype 
     		    inttype
     		    ) 
				"!IUMagString")

     	  
          (#xA9ED 		         ;/* _Pack6 */
          selector 
          12 
     		    rInttype 
				(
     		    ptrtype 
     		    ptrtype 
     		    inttype 
     		    inttype
     		    ) 
				"!IUMagIDString")

     	  
;  /* --------------------------------------------------------------------------------	*/
;  /*		    MacPlus traps 															*/
;  /* --------------------------------------------------------------------------------	*/

          (#xA80D 
          macPlus 
          nil 
     		    rinttype 
				(
     		    ResTypetype
				) 
				"!Count1Resources")

     	  
          (#xA80E 
          macPlus+SaveResError
          nil 
     		    rhndltype 
				(
     		    ResTypetype 
     		    inttype
     		    ) 
				"!Get1IndResource")

     	  

          (#xA81C 
          macPlus 
          nil 
     		    rinttype 
				(
     		    ) 
				"!Count1Types")

     	  

          (#xA80F 
          macPlus 
          nil 
     		    rDontCare 
				(
     		    VRestype 
     		    inttype
     		    ) 
				"!Get1IndType")

     	  

          (#xA810 
          macPlus 
          nil 
     		    rinttype 
				(
     		    ResTypetype
				) 
				"!Unique1ID")

     	  

          (#xA81F 
          macPlus+SaveResError 
          nil 
     		    rhndltype 
				(
     		    ResTypetype 
     		    inttype
     		    ) 
				"!Get1Resource")

     	  

          (#xA820 
          macPlus+SaveResError 
          nil 
     		    rhndltype 
				(
     		    ResTypetype 
     		    Strtype
     		    ) 
				"!Get1NamedResource")

     	  

          (#xA821 
          macPlus 
          nil 
     		    rlngInttype 
				(
     		    hndltype
				) 
				"!MaxSizeRsrc")

     	  

          (#xA9C5 
          macPlus+SaveResError 
          nil 
     		    rlngInttype 
				(
     		    hndltype
				) 
				"!RsrcMapEntry")

     	  

          (#xA9C4 
          macPlus+SaveResError
          nil 
     		    rinttype 
				(
     		    strtype 
     		    inttype 
     		    inttype
				) 
				"!OpenRFPerm")

     	  

          (#xA839 
          macPlus 
          nil 
     		    rDontCare 
				(
     		    ptrtype 
     		    ptrtype 
     		    inttype 
     		    inttype 
     		    inttype 
     		    inttype 
     		    inttype 
     		    inttype
     		    ) 
				"!SeedFill")

     	  

          (#xA838 
          macPlus 
          nil 
     		    rDontCare 
				(
     		    ptrtype 
     		    ptrtype 
     		    inttype 
     		    inttype 
     		    inttype 
     		    inttype
     		    ) 
				"!CalcMask")

     	  

          (#xA817 
          macPlus 
          nil 
     		    rDontCare 
				(
     		    BitMaptype 
     		    BitMaptype 
     		    BitMaptype 
     		    Recttype 
     		    Recttype 
     		    Recttype
     		    ) 
				"!CopyMask")

     	  

          (#xA837 
          macPlus 
          nil 
     		    rDontCare 
				(
     		    inttype 
     		    ptrtype 
     		    ptrtype
				) 
				"!MeasureText")

     	  

          (#xA936 
          macPlus 
          nil 
     		    rPtrInA0 
				(
     		    ) 
				"!GetMaskTable")

     	  

          (#xA834 
          macPlus 
          nil 
     		    rDontCare 
				(
     		    Booltype
				) 
				"!SetFScaleDisable")

     	  

          (#xA835 
          macPlus 
          nil 
     		    rDontCare 
				(
     		    Hndlptrtype 		      ;***---***
				) 
				"!FontMetrics")

     	  

          (#xA83B 
          macPlus 
          nil 
     		    rBooltype 
				(
     		    WindowRectype 
     		    Pttype 
     		    inttype
				) 
				"!TrackBox")

     	  

          (#xA83A 
          macPlus 
          nil 
     		    rDontCare 
				(
     		    WindowRectype 
     		    inttype 
     		    Booltype
				) 
				"!ZoomWindow")

     	  

          (#xA953 
          macPlus 
          nil 
     		    rDontCare 
				(
     		    WindowRectype 
     		    Rgntype
     		    ) 
				"!UpdateControls")

     	  

          (#xA826 
          macPlus 
          nil 
     		    rDontCare 
				(
     		    menuHndletype 
     		    Strtype 
     		    inttype
				) 
				"!InsMenuItem")	       ;***---***

     	  

          (#xA952 
          macPlus 
          nil 
     		    rDontCare 
				(
     		    menuHndletype 
     		    inttype
     		    ) 
				"!DelMenuItem")	       ;***---***

     	  

          (#xA811 
          macPlus 
          nil 
     		    rDontCare 
				(
     		    TERectype
				) 
				"!TESelView")

     	  

          (#xA812 
          macPlus 
          nil 
     		    rDontCare 
				(
     		    inttype 
     		    inttype 
     		    TERectype
				) 
				"!TEPInScroll")

     	  

          (#xA813 
          macPlus 
          nil 
     		    rDontCare 
				(
     		    Booltype 
     		    TERectype
     		    ) 
				"!TEAutoview")

     	  

          (#xA827 
          macPlus 
          nil 
     		    rDontCare 
				(
     		    DialogRectype 
     		    inttype
     		    ) 
				"!HideDItem")

     	  

          (#xA828 
          macPlus 
          nil 
     		    rDontCare 
				(
     		    DialogRectype 
     		    inttype
     		    ) 
				"!ShowDItem")

     	  

          (#xA978 
          macPlus 
          nil 
     		    rDontCare 
				(
     		    DialogRectype 
     		    Rgntype
     		    ) 
				"!UpdateDialog")

     	  

          (#xA984 
          macPlus 
          nil 
     		    rIntTYpe			       ;***---***
				(
     		    DialogRectype 
     		    Pttype
     		    ) 
				"!FindDItem")

     	  
          (#xA346				       ;****9/13
          macPlus 
          nil 
     		    rPtrInA0 
				(
     		    IntInD0
				) 
				"!GetOSTrapAddress")

     	  
          (#xA746 
          macPlus 
          nil 
     		    rPtrInA0 
				(
     		    IntInD0
				) 
				"!GetToolTrapAddress")

     	  
          (#xA347				       ;****9/13
          macPlus 
          nil 
     		    rDontCare 
				(
     		    PtrInA0 
     		    IntInD0
     		    ) 
				"!SetOSTrapAddress")

     	  
          (#xA747				       ;****9/13
          macPlus 
          nil 
     		    rDontCare 
				(
     		    PtrInA0 
     		    IntInD0
     		    ) 
				"!SetToolTrapAddress")

     	  
          (#xA819 
          macPlus 
          nil 
     		    rlnginttype 
				(
     		    lngInttype 
     		    hndltype 
     		    lngInttype 
     		    ptrtype 
     		    lngInttype 
     		    ptrtype 
     		    lngInttype
				) 
				"!XMunger")

     	  
          (#xA83F 
          macPlus 
          nil 
     		    rlnginttype 
				(
     		    lngInttype
				) 
				"!Long2Fix")

     	  

          (#xA840 
          macPlus 
          nil 
     		    rlnginttype 
				(
     		    lngInttype
				) 
				"!Fix2Long")

     	  

          (#xA841 
          macPlus 
          nil 
     		    rlnginttype 
				(
     		    lngInttype
				) 
				"!Fix2Frac")

     	  

          (#xA842 
          macPlus 
          nil 
     		    rlnginttype 
				(
     		    lngInttype
				) 
				"!Frac2Fix")

     	  

          (#xA843 
          macPlus 
          nil 
     		    rlnginttype 
				(
     		    lngInttype
				) 
				"!Fix2X")

     	  

          (#xA844 
          macPlus 
          nil 
     		    rlnginttype 
				(
     		    lngInttype
				) 
				"!X2Fix")

     	  

          (#xA845 
          macPlus 
          nil 
     		    rlnginttype 
				(
     		    lngInttype
				) 
				"!Frac2X")

     	  

          (#xA846 
          macPlus 
          nil 
     		    rlnginttype 
				(
     		    lngInttype
				) 
				"!X2Frac")

     	  

          (#xA847 
          macPlus 
          nil 
     		    rlnginttype 
				(
     		    lngInttype
				) 
				"!FracCos")

     	  

          (#xA848 
          macPlus 
          nil 
     		    rlnginttype 
				(
     		    lngInttype
				) 
				"!FracSin")

     	  

          (#xA849 
          macPlus 
          nil 
     		    rlnginttype 
				(
     		    lngInttype
				) 
				"!FracSqrt")

     	  

          (#xA84A 
          macPlus 
          nil 
     		    rlnginttype 
				(
     		    lngInttype 
     		    lngInttype
     		    ) 
				"!FracMul")

     	  

          (#xA84B 
          macPlus 
          nil 
     		    rlnginttype 
				(
     		    lngInttype 
     		    lngInttype
     		    ) 
				"!FracDiv")

     	  

          (#xA818 
          macPlus 
          nil 
     		    rlnginttype 
				(
     		    lngInttype 
     		    lngInttype
     		    ) 
				"!FixAtan2")

     	  

          (#xA84D 
          macPlus 
          nil 
     		    rlnginttype 
				(
     		    lngInttype 
     		    lngInttype
     		    ) 
				"!FixDiv")

     	  

          (#xA067 
          macPlus 
          nil 
     		    rResultCodeInD0 
				(
     		    HndlInA0
				) 
				"!SetRBit")

     	  

          (#xA068 
          macPlus 
          nil 
     		    rResultCodeInD0 
				(
     		    HndlInA0
				) 
				"!ClrRBit")

     	  

          (#xA069 
          macPlus 
          nil 
     		    rIntInD0 
				(
     		    HndlInA0
				) 
				"!HGetState")

     	  

          (#xA06A 
          macPlus 
          nil 
     		    rResultCodeInD0 
				(
     		    HndlInA0 
     		    IntInA0
     		    ) 
				"!HSetState")

     	  

          (#xA061 
          macPlus 
          nil 
     		    rLongInD0 
				(
     		    ) 
				"!MaxBlock")

     	  

          (#xA062 
          macPlus 
          nil 
     		    rLongA0_LongD0 
				(
     		    ) 
				"!PurgeSpace")

     	  

          (#xA063 
          macPlus 
          nil 
     		    rResultCodeInD0 
				(
     		    ) 
				"!MaxApplZone")

     	  

          (#xA064 
          macPlus 
          nil 
     		    rResultCodeInD0 
				(
     		    macHndlInA0
				) 
				"!MoveHHi")

     	  

          (#xA065 
          macPlus 
          nil 
     		    rLongInD0 
				(
     		    ) 
				"!StackSpace")

     	  

          (#xA166 
          macPlus 
          nil 
     		    rMacHndlInA0 
				(
     		    ) 
				"!NewEmptyHandle")

     	  
          (#xA815 		         ;;/* _Pack6 */
          selector+macPlus 
          nil 
     		    rInttype 
				(
     		    ) 
				"!SCSIReset")

     	  
          (#xA815 		         ;;/* _Pack6 */
          selector+macPlus 
          1 
     		    rInttype 
				(
     		    ) 
				"!SCSIGet")

     	  
          (#xA815 		         ;;/* _Pack6 */
          selector+macPlus 
          2 
     		    rInttype 
				(
     		    inttype
				) 
				"!SCSISelect")

     	  
          (#xA815 		         ;;/* _Pack6 */
          selector+macPlus 
          3 
     		    rInttype 
				(
     		    ptrtype 
     		    inttype
     		    ) 
				"!SCSICmd")

     	  
          (#xA815 		         ;;/* _Pack6 */
          selector+macPlus 
          4 
     		    rInttype 
				(
     		    Vinttype 
     		    Vinttype 
     		    lngInttype
				) 
				"!SCSIComplete")

     	  
          (#xA815 		         ;;/* _Pack6 */
          selector+macPlus 
          5 
     		    rInttype 
				(
     		    ptrtype
				) 
				"!SCSIRead")

     	  

          (#xA815 		         ;;/* _Pack6 */
          selector+macPlus 
          6 
     		    rInttype 
				(
     		    ptrtype
				) 
				"!SCSIWrite")

     	  

          (#xA815 		         ;;/* _Pack6 */
          selector+macPlus 
          8 
     		    rInttype 
				(
     		    ptrtype
				) 
				"!SCSIRBlind")

     	  

          (#xA815 		         ;;/* _Pack6 */
          selector+macPlus 
          9 
     		    rInttype 
				(
     		    ptrtype
				) 
				"!SCSIWBlind")

     	  

          (#xA207 
          macPlus 
          nil 
     		    rResultCodeInD0 
				(
     		    ioParamInA0
				) 
				"!HGetVInfo")

     	  

          (#xA060 		         ;;/* _Pack6 */
          macPlus 
          11 					  ;;/* selector in D0 */
     		    rResultCodeInD0 
				(
     		    ioParamSel
				) 
				"!SetVolInfo") ;was named "!HSetVInfo" db ***???***

     	  

          (#xA214 
          macPlus 
          nil 
     		    rResultCodeInD0 
				(
     		    ioParamInA0
				) 
				"!HGetVol")

     	  

          (#xA215 
          macPlus 
          nil 
     		    rResultCodeInD0 
				(
     		    ioParamInA0
				) 
				"!HSetVol")

     	  

          (#xA200 
          macPlus 
          nil 
     		    rResultCodeInD0 
				(
     		    ioParamInA0
				) 
				"!HOpen")

     	  

          (#xA20A 
          macPlus 
          nil 
     		    rResultCodeInD0 
				(
     		    ioParamInA0
				) 
				"!HOpenRF")

     	  

          (#xA208 
          macPlus 
          nil 
     		    rResultCodeInD0 
				(
     		    ioParamInA0
				) 
				"!HCreate")

     	  

          (#xA209 
          macPlus 
          nil 
     		    rResultCodeInD0 
				(
     		    ioParamInA0
				) 
				"!HDelete")

     	  

          (#xA20C 
          macPlus 
          nil 
     		    rResultCodeInD0 
				(
     		    ioParamInA0
				) 
				"!HGetFInfo")

     	  

          (#xA20D 
          macPlus 
          nil 
     		    rResultCodeInD0 
				(
     		    ioParamInA0
				) 
				"!HSetFInfo")

     	  

          (#xA241 
          macPlus 
          nil 
     		    rResultCodeInD0 
				(
     		    ioParamInA0
				) 
				"!HSetFLock")

     	  

          (#xA242 
          macPlus 
          nil 
     		    rResultCodeInD0 
				(
     		    ioParamInA0
				) 
				"!HRstFLock")

     	  

          (#xA060 		         ;;/* _Pack6 */
          macPlus 
          9 					  ;;/* selector in D0 */
     		    rResultCodeInD0 
				(
     		    ioParamSel
				) 
				"!GetCatInfo")

     	  

          (#xA060 		         ;;/* _Pack6 */
          macPlus 
          10 					  ;;/* selector in D0 */
     		    rResultCodeInD0 
				(
     		    ioParamSel
				) 
				"!SetCatInfo")

     	  

          (#xA060 		         ;;/* _Pack6 */
          macPlus 
          5 					  ;;/* selector in D0 */
     		    rResultCodeInD0 
				(
     		    ioParamSel
				) 
				"!CatMove")

     	  

          (#xA060 		         ;;/* _Pack6 */
          macPlus 
          6 					  ;;/* selector in D0 */
     		    rResultCodeInD0 
				(
     		    ioParamSel
				) 
				"!DirCreate")

     	  

          (#xA060 		         ;;/* _Pack6 */
          macPlus 
          1 					  ;;/* selector in D0 */
     		    rResultCodeInD0 
				(
     		    ioParamSel
				) 
				"!OpenWD")

     	  

          (#xA060 		         ;;/* _Pack6 */
          macPlus 
          2 					  ;;/* selector in D0 */
     		    rResultCodeInD0 
				(
     		    ioParamSel
				) 
				"!CloseWD")

     	  

          (#xA060 		         ;;/* _Pack6 */
          macPlus 
          7 					  ;;/* selector in D0 */
     		    rResultCodeInD0 
				(
     		    ioParamSel
				) 
				"!GetWDInfo")

     	  
          (#xA060 		         ;;/* _Pack6 */
          macPlus 			
          8 					  ;;/* selector in D0 */
     		    rResultCodeInD0 
				(
     		    ioParamSel		
				) 
				"!GetFCBInfo")

     	  
  ;;/* -------------------------------------------------------------------------------	*/
  ;;/*			 List Manager 	*/
  ;;/* -------------------------------------------------------------------------------	*/

          (#xA9E7 		         ;;/* _Pack0 */
          selector+macPlus 
          68 
     		    rhndltype 
				(
     		    Recttype 
     		    Recttype 
     		    Pttype 
     		    inttype 
     		    windowRectype 
     		    Booltype 
     		    Booltype 
     		    Booltype 
     		    Booltype
				) 
				"!LNew")

     	  
          (#xA9E7 		         ;;/* _Pack0 */
          selector+macPlus 
          40 
     		    rDontCare 
				(
     		    ListRecType
				) 
				"!LDispose")

     	  
          (#xA9E7 		         ;;/* _Pack0 */
          selector+macPlus 
          4 
     		    rInttype 
				(
     		    inttype 
     		    inttype 
     		    ListRecType
				) 
				"!LAddColumn")

     	  
          (#xA9E7 		         ;;/* _Pack0 */
          selector+macPlus 
          8 
     		    rinttype 
				(
     		    inttype 
     		    inttype 
     		    ListRecType
				) 
				"!LAddRow")

     	  
          (#xA9E7 		         ;;/* _Pack0 */
          selector+macPlus 
          32 
     		    rDontCare 
				(
     		    inttype 
     		    inttype 
     		    ListRecType
				) 
				"!LDelColumn")

     	  
          (#xA9E7 		         ;;/* _Pack0 */
          selector+macPlus 
          36 
     		    rDontCare 
				(
     		    inttype 
     		    inttype 
     		    ListRecType
				) 
				"!LDelRow")

     	  
          (#xA9E7 		         ;;/* _Pack0 */
          selector+macPlus 
          12 
     		    rDontCare 
				(
     		    ptrtype 
     		    inttype 
     		    pttype 
     		    ListRecType
     		    ) 
				"!LAddToCell")

     	  
          (#xA9E7 		         ;;/* _Pack0 */
          selector+macPlus 
          28 
     		    rinttype 
				(
     		    pttype 
     		    ListRecType
     		    ) 
				"!LClrCell")

     	  
          (#xA9E7 		         ;;/* _Pack0 */
          selector+macPlus 
          56 
     		    rDontCare 
				(
     		    ptrtype 
     		    Vinttype 
     		    pttype 
     		    ListRecType
     		    ) 
				"!LGetCell")

     	  
          (#xA9E7 		         ;;/* _Pack0 */
          selector+macPlus 
          88 
     		    rDontCare 
				(
     		    ptrtype 
     		    inttype 
     		    pttype 
     		    ListRecType
     		    ) 
				"!LSetCell")

     	  
          (#xA9E7 		         ;;/* _Pack0 */
          selector+macPlus 
          20 
     		    rDontCare 
				(
     		    pttype 
     		    ListRecType
     		    ) 
				"!LCellSize")

     	  
          (#xA9E7 		         ;;/* _Pack0 */
          selector+macPlus 
          60 
     		    rBooltype 
				(
     		    Booltype 
     		    VPttype 
     		    ListRecType
				) 
				"!LGetSelect")

     	  
          (#xA9E7 		         ;;/* _Pack0 */
          selector+macPlus 
          92 
     		    rDontCare 
				(
     		    Booltype 
     		    pttype 
     		    ListRecType
				) 
				"!LSetSelect")

     	  
          (#xA9E7 		         ;;/* _Pack0 */
          selector+macPlus 
          24 
     		    rBoolType 
				(
     		    Pttype 
     		    inttype 
     		    ListRecType
				) 
				"!LClick")

     	  
          (#xA9E7 		         ;;/* _Pack0 */
          selector+macPlus 
          64 
     		    rMVInttype 
				(
     		    ListRecType
				) 
				"!LLastClick")

     	  
          (#xA9E7 		         ;;/* _Pack0 */
          selector+macPlus 
          52 
     		    rDontCare 
				(
     		    Vinttype 
     		    Vinttype 
     		    pttype 
     		    ListRecType
     		    ) 
				"!LFind")

     	  
          (#xA9E7 		         ;;/* _Pack0 */
          selector+macPlus 
          72 
     		    rBooltype 
				(
     		    Booltype 
     		    Booltype 
     		    VPttype 
     		    ListRecType
     		    ) 
				"!LNextCell")

     	  
          (#xA9E7 		         ;;/* _Pack0 */
          selector+macPlus 
          76 
     		    rDontCare 
				(
     		    VRecttype 
     		    pttype 
     		    ListRecType
				) 
				"!LRect")

     	  
          (#xA9E7 		         ;;/* _Pack0 */
          selector+macPlus 
          84 
     		    rBoolType 
				(
				ptrType 
				intType 
				ptrType 
     		    VPttype 
     		    ListRecType
				) 
				"!LSearch")

     	  
          (#xA9E7 		         ;;/* _Pack0 */
          selector+macPlus 
          96 
     		    rDontCare 
				(
     		    inttype 
     		    inttype 
     		    ListRecType
				) 
				"!LSize")

     	  
          (#xA9E7 		         ;;/* _Pack0 */
          selector+macPlus 
          48 
     		    rDontCare 
				(
     		    pttype 
     		    ListRecType
     		    ) 
				"!LDraw")

     	  
          (#xA9E7 		         ;;/* _Pack0 */
          selector+macPlus 
          44 
     		    rDontCare 
				(
     		    Booltype 
     		    ListRecType
     		    ) 
				"!LDoDraw")

     	  
          (#xA9E7 		         ;;/* _Pack0 */
          selector+macPlus 
          80 
     		    rDontCare 
				(
     		    inttype 
     		    inttype 
     		    ListRecType
				) 
				"!LScroll")

     	  
          (#xA9E7 		         ;;/* _Pack0 */
          selector+macPlus 
          16 
     		    rDontCare 
				(
     		    ListRecType
				) 
				"!LAutoScroll")

     	  
          (#xA9E7 		         ;;/* _Pack0 */
          selector+macPlus 
          100 
     		    rDontCare 
				(
     		    Rgntype 
     		    ListRecType
     		    ) 
				"!LUpdate")

     	  
          (#xA9E7 		         ;;/* _Pack0 */
          selector+macPlus 
          0 
     		    rDontCare 
				(
     		    Booltype 
     		    ListRecType
     		    ) 
				"!LActivate")

     	  
          (#xA9E9 		         ;;/* _Pack0 */
          selector 
          2 
     		    rDontCare 
				(
     		    ) 
				"!DILoad")

     	  
          (#xA9E9 		         ;;/* _Pack0 */
          selector 
          4 
     		    rDontCare 
				(
     		    ) 
				"!DIUnLoad")

     	  
          (#xA9E9 		         ;;/* _Pack0 */
          selector 
          0 
     		    rInttype 
				(
     		    Pttype 
     		    lngInttype
     		    ) 
				"!DIBadMount")

     	  
          (#xA9E9 		         ;;/* _Pack0 */
          selector 
          6 
     		    rinttype 
				(
     		    inttype
				) 
				"!DIFormat")

     	  
          (#xA9E9 		         ;;/* _Pack0 */
          selector 
          8 
     		    rinttype 
				(
     		    inttype
				) 
				"!DIVerify")

     	  
          (#xA9E9 		         ;;/* _Pack0 */
          selector 
          10 
     		    rinttype 
				(
     		    inttype 
     		    Strtype
				) 
				"!DIZero")
				
;  ;;/* ============================================================================= */
;  ;;/*			 Mac 2 traps	*/
;  ;;/* ============================================================================= */

;  ;;/* OpenCPort   (port: cGrafPtr)	*/

     	    (#xAA00 
     	    mac2 
     	    1 
     	    rDontcare 
				(
     	    	GrafPorttype
				) 
			"!OpenCPort")

  ;;;;/* InitCPort   (port: cGrafPtr)	*/

     	    (#xAA01 
     	    mac2 
     	    1 
     	    rDontcare 
     	    	(
     	    	GrafPorttype
				) 
			"!InitCPort")

  ;;/* CloseCPort  (port: cGrafPtr)	*/

     	    (#xAA02 
     	    mac2 
     	    1 
     	    rDontcare 
     	    	(
     	    	GrafPorttype
				) 
			"!CloseCPort")

  ;;/* NewPixMap:PixMapHandle	*/

     	    (#xAA03 
     	    mac2 
     	    nil 
     	    rHndltype 
     	    	(
				) 
			"!NewPixMap")
     	    	
  ;;/* DisposePixMap(pm:PixMapHandle)	*/

     	    (#xAA04 
     	    mac2 
     	    nil 
     	    rDontcare 
     	    	(
     	    	Hndltype
				) 
			"!DisposPixMap")

  ;;/* CopyPixMap(srcPM dstPM:PixMapHandle)	*/

     	    (#xAA05 
     	    mac2 
     	    nil 
     	    rDontcare 
     	    	(
     	    	Hndltype 
     	    	Hndltype
				) 
			"!CopyPixMap")
     	    
  ;;/* SetCPortPix(pm:PixMapHandle)	*/

     	    (#xAA06 
     	    mac2 
     	    nil 
     	    rDontcare 
     	    	(
     	    	Hndltype
				) 
			"!SetCPortPix")

  ;;/* NewPixPat:PixPatHandle	*/

     	    (#xAA07 
     	    mac2 
     	    0 
     	    rHndltype 
				(
				) 
			"!NewPixPat")
     	    
  ;;/* DisposePixPat(pp:PixPatHandle)	*/

     	    (#xAA08 
     	    mac2 
     	    1 
     	    rDontcare 
     	    	(
     	    	Hndltype
				) 
			"!DisposPixPat")

  ;;/* CopyPixPat(srcPP dstPP:PixPatHandle)	*/

     	    (#xAA09 
     	    mac2 
     	    2 
     	    rDontcare 
     	    	(
     	    	Hndltype 
     	    	Hndltype
				) 
			"!CopyPixPat")
     	    
  ;;/* PenPixPat(pp:PixPatHandle)	*/

     	    (#xAA0A 
     	    mac2 
     	    1 
     	    rDontcare 
     	    	(
     	    	Hndltype
				) 
			"!PenPixPat")

  ;;/* BackPixPat(pp:PixPatHandle)	*/

     	    (#xAA0B 
     	    mac2 
     	    1 
     	    rDontcare 
     	    	(
     	    	Hndltype
				) 
			"!BackPixPat")

  ;;/* DisposePixPat(patID:INTEGER):PixPatHandle	*/

     	    (#xAA0C 
     	    mac2 
     	    1 
     	    rHndltype 
     	    	(
     	    	inttype
				) 
			"!GetPixPat")

  ;;/* MakeRGBPat(pp:PixPatHandle myColor:RGBColor)	*/

     	    (#xAA0D 
     	    mac2 
     	    2 
     	    rDontcare 
     	    	(
     	    	Hndltype 
     	    	Colortype			       ;***---***
				) 
			"!MakeRGBPat")
     	    
  ;;/* FillCRect   (r: Rect  pp:PixPatHandle)	*/

     	    (#xAA0E 
     	    mac2 
     	    2 
     	    rDontcare 
     	    	(
     	    	Recttype 
     	    	Hndltype
				) 
			"!FillCRect")
     	    

  ;;/* FillCOval   (r: Rect pp:PixPatHandle)	*/

     	    (#xAA0F 
     	    mac2 
     	    2 
     	    rDontcare 
     	    	(
     	    	Recttype 
     	    	Hndltype
				) 
			"!FillCOval")
     	    

  ;;/* FillCRoundRect   (r: Rect  ovWd ovHt: INTEGER pp:PixPatHandle)	*/

     	    (#xAA10 
     	    mac2 
     	    4 
     	    rDontcare 
     	    	(
     	    	Recttype 
     	    	inttype 
     	    	inttype 
     	    	Hndltype
				) 
			"!FillCRoundRect")
     	    
  ;;/* FillCArc   (r: Rect  startAngle arcAngle: INTEGER pp:PixPatHandle)	*/

     	    (#xAA11 
     	    mac2 
     	    4 
     	    rDontcare 
     	    	(
     	    	Recttype 
     	    	inttype 
     	    	inttype 
     	    	Hndltype
				) 
			"!FillCArc")
     	    
  ;;/* FillCRgn   (rgn: RgnHandle pp:PixPatHandle)	*/

     	    (#xAA12 
     	    mac2 
     	    2 
     	    rDontcare 
     	    	(
     	    	Rgntype 
     	    	Hndltype
				) 
			"!FillCRgn")
     	    

  ;;/* FillCPoly    (poly: PolyHandle pp:PixPatHandle)	*/

     	    (#xAA13 
     	    mac2 
     	    2 
     	    rDontcare 
     	    	(
     	    	Polytype 
     	    	Hndltype
				) 
			"!FillCPoly")
     	    
  ;;/* RGBForeColor(color:RGBColor)	*/

     	    (#xAA14 
     	    mac2 
     	    1 
     	    rDontcare 
     	    	(
     	    	Colortype			       ;***---***
				) 
			"!RGBForeColor")

  ;;/* RGBBackColor(color:RGBColor)	*/

     	    (#xAA15 
     	    mac2 
     	    1 
     	    rDontcare 
     	    	(
     	    	Colortype			       ;***---***
				) 
			"!RGBBackColor")

  ;;/* SetCPixel	*/						

     	    (#xAA16 
     	    mac2 
     	    nil 
     	    rDontcare 
     	    	(
				intType 
				intType 
				ColorType	       ;***---***
				) 
			"!SetCPixel")

  ;;/* GetCPixel						*/

     	    (#xAA17 
     	    mac2 
     	    nil 
     	    rDontCare				       ;***---***DB 8/17/88
     	    	(
				intType 
				intType
				ColorType	       ;***---***
				) 
			"!GetCPixel")

  ;;/* GetCTable						*/

     	    (#xAA18 
     	    mac2 
     	    1 
     	    rHndlType 
     	    	(
				intType
				) 
			"!GetCTable")

  ;;/* GetForeColor					*/

     	    (#xAA19 
     	    mac2 
     	    1 
     	    rDontcare 
     	    	(
		 ColorType			       ;***---***
				) 
			"!GetForeColor")

  ;;/* GetBackColor					*/

     	    (#xAA1A 
     	    mac2 
     	    1 
     	    rDontcare 
     	    	(
				ColorType	       ;***---***
				) 
			"!GetBackColor")

  ;;/* GetCCursor						*/

     	    (#xAA1B 
     	    mac2 
     	    1 
     	    rHndlType 
     	    	(
				intType
				) 
			"!GetCCursor")

  ;;/* SetCCursor						*/

     	    (#xAA1C 
     	    mac2 
     	    1 
     	    rDontcare 
     	    	(
				hndlType
				) 
			"!SetCCursor")

  ;;/* AllocCursor					*/

     	    (#xAA1D 
     	    mac2 
     	    0 
     	    rDontcare 
     	    	(
				) 
			"!AllocCursor")

  ;;/* GetCIcon						*/

     	    (#xAA1E 
     	    mac2 
     	    1 
     	    rHndlType 
     	    	(
				intType
				) 
			"!GetCIcon")

  ;;/* PlotCIcon						*/

     	    (#xAA1F 
     	    mac2 
     	    2 
     	    rDontcare 
     	    	(
				rectType 
				hndlType
				) 
			"!PlotCIcon")

  ;;/* OpenCPicture					*/

     	    (#xAA20 
     	    mac2 
     	    1 
     	    rDontcare 
     	    	(
				hndlType
				) 
			"!OpenCPicture")

  ;;/* InitGDevice					*/

     	    (#xAA2E 
     	    mac2 
     	    3 
     	    rDontcare 
     	    	(
				intType 
				lngintType 
				hndlType
				) 
			"!InitGDevice")

  ;;/* NewGDevice						*/

     	    (#xAA2F 
     	    mac2 
     	    2 
     	    rHndlType 
     	    	(
				intType 
				lngintType
				) 
			"!NewGDevice")

  ;;/* DisposGDevice					*/

     	    (#xAA30 
     	    mac2 
     	    0 
     	    rHndlType 
     	    	(
				) 
			"!DisposGDevice")

  ;;/* SetGDevice						*/

     	    (#xAA31 
     	    mac2 
     	    1 
     	    rDontcare 
     	    	(
				hndlType
				) 
			"!SetGDevice")

  ;;/* GetGDevice						*/

     	    (#xAA32 
     	    mac2 
     	    1 
     	    rHndlType				       ;***---***
     	    	(
				) 
			"!GetGDevice")

  ;;/* Color2Index					*/

     	    (#xAA33 
     	    mac2 
     	    1 
     	    rLngIntType                             ; ***---*** rwr 8/28/88
     	    	(
				ColorType	       ;***---***
				) 
			"!Color2Index")

  ;;/* Index2Color					*/

     	    (#xAA34 
     	    mac2 
     	    1 
     	    rDontcare 
     	    	(
		 lnginttype			       ;***---***
		 ColorType			       ;***---***
				) 
			"!Index2Color")

  ;;/* InvertColor					*/

     	    (#xAA35 
     	    mac2 
     	    nil 
     	    rDontcare 
     	    	(
		 ColorType			       ;***---***
				) 
			"!InvertColor")

  ;;/* RealColor						*/

     	    (#xAA36 
     	    mac2 
     	    nil 
     	    rBoolType 
     	    	(
		 ColorType			       ;***---***
				) 
			"!RealColor")

  ;;/* GetSubTable					*/

     	    (#xAA37 
     	    mac2 
     	    3 
     	    rDontcare 
     	    	(
				hndlType              ;***---*** 8/28/88 rwr
				intType 
				hndlType
				) 
			"!GetSubTable")

  ;;/* UpdatePixMap					*/

     	    (#xAA38 
     	    mac2 
     	    0 
     	    rDontcare 
     	    	(
				) 
			"!UpdatePixMap")

  ;;/* MakeITable						*/

     	    (#xAA39 
     	    mac2+SaveQdError 
     	    3 
     	    rDontcare 
     	    	(
				hndlType 
				hndlType 
				intType
				) 
			"!MakeITable")

  ;;/* AddSearch						*/

     	    (#xAA3A 
     	    mac2 
     	    1 
     	    rDontcare 
     	    	(
				ptrType
				) 
			"!AddSearch")

  ;;/* AddComp						*/

     	    (#xAA3B 
     	    mac2 
     	    1 
     	    rDontcare 
     	    	(
				ptrType
				) 
			"!AddComp")

  ;;/* SetClientID					*/

     	    (#xAA3C 
     	    mac2 
     	    1 
     	    rDontcare 
     	    	(
				intType
				) 
			"!SetClientID")

  ;;/* ProtectEntry					*/

     	    (#xAA3D 
     	    mac2 
     	    2 
     	    rDontcare 
     	    	(
				intType 
				boolType
				) 
			"!ProtectEntry")

  ;;/* ReserveEntry					*/

     	    (#xAA3E 
     	    mac2+SaveQdError 
     	    2 
     	    rDontcare 
     	    	(
				intType 
				boolType
				) 
			"!ReserveEntry")

  ;;/* SetEntry						*/

     	    (#xAA3F 
     	    mac2 
     	    3 
     	    rDontcare 
     	    	(
				intType 
				ptrType 
				boolType
				) 
			"!SetEntry")

  ;;/* QDError						*/

     	    (#xAA40 
     	    mac2 
     	    0 
     	    rIntType 
     	    	(
				) 
			"!QDError")


  ;;/* SetCWinColor  (theWindow: WindowPtr  newColorTable: cTabHandle)	*/

     	    (#xAA41 
     	    mac2 
     	    2 
     	    rDontcare 
     	    	(
     	    	WindowRectype 
     	    	hndlType
				) 
			"!SetWinColor")

  ;;/*  GetAuxWin						*/

     	    (#xAA42 
     	    mac2 
     	    2 
     	    rBoolType 
     	    	(
				WindowRectype 
				VHndlType
				) 
			"!GetAuxWin")

  ;;/*  SetCtlColor					*/

     	    (#xAA43 
     	    mac2 
     	    2 
     	    rDontcare 
     	    	(
				CntlHndltype 
				hndlType
				) 
			"!SetCtlColor")

  ;;/*  GetAuxCtl						*/

     	    (#xAA44 
     	    mac2 
     	    2 
     	    rBoolType 
     	    	(
				CntlHndltype 
				VHndlType
				) 
			"!GetAuxCtl")

    	    
  ;;/*  NewCWindow(wStorage:Ptr boundsRect: Rect title:Str255 visible:BOOLEAN theProc:INTEGER	*/
  ;;/*   behind:WindowPtr goAwayFlag:BOOLEAN refCon:LongInt): cWindowPtr	*/

     	    (#xAA45 
     	    mac2 
     	    8 
     	    rwindPtrtype 
     	    	(
     	    	ptrtype 
     	   		Recttype 
     	    	Strtype 
     	    	Booltype 
     	    	inttype 
     	    	ptrtype 
     	    	Booltype 
     	    	lngInttype
				) 
			"!NewCWindow")
			
  ;;/*  GetNewCWindow					*/

     	    (#xAA46 
     	    mac2 
     	    3 
     	    rwindPtrtype 
     	    	(
				intType 
				ptrType 
				ptrType
				) 
			"!GetNewCWindow")

  ;;/*  SetDeskCPat					*/

     	    (#xAA47 
     	    mac2 
     	    nil 
     	    rDontcare 
     	    	(
				HndlType	       ;***---***
				) 
			"!SetDeskCPat")


  ;;/* GetColor                     */
          (#xA82E 		         ;;/* _Pack12 */
          selector 
          9 
     		    rBooltype 
				(
     		    Pttype 
     		    Strtype 
     		    Colortype			       ;***---***
     		    ColorType			       ;***---***
				) 
				"!GetColor")
				
  ;;/*  DelMCEntries					*/

     	    (#xAA60 
     	    mac2 
     	    2 
     	    rDontcare 
     	    	(
				intType 
				intType
				) 
			"!DelMCEntries")

  ;;/*  GetMCInfo						*/

     	    (#xAA61 
     	    mac2 
     	    0 
     	    rHndlType 
     	    	(
				) 
			"!GetMCInfo")

  ;;/*  SetMCInfo						*/

     	    (#xAA62 
     	    mac2 
     	    1 
     	    rDontcare 
     	    	(
				hndlType
				) 
			"!SetMCInfo")

  ;;/*  DispMCInfo						*/

     	    (#xAA63 
     	    mac2 
     	    1 
     	    rDontcare 
     	    	(
				hndlType
				) 
			"!DispMCInfo")

  ;;/*  GetMCEntry						*/

     	    (#xAA64 
     	    mac2 
     	    2 
     	    rPtrType 
     	    	(
				intType 
				intType
				) 
			"!GetMCEntry")

  ;;/* PopUpMenuSelect (menu: MenuHandle  top  left  popUpItem: INTEGER): LONGINT */

     	    (#xA80B 
     	    mac2 
     	    4 
     		    rMVInttype 
     	    	(
				MenuhndleType	       ;***---***
				intType 
				intType 
				intType
				) 
			"!PopUpMenuSelect")

  ;;/*  SetMCEntries					*/

	  (#xAA65				       ; MACTOOLBOX-1-19
	   mac2 
	   3 
	   rDontcare 
	   (
	    intType 
	    ptrType
	    ) 
	   "!SetMCEntries")


  ;;/*  Sound Manager Traps  DB - 1/25/88    */

  ;;/*	FUNCTION SndDoCommand(chan: SndChannelPtr  cmd: SndCommand  noWait: BOOLEAN): OSErr  */

		  ;;/* INLINE $A803  */
		
  ;;/*	FUNCTION SndDoImmediate(chan: SndChannelPtr  cmd: SndCommand): OSErr  */
		  ;;/* INLINE $A804  */
		
  ;;/*	FUNCTION SndAddModifier(chan: SndChannelPtr  modifierCode: ProcPtr  id: INTEGER  init: LONGINT): OSErr  */
		  ;;/* INLINE $A802  */
		
  ;;/*	FUNCTION SndNewChannel(VAR chan: SndChannelPtr  synth: INTEGER  init: LONGINT  userRoutine: ProcPtr): OSErr  */
		  ;;/* INLINE $A807  */
		
     	    (#xA807 
     	    mac2 
     	    4 
     		    rinttype 
     	    	(
				VptrType 
				inttype 
				LngIntType 
				ptrtype
				) 
			"!SndNewChannel")
		
  ;;/*	FUNCTION SndDisposeChannel(chan: SndChannelPtr  killNow: BOOLEAN): OSErr  */
		  ;;/* INLINE $A801  */
		
  ;;/*	FUNCTION SndPlay(chan: SndChannelPtr  sList: Handle  async: BOOLEAN): OSErr  */
		  ;;/* INLINE $A805  */

     	    (#xA805 
     	    mac2 
     	    3 
     		    rinttype 
     	    	(
				ptrType 
				hndltype 
				Booltype
				) 
			"!SndPlay"

  ;;/*	FUNCTION SndControl(id: INTEGER  VAR cmd: SndCommand): OSErr  */
		  ;;/* INLINE $A806  */
	)

          (#xA860				       ; ***---***
          nil 
          nil 
     		    rBooltype 
				(
     		    inttype 
     		    VEvtRectype
		    LngIntType
		    RgnType			       ; Really is a Region
     		    ) 
				"!WaitNextEventInternal")

		(#x0 
		Pascall 
		nil 
			rlngInttype 
			 (
			ptrtype 
			LngIntType
			) 
			"Fetch-internal")
			
			
		(#x1 
		Pascall 
		nil 
			rInttype 
			 (
			ptrtype 
			LngIntType
			) 
			"FetchWord-internal")

		(#x2 
		Pascall 
		nil 
			rInttype 
			 (
			ptrtype 
			LngIntType
			) 
			"FetchByte-internal")

		(#x3 
		Pascall 
		nil 
			rlngInttype 
			 (
			hndltype 
			LngIntType
			) 
			"FetchHandle-internal")
			
			
		(#x4 
		Pascall 
		nil 
			rInttype 
			 (
			hndltype 
			LngIntType
			) 
			"FetchWordHandle-internal")

		(#x5 
		Pascall 
		nil 
			rInttype 
			 (
			hndltype 
			LngIntType
			) 
			"FetchByteHandle-internal")
			
		(#x6 
		Pascall 
		nil 
			rdontcare 
			 (
			ptrtype 
			LngIntType 
			LngIntType
			) 
			"Stow-internal")
			
			
		(#x7
		Pascall 
		nil 
			rdontcare 
			 (
			ptrtype 
			LngIntType 
			inttype
			) 
			"StowWord-internal")

		(#x8 
		Pascall 
		nil 
			rdontcare 
			 (
			ptrtype 
			LngIntType 
			inttype
			) 
			"StowByte-internal")

		(#x9 
		Pascall 
		nil 
			rdontcare 
			 (
			hndltype 
			LngIntType 
			LngIntType
			) 
			"StowHandle-internal")
			
		(#xA 
		Pascall 
		nil 
			rdontcare 
			 (
			hndltype 
			LngIntType 
			IntType
			) 
			"StowWordHandle-internal")

		(#xB 
		Pascall 
		nil
			rdontcare 
			 (
			hndltype 
			LngIntType 
			IntType
			) 
			"StowByteHandle-internal")
		
		(#xC 
		Pascall 
		nil
			rdontcare 
			 (
			ptrtype 
			LngIntType 
			vrectType
			) 
			"FetchRect")

		(#xD 
		Pascall 
		nil
			rdontcare 
			 (
			hndltype 
			LngIntType 
			vrectType
			) 
			"FetchRectHandle")

		(#xE
		Pascall
		nil
			rdontcare
			(
			)
			"!PrOpen")
			
		(#xF
		Pascall
		nil
			rdontcare
			(
			)
			"!PrClose")

	   (#x10
		Pascall
		nil
			rdontcare
			(
			THPrinttype
			)
			"!PrintDefault")

	   (#x11
		Pascall
		nil
			rbooltype
			(
			THPrinttype
			)
			"!PrValidate")
		
	   (#x12
		Pascall
		nil
			rbooltype
			(
			THPrinttype
			)
			"!PrSTLDialog")
		
	  (#x13
		Pascall
		nil
			rbooltype
			(
			THprinttype
			)
			"!PrJobDialog")
			
			
	  (#x14
		Pascall
		nil
			rdontcare
			(
			THPrinttype
			THPrinttype
			)
			"!PrJobMerge")

	  (#x15
		Pascall
		nil
			rptrtype
			(
			THPrinttype
			grafporttype
			ptrtype
			)
			"!PrOpenDoc")

	  (#x16
		Pascall
		nil
			rdontcare
			(
			grafporttype
			recttype
			)
			"!PrOpenPage")
			
	  (#x17
		Pascall
		nil
			rdontcare
			(
			grafporttype
			)
			"!PrClosePage")
			
	  (#x18
		Pascall
		nil
			rdontcare
			(
			grafporttype
			)
			"!PrCloseDoc")	
			
	
			
		(#x19
		Pascall
		nil
			rdontcare
			(
			THPrinttype
			grafporttype
			ptrtype
			ptrtype
			TPrStatustype
			)
			"!PrPicFile")

	  (#x1A
		Pascall
		nil
			rinttype
			(
			)
			"!PrError")

	  (#x1B
		Pascall
		nil
			rdontcare
			(
			inttype
			)
			"!PrSetError")

		(#x1C
		Pascall
		nil
			rdontcare
			(
			)
			"!PrDrvrOpen")
			
		(#x1D
		Pascall
		nil
			rdontcare
			(
			)
			"!PrDrvrClose")

	  (#x1E
		Pascall
		nil
			rdontcare
			(
			inttype
			lnginttype
			lnginttype
			lnginttype
			)
			"!PrCtlCall")
			
          (#x1F
		Pascall
		nil
			rhndltype
			(
			)
			"!PrDrvrDCE")
			
		(#x20
		Pascall
		nil
			rinttype
			(
			)
			"!PrDrvrVers")
			
		(#x21
		Pascall
		nil
			rdontcare
			(
			HndlPtrtype
			)
			"!PrGeneral")
			
	

     	    (#xAA25 
     	    mac2 
     	    nil 
     	    rdontCare 
     	    	(
				HndlType
				) 
			"!DisposCIcon")

     	    (#xAA24 
     	    mac2 
     	    nil 
     	    rdontCare 
     	    	(
				HndlType
				) 
			"!DisposCTable")

     	    (#xAA26 
     	    mac2 
     	    nil 
     	    rdontCare 
     	    	(
				HndlType
				) 
			"!DisposCCursor")

     	    (#xAA23 
     	    mac2 
     	    nil 
     	    rdontCare 
     	    	(
				LngIntType
				) 
			"!CharExtra")

     	    (#xAA22 
     	    mac2 
     	    nil 
     	    rdontCare 
     	    	(
				ColorType
				) 
			"!HiliteColor")

	    (#xAA21 
     	    mac2 
     	    nil 
     	    rdontCare 
     	    	(
				ColorType
				) 
			"!OpColor")
	    
     	    (#xAA06 
     	    mac2 
     	    nil 
     	    rdontCare 
     	    	(
				HndlType
				) 
			"!SetPortPix")
	    
     	    (#xAA4F  
     	    mac2 
     	    nil 
     	    rdontCare 
     	    	(
				BitMapType
				BitMapType
				RectType
				RectType
				ColorType
				PtrType
				LngIntType
				) 
			"!CalcCMask")
     	    (#xAA50  
     	    mac2 
     	    nil 
     	    rdontCare 
     	    	(
				BitMapType
				BitMapType
				RectType
				RectType
				IntType
				IntType
				PtrType
				LngIntType
				) 
			"!SeedCFill")
     	    (#xAA4E  
     	    mac2 
     	    nil 
     	    rdontCare 
     	    	(
		                PtrType
				) 
			"!SetStdCProcs")

	    (#xA808
	     mac2
             nil
             rdontcare
	        (
	        inttype
		)
		"!InitProcMenu")

	    (#xAA66
              mac2
              nil
              rMVIntType
               (
                )
               "!MenuChoice")
	    
            (#xA84E
             mac2
             nil
             rdontcare
                (
                MenuHndleType
		inttype
		vCharType)
		"!GetItemCmd")

            (#xA84F
             mac2
             nil
             rdontcare
                (
                MenuHndleType
		inttype
		CharType)
		"!SetItemCmd")

	   (#xA80C
             mac2+SaveResError
             nil
             rhndlType
                (
		 ResTypeType
		 inttype
		 )
		"!RGetResource")

;;; 8/22/88 rwr  ***---***   Added the following traps

          (#xAA4B
          nil 
          nil 
     		    rDialogRectype 
				(
     		    ptrtype 
     		    Recttype 
     		    Strtype 
     		    Booltype 
     		    inttype 
     		    ptrtype 
     		    Booltype 
     		    lngInttype 
     		    Hndltype			       
				) 
				"!NewCDialog")

          (#xA978
          nil 
          nil 
     		    rDontcare 
				(
		    DialogRecType
		    rgntype
				) 
				"!UpdtDialog")

	       (#xA067
		nil
                nil
		 rintinD0
		 (
                 hndltype
                 )
                "!HSetRBit")

	       (#xA068
		nil
                nil
		 rintinD0
		 (
                 hndltype
                 )
                "!HClrRBit")
	       
               (#xAA94
                nil
                nil
                 rdontcare
		 (
                 WindowRecType
                 )
                 "!ActivatePalette")

               (#xAA99
                nil
                nil
                 rdontcare
                 (
                  WindowRecType
                  inttype
                  colortype
                 )
                 "!AnimateEntry")

               (#xAA9A
               nil
               nil
                rdontcare
                (
                 WindowRecType
                 hndltype
                 inttype
                 inttype
                 inttype
                )
                "!AnimatePalette")

               (#xAA9F
                nil
                nil
                 rdontcare
                 (
                  hndltype
		  hndltype
                  inttype
                  inttype
                 )
                "!CTab2Palette")

                (#xAA93
                 nil 
                 nil
                  rdontcare
                  (
                   hndltype
                  )
                "!DisposePalette")
    
               (#xAA9B      
                nil
                nil
                 rdontcare
                 (
                  hndltype
                  inttype
                  colortype
                 )
                "!GetEntryColor")

               (#xAA9D
                nil 
                nil
                 rdontcare
                (
                 hndltype
                 inttype
                 vinttype
                 vinttype
                )
                "!GetEntryUsage")

	       (#xAA92
		nil
		nil
		rhndltype
		(
		 inttype
		 )
		"!GetNewPalette")

	      (#xAA96
	       nil
	       nil
	       rhndltype
	       (
		WindowRecType
		)
	       "!GetPalette")

	      (#xAA91
	       nil
	       nil
	       rhndltype
	       (
		inttype
		colortype
		inttype
		inttype
		)
	       "!NewPalette")

	      (#xAAA0
	       nil
	       nil
	       rdontcare
	       (
		hndltype
		colortype
		)
	       "!Palette2CTab")
	      
	      (#xAA98
	       nil
	       nil
	       rdontcare
	       (
		inttype
		)
	       "!PmBackColor")

	      (#xAA97
	       nil
	       nil
	       rdontcare
	       (
		inttype
		)
	       "!PmForeColor")

	      (#xAA9C
	       nil
	       nil
	       rdontcare
	       (
		hndltype
		inttype
		colortype
		)
	       "!SetEntryColor")
	      
	      (#xAA9E
	       nil
	       nil
	       rdontcare
	       (
		hndltype
		inttype
		inttype
		inttype
		)
	       "!SetEntryUsage")

	      (#xAA95
	       nil
	       nil
	       rdontcare
	       (
		WindowRecType
		hndltype
		booltype
		)
	       "!SetPalette")

          (#xA82E
          selector 
          1 
	  rinttype 
	  (
	   lnginttype
	   ) 
	  "!Fix2SmallFract")

          (#xA82E
          selector 
          2 
	  rlnginttype 
	  (
	   inttype
	   ) 
	  "!SmallFract2Fix")

	  (#xA82E
          selector 
          3 
	  rdontcare 
	  (
	   hndlptrtype
	   colortype
	   ) 
	  "!CMY2RGB")

	  (#xA82E
          selector 
          4 
	  rdontcare 
	  (
	   colortype
	   hndlptrtype
	   ) 
	  "!RGB2CMY")

	  (#xA82E
          selector 
          5 
	  rdontcare 
	  (
	   hndlptrtype
	   colortype
	   ) 
	  "!HSL2RGB")

	  (#xA82E
          selector 
          6 
	  rdontcare 
	  (
	   colortype
	   hndlptrtype
	   ) 
	  "!RGB2HSL")

	  (#xA82E
          selector 
          7 
	  rdontcare 
	  (
	   hndlptrtype
	   colortype
	   ) 
	  "!HSV2RGB")

	  (#xA82E
          selector 
          8 
	  rdontcare 
	  (
	   colortype
	   hndlptrtype
	   ) 
	  "!RGB2HSV")

	  (#xA80A
	   nil
	   nil
	   rinttype
	   (
	    WindowRecType
	    )
	   "!GetWVariant")

	  (#xAA48
	   nil
	   nil
	   rdontcare
	   (
	    vPtrtype
	    )
	   "!GetCWMgrPort")

	  (#xA809
	   nil
	   nil
	   rinttype
	   (
	    CntlHndlType
	    )
	   "!GetCVariant")

	  (#xA96D
	   nil
	   nil
	   rdontcare
	   (
	    CntlHndlType
	    )
	   "!Draw1Control")

	  (#xA953
	   nil
	   nil
	   rdontcare
	   (
	    WindowRecType
	    Rgntype
	    )
	   "!UpdtControl")

	   (#xAA28
	    nil
	    nil
	       rlnginttype
	       (
		)
	       "!GetCTSeed")

	   (#xAA3F
	    nil
	    nil
	       rdontcare
	       (
		inttype
		inttype
		ptrtype
		)
	       "!SetEntries")

	   (#xAA49
	    mac2+SaveQdError
	    nil
	       rdontcare
	       (
		hndltype
		hndltype
		vptrtype
		)
	       "!SaveEntries")

	   (#xAA4A
	    nil
	    nil
	       rdontcare
	       (
		hndltype
		hndltype
		vptrtype
		)
	       "!RestoreEntries")

	   (#xAA4C
	    nil
	    nil
	       rdontcare
	       (
		ptrtype
		)
	       "!DelSearch")

	   (#xAA4D
	    nil
	    nil
	       rdontcare
	       (
		ptrtype
		)
	       "!DelComp")

		(#x22 
		 Pascall 
		 nil 
		 rResultCodeInD0 
		 (
		  PtrInA0 
		  PtrInA1 
		  LongInD0
		  ) 
		 "block-swap-16b")

		(#x23 
		 Pascall 
		 nil 
		 rResultCodeInD0 
		 (
		  PtrInA0 
		  PtrInA1 
		  LongInD0
		  ) 
		 "block-swap-32b")

		(#xA9F4
		 nil
		 nil
		        rdontcare
			()
			"!ExitToShell")

		;; Async device manager traps
		
		(#xa400 
		 nil 
		 nil 
		 rDontCare 
		 (
		  ioParamInA0
		  ) 
		 "!Open_async")
		
		
		(#xa401 
		 nil 
		 nil 
		 rDontCare 
		 (
		  ioParamInA0
		  ) 
		 "!Close_async")
		
		
		(#xa402 
		 nil 
		 nil 
		 rDontCare 
		 (
		  ioParamInA0
		  ) 
		 "!Read_async")
		
		
		(#xa403 
		 nil 
		 nil 
		 rDontCare 
		 (
		  ioParamInA0
		  ) 
		 "!Write_async")
		
		
		(#xa404 
		 nil 
		 nil 
		 rDontCare 
		 (
		  ioParamInA0
		  ) 
		 "!Control_async")
		
		
		(#xa405 
		 nil 
		 nil 
		 rDontCare 
		 (
		  ioParamInA0
		  ) 
		 "!Status_async")
		
		
		(#xa406 
		 nil 
		 nil 
		 rDontCare 
				(
     		    ioParamInA0
				) 
				"!KillIO_async")
          (#xa407 
          nil 
          nil 
     		    rDontCare 
				(
     		    ioParamInA0
				) 
				"!GetVolInfo_async")

     	  
          (#xa408 
          nil 
          nil 
     		    rDontCare 
				(
     		    ioParamInA0
				) 
				"!Create_async")

     	  
          (#xa409 
          nil 
          nil 
     		    rDontCare 
				(
     		    ioParamInA0
				) 
				"!Delete_async")

     	  
          (#xa40A 
          nil 
          nil 
     		    rDontCare 
				(
     		    ioParamInA0
				) 
				"!OpenRF_async")

     	  
          (#xa40B 
          nil 
          nil 
     		    rDontCare 
				(
     		    ioParamInA0
				) 
				"!ReName_async")

     	  
          (#xa40C 
          nil 
          nil 
     		    rDontCare 
				(
     		    ioParamInA0
				) 
				"!GetFileInfo_async")

     	  
          (#xa40D 
          nil 
          nil 
     		    rDontCare 
				(
     		    ioParamInA0
				) 
				"!SetFileInfo_async")

     	  
          (#xa40E 
          nil 
          nil 
     		    rDontCare 
				(
     		    ioParamInA0
				) 
				"!UnMountVol_async")

     	  
          (#xa40F 
          nil 
          nil 
     		    rDontCare 
				(
     		    ioParamInA0
				) 
				"!MountVol_async")

     	  
          (#xa410 
          nil 
          nil 
     		    rDontCare 
				(
     		    ioParamInA0
				) 
				"!Allocate_async")

     	  
          (#xa411 
          nil 
          nil 
     		    rDontCare 
				(
     		    ioParamInA0
				) 
				"!GetEOF_async")

     	  
          (#xa412 
          nil 
          nil 
     		    rDontCare 
				(
     		    ioParamInA0
				) 
				"!SetEOF_async")

     	  
          (#xa413 
          nil 
          nil 
     		    rDontCare 
				(
     		    ioParamInA0
				) 
				"!FlushVol_async")

     	  
          (#xa414 
          nil 
          nil 
     		    rDontCare 
				(
     		    ioParamInA0
				) 
				"!GetVol_async")

     	  
          (#xa415 
          nil 
          nil 
     		    rDontCare 
				(
     		    ioParamInA0
				) 
				"!SetVol_async")

     	  
          (#xa416 
          nil 
          nil 
     		    rDontCare 
				(
				) 
				"!InitQueue_async")

     	  
          (#xa417 
          nil 
          nil 
     		    rDontCare 
				(
     		    ioParamInA0
				) 
				"!Eject_async")

     	  
          (#xa418 
          nil 
          nil 
     		    rDontCare 
				(
     		    ioParamInA0
				) 
				"!GetFPos_async")
	  (#x24
	   pascall
	   nil
	   rinttype
	   (
	    intType
	    )
	   "!RamSDOpen")

	  (#x25
	   pascall
	   nil
	   rinttype
	   (
	    intType
	    )
	   "!RamSDClose")
	  
	  (#x26
	   pascall
	   nil 
	   rDontcare 
	   (
	    ptrType
	    ) 
	   "serial-read")
	) 
)




