;;; -*- Mode:Common-Lisp; Package:MACTOOLBOX; Base:10 -*-

;;; For the puposes of the Texas Instruments Contract, this software is in
;;; TBI Category "B". Copyright (C) 1988, 1987, ExperTelligence Incorporated.

;/*                                                                       */
;/*                      RESTRICTED RIGHTS LEGEND                         */
;/*                                                                       */
;/* Use, duplication, or disclosure by the Government is subject to       */
;/* restrictions as set forth in subdivision (c)(1)(ii) of the Rights in  */
;/* Technical Data and Computer Software clause at 52.227-7013.           */
;/*                                                                       */
;/*                           EXPERTELLIGENCE                             */
;/*                            5638 HOLLISTER                             */
;/*                          GOLETA, CA  93117                            */
;/*                                                                       */
;/*  Copyright (C) 1987-1989 EXPERTELLIGENCE Incorporated.                */
;/*  All rights reserved.                                                 */
;/*                                                                       */

;;; This file contains various forms which, for one reason or another, cannot
;;; or should not be compiled or loaded on an Explorer.  Instead, they should
;;; be loaded only on a microExplorer.


;;; from EXPER-TOOLBOX-INTERFACE
(setf (send (add:find-channel 8) :max-queue-length) 10)
(delete-initialization "Clear toolbox constants" 
		       :before-cold)
(add-initialization    "Clear toolbox constants" '(clear-toolbox-constants)
		       :before-cold)

;;; since this file is not loaded during compile, we won't get these obsolete
;;; warnings during compile.
(let ((lst '(GETFONTNAME GETWTITLE GETITEM GETCTITLE GETITEXT GETINDTYPE
			 GETRESINFO IUDATESTRING IUDATEPSTRING IUTIMESTRING
			 IUTIMEPSTRING GET1INDTYPE PTTOANGLE GETFNUM GETITEMICON
			 GETITEMSTYLE GETITEMMARK DIALOGSELECT GETDITEM
			 MODALDIALOG GETSCRAP SCSICOMPLETE LGETCELL
			 FindWindow FindControl
			 LFIND GETITEMCMD GETENTRYUSAGE GETWMGRPORT GETCWMGRPORT)))
  (export lst)
  (dolist (i lst)
    (compiler::make-obsolete-1
      (intern (string-append "!" i) 'tb)
      (format nil "by using ~s instead, VAR variables are not required." i)))
  )

(si:make-obsolete !GetPort
		  "by using GETPORT, the returned window will be EQ to the one which was returned when it was created")

(let ((lst '(GetResource Get1Resource RGetResource)))
  (export lst)
  (dolist (i lst)
    (compiler::make-obsolete-1
      (intern (string-append "!" i) 'tb)
      (format nil "by using ~s, nil handles will signal a resNotFound error" i)))
  )

(let ((lst '(!FixRatio !FixMul !FixRound !BitTst !BitSet !BitClr !BitAnd !BitOr
		       !BitXor !BitNot !BitShift !HiWord !LoWord !LongMul
		       !DeltaPoint !SlopeFromAngle !AngleFromSlope
		       !Long2Fix !Fix2Long !Fix2Frac !Frac2Fix !Fix2X !X2Fix
		       !Frac2X !X2Frac !FracCos !FracSin !FracSqrt !FracMul
		       !FracDiv !FixAtan2 !FixDiv !Fix2SmallFract !SmallFract2Fix
		       !NumToString !StringToNum !EqualString !UprString)))
  (dolist (i lst)
    (compiler::make-obsolete-1
      i
      (format nil "please use a lisp function instead" i)))
  )

(let ((lst '((!SetRect (rect :set))
	     (!OffsetRect (rect :offset))
	     (!InSetRect (rect :inset))
	     (!SectRect (rect :intersection))
	     (!UnionRect (rect :union))
	     (!PtInRect (rect :inside-p))
	     (!Pt2Rect (rect :set))
	     (!EqualRect (rect :equal))
	     (!EmptyRect (rect :empty-p))
	     (!AddPt (point :add))
	     (!SubPt (point :sub))
	     (!SetPt (point :set))
	     (!EqualPt (point :equal))
	     (!ScalePt (point :scale))
	     (!MapPt  (point :map))
	     (!MapRect (rect :map))
	     )))
  (dolist (i lst)
    (compiler::make-obsolete-1
      (first i)
      (format nil "the method ~s is much faster and more general" (second i))))
  )



;;; from MAC-APPLICATION
(delete-initialization "Initialize Application Channels" :system)
(add-initialization "Initialize Application Channels"
		    '(setf  *application-channels*
			    (reverse (dotimes (x *max-number-of-mac-applications*
						 *application-channels*)
				       (push (add:find-channel
					       (+ x *APPLICATION-CHANNEL-OFFSET*))
					     *application-channels*))))
		    '(:system :now))

(delete-initialization "Setup Toolbox constants" :warm)
(add-initialization "Setup Toolbox constants"
		    '(initialize-toolbox-constants)
		    '(:warm :now))

(delete-initialization "Reset mac application support" :before-cold)
(add-initialization "Reset mac application support" '(mac-application-cleanup nil)
		    :before-cold)

;;; The following DEFMETHOD is in this file (while the DEFUN of MISC-HANDLER-OPCODE-15
;;; is in MAC-APPLICATIONS because this method cannot be compiled on an Explorer.  Instead,
;;; it must be compiled on a microExplorer.
(compile (defmethod (add:MISC-HANDLER :CASE :HANDLE-OPCODE 15) (cmd)
	   (misc-handler-opcode-15 cmd)))
