;;; -*- Mode:Common-Lisp; Package:Yes-Way; Base:10; Patch-File: t -*-

(setq yw-zwei:*mail-reply-indent-prefix-strings*
      '(">>  " "->  " ">" "--> " "--->" "> ")
)

(setq yw-zwei:*mail-reply-indent-prefix-string-ring*
      (copy-list yw-zwei:*mail-reply-indent-prefix-strings*)
)

(setq *try-to-expose-all-summary-windows-on-mailer-expose* t)
(setq yw-zwei:*address-disposition-notifications-to-suppress* '(:Queued))
(setq yw-zwei:*silent-mail-delivery* :minibuffer)
(setq mail:*use-primary-mail-servers* :always)
(setq yw-zwei:*address-database-path* "x35:rice;address-database.database#1")
(setq *rule-base-path* "x35:rice;rule-base.rule-base#1")
(if nil;(and (not (find-package "SPELLER")) (not (sys:mx-p)))
    (progn (make-system :Spelling-Checker :Noconfirm :Nowarn :Silent)
	   (inside-all-zmacs 
	     (pushnew '((zwei:text-mode) zwei:auto-spell-check-mode)
		      zwei:*initial-minor-modes*
	     )
	   )
    )
    nil
)

(setq yw-zwei:*mail-fonts-attribute-mapping-alist*
      '(
	(fonts:cptfontb  fonts:tr8b)
	(fonts:cptfontcb fonts:tr8b)
	(fonts:cptfontbi fonts:5x5)
	(fonts:cptfonti  fonts:tr8i)
	(fonts:cptfont	 fonts:tvfont)
	(fonts:hl10b	 fonts:tr8b)
	(fonts:hl10	 fonts:hl7)
	(fonts:hl12bi	 fonts:tr8b)
	(fonts:hl12b	 fonts:tr8b)
	(fonts:hl12i	 fonts:tr8i)
	(fonts:hl12	 fonts:hl7)
	(fonts:medfnt	 fonts:tvfont)
	(fonts:metsb	 fonts:tr8b)
	(fonts:metsi	 fonts:tr8i)
	(fonts:mets	 fonts:tvfont)
	(fonts:tr10bi	 fonts:tr8i)
	(fonts:tr10b	 fonts:tr8b)
	(fonts:tr10i	 fonts:tr8i)
	(fonts:tr10	 fonts:tr8)
	(fonts:tr12bi	 fonts:tr8i)
	(fonts:tr12b	 fonts:tr8b)
	(fonts:tr12i	 fonts:tr8i)
	(fonts:tr12	 fonts:tr8)
       )
)
(setq *mouse-l-hold-drag-selection-enabled* t)
(setq fs:*merge-unix-types* t)
;(setq fs:*merge-unix-types* nil)
(setq *indent-text-for-message-replies* t)
(setq *include-source-header-in-reply* nil)
(setq *split-screen-for-message-replies* nil)
(setq mail:*user-mail-address* "James Rice <Rice@Sumex-AIM.Stanford.Edu>")
(setq yw-zwei:*mail-reply-indent-rejustify-right-margin* 59)
(setq *Default-Daemon-Actions*
	'((:Get-Unseen-Bodies :all)
	  (:Get-Selected-Bodies)
	  (:Get-Nearby-Bodies 3)
	  (:Get-Nearby-Bodies 3 :backwards)
	  (:Get-Headers 100 :Backwards)
	  (:Get-Recent-Bodies)
	  (:bodies-present)
	  (:Get-And-Cache-Directory-For-Completion)
	 )
)
(setq zwei:*default-bcc-string*
      "Outgoing Mail <Rice-Msgs@Sumex-Aim.Stanford.Edu>"
)
(setq yw-zwei:*always-use-deduced-prefices* t)
(setq *bboard-search-list* '("COMMON-LISP" "COMMONLOOPS" "SU-JOBS" "SU-ETC"))
(setq *netnews-search-list* '("clari.news.gov.state" "clari.news.gov.corrupt"))
(setq *bboard-filter-alist* '(("SU-ETC" uncrispin)))
(deffilter uncrispin
	   (:Printed-Representation "UnCrispin"
	    :Documentation "All messages not from Crispin"
	   )
  (and (recent) (not (from crispin)))
)

(deffilter unseen-to-me (:printed-representation "Personal Unread Mail")
  ;(and (Unseen) (or (to Rice) (cc Rice)))
  "Unseen and (to rice or cc rice)"
)

(deffilter unseen-to-lists (:printed-representation "Group Unread Mail")
  (and (Unseen) (not (or (to Rice) (cc Rice))))
)
(deffilter already-read-mail (:printed-representation "Seen Mail")
  (and (undeleted) (and (unflagged) (seen)))
)

(deffilter marked-mail (:printed-representation "Flagged Mail")
  (and (flagged) (undeleted)))

(setq *summary-windows-to-create-for-mailbox-alist*
     `(("Inbox" ((marked-mail)) ((already-read-mail))))
)
(setq *summary-windows-to-create-for-mailbox-alist*
     `(("Inbox" ((marked-mail))))
)
(setq *summary-windows-to-create-for-mailbox-alist*
     `(("Inbox" ((unseen-to-me)) ((unseen-to-lists))))
)
(setq *summary-windows-to-create-for-mailbox-alist*
     `(("Inbox" ((unseen-to-me)) ((unseen-to-lists)) ((already-read-mail))))
)
(setq *summary-windows-to-create-for-mailbox-alist* nil)

(deffilter special
	   (:Printed-Representation "Special"
	    :Documentation "All messages not from Rice"
	    :Applicable-If
	      #'(lambda (name ignore) (search "LOTUS" name :Test #'char-equal))
	   )
  (not (from Rice))
)
(deffilter magic ()
  (then (and (unseen) (reverse (and (not (deleted)) (to rice))))
	(and (unseen) (and (not (deleted)) (cc rice)))
  )
)
(defun user-find-zmacs-frame ()
  (declare (special *primary-zmacs-frame*))
  (if (boundp '*primary-zmacs-frame*)
      *primary-zmacs-frame*
      (progn (if (not (and (boundp 'Zwei::*All-Zmacs-Windows*)
			   Zwei::*All-Zmacs-Windows*
		      )
		 )
		 (zwei:find-or-create-idle-zmacs-window)
		 nil
	     )
	     (Send (First Zwei::*All-Zmacs-Windows*) :Superior)
      )
  )
)
(setq yw:*basic-header-types-to-filter*
      '(:Received :Return-Path :message-id :Full-Name :Character-Type-Mappings
	:In-Reply-To :Fonts :Posted-Date :Content-Type :X-Fonts
       )
)
(setq yw:*address-header-types-to-filter* '(:Bcc :Sender))
(setq yw:*yw-daemon-sleep-interval* (For-Processor-Type 40 10 20))
(setq *new-headers-window-x-offset* 0)
(setq *new-headers-window-y-offset* -15)
(setq zwei:*unsent-message-query-p* nil)
(setq mail:*try-mail-now-p* nil)
(setq zwei:*reformat-headers-include-list*
      '(:date :from :reply-to :to :cc :subject))
(setq zwei:*reformat-headers-body-goal-column* 9)
(setq zwei:*mail-template-header-body-goal-column* 9)
;(setq zwei:*choose-from-all-mail-keywords-p* t)
(setq zwei::*dont-reply-to*
      '("Rice@Sumex-Aim.Stanford.Edu" "Rice@KSL.Stanford.Edu")
)
(setq *message-header-flags-format-string* "~vA60")
(setq *message-header-length-format-string* "(~@vA)250")
(setq *message-header-from-format-string* "~vA200")
(defmethod yw-header-display-spec
       ((type (eql :from))
        value message-number message-flags message-date message-from message-to
	message-subject message-length-in-chars day month year date-mode-args
       )
  (ignore message-number message-flags message-date message-subject
	  message-length-in-chars day month year date-mode-args message-to
  )
  (let ((me-p (or (search "Rice@Sumex" message-from :Test #'char-equal)
		  (search "James Rice" message-from :Test #'char-equal)
	      )
	)
       )
       (maybe-max-width (if me-p
			    "-> ~vA200" 
			    *message-header-from-format-string*
			)
			value (if me-p message-to message-from)
       )
  )
)
;(defmethod yw-header-display-spec
;       ((type (eql :from))
;        value message-number message-flags message-date message-from message-to
;	message-subject message-length-in-chars day month year date-mode-args
;       )
;  (ignore message-number message-flags message-date message-subject
;	  message-length-in-chars day month year date-mode-args message-to
;  )
;  (let ((me-p (or (search "Rice@Sumex" message-from :Test #'char-equal)
;		  (search "James Rice" message-from :Test #'char-equal)
;	      )
;	)
;       )
;       (maybe-max-width *message-header-from-format-string*
;			(if me-p
;			    (if (consp value)
;			       `(,(first value) nil :Font 2)
;			       `(,value nil :Font 2)
;			    )
;			    value
;			)
;			(if me-p "Me!!!!" message-from)
;       )
;  )
;)

(setq yw:*message-header-display-specification*
     '(:Number 3
       :Space nil
       :Flags (4 nil :Font 2)
       :date :Date-Or-Time
       :from (15 15)
       :length (4 nil :Font 2)
       :Space nil
       :keywords (0 10 :Font 1)
       :Space nil
       :subject 0
      )
)
(defmacro-command interesting (:Keys (#\M-I))
  "Head from lakin
   Read >
  "
)
(setq *user-summary-window-inits* '(:scroll-bar-side :right))
(setq *user-mailbox-selector-inits* '(:scroll-bar-side :right))
(setq *user-system-output-window-inits* '(:scroll-bar-side :right))