;;;-*- Mode:Common-Lisp; Package:USER; Base:10 -*-

;;;                           RESTRICTED RIGHTS LEGEND

;;;Use, duplication, or disclosure by the Government is subject to
;;;restrictions as set forth in subdivision (b)(3)(ii) of the Rights in
;;;Technical Data and Computer Software clause at 52.227-7013.
;;;
;;;                     TEXAS INSTRUMENTS INCORPORATED.
;;;                              P.O. BOX 2909
;;;                           AUSTIN, TEXAS 78769
;;;                                 MS 2151
;;;
;;; Copyright (C) 1988, Texas Instruments Incorporated. All rights reserved.

;;;
;;;   This is the file that will build a band from the minprod ungc'ed band
;;;   Just load it and stand back.
;;;

(WHEN (Y-OR-N-P "Load patches?")
  (si:load-if "sys:cmint_tools;patch-support")
;;;;(si:load-if "sys:cmint_tools;system.system")
  
  (with-band-cleaner
    
    ;; Finish build
    (UNLESS (AND (VARIABLE-BOUNDP *finish-build-run*)
		 *finish-build-run*)
      (unless (fboundp 'si:finish-build)
	(si:load-if "sys:cmint_tools;finish-build" :verbose t))
      (si:finish-build :disk-save nil)		       ;do the clean up
      )
    
;;  (fix-and-load-patches)
    (load-patches :noselective)
    (print-herald t t)
    (print-herald nil nil)
    
    (let ((si:*no-query t))
      (si:unload-file "sys:cmint_tools;finish-build")
      (si:unload-file "sys:cmint_tools;patch-support"))
    
    ;; Tidy up
    (si:BAND-CLEANER :doc-strings nil
		     :unused-pathnames nil
		     :previous-defs t
		     :verbose t)
    
    ))

;;;(unless (fboundp 'si:tree-shake)
;;;  (si:load-if "sys:load-band;tree-shake" :verbose t))
;;;(si:tree-shake :clean-packages (list-all-packages) ;  at least do '("NAME" "FS" "RPC" "NFS")
;;;	       :keep-symbols '( si:dump-objects-in-region si:start-mx-listener
;;;			       name:delete-object add::*MICRONET-RECEIVE-LIST*
;;;			       name:initialize-name-service)
;;;	       :purge-packages (if (si:find-system-named "IP" t t)
;;;				   '("FED" "MT" "SYSLOG")
;;;				   '("FED" "MT" "SYSLOG"
;;;				     "NET" "TELNET" "CHAOS" "ETHERNET" "IP"
;;;				     "PRINTER" "IMAGEN" "MAIL"))
;;;	       :keep-packages '("SYSTEM" "MICRONET")
;;;	       :batch (not selective)
;;;	       :undo-previous-training t
;;;	       :kamikaze t)
;;;(si:unload-file "sys:load-band;tree-shake" :verbose t)

;  ) ;with-band-cleaner

(WHEN (Y-OR-N-P "Do training?")
  (gc-on)
;;  (gc-immediately :max-gen 3)			       ;get this to a manageble size
  (load "sys:training;defsystem" :verbose nil)	       ;get the training stuff
  (format t "~%Enter \"(TRAIN-A-BAND :UNIT-NUMBER <unit> :BAND-NAME <partition>)\" to start training")
  )















