;;; -*- Mode:Common-Lisp; Package:USER; Base:10 -*-

;;;                           RESTRICTED RIGHTS LEGEND

;;;Use, duplication, or disclosure by the Government is subject to
;;;restrictions as set forth in subdivision (c)(1)(ii) of the Rights in
;;;Technical Data and Computer Software clause at 52.227-7013.
;;;
;;;                     TEXAS INSTRUMENTS INCORPORATED.
;;;                              P.O. BOX 2909
;;;                           AUSTIN, TEXAS 78769
;;;                                 MS 2151
;;;
;;; Copyright (C) 1987-1989 Texas Instruments Incorporated. All rights reserved.

;;; Change History (started 10/22/87)
;;; Added Sam variables to defsystem (las - 2/26/88)
;;; Changes for mX (ab 3/10/88)

(defsystem visidoc
  (:name "Visidoc")
  (:nicknames "doc-viewer" "Document Viewer" "dox")
  (:pathname-default "sys:visidoc;")
  (:patchable "sys:patch.visidoc;" patch)
  (:warnings-pathname-default "sys:cwarns;visidoc.lisp")
  (:initial-status :released)
  (:documentation "Display pages of on-line manuals.")
  (:default-menu-column :USER-AIDS)
  (:default-system-key nil)
  (:instance-type :eval)
  (:instance-finder (zwei:view-on-line-documentation :selectp t))
  (:instance-creator nil)
  (:module client "client")
  (:module mixin "image-display-list-mixin")
  (:module diagram "dox-diagram")
  (:module defs "definitions")
  (:module viewer "document-viewer")
  (:module methods "methods")
  (:module mouse "mouse-handler")
  (:module window "window-pane")
  (:module sugg "suggestions-stuff")
  (:module fonts ("load-fonts"))
  (:readfile fonts)
  (:compile-load mixin)  
  (:compile-load diagram
		 ((:fasload mixin) (:readfile fonts))
		 ((:fasload mixin) (:readfile fonts)))
  (:compile-load client)
  (:compile-load defs (:fasload client) (:fasload client))
  (:compile-load mouse (:fasload defs) (:fasload defs))
  (:compile-load window (:fasload defs) (:fasload defs))
  (:compile-load viewer (:fasload diagram defs) (:fasload diagram defs))
  (:compile-load methods (:fasload defs) (:fasload defs))
  (:compile-load sugg  (:fasload defs) (:fasload defs)))
