;;; -*- Mode:Common-Lisp; Package:ZWEI; Fonts:(CPTFONT CPTFONTB CPTFONTBI); Base:10 -*-

;;;                           RESTRICTED RIGHTS LEGEND

;;;Use, duplication, or disclosure by the Government is subject to
;;;restrictions as set forth in subdivision (c)(1)(ii) of the Rights in
;;;Technical Data and Computer Software clause at 52.227-7013.
;;;
;;;                     TEXAS INSTRUMENTS INCORPORATED.
;;;                              P.O. BOX 2909
;;;                           AUSTIN, TEXAS 78769
;;;                                 MS 2151
;;;
;;; Copyright (C) 1987-1989 Texas Instruments Incorporated. All rights reserved.

;;; CHANGE HISTORY started on 10/8/87 by slm

(UNLESS (si:addin-p)
  (PUSHNEW '(zwei:doc-viewer-mode zwei:VISIDOC-commands-menu)
	   sugg:*suggestions-zmacs-modes* :test #'EQUAL))

(WHEN (FBOUNDP 'sugg:suggestions-build-menu)
  (sugg:suggestions-build-menu
    'VISIDOC-commands-menu ""
    '(("Top Level Commands" :no-select ignore :font sugg:menu-subtitle-std-font)
      ("Get New Documentation" . com-doc-viewer-2)
      ("List of Manuals" . com-list-of-manuals)
      ("Table of Contents" . com-table-of-contents)
      ("Find..." . com-doc-viewer-apropos)
      ("" :no-select ignore)
      ("Viewing Commands" :no-select ignore :font sugg:menu-subtitle-std-font)
      ("View Next Topic" . com-find-next)
      ("View Previous Topic" . com-find-previous)
      ("View Surrounding Topic" . com-find-superior)
      ("View Request History" . com-view-reference-history)
      ("" :no-select ignore)
      ("Location Commands" :no-select ignore :font sugg:menu-subtitle-std-font)
      ("Show Buffer Hierarchy" . com-show-buffer-hierarchy)
      ("Show Page Number" . com-show-page)
      ("Show Overview" . com-show-overview)
      ("" :no-select ignore)
      ("Miscellaneous Commands" :no-select ignore :font sugg:menu-subtitle-std-font)
      ("Expand Section" . com-expand-section)
      ("Contract Section" . com-contract-section)
      ("Save Request History" . com-save-history)
      ("Restore Request History" . com-restore-history)
      ("List VISIDOC buffers" . com-list-doc-viewer-buffers)
      ("" :no-select ignore)
      ("Exit" #\end :documentation "Exit the Viewer, returning to previous buffer"))))


