;;; -*- Mode:Common-Lisp; Package:TELNET; Base:10; Fonts:(MEDFNT HL12B HL12BI) -*-

;;;                           RESTRICTED RIGHTS LEGEND

;;;Use, duplication, or disclosure by the Government is subject to
;;;restrictions as set forth in subdivision (c)(1)(ii) of the Rights in
;;;Technical Data and Computer Software clause at 52.227-7013.
;;;
;;;                     TEXAS INSTRUMENTS INCORPORATED.
;;;                              P.O. BOX 2909
;;;                           AUSTIN, TEXAS 78769
;;;                                 MS 2151
;;;
;1;; Copyright (C) 1984-1989 Texas Instruments Incorporated. All rights reserved.*


(DEFCOMMAND (VT100-FRAME :UCL-KEYPAD-UP) ()
  `(:DESCRIPTION "Aux Keypad Up Arrow" :NAMES ("") :KEYS ,AUX-UP)
  (IF STREAM
      (SEND SELF :AUXILIARY-UP)
      (PROGN
	(FORMAT T "~&Not connected. Can't send Aux Keypad UP Arrow.")
	(WHEN (NOT UCL::PREEMPTING?)
	  (SEND SELF :HANDLE-PROMPT))))) 


(DEFCOMMAND (VT100-FRAME :UCL-KEYPAD-DOWN) ()
  `(:DESCRIPTION "Aux Keypad Down Arrow" :NAMES ("") :KEYS ,AUX-DOWN)
  (IF STREAM
      (SEND SELF :AUXILIARY-DOWN)
      (PROGN
	(FORMAT T "~&Not connected. Can't send Aux Keypad DOWN Arrow.")
	(WHEN (NOT UCL::PREEMPTING?)
	  (SEND SELF :HANDLE-PROMPT))))) 


(DEFCOMMAND (VT100-FRAME :UCL-KEYPAD-LEFT) ()
  `(:DESCRIPTION "Aux Keypad Left Arrow" :NAMES ("") :KEYS ,AUX-LEFT)
  (IF STREAM
      (SEND SELF :AUXILIARY-LEFT)
      (PROGN
	(FORMAT T "~&Not connected. Can't send Aux Keypad LEFT Arrow.")
	(WHEN (NOT UCL::PREEMPTING?)
	  (SEND SELF :HANDLE-PROMPT))))) 


(DEFCOMMAND (VT100-FRAME :UCL-KEYPAD-RIGHT) ()
  `(:DESCRIPTION "Aux Keypad Right Arrow" :NAMES ("") :KEYS ,AUX-RIGHT)
  (IF STREAM
      (SEND SELF :AUXILIARY-RIGHT)
      (PROGN
	(FORMAT T "~&Not connected. Can't send Aux Keypad RIGHT Arrow.")
	(WHEN (NOT UCL::PREEMPTING?)
	  (SEND SELF :HANDLE-PROMPT))))) 


(DEFCOMMAND (VT100-FRAME :UCL-KEYPAD-PF1) ()
  `(:DESCRIPTION "Aux Keypad PF 1" :NAMES ("PF1") :KEYS ,AUX-PF1)
  (IF STREAM
      (SEND SELF :AUXILIARY-PF-KEY-1)
      (PROGN
	(FORMAT T "~&Not connected. Can't send Aux Keypad PF1.")
	(WHEN (NOT UCL::PREEMPTING?)
	  (SEND SELF :HANDLE-PROMPT))))) 


(DEFCOMMAND (VT100-FRAME :UCL-KEYPAD-PF2) ()
  `(:DESCRIPTION "Aux Keypad PF 2" :NAMES ("PF2") :KEYS ,AUX-PF2)
  (IF STREAM
      (SEND SELF :AUXILIARY-PF-KEY-2)
      (PROGN
	(FORMAT T "~&Not connected. Can't send Aux Keypad PF2.")
	(WHEN (NOT UCL::PREEMPTING?)
	  (SEND SELF :HANDLE-PROMPT))))) 


(DEFCOMMAND (VT100-FRAME :UCL-KEYPAD-PF3) ()
  `(:DESCRIPTION "Aux Keypad PF 3" :NAMES ("PF3") :KEYS ,AUX-PF3)
  (IF STREAM
      (SEND SELF :AUXILIARY-PF-KEY-3)
      (PROGN
	(FORMAT T "~&Not connected. Can't send Aux Keypad PF3.")
	(WHEN (NOT UCL::PREEMPTING?)
	  (SEND SELF :HANDLE-PROMPT))))) 


(DEFCOMMAND (VT100-FRAME :UCL-KEYPAD-PF4) ()
  `(:DESCRIPTION "Aux Keypad PF 4" :NAMES ("PF4") :KEYS ,AUX-PF4)
  (IF STREAM
      (SEND SELF :AUXILIARY-PF-KEY-4)
      (PROGN
	(FORMAT T "~&Not connected. Can't send Aux Keypad PF4.")
	(WHEN (NOT UCL::PREEMPTING?)
	  (SEND SELF :HANDLE-PROMPT))))) 


(DEFCOMMAND (VT100-FRAME :UCL-KEYPAD-0) ()
  `(:DESCRIPTION "Aux Keypad 0" :NAMES ("0") :KEYS ,AUX-0)
  (IF STREAM
      (SEND SELF :AUXILIARY-0)
      (PROGN
	(FORMAT T "~&Not connected. Can't send Aux Keypad 0.")
	(WHEN (NOT UCL::PREEMPTING?)
	  (SEND SELF :HANDLE-PROMPT))))) 


(DEFCOMMAND (VT100-FRAME :UCL-KEYPAD-1) ()
  `(:DESCRIPTION "Aux Keypad 1" :NAMES ("1") :KEYS ,AUX-1)
  (IF STREAM
      (SEND SELF :AUXILIARY-1)
      (PROGN
	(FORMAT T "~&Not connected. Can't send Aux Keypad 1.")
	(WHEN (NOT UCL::PREEMPTING?)
	  (SEND SELF :HANDLE-PROMPT))))) 


(DEFCOMMAND (VT100-FRAME :UCL-KEYPAD-2) ()
  `(:DESCRIPTION "Aux Keypad 2" :NAMES ("2") :KEYS ,AUX-2)
  (IF STREAM
      (SEND SELF :AUXILIARY-2)
      (PROGN
	(FORMAT T "~&Not connected. Can't send Aux Keypad 2.")
	(WHEN (NOT UCL::PREEMPTING?)
	  (SEND SELF :HANDLE-PROMPT))))) 


(DEFCOMMAND (VT100-FRAME :UCL-KEYPAD-3) ()
  `(:DESCRIPTION "Aux Keypad 3" :NAMES ("3") :KEYS ,AUX-3)
  (IF STREAM
      (SEND SELF :AUXILIARY-3)
      (PROGN
	(FORMAT T "~&Not connected. Can't send Aux Keypad 3.")
	(WHEN (NOT UCL::PREEMPTING?)
	  (SEND SELF :HANDLE-PROMPT))))) 


(DEFCOMMAND (VT100-FRAME :UCL-KEYPAD-4) ()
  `(:DESCRIPTION "Aux Keypad 4" :NAMES ("4") :KEYS ,AUX-4)
  (IF STREAM
      (SEND SELF :AUXILIARY-4)
      (PROGN
	(FORMAT T "~&Not connected. Can't send Aux Keypad 4.")
	(WHEN (NOT UCL::PREEMPTING?)
	  (SEND SELF :HANDLE-PROMPT))))) 


(DEFCOMMAND (VT100-FRAME :UCL-KEYPAD-5) ()
  `(:DESCRIPTION "Aux Keypad 5" :NAMES ("5") :KEYS ,AUX-5)
  (IF STREAM
      (SEND SELF :AUXILIARY-5)
      (PROGN
	(FORMAT T "~&Not connected. Can't send Aux Keypad 5.")
	(WHEN (NOT UCL::PREEMPTING?)
	  (SEND SELF :HANDLE-PROMPT))))) 


(DEFCOMMAND (VT100-FRAME :UCL-KEYPAD-6) ()
  `(:DESCRIPTION "Aux Keypad 6" :NAMES ("6") :KEYS ,AUX-6)
  (IF STREAM
      (SEND SELF :AUXILIARY-6)
      (PROGN
	(FORMAT T "~&Not connected. Can't send Aux Keypad 6.")
	(WHEN (NOT UCL::PREEMPTING?)
	  (SEND SELF :HANDLE-PROMPT))))) 


(DEFCOMMAND (VT100-FRAME :UCL-KEYPAD-7) ()
  `(:DESCRIPTION "Aux Keypad 7" :NAMES ("7") :KEYS ,AUX-7)
  (IF STREAM
      (SEND SELF :AUXILIARY-7)
      (PROGN
	(FORMAT T "~&Not connected. Can't send Aux Keypad 7.")
	(WHEN (NOT UCL::PREEMPTING?)
	  (SEND SELF :HANDLE-PROMPT))))) 


(DEFCOMMAND (VT100-FRAME :UCL-KEYPAD-8) ()
  `(:DESCRIPTION "Aux Keypad 8" :NAMES ("8") :KEYS ,AUX-8)
  (IF STREAM
      (SEND SELF :AUXILIARY-8)
      (PROGN
	(FORMAT T "~&Not connected. Can't send Aux Keypad 8.")
	(WHEN (NOT UCL::PREEMPTING?)
	  (SEND SELF :HANDLE-PROMPT))))) 


(DEFCOMMAND (VT100-FRAME :UCL-KEYPAD-9) ()
  `(:DESCRIPTION "Aux Keypad 9" :NAMES ("9") :KEYS ,AUX-9)
  (IF STREAM
      (SEND SELF :AUXILIARY-9)
      (PROGN
	(FORMAT T "~&Not connected. Can't send Aux Keypad 9.")
	(WHEN (NOT UCL::PREEMPTING?)
	  (SEND SELF :HANDLE-PROMPT))))) 


(DEFCOMMAND (VT100-FRAME :UCL-KEYPAD-MINUS) ()
  `(:DESCRIPTION "Aux Keypad -" :NAMES ("-") :KEYS ,AUX-MINUS)
  (IF STREAM
      (SEND SELF :AUXILIARY-MINUS)
      (PROGN
	(FORMAT T "~&Not connected. Can't send Aux Keypad MINUS.")
	(WHEN (NOT UCL::PREEMPTING?)
	  (SEND SELF :HANDLE-PROMPT))))) 
       

(DEFCOMMAND (VT100-FRAME :UCL-KEYPAD-PLUS) ()
  `(:DESCRIPTION "Aux Keypad +" :NAMES ("+") :KEYS ,AUX-PLUS)
  (IF STREAM
      (SEND SELF :AUXILIARY-PLUS)
      (PROGN
	(FORMAT T "~&Not connected. Can't send Aux Keypad PLUS.")
	(WHEN (NOT UCL::PREEMPTING?)
	  (SEND SELF :HANDLE-PROMPT))))) 


(DEFCOMMAND (VT100-FRAME :UCL-KEYPAD-SPACE) ()
  `(:DESCRIPTION "Aux Keypad Space" :NAMES ("Space") :KEYS ,AUX-SPACE)
  (IF STREAM
      (SEND SELF :AUXILIARY-SPACE)
      (PROGN
	(FORMAT T "~&Not connected. Can't send Aux Keypad SPACE.")
	(WHEN (NOT UCL::PREEMPTING?)
	  (SEND SELF :HANDLE-PROMPT))))) 


(DEFCOMMAND (VT100-FRAME :UCL-KEYPAD-COMMA) ()
  `(:DESCRIPTION "Aux Keypad ," :NAMES (",") :KEYS ,AUX-COMMA)
  (IF STREAM
      (SEND SELF :AUXILIARY-COMMA)
      (PROGN
	(FORMAT T "~&Not connected. Can't send Aux Keypad COMMA.")
	(WHEN (NOT UCL::PREEMPTING?)
	  (SEND SELF :HANDLE-PROMPT))))) 


(DEFCOMMAND (VT100-FRAME :UCL-KEYPAD-EQUAL) ()
  `(:DESCRIPTION "Aux Keypad =" :NAMES ("=") :KEYS ,AUX-EQUAL)
  (IF STREAM
      (SEND SELF :AUXILIARY-EQUAL)
      (PROGN
	(FORMAT T "~&Not connected. Can't send Aux Keypad EQUAL.")
	(WHEN (NOT UCL::PREEMPTING?)
	  (SEND SELF :HANDLE-PROMPT))))) 


(DEFCOMMAND (VT100-FRAME :UCL-KEYPAD-TAB) ()
  `(:DESCRIPTION "Aux Keypad Tab" :NAMES ("TAB") :KEYS ,AUX-TAB)
  (IF STREAM
      (SEND SELF :AUXILIARY-TAB)
     ;(SEND SELF :MOVE-TO-TAB)
      (PROGN
	(FORMAT T "~&Not connected. Can't send Aux Keypad TAB.")
	(WHEN (NOT UCL::PREEMPTING?)
	  (SEND SELF :HANDLE-PROMPT))))) 


(DEFCOMMAND (VT100-FRAME :UCL-KEYPAD-PERIOD) ()
  `(:DESCRIPTION "Aux Keypad ." :NAMES (".") :KEYS ,AUX-PERIOD)
  (IF STREAM
      (SEND SELF :AUXILIARY-PERIOD)
      (PROGN
	(FORMAT T "~&Not connected. Can't send Aux Keypad PERIOD.")
	(WHEN (NOT UCL::PREEMPTING?)
	  (SEND SELF :HANDLE-PROMPT))))) 
       

(DEFCOMMAND (VT100-FRAME :UCL-KEYPAD-ENTER) ()
  `(:DESCRIPTION "Aux Keypad Enter" :NAMES ("ENTER") :KEYS ,AUX-ENTER)
  (IF STREAM
      (SEND SELF :AUXILIARY-ENTER)
      (PROGN
	(FORMAT T "~&Not connected. Can't send Aux Keypad ENTER.")
	(WHEN (NOT UCL::PREEMPTING?)
	  (SEND SELF :HANDLE-PROMPT))))) 


(BUILD-COMMAND-TABLE 'VT100-KEYPAD-CMD-TABLE 'VT100-FRAME
  '(:UCL-KEYPAD-UP :UCL-KEYPAD-DOWN :UCL-KEYPAD-LEFT :UCL-KEYPAD-RIGHT
		   :UCL-KEYPAD-PF1 :UCL-KEYPAD-PF2 :UCL-KEYPAD-PF3 :UCL-KEYPAD-PF4
		   :UCL-KEYPAD-EQUAL :UCL-KEYPAD-PLUS :UCL-KEYPAD-SPACE :UCL-KEYPAD-TAB
		   :UCL-KEYPAD-7 :UCL-KEYPAD-8 :UCL-KEYPAD-9 :UCL-KEYPAD-MINUS :UCL-KEYPAD-4
		   :UCL-KEYPAD-5 :UCL-KEYPAD-6 :UCL-KEYPAD-COMMA :UCL-KEYPAD-1 :UCL-KEYPAD-2
		   :UCL-KEYPAD-3 :UCL-KEYPAD-ENTER :UCL-KEYPAD-0 :UCL-KEYPAD-PERIOD)
  :INIT-OPTIONS
  '(:NAME "Vt100 Keypad Commands" :DOCUMENTATION "The Vt100 Keypad commands.")) 


(BUILD-MENU 'UCL-VT100-KEYPAD-MENU 'VT100-FRAME :DEFAULT-ITEM-OPTIONS
	    '(:FONT FONTS:WIDER-MEDFNT) :ITEM-LIST-ORDER
	    '(:UCL-KEYPAD-UP :UCL-KEYPAD-DOWN :UCL-KEYPAD-LEFT :UCL-KEYPAD-RIGHT :UCL-KEYPAD-PF1
			     :UCL-KEYPAD-PF2 :UCL-KEYPAD-PF3
			     :UCL-KEYPAD-PF4	   ;    :ucl-keypad-equal
					   ;    :ucl-keypad-plus
					   ;    :ucl-keypad-space
					   ;    :ucl-keypad-tab
			     :UCL-KEYPAD-7 :UCL-KEYPAD-8 :UCL-KEYPAD-9 :UCL-KEYPAD-MINUS :UCL-KEYPAD-4
			     :UCL-KEYPAD-5 :UCL-KEYPAD-6 :UCL-KEYPAD-COMMA :UCL-KEYPAD-1 :UCL-KEYPAD-2
			     :UCL-KEYPAD-3 ;    :ucl-keypad-enter    
			     :UCL-KEYPAD-TAB
			     ;; 1take out if insert tab above*
			     :UCL-KEYPAD-0 :UCL-KEYPAD-PERIOD :UCL-KEYPAD-ENTER))   ;; 1take out if insert enter above*

(COMPILE-FLAVOR-METHODS vt100-screen auxiliary-keypad vt100-frame vt100-telnet-menu)

