;;; -*- Mode:Common-Lisp; Package:ZWEI; Base:8 -*-

;;;                           RESTRICTED RIGHTS LEGEND

;;;Use, duplication, or disclosure by the Government is subject to
;;;restrictions as set forth in subdivision (c)(1)(ii) of the Rights in
;;;Technical Data and Computer Software clause at 52.227-7013.
;;;
;;;                     TEXAS INSTRUMENTS INCORPORATED.
;;;                              P.O. BOX 2909
;;;                           AUSTIN, TEXAS 78769
;;;                                 MS 2151
;;;
;;; Copyright (C) 1984-1989 Texas Instruments Incorporated. All rights reserved.


(SHADOW '(ZWEI::SEARCH
	  ZWEI::FIND
	  ZWEI::VIEW-FILE)
	'ZWEI)

(SHADOW '(SRCCOM::FILE-LENGTH)
	'SRCCOM)

;;; Export some Zwei symbols.
;;; Most of these were external symbols in release 2, so I guess they should be
;;; external for release 3. I have added a few that seemed like they should have
;;; been external before, but weren't. There should probably be more, and perhaps
;;; some of these should not be here. In other words, if you don't agree with this
;;; list, let me know - it is probably negotiable.
;;; - rpm 3/26/87.
(EXPORT '(BARF
	   BP-STATUS
	   BP-=
	   BP-<
	   BUFFER-FILE-ID
	   BUFFER-NAME
	   BUFFER-PATHNAME
	   BUFFER-TICK
	   CHAR-SYNTAX
	   COMMAND-DEFINE
	   COPY-BP
	   DEFCOM
	   EDITOR-TOP-LEVEL
	   GO-TO-END-OF-FILE-POSSIBILITY
	   INTERVAL-FIRST-BP
	   INTERVAL-LAST-BP
	   INTERVAL-STREAM
	   INTERVAL-STREAM-FAT
	   INTERVAL-STREAM-WITH-FONTS
	   FILE-ID
	   FILE-TICK
	   FIND-BUFFER-NAMED
	   INTERVAL
	   KILL-RING-POP
	   KILL-RING-STRING
	   KILL-STRING
	   LINE-NEXT
	   LINE-PREVIOUS
	   MAKE-COMMAND-NAME
	   MAKE-FILE-BUFFER-STREAM
	   MAKE-REGISTER-NAME
	   MARK
	   NODE-TICK
	   POINT
	   POP-UP-EDSTRING
	   POP-UP-STANDALONE-EDITOR-FRAME
	   READ-DEFAULTED-PATHNAME-NEAR-WINDOW
	   REGION
	   SAVE-POSITION-IN-REGISTER
	   SORT-COMPLETION-AARRAY
	   STANDALONE-EDITOR-FRAME
	   STANDALONE-EDITOR-WINDOW
	   STRING-INTERVAL
	   STRING-REPLACE-KEY
	   STRING-STRIP-CHARS
	   SUMMARIZE-INTERVAL
	   TEMPORARY-MODE-LINE-WINDOW-WITH-BORDERS
	   TICK
	   TYPEIN-LINE-MULTI-LINE-READ
	   TYPEIN-LINE-MULTI-LINE-READLINE
	   TYPEIN-LINE-READ
	   TYPEIN-LINE-READLINE
	   TYPEIN-LINE-READLINE-NEAR-WINDOW
	   WINDOW
	   WINDOW-MARK
	   WINDOW-MARK-P
	   WINDOW-POINT
	   ZMACS-FRAME
	   ZMACS-WINDOW
	   ;;; variables 
	   DIS-ALL  
	   DIS-BPS  
	   DIS-LINE
	   DIS-MARK-GOES 
	   DIS-NONE
	   DIS-TEXT
	   *KILL-RING*
	   NO-COMPLETION
	   *PATHNAME-DEFAULTS*
	   *WINDOW*
	   WORD-ALPHABETIC
	   WORD-DELIMITER
	   *WORD-SYNTAX-TABLE*
	   *ZMACS-BUFFER-LIST*)
	'ZWEI)

;;; Export some Srccom symbols.
;;; See the comments above for a (non-)explanation of what appears here.
;;; - rpm 3/26/87.
(EXPORT '(SRCCOM::CREATE-FILE
	   SRCCOM::FILE-IDENTIFIER
	   SRCCOM::FILE-MAJOR-MODE
	   SRCCOM::FILE-NAME
	   SRCCOM::FILE-STREAM
	   SRCCOM::FILE-TYPE
	   SRCCOM::MAKE-FILE
	   SRCCOM::PRINT-DIFFERENCES
	   SRCCOM::PROMPTED-SOURCE-COMPARE
	   SRCCOM::SOURCE-COMPARE
	   SRCCOM::SOURCE-COMPARE-AUTOMATIC-MERGE
	   SRCCOM::SOURCE-COMPARE-AUTOMATIC-MERGE-RECORDING
	   SRCCOM::SOURCE-COMPARE-FILES
	   SRCCOM::*DIFFERENCE-PRINTER*
	   SRCCOM::*LINES-NEEDED-TO-MATCH*
	   SRCCOM::*LINES-TO-PRINT-AFTER*
	   SRCCOM::*LINES-TO-PRINT-BEFORE*
	   SRCCOM::*PRINT-LABELS*)
	'SRCCOM)

;;; Export all Profile variables.
;;; This seems to be complete and correct.
;;; - rpm 3/26/87.
(EXPORT '(*ALPHABETIC-CASE-AFFECTS-SEARCH*
	   *APROPOS-SEARCH-OTHER-COMTABS* 
	   *AUTO-DIRECTORY-DISPLAY* 
	   *AUTO-FILL-ACTIVATION-CHARACTERS* 
	   *AUTO-PUSH-POINT-NOTIFICATION* 
	   *AUTO-PUSH-POINT-OPTION* 
	   *BLANKS* 
	   *CASE-REPLACE* 
	   *CASE-REPLACE-P*
	   *CENTER-FRACTION* 
	   *CHECK-UNBALANCED-PARENTHESES-WHEN-SAVING*
	   *COMMENT-BEGIN* 
	   *COMMENT-COLUMN*
	   *COMMENT-END*
	   *COMMENT-ROUND-FUNCTION* 
	   *COMMENT-START*
	   *CR-AFTER-LINE-MOUSE-YANK* 
	   *DEFAULT-BASE*
	   *DEFAULT-PACKAGE* 
	   *DEFAULT-SAVE-MODE*
	   *DIRECTORY-LISTER* 
	   *DIRECTORY-SINGLE-FILE-LISTER*
	   *DIRED-LINE-BOXING* 
	   *DISCARD-UNDO-INFO-ON-SAVING*
	   *EDIT-DEFINITION-IS-READ-ONLY* 
	   *ELECTRIC-SHIFT-LOCK-XORS*
	   *FILE-VERSIONS-KEPT* 
	   *FILL-COLUMN*
	   *FILL-EXTRA-SPACE-LIST* 
	   *FILL-PREFIX*
	   *FIND-FILE-EARLY-SELECT* 
	   *FIND-FILE-NOT-FOUND-IS-AN-ERROR*
	   *FIND-FILE-SAVE-MODE* 
	   *FIND-PATCH-DEFINITIONS-TOO* 
	   *FINISHED-AFTER-ENTIRE-MOUSE-YANK*
	   *FLASH-MATCHING-PAREN* 
	   *FLASH-MATCHING-PAREN-MAX-LINES*
	   *HELP-PROMPTS-IN-OLD-STYLE* 
	   *HISTORY-MENU-LENGTH*
	   *HISTORY-ROTATE-IF-NUMERIC-ARG* 
	   *HISTORY-YANK-WRAPAROUND*
	   *INDENT-NEW-LINE-INDENT-FUNCTION* 
	   *INDENT-NEW-LINE-NEW-LINE-FUNCTION*
	   *INDENT-WITH-TABS* 
	   *KILL-INTERVAL-SMARTS*
	   *LISP-DEFUN-INDENTATION* 
	   *LISP-INDENT-LONE-FUNCTION-OFFSET*
	   *MAX-RESET-FRACTION*
	   *MIN-RESET-FRACTION* 
	   *NEXT-SCREEN-CONTEXT-LINES*
	   *ONE-WINDOW-DEFAULT* 
	   *PAGE-DELIMITER-LIST*
	   *PARAGRAPH-DELIMITER-LIST* 
	   *PERMANENT-REAL-LINE-GOAL-XPOS*
	   *PL1-INDING-STYLE* 
	   *POINT-PDL-MAX*
	   *REGION-RIGHT-MARGIN-MODE* 
	   *SEARCH-RING-MAX*
	   *SPACE-INDENT-FLAG* 
	   *STICKY-MINOR-MODES*
	   *TAB-BLINKER-FLAG* 
	   *TAB-WIDTH*
	   *TEMP-FILE-TYPE-LIST*
	   *TYPE-HOG-ALIST* 
	   *UNDO-SAVE-SMALL-CHANGES*
	   *UNSTICKY-MINOR-MODES* 
	   *UPDATE-PLIST-ON-WRITE-OK*
	   *VIEWING-EXIT-CHARACTERS*
	   *VIEWING-IGNORE-NON-COMMAND-CHARACTERS* 
	   *VIEWING-RETURN-IF-NO-MORE-DEFAULT*
	   *VIEWING-SCROLL-BACKWARD-LINE-CHARACTERS* 
	   *VIEWING-SCROLL-BACKWARD-SCREEN-CHARACTERS* 
	   *VIEWING-SCROLL-FORWARD-LINE-CHARACTERS*
	   *VIEWING-SCROLL-FORWARD-SCREEN-CHARACTERS* 
	   *VSP* 
	   *WHITESPACE-CHARS*)
	'ZWEI)

;;; Get set up for Suggestions.
(sys:declare-suggestions-for
  'ZWEI:EDIT-IN-MINI-BUFFER
  :around '(locally (declare (special sys:*suggestions-menus-on?* sys:function-arglist))
	     (cond (sys:*suggestions-menus-on?*
		    (multiple-value-bind
		      (saved-main-stack saved-selected-window item-number
		       entry-comtab)
			(sys:sugg-before-edit-in-minibuffer sys:function-arglist)
		      (declare (special item-number saved-main-stack
					saved-selected-window))
		      (sys:update-suggestions-menus :install :middle entry-comtab)
		      (sys:signal-suggestions-process :redisplay-middle)
		      (unwind-protect :do-it
			(sys:sugg-after-edit-in-minibuffer
			  saved-main-stack saved-selected-window item-number
			  entry-comtab))))
		   (t :do-it)))
  :use-arglist t)

(sys:declare-suggestions-for
  'ZWEI:INCREMENTAL-SEARCH
  :around (sys:make-default-around-form
	    zwei:INCREMENTAL-SEARCH nil nil zwei:incremental-search-menu
	    :pop-menus-form
	    (sys:special-pop-menus 'zwei:INCREMENTAL-SEARCH
				    nil nil 'zwei:incremental-search-menu)))

(sys:declare-suggestions-for
  'ZWEI:QUERY-REPLACE
  :around (sys:make-default-around-form
	    ZWEI:QUERY-REPLACE nil nil ZWEI:QUERY-REPLACE-MENU
	    :pop-menus-form
	    (sys:special-pop-menus
	      'ZWEI:QUERY-REPLACE nil nil 'ZWEI:QUERY-REPLACE-MENU)))

(sys:declare-suggestions-for
  'ZWEI:COM-STRING-SEARCH-INTERNAL
  :around  (sys:make-default-around-form ZWEI:COM-STRING-SEARCH-INTERNAL
					  nil nil ZWEI:COM-STRING-SEARCH-MENU))

(sys:declare-suggestions-for
  'ZWEI:QUERY-REPLACE-LIST
  :around (sys:make-default-around-form
	    ZWEI:QUERY-REPLACE-LIST nil nil ZWEI:QUERY-REPLACE-MENU
	    :pop-menus-form
	    (sys:special-pop-menus
	      'ZWEI:QUERY-REPLACE-LIST nil nil 'ZWEI:QUERY-REPLACE-MENU)))

(sys:declare-suggestions-for
  'ZWEI:CHECK-FOR-TYPEOUT-WINDOW-TYPEOUT
  :around '(locally (declare (special sys:*suggestions-menus-on?*))
	     (cond ((and sys:*suggestions-menus-on?*
			 (ZWEI:TYPEOUT-WINDOW-INCOMPLETE-P ZWEI:*TYPEOUT-WINDOW*)
			 (not (sys:stack-position 'ZWEI:COM-DOCUMENTATION)))
		    (multiple-value-bind
		      (saved-selected-window mouse-sensitive-? item-number)
			(sys:sugg-before-check-for-typeout-window-typeout)
		      (unwind-protect :do-it
			(sys:sugg-after-check-for-typeout-window-typeout
			  saved-selected-window mouse-sensitive-? item-number))))
		   (t :do-it))))

(sys:declare-suggestions-for
  'ZWEI:CONTROL-R
  :around (sys:make-default-around-form
	    ZWEI:CONTROL-R nil nil ZWEI:CONTROL-R-MENU))

(sys:declare-suggestions-for
  'ZWEI:MAKE-EXTENDED-COMMAND-INTERNAL
  :around '(locally (declare (special sys:*suggestions-menus-on?*))
	     (cond (sys:*suggestions-menus-on?*
		    (let ((entry-comtab (ZWEI:THE-COMTAB)))
		      (cond ((neq entry-comtab 'ZWEI:ZMACS-CONTROL-X-COMTAB-MENU)
			     (multiple-value-bind
			       (saved-main-stack saved-selected-window item-number)
				 (sys:sugg-before-make-extended-command-internal)
			       (declare (special saved-main-stack saved-selected-window
						 item-number))
			       (sys:update-suggestions-menus :install :middle entry-comtab)
			       (sys:signal-suggestions-process :redisplay-middle)
			       (unwind-protect :do-it
				 (sys:sugg-after-make-extended-command-internal
				   saved-main-stack saved-selected-window
				   item-number entry-comtab))))
			    (t :do-it))))
		   (t :do-it))))

(sys:declare-suggestions-for
  'ZWEI:UNKNOWN-SPECIAL-COMMAND
  :around '(locally (declare (special sys:*suggestions-menus-on?* sys:function-arglist))
	     (cond ((and sys:*suggestions-menus-on?*
			 (member (car sys:function-arglist)
				 '(:menu :suggestions-menu) :test #'eq))
		    (sys:sugg-around-unknown-special-command sys:function-arglist)
		    t)
		   (t :do-it)))
  :use-arglist t)

(sys:declare-suggestions-for
  'ZWEI:COM-DOCUMENTATION
  :around (sys:make-default-around-form
	    ZWEI:COM-DOCUMENTATION nil nil ZWEI:COM-HELP-KEY-MENU))

(sys:declare-suggestions-for
  'ZWEI:PRINT-DOC
  :around '(let ()
	     (declare (special ZWEI:COLLECTED-COMMANDS sys:function-arglist ZWEI:*COMMAND-ALIST*))
	     (cond (sys:doing-apropos?
		    (let ((command (second sys:function-arglist)))
		      (push (rassoc command ZWEI:*COMMAND-ALIST*)
			    ZWEI:COLLECTED-COMMANDS))))
	     :do-it)
  :use-arglist t)

(sys:declare-suggestions-for
  'ZWEI:VIEW-FILE
  :around (sys:make-default-around-form
	    ZWEI:VIEW-FILE nil nil ZWEI:COM-WHEN-VIEWING-MENU))

(sys:declare-suggestions-for
  'ZWEI:TURN-ON-MODE
  :after '(locally (declare (special sys:function-arglist))
	    (sys:sugg-after-turn-on-mode sys:function-arglist))
  :use-arglist t)

(sys:declare-suggestions-for
  'ZWEI:UN-SET-MODES
  :before '(sys:sugg-before-un-set-modes))

(sys:declare-suggestions-for
  'ZWEI:READ-FUNCTION-NAME
  :around (sys:make-default-around-form
	    ZWEI:READ-FUNCTION-NAME nil nil ZWEI:MOUSE-SENSITIVE-ITEMS-MENU
	    :pop-menus-form (sys:special-pop-menus
			      'ZWEI:READ-FUNCTION-NAME 
			      nil nil 'ZWEI:MOUSE-SENSITIVE-ITEMS-MENU)))

(sys:declare-suggestions-for
  'zwei:GET-EXTENDED-SEARCH-STRINGS
  :after '(let ()
	    (declare (special ZWEI:APROPOS-STRING sys:function-values))
	    (cond (sys:doing-apropos?
		   (setq ZWEI:APROPOS-STRING (third sys:function-values))))
	    sys:function-values)
  :use-arglist t)

