;;; -*- Mode:Common-Lisp; Package:ZWEI; Base:8 -*-

;;;                           RESTRICTED RIGHTS LEGEND

;;;Use, duplication, or disclosure by the Government is subject to
;;;restrictions as set forth in subdivision (c)(1)(ii) of the Rights in
;;;Technical Data and Computer Software clause at 52.227-7013.
;;;
;;;                     TEXAS INSTRUMENTS INCORPORATED.
;;;                              P.O. BOX 2909
;;;                           AUSTIN, TEXAS 78769
;;;                                 MS 2151
;;;
;;; Copyright (C) 1984-1989 Texas Instruments Incorporated. All rights reserved.
;;; Copyright (C) 1980, Massachusetts Institute of Technology

;;; This is the last file loaded in the editor, it should contain only flavors
;;; and initializations

;;; Compile the necessary flavors

(COMPILE-FLAVOR-METHODS INTERVAL NODE SECTION-NODE ZMACS-BUFFER
			INTERVAL-WITH-SORT-KEY INTERVAL-WITH-SORT-INTERVAL) 

(COMPILE-FLAVOR-METHODS EDITOR-TYPEOUT-WINDOW
			ECHO-AREA-WINDOW TYPEIN-WINDOW
			ZWEI-WITHOUT-TYPEOUT ZWEI-MINI-BUFFER
			ZWEI-WINDOW ZWEI-WINDOW-PANE ZMACS-WINDOW ZMACS-WINDOW-PANE
			MODE-LINE-WINDOW POP-UP-MODE-LINE-WINDOW
			ZWEI-OVERLYING-WINDOW
			ZWEI-FRAME ZMACS-FRAME MENU-COMMAND-MOMENTARY-MENU
			STANDALONE-EDITOR-WINDOW
			STANDALONE-EDITOR-FRAME POP-UP-STANDALONE-EDITOR-FRAME
			TEMPORARY-MODE-LINE-WINDOW TEMPORARY-MODE-LINE-WINDOW-WITH-BORDERS
			EDITOR-STREAM-WINDOW EDITOR-TOP-LEVEL
			EDITOR-STREAM-FROM-WINDOW STREAM-IBEAM-BLINKER
			ZTOP-STREAM-FROM-WINDOW
			BACKGROUND-TYPEOUT-WINDOW
			UCL::UTILITY-POP-UP-EDITOR 
			) 

;;;Initialize the editor the first time we are loaded up
(DEFUN INITIALIZE-ALL-OF-EDITOR (&AUX (*PACKAGE* *PACKAGE*))
  (LET ((ELEM (ASSOC "INITIALIZE-ZMACS" *EDITOR-INITIALIZATION-LIST* :TEST 'EQUALP)))
    (AND ELEM (SETQ *EDITOR-INITIALIZATION-LIST*
		    (CONS ELEM (DELETE ELEM
				       (THE LIST *EDITOR-INITIALIZATION-LIST*)
				       :TEST #'EQ)))))
  (W:WITHOUT-SCREEN-MANAGEMENT (INITIALIZATIONS '*EDITOR-INITIALIZATION-LIST*))
  ;; Make one of each
  (USING-RESOURCE (WINDOW TEMPORARY-MODE-LINE-WINDOW-WITH-BORDERS-RESOURCE))
  (USING-RESOURCE (WINDOW BACKGROUND-TYPEOUT-WINDOWS))
  (USING-RESOURCE (FOO POP-UP-STANDALONE-EDITOR-FRAME) FOO))

;;; Make the rubout-handler use our word syntax table.
(DEFUN RUBOUT-KLUDGE (X)			;for W:RUBOUT-HANDLER-ALPHA-CHAR-P
  (EQ (CHAR-SYNTAX X *WORD-SYNTAX-TABLE*)
      WORD-ALPHABETIC))
(SETF W:RUBOUT-HANDLER-ALPHA-CHAR-P (SYMBOL-FUNCTION 'RUBOUT-KLUDGE))


(ADD-INITIALIZATION "INITIALIZE-ALL-OF-EDITOR"
		    '(INITIALIZE-ALL-OF-EDITOR)
		    '(:ONCE)) 

;;;
;;;Add Zmacs to the system menu and the system key.
(W:MODIFY-SYSTEM-ACCESS-SPEC 'ZWEI
			     :ASSIGN-DEFAULTS)

(SETF (SYS:SYSTEM-MADE-P 'ZWEI) T)


;;;Add Zmacs to the list of window types available via the CREATE option on the system menu.  
(W:ADD-WINDOW-TYPE "Edit"
		    'ZMACS-FRAME
		    "An editor, sharing buffers with other editors.")
