;;;-*- Mode: Common-Lisp; Package: SI; Base: 10.; Cold-Load: T -*-

;;;			      RESTRICTED RIGHTS LEGEND

;;; Use, duplication, or disclosure by the Government is subject to
;;; restrictions as set forth in subdivision (c)(1)(ii) of the Rights in
;;; Technical Data and Computer Software clause at 52.227-7013.
;;;
;;;			TEXAS INSTRUMENTS INCORPORATED.
;;;				 P.O. BOX 2909
;;;			      AUSTIN, TEXAS 78769
;;;				    MS 2151
;;;
;;; Copyright (C) 1989 Texas Instruments Incorporated. All rights reserved.


;;;  External Symbols in the SYSTEM package.  These are
;;;  exported by PKG-INITIALIZE.

;;;  Contains system-specific symbols that are shared among
;;;  various systems programs or advertised to users.  The
;;;  majority of system-specific symbols are internal symbols.

;; 12/29/87 DNG - Added SHUTDOWN, INHIBIT-DISPLACING-FLAG, and a bunch of 
;;		symbols referenced by the compiler.
;;  1/28/88 DNG - Add DUMP-OBJECTS-IN-REGION .
;;  2/19/88 ab  - Added some predicate symbols
;;  7/26/88 JHO - Added FILE-LOCAL-DECLARATIONS-DEF-ALIST
;;  3/16/89 DNG - Added FUNCTION-SPEC-P and NON-FATAL-ERROR .
;;  3/18/89 DNG - Added MAKE-FLAVOR-INSTANCE .
;;  4/22/89 DNG - Added SCHEME-ON-P .
;;  4/27/89 DNG - Added GET-FROM-FRAME-LIST .
;;  5/01/89 DNG - Added *GENSYM-COUNTER* [this will be part of ANSI CL].

(DEFCONSTANT *EXTERNAL-SYSTEM-SYMBOLS*
	     '(%%ARG-DESC-ANY-REST
		%%ARG-DESC-EVALED-REST
		%%ARG-DESC-FEF-BIND-HAIR
		%%ARG-DESC-FEF-LOCAL-BLOCK-LENGTH
		%%ARG-DESC-FEF-QUOTE-HAIR
		%%ARG-DESC-INTERPRETED 
		%%ARG-DESC-MAX-ARGS    
		%%ARG-DESC-MIN-ARGS    
		%%ARG-DESC-QUOTED-REST 
		%%ARRAY-DISPLACED-BIT
		%%ARRAY-FLAG-BIT
		%%ARRAY-INDEX-LENGTH-IF-SHORT
		%%ARRAY-LEADER-BIT
		%%ARRAY-LEADER-FUNCALL-AS-HASH-TABLE
		%%ARRAY-LEADER-LENGTH
		%%ARRAY-LONG-LENGTH-FLAG
		%%ARRAY-NAMED-STRUCTURE-FLAG
		%%ARRAY-NUMBER-DIMENSIONS
		%%ARRAY-PHYSICAL-BIT
		%%ARRAY-TYPE-AND-PHYSICAL-FIELD
		%%ARRAY-TYPE-FIELD
		%%BYTE-SPECIFIER-POSITION
		%%BYTE-SPECIFIER-SIZE
		%%CALL-INFO-MICROSTACK-PUSHED
		%%CALL-INFO-NUMBER-OF-ARGUMENTS
		%%CH-CHAR 
		%%CH-FONT 
		%%DATA-TYPE-AND-HEADER-FIELDS
		%%DOUBLE-FLOAT-EXPONENT
		%%DOUBLE-FLOAT-HIGH-MANTISSA
		%%DOUBLE-FLOAT-LOW-MANTISSA
		%%DOUBLE-FLOAT-PACKED-HIGH-TO-UNPACKED-HIGH-MANTISSA
		%%DOUBLE-FLOAT-PACKED-LOW-TO-UNPACKED-HIGH-MANTISSA
		%%DOUBLE-FLOAT-SIGN-BIT
		%%DOUBLE-FLOAT-UNPACKED-EXPONENT
		%%DOUBLE-FLOAT-UNPACKED-GUARD-BIT
		%%DOUBLE-FLOAT-UNPACKED-HIGH-MANTISSA
		%%DOUBLE-FLOAT-UNPACKED-HIGH-MANTISSA-AND-LEAD-BIT
		%%DOUBLE-FLOAT-UNPACKED-LEAD-BIT
		%%DOUBLE-FLOAT-UNPACKED-LOW-MANTISSA
		%%DOUBLE-FLOAT-UNPACKED-ROUND-BIT
		%%DOUBLE-FLOAT-UNPACKED-SIGN-BIT
		%%FIX-TO-DOUBLE-FLOAT-UNPACKED-HIGH-MANTISSA
		%%FIX-TO-DOUBLE-FLOAT-UNPACKED-LOW-MANTISSA
		%%HEADER-REST-FIELD
		%%HEADER-TYPE-FIELD
		%%KBD-CHAR
		%%KBD-CONTROL
		%%KBD-CONTROL-META 
		%%KBD-HYPER   
		%%KBD-KEYPAD
		%%KBD-META         
		%%KBD-MOUSE        
		%%KBD-MOUSE-BUTTON 
		%%KBD-MOUSE-N-CLICKS
		%%KBD-SUPER         
		%%M-FLAGS-CAR-NUM-MODE
		%%M-FLAGS-CAR-SYM-MODE
		%%M-FLAGS-CDR-NUM-MODE
		%%M-FLAGS-CDR-SYM-MODE
		%%M-FLAGS-DEFERRED-SEQUENCE-BREAK
		%%M-FLAGS-DONT-SWAP-IN
		%%M-FLAGS-INTERRUPT
		%%M-FLAGS-MAR-MODE
		%%M-FLAGS-METER-ENABLE
		%%M-FLAGS-PGF-WRITE
		%%M-FLAGS-QBBFL
		%%M-FLAGS-SCAVENGE
		%%M-FLAGS-STACK-GROUP-SWITCH
		%%M-FLAGS-TRANSPORT
		%%M-FLAGS-TRAP-ENABLE
		%%M-FLAGS-TRAP-ON-CALL
		%%METER-CONS-ENABLE
		%%METER-FUNCTION-ENTRY-EXIT-ENABLE
		%%METER-PAGE-FAULT-ENABLE
		%%METER-STACK-GROUP-SWITCH-ENABLE
		%%PHT1-AGE	;delete
		%%Q-ALL-BUT-CDR-CODE 
		%%Q-ALL-BUT-POINTER  
		%%Q-ALL-BUT-TYPED-POINTER 
		%%Q-BOXED-SIGN-BIT        
		%%Q-CDR-CODE              
		%%Q-DATA-TYPE             
		%%Q-HIGH-HALF             
		%%Q-LOW-HALF
		%%Q-POINTER	
		%%Q-POINTER-WITHIN-PAGE	
		%%Q-TYPED-POINTER	
		%%SELF-REF-INDEX
		%%SELF-REF-MAP-LEADER-FLAG
		%%SELF-REF-MONITOR-FLAG
		%%SELF-REF-RELOCATE-FLAG
		%%SELF-REF-WORD-INDEX
		%%SG-ST-CURRENT-STATE
		%%SG-ST-FOOTHOLD-EXECUTING
		%%SG-ST-IN-SWAPPED-STATE
		%%SG-ST-INST-DISP
		%%SG-ST-PROCESSING-ERROR
		%%SG-ST-PROCESSING-INTERRRUPT-REQUEST
		%%SG-ST-SAFE
		%%SG-ST-SWAP-SV-OF-SG-THAT-CALLS-ME
		%%SG-ST-SWAP-SV-ON-CALL-OUT
		%%SINGLE-TO-DOUBLE-FLOAT-UNPACKED-HIGH-MANTISSA
		%%SINGLE-TO-DOUBLE-FLOAT-UNPACKED-LOW-MANTISSA
		%%SPECPDL-BLOCK-START-FLAG
		%%SPECPDL-CLOSURE-BINDING
		%%US-MACRO-INSTRUCTION-RETURN
		%%US-PPBMIA
		%%US-PPBSPC
		%%US-RPC
		%%QMI-FULL-OPCODE
		%%QMI-DEST-OPCODE
		%%QMI-PUSH
		%QMI-PUSH
		%QMI-TEST
		%%QMI-REGISTER
		%QMI-REG-LEX
		%QMI-REG-CONST
		%QMI-REG-IVAR
		%QMI-REG-LOCAL
		%QMI-REG-ARG
		%QMI-REG-PDL
		%QMI-REG-IVAR
		%%QMI-OFFSET
		%%QMI-FEF-OFFSET
		%%QMI-INST-ADR
		%%QMI-MISC-OP
		%%QMI-AUX-OP
		%%QMI-External-Module-Number
		%%QMI-Module-Op
		%%QMI-BR-OFFSET
		%%QMI-CALL-DEST
		%%QMI-MOD-DEST
		%QMI-CALLDEST-INDS
		%QMI-CALLDEST-PUSH
		%QMI-CALLDEST-RETURN
		%QMI-CALLDEST-TAIL-REC
		%%QMI-CALL-NUMARGS
		%%QMI-LEX-LEVEL
		%QMI-LEX-PARENT-A
		%QMI-LEX-PARENT-B
		%%QMI-LEX-OFFSET
		%%QMI-IVAR-MAPPED
		%%QMI-IVAR-INDEX
		%24-BIT-DIFFERENCE
		%24-BIT-PLUS
		%24-BIT-TIMES
		%ACTIVATE-OPEN-CALL-BLOCK	
		%ADD-INTERRUPT
		%ADD-PAGE-DEVICE
		%ADDRESS-SPACE-MAP-BYTE-SIZE
		%ADDRESS-SPACE-QUANTUM-SIZE
		%ALLOCATE-AND-INITIALIZE      
		%ALLOCATE-AND-INITIALIZE-ARRAY
		%ALLOCATE-AND-INITIALIZE-INSTANCE 
		%AREA-NUMBER
		%ARG-DESC-EVALED-REST  
		%ARG-DESC-FEF-BIND-HAIR     
		%ARG-DESC-FEF-QUOTE-HAIR    
		%ARG-DESC-INTERPRETED       
		%ARG-DESC-QUOTED-REST
		%ARRAY-LEADER-LENGTH
		%ARRAY-MAX-SHORT-INDEX-LENGTH
		%ASSURE-PDL-ROOM			
		%BIND
		%BINDING-INSTANCES
		%BLT
		%BLT-FROM-PHYSICAL
		%BLT-TO-PHYSICAL
		%BLT-TYPED
		%BUFFER-CHAR-MAP		;kt 8-5-88
		%CALL
		%CALL-STATE-LENGTH
		%CATCH-BLOCK-CATCH-TAG
		%CATCH-BLOCK-SAVED-CATCH-POINTER
		%CHANGE-PAGE-STATUS
		%CLASS-DESCRIPTION		;RJF 2/03/88
		%COMPUTE-PAGE-HASH
                %CRASH
		%CREATE-PHYSICAL-PAGE 
		%CURRENT-STACK-GROUP-CALLING-ARGS-NUMBER
		%CURRENT-STACK-GROUP-CALLING-ARGS-POINTER
		%CURRENT-STACK-GROUP-STATE
		%DATA-TYPE
		%DELETE-PHT-ENTRY 
		%DELETE-PHYSICAL-PAGE
		%DISABLE-NUPI-LOCKING
		%DISPATCH-METHOD	
		%DISK-BLOCKS-PER-CYLINDER
		%DISK-BLOCKS-PER-TRACK
		%DISK-PAGE-MAPPING-TABLE-ENTRY	;delete
		%DISK-RESTORE
		%DISK-RUN-LIGHT
		%DISK-SWITCHES
		%DIVIDE-DOUBLE
		%DRAW-CHARACTER
		%DRAW-CHAR			
		%DRAW-FILLED-RASTER-LINE		
		%DRAW-FILLED-TRIANGLE		
		%DRAW-LINE
		%DRAW-RECTANGLE
		%DRAW-SHADED-RASTER-LINE
		%DRAW-SHADED-TRIANGLE
		%DRAW-STRING
		%ENABLE-NUPI-LOCKING 
		%ERROR-HANDLER-STACK-GROUP
		%EXTERNAL-VALUE-CELL
		%FEF-HEADER-LENGTH
		%FINDCORE
		%FIND-STRUCTURE-HEADER 
		%FIND-STRUCTURE-LEADER 
		%FIXNUM-MICROSECOND-TIME
		%FLOAT-DOUBLE
		%FLUSH-EXTRA-PDL
		%FUNCTION-INSIDE-SELF
		%GC-CONS-WORK 
		%GC-FLIP
		%GC-FLIP-READY
		%GC-FREE-REGION
		%GC-GENERATION-NUMBER
		%GC-SCAV-RESET
		%GC-SCAVENGE 
		%GET-SELF-MAPPING-TABLE
		%GETLONG			;kt 8-5-88
		%GETWORD-16B			;kt 8-5-88
		%HALT
		%HEADER-TYPE-ARRAY-LEADER
		%HEADER-TYPE-BIGNUM
		%HEADER-TYPE-COMPLEX
		%HEADER-TYPE-DOUBLE-FLOAT
		%HEADER-TYPE-ERROR
		%HEADER-TYPE-FLONUM
		%HEADER-TYPE-RATIONAL
		%IMPORT-OBJECT	
		%INHIBIT-READ-ONLY
		%INITIAL-FEF
		%INITIAL-STACK-GROUP
		%INITIALLY-DISABLE-TRAPPING
		%INSTANCE-DESCRIPTOR-ALL-INSTANCE-VARIABLES
		%INSTANCE-DESCRIPTOR-BINDINGS
		%INSTANCE-DESCRIPTOR-DEPENDS-ON-ALL
		%INSTANCE-DESCRIPTOR-FUNCTION
		%INSTANCE-DESCRIPTOR-HEADER
		%INSTANCE-DESCRIPTOR-IGNORE
		%INSTANCE-DESCRIPTOR-MAPPING-TABLE-ALIST
		%INSTANCE-DESCRIPTOR-RESERVED
		%INSTANCE-DESCRIPTOR-SIZE
		%INSTANCE-DESCRIPTOR-TYPENAME
		%INSTANCE-LOC
		%INSTANCE-REF
		%INTERNAL-VALUE-CELL
		%IO
                %IO-SPACE-READ  
                %IO-SPACE-WRITE 
		%LOAD-MEMORY-MAP
		%LOGDPB
		%LOGICAL-PAGE-DEVICE-INFORMATION-BLOCK
		%LOGLDB
		%MAKE-EXPLICIT-STACK-LIST
		%MAKE-EXPLICIT-STACK-LIST*
		%MAKE-LIST
		%MAKE-LIST*			;8/5/88 ab
		%MAKE-POINTER 
		%MAKE-POINTER-OFFSET
		%MAKE-REGION
		%MAKE-STACK-LIST
		%MAR-HIGH
		%MAR-LOW
		%METER-BUFFER-POINTER
		%METER-CONS-EVENT
		%METER-DISK-ADDRESS
		%METER-DISK-COUNT
		%METER-FUNCTION-ENTRY-EVENT
		%METER-FUNCTION-EXIT-EVENT
		%METER-FUNCTION-UNWIND-EVENT
		%METER-GLOBAL-ENABLE
		%METER-MICRO-ENABLES
		%METER-PAGE-IN-EVENT
		%METER-PAGE-OUT-EVENT
		%METER-STACK-GROUP-SWITCH-EVENT
		%MICROCODE-VERSION-NUMBER
		%MICROSECOND-TIME
		%MULTIPLE-VALUE-LIST-RETURN
		%MULTIPLY-FRACTIONS
		%NORMAL-RETURN
		%NUBUS-PHYSICAL-ADDRESS
		%NUBUS-READ
		%NUBUS-READ-16B
		%NUBUS-READ-8B
		%NUBUS-READ-8B-CAREFUL
		%NUBUS-WRITE
		%NUBUS-WRITE-16B
		%NUBUS-WRITE-8B
		%ONLY-ONE-RESULT-NEEDED
		%NUMBER-OF-MICRO-ENTRIES
		%OPEN-MOUSE-CURSOR
		%OPEN-CALL-BLOCK			
		%P-CDR-CODE
		%P-CDR-CODE-OFFSET
		%P-CONTENTS-AS-LOCATIVE
		%P-CONTENTS-AS-LOCATIVE-OFFSET
		%P-CONTENTS-OFFSET
		%P-CONTENTS-SAFE-P
		%P-CONTENTS-SAFE-P-OFFSET
		%P-DATA-TYPE
		%P-DATA-TYPE-OFFSET
		%P-DEPOSIT-FIELD
		%P-DEPOSIT-FIELD-OFFSET
		%P-DPB
		%P-DPB-OFFSET
		%P-LDB
		%P-LDB-OFFSET
		%P-MASK-FIELD
		%P-MASK-FIELD-OFFSET
		%P-POINTER
		%P-POINTER-OFFSET
		%P-POINTERP
		%P-POINTERP-OFFSET
		%P-SAFE-CONTENTS-OFFSET
		%P-STORE-CDR-CODE
		%P-STORE-CDR-CODE-OFFSET
		%P-STORE-CONTENTS
		%P-STORE-CONTENTS-OFFSET
		%P-STORE-DATA-TYPE
		%P-STORE-DATA-TYPE-OFFSET
		%P-STORE-POINTER
		%P-STORE-POINTER-OFFSET
		%P-STORE-TAG-AND-POINTER
		%PAGE-CONS-ALARM
		%PAGE-IN
		%PAGE-STATUS
		%PAGE-TRACE
	       %PHYS-LOGDPB
	       %PHYS-LOGLDB
	       %PHYSICAL-ADDRESS
	       %POINTER
	       %POINTER-DIFFERENCE
	       %POINTER-PLUS
	       %POINTER-TIMES
	       %POINTER-TYPE-P
	       %POINTERP
	       %POP				
	       %PUSH
	       %PUTLONG				;kt 8-5-88
	       %PUTWORD-16B			;kt 8-5-88
	       %RATIO-CONS
	       %RECORD-EVENT
	       %REGION-CONS-ALARM
	       %REGION-NUMBER
	       %REMAINDER-DOUBLE
	       %RETURN-ALL-VALUES-WITH-COUNT-ON-STACK
	       %SCHEDULER-STACK-GROUP
	       %SCROLL			
               %SCRUB			
	       %SET-MOUSE-SCREEN
	       %SET-SELF-MAPPING-TABLE 
	       %SPREAD
	       %STACK-FRAME-POINTER
	       %STORE-CONDITIONAL
	       %STORE-KEY-WORD-ARGS	
	       %STRING-EQUAL
	       %STRING-SEARCH-CHAR
	       %STRING-WIDTH
	       %STRUCTURE-BOXED-SIZE
	       %STRUCTURE-TOTAL-SIZE
	       %SUM-ARRAY			;ab 8/19/88
	       %SXHASH-STRING
	       %SYS-COM-AREA-ORIGIN-PNTR
	       %SYS-COM-BAND-FORMAT
	       %SYS-COM-CHAOS-FREE-LIST
	       %SYS-COM-CHAOS-RECEIVE-LIST
	       %SYS-COM-CHAOS-TRANSMIT-LIST
	       %SYS-COM-DEBUGGER-DATA-1
	       %SYS-COM-DEBUGGER-DATA-2
	       %SYS-COM-DEBUGGER-KEEP-ALIVE
	       %SYS-COM-DEBUGGER-REQUESTS
	       %SYS-COM-DESCRIPTOR-SPACE-FREE-POINTER
	       %SYS-COM-DESIRED-MICROCODE-VERSION
	       %SYS-COM-DEVICE-INTERRUPT-TABLE
	       %SYS-COM-ETHER-FREE-LIST
	       %SYS-COM-ETHER-RECEIVE-LIST
	       %SYS-COM-ETHER-TRANSMIT-LIST
	       %SYS-COM-FREE-AREA#-LIST
	       %SYS-COM-FREE-REGION#-LIST
	       %SYS-COM-GC-GENERATION-NUMBER
	       %SYS-COM-HIGHEST-VIRTUAL-ADDRESS
	       %SYS-COM-MAJOR-VERSION
	       %SYS-COM-MEMORY-SIZE
	       %SYS-COM-OBARRAY-PNTR
	       %SYS-COM-PAGE-DEVICE-TABLE
	       %SYS-COM-PAGE-TABLE-PNTR
	       %SYS-COM-PAGE-TABLE-SIZE
	       %SYS-COM-POINTER-WIDTH
	       %SYS-COM-PROCESSOR-SLOT
	       %SYS-COM-SYSTEM-NUPI-DESCRIPTOR
	       %SYS-COM-TEMPORARY
	       %SYS-COM-VALID-SIZE
	       %SYS-COM-WIRED-SIZE
	       %TEST&SET-68K
	       %TRAP-MICRO-PC
	       %USING-BINDING-INSTANCES 
	       %WRITE-INTERNAL-PROCESSOR-MEMORIES
               *ADAPTIVE-TRAINING-ENABLED*
	       *BATCH-MODE-P*
	       *BOOLE
	       *BREAK-BINDINGS*
	       *DEBUG-INFO-LOCAL-DECLARATION-TYPES*
	       *DEBUG-STRUCT-LOCAL-DECLARATION-TYPES*
	       *DEFAULT-BIT-ARRAY-PRINTER*
	       *DEFAULT-DISK-UNIT*
	       *DEFAULT-PRINTER*
	       *DONT-RECOMPILE-FLAVORS*
	       *EVAL
	       *FILE-TRANSFORMATION-FUNCTION*
	       *GC-CONSOLE-DELAY-INTERVAL*
	       *GC-MAX-INCREMENTAL-GENERATION* 
	       *GC-NOTIFICATIONS*
               *GC-REPORT-STREAM*
	       *GENSYM-COUNTER*		; DNG 5/1/89
	       *LOADED-BAND*
	       *load-sib*			;ab 6/8/88 (and next 8)
	       *load-disk*
	       *load-nvram*
	       *load-keyboard*
	       *load-mouse*
	       *load-rtc*
	       *load-sound*
	       *load-nubus*
	       *load-enet*
	       *LOGAND
	       *LOGIOR
	       *LOGXOR
	       *FILE-TRANSFORMATION-FUNCTION*
 	       *FLAVOR-COMPILATIONS*
	       *MAKE-SYSTEM-FORMS-TO-BE-EVALED-AFTER*
	       *MAKE-SYSTEM-FORMS-TO-BE-EVALED-BEFORE*
	       *MAKE-SYSTEM-FORMS-TO-BE-EVALED-FINALLY*
	       *MICROCODE-NAME-ALIST*
               *MICROCODE-TYPE-LIST*
	       *QUERY-TYPE*
	       *READ-ACCEPT-EXTENSIONS*
	       *REDO-ALL*
	       *SILENT-P*
	       *SYSTEM-BEING-DEFINED*
	       *SYSTEM-BEING-MADE*
	       *TGC-TRAINING-ENABLED*
	       *TOP-LEVEL-TRANSFORMATIONS*
	       A-MEMORY-ARRAY-SYMBOLS
	       A-MEMORY-COUNTER-BLOCK-NAMES
	       A-MEMORY-LOCATION-NAMES
	       A-MEMORY-VIRTUAL-ADDRESS
	       ACTIVE-PROCESSES
	       ADDIN-P				;ab 2/19/88
	       ADDRESS-SPACE-MAP
	       ADVISE-1
	       ADVISED-FUNCTIONS
	       ALL-PROCESSES
	       AMEM-EVCP-VECTOR
	       AREA-MAXIMUM-SIZE
	       AREA-REGION-BITS
	       AREA-REGION-LIST
	       AREA-REGION-SIZE
	       AREA-TEMPORARY-P
	       ARGS-DESC
	       ARRAY-DIM-MULT
	       ARRAY-DIMENSION-SHIFT
	       ARRAY-DISPLACED-BIT
	       ARRAY-FIELDS
	       ARRAY-LEADER-BIT
	       ARRAY-LEADER-FIELDS
	       ARRAY-LONG-LENGTH-FLAG
	       ARRAY-MISCS
	       ARRAY-NAMED-STRUCTURE-FLAG
	       ARRAY-REGISTER		; declaration ignored for brand S compatibility
	       ARRAY-REGISTER-1D	; declaration ignored for brand S compatibility
	       ARRAY-TYPE-FROM-ELEMENT-TYPE
	       ARRAY-TYPE-SHIFT
	       ASSOC-EQL
	       ASSOC-EQUALP
	       BACKGROUND-CONS-AREA
	       BEFORE-COLD-INITIALIZATION-LIST
	       BIDIRECTIONAL-STREAM
	       BIGNUM-TO-ARRAY
	       BUFFERED-CHARACTER-STREAM
	       BUFFERED-INPUT-CHARACTER-STREAM
	       BUFFERED-INPUT-STREAM
	       BUFFERED-OUTPUT-CHARACTER-STREAM
	       BUFFERED-OUTPUT-STREAM
	       BUFFERED-STREAM
	       CADR-TYPE-CODE
	       CARCDR
	       CELL-LOCATION-IN-STACK-GROUP
	       CHANGE-INDIRECT-ARRAY
	       CHANGE-SWAP-SPACE-ALLOCATION
	       CLEAN-UP-STATIC-AREA
	       CLOCK-FUNCTION-LIST
	       CODE-MOUSE-CHAR
	       COERCE-TO-ARRAY-OPTIMIZED
	       COERCE-TO-CHARACTER
	       COERCE-TO-DOUBLE-FLOAT
	       COERCE-TO-FLOAT
	       COERCE-TO-LIST
	       COERCE-TO-SINGLE-FLOAT
	       COERCE-TO-SMALL-FLOAT
  	       COLD-INITIALIZATION-LIST
	       COLD-LOAD-STREAM
	       COMMON-LISP-AR-1
	       COMMON-LISP-AR-1-FORCE
	       COMMON-LISP-AR-2
	       COMMON-LISP-AR-3
	       COMMON-LISP-AREF
	       COMMON-LISP-ELT
	       COMMON-LISP-LISTP
	       COMMON-LISP-READTABLE
	       COMPARE-BAND
	       COMPILE-IF
	       COMPILE-LOAD-IF
	       COMPUTE-LISPM-ARRAY-TYPE
	       CONSP-OR-POP
 	       CONTROL-TABLES
	       CONVERT-TO-DOUBLE-FLOAT-UNPACKED-FIELDS
	       COPY-OBJECT-TREE
	       CURRENT-BAND
	       CURRENT-MICROLOAD
	       CURRENTLY-PREPARED-SHEET
	       DBIS-PLIST
	       DEBUG-WARM-BOOTED-PROCESS
	       DECLARED-DEFINITION
	       DECODE-KEYWORD-ARGLIST
	       DEFINE-DEFSYSTEM-SPECIAL-VARIABLE
	       DEFINE-MAKE-SYSTEM-SPECIAL-VARIABLE
	       DEFINE-SIMPLE-TRANSFORMATION
	       DEFSTRUCT-DEFINE-TYPE
	       DEFUN-COMPATIBILITY
	       DELETE-BINDING-FROM-CLOSURE
	       DELETE-LIST-EQ
	       DEP-COMPILE-IF
	       DEP-COMPILE-LOAD-IF
 	       DEVICE-DESCRIPTOR-AREA
	       DISJOINT-TYPEP
	       DISK-PAGE-MAP-AREA
	       DISK-READ
	       DISK-READ-COMPARE
	       DISK-WRITE
	       DISPLACED
	       DOUBLE-FLOAT-CONSTANTS
	       DOUBLE-FLOAT-FIELDS
	       DOUBLE-FLOAT-MANTISSA-PLUS-GUARD-PLUS-ROUND-LENGTH
	       DOUBLE-FLOAT-MAXIMUM-UNPACKED-EXPONENT
	       DOUBLE-FLOAT-MINIMUM-UNPACKED-EXPONENT
	       DOUBLE-FLOAT-PACKED-TO-UNPACKED-FIELDS
	       DOUBLE-FLOAT-UNPACKED-FIELDS
	       DOUBLE-FLOATP 
	       DOWNWARD-FUNARG
	       DOWNWARD-FUNCTION
	       DTP-ARRAY					
	       DTP-ARRAY-HEADER			    
	       DTP-ARRAY-POINTER		;obsolete - now dtp-array				
	       DTP-BODY-FORWARD			       
	       DTP-CHARACTER				       
	       DTP-CLOSURE
	       DTP-EXTENDED-NUMBER			       
	       DTP-EXTERNAL-VALUE-CELL-POINTER		       
	       DTP-FEF-HEADER				       
	       DTP-FEF-POINTER			;obsolete - now dtp-function
	       DTP-FIX					       
	       DTP-FREE					
	       DTP-FUNCTION					
	       DTP-GC-FORWARD
	       DTP-HEADER					
	       DTP-HEADER-FORWARD			       
	       DTP-INSTANCE				       
	       DTP-INSTANCE-HEADER				
	       DTP-LEXICAL-CLOSURE				
	       DTP-LIST					
	       DTP-LOCATIVE				       
	       DTP-NULL				       
	       DTP-ONE-Q-FORWARD			       
	       DTP-ONES-TRAP
	       DTP-SELF-REF-POINTER			       
	       DTP-SHORT-FLOAT					
	       DTP-SINGLE-FLOAT				
	       DTP-STACK-CLOSURE		;obsolete - now dtp-lexical-closure
	       DTP-STACK-GROUP				       
	       DTP-STACK-LIST				       
	       DTP-SYMBOL				       
	       DTP-SYMBOL-HEADER				
	       DTP-TRAP					
	       DTP-U-ENTRY
	       DUMP-MEMORY			;ab 2/19/88
	       DUMP-PHYSICAL			;ab 2/19/88
	       DUMP-OBJECTS-IN-REGION
	       DUMP-WARNINGS
	       DWIMIFY-ARG-PACKAGE
	       DWIMIFY-PACKAGE
	       DWIMIFY-PACKAGE-0
	       EAS-ON				;jho 4/22/88
	       EDIT-DISK-LABEL
	       ENCAPSULATE
	       ENCAPSULATION-BODY
	       ENCAPSULATION-STANDARD-ORDER
	       EVAL-ABORT-TRIVIAL-ERRORS
	       EVAL1
	       EXP2-P				;ab 2/19/88
	       EXPONENT-CONVERSIONS
	       EXTRA-PDL-AREA 
	       EXTRACT-DEBUG-INFO-STRUCT-FROM-FEF
	       EXTRACT-DECLARATIONS
	       FASL-CONSTANTS-AREA
	       FASL-RECORD-FILE-MACROS-EXPANDED
	       FASL-TABLE-AREA
	       FASL-TEMP-AREA
	       FASLOAD-COMBINED
	       FAT-STRING-CHAR-P
	       FDEFINE-FILE-PATHNAME
	       FDEFINITION-SAFE
	       FEF-ADL-LENGTH
	       FEF-ADL-ORIGIN
	       FEF-BIT-MAP
	       FEF-BIT-MAP-P
	       FEF-FAST-ARGUMENT-OPTION-P
	       FEF-FAST-ARGUMENT-OPTION-WORD
	       FEF-HEADER-FIELDS
	       FEF-INITIAL-PC
	       FEF-INSTRUCTION
	       FEF-INSTRUCTION-LENGTH
 	       FEF-LENGTH
	       FEF-LIMIT-PC
	       FEF-NAME
	       FEF-NO-ADL-P
	       FEF-NUMBER-OF-LOCALS
	       FEF-SPECIALS-BOUND-P
	       FILE-IN-COLD-LOAD
	       FILE-LOCAL-DECLARATIONS
	       FILE-LOCAL-DECLARATIONS-DEF-ALIST
 	       FILE-OPERATION-WITH-WARNINGS
	       FILE-STREAM-MIXIN
	       FIND-DISK-PARTITION
	       FIND-DISK-PARTITION-FOR-READ
	       FIND-DISK-PARTITION-FOR-WRITE
	       FIND-READTABLE-NAMED
 	       FIX-TO-DOUBLE-FLOAT-EXPONENT
	       FLAVOR-ALL-ALLOWED-INIT-KEYWORDS
	       FLAVOR-ALL-INSTANCE-VARIABLES
	       FLAVOR-VAR-SELF-REF-INDEX
	       FLOAT-EXPONENT
	       FLOAT-FRACTION
	       FUNCALL-WITH-MAPPING-TABLE-INTERNAL
 	       FUNCTION-PARENT
	       FUNCTION-SPEC-GET
	       FUNCTION-SPEC-HANDLER
	       FUNCTION-SPEC-LESSP
	       FUNCTION-SPEC-P ; DNG 3/16/89 - used in Inspector, Zmacs, and code walker
	       FUNCTION-SPEC-PUSH-PROPERTY
	       FUNCTION-SPEC-PUTPROP
	       FUNCTION-START-SYMBOLS
	       GC-EXTERNAL				;;jho 4/22/88
	       GC-REPORT-STREAM
	       GET-ALL-SOURCE-FILE-NAMES
	       GET-DEBUG-INFO-FIELD
	       GET-DEBUG-INFO-STRUCT
	       GET-DISK-FIXNUM
	       GET-DISK-RQB
 	       GET-DISK-STRING
	       GET-FILE-LOADED-ID
	       GET-FROM-FRAME-LIST ; DNG 4/27/89
 	       GET-LEXICAL-VALUE-CELL
	       GET-LOCATION
	       GET-LOCATION-OR-NIL
	       GET-MACRO-ARG-DESC-POINTER
 	       GET-SOURCE-FILE-NAME
	       GET-SYSTEM-VERSION
	       HARDWARE-MEMORY-SIZES
	       HEADER-FIELDS
	       HOST-ALIST
	       INHIBIT-DISPLACING-FLAG
	       INHIBIT-GC-FLIPS 
	       INHIBIT-IDLE-SCAVENGING-FLAG
	       INHIBIT-SCAVENGING-FLAG
 	       INIT-LIST-AREA
	       INITIAL-COMMON-LISP-READTABLE
	       INITIAL-PROCESS
	       INITIAL-READTABLE
	       INITIALIZATION-KEYWORDS
	       INPUT-FILE-STREAM-MIXIN
	       INPUT-POINTER-REMEMBERING-MIXIN
	       INPUT-STREAM
	       INSERT-BINDING-IN-CLOSURE
	       INSTANCE-DESCRIPTOR-OFFSETS
	       INSTANCE-FLAVOR
	       INTERNAL-CHAR-EQUAL
	       INTERNAL-FLOAT
	       INTERNAL-GET-3
	       INTERNAL-MAKE-SIMPLE-VECTOR
	       INVALID-FUNCTION
	       IO-SPACE-VIRTUAL-ADDRESS
	       KBD-CONVERT-TO-SOFTWARE-CHAR
	       KBD-GET-HARDWARE-CHAR
	       KBD-HARDWARE-CHAR-AVAILABLE
	       LAMBDA-EXP-ARGS-AND-BODY
	       LAMBDA-MACRO-CALL-P
	       LAMBDA-MACRO-EXPAND
	       LAMBDA-TYPE-CODE
	       LENGTH-GREATERP
	       LENGTH-OF-ATOM-HEAD
	       LENGTH-OF-FASL-TABLE
	       LEXICAL-ENVIRONMENT
	       LEXPR-FUNCALL-WITH-MAPPING-TABLE-INTERNAL
	       LINE-OUTPUT-STREAM-MIXIN
	       LINEAR-BIND-PDL-AREA
	       LINEAR-PDL-AREA
	       LISP-CRASH-LIST
	       LISP-ERROR-HANDLER
	       LISP-REINITIALIZE
	       LISP-TOP-LEVEL
	       LISP-TOP-LEVEL1
	       LOAD-IF
	       LOCAL-BINARY-FILE-TYPE
	       LOCF-METHOD
	       LOGIN-HISTORY
	       LOOP-NAMED-VARIABLE
	       LOOP-TASSOC
	       LOOP-TEQUAL
	       LOOP-TMEMBER
	       M-EQ
	       M-FLAGS-FIELDS
	       M-MEMORY-LOCATION-NAMES
	       MAKE-DEBUG-INFO-STRUCT
	       MACROS-EXPANDED
	       MAKE-FLAVOR-INSTANCE ; DNG 3/18/89
	       MAKE-OBSOLETE
	       MAKE-PARALLEL-STREAM
	       MAKE-PROCESS-QUEUE
	       MAKE-SERIAL-STREAM
	       MAYBE-PRINT-OBJECT-WARNINGS-HEADER
	       MEASURED-SIZE-OF-PARTITION
 	       MEMBER-EQL
	       MEMBER-EQUALP
	       METER-ENABLES
	       METER-EVENTS
	       MICRO-CODE-ENTRY-AREA
	       MICRO-CODE-ENTRY-DEBUG-INFO-AREA
	       MICRO-STACK-FIELDS
	       MICROCODE-TYPE-CODE
	       MISMATCH*
	       MOUSE-BUTTONS-BUFFER
	       MOUSE-CURSOR-PATTERN
	       MOUSE-WAKEUP
	       MOUSE-X-SCALE-ARRAY
	       MOUSE-Y-SCALE-ARRAY
	       MX-BOOT-STATUS			;ab 02/19/88
	       MX-P				;ab 02/19/88
	       NON-FATAL-ERROR			;DNG 3/16/89
	       NR-SYM
	       NULL-STREAM
	       NUMBER-CONS-AREA
	       NUMERIC-ARG-DESC-FIELDS
	       OBJECT-OPERATION-WITH-WARNINGS
	       OBT-TAILS
	       ONCE-ONLY-INITIALIZATION-LIST
	       OUTPUT-FILE-STREAM-MIXIN
	       OUTPUT-POINTER-REMEMBERING-MIXIN
	       OUTPUT-STREAM			
	       P-N-STRING
	       PAGE-GC-BITS
	       PAGE-HASH-TABLE-FIELDS
	       PAGE-IN-AREA
	       PAGE-IN-ARRAY
	       PAGE-IN-PIXEL-ARRAY
 	       PAGE-IN-REGION
	       PAGE-IN-STRUCTURE
	       PAGE-IN-WORDS
	       PAGE-OUT-AREA
	       PAGE-OUT-ARRAY
	       PAGE-OUT-PIXEL-ARRAY
	       PAGE-OUT-REGION
	       PAGE-OUT-STRUCTURE
	       PAGE-OUT-WORDS
	       PAGE-SIZE
	       PAGE-TABLE-AREA
	       PARSE-FERROR
	       PARTITION-COMMENT
	       PATCH-LOADED-P
 	       PDL-AREA
	       PDL-ARRAY-INDEX
	       PDL-BUFFER-INDEX
	       PDL-WORD
	       PHYSICAL-PAGE-DATA
	       PKG-AREA
	       PKG-SHORTEST-NAME
	       ;;ab 8/6/87.  Add Prolog MISCOP names.
	       PL-TRAIL1
	       PL-BIND-VAR-TO-VAR
	       PL-BIND-VAR-TO-TERM
	       PL-VARP
	       PL-LISTP
	       PL-STRUCTP
	       PL-ATOMP
	       PL-ATOMICP
	       PL-INITIALIZE
	       PL-INITIALIZE1
	       PL-DEREFERENCE
	       PL-RESOLVE
	       PL-STACK-OVERFLOW-SAVECP
	       PLL-FAIL1
	       PL-UNIFY1
	       ;;ab
	       POP-M-FROM-UNDER-N
	       PREMATURE-WARNINGS
	       PREMATURE-WARNINGS-MARKER
	       PRINT-DISK-ERROR-LOG
	       PRINT-LIST
	       PRINT-NOT-READABLE
	       PRINT-OBJECT
	       PRINTING-RANDOM-OBJECT
	       PRINT-READABLY
	       PRINT-READABLY-MIXIN
	       PROCESS
	       PROCESS-DEQUEUE
	       PROCESS-ENQUEUE
	       PROCESS-QUEUE-LOCKER
	       PROCESSOR-TYPE	
	       PROPERTY-LIST-AREA
	       PROPERTY-LIST-MIXIN
	       PUT-DEBUG-INFO-FIELD
	       PUT-DISK-FIXNUM
	       PUT-DISK-STRING
	       Q-CDR-CODES
	       Q-FIELDS
	       Q-GCV-MVP-BITS
	       Q-HEADER-TYPES
	       Q-REGION-BITS
	       QUOTE-EVAL-AT-LOAD-TIME
	       RANDOM-CREATE-ARRAY
	       RANDOM-IN-RANGE
	       RANDOM-INITIALIZE
 	       RASSOC-EQL
	       RASSOC-EQUALP
	       RATIOP
	       RDTBL-NAMES
	       READ-AREA
	       READ-RECURSIVE
	       RECEIVE-BAND
	       RECORD-AND-PRINT-WARNING
 	       RECORD-MACROS-EXPANDED
	       RECORD-SOURCE-FILE-NAME
	       RECORD-WARNING
 	       REG-PDL-LEADER-QS
	       REG-PDL-SG-HEAD-POINTER
	       REGION-BITS
	       REGION-FREE-POINTER
	       REGION-GC-POINTER
	       REGION-LENGTH
	       REGION-LIST-THREAD
	       REGION-ORIGIN
	       REGULAR-PDL-SG
	       RENAME-WITHIN-NEW-DEFINITION-MAYBE
	       RESET-PROCESS-QUEUE
	       RESET-TEMPORARY-AREA
	       RESIDENT-SYMBOL-AREA
	       RESOURCE-IN-USE-P
	       RESOURCE-N-OBJECTS
	       RESOURCE-OBJECT
	       RESOURCE-PARAMETERS
	       RESOURCE-PARAMETIZER
	       RETURN-DISK-RQB
	       RP-ARGUMENT-POINTER
	       RP-ARGUMENT-OFFSET
 	       RP-BINDING-BLOCK-PUSHED
	       RP-CALL-INFO-WORD
	       RP-DESTINATION
	       RP-EXIT-PC
	       RP-ENV-PTR-POINTS-HERE
	       RP-FEF-WORD
	       RP-FUNCTION-WORD
	       RP-LEXPR-FUNCALL-FLAG
	       RP-LOCAL-POINTER
	       RP-LOCAL-OFFSET
	       RP-LOCATION-COUNTER-OFFSET
	       RP-MICRO-STACK-PUSHED
	       RP-MICRO-STACK-SAVED
	       RP-NUMBER-ARGS-SUPPLIED
	       RP-NUMBER-OF-ARGUMENTS
	       RP-NUMBER-OF-RESULTS
	       RP-RETURN-TYPE
	       RP-SAVED-DESTINATION
	       RP-SELF-MAP-TABLE-PROVIDED
	       RP-TRAP-ON-EXIT
	       RQB-8-BIT-BUFFER
	       RQB-BUFFER
	       RQB-NPAGES
	       SB-ON
	       SCAVENGER-WS-ENABLE
	       SCHEDULER-STACK-GROUP
	       SCHEME-ON-P ; defined in "SYS:PUBLIC.SCHEME;MODE" but used in "COMPILER;FILE".
 	       SCRATCH-PAD-INIT-AREA
	       SELF-BINDING-INSTANCES
 	       SELF-FLAVOR-DECLARATION
 	       SELF-MAPPING-TABLE
	       SELF-REF
	       SELF-REF-POINTER-FIELDS
	       SET-%INSTANCE-REF
	       SET-ALL-SWAP-RECOMMENDATIONS
	       SET-AR-1
	       SET-AR-1-FORCE
	       SET-AR-2
	       SET-AR-3
	       SET-AREF
	       SET-ARRAY-LEADER
	       SET-CURRENT-BAND
	       SET-FILE-LOADED-ID
	       SET-MEMORY-SIZE
	       SET-PROCESS-WAIT
	       SET-SCAVENGER-WS
	       SET-SWAP-RECOMMENDATIONS-OF-AREA
	       SET-SYSTEM-SOURCE-FILE
	       SET-SYSTEM-STATUS
	       SETCAR
	       SETCDR
	       SETELT
	       SG-AC-1
	       SG-AC-2
	       SG-AC-3
	       SG-AC-4
	       SG-AC-A
	       SG-AC-B
	       SG-AC-C
	       SG-AC-D
	       SG-AC-E
	       SG-AC-F
	       SG-AC-G
	       SG-AC-H
	       SG-AC-I
	       SG-AC-J
	       SG-AC-K
	       SG-AC-L
	       SG-AC-Q
	       SG-AC-R
	       SG-AC-S
	       SG-AC-T
	       SG-AC-ZR
	       SG-CALLING-ARGS-NUMBER
	       SG-CALLING-ARGS-POINTER
	       SG-CATCH-POINTER
	       SG-CURRENT-STATE
	       SG-DEBUG-DISPATCH
	       SG-FLAGS-CAR-NUM-MODE
	       SG-FLAGS-CAR-SYM-MODE
	       SG-FLAGS-CDR-NUM-MODE
	       SG-FLAGS-CDR-SYM-MODE
	       SG-FLAGS-DONT-SWAP-IN
	       SG-FLAGS-MAR-MODE
	       SG-FLAGS-METER-ENABLE
	       SG-FLAGS-PGF-WRITE
	       SG-FLAGS-QBBFL
	       SG-FLAGS-TRAP-ENABLE
	       SG-FLAGS-TRAP-ON-CALL
	       SG-FOOTHOLD-DATA
	       SG-FOOTHOLD-EXECUTING-FLAG
	       SG-IN-SWAPPED-STATE
	       SG-INITIAL-FUNCTION-INDEX
	       SG-INST-DISP
	       SG-INST-DISPATCHES
 	       SG-M3-M4-TAGS
 	       SG-MAIN-DISPATCH
	       SG-NAME
	       SG-PDL-PHASE
	       SG-PREVIOUS-STACK-GROUP
	       SG-PROCESSING-ERROR-FLAG
	       SG-PROCESSING-INTERRUPT-FLAG
	       SG-RECOVERY-HISTORY
	       SG-REGULAR-PDL
	       SG-REGULAR-PDL-LIMIT
	       SG-REGULAR-PDL-POINTER
	       SG-RESTORE-MICROSTACK
	       SG-RESUMABLE-P
	       SG-SAFE
	       SG-SAVED-M-FLAGS
	       SG-SAVED-VMA
	       SG-SINGLE-STEP-DISPATCH
	       SG-SINGLE-STEP-TRAP
	       SG-SPECIAL-PDL
	       SG-SPECIAL-PDL-LIMIT
	       SG-SPECIAL-PDL-POINTER
	       SG-STATE
	       SG-STATE-ACTIVE
	       SG-STATE-AWAITING-CALL
	       SG-STATE-AWAITING-ERROR-RECOVERY
	       SG-STATE-AWAITING-INITIAL-CALL
	       SG-STATE-AWAITING-RETURN
	       SG-STATE-ERROR
	       SG-STATE-EXHAUSTED
	       SG-STATE-FIELDS
	       SG-STATE-INTERRUPTED-DIRTY
	       SG-STATE-INVOKE-CALL-ON-RETURN
	       SG-STATE-RESUMABLE
	       SG-STATES
	       SG-SWAP-SV-OF-SG-THAT-CALLS-ME
	       SG-SWAP-SV-ON-CALL-OUT
	       SG-TOP-FRAME
	       SG-TRAP-AP-LEVEL
	       SG-TRAP-MICRO-PC
	       SG-TRAP-TAG
 	       SG-VMA-M1-M2-TAGS
	       SHIFT-LOCK-XORS
	       SHRINK-PDL-SAVE-TOP
	       SIMPLE-ARRAY-P
               SIMPLE-MAKE-ARRAY
	       SIMPLE-PROCESS
	       SINGLE-FLOATP 
	       SINGLE-TO-DOUBLE-FLOAT-EXPONENT-DIFFERENCE
	       SIZE-OF-AREA-ARRAYS
	       SIZE-OF-HARDWARE-A-MEMORY
	       SIZE-OF-HARDWARE-CONTROL-MEMORY
	       SIZE-OF-HARDWARE-DISPATCH-MEMORY
	       SIZE-OF-HARDWARE-LEVEL-1-MAP
	       SIZE-OF-HARDWARE-LEVEL-2-MAP
	       SIZE-OF-HARDWARE-M-MEMORY
	       SIZE-OF-HARDWARE-MICRO-STACK
	       SIZE-OF-HARDWARE-PDL-BUFFER
	       SIZE-OF-OB-TBL
	       SIZE-OF-REGION-ARRAYS
	       SPECIAL-PDL-INDEX               
	       SPECIAL-PDL-LEADER-QS
	       SPECIAL-PDL-SG
	       SPECIAL-PDL-SG-HEAD-POINTER
	       SPECPDL-FIELDS
	       STACK-GROUP-HEAD-LEADER-QS
	       STANDARDIZE-FUNCTION-SPEC
	       STORE-KEYWORD-ARG-VALUES
	       SUBLIS-EVAL-ONCE
	       SUBST-EXPAND
	       SUPPORT-ENTRY-VECTOR
	       SWAP-STATUS
	       SYMBOL-NAME-CONFLICT
	       SYSTEM-COMMUNICATION-AREA
	       SYSTEM-COMMUNICATION-AREA-QS
	       SYSTEM-INITIALIZATION-LIST
	       SYSTEM-VERSION-INFO
	       TARGET-BINARY-FILE-TYPE
	       TEST
 	       TIME-IN-60THS
	       TRANSMIT-BAND
	       TYPEP-STRUCTURE-OR-FLAVOR
	       UNADVISE-1
	       UNBIND-1
	       UNBIND-2
	       UNBIND-3
	       UNBIND-4
	       UNBIND-5
	       UNBIND-6
	       UNBIND-7
	       UNBIND-10
	       UNBIND-11
	       UNBIND-12
	       UNBIND-13
	       UNBIND-14
	       UNBIND-15
	       UNBIND-16
	       UNBIND-TO-INDEX
	       UNBIND-TO-INDEX-MOVE              
	       UNBUFFERED-LINE-INPUT-STREAM
	       UNDO-DECLARATIONS-FLAG
	       UNDOABLE-FORMS-1
	       UNENCAPSULATE-FUNCTION-SPEC
	       UNFASL
	       UNFASL-PRINT
	       UNWIRE-PAGE
	       UPDATE-PARTITION-COMMENT
	       USER-INIT-OPTIONS
 	       VALIDATE-FUNCTION-SPEC
	       VANILLA-FLAVOR
	       WARM-INITIALIZATION-LIST
	       WIRE-PAGE
	       WITH-SELF-ACCESSIBLE
	       XR-XRTYI
	       XR-XRUNTYI
 	       
;; Standard fundamental error flavors
	       
	       AUTOMATIC-ABORT-DEBUGGER-MIXIN
	       NO-ACTION-MIXIN
	       PROCEED-WITH-VALUE-MIXIN
	       WARNING
	       
;; Standard error flavors
	       
	       ARITHMETIC-ERROR
	       BAD-ARRAY-MIXIN
	       CELL-CONTENTS-ERROR
	       END-OF-FILE
	       PACKAGE-ERROR
	       PACKAGE-LOCKED
	       PACKAGE-NOT-FOUND
	       READ-END-OF-FILE
	       READ-ERROR
	       UNBOUND-VARIABLE
	       
;; A few signal-names, not advertised, but here for communication with signalers
	       
	       READ-ERROR-1
	       END-OF-FILE-1
	       
;; Standard error condition names
	       
	       ABORT
	       AREA-OVERFLOW
	       ARRAY-HAS-NO-LEADER
	       ARRAY-WRONG-NUMBER-OF-DIMENSIONS
	       BAD-ARRAY-ERROR
	       BAD-ARRAY-TYPE
	       BAD-CDR-CODE
	       BAD-DATA-TYPE-IN-MEMORY
	       BAD-INTERNAL-MEMORY-SELECTOR-ARG
	       BAD-KEYWORD-ARGLIST
	       BIGNUM-NOT-BIG-ENOUGH-DPB
	       BITBLT-DESTINATION-TOO-SMALL
	       BREAK-CONDITION
	       BREAKPOINT
	       CALL-TRAP
	       CONS-IN-FIXED-AREA
	       CONS-ZERO-SIZE
	       DATA-TYPE-SCREWUP
	       DISK-ERROR
	       DIVIDE-BY-ZERO
	       DRAW-OFF-END-OF-SCREEN
	       DRAW-ON-UNPREPARED-SHEET
	       EXIT-TRAP
	       FAILED-ASSERTION
	       FILL-POINTER-NOT-FIXNUM
	       FIXNUM-OVERFLOW
	       FLOATING-EXPONENT-OVERFLOW
	       FLOATING-EXPONENT-UNDERFLOW
	       FUNCALL-MACRO
	       HOST-NOT-RESPONDING
	       IALLB-TOO-SMALL
	       ILLEGAL-INSTRUCTION
	       INVALID-FORM
	       INVALID-FUNCTION
	       INVALID-FUNCTION-SPEC
	       INVALID-LAMBDA-LIST
	       LOCK-TIMEOUT
	       MICRO-CODE-ENTRY-OUT-OF-RANGE
	       MISSING-CLOSEPAREN
	       MVR-BAD-NUMBER
	       NEGATIVE-SQRT
	       NO-MAPPING-TABLE
	       NO-MAPPING-TABLE-1
	       NON-POSITIVE-LOG
	       NUMBER-ARRAY-NOT-ALLOWED
	       PACKAGE-ERROR
	       PACKAGE-NOT-FOUND
	       PACKAGE-NOT-FOUND-1
	       PARSE-ERROR
	       PARSE-FERROR
	       PDL-OVERFLOW
	       PRINT-NOT-READABLE
	       READ-LIST-END-OF-FILE
	       READ-PACKAGE-NOT-FOUND
	       READ-STRING-END-OF-FILE
	       READ-SYMBOL-END-OF-FILE
	       REDEFINITION
	       REGION-TABLE-OVERFLOW
	       RPLACD-WRONG-REPRESENTATION-TYPE
	       SELECT-METHOD-BAD-SUBROUTINE-CALL
	       SELECT-METHOD-GARBAGE-IN-SELECT-METHOD-LIST
	       SELECTED-METHOD-NOT-FOUND
	       SELF-NOT-INSTANCE
	       SHUTDOWN
	       SIMPLE-VECTOR-SIZE-P
	       STACK-FRAME-TOO-LARGE
	       STEP-BREAK
	       STREAM-CLOSED
	       STREAM-INVALID
	       STRING-EQUAL*
	       STRING=*
	       SUBSCRIPT-OUT-OF-BOUNDS
	       SYMBOL-FROM-VALUE-CELL-LOCATION
	       SYMBOL-NAME-CONFLICT
	       TAPE-ERROR
	       THROW-EXIT-TRAP
	       THROW-TAG-NOT-SEEN
	       TOO-FEW-ARGUMENTS
	       TOO-MANY-ARGUMENTS
	       TYPE-CANONICALIZE
	       UNBOUND-CLOSURE-VARIABLE
	       UNBOUND-INSTANCE-VARIABLE
	       UNBOUND-LOCAL-VARIABLE		;Never signaled, at the present time.
	       UNBOUND-SPECIAL-VARIABLE
	       UNBOUND-SYMBOL
	       UNBOUND-VARIABLE
	       UNCLAIMED-MESSAGE
	       UNDEFINED-FUNCTION
	       UNDEFINED-KEYWORD-ARGUMENT
	       UNKNOWN-LOCF-REFERENCE
	       UNKNOWN-SETF-REFERENCE
	       VIRTUAL-MEMORY-OVERFLOW
	       WRITE-IN-READ-ONLY
	       WRONG-STACK-GROUP-STATE
	       WRONG-TYPE-ARGUMENT
	       ZERO-ARGS-TO-SELECT-METHOD
	       ZERO-LOG
	       ZERO-TO-NEGATIVE-POWER
	       SI:*APPEND  
	  SI:*NCONC
	  SI:MEMBER-TEST
	  SI:MEMBER-EQUAL
	  SI:MEMBER-EQL
	  SI:MEMBER-EQUALP
	  SI:MEMBER* 
	  SI:MEMBER-IF*
	  SI:MEMBER-IF-NOT*
	  SI:ASSOC-TEST
	  SI:ASSOC-EQUAL
	  SI:ASSOC-EQL
	  SI:ASSOC-EQUALP
	  SI:ASSOC-TESTNOT
	  SI:RASSOC-EQUAL
	  SI:RASSOC-TEST
	  SI:RASSOC-TESTNOT
	  SI:RASSOC-EQL 
	  SI:RASSOC-EQUALP
	  SI:ADJOIN-TEST
	  SI:ADJOIN* 
	  SI:SUBST-EQUAL
	  SI:SUBST-EQL
	  SI:SUBST*
	  SI:SUBST-IF*
	  SI:SUBST-IF-NOT*
	  SI:NSUBST* 
	  SI:NSUBST-IF*
	  SI:NSUBST-IF-NOT*
	  SI:SUBLIS* 
	  SI:NSUBLIS*
	  SI:INTERSECTION*
	  SI:NINTERSECTION*
	  SI:SET-DIFFERENCE*
	  SI:NSET-DIFFERENCE*
	  SI:UNION-TEMPLATE
	  SI:UNION*
	  SI:NUNION-TEMPLATE
	  SI:NUNION*
	  SI:NSET-EXCLUSIVE-OR*
	  SI:SET-EXCLUSIVE-OR*
	  SI:SUBSETP*   ;; <----- LAST SYMBOL FROM LISTS
	  SI:INTERNAL-MAKE-VECTOR   ;; <---- SEQUENCES1
	  SI:ADJUST-VECTOR
	  SI:REPLACE*
	  SI:REVERSE-LIST
	  SI:REVERSE-VECTOR
	  SI:NREVERSE-LIST
	  SI:NREVERSE-VECTOR
	  SI:REDUCE-VECTOR
	  SI:REDUCE-LIST
	  SI:REDUCE*
	  SI:FILL-VECTOR
	  SI:FILL-LIST
	  SI:FILL*		  ;; <---------- LAST SYMBOL FROM SEQUENCES1
	  SI:SEARCH*
	  SI:SEARCH*-LIST
	  SI:SEARCH*-LIST-EQ-OR-EQL
	  SI:SEARCH*-STRING-CASE
	  SI:SEARCH*-STRING-CASE-FROMEND
	  SI:SEARCH*-STRING-NOCASE
	  SI:SEARCH*-STRING-NOCASE-FROMEND
	  SI:SEARCH*-VECTOR
	  SI:SEARCH*-VECTOR-EQL
	  SI:SEARCH*-VECTOR-FROMEND
	  SI:COPY-ARRAY-BELOW-INDEX
	  SI:COPY-LIST-BELOW-INDEX
	  SI:DELETE-LIST
	  SI:DELETE-IF-LIST
	  SI:DELETE-IF-NOT-LIST
	  SI:DELETE-VECTOR
	  SI:DELETE-IF-VECTOR
	  SI:DELETE-IF-NOT-VECTOR
	  SI:DELETE-IF*
	  SI:DELETE-IF-NOT*
	  SI:DELETE*
	  SI:DELETE-LIST-EQ
	  SI:DELETE-LIST-EQUAL
	  SI:DELETE-LIST-EQL
	  SI:REMOVE-LIST
	  SI:REMOVE-IF-LIST
	  SI:REMOVE-IF-NOT-LIST
	  SI:REMOVE-VECTOR
	  SI:REMOVE-IF-VECTOR
	  SI:REMOVE-IF-NOT-VECTOR
	  SI:REMOVE-IF*
	  SI:REMOVE-IF-NOT*
	  SI:REMOVE*
	  SI:REMOVE-LIST-EQ
	  SI:REMOVE-LIST-EQUAL
	  SI:REMOVE-LIST-EQL
	  SI:DELETE-DUPLICATES-LIST
	  SI:DELETE-DUPLICATES-LIST-EQL
	  SI:DELETE-DUPLICATES-VECTOR
	  SI:DELETE-DUPLICATES*
	  SI:REMOVE-DUPLICATES-LIST
	  SI:REMOVE-DUPLICATES-LIST-EQL
	  SI:REMOVE-DUPLICATES-VECTOR
	  SI:REMOVE-DUPLICATES*
	  SI:FIND-LIST
	  SI:FIND-IF-LIST
	  SI:FIND-IF-NOT-LIST
	  SI:FIND-VECTOR
	  SI:FIND-IF-VECTOR
	  SI:FIND-IF-NOT-VECTOR
	  SI:FIND*
	  SI:FIND-IF*
	  SI:FIND-IF-NOT*
	  SI:POSITION*
	  SI:POSITION-IF*
	  SI:POSITION-IF-NOT*
	  SI:NSUBSTITUTE-LIST
	  SI:NSUBSTITUTE-IF-LIST
	  SI:NSUBSTITUTE-IF-NOT-LIST
	  SI:NSUBSTITUTE-VECTOR
	  SI:NSUBSTITUTE-IF-VECTOR
	  SI:NSUBSTITUTE-IF-NOT-VECTOR
	  SI:NSUBSTITUTE*
	  SI:NSUBSTITUTE-IF*
	  SI:NSUBSTITUTE-IF-NOT*
	  SI:SUBSTITUTE-LIST
	  SI:SUBSTITUTE-IF-LIST
	  SI:SUBSTITUTE-IF-NOT-LIST
	  SI:SUBSTITUTE-VECTOR
	  SI:SUBSTITUTE-IF-VECTOR
	  SI:SUBSTITUTE-IF-NOT-VECTOR
	  SI:SUBSTITUTE*
	  SI:SUBSTITUTE-IF*
	  SI:SUBSTITUTE-IF-NOT*
	  SI:COUNT-LIST
	  SI:COUNT-IF-LIST
	  SI:COUNT-IF-NOT-LIST
	  SI:COUNT-VECTOR
	  SI:COUNT-IF-VECTOR
	  SI:COUNT-IF-NOT-VECTOR
	  SI:COUNT*
	  SI:COUNT-IF*
	  SI:COUNT-IF-NOT*))
	       
		




