;;;-*- cold-load:t; Mode: Common-Lisp; Package: SI; Base: 10. -*-

;;;                           RESTRICTED RIGHTS LEGEND

;;;Use, duplication, or disclosure by the Government is subject to
;;;restrictions as set forth in subdivision (c)(1)(ii) of the Rights in
;;;Technical Data and Computer Software clause at 52.227-7013.

;;;                     TEXAS INSTRUMENTS INCORPORATED.
;;;                              P.O. BOX 2909
;;;                           AUSTIN, TEXAS 78769
;;;                                 MS 2151

;; Copyright (c) 1986-1989 Texas Instruments Incorporated.  All Rights Reserved.

;;;  Initial Symbols in the ZLC (ZetaLisp Compatibility) Package.

;;;  Contains all Zetalisp-specific and all obsolete symbols.
;;;  Those Zetalisp symbols that are incompatible with their 
;;;  Common Lisp namesakes are specified as internal ZLC symbols,
;;;  while all other ZLC symbols are external.  When Zetalisp mode
;;;  is turned on, the reader and the evaluator access the
;;;  internal, incompatible Zetalisp symbols instead of the ones
;;;  defined in the LISP or TICL packages.

;;;  5/02/89 JLM  Added DBG 

(defconstant *INITIAL-ZLC-SYMBOLS*
	     'zlc:(%args-info
		/$				
		*$
		-$				
		+$				
		1-$				
		1+$				
		*all-packages*
		*array
		*default-pathname-defaults*
		*catch
		*dif
		*expr
		*fexpr
		*lexpr
		*lexpr-arglist*
		*plus
		*quo
		*throw
		*times
		
		
		
		/			
		\\
		\\\\
		^
		^$
		add1
		adjust-array-size
		allow-variables-in-function-position-switch
		all-special-switch		
		ar-1
		ar-1-force
		ar-2-reverse
		aref
		arg
		args-info
		array-#-dims
		array-dimension-n
		array-grow
		array-index-order
		array-pop
		array-push
		array-push-extend
		arraycall
		arraydims
		as-2-reverse
		ascii
		aset
		ass
		assq
		assoc
		atan
		atan2
		base
		bit-test
		caseq
		ceil
		char
		char
		char
		character
		check-arg-type
		;; class ; removed 2/27/89 by DNG; no longer defined for Zetalisp, but conflicts with CLOS
		close
		clrhash-equal
		compile-file-alist
		copyalist
		copylist
		copysymbol
		copytree
		dbg				;jlm 5/8/89
		debugging-info
		declare-flavor-instance-variables
		defconst
		defstruct
		defunp
		del
		del-if
		del-if-not
		delete
		deletef
		delq
		deposit-byte
		difference
		do-named
		DO*-NAMED
;;;		elt
		entity
		entityp
		err
;;		error             
		error-output
		explode
		explodec
		exploden
		eval
		every
		fexpr				
		fillarray
		find-position-in-list
		find-position-in-list-equal
		fix
		fixp
		fixr
		float
		format
		fset
		fset-carefully
		fsymeval
		funcall-self
		get-alternate
		get-from-alternating-list
		get-pname
		getchar
		getcharn
		gethash-equal
		globalize
		greaterp
		ibase
		implode
		intern-local-soft
		intern-soft
		intersection
		lambda
		lessp
		lexpr-funcall
		lexpr-funcall-self
		listify
		listp
		load-byte
		load-file-alist
		load-file-list
		local-declare
		make-equal-hash-table
		make-hash-table
		make-instance ; added 3/16/89 by DNG
		make-pixel-array
		make-syn-stream
		maknam
		map
		maphash-equal
		mem
		memass
		member
		memq
		minus
		multiple-value
		named-lambda
		named-subst
		ncons
		ncons-in-area
		nintersection
		nlistp
		nunion
		package-declare
		pixel-array-height
		pixel-array-width
		pkg-create-package
		pkg-kill
		pkg-name
		plist
		plus
		prinlength
		prinlevel
		probef
		process-create
		process-run-temporary-function
		put-on-alternating-list
		puthash-equal
		qc-file
		qc-file-load
		rass
		rassoc
		rassq
		read
		read-from-string
		readch
		readline
		rem-if
		rem-if-not
		rem
		remainder
		remhash-equal
		remob
		remove
		remq
		renamef
		rest1
		rest2
		rest3
		rest4
		return-list
		samepnamep
		sassoc
		sassq
		select-processor
		selectq
		setarg
		setplist
		signp
		some
		sstatus
		standard-input
		standard-output
		status
		store
		string
		string-length
		string-nreverse
		string-reverse
		string-reverse-search
		string-reverse-search-char
		string-reverse-search-not-char
		string-search
		string-search-char
		string-search-not-char
		string=
		string
		string
		string
		string-equal
		sub1
		subrp
		subset
		subset-not
		subst
		substring
		swapf
		swaphash-equal
		symeval
		terminal-io
		terpri
		times
		trunc
		tyo
		undeletef
		union
		viewf
		xcons
		xcons-in-area
		xstore
		))

;;;  *EXTERNAL-ZLC-SYMBOLS* are exported by PKG-INITIALIZE.

(defconstant *EXTERNAL-ZLC-SYMBOLS*
	     'zlc:(%args-info
		/$				
		*$				
		-$				
		+$				
		1-$				
		1+$				
		*all-packages*
		*array
		*catch
		*dif
		*expr
		*fexpr
		*lexpr
		*lexpr-arglist*
		*plus
		*quo
		*throw
		*times
		
		
		
		\\
		\\\\
		^
		^$
		add1
		adjust-array-size
		allow-variables-in-function-position-switch
		all-special-switch		
		ar-2-reverse
		arg
		args-info
		array-#-dims
		array-dimension-n
		array-grow
		array-index-order
		array-pop
		array-push
		array-push-extend
		arraycall
		arraydims
		as-2-reverse
		ascii
		aset
		ass
		assq
		atan2
		base
		bit-test
		caseq
		ceil
		char
		char
		char
		check-arg-type
		;; class ; removed 3/8/89 by DNG; no longer defined for Zetalisp, but conflicts with CLOS
		clrhash-equal
		compile-file-alist
		copyalist
		copylist
		copysymbol
		copytree
		dbg				;jlm 5/8/89
		debugging-info
		declare-flavor-instance-variables
		defconst
		defunp
		del
		del-if
		del-if-not
		deletef
		delq
		deposit-byte
		difference
		do-named
		do*-named
		entity
		entityp
		err
		error-output
		explode
		explodec
		exploden
		fexpr				
		fillarray
		find-position-in-list
		find-position-in-list-equal
		fix
		fixp
		fixr
		fset
		fset-carefully
		fsymeval
		funcall-self
		get-alternate
		get-from-alternating-list
		get-pname
		getchar
		getcharn
		gethash-equal
		globalize
		greaterp
		ibase
		implode
		intern-local-soft
		intern-soft
		lessp
		lexpr-funcall
		lexpr-funcall-self
		listify
		load-byte
		load-file-alist
		load-file-list
		local-declare
		make-equal-hash-table
		make-pixel-array
		make-syn-stream
		maknam
		maphash-equal
		mem
		memass
		memq
		minus
		multiple-value
		ncons
		ncons-in-area
		package-declare
		pixel-array-height
		pixel-array-width
		pkg-create-package
		pkg-kill
		pkg-name
		plist
		plus
		prinlength
		prinlevel
		probef
		process-create
		process-run-temporary-function
		put-on-alternating-list
		puthash-equal
		qc-file
		qc-file-load
		rass
		rassq
		readch
		readline
		rem-if
		rem-if-not
		remainder
		remhash-equal
		remob
		remq
		renamef
		rest1
		rest2
		rest3
		rest4
		return-list
		samepnamep
		sassoc
		sassq
		select-processor
		selectq
		setarg
		setplist
		signp
		sstatus
		standard-input
		standard-output
		status
		store
		string-length
		string-nreverse
		string-reverse
		string-reverse-search
		string-reverse-search-char
		string-reverse-search-not-char
		string-search
		string-search-char
		string-search-not-char
		string
		string
		string
		sub1
		subrp
		subset
		subset-not
		substring
		swapf
		swaphash-equal
		symeval
		terminal-io
		times
		trunc
		tyo
		undeletef
		viewf
		xcons
		xcons-in-area
		xstore
		))
