;;; -*- Mode: Lisp; Package: GLOSS; Base: 10 -*-


(SETQ GLOSS:BINARY-FORMAT-VERSION 1)

(SETQ
 GLOSS:TEMPORARY-GLOSSARY-ENTRY-LIST
 (QUOTE
  (("a-list"
    (("                See association list.  " (20 35 "association list"))
     ("  ")
     ("")))
   ("abnormal shutdown"
    (("                See crash." (20 24 "CRASH")) ("                ")
                                                    ("")))
   ("ABORT key"
    (("                See program control keys.  "
      (20 39 "program control keys"))
     ("  ")
     ("")))
   ("access function"
    (("                A  function  that  can  access  each  element  of  a defined"
      (19 26 "function")
      (54 60 "element"))
     ("                structure. This  function  is  usually created automatically"
      (16 24 "structure")
      (33 40 "function"))
     ("                when the structure is defined." (25 33 "structure"))
     ("                  ")
     ("")))
   ("access operation"
    (("                Any  operation  that  recovers  the  value  of  a referenced")
     ("                object.  " (16 21 "object"))
     ("  ")
     ("")))
   ("accessor function"
    (("                See access function.  " (20 34 "access function"))
     ("  ")
     ("")))
   ("activation environment"
    (("                The calling environment; the environment currently in  force"
      (28 38 "environment"))
     ("                when a call to a function occurs.  " (33 40
                                                                "function"))
     ("  ")
     ("")))
   ("active element"
    (("                An element of a vector that is in use.  That is, if a vector"
      (19 25 "element")
      (32 37 "vector"))
     ("                has a fill pointer, all elements with an index less than the"
      (22 33 "fill pointer")
      (40 46 "element"))
     ("                fill pointer are considered  to be active.   If there is  no"
      (16 27 "fill pointer"))
     ("                fill pointer, all elements of the vector are active."
      (16 27 "fill pointer")
      (34 40 "element")
      (50 55 "vector"))
     ("                ")
     ("")))
   ("active process"
    (("                A  process  that  is  either currently running or waiting to"
      (19 25 "process"))
     ("                run; a process that has at  least  one  run  reason  and  no"
      (23 29 "process")
      (56 66 "run reason"))
     ("                arrest reasons.  " (16 21 "arrest"))
     ("  ")
     ("")))
   ("active window"
    (("                An existing  window  that  can  be  exposed  if its superior"
      (29 34 "window"))
     ("                window has a screen array, or  any window that  has had  its"
      (16 21 "window")
      (29 40 "screen array"))
     ("                window object presented to the screen manager for scheduling"
      (16 21 "window")
      (23 28 "object")
      (47 60 "screen manager"))
     ("                to be displayed on  the screen.  You  can select any  active"
      (40 45 "screen")
      (58 63 "select"))
     ("                window or create a new one as desired.  "
      (16 21 "window"))
     ("                  ")
     ("")))
   ("adjust"
    (("                For text, to justify or add spaces until the  right  margins"
      (29 35 "justify")
      (69 74 "margin"))
     ("                of each line align.  For arrays, to change the length of the"
      (41 45 "array"))
     ("                array.  " (16 20 "array"))
     ("  ")
     ("")))
   ("advise"
    (("                To add code before, after, or around a function so that  you"
      (55 62 "function"))
     ("                modify its  behavior  without  actually  changing its source")
     ("                definition and without its caller  knowing there has been  a")
     ("                change.  This procedure is useful for testing a change  to a")
     ("                function  without   committing   to   that   change  or  for"
      (16 23 "function"))
     ("                customizing a function that is also used elsewhere.   Advise"
      (30 37 "function"))
     ("                should  be  used  for   debugging  purposes  only--not   for")
     ("                production work.  ")
     ("  ")
     ("")))
   ("after daemon"
    (("                A method  called  after  the  primary  method  of a combined"
      (18 23 "method")
      (46 60 "primary method"))
     ("                method.  See daemon method. " (16 21 "method")
                                                     (29 41 "daemon method"))
     ("                ")
     ("")))
   ("alu function"
    (("                See arithmetic logic unit function.  "
      (20 49 "arithmetic logic unit function"))
     ("  ")
     ("")))
   ("ancestor"
    (("                A  higher-level,  or  preceding,  node  in  a   hierarchical")
     ("                structure  such  as  the  window  system.   For  example,  a"
      (16 24 "structure")
      (42 55 "window system"))
     ("                window's ancestors are the superior window of the window and"
      (43 57 "superior window"))
     ("                all the superior windows of the superior window.  "
      (24 38 "superior window"))
     ("  ")
     ("")))
   ("application"
    (("                1.  The act of  binding  argument  values  to  a  function's"
      (32 38 "binding")
      (41 48 "argument"))
     ("                parameters  and executing the function within the context of"
      (16 24 "parameter")
      (46 53 "function"))
     ("                those   values.    Normally,   application   is    performed")
     ("                automatically  whenever  a  function-call  form is evaluated"
      (44 51 "function")
      (59 62 "form"))
     ("                (implicit  application).   However,   application   can   be")
     ("                explicitly invoked by the special forms apply and funcall. "
      (42 53 "special form"))
     ("  ")
     ("                2.   A  program  that  allows the user to solve a particular")
     ("                problem or to perform a particular task.  ")
     ("  ")
     ("")))
   ("apropos"
    (("                A facility that searches the system for  all  symbols  whose"
      (45 50 "system")
      (62 67 "symbol"))
     ("                print   names   contain   a   specified  string  and  prints"
      (16 27 "print name")
      (57 62 "string"))
     ("                information about the symbols found. This facility  provides"
      (38 43 "symbol"))
     ("                features  for  performing  complex,  extended  searches; for"
      (53 68 "extended search"))
     ("                example, you can search for a combination  of  two  strings."
      (68 73 "string"))
     ("                Different  utilities  have different apropos functions.  For"
      (61 68 "function"))
     ("                example, you  can  search  for  Lisp  symbols  in  the  Lisp"
      (48 51 "Lisp")
      (54 59 "symbol"))
     ("                Listener,  and  you  can search for Zmacs command names when"
      (16 23 "Listener")
      (52 56 "Zmacs"))
     ("                you are in Zmacs.  " (27 31 "Zmacs"))
     ("  ")
     ("")))
   ("apropos completion"
    (("                See completion.  " (20 29 "completion")) ("  ") ("")))
   ("area"
    (("                A logical division of virtual memory that comprises  one  or")
     ("                more  physical  divisions  (regions).   An  area can contain")
     ("                related objects of any type.  You can specify which  area(s)"
      (24 29 "object"))
     ("                your  program  is  to  use  for  storage, or you can use the")
     ("                default area.  Specifying areas gives you more control  over")
     ("                garbage collection and paging operations for your program.  ")
     ("  ")
     ("")))
   ("argument"
    (("                An  object in a function-call form whose value is bound to a"
      (20 25 "object")
      (32 39 "function")
      (46 49 "form"))
     ("                corresponding parameter in the function's lambda list.  This"
      (30 38 "parameter")
      (58 68 "lambda list"))
     ("                is analogous to an actual  parameter  in  other  programming"
      (43 51 "parameter"))
     ("                languages.  ")
     ("  ")
     ("")))
   ("arithmetic logic unit function"
    (("                A graphics operation function that controls the way the bits"
      (37 44 "function")
      (72 74 "bit"))
     ("                of  the  graphic  object being drawn are combined with those"
      (34 39 "object"))
     ("                already present in the window.  This is also called  an  alu"
      (39 44 "window"))
     ("                function.  " (16 23 "function"))
     ("  ")
     ("")))
   ("array"
    (("                A Lisp object consisting of multiple components or elements,"
      (18 28 "Lisp object")
      (67 73 "element"))
     ("                dimensionally  arranged  according to a Cartesian coordinate")
     ("                system.   An  array  can  have  any  nonnegative  number  of"
      (16 21 "system")
      (66 71 "number"))
     ("                dimensions;   the   components   are  indexed  by  numerical")
     ("                subscripts consisting of a sequence of integers.  "
      (43 50 "sequence"))
     ("  ")
     ("                A general  array  (art-q)  can  hold  any  Lisp  objects  as"
      (18 31 "general array")
      (59 70 "Lisp object"))
     ("                components.  A specialized array can hold only certain types"
      (31 47 "specialized array"))
     ("                of Lisp objects.  " (19 29 "Lisp object"))
     ("  ")
     ("")))
   ("array leader"
    (("                A one-dimensional array containing data about, and  attached"
      (34 38 "array"))
     ("                to, another array  of arbitrary  dimensions.  An  array that"
      (28 32 "array"))
     ("                has a leader acts like two arrays joined together, which can"
      (22 27 "leader")
      (43 47 "array"))
     ("                be treated  as  one  object.   This, in  effect, produces  a"
      (37 42 "object"))
     ("                property list  for  arrays  in  that it allows you to attach"
      (16 28 "property list")
      (36 40 "array"))
     ("                arbitrary information to an array." (44 48 "array"))
     ("                ")
     ("")))
   ("arrest"
    (("                To stop or halt a  process.   An  arrested  process  is  not"
      (35 41 "process"))
     ("                allowed  to  run  or  compete for resources until it is made"
      (50 57 "resource"))
     ("                active again.  ")
     ("  ")
     ("")))
   ("art-q array"
    (("                A general array.  Each element of an art-q array can be  any"
      (18 30 "general array")
      (39 45 "element"))
     ("                type of Lisp object.   The term art  stands for array  type."
      (24 34 "Lisp object")
      (64 68 "array"))
     ("                In Common Lisp, an  art-q array is  called simply a  general"
      (19 29 "Common Lisp")
      (42 46 "array"))
     ("                array but has no specific type-specifier name.  "
      (16 20 "array"))
     ("                  ")
     ("")))
   ("association list"
    (("                A data structure consisting of  a  list  of  pairs  (conses)"
      (23 31 "structure")
      (51 54 "list")
      (69 72 "cons"))
     ("                where  each  pair  represents  an  association  between  its")
     ("                objects.  The first element of the pair (the car) is the key"
      (16 21 "object")
      (30 34 "first")
      (36 42 "element")
      (61 63 "car"))
     ("                and the second element (the cdr) is associated  data.   This"
      (31 37 "element")
      (44 46 "cdr"))
     ("                is also referred to as an a-list.  " (42 47 "a-list"))
     ("  ")
     ("")))
   ("association pair"
    (("                A  cons used to represent an association between its car and"
      (19 22 "cons")
      (69 71 "car"))
     ("                its cdr.  " (20 22 "cdr"))
     ("  ")
     ("")))
   ("atom"
    (("                A single, indivisible Lisp object;  specifically,  any  Lisp"
      (38 48 "Lisp object"))
     ("                object that is not a cons.  " (16 21 "object")
                                                     (37 40 "cons"))
     ("  ")
     ("")))
   ("atomic form"
    (("                An  object  that can be evaluated but is not in a list form,"
      (20 25 "object")
      (66 69 "list")
      (71 74 "form"))
     ("                such as a symbol, string, or number.  " (26 31
                                                                   "symbol")
                                                               (34 39
                                                                   "string")
                                                               (45 50
                                                                   "number"))
     ("  ")
     ("")))
   ("attribute list"
    (("                See file attribute list.  "
      (20 38 "file attribute list"))
     ("  ")
     ("")))
   ("autoexposure"
    (("                A feature that automatically exposes a window when it  falls"
      (55 60 "window"))
     ("                entirely  within  unclaimed  areas  of the screen and can be"
      (45 48 "area")
      (59 64 "screen"))
     ("                made visible without deexposing other windows.  "
      (54 59 "window"))
     ("                  ")
     ("")))
   ("autoselect"
    (("                A feature that allows the screen  manager  to  automatically"
      (42 56 "screen manager"))
     ("                select a window if no window is selected.  "
      (16 21 "select")
      (25 30 "window"))
     ("                  ")
     ("")))
   ("aux variable"
    (("                See auxiliary keyword variable.  "
      (20 45 "auxiliary keyword variable"))
     ("  ")
     ("")))
   ("auxiliary keyword variable"
    (("                A  variable (often called an aux variable) that appears in a"
      (19 26 "variable")
      (45 56 "aux variable"))
     ("                function's lambda list.  Aux variables are indicated by  the"
      (27 37 "lambda list")
      (41 52 "aux variable"))
     ("                lambda-list  keyword  &aux.   However, aux variables are not"
      (16 35 "lambda-list keyword")
      (55 66 "aux variable"))
     ("                parameters; they are not bound to any argument value  during"
      (16 24 "parameter")
      (54 61 "argument"))
     ("                function  application.   Their purpose is to establish local"
      (16 23 "function")
      (26 36 "application"))
     ("                variables within the function, and they are bound to  values"
      (16 23 "variable")
      (37 44 "function"))
     ("                specified  in the definition of the function.  Aux varaibles"
      (52 59 "function"))
     ("                behave identically to variables bound with a let* form."
      (38 45 "variable")
      (66 69 "form"))
     ("                ")
     ("")))
   ("backplane"
    (("                A  printed  wiring  board  in  the  system  enclosure   that"
      (52 68 "system enclosure"))
     ("                interconnects the system logic boards, the power supply, and"
      (34 39 "system"))
     ("                the  peripheral  cable adapter (PCA) boards and cables.  The"
      (48 57 "PCA board"))
     ("                Explorer backplane contains eight  slots,  each  with  three")
     ("                rows  of  female  connectors  to mate with the corresponding")
     ("                logic board connectors on one side and the PCA boards on the"
      (59 67 "PCA board"))
     ("                other side.  ")
     ("  ")
     ("")))
   ("backquote facility"
    (("                A facility that allows you to construct  an  expansion  form"
      (72 75 "form"))
     ("                without  having  to use a long sequence of list-manipulating"
      (47 54 "sequence")
      (59 62 "list"))
     ("                functions.  The backquote character (`) allows the expansion"
      (16 23 "function")
      (42 50 "character"))
     ("                function  to  more  closely  resemble  a  template  for  the"
      (16 23 "function"))
     ("                expanded code and makes it easier to use.  ")
     ("  ")
     ("")))
   ("backup system"
    (("                A   window-based   software  facility  for  backing  up  and"
      (20 25 "window"))
     ("                restoring files on cartridge tapes.  " (26 29 "file"))
     ("  ")
     ("")))
   ("band"
    (("                A logical grouping of one or more physical partitions.   See"
      (59 67 "partition"))
     ("                also partition.  " (21 29 "partition"))
     ("                  ")
     ("")))
   ("bar" (("                See foo.  " (20 22 "foo")) ("  ") ("")))
   ("base flavor"
    (("                A  flavor  that  is  used to build a family of other related"
      (19 24 "flavor"))
     ("                flavors.  " (16 21 "flavor"))
     ("  ")
     ("")))
   ("baseline"
    (("                A nonnegative fixnum that is  the  number  of  raster  lines"
      (30 35 "fixnum")
      (51 56 "number"))
     ("                between  the  top  of  each character and the lowest point--"
      (44 52 "character")
      (69 73 "point"))
     ("                excluding the descender--of the character.  "
      (30 38 "descender")
      (48 56 "character"))
     ("  ")
     ("")))
   ("baz" (("                See foo.  " (20 22 "foo")) ("  ") ("")))
   ("beep"
    (("                The output of a function that attracts the user's attention."
      (32 39 "function"))
     ("                Examples are an audible beep or a flashing screen."
      (59 64 "screen"))
     ("                ")
     ("")))
   ("before daemon"
    (("                A method  called  before  the  primary  method of a combined"
      (18 23 "method")
      (47 61 "primary method"))
     ("                method.  See daemon method.  " (16 21 "method")
                                                      (29 41
                                                          "daemon method"))
     ("                  ")
     ("")))
   ("bignum"
    (("                A  big  number; any integer less than -2**25 or greater than"
      (24 29 "number"))
     ("                (2**25)-1.  A bignum requires more than one word of memory. "
      (60 63 "word"))
     ("  ")
     ("")))
   ("bind"
    (("                To temporarily associate  a value  with a  symbol.  When the"
      (59 64 "symbol"))
     ("                association is  removed,  the  symbol  assumes  its previous"
      (47 52 "symbol"))
     ("                value.")
     ("                  ")
     ("")))
   ("binding"
    (("                The value currently assigned to a symbol.  "
      (50 55 "symbol"))
     ("  ")
     ("")))
   ("bit"
    (("                The smallest unit of information that can be represented  in")
     ("                computer hardware.  ")
     ("  ")
     ("")))
   ("bit array"
    (("                An  array  whose  elements consist of bits only.  Bit arrays"
      (20 24 "array")
      (34 40 "element")
      (54 56 "bit"))
     ("                are primarily used for graphics operations.  ")
     ("  ")
     ("")))
   ("bit map"
    (("                A two-dimensional memory array on the system interface board"
      (41 45 "array")
      (54 75 "system interface board"))
     ("                that stores the  values  for  the  pixels  on  the  physical"
      (51 55 "pixel"))
     ("                display.  Each  element  of  the  array  is  one  bit, which"
      (32 38 "element")
      (50 54 "array")
      (66 68 "bit"))
     ("                corresponds to one pixel.  Images  are  constructed  on  the"
      (35 39 "pixel"))
     ("                display by setting the appropriate bits in memory.  "
      (51 53 "bit"))
     ("  ")
     ("")))
   ("bit vector"
    (("                A vector whose elements consist of bits only.  "
      (18 23 "vector")
      (31 37 "element")
      (51 53 "bit"))
     ("  ")
     ("")))
   ("bit-save array"
    (("                An  array  used  to  hold  the  contents (pixel values) of a"
      (20 24 "array"))
     ("                window when the window is not fully visible on  the  screen."
      (16 21 "window")
      (69 74 "screen"))
     ("                When  the  window  becomes fully visible again, the contents"
      (27 32 "window"))
     ("                are copied from the bit-save array back into the bit map.  "
      (36 38 "bit")
      (45 49 "array")
      (65 71 "bit map"))
     ("  ")
     ("")))
   ("bitblt"
    (("                A  bit block transfer operation.  The bitblt function copies"
      (19 21 "bit")
      (61 68 "function"))
     ("                a rectangular portion of an array to another array.  "
      (44 48 "array"))
     ("  ")
     ("")))
   ("bits attribute"
    (("                Extra flags associated with a character.  A  character  with"
      (46 54 "character"))
     ("                attribute bits is produced by a key used in combination with"
      (26 28 "bit"))
     ("                the SUPER, HYPER, META, or CTRL keys.  "
      (43 50 "CTRL key"))
     ("  ")
     ("")))
   ("bitwise logical operation"
    (("                A  Boolean   logical   operation   performed   on   matching")
     ("                subscripted  elements  of two or more bit arrays of matching"
      (29 35 "element")
      (54 62 "bit array"))
     ("                rank and dimensions.  " (16 19 "rank"))
     ("  ")
     ("")))
   ("black plane"
    (("                A buffer in the  font  editor  that  normally  contains  the"
      (18 23 "buffer")
      (33 44 "font editor"))
     ("                character you are editing (compare with gray plane).  Pixels"
      (16 24 "character")
      (56 65 "gray plane")
      (70 74 "pixel"))
     ("                that are set only in the black plane are displayed in black;"
      (25 27 "set")
      (47 51 "plane"))
     ("                pixels  that  are  set  in both the black plane and the gray"
      (16 20 "pixel")
      (35 37 "set")
      (58 62 "plane"))
     ("                plane are shown in medium gray.  " (16 20 "plane"))
     ("  ")
     ("")))
   ("blinker"
    (("                A visible indicator used to mark a  location  in  a  window."
      (26 34 "indicator")
      (44 47 "mark")
      (69 74 "window"))
     ("                Blinkers  appear  in various shapes and sizes.  A window can"
      (66 71 "window"))
     ("                use any number of blinkers.  Some blinkers  actually  blink,"
      (24 29 "number"))
     ("                but  others  are  visible  continuously.   When blinkers are")
     ("                turned off, they become invisible.  The keyboard cursor  and"
      (56 70 "keyboard cursor"))
     ("                the mouse cursor are examples of blinkers.  "
      (20 31 "mouse cursor"))
     ("  ")
     ("")))
   ("blip"
    (("                A character in the input buffer that is actually a list.  It"
      (18 26 "character")
      (41 46 "buffer")
      (67 70 "list"))
     ("                is  often used for program-generated input, especially mouse"
      (71 75 "mouse"))
     ("                clicks.  By convention, the car of the  list  indicates  the"
      (16 20 "click")
      (44 46 "car")
      (56 59 "list"))
     ("                type  of  the  blip.  For simple mouse click blips, the blip"
      (49 59 "mouse click"))
     ("                indicates not only which mouse button was clicked, but  also"
      (41 45 "mouse")
      (58 62 "click"))
     ("                where on the screen the mouse cursor was located.  "
      (29 34 "screen")
      (40 51 "mouse cursor"))
     ("  ")
     ("")))
   ("blt" (("                An abbreviation for block transfer.  ") ("  ")
                                                                     ("")))
   ("BOLD LOCK key"
    (("                See mode keys.  " (20 28 "mode keys")) ("  ") ("")))
   ("boot"
    (("                The  reinitializing  of  the system.  See also cold boot and"
      (45 50 "system")
      (63 71 "cold boot"))
     ("                warm boot.  " (16 24 "warm boot"))
     ("  ")
     ("")))
   ("boot partition"
    (("                A disk  band  that  contains  the  code  for  the  menu boot"
      (24 27 "band")
      (67 75 "menu boot"))
     ("                procedure.  ")
     ("                  ")
     ("")))
   ("border"
    (("                A  rectangular  box  drawn  around  the outside of a window."
      (32 34 "box")
      (69 74 "window"))
     ("                Borders are margin items and consist of  straight  lines  of"
      (28 38 "margin item"))
     ("                variable thickness unless you define them differently.  "
      (16 23 "variable"))
     ("  ")
     ("                An  area  of  whitespace,  known as the border margin width,"
      (20 23 "area")
      (30 39 "whitespace")
      (56 74 "border margin width"))
     ("                separates the border from the inside of the  window  or  the"
      (61 66 "window"))
     ("                next  innermost  margin  item to keep them from merging with"
      (33 44 "margin item"))
     ("                the border.  ")
     ("  ")
     ("")))
   ("border margin width"
    (("                See border.  " (20 25 "border")) ("  ") ("")))
   ("bound variable"
    (("                A  variable  that  has  some  value  assigned  to  it.    In"
      (19 26 "variable"))
     ("                particular,  the  parameters  of a lambda list of a function"
      (34 42 "parameter")
      (51 61 "lambda list")
      (68 75 "function"))
     ("                definition are bound to argument values  when  the  function"
      (40 47 "argument")
      (68 75 "function"))
     ("                definition is invoked.  ")
     ("  ")
     ("")))
   ("box"
    (("                To  point  to  a mouse-sensitive item with the mouse cursor."
      (20 24 "point")
      (33 52 "mouse-sensitive item")
      (63 74 "mouse cursor"))
     ("                When you  do  this,  a  box  appears  around  the  item  and")
     ("                information  about  the  item  usually  appears in the mouse"
      (71 75 "mouse"))
     ("                documentation line.  When an item is boxed, you can  perform")
     ("                an  operation  on  the  item  by  clicking  one of the mouse"
      (50 54 "click")
      (71 75 "mouse"))
     ("                buttons.  ")
     ("  ")
     ("")))
   ("break"
    (("                To halt execution of  a program and  enter a Lisp  Listener."
      (61 74 "Lisp Listener"))
     ("                You can  set  a  breakpoint  in  your  program  or  enter  a"
      (25 27 "set"))
     ("                breakpoint from  the  keyboard  (by  pressing the BREAK key)"
      (66 74 "BREAK key"))
     ("                anytime during execution.  You can also specify a break that")
     ("                invokes the debugger when a specified function is called  or"
      (28 35 "debugger")
      (54 61 "function"))
     ("                is called under certain conditions.  "
      (40 48 "condition"))
     ("  ")
     ("")))
   ("BREAK key"
    (("                See program control keys.  "
      (20 39 "program control keys"))
     ("  ")
     ("")))
   ("brick"
    (("                The common name for the mass storage enclosure."
      (40 61 "mass storage enclosure"))
     ("                  ")
     ("")))
   ("buffer"
    (("                A  temporary  storage  facility  within  the  active  system"
      (70 75 "system"))
     ("                environment.   For  example,  when you edit a file in Zmacs,"
      (16 26 "environment")
      (62 65 "file")
      (70 74 "Zmacs"))
     ("                the file is copied into a buffer, and you edit the  copy  in"
      (20 23 "file"))
     ("                the buffer.  ")
     ("  ")
     ("")))
   ("bump"
    (("                To push the mouse cursor against the scroll bar margin of  a"
      (28 39 "mouse cursor")
      (53 62 "scroll bar")
      (64 69 "margin"))
     ("                window.  This causes the scroll bar to be displayed."
      (16 21 "window")
      (41 50 "scroll bar"))
     ("                ")
     ("")))
   ("bury"
    (("                To deexpose a window and place  it  at  the  bottom  of  its"
      (30 35 "window")
      (41 45 "place"))
     ("                priority  group  in  the window ordering.  Any other windows"
      (41 46 "window"))
     ("                that it overlapped now overlap it.  ")
     ("  ")
     ("")))
   ("bus"
    (("                A group of signal lines used to transfer data  from  one  or")
     ("                more sources to one or more destinations.  ")
     ("  ")
     ("")))
   ("byte specifier"
    (("                A pointer used to designate a specific byte position  within"
      (18 24 "pointer"))
     ("                any integer.  (Here byte refers to an arbitrary  bit string,"
      (65 67 "bit")
      (69 74 "string"))
     ("                not eight bits.)  The representation of a byte  specifier is"
      (26 28 "bit"))
     ("                a  fixnum.   The  two  lowest  octal  digits  of  the fixnum"
      (19 24 "fixnum"))
     ("                represent the number  of bits  of the  byte, and  the higher"
      (30 35 "number")
      (41 43 "bit"))
     ("                octal digits represent the position  of the byte within  the")
     ("                integer (0 means the least significant bit).  "
      (55 57 "bit"))
     ("")))
   ("canonical"
    (("                The usual, standard, or accepted way of doing something.  In")
     ("                the file system, canonical file types, such  as  :lisp,  are"
      (20 30 "file system")
      (43 51 "file type"))
     ("                used  because  this  extension  could  exist as lisp or lsp,"
      (64 67 "Lisp"))
     ("                depending on which host you are using.  In  this  case,  the"
      (35 38 "host"))
     ("                canonical type provides a host-independent standard."
      (42 45 "host"))
     ("                  ")
     ("")))
   ("CAPS LOCK key"
    (("                See mode keys.  " (20 28 "mode keys")) ("  ") ("")))
   ("car"
    (("                The  function  that  extracts the first component of a cons,"
      (21 28 "function")
      (50 54 "first")
      (71 74 "cons"))
     ("                and by common usage, the name of that component itself.  ")
     ("  ")
     ("")))
   ("catch"
    (("                A special form used with throw to  perform  nonlocal  exits."
      (18 29 "special form")
      (41 45 "throw")
      (60 73 "nonlocal exit"))
     ("                The  catch  construct serves as a target for the transfer of")
     ("                control by a throw.  " (29 33 "throw"))
     ("  ")
     ("")))
   ("cdr"
    (("                The function that extracts the second component of  a  cons,"
      (20 27 "function")
      (71 74 "cons"))
     ("                and by common usage, the name of that second component.  ")
     ("  ")
     ("")))
   ("cdr-coding"
    (("                A memory compaction scheme implemented in hardware and  used")
     ("                during the  creation  of  lists  and  conses.   This  scheme"
      (42 45 "list")
      (54 57 "cons"))
     ("                removes the need for two memory locations for each item of a")
     ("                list.  Conventionally, the second  location is a  pointer to"
      (16 19 "list")
      (66 72 "pointer"))
     ("                the next item in the  list; with the cdr-coding  scheme, the"
      (38 41 "list")
      (53 55 "cdr"))
     ("                items of a list are in consecutive memory locations. "
      (27 30 "list"))
     ("                  ")
     ("")))
   ("Chaosnet"
    (("                A communications protocol that provides an Ethernet protocol"
      (59 66 "Ethernet"))
     ("                between two  user  processes  on  different  machines.   The"
      (35 41 "process"))
     ("                protocol is a full-duplex, packet-transmission channel.  The"
      (43 48 "packet"))
     ("                term  Chaos  in the name refers to the fact that there is no")
     ("                central control.  ")
     ("  ")
     ("")))
   ("Chaosnet server"
    (("                A program that handles standard  service  requests  received")
     ("                over the network using the Chaosnet protocol.  "
      (25 31 "network")
      (43 50 "Chaosnet"))
     ("  ")
     ("")))
   ("character"
    (("                A unit of information in a computer  representing one of the")
     ("                following:")
     ("                                    ")
     ("                 Alphabetic symbols, which include:" (28 33 "symbol"))
     ("                                    ")
     ("                 -  Uppercase and lowercase symbols of the alphabet "
      (44 49 "symbol"))
     ("                                    ")
     ("                 -  The numeric symbols 0 through 9" (32 37 "symbol"))
     ("                                    ")
     ("                 -  Punctuation symbols " (32 37 "symbol"))
     ("                                     ")
     ("                 -  Special graphic symbols, such as the tilde (~)"
      (36 41 "symbol"))
     ("                    and the dollar sign ($) ")
     ("                                    ")
     ("                 Numerical digits (Note  that a  numeric digit  is different")
     ("                 from an alphabetic numerical digit.)  ")
     ("                                    ")
     ("                 Special nongraphic characters, such as the RETURN character")
     ("                 or the space character")
     ("                                    ")
     ("                 On the Explorer system,  characters are represented  in two"
      (33 38 "system"))
     ("                 ways.  In  Zetalisp  mode,  characters  are  represented as"
      (28 41 "Zetalisp mode"))
     ("                 integers. In Common  Lisp mode,  characters are represented"
      (30 46 "Common Lisp mode"))
     ("                 as character data objects.  " (35 40 "object"))
     ("                                ")
     ("                ")
     ("")))
   ("character box"
    (("                A box in the font editor that indicates the width and, along"
      (18 20 "box")
      (29 39 "font editor"))
     ("                with the line below it, the height of a character.  "
      (56 64 "character"))
     ("  ")
     ("")))
   ("character keys"
    (("                The set of keys on  the keyboard that includes  the standard"
      (20 22 "set"))
     ("                QWERTY (typewriter) keys  as well  as the  braces, brackets,")
     ("                and extra set of parentheses.  " (26 28 "set"))
     ("                  ")
     ("")))
   ("character spacing"
    (("                The  pitch  of  a printed line; the number of characters per"
      (21 25 "pitch")
      (52 57 "number")
      (62 70 "character"))
     ("                inch (cpi).  This  term  usually  describes  output  from  a")
     ("                printer.  ")
     ("  ")
     ("")))
   ("choice box"
    (("                A box  in  a  multiple-choice  menu  or  window  margin that"
      (18 20 "box")
      (30 50 "multiple-choice menu")
      (57 62 "window")
      (65 70 "margin"))
     ("                indicates a yes or no choice for an item.  You can  indicate")
     ("                yes or no by clicking the mouse within the choice box.  "
      (29 33 "click")
      (42 46 "mouse")
      (66 68 "box"))
     ("  ")
     ("")))
   ("choice facilities"
    (("                A set of facilities in the window system that allows you  to"
      (18 20 "set")
      (43 55 "window system"))
     ("                create different types of menus for your applications.  "
      (42 45 "menu")
      (57 67 "application"))
     ("  ")
     ("")))
   ("choose-variable-values menu"
    (("                A  menu  that  displays a set of variables and their values,"
      (19 22 "menu")
      (42 44 "set")
      (49 56 "variable"))
     ("                allowing you to change the values.  In some  cases,  several")
     ("                different  values  for  a variable may be shown, and you can"
      (42 49 "variable"))
     ("                select one with the mouse.  The  current  value  is  usually"
      (16 21 "select")
      (36 40 "mouse"))
     ("                shown  in boldface type.  In other cases, you can select the"
      (66 71 "select"))
     ("                value with  the  mouse  and  enter  a  new  value  from  the"
      (33 37 "mouse"))
     ("                keyboard.  ")
     ("  ")
     ("")))
   ("chording"
    (("                Key combinations in  which you  must press  and hold  two or")
     ("                more keys simultaneously.  Chorded sequences are denoted  by"
      (51 58 "sequence"))
     ("                a hyphen  between  the  individual  key  names, for example,")
     ("                META-X.  ")
     ("  ")
     ("")))
   ("circular list"
    (("                A list in which the pointer of the last element of the  list"
      (18 21 "list")
      (36 42 "pointer")
      (56 62 "element"))
     ("                points to the first  element of the  list.  An example  is a"
      (16 20 "point")
      (30 34 "first")
      (37 43 "element")
      (53 56 "list"))
     ("                list in which the cdr of the last cons is the first  cons of"
      (16 19 "list")
      (34 36 "cdr")
      (50 53 "cons")
      (62 66 "first"))
     ("                the list.  " (20 23 "list"))
     ("  ")
     ("")))
   ("CLEAR INPUT key"
    (("                See user interaction keys.  "
      (20 40 "user interaction keys"))
     ("  ")
     ("")))
   ("CLEAR SCREEN key"
    (("                See user interaction keys.  "
      (20 40 "user interaction keys"))
     ("  ")
     ("")))
   ("click"
    (("                The  pressing  and  releasing  of  one of the mouse buttons."
      (62 74 "mouse buttons"))
     ("                Single clicks are denoted by L, M, and R  (corresponding  to")
     ("                the left, middle, and right buttons).  Double clicks require")
     ("                you  to  quickly  press  and  release  the same mouse button"
      (64 68 "mouse"))
     ("                twice.  (Alternately,  you  can  press  CTRL  and  a  single")
     ("                click.)   These  are  denoted  by  L2,  M2,  and R2.  Rubber")
     ("                banding operations require you to press a button and hold it"
      (16 19 "band"))
     ("                while moving the mouse.  These are denoted by LHOLD,  MHOLD,"
      (33 37 "mouse"))
     ("                and RHOLD.  ")
     ("  ")
     ("")))
   ("closure"
    (("                A functional object that is functionally similar to a flavor"
      (29 34 "object")
      (70 75 "flavor"))
     ("                instance in  that it retains  state  and  maintains  private"
      (16 23 "instance"))
     ("                values  for  certain  variables  whose  initial  values  are"
      (38 45 "variable"))
     ("                determined when the object is created.  There are two  types"
      (36 41 "object"))
     ("                of closures available in the Explorer  environment:  lexical")
     ("                and  dynamic.  Lexical  closures  (a  standard  Common  Lisp"
      (31 46 "lexical closure")
      (64 75 "Common Lisp"))
     ("                construct)  are  created  by  a  /"#'(LAMBDA .../"  form.  A"
      (66 69 "form"))
     ("                lexical closure  maintains  the  complete  existing  lexical"
      (16 30 "lexical closure"))
     ("                environment at the time the closure  is  created.  A dynamic"
      (16 26 "environment"))
     ("                closure (an Explorer extension) is created  by  the  CLOSURE")
     ("                function.     Dynamic   closures   are   closures   over   a"
      (16 23 "function"))
     ("                user-specified list  of  (dynamic)  special  variables  with"
      (31 34 "list")
      (52 68 "special variable"))
     ("                respect to a function.   Closures  of  either  type  can  be"
      (29 36 "function"))
     ("                funcalled,  causing  the  function  to  be  executed  in  an"
      (42 49 "function"))
     ("                environment in  which  the  values  of  the  /"closed-over/""
      (16 26 "environment"))
     ("                variables are obtained and updated." (16 23
                                                                "variable"))
     ("  ")
     ("")))
   ("code attribute"
    (("                The  ASCII  character  code  associated with a character, as"
      (28 36 "character"))
     ("                distinguished from its bits attributes or font attribute.  "
      (39 52 "bits attribute")
      (58 71 "font attribute"))
     ("  ")
     ("")))
   ("coercion"
    (("                A  concept  that  deals   with  converting  objects   to  an"
      (60 65 "object"))
     ("                equivalent object of another  type.  This usually  refers to"
      (27 32 "object"))
     ("                the conversion  of  numbers  (for  example,  a  real  number"
      (36 41 "number"))
     ("                becomes  a  complex  number),  but  it  can  also  refer  to"
      (37 42 "number"))
     ("                converting other objects  (for example,  a single  character"
      (33 38 "object")
      (67 75 "character"))
     ("                can become a string).  " (29 34 "string"))
     ("                  ")
     ("                ")
     ("")))
   ("cold boot"
    (("                The  reloading  of the load band and the microload band that"
      (39 42 "load")
      (44 47 "band"))
     ("                were running when you pressed the keystroke  sequence  META-"
      (50 68 "keystroke sequence"))
     ("                CTRL-META-CTRL-RUBOUT.   Thus,  you have a newly initialized")
     ("                Lisp system with no problems, but you have lost the contents"
      (16 19 "Lisp")
      (21 26 "system"))
     ("                of virtual memory.  See also system reset,  menu  boot,  and"
      (45 56 "system reset")
      (60 69 "menu boot"))
     ("                warm boot.  " (16 24 "warm boot"))
     ("")))
   ("combined method"
    (("                A  single  method that is automatically constructed for each"
      (27 32 "method"))
     ("                operation when flavors are combined.  The combined method is"
      (31 36 "flavor")
      (67 72 "method"))
     ("                constructed out of all methods for that operation  from  all"
      (39 44 "method"))
     ("                the  components  of  the  new  flavor.   The combined method"
      (47 52 "flavor")
      (70 75 "method"))
     ("                consists of one primary method  and  any  number  of  daemon"
      (32 45 "primary method")
      (58 63 "number"))
     ("                methods.  " (16 21 "method"))
     ("  ")
     ("                By default, the combined method is the primary method of the"
      (41 46 "method")
      (55 68 "primary method"))
     ("                first  specified  component  flavor  that provides a primary"
      (16 20 "first")
      (34 50 "component flavor"))
     ("                method for the operation.  The primary  methods  from  other"
      (16 21 "method")
      (47 61 "primary method"))
     ("                component  flavors  are  ignored.   If  daemon  methods  are"
      (16 32 "component flavor")
      (56 69 "daemon method"))
     ("                defined, the combined method calls all the daemons from  all"
      (38 43 "method"))
     ("                component  flavors  that  provide them.  The returned values"
      (16 32 "component flavor"))
     ("                from the combined method are  the  values  returned  by  the"
      (34 39 "method"))
     ("                primary  method  only;  any values returned from the daemons"
      (16 30 "primary method"))
     ("                are ignored.  ")
     ("  ")
     ("                You can select other ways to combine methods when you define"
      (24 29 "select")
      (53 58 "method"))
     ("                the combined flavors.  " (29 34 "flavor"))
     ("  ")
     ("")))
   ("combining type specifier"
    (("                A type specifier that  defines  a  data  type  in  terms  of"
      (18 31 "type specifier")
      (51 60 "data type"))
     ("                combinations of other data types.  " (38 46
                                                                "data type"))
     ("  ")
     ("")))
   ("command editor"
    (("                A feature in the Universal  Command Loop that allows  you to"
      (33 55 "Universal Command Loop"))
     ("                create new commands  and command  macros for  a utility,  to"
      (50 54 "macro"))
     ("                tailor existing commands, and to  save them to disk  for use"
      (50 53 "save"))
     ("                in another session.  ")
     ("                  ")
     ("                ")
     ("")))
   ("command history"
    (("                A buffer that  stores  the  commands  you  invoke  within  a"
      (18 23 "buffer"))
     ("                particular  window.   Only certain windows implement command"
      (28 33 "window"))
     ("                histories, and only significant commands are stored  in  the"
      (36 54 "significant command"))
     ("                history.  See also history.  " (16 22 "history"))
     ("  ")
     ("")))
   ("command menu"
    (("                A  menu  that allows you to invoke commands or operations by"
      (19 22 "menu"))
     ("                selecting items from the menu.  " (16 21 "select")
                                                         (41 44 "menu"))
     ("  ")
     ("")))
   ("comment"
    (("                A string within code  that  is  ignored  when  the  code  is"
      (18 23 "string"))
     ("                compiled  or  executed.  For Lisp, the semicolon (;) is used"
      (16 22 "compile")
      (45 48 "Lisp"))
     ("                to denote the beginning of a comment.  You can also create a")
     ("                multiline comment, which begins with #| and ends with |#.  ")
     ("")))
   ("Common Lisp"
    (("                The dialect of the Lisp language that is  supported  by  the"
      (35 38 "Lisp"))
     ("                Explorer  system.   Common Lisp was defined by a joint group"
      (26 31 "system")
      (43 46 "Lisp"))
     ("                of industry and university representatives  to  establish  a")
     ("                standard  for  portability  and  consistency among different")
     ("                machine implementations of the  language.   It  was  derived")
     ("                from  Maclisp  and  influenced  strongly  by  Zetalisp.   In"
      (62 69 "Zetalisp"))
     ("                addition to Common Lisp, the Explorer supports  higher-level"
      (35 38 "Lisp"))
     ("                extensions to the language.  ")
     ("  ")
     ("")))
   ("Common Lisp mode"
    (("                An editing mode  that is  context sensitive  to Common Lisp."
      (64 74 "Common Lisp"))
     ("                See Zmacs major mode.  " (20 35 "Zmacs major mode"))
     ("                  ")
     ("")))
   ("compile"
    (("                To  translate  a  user-written program into code more easily")
     ("                recognizable by a computer.   Such  code  normally  executes")
     ("                faster than code that has not been compiled.  ")
     ("  ")
     ("")))
   ("compiler" (("                See Lisp compiler.  " (20 32
                                                            "Lisp compiler"))
                ("  ")
                ("")))
   ("completion"
    (("                A  feature  that attempts to complete the name of a command,")
     ("                Lisp object, buffer, or file after  you  have  typed  a  few"
      (16 26 "Lisp object")
      (29 34 "buffer")
      (40 43 "file"))
     ("                characters.   If  you  do  not  type  enough  characters  to"
      (16 24 "character"))
     ("                identify a unique string, you can request a menu or list  of"
      (34 39 "string")
      (60 63 "menu")
      (68 71 "list"))
     ("                possible  completions, from which you can select the one you"
      (58 63 "select"))
     ("                want.  Three types of completion are available:  ")
     ("  ")
     ("                *  Apropos -- Searches for any substring that matches the"
      (19 25 "apropos"))
     ("                   characters you have entered.  " (19 27
                                                              "character"))
     ("  ")
     ("                *  Recognition -- Searches for strings  where  the  first"
      (47 52 "string")
      (68 72 "first"))
     ("                   letter (or first few letters) of each word matches the"
      (30 34 "first")
      (57 60 "word"))
     ("                   characters you have entered.  " (19 27
                                                              "character"))
     ("  ")
     ("                *  Spelling  --  Searches for a string that resembles the"
      (48 53 "string"))
     ("                   order of the characters you have entered.  "
      (32 40 "character"))
     ("  ")
     ("")))
   ("complex numbers"
    (("                A numbering  system  in  which  numbers  are  represented as"
      (18 23 "number")
      (29 34 "system"))
     ("                ordered pairs (a,b), where a and b are elements of the  real"
      (55 61 "element"))
     ("                number set.  Special operations can be performed on  complex"
      (16 21 "number")
      (23 25 "set"))
     ("                numbers that enable the square root of -1 to be defined.  "
      (16 21 "number"))
     ("  ")
     ("")))
   ("component flavor"
    (("                An existing flavor that is used as  a  constituent  part  in"
      (28 33 "flavor"))
     ("                forming another flavor.  " (16 19 "form")
                                                  (32 37 "flavor"))
     ("  ")
     ("")))
   ("component option"
    (("                A  user-defined  option  that  declares  a  component  of  a")
     ("                structure defined by defstruct to be of  a  particular  data"
      (16 24 "structure"))
     ("                type or to be unsettable.  ")
     ("")))
   ("condition"
    (("                Some noteworthy event that can occur during the execution of"
      (32 36 "event"))
     ("                a program, such as an error.  ")
     ("  ")
     ("")))
   ("condition handler"
    (("                A function that is  associated with certain  condition names"
      (18 25 "function")
      (61 74 "condition name"))
     ("                and  called  to  handle  those  conditions  when  they   are"
      (48 56 "condition"))
     ("                signaled.  ")
     ("  ")
     ("")))
   ("condition instance"
    (("                An instance of a particular type of condition.  "
      (19 26 "instance")
      (52 60 "condition"))
     ("  ")
     ("")))
   ("condition name"
    (("                1.  A symbol used to convey a category of conditions.  "
      (22 27 "symbol")
      (58 66 "condition"))
     ("  ")
     ("                2.  Any flavor with condition as one of its base flavors.  "
      (24 29 "flavor")
      (36 44 "condition")
      (60 70 "base flavor"))
     ("  ")
     ("")))
   ("condition signaling"
    (("                A facility based  on  flavors  that  allows  you  to  define"
      (38 43 "flavor"))
     ("                signal-specific conditions in your programs.  "
      (32 40 "condition"))
     ("  ")
     ("")))
   ("conditional"
    (("                A construct that  allows a  program to  make a  decision and")
     ("                perform  one  action  or   another  based  on   some logical")
     ("                condition. Common Lisp supports three types of conditionals:"
      (16 24 "condition")
      (27 37 "Common Lisp"))
     ("                one-way (AND and OR), two-way  (IF), and multiway (COND  and")
     ("                CASE).  ")
     ("  ")
     ("")))
   ("configuration ROM"
    (("                A special ROM located on each NuBus board, which allows  the")
     ("                system to automatically  configure itself  according to  the"
      (16 21 "system"))
     ("                boards   installed.    Each   configuration   ROM   contains")
     ("                information  about   the   basic   characteristics  of  that")
     ("                board, such  as  board  type, required  parameters,  and  an"
      (46 64 "required parameter"))
     ("                address pointer to diagnostic routines.  "
      (24 30 "pointer"))
     ("                  ")
     ("                ")
     ("")))
   ("cons"
    (("                A compound data object consisting of  two  components:   the"
      (32 37 "object"))
     ("                car and the cdr.  Conceptually, the car represents the first"
      (16 18 "car")
      (28 30 "cdr")
      (71 75 "first"))
     ("                component  of  the  cons,  and  the  cdr represents the next"
      (53 55 "cdr"))
     ("                component of the cons.  In actuality, a cons is a contiguous")
     ("                pair of pointers, and each can point  to  any  data  object."
      (24 30 "pointer")
      (47 51 "point")
      (69 74 "object"))
     ("                The  first  pointer  is the car, and the next pointer is the"
      (21 25 "first")
      (28 34 "pointer")
      (44 46 "car"))
     ("                cdr.  " (16 18 "cdr"))
     ("  ")
     ("                Conses are used primarily to represent lists.  In this case,"
      (55 58 "list"))
     ("                the car of the cons points to an element in  the  list,  and"
      (20 22 "car")
      (36 40 "point")
      (49 55 "element")
      (66 69 "list"))
     ("                the  cdr  points  to  the  next cons in the list.  In a true"
      (21 23 "cdr")
      (26 30 "point")
      (60 63 "list"))
     ("                list, the cdr of the last cons in the  list  points  to  the"
      (16 19 "list")
      (26 28 "cdr")
      (61 65 "point"))
     ("                symbol  nil.   In  a  dotted  list, the cdr of the last cons"
      (16 21 "symbol")
      (24 26 "nil")
      (38 49 "dotted list")
      (56 58 "cdr"))
     ("                points to a non-nil atom.  " (16 20 "point")
                                                    (36 39 "atom"))
     ("  ")
     ("")))
   ("console"
    (("                The collection of  hardware  components  through  which  you")
     ("                interact  with  the system.  It consists of the monitor, the"
      (36 41 "system"))
     ("                keyboard, and the mouse.  This is  also  called  the  system"
      (34 38 "mouse")
      (70 75 "system"))
     ("                console, and sometimes, the display unit.  "
      (44 55 "display unit"))
     ("  ")
     ("")))
   ("constraint frame"
    (("                A  description  of the conditions defining the layout or the"
      (39 47 "condition"))
     ("                configuration of panes within a frame.  The  description  is"
      (33 36 "pane")
      (48 52 "frame"))
     ("                stated symbolically rather than in explicit units of pixels;"
      (69 73 "pixel"))
     ("                thus,   when   the   window   changes  shape,  the  symbolic"
      (37 42 "window"))
     ("                description can be recomputed, and the  panes  are  reshaped"
      (56 59 "pane"))
     ("                appropriately.  ")
     ("  ")
     ("")))
   ("constructor function"
    (("                A function that creates  an instance of  a defstruct-defined"
      (18 25 "function")
      (44 51 "instance"))
     ("                structure.   A  constructor  function  is  usually   created"
      (16 24 "structure")
      (45 52 "function"))
     ("                automatically when the structure is defined.  "
      (39 47 "structure"))
     ("                  ")
     ("")))
   ("contagion"
    (("                A concept  that  deals  with  the  automatic type conversion")
     ("                rules applied during numerical operations with arguments  of"
      (63 70 "argument"))
     ("                different types.  See coercion.  " (38 45 "coercion"))
     ("                  ")
     ("")))
   ("control bits"
    (("                See bits attribute.  " (20 33 "bits attribute"))
     ("  ")
     ("")))
   ("control stack"
    (("                A stack  that  contains  such  information  as  the  current"
      (18 22 "stack"))
     ("                function being run, its caller, the caller's caller, and the"
      (16 23 "function"))
     ("                point of execution or the return address of each function.  "
      (16 20 "point")
      (65 72 "function"))
     ("  ")
     ("")))
   ("control structure"
    (("                A Lisp form or structure that allows you to control the flow"
      (18 26 "Lisp form")
      (31 39 "structure"))
     ("                of program execution within a function.  "
      (46 53 "function"))
     ("  ")
     ("")))
   ("control-bit weights"
    (("                The integer values given to the following  named  constants:")
     ("                char-control-bit,  char-meta-bit,  char-super-bit, and char-")
     ("                hyper-bit.  These weights are used to  manipulate  the  bits"
      (72 74 "bit"))
     ("                attribute of a character.  " (31 39 "character"))
     ("  ")
     ("")))
   ("convenience receptacles"
    (("                Power  outlets  in  the  back  of  the system enclosure that"
      (55 70 "system enclosure"))
     ("                accept up to two  power  cords  from  the  monitor  or  mass")
     ("                storage  enclosures.   These  outlets  are controlled by the")
     ("                on//off button on the front of the system enclosure and allow"
      (50 65 "system enclosure"))
     ("                you to conveniently control power to the attached enclosures")
     ("                with one button.  ")
     ("  ")
     ("")))
   ("Converse"
    (("                An interactive window  that allows  you to  send messages to"
      (31 36 "window")
      (65 71 "message"))
     ("                other users on the network  and receive messages from  them."
      (35 41 "network")
      (56 62 "message"))
     ("                The   messages   are    organized   into    groups,   called"
      (22 28 "message"))
     ("                conversations, with one conversation for each user with whom")
     ("                you are communicating.  Editing  commands are available  for")
     ("                entering  messages.   The  Converse  window  shows  all  the"
      (26 32 "message")
      (53 58 "window"))
     ("                messages  sent  and  received  since  the  last  cold   boot"
      (16 22 "message")
      (65 75 "cold boot"))
     ("                operation.  ")
     ("  ")
     ("")))
   ("copier function"
    (("                A   function   that   creates   a   new   instance   of    a"
      (20 27 "function")
      (58 65 "instance"))
     ("                defstruct-defined structure that is  a component copy  of an"
      (34 42 "structure"))
     ("                already existing structure  instance.  A  copier function is"
      (33 51 "structure instance")
      (65 72 "function"))
     ("                usually created automatically when the structure is defined."
      (55 63 "structure"))
     ("                ")
     ("  ")
     ("")))
   ("coroutine"
    (("                A term used in concurrent or parallel processing to describe"
      (54 60 "process"))
     ("                a routine that is being executed concurrently  with  another")
     ("                routine.  ")
     ("  ")
     ("")))
   ("Counters"
    (("                A  command,  contained  in the Peek facility, that lists the"
      (47 50 "Peek")
      (67 70 "list"))
     ("                statistics  of  all  the  microcode  meters  and  associated"
      (42 50 "microcode"))
     ("                counters.  ")
     ("  ")
     ("")))
   ("CRASH"
    (("                System shutdown due  to microcode  detecting an  irrevocable"
      (40 48 "microcode"))
     ("                error.       Functions     sys:report-last-shutdown      and"
      (29 36 "function"))
     ("                sys:report-all-shutdowns can be  used  to  display the crash")
     ("                records. ")
     ("                                ")
     ("                ")
     ("")))
   ("crash record"
    (("                Information about a  system crash,  such as  reason, time of"
      (37 42 "system")
      (44 48 "CRASH"))
     ("                crash, function running, and some microcode  registers.  See"
      (16 20 "CRASH")
      (23 30 "function")
      (50 58 "microcode")
      (61 68 "register"))
     ("                crash." (16 20 "CRASH"))
     ("                ")
     ("")))
   ("CTRL key" (("                See modifier keys.  " (20 32
                                                            "modifier keys"))
                ("  ")
                ("")))
   ("current font"
    (("                The  font currently being used to print output characters in"
      (21 24 "font")
      (63 71 "character"))
     ("                a window.  The current font of a window is always one of the"
      (18 23 "window")
      (39 42 "font"))
     ("                fonts in the window's font map.  " (16 19 "font")
                                                          (38 45 "font map"))
     ("  ")
     ("")))
   ("current package"
    (("                The package that is currently in effect.   This  package  is"
      (20 26 "package"))
     ("                always identified by the value of the *package* variable.  "
      (64 71 "variable"))
     ("  ")
     ("")))
   ("current process"
    (("                The process that is currently executing.  "
      (20 26 "process"))
     ("  ")
     ("")))
   ("current stack group"
    (("                The  stack  group associated with the current process.  Also"
      (21 32 "stack group")
      (54 68 "current process"))
     ("                called the running stack group.  "
      (27 45 "running stack group"))
     ("  ")
     ("")))
   ("cursor pad"
    (("                A set of keys labeled with arrows  that,  depending  on  the"
      (18 20 "set")
      (30 34 "label"))
     ("                software,  either  move  the  cursor in the direction of the")
     ("                arrow or produce arrow characters. " (39 47
                                                                "character"))
     ("")))
   ("daemon method"
    (("                A method that is called  by a combined method  either before"
      (18 23 "method")
      (46 60 "combined method"))
     ("                or after the primary method  is called.  Daemon methods  are"
      (29 42 "primary method"))
     ("                frequently provided by component  flavors so that  they know"
      (39 55 "component flavor"))
     ("                when a message is  sent or that  they can perform  a part of"
      (23 29 "message"))
     ("                the operation  defined  by  the  primary method.  The daemon"
      (49 62 "primary method"))
     ("                methods are  passed  the  same  arguments  that the combined"
      (16 21 "method")
      (48 55 "argument"))
     ("                method was given, but values  returned from the daemons  are"
      (16 21 "method"))
     ("                ignored.  ")
     ("  ")
     ("")))
   ("data brick"
    (("                See mass storage enclosure.  "
      (20 41 "mass storage enclosure"))
     ("  ")
     ("")))
   ("data type"
    (("                A set of  Lisp objects.   Many Lisp  objects belong  to more"
      (18 20 "set")
      (26 36 "Lisp object"))
     ("                than one set.  Thus, an object is said to belong to a  given"
      (25 27 "set")
      (40 45 "object"))
     ("                data type rather than to  be a particular type.  Common Lisp"
      (65 75 "Common Lisp"))
     ("                provides a  large  set  of  predefined data types, including"
      (35 37 "set"))
     ("                symbols, functions, lists, arrays, numbers, characters,  and"
      (16 21 "symbol")
      (25 32 "function")
      (36 39 "list")
      (43 47 "array")
      (51 56 "number")
      (60 68 "character"))
     ("                structures.  You can also choose your own set of objects  to"
      (16 24 "structure")
      (58 60 "set")
      (65 70 "object"))
     ("                define a new data type.  ")
     ("  ")
     ("")))
   ("data type checking"
    (("                Checking  done  automatically  during run time to select the"
      (66 71 "select"))
     ("                appropriate instruction for that type of data.  ")
     ("  ")
     ("")))
   ("data type specifier"
    (("                The name of a particular data type; often  called  simply  a"
      (41 49 "data type"))
     ("                type  specifier.  A type specifier can be either a symbol or"
      (16 30 "type specifier")
      (67 72 "symbol"))
     ("                a list.  Symbols name predefined classes of  objects;  lists"
      (18 21 "list")
      (25 30 "symbol")
      (61 66 "object"))
     ("                usually  indicate combinations or specializations of simpler")
     ("                data types.  " (16 24 "data type"))
     ("  ")
     ("")))
   ("deactivate"
    (("                To remove a window from  the active windows of  its superior"
      (28 33 "window")
      (45 57 "active window"))
     ("                window.  Deactivated windows are  not managed by  the window"
      (16 21 "window"))
     ("                system; they can be reclaimed  by the garbage collector.   A"
      (16 21 "system")
      (54 70 "garbage collector"))
     ("                deactivated window can be reactivated by the user.  "
      (28 33 "window"))
     ("  ")
     ("")))
   ("debugger"
    (("                A facility that helps you find and  handle  errors  in  your")
     ("                programs.   The debugger lets you examine the environment in"
      (62 72 "environment"))
     ("                which an error (or some other condition) is  signaled,  take"
      (46 54 "condition"))
     ("                corrective   action,  and  resume  execution  or  abort  the")
     ("                program.  ")
     ("  ")
     ("")))
   ("declaration"
    (("                A statement in certain special  forms  that  allows  you  to"
      (39 51 "special form"))
     ("                specify additional information about objects in your program"
      (53 58 "object"))
     ("                to aid in compilation and compiler optimization.  "
      (42 49 "compiler"))
     ("  ")
     ("")))
   ("deexposed typeout action"
    (("                A specified action to be taken when output is attempted to a")
     ("                window  that  is  not  exposed.   For example, the specified"
      (16 21 "window"))
     ("                action can be to signal an error or to expose the window.  "
      (66 71 "window"))
     ("  ")
     ("")))
   ("deexposed window"
    (("                A window whose superior window has no screen array (that is,"
      (18 23 "window")
      (31 45 "superior window")
      (54 65 "screen array"))
     ("                there is no place to accept typeout for this window),  or  a"
      (28 32 "place")
      (61 66 "window"))
     ("                window  that is not ready to be exposed.  Except for special"
      (16 21 "window"))
     ("                circumstances, a process cannot send output to  a  deexposed"
      (33 39 "process"))
     ("                window.  " (16 21 "window"))
     ("  ")
     ("")))
   ("defaulting"
    (("                See pathname defaulting.  "
      (20 38 "pathname defaulting"))
     ("  ")
     ("")))
   ("definition environment"
    (("                The environment in force when variables are defined.  "
      (20 30 "environment")
      (46 53 "variable"))
     ("  ")
     ("")))
   ("defstruct macro"
    (("                A macro that enables you to define record structures.  "
      (18 22 "macro")
      (51 66 "record structure"))
     ("  ")
     ("")))
   ("defstruct option"
    (("                An option of the defstruct macro that allows you to define a"
      (33 47 "defstruct macro"))
     ("                specialized functionality for a particular record structure."
      (59 74 "record structure"))
     ("  ")
     ("")))
   ("delete"
    (("                1.   In the Explorer  file system, to  mark a file  or empty"
      (38 48 "file system")
      (55 58 "mark"))
     ("                directory for  removal.   An  empty  directory  contains  no"
      (16 24 "directory"))
     ("                subdirectories   or   files.    (A   directory    containing"
      (38 41 "file")
      (53 61 "directory"))
     ("                subdirectories or files cannot be deleted.)  You must use an"
      (34 37 "file"))
     ("                expunge operation  to  actually  remove  the  file  or empty"
      (16 22 "expunge")
      (62 65 "file"))
     ("                directory.  " (16 24 "directory"))
     ("                  ")
     ("                2.    When  editing  text,  except  for  single  characters,"
      (65 73 "character"))
     ("                deleting does not actually remove the item from the  system,"
      (69 74 "system"))
     ("                and a delete operation can be undone.  ")
     ("                  ")
     ("")))
   ("demand paging"
    (("                The  act  of moving a page that contains a referenced object"
      (38 41 "page")
      (70 75 "object"))
     ("                not  currently  in  primary  storage  (main   memory)   from"
      (55 67 "main memory"))
     ("                secondary storage (disk) to main memory.  "
      (44 54 "main memory"))
     ("  ")
     ("")))
   ("descendant"
    (("                A  lower-level  node in a hierarchical structure such as the"
      (55 63 "structure"))
     ("                window system.  For example, a window's inferior and all its"
      (16 28 "window system")
      (56 63 "inferior"))
     ("                inferior's inferiors are the window's descendants.  "
      (27 34 "inferior"))
     ("  ")
     ("")))
   ("descender"
    (("                The part of a character that falls below the baseline of the"
      (30 38 "character")
      (61 68 "baseline"))
     ("                character.  " (16 24 "character"))
     ("  ")
     ("")))
   ("deselected window"
    (("                A window that is no longer enabled to accept input from  the"
      (18 23 "window"))
     ("                keyboard or mouse.  See selected window. "
      (28 32 "mouse")
      (40 54 "selected window"))
     ("                  ")
     ("")))
   ("destroyed argument"
    (("                A  sequence-type  argument whose structure is altered in any"
      (19 26 "sequence")
      (34 41 "argument")
      (49 57 "structure"))
     ("                manner during the processing of a function.  If  a  copy  of"
      (34 40 "process")
      (50 57 "function"))
     ("                the  argument  is made and then altered by the function, the"
      (21 28 "argument")
      (63 70 "function"))
     ("                argument is not considered destroyed.  "
      (16 23 "argument"))
     ("  ")
     ("")))
   ("destructive counterpart function"
    (("                A sequence-manipulating function that alters  the  structure"
      (18 25 "sequence")
      (40 47 "function")
      (67 75 "structure"))
     ("                of  its arguments and has counterpart functions that perform"
      (24 31 "argument")
      (54 61 "function"))
     ("                the same operation but do not alter the structure  of  their"
      (56 64 "structure"))
     ("                arguments.    For   example,   nconc   is   the  destructive"
      (16 23 "argument"))
     ("                counterpart function to append.  " (28 35 "function"))
     ("  ")
     ("")))
   ("diagnostic ROM"
    (("                A special ROM located on certain system boards that contains"
      (49 54 "system"))
     ("                diagnostic routines for that board.  The processor can  read")
     ("                and execute the routines to test the board.  ")
     ("  ")
     ("")))
   ("diagnostics partition"
    (("                A  disk  partition  that  contains diagnostics microcode and"
      (25 33 "partition")
      (63 71 "microcode"))
     ("                test patterns used for testing the system.  "
      (51 56 "system"))
     ("  ")
     ("")))
   ("DIN"
    (("                The German standards organization comparable to ANSI in  the")
     ("                United States.  ")
     ("  ")
     ("")))
   ("directory"
    (("                A group of related files and subdirectories.  "
      (35 38 "file"))
     ("  ")
     ("")))
   ("directory editor"
    (("                A  facility within Zmacs that allows you to perform all your"
      (35 39 "Zmacs"))
     ("                directory housekeeping.  You can delete, copy, rename, edit,"
      (16 24 "directory")
      (49 54 "delete"))
     ("                view, and print files.  This is also referred to as Dired.  "
      (16 19 "view")
      (32 35 "file")
      (68 72 "Dired"))
     ("  ")
     ("")))
   ("Dired"
    (("                See directory editor.  " (20 35 "directory editor"))
     ("  ")
     ("")))
   ("disassemble"
    (("                The converting of machine language code (that is, a compiled"
      (68 74 "compile"))
     ("                function) into a  textual  representation--the  opposite  of"
      (16 23 "function"))
     ("                what an assembler does on most computers.  ")
     ("  ")
     ("")))
   ("disk label"
    (("                A  description  of the partitions of a disk.  The disk label"
      (39 47 "partition")
      (71 75 "label"))
     ("                includes a name that uniquely identifies  the  system  on  a"
      (63 68 "system"))
     ("                network.  " (16 22 "network"))
     ("  ")
     ("")))
   ("displaced array"
    (("                An array  whose  contents  are  located  in  another  array."
      (19 23 "array"))
     ("                Therefore, the two arrays share array elements.  If array  X"
      (35 39 "array")
      (54 60 "element"))
     ("                is displaced to array Y, then when you reference elements of"
      (32 36 "array")
      (65 71 "element"))
     ("                array X, you are actually referencing array Y's elements.  "
      (16 20 "array")
      (64 70 "element"))
     ("  ")
     ("")))
   ("display unit"
    (("                See console.  " (20 26 "console")) ("  ") ("")))
   ("documentation string"
    (("                A string  within  a  function  definition  and several other"
      (18 23 "string")
      (37 56 "function definition"))
     ("                forms that appears as the first element of the body.  Unlike"
      (16 19 "form")
      (42 46 "first")
      (48 54 "element"))
     ("                a comment, the documentation  string  is  retained  with the"
      (18 24 "comment")
      (46 51 "string"))
     ("                object code during compilation so that it can be accessed by"
      (16 21 "object"))
     ("                various functions for online documentation.  "
      (24 31 "function"))
     ("                  ")
     ("")))
   ("dotted list"
    (("                A  list that is terminated by a non-nil atom rather than the"
      (19 22 "list")
      (56 59 "atom"))
     ("                symbol nil.  Dotted lists are denoted by preceding  the  cdr"
      (16 21 "symbol")
      (23 25 "nil")
      (36 39 "list")
      (73 75 "cdr"))
     ("                of  the  last  cons with a dot (surrounded by blank spaces)."
      (31 34 "cons"))
     ("                Example:  (a b c . d) ")
     ("  ")
     ("")))
   ("dotted pair"
    (("                A single cons whose cdr points to a  non-nil  atom.   Dotted"
      (25 28 "cons")
      (36 38 "cdr")
      (40 44 "point")
      (62 65 "atom"))
     ("                pairs  are  denoted  by  a  dot (surrounded by blank spaces)")
     ("                between the car and the cdr.  Example:  (a . b) "
      (28 30 "car")
      (40 42 "cdr"))
     ("  ")
     ("")))
   ("double-colon package qualifier"
    (("                A package qualifier (consisting of two colons)  that  allows"
      (18 34 "package qualifier"))
     ("                you  to  externally  access  the internal symbols of another"
      (49 63 "internal symbol"))
     ("                package.  " (16 22 "package"))
     ("  ")
     ("                This accessing should  be done  with care  because functions"
      (67 74 "function"))
     ("                named by internal symbols of a package are not  designed for"
      (25 39 "internal symbol")
      (47 53 "package"))
     ("                public  use  and  therfore   may  not  have   the exhaustive")
     ("                error-checking code that functions named by external symbols"
      (41 48 "function")
      (60 74 "external symbol"))
     ("                normally have. Thus, using these internal symbols can result"
      (49 63 "internal symbol"))
     ("                in programming errors that are extremely difficult  to find.")
     ("                ")
     ("  ")
     ("")))
   ("drag"
    (("                To move a window  or  graphics  object  on  the  display  by"
      (26 31 "window")
      (38 53 "graphics object"))
     ("                pressing  and holding a mouse button while moving the mouse."
      (40 44 "mouse"))
     ("                As you move the mouse cursor, the object  follows  it  until"
      (32 43 "mouse cursor")
      (50 55 "object"))
     ("                you release the button.  The object then remains at the last"
      (45 50 "object"))
     ("                position of the mouse cursor.  " (32 43
                                                            "mouse cursor"))
     ("  ")
     ("")))
   ("dribble file"
    (("                A  file  used to log terminal interaction.  When the dribble"
      (19 22 "file"))
     ("                file is activated, all input and output is directed  to  the"
      (16 19 "file"))
     ("                file as well as to the terminal.  " (16 19 "file"))
     ("  ")
     ("")))
   ("dynamic binding"
    (("                A type  of  binding  in  which  a variable can be referenced"
      (28 34 "binding")
      (50 57 "variable"))
     ("                anywhere outside its establishing function.  "
      (50 57 "function"))
     ("                  ")
     ("")))
   ("dynamic extent"
    (("                A type  of  extent  in  which  references can occur any time"
      (28 33 "extent"))
     ("                between   the   establishment   of   an   object   and   the"
      (58 63 "object"))
     ("                disestablishment of that object.   An object is  established"
      (41 46 "object"))
     ("                and disestablished  with  the  initiation  and  termination,")
     ("                respectively, of language  contructs such  as with-open-file")
     ("                and the binding of special variables."
      (24 30 "binding")
      (35 50 "special variable"))
     ("")))
   ("dynamic item list menu"
    (("                A menu that dynamically recomputes its  menu  item  list  at"
      (18 21 "menu")
      (56 71 "menu item list"))
     ("                various times.  ")
     ("  ")
     ("")))
   ("dynamic scope"
    (("                Bindings having  dynamic  extent  and  indefinite scope.  An"
      (16 22 "binding")
      (33 47 "dynamic extent")
      (55 70 "indefinite scope"))
     ("                example is the binding of special variables."
      (31 37 "binding")
      (42 57 "special variable"))
     ("")))
   ("element"
    (("                A component of a list or an array.  " (33 36 "list")
                                                             (44 48 "array"))
     ("  ")
     ("")))
   ("empty list"
    (("                A  list  that has no elements.  The empty list is denoted by"
      (19 22 "list")
      (37 43 "element"))
     ("                the symbol nil or ().  " (20 25 "symbol")
                                                (27 29 "nil"))
     ("  ")
     ("")))
   ("encapsulation"
    (("                A special  type  of  form  that  surrounds  another form and"
      (37 40 "form"))
     ("                enhances the  other  form's  operation  without changing its")
     ("                basic  functionality.    A   trace,   for   example,  is  an"
      (45 49 "trace"))
     ("                encapsulation.  ")
     ("  ")
     ("")))
   ("END key"
    (("                See user interaction keys.  "
      (20 40 "user interaction keys"))
     ("  ")
     ("")))
   ("end-test"
    (("                A conditional test that stops iteration.  "
      (18 28 "conditional"))
     ("  ")
     ("")))
   ("ENTER key"
    (("                See number pad.  " (20 29 "number pad")) ("  ") ("")))
   ("environment"
    (("                A  collection  of  variable  bindings  resulting  from   the"
      (35 42 "variable")
      (45 51 "binding"))
     ("                invocation of a function or a program.  "
      (32 39 "function"))
     ("  ")
     ("")))
   ("environment stack"
    (("                The  stack  that  contains all of the values saved by lambda"
      (21 25 "stack")
      (61 64 "save"))
     ("                binding.  Also called the special push-down list (PDL).   "
      (16 22 "binding")
      (60 63 "list"))
     ("  ")
     ("")))
   ("EOF" (("                An abbreviation for end of file.  " (43 46
                                                                     "file"))
           ("  ")
           ("")))
   ("eq"
    (("                A condition of  equality in  which two  or more  objects are"
      (18 26 "condition")
      (65 70 "object"))
     ("                identical.  This usually implies that they point to the same"
      (59 63 "point"))
     ("                memory location.  ")
     ("  ")
     ("")))
   ("eql"
    (("                A condition of equality in which two or more objects are one"
      (18 26 "condition")
      (61 66 "object"))
     ("                of the following:")
     ("                  ")
     ("                *  eq " (19 20 "eq"))
     ("                  ")
     ("                *  Numbers of the same type and value " (19 24
                                                                   "number"))
     ("                  ")
     ("                *  Character objects representing the same character "
      (19 27 "character")
      (29 34 "object"))
     ("")))
   ("equal"
    (("                A condition of  equality in  which two  or more  objects are"
      (18 26 "condition")
      (65 70 "object"))
     ("                similar in structure  and value.   Two numbers  are equal if"
      (27 35 "structure")
      (55 60 "number"))
     ("                they have the  same value  and type.   For conses,  equal is"
      (59 62 "cons"))
     ("                defined recursively as the two cars being equal and the  two"
      (47 49 "car"))
     ("                cdrs being equal.  Two  strings are equal  if they have  the"
      (16 18 "cdr")
      (40 45 "string"))
     ("                same length and the characters composing them are the  same."
      (36 44 "character"))
     ("                All other objects are equal if and only if they are eq."
      (26 31 "object")
      (68 69 "eq"))
     ("")))
   ("equalp"
    (("                The most general  test of  equality.  Character  case, font,"
      (54 62 "character")
      (71 74 "font"))
     ("                and  bits  attributes  are  not  considered  when  comparing"
      (21 35 "bits attribute"))
     ("                characters using equalp.  Numeric formats are not considered"
      (16 24 "character"))
     ("                when comparing numbers.  " (31 36 "number"))
     ("                  ")
     ("")))
   ("error handler"
    (("                A condition handler that deals with errors.  "
      (18 34 "condition handler"))
     ("  ")
     ("")))
   ("ESCAPE key"
    (("                See user interaction keys.  "
      (20 40 "user interaction keys"))
     ("  ")
     ("")))
   ("Ethernet"
    (("                The  DEC-INTEL-XEROX  (DIX)  standard network communications"
      (54 60 "network"))
     ("                system, version 1.0, 30 September, 1983.  "
      (16 21 "system"))
     ("  ")
     ("                Ethernet is a registered trademark of Xerox Corporation.  "
      (30 37 "register"))
     ("  ")
     ("")))
   ("Ethernet controller"
    (("                An optional logic board installed in  the  system  enclosure"
      (59 75 "system enclosure"))
     ("                that provides an interface between the Explorer system and a"
      (64 69 "system"))
     ("                local area network (LAN).  "
      (16 33 "local area network"))
     ("  ")
     ("")))
   ("Ethernet network"
    (("                A  local  area network (LAN) that employs Manchester-encoded"
      (19 37 "local area network"))
     ("                data and uses coaxial cables to transmit data at  speeds  up")
     ("                to  10  megabits  per second.  The Ethernet uses the carrier"
      (51 58 "Ethernet"))
     ("                sense multiple access//collision detect  (CSMA//CD)  protocol.")
     ("                An Ethernet segment can extend up to 1500 meters (4920 feet)"
      (19 26 "Ethernet"))
     ("                and accommodate up to 100 transceivers.  "
      (42 52 "transceiver"))
     ("  ")
     ("")))
   ("Ethernet transceiver"
    (("                The  electronic  device  that attaches a host to the network"
      (57 60 "host")
      (69 75 "network"))
     ("                coaxial cable.  The transceiver provides the electronics  to"
      (36 46 "transceiver"))
     ("                transmit   and   receive   Manchester-encoded  data  on  the")
     ("                Ethernet.  It also provides the electrical isolation between"
      (16 23 "Ethernet"))
     ("                the host and the network.  " (20 23 "host")
                                                    (33 39 "network"))
     ("  ")
     ("")))
   ("Eurocard"
    (("                Any printed  circuit  board  constructed  according  to  the")
     ("                Eurocard  format.    Explorer   logic   boards  are extended"
      (16 31 "Eurocard format"))
     ("                three-high Eurocards.  ")
     ("  ")
     ("")))
   ("Eurocard format"
    (("                A  mechanical-design  format  for  printed  circuit   boards")
     ("                developed as a European standard for high-performance board-")
     ("                level  products.   This  format  defines  a  standard  board")
     ("                outline and  connector  style  (DIN  41612).   The  Eurocard"
      (68 75 "Eurocard"))
     ("                format  defines  a family of board sizes, based on rules for")
     ("                combining  multiples  of  the  basic   board   outline   and")
     ("                connector.  ")
     ("  ")
     ("")))
   ("evaluation"
    (("                The means by which the Explorer system extracts a value from"
      (48 53 "system"))
     ("                a Lisp form.   Execution of  Lisp code  is called evaluation"
      (18 26 "Lisp form"))
     ("                because executing a piece of code normally results in a data")
     ("                object, called the returned value.  " (16 21
                                                                 "object"))
     ("  ")
     ("                The evaluation of a  symbol  returns  the  contents  of  the"
      (37 42 "symbol"))
     ("                symbol's value cell.  The evaluation of a function call also"
      (25 34 "value cell")
      (58 70 "function call"))
     ("                involves  application,  because the function must be applied"
      (26 36 "application")
      (52 59 "function"))
     ("                to its arguments in order to extract a value from it.  "
      (23 30 "argument"))
     ("  ")
     ("                Normally, one level of evaluation is performed automatically")
     ("                with each entered Lisp object  (implicit  evaluation).   You"
      (34 44 "Lisp object"))
     ("                can  inhibit this level of evaluation with the quote special"
      (63 67 "quote"))
     ("                form.  For example, list forms are generally interpreted and"
      (16 19 "form")
      (36 39 "list"))
     ("                evaluated as function calls, macro calls, or special  forms."
      (29 41 "function call")
      (45 54 "macro call")
      (61 73 "special form"))
     ("                If  you  inhibit  evaluation of the list form, it is treated"
      (52 55 "list")
      (57 60 "form"))
     ("                strictly as data.  ")
     ("  ")
     ("                You can also explicitly  invoke another level  of evaluation")
     ("                with the eval or eval-when special form.  This evaluation is"
      (43 54 "special form"))
     ("                useful when the value of a symbol is a function call and you"
      (43 48 "symbol")
      (55 67 "function call"))
     ("                want to invoke that function.  " (36 43 "function"))
     ("  ")
     ("                The  notation  => is used in examples to indicate evaluation")
     ("                and the returned values.  ")
     ("  ")
     ("")))
   ("evaluator"
    (("                The part of the Lisp interpreter that evaluates Lisp forms. "
      (32 47 "Lisp interpreter")
      (64 72 "Lisp form"))
     ("  ")
     ("")))
   ("event"
    (("                A situation, circumstance, or state that the  Lisp  software"
      (62 65 "Lisp"))
     ("                or  system  microcode  detects,  records,  and normally acts"
      (20 25 "system")
      (28 36 "microcode"))
     ("                upon.  For example, the event could be an end-of-file  mark,"
      (71 74 "mark"))
     ("                an error condition, or a context change.  "
      (25 33 "condition"))
     ("  ")
     ("")))
   ("exit form"
    (("                A  form whose value is returned during the exiting procedure"
      (19 22 "form"))
     ("                of an iterative form.  " (32 35 "form"))
     ("  ")
     ("")))
   ("expanded function"
    (("                A function resulting from the expansion of a macro.  "
      (18 25 "function")
      (61 65 "macro"))
     ("  ")
     ("")))
   ("explicit application"
    (("                See application.  " (20 30 "application")) ("  ")
                                                                  ("")))
   ("explicit evaluation"
    (("                See evaluation.  " (20 29 "evaluation")) ("  ") ("")))
   ("explicitly specified structure"
    (("                A structure whose representation type  has  been  explicitly"
      (18 26 "structure"))
     ("                specified in the defstruct macro that defines the structure."
      (33 47 "defstruct macro")
      (66 74 "structure"))
     ("                For  example,  you  can specify that when an instance of the"
      (61 68 "instance"))
     ("                structure is created, it will be created  as  a  list  or  a"
      (16 24 "structure")
      (65 68 "list"))
     ("                specific type of vector.  " (33 38 "vector"))
     ("  ")
     ("")))
   ("exporting a symbol"
    (("                To enable a symbol internal to particular package to  become"
      (28 33 "symbol")
      (58 64 "package"))
     ("                an external symbol.  " (19 33 "external symbol"))
     ("  ")
     ("")))
   ("exposed window"
    (("                A window that is  enabled  to  accept  output  data  from  a"
      (18 23 "window"))
     ("                process.   An  exposed window need not be visible.  In order"
      (16 22 "process")
      (39 44 "window"))
     ("                to be exposed, the superior window of the window must have a"
      (35 49 "superior window"))
     ("                screen array.  " (16 27 "screen array"))
     ("  ")
     ("")))
   ("exposure priority"
    (("                A value associated with a  window to determine which  window"
      (43 48 "window"))
     ("                is displayed  when  more  than  one  window  is  ready to be"
      (53 58 "window"))
     ("                exposed simultaneously.  ")
     ("  ")
     ("")))
   ("expunge"
    (("                To actually  remove  an  item,  such  as  a  file  or  empty"
      (61 64 "file"))
     ("                directory,  that  has  been  marked  for  deletion  from the"
      (16 24 "directory")
      (45 48 "mark"))
     ("                system.  An expunge operation cannot be undone.  "
      (16 21 "system"))
     ("  ")
     ("")))
   ("extended command"
    (("                A command  in  Zmacs  invoked  by  pressing  META-X and then"
      (31 35 "Zmacs"))
     ("                entering the command name in the minibuffer."
      (49 58 "minibuffer"))
     ("                ")
     ("                  ")
     ("")))
   ("extended search"
    (("                A search facility that  allows  you  to  specify  a  pattern")
     ("                rather  than  just  a  character string for the search.  For"
      (39 47 "character")
      (49 54 "string"))
     ("                example, you can search for two words at the same time.  "
      (48 51 "word"))
     ("  ")
     ("")))
   ("extent"
    (("                The interval of time during which references  to  an  object"
      (70 75 "object"))
     ("                can occur.  ")
     ("  ")
     ("")))
   ("external package mapping"
    (("                An operation that  occurs when  code in  the current package"
      (61 75 "current package"))
     ("                accesses a  symbol  that  does  not  belong  to  the current"
      (28 33 "symbol"))
     ("                package.  " (16 22 "package"))
     ("                  ")
     ("")))
   ("external symbol"
    (("                A symbol in one package that can be accessed by functions of"
      (18 23 "symbol")
      (32 38 "package")
      (64 71 "function"))
     ("                other  packages.   Such   symbols  are   used  as   external"
      (23 29 "package")
      (42 47 "symbol"))
     ("                interfaces to other packages.  " (36 42 "package"))
     ("  ")
     ("")))
   ("external value cell"
    (("                The memory location that contains the value of a symbol that"
      (65 70 "symbol"))
     ("                is closed over by a closure. " (36 42 "closure"))
     ("")))
   ("F1, F2, F3, F4 keys"
    (("                See function keys.  " (20 32 "function keys")) ("")))
   ("fiber-optic link"
    (("                A  cable  that  transmits  data  by means of light reflected")
     ("                through thin, flexible glass rods.  ")
     ("  ")
     ("")))
   ("file"
    (("                A sequence of character or binary data, stored as a group on"
      (18 25 "sequence")
      (30 38 "character"))
     ("                disk or tape.  A  file  of  Lisp  programs  can  be  edited,"
      (44 47 "Lisp"))
     ("                compiled, and loaded.  " (16 22 "compile")
                                                (30 33 "load"))
     ("  ")
     ("                When  you  edit  a  file in Zmacs, the file is copied into a"
      (44 48 "Zmacs"))
     ("                buffer and you edit the copy in the buffer.  "
      (16 21 "buffer"))
     ("  ")
     ("")))
   ("file attribute list"
    (("                A  list  (starting  with  -*-)  in  which  you  specify  the"
      (19 22 "list"))
     ("                attributes of a file.  This list is located at the beginning"
      (32 35 "file")
      (44 47 "list"))
     ("                of the file.  Useful attributes might include base, package,"
      (23 26 "file")
      (68 74 "package"))
     ("                editing mode, and font.  " (34 37 "font"))
     ("  ")
     ("")))
   ("file partition"
    (("                A disk partition (usually  named FILE) that  contains either"
      (23 31 "partition")
      (49 52 "file"))
     ("                all or a portion of a file system.  "
      (38 48 "file system"))
     ("                  ")
     ("")))
   ("file server"
    (("                A program on a host with a file system that handles standard"
      (31 34 "host")
      (43 53 "file system"))
     ("                requests  for  file  operations  from  other  hosts  on  the"
      (31 34 "file")
      (62 65 "host"))
     ("                network.  " (16 22 "network"))
     ("  ")
     ("")))
   ("file system"
    (("                A  set of directories, subdirectories, and files.  Each file"
      (19 21 "set")
      (59 62 "file"))
     ("                system is contained in one or more file partitions.  "
      (16 21 "system")
      (51 64 "file partition"))
     ("  ")
     ("")))
   ("file type"
    (("                An extension  to  a  filename  that  indicates  the  type of"
      (37 44 "filename"))
     ("                information in the  file.  For  example, the  file type LISP"
      (36 39 "file")
      (72 75 "Lisp"))
     ("                denotes a Lisp source code  file, the file type  XLD denotes"
      (26 29 "Lisp")
      (44 47 "file")
      (65 67 "xld"))
     ("                an Explorer file containing compiled code, and the file type"
      (28 31 "file")
      (44 50 "compile"))
     ("                TEXT denotes a general text file.  " (44 47 "file"))
     ("                  ")
     ("")))
   ("file version"
    (("                See version number.  " (20 33 "version number"))
     ("  ")
     ("")))
   ("filename" (("                See pathname.  " (20 27 "pathname")) ("  ")
                                                                       ("")))
   ("fill"
    (("                To put as much text as possible on the current line  without")
     ("                exceeding the right margin.  " (36 41 "margin"))
     ("  ")
     ("                The  fill  column  defines  the  maximum  width of a line by")
     ("                setting the right margin.  " (34 39 "margin"))
     ("  ")
     ("                You can also define a group of characters,  usually  blanks,"
      (47 55 "character"))
     ("                to  start  a  line.   You  can use the prefix to start every")
     ("                line.  Basically, the fill prefix is the left margin.  "
      (62 67 "margin"))
     ("  ")
     ("")))
   ("fill pointer"
    (("                A number that indicates how many elements of  an  array  are"
      (18 23 "number")
      (49 55 "element")
      (66 70 "array"))
     ("                currently being used.  See active element."
      (43 56 "active element"))
     ("                  ")
     ("")))
   ("first"
    (("                A term sometimes used to refer to the car of a list."
      (54 56 "car")
      (63 66 "list"))
     ("  ")
     ("")))
   ("fixnum"
    (("                A  fixed-number;  any integer in the range of -2**25 through")
     ("                (2**25)-1.  Integers outside of this range are bignums.  "
      (63 68 "bignum"))
     ("  ")
     ("")))
   ("flavor"
    (("                An abstract data structure that describes a whole  class  of"
      (33 41 "structure"))
     ("                similar  objects in object-oriented programming.  A specific"
      (25 30 "object"))
     ("                object  is  an  instance  of  a  particular   flavor.    The"
      (16 21 "object")
      (32 39 "instance"))
     ("                operations that can be performed on an object are defined by"
      (55 60 "object"))
     ("                the methods attached to the flavor.  " (20 25
                                                                  "method"))
     ("  ")
     ("                The  Explorer  system  includes a large number of predefined"
      (31 36 "system")
      (56 61 "number"))
     ("                flavors, which you can instantiate and use in your programs."
      (39 49 "instantiate"))
     ("                You can also define your own  flavors  or  combine  existing")
     ("                flavors  to  form  new ones.  See also base flavor and mixin"
      (29 32 "form")
      (55 65 "base flavor"))
     ("                flavor.  ")
     ("  ")
     ("")))
   ("Flavor Inspector"
    (("                A window-oriented program for examining flavors."
      (18 23 "window")
      (56 61 "flavor"))
     ("                ")
     ("")))
   ("floating-point precision"
    (("                The  number  of  digits  used  to represent a floating-point"
      (21 26 "number"))
     ("                number at a specified precision (short, single,  double,  or"
      (16 21 "number"))
     ("                long).  ")
     ("  ")
     ("")))
   ("flonum"
    (("                A floating-point number; any real number.  "
      (33 38 "number"))
     ("  ")
     ("")))
   ("font"
    (("                A set of  alphanumeric characters,  usually all  in one size"
      (18 20 "set")
      (39 47 "character"))
     ("                and  style  of  typeface.    A  font  can   include  special")
     ("                characters, such as icons, as well as the regular  character"
      (16 24 "character"))
     ("                set.  Each font is represented  as a Lisp object  consisting"
      (16 18 "set")
      (53 63 "Lisp object"))
     ("                of an array indexed by character code.  The Explorer  system"
      (22 26 "array")
      (39 47 "character")
      (70 75 "system"))
     ("                has a number of predefined fonts that you can use to display"
      (22 27 "number"))
     ("                or print text.  You can also define your own fonts or modify")
     ("                existing fonts with the font editor.  "
      (40 50 "font editor"))
     ("  ")
     ("")))
   ("font attribute"
    (("                A component of a character object that is intended to permit"
      (33 41 "character")
      (43 48 "object"))
     ("                a different font style for each character, such as italic or"
      (28 31 "font")
      (48 56 "character"))
     ("                boldface.  ")
     ("")))
   ("font editor"
    (("                A facility that allows you to define  new  fonts  or  modify"
      (59 62 "font"))
     ("                existing   fonts  by  using  the  mouse  to  draw  magnified"
      (27 30 "font")
      (50 54 "mouse"))
     ("                characters on a grid of dots.  " (16 24 "character"))
     ("  ")
     ("")))
   ("font map"
    (("                An array that specifies the fonts available  for  use  in  a"
      (19 23 "array")
      (44 47 "font"))
     ("                window.  Each window has a font map.  " (16 21
                                                                   "window")
                                                               (43 46
                                                                   "font"))
     ("  ")
     ("")))
   ("foo"
    (("                A  meaningless  expression  used  to  represent an arbitrary")
     ("                symbol,  variable,  or  function.   When   more   than   one"
      (16 21 "symbol")
      (25 32 "variable")
      (40 47 "function"))
     ("                expression is needed, the terms bar and baz are also used.  "
      (48 50 "bar")
      (56 58 "baz"))
     ("  ")
     ("")))
   ("form"
    (("                A  Lisp object that can be evaluated.  Forms divide into two"
      (19 29 "Lisp object"))
     ("                broad categories:  list forms and nonlist forms.  "
      (35 38 "list"))
     ("  ")
     ("")))
   ("format partition"
    (("                A disk partition that contains  parameters  for  format  and"
      (23 31 "partition")
      (48 56 "parameter"))
     ("                surface analysis of the disk.  ")
     ("  ")
     ("")))
   ("frame"
    (("                1.  A collection of panes or inferior windows  that  can  be"
      (36 39 "pane")
      (45 59 "inferior window"))
     ("                manipulated as a single window.  " (40 45 "window"))
     ("  ")
     ("                2.   A  single processing environment or block of a run-time"
      (31 37 "process")
      (42 52 "environment"))
     ("                stack.  " (16 20 "stack"))
     ("  ")
     ("")))
   ("free list"
    (("                A list of memory that has not been used and is accessible to"
      (18 21 "list"))
     ("                the user.  Also called free storage.  "
      (39 50 "free storage"))
     ("  ")
     ("")))
   ("free storage"
    (("                See free list.  " (20 28 "free list")) ("  ") ("")))
   ("free variable"
    (("                A variable  that  is  used  within  a  function but does not"
      (18 25 "variable")
      (55 62 "function"))
     ("                appear in  the  function's  parameter  list  or in any other"
      (44 58 "parameter list"))
     ("                local binding.  This is commonly called a nonlocal variable."
      (22 28 "binding")
      (58 74 "nonlocal variable"))
     ("                ")
     ("                 ")
     ("")))
   ("frobboz"
    (("                A window naming convention used to stand  for  any  feature,"
      (18 23 "window"))
     ("                attribute,  or  class of windows that can appear in a flavor"
      (41 46 "window")
      (70 75 "flavor"))
     ("                name.  ")
     ("  ")
     ("")))
   ("full-rubout" (("                See over-rubout.  " (20 30
                                                             "over-rubout"))
                   ("  ")
                   ("")))
   ("function"
    (("                A Lisp  object  that  can  be  invoked  as  a  procedure.  A"
      (18 29 "Lisp object"))
     ("                function may take  arguments, and  it returns  zero or  more"
      (35 42 "argument"))
     ("                values.  The  Explorer  system  has  thousands of predefined"
      (40 45 "system"))
     ("                functions you can invoke (see function call).  You can  also"
      (46 58 "function call"))
     ("                define your own functions (see function definition).  "
      (47 65 "function definition"))
     ("                  ")
     ("")))
   ("function call"
    (("                A list form consisting of a symbol  that  names  a  function"
      (18 21 "list")
      (23 26 "form")
      (44 49 "symbol")
      (68 75 "function"))
     ("                followed by arguments to that function.  This is also called"
      (28 35 "argument")
      (46 53 "function"))
     ("                a  function  call  form or simply a function form.  The form"
      (19 26 "function")
      (35 38 "form"))
     ("                invokes the specified  function  by  applying  the  function"
      (39 46 "function"))
     ("                definition  (obtained  from the symbol's function definition"
      (57 75 "function definition"))
     ("                cell) to the arguments.  " (29 36 "argument"))
     ("  ")
     ("                Any list form that has no other interpretation,  such  as  a"
      (20 23 "list")
      (25 28 "form"))
     ("                macro  call or a special form, is considered a function call"
      (16 26 "macro call")
      (33 44 "special form")
      (63 70 "function"))
     ("                and is evaluated as a function unless it is quoted.  "
      (38 45 "function")
      (60 64 "quote"))
     ("  ")
     ("")))
   ("function definition"
    (("                A procedure that creates a  new  function  and  defines  its"
      (49 56 "function"))
     ("                actions.  Typically, you define a new function in one of two"
      (54 61 "function"))
     ("                ways:  ")
     ("  ")
     ("                *  The   defun   special  form,  which  defines  a  named"
      (33 45 "special form"))
     ("                   function, assigns a specified symbol as  the  function"
      (19 26 "function")
      (49 54 "symbol"))
     ("                   name, and puts the function definition in the symbol's"
      (38 45 "function"))
     ("                   function definition  cell.   Named  functions  can  be"
      (19 43 "function definition cell"))
     ("                   referenced  and  invoked  at any time using a function"
      (65 72 "function"))
     ("                   call form.  " (24 27 "form"))
     ("  ")
     ("                *  A lambda expression defines an unnamed function within"
      (21 37 "lambda expression")
      (50 65 "unnamed function"))
     ("                   a function call form.  Since the function is  unnamed,"
      (21 33 "function call")
      (35 38 "form"))
     ("                   it  can  only  be  used within the form in which it is"
      (54 57 "form"))
     ("                   defined.  Use of lambda expressions reduces the number"
      (36 52 "lambda expression")
      (67 72 "number"))
     ("                   of symbols needed.  " (22 27 "symbol"))
     ("  ")
     ("")))
   ("function definition cell"
    (("                A component of a symbol that points to a function definition"
      (33 38 "symbol")
      (45 49 "point")
      (57 75 "function definition"))
     ("                when the symbol is the name of a function.  "
      (25 30 "symbol")
      (49 56 "function"))
     ("  ")
     ("")))
   ("function keys"
    (("                A set of programmable keys (F1, F2, F3, and F4) that can  be"
      (18 20 "set"))
     ("                used  in  application  software.   They  are not used by the"
      (26 36 "application"))
     ("                system software.  These keys are equivalent to the Roman  I,"
      (16 21 "system"))
     ("                II, III, and IV keys on other machines.  ")
     ("                ")
     ("")))
   ("function specification"
    (("                A  Lisp object that describes the location of a function and"
      (19 29 "Lisp object")
      (64 71 "function"))
     ("                therefore serves as the  function  name.   In  much  of  the"
      (41 48 "function"))
     ("                Explorer documentation, this term is called a function spec."
      (62 69 "function"))
     ("                The  most common function specs are symbols.  Function specs"
      (33 40 "function")
      (52 57 "symbol"))
     ("                can also be lists; for  example, (:method w:window  :expose)"
      (28 31 "list"))
     ("                is a list function spec.  " (21 24 "list")
                                                   (26 33 "function"))
     ("  ")
     ("")))
   ("functional position"
    (("                The  first  position  in a list.  This position is used as a"
      (21 25 "first")
      (43 46 "list"))
     ("                function call.  " (16 28 "function call"))
     ("  ")
     ("")))
   ("garbage collector"
    (("                A program that  reclaims  memory  cells  used  to  represent")
     ("                objects  that  are no longer accessible.  Once the memory is"
      (16 21 "object"))
     ("                recovered, it can be used again to  represent  new  objects."
      (68 73 "object"))
     ("                You can turn the garbage collector on or off and control its")
     ("                operation   in   one  of  two  modes:   incremental  garbage")
     ("                collection or stop-and-collect garbage collection.  "
      (30 64 "stop-and-collect garbage collection"))
     ("  ")
     ("")))
   ("general array"
    (("                An array whose elements can be any type of data object.  "
      (19 23 "array")
      (31 37 "element")
      (64 69 "object"))
     ("  ")
     ("")))
   ("general scroll window"
    (("                An independent facility from text scroll windows.   Although"
      (45 62 "text scroll window"))
     ("                these  windows are called scroll windows, the windows do not"
      (23 28 "window"))
     ("                actually scroll.  The contents of the windows are updated as"
      (54 59 "window"))
     ("                items in the windows change.  Peek is a good  example  of  a"
      (29 34 "window")
      (46 49 "Peek"))
     ("                general scroll window.  " (31 36 "window"))
     ("  ")
     ("")))
   ("generalized variable"
    (("                Any storage location that can be referenced by an operation,")
     ("                no matter how that location is named.  For example, the form"
      (72 75 "form"))
     ("                (car  x) refers to a storage location and, therefore, can be")
     ("                considered a generalized variable.  " (41 48
                                                                 "variable"))
     ("  ")
     ("")))
   ("generator"
    (("                The usage of a closure that is called successively to obtain"
      (31 37 "closure"))
     ("                a unique value on each call.  ")
     ("  ")
     ("")))
   ("generic function"
    (("                A function that accepts any type of arguments  and  performs"
      (18 25 "function")
      (52 59 "argument"))
     ("                the appropriate action on them.  ")
     ("  ")
     ("")))
   ("gettable"
    (("                The  ability  to  access an instance variable of a flavor by"
      (44 60 "instance variable")
      (67 72 "flavor"))
     ("                using an automatically generated method.  "
      (49 54 "method"))
     ("  ")
     ("")))
   ("global variable"
    (("                A special variable  that has  been assigned  a global value."
      (18 33 "special variable"))
     ("                This variable is accessible  to any function  in any program"
      (21 28 "variable")
      (52 59 "function"))
     ("                throughout the system and is usually created with  defvar or"
      (31 36 "system"))
     ("                defparameter.")
     ("                ")
     ("")))
   ("Glossary utility"
    (("                An online facility for accessing and displaying  definitions")
     ("                of terms.  The utility provides features for accessing terms")
     ("                in different ways.  A system glossary file is provided.  You"
      (38 43 "system")
      (54 57 "file"))
     ("                can  add  to  this  file  or build your own glossary file to"
      (36 39 "file"))
     ("                display terms appropriate to your application.  "
      (50 60 "application"))
     ("  ")
     ("")))
   ("grabbing the mouse"
    (("                A situation in which  a process takes  control of the  mouse"
      (40 46 "process")
      (71 75 "mouse"))
     ("                away from all windows.  " (30 35 "window"))
     ("")))
   ("graphics character"
    (("                A  character that has a standard textual representation as a"
      (19 27 "character"))
     ("                single character, such as A, *, or =.  "
      (23 31 "character"))
     ("  ")
     ("")))
   ("graphics editor"
    (("                An interactive tool for creating pictures.  "
      (49 55 "picture"))
     ("                  ")
     ("")))
   ("graphics object"
    (("                A  flavor  instance  used  in  the graphics window system to"
      (19 24 "flavor")
      (27 34 "instance")
      (51 72 "graphics window system"))
     ("                represent and display a graphics object, such as  a  circle,"
      (49 54 "object"))
     ("                square, text string, or any user-defined object.  "
      (29 34 "string")
      (57 62 "object"))
     ("  ")
     ("")))
   ("graphics window system"
    (("                A flavor-based support for creating graphics objects such as"
      (18 23 "flavor")
      (52 66 "graphics object"))
     ("                lines, splines, arcs, circles, polygons, and text.  "
      (23 28 "spline"))
     ("                  ")
     ("")))
   ("Grasper"
    (("                An  optional  network  representation  tool  built on top of"
      (30 36 "network"))
     ("                Lisp.   You  can  use  it  to  describe  knowledge  that  is"
      (16 19 "Lisp"))
     ("                naturally  represented as a network.  The Grasper primitives"
      (44 50 "network"))
     ("                include functions to create,  delete,  bind,  evaluate,  and"
      (24 31 "function")
      (46 51 "delete")
      (55 58 "bind"))
     ("                show  the  existence  of  elements  in  a  network.  Network"
      (42 48 "element")
      (59 65 "network"))
     ("                elements include nodes to represent specific objects,  edges"
      (16 22 "element")
      (61 66 "object"))
     ("                to  represent  relationships  between objects, and spaces to"
      (54 59 "object"))
     ("                represent a collection of objects or a specific  view  of  a"
      (42 47 "object")
      (65 68 "view"))
     ("                collection of objects.  " (30 35 "object"))
     ("                  ")
     ("")))
   ("gray plane"
    (("                A  buffer in the font editor that displays characters in the"
      (19 24 "buffer")
      (33 43 "font editor")
      (59 67 "character"))
     ("                editing area.  You can use a character in the gray plane  as"
      (24 27 "area")
      (45 53 "character")
      (67 71 "plane"))
     ("                a reference or template for the character you are editing in"
      (48 56 "character"))
     ("                the  black  plane.   Pixels  set  in the gray plane only are"
      (21 32 "black plane")
      (37 41 "pixel")
      (45 47 "set"))
     ("                displayed in light gray; pixels set in both the  gray  plane"
      (41 45 "pixel")
      (48 50 "set")
      (71 75 "plane"))
     ("                and the black plane are displayed in medium gray.  "
      (24 34 "black plane"))
     ("  ")
     ("")))
   ("gridify"
    (("                To  set the coordinates of a point to the coordinates of the"
      (20 22 "set")
      (45 49 "point"))
     ("                nearest grid point.  For example, if the x grid  spacing  is"
      (29 33 "point"))
     ("                20  and  the  y  grid  spacing  is  15,  a  point  with  the"
      (60 64 "point"))
     ("                coordinates (32,48) is moved to (40,45).  Points are  always"
      (58 62 "point"))
     ("                and only gridified when the grid is turned on.  ")
     ("  ")
     ("")))
   ("grind"
    (("                To  print  or  display Lisp code with line indentations that"
      (39 42 "Lisp"))
     ("                indicate the nesting level of  functions,  thus  making  the"
      (47 54 "function"))
     ("                code easier to read.  Grind is synonymous with pretty print."
      (63 74 "pretty print"))
     ("")))
   ("hash code"
    (("                The value  produced  by  hashing  an  object.  This value is"
      (41 47 "hashing")
      (54 59 "object"))
     ("                usually an integer used as an index to a hash table.  "
      (57 66 "hash table"))
     ("  ")
     ("")))
   ("hash function"
    (("                A function that defines a hashing algorithm.  This  type  of"
      (18 25 "function")
      (42 48 "hashing"))
     ("                function  accepts  a  hash  key as an argument and returns a"
      (16 23 "function")
      (38 46 "hash key")
      (54 61 "argument"))
     ("                hash code.  The hash code is then used as a value to  access"
      (16 24 "hash code"))
     ("                a hash table entry.  See also hash value.  "
      (18 27 "hash table")
      (46 55 "hash value"))
     ("  ")
     ("")))
   ("hash key"
    (("                A symbol that names an entry in a hash table.  "
      (18 23 "symbol")
      (50 59 "hash table"))
     ("  ")
     ("")))
   ("hash table"
    (("                A table containing objects that have undergone hashing. Each"
      (35 40 "object")
      (63 69 "hashing"))
     ("                hash table has a pair of entries associating a hash key with"
      (63 70 "hash key"))
     ("                a hash value.  " (18 27 "hash value"))
     ("  ")
     ("")))
   ("hash value"
    (("                The value associated with a hash key in a hash table.  "
      (44 51 "hash key")
      (58 67 "hash table"))
     ("  ")
     ("")))
   ("hashing"
    (("                A  technique used to provide fast retrieval of data in large")
     ("                tables.  It consists of performing a computation on a set of"
      (70 72 "set"))
     ("                objects to produce a hash code for each object.  Each object"
      (16 21 "object")
      (37 45 "hash code"))
     ("                becomes an entry in a hash table, which is indexed according"
      (38 47 "hash table"))
     ("                to its hash code.  " (23 31 "hash code"))
     ("  ")
     ("")))
   ("hashing collision"
    (("                A condition that occurs when hashing two  different  objects"
      (18 26 "condition")
      (45 51 "hashing")
      (69 74 "object"))
     ("                results in the same hash code.  " (36 44 "hash code"))
     ("  ")
     ("")))
   ("HELP key"
    (("                See information and status keys.  "
      (20 46 "information and status keys"))
     ("  ")
     ("")))
   ("herald"
    (("                A  listing  of information about your system, which includes"
      (19 22 "list")
      (54 59 "system"))
     ("                the name of your system, the memory available, the name  and"
      (33 38 "system"))
     ("                version  of  the software available, and the logical name of")
     ("                your machine.  The herald is displayed in the Lisp  Listener"
      (62 75 "Lisp Listener"))
     ("                window when you boot the system.  You can display the herald"
      (16 21 "window")
      (32 35 "boot")
      (41 46 "system"))
     ("                by executing the print-herald function.  "
      (46 53 "function"))
     ("  ")
     ("")))
   ("history"
    (("                A  place  to store information entered in one window so that"
      (19 23 "place")
      (62 67 "window"))
     ("                it can be retrieved in a different spot in that window or in"
      (64 69 "window"))
     ("                another window.  " (24 29 "window"))
     ("  ")
     ("                Different histories are used for storing different types  of")
     ("                information (see also command history, input history, output"
      (38 52 "command history")
      (55 67 "input history"))
     ("                history,  and  kill  history).   In  some  cases, the system"
      (31 43 "kill history")
      (70 75 "system"))
     ("                automatically places entries in a history; in  other  cases,"
      (30 34 "place"))
     ("                you must use commands to do this.  Commands are available in")
     ("                various windows to retrieve the entries.  "
      (24 29 "window"))
     ("  ")
     ("                The  entries  stay  in the history until the session ends or")
     ("                until the history becomes full.  Once a history is full,  an")
     ("                entry  is  deleted each time a new one is added.  The number"
      (27 32 "delete")
      (70 75 "number"))
     ("                of entries that can be put in a history is user-modifiable. ")
     ("  ")
     ("")))
   ("hog"
    (("                A file that  has  an  excessive  number  of  older  versions"
      (18 21 "file")
      (49 54 "number"))
     ("                present in the file system.  " (31 41 "file system"))
     ("  ")
     ("")))
   ("home directory"
    (("                Generally, the directory where you keep your personal files,"
      (31 39 "directory")
      (70 73 "file"))
     ("                such as initialization files and  your mail file.  When  you"
      (24 42 "initialization file")
      (55 58 "Mail"))
     ("                log in, you can specify the name of the host where you  keep"
      (56 59 "host"))
     ("                your home directory if it is on a machine other than the one"
      (26 34 "directory"))
     ("                you are  using.   Your  home  directory is identified by the"
      (46 54 "directory"))
     ("                function user-homedir-pathname.  " (16 23 "function"))
     ("  ")
     ("")))
   ("home package"
    (("                The package that owns a given symbol.  A symbol  can  appear"
      (20 26 "package")
      (46 51 "symbol"))
     ("                in  more  than  one  package,  but it can have only one home"
      (37 43 "package"))
     ("                package.  The symbol's package cell contains the name of the"
      (16 22 "package")
      (39 50 "package cell"))
     ("                home package.  " (21 27 "package"))
     ("  ")
     ("")))
   ("hook"
    (("                A piece of software or hardware  that  acts  as  an  aid  to")
     ("                debugging.   A  hook  enables  normal software evaluation or"
      (63 72 "evaluation"))
     ("                hardware execution to be interrupted at specified points  in"
      (41 49 "interrupt")
      (66 70 "point"))
     ("                order to examine the program execution state or the hardware")
     ("                state.  ")
     ("  ")
     ("")))
   ("horizontal index"
    (("                A  column  subscript  for  a  two-dimensional array.  On the"
      (62 66 "array"))
     ("                Explorer system, this is the second subscript.    "
      (25 30 "system"))
     ("")))
   ("host"
    (("                Any computer or node  on  a  network  that  can  initiate  a"
      (45 51 "network"))
     ("                network  operation  or  has  a  resource that can be used by"
      (16 22 "network")
      (48 55 "resource"))
     ("                other computers on the network.  " (39 45 "network"))
     ("  ")
     ("")))
   ("host object"
    (("                A Lisp object that represents a computer, usually  connected"
      (18 28 "Lisp object"))
     ("                to a network.  On  the Explorer system,  a host object  is a"
      (21 27 "network")
      (48 53 "system")
      (59 62 "host")
      (64 69 "object"))
     ("                flavor instance that records information such as the name of"
      (16 21 "flavor")
      (23 30 "instance"))
     ("                the  host,  its  operating  system  type,  and  its  network"
      (21 24 "host")
      (44 49 "system")
      (69 75 "network"))
     ("                address.  ")
     ("  ")
     ("")))
   ("HYPER key"
    (("                See modifier keys.  " (20 32 "modifier keys")) ("  ")
                                                                      ("")))
   ("hysteresis"
    (("                The distance, in pixels, that you can move the mouse blinker"
      (33 37 "pixel")
      (63 67 "mouse")
      (69 75 "blinker"))
     ("                outside of a menu before the menu disappears."
      (29 32 "menu"))
     ("")))
   ("I//O stream" (("                See stream.  " (20 25 "stream")) ("  ")
                                                                      ("")))
   ("implicit application"
    (("                See application.  " (20 30 "application")) ("  ")
                                                                  ("")))
   ("implicit evaluation"
    (("                See evaluation.  " (20 29 "evaluation")) ("  ") ("")))
   ("import shadowing"
    (("                A type of shadowing that may occur when a particular package"
      (26 31 "shadow")
      (69 75 "package"))
     ("                imports symbols from  another package.   Ordinarily, if  the"
      (24 29 "symbol")
      (46 52 "package"))
     ("                names of the  imported symbols  conflict with  those of  the"
      (39 44 "symbol"))
     ("                current package, an  error is  signaled by  the Lisp Reader."
      (16 30 "current package")
      (64 74 "Lisp Reader"))
     ("                However, the local symbols can  be shadowed by the  imported"
      (35 40 "symbol")
      (51 56 "shadow"))
     ("                symbols through  the  use  of  the shadowing-import form, in"
      (16 21 "symbol")
      (68 71 "form"))
     ("                which case  the  imported  symbols  take precedence over the"
      (43 48 "symbol"))
     ("                local ones.")
     ("")))
   ("importing a symbol"
    (("                To cause a symbol to become an internal symbol of a package."
      (27 32 "symbol")
      (47 61 "internal symbol")
      (68 74 "package"))
     ("                A  symbol  can be internal to more than one package although"
      (19 24 "symbol")
      (60 66 "package"))
     ("                it can have only one home package.  "
      (37 48 "home package"))
     ("  ")
     ("")))
   ("incremental garbage collection"
    (("                A type of garbage collection that occurs  in  parallel  with")
     ("                computation.   Incremental  garbage  collection is triggered")
     ("                when a user-specified threshold of available memory has been")
     ("                crossed.  ")
     ("  ")
     ("")))
   ("incremental search"
    (("                A Zmacs search  facility  that  finds  intermediate  strings"
      (18 22 "Zmacs")
      (69 74 "string"))
     ("                while  you  are typing.  As the string is accumulated,  this"
      (48 53 "string"))
     ("                facility searches for what you have typed so far.  That  is,")
     ("                if  you  want  to  find  the word CATS, this search facility"
      (45 48 "word"))
     ("                finds the first C when you type it.  When  you  type  A,  it"
      (26 30 "first"))
     ("                finds the first CA and so on.  " (26 30 "first"))
     ("  ")
     ("")))
   ("indefinite extent"
    (("                A type of extent in which an established object continues to"
      (26 31 "extent")
      (57 62 "object"))
     ("                exist as long as the possibility of reference remains.  "
      (37 47 "possibility"))
     ("  ")
     ("")))
   ("indefinite scope"
    (("                A type  of  scope  in  which  an  established  object can be"
      (28 32 "scope")
      (63 68 "object"))
     ("                referenced  from  anywhere  within  any  program.   This  is")
     ("                similar to the concept of a global variable.  "
      (44 58 "global variable"))
     ("  ")
     ("")))
   ("index offset"
    (("                A number that is added to a subscript of an  array  to  give"
      (18 23 "number")
      (61 65 "array"))
     ("                the actual displacement of the element in the array.  "
      (47 53 "element")
      (62 66 "array"))
     ("  ")
     ("")))
   ("index value"
    (("                1.  The integer value used to access an element of an array."
      (56 62 "element")
      (70 74 "array"))
     ("  ")
     ("                2.   During list traversal, a value indicating how many list"
      (28 31 "list"))
     ("                elements should be traversed before extracting  the  desired"
      (16 22 "element"))
     ("                element.  " (16 22 "element"))
     ("  ")
     ("")))
   ("index variable"
    (("                A variable used in iterative forms, such as the do function,"
      (18 25 "variable")
      (45 48 "form")
      (67 74 "function"))
     ("                that is manipulated to control the amount of iteration.  ")
     ("  ")
     ("")))
   ("indicator"
    (("                A symbol that names an entry  in a property list, usually  a"
      (18 23 "symbol")
      (51 63 "property list"))
     ("                keyword.  " (16 22 "keyword"))
     ("                  ")
     ("")))
   ("indirect array"
    (("                An array whose contents, instead of being located at a fixed"
      (19 23 "array"))
     ("                place  in virtual memory, are defined to be those of another"
      (16 20 "place"))
     ("                array.  " (16 20 "array"))
     ("  ")
     ("")))
   ("inferior"
    (("                See inferior window.  " (20 34 "inferior window"))
     ("  ")
     ("")))
   ("inferior window"
    (("                A subordinate  window.   An  inferior  window  is  contained"
      (31 36 "window")
      (45 52 "inferior"))
     ("                entirely  within  its  superior  window  and  is  positioned"
      (39 54 "superior window"))
     ("                relative to the top left corner of the superior window.  "
      (55 69 "superior window"))
     ("  ")
     ("")))
   ("information and status keys"
    (("                The set of keys that supply information,  invoke  utilities,"
      (20 22 "set"))
     ("                and control the keyboard:")
     ("                  ")
     ("                *  HELP  --  Provides  online  documentation  of  various")
     ("                   features.  ")
     ("                  ")
     ("                *  NETWORK -- Invokes functions in network utilities such"
      (19 25 "network")
      (38 45 "function"))
     ("                   as Telnet.  " (22 27 "Telnet"))
     ("                  ")
     ("                *  STATUS -- Accesses the contents of the input,  output,")
     ("                   or kill histories.  " (22 25 "kill"))
     ("                  ")
     ("                *  SYSTEM  --  Used in combination with character keys to"
      (19 24 "system")
      (56 69 "character keys"))
     ("                   invoke system utilities.  SYSTEM HELP has other useful"
      (26 31 "system"))
     ("                   information. ")
     ("                  ")
     ("                *  TERM -- Used  in combination with  other keys to  perform")
     ("                   various functions on  the console.   TERM HELP  has other"
      (27 34 "function")
      (45 51 "console"))
     ("                   useful information. ")
     ("                  ")
     ("")))
   ("init file"
    (("                See initialization file.  "
      (20 38 "initialization file"))
     ("  ")
     ("")))
   ("initialization file"
    (("                A file you can create in your home directory or create  with"
      (18 21 "file")
      (46 59 "home directory"))
     ("                the Profile utility for customizations to be executed  every"
      (20 34 "Profile utility"))
     ("                time you log  in.  These  customizations can  set variables,"
      (62 64 "set")
      (66 73 "variable"))
     ("                load files,  define  functions,  and  so  on.   If your home"
      (16 19 "load")
      (21 24 "file")
      (37 44 "function"))
     ("                directory is on  an Explorer  system, the  pathname of  this"
      (16 24 "directory")
      (46 51 "system")
      (59 66 "pathname"))
     ("                initialization file will be LOGIN-INIT.LISP.  "
      (31 34 "file"))
     ("                  ")
     ("")))
   ("initialization option"
    (("                An  option  provided  by  the  flavor  system  enabling  the"
      (47 52 "flavor")
      (55 60 "system"))
     ("                instance variables of  a flavor  instance to  be initialized"
      (16 32 "instance variable")
      (41 46 "flavor"))
     ("                when a flavor instance  is created.  (Sometimes  referred to"
      (23 28 "flavor")
      (30 37 "instance"))
     ("                as an init option.)  ")
     ("  ")
     ("")))
   ("inittable"
    (("                A characteristic  of  instance  variables  of  a flavor that"
      (38 55 "instance variable")
      (65 70 "flavor"))
     ("                enables  the  instance  variables  to  be  initialized  to a"
      (30 47 "instance variable"))
     ("                specified value when an instance of the flavor is created.  "
      (40 47 "instance")
      (56 61 "flavor"))
     ("  ")
     ("")))
   ("inline subroutine"
    (("                A function in which the compiler incorporates the body forms"
      (18 25 "function")
      (40 47 "compiler")
      (71 74 "form"))
     ("                of a subroutine into a function being compiled, substituting"
      (39 46 "function")
      (54 60 "compile"))
     ("                the argument forms  for references  to the  variables in the"
      (20 27 "argument")
      (29 32 "form")
      (60 67 "variable"))
     ("                inline subroutine's lambda list.   This operation makes  the"
      (36 46 "lambda list"))
     ("                code more efficient  at the  cost of  losing some  debugging")
     ("                ability.  An inline subroutine is also called an  open-coded")
     ("                subroutine.  ")
     ("  ")
     ("")))
   ("input editor"
    (("                A facility that allows you  to edit input streams;  formerly"
      (58 63 "stream"))
     ("                known as the rubout handler.  " (29 42
                                                           "rubout handler"))
     ("  ")
     ("")))
   ("input history"
    (("                A buffer that records the forms you enter in a Lisp Listener"
      (18 23 "buffer")
      (42 45 "form")
      (63 75 "Lisp Listener"))
     ("                window.  See also history.  " (16 21 "window")
                                                     (34 40 "history"))
     ("  ")
     ("")))
   ("insignificant command"
    (("                A Universal Command Loop (UCL) command that performs a minor"
      (18 39 "Universal Command Loop")
      (42 44 "UCL"))
     ("                or  insignificant operation.  Insignificant commands are not")
     ("                placed in UCL command histories.  " (16 20 "place")
                                                           (26 28 "UCL"))
     ("  ")
     ("")))
   ("Inspector"
    (("                A  window-oriented  program  for  examining   complex   data"
      (19 24 "window"))
     ("                structures.   It  allows  you  to  view  and  modify various"
      (16 24 "structure")
      (51 54 "view"))
     ("                components of Lisp objects.  The  Inspector  has  a  history"
      (30 40 "Lisp object")
      (69 75 "history"))
     ("                pane  that  maintains a list of all objects inspected so far"
      (16 19 "pane")
      (40 43 "list")
      (52 57 "object"))
     ("                and  several  inspection  panes  that  allow  you  to   view"
      (42 45 "pane")
      (72 75 "view"))
     ("                different objects at the same time.  See Flavor Inspector."
      (26 31 "object")
      (57 72 "Flavor Inspector"))
     ("                  ")
     ("")))
   ("instance"
    (("                An individual occurrence of a flavor or structure.  "
      (46 51 "flavor")
      (56 64 "structure"))
     ("  ")
     ("")))
   ("instance variable"
    (("                A  part  of the data structure of a flavor that specifies an"
      (37 45 "structure")
      (52 57 "flavor"))
     ("                attribute for that flavor.  Each  object  (instance  of  the"
      (35 40 "flavor")
      (50 55 "object")
      (59 66 "instance"))
     ("                flavor)  holds  its  own  set  of  values  for  the instance"
      (16 21 "flavor")
      (42 44 "set")
      (68 75 "instance"))
     ("                variables.  The flavor can establish default initial  values"
      (16 23 "variable")
      (32 37 "flavor"))
     ("                for   the   instance  variables,  or  you  can  supply  them"
      (28 35 "instance")
      (38 45 "variable"))
     ("                explicitly when you instantiate a flavor.  "
      (36 46 "instantiate")
      (50 55 "flavor"))
     ("  ")
     ("                When you combine flavors, the set of instance variables  for"
      (33 38 "flavor")
      (46 48 "set")
      (53 60 "instance")
      (62 69 "variable"))
     ("                the  new  flavor  is  the  union of all the sets of instance"
      (26 31 "flavor")
      (60 62 "set")
      (68 75 "instance"))
     ("                variables from all the component flavors.  "
      (16 23 "variable")
      (39 54 "component flavor"))
     ("  ")
     ("")))
   ("instantiate"
    (("                To dynamically create an object, which can be an instance of"
      (41 46 "object")
      (65 72 "instance"))
     ("                a flavor or a defined structure.  " (18 23 "flavor")
                                                           (38 46
                                                               "structure"))
     ("")))
   ("internal package mapping"
    (("                An operation that occurs when the current package accesses a"
      (50 64 "current package"))
     ("                symbol that belongs to the current package.  "
      (16 21 "symbol")
      (43 57 "current package"))
     ("  ")
     ("")))
   ("internal symbol"
    (("                A symbol of a package that normally cannot  be  accessed  by"
      (18 23 "symbol")
      (30 36 "package"))
     ("                functions of other packages.  " (16 23 "function")
                                                       (35 41 "package"))
     ("  ")
     ("")))
   ("internal value cell"
    (("                See value cell.  " (20 29 "value cell")) ("  ") ("")))
   ("interned symbol"
    (("                A  symbol  that  belongs  to  a  specific  package, which is"
      (19 24 "symbol")
      (59 65 "package"))
     ("                specified by the value of the symbol's package cell.  "
      (55 66 "package cell"))
     ("  ")
     ("")))
   ("interning a symbol"
    (("                To cause a symbol to belong to a package.  "
      (27 32 "symbol")
      (49 55 "package"))
     ("  ")
     ("")))
   ("interpreted function"
    (("                A function  whose  definition  has  been  converted  into an"
      (18 25 "function"))
     ("                internal list representation by the Lisp Reader and which is"
      (25 28 "list")
      (52 62 "Lisp Reader"))
     ("                then interpreted  by  the  Lisp  evaluator.   Only  the list"
      (43 46 "Lisp")
      (49 57 "evaluator")
      (72 75 "list"))
     ("                representation  of  the  function  definition  is  saved  in"
      (41 60 "function definition")
      (67 70 "save"))
     ("                memory, not the printed representation.  "
      (32 53 "printed representation"))
     ("  ")
     ("")))
   ("interpreter"
    (("                See Lisp interpreter.  " (20 35 "Lisp interpreter"))
     ("  ")
     ("")))
   ("interrupt"
    (("                A  timing  signal  that  causes  the  processor  to  suspend")
     ("                execution  of  its  current  process  and to execute another"
      (36 51 "current process"))
     ("                process.  On the Explorer system, interrupts are implemented"
      (16 22 "process")
      (42 47 "system"))
     ("                as events.  " (19 23 "event"))
     ("  ")
     ("")))
   ("ITAL LOCK key"
    (("                See mode keys.  " (20 28 "mode keys")) ("")))
   ("justify" (("                See adjust. " (20 25 "adjust")) ("")))
   ("keyboard cursor"
    (("                A blinking cursor appearing  in  the  selected  window  that"
      (54 69 "selected window"))
     ("                indicates where the text you type is echoed on the display. ")
     ("  ")
     ("")))
   ("keyboard macro"
    (("                A  series  of  Zmacs  commands  that are stored for use as a"
      (31 35 "Zmacs"))
     ("                group.  If you repeatedly use a particular series of command")
     ("                keystrokes, you can specify that the sequence of  keystrokes"
      (53 60 "sequence"))
     ("                be  installed  on  a  single  key.   You can specify several")
     ("                keyboard macros.  " (25 29 "macro"))
     ("  ")
     ("")))
   ("keystroke sequence"
    (("                Any combination of keystrokes used to invoke  a  command  or")
     ("                operation.  Some sequences are chorded, which means you must"
      (33 40 "sequence"))
     ("                press  all  the  keys simultaneously.  Chorded sequences are"
      (63 70 "sequence"))
     ("                denoted by hyphens between key names.   Sequences  that  are"
      (56 63 "sequence"))
     ("                not  chorded  are  denoted  by spaces between key names; you")
     ("                must press these keys in the order specified.  ")
     ("  ")
     ("")))
   ("keyword"
    (("                A symbol that evaluates to itself and is  contained  in  the"
      (18 23 "symbol"))
     ("                keyword  package.   Keywords  can  be  used  as arguments to"
      (16 31 "KEYWORD package")
      (64 71 "argument"))
     ("                functions.  " (16 23 "function"))
     ("  ")
     ("")))
   ("keyword argument"
    (("                An argument passed to a keyword parameter.  The argument  is"
      (19 26 "argument")
      (40 56 "keyword parameter"))
     ("                a pair consisting of a keyword and an associated value.  The"
      (39 45 "keyword"))
     ("                value  is  bound to the corresponding keyword parameter when"
      (54 70 "keyword parameter"))
     ("                the function is applied.  The value of  a  keyword  argument"
      (20 27 "function")
      (59 65 "keyword")
      (68 75 "argument"))
     ("                can itself be a keyword.  " (32 38 "keyword"))
     ("  ")
     ("")))
   ("KEYWORD package"
    (("                The  package  that  contains all keyword symbols used by the"
      (21 27 "package")
      (49 55 "keyword")
      (57 62 "symbol"))
     ("                system and by user-written code.  " (16 21 "system"))
     ("  ")
     ("")))
   ("keyword package qualifier"
    (("                A package qualifier consisting of a single colon  (:)   that"
      (18 34 "package qualifier"))
     ("                is  not preceded by a package name.  This indicates that the"
      (38 49 "package name"))
     ("                symbol belongs to the KEYWORD package.  "
      (16 21 "symbol")
      (38 52 "KEYWORD package"))
     ("  ")
     ("")))
   ("keyword parameter"
    (("                A symbol in a lambda list  indicating that this symbol is  a"
      (18 23 "symbol")
      (30 40 "lambda list"))
     ("                function keyword.   Keyword  parameters  always  follow  the"
      (16 23 "function")
      (25 31 "keyword")
      (45 53 "parameter"))
     ("                lambda-list  keyword  &key.   They  allow  an argument to be"
      (16 35 "lambda-list keyword")
      (62 69 "argument"))
     ("                passed and  matched  to  the  corresponding  parameter  by a"
      (61 69 "parameter"))
     ("                keyword rather than by position in the function call.  "
      (16 22 "keyword")
      (55 67 "function call"))
     ("  ")
     ("")))
   ("kill"
    (("                1.  To deactivate a window and make  a  positive  effort  to"
      (23 32 "deactivate")
      (36 41 "window"))
     ("                remove  any  other  entities--such  as  processes or network"
      (56 62 "process")
      (69 75 "network"))
     ("                connections--that may be associated with the killed  window."
      (69 74 "window"))
     ("                If  the  killed  window  has  associated  entities,  garbage"
      (33 38 "window"))
     ("                collection  alone  may  not  be  satisfactory.    Therefore,")
     ("                killing a window is preferable to deactivating a window.  "
      (26 31 "window"))
     ("  ")
     ("                2.   In Zmacs, to move a block of text into the kill history"
      (24 28 "Zmacs")
      (64 75 "kill history"))
     ("                and remove it from your buffer.  See also save.  "
      (40 45 "buffer")
      (58 61 "save"))
     ("  ")
     ("")))
   ("kill history"
    (("                A type of  buffer that  stores any  block of  text you  have"
      (27 32 "buffer"))
     ("                killed in a Zmacs buffer or  in the input editor.  The  kill"
      (16 19 "kill")
      (28 39 "Zmacs buffer")
      (52 63 "input editor"))
     ("                history is a mouse-sensitive display.  You can retrieve  the"
      (16 22 "history")
      (29 33 "mouse"))
     ("                entries in the kill history by  using the mouse or by  using"
      (31 34 "kill")
      (36 42 "history")
      (58 62 "mouse"))
     ("                yank commands.  See also history.  " (16 19 "yank")
                                                            (41 47
                                                                "history"))
     ("")))
   ("label"
    (("                1.  A text string in a window  margin  that  identifies  the"
      (27 32 "string")
      (39 44 "window")
      (47 52 "margin"))
     ("                window.   Usually, the  label appears in the lower left-hand"
      (16 21 "window"))
     ("                corner.  ")
     ("  ")
     ("                2.  The description of the partitions of a disk.  "
      (43 51 "partition"))
     ("  ")
     ("")))
   ("lambda binding"
    (("                The binding  of  the  parameters  of  a  function  to  their"
      (20 26 "binding")
      (38 46 "parameter")
      (57 64 "function"))
     ("                corresponding  argument  values  during  application  of the"
      (31 38 "argument")
      (57 67 "application"))
     ("                function.  " (16 23 "function"))
     ("  ")
     ("")))
   ("lambda expression"
    (("                A list that consists of the  symbol  lambda  followed  by  a"
      (18 21 "list")
      (45 50 "symbol"))
     ("                lambda  list  and  a  body  containing  any number of forms."
      (16 27 "lambda list")
      (60 65 "number")
      (70 73 "form"))
     ("                Lambda expressions are  used  to  define  unnamed  functions"
      (58 74 "unnamed function"))
     ("                within   a   function  call  form.   Lambda  expressions  by"
      (29 42 "function call")
      (45 48 "form"))
     ("                themselves are not forms and cannot be evaluated.  "
      (35 38 "form"))
     ("  ")
     ("")))
   ("lambda list"
    (("                A list that specifies names for the parameters of a function"
      (18 21 "list")
      (52 60 "parameter")
      (68 75 "function"))
     ("                (sometimes called  a  parameter  list).   Lambda  lists  are"
      (38 52 "parameter list"))
     ("                contained within function definitions.  "
      (33 51 "function definition"))
     ("  ")
     ("")))
   ("lambda-list keyword"
    (("                A keyword used in a lambda list to indicate a parameter type"
      (18 24 "keyword")
      (36 46 "lambda list")
      (62 70 "parameter"))
     ("                such as  an  optional  or  rest  parameter.  The lambda list"
      (43 57 "rest parameter")
      (65 75 "lambda list"))
     ("                keywords are always  preceded by  an ampersand  (&) and  are"
      (16 22 "keyword"))
     ("                provided in a  function definition.   The following  are the"
      (31 49 "function definition"))
     ("                available lambda-list keywords:")
     ("  ")
     ("                *  &optional ")
     ("  ")
     ("                *  &rest ")
     ("  ")
     ("                *  &key ")
     ("  ")
     ("                *  &aux ")
     ("  ")
     ("                *  &special ")
     ("  ")
     ("                *  &local ")
     ("  ")
     ("                *  &functional ")
     ("  ")
     ("                *  &quote ")
     ("  ")
     ("                *  &eval ")
     ("  ")
     ("")))
   ("LAN"
    (("                See local area network.  " (20 37
                                                      "local area network"))
     ("")))
   ("landscape"
    (("                A particular orientation (shape) of a window or the  display"
      (54 59 "window"))
     ("                in which  the  area  shown  is  wider  than it is tall.  The"
      (31 34 "area"))
     ("                Explorer monitor uses a landscape orientation, instead  of a")
     ("                portrait orientation.  " (16 23 "portrait"))
     ("  ")
     ("")))
   ("leader"
    (("                See array leader.  " (20 31 "array leader")) ("  ")
                                                                    ("")))
   ("leaf"
    (("                A component of a list that is not another list.  "
      (33 36 "list"))
     ("  ")
     ("")))
   ("LEFT key"
    (("                See mouse keys.  " (20 29 "mouse keys")) ("  ") ("")))
   ("lexical binding"
    (("                A type of binding in  which a variable can  be accessed only"
      (26 32 "binding")
      (46 53 "variable"))
     ("                if its reference  occurs textually  within its  establishing")
     ("                function (making it local).  " (16 23 "function"))
     ("  ")
     ("")))
   ("lexical closure"
    (("                A closure that saves the  values  of  a  function's  lexical"
      (18 24 "closure")
      (31 34 "save"))
     ("                variables when the function has completed executing.  "
      (16 23 "variable")
      (35 42 "function"))
     ("  ")
     ("")))
   ("lexical scope"
    (("                A type of scope  in which the  values of free  variables are"
      (26 30 "scope")
      (57 70 "free variable"))
     ("                determined in the definition environment rather than in  the"
      (34 55 "definition environment"))
     ("                run-time environment.  In lexical  scope, a reference  to an"
      (25 35 "environment")
      (51 55 "scope"))
     ("                established object occurs only  within a particular  portion"
      (28 33 "object"))
     ("                of the  program  that  is  lexically  contained  within  the")
     ("                establishing form.  " (29 32 "form"))
     ("  ")
     ("")))
   ("lexical variable"
    (("                A variable used in a function as a local variable.  "
      (18 25 "variable")
      (37 44 "function"))
     ("  ")
     ("")))
   ("lexicographic comparison"
    (("                An  alphanumeric  comparison  of  two  strings  based  on  a"
      (55 60 "string"))
     ("                collating sequence.  " (26 33 "sequence"))
     ("  ")
     ("")))
   ("LINE FEED key"
    (("                See line-positioning keys.  "
      (20 40 "line-positioning keys"))
     ("                  ")
     ("                ")
     ("")))
   ("line height"
    (("                The largest height of all the characters of the fonts in the"
      (46 54 "character")
      (64 67 "font"))
     ("                font  map plus the VSP, which is the amount of space between"
      (16 24 "font map")
      (35 37 "VSP"))
     ("                lines.  The line  height  determines  the  amount  of  space")
     ("                allowed  for  each line of text on the display.  If the font"
      (72 75 "font"))
     ("                map contains a large font and a small font, the line  height"
      (37 40 "font"))
     ("                is still large enough for the large font.  "
      (52 55 "font"))
     ("  ")
     ("")))
   ("line spacing"
    (("                The  number  of  lines  per  inch  (lpi) printed.  This term"
      (21 26 "number"))
     ("                usually describes output from a printer.  ")
     ("  ")
     ("")))
   ("line-positioning keys"
    (("                The  set of keys that move the keyboard cursor within a line"
      (21 23 "set")
      (47 61 "keyboard cursor"))
     ("                or to a new line.  These keys are as follows:  ")
     ("                  ")
     ("                *  LINE FEED -- Inserts a  carriage  return,  moving  the")
     ("                   cursor to  a  new  line  and,  if  in  the  Zmacs editor,"
      (63 67 "Zmacs"))
     ("                   properly indenting the line for Lisp code.  "
      (51 54 "Lisp"))
     ("                  ")
     ("                *  RETURN -- Usually inserts a  carriage  return,  moving")
     ("                   the cursor to the left margin of the new line.  "
      (42 47 "margin"))
     ("                  ")
     ("                *  RUBOUT  --  Backspaces  and deletes a character at the"
      (47 52 "delete")
      (57 65 "character"))
     ("                   current cursor position; can  be  used  with  modifier")
     ("                   keys to rub out more than one character at a time.  "
      (49 57 "character"))
     ("                  ")
     ("                *  TAB -- Moves the keyboard cursor a specified number of"
      (36 50 "keyboard cursor")
      (64 69 "number"))
     ("                   columns to the right.  ")
     ("                  ")
     ("                ")
     ("")))
   ("linearization"
    (("                A procedure  involving  the  computation  of an offset value")
     ("                from the  subscripts  of  a  multidimensional  array.   Real"
      (63 67 "array"))
     ("                memory arrangement is linear.  Therefore, when elements of a"
      (63 69 "element"))
     ("                logical multidimensional array are accessed, there must be a"
      (41 45 "array"))
     ("                mapping from a logical multidimensional subscript to a  real"
      (16 22 "mapping"))
     ("                single offset of linearly arranged memory.  ")
     ("  ")
     ("")))
   ("linearized subscript"
    (("                The  result  of multiplying each subscript of an array by an"
      (65 69 "array"))
     ("                appropriate coefficient and adding them together.  ")
     ("  ")
     ("")))
   ("Lisp"
    (("                A  programming  language  that  is  especially  suited   for")
     ("                manipulating  symbolic  structures  in  the  form  of linked"
      (40 48 "structure")
      (61 64 "form"))
     ("                lists.  Lisp is  widely  used  for  artificial  intelligence"
      (16 19 "list"))
     ("                research  and  applications  requiring  symbolic processing."
      (31 41 "application")
      (65 71 "process"))
     ("                The Explorer system is written in Lisp,  providing  a  rich,"
      (29 34 "system"))
     ("                integrated environment for the development of Lisp programs."
      (27 37 "environment"))
     ("  ")
     ("")))
   ("Lisp compiler"
    (("                A  program that converts Lisp functions into machine code so"
      (41 44 "Lisp")
      (46 53 "function"))
     ("                that they run faster and require less memory.  The  compiler"
      (68 75 "compiler"))
     ("                performs  a  number  of  different  types  of optimizations,"
      (29 34 "number"))
     ("                checks for errors,  and  issues  warnings  when  errors  are")
     ("                found.  ")
     ("  ")
     ("")))
   ("Lisp form"
    (("                An object that can be evaluated.  " (19 24 "object"))
     ("  ")
     ("")))
   ("Lisp interpreter"
    (("                A program that evaluates Lisp forms.  "
      (41 49 "Lisp form"))
     ("  ")
     ("")))
   ("Lisp Listener"
    (("                A  window  through  which you can interact directly with the"
      (19 24 "window"))
     ("                Lisp interpreter.  The Listener accepts Lisp  forms  as  you"
      (16 31 "Lisp interpreter")
      (39 46 "Listener")
      (56 65 "Lisp form"))
     ("                type  them  and  displays  the  results  of evaluation.  The"
      (60 69 "evaluation"))
     ("                Listener has a number of features  to  help  you  type  Lisp"
      (16 23 "Listener")
      (31 36 "number")
      (72 75 "Lisp"))
     ("                forms, including completion and editing capabilities.  "
      (16 19 "form")
      (33 42 "completion"))
     ("  ")
     ("")))
   ("Lisp object"
    (("                Any  element  of  the Lisp language, such as a symbol, list,"
      (21 27 "element")
      (38 41 "Lisp")
      (63 68 "symbol")
      (71 74 "list"))
     ("                function, or structure.  Objects include those that  can  be"
      (16 23 "function")
      (29 37 "structure")
      (41 46 "object"))
     ("                evaluated  (forms)  and those that cannot be evaluated (such")
     ("                as property lists).  A set of similar  objects  comprises  a"
      (19 31 "property list")
      (39 41 "set")
      (55 60 "object"))
     ("                data type.  " (16 24 "data type"))
     ("  ")
     ("")))
   ("Lisp Reader"
    (("                A Lisp procedure that reads characters from an input stream,"
      (18 21 "Lisp")
      (44 52 "character")
      (69 74 "stream"))
     ("                interprets  them  as  the  printed  representation of a Lisp"
      (43 65 "printed representation")
      (72 75 "Lisp"))
     ("                object, converts the printed representation into an internal"
      (16 21 "object")
      (37 58 "printed representation"))
     ("                binary  representation,  and  and  returns  a  corresponding")
     ("                object.  " (16 21 "object"))
     ("  ")
     ("")))
   ("list"
    (("                A data structure represented internally by a chain of conses"
      (23 31 "structure")
      (70 73 "cons"))
     ("                (nodes) linked together by the cdr components of the conses."
      (47 49 "cdr")
      (69 72 "cons"))
     ("                A   true   list  (sometimes  called  an  ordinary  list)  is"
      (20 30 "true list")
      (57 70 "ordinary list"))
     ("                terminated by the symbol nil.  A dotted list  is  terminated"
      (34 39 "symbol")
      (41 43 "nil")
      (49 59 "dotted list"))
     ("                by  a  non-nil  atom.   Most  functions  requiring  lists as"
      (32 35 "atom")
      (46 53 "function"))
     ("                arguments require true lists.  " (16 23 "argument")
                                                        (34 42 "true list"))
     ("  ")
     ("                A list's external representation consists of a  sequence  of"
      (64 71 "sequence"))
     ("                elements  enclosed in parentheses.  Each element in the list"
      (16 22 "element"))
     ("                can be either an atom or another list.  " (33 36
                                                                     "atom"))
     ("  ")
     ("                Lists are interpreted as function  calls,  macro  calls,  or"
      (41 54 "function call")
      (59 69 "macro call"))
     ("                special forms unless they are quoted.  "
      (16 27 "special form")
      (46 50 "quote"))
     ("  ")
     ("")))
   ("Listener" (("                See Lisp Listener.  " (20 32
                                                            "Lisp Listener"))
                ("  ")
                ("")))
   ("lm"
    (("                See local machine.  " (20 32 "local machine")) ("  ")
                                                                      ("")))
   ("load"
    (("                To  bring  a  file  into  memory  so  that  it  is ready for"
      (30 33 "file"))
     ("                execution.  You can load the system, files, and patches with"
      (45 50 "system")
      (53 56 "file")
      (64 68 "patch"))
     ("                specially defined load functions or with load commands.   "
      (39 46 "function"))
     ("                  ")
     ("                To load  a  character  (text)  file  is  to read through it,"
      (28 36 "character")
      (47 50 "file"))
     ("                evaluating each form  within the  file.  Loading  a compiled"
      (32 35 "form")
      (50 53 "file")
      (68 74 "compile"))
     ("                (xld) file, evaluates the compiled  forms in the file.   The"
      (22 25 "file")
      (42 48 "compile")
      (52 55 "form"))
     ("                usual reason for  loading a  file is  to declare  variables,"
      (45 48 "file")
      (66 73 "variable"))
     ("                functions, flavors, and  so on.   The best  way to  load any"
      (16 23 "function")
      (27 32 "flavor"))
     ("                type of file is with the function load, which loads the file"
      (24 27 "file")
      (41 48 "function"))
     ("                according to the file type (character or binary).  "
      (33 41 "file type")
      (44 52 "character"))
     ("                  ")
     ("")))
   ("load partition"
    (("                A disk  partition  that  contains  the  initial  environment"
      (24 32 "partition")
      (65 75 "environment"))
     ("                loaded  when  you  cold  boot  the  system.  Also called the"
      (16 19 "load")
      (35 44 "cold boot")
      (52 57 "system"))
     ("                system partition, system band, or world load.  "
      (16 21 "system")
      (23 31 "partition")
      (41 44 "band")
      (56 59 "load"))
     ("                  ")
     ("")))
   ("local area network"
    (("                A number of computer systems  connected  to  a  common  data"
      (18 23 "number")
      (37 42 "system"))
     ("                link; usually confined to a small area, such as an office or"
      (50 53 "area"))
     ("                building.  ")
     ("  ")
     ("")))
   ("local bus"
    (("                A  high-speed, 32-bit backplane bus for exclusive use of one"
      (38 46 "backplane")
      (48 50 "bus"))
     ("                processor.  The Explorer processor uses the  local  bus  for"
      (68 70 "bus"))
     ("                access  to  main memory and the graphics bit map.  The local"
      (28 38 "main memory")
      (57 63 "bit map"))
     ("                bus provides a high processor-to-memory bandwidth and leaves"
      (16 18 "bus"))
     ("                the NuBus device available for system-wide operations.   Use"
      (20 31 "NuBus device")
      (47 52 "system"))
     ("                of the local bus is transparent to the software.  "
      (29 31 "bus"))
     ("  ")
     ("")))
   ("local machine"
    (("                The  system  you  are  currently  working  on  as opposed to"
      (21 26 "system"))
     ("                another system on the network.  The local machine is usually"
      (24 29 "system")
      (38 44 "network"))
     ("                abbreviated as lm in pathnames.  " (31 32 "lm")
                                                          (37 44 "pathname"))
     ("                  ")
     ("")))
   ("local pervasive declaration"
    (("                A local declaration that affects all code of a special form."
      (24 34 "declaration")
      (63 74 "special form"))
     ("  ")
     ("")))
   ("locative"
    (("                A low-level type of Lisp object  used  as  a  pointer  to  a"
      (36 46 "Lisp object")
      (62 68 "pointer"))
     ("                memory location.  ")
     ("  ")
     ("")))
   ("loop macro"
    (("                A  programmable  iteration  facility  that  consists of some")
     ("                initialization code, a body that can be executed a number of"
      (67 72 "number"))
     ("                times, and some exit code.   Each  loop  macro  consists  of"
      (57 61 "macro"))
     ("                clauses;  you  can  choose and combine predefined clauses to")
     ("                specify the iteration path. ")
     ("")))
   ("macro"
    (("                A form that is converted into a different (usually,  a  more"
      (18 21 "form"))
     ("                complex  or  more  internally  efficient)  form before it is"
      (59 62 "form"))
     ("                evaluated or compiled.  Macros give Lisp more versatility by"
      (29 35 "compile")
      (52 55 "Lisp"))
     ("                allowing you to write code in a form more suitable  to  your"
      (48 51 "form"))
     ("                application.  " (16 26 "application"))
     ("  ")
     ("                The  notation  ==>  is  used  in  examples to indicate macro")
     ("                expansion.  ")
     ("  ")
     ("")))
   ("macro call"
    (("                A list form that is similar to a function call  except  that"
      (18 21 "list")
      (23 26 "form")
      (49 61 "function call"))
     ("                it invokes a defined macro rather than a function.  "
      (37 41 "macro")
      (57 64 "function"))
     ("  ")
     ("")))
   ("macro definition"
    (("                A  procedure  that  creates  a  new  macro  and  defines its"
      (53 57 "macro"))
     ("                actions.  ")
     ("  ")
     ("")))
   ("macrocode"
    (("                The actual  machine  code.   If  the  Explorer system had an"
      (63 68 "system"))
     ("                assembler, it would produce macrocode.  ")
     ("  ")
     ("")))
   ("Mail"
    (("                An  interactive facility for sending and receiving mail over")
     ("                the network and for managing your mail files.  "
      (20 26 "network")
      (55 58 "file"))
     ("                  ")
     ("")))
   ("main memory"
    (("                The physical address space  located on the  memory board(s).")
     ("                Main  memory  is  the  primary  store  in  Explorer system's")
     ("                virtual memory.  ")
     ("  ")
     ("")))
   ("main screen"
    (("                The portion of the physical display area excluding the mouse"
      (52 55 "area")
      (71 75 "mouse"))
     ("                documentation window and the  status line.  The  main screen"
      (30 35 "window")
      (46 56 "status line")
      (70 75 "screen"))
     ("                is used for displaying the  windows of active processes  you"
      (44 49 "window")
      (55 68 "active process"))
     ("                invoke.  ")
     ("                  ")
     ("                ")
     ("")))
   ("major mode"
    (("                See Zmacs major mode.  " (20 35 "Zmacs major mode"))
     ("  ")
     ("")))
   ("major version number"
    (("                See version number.  " (20 33 "version number"))
     ("  ")
     ("")))
   ("map partition"
    (("                A disk partition that lists all media defects on the disk.  "
      (23 31 "partition")
      (38 41 "list"))
     ("  ")
     ("")))
   ("mapping"
    (("                A type of iteration in  which  a  function  is  successively"
      (50 57 "function"))
     ("                applied  to  elements of a list or a sequence.  Examples are"
      (29 35 "element")
      (43 46 "list")
      (53 60 "sequence"))
     ("                mapcar and mapcon.   Mapping  functions  provide  a  control"
      (46 53 "function"))
     ("                structure for applying a function to every element in a list"
      (16 24 "structure")
      (41 48 "function")
      (59 65 "element")
      (72 75 "list"))
     ("                and accumulating the results.  ")
     ("  ")
     ("")))
   ("MAR"
    (("                Memory Address Register, which provides the ability to  trap"
      (31 38 "register")
      (72 75 "trap"))
     ("                on any reference to  a word (or  a set of  words) in memory."
      (39 42 "word")
      (51 53 "set"))
     ("                If something is  being written  to by  unknown agents,  this")
     ("                facility can  help  track  down  the  source of the unwanted")
     ("                input.")
     ("  ")
     ("")))
   ("margin"
    (("                The  part  of a window that is not the inside.  A window has"
      (32 37 "window"))
     ("                four margins, one for each edge.  The inside and the margins")
     ("                of the window are kept separate.  I//O can only  be  done  to"
      (23 28 "window"))
     ("                the inside.  ")
     ("  ")
     ("")))
   ("margin choice"
    (("                A  facility  that  allows  choice  boxes to be placed in the"
      (43 53 "choice box")
      (63 67 "place"))
     ("                bottom margin of a window.  This allows certain  choices  to"
      (23 28 "margin")
      (35 40 "window"))
     ("                be independent of anything else in the window.  "
      (55 60 "window"))
     ("  ")
     ("")))
   ("margin item"
    (("                A  component  of  a window that is contained within a margin"
      (36 41 "window")
      (70 75 "margin"))
     ("                (for example, a border, a label, or a scroll bar).  "
      (32 37 "border")
      (42 46 "label")
      (54 63 "scroll bar"))
     ("  ")
     ("")))
   ("mark"
    (("                1.  To highlight (usually by underlining) a block of text by")
     ("                setting the two buffer pointers in Zmacs (that is, point and"
      (32 37 "buffer")
      (39 45 "pointer")
      (51 55 "Zmacs")
      (67 71 "point"))
     ("                mark) at either end of the block  of  text.   You  can  then")
     ("                manipulate the block of text as one unit.  You can mark text")
     ("                of  any  size.  The marked text is called a region.  Some of"
      (60 65 "region"))
     ("                the uses for marking text are as follows:  ")
     ("  ")
     ("                *  To put the region on the kill history  by  killing  or"
      (30 35 "region")
      (44 55 "kill history"))
     ("                   saving it ")
     ("  ")
     ("                *  To evaluate or compile the region " (34 40
                                                                  "compile")
                                                              (46 51
                                                                  "region"))
     ("  ")
     ("                *  To change the font of the region " (33 36 "font")
                                                             (45 50
                                                                 "region"))
     ("  ")
     ("                2.   A buffer pointer in Zmacs used to specify one edge of a"
      (23 28 "buffer")
      (30 36 "pointer")
      (41 45 "Zmacs"))
     ("                region.  (The other edge is specified by point, which is the"
      (16 21 "region")
      (57 61 "point"))
     ("                left edge of the keyboard cursor.)  "
      (33 47 "keyboard cursor"))
     ("  ")
     ("")))
   ("mass storage controller"
    (("                A  logic  board  installed  in  the  system  enclosure  that"
      (53 69 "system enclosure"))
     ("                provides an interface between the NuBus device and the small"
      (50 61 "NuBus device"))
     ("                computer  systems  interface (SCSI) bus for all mass storage"
      (26 31 "system")
      (52 54 "bus"))
     ("                devices.  ")
     ("  ")
     ("")))
   ("mass storage enclosure"
    (("                A compact enclosure that houses two  storage  devices;  this")
     ("                can  be any combination of Winchester disks and tape drives.")
     ("                (This is commonly called a data brick.)  "
      (43 52 "data brick"))
     ("  ")
     ("")))
   ("mass storage subsystem"
    (("                The set  of  hardware  components  that  provides  permanent"
      (20 22 "set"))
     ("                storage  for  programs  and data.  The subsystem consists of")
     ("                the mass storage  controller,  the  small  computer  systems"
      (20 43 "mass storage controller")
      (69 74 "system"))
     ("                interface  (SCSI)  bus  and  cables,  and  the  mass storage"
      (35 37 "bus"))
     ("                enclosures.  ")
     ("  ")
     ("")))
   ("menu"
    (("                A window that presents a set of items  from  which  you  can"
      (18 23 "window")
      (41 43 "set"))
     ("                select  various  choices  using  the mouse.  A menu can be a"
      (16 21 "select")
      (53 57 "mouse"))
     ("                permanent pane in a window, or it can be a temporary window."
      (26 29 "pane")
      (36 41 "window")
      (59 74 "temporary window"))
     ("  ")
     ("")))
   ("menu boot"
    (("                The invoking of a series of menus that allow you to  specify"
      (44 47 "menu"))
     ("                the  device,  load  band,  and microload band from which the"
      (30 33 "load")
      (36 39 "band"))
     ("                system boots.  You execute a menu boot when  you  press  the"
      (16 21 "system")
      (23 26 "boot")
      (45 48 "menu"))
     ("                keystroke  sequence  META-CTRL-META-CTRL-M.  See also"
      (16 34 "keystroke sequence"))
     ("                system reset, cold boot, and warm boot.  "
      (16 27 "system reset")
      (30 38 "cold boot")
      (45 53 "warm boot"))
     ("")))
   ("menu geometry"
    (("                The way in which a menu is displayed  as  described  by  six"
      (35 38 "menu"))
     ("                parameters:   the number of columns, the number of rows, the"
      (34 39 "number"))
     ("                inside width in pixels, the inside  height  in  pixels,  the"
      (32 36 "pixel"))
     ("                maximum  width  in pixels, and the maximum height in pixels."
      (35 39 "pixel"))
     ("                Each parameter can be specified as a constraint  or  can  be"
      (21 29 "parameter"))
     ("                allowed  to  default  based  on  the  menu item list and the"
      (54 67 "menu item list"))
     ("                parameters that are constrained.  " (16 24
                                                               "parameter"))
     ("  ")
     ("")))
   ("menu item list"
    (("                A list  of  the  items  contained  in  a  menu.   Each  item"
      (18 21 "list")
      (58 61 "menu"))
     ("                represents  one of the choices offered and specifies what to")
     ("                display in the menu and what operation to perform when  that"
      (31 34 "menu"))
     ("                item is selected.  " (24 29 "select"))
     ("  ")
     ("")))
   ("merging of pathnames"
    (("                The operation that takes as input a pathname, an association"
      (52 59 "pathname"))
     ("                list  of defaults (or another pathname), a default type, and"
      (16 19 "list")
      (46 53 "pathname"))
     ("                a default version, and returns a pathname.   Basically,  the"
      (49 56 "pathname"))
     ("                missing  components  in  the pathname are filled in from the"
      (45 52 "pathname")
      (58 61 "fill"))
     ("                association  list  of  defaults.   However,  if  a  name  is"
      (16 32 "association list"))
     ("                specified  but  the type or version is not, then the type or")
     ("                version is treated specially.  ")
     ("  ")
     ("")))
   ("message"
    (("                In the flavor system, a call  to perform an operation on  an"
      (23 28 "flavor")
      (30 35 "system"))
     ("                object and return a value.  The message consists of the name"
      (16 21 "object"))
     ("                of the  object  and  the  operation  to  be  performed  (and"
      (24 29 "object"))
     ("                arguments).  The  operation  is  handled  by the appropriate"
      (16 23 "argument"))
     ("                method attached to  the flavor  of which  that object  is an"
      (16 21 "method")
      (40 45 "flavor")
      (63 68 "object"))
     ("                instance.  " (16 23 "instance"))
     ("                  ")
     ("                ")
     ("")))
   ("META key" (("                See modifier keys.  " (20 32
                                                            "modifier keys"))
                ("  ")
                ("")))
   ("metering"
    (("                A facility that monitors your  program so that you  can find")
     ("                out which  parts  use  the  most  time.   When  you run your")
     ("                program with metering, the system records each function call"
      (43 48 "system")
      (63 75 "function call"))
     ("                and it's return,  along with  the time  each occurred.  Page"
      (72 75 "page"))
     ("                faults are also recorded.  ")
     ("")))
   ("metering partition"
    (("                A disk partition  named METR  that contains  the information"
      (23 31 "partition"))
     ("                generated by metering.  " (29 36 "metering"))
     ("                  ")
     ("")))
   ("method"
    (("                A function that is attached to a flavor to define a  generic"
      (18 25 "function")
      (49 54 "flavor"))
     ("                operation that  can  be  performed  on  any  object  of that"
      (61 66 "object"))
     ("                flavor.  The method handles the operation named in a message"
      (16 21 "flavor")
      (69 75 "message"))
     ("                sent to the object.  " (28 33 "object"))
     ("  ")
     ("")))
   ("microcode"
    (("                Machine instructions that  implement  the  Explorer  system."
      (69 74 "system"))
     ("                Microcode is contained in the microload partition.  "
      (46 64 "microload partition"))
     ("                  ")
     ("                ")
     ("")))
   ("microload partition"
    (("                A disk  partition  containing  the  microcode that is loaded"
      (24 32 "partition")
      (52 60 "microcode")
      (70 73 "load"))
     ("                when you cold boot the system.  " (25 33 "cold boot")
                                                         (39 44 "system"))
     ("  ")
     ("")))
   ("MIDDLE key"
    (("                See mouse keys.  " (20 29 "mouse keys")) ("  ") ("")))
   ("minibuffer"
    (("                See Zmacs minibuffer.  " (20 35 "Zmacs minibuffer"))
     ("  ")
     ("")))
   ("minor mode"
    (("                See Zmacs minor mode.  " (20 35 "Zmacs minor mode"))
     ("  ")
     ("")))
   ("minor version number"
    (("                See version number.  " (20 33 "version number"))
     ("  ")
     ("")))
   ("mixin flavor"
    (("                A flavor that defines one feature or  characteristic  of  an"
      (18 23 "flavor"))
     ("                object.  (Often called simply a mixin.)  Mixins usually must"
      (16 21 "object"))
     ("                be  combined  with  a base flavor to be complete.  Normally,"
      (38 48 "base flavor"))
     ("                mixins are used to slightly alter a base flavor by  changing"
      (52 62 "base flavor"))
     ("                or adding methods.  " (26 31 "method"))
     ("  ")
     ("")))
   ("mode keys"
    (("                Keys that put the keyboard into a specific mode of operation")
     ("                when locked.  The mode keys are locked electronically rather")
     ("                than mechanically; a small LED on the keycap lights up  when")
     ("                the key is locked.  The following are the mode keys:")
     ("  ")
     ("                *  BOLD LOCK -- Reserved for future use.  ")
     ("  ")
     ("                *  CAPS LOCK -- Produces uppercase letters for the letter")
     ("                   keys.  ")
     ("  ")
     ("                *  ITAL LOCK -- Reserved for future use.  ")
     ("  ")
     ("                *  MODE  LOCK -- Enables the cursor pad to move the mouse"
      (45 54 "cursor pad")
      (68 72 "mouse"))
     ("                   cursor.  ")
     ("  ")
     ("")))
   ("mode line"
    (("                A  line  in  a  Zmacs  window,  appearing  just  above   the"
      (32 36 "Zmacs")
      (39 44 "window"))
     ("                minibuffer,  that  contains  information about the major and"
      (16 25 "minibuffer"))
     ("                minor modes in effect, the  name  of  the  buffer,  and  the"
      (16 25 "minor mode")
      (59 64 "buffer"))
     ("                status of the buffer.  " (30 35 "buffer"))
     ("  ")
     ("")))
   ("MODE LOCK key"
    (("                See mode keys.  " (20 28 "mode keys")) ("  ") ("")))
   ("modifier keys"
    (("                A  set of keys used in combination with other keys to modify"
      (19 21 "set"))
     ("                their behavior and invoke a variety of  commands.   Modifier")
     ("                keys  do  not  themselves transmit characters.  The modifier"
      (51 59 "character"))
     ("                keys are HYPER, SUPER, META, CTRL, and SYMBOL.  "
      (55 60 "symbol"))
     ("  ")
     ("                HYPER, SUPER, META, and CTRL are generally  used  to  invoke")
     ("                commands.   SYMBOL  is  used  with  letters  or  with  other"
      (28 33 "symbol"))
     ("                modifier keys to produce alternate  character  sets.   SHIFT"
      (52 60 "character")
      (63 65 "set"))
     ("                produces  uppercase  letters  and  is  also  used with other")
     ("                modifier keys to invoke commands.  ")
     ("  ")
     ("")))
   ("module"
    (("                A software subsystem that is loaded from one or  more  files"
      (45 48 "load")
      (71 74 "file"))
     ("                and that can contain one or more packages.  "
      (49 55 "package"))
     ("  ")
     ("")))
   ("more processing"
    (("                Output exception processing  that  allows  a  programmer  to"
      (33 39 "process"))
     ("                specify  what  happens  when  typeout  to  a window would go"
      (61 66 "window"))
     ("                beyond the bottom or edge of the window.  "
      (49 54 "window"))
     ("  ")
     ("")))
   ("mouse"
    (("                A hand-held pointing  device that  when moved  across a flat"
      (28 32 "point"))
     ("                surface causes movement of a special pointer (mouse  cursor)"
      (53 59 "pointer"))
     ("                on the  display.   The  mouse  on  the Explorer system is an"
      (64 69 "system"))
     ("                optical mouse.  The mouse has  three buttons that can  cause")
     ("                operations to be performed when pressed.  ")
     ("                  ")
     ("")))
   ("mouse buttons"
    (("                A  set  of  buttons on the mouse that cause operations to be"
      (19 21 "set")
      (43 47 "mouse"))
     ("                performed when pressed.  The operation is performed  on  the")
     ("                item the mouse cursor is positioned over.  "
      (25 36 "mouse cursor"))
     ("  ")
     ("")))
   ("mouse click" (("                See click.  " (20 24 "click")) ("  ")
                                                                    ("")))
   ("mouse cursor"
    (("                A blinker on  the display  that is  positioned by  using the"
      (18 24 "blinker"))
     ("                mouse.  The mouse cursor is usually in the shape of an arrow"
      (16 20 "mouse"))
     ("                outside a menu or the shape of  a thin x inside a menu,  but"
      (26 29 "menu"))
     ("                it can change shape  to indicate the  type of operation  for")
     ("                which the mouse is currently being used."
      (26 30 "mouse"))
     ("  ")
     ("")))
   ("mouse documentation window"
    (("                One or more lines (two in reverse video,  by  default)  that"
      (42 54 "reverse video"))
     ("                appear  just  above  the  status line near the bottom of the"
      (42 52 "status line"))
     ("                display.   The  mouse  documentation  window describes   the"
      (32 36 "mouse")
      (54 59 "window"))
     ("                currently available  mouse  operations  or gives information"
      (37 41 "mouse"))
     ("                about the item to which the mouse cursor is pointing.   Also"
      (44 55 "mouse cursor")
      (60 64 "point"))
     ("                called the mouse doc-line. " (27 31 "mouse"))
     ("                  ")
     ("                ")
     ("")))
   ("mouse keys"
    (("                A set of keys (LEFT, MIDDLE, and RIGHT) on the keyboard that"
      (18 20 "set"))
     ("                perform the same functions as the mouse buttons.  "
      (33 40 "function")
      (50 62 "mouse buttons"))
     ("  ")
     ("")))
   ("mouse pad"
    (("                A special  surface  used  with  some  optical mice to detect")
     ("                movement.  For proper  results, place  the mouse  pad in the"
      (48 52 "place")
      (59 63 "mouse")
      (66 68 "pad"))
     ("                same orientation (landscape) as the display.  ")
     ("                  ")
     ("")))
   ("mouse process"
    (("                The process that  tracks  the  position  of  the  mouse  and"
      (20 26 "process")
      (66 70 "mouse"))
     ("                handles input from the mouse buttons.  "
      (39 51 "mouse buttons"))
     ("  ")
     ("")))
   ("mouse-sensitive item"
    (("                An  item in a menu or window that is highlighted in some way"
      (30 33 "menu")
      (38 43 "window"))
     ("                (usually boxed) when you point to it with the mouse  cursor."
      (25 27 "box")
      (41 45 "point")
      (62 74 "mouse cursor"))
     ("                You can then perform operations on a mouse-sensitive item by"
      (53 57 "mouse"))
     ("                clicking one of the mouse buttons.  "
      (16 20 "click")
      (36 48 "mouse buttons"))
     ("  ")
     ("")))
   ("multiple returned value"
    (("                More than one value returned by a function.  "
      (50 57 "function"))
     ("  ")
     ("")))
   ("multiple values"
    (("                A Lisp facility that enables an evaluated form to produce or"
      (18 21 "Lisp")
      (58 61 "form"))
     ("                return more than one value.  ")
     ("  ")
     ("")))
   ("multiple-choice menu"
    (("                A  menu that displays a series of items, one per line, along"
      (19 22 "menu"))
     ("                with a set of choice boxes for each item.  The set of choice"
      (23 25 "set")
      (30 39 "choice box"))
     ("                boxes is the same for all items.  You can select yes  or  no"
      (16 18 "box")
      (58 63 "select"))
     ("                for each choice by clicking the mouse within the choice box."
      (35 39 "click")
      (48 52 "mouse")
      (65 74 "choice box"))
     ("  ")
     ("")))
   ("multiple-item menu"
    (("                A  menu  that  allows you to select any combination of items"
      (19 22 "menu")
      (45 50 "select"))
     ("                rather than a single item.  After you select the items,  you"
      (54 59 "select"))
     ("                need  to  select  another  item  to  perform  the  specified"
      (26 31 "select"))
     ("                operations, such as the Do It item. ")
     ("")))
   ("name conflict"
    (("                A problem that occurs when a symbol  is  used  to  name  two"
      (45 50 "symbol"))
     ("                different  objects.   The  package system helps prevent name"
      (27 32 "object")
      (43 56 "package system"))
     ("                conflicts.  ")
     ("  ")
     ("")))
   ("name server"
    (("                A host that serves a namespace.   That is, a name server  is"
      (18 21 "host")
      (37 45 "namespace")
      (66 71 "server"))
     ("                responsible for accepting updates and responding to requests")
     ("                for information contained in the namespace."
      (49 57 "namespace"))
     ("")))
   ("named structure"
    (("                An aggregated user-defined data type that is created by  the"
      (43 51 "data type"))
     ("                defstruct macro and is named.  "
      (16 30 "defstruct macro"))
     ("  ")
     ("")))
   ("namespace"
    (("                A database composed of objects  that are identified by  name"
      (39 44 "object"))
     ("                and class  within  the  namespace.   These  objects can have"
      (60 65 "object"))
     ("                arbitrary attributes (or  properties) attached  to them.   A")
     ("                namespace is  used  on  the  Explorer  system  to define the"
      (55 60 "system"))
     ("                network configuration.  Explorer namespaces can be  used for"
      (16 22 "network"))
     ("                other purposes as well.")
     ("                ")
     ("")))
   ("namespace editor"
    (("                A screen-oriented editor used to view and//or modify  objects"
      (18 23 "screen")
      (49 52 "view")
      (69 74 "object"))
     ("                within a namespace." (25 33 "namespace"))
     ("")))
   ("namespace search list"
    (("                A list of namespaces used as ordered defaults for looking up"
      (18 21 "list")
      (26 34 "namespace"))
     ("                names when a particular namespace is not specified."
      (40 48 "namespace"))
     ("")))
   ("Natural Language Menu System"
    (("                An optional set of tools for building a menu-driven, natural"
      (28 30 "set")
      (56 59 "menu"))
     ("                language  interface  to  your applications.  NLMenu presents"
      (46 56 "application")
      (61 66 "NLMenu"))
     ("                users with a set of windows and menus  containing  words  or"
      (29 31 "set")
      (36 41 "window")
      (48 51 "menu")
      (67 70 "word"))
     ("                phrases  in  English (or some other natural language).  From")
     ("                these, the user selects the appropriate items  to  construct"
      (32 37 "select"))
     ("                input  sentences,  such  as  queries  to a database.  NLMenu"
      (70 75 "NLMenu"))
     ("                controls each step of the  selection,  allowing  only  valid")
     ("                sentences  to  be  constructed.   NLMenu  includes tools for"
      (50 55 "NLMenu"))
     ("                building the lexicon, grammar, and screen  formats  required"
      (51 56 "screen"))
     ("                for each specific application.  " (34 44
                                                             "application"))
     ("  ")
     ("")))
   ("network"
    (("                A complex that consists of two or more interconnected hosts."
      (70 73 "host"))
     ("  ")
     ("")))
   ("NETWORK key"
    (("                See information and status keys.  "
      (20 46 "information and status keys"))
     ("  ")
     ("")))
   ("nil"
    (("                A  symbol that represents the empty list and a logical false"
      (19 24 "symbol")
      (46 55 "empty list"))
     ("                value.  The notation () is an alternate  representation  for")
     ("                the  symbol  nil.   By  convention,  () is used to denote an"
      (21 26 "symbol"))
     ("                empty list, and nil is used to denote a false value.  "
      (16 25 "empty list"))
     ("  ")
     ("")))
   ("NLMenu"
    (("                See Natural Language Menu System.  "
      (20 47 "Natural Language Menu System"))
     ("  ")
     ("")))
   ("nonlocal exit"
    (("                A facility for exiting a  complex  process  in  a  nonlocal,"
      (51 57 "process"))
     ("                dynamically  scoped  manner.   This  facility uses catch and"
      (29 33 "scope")
      (67 71 "catch"))
     ("                throw forms, allowing you to backtrack in a search operation"
      (16 20 "throw")
      (22 25 "form"))
     ("                or recover from errors.  ")
     ("  ")
     ("")))
   ("nonlocal variable"
    (("                See free variable.  " (20 32 "free variable")) ("  ")
                                                                      ("")))
   ("nonpervasive declaration"
    (("                A declaration that does not affect all the code of a special"
      (18 28 "declaration"))
     ("                form except when the code is defined to be within the  scope"
      (16 19 "form")
      (71 75 "scope"))
     ("                of the variables affected by the declaration.  "
      (23 30 "variable")
      (49 59 "declaration"))
     ("  ")
     ("")))
   ("normal video"
    (("                A display state in which black  images are shown on a  white")
     ("                background  (negative  contrast  or  positive  image).    By")
     ("                default, most windows appear  in normal video  (an exception"
      (30 35 "window"))
     ("                is the mouse documentation window).  You can toggle  between"
      (23 48 "mouse documentation window")
      (61 66 "toggle"))
     ("                normal and reverse video by  changing the value of  a system"
      (27 39 "reverse video")
      (70 75 "system"))
     ("                variable." (16 23 "variable"))
     ("  ")
     ("")))
   ("notification window"
    (("                A  temporary  window that notifies you of an error or action"
      (19 35 "temporary window"))
     ("                taken by  some  process  other  than  the  process  for  the"
      (32 38 "process"))
     ("                currently selected window.  " (26 40
                                                         "selected window"))
     ("  ")
     ("")))
   ("notifications"
    (("                A   facility   that   displays   messages  that  take  place"
      (49 55 "message")
      (71 75 "place"))
     ("                asynchronously and are not related to  the  process  in  the"
      (60 66 "process"))
     ("                currently  selected  window  (for  example,  file  and print"
      (27 42 "selected window")
      (61 64 "file"))
     ("                servers).  Notifications work through  the  process  in  the"
      (16 21 "server")
      (60 66 "process"))
     ("                selected  window;  each  window  can  display a notification"
      (16 31 "selected window"))
     ("                differently.  ")
     ("  ")
     ("")))
   ("NuBus device"
    (("                The backplane bus on which the Explorer system  architecture"
      (20 28 "backplane")
      (30 32 "bus")
      (56 61 "system"))
     ("                is  based.   The  NuBus  device  is a processor-independent,")
     ("                high-speed, asynchronous bus that  multiplexes  32-bit  data"
      (41 43 "bus"))
     ("                words  with  32-bit  address  codes  and uses a master//slave"
      (16 19 "word"))
     ("                communications protocol.  ")
     ("  ")
     ("                NuBus is a trademark of Texas Instruments Incorporated.  ")
     ("  ")
     ("")))
   ("number" (("                See number object.  " (20 32
                                                          "number object"))
              ("  ")
              ("")))
   ("number object"
    (("                A data object in Lisp that represents rational,  irrational,"
      (23 28 "object")
      (33 36 "Lisp"))
     ("                or complex numbers.  The different types of numbers  require"
      (19 33 "complex numbers"))
     ("                different data objects.  " (31 36 "object"))
     ("  ")
     ("")))
   ("number pad"
    (("                A set of keys that includes numeric  digits  and  characters"
      (18 20 "set")
      (66 74 "character"))
     ("                for   entering   arithmetic  expressions,  as  well  as  the")
     ("                following:  ")
     ("  ")
     ("                *  ENTER -- Currently not used, but can be programmed for")
     ("                   use in application software.  " (26 36
                                                              "application"))
     ("  ")
     ("                *  SPACE -- Performs the same function as the space bar. "
      (46 53 "function")
      (68 70 "bar"))
     ("  ")
     ("                *  TAB -- Performs the same function as the  TAB  key  on"
      (44 51 "function")
      (61 68 "TAB key"))
     ("                   the main part of the keyboard.  ")
     ("  ")
     ("")))
   ("numeric argument"
    (("                An argument  that  you  can  give  to  many  Zmacs commands,"
      (19 26 "argument")
      (61 65 "Zmacs"))
     ("                usually designating a repeat count (the number of times  you"
      (56 61 "number"))
     ("                want the command executed).  ")
     ("                ")
     ("")))
   ("object"
    (("                1.  Any element of the Lisp language.  See also Lisp object."
      (24 30 "element")
      (39 42 "Lisp")
      (64 74 "Lisp object"))
     ("  ")
     ("                2.  In the flavor system, a specific instance of a flavor.  "
      (27 32 "flavor")
      (34 39 "system")
      (53 60 "instance"))
     ("  ")
     ("")))
   ("one-origin indexing"
    (("                A type  of  indexing  for  arrays  or sequences in which the"
      (43 47 "array")
      (54 61 "sequence"))
     ("                first  index  starts   with  1.    All  Explorer   code uses"
      (16 20 "first"))
     ("                zero-origin indexing.  " (16 35
                                                    "zero-origin indexing"))
     ("  ")
     ("")))
   ("open-coded subroutine"
    (("                See inline subroutine.  " (20 36 "inline subroutine"))
     ("  ")
     ("")))
   ("optional parameter"
    (("                A parameter that does not require a  corresponding  argument"
      (18 26 "parameter")
      (68 75 "argument"))
     ("                value  in  the  call  in  order  for the function to execute"
      (57 64 "function"))
     ("                correctly.  The lambda-list keyword  &optional  is  used  to"
      (32 50 "lambda-list keyword"))
     ("                indicate the optional parameters in a function.  "
      (38 46 "parameter")
      (54 61 "function"))
     ("  ")
     ("")))
   ("ordinary list" (("                See list.  " (20 23 "list")) ("  ")
                                                                    ("")))
   ("output history"
    (("                A buffer that stores the returned values of forms entered in"
      (18 23 "buffer")
      (60 63 "form"))
     ("                a Lisp Listener window.  See also history.  "
      (18 30 "Lisp Listener")
      (32 37 "window")
      (50 56 "history"))
     ("  ")
     ("")))
   ("over-rubout"
    (("                A  condition  that occurs when you press the RUBOUT key more"
      (19 27 "condition")
      (61 70 "RUBOUT key"))
     ("                times than necessary to rub out all  the  characters  in  the"
      (58 66 "character"))
     ("                window's input buffer.  Also called full-rubout.  "
      (31 36 "buffer")
      (52 62 "full-rubout"))
     ("  ")
     ("")))
   ("owning the mouse"
    (("                A  term  descriptive  of  the window that handles the mouse."
      (46 51 "window")
      (70 74 "mouse"))
     ("                This is usually the window in which the mouse is positioned."
      (36 41 "window")
      (56 60 "mouse"))
     ("                The window that owns the mouse is the one that receives  the"
      (20 25 "window")
      (41 45 "mouse"))
     ("                :handle-mouse, :mouse-moves, and :mouse-click messages."
      (62 68 "message"))
     ("")))
   ("P1, P2, P3 connectors"
    (("                The  set  of connectors on the system logic boards that plug"
      (21 23 "set")
      (47 52 "system"))
     ("                into the backplane.  The P1 connectors plug into the top row"
      (25 33 "backplane"))
     ("                of the backplane and provide NuBus  device  signals  on  all"
      (23 31 "backplane")
      (45 57 "NuBus device"))
     ("                boards.   The P2 connectors plug into the center row and are")
     ("                used for local bus access on some boards and  are  available"
      (25 33 "local bus"))
     ("                for  general  I//O  on  other boards.  The P3 connectors plug")
     ("                into the bottom row and are used for general I//O.  ")
     ("")))
   ("package"
    (("                A  collection  of  symbols  that serves as a namespace.  See"
      (35 40 "symbol")
      (61 69 "namespace"))
     ("                also package system.  " (21 34 "package system"))
     ("  ")
     ("")))
   ("package cell"
    (("                A component of a  symbol  that  contains  the  name  of  the"
      (34 39 "symbol"))
     ("                symbol's home package.  " (25 36 "home package"))
     ("  ")
     ("")))
   ("package name"
    (("                A string that serves as a name for a particular package.  "
      (18 23 "string")
      (64 70 "package"))
     ("  ")
     ("")))
   ("package nickname"
    (("                A shortened or alternate package name.  "
      (41 52 "package name"))
     ("  ")
     ("")))
   ("package qualifier"
    (("                A prefix  to  a  symbol  or  object  that specifies that the"
      (33 38 "symbol")
      (45 50 "object"))
     ("                symbol or object belongs to a package other than the current"
      (16 21 "symbol")
      (26 31 "object")
      (46 52 "package"))
     ("                package.  The package qualifier consists of the name of  the"
      (16 22 "package"))
     ("                symbol's home  package  and  a  colon.   For example, user:x"
      (25 37 "home package"))
     ("                indicates that the symbol x is in the USER package.  "
      (35 40 "symbol")
      (59 65 "package"))
     ("                  ")
     ("                ")
     ("")))
   ("package system"
    (("                A facility that  establishes a  mapping from  print names to"
      (48 54 "mapping")
      (62 71 "print name"))
     ("                symbols and helps prevent namespace conflicts.  The  package"
      (16 21 "symbol")
      (42 50 "namespace")
      (69 75 "package"))
     ("                system allows different  programs to  use the  same name for"
      (16 21 "system"))
     ("                objects so that the programs and objects can coexist in  the"
      (16 21 "object"))
     ("                same environment.  The different  programs can be  placed in"
      (21 31 "environment")
      (67 71 "place"))
     ("                separate  packages.    Each   package   provides  a separate"
      (26 32 "package"))
     ("                namespace for all  the symbols  used in  the programs within"
      (16 24 "namespace")
      (39 44 "symbol"))
     ("                that  package.   However,  you   can  access  symbols   from"
      (22 28 "package")
      (62 67 "symbol"))
     ("                different packages using package qualifiers.  "
      (26 32 "package")
      (41 57 "package qualifier"))
     ("  ")
     ("")))
   ("packet"
    (("                The basic unit of data that is transmitted over the network."
      (68 74 "network"))
     ("  ")
     ("")))
   ("pad" (("                See mouse pad.  " (20 28 "mouse pad")) ("  ")
                                                                    ("")))
   ("page"
    (("                1.  A  unit  of  storage  for  programs  and  data  used  to")
     ("                implement virtual memory.  On the Explorer system, each page"
      (59 64 "system"))
     ("                consists of 1K bytes.  ")
     ("  ")
     ("                2.  In Zmacs, text separated by the page character, which is"
      (23 27 "Zmacs")
      (57 65 "character"))
     ("                produced by pressing CTRL-Q CLEAR SCREEN.  "
      (50 55 "screen"))
     ("  ")
     ("")))
   ("page band"
    (("                A group of one or more  page partitions.  If more memory  is"
      (40 53 "page partition"))
     ("                required than is  physically present,  pages are  moved from"
      (55 58 "page"))
     ("                physical  memory  to  the  page  band,  thus  making   space"
      (43 46 "page")
      (49 52 "band"))
     ("                available in physical memory.  ")
     ("                ")
     ("")))
   ("page partition"
    (("                A disk partition that is used to implement address space for"
      (23 31 "partition"))
     ("                virtual  memory.   ")
     ("                  ")
     ("")))
   ("pairwise comparison"
    (("                A type of comparison in which elements are compared based on"
      (46 52 "element"))
     ("                their positions  in  a  sequence.   For  example,  the first"
      (40 47 "sequence")
      (71 75 "first"))
     ("                element of  one  sequence  is  compared  only with the first"
      (16 22 "element")
      (33 40 "sequence")
      (71 75 "first"))
     ("                element of another sequence.  " (16 22 "element")
                                                       (35 42 "sequence"))
     ("  ")
     ("")))
   ("pan"
    (("                Panning moves a  window in  relation to  the objects  in the"
      (33 38 "window")
      (61 66 "object"))
     ("                current graphics  editor  buffer,  but  does  not change the"
      (24 39 "graphics editor")
      (42 47 "buffer"))
     ("                apparent scale  of  the  objects  that  are  displayed.  For"
      (41 46 "object"))
     ("                example, panning left shows the graphics objects that are to"
      (48 62 "graphics object"))
     ("                the left of the current window.  " (40 45 "window"))
     ("  ")
     ("")))
   ("pane"
    (("                A subdivision of a window; an inferior window.  A collection"
      (35 40 "window")
      (46 60 "inferior window"))
     ("                of panes comprises a frame, which can then be manipulated as"
      (19 21 "pan")
      (37 41 "frame"))
     ("                a single window.  " (25 30 "window"))
     ("  ")
     ("")))
   ("parameter"
    (("                A  variable  named  in  a  function's lambda list.  When the"
      (19 26 "variable")
      (54 64 "lambda list"))
     ("                function is applied, the parameter is bound to the value  of"
      (16 23 "function"))
     ("                the  corresponding argument in the function call.  This kind"
      (35 42 "argument")
      (51 63 "function call"))
     ("                of parameter is analogous to a  formal  parameter  in  other")
     ("                programming languages.  ")
     ("  ")
     ("                There  are  four  types of parameters:  required parameters,"
      (56 73 "required parameter"))
     ("                optional   parameters,   rest   parameters,   and    keyword"
      (16 35 "optional parameter")
      (41 56 "rest parameter")
      (69 75 "keyword"))
     ("                parameters.   Required  parameters  must appear first in the"
      (30 48 "required parameter")
      (64 68 "first"))
     ("                function's lambda list.  The other types of  parameters  are"
      (27 37 "lambda list"))
     ("                indicated by lambda-list keywords.  "
      (29 47 "lambda-list keyword"))
     ("  ")
     ("")))
   ("parameter list"
    (("                See lambda list.  " (20 30 "lambda list")) ("  ")
                                                                  ("")))
   ("parse"
    (("                To  determine  the syntactic structure of a sentence or some"
      (45 53 "structure"))
     ("                other object.  " (22 27 "object"))
     ("  ")
     ("")))
   ("parsing of pathnames"
    (("                An operation that converts a string into a pathname object. "
      (45 50 "string")
      (59 66 "pathname")
      (68 73 "object"))
     ("  ")
     ("")))
   ("partition"
    (("                A contiguous, discrete region on a disk.  Each partition has"
      (39 44 "region"))
     ("                a unique name that indicates the function of that partition."
      (49 56 "function"))
     ("  ")
     ("")))
   ("partition-table partition"
    (("                A disk partition that contains information about each of the"
      (23 31 "partition"))
     ("                partitions on the disk.  " (16 24 "partition"))
     ("  ")
     ("")))
   ("patch"
    (("                A small change or set  of changes that updates  a particular"
      (34 36 "set"))
     ("                version of a system.  Note  that a patch replaces  an entire"
      (29 34 "system"))
     ("                function body,  not  just  a  few  words within the function"
      (16 23 "function")
      (51 54 "word"))
     ("                body.")
     ("                ")
     ("")))
   ("patch system"
    (("                A facility that keeps track of all the existing patch  files"
      (64 68 "patch")
      (71 74 "file"))
     ("                and incorporates  them  into  the  system.   Patch files are"
      (51 56 "system")
      (61 65 "patch")
      (67 70 "file"))
     ("                loaded to cause  changes (bug  fixes or  improvements) in an"
      (16 19 "load"))
     ("                existing program.  The patch facility allows  maintenance of"
      (39 43 "patch"))
     ("                both the Explorer  system itself  and applications  that are"
      (35 40 "system")
      (54 64 "application"))
     ("                large enough to be loaded and saved on a disk partition.  "
      (35 38 "load")
      (46 49 "save")
      (62 70 "partition"))
     ("  ")
     ("")))
   ("pathname"
    (("                A string  used  to  access  a  file  or  directory.   On the"
      (18 23 "string")
      (47 50 "file")
      (57 65 "directory"))
     ("                Explorer system, all pathnames have five components, each of"
      (25 30 "system"))
     ("                which is delineated by a special character, as follows:"
      (49 57 "character"))
     ("                  ")
     ("                       host:directory;name.type#version")
     ("                  ")
     ("                The host  component  can  be  either  the  name of the local"
      (20 23 "host"))
     ("                machine or  any  remote  host.   The directory component can"
      (41 44 "host")
      (53 61 "directory"))
     ("                include subdirectory components, each of which is  separated"
      (24 35 "subdirectory"))
     ("                by a period (.).  The name  component is simply the name  of")
     ("                the file followed by the file type component and the version"
      (20 23 "file")
      (41 49 "file type"))
     ("                number component of the file.  " (16 21 "number")
                                                        (40 43 "file"))
     ("                  ")
     ("                Except for the host (which specifies the flavor of  pathname"
      (31 34 "host")
      (57 62 "flavor"))
     ("                object to  use),  all  pathname  components  can be either a"
      (16 21 "object"))
     ("                string or a symbol.  The special symbol :wild can match  any"
      (16 21 "string")
      (28 33 "symbol"))
     ("                file with respect  to that  component.  A  wild component is"
      (16 19 "file"))
     ("                read and written as an asterisk (*).  ")
     ("                  ")
     ("                See also parsing of pathnames and merging of pathnames.  "
      (25 44 "parsing of pathnames")
      (50 69 "merging of pathnames"))
     ("                  ")
     ("")))
   ("pathname defaulting"
    (("                To supply the  missing components  of a  pathname.  When the"
      (57 64 "pathname"))
     ("                Explorer system  prompts  you  for  a  pathname, it does not"
      (25 30 "system")
      (55 62 "pathname"))
     ("                expect you  to  type  a  complete pathname that contains all"
      (50 57 "pathname"))
     ("                five pathname components.  Instead, default values allow the"
      (21 28 "pathname"))
     ("                Explorer system to automatically supply whatever  components"
      (25 30 "system"))
     ("                are missing.  Each program dealing with pathnames  typically"
      (56 63 "pathname"))
     ("                has its own set of defaults.  " (28 30 "set"))
     ("  ")
     ("")))
   ("PCA board"
    (("                See peripheral cable adapter board.  "
      (20 49 "peripheral cable adapter board"))
     ("  ")
     ("")))
   ("PDL" (("                A push-down list; a stack.  " (28 31 "list")
                                                           (36 40 "stack"))
           ("  ")
           ("")))
   ("Peek"
    (("                A window-oriented utility that displays different  types  of"
      (18 23 "window"))
     ("                system activities and their current states.  "
      (16 21 "system"))
     ("  ")
     ("")))
   ("peripheral cable adapter board"
    (("                A  small  board  that  plugs  into  the system backplane and"
      (56 61 "system")
      (63 71 "backplane"))
     ("                provides an interface between the system and the I//O  cables"
      (50 55 "system"))
     ("                to peripheral devices.  This is also called a PCA board.  "
      (62 70 "PCA board"))
     ("  ")
     ("")))
   ("permanent menu"
    (("                A menu contained on one of the panes of a window.  "
      (18 21 "menu")
      (47 50 "pane")
      (58 63 "window"))
     ("  ")
     ("")))
   ("pervasive declaration"
    (("                A declaration that affects all the code within the body of a"
      (18 28 "declaration"))
     ("                special form.  " (16 27 "special form"))
     ("  ")
     ("")))
   ("picture"
    (("                The  definition of an object or collection of objects within"
      (38 43 "object"))
     ("                the graphics editor or graphics window system.  You can save"
      (20 34 "graphics editor")
      (39 60 "graphics window system")
      (72 75 "save"))
     ("                a picture  for  future  use  and  integrate  it  with  other")
     ("                pictures or subpictures.  ")
     ("  ")
     ("")))
   ("pitch"
    (("                See character spacing.  " (20 36 "character spacing"))
     ("  ")
     ("")))
   ("pixel"
    (("                The smallest unit that can be displayed on a screen.  "
      (61 66 "screen"))
     ("  ")
     ("")))
   ("place"
    (("                A term used to denote a generalized variable.  "
      (40 59 "generalized variable"))
     ("  ")
     ("")))
   ("plane"
    (("                An  array whose bounds, in each dimension, are theoretically"
      (20 24 "array"))
     ("                plus infinity and minus infinity.  All integers are legal as")
     ("                indices for a plane.  ")
     ("  ")
     ("")))
   ("plist"
    (("                See property list.  " (20 32 "property list")) ("  ")
                                                                      ("")))
   ("point"
    (("                A buffer pointer in Zmacs used to specify  the  location  of"
      (18 23 "buffer")
      (25 31 "pointer")
      (36 40 "Zmacs"))
     ("                the  keyboard  cursor  or  one edge of a region.  (The other"
      (21 36 "keyboard cursor")
      (57 62 "region"))
     ("                edge of a region is specified by  mark.)   Point  is  always"
      (26 31 "region")
      (50 53 "mark"))
     ("                between  characters  and  is  shown  by the left edge of the"
      (25 33 "character"))
     ("                keyboard cursor.  " (16 30 "keyboard cursor"))
     ("  ")
     ("")))
   ("point PDL"
    (("                A push-down list (PDL) in Zmacs that stores cursor locations"
      (28 31 "list")
      (42 46 "Zmacs"))
     ("                (or point).  Zmacs allows you to store cursor locations  and"
      (20 24 "point")
      (29 33 "Zmacs"))
     ("                return to  them  later.   The  cursor  locations  can  be in")
     ("                different buffers, allowing you to jump between buffers."
      (26 31 "buffer"))
     ("                  ")
     ("  ")
     ("")))
   ("pointer"
    (("                An object whose value is the address or location of a  piece"
      (19 24 "object"))
     ("                of data.  ")
     ("  ")
     ("")))
   ("pop-up menu"
    (("                A  temporary  menu from which you must select an item before"
      (30 33 "menu")
      (55 60 "select"))
     ("                the menu goes away.  " (20 23 "menu"))
     ("  ")
     ("")))
   ("portrait"
    (("                A particular orientation (shape) of a window or a display in"
      (54 59 "window"))
     ("                which the area shown is taller than it is wide.  "
      (26 29 "area"))
     ("  ")
     ("")))
   ("positional constructor function"
    (("                A function that allows the  components of a structure  to be"
      (18 25 "function")
      (60 68 "structure"))
     ("                initialized  in   a   manner   that   differs  from  regular")
     ("                constructor functions.  With regular constructor  functions,"
      (16 35 "constructor function"))
     ("                structure components  are  initialized  by  keywords.   With"
      (16 24 "structure")
      (60 66 "keyword"))
     ("                positional constructor functions,  structure components  are"
      (27 46 "constructor function")
      (51 59 "structure"))
     ("                initialized without  keywords.   Also  known  as  /"by  order"
      (37 43 "keyword"))
     ("                of arguments/", or BOA, constructor. ")
     ("                  ")
     ("")))
   ("positional parameter"
    (("                A  parameter that is passed argument values according to its"
      (19 27 "parameter")
      (44 51 "argument"))
     ("                position in the lambda list.  " (32 42 "lambda list"))
     ("  ")
     ("")))
   ("possibility"
    (("                In Zmacs, certain commands,  such  as  the  Edit  Definition"
      (19 23 "Zmacs"))
     ("                command  (META-.),  perform  operations that create a set of"
      (70 72 "set"))
     ("                results.   Each  result  is  a  possibility  that   can   be")
     ("                individually examined.  For example, if you wish to edit the")
     ("                definition  of a function with META-.  and that function was"
      (33 40 "function"))
     ("                defined in a number of places,  each  definition  becomes  a"
      (29 34 "number")
      (39 43 "place"))
     ("                possibility that you can examine.  ")
     ("  ")
     ("")))
   ("predicate"
    (("                A function that tests for a specific condition involving its"
      (18 25 "function")
      (53 61 "condition"))
     ("                arguments  and  returns a non-nil value (often the symbol t)"
      (16 23 "argument")
      (67 72 "symbol")
      (74 74 "t"))
     ("                if the condition is true  or nil if it  is  not  true.   For"
      (23 31 "condition")
      (45 47 "nil"))
     ("                example,  the  function  listp returns t or nil depending on"
      (31 38 "function")
      (55 55 "t")
      (60 62 "nil"))
     ("                whether its argument is a list or not.  Conventionally,  the"
      (28 35 "argument")
      (42 45 "list"))
     ("                name  of  a  predicate  begins with a function name and ends"
      (54 61 "function"))
     ("                with the letter p, such as with the function listp.  "
      (52 59 "function"))
     ("  ")
     ("")))
   ("predicate-specified type specifier"
    (("                A type specifier that  defines  a  data  type  in  terms  of"
      (18 31 "type specifier")
      (51 60 "data type"))
     ("                objects that satisfy a given predicate.  "
      (16 21 "object")
      (45 53 "predicate"))
     ("  ")
     ("")))
   ("pretty print" (("                See grind.  " (20 24 "grind")) ("  ")
                                                                     ("")))
   ("primary method"
    (("                A flavor method that handles the main task of an  operation."
      (18 23 "flavor")
      (25 30 "method"))
     ("                When methods are combined, only  one primary method is  used"
      (21 26 "method"))
     ("                for a given operation.  ")
     ("                  ")
     ("")))
   ("print name"
    (("                The  printed  representation of a symbol; the string used to"
      (21 43 "printed representation")
      (50 55 "symbol")
      (62 67 "string"))
     ("                identify a symbol.  The print name is stored as a  component"
      (27 32 "symbol"))
     ("                of the symbol.  " (23 28 "symbol"))
     ("  ")
     ("")))
   ("print server"
    (("                A  program  on  a  host  with printers that handles standard"
      (35 38 "host"))
     ("                requests for printing from other hosts on the network.  "
      (49 52 "host")
      (62 68 "network"))
     ("  ")
     ("")))
   ("print-print consistency"
    (("                A concept stating that if two interned symbols are  not  eq,"
      (46 60 "interned symbol")
      (73 74 "eq"))
     ("                then  their  printed representations are different sequences"
      (29 50 "printed representation")
      (67 74 "sequence"))
     ("                of characters.  " (19 27 "character"))
     ("  ")
     ("")))
   ("print-read consistency"
    (("                A concept stating that an interned symbol that always prints"
      (42 56 "interned symbol"))
     ("                as a sequence of characters yields the same (eq) symbol when"
      (21 28 "sequence")
      (33 41 "character")
      (65 70 "symbol"))
     ("                read back in.  ")
     ("  ")
     ("")))
   ("printed representation"
    (("                The representation of Lisp objects as they appear in printed"
      (38 48 "Lisp object"))
     ("                text.  ")
     ("  ")
     ("")))
   ("process"
    (("                A separate computation  or activity  consisting of  a set of"
      (70 72 "set"))
     ("                operations  performed  sequentially.   The  Explorer  system"
      (70 75 "system"))
     ("                allows a number of processes to be active concurrently.  All"
      (25 30 "number"))
     ("                processes run in the same virtual address space, sharing the"
      (42 62 "virtual address space"))
     ("                same set of Lisp objects.  However, each process has its own"
      (21 23 "set")
      (28 38 "Lisp object"))
     ("                program counter, its  own stack  of function  calls, and its"
      (42 46 "stack")
      (52 65 "function call"))
     ("                own special-variable binding environment.  "
      (37 43 "binding")
      (45 55 "environment"))
     ("  ")
     ("")))
   ("proclamation"
    (("                A universal declaration; a declaration  that  is  always  in"
      (28 38 "declaration"))
     ("                force unless locally shadowed by another declaration.  "
      (37 42 "shadow")
      (57 67 "declaration"))
     ("  ")
     ("")))
   ("Profile utility"
    (("                A series of windows that allow you to inspect and change the"
      (28 33 "window"))
     ("                values of various system default variables, and to then save"
      (34 39 "system")
      (49 56 "variable")
      (72 75 "save"))
     ("                these customized changes in  an initialization (usually  the")
     ("                login) file." (23 26 "file"))
     ("                ")
     ("")))
   ("progn-type form"
    (("                See simple sequencing function.  "
      (20 45 "simple sequencing function"))
     ("  ")
     ("")))
   ("program control keys"
    (("                A  set of keys that interrupt and resume the flow of control"
      (19 21 "set")
      (36 44 "interrupt"))
     ("                in program execution.  These keys are the following:  ")
     ("                  ")
     ("                *  ABORT -- Stops the current program and returns to  the")
     ("                   next  higher  command  level.   This key is often used")
     ("                   with modifier keys to leave a recursive function.  "
      (24 36 "modifier keys")
      (49 66 "recursive function"))
     ("                  ")
     ("                *  BREAK -- Stops the current program.  "
      (19 23 "break"))
     ("                  ")
     ("                *  RESUME -- Resumes execution  of  a  program  that  was")
     ("                   stopped  by  using  the BREAK key or by encountering a"
      (43 51 "BREAK key"))
     ("                   breakpoint.  This key is also used to signal a proceed")
     ("                   option when recovering from  an  error  in  the  error")
     ("                   handler. ")
     ("                  ")
     ("")))
   ("Prolog"
    (("                A  logic  programming  language  used alone or with Lisp for"
      (68 71 "Lisp"))
     ("                representing  objects  and   solving   object   relationship"
      (30 35 "object"))
     ("                problems.  ")
     ("                  ")
     ("                Prolog is  an  optional  package  available for the Explorer"
      (41 47 "package"))
     ("                system that  includes  a  Prolog  compiler  and  a prototype"
      (16 21 "system")
      (50 57 "compiler"))
     ("                expert system that uses a Prolog inference engine.   You can"
      (23 28 "system"))
     ("                extend the prototype expert system to suit your needs or use"
      (44 49 "system"))
     ("                it as is.  ")
     ("                  ")
     ("                ")
     ("                ")
     ("")))
   ("Prolog window"
    (("                The window  in  which  a  user  develops  and  tests  Prolog"
      (20 25 "window")
      (70 75 "Prolog"))
     ("                programs.  ")
     ("                ")
     ("")))
   ("property list"
    (("                A component of a symbol that effectively provides the symbol"
      (33 38 "symbol"))
     ("                with many modifiable, named components.  The  property  list"
      (72 75 "list"))
     ("                has  zero  or  more entries, with each entry consisting of a")
     ("                pair of elements.  The first element of the pair  is  called"
      (24 30 "element")
      (39 43 "first"))
     ("                the  indicator  and  is  used to name a particular property."
      (21 29 "indicator"))
     ("                Each indicator must be unique  within  that  property  list."
      (21 29 "indicator")
      (71 74 "list"))
     ("                The  second  element  can be any Lisp object that represents"
      (29 35 "element")
      (49 59 "Lisp object"))
     ("                the value of that  property.   Functions  are  available  to"
      (47 54 "function"))
     ("                manipulate a symbol's property list.  " (47 50
                                                                   "list"))
     ("  ")
     ("")))
   ("property name"
    (("                See indicator.  " (20 28 "indicator")) ("")))
   ("quote"
    (("                To inhibit the evaluation  of  an  object.   This  is  often"
      (31 40 "evaluation")
      (51 56 "object"))
     ("                called  quoting  because you generally use the quote special")
     ("                form to inhibit evaluation.  You can abbreviate the  special"
      (16 19 "form")
      (32 41 "evaluation"))
     ("                form to a single quote mark or apostrophe ('). "
      (16 19 "form")
      (39 42 "mark"))
     ("")))
   ("radix"
    (("                The  base of the numbering system being used.  For instance,"
      (33 38 "number")
      (43 48 "system")
      (67 74 "instance"))
     ("                the binary numbering system is of radix 2. "
      (27 32 "number")
      (37 42 "system"))
     ("")))
   ("random number"
    (("                A number  obtained  by  chance  from  a  uniformly  probable"
      (18 23 "number"))
     ("                distribution of numbers.  " (32 37 "number"))
     ("  ")
     ("")))
   ("random-number generator"
    (("                A function designed to produce random numbers.  "
      (18 25 "function")
      (47 59 "random number"))
     ("  ")
     ("")))
   ("rank"
    (("                The number  of  subscripts  used  to  refer  to  one  of the"
      (20 25 "number"))
     ("                elements of an array, or simply the number of dimensions  of"
      (16 22 "element")
      (31 35 "array")
      (52 57 "number"))
     ("                an array.  On the Explorer system, arrays can have a maximum"
      (19 23 "array")
      (43 48 "system"))
     ("                rank of 7.  ")
     ("  ")
     ("")))
   ("raster height and raster width"
    (("                The dimensions of the array of bits stored for each physical"
      (38 42 "array")
      (47 49 "bit"))
     ("                character in a font.  Every array for one font has the  same"
      (16 24 "character")
      (31 34 "font")
      (44 48 "array"))
     ("                raster height and width.  ")
     ("  ")
     ("")))
   ("read-eval-print loop"
    (("                A  continuous loop that reads a Lisp form, evaluates it, and"
      (48 56 "Lisp form"))
     ("                prints the returned value(s).  ")
     ("  ")
     ("")))
   ("read-read consistency"
    (("                A concept stating that when reading the same print name  you"
      (61 70 "print name"))
     ("                always receive the same (eq) symbol.  " (45 50
                                                                   "symbol"))
     ("  ")
     ("")))
   ("Reader"
    (("                See Lisp Reader.  " (20 30 "Lisp Reader")) ("  ")
                                                                  ("")))
   ("recognition completion"
    (("                See completion.  " (20 29 "completion")) ("  ") ("")))
   ("record structure" (("                See structure.  " (20 28
                                                                "structure"))
                        ("  ")
                        ("")))
   ("recursive function"
    (("                A  function  that steps through its operation by continually"
      (19 26 "function"))
     ("                invoking itself until a point  of  termination  is  reached."
      (40 44 "point"))
     ("                Then,  a  value  is  returned  to  the  environment  of each"
      (56 66 "environment"))
     ("                invocation of the function.  " (34 41 "function"))
     ("  ")
     ("")))
   ("reduced ratio"
    (("                A ratio number that is in a form such that further factoring"
      (24 29 "number")
      (44 47 "form"))
     ("                with the  denominator  and  numerator  of  the number is not"
      (63 68 "number"))
     ("                possible.  ")
     ("  ")
     ("")))
   ("region"
    (("                1.   A  contiguous  section of address space used as storage"
      (36 42 "section"))
     ("                for an area.  The area can be divided  into  more  than  one"
      (23 26 "area"))
     ("                region.    A   given   region   can   store  only  one  data")
     ("                representation type (a list or a structure).  "
      (39 42 "list")
      (49 57 "structure"))
     ("  ")
     ("                2.  Any block of text in a Zmacs buffer defined by point and"
      (43 54 "Zmacs buffer")
      (67 71 "point"))
     ("                mark.  Commands are available to  manipulate  regions.   See"
      (16 19 "mark"))
     ("                also mark.  " (21 24 "mark"))
     ("  ")
     ("")))
   ("register"
    (("                1.  A Zmacs temporary  storage area in  which you can  store"
      (22 26 "Zmacs")
      (47 50 "area"))
     ("                and retrieve either text or  cursor locations. You can  also")
     ("                store text  and  a  cursor  location  simultaneously  in one")
     ("                register.  A register is similar to the kill history  except"
      (56 67 "kill history"))
     ("                that you can  only store  one block  of text  and one cursor")
     ("                location in  a  register.   However,  they  stay  in a fixed")
     ("                place.  In the kill history, text is moved down the stack as"
      (16 20 "place")
      (31 42 "kill history")
      (68 72 "stack"))
     ("                new entries are added.  ")
     ("                  ")
     ("                2.    In   the  font  editor,  buffer-like  panes  that  can"
      (32 43 "font editor")
      (47 52 "buffer")
      (60 63 "pane"))
     ("                temporarily hold characters.  " (33 41 "character"))
     ("                  ")
     ("                ")
     ("")))
   ("rehash threshold"
    (("                A predetermined number of hash  table  entries.   Once  this"
      (32 37 "number")
      (42 52 "hash table"))
     ("                threshold  is  exceeded,  a hash table must grow in size and"
      (44 53 "hash table"))
     ("                its current entries must be  rehashed  to  accommodate  more")
     ("                entries.  ")
     ("  ")
     ("")))
   ("Relational Table Management System"
    (("                An   optional   facility   for   building,   accessing,  and")
     ("                manipulating relational tables within the Lisp  environment."
      (58 61 "Lisp")
      (64 74 "environment"))
     ("                It  provides the basic features of a database while allowing")
     ("                as much flexibility as possible.  All database manipulations")
     ("                occur in virtual memory; however, the database elements  can"
      (63 69 "element"))
     ("                be saved to and loaded from disk.  " (19 22 "save")
                                                            (32 35 "load"))
     ("  ")
     ("")))
   ("reparse attribute list"
    (("                To  permanently record editing changes made to the attribute")
     ("                list in a Zmacs  buffer  and  to  make  those  changes  take"
      (16 19 "list")
      (26 38 "Zmacs buffer"))
     ("                effect.  The changes are also saved when the file is written"
      (46 49 "save")
      (61 64 "file"))
     ("                to  disk.   This  operation  is  the  inverse  of the update")
     ("                attribute list operation, which records the changes  in  the"
      (16 29 "attribute list"))
     ("                attribute list from the current settings of the buffer (that"
      (16 29 "attribute list")
      (64 69 "buffer"))
     ("                is,  buffer  attributes that are changed but not recorded in"
      (21 26 "buffer"))
     ("                the attribute list, such  as  changing  modes  with  a  mode"
      (20 33 "attribute list"))
     ("                command).  ")
     ("  ")
     ("")))
   ("repeat form"
    (("                A form that is repeatedly evaluated during iteration.  "
      (18 21 "form"))
     ("  ")
     ("")))
   ("required parameter"
    (("                A parameter that requires a corresponding argument value  to"
      (18 26 "parameter")
      (58 65 "argument"))
     ("                be  passed  when  the  function  is  called in order for the"
      (39 46 "function"))
     ("                function to execute correctly.  " (16 23 "function"))
     ("  ")
     ("")))
   ("reset"
    (("                To throw out the entire computation for a process and  force"
      (19 23 "throw")
      (58 64 "process"))
     ("                the process to call its initial function again.  Resetting a"
      (20 26 "process")
      (48 55 "function"))
     ("                process  clears  its waiting condition, and if it is active,"
      (16 22 "process")
      (45 53 "condition"))
     ("                it starts running.  ")
     ("                  ")
     ("")))
   ("resource"
    (("                A pool of interchangeable objects that are available  to  be"
      (42 47 "object"))
     ("                used temporarily and then returned to the pool.  ")
     ("  ")
     ("                Resources  whose  objects are windows are often useful.  For"
      (34 39 "object")
      (46 51 "window"))
     ("                example, a resource of windows serves as  the  System  menu;"
      (39 44 "window")
      (63 74 "System menu"))
     ("                when  you invoke the System menu, a window is allocated from"
      (37 47 "System menu")
      (52 57 "window"))
     ("                the resource, and it is returned to the resource's pool when")
     ("                it is deactivated.  " (22 31 "deactivate"))
     ("  ")
     ("")))
   ("rest"
    (("                A term sometimes used to refer to the cdr.  "
      (54 56 "cdr"))
     ("  ")
     ("")))
   ("rest parameter"
    (("                A parameter that can be passed any number of arguments.  The"
      (18 26 "parameter")
      (51 56 "number")
      (61 68 "argument"))
     ("                lambda-list  keyword  &rest  is  used  to  indicate  a  rest"
      (16 35 "lambda-list keyword")
      (72 75 "rest"))
     ("                parameter.   When  the  function is called, the required and"
      (16 24 "parameter")
      (40 47 "function"))
     ("                optional parameters are bound to their  respective  argument"
      (16 33 "optional parameter")
      (68 75 "argument"))
     ("                values,  and  the  rest  parameter is bound to a list of any"
      (35 38 "rest")
      (41 49 "parameter")
      (65 68 "list"))
     ("                remaining argument values.  " (26 33 "argument"))
     ("  ")
     ("")))
   ("RESUME key"
    (("                See program control keys.  "
      (20 39 "program control keys"))
     ("  ")
     ("")))
   ("resumption"
    (("                See stack group switch.  " (20 37
                                                      "stack group switch"))
     ("  ")
     ("")))
   ("RETURN key"
    (("                See line-positioning keys.  "
      (20 40 "line-positioning keys"))
     ("  ")
     ("")))
   ("reverse video"
    (("                A display state in which white images are shown on  a  black")
     ("                background (reverse of normal video).  "
      (39 50 "normal video"))
     ("  ")
     ("")))
   ("RIGHT key"
    (("                See mouse keys.  " (20 29 "mouse keys")) ("  ") ("")))
   ("root directory"
    (("                The  topmost  level  of  directories  in  the  file  system,"
      (63 74 "file system"))
     ("                containing a number of  user directories.  Only  directories"
      (29 34 "number"))
     ("                (that is,  no  files)  are  allowed  at  the top level of an"
      (31 34 "file"))
     ("                Explorer root.  ")
     ("                  ")
     ("                ")
     ("")))
   ("row-major order"
    (("                An ordering  of  multidimensional  arrays  in  which  memory"
      (51 55 "array"))
     ("                locations represent the rows  of the array.   Therefore, the"
      (53 57 "array"))
     ("                subscript representing rows is the first subscript, and  the"
      (51 55 "first"))
     ("                subscript  representing  columns   is  the   last subscript.")
     ("                Arrays on the Explorer system are stored in row-major order."
      (16 20 "array")
      (39 44 "system"))
     ("                ")
     ("  ")
     ("")))
   ("RTMS"
    (("                See Relational Table Management System.  "
      (20 53 "Relational Table Management System"))
     ("  ")
     ("")))
   ("rubber banding"
    (("                An  operation  on  a  window  or  graphics  object  that  is"
      (38 43 "window")
      (50 65 "graphics object"))
     ("                performed by pressing and holding a mouse button  while  you"
      (52 56 "mouse"))
     ("                move  the  mouse.   As  the  mouse  cursor moves, the object"
      (27 31 "mouse")
      (45 57 "mouse cursor")
      (70 75 "object"))
     ("                stretches or shrinks in size, following the cursor until you")
     ("                release the button.  ")
     ("  ")
     ("")))
   ("rubout handler"
    (("                See input editor.  " (20 31 "input editor")) ("  ")
                                                                    ("")))
   ("RUBOUT key"
    (("                See line-positioning keys.  "
      (20 40 "line-positioning keys"))
     ("  ")
     ("")))
   ("run bars"
    (("                A set of three, thin horizontal lines  that  appear  in  the"
      (18 20 "set"))
     ("                status  line,  indicating  that the system is actively doing"
      (16 27 "status line")
      (52 57 "system"))
     ("                something.  From left to right, the run bars  correspond  to"
      (56 58 "bar"))
     ("                the  activities of garbage collecting, paging, and executing")
     ("                a process.  " (18 24 "process"))
     ("  ")
     ("")))
   ("run reason"
    (("                A Lisp  object  associated  with  a  process.   The Explorer"
      (18 29 "Lisp object")
      (53 59 "process"))
     ("                system considers  a  process  active  if  the process has at"
      (16 21 "system")
      (37 43 "process"))
     ("                least one run reason and  no arrest reasons associated  with"
      (45 50 "arrest"))
     ("                it.  ")
     ("                  ")
     ("")))
   ("running stack group"
    (("                See current stack group.  "
      (20 38 "current stack group"))
     ("")))
   ("salvager"
    (("                A facility that verifies the integrity  of  a  file  system."
      (63 74 "file system"))
     ("                The  salvager  verifies  that  all  blocks  and pointers are"
      (64 70 "pointer"))
     ("                correct, that  all  files  are  closed,  and  that  no  dual"
      (36 39 "file"))
     ("                pointers exist.  " (16 22 "pointer"))
     ("  ")
     ("")))
   ("save"
    (("                1.  To write a Zmacs buffer to disk, automatically using the"
      (31 42 "Zmacs buffer"))
     ("                default filename.   This  differs  from  a  write operation,"
      (24 31 "filename"))
     ("                which allows you to specify the filename.  "
      (48 55 "filename"))
     ("                  ")
     ("                2.  To move a  block of text  into the kill  history without"
      (55 67 "kill history"))
     ("                removing it from your Zmacs buffer.  See also kill.  "
      (38 49 "Zmacs buffer")
      (62 65 "kill"))
     ("                  ")
     ("                ")
     ("")))
   ("scheduler"
    (("                Software that manages the  set  of  active  processes.   The"
      (43 45 "set")
      (52 66 "active process"))
     ("                scheduler  repeatedly  cycles  through the active processes,"
      (59 72 "active process"))
     ("                determining for each process whether it is ready to  run  or"
      (37 43 "process"))
     ("                is  waiting.   When  the  scheduler finds a process ready to"
      (60 66 "process"))
     ("                run, that process is made the current process.  "
      (26 32 "process")
      (46 60 "current process"))
     ("  ")
     ("")))
   ("scope"
    (("                The spatial or textual region of a program  or  form  within"
      (39 44 "region")
      (64 67 "form"))
     ("                which it is possible to refer to an object.  "
      (52 57 "object"))
     ("  ")
     ("")))
   ("scoping"
    (("                The  rules  or  procedures  involved  in assigning values to")
     ("                variables when a program is implementing multiple levels  of"
      (16 23 "variable"))
     ("                environments.  " (16 26 "environment"))
     ("  ")
     ("")))
   ("screen"
    (("                The topmost  node  of  the  window  system  hierarchy, which"
      (44 57 "window system"))
     ("                defines an  area  of  the  physical  display.   The physical"
      (28 31 "area"))
     ("                display area is divided logically into two screens: the main"
      (24 27 "area"))
     ("                screen and the screen containing  the status line and  mouse"
      (54 64 "status line")
      (71 75 "mouse"))
     ("                documentation window.  A screen has no superior windows, and"
      (30 35 "window")
      (55 69 "superior window"))
     ("                windows in  one  screen  cannot  be  extended into the other"
      (16 21 "window"))
     ("                screen.  ")
     ("  ")
     ("")))
   ("screen array"
    (("                A special area in the hardware that is used to  display  the"
      (26 29 "area"))
     ("                image on the screen.  " (29 34 "screen"))
     ("  ")
     ("")))
   ("screen formatter"
    (("                A  menu-based  facility that allows you to change the shapes"
      (19 22 "menu"))
     ("                and sizes of windows and reposition windows within a screen."
      (29 34 "window")
      (69 74 "screen"))
     ("                You can access the screen formatter through the System menu."
      (35 40 "screen")
      (64 74 "System menu"))
     ("  ")
     ("")))
   ("screen manager"
    (("                The utility that controls which windows appear on  a  screen"
      (48 53 "window")
      (70 75 "screen"))
     ("                and  where  the  windows  appear  on the screen.  The screen"
      (33 38 "window")
      (57 62 "screen"))
     ("                manager can also select a window if no window  is  selected."
      (33 38 "select")
      (42 47 "window"))
     ("                See also autoselect.  " (25 34 "autoselect"))
     ("  ")
     ("")))
   ("scroll bar"
    (("                A thin, vertical line that appears when you move  the  mouse"
      (71 75 "mouse"))
     ("                cursor  against  the left margin of certain windows (such as"
      (42 47 "margin")
      (60 65 "window"))
     ("                Zmacs).  The size and position of the scroll  bar  indicates"
      (16 20 "Zmacs")
      (62 64 "bar"))
     ("                the  relative  portion of the total buffer that is currently"
      (52 57 "buffer"))
     ("                visible.  For example, a short scroll bar appearing near the"
      (54 56 "bar"))
     ("                top of the displayed text indicates that you are looking  at")
     ("                a small portion of the beginning of the buffer.  "
      (56 61 "buffer"))
     ("                  ")
     ("                When  in the  scroll region, the mouse cursor changes to the"
      (37 42 "region")
      (49 60 "mouse cursor"))
     ("                shape of a fat double-headed arrow, and  you  can  then  use")
     ("                mouse buttons to perform scrolling operations.  "
      (16 28 "mouse buttons")
      (41 49 "scrolling"))
     ("                  ")
     ("")))
   ("scrolling"
    (("                The  act  of displaying different portions of a buffer whose"
      (64 69 "buffer"))
     ("                contents are too big to all fit within a window at one time."
      (57 62 "window"))
     ("                Scrolling forward displays a portion toward the end  of  the")
     ("                buffer; scrolling backward displays a portion toward the top"
      (16 21 "buffer"))
     ("                of the buffer.  " (23 28 "buffer"))
     ("  ")
     ("")))
   ("scrolling window"
    (("                See text scroll window.  " (20 37
                                                      "text scroll window"))
     ("  ")
     ("")))
   ("SCSI bus"
    (("                See small computer systems interface bus.  "
      (35 40 "system")
      (53 55 "bus"))
     ("  ")
     ("")))
   ("section"
    (("                A top-level Lisp form in a Zmacs buffer.  Usually, a section"
      (18 26 "top-level")
      (28 36 "Lisp form")
      (43 54 "Zmacs buffer"))
     ("                defines a variable or a function.  Zmacs provides tools like"
      (26 33 "variable")
      (40 47 "function")
      (51 55 "Zmacs"))
     ("                List  Sections  that  facilitate  writing and debugging Lisp"
      (16 19 "list")
      (72 75 "Lisp"))
     ("                code.  ")
     ("                  ")
     ("                The only  buffers  that  have  sections are those containing"
      (26 31 "buffer"))
     ("                Lisp code.  Other buffers do  not have sections.  A  section"
      (16 19 "Lisp")
      (34 39 "buffer"))
     ("                can contain  any  defining  construct  that  begins with def")
     ("                after the  initial  opening  parenthesis,  such  as  defvar,")
     ("                defflavor,  and  defun.   The  defining  construct  can   be")
     ("                user-defined.  Each definition is a section.  ")
     ("                  ")
     ("                Actually, Zmacs looks for  a  matching  set  of  parentheses"
      (26 30 "Zmacs")
      (56 58 "set"))
     ("                starting  with  an  opening parenthesis in the first column."
      (63 67 "first"))
     ("                Zmacs' detection of an  opening  parenthesis  in  the  first"
      (71 75 "first"))
     ("                column  is unconditional.  Even if the parenthesis is inside")
     ("                a quoted string or a block comment (that is,  #|  ...   |#),"
      (18 22 "quote")
      (25 30 "string")
      (43 49 "comment"))
     ("                Zmacs   starts  a  new  section.   This  feature  may  cause"
      (16 20 "Zmacs"))
     ("                unexpected errors.  ")
     ("                  ")
     ("")))
   ("sectionize"
    (("                To read the Lisp code in a Zmacs  buffer  and  update  Zmacs"
      (28 31 "Lisp")
      (43 55 "Zmacs buffer"))
     ("                internal  data  and  property lists of the defined sections."
      (37 49 "property list")
      (67 73 "section"))
     ("                This sectionizing is done automatically  when  a  buffer  is"
      (66 71 "buffer"))
     ("                created.  Certain Zmacs commands, such as Sectionize Buffer,"
      (34 38 "Zmacs")
      (69 74 "buffer"))
     ("                allow  you  to resectionize the buffer after making changes."
      (48 53 "buffer"))
     ("                See also section.  " (25 31 "section"))
     ("  ")
     ("")))
   ("seed"
    (("                A number used to initiate a random-number generator.  "
      (18 23 "number")
      (44 66 "random-number generator"))
     ("  ")
     ("")))
   ("select"
    (("                1.  To allow keyboard input to be sent to a window.  "
      (60 65 "window"))
     ("  ")
     ("                2.  To box an item in a menu and click  left  to  execute  a"
      (23 25 "box")
      (40 43 "menu")
      (49 53 "click"))
     ("                command  or invoke another menu.  For example, if you select"
      (43 46 "menu"))
     ("                the System Menu item in the menu at the bottom of  the  Lisp"
      (20 30 "System menu")
      (72 75 "Lisp"))
     ("                Listener, you invoke the System menu.  "
      (16 23 "Listener")
      (41 51 "System menu"))
     ("  ")
     ("")))
   ("selected window"
    (("                A window that is enabled  to accept input from  the keyboard"
      (18 23 "window"))
     ("                or mouse.  Only one  window can be  selected at a  time, and"
      (19 23 "mouse")
      (37 42 "window")
      (52 57 "select"))
     ("                the selected window  is made  fully visible.   The currently"
      (20 25 "select")
      (29 34 "window"))
     ("                selected window is usually indicated by a blinking  keyboard"
      (16 21 "select")
      (25 30 "window"))
     ("                cursor.  ")
     ("  ")
     ("")))
   ("self-evaluating form"
    (("                A  form  that,  when evaluated, returns itself (or a copy of"
      (19 22 "form"))
     ("                itself) as the value of  the  form.   Self-evaluating  forms"
      (46 49 "form"))
     ("                include  all numbers, characters, strings, keywords, and bit"
      (29 34 "number")
      (38 46 "character")
      (50 55 "string")
      (59 65 "keyword")
      (73 75 "bit"))
     ("                vectors.  " (16 21 "vector"))
     ("  ")
     ("")))
   ("semilexicographic comparison"
    (("                A string comparison where distinctions between lowercase and"
      (18 23 "string"))
     ("                uppercase characters are ignored.  " (26 34
                                                                "character"))
     ("  ")
     ("")))
   ("sequence"
    (("                A data type that contains an ordered set of elements,  which"
      (18 26 "data type")
      (53 55 "set")
      (60 66 "element"))
     ("                encompasses both lists and vectors.  " (33 36 "list")
                                                              (43 48
                                                                  "vector"))
     ("  ")
     ("")))
   ("server"
    (("                A program that provides a standard service of some type on a")
     ("                network.  " (16 22 "network"))
     ("  ")
     ("")))
   ("set"
    (("                1.  To permanently assign a value to a symbol or variable."
      (55 60 "symbol")
      (65 72 "variable"))
     ("                ")
     ("                2.   An  abstract  object  containing  zero  or more related"
      (35 40 "object"))
     ("                objects that can be represented in Lisp as lists or arrays."
      (16 21 "object")
      (51 54 "Lisp")
      (59 62 "list")
      (68 72 "array"))
     ("")))
   ("settable"
    (("                The ability to set an instance variable of a flavor  with  a"
      (31 33 "set")
      (38 54 "instance variable")
      (61 66 "flavor"))
     ("                value.  ")
     ("  ")
     ("")))
   ("shadow"
    (("                To  cause  a symbol to take precedence over other symbols of"
      (29 34 "symbol"))
     ("                the same name within a namespace.  " (39 47
                                                                "namespace"))
     ("  ")
     ("")))
   ("SHIFT key"
    (("                See modifier keys.  " (20 32 "modifier keys")) ("  ")
                                                                      ("")))
   ("signaling"
    (("                See condition signaling.  "
      (20 38 "condition signaling"))
     ("  ")
     ("")))
   ("significant command"
    (("                A command that  performs a  major or  significant operation.")
     ("                Significant commands are placed  in command histories.   For"
      (41 45 "place"))
     ("                example,  deleting  a  line  of  text  is  significant,  but")
     ("                deleting a single character is not. "
      (34 42 "character"))
     ("                  ")
     ("                ")
     ("")))
   ("simple array"
    (("                An array that is not displaced to another array, has no fill"
      (19 23 "array")
      (72 75 "fill"))
     ("                pointer, and does not have its size altered dynamically.  "
      (16 22 "pointer"))
     ("  ")
     ("")))
   ("simple sequencing function"
    (("                A function that executes each form within  the  function  in"
      (18 25 "function")
      (46 49 "form"))
     ("                sequence and returns the value of the last form as the value"
      (16 23 "sequence")
      (59 62 "form"))
     ("                of the function.  This is also called a progn-type form.  "
      (23 30 "function")
      (56 70 "progn-type form"))
     ("  ")
     ("")))
   ("single-colon package qualifier"
    (("                A  package qualifier (containing a single colon) that allows"
      (19 35 "package qualifier"))
     ("                you to access the external symbols of another package.  "
      (34 48 "external symbol")
      (62 68 "package"))
     ("  ")
     ("")))
   ("small computer systems interface  bus"
    (("                An industry-standard bus used for  access  to  mass  storage"
      (37 39 "bus"))
     ("                devices.  Use of this bus also allows for other commercially"
      (38 40 "bus"))
     ("                available devices.  ")
     ("  ")
     ("")))
   ("sorting"
    (("                The  arranging of items in a sequence in some logical order,"
      (45 52 "sequence"))
     ("                for example, alphabetic order or numeric order.  ")
     ("  ")
     ("")))
   ("SPACE key"
    (("                See number pad.  " (20 29 "number pad")) ("  ") ("")))
   ("special form"
    (("                A form that has its own idiosyncratic syntax.  Special forms"
      (18 21 "form")
      (54 59 "syntax"))
     ("                are generally environment and control constructs.   The  set"
      (30 40 "environment")
      (73 75 "set"))
     ("                of  special forms is fixed in Common Lisp; you cannot define"
      (28 31 "form")
      (46 56 "Common Lisp"))
     ("                new ones.  ")
     ("  ")
     ("")))
   ("special variable"
    (("                A variable that has  dynamic  scope  (indefinite  scope  and"
      (18 25 "variable")
      (37 50 "dynamic scope"))
     ("                dynamic  extent);  similar  to  a  global  variable in other"
      (16 30 "dynamic extent")
      (51 66 "global variable"))
     ("                languages.  ")
     ("  ")
     ("")))
   ("specialized array"
    (("                An array whose elements are restricted to  a  specific  data"
      (19 23 "array")
      (31 37 "element"))
     ("                type.  ")
     ("  ")
     ("")))
   ("specializing type specifier"
    (("                A  type  specifier  that  defines specializations for a data"
      (19 33 "type specifier"))
     ("                type.  These specializations are used  to  incorporate  more")
     ("                efficient  data  type  representations  and allow for better"
      (27 36 "data type"))
     ("                compiler optimization.  " (16 23 "compiler"))
     ("  ")
     ("")))
   ("spelling completion"
    (("                See completion.  " (20 29 "completion")) ("  ") ("")))
   ("spline"
    (("                A smooth curve through an ordered set  of  points.   Splines"
      (50 52 "set")
      (59 63 "point"))
     ("                are used to draw a curved line in utilities such as the font"
      (72 75 "font"))
     ("                editor or the graphics editor.  "
      (30 44 "graphics editor"))
     ("  ")
     ("")))
   ("split screen"
    (("                A layout of the main screen in which two or more windows are"
      (32 42 "main screen")
      (65 70 "window"))
     ("                completely  visible.   You   can  set   up  a   split-screen"
      (50 52 "set"))
     ("                configuration using the screen formatter.  "
      (40 55 "screen formatter"))
     ("  ")
     ("")))
   ("stable rounding"
    (("                A  technique  for rounding off floating-point numbers.  This"
      (62 67 "number"))
     ("                technique determines when to round up or down if a resulting")
     ("                value  is  exactly  in  the  middle  of  two  floating-point")
     ("                numbers.   It  rounds down if the least-significant bit is 0"
      (16 21 "number")
      (68 70 "bit"))
     ("                and rounds up if  the  least-significant  bit  is  1.   This"
      (58 60 "bit"))
     ("                technique ensures that no systematic bias is introduced.  ")
     ("  ")
     ("")))
   ("stable sorting"
    (("                A  procedure  that keeps equal items in their original order"
      (41 45 "equal"))
     ("                during a sorting operation.  For example, when x and  y  are"
      (25 31 "sorting"))
     ("                equal  items  being  sorted with other items and x initially"
      (16 20 "equal"))
     ("                comes before  y,  x  remains  before  y  after  the  sorting"
      (69 75 "sorting"))
     ("                operation.  ")
     ("  ")
     ("")))
   ("stack"
    (("                An area  of  memory  used  for  temporary storage; sometimes"
      (19 22 "area"))
     ("                referred to as the Lisp stack.  The stack is implemented  as"
      (35 38 "Lisp"))
     ("                a last-in//first-out data structure.   As objects are  pushed"
      (41 49 "structure")
      (57 62 "object"))
     ("                onto the  stack,  the  stack  pointer  is  incremented.   As"
      (46 52 "pointer"))
     ("                objects are  popped  from  the  stack,  the stack pointer is"
      (16 21 "object")
      (66 72 "pointer"))
     ("                decremented.  In  the  Explorer  system,  special high-speed"
      (49 54 "system"))
     ("                memories (caches) are reserved as stack buffers.  "
      (56 61 "buffer"))
     ("  ")
     ("")))
   ("stack group"
    (("                A  type  of  Lisp  object  that represents a process and its"
      (29 40 "Lisp object")
      (61 67 "process"))
     ("                internal state, including the Lisp stack.  The  stack  group"
      (46 49 "Lisp")
      (51 55 "stack"))
     ("                holds  state  information,  including the local environment,"
      (23 40 "state information")
      (64 74 "environment"))
     ("                special variables, and dynamic storage associated  with  the"
      (16 31 "special variable"))
     ("                process.   Stack  groups are useful for implementing certain"
      (16 22 "process")
      (27 31 "stack"))
     ("                advanced  control  structures,  such   as   coroutines   and"
      (26 43 "control structure")
      (60 68 "coroutine"))
     ("                generators.  " (16 24 "generator"))
     ("  ")
     ("")))
   ("stack group switch"
    (("                The  operation  of  making  a  specified  stack group be the"
      (58 68 "stack group"))
     ("                current stack group; also called resumption.  "
      (16 34 "current stack group")
      (49 58 "resumption"))
     ("  ")
     ("")))
   ("stack list"
    (("                A list that is discarded once the function that  creates  it"
      (18 21 "list")
      (50 57 "function"))
     ("                is finished with it; also called a temporary list.  "
      (61 64 "list"))
     ("  ")
     ("")))
   ("standalone editor"
    (("                An editor that functions like a Zmacs editor but is not tied"
      (31 38 "function")
      (48 52 "Zmacs"))
     ("                to the rest of the editing system.  You can use a standalone"
      (23 26 "rest")
      (43 48 "system"))
     ("                editor in your program for terminal input//output.  ")
     ("  ")
     ("")))
   ("starter kit"
    (("                A file or set of files that comes with each system  software"
      (18 21 "file")
      (26 28 "set")
      (60 65 "system"))
     ("                option.  The starter kits make use of the different features")
     ("                for each tool.  They are  intended to provide examples  from")
     ("                which you can learn how to use a tool or upon which you  can")
     ("                base your own application.  " (30 40 "application"))
     ("                  ")
     ("")))
   ("state information"
    (("                Information on the values  in  an  environment  at  any  one"
      (51 61 "environment"))
     ("                quantum of time.  ")
     ("  ")
     ("")))
   ("statements"
    (("                The  independently  evaluated  subforms  of  certain special")
     ("                forms.  " (16 19 "form"))
     ("  ")
     ("")))
   ("static area"
    (("                A  specified  area  whose  contents   change   slowly   and,"
      (30 33 "area"))
     ("                therefore,   do  not  require  regular  garbage  collecting.")
     ("                However, you can explicitly garbage collect  a  static  area"
      (72 75 "area"))
     ("                when necessary.  ")
     ("  ")
     ("")))
   ("statistic counters" (("                See Counters.  " (20 27
                                                                 "Counters"))
                          ("  ")
                          ("")))
   ("STATUS key"
    (("                See information and status keys.  "
      (20 46 "information and status keys"))
     ("  ")
     ("")))
   ("status line"
    (("                A  line  in  normal  video at the bottom of the display that"
      (29 41 "normal video"))
     ("                indicates the status of the system.  From left to right  the"
      (44 49 "system"))
     ("                status  line  shows  the date and time, your login name, the")
     ("                current package, various status messages, and the run  bars."
      (16 30 "current package")
      (41 54 "status message")
      (66 74 "run bars"))
     ("                The  status line can also show messages from the file server"
      (47 53 "message")
      (65 75 "file server"))
     ("                or the print server.  " (23 34 "print server"))
     ("  ")
     ("")))
   ("status message"
    (("                A word or phrase appearing in the status line that describes"
      (18 21 "word")
      (50 60 "status line"))
     ("                the current state or  activity.   For  example,  the  status")
     ("                message Keyboard, indicates that the process in the selected"
      (16 22 "message")
      (53 59 "process")
      (68 73 "select"))
     ("                window is waiting for input from the keyboard.  "
      (16 21 "window"))
     ("  ")
     ("")))
   ("Stepper"
    (("                A  facility  that  allows  you  to  follow  each step in the")
     ("                evaluation of a Lisp form and examine what is going on.  The"
      (16 25 "evaluation")
      (32 40 "Lisp form"))
     ("                Stepper has a number of commands  to  control  the  stepping"
      (30 35 "number"))
     ("                sequence.  " (16 23 "sequence"))
     ("  ")
     ("")))
   ("sticky minor mode"
    (("                See Zmacs minor mode.  " (20 35 "Zmacs minor mode"))
     ("  ")
     ("")))
   ("stop-and-collect garbage collection"
    (("                A  type  of  garbage  collection  that occurs at a specified")
     ("                point in your program or whenever you turn  on  the  garbage"
      (16 20 "point"))
     ("                collector in this mode.  ")
     ("  ")
     ("")))
   ("stream"
    (("                A  Lisp  object  that serves as a software channel for input"
      (19 30 "Lisp object"))
     ("                and output.  The use of streams allows  I//O  devices  to  be")
     ("                handled  in  a standard manner so that a program need not be")
     ("                concerned with the details of a particular device.  A set of"
      (70 72 "set"))
     ("                standard  operations  is   available   for   every   stream.")
     ("                Additional  operations  are  defined  for  specific types of")
     ("                streams.  ")
     ("  ")
     ("")))
   ("string"
    (("                A  one-dimensional  array  that  represents  a  sequence  of"
      (36 40 "array")
      (64 71 "sequence"))
     ("                characters.  " (16 24 "character"))
     ("  ")
     ("")))
   ("structure"
    (("                A  named,  compound  data  object  consisting  of  different"
      (43 48 "object"))
     ("                components, which are  also  named;  also  called  a  record")
     ("                structure.   In  order  to  access the different components,")
     ("                both the structure name and component name must be used.  ")
     ("  ")
     ("")))
   ("structure access function"
    (("                See access function.  " (20 34 "access function"))
     ("  ")
     ("")))
   ("structure instance"
    (("                A single occurrence of a record structure  that  is  created"
      (41 56 "record structure"))
     ("                from a predefined structure template.  "
      (34 42 "structure"))
     ("  ")
     ("")))
   ("subdirectory"
    (("                A  directory  that is part of another superior directory.  A"
      (19 27 "directory"))
     ("                subdirectory looks similar to any other file in the superior"
      (56 59 "file"))
     ("                directory.  On the Explorer system, the syntax of a pathname"
      (16 24 "directory")
      (44 49 "system")
      (56 61 "syntax")
      (68 75 "pathname"))
     ("                in a subdirectory is as follows:  ")
     ("  ")
     ("                host:superior-name.sub-name;name.type#version ")
     ("  ")
     ("                On most file systems, any reasonable number of  subdirectory"
      (24 34 "file system")
      (53 58 "number"))
     ("                levels can exist.  ")
     ("  ")
     ("")))
   ("subwindow" (("                See pane.  " (20 23 "pane")) ("  ") ("")))
   ("Suggestions menu"
    (("                A  type  of  menu  that  lists  the  commands available to a"
      (29 32 "menu")
      (41 44 "list"))
     ("                particular utility and//or types of things that can  be  done")
     ("                in  the  current  situation.   The  menus change dynamically"
      (52 55 "menu"))
     ("                according to  what  you  are  doing.   Many  of  the  system"
      (70 75 "system"))
     ("                utilities  have a Suggestions menu, which you can turn on or"
      (46 49 "menu"))
     ("                off.  You can tailor an existing Suggestions  menu  to  meet"
      (62 65 "menu"))
     ("                your  needs,  or  you can build a Suggestions menu on top of"
      (62 65 "menu"))
     ("                the UCL for your application.  " (20 22 "UCL")
                                                        (33 43
                                                            "application"))
     ("  ")
     ("")))
   ("SUPER key"
    (("                See modifier keys.  " (20 32 "modifier keys")) ("  ")
                                                                      ("")))
   ("superior window"
    (("                A  higher-level  window.   For  example,  a  screen  is  the"
      (33 38 "window")
      (61 66 "screen"))
     ("                superior  of  a  window,  and  a window is the superior of a"
      (33 38 "window"))
     ("                pane.  The position of a window is remembered  in  terms  of"
      (16 19 "pane")
      (41 46 "window"))
     ("                where it is within its superior.  ")
     ("  ")
     ("")))
   ("surface-mount technology"
    (("                A technique  in  which  chip  carrier  circuits are soldered")
     ("                directly to the surface of a board, allowing greater packing")
     ("                density, higher performance, and  lower costs than  previous")
     ("                methods.  " (16 21 "method"))
     ("                  ")
     ("")))
   ("symbol"
    (("                A Lisp object used as  an  identifier  to  name  other  Lisp"
      (18 28 "Lisp object"))
     ("                objects   and   variables.    Internally,   each  symbol  is"
      (16 21 "object")
      (32 39 "variable"))
     ("                represented as a structure  with  the  following  components"
      (33 41 "structure"))
     ("                (cells):  ")
     ("  ")
     ("                *  Print name " (19 28 "print name"))
     ("  ")
     ("                *  Value cell " (19 28 "value cell"))
     ("  ")
     ("                *  Function definition cell "
      (19 42 "function definition cell"))
     ("  ")
     ("                *  Property list " (19 31 "property list"))
     ("  ")
     ("                *  Package cell " (19 30 "package cell"))
     ("  ")
     ("                These  cells  contain  information  about  the  symbol,  and")
     ("                functions are provided to manipulate  this  information,  as"
      (16 23 "function"))
     ("                well as the symbol itself.  ")
     ("  ")
     ("")))
   ("symbol inheritance"
    (("                To enable external symbols of a package to become accessible"
      (26 40 "external symbol")
      (48 54 "package"))
     ("                to another package without the use of package qualifiers.  "
      (27 33 "package")
      (54 70 "package qualifier"))
     ("  ")
     ("")))
   ("SYMBOL key"
    (("                See modifier keys.  " (20 32 "modifier keys")) ("  ")
                                                                      ("")))
   ("syntax"
    (("                The  set  of  rules that govern the legal order of words and"
      (21 23 "set")
      (67 70 "word"))
     ("                the meaning of special characters within  a  language.   For"
      (39 47 "character"))
     ("                Lisp,  the  read  function  reads  a character from an input"
      (16 19 "Lisp")
      (34 41 "function")
      (53 61 "character"))
     ("                stream  and   interprets   it,   and   possibly   subsequent"
      (16 21 "stream"))
     ("                characters, depending on the type of the character.  "
      (16 24 "character"))
     ("  ")
     ("")))
   ("system"
    (("                1.  The hardware and software that make up a single Explorer")
     ("                system.   This   overall   system   includes  many  standard")
     ("                utilities, including the  Lisp Listener,  the Zmacs  editor,"
      (42 54 "Lisp Listener")
      (62 66 "Zmacs"))
     ("                the Inspector,  and  so  on.   An  Explorer  system can also"
      (20 28 "Inspector"))
     ("                include optional  toolkits  such  as  the  Relational  Table")
     ("                Management System (RTMS).  You can access most utilities  in")
     ("                an Explorer system by selecting an item from the System menu"
      (38 43 "select")
      (65 75 "System menu"))
     ("                or by pressing the SYSTEM key and a letter.  You can display"
      (35 44 "SYSTEM key"))
     ("                a list of the keys used  to invoke utilities on your  system"
      (18 21 "list"))
     ("                by pressing SYSTEM HELP.  ")
     ("                  ")
     ("                2.  A collection of files that comprise a program or set  of"
      (36 39 "file")
      (69 71 "set"))
     ("                programs.  Once a system  is defined, the  system definition"
      (59 75 "system definition"))
     ("                facility handles the recompilation and loading of the  files"
      (55 58 "load")
      (71 74 "file"))
     ("                that make up the system.  ")
     ("                  ")
     ("                ")
     ("")))
   ("system console"
    (("                See console.  " (20 26 "console")) ("  ") ("")))
   ("system definition"
    (("                A means to divide a large  program  into  several  files  in"
      (67 70 "file"))
     ("                order  to  keep  the  parts  of the program organized.  This")
     ("                makes items easier to find and results in  smaller  portions")
     ("                of code to edit and compile.  " (36 42 "compile"))
     ("  ")
     ("                The  system facility, which uses the defsystem macro, allows"
      (21 26 "system")
      (63 67 "macro"))
     ("                you to specify which files make up the  system,  which  ones"
      (37 40 "file")
      (56 61 "system"))
     ("                depend  on  the  presence  of others, and so on.  The system"
      (70 75 "system"))
     ("                definition resides in its own file, which you load to inform"
      (46 49 "file")
      (62 65 "load"))
     ("                the Lisp environment about your system and what files are in"
      (20 23 "Lisp")
      (25 35 "environment")
      (48 53 "system")
      (64 67 "file"))
     ("                it.  You can then use the make-system function to  load  all"
      (54 61 "function")
      (67 70 "load"))
     ("                the  files  of the system, recompile all the files that need"
      (21 24 "file")
      (35 40 "system"))
     ("                compiling, and so on.  ")
     ("  ")
     ("")))
   ("system enclosure"
    (("                A compact enclosure that houses the system logic boards, the"
      (52 57 "system"))
     ("                backplane,  power  supplies,  and  PCA  boards   and   cable"
      (16 24 "backplane")
      (51 60 "PCA board"))
     ("                connections to peripheral devices.  ")
     ("  ")
     ("")))
   ("system interface board"
    (("                A  logic  board  installed  in  the  system  enclosure  that"
      (53 69 "system enclosure"))
     ("                provides an interface to the display unit, graphics  control"
      (45 56 "display unit"))
     ("                logic, both parallel and serial I//O ports, and various other")
     ("                system  resources,  such  as  clocks,  timers,   nonvolatile"
      (16 21 "system")
      (24 31 "resource"))
     ("                memory, and power failure event logic.  "
      (42 46 "event"))
     ("                  ")
     ("                ")
     ("")))
   ("SYSTEM key"
    (("                See information and status keys.  "
      (20 46 "information and status keys"))
     ("")))
   ("System menu"
    (("                A top-level menu that can be invoked from any system utility"
      (18 26 "top-level")
      (28 31 "menu")
      (62 67 "system"))
     ("                by  clicking  the  right  mouse  button  once or twice.  The"
      (20 24 "click")
      (42 46 "mouse"))
     ("                System menu allows you to invoke and manipulate  windows  on"
      (16 21 "system")
      (23 26 "menu")
      (65 70 "window"))
     ("                the screen layout.  " (20 25 "screen"))
     ("  ")
     ("")))
   ("system reset"
    (("                The  complete  initializing  of  the system, either when the"
      (53 58 "system"))
     ("                system first powers up  or  when  you  press  the  keystroke"
      (16 21 "system")
      (23 27 "first"))
     ("                sequence  META-CTRL-META-CTRL-ABORT.  During a system reset,"
      (16 23 "sequence")
      (63 68 "system")
      (70 74 "reset"))
     ("                the system performs hardware self-tests; loads the microcode"
      (20 25 "system")
      (57 60 "load")
      (67 75 "microcode"))
     ("                contained in the microload partition; loads the  load  band,"
      (33 51 "microload partition")
      (54 57 "load")
      (71 74 "band"))
     ("                which destroys any contents of virtual memory; initializes a")
     ("                file   system;   performs   other   tasks   defined  in  the"
      (16 28 "file system"))
     ("                initialization lists; and invokes a program,  by  default  a"
      (31 34 "list"))
     ("                Lisp  Listener.   At  system  reset,  you have the option of"
      (16 29 "Lisp Listener")
      (38 43 "system")
      (46 50 "reset"))
     ("                specifying the device, load band, and  microload  band  from"
      (39 42 "load")
      (44 47 "band"))
     ("                which the system boots.  " (26 31 "system")
                                                  (33 36 "boot"))
     ("                  ")
     ("                In contrast to  resetting the  system, cold  booting reloads"
      (47 52 "system")
      (55 64 "cold boot"))
     ("                the load band and microload band that you use when you reset"
      (20 23 "load")
      (25 28 "band")
      (71 75 "reset"))
     ("                but does  not  perform  any  hardware  tests.   Menu booting"
      (64 72 "menu boot"))
     ("                offers you the  same options  for booting  as resetting  the"
      (50 53 "boot"))
     ("                system does  but,  again,  does  not perform hardware tests."
      (16 21 "system"))
     ("                Both cold  booting  and  menu  booting  reinitialize virtual"
      (21 30 "cold boot")
      (41 50 "menu boot"))
     ("                memory. Warm booting resets  and restarts all  processes but"
      (24 32 "warm boot")
      (37 41 "reset")
      (63 69 "process"))
     ("                does not destroy  the contents  of virtual  memory or edited")
     ("                buffers." (16 21 "buffer"))
     ("                ")
     ("")))
   ("t"
    (("                A  symbol  used  to represent the Boolean value true when no"
      (19 24 "symbol"))
     ("                other value is more appropriate.")
     ("")))
   ("TAB key"
    (("                See line-positioning keys and number pad.  "
      (20 40 "line-positioning keys")
      (46 55 "number pad"))
     ("  ")
     ("")))
   ("tab-stop buffer"
    (("                A Zmacs buffer that allows you to set tab stops.  "
      (18 29 "Zmacs buffer")
      (50 52 "set"))
     ("  ")
     ("")))
   ("tag"
    (("                Analogous to a  statement  label  in  other  languages  like"
      (43 47 "label"))
     ("                Fortran  and  PL//1.   A tag enables the goto construct to be")
     ("                performed in Lisp.  " (29 32 "Lisp"))
     ("  ")
     ("")))
   ("Telnet"
    (("                A facility that allows you to use its window as  a  terminal"
      (54 59 "window"))
     ("                to  another  host.   Telnet  sends  characters  typed on the"
      (29 32 "host")
      (52 60 "character"))
     ("                keyboard to the remote host's Telnet server.  "
      (53 58 "server"))
     ("  ")
     ("")))
   ("temp-locking"
    (("                Temporarily locks an exposed window so that output cannot be"
      (37 50 "exposed window"))
     ("                sent to it while a temporary  window  is  exposed.   When  a"
      (35 51 "temporary window"))
     ("                window  is  covered--or  partially  covered--by  a temporary"
      (16 21 "window"))
     ("                window such as the System menu, output sent to  the  exposed"
      (16 21 "window")
      (35 45 "System menu"))
     ("                window  overwrites  the  temporary  window;  therefore,  the"
      (16 21 "window")
      (41 57 "temporary window"))
     ("                exposed window is temp-locked  until  the  temporary  window"
      (16 29 "exposed window")
      (59 75 "temporary window"))
     ("                disappears.  ")
     ("  ")
     ("")))
   ("temporary window"
    (("                A  window  that appears on the display for a short period of"
      (19 24 "window"))
     ("                time and goes away after you have  performed  an  action  to")
     ("                remove  it.   You  must remove a temporary window before you"
      (59 64 "window"))
     ("                can manipulate any windows  that  the  temporary  window  is"
      (35 40 "window"))
     ("                covering  (either  partially  or fully).  A temporary window"
      (70 75 "window"))
     ("                does not deexpose the window(s) it covers up.  "
      (38 43 "window"))
     ("  ")
     ("")))
   ("TERM key"
    (("                See information and status keys.  "
      (20 46 "information and status keys"))
     ("  ")
     ("")))
   ("test zone partition"
    (("                A partition that contains data patterns used  in  diagnostic"
      (18 26 "partition"))
     ("                testing.  ")
     ("  ")
     ("")))
   ("Text mode"
    (("                See Zmacs major mode.  " (20 35 "Zmacs major mode"))
     ("  ")
     ("")))
   ("text scroll window"
    (("                A  window  that  provides  a  simple means of displaying and"
      (19 24 "window"))
     ("                scrolling a  number  of  lines  of  similar  material.   For"
      (16 24 "scrolling")
      (29 34 "number"))
     ("                example, editor windows and menus can scroll.  "
      (32 37 "window")
      (44 47 "menu"))
     ("")))
   ("throw"
    (("                A special form used with catch to perform nonlocal exits.  A"
      (18 29 "special form")
      (41 45 "catch")
      (58 70 "nonlocal exit"))
     ("                throw  transfers control to a matching catch construct.  The"
      (55 59 "catch"))
     ("                throw form need not be within the body of  the  catch  form,"
      (22 25 "form")
      (64 68 "catch"))
     ("                but it must occur within the extent of the evaluation of the"
      (45 50 "extent")
      (59 68 "evaluation"))
     ("                body of the catch.  " (28 32 "catch"))
     ("  ")
     ("")))
   ("toggle"
    (("                To complement or switch back and forth between two states of")
     ("                a condition.  " (18 26 "condition"))
     ("  ")
     ("")))
   ("top-level"
    (("                A  level  of  control  that  is not contained within another")
     ("                level.  For example, a top-level function is one that has no"
      (49 56 "function"))
     ("                other callers.  ")
     ("  ")
     ("")))
   ("top-level directory"
    (("                See root directory.  " (20 33 "root directory"))
     ("  ")
     ("")))
   ("top-level loop"
    (("                The highest level of control in a process, consisting of  an"
      (50 56 "process"))
     ("                endless  read-eval-print  loop  that reads a form, evaluates"
      (25 45 "read-eval-print loop")
      (61 64 "form"))
     ("                it, and prints the results.  ")
     ("  ")
     ("")))
   ("trace"
    (("                A facility  that  allows  you  to examine certain functions."
      (66 73 "function"))
     ("                When a function is traced, certain special actions are taken"
      (23 30 "function"))
     ("                when it is called and when it returns.  The default  tracing")
     ("                action is to print  a message when  the function is  called,"
      (38 44 "message")
      (56 63 "function"))
     ("                showing its name and arguments, and another message when the"
      (37 44 "argument")
      (60 66 "message"))
     ("                function returns, showing its name and value(s).  "
      (16 23 "function"))
     ("  ")
     ("")))
   ("tracking the mouse"
    (("                A term that describes how the  mouse  process  examines  the"
      (47 60 "mouse process"))
     ("                hardware mouse interface, notes how the mouse is moving, and"
      (25 29 "mouse"))
     ("                adjusts  the  mouse  cursor  position  and the mouse blinker"
      (16 21 "adjust")
      (30 42 "mouse cursor")
      (69 75 "blinker"))
     ("                accordingly.  ")
     ("  ")
     ("")))
   ("transceiver"
    (("                See Ethernet transceiver.  "
      (20 39 "Ethernet transceiver"))
     ("  ")
     ("")))
   ("transformation"
    (("                An operation, such as compiling or loading, that  is  to  be"
      (51 54 "load"))
     ("                performed  on  a  set  of files that comprise a system.  The"
      (34 36 "set")
      (42 45 "file")
      (64 69 "system"))
     ("                system definition facility  has  a  number  of  options  for"
      (16 32 "system definition")
      (52 57 "number"))
     ("                specifying   the   transformations  or  the  conditions  for"
      (61 69 "condition"))
     ("                transformations to occur.  ")
     ("  ")
     ("")))
   ("trap"
    (("                A special software subroutine activated whenever a condition"
      (67 75 "condition"))
     ("                has been met that is not part of normal  program  execution.")
     ("                This  subroutine  usually  halts execution immediately after")
     ("                recording certain information, such as the location  of  the")
     ("                program counter or the contents of various status registers."
      (66 73 "register"))
     ("")))
   ("tree editor"
    (("                A tool that graphically displays any tree-structured object."
      (69 74 "object"))
     ("                To use the tree editor for a specific application, you write"
      (54 64 "application"))
     ("                simple interface  routines  that  enable  it to traverse the")
     ("                tree structure,  to  handle  node  selection, and to provide"
      (21 29 "structure"))
     ("                editing functions on the  tree structure or  on the data  in"
      (24 31 "function")
      (47 55 "structure"))
     ("                the nodes.  ")
     ("                  ")
     ("")))
   ("true list" (("                See list.  " (20 23 "list")) ("  ") ("")))
   ("type specifier"
    (("                See data type specifier.  "
      (20 38 "data type specifier"))
     ("  ")
     ("")))
   ("type-ahead buffer"
    (("                A  special  buffer that stores keystrokes as you enter them."
      (28 33 "buffer"))
     ("                The buffer accommodates  speedy  typists,  allowing  you  to"
      (20 25 "buffer"))
     ("                continue  typing  even  though  the  system  cannot read and"
      (53 58 "system"))
     ("                evaluate your input as quickly as you enter it.  The  system"
      (70 75 "system"))
     ("                does  not evaluate your input (echo it on the display) until")
     ("                you have stopped typing.  ")
     ("  ")
     ("")))
   ("typeout window"
    (("                A  window  that  prints  output,  usually  in  response   to"
      (19 24 "window"))
     ("                individual  commands,  from other windows.  A typeout window"
      (50 55 "window"))
     ("                exposes itself when output is directed to it.   The  typeout")
     ("                window  is  an  inferior of the window from which the output"
      (16 21 "window")
      (32 39 "inferior"))
     ("                comes.  ")
     ("")))
   ("UCL"
    (("                See Universal Command Loop.  "
      (20 41 "Universal Command Loop"))
     ("  ")
     ("")))
   ("unbind"
    (("                To make a bound variable have either no value or  the  value"
      (26 39 "bound variable"))
     ("                it was formerly bound to if it was temporarily bound.  ")
     ("  ")
     ("")))
   ("unbound symbol"
    (("                A symbol that has no value; its value cell is empty.  "
      (18 23 "symbol")
      (48 57 "value cell"))
     ("  ")
     ("")))
   ("UNDO key"
    (("                See user interaction keys.  "
      (20 40 "user interaction keys"))
     ("  ")
     ("")))
   ("uninterned symbol"
    (("                A  symbol  that  does  not belong to a package; the symbol's"
      (19 24 "symbol")
      (55 61 "package"))
     ("                package cell contains nil.   Typically,  uninterned  symbols"
      (16 27 "package cell")
      (38 40 "nil")
      (69 74 "symbol"))
     ("                are used simply as data objects.  " (40 45 "object"))
     ("  ")
     ("")))
   ("uninterned symbol qualifier"
    (("                A  symbol  whose  package  cell  contains  nil (that is, the"
      (19 24 "symbol")
      (34 46 "package cell")
      (59 61 "nil"))
     ("                symbol has no home package); when  printed,  the  symbol  is"
      (16 21 "symbol")
      (30 41 "home package"))
     ("                preceded by #:.  ")
     ("  ")
     ("")))
   ("uninterning a symbol"
    (("                To cause a symbol to belong to no package.  "
      (27 32 "symbol")
      (50 56 "package"))
     ("  ")
     ("")))
   ("Universal Command Loop"
    (("                A  facility  for  constructing  a  command loop that accepts")
     ("                various forms of user input (menu selection with the  mouse,"
      (24 27 "form")
      (70 74 "mouse"))
     ("                keystroke  sequence,  or  typed command name) and interprets"
      (16 34 "keystroke sequence"))
     ("                the input as requests for command  execution.   It  provides")
     ("                structures for command definitions and  command  tables,  as"
      (16 24 "structure"))
     ("                well as a number of help facilities for the interface.  "
      (26 31 "number"))
     ("                  ")
     ("                ")
     ("")))
   ("universal time"
    (("                A  standard way of indicating time that counts the number of"
      (67 72 "number"))
     ("                seconds since midnight Greenwich Mean  Time  on  January  1,")
     ("                1900.  ")
     ("                  ")
     ("                ")
     ("")))
   ("unnamed function"
    (("                See lambda expression.  " (20 36 "lambda expression"))
     ("  ")
     ("")))
   ("unnamed structure"
    (("                An  explicitly  specified  structure  that,  when defined by"
      (20 51 "explicitly specified structure"))
     ("                defstruct, does not use the :named  option  when  using  the")
     ("                :type  option.   This  results in a structure that cannot be"
      (52 60 "structure"))
     ("                referred to by name.  ")
     ("  ")
     ("")))
   ("unreduced ratio"
    (("                A ratio number that is in a form such that further factoring"
      (24 29 "number")
      (44 47 "form"))
     ("                with  the  denominator  and   numerator  of  the   number is"
      (67 72 "number"))
     ("                possible.")
     ("  ")
     ("")))
   ("unsticky minor mode"
    (("                See Zmacs minor mode.  " (20 35 "Zmacs minor mode"))
     ("  ")
     ("")))
   ("update attribute list"
    (("                To permanently record the current  settings  of  the  buffer"
      (70 75 "buffer"))
     ("                attributes in the attribute list of a Zmacs buffer (that is,"
      (34 47 "attribute list")
      (54 65 "Zmacs buffer"))
     ("                buffer  attributes  that are changed but not recorded in the"
      (16 21 "buffer"))
     ("                attribute list, such as changing modes with a mode command)."
      (16 29 "attribute list"))
     ("                The changes are also saved when the file is written to disk."
      (37 40 "save")
      (52 55 "file"))
     ("                This operation is the inverse of the reparse attribute  list"
      (53 75 "reparse attribute list"))
     ("                operation,   which  records  editing  changes  made  to  the")
     ("                attribute list and makes them take effect.  "
      (16 29 "attribute list"))
     ("  ")
     ("")))
   ("update operation"
    (("                Any  operation  that  alters  the  value  of  a  generalized")
     ("                variable.  " (16 23 "variable"))
     ("  ")
     ("")))
   ("user directory"
    (("                A  directory that contains an arbitrary number (0 through n)"
      (19 27 "directory")
      (56 61 "number"))
     ("                of other user directories (called subdirectories) and files."
      (70 73 "file"))
     ("                It can also contain nothing (called an empty directory).  "
      (61 69 "directory"))
     ("  ")
     ("")))
   ("user interaction keys"
    (("                The set of keys that enable you to modify  the  contents  of"
      (20 22 "set"))
     ("                the  video display or to leave certain programs.  These keys")
     ("                are the following:  ")
     ("  ")
     ("                *  CLEAR INPUT -- Erases the  characters  that  you  have"
      (46 54 "character"))
     ("                   typed.  Depending on the software, this key erases the")
     ("                   characters  on  the current line or all the characters"
      (19 27 "character"))
     ("                   typed  since  the  last  complete  function,   or   it"
      (54 61 "function"))
     ("                   redisplays a window obscured by an error handler.  "
      (32 37 "window")
      (54 66 "error handler"))
     ("  ")
     ("                *  CLEAR  SCREEN  --  Clears the contents of the selected"
      (26 31 "screen")
      (65 70 "select"))
     ("                   window.  Zmacs refers to this as the PAGE key.  "
      (19 24 "window")
      (28 32 "Zmacs")
      (56 59 "page"))
     ("  ")
     ("                *  END -- Depending on the software, this key is used  to")
     ("                   terminate a command, conversation, or application.  "
      (57 67 "application"))
     ("  ")
     ("                *  ESCAPE  -- Depending on the software, this key is used")
     ("                   to escape from search mode.  In  Zmacs,  this  key  is"
      (52 56 "Zmacs"))
     ("                   used with modifier keys to invoke command completion. "
      (29 41 "modifier keys")
      (61 70 "completion"))
     ("  ")
     ("                *  UNDO  --  Depending on the software, this key reverses")
     ("                   an action taken.  ")
     ("  ")
     ("")))
   ("user variable"
    (("                See Zmacs user variable.  "
      (20 38 "Zmacs user variable"))
     ("  ")
     ("")))
   ("usurping the mouse"
    (("                The act of setting aside the mouse  process  and  explicitly"
      (45 58 "mouse process"))
     ("                doing  all  the mouse tracking.  The mouse blinker is turned"
      (32 36 "mouse")
      (59 65 "blinker"))
     ("                off, so the usurping process must provide a mouse blinker if"
      (37 43 "process")
      (60 64 "mouse")
      (66 72 "blinker"))
     ("                a visual indicator is necessary. " (25 33
                                                              "indicator"))
     ("")))
   ("value cell"
    (("                A component of a symbol that contains the  symbol's  current"
      (33 38 "symbol"))
     ("                value  or  binding.   This  is  the  value returned when the"
      (27 33 "binding"))
     ("                symbol is evaluated, and it can refer to  any  Lisp  object."
      (16 21 "symbol")
      (63 74 "Lisp object"))
     ("                If the value cell is empty, the symbol is unbound.  "
      (48 53 "symbol"))
     ("  ")
     ("")))
   ("vanilla flavor"
    (("                A   base   flavor   that,  unless  otherwise  specified,  is"
      (20 32 "base flavor"))
     ("                automatically included in every defined flavor.  The vanilla"
      (56 61 "flavor"))
     ("                flavor has no instance variables but provides methods useful"
      (16 21 "flavor")
      (30 46 "instance variable")
      (62 67 "method"))
     ("                for all flavors.  " (24 29 "flavor"))
     ("  ")
     ("")))
   ("variable"
    (("                An abstract object that  signifies  any  actual  value.   In"
      (28 33 "object"))
     ("                Lisp, variables are implemented as symbols.  "
      (16 19 "Lisp")
      (51 56 "symbol"))
     ("  ")
     ("")))
   ("vector"
    (("                A one-dimensional array.  " (34 38 "array")) ("  ")
                                                                    ("")))
   ("version number"
    (("                1.  A number  associated with  a file  or system  definition"
      (22 27 "number")
      (49 52 "file")
      (58 75 "system definition"))
     ("                that indicates a sequence of  updates.  Each time a  file is"
      (33 40 "sequence")
      (69 72 "file"))
     ("                edited and saved, a  new copy of  the file is  made with its"
      (27 30 "save")
      (54 57 "file"))
     ("                version number incremented  by 1.   (You can  also specify a"
      (24 29 "number"))
     ("                version number not in sequence.)  " (24 29 "number")
                                                           (38 45
                                                               "sequence"))
     ("                  ")
     ("                2.  The version  number of  a system  definition consists of"
      (33 38 "number")
      (46 63 "system definition"))
     ("                two parts: the  minor version  number and  the major version"
      (32 52 "minor version number"))
     ("                number.  The minor version number is increased every time  a"
      (16 21 "number")
      (29 48 "minor version number"))
     ("                new patch is made to  the system.  The major  version number"
      (20 24 "patch")
      (42 47 "system")
      (55 75 "major version number"))
     ("                is increased when  the system  is completely  recompiled and"
      (39 44 "system"))
     ("                the minor version number is reset to 0.  "
      (20 39 "minor version number")
      (44 48 "reset"))
     ("                  ")
     ("                ")
     ("")))
   ("vertical index"
    (("                A  row  subscript  for  a  two-dimensional  array.   On  the"
      (60 64 "array"))
     ("                Explorer system, this is the first subscript.  "
      (25 30 "system")
      (45 49 "first"))
     ("")))
   ("vertical spacing" (("                See VSP.  " (20 22 "VSP")) ("  ")
                                                                     ("")))
   ("view"
    (("                To cause Zmacs  to display  the contents  of a  file without"
      (25 29 "Zmacs")
      (64 67 "file"))
     ("                reading it  into  a  buffer  first.   You cannot edit a file"
      (37 42 "buffer")
      (45 49 "first")
      (72 75 "file"))
     ("                while you are viewing it.  See also visit.  "
      (52 56 "visit"))
     ("                  ")
     ("                ")
     ("")))
   ("virtual address space"
    (("                The total  amount  of  memory  that  can be addressed by the")
     ("                system.   In  the  Explorer  system,  this  amount  is   128"
      (16 21 "system"))
     ("                megabytes.  ")
     ("                  ")
     ("                ")
     ("")))
   ("virtual window"
    (("                A window that is--or  may  be--too  large  to  be  displayed"
      (18 23 "window"))
     ("                within  an  actual window.  A virtual window is displayed in"
      (35 40 "window"))
     ("                portions by a scrolling window.  "
      (30 45 "scrolling window"))
     ("  ")
     ("")))
   ("visible window"
    (("                A window that is currently displayed on a screen.  A  window"
      (18 23 "window")
      (58 63 "screen"))
     ("                is  fully visible if no other window is covering any part of"
      (46 51 "window"))
     ("                it; a window is partially visible if  any other  windows are"
      (22 27 "window"))
     ("                covering part of it.  ")
     ("  ")
     ("")))
   ("visit"
    (("                To  cause Zmacs to copy a file into a buffer so that you can"
      (26 30 "Zmacs")
      (42 45 "file")
      (54 59 "buffer"))
     ("                edit the file.  You work on the buffer as  if  it  were  the"
      (25 28 "file")
      (48 53 "buffer"))
     ("                file.  See also view.  " (16 19 "file")
                                                (32 35 "view"))
     ("  ")
     ("")))
   ("VSP"
    (("                The  number of blank rows of pixels between lines of text in"
      (21 26 "number")
      (45 49 "pixel"))
     ("                a window.  VSP stands for vertical spacing.  "
      (18 23 "window")
      (42 57 "vertical spacing"))
     ("  ")
     ("")))
   ("VT100 emulator"
    (("                A window-based facility that allows you to use your Explorer"
      (18 23 "window"))
     ("                monitor and keyboard as a  VT100  terminal.   When  you  are")
     ("                using  the  VT100 emulator, all alphabetic and nonalphabetic")
     ("                keys, cursor control keys, and most function  keys  transmit"
      (52 65 "function keys"))
     ("                the VT100 key codes to a connected host.  "
      (51 54 "host"))
     ("                  ")
     ("                VT100 is a trademark of Digital Equipment Corporation. ")
     ("")))
   ("warm boot"
    (("                The resetting and restarting of all processes in the system."
      (52 58 "process")
      (69 74 "system"))
     ("                Warm  booting  retains  unchanged  the  contents  of virtual"
      (22 25 "boot"))
     ("                memory and edited buffers.  You can warm  boot  by  pressing"
      (34 39 "buffer")
      (58 61 "boot"))
     ("                META-CTRL-META-CTRL-RETURN.   See also cold boot,"
      (55 63 "cold boot"))
     ("                menu boot, and system reset.  " (16 24 "menu boot")
                                                       (31 42
                                                           "system reset"))
     ("")))
   ("warping the mouse"
    (("                A term that describes how the program moves the mouse cursor"
      (64 75 "mouse cursor"))
     ("                and changes the logical position of the mouse.  For example,"
      (56 60 "mouse"))
     ("                double clicking left in the editor warps the mouse to  where"
      (23 27 "click")
      (61 65 "mouse"))
     ("                the editor cursor is currently  located.  Since there is  no")
     ("                fixed association between positions of the physical mouse on"
      (68 72 "mouse"))
     ("                an optical  pad  and  positions  of  the mouse cursor on the"
      (28 30 "pad")
      (57 68 "mouse cursor"))
     ("                screen,  warping   the   mouse   does   not  result  in  any"
      (16 21 "screen")
      (41 45 "mouse"))
     ("                inconsistency.  ")
     ("                  ")
     ("                ")
     ("")))
   ("whitespace"
    (("                One  of  the  following  characters:   space,  tab,  return,")
     ("                linefeed, page, and newline.  " (26 29 "page"))
     ("  ")
     ("")))
   ("who-line"
    (("                A term previously used to  refer to the combination  of both")
     ("                the mouse documentation window and the status line.  "
      (20 45 "mouse documentation window")
      (55 65 "status line"))
     ("                ")
     ("")))
   ("wildcard"
    (("                A special character (*) that can be substituted either for a"
      (26 34 "character"))
     ("                missing  pathname  component, or for missing characters in a"
      (25 32 "pathname")
      (61 69 "character"))
     ("                pathname component.  " (16 23 "pathname"))
     ("  ")
     ("")))
   ("window"
    (("                A rectangular region that can be displayed on a  screen.   A"
      (30 35 "region")
      (65 70 "screen"))
     ("                window  is associated with one process and acts as a stream,"
      (47 53 "process")
      (69 74 "stream"))
     ("                providing a place for the process to write to and read from."
      (28 32 "place")
      (42 48 "process"))
     ("                Each window is  an  instance  of  a  specific  flavor.   The"
      (36 43 "instance")
      (63 68 "flavor"))
     ("                window's flavor governs how the window and process interact."
      (25 30 "flavor")
      (59 65 "process"))
     ("  ")
     ("")))
   ("window status"
    (("                A  condition  that  indicates  whether  or  not  a window is"
      (19 27 "condition")
      (67 72 "window"))
     ("                exposed or selected.  " (27 32 "select"))
     ("  ")
     ("")))
   ("window system"
    (("                A collection of software that manages the display of various")
     ("                processes and directs input from the keyboard  or  mouse  to"
      (16 22 "process")
      (67 71 "mouse"))
     ("                the  appropriate  process.   " (34 40 "process"))
     ("                  ")
     ("                ")
     ("")))
   ("window-based debugger"
    (("                A window-oriented version  of  the  debugger  that  includes"
      (18 23 "window")
      (52 59 "debugger"))
     ("                several  panes,  allowing  you  to  view  different types of"
      (25 28 "pane")
      (52 55 "view"))
     ("                information at one time.  ")
     ("  ")
     ("")))
   ("word"
    (("                1.  In the hardware of the Explorer system, a 32-bit  memory"
      (52 57 "system"))
     ("                cell.  ")
     ("  ")
     ("                2.   A  group  of  contiguous  letters containing no blanks.")
     ("                Zmacs contains many commands that operate on the word level."
      (16 20 "Zmacs"))
     ("  ")
     ("")))
   ("word abbreviation"
    (("                A single word that Zmacs  automatically  expands  after  you"
      (25 28 "word")
      (35 39 "Zmacs"))
     ("                type  the abbreviation and a space (or any character that is"
      (59 67 "character"))
     ("                not a letter or a number).  " (34 39 "number"))
     ("  ")
     ("")))
   ("wrapper"
    (("                A  construct  dealing  with  flavors  that  allows  you   to"
      (45 50 "flavor"))
     ("                implement advanced method accessing control.  This construct"
      (35 40 "method"))
     ("                can  surround (or wrap around) a flavor's methods and allows"
      (58 63 "method"))
     ("                specific operations to occur before and after the  execution")
     ("                of any of the flavor's methods. " (39 44 "method"))
     ("")))
   ("xfasl"
    (("                On the  Explorer  system,  the  file  type used for software"
      (34 39 "system")
      (48 57 "file type"))
     ("                releases prior to  3.0 into  which compiled  code is loaded."
      (51 57 "compile")
      (69 72 "load"))
     ("                The x refers to Explorer system source code, and fasl stands"
      (41 46 "system"))
     ("                for fast load.  " (25 28 "load"))
     ("                ")
     ("")))
   ("xld"
    (("                The file  type  of  compiled  code  on  releases of Explorer"
      (20 29 "file type")
      (36 42 "compile"))
     ("                software 3.0 and later.  The x refers to the Explorer system"
      (70 75 "system"))
     ("                and ld stands for loadable code.")
     ("                ")
     ("")))
   ("yank"
    (("                To retrieve an entry from the kill history. "
      (46 57 "kill history"))
     ("")))
   ("zero-origin indexing"
    (("                A type  of  indexing  for  arrays  or sequences in which the"
      (43 47 "array")
      (54 61 "sequence"))
     ("                first index starts with 0.  " (16 20 "first"))
     ("  ")
     ("")))
   ("Zetalisp"
    (("                A dialect of Lisp  developed  at  M.I.T.   that  contributed"
      (29 32 "Lisp")
      (54 54 "t"))
     ("                significantly  to  the  definition of Common Lisp.  Zetalisp"
      (54 64 "Common Lisp"))
     ("                includes most of the features  of  Common  Lisp,  with  some"
      (51 62 "Common Lisp"))
     ("                differences  in  syntax  and functionality, as well as other"
      (33 38 "syntax"))
     ("                features such as the  flavor  system  and  the  loop  macro."
      (38 43 "flavor")
      (46 51 "system")
      (64 74 "loop macro"))
     ("                Zetalisp is fully supported on the Explorer system.  "
      (60 65 "system"))
     ("  ")
     ("")))
   ("Zetalisp mode"
    (("                See Zmacs major mode.  " (20 35 "Zmacs major mode"))
     ("  ")
     ("")))
   ("Zmacs"
    (("                A  real-time, window-oriented editor that provides extensive"
      (30 35 "window"))
     ("                support for writing Lisp programs as well as other types  of"
      (36 39 "Lisp"))
     ("                text.   Zmacs  is  based  on  the  M.I.T.   Emacs editor and"
      (55 55 "t"))
     ("                includes hundreds of  features  for  manipulating  text  and")
     ("                supporting program development.  ")
     ("  ")
     ("")))
   ("Zmacs buffer" (("                See buffer.  " (20 25 "buffer")) ("  ")
                                                                       ("")))
   ("Zmacs buffer history"
    (("                A listing produced by the List Buffers command in Zmacs that"
      (18 21 "list")
      (47 52 "buffer")
      (66 70 "Zmacs"))
     ("                lists  all  the  buffers  in  their  most recently used (not"
      (16 19 "list")
      (33 38 "buffer"))
     ("                created) order.  ")
     ("  ")
     ("")))
   ("Zmacs editor buffer window"
    (("                The upper section of the Zmacs display in which you edit.  "
      (26 32 "section")
      (41 45 "Zmacs"))
     ("  ")
     ("")))
   ("Zmacs major mode"
    (("                A mode of operation  that tells Zmacs  what type of  file is"
      (48 52 "Zmacs")
      (69 72 "file"))
     ("                being edited.  A major mode has its own distinct set of  key"
      (33 42 "major mode")
      (65 67 "set"))
     ("                bindings, indentation, and delimiters.  Only one major  mode"
      (16 22 "binding")
      (65 75 "major mode"))
     ("                can be in effect for a given buffer at a time.  Some of  the"
      (45 50 "buffer"))
     ("                major modes available are the following:"
      (16 25 "major mode"))
     ("  ")
     ("                *  Text -- Designed for editing text.  ")
     ("  ")
     ("                *  Common Lisp -- Designed for editing Common Lisp code. "
      (19 29 "Common Lisp"))
     ("  ")
     ("                *  Zetalisp -- Designed for editing Zetalisp code.  "
      (19 26 "Zetalisp"))
     ("  ")
     ("")))
   ("Zmacs minibuffer"
    (("                A small window in Zmacs  below  the  editor  buffer  window,"
      (24 29 "window")
      (34 38 "Zmacs")
      (61 66 "buffer"))
     ("                where  prompts  for Zmacs commands appear and where you type"
      (36 40 "Zmacs"))
     ("                responses to prompts.  ")
     ("  ")
     ("")))
   ("Zmacs minor mode"
    (("                In  Zmacs,  a  mode  of  operation  that  adds  a   specific"
      (20 24 "Zmacs"))
     ("                customization  to  the  way  Zmacs behaves.  Minor modes are"
      (45 49 "Zmacs")
      (61 70 "minor mode"))
     ("                optional and independent of the major mode in  effect.   You"
      (48 57 "major mode"))
     ("                can have more than one minor mode active at a time.  Some of"
      (39 48 "minor mode"))
     ("                the minor modes available are the following:  "
      (20 29 "minor mode"))
     ("                  ")
     ("                *  Auto  Fill -- Zmacs automatically fills text.  You can"
      (25 28 "fill")
      (33 37 "Zmacs"))
     ("                   type text without worrying  about  the  width  of  the")
     ("                   Zmacs  window.   Return  characters  are inserted when"
      (19 23 "Zmacs")
      (26 31 "window")
      (44 52 "character"))
     ("                   needed to break lines.  " (29 33 "break"))
     ("                  ")
     ("                *  Electric Font Lock -- Zmacs puts text in the first font,"
      (28 31 "font")
      (41 45 "Zmacs")
      (64 68 "first"))
     ("                   comments in the second font,  documentations strings  in"
      (19 25 "comment")
      (42 45 "font")
      (64 69 "string"))
     ("                   the  third  font, and  other strings in the  fourth font.  "
      (31 34 "font")
      (48 53 "string"))
     ("                   Font IDs are read from the file attribute list.  "
      (19 22 "font")
      (46 64 "file attribute list"))
     ("                  ")
     ("                *  Electric Shift Lock  --  Zmacs  uppercases  everything"
      (44 48 "Zmacs"))
     ("                   except comments and strings.  " (26 32 "comment")
                                                          (39 44 "string"))
     ("                  ")
     ("                *  Overwrite  -- Typing over existing characters replaces"
      (54 62 "character"))
     ("                   them.  ")
     ("                  ")
     ("                *  RETURN Indents -- The RETURN key indents, and the LINE"
      (41 50 "RETURN key"))
     ("                   FEED key does not.   ")
     ("                  ")
     ("                *  Word Abbreviation -- Zmacs expands word abbreviations."
      (19 35 "word abbreviation")
      (40 44 "Zmacs"))
     ("                  ")
     ("                A minor mode can be either sticky  or  unsticky.   A  sticky"
      (18 27 "minor mode"))
     ("                minor  mode  remains active when you change major mode or go"
      (16 26 "minor mode")
      (60 69 "major mode"))
     ("                to another buffer.  An unsticky minor mode does  not  remain"
      (27 32 "buffer")
      (39 57 "unsticky minor mode"))
     ("                active.   Also, if you reparse the attribute list (to record"
      (51 64 "attribute list"))
     ("                a new major mode setting), the  sticky  minor  modes  remain"
      (22 31 "major mode")
      (48 66 "sticky minor mode"))
     ("                active and the unsticky ones do not.  ")
     ("                  ")
     ("                ")
     ("")))
   ("Zmacs user variable"
    (("                A  type of variable in Zmacs that the user can easily access"
      (27 34 "variable")
      (39 43 "Zmacs"))
     ("                and change to customize  some  of  the  workings  of  Zmacs."
      (70 74 "Zmacs"))
     ("                Zmacs  contains  two  types  of  user variables:  global and"
      (16 20 "Zmacs"))
     ("                local.  A global user variable applies to  all  buffers.   A"
      (33 45 "user variable")
      (64 69 "buffer"))
     ("                local user variable applies to only one buffer.  "
      (22 34 "user variable")
      (56 61 "buffer"))
     ("  ")
     ("")))
   ("zoom"
    (("                To change a  window so  that the  scale of  graphics objects"
      (29 34 "window")
      (60 74 "graphics object"))
     ("                that are  displayed  appears  to  change.   Zooming in makes")
     ("                objects appear  larger;  zooming  out  makes  objects appear"
      (16 21 "object"))
     ("                smaller.  ")
     (""))))))

